module m_ES_NonCollinear
! $Id: m_ES_NonCollinear.f90 487 2016-05-17 05:20:42Z ktagami $
  use m_Const_Parameters,   only : DP, CMPLDP, zi, yes, PAI, &
       &                            BuiltIn, ByProjector, ByPawPot, ZeffApprox, &
       &                           BUCS, CARTS, CRDTYP, DELTA10, ReadFromPP
  
  use m_Control_Parameters,  only : noncol, ndim_spinor, ndim_magmom, ndim_chgpot, &
       &                            kimg, nspin, ipri, iprixc, SpinOrbit_Mode

  use m_Ionic_System,       only : natm, ntyp, ityp, mag_direction0_atomtyp, &
       &                           natm2, pos, iwei, magmom_local_now
  
  use m_PseudoPotential,     only : dion_so, dion_scr_noncl, q_noncl, flg_soc, &
       &                            pot_has_soc, dion0_noncl, &
       &                            nlmt, ipaw, dion, dion_paw, q, ltp, mtp, jtp, &
       &                            nac, nac_p, nlmta_phi, &
       &                            ilmt

  use m_Parallelization,      only : ista_kngp, iend_kngp, ista_fftp, iend_fftp, &
       &                             ista_fftph, iend_fftph, &
       &                             myrank_ggacmp, nrank_ggacmp, npes, ierr, &
       &                             mpi_comm_group

  use m_Files,                 only : nfout

!!!

  use m_SpinOrbit_Potential,    only : MatU_ylm_RC_L0, MatU_ylm_RC_L1, &
       &                              MatU_ylm_RC_L2, MatU_ylm_RC_L3, &
       &                              dsoc

!  use m_Crystal_Structure,      only : mag_direction0_global

!  use m_Crystal_Structure,      only : nopr, op, ig01, tau, m_CS_op_in_PUCD

! === KT_add === 2014/08/04
  use m_Crystal_Structure,   only : threshold_vorticity, threshold_helicity
! ============== 2014/08/04

  implicit none

  include 'mpif.h'
  integer istatus(mpi_status_size)

  complex(kind=CMPLDP), allocatable :: Spinor_EigenWfn0_atomtyp(:,:,:)
  complex(kind=CMPLDP), allocatable :: Spinor_EigenWfn0_global(:,:)
  complex(kind=CMPLDP), allocatable :: factor_f( :,:,:,:,: )

  real(kind=DP) :: Global_Quantz_Axis_now(3)

contains 

! ------------------------------------------------------------------------  
!!
!!!   Spinor eigenwfns calculated from the initial mag. orientaion.
!!
! -----------------------------------------------------------------------
  subroutine m_ES_alloc_spinor_eigenwfn_0
    allocate( Spinor_EigenWfn0_atomtyp( ntyp, ndim_spinor, ndim_spinor ) )
    Spinor_EigenWfn0_atomtyp = 0.0d0
  end subroutine m_ES_alloc_spinor_eigenwfn_0

  subroutine m_ES_dealloc_spinor_eigenwfn_0
    deallocate( Spinor_EigenWfn0_atomtyp )
  end subroutine m_ES_dealloc_spinor_eigenwfn_0

  subroutine m_ES_set_spinor_eigenwfn_0
    integer :: it
    real(kind=DP) :: c_mx, c_my, c_mz
    real(kind=DP) :: theta, phi
    real(kind=DP) :: c1, s1
    complex(kind=CMPLDP) :: z1

    Do it=1, ntyp
       c_mx = mag_direction0_atomtyp( it,1 )
       c_my = mag_direction0_atomtyp( it,2 )
       c_mz = mag_direction0_atomtyp( it,3 )
!
       theta = atan2( sqrt( c_mx**2 +c_my**2), c_mz )
       phi = atan2( c_my, c_mx )
!
!       write(*,*) 'cmx = ', c_mx, c_my, c_mz
!       write(*,*) 'Th phi = ', theta, phi
!
       c1 = cos( theta/2.0d0 );  s1 = sin( theta/2.0d0 )
       z1 = exp( zi *phi /2.0d0 )
! ------------------------------------------------------ Kai_+ ---
       Spinor_EigenWfn0_atomtyp( it,1,1 ) = conjg(z1)*c1
       Spinor_EigenWfn0_atomtyp( it,2,1 ) = z1 *s1
! ------------------------------------------------------ Kai_- ---
       Spinor_EigenWfn0_atomtyp( it,1,2 ) = -conjg(z1)*s1
       Spinor_EigenWfn0_atomtyp( it,2,2 ) = z1 *c1
    End do
 
  end subroutine m_ES_set_spinor_eigenwfn_0

! ------------------------------------------------------------------------  
!!
!!!        Factor F defined defined by A. Coroso et al
!!!                                    see. PRB 71 (2005) 115106.
!!
! -------------------------------------------------------------------------
  subroutine m_ES_alloc_factor_fss
    allocate( factor_f( nlmt, nlmt, ndim_spinor, ndim_spinor, ntyp ) )
    factor_f = 0.0d0
  end subroutine m_ES_alloc_factor_fss

  subroutine m_ES_dealloc_factor_fss
    deallocate( factor_f )
  end subroutine m_ES_dealloc_factor_fss

  subroutine m_ES_set_factor_fss
    integer :: it
    integer :: ilmt1, ilmt2, l1, l2, m1, m2
    integer :: is1, is2

    integer :: ni, number_of_mj

    real(kind=DP) :: jval1, jval2, mj
    real(kind=DP) :: c1, c2
    complex(kind=CMPLDP) :: z1, z2, zsum

    Do it=1, ntyp

       if ( .not. pot_has_soc(it)  ) cycle

       Do ilmt1=1, nlmt
          l1 = ltp( ilmt1, it )
          m1 = mtp( ilmt1, it )
          jval1 = jtp( ilmt1, it ) -0.50d0

          Do ilmt2=1, nlmt
             l2 = ltp( ilmt2, it )
             m2 = mtp( ilmt2, it )
             jval2 = jtp( ilmt2, it ) -0.5d0
          
             if ( l1 /= l2 ) cycle
             if ( abs(jval1-jval2) < 1.0D-4 )  cycle

             number_of_mj = nint( 2*jval1 +1 )

             write(*,*) 'mj = ', number_of_mj


             Do is1=1, ndim_spinor
                Do is2=1, ndim_spinor

                   zsum = 0.0d0
                   Do ni=1, number_of_mj
                      mj = -jval1 + ni -1
                      c1 = coeff_ClebshGordan( l1, jval1, mj, is1 ) 
                      c2 = coeff_ClebshGordan( l1, jval1, mj, is2 )
                      z1 = coeff_MatUs( l1, jval1, mj, m1, is1 )
                      z2 = coeff_MatUs( l1, jval1, mj, m2, is2 )
                      zsum = zsum + c1 *z1 *c2 *conjg( z2 )
                   End do
!
                   factor_f( ilmt1, ilmt2, is1, is2, it ) = zsum
                End do
             End do
          End do
       End do
    End Do

  end subroutine m_ES_set_factor_fss

!------------------------------------------------------------------
!!
!!!     Generalizatin of Dion and q 
!!
! ----------------------------------------------------------------
  subroutine m_ES_set_Mat_q_noncl
    integer :: it

    q_noncl = 0.0d0

    if ( SpinOrbit_mode == BuiltIn ) then
       Do it=1, ntyp
          call set_q_so( it )
       End do
    else
       Do it=1, ntyp
          q_noncl( 1:nlmt, 1:nlmt, 1, it ) = q( 1:nlmt, 1:nlmt, it )
          q_noncl( 1:nlmt, 1:nlmt, ndim_chgpot, it ) = q( 1:nlmt, 1:nlmt, it )
       End do
    endif

  contains

    subroutine set_q_so( it )
      integer, intent(in) :: it
      
      integer :: lmt1, lmt2, lmt3, lmt4
      integer :: is1, is2, is3, is4
      integer :: is_tmp
      complex(kind=CMPLDP) :: z1, zsum

      Do lmt1 = 1, nlmt
         Do lmt2 = 1, nlmt
            
            Do is_tmp = 1, ndim_chgpot
               is1 = ( is_tmp -1 ) /ndim_spinor + 1
               is2 = mod( is_tmp -1,2 ) +1
               
               zsum = 0.0d0
               
               Do lmt3 = 1, nlmt
                  Do lmt4 = 1, nlmt
                     Do is3=1, ndim_spinor
                        is4 = is3
                        z1 = q( lmt1, lmt2, it ) &
                             &   *factor_f( lmt1, lmt3, is1, is3, it ) &
                             &   *factor_f( lmt4, lmt2, is4, is2, it ) 
                        zsum = zsum + z1
                     End do
                  End do
               End do
                  !
               q_noncl( lmt1, lmt2, is_tmp, it ) = zsum
               !
            End do
         End do
      End do
    end subroutine set_q_so

  end subroutine m_ES_set_Mat_q_noncl

  subroutine m_ES_init_Mat_dion0_noncl
    integer :: it, ia
    
    if ( SpinOrbit_Mode == BuiltIn ) then      ! full-relativisitic
       Do ia=1, natm
          it = ityp(ia)
          call set_dion_so( ia, it )

       End do

    else if ( SpinOrbit_Mode == ByProjector .or. &
         &    SpinOrbit_Mode == ZeffApprox ) then      ! soc by parameter
       Do ia=1, natm
          it = ityp(ia)
          dion0_noncl( 1:nlmt, 1:nlmt, 1, ia ) = dion( 1:nlmt, 1:nlmt, it )
          dion0_noncl( 1:nlmt, 1:nlmt, ndim_chgpot, ia ) &
               &                 = dion( 1:nlmt, 1:nlmt, it )
         
          call add_Dsoc_term_noncl( ia )
       End do

    else if ( SpinOrbit_Mode == ReadFromPP .or. &
         &    SpinOrbit_Mode == ByPawPot ) then 
                                      
       Do ia=1, natm
          it = ityp(ia)
          dion0_noncl( 1:nlmt, 1:nlmt, 1, ia ) = dion( 1:nlmt, 1:nlmt, it )
          dion0_noncl( 1:nlmt, 1:nlmt, ndim_chgpot, ia ) &
               &                 = dion( 1:nlmt, 1:nlmt, it )
         
          call add_Dsoc_term_noncl( ia )
       End do

    else                                 ! neglect soc
       Do ia=1, natm
          it = ityp(ia)
          dion0_noncl( 1:nlmt, 1:nlmt, 1, ia ) = dion( 1:nlmt, 1:nlmt, it )
          dion0_noncl( 1:nlmt, 1:nlmt, ndim_chgpot, ia ) &
               &                 = dion( 1:nlmt, 1:nlmt, it )
       End do
    end if

    dion_scr_noncl = dion0_noncl

  contains

    subroutine add_Dsoc_term_noncl( ia )
      integer, intent (in ) :: ia
      integer is
      
      Do is=1, ndim_chgpot
         dion0_noncl(:,:,is,ia) = dion0_noncl(:,:,is,ia) + dsoc(:,:,ia,is)
      End do
    end subroutine add_Dsoc_term_noncl

! --
    subroutine set_dion_so( ia, it )
      integer, intent (in ) :: ia, it
!
      integer :: is1, is2, is_tmp
      integer :: ilmt1, ilmt2, l1, m1, l2, m2
      real(kind=DP) :: jval1, jval2
      complex(kind=CMPLDP) :: z1, z2
      !
      Do ilmt1=1, nlmt
         l1 = ltp( ilmt1, it )
         m1 = mtp( ilmt1, it )
         jval1 = jtp( ilmt1, it )
         
         Do ilmt2=1, nlmt
            l2 = ltp( ilmt2, it )
            m2 = mtp( ilmt2, it )
            jval2 = jtp( ilmt2, it )
            
            if ( l1 /= l2 ) cycle
            if ( abs(jval1-jval2) < 1.0D-4 )  cycle
            
            z1 = dion( ilmt1, ilmt2, it )
            Do is1=1, ndim_spinor
               Do is2=1, ndim_spinor
                  is_tmp = ( is1 -1 )*ndim_spinor + is2
                  
                  z2 = z1 *factor_f( ilmt1, ilmt2, is1, is2, it )
                  dion0_noncl( ilmt1, ilmt2, is_tmp, ia ) = z2
               End do
            End do
         End do
      End do
      
    end subroutine set_dion_so

  end subroutine m_ES_init_Mat_dion0_noncl

  subroutine m_ES_update_Mat_dion0_noncl         ! for PAW
    integer :: it, ia
    complex(kind=CMPLDP), allocatable :: dion_paw_ssrep(:,:,:,:)

    allocate( dion_paw_ssrep(nlmt,nlmt,ndim_magmom,natm) )
    call m_ES_MagMom_To_DensMat_DionPaw( dion_paw, dion_paw_ssrep )

    if ( SpinOrbit_Mode == BuiltIn ) then      ! full-relativisitic
       stop 'kt : Not suppported spin-orbit + paw'

       Do ia=1, natm
          it = ityp(ia)
          call set_dion_so( ia, it )      !  ?????????????
       End do

    else if ( SpinOrbit_Mode == ByProjector .or. &
         &    SpinOrbit_Mode == ZeffApprox ) then      ! soc by parameter
       Do ia=1, natm
          dion0_noncl( 1:nlmt, 1:nlmt, :, ia ) = dion_paw_ssrep( 1:nlmt, 1:nlmt, :, ia )
          call add_Dsoc_term_noncl( ia )
       End do

    else if ( SpinOrbit_Mode == ReadFromPP .or. &
         &    SpinOrbit_Mode == ByPawPot ) then      
       Do ia=1, natm
          dion0_noncl( 1:nlmt, 1:nlmt, :, ia ) = dion_paw_ssrep( 1:nlmt, 1:nlmt, :, ia )
          call add_Dsoc_term_noncl( ia )
       End do

    else                                 ! neglect soc
       Do ia=1, natm
          dion0_noncl( 1:nlmt, 1:nlmt, :, ia ) = dion_paw_ssrep( 1:nlmt, 1:nlmt, :, ia )
       End do
    end if

    dion_scr_noncl = dion0_noncl
    deallocate( dion_paw_ssrep )

  contains

    subroutine add_Dsoc_term_noncl( ia )
      integer, intent (in ) :: ia
      integer is
      
      Do is=1, ndim_chgpot
         dion0_noncl(:,:,is,ia) = dion0_noncl(:,:,is,ia) + dsoc(:,:,ia,is)
      End do
    end subroutine add_Dsoc_term_noncl

! --
    subroutine set_dion_so( ia, it )
      integer, intent (in ) :: ia, it
!
      integer :: is1, is2, is_tmp
      integer :: ilmt1, ilmt2, l1, m1, l2, m2
      real(kind=DP) :: jval1, jval2
      complex(kind=CMPLDP) :: z1, z2
      !
      Do ilmt1=1, nlmt
         l1 = ltp( ilmt1, it )
         m1 = mtp( ilmt1, it )
         jval1 = jtp( ilmt1, it )
         
         Do ilmt2=1, nlmt
            l2 = ltp( ilmt2, it )
            m2 = mtp( ilmt2, it )
            jval2 = jtp( ilmt2, it )
            
            if ( l1 /= l2 ) cycle
            if ( abs(jval1-jval2) < 1.0D-4 )  cycle
            
            z1 = dion( ilmt1, ilmt2, it )
            Do is1=1, ndim_spinor
               Do is2=1, ndim_spinor
                  is_tmp = ( is1 -1 )*ndim_spinor + is2
                  
                  z2 = z1 *factor_f( ilmt1, ilmt2, is1, is2, it )
                  dion0_noncl( ilmt1, ilmt2, is_tmp, ia ) = z2
               End do
            End do
         End do
      End do
      
    end subroutine set_dion_so

  end subroutine m_ES_update_Mat_dion0_noncl

  subroutine m_ES_set_Mat_dion_scr_noncl( VlhxcQ_l, dhub_aimag )
    real(kind=DP), intent(in) :: VlhxcQ_l( nlmt, nlmt, natm, ndim_magmom )
    real(kind=DP), optional, intent(in) :: dhub_aimag( nlmt, nlmt, natm, ndim_magmom )

    complex(kind=CMPLDP), allocatable :: vlhxcQ_ssrep( :,:,:,: )
    complex(kind=CMPLDP) :: PauliMatrix( ndim_magmom, ndim_spinor, ndim_spinor )
!
    integer :: ia, it

    allocate( vlhxcQ_ssrep( nlmt,nlmt,natm,ndim_magmom ) )
    vlhxcQ_ssrep = 0.0d0
!
    if ( present(dhub_aimag) ) then
       call m_ES_MagMom_to_DensMat_vlhxcQ( vlhxcQ_l, vlhxcQ_ssrep, dhub_aimag )
    else
       call m_ES_MagMom_to_DensMat_vlhxcQ( vlhxcQ_l, vlhxcQ_ssrep )
    endif
!
    call m_ES_set_Pauli_matrix( PauliMatrix )

!------------------------------------------
    dion_scr_noncl = dion0_noncl
! -------------------------------------

    if ( SpinOrbit_Mode == BuiltIn ) then      ! full-relativisitic
       Do ia=1, natm
          it = ityp(ia)
          call add_VlhxcQ_term_noncl_B( ia )
       End do

    else if ( SpinOrbit_Mode == ByProjector .or. &
         &    SpinOrbit_Mode == ZeffApprox ) then      ! soc by parameter
       Do ia=1, natm
          it = ityp(ia)
          call add_VlhxcQ_term_noncl_A( ia )
       End do

    else if ( SpinOrbit_Mode == ReadFromPP .or. &
         &    SpinOrbit_Mode == ByPawPot ) then 
       Do ia=1, natm
          it = ityp(ia)
          call add_VlhxcQ_term_noncl_A( ia )
       End do

    else                                 ! neglect soc
       Do ia=1, natm
          it = ityp(ia)
          call add_VlhxcQ_term_noncl_A( ia )
       End do
    end if

    deallocate( vlhxcQ_ssrep )
    
  contains

    subroutine add_VlhxcQ_term_noncl_A( ia )
      integer, intent (in ) :: ia
      integer is
      
      Do is=1, ndim_chgpot
         dion_scr_noncl(:,:,is,ia) = dion0_noncl(:,:,is,ia) +vlhxcQ_ssrep( :,:,ia,is)
      End do
    end subroutine add_VlhxcQ_term_noncl_A
    
    subroutine add_VlhxcQ_term_noncl_B( ia )
      integer, intent (in ) :: ia

      integer :: is1, is2, is3, is4
      integer :: lmt1, lmt2, lmt3, lmt4 
      integer :: ialph, is_tmp

      complex(kind=CMPLDP) :: zsum, z1
      
      Do lmt1 = 1, nlmt
         Do lmt2 = 1, nlmt
            
            Do is_tmp = 1, ndim_chgpot
               is1 = ( is_tmp -1 ) /ndim_spinor + 1
               is2 = mod( is_tmp -1,2 ) +1
               
               zsum = 0.0d0
               
               Do lmt3 = 1, nlmt
                  Do lmt4 = 1, nlmt
                     Do is3=1, ndim_spinor
                        Do is4=1, ndim_spinor
                           
                           Do ialph=1, ndim_magmom
                              z1 = PauliMatrix( ialph, is3, is4 ) &
                                   &     *VlhxcQ_ssrep( lmt3, lmt4, ia, ialph ) &
                                   &     *factor_f( lmt1, lmt3, is1, is3, it ) &
                                   &     *factor_f( lmt4, lmt2, is4, is2, it ) 
                              zsum = zsum + z1
                           End do
                        End do
                     End do
                  End do
               End do
!
               dion_scr_noncl(:,:,is_tmp,ia) = dion0_noncl(:,:,is_tmp,ia) +zsum
!
            End do
         End do
      End do
      
    end subroutine add_VlhxcQ_term_noncl_B
         
  end subroutine m_ES_set_Mat_dion_scr_noncl

!--------------------------------------------------------------
!!
!!!   Clebsh Gordan coeff etc defined by A. Corso et al
!!!                                    see. PRB 71 (2005) 115106.
!!
! -------------------------------------------------------------
  complex(kind=CMPLDP) function coeff_MatUs( l, j, mj, mprime, is)
    integer, intent(in) :: l, is, mprime
    real(kind=DP), intent(in) :: j, mj

    integer :: m
    complex(kind=CMPLDP) :: z1

    stop "Not checked"

    z1 = 0.0d0
    if ( abs( j -l -0.5d0 ) < 1.0D-4 ) then
       m = nint( mj - 0.5d0 )
       if ( is == 1 .and. m >=-l ) then
          if ( l == 0 ) z1 = MatU_ylm_RC_L0( mprime, m )
          if ( l == 1 ) z1 = MatU_ylm_RC_L1( mprime, m )
          if ( l == 2 ) z1 = MatU_ylm_RC_L2( mprime, m )
          if ( l == 3 ) z1 = MatU_ylm_RC_L3( mprime, m )
       else if ( is == 2 .and. m <= l-1 ) then
          if ( l == 0 ) z1 = MatU_ylm_RC_L0( mprime, m+1 )
          if ( l == 1 ) z1 = MatU_ylm_RC_L1( mprime, m+1 )
          if ( l == 2 ) z1 = MatU_ylm_RC_L2( mprime, m+1 )
          if ( l == 3 ) z1 = MatU_ylm_RC_L3( mprime, m+1 )
       endif
    else if ( abs ( j -l +0.5d0 ) < 1.0D-4 ) then
       m = nint( mj + 0.5d0 )
       if ( is == 1 .and. m >=-l+1 ) then
          if ( l == 0 ) z1 = MatU_ylm_RC_L0( mprime, m-1 )
          if ( l == 1 ) z1 = MatU_ylm_RC_L1( mprime, m-1 )
          if ( l == 2 ) z1 = MatU_ylm_RC_L2( mprime, m-1 )
          if ( l == 3 ) z1 = MatU_ylm_RC_L3( mprime, m-1 )
       else if ( is == 2 .and. m <= l ) then
          if ( l == 0 ) z1 = MatU_ylm_RC_L0( mprime, m )
          if ( l == 1 ) z1 = MatU_ylm_RC_L1( mprime, m )
          if ( l == 2 ) z1 = MatU_ylm_RC_L2( mprime, m )
          if ( l == 3 ) z1 = MatU_ylm_RC_L3( mprime, m )
       endif
    end if

    coeff_MatUs = conjg(z1)

  end function coeff_MatUs

  real(kind=DP) function coeff_ClebshGordan( l, j, mj, is )
    integer, intent(in) :: l, is
    real(kind=DP), intent(in) :: j, mj

    real(kind=DP) :: c1
    integer :: m

    c1 = 0.0d0
    if ( abs( j -l -0.5d0 ) < 1.0D-4 ) then
       m = nint( mj - 0.5d0 )
       if ( is == 1 ) c1 = sqrt( ( l+m+1)/(2.d0*l+1.d0) )
       if ( is == 2 ) c1 = sqrt( ( l-m)/(2.d0*l+1.d0) )
    else if ( abs ( j -l +0.5d0 ) < 1.0D-4 ) then
       m = nint( mj + 0.5d0 )
       if ( is == 1 ) c1 = sqrt( ( l-m+1)/(2.d0*l+1.d0) )
       if ( is == 2 ) c1 =-sqrt( ( l+m)/(2.d0*l+1.d0) )
    endif

    coeff_ClebshGordan = c1
    return

  end function coeff_ClebshGordan

  subroutine m_ES_set_Pauli_matrix( PauliMatrix )
    complex(kind=CMPLDP), intent(out) :: &
         &                PauliMatrix( ndim_magmom, ndim_spinor, ndim_spinor )

    PauliMatrix = 0.0d0
    
    PauliMatrix( 1,1,1 ) = 1.0d0;     PauliMatrix( 1,2,2 ) = 1.0d0   ! Sigma 0
    PauliMatrix( 2,1,2 ) = 1.0d0;     PauliMatrix( 2,2,1 ) = 1.0d0   ! Sigma X
    PauliMatrix( 3,1,2 ) =   -zi;     PauliMatrix( 3,2,1 ) =    zi   ! Sigma Y
    PauliMatrix( 4,1,1 ) = 1.0d0;     PauliMatrix( 4,2,2 ) =-1.0d0   ! Sigma Z
    
  end subroutine m_ES_set_Pauli_matrix

! -------------------------------
  subroutine m_ES_set_Mat_hsr_with_soc( hsr_ssrep, hsi_ssrep, &
       &                                hsr_ssrep_with_soc, hsi_ssrep_with_soc )
    real(kind=DP), intent(in) :: hsr_ssrep( natm, nlmt, nlmt, ndim_chgpot )
    real(kind=DP), intent(in) :: hsi_ssrep( natm, nlmt, nlmt, ndim_chgpot )
    real(kind=DP), intent(out):: hsr_ssrep_with_soc( natm, nlmt, nlmt, ndim_chgpot )
    real(kind=DP), intent(out):: hsi_ssrep_with_soc( natm, nlmt, nlmt, ndim_chgpot )

    integer :: ia, it
    integer :: is1, is2, is3, is4, is_tmp, is_tmp2
    integer :: ilmt1, ilmt2, ilmt3, ilmt4
    integer :: l1, l2, l3, l4, m1, m2, m3, m4
    real(kind=DP) :: jval1, jval2, jval3, jval4
    complex(kind=CMPLDP) :: z1, z2, z3, zsum

    Do ia=1, natm
       it = ityp(ia)
       
       Do ilmt1=1, nlmt
          l1 = ltp( ilmt1, it )
          m1 = mtp( ilmt1, it )
          jval1 = jtp( ilmt1, it )
          
          Do ilmt2=1, nlmt
             l2 = ltp( ilmt2, it )
             m2 = mtp( ilmt2, it )
             jval2 = jtp( ilmt2, it )
             
             Do is_tmp = 1, ndim_chgpot
                is1 = ( is_tmp -1 ) /ndim_spinor + 1
                is2 = mod( is_tmp -1, ndim_spinor ) +1
                
                zsum = 0.0d0
                Do ilmt3=1, nlmt
                   l3 = ltp( ilmt3, it )
                   m3 = mtp( ilmt3, it )
                   jval3 = jtp( ilmt3, it )
                   
                   if ( l1 /= l3 ) cycle
                   if ( abs(jval1-jval3) > 1.0E-4 ) cycle
                   
                   Do ilmt4=1, nlmt
                      l4 = ltp( ilmt4, it )
                      m4 = mtp( ilmt4, it )
                      jval4 = jtp( ilmt4, it )
                      
                      if ( l2 /= l4 ) cycle
                      if ( abs(jval2-jval4) > 1.0E-4 ) cycle
                      
                      Do is3=1, ndim_spinor
                         Do is4=1, ndim_spinor
                            is_tmp2 = ( is3 -1 )*ndim_spinor + is4
                            
                            z1 = factor_f( ilmt3, ilmt1, is3, is1, it )
                            z2 = factor_f( ilmt2, ilmt4, is2, is4, it )
                            
                            z3 = dcmplx( hsr_ssrep( ia, ilmt3, ilmt4, is_tmp2 ), &
                                 &       hsi_ssrep( ia, ilmt3, ilmt4, is_tmp2 ) )
                            zsum = zsum + z1 *z3 *z2
                         End do
                      End do
                   End do
                End do
                
                hsr_ssrep_with_soc( ia, ilmt1, ilmt2, is_tmp ) = real(zsum)
                hsi_ssrep_with_soc( ia, ilmt1, ilmt2, is_tmp ) = aimag(zsum)
             End do
          End do
       End do
    End Do
 end subroutine m_ES_set_Mat_hsr_with_soc
!

! ----------------------------------------------------------------------
!!
!!!   Converters between the ss-repsentaion and magmom-representaion
!!
! ----------------------------------------------------------------------
  subroutine m_ES_MagMom_to_DensMat_Gspace( Rho_MagMom, DensMat )
    real(kind=DP), intent(in)  :: Rho_MagMom( ista_kngp:iend_kngp,kimg,ndim_magmom )
    real(kind=DP), intent(out) :: DensMat(    ista_kngp:iend_kngp,kimg,ndim_chgpot )
    ! --
    !                                       note : ndim_magmom = 4 
! --
    integer i, k
    Real(kind=DP) :: c_rho(kimg), c_mx (kimg), c_my (kimg), c_mz (kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    DensMat = 0.0d0
    Do i=ista_kngp, iend_kngp
       
       Do k=1, kimg
          c_rho(k) = Rho_MagMom( i,k,1 )
          c_mx(k)  = Rho_MagMom( i,k,2 )
          c_my(k)  = Rho_MagMom( i,k,3 )
          c_mz(k)  = Rho_MagMom( i,k,4 )
       End do
       ! -------------------- real part ------
       c_n11(1) = ( c_rho(1) + c_mz(1) ) /2.0d0
       c_n22(1) = ( c_rho(1) - c_mz(1) ) /2.0d0
       c_n12(1) = ( c_mx(1)  + c_my(2) ) /2.0d0
       c_n21(1) = ( c_mx(1)  - c_my(2) ) /2.0d0
       ! ---------------------- imaginary part --
       c_n11(2) = ( c_rho(2) + c_mz(2) ) /2.0d0
       c_n22(2) = ( c_rho(2) - c_mz(2) ) /2.0d0
       c_n12(2) = ( c_mx(2)  - c_my(1) ) /2.0d0
       c_n21(2) = ( c_mx(2)  + c_my(1) ) /2.0d0
       ! ----
       Do k=1,  kimg
          DensMat( i,k,1 ) = c_n11(k)
          DensMat( i,k,2 ) = c_n12(k)
          DensMat( i,k,3 ) = c_n21(k)
          DensMat( i,k,4 ) = c_n22(k)
       End do
    End Do
  end subroutine m_ES_MagMom_to_DensMat_Gspace
  
! -----------------------------------------------------------------
!!
!!!  n11(G),n12(G), n21(G), n22(G) ---> n(G), mx(G), my(G), mz(G)
!!
! -----------------------------------------------------------------
  subroutine m_ES_DensMat_To_MagMom_Gspace( DensMat, Rho_MagMom )

    real(kind=DP), intent(in)   :: DensMat(    ista_kngp:iend_kngp,kimg,ndim_chgpot )
    real(kind=DP), intent(out)  :: Rho_MagMom( ista_kngp:iend_kngp,kimg,ndim_magmom )
!
    integer i, k
    Real(kind=DP) :: c_rho(kimg), c_mx (kimg), c_my (kimg), c_mz (kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
    !
    Rho_MagMom = 0.0d0
    Do i=ista_kngp, iend_kngp
       
       Do k=1,  kimg
          c_n11(k) = DensMat( i,k,1 )
          c_n12(k) = DensMat( i,k,2 )
          c_n21(k) = DensMat( i,k,3 )
          c_n22(k) = DensMat( i,k,4 )
       End do
! -------------------- real part ------
       c_rho(1) = c_n11(1) + c_n22(1)
       c_mx(1)  = c_n12(1) + c_n21(1)
       c_my(1)  = c_n21(2) - c_n12(2)
       c_mz(1)  = c_n11(1) - c_n22(1)
! ---------------------- imaginary part --
       c_rho(2) = c_n11(2) + c_n22(2)
       c_mx(2)  = c_n12(2) + c_n21(2)
       c_my(2)  =-c_n21(1) + c_n12(1)
       c_mz(2)  = c_n11(2) - c_n22(2)
! ----
       Do k=1, kimg
          Rho_MagMom( i,k,1 ) = c_rho(k)
          Rho_MagMom( i,k,2 ) = c_mx(k)
          Rho_MagMom( i,k,3 ) = c_my(k)
          Rho_MagMom( i,k,4 ) = c_mz(k)
       End do
! --
    End Do
  end subroutine m_ES_DensMat_To_MagMom_Gspace

  subroutine m_ES_DensMat_To_MagMom_hsr( natm, nlmt, hsr_densmat, hsi_densmat, &
       &                                 hsr_magmom, hsi_magmom )
    integer, intent(in) :: natm, nlmt
    real(kind=DP), intent(in)   :: hsr_densmat( natm, nlmt, nlmt, ndim_chgpot )
    real(kind=DP), intent(in)   :: hsi_densmat( natm, nlmt, nlmt, ndim_chgpot )
    real(kind=DP), intent(out)  :: hsr_magmom(  natm, nlmt, nlmt, ndim_magmom )
    real(kind=DP), intent(out)  :: hsi_magmom(  natm, nlmt, nlmt, ndim_magmom )
!
    integer i, k
    integer :: ia, lmt1, lmt2
    Real(kind=DP) :: c_rho(kimg), c_mx (kimg), c_my (kimg), c_mz (kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    hsr_magmom = 0.0d0
    Do lmt2=1, nlmt
       Do lmt1=1, nlmt
          Do ia=1, natm
             c_n11(1) = hsr_densmat( ia, lmt1, lmt2, 1 )
             c_n12(1) = hsr_densmat( ia, lmt1, lmt2, 2 )
             c_n21(1) = hsr_densmat( ia, lmt1, lmt2, 3 )
             c_n22(1) = hsr_densmat( ia, lmt1, lmt2, 4 )
             !
             c_n11(2) = hsi_densmat( ia, lmt1, lmt2, 1 )
             c_n12(2) = hsi_densmat( ia, lmt1, lmt2, 2 )
             c_n21(2) = hsi_densmat( ia, lmt1, lmt2, 3 )
             c_n22(2) = hsi_densmat( ia, lmt1, lmt2, 4 )
!
! -------------------- real part ------
             c_rho(1) = c_n11(1) + c_n22(1)
             c_mx(1)  = c_n12(1) + c_n21(1)
             c_my(1)  = c_n21(2) - c_n12(2)
             c_mz(1)  = c_n11(1) - c_n22(1)
! ---------------------- imaginary part --
             c_rho(2) = c_n11(2) + c_n22(2)
             c_mx(2)  = c_n12(2) + c_n21(2)
             c_my(2)  =-c_n21(1) + c_n12(1)
             c_mz(2)  = c_n11(2) - c_n22(2)
!
             hsr_magmom( ia, lmt1, lmt2, 1 ) = c_rho(1)
             hsr_magmom( ia, lmt1, lmt2, 2 ) = c_mx(1)
             hsr_magmom( ia, lmt1, lmt2, 3 ) = c_my(1)
             hsr_magmom( ia, lmt1, lmt2, 4 ) = c_mz(1)
!
             hsi_magmom( ia, lmt1, lmt2, 1 ) = c_rho(2)
             hsi_magmom( ia, lmt1, lmt2, 2 ) = c_mx(2)
             hsi_magmom( ia, lmt1, lmt2, 3 ) = c_my(2)
             hsi_magmom( ia, lmt1, lmt2, 4 ) = c_mz(2)
          End do
       End do
! --
    End Do
  end subroutine m_ES_DensMat_To_MagMom_hsr

  subroutine m_ES_DensMat_To_MagMom_hsr0( hsr_densmat, hsi_densmat, hsr_magmom )
    real(kind=DP), intent(in)   :: hsr_densmat( natm, nlmt, nlmt, ndim_chgpot )
    real(kind=DP), intent(in)   :: hsi_densmat( natm, nlmt, nlmt, ndim_chgpot )
    real(kind=DP), intent(out)  :: hsr_magmom(  natm, nlmt, nlmt, ndim_magmom )
!
    integer i, k
    integer :: ia, lmt1, lmt2
    Real(kind=DP) :: c_rho(kimg), c_mx (kimg), c_my (kimg), c_mz (kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    hsr_magmom = 0.0d0
    Do lmt2=1, nlmt
       Do lmt1=1, nlmt
          Do ia=1, natm
             c_n11(1) = hsr_densmat( ia, lmt1, lmt2, 1 )
             c_n12(1) = hsr_densmat( ia, lmt1, lmt2, 2 )
             c_n21(1) = hsr_densmat( ia, lmt1, lmt2, 3 )
             c_n22(1) = hsr_densmat( ia, lmt1, lmt2, 4 )
             !
             c_n11(2) = hsi_densmat( ia, lmt1, lmt2, 1 )
             c_n12(2) = hsi_densmat( ia, lmt1, lmt2, 2 )
             c_n21(2) = hsi_densmat( ia, lmt1, lmt2, 3 )
             c_n22(2) = hsi_densmat( ia, lmt1, lmt2, 4 )
!
! -------------------- real part ------
             c_rho(1) = c_n11(1) + c_n22(1)
             c_mx(1)  = c_n12(1) + c_n21(1)
             c_my(1)  = c_n21(2) - c_n12(2)
             c_mz(1)  = c_n11(1) - c_n22(1)
! ---------------------- imaginary part --
             c_rho(2) = c_n11(2) + c_n22(2)
             c_mx(2)  = c_n12(2) + c_n21(2)
             c_my(2)  =-c_n21(1) + c_n12(1)
             c_mz(2)  = c_n11(2) - c_n22(2)

             hsr_magmom( ia, lmt1, lmt2, 1 ) = c_rho(1)
             hsr_magmom( ia, lmt1, lmt2, 2 ) = c_mx(1)
             hsr_magmom( ia, lmt1, lmt2, 3 ) = c_my(1)
             hsr_magmom( ia, lmt1, lmt2, 4 ) = c_mz(1)
          End do
       End do
! --
    End Do
  end subroutine m_ES_DensMat_To_MagMom_hsr0

  subroutine m_ES_MagMom_To_DensMat_hsr( natm, nlmt, hsr_magmom, hsi_magmom, &
       &                                 hsr_densmat, hsi_densmat )
    integer, intent(in) :: natm, nlmt
    real(kind=DP), intent(in)  :: hsr_magmom(  natm, nlmt, nlmt, ndim_magmom )
    real(kind=DP), intent(in)  :: hsi_magmom(  natm, nlmt, nlmt, ndim_magmom )
    real(kind=DP), intent(out)   :: hsr_densmat( natm, nlmt, nlmt, ndim_chgpot )
    real(kind=DP), intent(out)   :: hsi_densmat( natm, nlmt, nlmt, ndim_chgpot )
!
    integer i, k
    integer :: ia, lmt1, lmt2
    Real(kind=DP) :: c_rho(2), c_mx(2), c_my(2), c_mz(2)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    hsr_densmat = 0.0d0
    hsi_densmat = 0.0d0
    Do lmt2=1, nlmt
       Do lmt1=1, nlmt
          Do ia=1, natm

             c_rho(1) = hsr_magmom( ia, lmt1, lmt2, 1 )
             c_mx(1)  = hsr_magmom( ia, lmt1, lmt2, 2 )
             c_my(1)  = hsr_magmom( ia, lmt1, lmt2, 3 )
             c_mz(1)  = hsr_magmom( ia, lmt1, lmt2, 4 )

             c_rho(2) = hsi_magmom( ia, lmt1, lmt2, 1 )
             c_mx(2)  = hsi_magmom( ia, lmt1, lmt2, 2 )
             c_my(2)  = hsi_magmom( ia, lmt1, lmt2, 3 )
             c_mz(2)  = hsi_magmom( ia, lmt1, lmt2, 4 )

       ! -------------------- real part ------
             c_n11(1) = ( c_rho(1) + c_mz(1) ) /2.0d0
             c_n22(1) = ( c_rho(1) - c_mz(1) ) /2.0d0
             c_n12(1) = ( c_mx(1)  + c_my(2) ) /2.0d0
             c_n21(1) = ( c_mx(1)  - c_my(2) ) /2.0d0
       ! ---------------------- imaginary part --
             c_n11(2) = ( c_rho(2) + c_mz(2) ) /2.0d0
             c_n22(2) = ( c_rho(2) - c_mz(2) ) /2.0d0
             c_n12(2) = ( c_mx(2)  - c_my(1) ) /2.0d0
             c_n21(2) = ( c_mx(2)  + c_my(1) ) /2.0d0
       ! ----
             hsr_densmat( ia, lmt1, lmt2, 1 ) = c_n11(1)
             hsr_densmat( ia, lmt1, lmt2, 2 ) = c_n12(1)
             hsr_densmat( ia, lmt1, lmt2, 3 ) = c_n21(1)
             hsr_densmat( ia, lmt1, lmt2, 4 ) = c_n22(1)

             hsi_densmat( ia, lmt1, lmt2, 1 ) = c_n11(2)
             hsi_densmat( ia, lmt1, lmt2, 2 ) = c_n12(2)
             hsi_densmat( ia, lmt1, lmt2, 3 ) = c_n21(2)
             hsi_densmat( ia, lmt1, lmt2, 4 ) = c_n22(2)

          End do
       End do
! --
    End Do
  end subroutine m_ES_MagMom_To_DensMat_hsr

  subroutine m_ES_MagMom_To_DensMat_hsr0( hsr_magmom, hsr_densmat, hsi_densmat )
    real(kind=DP), intent(in)  :: hsr_magmom(  natm, nlmt, nlmt, ndim_magmom )
    real(kind=DP), intent(out)   :: hsr_densmat( natm, nlmt, nlmt, ndim_chgpot )
    real(kind=DP), intent(out)   :: hsi_densmat( natm, nlmt, nlmt, ndim_chgpot )
!
    integer i, k
    integer :: ia, lmt1, lmt2
    Real(kind=DP) :: c_rho, c_mx, c_my, c_mz
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    hsr_densmat = 0.0d0
    hsi_densmat = 0.0d0
    Do lmt2=1, nlmt
       Do lmt1=1, nlmt
          Do ia=1, natm

             c_rho = hsr_magmom( ia, lmt1, lmt2, 1 )
             c_mx  = hsr_magmom( ia, lmt1, lmt2, 2 )
             c_my  = hsr_magmom( ia, lmt1, lmt2, 3 )
             c_mz  = hsr_magmom( ia, lmt1, lmt2, 4 )
       ! -------------------- real part ------
             c_n11(1) = ( c_rho + c_mz ) /2.0d0
             c_n22(1) = ( c_rho - c_mz ) /2.0d0
             c_n12(1) = c_mx /2.0d0
             c_n21(1) = c_mx /2.0d0
       ! ---------------------- imaginary part --
             c_n11(2) = 0.0d0
             c_n22(2) = 0.0d0
             c_n12(2) = -c_my /2.0d0
             c_n21(2) =  c_my /2.0d0
       ! ----
             hsr_densmat( ia, lmt1, lmt2, 1 ) = c_n11(1)
             hsr_densmat( ia, lmt1, lmt2, 2 ) = c_n12(1)
             hsr_densmat( ia, lmt1, lmt2, 3 ) = c_n21(1)
             hsr_densmat( ia, lmt1, lmt2, 4 ) = c_n22(1)

             hsi_densmat( ia, lmt1, lmt2, 1 ) = c_n11(2)
             hsi_densmat( ia, lmt1, lmt2, 2 ) = c_n12(2)
             hsi_densmat( ia, lmt1, lmt2, 3 ) = c_n21(2)
             hsi_densmat( ia, lmt1, lmt2, 4 ) = c_n22(2)

          End do
       End do
! --
    End Do
  end subroutine m_ES_MagMom_To_DensMat_hsr0

  subroutine m_ES_MagMom_to_DensMat_vlhxcQ0( vlhxcQ_magmom, vlhxcQ_densmat )
    real(kind=DP),        intent(in) :: vlhxcQ_magmom( nlmt, nlmt, natm, ndim_magmom )
    complex(kind=CMPLDP), intent(out):: vlhxcQ_densmat( nlmt, nlmt, natm, ndim_chgpot )
    
    Real(kind=DP) :: c_rho, c_mx, c_my, c_mz
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    integer :: ia, lmt1, lmt2
!
!    c_rho(2) = 0.0d0;  c_mx(2) = 0.0d0;   c_my(2) = 0.0d0;   c_mz(2) = 0.0d0
!
    vlhxcQ_densmat = 0.0d0
    Do ia=1, natm
       Do lmt2=1, nlmt
          Do lmt1=1, nlmt
             c_rho = vlhxcQ_magmom( lmt1, lmt2, ia, 1 )
             c_mx  = vlhxcQ_magmom( lmt1, lmt2, ia, 2 )
             c_my  = vlhxcQ_magmom( lmt1, lmt2, ia, 3 )
             c_mz  = vlhxcQ_magmom( lmt1, lmt2, ia, 4 )
             !
             c_n11(1) = c_rho + c_mz 
             c_n22(1) = c_rho - c_mz 
             c_n12(1) = c_mx 
             c_n21(1) = c_mx 
! ---------------------- imaginary part --
             c_n11(2) = 0.0d0
             c_n22(2) = 0.0d0
             c_n12(2) = -c_my 
             c_n21(2) =  c_my
! ----
             vlhxcQ_densmat( lmt1, lmt2, ia, 1 ) = dcmplx( c_n11(1), c_n11(2) )
             vlhxcQ_densmat( lmt1, lmt2, ia, 2 ) = dcmplx( c_n12(1), c_n12(2) )
             vlhxcQ_densmat( lmt1, lmt2, ia, 3 ) = dcmplx( c_n21(1), c_n21(2) )
             vlhxcQ_densmat( lmt1, lmt2, ia, 4 ) = dcmplx( c_n22(1), c_n22(2) )
          End do
       End do
    End Do
  end subroutine m_ES_MagMom_to_DensMat_vlhxcQ0

  subroutine m_ES_MagMom_to_DensMat_vlhxcQ( vlhxcQ_r_magmom, vlhxcQ_densmat, &
       &                                     vlhxcQ_i_magmom )
    real(kind=DP),         intent(in) :: vlhxcQ_r_magmom( nlmt, nlmt, natm, ndim_magmom )
    real(kind=DP),optional,intent(in) :: vlhxcQ_i_magmom( nlmt, nlmt, natm, ndim_magmom )
    complex(kind=CMPLDP), intent(out):: vlhxcQ_densmat( nlmt, nlmt, natm, ndim_chgpot )

    Real(kind=DP) :: c_rho(kimg), c_mx(kimg), c_my(kimg), c_mz(kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    integer :: ia, lmt1, lmt2

    vlhxcQ_densmat = 0.0d0
    Do ia=1, natm
       Do lmt2=1, nlmt
          Do lmt1=1, nlmt
             c_rho(1) = vlhxcQ_r_magmom( lmt1, lmt2, ia, 1 )
             c_mx(1)  = vlhxcQ_r_magmom( lmt1, lmt2, ia, 2 )
             c_my(1)  = vlhxcQ_r_magmom( lmt1, lmt2, ia, 3 )
             c_mz(1)  = vlhxcQ_r_magmom( lmt1, lmt2, ia, 4 )
!
             if ( present(vlhxcQ_i_magmom) ) then
                c_rho(2) = vlhxcQ_i_magmom( lmt1, lmt2, ia, 1 )
                c_mx(2)  = vlhxcQ_i_magmom( lmt1, lmt2, ia, 2 )
                c_my(2)  = vlhxcQ_i_magmom( lmt1, lmt2, ia, 3 )
                c_mz(2)  = vlhxcQ_i_magmom( lmt1, lmt2, ia, 4 )
             else
                c_rho(2) = 0.0d0
                c_mx(2) = 0.0d0
                c_my(2) = 0.0d0
                c_mz(2) = 0.0d0
             endif
       ! -------------------- real part ------
             c_n11(1) = c_rho(1) + c_mz(1)
             c_n22(1) = c_rho(1) - c_mz(1)
             c_n12(1) = c_mx(1)  + c_my(2)
             c_n21(1) = c_mx(1)  - c_my(2)
       ! ---------------------- imaginary part --
             c_n11(2) = c_rho(2) + c_mz(2)
             c_n22(2) = c_rho(2) - c_mz(2)
             c_n12(2) = c_mx(2)  - c_my(1)
             c_n21(2) = c_mx(2)  + c_my(1)
       ! ----
             vlhxcQ_densmat( lmt1, lmt2, ia, 1 ) = dcmplx( c_n11(1), c_n11(2) )
             vlhxcQ_densmat( lmt1, lmt2, ia, 2 ) = dcmplx( c_n12(1), c_n12(2) )
             vlhxcQ_densmat( lmt1, lmt2, ia, 3 ) = dcmplx( c_n21(1), c_n21(2) )
             vlhxcQ_densmat( lmt1, lmt2, ia, 4 ) = dcmplx( c_n22(1), c_n22(2) )
          End do
       End do
    End Do

  end subroutine m_ES_MagMom_to_DensMat_vlhxcQ

  subroutine m_ES_MagMom_to_DensMat_vlhxcl( vlhxc_l, vlhxc_ssrep )

    real(kind=DP), intent(in):: vlhxc_l(ista_kngp:iend_kngp,kimg,ndim_magmom)
    real(kind=DP), intent(out) :: vlhxc_ssrep(ista_kngp:iend_kngp,kimg,ndim_chgpot)
!
    integer :: i, k
    Real(kind=DP) :: c_rho(kimg), c_mx(kimg), c_my(kimg), c_mz(kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)

    vlhxc_ssrep = 0.0d0
    Do i=ista_kngp, iend_kngp

       Do k=1, kimg
          c_rho(k) = vlhxc_l( i,k,1 )
          c_mx(k)  = vlhxc_l( i,k,2 )
          c_my(k)  = vlhxc_l( i,k,3 )
          c_mz(k)  = vlhxc_l( i,k,4 )
       End do
       ! -------------------- real part ------
       c_n11(1) = c_rho(1) + c_mz(1) 
       c_n22(1) = c_rho(1) - c_mz(1) 
       c_n12(1) = c_mx(1)  + c_my(2) 
       c_n21(1) = c_mx(1)  - c_my(2) 
       ! ---------------------- imaginary part --
       c_n11(2) = c_rho(2) + c_mz(2)
       c_n22(2) = c_rho(2) - c_mz(2)
       c_n12(2) = c_mx(2)  - c_my(1)
       c_n21(2) = c_mx(2)  + c_my(1)
       ! ----
       Do k=1, kimg
          vlhxc_ssrep( i,k,1 ) = c_n11(k)
          vlhxc_ssrep( i,k,2 ) = c_n12(k)
          vlhxc_ssrep( i,k,3 ) = c_n21(k)
          vlhxc_ssrep( i,k,4 ) = c_n22(k)
       End do
! --
    End Do

  end subroutine m_ES_MagMom_to_DensMat_vlhxcl

  subroutine m_ES_DensMat_to_MagMom_vlhxcl( vlhxc_ssrep, vlhxc_l )

    real(kind=DP), intent(in) :: vlhxc_ssrep(ista_kngp:iend_kngp,kimg,ndim_chgpot)
    real(kind=DP), intent(out):: vlhxc_l(ista_kngp:iend_kngp,kimg,ndim_magmom)
!
    integer :: i, k
    Real(kind=DP) :: c_rho(kimg), c_mx(kimg), c_my(kimg), c_mz(kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)

    vlhxc_l = 0.0d0
    Do i=ista_kngp, iend_kngp

       Do k=1, kimg
          c_n11(k) = vlhxc_ssrep( i,k,1 )
          c_n12(k) = vlhxc_ssrep( i,k,2 )
          c_n21(k) = vlhxc_ssrep( i,k,3 )
          c_n22(k) = vlhxc_ssrep( i,k,4 )
       End do
! -------------------- real part ------
       c_rho(1) = ( c_n11(1) + c_n22(1) ) /2.0d0
       c_mx(1)  = ( c_n12(1) + c_n21(1) ) /2.0d0
       c_my(1)  = ( c_n21(2) - c_n12(2) ) /2.0d0
       c_mz(1)  = ( c_n11(1) - c_n22(1) ) /2.0d0
! ---------------------- imaginary part --
       c_rho(2) = ( c_n11(2) + c_n22(2) ) /2.0d0
       c_mx(2)  = ( c_n12(2) + c_n21(2) ) /2.0d0
       c_my(2)  = (-c_n21(1) + c_n12(1) ) /2.0d0
       c_mz(2)  = ( c_n11(2) - c_n22(2) ) /2.0d0
! ----
       Do k=1, kimg
          vlhxc_l( i,k,1 ) = c_rho(k)
          vlhxc_l( i,k,2 ) = c_mx(k)
          vlhxc_l( i,k,3 ) = c_my(k)
          vlhxc_l( i,k,4 ) = c_mz(k)
       End do
! --
    End Do

  end subroutine m_ES_DensMat_to_MagMom_vlhxcl


  subroutine m_ES_DensMat_To_MagMom_dm( dm_ssrep, dm_magmom, max2lp, max_projs )
    integer, intent(in) :: max2lp, max_projs
    complex(kind=CMPLDP), intent(in)  :: dm_ssrep( max2lp, max2lp, max_projs, &
         &                                         natm, ndim_chgpot )
    real(kind=DP), intent(out)  :: dm_magmom( max2lp, max2lp, max_projs, &
         &                                    natm, ndim_magmom )
!
    integer i, k
    integer :: ia, i1, i2, ip
    Real(kind=DP) :: c_rho(kimg), c_mx (kimg), c_my (kimg), c_mz (kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    dm_magmom = 0.0d0
    Do ia=1, natm
       Do ip=1, max_projs
          Do i2=1, max2lp
             Do i1=1, max2lp

                c_n11(1) = real( dm_ssrep( i1, i2, ip, ia, 1 ) )
                c_n12(1) = real( dm_ssrep( i1, i2, ip, ia, 2 ) )
                c_n21(1) = real( dm_ssrep( i1, i2, ip, ia, 3 ) )
                c_n22(1) = real( dm_ssrep( i1, i2, ip, ia, 4 ) )

                c_n11(2) = aimag( dm_ssrep( i1, i2, ip, ia, 1 ) )
                c_n12(2) = aimag( dm_ssrep( i1, i2, ip, ia, 2 ) )
                c_n21(2) = aimag( dm_ssrep( i1, i2, ip, ia, 3 ) )
                c_n22(2) = aimag( dm_ssrep( i1, i2, ip, ia, 4 ) )

! -------------------- real part ------
                c_rho(1) = c_n11(1) + c_n22(1)
                c_mx(1)  = c_n12(1) + c_n21(1)
                c_my(1)  = c_n21(2) - c_n12(2)
                c_mz(1)  = c_n11(1) - c_n22(1)
! ---------------------- imaginary part --
                c_rho(2) = c_n11(2) + c_n22(2)
                c_mx(2)  = c_n12(2) + c_n21(2)
                c_my(2)  =-c_n21(1) + c_n12(1)
                c_mz(2)  = c_n11(2) - c_n22(2)
!
                dm_magmom( i1, i2, ip, ia, 1 )  = c_rho(1)
                dm_magmom( i1, i2, ip, ia, 2 )  = c_mx(1)
                dm_magmom( i1, i2, ip, ia, 3 )  = c_my(1)
                dm_magmom( i1, i2, ip, ia, 4 )  = c_mz(1)
             End Do
          End do
       End do
! --
    End Do
  end subroutine m_ES_DensMat_To_MagMom_dm

  subroutine m_ES_MagMom_To_DensMat_porb0( nsize, porb_r_magmom, &
       &                                  porb_ssrep )

    integer, intent(in) :: nsize
    real(kind=DP), intent(in)  :: porb_r_magmom( nsize, ndim_magmom )
!    real(kind=DP), intent(in)  :: porb_i_magmom( nsize, ndim_magmom )
    complex(kind=CMPLDP), intent(out)  :: porb_ssrep( nsize, ndim_chgpot )
!
    integer :: i
    Real(kind=DP) :: c_rho(kimg), c_mx(kimg), c_my(kimg), c_mz(kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    porb_ssrep = 0.0d0

    Do i=1, nsize
       c_rho(1) = porb_r_magmom( i,1 )
       c_mx(1)  = porb_r_magmom( i,2 ) 
       c_my(1)  = porb_r_magmom( i,3 ) 
       c_mz(1)  = porb_r_magmom( i,4 ) 

!       c_rho(2) = porb_i_magmom( i,1 )
!       c_mx(2)  = porb_i_magmom( i,2 )
!       c_my(2)  = porb_i_magmom( i,3 )
!       c_mz(2)  = porb_i_magmom( i,4 )
       c_rho(2) = 0.0d0
       c_mx(2)  = 0.0d0
       c_my(2)  = 0.0d0
       c_mz(2)  = 0.0d0

       ! -------------------- real part ------
       c_n11(1) = ( c_rho(1) + c_mz(1) ) /2.0d0
       c_n22(1) = ( c_rho(1) - c_mz(1) ) /2.0d0
       c_n12(1) = ( c_mx(1)  + c_my(2) ) /2.0d0
       c_n21(1) = ( c_mx(1)  - c_my(2) ) /2.0d0
       ! ---------------------- imaginary part --
       c_n11(2) = ( c_rho(2) + c_mz(2) ) /2.0d0
       c_n22(2) = ( c_rho(2) - c_mz(2) ) /2.0d0
       c_n12(2) = ( c_mx(2)  - c_my(1) ) /2.0d0
       c_n21(2) = ( c_mx(2)  + c_my(1) ) /2.0d0
!
       porb_ssrep( i, 1 ) = dcmplx( c_n11(1), c_n11(2) )
       porb_ssrep( i, 2 ) = dcmplx( c_n12(1), c_n12(2) )
       porb_ssrep( i, 3 ) = dcmplx( c_n21(1), c_n21(2) )
       porb_ssrep( i, 4 ) = dcmplx( c_n22(1), c_n22(2) )
! --
    End Do
  end subroutine m_ES_MagMom_To_DensMat_porb0

  subroutine m_ES_MagMom_To_DensMat_porb( nsize, porb_r_magmom, porb_i_magmom, &
       &                                  porb_ssrep )

    integer, intent(in) :: nsize
    real(kind=DP), intent(in)  :: porb_r_magmom( nsize, ndim_magmom )
    real(kind=DP), intent(in)  :: porb_i_magmom( nsize, ndim_magmom )
    complex(kind=CMPLDP), intent(out)  :: porb_ssrep( nsize, ndim_chgpot )
!
    integer :: i
    Real(kind=DP) :: c_rho(kimg), c_mx(kimg), c_my(kimg), c_mz(kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    porb_ssrep = 0.0d0

    Do i=1, nsize
       c_rho(1) = porb_r_magmom( i,1 )
       c_mx(1)  = porb_r_magmom( i,2 )
       c_my(1)  = porb_r_magmom( i,3 )
       c_mz(1)  = porb_r_magmom( i,4 )

       c_rho(2) = porb_i_magmom( i,1 )
       c_mx(2)  = porb_i_magmom( i,2 )
       c_my(2)  = porb_i_magmom( i,3 )
       c_mz(2)  = porb_i_magmom( i,4 )

       ! -------------------- real part ------
       c_n11(1) = ( c_rho(1) + c_mz(1) ) /2.0d0
       c_n22(1) = ( c_rho(1) - c_mz(1) ) /2.0d0
       c_n12(1) = ( c_mx(1)  + c_my(2) ) /2.0d0
       c_n21(1) = ( c_mx(1)  - c_my(2) ) /2.0d0
       ! ---------------------- imaginary part --
       c_n11(2) = ( c_rho(2) + c_mz(2) ) /2.0d0
       c_n22(2) = ( c_rho(2) - c_mz(2) ) /2.0d0
       c_n12(2) = ( c_mx(2)  - c_my(1) ) /2.0d0
       c_n21(2) = ( c_mx(2)  + c_my(1) ) /2.0d0
!
       porb_ssrep( i, 1 ) = dcmplx( c_n11(1), c_n11(2) )
       porb_ssrep( i, 2 ) = dcmplx( c_n12(1), c_n12(2) )
       porb_ssrep( i, 3 ) = dcmplx( c_n21(1), c_n21(2) )
       porb_ssrep( i, 4 ) = dcmplx( c_n22(1), c_n22(2) )
! --
    End Do
  end subroutine m_ES_MagMom_To_DensMat_porb

  subroutine m_ES_DensMat_To_MagMom_porb( nsize, porb_ssrep, porb_magmom )

    integer, intent(in) :: nsize
    complex(kind=CMPLDP), intent(in)  :: porb_ssrep( nsize, ndim_chgpot )
    real(kind=DP), intent(out)  :: porb_magmom( nsize, ndim_magmom )
!
    integer :: i
    Real(kind=DP) :: c_rho(kimg), c_mx (kimg), c_my (kimg), c_mz (kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    porb_magmom = 0.0d0
    Do i=1, nsize
       c_n11(1) = real( porb_ssrep( i, 1 ) )
       c_n12(1) = real( porb_ssrep( i, 2 ) )
       c_n21(1) = real( porb_ssrep( i, 3 ) )
       c_n22(1) = real( porb_ssrep( i, 4 ) )

       c_n11(2) = aimag( porb_ssrep( i, 1 ) )
       c_n12(2) = aimag( porb_ssrep( i, 2 ) )
       c_n21(2) = aimag( porb_ssrep( i, 3 ) )
       c_n22(2) = aimag( porb_ssrep( i, 4 ) )

! -------------------- real part ------
       c_rho(1) = c_n11(1) + c_n22(1)
       c_mx(1)  = c_n12(1) + c_n21(1)
       c_my(1)  = c_n21(2) - c_n12(2)
       c_mz(1)  = c_n11(1) - c_n22(1)
! ---------------------- imaginary part --
       c_rho(2) = c_n11(2) + c_n22(2)
       c_mx(2)  = c_n12(2) + c_n21(2)
       c_my(2)  =-c_n21(1) + c_n12(1)
       c_mz(2)  = c_n11(2) - c_n22(2)
!
       porb_magmom( i, 1 ) = c_rho(1)
       porb_magmom( i, 2 ) = c_mx(1)
       porb_magmom( i, 3 ) = c_my(1)
       porb_magmom( i, 4 ) = c_mz(1)
! --
    End Do
  end subroutine m_ES_DensMat_To_MagMom_porb

  subroutine m_ES_MagMom_to_DensMat_DionPaw( dion_magmom, dion_ssrep )
    real(kind=DP), intent(in):: dion_magmom(nlmt,nlmt,ndim_magmom,natm)
    complex(kind=CMPLDP), intent(out) :: dion_ssrep(nlmt,nlmt,ndim_chgpot,natm)
!
    integer :: ia, lmt1, lmt2
    Real(kind=DP) :: c_rho, c_mx, c_my, c_mz
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)

    dion_ssrep = 0.0d0
    Do ia=1, natm
       Do lmt2=1, nlmt
          Do lmt1=1, nlmt
             c_rho = dion_magmom( lmt1, lmt2, 1, ia )
             c_mx  = dion_magmom( lmt1, lmt2, 2, ia )
             c_my  = dion_magmom( lmt1, lmt2, 3, ia )
             c_mz  = dion_magmom( lmt1, lmt2, 4, ia )
             ! -------------------- real part ------
             c_n11(1) = c_rho + c_mz 
             c_n22(1) = c_rho - c_mz 
             c_n12(1) = c_mx
             c_n21(1) = c_mx
       ! ---------------------- imaginary part --
             c_n11(2) = 0.0d0
             c_n22(2) = 0.0d0
             c_n12(2) = -c_my
             c_n21(2) =  c_my
       ! ----
             dion_ssrep( lmt1, lmt2, 1, ia ) = dcmplx( c_n11(1), c_n11(2) )
             dion_ssrep( lmt1, lmt2, 2, ia ) = dcmplx( c_n12(1), c_n12(2) )
             dion_ssrep( lmt1, lmt2, 3, ia ) = dcmplx( c_n21(1), c_n21(2) )
             dion_ssrep( lmt1, lmt2, 4, ia ) = dcmplx( c_n22(1), c_n22(2) )
          End do
       End Do
! --
    End Do

  end subroutine m_ES_MagMom_to_DensMat_DionPaw

  subroutine m_ES_DensMat_to_MagMom_Dhub0( dhub_ssrep, dhub_magmom )
    complex(kind=CMPLDP), intent(in) :: dhub_ssrep(nlmt,nlmt,natm,ndim_chgpot)
    real(kind=DP), intent(out):: dhub_magmom(nlmt,nlmt,natm,ndim_magmom)
!
    integer :: ia, lmt1, lmt2
    Real(kind=DP) :: c_rho(kimg), c_mx(kimg), c_my(kimg), c_mz(kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    dhub_magmom = 0.0d0

    Do ia=1, natm
       Do lmt2=1, nlmt
          Do lmt1=1, nlmt
             c_n11(1) = real( dhub_ssrep( lmt1, lmt2, ia, 1 ) )
             c_n12(1) = real( dhub_ssrep( lmt1, lmt2, ia, 2 ) )
             c_n21(1) = real( dhub_ssrep( lmt1, lmt2, ia, 3 ) )
             c_n22(1) = real( dhub_ssrep( lmt1, lmt2, ia, 4 ) )

             c_n11(2) = aimag( dhub_ssrep( lmt1, lmt2, ia, 1 ) )
             c_n12(2) = aimag( dhub_ssrep( lmt1, lmt2, ia, 2 ) )
             c_n21(2) = aimag( dhub_ssrep( lmt1, lmt2, ia, 3 ) )
             c_n22(2) = aimag( dhub_ssrep( lmt1, lmt2, ia, 4 ) )

! -------------------- real part ------
             c_rho(1) = ( c_n11(1) + c_n22(1) ) /2.0d0
             c_mx(1)  = ( c_n12(1) + c_n21(1) ) /2.0d0
             c_my(1)  = ( c_n21(2) - c_n12(2) ) /2.0d0
             c_mz(1)  = ( c_n11(1) - c_n22(1) ) /2.0d0
! ---------------------- imaginary part --
             c_rho(2) = ( c_n11(2) + c_n22(2) ) /2.0d0
             c_mx(2)  = ( c_n12(2) + c_n21(2) ) /2.0d0
             c_my(2)  = (-c_n21(1) + c_n12(1) ) /2.0d0
             c_mz(2)  = ( c_n11(2) - c_n22(2) ) /2.0d0
! ----
             dhub_magmom( lmt1, lmt2, ia, 1 ) = c_rho(1)
             dhub_magmom( lmt1, lmt2, ia, 2 ) = c_mx(1)
             dhub_magmom( lmt1, lmt2, ia, 3 ) = c_my(1)
             dhub_magmom( lmt1, lmt2, ia, 4 ) = c_mz(1)
!
!             write(500,*) 'ilmt1 ilmt2 ia ', lmt1, lmt2, ia
!             write(500,*) c_rho(2), c_mx(2), c_my(2), c_mz(2)
          End do
       End Do
! --
    End Do

  end subroutine m_ES_DensMat_to_MagMom_Dhub0

  subroutine m_ES_DensMat_to_MagMom_Dhub( dhub_ssrep, dhub_r_magmom, dhub_i_magmom )
    complex(kind=CMPLDP), intent(in) :: dhub_ssrep(nlmt,nlmt,natm,ndim_chgpot)
    real(kind=DP), intent(out):: dhub_r_magmom(nlmt,nlmt,natm,ndim_magmom)
    real(kind=DP), intent(out):: dhub_i_magmom(nlmt,nlmt,natm,ndim_magmom)
!
    integer :: ia, lmt1, lmt2
    Real(kind=DP) :: c_rho(kimg), c_mx(kimg), c_my(kimg), c_mz(kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    dhub_r_magmom = 0.0d0
    dhub_i_magmom = 0.0d0

    Do ia=1, natm
       Do lmt2=1, nlmt
          Do lmt1=1, nlmt
             c_n11(1) = real( dhub_ssrep( lmt1, lmt2, ia, 1 ) )
             c_n12(1) = real( dhub_ssrep( lmt1, lmt2, ia, 2 ) )
             c_n21(1) = real( dhub_ssrep( lmt1, lmt2, ia, 3 ) )
             c_n22(1) = real( dhub_ssrep( lmt1, lmt2, ia, 4 ) )

             c_n11(2) = aimag( dhub_ssrep( lmt1, lmt2, ia, 1 ) )
             c_n12(2) = aimag( dhub_ssrep( lmt1, lmt2, ia, 2 ) )
             c_n21(2) = aimag( dhub_ssrep( lmt1, lmt2, ia, 3 ) )
             c_n22(2) = aimag( dhub_ssrep( lmt1, lmt2, ia, 4 ) )

! -------------------- real part ------
             c_rho(1) = ( c_n11(1) + c_n22(1) ) /2.0d0
             c_mx(1)  = ( c_n12(1) + c_n21(1) ) /2.0d0
             c_my(1)  = ( c_n21(2) - c_n12(2) ) /2.0d0
             c_mz(1)  = ( c_n11(1) - c_n22(1) ) /2.0d0
! ---------------------- imaginary part --
             c_rho(2) = ( c_n11(2) + c_n22(2) ) /2.0d0
             c_mx(2)  = ( c_n12(2) + c_n21(2) ) /2.0d0
             c_my(2)  = (-c_n21(1) + c_n12(1) ) /2.0d0
             c_mz(2)  = ( c_n11(2) - c_n22(2) ) /2.0d0
! ----
             dhub_r_magmom( lmt1, lmt2, ia, 1 ) = c_rho(1)
             dhub_r_magmom( lmt1, lmt2, ia, 2 ) = c_mx(1)
             dhub_r_magmom( lmt1, lmt2, ia, 3 ) = c_my(1)
             dhub_r_magmom( lmt1, lmt2, ia, 4 ) = c_mz(1)
! ----
             dhub_i_magmom( lmt1, lmt2, ia, 1 ) = c_rho(2)
             dhub_i_magmom( lmt1, lmt2, ia, 2 ) = c_mx(2)
             dhub_i_magmom( lmt1, lmt2, ia, 3 ) = c_my(2)
             dhub_i_magmom( lmt1, lmt2, ia, 4 ) = c_mz(2)
!
!             write(500,*) 'ilmt1 ilmt2 ia ', lmt1, lmt2, ia
!             write(500,*) c_rho(2), c_mx(2), c_my(2), c_mz(2)
          End do
       End Do
! --
    End Do

  end subroutine m_ES_DensMat_to_MagMom_Dhub
  
  subroutine m_ES_MagMom_to_DensMat_Dhub( dhub_r_magmom, dhub_i_magmom, dhub_ssrep )
    real(kind=DP), intent(in):: dhub_r_magmom(nlmt,nlmt,natm,ndim_magmom)
    real(kind=DP), intent(in):: dhub_i_magmom(nlmt,nlmt,natm,ndim_magmom)
    complex(kind=CMPLDP), intent(out) :: dhub_ssrep(nlmt,nlmt,natm,ndim_chgpot)
!
    integer :: ia, lmt1, lmt2
    Real(kind=DP) :: c_rho(kimg), c_mx(kimg), c_my(kimg), c_mz(kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    dhub_ssrep = 0.0d0

    Do ia=1, natm
       Do lmt2=1, nlmt
          Do lmt1=1, nlmt

             c_rho(1) = dhub_r_magmom( lmt1, lmt2, ia, 1 )
             c_mx(1)  = dhub_r_magmom( lmt1, lmt2, ia, 2 )
             c_my(1)  = dhub_r_magmom( lmt1, lmt2, ia, 3 )
             c_mz(1)  = dhub_r_magmom( lmt1, lmt2, ia, 4 )
!
             c_rho(2) = dhub_i_magmom( lmt1, lmt2, ia, 1 )
             c_mx(2)  = dhub_i_magmom( lmt1, lmt2, ia, 2 )
             c_my(2)  = dhub_i_magmom( lmt1, lmt2, ia, 3 )
             c_mz(2)  = dhub_i_magmom( lmt1, lmt2, ia, 4 )

       ! -------------------- real part ------
             c_n11(1) = c_rho(1) + c_mz(1)
             c_n22(1) = c_rho(1) - c_mz(1)
             c_n12(1) = c_mx(1)  + c_my(2)
             c_n21(1) = c_mx(1)  - c_my(2)
       ! ---------------------- imaginary part --
             c_n11(2) = c_rho(2) + c_mz(2)
             c_n22(2) = c_rho(2) - c_mz(2)
             c_n12(2) = c_mx(2)  - c_my(1)
             c_n21(2) = c_mx(2)  + c_my(1)
       ! ----
             dhub_ssrep( lmt1, lmt2, ia, 1 ) = dcmplx( c_n11(1), c_n11(2) )
             dhub_ssrep( lmt1, lmt2, ia, 2 ) = dcmplx( c_n12(1), c_n12(2) )
             dhub_ssrep( lmt1, lmt2, ia, 3 ) = dcmplx( c_n21(1), c_n21(2) )
             dhub_ssrep( lmt1, lmt2, ia, 4 ) = dcmplx( c_n22(1), c_n22(2) )

          End do
       End Do
! --
    End Do

  end subroutine m_ES_MagMom_to_DensMat_Dhub

! ------------------------------------------------------------------------
!!
!!!   Diagonalize the density matrix, obtain the local quantization axis, 
!!!                and up/down spin desity along this axis
!!
! -----------------------------------------------------------------------
  subroutine m_ES_get_Angles_MagMom_Rspace( RhoMag_R, Rot_Angles )
    Real(kind=DP), intent(in)  :: RhoMag_R(    ista_fftph:iend_fftph,ndim_magmom )
    Real(kind=DP), intent(out) :: Rot_Angles( ista_fftph:iend_fftph,2 )
    
    integer :: i
    Real(kind=DP) :: c_n, c_mx, c_my, c_mz
    Real(kind=DP) :: theta, phi, m_norm
    
!    real(kind=DP) :: m_norm_criteria = 5.0D-3
!    real(kind=DP) :: m_norm_criteria = 1.0D-6
!    real(kind=DP) :: m_norm_criteria = 1.0D-12
    real(kind=DP) :: m_norm_criteria = 1.0D-20

! --
    real(kind=DP) :: theta_neighbor, phi_neighbor 

! --------- initialize --
    theta_neighbor = 0.0d0
    phi_neighbor = 0.0d0
! --
!    write(940,*) 'aa '

    Do i=ista_fftph, iend_fftph
       c_n  = RhoMag_R( i,1 );  c_mx = RhoMag_R( i,2 )
       c_my = RhoMag_R( i,3 );  c_mz = RhoMag_R( i,4 )
!
       m_norm = sqrt( c_mx**2 + c_my**2 + c_mz**2 )
!
       if ( m_norm > m_norm_criteria ) then

! ---------------- original ------
!!!!!!!!          theta = atan2( sqrt( c_mx**2 +c_my**2), c_mz )
!!!!!          phi = atan2(  c_my, c_mx )

! --- for test -
          theta = atan2( sqrt( c_mx**2 +c_my**2), abs(c_mz) )
          phi = atan2( abs(c_my), abs(c_mx) )

!          goto 100
          goto 120

! --- for test2 -

          if ( c_mz > 0.0d0 ) then
             theta = atan2( sqrt( c_mx**2 +c_my**2), c_mz )
             phi = atan2( c_my, c_mx )
          else if ( c_mz < 0.0d0 ) then
             theta = atan2( sqrt( c_mx**2 +c_my**2), -c_mz )
             phi = atan2( -c_my, -c_mx )
          else
             theta = atan2( sqrt( c_mx**2 +c_my**2), -c_mz )
             if ( c_mx > 0.0d0 ) then
                phi = atan2( c_my,  c_mx )
             else if ( c_mx < 0.0d0 ) then
                phi = atan2( -c_my,  -c_mx )
             else
                phi = atan2( abs(c_my), c_mx )
             endif
          endif

120       continue
! --- for test3 -

!          write(940,*) i, c_n
          if ( c_mz >= 0.0d0 ) then
             theta = atan2( sqrt( c_mx**2 +c_my**2), c_mz )
             phi = atan2( c_my, c_mx )
          else if ( c_mz < 0.0d0 ) then
             theta = atan2( sqrt( c_mx**2 +c_my**2), -c_mz )
             phi = atan2( -c_my, -c_mx )
          endif

100       continue

       else
!!!!!!          theta = 0.0d0;       phi =0.0d0
          theta = theta_neighbor;  phi  = phi_neighbor
       endif
!
       theta_neighbor = theta;  phi_neighbor = phi
!!
       Rot_Angles( i, 1 ) = theta
       Rot_Angles( i, 2 ) = phi
    End do
  end subroutine m_ES_get_Angles_MagMom_Rspace

  subroutine m_ES_get_Angles_MagMom_Rspace2( RhoMag_R, Rot_Angles )
    Real(kind=DP), intent(in)  :: RhoMag_R(    ista_fftph:iend_fftph,ndim_magmom )
    Real(kind=DP), intent(out) :: Rot_Angles( ista_fftph:iend_fftph,2 )
    
    integer :: i
    Real(kind=DP) :: c_n, c_mx, c_my, c_mz
    Real(kind=DP) :: mmx, mmy, mmz, ctmp
    Real(kind=DP) :: theta, phi, m_norm
    
!    real(kind=DP) :: m_norm_criteria = 5.0D-3
!    real(kind=DP) :: m_norm_criteria = 1.0D-6
!    real(kind=DP) :: m_norm_criteria = 1.0D-12
    real(kind=DP) :: m_norm_criteria = 1.0D-20
! --
    real(kind=DP) :: theta_neighbor, phi_neighbor 
    real(kind=DP) :: theta0, phi0

    real(kind=DP) :: MagDirec_OnMesh_avg(3)

! --------- initialize --
    theta_neighbor = 0.0d0
    phi_neighbor = 0.0d0
! --
!    write(940,*) 'aa '

    call calc_averaged_mag_direc_now( MagDirec_OnMesh_avg )
!
    theta0 = atan2( sqrt( MagDirec_OnMesh_avg(1)**2 &
         &             + MagDirec_OnMesh_avg(2)**2 ), MagDirec_OnMesh_avg(3) )
    phi0 = atan2( MagDirec_OnMesh_avg(2), MagDirec_OnMesh_avg(1) )
!
!    write(990,*) 'th0 ph0 = ', theta0, phi0
!    write(990,*) MagDirec_OnMesh_Avg(1), MagDirec_OnMesh_Avg(2), MagDirec_OnMesh_Avg(3)
!
    Do i=ista_fftph, iend_fftph
       c_n  = RhoMag_R( i,1 );  c_mx = RhoMag_R( i,2 )
       c_my = RhoMag_R( i,3 );  c_mz = RhoMag_R( i,4 )
!
       m_norm = sqrt( c_mx**2 + c_my**2 + c_mz**2 )
!
       if ( m_norm > m_norm_criteria ) then
!
          mmx = c_mx / m_norm
          mmy = c_my / m_norm
          mmz = c_mz / m_norm

          ctmp = mmx *MagDirec_OnMesh_avg(1) &
               & + mmy *MagDirec_OnMesh_avg(2) &
               & + mmz *MagDirec_OnMesh_avg(3)

          theta = atan2( sqrt( c_mx**2 +c_my**2), c_mz )
          phi = atan2( c_my, c_mx )

          if ( ctmp >= 0.0d0 ) then
          else 
!             theta = atan2( sqrt( c_mx**2 +c_my**2), -c_mz )
!             phi = atan2( -c_my, -c_mx )
             theta = PAI - theta
             phi =   PAI + phi
          endif

       else
!          theta = theta0
!          phi = phi0
          theta = theta_neighbor
          phi = phi_neighbor
       endif

       theta_neighbor = theta;  phi_neighbor = phi
!!
       Rot_Angles( i, 1 ) = theta
       Rot_Angles( i, 2 ) = phi
    End do


  contains
    
    subroutine calc_averaged_mag_direc_now( MagDirec_OnMesh_avg )
      real(kind=DP), intent(out) :: MagDirec_OnMesh_avg(3)
      
      real(kind=DP) :: MagVectorSum(3), MagVectorSum_mpi(3)
      real(kind=DP) :: cnorm
      integer :: i

      MagDirec_OnMesh_avg = 0.0d0

      MagVectorSum = 0.0d0
      Do i=ista_fftph, iend_fftph
         MagVectorSum(1) = MagVectorSum(1) +  abs( RhoMag_R( i,2 ) )
         MagVectorSum(2) = MagVectorSum(2) +  abs( RhoMag_R( i,3 ) )
         MagVectorSum(3) = MagVectorSum(3) +  abs( RhoMag_R( i,4 ) )
      End do

      if ( npes > 1 ) then
         call mpi_allreduce( MagVectorSum, MagVectorSum_mpi, 3, &
              &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
         MagVectorSum = MagVectorSum_mpi
      endif
!
      cnorm = MagVectorSum(1)**2 + MagVectorSum(2)**2 + MagVectorSum(3)**2
      cnorm = sqrt( cnorm )
!
      if ( cnorm > m_norm_criteria ) then
         MagDirec_OnMesh_avg = MagVectorSum / cnorm
      else
         MagDirec_OnMesh_avg(3) = 1.0d0
      endif
    end subroutine calc_averaged_mag_direc_now

  end subroutine m_ES_get_Angles_MagMom_Rspace2


  subroutine m_ES_SpinDens_Along_QuantzAxis( RhoMag_R, Rot_Angles, chgrhr_l )
    Real(kind=DP), intent(in)  :: RhoMag_R(   ista_fftph:iend_fftph,ndim_magmom )
    Real(kind=DP), intent(in)  :: Rot_Angles( ista_fftph:iend_fftph,nspin )
    Real(kind=DP), intent(out) :: chgrhr_l(   ista_fftph:iend_fftph,nspin )

    integer :: i
    Real(kind=DP) :: c_n, c_mx, c_my, c_mz, c_tmp
    Real(kind=DP) :: theta, phi
    Real(kind=DP) :: cos_th, sin_th, cos_ph, sin_ph
    !
    chgrhr_l = 0.0d0
    Do i=ista_fftph, iend_fftph
       c_n  = RhoMag_R( i,1 );      c_mx = RhoMag_R( i,2 )
       c_my = RhoMag_R( i,3 );      c_mz = RhoMag_R( i,4 )
!
       theta = Rot_Angles( i,1 );    phi   = Rot_Angles( i,2 )
!
       cos_th = cos( theta );  sin_th = sin( theta )
       cos_ph = cos( phi );    sin_ph = sin( phi )
       !
!!!!!!!!!!!!!!!!!       c_tmp = ( c_mx *cos_ph - c_my *sin_ph ) /2.0d0
       c_tmp = ( c_mx *cos_ph + c_my *sin_ph ) /2.0d0
       c_tmp = c_tmp *sin_th
!
       chgrhr_l( i,1 ) = ( c_n + c_mz *cos_th ) /2.0d0  + c_tmp       ! up
       chgrhr_l( i,2 ) = ( c_n - c_mz *cos_th ) /2.0d0  - c_tmp       ! down
! --
!       write(*,*) "  A ", i, theta, phi
!       write(*,*) "  B ", i, c_mz

    End do
!
    if ( iprixc >=2 ) then
       write(nfout,*) '!ES XC =='
       write(nfout,*) '!ES XC :         ispin = 1 '
       write(nfout,*) '!ES XC -- chgrhr_l -- '
       write(nfout,'(" !ES XC ",6f12.6)') (chgrhr_l(i,1),i=ista_fftph,ista_fftph+17)
!
       write(nfout,*) '!ES XC =='
       write(nfout,*) '!ES XC :         ispin = 2 '
       write(nfout,*) '!ES XC -- chgrhr_l -- '
       write(nfout,'(" !ES XC ",6f12.6)') (chgrhr_l(i,2),i=ista_fftph,ista_fftph+17)

    endif
!
  end subroutine m_ES_SpinDens_Along_QuantzAxis

  subroutine m_ES_SpinDens_Along_QuantzAxis2( RhoMag_R, chgrhr_l, &
       &                                      quantz_axis_inversion_flg_mesh, &
       &                                      skip_flag )
    Real(kind=DP), intent(in)  :: RhoMag_R(   ista_fftph:iend_fftph,ndim_magmom )
    Real(kind=DP), intent(out) :: chgrhr_l(   ista_fftph:iend_fftph,nspin )
    integer, intent(inout) :: quantz_axis_inversion_flg_mesh(ista_fftph:iend_fftph)
    logical, intent(in) :: skip_flag

    integer :: i
    Real(kind=DP) :: c_n, c_mx, c_my, c_mz, ctmp
    real(kind=DP) :: d1, d2
    real(kind=DP) :: MagDirec_OnMesh_avg(3)
    real(kind=DP) :: mmx, mmy, mmz, m_norm
    real(kind=DP) :: m_norm_criteria = 1.0D-20
!    real(kind=DP) :: m_norm_lowlimit = 1.0D-40
    real(kind=DP) :: m_norm_lowlimit = 1.0D-30

    integer :: exit_flag
    integer :: count1, count1_sum
    integer :: count2, count2_sum

! ============
!    call calc_averaged_mag_direc_now( MagDirec_OnMesh_avg )

    call calc_averaged_mag_direc_now_A( Global_Quantz_axis_now, exit_flag )
    if ( exit_flag == 1 ) then
       call calc_averaged_mag_direc_now_B( Global_Quantz_axis_now )
    endif
! ===========

    if ( iprixc >=2 ) then
       write(nfout,'(A,3E20.10)') "!ES XC : GlobalAxis = ", Global_Quantz_axis_now(1:3)
    endif

    chgrhr_l = 0.0d0
    Do i=ista_fftph, iend_fftph
       c_n  = RhoMag_R( i,1 );      c_mx = RhoMag_R( i,2 )
       c_my = RhoMag_R( i,3 );      c_mz = RhoMag_R( i,4 )
!
       m_norm = sqrt( c_mx**2 + c_my**2 + c_mz**2 )
       d1 = (c_n +m_norm) /2.0d0;  d2 = ( c_n - m_norm )/2.0d0

! ---- only test, but may be important ------
       if ( skip_flag ) goto 130
       
!       if ( c_n < 0.0 ) then
!          d1 = m_norm_lowlimit;    d2 = m_norm_lowlimit
!       else
          if ( d1 < 0.0 ) d1 = m_norm_lowlimit
          if ( d2 < 0.0 ) d2 = m_norm_lowlimit
!       endif
       
130    continue
! -----------------------------------------
       if ( m_norm > m_norm_criteria ) then
!
!          mmx = c_mx / m_norm
!          mmy = c_my / m_norm
!         mmz = c_mz / m_norm
          mmx = c_mx
          mmy = c_my
          mmz = c_mz

!          ctmp = mmx *MagDirec_OnMesh_avg(1) &
!               & + mmy *MagDirec_OnMesh_avg(2) &
!               & + mmz *MagDirec_OnMesh_avg(3)
          ctmp = mmx *Global_Quantz_Axis_now(1) &
               & + mmy *Global_Quantz_Axis_now(2) &
               & + mmz *Global_Quantz_Axis_now(3)

          if ( ctmp > 0.0 ) then 
             chgrhr_l( i,1 ) = d1;  chgrhr_l( i,2 ) = d2
             quantz_axis_inversion_flg_mesh(i) = 1
          else
             chgrhr_l( i,1 ) = d2;  chgrhr_l( i,2 ) = d1
             quantz_axis_inversion_flg_mesh(i) = -1
          endif
!
       else
!!!!          d1 = ( d1 +d2 )/2.0d0;  d2 = d1
          chgrhr_l( i,1 ) = d1;  chgrhr_l( i,2 ) = d2
          quantz_axis_inversion_flg_mesh(i) = 1
       endif

    End do
!
    if ( iprixc >=2 ) then
       write(nfout,*) '!ES XC =='
       write(nfout,*) '!ES XC :         ispin = 1 '
       write(nfout,*) '!ES XC -- chgrhr_l -- '
       write(nfout,'(" !ES XC ",6f12.6)') (chgrhr_l(i,1),i=ista_fftph,ista_fftph+17)
!
       write(nfout,*) '!ES XC =='
       write(nfout,*) '!ES XC :         ispin = 2 '
       write(nfout,*) '!ES XC -- chgrhr_l -- '
       write(nfout,'(" !ES XC ",6f12.6)') (chgrhr_l(i,2),i=ista_fftph,ista_fftph+17)
    endif
!
    if ( iprixc >=2 ) then
       count1 = 0;  count2 = 0
       Do i=ista_fftph, iend_fftph
          if ( quantz_axis_inversion_flg_mesh(i) ==  1 ) count1 = count1 +1
          if ( quantz_axis_inversion_flg_mesh(i) == -1 ) count2 = count2 +1
       Enddo
       call mpi_allreduce( count1, count1_sum, 1, mpi_integer, &
            &              mpi_sum, mpi_comm_group, ierr )
       call mpi_allreduce( count2, count2_sum, 1, mpi_integer, &
            &              mpi_sum, mpi_comm_group, ierr )
       write(nfout,*) 'count_sum = ', count1_sum, count2_sum
    endif

  contains

    subroutine calc_averaged_mag_direc_now_A( MagDirec_OnMesh_avg, exit_flag )
      real(kind=DP), intent(out) :: MagDirec_OnMesh_avg(3)
      integer, intent(out) :: exit_flag

      real(kind=DP) :: MagVectorSum(3), MagVectorSum_mpi(3)
      real(kind=DP) :: cnorm
      integer :: i

      MagDirec_OnMesh_avg = 0.0d0

      MagVectorSum = 0.0d0
      Do i=ista_fftph, iend_fftph
         MagVectorSum(1) = MagVectorSum(1) +  RhoMag_R( i,2 )
         MagVectorSum(2) = MagVectorSum(2) +  RhoMag_R( i,3 )
         MagVectorSum(3) = MagVectorSum(3) +  RhoMag_R( i,4 )
      End do

      if ( npes > 1 ) then
         call mpi_allreduce( MagVectorSum, MagVectorSum_mpi, 3, &
              &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
         MagVectorSum = MagVectorSum_mpi
      endif
!
      cnorm = MagVectorSum(1)**2 + MagVectorSum(2)**2 + MagVectorSum(3)**2
      cnorm = sqrt( cnorm )
!
      if ( cnorm > m_norm_criteria ) then
         MagDirec_OnMesh_avg = MagVectorSum / cnorm
         exit_flag = 0
      else
         MagDirec_OnMesh_avg(3) = 1.0d0
         exit_flag = 1
      endif
    end subroutine calc_averaged_mag_direc_now_A

    subroutine calc_averaged_mag_direc_now_B( MagDirec_OnMesh_avg )
      real(kind=DP), intent(out) :: MagDirec_OnMesh_avg(3)
      
      real(kind=DP) :: MagVectorSum(3), MagVectorSum_mpi(3)
      real(kind=DP) :: cnorm
      integer :: i

      MagDirec_OnMesh_avg = 0.0d0

      MagVectorSum = 0.0d0
      Do i=ista_fftph, iend_fftph
         MagVectorSum(1) = MagVectorSum(1) +  abs( RhoMag_R( i,2 ) )
         MagVectorSum(2) = MagVectorSum(2) +  abs( RhoMag_R( i,3 ) )
         MagVectorSum(3) = MagVectorSum(3) +  abs( RhoMag_R( i,4 ) )
      End do

      if ( npes > 1 ) then
         call mpi_allreduce( MagVectorSum, MagVectorSum_mpi, 3, &
              &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
         MagVectorSum = MagVectorSum_mpi
      endif
!
      cnorm = MagVectorSum(1)**2 + MagVectorSum(2)**2 + MagVectorSum(3)**2
      cnorm = sqrt( cnorm )
!
      if ( cnorm > m_norm_criteria ) then
         MagDirec_OnMesh_avg = MagVectorSum / cnorm
      else
         MagDirec_OnMesh_avg(3) = 1.0d0
      endif
    end subroutine calc_averaged_mag_direc_now_B

  end subroutine m_ES_SpinDens_Along_QuantzAxis2
  
! -----------------------------------------------------------------------
!!
!!!    convert "up/down"-xc potential calculated along the quantization axis 
!!!            to the original xyz-axis basis.
!!
! -----------------------------------------------------------------------
  subroutine m_ES_cp_VxcR_to_afft( iloop, VxcPot_R, Rot_Angles, afft )
    integer, intent(in) :: iloop
    Real(kind=DP), intent(in)  :: VxcPot_R(   ista_fftph:iend_fftph,nspin )
    Real(kind=DP), intent(in)  :: Rot_Angles( ista_fftph:iend_fftph,nspin )
    Real(kind=DP), intent(out) :: afft( ista_fftp:iend_fftp )

    integer :: i
    Real(kind=DP) :: theta, phi
    Real(kind=DP) :: V0, dV
    Real(kind=DP) :: cos_th, sin_th, cos_ph, sin_ph

    afft = 0.0d0
    Do i=ista_fftph, iend_fftph
       theta = Rot_Angles( i,1 ); phi = Rot_Angles( i,2 )
       cos_th = cos( theta );  sin_th = sin( theta )
       cos_ph = cos( phi );    sin_ph = sin( phi )
!
       V0 = ( VxcPot_R( i,1 ) + VxcPot_R(i,2) ) /2.0d0
       dV = ( VxcPot_R( i,1 ) - VxcPot_R(i,2) ) /2.0d0
!
       select case (iloop)
       case (1)
          afft( 2*i-1 ) = v0 + dV *cos_th
       case (2)
          afft( 2*i-1 ) =  dV *cos_ph *sin_th
          afft( 2*i   ) = -dV *sin_ph *sin_th
       case (3)
          afft( 2*i-1 ) =  dV *cos_ph *sin_th
          afft( 2*i   ) =  dV *sin_ph *sin_th
       case (4)
          afft( 2*i-1 ) = v0 - dV *cos_th
       end select
    End Do
  end subroutine m_ES_cp_VxcR_to_afft

  subroutine m_ES_cp_VxcR_to_afft2( iloop, quantz_axis_inversion_flg_mesh, &
       &                            RhoMag_R, VxcPot_R, afft )
                                         ! output is in magmom rep.
    integer, intent(in) :: iloop
    integer, intent(in) :: quantz_axis_inversion_flg_mesh(ista_fftph:iend_fftph)
    Real(kind=DP), intent(in)  :: RhoMag_R(   ista_fftph:iend_fftph,ndim_magmom )
    Real(kind=DP), intent(in)  :: VxcPot_R(   ista_fftph:iend_fftph,nspin )
    Real(kind=DP), intent(out) :: afft( ista_fftp:iend_fftp )

    integer :: i
    Real(kind=DP) :: V0, dV
    real(kind=DP) :: c_n, c_mx, c_my, c_mz
    real(kind=DP) :: m_norm
    real(kind=DP) :: mmx, mmy, mmz
    real(kind=DP) :: m_norm_criteria = 1.0D-20
!!    real(kind=DP) :: m_norm_criteria = 1.0D-16
!!    real(kind=DP) :: m_norm_criteria = 1.0D-18

    afft = 0.0d0
    Do i=ista_fftph, iend_fftph
       V0 = ( VxcPot_R( i,1 ) + VxcPot_R(i,2) ) /2.0d0
       dV = ( VxcPot_R( i,1 ) - VxcPot_R(i,2) ) /2.0d0
!
       c_n  = RhoMag_R( i,1 );      c_mx = RhoMag_R( i,2 )
       c_my = RhoMag_R( i,3 );      c_mz = RhoMag_R( i,4 )
!
       m_norm = sqrt( c_mx**2 + c_my**2 + c_mz**2 )

       if ( m_norm > m_norm_criteria ) then
          mmx = c_mx / m_norm
          mmy = c_my / m_norm
          mmz = c_mz / m_norm
       else
!          if ( quantz_axis_inversion_flg_mesh(i) == 1 ) then
!             mmx = Global_Quantz_axis_now(1)
!             mmy = Global_Quantz_axis_now(2)
!             mmz = Global_Quantz_axis_now(3)
!          else
!             mmx = -Global_Quantz_axis_now(1)
!             mmy = -Global_Quantz_axis_now(2)
!             mmz = -Global_Quantz_axis_now(3)
!          endif
          mmx = 0.0d0; mmy = 0.0d0;  mmz = 0.0d0
       endif

       select case (iloop)
       case (1)
          afft( 2*i-1 ) = v0
       case (2)
          afft( 2*i-1 ) =  dV *mmx *quantz_axis_inversion_flg_mesh(i)
       case (3)
          afft( 2*i-1 ) =  dV *mmy *quantz_axis_inversion_flg_mesh(i)
       case (4)
          afft( 2*i-1 ) =  dV *mmz *quantz_axis_inversion_flg_mesh(i)
       end select
    End Do
  end subroutine m_ES_cp_VxcR_to_afft2

  subroutine m_ES_Chgsoft_Along_QuantzAxis( RhoMag_R, chgrhr_l, &
       &                                    quantz_axis_inversion_flg_mesh )

    Real(kind=DP), intent(in)  :: RhoMag_R( ista_fftph:iend_fftph,ndim_magmom )
    Real(kind=DP), intent(out) :: chgrhr_l( ista_fftph:iend_fftph,nspin )
    integer, intent(in) :: quantz_axis_inversion_flg_mesh(ista_fftph:iend_fftph)

    integer :: i
    Real(kind=DP) :: c_n, c_mx, c_my, c_mz, m_norm
    real(kind=DP) :: d1, d2

    Do i=ista_fftph, iend_fftph
       c_n  = RhoMag_R( i,1 );    c_mx = RhoMag_R( i,2 )
       c_my = RhoMag_R( i,3 );    c_mz = RhoMag_R( i,4 )
!
       m_norm = sqrt( c_mx**2 + c_my**2 + c_mz**2 )
       d1 = (c_n +m_norm) /2.0d0;  d2 = ( c_n - m_norm )/2.0d0
!
       if ( quantz_axis_inversion_flg_mesh(i) == 1 ) then
          chgrhr_l(i,1) = d1
          chgrhr_l(i,2) = d2
       else
          chgrhr_l(i,1) = d2
          chgrhr_l(i,2) = d1
       endif
    End do
  end subroutine m_ES_Chgsoft_Along_QuantzAxis

  subroutine m_ES_QuantzAxis_inv_flg_atm( magmom_local, &
       &                                  quantz_axis_inversion_flg_atm )
    Real(kind=DP), intent(in)  :: magmom_local(natm,3)
    integer, intent(out) :: quantz_axis_inversion_flg_atm(natm)

    integer :: ia
    Real(kind=DP) :: c_mx, c_my, c_mz, ctmp
    real(kind=DP) :: mmx, mmy, mmz, m_norm
    real(kind=DP) :: m_norm_criteria = 1.0D-20
   !

    Do ia=1, natm
       c_mx = magmom_local( ia,1 )
       c_my = magmom_local( ia,2 )
       c_mz = magmom_local( ia,3 )
!
       m_norm = sqrt( c_mx**2 + c_my**2 + c_mz**2 )
!
       if ( m_norm > m_norm_criteria ) then
!
          mmx = c_mx / m_norm
          mmy = c_my / m_norm
          mmz = c_mz / m_norm

          ctmp = mmx *Global_Quantz_Axis_now(1) &
               & + mmy *Global_Quantz_Axis_now(2) &
               & + mmz *Global_Quantz_Axis_now(3)

          if ( ctmp > 0.0 ) then
             quantz_axis_inversion_flg_atm(ia) = 1
          else
             quantz_axis_inversion_flg_atm(ia) = -1
          endif
       else
          quantz_axis_inversion_flg_atm(ia) = 1
       endif
    End do
  end subroutine m_ES_QuantzAxis_inv_flg_atm

  subroutine m_ES_Chghard_Along_QuantzAxis( hsr, hsrd,  hsr_along_QuantzAxis, &
       &                                    hsrd_along_QuantzAxis )
!
    real(kind=DP), intent(in) :: hsr( natm,nlmt,nlmt,ndim_magmom )
    real(kind=DP), intent(in) :: hsrd( natm,nlmt,nlmt,ndim_magmom,3,3 )
    real(kind=DP), intent(out) :: hsr_along_QuantzAxis( natm,nlmt,nlmt,nspin )
   real(kind=DP), intent(out) :: hsrd_along_QuantzAxis( natm,nlmt,nlmt,nspin,3,3 )

! ------
!!!!    integer, intent(in) :: quantz_axis_inversion_flg_atm(natm)
! -----
    real(kind=DP) :: cos_th, sin_th, cos_ph, sin_ph
    real(kind=DP) :: c_n, c_mx, c_my, c_mz, c_tmp, c1
    real(kind=DP) :: d1, d2
!
    integer :: ia, it, lmt1, lmt2, i1, i2
!
    cos_th = Global_Quantz_Axis_now(3)
    sin_th = sqrt( 1.0D0 - cos_th**2 )
!
    if ( sin_th > 0.0d0 ) then
       c1 = Global_Quantz_Axis_now(1)**2 + Global_Quantz_Axis_now(2)**2
       cos_ph = Global_Quantz_Axis_now(1) / c1
       sin_ph = Global_Quantz_Axis_now(2) / c1
    else
       cos_ph = 0.0d0;  sin_ph = 0.0d0
    endif

    Do ia=1, natm
       it = ityp(ia)
       Do lmt1=1, ilmt(it)
          Do lmt2=1, ilmt(it)

             c_n =  hsr( ia, lmt1, lmt2, 1 )
             c_mx = hsr( ia, lmt1, lmt2, 2 )
             c_my = hsr( ia, lmt1, lmt2, 3 )
             c_mz = hsr( ia, lmt1, lmt2, 4 )
!
             c_tmp = ( c_mx *cos_ph + c_my *sin_ph ) /2.0d0
             c_tmp = c_tmp *sin_th
!
             d1 = ( c_n + c_mz *cos_th ) /2.0d0  + c_tmp
             d2 = ( c_n - c_mz *cos_th ) /2.0d0  - c_tmp
!
             hsr_along_QuantzAxis(ia,lmt1,lmt2,1) = d1
             hsr_along_QuantzAxis(ia,lmt1,lmt2,2) = d2
          End do
       End Do
    End do
!
    Do ia=1, natm
       Do lmt1=1, ilmt(it)
          Do lmt2=1, ilmt(it)

             Do i1=1, 3
                Do i2=1, 3
                   c_n =  hsrd( ia, lmt1, lmt2, 1, i1, i2 )
                   c_mx = hsrd( ia, lmt1, lmt2, 2, i1, i2 )
                   c_my = hsrd( ia, lmt1, lmt2, 3, i1, i2 )
                   c_mz = hsrd( ia, lmt1, lmt2, 4, i1, i2 )
!
                   c_tmp = ( c_mx *cos_ph + c_my *sin_ph ) /2.0d0
                   c_tmp = c_tmp *sin_th
!
                   d1 = ( c_n + c_mz *cos_th ) /2.0d0  + c_tmp
                   d2 = ( c_n - c_mz *cos_th ) /2.0d0  - c_tmp
!
                   hsrd_along_QuantzAxis(ia,lmt1,lmt2,1,i1,i2) = d1
                   hsrd_along_QuantzAxis(ia,lmt1,lmt2,2,i1,i2) = d2
                End do
             End Do
          End do
       End Do
    End do

  end subroutine m_ES_Chghard_Along_QuantzAxis

! ------
  subroutine m_ES_GradCorr_Along_QuantzAxis( RhoMag_R, bfft_kt, &
       &                                    quantz_axis_inversion_flg_mesh )
    real(kind=DP), intent(in) :: RhoMag_R( ista_fftph:iend_fftph,ndim_magmom )
    real(kind=DP), intent(inout) :: bfft_kt( ista_fftp:iend_fftp,ndim_magmom )
    integer, intent(in) :: quantz_axis_inversion_flg_mesh(ista_fftph:iend_fftph)

! --
    integer :: i
    real(kind=DP) :: c_n, c_mx, c_my, c_mz
    real(kind=DP) :: ctarget_n, ctarget_mx, ctarget_my, ctarget_mz
    real(kind=DP) :: cos_th, sin_th, cos_ph, sin_ph
    real(kind=DP) :: d1, d2, c_tmp
    real(kind=DP) :: m_norm
!    real(kind=DP), parameter :: m_norm_criteria = 1.0D-20
    real(kind=DP), parameter :: m_norm_criteria = 1.0D-16

    Do i = ista_fftph, iend_fftph
       c_n  = RhoMag_R( i,1 );    c_mx = RhoMag_R( i,2 )
       c_my = RhoMag_R( i,3 );    c_mz = RhoMag_R( i,4 )
!
       m_norm = sqrt( c_mx**2 + c_my**2 + c_mz**2 )
!
       ctarget_n = bfft_kt(2*i,1)
       ctarget_mx = bfft_kt(2*i,2)
       ctarget_my = bfft_kt(2*i,3)
       ctarget_mz = bfft_kt(2*i,4)
       
       if ( m_norm < m_norm_criteria ) then
          d1 = ctarget_n /2.0d0;   d2 = d1
       else
          cos_th = c_mz / m_norm
          sin_th = sqrt( 1.0D0 - cos_th**2 )

          if ( sin_th > 1.0D-16 ) then
             cos_ph = ( c_mx /m_norm ) / sin_th
             sin_ph = ( c_my /m_norm ) / sin_th
          else
             cos_ph = 0.0d0;  sin_ph = 0.0d0
          endif
!
          c_tmp = ( ctarget_mx *cos_ph + ctarget_my *sin_ph )/2.0d0
          c_tmp = c_tmp *sin_th
          d1 = ( ctarget_n + ctarget_mz *cos_th ) /2.0d0 +c_tmp
          d2 = ( ctarget_n - ctarget_mz *cos_th ) /2.0d0 -c_tmp
       endif
       
       if ( quantz_axis_inversion_flg_mesh(i) == 1 ) then
          bfft_kt(2*i,1) = d1;   bfft_kt(2*i,2) = d2
       else
          bfft_kt(2*i,1) = d2;   bfft_kt(2*i,2) = d1
       endif
    End do
    
  end subroutine m_ES_GradCorr_Along_QuantzAxis

  subroutine m_ES_GradCorr_Along_QuantzAxis2( RhoMag_R, bfft_kt, &
       &                                    quantz_axis_inversion_flg_mesh )
    real(kind=DP), intent(in) :: RhoMag_R( ista_fftph:iend_fftph,ndim_magmom )
    real(kind=DP), intent(inout) :: bfft_kt( ista_fftp:iend_fftp,ndim_magmom )
    integer, intent(in) :: quantz_axis_inversion_flg_mesh(ista_fftph:iend_fftph)

! --
    integer :: i
    real(kind=DP) :: c_n, c_mx, c_my, c_mz
    real(kind=DP) :: ctarget_n, ctarget_mx, ctarget_my, ctarget_mz
    real(kind=DP) :: d1, d2, ctmp1, da1, da2
    real(kind=DP) :: m_norm, mmx, mmy, mmz

    real(kind=DP), parameter :: m_norm_criteria = 1.0D-20
    real(kind=DP), parameter :: m_norm_criteria2 = 1.0D-12

    Do i = ista_fftph, iend_fftph
       c_n  = RhoMag_R( i,1 );    c_mx = RhoMag_R( i,2 )
       c_my = RhoMag_R( i,3 );    c_mz = RhoMag_R( i,4 )
       m_norm = sqrt( c_mx**2 + c_my**2 + c_mz**2 )
!
       da1 = (c_n +m_norm) /2.0d0;  da2 = ( c_n - m_norm )/2.0d0
!
       if ( m_norm < m_norm_criteria ) then
          mmx = 0.0d0;  mmy = 0.0d0;  mmz = 0.0d0

       else if ( m_norm < m_norm_criteria2 ) then
          if ( quantz_axis_inversion_flg_mesh(i) == 1 ) then
             mmx = Global_Quantz_Axis_now(1)
             mmy = Global_Quantz_Axis_now(2)
             mmz = Global_Quantz_Axis_now(3)
          else
             mmx = -Global_Quantz_Axis_now(1)
             mmy = -Global_Quantz_Axis_now(2)
             mmz = -Global_Quantz_Axis_now(3)
          endif

       else
          mmx = c_mx / m_norm
          mmy = c_my / m_norm
          mmz = c_mz / m_norm
       endif
!
       ctarget_n = bfft_kt(2*i,1)
       ctarget_mx = bfft_kt(2*i,2)
       ctarget_my = bfft_kt(2*i,3)
       ctarget_mz = bfft_kt(2*i,4)
!
       ctmp1 = ctarget_mx *mmx + ctarget_my *mmy + ctarget_mz *mmz
!
       d1 = ( ctarget_n +ctmp1 ) /2.0d0
       d2 = ( ctarget_n -ctmp1 )/2.0d0
          
       if ( quantz_axis_inversion_flg_mesh(i) == 1 ) then
          bfft_kt(2*i,1) = d1;   bfft_kt(2*i,2) = d2
       else
          bfft_kt(2*i,1) = d2;   bfft_kt(2*i,2) = d1
       endif

       bfft_kt(2*i-1,1:4) = 0.0d0
       bfft_kt(2*i,3:4) = 0.0d0;

    End do

  end subroutine m_ES_GradCorr_Along_QuantzAxis2

! ===== KT_add === 2014/08/04
  subroutine m_ES_add_contrib_to_Vorticity( ixyz, bfft_kt, MagVorticity )
    integer, intent(in) :: ixyz
    real(kind=DP), intent(in)  :: bfft_kt( ista_fftp:iend_fftp,ndim_magmom )
    real(kind=DP), intent(out) :: MagVorticity( ista_fftph:iend_fftph, 3 )

    integer :: i
    real(kind=DP) :: ctarget_n, ctarget_mx, ctarget_my, ctarget_mz

    Do i = ista_fftph, iend_fftph
!       ctarget_n = bfft_kt(2*i,1)
       ctarget_mx = bfft_kt(2*i,2)
       ctarget_my = bfft_kt(2*i,3)
       ctarget_mz = bfft_kt(2*i,4)
!
       if ( ixyz == 1 ) then
          MagVorticity(i,2) = MagVorticity(i,2) -ctarget_mz
          MagVorticity(i,3) = MagVorticity(i,3) +ctarget_my
       else if ( ixyz == 2 ) then
          MagVorticity(i,3) = MagVorticity(i,3) -ctarget_mx
          MagVorticity(i,1) = MagVorticity(i,1) +ctarget_mz
       else if ( ixyz == 3 ) then
          MagVorticity(i,1) = MagVorticity(i,1) -ctarget_my
          MagVorticity(i,2) = MagVorticity(i,2) +ctarget_mx
       endif
    End Do
  end subroutine m_ES_add_contrib_to_Vorticity

  subroutine m_ES_neglect_low_Helicity( RhoMag_R, MagVorticity, Mat )
    real(kind=DP), intent(in) :: RhoMag_R( ista_fftph:iend_fftph, ndim_magmom )
    real(kind=DP), intent(in) :: MagVorticity( ista_fftph:iend_fftph, 3 )
    real(kind=DP), intent(inout) :: Mat( ista_fftph:iend_fftph )

    integer :: i, k
    real(kind=DP) :: ctmp1

    Do i=ista_fftph, iend_fftph
       ctmp1 = 0.0d0
       Do k=1, 3
          ctmp1 = ctmp1 +RhoMag_R(i,k+1)*MagVorticity(i,k)
       End do
       if ( abs(ctmp1) < threshold_helicity ) Mat(i) = 0.0d0
    End Do

  end subroutine m_ES_neglect_low_Helicity

  subroutine m_ES_neglect_low_Vorticity( RhoMag_R, MagVorticity, Mat )
    real(kind=DP), intent(in) :: RhoMag_R( ista_fftph:iend_fftph, ndim_magmom )
    real(kind=DP), intent(in) :: MagVorticity( ista_fftph:iend_fftph, 3 )
    real(kind=DP), intent(inout) :: Mat( ista_fftph:iend_fftph )

    integer :: i, k
    real(kind=DP) :: ctmp1

    Do i=ista_fftph, iend_fftph
       ctmp1 = 0.0d0
       Do k=1, 3
          ctmp1 = ctmp1 +MagVorticity(i,k)**2
       End do
       ctmp1 = sqrt(ctmp1)

       if ( ctmp1 < threshold_vorticity ) Mat(i) = 0.0d0
    End Do

  end subroutine m_ES_neglect_low_Vorticity
! ================ 2014/08/04

end module m_ES_NonCollinear

!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 481 $)
!
!  MODULE: m_FFT
!
!  AUTHOR(S): T. Yamasaki, K. Betsuyaku,   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!                                   , March/14/2005, April/10/2007
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!

module m_FFT
! $Id: m_FFT.F90 481 2016-03-25 02:51:57Z jkoga $
!
  use m_Timing,            only : tstatc0_begin, tstatc0_end
  use m_Files,             only : nfout
  use m_Control_Parameters,only : kimg, ipri, iprinegativecharge, iprinegativecharge0 &
       &                        , max_warnings_negativecharge, sw_positron, ldx, ldy, ldz
  use m_Const_Parameters,  only : DP,CMPLDP, ON, OFF, INVERSE, DIRECT, OUTER, INNER &
       &                        , ELECTRON, POSITRON, YES, NO
  use m_Parallelization,   only : mpi_comm_group,ista_sfftp,iend_sfftp,ista_sfftph,iend_sfftph &
       &                        , ista_fftp, iend_fftp &
       &                        , mype,npes,ierr,nel_sfftp,idisp_sfftp &
       &                        , myrank_cdfft,myrank_ggacmp,nrank_ggacmp,npes_cdfft &
       &                        , nel_fftp, idisp_fftp, mpi_cdfft_world
#ifdef MKLFFT
  use MKL_DFTI 
  use mklfft
#endif

! ================================= added by K. Tagami ============== 11.0
  use m_Const_Parameters,       only : CMPLDP
! =================================================================== 11.0

! ======= KT_add ========================================== 13.0F
  use m_Control_Parameters, only : sw_hybrid_functional
! ========================================================= 13.0F

  implicit none
  integer, dimension(3,0:1) :: fft_box_size_WF, fft_box_size_CD
  integer, dimension(3,0:0) :: fft_box_size_CD_c, fft_box_size_CD_nonpara
  integer, dimension(3,0:1) :: fft_box_size_CD_exx,fft_box_size_CD_exx_nonpara
  integer               :: nfft, nfftp, nfftps, nfftp_nonpara

  integer               :: nfftp_exx_nonpara

  integer               :: ny_d, nz_d, ly_d, lx, ly, lz_d, lz &
       &                 , ny_ds,nz_ds,ly_ds,lxs,lys,lz_ds,lzs

  ! ------- Positron start 
  integer, dimension(3,0:1) :: fft_box_size_pWF
  integer ::                   nfft_pstrn
  ! ------- Positron end

! ======= KT_add =================================== 13.0F
  integer, dimension(3,0:1) :: fft_box_size_EXX
  integer                   :: nfft_exx
! ================================================== 13.0F

#ifdef _MPIFFT_
  integer :: sw_mpifft = ON
#else
  integer :: sw_mpifft = OFF
#endif

  integer, private      :: CD_setup_is_done = NO
  integer, private      :: CD_setup_is_done_EXX = NO

  real(kind=DP),private,allocatable,dimension(:)           :: afft_CD
  real(kind=DP),private,allocatable,dimension(:)           :: afft_CD_exx
#ifdef VPP
  integer, private, parameter :: ncache=0
#elif DEC
  integer, private, parameter :: ncache=6*1024
#elif HP
  integer, private, parameter :: ncache=1*1024
#elif SUN
  integer, private, parameter :: ncache=1*1024
#elif ONYX
  integer, private, parameter :: ncache=1*1024
#elif IRIX64
  integer, private, parameter :: ncache=1*1024
#elif CRAY
  integer, private, parameter :: ncache=1*1024
#elif HIUX
  integer, private, parameter :: ncache=1*1024
#elif SX
  integer, private, parameter :: ncache=0
#elif SP2
  integer, private, parameter :: ncache=1*1024
#elif Linux
  integer, private, parameter :: ncache=6*1024
#endif

! contains
#ifdef JRCATFFT_WS
include "m_FFT_type1_jrcatfft.F90"
#define _INCLUDE_EXX_
#elif FFTW3
include "m_FFT_type4_fftw3_rev.F90"
#define _INCLUDE_EXX_
#elif MKLFFT
include "m_FFT_type3_mklfft.F90"
#elif ASLFFT
#ifdef _MPIFFT_
#ifdef NEC_TUNE_FFT
include "m_FFT_type5_aslfft+mpifft.hybrid.f90"
#else
include "m_FFT_type5_aslfft+mpifft.mpi.f90"
#endif
#else
#ifdef NEC_TUNE_FFT
include "m_FFT_type5_aslfft.hybrid.f90"
#else
include "m_FFT_type5_aslfft.mpi.f90"
#endif
#endif
#elif WF_JRCATFFT
include "m_FFT_type6_jrcatfft+ifft.F90"
#elif GOEDECKER_FFT
include "m_FFT_type8_goedecker.F90"
#elif FFTE
include "m_FFT_type9_ffte.F90"
#endif
! ---------------------

  ! 6. (common) wd_FFTboxsizes(nfout)
  ! 7. (common) m_FFT_set_box_sizes(n_rGv,n_rGpv,n_rGv_pstrn,outer_or_inner)
  ! 8. (common) m_FFT_wd_box_sizes(nf_bin)
  ! 9. (common) decomp3(oi,i,j)
  !10. (common) decomp3p(i,j)
  !13. (common) m_FFT_Vlocal_W(afft,bfft)
  !21. (common) m_FFT_check_of_negative_CD(npes_in,ista_fftp,iend_fftp,ista_fftph,iend_fftph &
  !22. (common) m_FFT_W_Vlocal_W(electron_or_positron,nabfft,afft,bfft,eg)
  !28. (common) m_FFT_set_cdata(aa,a)
  !29. (common) m_FFT_set_scdata(aa,a)
  !30. (common) m_FFT_coef_CD_integration(f2or1)
  !31. (common) m_FFT_set_cdata
  !32. (common) m_FFT_set_scdata(aa,a)

  subroutine wd_FFTboxsizes(nfout)
    integer, intent(in) :: nfout


    write(nfout,*) ' ---- (WF)FFT size ----'
    write(nfout,'("     (nfft, fft_box_size_WF)")')
    write(nfout,100) nfft
    write(nfout,101) fft_box_size_WF(1:3,0)
    write(nfout,102) fft_box_size_WF(1:3,1)

    write(nfout,*) ' ---- (CD)FFT size ----'
    write(nfout,'("     (nfftps, fft_box_size_CD)")')
    write(nfout,100) nfftps
    write(nfout,101) fft_box_size_CD(1:3,0)
    write(nfout,102) fft_box_size_CD(1:3,1)


#ifdef _MPIFFT_
    write(nfout,*) ' ---- (CD)FFT size ----'
    write(nfout,'("     (nfftps, fft_box_size_CD_nonpara)")')
    write(nfout,100) nfftp_nonpara
    write(nfout,101) fft_box_size_CD_nonpara(1:3,0)
#endif

    if(sw_positron /= OFF) then
       write(nfout,*) ' ---- (pWF)FFT size ----'
       write(nfout,'("     (nfft_pstrn, fft_box_size_pWF)")')
       write(nfout,100) nfft_pstrn
       write(nfout,101) fft_box_size_pWF(1:3,0)
       write(nfout,102) fft_box_size_pWF(1:3,1)
    end if

    write(nfout,*) ' ---- (CD_c)FFT size ----'
    write(nfout,'("     (nfftp, fft_box_size_CD_c)")')
    write(nfout,100) nfftp
    write(nfout,101) fft_box_size_CD_c(1:3,0)

100 format(" FFT total elements(including work area) = ",i10)
101 format(" FFT box adjustable dimension            = ",3i5)
102 format(" FFT box real dimension                  = ",3i5)
  end subroutine wd_FFTboxsizes
  
! =============== KT_add ============================= 13.0F
  subroutine wd_FFTboxsizes_exx(nfout)
    integer, intent(in) :: nfout

    write(nfout,*) ' ---- (Exx)FFT size ----'
    write(nfout,'("     (nfft_exx, fft_box_size_Exx)")')
    write(nfout,100) nfft_exx
    write(nfout,101) fft_box_size_EXX(1:3,0)
    write(nfout,102) fft_box_size_EXX(1:3,1)

    write(nfout,*) ' ---- (Exx)FFT_CD size ----'
    write(nfout,'("     (nfftp_exx_nonpara, fft_box_size_CD_Exx)")')
    write(nfout,100) nfftp_exx_nonpara
    write(nfout,101) fft_box_size_CD_EXX(1:3,0)
    write(nfout,102) fft_box_size_CD_EXX(1:3,1)

100 format(" FFT total elements(including work area) = ",i10)
101 format(" FFT box adjustable dimension            = ",3i5)
102 format(" FFT box real dimension                  = ",3i5)

  end subroutine wd_FFTboxsizes_exx
! ==================================================== 13.0F

  subroutine m_FFT_set_box_sizes(n_rGv,n_rGpv,n_rGv_pstrn,outer_or_inner)
    integer,intent(in),dimension(3) :: n_rGv,n_rGpv,n_rGv_pstrn
    integer,intent(in)              :: outer_or_inner

    integer :: i, ip

    do i = 1, 3
!  -- FFT box size for Wave Functions --
       ip = n_rGv(i)
       if(sw_avoiding_odd_fftbox == ON) then
          if(mod(ip,2) == 1) ip = ip + 1
       endif
       call decomp3(outer_or_inner,ip,fft_box_size_WF(i,1))
!  -- FFT box size for Charge Density --
       ip = n_rGpv(i)
       if(sw_avoiding_odd_fftbox == ON) then
          if(mod(ip,2) == 1) ip = ip + 1
       end if

#ifdef _PFFT_
       call decomp3p(ip,fft_box_size_CD(i,1))
#else
       call decomp3(outer_or_inner,ip,fft_box_size_CD(i,1))
#endif
    end do
    if(ipri>=1) then
       write(nfout,*) ' --- fft_box_size <<m_FFT_set_box_sizes>> ---'
       write(nfout,'("  WF ",3i5)') fft_box_size_WF(1:3,1)
       write(nfout,'("  CD ",3i5)') fft_box_size_CD(1:3,1)
    end if
    ! ------- Positron start 
    if(sw_positron /= OFF) then
       do i = 1, 3
          !  -- FFT box size for positron Wave Functions --
          ip = n_rGv_pstrn(i)
          if(sw_avoiding_odd_fftbox == ON) then
             if(mod(ip,2) == 1) ip = ip + 1
          end if
          call decomp3(outer_or_inner,ip,fft_box_size_pWF(i,1))
       end do
       if(ipri>=1) write(nfout,'(" pWF ",3i5)') fft_box_size_pWF(1:3,1)
    end if
    ! ------- Positron end

  end subroutine m_FFT_set_box_sizes

! ======= KT_add ======================================= 13.0F
  subroutine m_FFT_set_box_size_exx( n_rGv_exx, outer_or_inner )
    integer,intent(in),dimension(3) :: n_rGv_exx
    integer,intent(in)              :: outer_or_inner

    integer :: i, ip

    if(sw_hybrid_functional /= OFF) then
       do i = 1, 3
          !  -- FFT box size for Wave Functions (exx) --
          ip = n_rGv_exx(i)

          if(sw_avoiding_odd_fftbox == ON) then
             if(mod(ip,2) == 1) ip = ip + 1
          end if
          call decomp3(outer_or_inner,ip,fft_box_size_exx(i,1))
       end do
       if(ipri>=1) write(nfout,'(" exx ",3i5)') fft_box_size_exx(1:3,1)
    end if

  end subroutine m_FFT_set_box_size_exx

  subroutine m_FFT_set_box_size_cd_exx( n_rGpv_exx, outer_or_inner )
    integer,intent(in),dimension(3) :: n_rGpv_exx
    integer,intent(in)              :: outer_or_inner

    integer :: i, ip, ipad

    if(sw_hybrid_functional /= OFF) then
       do i = 1, 3
          !  -- FFT box size for Wave Functions (exx) --
          ip = n_rGpv_exx(i)

          if(sw_avoiding_odd_fftbox == ON) then
             if(mod(ip,2) == 1) ip = ip + 1
          end if
          call decomp3(outer_or_inner,ip,fft_box_size_CD_exx(i,1))
       end do
       if(ipri>=1) write(nfout,'(" exx_CD ",3i5)') fft_box_size_CD_exx(1:3,1)
       if(kimg == 1) then  ! kimg == 1
          ipad = 2
       else if(kimg == 2) then ! kimg == 2
          ipad = 0
       end if

       fft_box_size_CD_exx_nonpara(1,0)   = fft_box_size_CD_exx(1,1) + ipad
       fft_box_size_CD_exx_nonpara(2:3,0) = fft_box_size_CD_exx(2:3,1)

       fft_box_size_CD_exx(1,0)   = fft_box_size_CD_exx(1,1) + ipad
       fft_box_size_CD_exx(2:3,0) = fft_box_size_CD_exx(2:3,1)
      
       nfftp_exx_nonpara  = product(fft_box_size_CD_exx_nonpara(1:3,0)) * kimg
    end if

  end subroutine m_FFT_set_box_size_cd_exx
! ====================================================== 13.0F

  subroutine m_FFT_wd_box_sizes(nf_bin)
    integer, intent(in) :: nf_bin
    if(mype == 0) &
         & write(nf_bin) fft_box_size_WF(1:3,1),fft_box_size_CD(1:3,1)
  end subroutine m_FFT_wd_box_sizes

  subroutine decomp3(oi,i,j)
    integer, intent(in)  :: oi, i
    integer, intent(out) :: j

    integer :: ipm, iab, ik, imini
    imini = i*189/200+1

    if(oi == OUTER) then
       ipm = +1
    else
       ipm = -1
    endif
100 iab=-1
110 iab=iab+1
    ik= i+ipm*iab
    if(ik < imini) then
       ipm=1
       goto 100
    end if
    j = ik*2
120 continue
    if(mod(j,2) == 0) then
       j=j/2
       goto 120
    else if(mod(j,3) == 0) then
       j=j/3
       goto 120
    else if(mod(j,5) == 0) then
       j=j/5
       goto 120
    else if(j == 1) then
       goto 130
    else
       goto 110
    end if
130 ik= i+ipm*iab
    j  = ik*2
  end subroutine decomp3

#ifdef _PFFT_
  subroutine decomp3p(i,j)
    integer, intent(in)  :: i
    integer, intent(out) :: j

    integer :: iab, ik

    iab=-1
110 iab=iab+1
    ik = i+iab
    if(mod(ik,npes) /= 0) goto 110
    j  = ik*2
120 continue
    if(mod(j,2) == 0) then
       j=j/2
       goto 120
    else if(mod(j,3) == 0) then
       j=j/3
       goto 120
    else if(mod(j,5) == 0) then
       j=j/5
       goto 120
    else if(j == 1) then
       goto 130
    else
       goto 110
    end if
130 ik= i+iab
    j  = ik*2
  end subroutine decomp3p
#endif

  subroutine m_FFT_Vlocal_W(afft,bfft)
    real(kind=DP), intent(in),    dimension(nfft) :: afft
    real(kind=DP), intent(inout), dimension(nfft) :: bfft

    integer i

    do i = 1, nfft-1, 2
       bfft(i)   = afft(i) * bfft(i)
       bfft(i+1) = afft(i) * bfft(i+1)
    end do
    if(mod(nfft,2) == 1) bfft(nfft) = afft(nfft)*bfft(nfft)
  end subroutine m_FFT_Vlocal_W

! =============================== added by K. Tagami ============= 11.0
  subroutine m_FFT_Vlocal_W_noncl( afft_kt, bfft_kt, ndim_chgpot, ndim_spinor )
    integer,  intent(in) :: ndim_spinor, ndim_chgpot
    real(kind=DP), intent(inout) :: afft_kt( nfft,ndim_chgpot )
    real(kind=DP), intent(inout) :: bfft_kt( nfft,ndim_spinor )

    real(kind=DP) :: ctmp_r, ctmp_i

    real(kind=DP), allocatable :: ccfft( :,: )
    integer i

    allocate( ccfft( nfft, ndim_spinor ) ); ccfft = 0.0d0

    do i = 1, nfft-1, 2
       ctmp_r = afft_kt(i,1) *bfft_kt(i,1) - afft_kt(i+1,1) *bfft_kt(i+1,1) &
            & + afft_kt(i,2) *bfft_kt(i,2) - afft_kt(i+1,2) *bfft_kt(i+1,2)
       ctmp_i = afft_kt(i+1,1) *bfft_kt(i,1) + afft_kt(i,1) *bfft_kt(i+1,1) &
            & + afft_kt(i+1,2) *bfft_kt(i,2) + afft_kt(i,2) *bfft_kt(i+1,2)
!       afft_kt(i,  1) = ctmp_r
!       afft_kt(i+1,1) = ctmp_i

       ccfft( i,1 ) = ctmp_r;  ccfft( i+1, 1 ) = ctmp_i
    end do
!
    do i = 1, nfft-1, 2
       ctmp_r = afft_kt(i,3) *bfft_kt(i,1) - afft_kt(i+1,3) *bfft_kt(i+1,1) &
            & + afft_kt(i,4) *bfft_kt(i,2) - afft_kt(i+1,4) *bfft_kt(i+1,2)
       ctmp_i = afft_kt(i+1,3) *bfft_kt(i,1) + afft_kt(i,3) *bfft_kt(i+1,1) &
            & + afft_kt(i+1,4) *bfft_kt(i,2) + afft_kt(i,4) *bfft_kt(i+1,2)
!       afft_kt(i,  2) = ctmp_r
!       afft_kt(i+1,2) = ctmp_i

       ccfft( i,2 ) = ctmp_r;  ccfft( i+1, 2 ) = ctmp_i
    end do

!    bfft_kt(:,1) = afft_kt(:,1)
!    bfft_kt(:,2) = afft_kt(:,2)

    bfft_kt(:,1) = ccfft(:,1)
    bfft_kt(:,2) = ccfft(:,2)

    deallocate( ccfft )

  end subroutine m_FFT_Vlocal_W_noncl
! ========================================================================= 11.0

  subroutine m_FFT_check_of_negative_CD(npes_in,ista_fftp,iend_fftp,ista_fftph,iend_fftph &
       &                               ,afft,nfout,nspin,ispin)
    integer, intent(in)          :: npes_in, ista_fftp, iend_fftp, ista_fftph, iend_fftph
    real(kind=DP), intent(inout) :: afft(ista_fftp:iend_fftp)
    integer, intent(in)          :: nfout,nspin,ispin

    integer                   :: ip, i,j,k, nlp,nmp,nnp,idp,nd2p,nd3p, nlph, nd1h
    integer                   :: icwarn_NEGA, icwarn_IMAG, icwarn_NEGA2,icwarn_IMAG2 &
         &                     , icwarn_NEGA_total,icwarn_IMAG_total, icwarn_NEGA_0, icwarn_IMAG_0, isw
    integer, allocatable, dimension(:)       :: istatus_afft_nega, istatus_afft_imag
!!$    integer, parameter        :: MXWARN = 10
    real(kind=DP),parameter   :: chgdel = 8.d-5
    real(kind=DP),parameter   :: D_min  = 1.d-40
!     Revised by T. Yamasaki, 14th Mar. 2005
!         Write statements in if-blocks in a do-loop have been excluded for vector processors.
    integer :: ipad1, ipad2, ipad3

    integer ::        kk, nstart, nend, itmp

    if(kimg ==  1) then
       idp = nfftp+10
    end if

    nlp = fft_box_size_CD(1,1)
    nmp = fft_box_size_CD(2,1)
    nnp = fft_box_size_CD(3,1)
    if(npes_in == npes) then
       nd2p = fft_box_size_CD(2,0)
       nd3p = fft_box_size_CD(3,0)
       if(kimg == 2) idp = fft_box_size_CD(1,0)
    else if(npes_in == npes_cdfft) then
       nd2p = fft_box_size_CD_c(2,0)
       nd3p = fft_box_size_CD_c(3,0)
       if(kimg == 2) idp = fft_box_size_CD_c(1,0)
    end if

! -- Zero padding
    if(kimg == 1) then
       ipad1 = fft_box_size_CD(1,0) - fft_box_size_CD(1,1)
       ipad2 = fft_box_size_CD(2,0) - fft_box_size_CD(2,1)
       ipad3 = fft_box_size_CD(3,0) - fft_box_size_CD(3,1)

! === DEBUG by tkato 2011/09/12 ================================================
       nlph = nlp/2
       nd1h = fft_box_size_CD(1,0)/2
! ==============================================================================
       if(ipad1 >= 4) then
! === DEBUG by tkato 2011/09/12 ================================================
!         nlph = nlp/2
!         nd1h = fft_box_size_CD(1,0)/2
! ==============================================================================
          do j = nlph+2, nd1h
             do i = 1, nd2p*nnp
                itmp = nd1h*(i-1)+j
                if(ipri >= 2) write(nfout,*) 'ZERO1: i=',itmp
                ip = 2*(nd1h*(i-1)+j)-1
                if(ip >= ista_fftp .and. ip <= iend_fftp) then
                   afft(ip)   = 0.d0
                   afft(ip+1) = 0.d0
                end if
             end do
          end do
       end if
       if(ipad2 >= 2) then
          do j = nmp+1, nd2p
             do k = 1, nnp
                do i = 1, nlph
                   itmp = i + nd1h*(j-1) + nd1h*nd2p*(k-1)
                   if(ipri >= 2) write(nfout,*) 'ZERO2: i=',itmp
                   ip = 2*(i + nd1h*(j-1) + nd1h*nd2p*(k-1))-1
                   if(ip >= ista_fftp .and. ip <= iend_fftp) then
                      afft(ip)   = 0.d0
                      afft(ip+1) = 0.d0
                   end if
                end do
             end do
          end do
       end if
       if(ipad3 >= 2) then
          do k = nnp+1, nd3p
             do i = 1, nd1h*nd2p
                itmp = nd1h*nd2p*(k-1) + i
                if(ipri >= 2) write(nfout,*) 'ZERO3: i=',itmp
                ip = 2*(nd1h*nd2p*(k-1) + i) - 1
                if(ip >= ista_fftp .and. ip <= iend_fftp) then
                   afft(ip) = 0.d0
                   afft(ip+1) = 0.d0
                end if
             end do
          end do
       end if
    end if

    if(sw_mpifft == ON) then
       if(kimg == 2) then
          do j = nlp+1, idp       ! x
             do i = 1, nd2p*nd3p  ! y,z
                ip = 2*(idp*(i-1)+j)-1
                if(ip >= ista_fftp .and. ip+1 <= iend_fftp) then
                   afft(ip)   = 0.d0
                   afft(ip+1) = 0.d0
                end if
             end do
          end do
!!$       lz_d   = fft_box_size_CD_c(3,0)/npes_cdfft
          do j = nmp+1, nd2p      ! y
             do k = 1, lz_d       ! z
                do i = 1, nlp     ! x
                   ip = 2*(i+idp*(j-1)+idp*nd2p*(k-1)+idp*nd2p*lz_d*myrank_cdfft)-1
                   if(ip >= ista_fftp .and. ip+1 <= iend_fftp) then
                      afft(ip)   = 0.d0
                      afft(ip+1) = 0.d0
                   end if
                end do
             end do
          end do
          nstart = min(lz_d*myrank_cdfft+nz_d+1,nnp+myrank_cdfft*(lz_d-nz_d)+1) ! = nnp + (isize-1)*ld + 1
          nend   = (myrank_cdfft+1)*lz_d
          do k = nstart, nend     ! z
             kk = k - lz_d*myrank_cdfft + 1
             do j = 1, nmp        ! y
                do i = 1, nlp     ! x
                   ip = 2*(i+idp*(j-1)+idp*nd2p*(kk-1)+idp*nd2p*lz_d*myrank_cdfft)-1
                   if(ip >= ista_fftp .and. ip+1 <= iend_fftp) then
                      afft(ip)   = 0.d0
                      afft(ip+1) = 0.d0
                   end if
                end do
             end do
          end do
       end if
    else
!!$#ifndef ASLFFT
       if(sw_zero_padding == ON) then
          if(kimg == 2) then
             do j = nlp+1, idp        ! x
                do i = 1, nmp*nnp     ! y,z
                   ip = 2*(idp*(i-1)+j)-1
                   if(ip >= ista_fftp .and. ip <= iend_fftp) then
                      afft(ip)   = 0.d0
                      afft(ip+1) = 0.d0
                   end if
                end do
             end do
             do j = nmp+1, nd2p       ! y
                do k = 1, nnp         ! z
                   do i = 1, nlp      ! x
                      ip = 2*(i + idp*(j-1) + idp*nd2p*(k-1))-1
                      if(ip >= ista_fftp .and. ip <= iend_fftp) then
                         afft(ip)   = 0.d0
                         afft(ip+1) = 0.d0
                      end if
                   end do
                end do
             end do
          end if
       end if
!!$#endif
    end if

    icwarn_NEGA = 0
    icwarn_IMAG = 0
    if(iprinegativecharge0 < 1 .or. max_warnings_negativecharge <= 0) then
#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
       do i = ista_fftph, iend_fftph
          ip = i*2-1
          if(afft(ip) <= -chgdel .and. mod(ip+1,idp) /= 0) then
             icwarn_NEGA = icwarn_NEGA + 1
             afft(ip) = D_min
          else if (afft(ip) <= 0.d0) then
             afft(ip) = D_min
          end if
          if( (abs(afft(ip+1)) > chgdel).and. (mod(ip+1,idp) /= 0) ) then
             icwarn_IMAG = icwarn_IMAG + 1
             afft(ip+1) = 0.d0
          else if (abs(afft(ip+1)) > 0.d0) then
             afft(ip+1) = 0.d0
          end if
       end do

    else if(iprinegativecharge0 >= 1 .and. max_warnings_negativecharge > 0) then
#ifdef _VECTOR_TUNING_
       allocate(istatus_afft_nega(ista_fftph:iend_fftph)); istatus_afft_nega = 0;
       allocate(istatus_afft_imag(ista_fftph:iend_fftph)); istatus_afft_imag = 0;

       icwarn_NEGA2 = 0
       icwarn_IMAG2 = 0
#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
       do i = ista_fftph, iend_fftph
          ip = i*2-1
          if(afft(ip) <= -chgdel .and. mod(ip+1,idp) /= 0) then
             istatus_afft_nega(i) = 1
             icwarn_NEGA = icwarn_NEGA + 1
          else if (afft(ip) <= 0.d0) then
             icwarn_NEGA2 = icwarn_NEGA2 + 1
             istatus_afft_nega(i) = 2
          end if
          if( (abs(afft(ip+1)) > chgdel).and. (mod(ip+1,idp) /= 0) ) then
             istatus_afft_imag(i) = 1
             icwarn_IMAG = icwarn_IMAG + 1
          else if (abs(afft(ip+1)) > 0.d0) then
             icwarn_IMAG2 = icwarn_IMAG2 + 1
             istatus_afft_imag(i) = 2
          end if
       end do

       if(iprinegativecharge >= 1) then
          if(icwarn_NEGA >= 1) then
             do i = ista_fftph, iend_fftph
                if(istatus_afft_nega(i) == 1) exit
             end do
             icwarn_NEGA_0 = i
             if(iprinegativecharge >= 2) &
                  & write(nfout,'(" ista_fftph, iend_fftph, icwarn_NEGA_0 = ",3i8)') ista_fftph, iend_fftph, icwarn_NEGA_0

! ============================ modified by K. Tagami ================ 11.0
!             if(nspin == 2)  write(nfout,'(" #spin = ",i3)') ispin
!
             if ( nspin == 100 ) then
                write(nfout,'(" #loop = ",i3)') ispin
             else if ( nspin == 2 )  then
                write(nfout,'(" #spin = ",i3)') ispin
             endif
! ============================ modified by K. Tagami ================ 11.0

             j = 0
             do i = icwarn_NEGA_0, iend_fftph
                ip = i*2-1
                if(istatus_afft_nega(i) == 1) then
                   j = j+1
                   if(j > max_warnings_negativecharge) exit
                   write(nfout,'(" *** WARN CHG.DEN = ",d15.7, " < 0.0 AT ",i8," ***")') afft(ip),i
                end if
             end do
          end if
          if(icwarn_IMAG >= 1) then
             do i = ista_fftph, iend_fftph
                if(istatus_afft_imag(i) == 1) exit
             end do
             icwarn_IMAG_0 = i
             if(iprinegativecharge >= 2) &
                  & write(nfout,'(" ista_fftph, iend_fftph, icwarn_NEGA_0 = ",3i8)') ista_fftph, iend_fftph, icwarn_IMAG_0

! =================================== modified by K. Tagami ================ 11.0
!             if(nspin == 2) write(nfout,'(" #spin = ",i3)') ispin
!
             if ( nspin == 100 ) then
                write(nfout,'(" #loop = ",i3)') ispin
             else if ( nspin == 2 ) then
                write(nfout,'(" #spin = ",i3)') ispin
             endif
! ========================================================================== 11.0

             j = 0
             do i = icwarn_IMAG_0, iend_fftph
                ip = i*2-1
                if(istatus_afft_imag(i) == 1) then
                   j = j+1
                   if(j > max_warnings_negativecharge) exit
                   write(nfout,'(" *** WARN IMAG(CHG) = ",d15.7, " > 0.0 AT ",i8," ***")') afft(ip+1),i
                end if
             end do
          end if
       end if

       if(icwarn_NEGA+icwarn_NEGA2 >=1 .or. icwarn_IMAG+icwarn_IMAG2 >=1) then
          do i = ista_fftph, iend_fftph
             ip = i*2-1
             if(istatus_afft_nega(i) >= 1) afft(ip) = D_min
             if(istatus_afft_imag(i) >= 1) afft(ip+1) = 0.d0
          end do
       end if

       deallocate(istatus_afft_imag, istatus_afft_nega)

#else
       isw = 0
       do i = ista_fftph, iend_fftph
          ip = i*2-1
          if(afft(ip) <= -chgdel .and. mod(ip+1,idp) /= 0) then
             icwarn_NEGA = icwarn_NEGA + 1
             if(icwarn_NEGA <= max_warnings_negativecharge) then

! ==================================== modified by K. Tagami ============= 11.0
!                if(icwarn_NEGA == 1 .and. nspin == 2) then
!                   if(iprinegativecharge>=1) then
!                      write(nfout,'(" #spin = ",i3)') ispin
!                      isw = 1
!                   end if
!                endif
!
                if (icwarn_NEGA == 1) then
                   if ( nspin == 100 ) then
                      if(iprinegativecharge>=1) then
                         write(nfout,'(" #loop = ",i3)') ispin
                         isw = 1
                      end if
                   else if ( nspin == 2 ) then
                      if(iprinegativecharge>=1) then
                         write(nfout,'(" #spin = ",i3)') ispin
                         isw = 1
                      end if
                   end if
                end if
! ====================================================================== 11.0

                if(iprinegativecharge >=1) &
                     & write(nfout,'(" *** WARN CHG.DEN = ",d15.7, " < 0.0 AT ",i8," ***")') afft(ip),i
             endif
             afft(ip) = D_min
          else if (afft(ip) <= 0.d0) then
             afft(ip) = D_min
          end if
          if( (abs(afft(ip+1)) > chgdel).and. (mod(ip+1,idp) /= 0) ) then
             icwarn_IMAG = icwarn_IMAG + 1
             if(icwarn_IMAG <= max_warnings_negativecharge) then
! ==================================== modified by K. Tagami ============ 11.0
!                if(icwarn_IMAG == 1 .and. nspin == 2) then
!                   if(iprinegativecharge >=1 .and. isw == 0) write(nfout,'("#spin = ",i3)') ispin
!                endif
!
                if (icwarn_IMAG == 1 ) then
                   if ( nspin == 100 ) then
                      if(iprinegativecharge >=1 .and. isw == 0) &
                           &         write(nfout,'(" #loop = ",i3)') ispin
                   else if ( nspin == 2 ) then
                      if(iprinegativecharge >=1 .and. isw == 0) &
                           &         write(nfout,'(" #spin = ",i3)') ispin
                   endif
                endif
! ======================================================================== 11.0

                if(iprinegativecharge>=1) &
                     & write(nfout,'(" *** WARN IMAG(CHG) = ",d15.7, " > 0.0 AT ",i8," ***")') afft(ip+1),i
             endif
             afft(ip+1) = 0.d0
          else if (abs(afft(ip+1)) > 0.d0) then
             afft(ip+1) = 0.d0
          end if
       end do
#endif
    end if

    if(iprinegativecharge0 >= 1) then
       if(npes_in == npes .and. npes > 1) then
          call mpi_allreduce(icwarn_NEGA,icwarn_NEGA_total,1,mpi_integer,mpi_sum,mpi_comm_group,ierr)
          call mpi_allreduce(icwarn_IMAG,icwarn_IMAG_total,1,mpi_integer,mpi_sum,mpi_comm_group,ierr)
       else if(npes_in == npes_cdfft .and. npes_cdfft > 1) then
          call mpi_allreduce(icwarn_NEGA,icwarn_NEGA_total,1,mpi_integer,mpi_sum &
               & ,mpi_cdfft_world(myrank_ggacmp),ierr)
          call mpi_allreduce(icwarn_IMAG,icwarn_IMAG_total,1,mpi_integer,mpi_sum &
               & ,mpi_cdfft_world(myrank_ggacmp),ierr)
       else
          icwarn_NEGA_total = icwarn_NEGA
          icwarn_IMAG_total = icwarn_IMAG
       end if
    end if

    if(iprinegativecharge >=1) then
       if(icwarn_NEGA_total >= 1) then
! =============================== modified by K. Tagami =============== 11.0
!          if(nspin == 2) write(nfout,'(" #spin = ",i3," : 1 = UP, 2 = DOWN")') ispin
!
          if ( nspin == 100 ) then
             write(nfout,'(" #loop = ",i3)' ) ispin
          else if (nspin == 2) then
             write(nfout,'(" #spin = ",i3," : 1 = UP, 2 = DOWN")') ispin
          endif
! ===================================================================== 11.0  

          if(npes == 1) then
             !write(nfout,'(" *** WARN  # of <<Negative Charge Density>>  = ",i9)') icwarn_NEGA_total
             write(nfout,'(" ### Warning(4202): Number of <<Negative Charge Density>> =",i9)') icwarn_NEGA_total

          else
             !write(nfout,'(" *** WARN  # of <<Negative Charge Density>>  = ",i9,", (node ",i3,") = ",i9)') &
             !     & icwarn_NEGA_total, mype,icwarn_NEGA
             write(nfout,'(" ### Warning(4202): Number of <<Negative Charge Density>> =",i9,", (node ",i3,") = ",i9)') &
                  & icwarn_NEGA_total, mype,icwarn_NEGA
          end if
       endif

       if(icwarn_IMAG_total >= 1) then
! =============================== modified by K. Tagami =============== 11.0
!          if(nspin == 2) write(nfout,'(" #spin = ",i3," : 1 = UP, 2 = DOWN")') ispin
!
          if ( nspin == 100 ) then
             write(nfout,'(" #loop = ",i3)' ) ispin
          else if (nspin == 2) then
             write(nfout,'(" #spin = ",i3," : 1 = UP, 2 = DOWN")') ispin
          endif
! ===================================================================== 11.0

          if(npes == 1) then
             write(nfout,'(" *** WARN  # of <<Imaginary Charge Density>> = ",i9)') icwarn_IMAG_total
          else
             write(nfout,'(" *** WARN  # of <<Imaginary Charge Density>> = ",i9,", (node ",i3,") = ",i9)') &
                  & icwarn_IMAG_total, mype,icwarn_IMAG
          end if
       end if
    end if
  end subroutine m_FFT_check_of_negative_CD

  subroutine m_FFT_W_Vlocal_W(electron_or_positron,nabfft,afft,bfft,eg)
    integer, intent(in) ::                             electron_or_positron
    integer, intent(in) ::                             nabfft
    real(kind=DP), intent(in),    dimension(nabfft) :: afft
    real(kind=DP), intent(inout), dimension(nabfft) :: bfft
    real(kind=DP), intent(out)                 :: eg

    integer i, id, j, k, ip, nl, nm, nn, nd2, nd3, nlh, idh
    real(kind=DP) :: s



    if(electron_or_positron == ELECTRON) then
       id  = fft_box_size_WF(1,0)
       nl  = fft_box_size_WF(1,1)
       nm  = fft_box_size_WF(2,1)
       nn  = fft_box_size_WF(3,1)
       nd2 = fft_box_size_WF(2,0)
       nd3 = fft_box_size_WF(3,0)
    else if(electron_or_positron == POSITRON) then
       id  = fft_box_size_pWF(1,0)
       nl  = fft_box_size_pWF(1,1)
       nm  = fft_box_size_pWF(2,1)
       nn  = fft_box_size_pWF(3,1)
       nd2 = fft_box_size_pWF(2,0)
       nd3 = fft_box_size_pWF(3,0)
    end if

    s = 0.d0
    if(kimg == 1) then
       do i = 1, id*nd2*nn-1, 2
          bfft(i) = afft(i)*(bfft(i)**2 + bfft(i+1)**2)
       end do
       nlh = nl/2
       do i = 1, id*nd2*nn-1, 2
          s = s + bfft(i)
       end do
       s = s + s
       do i = 1, id*nd2*nn-1, id
          s = s - bfft(i)
       end do
       do i = nlh*2+1, id*nd2*nn-1, id
          s = s - bfft(i)
       end do
!!$       write(6,'(" s = ", d20.8)') s
    else if(kimg == 2) then
       do i = 1, id*nd2*nn*kimg-1, 2
          s = s + afft(i)*(bfft(i)**2 + bfft(i+1)**2)
       end do
!!$       if(sw_zero_padding == ON) then
!!$          do j = nl+1, id
!!$             do i = 1, nd2*nn
!!$                ip = id*(i-1) + j
!!$                bfft(ip*2-1) = 0.d0
!!$                bfft(ip*2) = 0.d0
!!$             end do
!!$          end do
!!$          do j = nm+1, nd2
!!$             do k = 1, nn
!!$                do i = 1, nl
!!$                   ip = i + id*(j-1) + id*nd2*(k-1)
!!$                   bfft(ip*2-1) = 0.d0
!!$                   bfft(ip*2) = 0.d0
!!$                end do
!!$             end do
!!$          end do
    end if
    eg = s / product(fft_box_size_WF(1:3,1))
  end subroutine m_FFT_W_Vlocal_W

! =========================== added by K. Tagami =================== 11.0 
  subroutine m_FFT_W_Vlocal_W_noncl(electron_or_positron,nabfft,afft_kt,bfft_kt,eg, &
       &     ndim_spinor, ndim_chgpot )
    integer, intent(in) ::     electron_or_positron
    integer, intent(in) ::     nabfft
    integer, intent(in) ::     ndim_chgpot, ndim_spinor

    real(kind=DP), intent(in)    :: afft_kt( nabfft,ndim_chgpot )
    real(kind=DP), intent(inout) :: bfft_kt( nabfft,ndim_spinor  )
    real(kind=DP), intent(out)                 :: eg
!
    real(kind=DP), allocatable ::  afft_tmp(:)
    integer i, id, j, k, ip, nl, nm, nn, nd2, nd3, nlh, idh
    real(kind=DP) :: s, ctmp_r, ctmp_i

! 
    integer :: is1, is2, is_tmp
    complex(kind=CMPLDP) :: z1, z2, z3, zsum

    if(electron_or_positron == ELECTRON) then
       id  = fft_box_size_WF(1,0)
       nl  = fft_box_size_WF(1,1)
       nm  = fft_box_size_WF(2,1)
       nn  = fft_box_size_WF(3,1)
       nd2 = fft_box_size_WF(2,0)
       nd3 = fft_box_size_WF(3,0)
    else if(electron_or_positron == POSITRON) then
       id  = fft_box_size_pWF(1,0)
       nl  = fft_box_size_pWF(1,1)
       nm  = fft_box_size_pWF(2,1)
       nn  = fft_box_size_pWF(3,1)
       nd2 = fft_box_size_pWF(2,0)
       nd3 = fft_box_size_pWF(3,0)
    end if

    allocate( afft_tmp( nabfft ) ); afft_tmp = 0.0d0

    s = 0.d0
    if(kimg == 1) then
       do i = 1, id*nd2*nn-1, 2
          ctmp_r = bfft_kt( i,  1 ) *bfft_kt( i,2 ) + bfft_kt( i+1,1 )*bfft_kt( i+1,2 )
          ctmp_i = bfft_kt( i+1,1 ) *bfft_kt( i,2 ) - bfft_kt( i  ,1 )*bfft_kt( i+1,2 )

          afft_tmp(i) =  afft_kt(i,1)*( bfft_kt(i,1)**2 + bfft_kt(i+1,1)**2 ) &
               &        +afft_kt(i,4)*( bfft_kt(i,2)**2 + bfft_kt(i+1,2)**2 ) &
               &        +( afft_kt(i,2)*ctmp_r -afft_kt(i+1,2)*ctmp_i )*2.0d0

       end do

       nlh = nl/2
       do i = 1, id*nd2*nn-1, 2
          s = s + afft_tmp(i)
       end do
       s = s + s
       do i = 1, id*nd2*nn-1, id
          s = s - afft_tmp(i)
       end do
       do i = nlh*2+1, id*nd2*nn-1, id
          s = s - afft_tmp(i)
       end do
!!$       write(6,'(" s = ", d20.8)') s
    else if(kimg == 2) then

       do i = 1, id*nd2*nn*kimg -1, 2
          zsum = 0.0d0
          Do is1=1, ndim_spinor
             Do is2=1, ndim_spinor

                is_tmp = ( is1- 1 )*ndim_spinor + is2
                z1 = dcmplx( bfft_kt(i,is1), bfft_kt(i+1,is1) )
                z2 = dcmplx( bfft_kt(i,is2), bfft_kt(i+1,is2) )
                z3 = dcmplx( afft_kt(i,is_tmp), afft_kt(i+1,is_tmp) ) 
                zsum = zsum + conjg( z1 )*z2 *z3
             End do
          End do

          afft_tmp(i) = real(zsum)

!          ctmp_r = bfft_kt( i,  1 ) *bfft_kt( i,2 ) + bfft_kt( i+1,1 )*bfft_kt( i+1,2 )
!          ctmp_i = bfft_kt( i+1,1 ) *bfft_kt( i,2 ) - bfft_kt( i  ,1 )*bfft_kt( i+1,2 )

!          afft_tmp(i) =  afft_kt(i,1)*( bfft_kt(i,1)**2 + bfft_kt(i+1,1)**2 ) &
!               &        +afft_kt(i,4)*( bfft_kt(i,2)**2 + bfft_kt(i+1,2)**2 ) &
!               &        +( afft_kt(i,2)*ctmp_r -afft_kt(i+1,2)*ctmp_i )*2.0d0

       end do
       do i = 1, id*nd2*nn*kimg -1, 2
          s = s + afft_tmp(i)
       end do

    end if
    eg = s / product(fft_box_size_WF(1:3,1))

    if ( allocated( afft_tmp ) ) deallocate( afft_tmp )

  end subroutine m_FFT_W_Vlocal_W_noncl
!! ============================================================================ 11.0

  subroutine m_FFT_afft_allgatherv(afft_mpi0,afft)
    real(kind=DP),intent(in),dimension(:) :: afft_mpi0(ista_sfftp:iend_sfftp)
    real(kind=DP),intent(out),dimension(:):: afft(nfftp)
    integer  :: id_sname = -1
    if(npes >= 2) then
       call tstatc0_begin('m_FFT_afft_allgatherv(in m_FFT.) ',id_sname)
       call mpi_allgatherv(afft_mpi0,nel_sfftp(mype),mpi_double_precision &  ! MPI
            &       ,afft,nel_sfftp,idisp_sfftp,mpi_double_precision,mpi_comm_group,ierr)
    else     ! npes == 1
       afft = afft_mpi0
    end if
    if(npes >= 2) call tstatc0_end(id_sname)
  end subroutine m_FFT_afft_allgatherv

  subroutine m_FFT_afft_allgatherv_c(afft_mpi0,afft)
    real(kind=DP),intent(in),dimension(:) :: afft_mpi0(ista_fftp:iend_fftp)
    real(kind=DP),intent(out),dimension(:):: afft(nfftp)
    integer  :: id_sname = -1
    if(npes_cdfft >= 2) then
       call tstatc0_begin('m_FFT_afft_allgatherv_c(in m_FFT.) ',id_sname)
       if(myrank_ggacmp <nrank_ggacmp) then
          call mpi_allgatherv(afft_mpi0,nel_fftp(myrank_cdfft),mpi_double_precision &  ! MPI
               &       ,afft,nel_fftp,idisp_fftp,mpi_double_precision,mpi_cdfft_world(myrank_ggacmp),ierr)
       end if
       call tstatc0_end(id_sname)
    else     ! npes == 1
       afft = afft_mpi0
    end if
  end subroutine m_FFT_afft_allgatherv_c

  subroutine m_FFT_Vlocal_pW(afft,bfft)
    real(kind=DP), intent(in),    dimension(nfft_pstrn) :: afft
    real(kind=DP), intent(inout), dimension(nfft_pstrn) :: bfft

    integer i
    do i = 1, nfft_pstrn-1, 2
       bfft(i)   = afft(i) * bfft(i)
       bfft(i+1) = afft(i) * bfft(i+1)
    end do
    if(mod(nfft_pstrn,2) == 1) bfft(nfft_pstrn) = afft(nfft_pstrn)*bfft(nfft_pstrn)
  end subroutine m_FFT_Vlocal_pW

! === EXP_CELLOPT ==== 2015/09/24
  subroutine m_FFT_coef_CD_integration_kt(ista,iend,f2or1)
                                            ! from m_XC_Potential.F90,  for electron ?
    integer, intent(in) :: ista, iend
    real(kind=DP),intent(out) :: f2or1( ista:iend )

    integer                  :: idp,nlp,nmp,nnp,nd2p,nd3p,ip, idph, nlph

    nlp  = fft_box_size_CD(1,1)
    nmp  = fft_box_size_CD(2,1)
    nnp  = fft_box_size_CD(3,1)
#ifdef _MPIFFT_
    idp  = fft_box_size_CD_c(1,0)
    nd2p = fft_box_size_CD_c(2,0)
    nd3p = fft_box_size_CD_c(3,0)
#else
    idp  = fft_box_size_CD(1,0)
    nd2p = fft_box_size_CD(2,0)
    nd3p = fft_box_size_CD(3,0)
#endif

    call set_f2or1( npes, ista, iend, f2or1 )

  contains

    subroutine set_f2or1(npes,ista,iend,f2or1)
      integer, intent(in) :: npes,ista, iend
      real(kind=DP), intent(out), dimension(ista:iend) :: f2or1
      integer :: idph,nlph,ip,i,j,k

      if(kimg == 1) then
         idph = idp/2
         nlph = nlp/2
#ifdef _MPIFFT_

         f2or1 = 0.d0
!!$         do j = 1, min(nz_d,nnp-nz_d*myrank_cdfft)*nmp
!!$         do j = 1, min(nz_d,nnp-nz_d*myrank_cdfft)*nd2p
         do k = 1, min(nz_d, nnp-nz_d*myrank_cdfft)
            do j = 1, nmp
               do i = 1, nlph
!!$                  ip = i + idph*(j-1) + idph*ly*lz_d*myrank_cdfft
                  ip = i + idph*(j-1) + idph*ly*(k-1) + idph*ly*lz_d*myrank_cdfft
                  f2or1(ip) = 2.d0
               end do
               ip = 1 + idph*(j-1) + idph*ly*(k-1) + idph*ly*lz_d*myrank_cdfft
               f2or1(ip) = 1.d0
               ip = nlph+1 + idph*(j-1) + idph*ly*(k-1) + idph*ly*lz_d*myrank_cdfft
               f2or1(ip) = 1.d0
            end do
         end do
!!$            ip = idph*(j-1) + 1 + idph*ly*lz_d*myrank_cdfft
!!$            f2or1(ip) = 1.d0
!!$            ip = idph*(j-1)+ nlph + 1 + idph*ly*lz_d*myrank_cdfft
!!$            f2or1(ip) = 1.d0
!!$         end do
#else
         f2or1 = 2.d0
         if(npes >= 2) then
            do i = 1, nd2p*nnp
               ip = idph*(i-1) + 1
               if(ip>= ista .and. ip <= iend) f2or1(ip) = 1.d0
            end do
            do i = 1, nd2p*nnp
               ip = idph*(i-1) + nlph + 1
               if(ip>= ista .and. ip <= iend) f2or1(ip) = 1.d0
            end do
            do j = nlph+2, idph
               do i = 1,nd2p*nnp
                  ip = idph*(i-1)+j
                  if(ip>= ista .and. ip <= iend) f2or1(ip) = 0.d0
               end do
            end do
            do j = nmp+1, nd2p
               do k = 1, nnp
                  do i = 1, nlph
                     ip = i + idph*(j-1) + idph*nd2p*(k-1)
                     if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
                  end do
               end do
            end do
! for SX6 ASL 20040817
            do k = nnp+1, nd3p
               do i = 1, idph*nd2p
                  ip = i + idph*nd2p*(k-1)
                  if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
               end do
            end do
         else
            do i = 1, nd2p*nnp
               ip = idph*(i-1) + 1
               f2or1(ip) = 1.d0
            end do
            do i = 1, nd2p*nnp
               ip = idph*(i-1) + nlph + 1
               f2or1(ip) = 1.d0
            end do
            do j = nlph+2, idph
               do i = 1,nd2p*nnp
                  ip = idph*(i-1)+j
                  f2or1(ip) = 0.d0
               end do
            end do
            do j = nmp+1, nd2p
               do k = 1, nnp
                  do i = 1, nlph
                     ip = i + idph*(j-1) + idph*nd2p*(k-1)
                     f2or1(ip) = 0.d0
                  end do
               end do
            end do
! for SX6 ASL 20040817
            do k = nnp+1, nd3p
               do i = 1, idph*nd2p
                  ip = i + idph*nd2p*(k-1)
                  f2or1(ip) = 0.d0
               end do
            end do
         end if
!!$       do i = ista, iend
!!$          if(mod(i*2,idp) == 2 .or. mod(i*2,idp) == 0) f2or1(i) = 1.d0
!!$       end do
#endif
      else
#ifdef _MPIFFT_
!!$         f2or1 = 0.d0                 ! f2or1 works to the fft data in Rspace.
!!$         do k = 1, min(nz_d,nnp-nz_d*myrank_cdfft)
!!$            do j = 1, nmp     ! nmp = fft_box_size_CD(2,1)
!!$               do i = 1, nlp  ! nlp = fft_box_size_CD(1,1)
!!$                  ip = i+(j-1)*idp+(k-1)*idp*nd2p+idp*nd2p*lz_d*myrank_cdfft
!!$                  f2or1(ip) = 1.d0
!!$               end do
!!$            end do
!!$         end do
!         if(iprixc >= 2 ) write(nfout,'(" ix kimg = 2 <<set_f2or1>>")')
         f2or1 = 1.d0
         do j = nlp+1, idp      ! x
            do i = 1, ly*nz_d
               ip = idp*(i-1)+j+ista-1
               f2or1(ip) = 0.d0
            end do
         end do
!         if(iprixc >= 2 ) write(nfout,'(" iy kimg = 2 <<set_f2or1>>")')
         do j = nmp+1,ly         ! y
            do k = 1, nz_d
               do i = 1, nlp
                  ip = i + idp*(j-1) + idp*ly*(k-1) + ista-1
                  f2or1(ip) = 0.d0
               end do
            end do
         end do
!         if(iprixc >= 2 ) write(nfout,'(" iz kimg = 2 <<set_f2or1>>")')
         do  k = nz_d+1, lz_d   ! z
            do i = 1, idp*ly
               ip = i + idp*ly*(k-1) + ista-1
               f2or1(ip) = 0.d0
            end do
         end do
#else
         f2or1 = 1.d0
         if(npes >= 2) then
            do j = nlp+1, idp    ! x
               do i = 1, nd2p*nnp
                  ip = idp*(i-1)+j
                  if(ip>= ista .and. ip <= iend) f2or1(ip) = 0.d0
               end do
            end do
            do j = nmp+1, nd2p   ! y
               do k = 1, nnp
                  do i = 1, nlp
                     ip = i + idp*(j-1) + idp*nd2p*(k-1)
                     if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
                  end do
               end do
            end do
! for SX6 ASL 20040817
            do k = nnp+1, nd3p   ! z
               do i = 1, idp*nd2p
                  ip = i + idp*nd2p*(k-1)
                  if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
               end do
            end do
         else
            do j = nlp+1, idp    ! x
               do i = 1, nd2p*nnp
                  ip = idp*(i-1)+j
! ================================ modifed by K. Tagami ====( uncertain )== 11.0
!                  f2or1(ip) = 0.d0
                  if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
! ===================================================================== 11.0
               end do
            end do
            do j = nmp+1, nd2p   ! y
               do k = 1, nnp
                  do i = 1, nlp
                     ip = i + idp*(j-1) + idp*nd2p*(k-1)
! ================================ modifed by K. Tagami ====( uncertain )== 11.0
!                     f2or1(ip) = 0.d0
                     if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
! ===================================================================== 11.0
                  end do
               end do
            end do
! for SX6 ASL 20040817
            do k = nnp+1, nd3p   ! z
               do i = 1, idp*nd2p
                  ip = i + idp*nd2p*(k-1)
! ================================ modifed by K. Tagami ====( uncertain )== 11.0
!                  f2or1(ip) = 0.d0
                  if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
! ===================================================================== 11.0
               end do
            end do
         end if
#endif
      end if
    end subroutine set_f2or1
  end subroutine m_FFT_coef_CD_integration_kt
! ==================== 2015/09/24

  subroutine m_FFT_coef_CD_integration(f2or1)
    real(kind=DP),intent(out), dimension(ista_sfftph:iend_sfftph) :: f2or1
    integer :: idp, nlp, nmp, nnp, nd2p, idph, nlph, ip, i, j, k

    idp  = fft_box_size_CD(1,0)
    nlp  = fft_box_size_CD(1,1)
    nmp  = fft_box_size_CD(2,1)
    nnp  = fft_box_size_CD(3,1)
    nd2p = fft_box_size_CD(2,0)


    if(kimg == 1) then
       f2or1 = 2.d0
       idph = idp/2
       nlph = nlp/2
       if(npes >= 2) then
          do i = 1, nd2p*nnp
             ip = idph*(i-1) + 1
             if(ip>= ista_sfftph .and. ip <= iend_sfftph) f2or1(ip) = 1.d0
          end do
          do i = 1, nd2p*nnp
             ip = idph*(i-1) + nlph + 1
             if(ip>= ista_sfftph .and. ip <= iend_sfftph) f2or1(ip) = 1.d0
          end do
          do j = nlph+2, idph
             do i = 1,nd2p*nnp
                ip = idph*(i-1)+j
                if(ip>= ista_sfftph .and. ip <= iend_sfftph) f2or1(ip) = 0.d0
             end do
          end do
          do j = nmp+1, nd2p
             do i = 1, nlph
                ip = i + idph*(j-1) + idph*nd2p*(k-1)
                if(ip >= ista_sfftph .and. ip <= iend_sfftph) f2or1(ip) = 0.d0
             end do
          end do
       else
          do i = 1, nd2p*nnp
             ip = idph*(i-1) + 1
             f2or1(ip) = 1.d0
          end do
          do i = 1, nd2p*nnp
             ip = idph*(i-1) + nlph + 1
             f2or1(ip) = 1.d0
          end do
          do j = nlph+2, idph
             do i = 1,nd2p*nnp
                ip = idph*(i-1)+j
                f2or1(ip) = 0.d0
             end do
          end do
          do j = nmp+1, nd2p
             do i = 1, nlph
                ip = i + idph*(j-1) + idph*nd2p*(k-1)
                f2or1(ip) = 0.d0
             end do
          end do
       end if
!!$       do i = ista_sfftph, iend_sfftph
!!$          if(mod(i*2,idp) == 2 .or. mod(i*2,idp) == 0) f2or1(i) = 1.d0
!!$       end do
    else
       f2or1 = 1.d0
       if(npes >= 2) then
          do j = nlp+1, idp
             do i = 1, nd2p*nnp
                ip = idp*(i-1)+j
                if(ip>= ista_sfftph .and. ip <= iend_sfftph) f2or1(ip) = 0.d0
             end do
          end do
          do j = nmp+1, nd2p
             do k = 1, nnp
                do i = 1, nlp
                   ip = i + idp*(j-1) + idp*nd2p*(k-1)
                   if(ip >= ista_sfftph .and. ip <= iend_sfftph) f2or1(ip) = 0.d0
                end do
             end do
          end do
       else
          do j = nlp+1, idp
             do i = 1, nd2p*nnp
                ip = idp*(i-1)+j
                f2or1(ip) = 0.d0
             end do
          end do
          do j = nmp+1, nd2p
             do k = 1, nnp
                do i = 1, nlp
                   ip = i + idp*(j-1) + idp*nd2p*(k-1)
                   f2or1(ip) = 0.d0
                end do
             end do
          end do
       end if
    end if
  end subroutine m_FFT_coef_CD_integration
#ifdef _MPIFFT_
  subroutine m_FFT_set_cdata(aa,a)
    real(kind=DP), dimension(nfftp), intent(in)                :: aa
    real(kind=DP), dimension(ista_fftp:iend_fftp), intent(out) :: a
    integer :: i,j,k,ii,jj,kk,nn(3),nstart(3),nend(3)
    integer :: lx, llx,lly,lxy,llxy, indexa, ipout, ipin
    indexa = 2
    if(kimg == 1) then
       a = 0.d0
       nn(1:3) = fft_box_size_CD(1:3,1)
       nn(2)   = ny_d
       nstart(1:3) = 1
       nend(1:3) = nn(1:3)
       nstart(indexa)=myrank_cdfft*nn(indexa)+1
       nend(indexa)  =min(fft_box_size_CD(indexa,1),(myrank_cdfft+1)*nn(indexa))
       lx = fft_box_size_CD_c(1,0)
!!$       ly = ly_d   !          =fft_box_size_CD_c(2,0)/npes_cdfft
       llx = fft_box_size_CD_c(1,0)
       lly = fft_box_size_CD_c(2,0)
       lxy = lx*ly_d
       llxy = llx*lly
       do i=nstart(1),nend(1)
          ii=i-nstart(1)+1
          do j=nstart(2),nend(2)
             jj=j-nstart(2)+1
             do k=nstart(3),nend(3)
                kk=k-nstart(3)+1
                ipout = ista_fftp-1+ (ii +(jj-1)* lx+(kk-1)* lxy)
                ipin  =              ( i +( j-1)*llx+( k-1)*llxy)
                A(ipout)   = AA(ipin)
!!$                A(ipout+1) = AA(ipin+1)
             enddo
          enddo
       enddo
    else if(kimg == 2) then
       A = 0.d0
       nn(1:3) = fft_box_size_CD(1:3,1)
       nn(2) = ny_d
       nstart(1:3) = 1
       nend(1:3) = nn(1:3)
       nstart(indexa)=myrank_cdfft*nn(indexa)+1
       nend(indexa)  =min(fft_box_size_CD(indexa,1),(myrank_cdfft+1)*nn(indexa))
       lx = fft_box_size_CD_c(1,0)
!!$       ly = ly_d   !          =fft_box_size_CD_c(2,0)/npes_cdfft
       llx = fft_box_size_CD_c(1,0)
       lly = fft_box_size_CD_c(2,0)
       lxy = lx*ly_d
       llxy = llx*lly
       if(ipri >= 2) then
          write(nfout,'(" nstart(1), nend(1) = ",2i8)') nstart(1), nend(1)
          write(nfout,'(" nstart(2), nend(2) = ",2i8)') nstart(2), nend(2)
          write(nfout,'(" nstart(3), nend(3) = ",2i8)') nstart(3), nend(3)
          write(nfout,'(" llx,lx,lly,ly_d    = ",4i8)') llx,lx,lly,ly_d
       end if
!!$       if(npes_cdfft == 1) nend(2) = nend(2)/2
!!$       if(myrank_cdfft == 0) then
       do i=nstart(1),nend(1)
          ii=i-nstart(1)+1
          do j=nstart(2),nend(2)
             jj=j-nstart(2)+1
             do k=nstart(3),nend(3)
                kk=k-nstart(3)+1
                ipout = ista_fftp-1 + 2*(ii +(jj-1)* lx+(kk-1)* lxy)-1
                ipin  =               2*( i +( j-1)*llx+( k-1)*llxy)-1
                A(ipout)   = AA(ipin)
                A(ipout+1) = AA(ipin+1)
             end do
          end do
       end do
    end if

  end subroutine m_FFT_set_cdata

  subroutine m_FFT_set_scdata(aa,a)
    real(kind=DP), dimension(*), intent(in)                    :: aa
    real(kind=DP), dimension(ista_fftp:iend_fftp), intent(out) :: a
    integer :: i,j,k,ii,jj,kk,nn(3),nstart(3),nend(3)
    integer :: lx,llx,lly,lxy,llxy,indexa
    indexa = 2
    if(kimg == 2) then
       nn(1:3) = fft_box_size_CD(1:3,1)
       nn(2) = ny_ds
       nstart(1:3) = 1
       nend(1:3) = nn(1:3)
       nstart(indexa)=mype*nn(indexa)+1
       nend(indexa)  =min(fft_box_size_CD(indexa,1),(mype+1)*nn(indexa))
       lx = fft_box_size_CD_c(1,0)
!!$       ly = fft_box_size_CD(2,0)/npes ! = ly_ds
       llx = fft_box_size_CD_c(1,0)
       lly = fft_box_size_CD_c(2,0)
       lxy = lx*ly_ds
       llxy = llx*lly
       do i=nstart(1),nend(1)
          ii=i-nstart(1)+1
          do j=nstart(2),nend(2)
             jj=j-nstart(2)+1
             do k=nstart(3),nend(3)
                kk=k-nstart(3)+1
                A(ista_fftp-1+ii+(jj-1)*lx+(kk-1)*lxy)=AA(i+(j-1)*llx+(k-1)*llxy-ista_fftp)
             enddo
          enddo
       enddo
    end if

  end subroutine m_FFT_set_scdata
#endif

#ifdef _MPIFFT_
  subroutine check_ierr(ierr0)
    integer, intent(in),dimension(2) :: ierr0
    IF( IERR0(1) .GE. 3000 ) THEN
       WRITE(6,*) '*** 3D FFT ERROR ***'
       WRITE(6,*) mype,':IERR =',IERR0(1)
       IF( IERR0(1) .EQ. -1 ) THEN
          WRITE(6,*) mype,':MPI ERROR =',IERR0(2)
       ENDIF
       stop 'error hyb fft'
    ENDIF
  end subroutine check_ierr

  subroutine wd_time(time)
    real(kind=DP), intent(in), dimension(5) :: time
    WRITE(6,6000)
    WRITE(6,6010) mype,TIME(1:5)
6000 FORMAT(' RANK     X-FFT       Y-FFT       Z-FFT       ', &
          &       'TRANS       TOTAL  (Direct)')
6010 FORMAT(1X,I4,':',6(1PD12.4),0PF9.1)
  end subroutine wd_time

  subroutine get_nxnynz(nx,ny,nz)
    integer, intent(out) :: nx,ny,nz
    NX = fft_box_size_CD(1,1)
    NY = fft_box_size_CD(2,1)
    NZ = fft_box_size_CD(3,1)
  end subroutine get_nxnynz

#endif

  subroutine m_FFT_CD_direct(nfout,afft)   ! R space --> G space
#ifdef NEC_TUNE_FFT
      use m_Parallelization,   only : itask
#endif
    integer, intent(in)       :: nfout
    real(kind=DP), intent(inout) :: afft(ista_sfftp:iend_sfftp)
#ifdef _MPIFFT_
    INTEGER :: NX,NY,NZ
    INTEGER :: NT,ISW,IERR0(2)
    integer, parameter :: INDEXA = 2, INDEXB = 3
    real(kind=DP),allocatable :: B(:)
    real(kind=DP) :: TIME(5)
    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_CD_direct ',id_sname)

    call get_nxnynz(nx,ny,nz)

    allocate(B(ista_sfftp:iend_sfftp))
    ISW = 1
#ifdef NEC_TUNE_FFT
    NT = itask
#else
    NT = 1
#endif

    if(kimg==1) then
       call fft_r3d(nx,ny,nz,ny_ds,nz_ds,afft &
            &      ,lxs,lys,lzs,ly_ds,lz_ds,indexa,isw,time,b &
            &      ,nt, mpi_comm_group,ierr0)
    else
       call fft_c3d(nx,ny,nz,ny_ds,nz_ds,afft &
            &      ,lxs,lys,lzs,ly_ds,lz_ds,indexa,isw,time,b &
            &      ,nt, mpi_comm_group,ierr0)
    end if
    call check_ierr(ierr0)

    CALL MPI_BARRIER(MPI_COMM_GROUP,IERR)
    
    if(ipri >= 2) call wd_time(time)

    deallocate(B)
#else
    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_CD_direct ',id_sname)

    if(npes >= 2) then
       call m_FFT_afft_allgatherv(afft,afft_CD)
    else
       afft_CD = afft
    end if

    call fft_CD_direct_core(afft_CD)

    afft(ista_sfftp:iend_sfftp) = afft_CD(ista_sfftp:iend_sfftp)
#endif
    call tstatc0_end(id_sname)
  end subroutine m_FFT_CD_direct

  subroutine m_FFT_reset_CD_setup_stat()
    CD_setup_is_done = NO
  end subroutine m_FFT_reset_CD_setup_stat


  subroutine m_FFT_CD0(nfout,afftp,inverse_or_direct)  ! R space --> G space
    integer, intent(in)          :: nfout, inverse_or_direct
    real(kind=DP), intent(inout) :: afftp(nfftp_nonpara)
    integer :: id_sname = -1
    integer, dimension(2) :: flag_mklfft = (/-1, 1/)

    if(ipri >= 2) write(nfout,'(" <<m_FFT_CD0>>")')
    call tstatc0_begin('m_FFT_CD0 ', id_sname, 1)
    if(CD_setup_is_done == NO) then
       if(ipri >= 1) write(nfout,'(" <<CDFFT_setup>>")')
       call CDFFT_setup()
    end if

    if(inverse_or_direct == DIRECT) then
       call fft_CD_direct_core(afftp)
    else if(inverse_or_direct == INVERSE) then
       call fft_CD_inverse_core(afftp)
    end if

    call tstatc0_end(id_sname)
  end subroutine m_FFT_CD0

  subroutine m_FFT_CD0_exx(nfout,afftp,inverse_or_direct)  ! R space --> G space
    integer, intent(in)          :: nfout, inverse_or_direct
    real(kind=DP), intent(inout) :: afftp(nfftp_exx_nonpara)
    integer :: id_sname = -1
    integer, dimension(2) :: flag_mklfft = (/-1, 1/)
#if defined(JRCATFFT_WS) || defined(FFTW3)
    if(ipri >= 2) write(nfout,'(" <<m_FFT_CD0_exx>>")')
    call tstatc0_begin('m_FFT_CD0_exx ', id_sname, 1)
    if(CD_setup_is_done_exx == NO) then
#ifdef _INCLUDE_EXX_
       if(ipri >= 1) write(nfout,'(" <<CDFFT_setup_exx>>")')
       call CDFFT_setup_exx()
#endif
    end if
    if(inverse_or_direct == DIRECT) then
       call fft_CD_direct_core_exx(afftp)
    else if(inverse_or_direct == INVERSE) then
       call fft_CD_inverse_core_exx(afftp)
    end if

    call tstatc0_end(id_sname)
#else
    stop 'EXX in rspace can only be used with JRCAT FFT or FFTW3'
#endif
  end subroutine m_FFT_CD0_exx

  subroutine m_FFT_CD_direct_c(nfout,afft,mode)   ! R space --> G space
#ifdef NEC_TUNE_FFT
      use m_Parallelization,   only : itask
#endif
    integer, intent(in)       :: nfout
    real(kind=DP), intent(inout) :: afft(ista_fftp:iend_fftp)
    integer, intent(in), optional :: mode
#ifdef _MPIFFT_

    INTEGER :: NX,NY,NZ
    INTEGER :: NT,ISW,IERR0(2)

    integer, parameter :: INDEXA = 2, INDEXB = 3
    real(kind=DP),allocatable :: B(:)
    real(kind=DP) :: TIME(5)
#endif

    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_CD_direct_c ',id_sname)
    if(present(mode) .and. mode == 0) goto 9999

#ifdef _MPIFFT_
    call get_nxnynz(nx,ny,nz)

    allocate(B(ista_fftp:iend_fftp))
    if(kimg == 1) then
       isw = -1
    else if(kimg == 2) then
       ISW = 1
    end if

#ifdef NEC_TUNE_FFT
    NT = itask
#else
    NT = 1
#endif

    if(kimg==1) then
       call fft_r3d(nx,ny,nz,ny_d,nz_d,afft &
            &      ,lx,ly,lz,ly_d,lz_d,indexb,isw,time,b &
            &      ,nt,mpi_cdfft_world(myrank_ggacmp),ierr0)
    else
       call fft_c3d(nx,ny,nz,ny_d,nz_d,afft &
            &      ,lx,ly,lz,ly_d,lz_d,indexb,isw,time,b &
            &      ,nt,mpi_cdfft_world(myrank_ggacmp),ierr0) 
    end if
    IF( IERR0(1) .GE. 3000 ) THEN
       write(6,*) ' nx,ny,nz,ny_d,nz_d = ',nx,ny,nz,ny_d,nz_d
       write(6,*) ' lx,ly,lz,ly_d,lz_d = ',lx,ly,lz,ly_d,lz_d
    ENDIF
    call check_ierr(ierr0)

    CALL MPI_BARRIER(mpi_cdfft_world(myrank_ggacmp),IERR)
    if(ipri >= 2) call wd_time(time)

    deallocate(B)

#else
    call m_FFT_afft_allgatherv_c(afft,afft_CD)

    call fft_CD_direct_core(afft_CD)

    afft(ista_fftp:iend_fftp) = afft_CD(ista_fftp:iend_fftp)
#endif
9999 call tstatc0_end(id_sname)
  end subroutine m_FFT_CD_direct_c

  subroutine m_FFT_CD_inverse(nfout,afft)  ! G space --> R space
#ifdef NEC_TUNE_FFT
      use m_Parallelization,   only : itask
#endif
    integer, intent(in)          :: nfout
    real(kind=DP), intent(inout) :: afft(ista_sfftp:iend_sfftp)
#ifdef _MPIFFT_
    INTEGER :: NX,NY,NZ
    INTEGER :: NT,ISW,IERR0(2)
    integer, parameter :: INDEXA = 2, INDEXB = 3
    real(kind=DP),allocatable :: B(:)
    real(kind=DP) :: TIME(5)

    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_CD_inverse ', id_sname)

    call get_nxnynz(nx,ny,nz)

    allocate(B(ista_sfftp:iend_sfftp))
    CALL MPI_BARRIER(MPI_COMM_GROUP,IERR)
    ISW = -1

#ifdef NEC_TUNE_FFT
    NT = itask
#else
    NT = 1
#endif

    if(kimg==1) then
       call fft_r3d(nx,ny,nz,ny_ds,nz_ds,afft &
            &      ,lxs,lys,lzs,ly_ds,lz_ds,indexa,isw,time,b &
            &      ,nt, mpi_comm_group,ierr0)
    else
       call fft_c3d(nx,ny,nz,ny_ds,nz_ds,afft &
            &      ,lxs,lys,lzs,ly_ds,lz_ds,indexa,isw,time,b &
            &      ,nt,mpi_comm_group,ierr0)
    end if
    call check_ierr(ierr0)
    CALL MPI_BARRIER(MPI_COMM_GROUP,IERR)
    if(ipri >= 2) call wd_time(time)
    deallocate(B)
#else
    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_CD_inverse ', id_sname)

    if(npes >= 2) then
       call m_FFT_afft_allgatherv(afft,afft_CD)
    else
       afft_CD = afft
    end if

    call fft_CD_inverse_core(afft_CD)

    afft(ista_sfftp:iend_sfftp) = afft_CD(ista_sfftp:iend_sfftp)
#endif
    call tstatc0_end(id_sname)
  end subroutine m_FFT_CD_inverse

  subroutine m_FFT_CD_inverse_c(nfout,afft,mode)  ! G space --> R space
#ifdef NEC_TUNE_FFT
      use m_Parallelization,   only : itask
#endif
    integer, intent(in)          :: nfout
    real(kind=DP), intent(inout) :: afft(ista_fftp:iend_fftp)
    integer, intent(in), optional :: mode

#ifdef _MPIFFT_
    INTEGER :: NX,NY,NZ,lx,ly,lz
    INTEGER :: NT,ISW,IERR0(2)
    integer, parameter :: INDEXA = 2, INDEXB = 3
    real(kind=DP),allocatable :: B(:)
    integer :: i, ip, j, k
    real(kind=DP) :: TIME(5)
#endif

    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_CD_inverse_c ', id_sname)
    if(present(mode) .and. mode == 0) goto 9999

#ifdef _MPIFFT_
    call get_nxnynz(nx,ny,nz)

    lx = fft_box_size_CD_c(1,0)
    ly = fft_box_size_CD_c(2,0)
    lz = fft_box_size_CD_c(3,0)

    allocate(B(ista_fftp:iend_fftp))

    if(kimg == 1) then
       isw = 1
    else if(kimg == 2) then
       ISW = -1
    end if

#ifdef NEC_TUNE_FFT
    NT = itask
#else
    NT = 1
#endif

    if(kimg==1) then
       if(ipri >= 2) then
          write(nfout,'(" before fft_r3d <<m_FFT_CD_inverse_c>>")')
          write(nfout,'(" nx,ny,nz,ny_d,nz_d = ",5i5)') nx,ny,nz,ny_d,nz_d 
          write(nfout,'(" lx,ly,lz,ly_d,lz_d = ",5i5)') lx,ly,lz,ly_d,lz_d
       end if
       call fft_r3d(nx,ny,nz,ny_d,nz_d,afft &
            &      ,lx,ly,lz,ly_d,lz_d,indexa,isw,time,b &
            &      ,nt,mpi_cdfft_world(myrank_ggacmp),ierr0)
    else if(kimg == 2) then
       if(ipri >= 2) then
          write(nfout,'(" before fft_c3d <<m_FFT_CD_inverse_c>>")')
          do k = 1, nz
             if(k >= 4 .and. k<= nz-3) cycle
             do j = 1, ny_d
                write(nfout,'(" j, k = ", 2i8)') j+ny_d*myrank_cdfft, k
                ip = 2*((j-1)*lx + (k-1)*lx*ly_d) + ista_fftp - 1 
                write(nfout,'(8d12.4)') (afft( ip+i),i=1,fft_box_size_CD(1,1)*2)
             end do
          end do
       end if
       call mpi_barrier(mpi_cdfft_world(myrank_ggacmp),ierr)
       call fft_c3d(nx,ny,nz,ny_d,nz_d,afft &
            &      ,lx,ly,lz,ly_d,lz_d,indexa,isw,time,B &
            &      ,nt,mpi_cdfft_world(myrank_ggacmp),ierr0)
       if(ipri >= 2) then
          write(nfout,'(" after fft_c3d <<m_FFT_CD_inverse_c>>")')
          do k = 1, min(nz_d,8)
             do j = 1, ny
                write(nfout,'(" j, k = ", 2i8)') j, k+nz_d*myrank_cdfft
                ip = 2*((j-1)*lx + (k-1)*lx*ly) + ista_fftp - 1
                write(nfout,'(8d12.4)') (afft( ip+i),i=1,16)
             end do
          end do
       end if
    end if
    call check_ierr(ierr0)
    CALL MPI_BARRIER(MPI_cdfft_world(myrank_ggacmp),IERR)
    if(ipri >= 2) call wd_time(time)

    deallocate(B)
#else
    call m_FFT_afft_allgatherv_c(afft,afft_CD)

    call fft_CD_inverse_core(afft_CD)

    afft(ista_fftp:iend_fftp) = afft_CD(ista_fftp:iend_fftp)
#endif
9999 call tstatc0_end(id_sname)
  end subroutine m_FFT_CD_inverse_c

  subroutine m_FFT_CD_inverse0(nfout,afftp)  ! G space --> R space
    integer, intent(in)          :: nfout
    real(kind=DP), intent(inout) :: afftp(nfftp_nonpara)
    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_CD_inverse0 ', id_sname)
    if(CD_setup_is_done == NO) call CDFFT_setup()

    call fft_CD_inverse_core(afftp)

    call tstatc0_end(id_sname)
  end subroutine m_FFT_CD_inverse0

!!$#ifdef _MPIFFT_
  subroutine set_mpifft_box_size_CD(inversion_symmetry)
    integer, intent(in) :: inversion_symmetry
    integer :: nx, ny, nz, ic, isize
    nx = fft_box_size_CD(1,1); ny = fft_box_size_CD(2,1); nz = fft_box_size_CD(3,1)
    do ic = 1, 2
       if(ic == 1) isize = npes
       if(ic == 2) isize = npes_cdfft
       ny_d =  ny/isize
       nz_d =  nz/isize
       if(mod( ny,isize) .ne. 0) ny_d = ny_d + 1
       if(mod( nz,isize) .ne. 0) nz_d = nz_d + 1
       ly_d = ny_d;   lz_d = nz_d
       if(inversion_symmetry == ON) then  ! kimg == 1
!!$          if(mod(nx,4) == 2) then
!!$             lx = nx + 4
!!$          else
          lx = nx + 2
!!$          end if
       else if(inversion_symmetry == OFF) then ! kimg == 2
          lx = nx
          if(mod(lx,2) == 0)   lx = nx + ldx
       end if

       if(mod(ly_d,2) == 0) ly_d = ny_d + ldy
       if(mod(lz_d,2) == 0) lz_d = nz_d + ldz

       ly   = ly_d*isize
       lz   = lz_d*isize
       if(ic == 1) then
          fft_box_size_CD(1,0) = lx
          fft_box_size_CD(2,0) = ly
          fft_box_size_CD(3,0) = lz
          ny_ds = ny_d;          nz_ds = nz_d;          ly_ds = ly_d
          lys   = ly;            lz_ds = lz_d;          lzs   = lz
          lxs   = lx
       else
          fft_box_size_CD_c(1,0) = lx
          fft_box_size_CD_c(2,0) = ly
          fft_box_size_CD_c(3,0) = lz
       end if
    end do
    if(ipri >= 1) then
       write(nfout,'(" nx,  ny,  nz,  ny_d, nz_d  = ",5i8)') nx,ny,nz,ny_d,nz_d
       write(nfout,'("      ly,  lz,  ly_d, lz_d  = ",8x,4i8)') ly,lz,ly_d,lz_d
!!$       write(nfout,'(" ny,nz,ny_d, nz_d, ly, lz, ly_d, lz_d  = ",/8x,8i8)')  &
!!$            &          ny,nz,ny_d, nz_d, ly, lz, ly_d, lz_d
       write(nfout,'("                ny_ds,nz_ds = ",24x,2i8)') ny_ds, nz_ds
       write(nfout,'("      lys, lzs, ly_ds,lz_ds = ",8x,4i8)') lys,lzs,ly_ds,lz_ds
!!$       write(nfout,'("       ny_ds,nz_ds,lys,lzs,ly_ds,lz_ds = ",/24x,6i8)')&
!!$            &                ny_ds,nz_ds,lys,lzs,ly_ds,lz_ds
    end if
  end subroutine set_mpifft_box_size_CD
!!$#endif


  subroutine m_FFT_cp_afft_CD(afft)
    real(kind=DP),intent(out),dimension(:):: afft(nfftp)
    !!$afft(1:nfftp)=afft_CD(1:nfftp)
    if(allocated(afft_CD)) afft=afft_CD
  end subroutine m_FFT_cp_afft_CD


end module m_FFT

#ifdef HIUX
*OPTION MP(P(0))
#endif
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
#ifdef WF_JRCATFFT
      subroutine jrcat_r3ft(ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                      kc1,kc2,kc3,key)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
c
c------------------>      for Estimation of CPU cost.
c                             by T.Yamasaki
c                               22th May. 1996
      real*8 CRTVL, PCPUDF
      parameter (CRTVL = 1.d-5, PCPUDF = 2.0)
c        CRTVL : CRItical VaLue for Division.
c        PCPUDF: Percent of CPU DiFference.
      real*8 cpu0ol,cpudif,rcpudf,ecpu,tcpu
      integer icount
      data icount/0/
      data ecpu/0.d0/
      data cpu0ol/0.d0/
      real*8 t_start, t_end, UMICRO
      parameter (UMICRO = 1.d-6)
c <-------------------------------------------
      real*8 ra   (id,n2,n3)
      real*8 work (id,n2,n3)

      complex*16 cw1(0:n1-1)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank

c********************************************************************************
c*   key = 0 : set up of FFT.
c*             ( Calculation of cw1,cw2 and cw3. )
c********************************************************************************
c*   n1,n2 and n3 must include radix 2, and they may include 3 or 5.
c*   id must be larger than or equal to n1 + 2.
c*
c********************************************************************************
c*  key = -1 & -2 : F.T. of real 3d array ra(0:n1-1,0:n2-1,0:n3-1) .
c********************************************************************************
c*
c*   The result(complex 'cb') is overwritten on 'ra'.
c*   ( i.e. equivalence(ra,cb) ).
c*   
c*     cb(k1,k2,k3) 
c*   = sum(ix=0:n1-1,iy=0:n2-1,iz=0:n3-1) 
c*     ra(i1,i2,i3) exp [- 2 * pai * ci * ( k1*i1/n1 + k2*i2/n2 + k3*i3/n3 ) ]
c*     
c*     where 0 <= k1 <= n1/2, 0 <= k2 <= n2-1, 0 <= k3 <= n3-1.
c*
c********************************************************************************
c*  key = +1 & +2: Inverse F.T. of copmplex 3d array cb(0:n1/2,0:n2-1,0:n3-1) .
c********************************************************************************
c*   Transform from 'cb' to 'ra'.
c*
c********************************************************************************
c*  kc1,kc2 kc3 are integer parameters specifying the mask for
c*  input data or output data.
c*
c*     If kc1.ge.n1/2.or.kc1.lt.0, then kc1 is forced to be 0. 
c*     If kc2.ge.n2/2.or.kc2.lt.0, then kc2 is forced to be 0. 
c*     If kc3.ge.n3/2.or.kc3.lt.0, then kc3 is forced to be 0. 
c*
c********************************************************************************
c** REMARK on Mask.
c********************************************************************************
c*
c*  key = -1 : Mask is for Output data ( cb ),
c*  key = +1 : Mask is for Input  data ( cb ),
c*  key = -2 : Mask is for Input  data ( ca ),
c*  key = +2 : Mask is for Output data ( ca ),
c*
c*     where ca(0:idh/2,0:n2-1,0:n3-1) and equivalence(ra,ca).
c*
c********************************************************************************
c*     Mask for Output data:
c********************************************************************************
c*
c*     If kc1.eq.0.and.kc2.eq.0.and.kc3.eq.0, then the full wavenumber
c*     range is calculated.
c*
c*     If kc1.ne.0, then only "0 <= k1 <= kc1" range is calculated.
c*
c*     If kc2.ne.0, then only "0 <= k2 <= kc2" and "n2-kc2 <= k2 <= n2-1" 
c*     range is calculated.
c*
c*     If kc3.ne.0, then only "0 <= k3 <= kc3" and "n3-kc3 <= k3 <= n3-1" 
c*     range is calculated.
c*
c********************************************************************************
c*     Mask for Input data:
c********************************************************************************
c*
c*     If kc1.eq.0.and.kc2.eq.0.and.kc3.eq.0, then the full wavenumber
c*     range is used to obtain real array 'ra'.
c*
c*     If kc1.ne.0, then only "0 <= k1 <= kc1" range is used.
c*
c*     If kc2.ne.0, then only "0 <= k2 <= kc2" and "n2-kc2 <= k2 <= n2-1" 
c*     range is used.
c*
c*     If kc3.ne.0, then only "0 <= k3 <= kc3" and "n3-kc3 <= k3 <= n3-1" 
c*     range is used.
c*
c********************************************************************************
c*
c******************************************************************
c**   choose nbank = 0 or nbank = 1 
c******************************************************************
c*   nbank = 0:
c*      The transpose is normally implemented.
c*      Bank conflict may appear patriculary in Vector Computers.
c*   nbank = 1:
c*      The transpose is implemented so as to prevent
c*      the bank conflict in the case the conflict may appear.
c******************************************************************
c
      call gettod(t_start)

      nbank = 0

c**

      if(key.eq.0) then

c** set up of FFT.

         call r3ft_0(cw1,cw2,cw3,n1,n2,n3)

         goto 1001
c$$$         return

      end if

c**
      if(kc1.ge.n1/2.or.kc1.lt.0) then 
         write(6,*) 'warning in FFT: kc1 is irrelevant.'
         write(6,*) 'kc1 has changed to be 0.'
         kc1 = 0
      end if

      if(kc2.ge.n2/2.or.kc2.lt.0) then 
         write(6,*) 'warning in FFT: kc2 is irrelevant.'
         write(6,*) 'kc2 has changed to be 0.'
         kc2 = 0
      end if

      if(kc3.ge.n3/2.or.kc3.lt.0) then 
         write(6,*) 'warning in FFT: kc3 is irrelevant.'
         write(6,*) 'kc3 has changed to be 0.'
         kc3 = 0
      end if
c**

      if(key.eq.-1) then

c** Forword FFT with mask for output.

         call r3ft_f_mask_for_out(ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                     kc1,kc2,kc3,nbank)

      else if(key.eq.-2) then

c** Forword FFT with mask for input.

         call r3ft_f_mask_for_in (ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                     kc1,kc2,kc3,nbank)

      else if(key.eq.+1) then

c** Backword FFT with mask for input.

         call r3ft_b_mask_for_in (ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                     kc1,kc2,kc3,nbank)

      else if(key.eq.+2) then

c** Backword FFT with mask for output.

         call r3ft_b_mask_for_out(ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                     kc1,kc2,kc3,nbank)

      end if

c**  
 1001 continue

c -------->  CPU cost estimation
      call gettod(t_end)
      tcpu = (t_end - t_start)*UMICRO
      icount = icount + 1
      ecpu = ecpu + tcpu
c <-------
      
      return

      entry jrc_r3strt
      icount = 0
      ecpu = 0.d0
      return
c--------------------------
      entry jrc_r3end
      cpudif = dabs(cpu0ol - ecpu)
      if(ecpu.gt.CRTVL) then
         rcpudf = cpudif/ecpu * 100.0
      else if(cpu0ol.le.CRTVL) then
         rcpudf = 0.0
      else
         rcpudf = 100.0
      endif
c               <-- Ratio in percent of CPU time difference
c                 between previous one and present one.
      cpu0ol = ecpu

c$$$      call eqivvl(rcpudf)

      if(rcpudf.gt.PCPUDF) then
         if(icount.gt.0) then
            tcpu = ecpu/dfloat(icount)
         endif
         write(6,9001) ecpu, icount, tcpu
 9001    format(1H ,' <<CPU TIME for JRCAT_R3FT = ',f11.3
     &        ,'(Sec.) = (',i6,' *',f10.5,')>>')
      endif
      return
      end  

      subroutine r3ft_0(cw1,cw2,cw3,n1,n2,n3)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      complex*16 cw1(0:n1/2-1,2)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

c**
      if(mod(n1,2).ne.0) then
         stop 'The first length is not an even number.'
      end if

         n1h = n1/2

         pai=3.14159265358979323846d0
         pc =2.0d0*pai/dble(n1)
         ci=(0.0d0,1.0d0)

         call setcw(cw1,n1h)
         call setcw(cw2,n2 )
         call setcw(cw3,n3 ) 

      do i=0,n1h-1
         tr=dcos(pc*dble(i))
         ti=dsin(pc*dble(i))
         cw1(i,2)=ci*dcmplx(tr,ti)
      end do   

      return
      end  

      subroutine r3ft_b_mask_for_in(ca,cb,id,n1,n2,n3,cw1,cw2,cw3,
     &                        kc1,kc2,kc3,nbank)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      real*8 ca (2,0:id/2-1,0:n2-1,0:n3-1)
      real*8 cb (0:id/2-1,0:n2-1,0:n3-1,2)
c     complex*16 ca (0:id/2-1,0:n2-1,0:n3-1)
c     complex*16 cb (0:id/2-1,0:n2-1,0:n3-1)

      complex*16 cw1(0:n1/2-1,2)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank
c**
         n1h = n1/2
         idh = id/2

      if(kc1.eq.0) then
           mm1 = n1h+1
c          mm1 = idh
      else
           mm1 = kc1+1
      end if

      if(kc2.eq.0) then
           mm2 = n2
      else
           mm2 = kc2*2+1
      end if

c** Packin from ca(2,0:idh-1,0:n2-1,0:n3-1) to cb(0:mm1-1,0:mm2-1,0:n3-1,2)

      call trans_in_b0(ca,cb,idh,n2,n3,mm1,mm2,kc1,kc2,kc3)

c** Length:n3 CFFT  

      call setlp(n3,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(cb,ca,cw3,n3,mm1*mm2,lp2,lp3,lp4,lp5,lp8)

c** cb(i1,i3,i2,2) <- ca(i1,i2,i3,2)

      call trans_in_b1(ca,cb,mm1,n2,mm2,n3,kc2)

c** Length:n2 CFFT    

      call setlp(n2,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(cb,ca,cw2,n2,mm1*n3,lp2,lp3,lp4,lp5,lp8) 

c** cb(i3,i2,i1,2) <- ca(i1,i3,i2,2)

      call trans_in_b2(ca,cb,mm1,n2,n3,n1h)

c**
      call trans_in_b3(cb,ca,cw1(0,2),n3*n2,n1h,kc1)

c** Length:n1h RCFFT  

      call setlp(n1h,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(ca,cb,cw1,n1h,n3*n2,lp2,lp3,lp4,lp5,lp8)

c** ca(2,i1,i2,i3) <- cb(i3,i2,i1,2)

      call trans_in_b4(cb,ca,n3,n2,idh,n1h)

      return

      end  

      subroutine r3ft_b_mask_for_out(ca,cb,id,n1,n2,n3,
     &                        cw1,cw2,cw3,
     &                        kc1,kc2,kc3,nbank)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      real*8 ca (2,0:id/2-1,0:n2-1,0:n3-1)
      real*8 cb (0:id/2-1,0:n2-1,0:n3-1,2)
c     complex*16 ca (0:id/2-1,0:n2-1,0:n3-1)
c     complex*16 cb (0:id/2-1,0:n2-1,0:n3-1)

      complex*16 cw1(0:n1/2-1,2)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank
c**
         n1h = n1/2
         idh = id/2

c$$$      if(kc1.eq.0) then
c$$$           mm1 = n1h+1 
c$$$      else
c$$$           mm1 = kc1+1
c$$$      end if

      if(kc2.eq.0) then
           mm2 = n2
      else
           mm2 = kc2*2+1
      end if

      if(kc3.eq.0) then
           mm3 = n3
      else
           mm3 = kc3*2+1
      end if

c** cb(i1,i2,i3,2) <- ca(2,i1,i2,i3)

      call trans_out_b0(ca,cb,idh,n2,n3,n1h)

c** Length:n3 CFFT  

      call setlp(n3,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(cb,ca,cw3,n3,(n1h+1)*n2,lp2,lp3,lp4,lp5,lp8)

c** cb(i1,i3,i2,2) <- ca(i1,i2,i3,2)

      call trans_out_b1(ca,cb,n1h,n2,n3,mm3,kc3)

c** Length:n2 CFFT    

      call setlp(n2,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(cb,ca,cw2,n2,(n1h+1)*mm3,lp2,lp3,lp4,lp5,lp8) 

c** cb(i3,i2,i1,2) <- ca(i1,i3,i2,2)

      call trans_out_b2(ca,cb,n1h,n2,mm2,mm3,kc2)

c**
      call trans_out_b3(cb,ca,cw1(0,2),mm3*mm2,n1h)

c** Length:n1h RCFFT  

      call setlp(n1h,lp2,lp3,lp4,lp5,lp8)
      call fsb_lp235(ca,cb,cw1,n1h,mm3*mm2,lp2,lp3,lp4,lp5,lp8)

c** ca(2,i1,i2,i3) <- cb(i3,i2,i1,2)

      call trans_out_b4(cb,ca,idh,n1h,n2,n3,mm2,mm3,kc1,kc2,kc3)

      return

      end  

      subroutine r3ft_f_mask_for_out(ca,cb,id,n1,n2,n3,
     &                        cw1,cw2,cw3,
     &                        kc1,kc2,kc3,nbank)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      real*8 ca (2,0:id/2-1,0:n2-1,0:n3-1)
      real*8 cb (0:id/2-1,0:n2-1,0:n3-1,2)
c     complex*16 ca (0:id/2-1,0:n2-1,0:n3-1)
c     complex*16 cb (0:id/2-1,0:n2-1,0:n3-1)

      complex*16 cw1(0:n1/2-1,2)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank
c**
         n1h = n1/2
         idh = id/2

      if(kc1.eq.0) then
           mm1 = n1h+1
      else
           mm1 = kc1+1
      end if

      if(kc2.eq.0) then
           mm2 = n2
      else
           mm2 = kc2*2+1
      end if
    
c**   cb(i3,i2,i1,2) <- CONJG(ca(2,i1,i2,i3))

         call trans_out_f1(ca,cb,idh,n1h,n2,n3)
 
c** Length:n1h RFFT

      call setlp(n1h,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(cb,ca,cw1,n1h,n3*n2,lp2,lp3,lp4,lp5,lp8)
      
c** Transform from 'n1h' complex to 'n1' real array. 

         call trans_out_f2(ca,cb,cw1(0,2),n3,n2,n1h,kc1) 

c**   ca(i3,k1,i2,2) <- cb(i3,i2,k1,2)

         call trans_out_f3(cb,ca,n3,n2,mm1,n1h)

c** Length:n2 CFFT  

      call setlp(n2,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(ca,cb,cw2,n2,n3*mm1,lp2,lp3,lp4,lp5,lp8)

c**   ca(k1,k2,i3,2) <- cb(i3,k1,k2,2)

            call trans_out_f4(cb,ca,n3,mm1,n2,mm2,kc2)

c** Length:n3 CFFT  

      call setlp(n3,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(ca,cb,cw3,n3,mm1*mm2,lp2,lp3,lp4,lp5,lp8)

c**   ca(2,i1,i2,i3) <- CONJG(cb(i1,i2,i3,2))

         call trans_out_f5(cb,ca,idh,n1h,n2,n3,mm1,mm2,kc1,kc2,kc3)

      return

      end  

      subroutine r3ft_f_mask_for_in(ca,cb,id,n1,n2,n3,cw1,cw2,cw3,
     &                        kc1,kc2,kc3,nbank)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      real*8 ca (2,0:id/2-1,0:n2-1,0:n3-1)
      real*8 cb (0:id/2-1,0:n2-1,0:n3-1,2)

c     complex*16 ca (0:id/2-1,0:n2-1,0:n3-1)
c     complex*16 cb (0:id/2-1,0:n2-1,0:n3-1)

      complex*16 cw1(0:n1/2-1,2)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank
c**
         n1h = n1/2
         idh = id/2

c$$$      if(kc1.eq.0) then
c$$$           mm1 = n1h+1 
c$$$      else
c$$$           mm1 = kc1+1
c$$$      end if

      if(kc2.eq.0) then
           mm2 = n2
      else
           mm2 = kc2*2+1
      end if

      if(kc3.eq.0) then
           mm3 = n3
      else
           mm3 = kc3*2+1
      end if
    
c**   cb(i3,i2,i1,2) <- CONJG(ca(2,i1,i2,i3))

         call trans_in_f1(ca,cb,idh,n1h,n2,n3,mm2,mm3,kc1,kc2,kc3)

c** Length:n1h RFFT

      call setlp(n1h,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(cb,ca,cw1,n1h,mm3*mm2,lp2,lp3,lp4,lp5,lp8)
      
c** Transform from 'n1h' complex to 'n1' real array. 

         call trans_in_f2(ca,cb,cw1(0,2),mm3,mm2,n1h) 

c**   ca(i3,k1,i2,2) <- cb(i3,i2,k1,2)

         call trans_in_f3(cb,ca,mm3,n2,mm2,n1h,kc2)

c** Length:n2 CFFT  

      call setlp(n2,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(ca,cb,cw2,n2,mm3*(n1h+1),lp2,lp3,lp4,lp5,lp8)

c**   ca(k1,k2,i3,2) <- cb(i3,k1,k2,2)

            call trans_in_f4(cb,ca,n1h,n2,n3,mm3,kc3)

c** Length:n3 CFFT  

      call setlp(n3,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(ca,cb,cw3,n3,(n1h+1)*n2,lp2,lp3,lp4,lp5,lp8)

c**   ca(2,i1,i2,i3) <- CONJG(cb(i1,i2,i3,2))

         call trans_in_f5(cb,ca,idh,n1h,n2,n3)

      return

      end  

      subroutine fsb_lp235(ca,cb,cw,n,ndim,lp2,lp3,lp4,lp5,lp8)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
      implicit complex*16(a-h,o-z)

      real*8 ca(ndim*n*2),cb(ndim*n*2)
c     complex*16 ca(ndim,n),cb(ndim,n)

      complex*16 cw(0:n-1)

      k =1
      la=1

c*** RADIX 2 FFT.

      do 2 i=1,lp2
      if(k.eq.1) then
         call fsb_lp2(ca,cb,cw,la,n,ndim)
      else
         call fsb_lp2(cb,ca,cw,la,n,ndim)
      end if
         k=k*(-1)
         la=la*2
    2 continue

c*** RADIX 3 FFT.

      do 3 i=1,lp3
      if(k.eq.1) then
         call fsb_lp3(ca,cb,cw,la,n,ndim)
      else
         call fsb_lp3(cb,ca,cw,la,n,ndim)
      end if
         k=k*(-1)
         la=la*3
    3 continue

c*** RADIX 4 FFT.

      do 4 i=1,lp4
      if(k.eq.1) then
         call fsb_lp4(ca,cb,cw,la,n,ndim)
      else
         call fsb_lp4(cb,ca,cw,la,n,ndim)
      end if
         k=k*(-1)
         la=la*4
    4 continue

c*** RADIX 5 FFT.

      do 5 i=1,lp5
      if(k.eq.1) then
         call fsb_lp5(ca,cb,cw,la,n,ndim)
      else
         call fsb_lp5(cb,ca,cw,la,n,ndim)
      end if
         k=k*(-1)
         la=la*5
    5 continue

c*** RADIX 8 FFT.

      do 8 i=1,lp8
      if(k.eq.1) then
         call fsb_lp8(ca,cb,cw,la,n,ndim)
      else
         call fsb_lp8(cb,ca,cw,la,n,ndim)
      end if
         k=k*(-1)
         la=la*8
    8 continue
c***
      if(k.eq.+1) then

         do 100 ii=1,ndim*n*2
            cb(ii)=ca(ii)
  100    continue

      else

         do 101 ii=1,ndim*n*2
            ca(ii)=cb(ii)
  101    continue

      end if
c**
      return
      end
c---------------------------------------------
      subroutine fsb_lp2(ca,cb,cw,la,n,ndim)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c---------------------------------------------
      implicit real*8(a-h,o-z)

      real*8 ca(ndim,n,2),cb(ndim,n,2),cw(2,0:n-1)

      m=n/2
      np=(m-la)/la

      i1=m
      j1=la
      jump=la  

      do 20 l=1,la
      do 20 ii=1,ndim

         cb(ii,l   ,1)=(ca(ii,l,1)+ca(ii,l+i1,1))
         cb(ii,l   ,2)=(ca(ii,l,2)+ca(ii,l+i1,2))

         cb(ii,l+j1,1)=(ca(ii,l,1)-ca(ii,l+i1,1))
         cb(ii,l+j1,2)=(ca(ii,l,2)-ca(ii,l+i1,2))

   20 continue

      do 21 kp=1,np
      do 21 l=1,la
      do 21 ii=1,ndim

         i0=l+kp*la         
         j0=l+kp*(la+jump)         

         cb(ii,j0   ,1)=(ca(ii,i0,1)+ca(ii,i0+i1,1))
         cb(ii,j0   ,2)=(ca(ii,i0,2)+ca(ii,i0+i1,2))

         cc1r = ca(ii,i0,1)-ca(ii,i0+i1,1)
         cc1i = ca(ii,i0,2)-ca(ii,i0+i1,2)

         cb(ii,j0+j1,1)=cc1r*cw(1,kp*la) - cc1i*cw(2,kp*la)
         cb(ii,j0+j1,2)=cc1r*cw(2,kp*la) + cc1i*cw(1,kp*la)

   21 continue

      return
      end
c---------------------------------------------
      subroutine fsb_lp3(ca,cb,cw,la,n,ndim)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c---------------------------------------------
      implicit real*8(a-h,o-z)  

      real*8 ca(ndim,n,2),cb(ndim,n,2),cw(2,0:n-1)

      real*8 sin60

      m=n/3
      np=(m-la)/la

      i1=m
      i2=m*2 

      j1=la
      j2=la*2

      jump=la*2

      sin60=0.5d0*dsqrt(3.0d0)

c*    k=0 
      do 30 l=1,la
      do 30 ii=1,ndim

         ct1r=ca(ii,l+i1,1)+ca(ii,l+i2,1)
         ct1i=ca(ii,l+i1,2)+ca(ii,l+i2,2)

         ct2r=ca(ii,l   ,1)-0.5d0*ct1r       
         ct2i=ca(ii,l   ,2)-0.5d0*ct1i       

         ct3r= - sin60*(ca(ii,l+i1,2)-ca(ii,l+i2,2))
         ct3i=   sin60*(ca(ii,l+i1,1)-ca(ii,l+i2,1))

         cb(ii,l   ,1)=ca(ii,l,1)+ct1r
         cb(ii,l   ,2)=ca(ii,l,2)+ct1i

         cb(ii,l+j1,1)=(ct2r+ct3r)
         cb(ii,l+j1,2)=(ct2i+ct3i)

         cb(ii,l+j2,1)=(ct2r-ct3r)
         cb(ii,l+j2,2)=(ct2i-ct3i)

   30 continue

      do 31 kp=1,np
      do 31 l=1,la
      do 31 ii=1,ndim

         i0=l+kp*la         
         j0=l+kp*(la+jump)         

         ct1r=ca(ii,i0+i1,1)+ca(ii,i0+i2,1)
         ct1i=ca(ii,i0+i1,2)+ca(ii,i0+i2,2)

         ct2r=ca(ii,i0   ,1)-0.5d0*ct1r       
         ct2i=ca(ii,i0   ,2)-0.5d0*ct1i       

         ct3r= - sin60*(ca(ii,i0+i1,2)-ca(ii,i0+i2,2))
         ct3i=   sin60*(ca(ii,i0+i1,1)-ca(ii,i0+i2,1))

         cb(ii,j0   ,1)=ca(ii,i0,1)+ct1r
         cb(ii,j0   ,2)=ca(ii,i0,2)+ct1i

         ct4r = ct2r + ct3r
         ct4i = ct2i + ct3i

         ct5r = ct2r - ct3r
         ct5i = ct2i - ct3i

         cb(ii,j0+j1,1)=ct4r*cw(1,kp*j1) - ct4i*cw(2,kp*j1)
         cb(ii,j0+j1,2)=ct4r*cw(2,kp*j1) + ct4i*cw(1,kp*j1)

         cb(ii,j0+j2,1)=ct5r*cw(1,kp*j2) - ct5i*cw(2,kp*j2)
         cb(ii,j0+j2,2)=ct5r*cw(2,kp*j2) + ct5i*cw(1,kp*j2)

   31 continue

      return
      end

c---------------------------------------------
      subroutine fsb_lp4(ca,cb,cw,la,n,ndim)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c---------------------------------------------
      implicit real*8(a-h,o-z)

      real*8 ca(ndim,n,2),cb(ndim,n,2),cw(2,0:n-1)

         m   =n/4
         np  =(m-la)/la
         jump=la*3
   
      do 40 l=1,la
      do 40 ii=1,ndim

      cc0r = ca(ii,l  ,1)+ca(ii,l+2*M,1)
      cc0i = ca(ii,l  ,2)+ca(ii,l+2*M,2)

      cc1r = ca(ii,l+M,1)+ca(ii,l+3*M,1)
      cc1i = ca(ii,l+M,2)+ca(ii,l+3*M,2)

      cc2r = ca(ii,l  ,1)-ca(ii,l+2*M,1)
      cc2i = ca(ii,l  ,2)-ca(ii,l+2*M,2)

      cc3r = - ca(ii,l+M,2) + ca(ii,l+3*M,2)
      cc3i =   ca(ii,l+M,1) - ca(ii,l+3*M,1)

         cb(ii,l     ,1)= cc0r+cc1r
         cb(ii,l     ,2)= cc0i+cc1i

         cb(ii,l+  LA,1)= cc2r+cc3r
         cb(ii,l+  LA,2)= cc2i+cc3i

         cb(ii,l+2*LA,1)= cc0r-cc1r
         cb(ii,l+2*LA,2)= cc0i-cc1i

         cb(ii,l+3*LA,1)= cc2r-cc3r
         cb(ii,l+3*LA,2)= cc2i-cc3i

   40 continue
   
      DO 41 KP=1,NP
      DO 41 L=1,LA
      DO 41 ii=1,ndim

         I0=L+KP* LA
         J0=L+KP*(LA+JUMP)

      cc1r =  ca(ii,I0  ,1)+ca(ii,I0+2*M,1)
      cc1i =  ca(ii,I0  ,2)+ca(ii,I0+2*M,2)

      cc2r =  ca(ii,I0+M,1)+ca(ii,I0+3*M,1)
      cc2i =  ca(ii,I0+M,2)+ca(ii,I0+3*M,2)

      cc3r =  ca(ii,I0  ,1)-ca(ii,I0+2*M,1)
      cc3i =  ca(ii,I0  ,2)-ca(ii,I0+2*M,2)

      cc4r = -ca(ii,I0+M,2)+ca(ii,I0+3*M,2)
      cc4i =  ca(ii,I0+M,1)-ca(ii,I0+3*M,1)

         cc5r = cc3r + cc4r
         cc5i = cc3i + cc4i

         cc6r = cc1r - cc2r
         cc6i = cc1i - cc2i

         cc7r = cc3r - cc4r
         cc7i = cc3i - cc4i

         cb(ii,J0     ,1) = cc1r+cc2r
         cb(ii,J0     ,2) = cc1i+cc2i

         cb(ii,J0+  LA,1) = cc5r*cw(1,KP*LA  ) - cc5i*cw(2,KP*LA  )
         cb(ii,J0+  LA,2) = cc5r*cw(2,KP*LA  ) + cc5i*cw(1,KP*LA  )

         cb(ii,J0+2*LA,1) = cc6r*cw(1,KP*LA*2) - cc6i*cw(2,KP*LA*2)
         cb(ii,J0+2*LA,2) = cc6r*cw(2,KP*LA*2) + cc6i*cw(1,KP*LA*2)

         cb(ii,J0+3*LA,1) = cc7r*cw(1,KP*LA*3) - cc7i*cw(2,KP*LA*3)
         cb(ii,J0+3*LA,2) = cc7r*cw(2,KP*LA*3) + cc7i*cw(1,KP*LA*3)

   41 continue
         
      RETURN
      END

c---------------------------------------------
      subroutine fsb_lp5(ca,cb,cw,la,n,ndim)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c---------------------------------------------
      implicit real*8(a-h,o-z)

      real*8 ca(ndim,n,2),cb(ndim,n,2),cw(2,0:n-1)
      real*8 pai,sin36,sin72,r54

      m=n/5
      np  =(m-la)/la

      i1=m
      i2=m*2 
      i3=m*3 
      i4=m*4 

      j1=la
      j2=la*2
      j3=la*3
      j4=la*4

      jump=la*4

      pai  =3.14159265358979323846d0
      sin36=dsin(pai*0.2d0)
      sin72=dsin(pai*0.4d0)
      r54  =dsqrt(5.0d0)/4.0d0

c** k=0
      do 50 l=1,la
      do 50 ii=1,ndim

         ct1r=ca(ii,l+i1,1)+ca(ii,l+i4,1)
         ct1i=ca(ii,l+i1,2)+ca(ii,l+i4,2)

         ct2r=ca(ii,l+i2,1)+ca(ii,l+i3,1)
         ct2i=ca(ii,l+i2,2)+ca(ii,l+i3,2)

         ct3r=ca(ii,l+i1,1)-ca(ii,l+i4,1)
         ct3i=ca(ii,l+i1,2)-ca(ii,l+i4,2)

         ct4r=ca(ii,l+i2,1)-ca(ii,l+i3,1)
         ct4i=ca(ii,l+i2,2)-ca(ii,l+i3,2)

         ct5r=     ct1r+ct2r
         ct5i=     ct1i+ct2i

         ct6r=r54*(ct1r-ct2r)
         ct6i=r54*(ct1i-ct2i)

         ct7r=ca(ii,l   ,1)-0.25d0*ct5r
         ct7i=ca(ii,l   ,2)-0.25d0*ct5i

         ct8r=ct7r+ct6r
         ct8i=ct7i+ct6i

         ct9r=ct7r-ct6r
         ct9i=ct7i-ct6i

         ct10r=-(sin72*ct3i+sin36*ct4i)
         ct10i= (sin72*ct3r+sin36*ct4r)

         ct11r=-(sin36*ct3i-sin72*ct4i)
         ct11i= (sin36*ct3r-sin72*ct4r)

         cb(ii,l   ,1)=ca(ii,l,1)+ct5r
         cb(ii,l   ,2)=ca(ii,l,2)+ct5i

         cb(ii,l+j1,1)=(ct8r+ct10r)
         cb(ii,l+j1,2)=(ct8i+ct10i)

         cb(ii,l+j2,1)=(ct9r+ct11r)
         cb(ii,l+j2,2)=(ct9i+ct11i)

         cb(ii,l+j3,1)=(ct9r-ct11r)
         cb(ii,l+j3,2)=(ct9i-ct11i)

         cb(ii,l+j4,1)=(ct8r-ct10r)
         cb(ii,l+j4,2)=(ct8i-ct10i)

   50 continue

      do 51 kp=1,np
      do 51 l=1,la
      do 51 ii=1,ndim

         I0=L+KP* LA
         J0=L+KP*(LA+JUMP)

         ct1r=ca(ii,i0+i1,1)+ca(ii,i0+i4,1)
         ct1i=ca(ii,i0+i1,2)+ca(ii,i0+i4,2)

         ct2r=ca(ii,i0+i2,1)+ca(ii,i0+i3,1)
         ct2i=ca(ii,i0+i2,2)+ca(ii,i0+i3,2)

         ct3r=ca(ii,i0+i1,1)-ca(ii,i0+i4,1)
         ct3i=ca(ii,i0+i1,2)-ca(ii,i0+i4,2)

         ct4r=ca(ii,i0+i2,1)-ca(ii,i0+i3,1)
         ct4i=ca(ii,i0+i2,2)-ca(ii,i0+i3,2)

         ct5r=     ct1r+ct2r
         ct5i=     ct1i+ct2i

         ct6r=r54*(ct1r-ct2r)
         ct6i=r54*(ct1i-ct2i)

         ct7r=ca(ii,i0  ,1)-0.25d0*ct5r
         ct7i=ca(ii,i0  ,2)-0.25d0*ct5i

         ct8r=ct7r+ct6r
         ct8i=ct7i+ct6i

         ct9r=ct7r-ct6r
         ct9i=ct7i-ct6i

         ct10r=-(sin72*ct3i+sin36*ct4i)
         ct10i= (sin72*ct3r+sin36*ct4r)

         ct11r=-(sin36*ct3i-sin72*ct4i)
         ct11i= (sin36*ct3r-sin72*ct4r)

         ct12r = ct8r + ct10r
         ct12i = ct8i + ct10i

         ct13r = ct9r + ct11r
         ct13i = ct9i + ct11i

         ct14r = ct9r - ct11r
         ct14i = ct9i - ct11i

         ct15r = ct8r - ct10r
         ct15i = ct8i - ct10i

         cb(ii,j0   ,1)=ca(ii,i0,1)+ct5r
         cb(ii,j0   ,2)=ca(ii,i0,2)+ct5i

         cb(ii,j0+j1,1)=ct12r*cw(1,kp*j1)-ct12i*cw(2,kp*j1)
         cb(ii,j0+j1,2)=ct12r*cw(2,kp*j1)+ct12i*cw(1,kp*j1)

         cb(ii,j0+j2,1)=ct13r*cw(1,kp*j2)-ct13i*cw(2,kp*j2)
         cb(ii,j0+j2,2)=ct13r*cw(2,kp*j2)+ct13i*cw(1,kp*j2)

         cb(ii,j0+j3,1)=ct14r*cw(1,kp*j3)-ct14i*cw(2,kp*j3)
         cb(ii,j0+j3,2)=ct14r*cw(2,kp*j3)+ct14i*cw(1,kp*j3)

         cb(ii,j0+j4,1)=ct15r*cw(1,kp*j4)-ct15i*cw(2,kp*j4)
         cb(ii,j0+j4,2)=ct15r*cw(2,kp*j4)+ct15i*cw(1,kp*j4)

   51 continue

      return
      end
c---------------------------------------------
      subroutine fsb_lp8(ca,cb,cw,la,n,ndim)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c---------------------------------------------
      implicit real*8(a-h,o-z)

      real*8 CA(ndim,n,2),CB(ndim,n,2),CW(2,0:n-1)
   
         R2=0.5D0
         X=DSQRT(R2)

         M   =N/8
         NP  =(M-LA)/LA
         JUMP=LA*7

      DO 80 L=1,LA
      DO 80 ii=1,ndim

      CC0r = CA(ii,l    ,1)+CA(ii,l+4*M,1)
      CC0i = CA(ii,l    ,2)+CA(ii,l+4*M,2)

      CC1r = CA(ii,l+  M,1)+CA(ii,l+5*M,1)
      CC1i = CA(ii,l+  M,2)+CA(ii,l+5*M,2)

      CC2r = CA(ii,l+2*M,1)+CA(ii,l+6*M,1)
      CC2i = CA(ii,l+2*M,2)+CA(ii,l+6*M,2)

      CC3r = CA(ii,l+3*M,1)+CA(ii,l+7*M,1)
      CC3i = CA(ii,l+3*M,2)+CA(ii,l+7*M,2)

      CC4r = CA(ii,l    ,1)-CA(ii,l+4*M,1)
      CC4i = CA(ii,l    ,2)-CA(ii,l+4*M,2)

      CC5r = CA(ii,l+  M,1)-CA(ii,l+5*M,1)
      CC5i = CA(ii,l+  M,2)-CA(ii,l+5*M,2)

      CC6r = -CA(ii,l+2*M,2)+CA(ii,l+6*M,2)
      CC6i =  CA(ii,l+2*M,1)-CA(ii,l+6*M,1)

      CC7r = -CA(ii,l+3*M,2)+CA(ii,l+7*M,2)
      CC7i =  CA(ii,l+3*M,1)-CA(ii,l+7*M,1)

         CD0r = CC0r+CC2r
         CD0i = CC0i+CC2i

         CD1r = CC1r+CC3r
         CD1i = CC1i+CC3i

         CD2r = CC4r+CC6r
         CD2i = CC4i+CC6i

            CE1r = CC5r+CC7r
            CE1i = CC5i+CC7i

         CD3r = (CE1r-CE1i)*x
         CD3i = (CE1r+CE1i)*x

         CD4r = CC0r-CC2r
         CD4i = CC0i-CC2i

         CD5r =-(CC1i-CC3i)
         CD5i = (CC1r-CC3r)

         CD6r = CC4r-CC6r
         CD6i = CC4i-CC6i

            CE2r = CC5r-CC7r
            CE2i = CC5i-CC7i

         CD7r = (-CE2r-CE2i)*x
         CD7i = ( CE2r-CE2i)*x

      CB(ii,l     ,1) = CD0r+CD1r
      CB(ii,l     ,2) = CD0i+CD1i

      CB(ii,l+  LA,1) = CD2r+CD3r
      CB(ii,l+  LA,2) = CD2i+CD3i

      CB(ii,l+2*LA,1) = CD4r+CD5r
      CB(ii,l+2*LA,2) = CD4i+CD5i

      CB(ii,l+3*LA,1) = CD6r+CD7r
      CB(ii,l+3*LA,2) = CD6i+CD7i

      CB(ii,l+4*LA,1) = CD0r-CD1r
      CB(ii,l+4*LA,2) = CD0i-CD1i

      CB(ii,l+5*LA,1) = CD2r-CD3r
      CB(ii,l+5*LA,2) = CD2i-CD3i

      CB(ii,l+6*LA,1) = CD4r-CD5r
      CB(ii,l+6*LA,2) = CD4i-CD5i

      CB(ii,l+7*LA,1) = CD6r-CD7r
      CB(ii,l+7*LA,2) = CD6i-CD7i

   80 CONTINUE
   
      DO 81 KP=1,NP
      DO 81 L=1,LA
      DO 81 ii=1,ndim

         I0=L+KP*LA
         J0=L+KP*(LA+JUMP)

      CC0r = CA(ii,I0    ,1)+CA(ii,I0+4*M,1)
      CC0i = CA(ii,I0    ,2)+CA(ii,I0+4*M,2)

      CC1r = CA(ii,I0+  M,1)+CA(ii,I0+5*M,1)
      CC1i = CA(ii,I0+  M,2)+CA(ii,I0+5*M,2)

      CC2r = CA(ii,I0+2*M,1)+CA(ii,I0+6*M,1)
      CC2i = CA(ii,I0+2*M,2)+CA(ii,I0+6*M,2)

      CC3r = CA(ii,I0+3*M,1)+CA(ii,I0+7*M,1)
      CC3i = CA(ii,I0+3*M,2)+CA(ii,I0+7*M,2)

      CC4r = CA(ii,I0    ,1)-CA(ii,I0+4*M,1)
      CC4i = CA(ii,I0    ,2)-CA(ii,I0+4*M,2)

      CC5r = CA(ii,I0+  M,1)-CA(ii,I0+5*M,1)
      CC5i = CA(ii,I0+  M,2)-CA(ii,I0+5*M,2)

      CC6r = -CA(ii,I0+2*M,2)+CA(ii,I0+6*M,2)
      CC6i =  CA(ii,I0+2*M,1)-CA(ii,I0+6*M,1)

      CC7r = -CA(ii,I0+3*M,2)+CA(ii,I0+7*M,2)
      CC7i =  CA(ii,I0+3*M,1)-CA(ii,I0+7*M,1)

         CD0r = CC0r+CC2r
         CD0i = CC0i+CC2i

         CD1r = CC1r+CC3r
         CD1i = CC1i+CC3i

         CD2r = CC4r+CC6r
         CD2i = CC4i+CC6i

            CE1r = CC5r+CC7r
            CE1i = CC5i+CC7i

         CD3r = (CE1r-CE1i)*x
         CD3i = (CE1r+CE1i)*x

         CD4r = CC0r-CC2r
         CD4i = CC0i-CC2i

         CD5r =-(CC1i-CC3i)
         CD5i = (CC1r-CC3r)

         CD6r = CC4r-CC6r
         CD6i = CC4i-CC6i

            CE2r = CC5r-CC7r
            CE2i = CC5i-CC7i

         CD7r = (-CE2r-CE2i)*x
         CD7i = ( CE2r-CE2i)*x

      CF1r = CD2r+CD3r
      CF1i = CD2i+CD3i

      CF2r = CD4r+CD5r
      CF2i = CD4i+CD5i

      CF3r = CD6r+CD7r
      CF3i = CD6i+CD7i

      CF4r = CD0r-CD1r
      CF4i = CD0i-CD1i

      CF5r = CD2r-CD3r
      CF5i = CD2i-CD3i

      CF6r = CD4r-CD5r
      CF6i = CD4i-CD5i

      CF7r = CD6r-CD7r
      CF7i = CD6i-CD7i

      CB(ii,J0     ,1) = CD0r+CD1r
      CB(ii,J0     ,2) = CD0i+CD1i

      CB(ii,J0+  LA,1) = CF1r*CW(1,KP*LA  )-CF1i*CW(2,KP*LA  )
      CB(ii,J0+  LA,2) = CF1r*CW(2,KP*LA  )+CF1i*CW(1,KP*LA  )

      CB(ii,J0+2*LA,1) = CF2r*CW(1,KP*LA*2)-CF2i*CW(2,KP*LA*2)
      CB(ii,J0+2*LA,2) = CF2r*CW(2,KP*LA*2)+CF2i*CW(1,KP*LA*2)

      CB(ii,J0+3*LA,1) = CF3r*CW(1,KP*LA*3)-CF3i*CW(2,KP*LA*3)
      CB(ii,J0+3*LA,2) = CF3r*CW(2,KP*LA*3)+CF3i*CW(1,KP*LA*3)

      CB(ii,J0+4*LA,1) = CF4r*CW(1,KP*LA*4)-CF4i*CW(2,KP*LA*4)
      CB(ii,J0+4*LA,2) = CF4r*CW(2,KP*LA*4)+CF4i*CW(1,KP*LA*4)

      CB(ii,J0+5*LA,1) = CF5r*CW(1,KP*LA*5)-CF5i*CW(2,KP*LA*5)
      CB(ii,J0+5*LA,2) = CF5r*CW(2,KP*LA*5)+CF5i*CW(1,KP*LA*5)

      CB(ii,J0+6*LA,1) = CF6r*CW(1,KP*LA*6)-CF6i*CW(2,KP*LA*6)
      CB(ii,J0+6*LA,2) = CF6r*CW(2,KP*LA*6)+CF6i*CW(1,KP*LA*6)

      CB(ii,J0+7*LA,1) = CF7r*CW(1,KP*LA*7)-CF7i*CW(2,KP*LA*7)
      CB(ii,J0+7*LA,2) = CF7r*CW(2,KP*LA*7)+CF7i*CW(1,KP*LA*7)

   81 CONTINUE
C**
      RETURN
      END
      subroutine setcw(cw,n)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      complex*16 cw(0:n-1)

      pai=3.14159265358979323846d0
      pc =2.0d0*pai/dble(n)

      do 10 i=0,n-1
         tr=dcos(pc*dble(i))
         ti=dsin(pc*dble(i))
         cw(i)=dcmplx(tr,ti)
   10 continue

      return
      end
      subroutine setlp(n,lp2,lp3,lp4,lp5,lp8)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
      implicit real*8(a-b,d-h,o-z)

         nn =n

         lp8=0
         lp5=0
         lp4=0
         lp3=0
         lp2=0

      do while(mod(nn,8).eq.0)
         lp8=lp8+1
         nn=nn/8
      end do

      do while(mod(nn,5).eq.0)
         lp5=lp5+1
         nn=nn/5
      end do

      do while(mod(nn,4).eq.0)
         lp4=lp4+1
         nn=nn/4
      end do

      do while(mod(nn,3).eq.0)
         lp3=lp3+1
         nn=nn/3
      end do

      do while(mod(nn,2).eq.0)
         lp2=lp2+1
         nn=nn/2
      end do

c     if(lp8+lp4+lp2.eq.0) stop 'n is not an even number.'
      if(nn.ne.1) stop 'n is an improper number.'

      return
      end
      subroutine trans_in_b0(ca,cb,idh,n2,n3,mm1,mm2,kc1,kc2,kc3)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(2,0:idh-1,0:n2-1 ,0:n3-1)
      real*8 cb(0:mm1-1,0:mm2-1,0:n3-1,2)

c     complex*16 ca(0:idh-1,0:n2-1 ,0:n3-1)
c     complex*16 cb(0:mm1-1,0:mm2-1,0:n3-1)
c*
      if(kc1.eq.0) then
         kk1 = mm1-1
      else
         kk1 = kc1
      end if 

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if 

c*
c* Packing from ca to cb
  
      do 10 i3=0,n3-1
      do 10 i2=0,kk2
      do 10 i1=0,kk1

         cb(i1,i2,i3,1) = ca(1,i1,i2,i3) 
         cb(i1,i2,i3,2) = ca(2,i1,i2,i3) 

  10  continue

      if(kc2.ne.0) then

         nskip2 = kc2*2+1-n2

         do 20 i3=0,n3-1
         do 20 i2=n2-kc2,n2-1
         do 20 i1=0,kk1

            cb(i1,i2+nskip2,i3,1) = ca(1,i1,i2,i3) 
            cb(i1,i2+nskip2,i3,2) = ca(2,i1,i2,i3) 

  20     continue

      end if
c*
      if(kc3.ne.0) then

         do 30 i3=kc3+1,n3-kc3-1
         do 30 i2=0,mm2-1
         do 30 i1=0,mm1-1

            cb(i1,i2,i3,1) = 0.0d0
            cb(i1,i2,i3,2) = 0.0d0

  30     continue

      end if
       
c*
      return
      end
      subroutine trans_in_b1(ca,cb,mm1,n2,mm2,n3,kc2)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)
      real*8 ca(0:mm1-1,0:mm2-1,0:n3-1,2)
      real*8 cb(0:mm1-1,0:n3-1 ,0:n2-1,2)

c     complex*16 ca(0:mm1-1,0:mm2-1,0:n3-1)
c     complex*16 cb(0:mm1-1,0:n3-1 ,0:n2-1)

c*
      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if

c*
      do 10 i3=0,n3-1
      do 10 i2=0,kk2
      do 10 i1=0,mm1-1

         cb(i1,i3,i2,1) = ca(i1,i2,i3,1)
         cb(i1,i3,i2,2) = ca(i1,i2,i3,2)

  10  continue

c*
      if(kc2.ne.0) then

         do 20 i2=kc2+1,n2-kc2-1
         do 20 i3=0,n3-1
         do 20 i1=0,mm1-1

            cb(i1,i3,i2,1) = 0.0d0 
            cb(i1,i3,i2,2) = 0.0d0 

  20     continue

         nstep2 = kc2*2-n2+1

         do 30 i3=0,n3-1
         do 30 i2=n2-kc2,n2-1
         do 30 i1=0,mm1-1

            cb(i1,i3,i2,1) = ca(i1,i2+nstep2,i3,1)
            cb(i1,i3,i2,2) = ca(i1,i2+nstep2,i3,2)

  30     continue

      end if
c*

      return
      end
      subroutine trans_in_b2(ca,cb,mm1,n2,n3,n1h)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(0:mm1-1  ,0:n3*n2-1 ,2)
      real*8 cb(0:n3*n2-1,0:n1h     ,2)

c     real*8 cb(0:n3*n2-1,0:mm1-1   ,2)
c     complex*16 ca(0:mm1-1  ,0:n3*n2-1 )
c     complex*16 cb(0:n3*n2-1,0:mm1-1   )

         do 10 i2 = 0,n3*n2-1
         do 10 i1 = 0,mm1-1

            cb(i2,i1,1) = ca(i1,i2,1)
            cb(i2,i1,2) = ca(i1,i2,2)

 10      continue

c*
         do 20 i1 = mm1,n1h
         do 20 i2 = 0,n3*n2-1

            cb(i2,i1,1) = 0.0d0
            cb(i2,i1,2) = 0.0d0

 20      continue

c*

      return
      end 
      subroutine trans_in_b3(cb,ca,cw1,nn,n1h,kc1)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 cb(nn,0:n1h  ,2)
      real*8 ca(nn,0:n1h-1,2)

c     complex*16 cb(nn,0:idh-1)
c     complex*16 ca(nn,0:idh-1)

      real*8 cw1(2,0:n1h-1)
c     complex*16 cw1(0:n1h-1)

      real*8 r0,r1
      real*8 rr0,rr1,ri0,ri1

c*
      do 10 ii=1,nn

         r0 = cb(ii,  0,1)
         r1 = cb(ii,n1h,1)

c        r0 = dble(cb(ii,  0))
c        r1 = dble(cb(ii,n1h))

         ca(ii,0,1)= r0 + r1 
         ca(ii,0,2)= r0 - r1 

c        ca(ii,0)=dcmplx( r0 + r1 , r0 - r1 )

  10  continue

      do 20 k1=1,n1h-1
      do 20 ii=1,nn

         rr0 = cb(ii,k1,1)
         ri0 = cb(ii,k1,2)

         rr1 = cb(ii,n1h-k1,1)
         ri1 = cb(ii,n1h-k1,2)

c        rr2 = rr0 + rr1 
c        ri2 = ri0 - ri1 

         rr3 = rr0 - rr1 
         ri3 = ri0 + ri1 

         ca(ii,k1,1) = rr0 + rr1 + rr3*cw1(1,k1) - ri3*cw1(2,k1)
         ca(ii,k1,2) = ri0 - ri1 + rr3*cw1(2,k1) + ri3*cw1(1,k1)

c        ca(ii,k1)=   cb(ii,k1)+dconjg(cb(ii,n1h-k1))
c    &             + (cb(ii,k1)-dconjg(cb(ii,n1h-k1)))*cw1(k1) 

  20  continue 

      return
      end 
      subroutine trans_in_b4(cb,ca,n3,n2,idh,n1h) 
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

c**
      implicit real*8(a-h,o-z)

      real*8 cb(0:n3-1 ,0:n2-1,0:n1h-1,2)
      real*8 ca(2,0:idh-1,0:n2-1,0:n3-1 )

c     complex*16 cb(0:n3-1 ,0:n2-1,0:idh-1)
c     complex*16 ca(0:idh-1,0:n2-1,0:n3-1 )
c**
         do 10 i1=0,n1h-1
         do 10 i2=0,n2-1
         do 10 i3=0,n3-1

            ca(1,i1,i2,i3) = cb(i3,i2,i1,1)
            ca(2,i1,i2,i3) = cb(i3,i2,i1,2)

  10     continue

         do 20 i3=0,n3-1
         do 20 i2=0,n2-1
         do 20 i1=n1h,idh-1

            ca(1,i1,i2,i3) = 0.0d0
            ca(2,i1,i2,i3) = 0.0d0

  20     continue

c**
      return
      end
      subroutine trans_in_f1(ca,cb,idh,n1h,n2,n3,
     &                       mm2,mm3,kc1,kc2,kc3)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(2,0:idh-1,0:n2-1,0:n3-1)
      real*8 cb(0:mm3-1,0:mm2-1,0:n1h-1,2)

c***
      if(kc1.eq.0) then
         kk1 = n1h-1
      else
         kk1 = kc1
      end if

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if

      if(kc3.eq.0) then
         kk3 = n3-1
      else
         kk3 = kc3
      end if
c**

         do 10 i3=0,kk3
         do 10 i2=0,kk2
         do 10 i1=0,kk1

            cb(i3,i2,i1,1) =   ca(1,i1,i2,i3) 
            cb(i3,i2,i1,2) = - ca(2,i1,i2,i3) 

   10    continue

c**
      if(kc2.ne.0) then

         do 20 i3=0,kk3
         do 20 i2=n2-kc2,n2-1
         do 20 i1=0,kk1

            ii2 = i2 + mm2 - n2
            cb(i3,ii2,i1,1) =   ca(1,i1,i2,i3) 
            cb(i3,ii2,i1,2) = - ca(2,i1,i2,i3) 

   20    continue
  
      end if
c**
      if(kc3.ne.0) then

         do 30 i3=n3-kc3,n3-1
         do 30 i2=0,kk2
         do 30 i1=0,kk1

            ii3 = i3 + mm3 - n3
            cb(ii3,i2,i1,1) =   ca(1,i1,i2,i3) 
            cb(ii3,i2,i1,2) = - ca(2,i1,i2,i3) 

   30    continue

      end if
c**
      if(kc2.ne.0.and.kc3.ne.0) then

         do 40 i3=n3-kc3,n3-1
         do 40 i2=n2-kc2,n2-1
         do 40 i1=0,kk1

            ii2 = i2 + mm2 - n2
            ii3 = i3 + mm3 - n3
            cb(ii3,ii2,i1,1) =   ca(1,i1,i2,i3) 
            cb(ii3,ii2,i1,2) = - ca(2,i1,i2,i3) 

   40    continue

      end if
c**
         do 50 i1=kk1+1,n1h-1
         do 50 i2=0,mm2-1
         do 50 i3=0,mm3-1

            cb(i3,i2,i1,1) = 0.0d0
            cb(i3,i2,i1,2) = 0.0d0

   50    continue
c**

      return
      end
      subroutine trans_in_f2(ca,cb,cw1,mm3,mm2,n1h)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8 (a-h,o-z)

      real*8 ca(mm3*mm2,0:n1h-1,2)
      real*8 cb(mm3*mm2,0:n1h  ,2)
      real*8 cw1(2,0:n1h-1)

c     complex*16 ca(mm3*mm2,0:n1h)
c     complex*16 cb(mm3*mm2,0:n1h)
c     complex*16 cw1(0:n1h-1)

      real*8 rr,ri
c**
      do i32 = 1,mm3*mm2

         rr = ca(i32,0,1)
         ri = ca(i32,0,2)

c        rr = dble (ca(i32,0))
c        ri = dimag(ca(i32,0))
       
         cb(i32,0  ,1) = rr-ri
         cb(i32,n1h,1) = rr+ri

         cb(i32,0  ,2) = 0.0d0 
         cb(i32,n1h,2) = 0.0d0 

c        cb(i32,0  )=dcmplx(rr-ri,0.0d0)
c        cb(i32,n1h)=dcmplx(rr+ri,0.0d0)

      end do
c**   
      do k1  = 1,n1h-1
      do ii = 1,mm3*mm2

         rr0 = ca(ii,k1,1)
         ri0 = ca(ii,k1,2)

         rr1 = ca(ii,n1h-k1,1)
         ri1 = ca(ii,n1h-k1,2)

c        rr2 = rr0 + rr1
c        ri2 = ri0 - ri1

         rr3 = rr0 - rr1
         ri3 = ri0 + ri1

         cb(ii,k1,1) = (rr0 + rr1 + rr3*cw1(1,k1) - ri3*cw1(2,k1))*0.5d0
         cb(ii,k1,2) = (ri0 - ri1 + rr3*cw1(2,k1) + ri3*cw1(1,k1))*0.5d0


c     cb(i32,k1) = ( ca(i32,k1)+dconjg(ca(i32,n1h-k1))
c    &            +( ca(i32,k1)-dconjg(ca(i32,n1h-k1)) )*cw1(k1))
c    &            * 0.5d0

      end do
      end do

      return
      end
      subroutine trans_in_f3(cb,ca,mm3,n2,mm2,n1h,kc2)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(0:mm3-1,0:n1h,0:n2-1,2)
      real*8 cb(0:mm3-1,0:mm2-1,0:n1h,2)
c     complex*16 ca(0:mm3-1,0:idh-1,0:n2-1)
c     complex*16 cb(0:mm3-1,0:mm2-1,0:idh-1)

c***********************************************
c**   transpose between 2nd axis and 3rd axis.
c***********************************************

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2 
      end if

      do 10 i1=0,n1h
      do 10 i2=0,kk2
      do 10 i3=0,mm3-1

         ca(i3,i1,i2,1) = cb(i3,i2,i1,1)
         ca(i3,i1,i2,2) = cb(i3,i2,i1,2)

  10  continue  

c**
      if(kc2.ne.0) then

         do 30 ii2=kk2+1,n2-kc2-1
         do 30 i1=0,n1h
         do 30 i3=0,mm3-1

            ca(i3,i1,ii2,1) = 0.0d0
            ca(i3,i1,ii2,2) = 0.0d0

  30     continue  

         do 20 i1=0,n1h
         do 20 i2=kk2+1,mm2-1
         do 20 i3=0,mm3-1

            ii2 = i2 + n2 - mm2
            ca(i3,i1,ii2,1) = cb(i3,i2,i1,1)
            ca(i3,i1,ii2,2) = cb(i3,i2,i1,2)

  20     continue  

      end if
c**
      return
      end
      subroutine trans_in_f4(cb,ca,n1h,n2,n3,mm3,kc3)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca((n1h+1)*n2 ,0:n3-1,2)
      real*8 cb(0:mm3-1,(n1h+1)*n2,2)
c     complex*16 ca(0:idh-1,0:n2-1 ,0:n3-1)
c     complex*16 cb(0:mm3-1,0:idh-1,0:n2-1)

c*
      if(kc3.eq.0) then
         kk3 = n3 - 1
      else
         kk3 = kc3
      end if

c     do 10 i2 =0,n2-1  
      do 10 i12 =1,(n1h+1)*n2
      do 10 i3 =0,kk3
      
         ca(i12,i3,1) = cb(i3,i12,1)
         ca(i12,i3,2) = cb(i3,i12,2)

  10  continue

c**
      if(kc3.ne.0) then

         do 20 ii3 = kk3+1,n3-kc3-1
c        do 20 i2 = 0,n2-1
         do 20 i12 =1,(n1h+1)*n2
      
            ca(i12,ii3,1) = 0.0d0
            ca(i12,ii3,2) = 0.0d0

  20     continue

c        do 30 i2 = 0,n2-1
         do 30 i12 =1,(n1h+1)*n2
         do 30 i3 = kk3+1,mm3-1
      
            ii3 = i3 + n3 - mm3 
            ca(i12,ii3,1) = cb(i3,i12,1)
            ca(i12,ii3,2) = cb(i3,i12,2)

  30     continue

      end if
c**
      return
      end


      subroutine trans_in_f5(cb,ca,idh,n1h,n2,n3)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(2,0:idh-1,0:n2*n3-1)
      real*8 cb(  0:n1h  ,0:n2*n3-1,2)
c     complex*16 ca(0:idh-1,0:n2-1,0:n3-1)
c     complex*16 cb(0:idh-1,0:n2-1,0:n3-1)
c*
      do 10 i23=0,n2*n3-1 
      do 10 i1=0,n1h 

         ca(1,i1,i23) =   cb(i1,i23,1)
         ca(2,i1,i23) = - cb(i1,i23,2)
c        ca(i1,i2,i3) = dconjg(cb(i1,i2,i3))

  10  continue                        

      do 20 i1=n1h+1,idh-1 
      do 20 i23=0,n2*n3-1 

         ca(1,i1,i23) = 0.0d0
         ca(2,i1,i23) = 0.0d0 

  20  continue                        

c*

      return
      end
      subroutine trans_out_b0(ca,cb,idh,n2,n3,n1h)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(2,0:idh-1,n2*n3)
      real*8 cb(0:n1h,n2*n3,2)

c     complex*16 ca(0:idh*n2*n3-1)
c     complex*16 cb(0:idh*n2*n3-1)
c*
  
      do 10 ii=1,n2*n3
      do 10  i=0,n1h   

         cb(i,ii,1) = ca(1,i,ii) 
         cb(i,ii,2) = ca(2,i,ii) 

  10  continue

c*
      return
      end
      subroutine trans_out_b1(ca,cb,n1h,n2,n3,mm3,kc3)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      real*8 ca(0:n1h,0:n2-1  ,0:n3-1,2)
      real*8 cb(0:n1h,0:mm3-1 ,0:n2-1,2)

c     complex*16 ca(0:idh-1,0:n2-1  ,0:n3-1)
c     complex*16 cb(0:idh-1,0:mm3-1 ,0:n2-1)

c*
      if(kc3.eq.0) then
         kk3 = n3-1
      else
         kk3 = kc3
      end if

c*
      do 10 i3=0,kk3
      do 10 i2=0,n2-1
      do 10 i1=0,n1h  

         cb(i1,i3,i2,1) = ca(i1,i2,i3,1)
         cb(i1,i3,i2,2) = ca(i1,i2,i3,2)

  10  continue

c*
      if(kc3.ne.0) then

         do 30 i3=n3-kc3,n3-1
         do 30 i2=0,n2-1
         do 30 i1=0,n1h   

            ii3 = i3 + mm3 - n3
            cb(i1,ii3,i2,1) = ca(i1,i2,i3,1)
            cb(i1,ii3,i2,2) = ca(i1,i2,i3,2)

  30     continue

      end if
c*

      return
      end
      subroutine trans_out_b2(ca,cb,n1h,n2,mm2,mm3,kc2)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)
      real*8 ca(0:n1h,0:mm3-1,0:n2-1 ,2)
      real*8 cb(0:mm3-1,0:mm2-1,0:n1h,2)

c     complex*16 ca(0:idh-1,0:mm3-1,0:n2-1 )
c     complex*16 cb(0:mm3-1,0:mm2-1,0:idh-1)

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2 
      end if

         do 10 i2 = 0,kk2
         do 10 i3 = 0,mm3-1
         do 10 i1 = 0,n1h   

            cb(i3,i2,i1,1) = ca(i1,i3,i2,1)
            cb(i3,i2,i1,2) = ca(i1,i3,i2,2)

 10      continue

      if(kc2.ne.0) then

         do 20 i2 = n2-kc2,n2-1
         do 20 i3 = 0,mm3-1
         do 20 i1 = 0,n1h   

            ii2 = i2 + mm2 - n2
            cb(i3,ii2,i1,1) = ca(i1,i3,i2,1)
            cb(i3,ii2,i1,2) = ca(i1,i3,i2,2)

 20      continue

      end if

      return
      end
      subroutine trans_out_b3(cb,ca,cw1,nn,n1h)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 cb(nn,0:n1h  ,2)
      real*8 ca(nn,0:n1h-1,2)
      real*8 cw1(2,0:n1h-1)

c     complex*16 cb(nn,0:n1h)
c     complex*16 ca(nn,0:n1h-1)
c     complex*16 cw1(0:n1h-1)

      real*8 r0,r1

c**
      do 10 ii=1,nn

         r0 = cb(ii,  0,1)
         r1 = cb(ii,n1h,1)

c        r0 = dble(cb(ii,  0))
c        r1 = dble(cb(ii,n1h))

         ca(ii,0,1)= r0 + r1 
         ca(ii,0,2)= r0 - r1 

c        ca(ii,0)=dcmplx( r0 + r1 , r0 - r1 )

  10  continue

      do 20 k1=1,n1h-1
      do 20 ii=1,nn

         rr0 = cb(ii,k1,1)
         ri0 = cb(ii,k1,2)

         rr1 = cb(ii,n1h-k1,1)
         ri1 = cb(ii,n1h-k1,2)

c        rr2 = rr0 + rr1
c        ri2 = ri0 - ri1

         rr3 = rr0 - rr1
         ri3 = ri0 + ri1

         ca(ii,k1,1) = rr0 + rr1 + rr3*cw1(1,k1) - ri3*cw1(2,k1)
         ca(ii,k1,2) = ri0 - ri1 + rr3*cw1(2,k1) + ri3*cw1(1,k1)

c        ca(ii,k1)=   cb(ii,k1)+dconjg(cb(ii,n1h-k1))
c    &             + (cb(ii,k1)-dconjg(cb(ii,n1h-k1)))*cw1(k1) 

  20  continue 

      return
      end 
      subroutine trans_out_b4(cb,ca,idh,n1h,n2,n3,mm2,mm3,
     &                        kc1,kc2,kc3) 
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c**
      implicit real*8(a-h,o-z)

      real*8 cb(0:mm3-1 ,0:mm2-1,0:n1h-1,2)
      real*8 ca(2,0:idh-1 ,0:n2-1 ,0:n3-1 )

c     complex*16 cb(0:mm3-1 ,0:mm2-1,0:idh-1)
c     complex*16 ca(0:idh-1 ,0:n2-1 ,0:n3-1 )
c**
      if(kc1.eq.0) then
         kk1 = n1h-1
      else
         kk1 = kc1
      end if

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if

      if(kc3.eq.0) then
         kk3 = n3-1
      else
         kk3 = kc3
      end if
c**
      do 100 i3 = 0,n3-1
      do 100 i2 = 0,n2-1
      do 100 i1 = 0,idh-1

         ca(1,i1,i2,i3) = 0.0d0
         ca(2,i1,i2,i3) = 0.0d0

 100  continue

c**
      do 10 i1=0,kk1
      do 10 i2=0,kk2
      do 10 i3=0,kk3

         ca(1,i1,i2,i3) = cb(i3,i2,i1,1)
         ca(2,i1,i2,i3) = cb(i3,i2,i1,2)

  10  continue
c**
      if(kc2.ne.0) then

         do 20 i1=0,kk1
         do 20 i2=kc2+1,kc2+kc2
         do 20 i3=0,kk3

            ii2 = i2 + n2-1-kc2*2
            ca(1,i1,ii2,i3) = cb(i3,i2,i1,1)
            ca(2,i1,ii2,i3) = cb(i3,i2,i1,2)

  20     continue

      end if
c**
      if(kc3.ne.0) then

         do 30 i1=0,kk1
         do 30 i2=0,kk2
         do 30 i3=kc3+1,kc3+kc3

            ii3 = i3 + n3-1-kc3*2
            ca(1,i1,i2,ii3) = cb(i3,i2,i1,1)
            ca(2,i1,i2,ii3) = cb(i3,i2,i1,2)

  30     continue

      end if
c**
      if(kc2.ne.0.and.kc3.ne.0) then

         do 40 i1=0,kk1
         do 40 i2=kc2+1,kc2+kc2
         do 40 i3=kc3+1,kc3+kc3

            ii2 = i2 + n2-1-kc2*2
            ii3 = i3 + n3-1-kc3*2
            ca(1,i1,ii2,ii3) = cb(i3,i2,i1,1)
            ca(2,i1,ii2,ii3) = cb(i3,i2,i1,2)

  40     continue

      end if

c**
      return
      end  
      subroutine trans_out_f1(ca,cb,idh,n1h,n2,n3)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(2,0:idh-1,0:n2-1,0:n3-1)
      real*8 cb(0:n3-1 ,0:n2-1,0:n1h-1,2)

c     complex*16 ca(0:m1-1,0:m2-1,0:m3-1),cb(0:m3-1,0:m2-1,0:m1-1)

c***
         do 10 i3=0,n3-1
         do 10 i2=0,n2-1
         do 10 i1=0,n1h-1

            cb(i3,i2,i1,1) =   ca(1,i1,i2,i3) 
            cb(i3,i2,i1,2) = - ca(2,i1,i2,i3) 

   10    continue

      return
      end
      subroutine trans_out_f2(ca,cb,cw1,n3,n2,n1h,kc1)
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(n3*n2,0:n1h-1,2)
      real*8 cb(n3*n2,0:n1h  ,2)
      real*8 cw1(2,0:n1h-1)
      real*8 rr,ri
c**
      do i32 = 1,n3*n2

         rr = ca(i32,0,1)
         ri = ca(i32,0,2)
c        rr = dble (ca(i32,0))
c        ri = dimag(ca(i32,0))

         cb(i32,0  ,1) = rr-ri
         cb(i32,n1h,1) = rr+ri

         cb(i32,0  ,2) = 0.0d0
         cb(i32,n1h,2) = 0.0d0

c        rr = dble (ca(i32,0))
c        ri = dimag(ca(i32,0))
       
c        cb(i32,0  )=dcmplx(rr-ri,0.0d0)
c        cb(i32,n1h)=dcmplx(rr+ri,0.0d0)

      end do
c**   
      if(kc1.eq.0) then
         mm = n1h-1
      else
         mm = kc1
      end if
c**
      do k1  = 1,mm
      do ii = 1,n3*n2

         rr0 = ca(ii,k1,1)
         ri0 = ca(ii,k1,2)

         rr1 = ca(ii,n1h-k1,1)
         ri1 = ca(ii,n1h-k1,2)

         rr2 = rr0 + rr1
         ri2 = ri0 - ri1

         rr3 = rr0 - rr1
         ri3 = ri0 + ri1

         cb(ii,k1,1) = ( rr2 + rr3*cw1(1,k1) - ri3*cw1(2,k1) )*0.5d0
         cb(ii,k1,2) = ( ri2 + rr3*cw1(2,k1) + ri3*cw1(1,k1) )*0.5d0

c     cb(i32,k1) = ( ca(i32,k1)+dconjg(ca(i32,n1h-k1))
c    &            +( ca(i32,k1)-dconjg(ca(i32,n1h-k1)) )*cw1(k1))
c    &            * 0.5d0

      end do
      end do

      return
      end
      subroutine trans_out_f3(cb,ca,n3,n2,mm1,n1h)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)
      real*8 ca(n3,0:mm1-1,n2,2)
      real*8 cb(n3,n2,0:n1h,2)

c***********************************************
c**   transpose between 2nd axis and 3rd axis.
c***********************************************

      do 10 i1=0,mm1-1
      do 10 i2=1,n2
      do 10 i3=1,n3

         ca(i3,i1,i2,1) = cb(i3,i2,i1,1)
         ca(i3,i1,i2,2) = cb(i3,i2,i1,2)

  10  continue  

      return
      end
      subroutine trans_out_f4(cb,ca,n3,mm1,n2,mm2,kc2)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)
      real*8 ca(0:mm1-1,0:mm2-1, 0:n3-1,2)
      real*8 cb(0:n3-1 ,0:mm1-1, 0:n2-1,2)

c*
      if(kc2.eq.0) then
         kk2 = n2 - 1
      else
         kk2 = kc2
      end if

      do 10 i2 =0,kk2  
      do 10 i1 =0,mm1-1
      do 10 i3 =0,n3-1
      
         ca(i1,i2,i3,1) = cb(i3,i1,i2,1)
         ca(i1,i2,i3,2) = cb(i3,i1,i2,2)

  10  continue

c*
      if(kc2.ne.0) then

         do 20 i2 = -kc2,-1
         do 20 i1 =    0,mm1-1
         do 20 i3 =    0,n3-1
      
            ii2 = i2 + kc2*2 + 1 
            ca(i1,ii2,i3,1) = cb(i3,i1,i2+n2,1)
            ca(i1,ii2,i3,2) = cb(i3,i1,i2+n2,2)

  20     continue

      end if

c*
      return
      end
      subroutine trans_out_f5(cb,ca,idh,n1h,n2,n3,mm1,mm2,kc1,kc2,kc3)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)
      real*8 ca(2,0:idh-1,0:n2-1 ,0:n3-1 )
      real*8 cb(0:mm1-1,0:mm2-1,0:n3-1 ,2)
c*
      if(kc1.eq.0) then
           kk1 = n1h
      else
           kk1 = kc1
      end if

      if(kc2.eq.0) then
           kk2 = n2-1
      else
           kk2 = kc2
      end if

      if(kc3.eq.0) then
           kk3 = n3-1
      else
           kk3 = kc3
      end if
c*

      do 100 i3=0,n3-1 
      do 100 i2=0,n2-1 
      do 100 i1=0,idh-1 

         ca(1,i1,i2,i3) = 0.0d0
 100     ca(2,i1,i2,i3) = 0.0d0

c*

      do 10 i3=0,kk3 
      do 10 i2=0,kk2 
      do 10 i1=0,kk1 

         ca(1,i1,i2,i3) =    cb(i1,i2,i3,1)
         ca(2,i1,i2,i3) =  - cb(i1,i2,i3,2)

  10  continue 

      if(kc2.ne.0) then

         nskip2 = n2-1-kc2*2

         do 11 i3=0,kk3 
         do 11 i2=kc2+1,kc2*2 
         do 11 i1=0,kk1 

            ca(1,i1,i2+nskip2,i3) =   cb(i1,i2,i3,1)
            ca(2,i1,i2+nskip2,i3) = - cb(i1,i2,i3,2)

  11     continue 

      end if

c******************************
      if(kc3.ne.0) then
c******************************

      do 20 i3=n3-kc3,n3-1 
      do 20 i2=0,kk2 
      do 20 i1=0,kk1 

         ca(1,i1,i2,i3) =   cb(i1,i2,i3,1)
         ca(2,i1,i2,i3) = - cb(i1,i2,i3,2)

  20  continue 

      if(kc2.ne.0) then

         nskip2 = n2-1-kc2*2

         do 21 i3=n3-kc3,n3-1 
         do 21 i2=kc2+1,kc2*2 
         do 21 i1=0,kk1 

            ca(1,i1,i2+nskip2,i3) =   cb(i1,i2,i3,1)
            ca(2,i1,i2+nskip2,i3) = - cb(i1,i2,i3,2)

  21     continue 

      end if

c******************************
      end if
c******************************

      return
      end
      subroutine jrcat_c3ft(ca,cwork,id,n1,n2,n3,cw1,cw2,cw3,
     &                      kc1,kc2,kc3,key)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

c********************************************************************************
c*    3 dimensional complex to complex FFT with mask
c*    either for input array or output array,
c*    developed by T.Sanada (sanada@think.com) on 1996.01.04.
c*    It is specified for Fujitsu VPP500.
c********************************************************************************

      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

c------------------>      for Estimation of CPU cost.
c                             by T.Yamasaki
c                               22th May. 1996
      real*8 CRTVL, PCPUDF
      parameter (CRTVL = 1.d-5, PCPUDF = 2.0)
c        CRTVL : CRItical VaLue for Division.
c        PCPUDF: Percent of CPU DiFference.
      real*8 cpu0ol,cpudif,rcpudf,ecpu,tcpu
      integer icount
      data icount/0/
      data ecpu/0.d0/
      data cpu0ol/0.d0/
      real*8 t_start, t_end, UMICRO
      parameter (UMICRO = 1.d-6)
c <-------------------------------------------

      complex*16 ca    (id,n2,n3)
      complex*16 cwork (id,n2,n3)

      complex*16 cw1(0:n1-1)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank

c********************************************************************************
c*   key = 0 : set up of FFT.
c*             ( Calculation of cw1,cw2 and cw3. )
c********************************************************************************
c*   n1,n2 and n3 must include radix 2, and they may include 3 or 5.
c*   id must be n1 + 2.
c*
c********************************************************************************
c*  key = -1 & -2 : F.T. of complex 3d array ca(0:n1-1,0:n2-1,0:n3-1) .
c********************************************************************************
c*
c*   The result(complex 'cb') is overwritten on 'ca'.
c*   
c*     cb(k1,k2,k3) 
c*   = sum(ix=0:n1-1,iy=0:n2-1,iz=0:n3-1) 
c*     ca(i1,i2,i3) exp [- 2 * pai * ci * ( k1*i1/n1 + k2*i2/n2 + k3*i3/n3 ) ]
c*     
c*     where 0 <= k1 <= n1/2, 0 <= k2 <= n2-1, 0 <= k3 <= n3-1.
c*
c********************************************************************************
c*  key = +1 & +2: Inverse F.T. of copmplex 3d array cb(0:n1/2,0:n2-1,0:n3-1) .
c********************************************************************************
c*   Transform from 'cb' to 'ra'.
c*
c********************************************************************************
c*  kc1,kc2 kc3 are integer parameters specifying the mask for
c*  input data or output data.
c*
c*     If kc1.ge.n1/2.or.kc1.lt.0, then kc1 is forced to be 0. 
c*     If kc2.ge.n2/2.or.kc2.lt.0, then kc2 is forced to be 0. 
c*     If kc3.ge.n3/2.or.kc3.lt.0, then kc3 is forced to be 0. 
c*
c********************************************************************************
c** REMARK on Mask.
c********************************************************************************
c*
c*  key = -1 : Mask is for Output data ( cb ),
c*  key = +1 : Mask is for Input  data ( cb ),
c*  key = -2 : Mask is for Input  data ( ca ),
c*  key = +2 : Mask is for Output data ( ca ),
c*
c*     where ca(0:idh/2,0:n2-1,0:n3-1) and equivalence(ra,ca).
c*
c********************************************************************************
c*     Mask for Output data:
c********************************************************************************
c*
c*     If kc1.eq.0.and.kc2.eq.0.and.kc3.eq.0, then the full wavenumber
c*     range is calculated.
c*
c*     If kc1.ne.0, then only "0 <= k1 <= kc1" range is calculated.
c*
c*     If kc2.ne.0, then only "0 <= k2 <= kc2" and "n2-kc2 <= k2 <= n2-1" 
c*     range is calculated.
c*
c*     If kc3.ne.0, then only "0 <= k3 <= kc3" and "n3-kc3 <= k3 <= n3-1" 
c*     range is calculated.
c*
c********************************************************************************
c*     Mask for Input data:
c********************************************************************************
c*
c*     If kc1.eq.0.and.kc2.eq.0.and.kc3.eq.0, then the full wavenumber
c*     range is used to obtain real array 'ra'.
c*
c*     If kc1.ne.0, then only "0 <= k1 <= kc1" range is used.
c*
c*     If kc2.ne.0, then only "0 <= k2 <= kc2" and "n2-kc2 <= k2 <= n2-1" 
c*     range is used.
c*
c*     If kc3.ne.0, then only "0 <= k3 <= kc3" and "n3-kc3 <= k3 <= n3-1" 
c*     range is used.
c*
c********************************************************************************
c*
c******************************************************************
c**   choose nbank = 0 or nbank = 1 
c******************************************************************
c*   nbank = 0:
c*      The transpose is normally implemented.
c*      Bank conflict may appear patriculary in Vector Computers.
c*   nbank = 1:
c*      The transpose is implemented so as to prevent
c*      the bank conflict in the case the conflict may appear.
c******************************************************************
c
      call gettod(t_start)

      nbank = 0

c**

      if(key.eq.0) then

c** set up of FFT.

         call c3ft_0(cw1,cw2,cw3,n1,n2,n3)

         goto 1001
c$$$         return

      end if

c**
      if(kc1.ge.n1/2.or.kc1.lt.0) then 
         write(6,*) 'warning in FFT: kc1 is irrelevant.'
         write(6,*) 'kc1 has changed to be 0.'
         kc1 = 0
      end if

      if(kc2.ge.n2/2.or.kc2.lt.0) then 
         write(6,*) 'warning in FFT: kc2 is irrelevant.'
         write(6,*) 'kc2 has changed to be 0.'
         kc2 = 0
      end if

      if(kc3.ge.n3/2.or.kc3.lt.0) then 
         write(6,*) 'warning in FFT: kc3 is irrelevant.'
         write(6,*) 'kc3 has changed to be 0.'
         kc3 = 0
      end if

c******************************************
      if(key.eq.-1.or.key.eq.+2) then
c******************************************

c** Forword  FFT with mask for output.
c** Backword FFT with mask for output.

         call c3ft_mask_for_out(ca,cwork,id,n1,n2,n3,cw1,cw2,cw3,
     &                     kc1,kc2,kc3,nbank,key)

c******************************************
      else 
c******************************************

c** Forword  FFT with mask for input.
c** Backword FFT with mask for input.

         call c3ft_mask_for_in (ca,cwork,id,n1,n2,n3,cw1,cw2,cw3,
     &                     kc1,kc2,kc3,nbank,key)


c******************************************
      end if
c******************************************

 1001 continue

c -------->  CPU cost estimation
      call gettod(t_end)
      tcpu = (t_end - t_start)*UMICRO
      icount = icount + 1
      ecpu = ecpu + tcpu
c <-------

      return
      entry jrc_c3strt
      icount = 0
      ecpu = 0.d0
      return
c--------------------------
      entry jrc_c3end
      cpudif = dabs(cpu0ol - ecpu)
      if(ecpu.gt.CRTVL) then
         rcpudf = cpudif/ecpu * 100.0
      else if(cpu0ol.le.CRTVL) then
         rcpudf = 0.0
      else
         rcpudf = 100.0
      endif
c               <-- Ratio in percent of CPU time difference
c                 between previous one and present one.
      cpu0ol = ecpu

c$$$      call eqivvl(rcpudf)

      if(rcpudf.gt.PCPUDF) then
         if(icount.gt.0) then
            tcpu = ecpu/dfloat(icount)
         endif
         write(6,9001) ecpu, icount, tcpu
 9001    format(1H ,' <<CPU TIME for JRCAT_C3FT = ',f11.3
     &        ,'(Sec.) = (',i6,' *',f10.5,')>>')
      endif
      return
      end  

      subroutine c3ft_0(cw1,cw2,cw3,n1,n2,n3)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      complex*16 cw1(0:n1-1)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

c**
         call setcw(cw1,n1)
         call setcw(cw2,n2)
         call setcw(cw3,n3) 

      return
      end  

      subroutine c3ft_mask_for_in(ca,cb,id,n1,n2,n3,cw1,cw2,cw3,
     &                            kc1,kc2,kc3,nbank,key)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      real*8 ca (0:id-1,0:n2-1,0:n3-1,2)
      real*8 cb (0:id-1,0:n2-1,0:n3-1,2)

c     complex*16 ca (0:id-1,0:n2-1,0:n3-1)
c     complex*16 cb (0:id-1,0:n2-1,0:n3-1)

      complex*16 cw1(0:n1-1)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank
c**
      if(kc1.eq.0) then
           mm1 = n1
      else
           mm1 = kc1*2+1
      end if

      if(kc2.eq.0) then
           mm2 = n2
      else
           mm2 = kc2*2+1
      end if

c$$$      if(kc3.eq.0) then
c$$$           mm3 = n3
c$$$      else
c$$$           mm3 = kc3*2+1
c$$$      end if

c** Packin from ca(2,0:id-1,0:n2-1,0:n3-1) to cb(0:mm1-1,0:mm2-1,0:n3-1,2)

      call trans_in_c0(ca,cb,id,n1,n2,n3,mm1,mm2,kc1,kc2,kc3,key)

c** Length:n3 CFFT  

      call setlp(n3,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(cb,ca,cw3,n3,mm1*mm2,lp2,lp3,lp4,lp5,lp8)

c** cb(i1,i3,i2,2) <- ca(i1,i2,i3,2)

      call trans_in_c1(ca,cb,mm1,n2,mm2,n3,kc2)

c** Length:n2 CFFT    

      call setlp(n2,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(cb,ca,cw2,n2,mm1*n3,lp2,lp3,lp4,lp5,lp8) 

c** cb(i3,i2,i1,2) <- ca(i1,i3,i2,2)

      call trans_in_c2(ca,cb,n1,mm1,n2,n3,kc1)

c** Length:n1 CFFT  

      call setlp(n1,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(cb,ca,cw1,n1,n3*n2,lp2,lp3,lp4,lp5,lp8)

c** cb(2,i1,i2,i3) <- ca(i3,i2,i1,2)

      call trans_in_c3(ca,cb,n3,n2,n1,id,key)

c** ca(2,i1,i2,i3) <- cb(2,i1,i2,i3)

      call trans_in_c4(cb,ca,id,n2,n3)   

      return

      end  

      subroutine c3ft_mask_for_out(ca,cb,id,n1,n2,n3,
     &                        cw1,cw2,cw3,
     &                        kc1,kc2,kc3,nbank,key)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c**
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      real*8 ca (0:id-1,0:n2-1,0:n3-1,2)
      real*8 cb (0:id-1,0:n2-1,0:n3-1,2)

c     complex*16 ca (0:id-1,0:n2-1,0:n3-1)
c     complex*16 cb (0:id-1,0:n2-1,0:n3-1)

      complex*16 cw1(0:n1-1)
      complex*16 cw2(0:n2-1)
      complex*16 cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer nbank

c$$$      if(kc1.eq.0) then
c$$$           mm1 = n1
c$$$      else
c$$$           mm1 = kc1*2+1
c$$$      end if

      if(kc2.eq.0) then
           mm2 = n2
      else
           mm2 = kc2*2+1
      end if

      if(kc3.eq.0) then
           mm3 = n3
      else
           mm3 = kc3*2+1
      end if

c** cb(i1,i2,i3,2) <- ca(2,i1,i2,i3)

      call trans_out_c0(ca,cb,id,n1,n2,n3,key)

c** Length:n3 CFFT  

      call setlp(n3,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(cb,ca,cw3,n3,n1*n2,lp2,lp3,lp4,lp5,lp8)

c** cb(i1,i3,i2,2) <- ca(i1,i2,i3,2)

      call trans_out_c1(ca,cb,n1,n2,n3,mm3,kc3)

c** Length:n2 CFFT    

      call setlp(n2,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(cb,ca,cw2,n2,n1*mm3,lp2,lp3,lp4,lp5,lp8) 

c** cb(i3,i2,i1,2) <- ca(i1,i3,i2,2)

      call trans_out_c2(ca,cb,n1,n2,mm2,mm3,kc2)

c** Length:n1 CFFT  

      call setlp(n1,lp2,lp3,lp4,lp5,lp8)

      call fsb_lp235(cb,ca,cw1,n1,mm3*mm2,lp2,lp3,lp4,lp5,lp8)

c** cb(2,i1,i2,i3) <- ca(i3,i2,i1,2)

      call trans_out_c3(ca,cb,id,n1,n2,n3,mm2,mm3,kc1,kc2,kc3,key)

c** ca(2,i1,i2,i3) <- cb(2,i1,i2,i3)

      call trans_out_c4(cb,ca,id,n2,n3)

      return
      end
      subroutine trans_in_c0(ca,cb,id,n1,n2,n3,mm1,mm2,kc1,kc2,kc3,key)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(2,0:id-1 ,0:n2-1 ,0:n3-1)
      real*8 cb(0:mm1-1,0:mm2-1,0:n3-1,2)

      real*8 parity
c*
      if(kc1.eq.0) then
         kk1 = n1-1
      else
         kk1 = kc1
      end if

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if

      if(kc3.eq.0) then
         kk3 = n3-1
      else
         kk3 = kc3
      end if
c*
      if(key.eq.+1.or.key.eq.+2) then
         parity = +1.0d0
      else
         parity = -1.0d0
      end if

c*
      do 10 i3=0,n3-1
      do 10 i2=0,mm2-1
      do 10 i1=0,mm1-1

         cb(i1,i2,i3,1)=0.0d0
         cb(i1,i2,i3,2)=0.0d0

 10   continue
c*
      do 20 i3=0,kk3
      do 20 i2=0,kk2
      do 20 i1=0,kk1

         cb(i1,i2,i3,1) = ca(1,i1,i2,i3)
         cb(i1,i2,i3,2) = ca(2,i1,i2,i3) * parity

 20   continue

      if(kc1.ne.0) then

         do 30 i3=0,kk3
         do 30 i2=0,kk2
         do 30 i1=n1-kc1,n1-1
     
            ii1 = i1 + mm1 - n1
            cb(ii1,i2,i3,1) = ca(1,i1,i2,i3)
            cb(ii1,i2,i3,2) = ca(2,i1,i2,i3) * parity

 30      continue

      end if

      if(kc2.ne.0) then

         do 40 i3=0,kk3
         do 40 i2=n2-kc2,n2-1
         do 40 i1=0,kk1
     
            ii2 = i2 + mm2 - n2
            cb(i1,ii2,i3,1) = ca(1,i1,i2,i3)
            cb(i1,ii2,i3,2) = ca(2,i1,i2,i3) * parity

 40      continue

      end if

      if(kc3.ne.0) then

         do 50 i3=n3-kc3,n3-1
         do 50 i2=0,kk2
         do 50 i1=0,kk1
     
            ii3 = i3 
            cb(i1,i2,ii3,1) = ca(1,i1,i2,i3)
            cb(i1,i2,ii3,2) = ca(2,i1,i2,i3) * parity

 50      continue

      end if

      if(kc1.ne.0.and.kc2.ne.0) then

         do 60 i3=0,kk3
         do 60 i2=n2-kc2,n2-1
         do 60 i1=n1-kc1,n1-1
     
            ii1 = i1 + mm1 - n1
            ii2 = i2 + mm2 - n2
            cb(ii1,ii2,i3,1) = ca(1,i1,i2,i3)
            cb(ii1,ii2,i3,2) = ca(2,i1,i2,i3) * parity

 60      continue

      end if

      if(kc1.ne.0.and.kc3.ne.0) then

         do 70 i3=n3-kc3,n3-1
         do 70 i2=0,kk2
         do 70 i1=n1-kc1,n1-1
     
            ii1 = i1 + mm1 - n1
            ii3 = i3 
            cb(ii1,i2,ii3,1) = ca(1,i1,i2,i3)
            cb(ii1,i2,ii3,2) = ca(2,i1,i2,i3) * parity

 70      continue

      end if

      if(kc2.ne.0.and.kc3.ne.0) then

         do 80 i3=n3-kc3,n3-1
         do 80 i2=n2-kc2,n2-1
         do 80 i1=0,kk1
     
            ii2 = i2 + mm2 - n2
            ii3 = i3 
            cb(i1,ii2,ii3,1) = ca(1,i1,i2,i3)
            cb(i1,ii2,ii3,2) = ca(2,i1,i2,i3) * parity

 80      continue

      end if

      if(kc1.ne.0.and.kc2.ne.0.and.kc3.ne.0) then

         do 90 i3=n3-kc3,n3-1
         do 90 i2=n2-kc2,n2-1
         do 90 i1=n1-kc1,n1-1
     
            ii1 = i1 + mm1 - n1
            ii2 = i2 + mm2 - n2
            ii3 = i3 
            cb(ii1,ii2,ii3,1) = ca(1,i1,i2,i3)
            cb(ii1,ii2,ii3,2) = ca(2,i1,i2,i3) * parity

 90      continue

      end if

      return
      end
      subroutine trans_in_c1(ca,cb,mm1,n2,mm2,n3,kc2)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(0:mm1-1,0:mm2-1,0:n3-1,2)
      real*8 cb(0:mm1-1,0:n3-1 ,0:n2-1,2)

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if

      do 10 i3=0,n3-1
      do 10 i2=0,kk2
      do 10 i1=0,mm1-1

         cb(i1,i3,i2,1) = ca(i1,i2,i3,1)
         cb(i1,i3,i2,2) = ca(i1,i2,i3,2)

  10  continue

      if(kc2.ne.0) then

         do 20 i2=kk2+1,n2-kc2-1
         do 20 i3=0,n3-1
         do 20 i1=0,mm1-1

            cb(i1,i3,i2,1) = 0.0d0
            cb(i1,i3,i2,2) = 0.0d0

  20     continue

         do 30 i2=n2-kc2,n2-1
         do 30 i3=0,n3-1
         do 30 i1=0,mm1-1

            ii2 = i2 + mm2 - n2
            cb(i1,i3,i2,1) = ca(i1,ii2,i3,1)
            cb(i1,i3,i2,2) = ca(i1,ii2,i3,2)

  30     continue

      end if

      return
      end
      subroutine trans_in_c2(ca,cb,n1,mm1,n2,n3,kc1)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(0:mm1-1  ,0:n3*n2-1,2)
      real*8 cb(0:n3*n2-1,0:n1-1   ,2)

      if(kc1.eq.0) then
         kk1 = n1-1
      else
         kk1 = kc1
      end if

c**
      do 10 i1 = 0,kk1
      do 10 i32 = 0,n3*n2-1

         cb(i32,i1,1) = ca(i1,i32,1)
         cb(i32,i1,2) = ca(i1,i32,2)

  10  continue

      if(kc1.ne.0) then

         do 20 i1 = kk1+1,n1-kc1-1
         do 20 i32 = 0,n3*n2-1

            cb(i32,i1,1) = 0.0d0
            cb(i32,i1,2) = 0.0d0

  20     continue

         do 30 i1 = n1-kc1,n1-1
         do 30 i32 = 0,n3*n2-1

            ii1 = i1 + mm1 - n1
            cb(i32,i1,1) = ca(ii1,i32,1)
            cb(i32,i1,2) = ca(ii1,i32,2)

  30     continue

      end if

      return
      end
      subroutine trans_in_c3(ca,cb,n3,n2,n1,id,key)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(0:n3-1,0:n2-1,0:n1-1,2)
      real*8 cb(2,0:id-1,0:n2-1,0:n3-1)

      real*8 parity
c*
      if(key.eq.+1.or.key.eq.+2) then
         parity = +1.0d0
      else
         parity = -1.0d0
      end if
c*
      do 10 i3=0,n3-1
      do 10 i2=0,n2-1
      do 10 i1=n1,id-1

         cb(1,i1,i2,i3) = 0.0d0
         cb(2,i1,i2,i3) = 0.0d0

  10  continue

      do 20 i1=0,n1-1
      do 20 i2=0,n2-1
      do 20 i3=0,n3-1

         cb(1,i1,i2,i3) = ca(i3,i2,i1,1)
         cb(2,i1,i2,i3) = ca(i3,i2,i1,2) * parity

  20  continue

      return
      end

      subroutine trans_in_c4(cb,ca,id,n2,n3)   
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 cb(id*n2*n3*2)
      real*8 ca(id*n2*n3*2)

      do 10 ii=1,id*n2*n3*2

         ca(ii) = cb(ii)

 10   continue

      return
      end
      subroutine trans_out_c0(ca,cb,id,n1,n2,n3,key)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(2,id,n2*n3)
      real*8 cb(n1,n2*n3,2)

      real*8 parity
c*
      if(key.eq.+1.or.key.eq.+2) then
         parity = +1.0d0
      else
         parity = -1.0d0
      end if
c*
      do 10 i23=1,n2*n3
      do 10 i1=1,n1

         cb(i1,i23,1) = ca(1,i1,i23)
         cb(i1,i23,2) = ca(2,i1,i23) * parity

 10   continue

      return
      end 
      subroutine trans_out_c1(ca,cb,n1,n2,n3,mm3,kc3)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(0:n1-1,0:n2-1 ,0:n3-1,2)
      real*8 cb(0:n1-1,0:mm3-1,0:n2-1,2)

      if(kc3.eq.0) then
         kk3 = n3-1
      else
         kk3 = kc3  
      end if

      do 10 i3=0,kk3
      do 10 i2=0,n2-1
      do 10 i1=0,n1-1

         cb(i1,i3,i2,1) = ca(i1,i2,i3,1)
         cb(i1,i3,i2,2) = ca(i1,i2,i3,2)

 10   continue

      if(kc3.ne.0) then

         do 20 i3=n3-kc3,n3-1
         do 20 i2=0,n2-1
         do 20 i1=0,n1-1

            ii3 = i3 + mm3 - n3
            cb(i1,ii3,i2,1) = ca(i1,i2,i3,1)
            cb(i1,ii3,i2,2) = ca(i1,i2,i3,2)

 20      continue

      end if

      return
      end
      subroutine trans_out_c2(ca,cb,n1,n2,mm2,mm3,kc2)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(0:n1-1 ,0:mm3-1,0:n2-1,2)
      real*8 cb(0:mm3-1,0:mm2-1,0:n1-1,2)

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if

      do 10 i2 = 0,kk2
      do 10 i3 = 0,mm3-1
      do 10 i1 = 0,n1-1
   
         cb(i3,i2,i1,1) = ca(i1,i3,i2,1)
         cb(i3,i2,i1,2) = ca(i1,i3,i2,2)

  10  continue

      if(kc2.ne.0) then

      do 20 i2 = n2-kc2,n2-1
      do 20 i3 = 0,mm3-1
      do 20 i1 = 0,n1-1
   
         ii2 = i2 + mm2 - n2
         cb(i3,ii2,i1,1) = ca(i1,i3,i2,1)
         cb(i3,ii2,i1,2) = ca(i1,i3,i2,2)

  20  continue

      end if

      return
      end
      subroutine trans_out_c3(ca,cb,id,n1,n2,n3,mm2,mm3,kc1,kc2,kc3,key)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(0:mm3-1,0:mm2-1,0:n1-1,2)
      real*8 cb(2,0:id-1 ,0:n2-1 ,0:n3-1)

      real*8 parity
c*
      if(key.eq.+1.or.key.eq.+2) then
         parity = +1.0d0
      else
         parity = -1.0d0
      end if
c*

      do 1 i3=0,n3-1
      do 1 i2=0,n2-1
      do 1 i1=0,id-1

         cb(1,i1,i2,i3) = 0.0d0
         cb(2,i1,i2,i3) = 0.0d0

  1   continue

      if(kc1.eq.0) then
         kk1 = n1-1
      else
         kk1 = kc1
      end if

      if(kc2.eq.0) then
         kk2 = n2-1
      else
         kk2 = kc2
      end if

      if(kc3.eq.0) then
         kk3 = n3-1
      else
         kk3 = kc3
      end if

      do 10 i1 = 0,kk1
      do 10 i3 = 0,kk3
      do 10 i2 = 0,kk2

         cb(1,i1,i2,i3) = ca(i3,i2,i1,1)
         cb(2,i1,i2,i3) = ca(i3,i2,i1,2) * parity

  10  continue

      if(kc1.ne.0) then

      do 20 i1 = n1-kc1,n1-1
      do 20 i3 = 0,kk3
      do 20 i2 = 0,kk2

         ii1 = i1
         cb(1,i1,i2,i3) = ca(i3,i2,ii1,1)
         cb(2,i1,i2,i3) = ca(i3,i2,ii1,2) * parity

  20  continue

      end if

      if(kc2.ne.0) then

      do 30 i1 = 0,kk1
      do 30 i3 = 0,kk3
      do 30 i2 = n2-kc2,n2-1

         ii2 = i2 + mm2 - n2
         cb(1,i1,i2,i3) = ca(i3,ii2,i1,1)
         cb(2,i1,i2,i3) = ca(i3,ii2,i1,2) * parity

  30  continue

      end if

      if(kc3.ne.0) then

      do 40 i1 = 0,kk1
      do 40 i3 = n3-kc3,n3-1
      do 40 i2 = 0,kk2

         ii3 = i3 + mm3 - n3
         cb(1,i1,i2,i3) = ca(ii3,i2,i1,1)
         cb(2,i1,i2,i3) = ca(ii3,i2,i1,2) * parity

  40  continue

      end if

      if(kc1.ne.0.and.kc2.ne.0) then

      do 50 i1 = n1-kc1,n1-1
      do 50 i3 = 0,kk3
      do 50 i2 = n2-kc2,n2-1

         ii1 = i1
         ii2 = i2 + mm2 - n2
         cb(1,i1,i2,i3) = ca(i3,ii2,ii1,1)
         cb(2,i1,i2,i3) = ca(i3,ii2,ii1,2) * parity

  50  continue

      end if

      if(kc1.ne.0.and.kc3.ne.0) then

      do 60 i1 = n1-kc1,n1-1
      do 60 i3 = n3-kc3,n3-1
      do 60 i2 = 0,kk2

         ii1 = i1
         ii3 = i3 + mm3 - n3
         cb(1,i1,i2,i3) = ca(ii3,i2,ii1,1)
         cb(2,i1,i2,i3) = ca(ii3,i2,ii1,2) * parity

  60  continue

      end if

      if(kc2.ne.0.and.kc3.ne.0) then

      do 70 i1 = 0,kk1
      do 70 i3 = n3-kc3,n3-1
      do 70 i2 = n2-kc2,n2-1

         ii2 = i2 + mm2 - n2
         ii3 = i3 + mm3 - n3
         cb(1,i1,i2,i3) = ca(ii3,ii2,i1,1)
         cb(2,i1,i2,i3) = ca(ii3,ii2,i1,2) * parity

  70  continue

      end if

      if(kc1.ne.0.and.kc2.ne.0.and.kc3.ne.0) then

      do 80 i1 = n1-kc1,n1-1
      do 80 i3 = n3-kc3,n3-1
      do 80 i2 = n2-kc2,n2-1

         ii1 = i1
         ii2 = i2 + mm2 - n2
         ii3 = i3 + mm3 - n3
         cb(1,i1,i2,i3) = ca(ii3,ii2,ii1,1)
         cb(2,i1,i2,i3) = ca(ii3,ii2,ii1,2) * parity

  80  continue

      end if

      return
      end
      subroutine trans_out_c4(cb,ca,id,n2,n3)
! $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $

      implicit real*8(a-h,o-z)

      real*8 ca(id*n2*n3*2)
      real*8 cb(id*n2*n3*2)

c*
      do 10 ii=1,id*n2*n3*2

         ca(ii) = cb(ii)

 10   continue

      return
      end
#else
!
c $Id: jrcat_fft.F 376 2014-06-17 07:48:31Z jkoga $
c---------------------------------------------
      subroutine jrcat_c3ft(ca,cwork,id,n1,n2,n3,cw1,cw2,cw3,
     &                      kc1,kc2,kc3,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
c
c------------------>      for Estimation of CPU cost.
c                             by T.Yamasaki
c                               22th May. 1996
      real*8 CRTVL, PCPUDF
      parameter (CRTVL = 1.d-5, PCPUDF = 2.0)
c        CRTVL : CRItical VaLue for Division.
c        PCPUDF: Percent of CPU DiFference.
      real*8 cpu0ol,cpudif,rcpudf,ecpu,tcpu
      integer icount
      data icount/0/
      data ecpu/0.d0/
      data cpu0ol/0.d0/
      real*8 t_start, t_end, UMICRO
      parameter (UMICRO = 1.d-6)
c <-------------------------------------------
      dimension ca    (id,n2,n3)
      dimension cwork (id+n2+n3,2)

      dimension cw1(0:n1-1)
      dimension cw2(0:n2-1)
      dimension cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer key

c*******************************************************************************
c*  3 DIMENSIONAL FAST FOURIER TRANSFORM OF COMPLEX ARRAY WITH MASK,
c*                developed on 1997.6.5.
c*                modified  on 1998.5.18.
c*******************************************************************************
c*  
c*  The 3-dimensional array ca(id,n2,n3) is fourier-transfomed and
c*  its result is overwritten on ca. The size of fourier-transformed is
c*  (n1,n2,n3) and hence id must be larger than or equal to n1.
c*  Also n1,n2 and n3 must be radix 2,3,5 integers.
c*
c*  cwork is complex work array and the size must be at least (id+n2+n3)*2
c*
c*******************************************************************************
c*  How to set the value of key.
c*
c*(1) key = 0       : set up of FFT 
c*    
c*     Calculations of cw1,cw2 and cw3.
c*
c*(2) key = -1 & -2 : 
c*
c*     Forward F.T. of complex 3d array ca(0:id-1,0:n2-1,0:n3-1),
c*
c*     here the definition of fourier-transform is
c*  
c*       cb(k1,k2,k3) 
c*     = sum(i1=0:n1-1,i2=0:n2-1,i3=0:n3-1) 
c*       ca(i1,i2,i3) exp [- 2 * pai * ci * ( k1*i1/n1 + k2*i2/n2 + k3*i3/n3 ) ]
c*     
c*        where 0 <= k1 <= n1-1, 0 <= k2 <= n2-1, 0 <= k3 <= n3-1,
c*              and ci is the imaginary unit.
c*
c*    The result(complex array cb(0:id-1,0:n2-1,0:n3-1)) is overwritten on 'ca'.
c*
c*(3) key = +1 & +2 : 
c*
c*     Inverse F.T. of complex 3d array cb(0:id-1,0:n2-1,0:n3-1) 
c*                   to ca(0:id-1,0:n2-1,0:n3-1).
c*
c*******************************************************************************
c*  How to set the mask.
c*
c*  kc1,kc2,kc3 and key are integer parameters specifying the mask for
c*  input data or output data.
c*
c*     key = -1 : Mask is for Output data ( cb ),
c*     key = +1 : Mask is for Input  data ( cb ),
c*     key = -2 : Mask is for Input  data ( ca ),
c*     key = +2 : Mask is for Output data ( ca ),
c*
c*     If kc1.ge.n1/2.or.kc1.lt.0, then kc1 is forced to be 0. 
c*     If kc2.ge.n2/2.or.kc2.lt.0, then kc2 is forced to be 0. 
c*     If kc3.ge.n3/2.or.kc3.lt.0, then kc3 is forced to be 0. 
c*
c*     where ca(0:id-1,0:n2-1,0:n3-1) is equivalent to cb.
c*
c*******************************************************************************
c*  Mask for Output data:
c*
c*     If kc1.eq.0.and.kc2.eq.0.and.kc3.eq.0, then the full 
c*     range is calculated.
c*
c*     If kc1.ne.0, then only "0 <= k1 <= kc1" and "n1-kc1 <= k1 <= n1-1" 
c*     range is calculated.
c*
c*     If kc2.ne.0, then only "0 <= k2 <= kc2" and "n2-kc2 <= k2 <= n2-1" 
c*     range is calculated.
c*
c*     If kc3.ne.0, then only "0 <= k3 <= kc3" and "n3-kc3 <= k3 <= n3-1" 
c*     range is calculated.
c*
c*******************************************************************************
c*  Mask for Input data:
c*
c*     If kc1.eq.0.and.kc2.eq.0.and.kc3.eq.0, then the full 
c*     range is used to obtain complex array 'ca'.
c*
c*     If kc1.ne.0, then only "0 <= k1 <= kc1" and "n1-kc1 <= k1 <= n1-1" 
c*     range is calculated.
c*
c*     If kc2.ne.0, then only "0 <= k2 <= kc2" and "n2-kc2 <= k2 <= n2-1" 
c*     range is used.
c*
c*     If kc3.ne.0, then only "0 <= k3 <= kc3" and "n3-kc3 <= k3 <= n3-1" 
c*     range is used.
c*
c*******************************************************************************
c
      call gettod(t_start)

c** Set up of FFT.
      if(key.eq.0) then
         call c3ft_0(cw1,cw2,cw3,n1,n2,n3)
         return
      end if
c**
      if(kc1.ge.n1/2.or.kc1.lt.0) then 
         write(6,*) 'warning in JRCAT_C3FT: kc1 is irrelevant.'
         write(6,*) 'kc1 has changed to be 0.'
         kc1 = 0
      end if
c*
      if(kc2.ge.n2/2.or.kc2.lt.0) then 
         write(6,*) 'warning in JRCAT_C3FT: kc2 is irrelevant.'
         write(6,*) 'kc2 has changed to be 0.'
         kc2 = 0
      end if
c*
      if(kc3.ge.n3/2.or.kc3.lt.0) then 
         write(6,*) 'warning in JRCAT_C3FT: kc3 is irrelevant.'
         write(6,*) 'kc3 has changed to be 0.'
         kc3 = 0
      end if
c**
      if(key.eq.-1.or.key.eq.-2) then
         call c3ft_conj(cw1,n1)
         call c3ft_conj(cw2,n2)
         call c3ft_conj(cw3,n3)
      end if
c********************************************************************
      if(key.eq.-1.or.key.eq.+2) then
c********************************************************************
c*  Forword or Backword FFT with mask for output.

         call c3ft_mask_for_out(ca,cwork,id,n1,n2,n3,cw1,cw2,cw3,
     &                     kc1,kc2,kc3,key)

c********************************************************************
      else 
c********************************************************************
c*  Forword or Backword FFT with mask for input.

         call c3ft_mask_for_in (ca,cwork,id,n1,n2,n3,cw1,cw2,cw3,
     &                     kc1,kc2,kc3,key)

c********************************************************************
      end if
c********************************************************************
      if(key.eq.-1.or.key.eq.-2) then
         call c3ft_conj(cw1,n1)
         call c3ft_conj(cw2,n2)
         call c3ft_conj(cw3,n3)
      end if
c**  
c -------->  CPU cost estimation
      call gettod(t_end)
      tcpu = (t_end - t_start)*UMICRO
      icount = icount + 1
      ecpu = ecpu + tcpu
c <-------

      return
      entry jrc_c3strt
      icount = 0
      ecpu = 0.d0
      return
c--------------------------
      entry jrc_c3end
      cpudif = dabs(cpu0ol - ecpu)
      if(ecpu.gt.CRTVL) then
         rcpudf = cpudif/ecpu * 100.0
      else if(cpu0ol.le.CRTVL) then
         rcpudf = 0.0
      else
         rcpudf = 100.0
      endif
c               <-- Ratio in percent of CPU time difference
c                 between previous one and present one.
      cpu0ol = ecpu

c$$$      call eqivvl(rcpudf)

      if(rcpudf.gt.PCPUDF) then
         if(icount.gt.0) then
            tcpu = ecpu/dfloat(icount)
         endif
         write(6,9001) ecpu, icount, tcpu
 9001    format(1H ,' <<CPU TIME for JRCAT_C3FT = ',f11.3
     &        ,'(Sec.) = (',i6,' *',f10.5,')>>')
      endif
      return
      end  

c---------------------------------------------
      subroutine jrcat_r3ft(ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                      kc1,kc2,kc3,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
c
c------------------>      for Estimation of CPU cost.
c                             by T.Yamasaki
c                               22th May. 1996
      real*8 CRTVL, PCPUDF
      parameter (CRTVL = 1.d-5, PCPUDF = 2.0)
c        CRTVL : CRItical VaLue for Division.
c        PCPUDF: Percent of CPU DiFference.
      real*8 cpu0ol,cpudif,rcpudf,ecpu,tcpu
      integer icount
      data icount/0/
      data ecpu/0.d0/
      data cpu0ol/0.d0/
      real*8 t_start, t_end, UMICRO
      parameter (UMICRO = 1.d-6)
c <-------------------------------------------

      dimension ra   (id,n2,n3)
      dimension work (id+n2+n3,2)

      dimension cw1(0:n1-1)
      dimension cw2(0:n2-1)
      dimension cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer key 

c*******************************************************************************
c*  3 DIMENSIONAL FAST FOURIER TRANSFORM OF REAL ARRAY WITH MASK,
c*                developed on 1997.6.5.
c*******************************************************************************
c*
c*  The 3-dimensional array ra(id,n2,n3) is fourier-transfomed and
c*  its result is overwritten on ra. The size of fourier-transformed is
c*  (n1,n2,n3) and n1 axis is the complex conjugate axis. id must be n1 + 2.
c*  Also n1 must be an even number and n1,n2 and n3 must be radix 2,3,5
c*  integers.
c*
c*  work is real work array and the size must be at least (id+n2+n3)*2.
c*
c*******************************************************************************
c*  How to set the value of key.
c*
c*(1) key = 0 : set up of FFT.
c*
c*    Calculation of cw1,cw2 and cw3. 
c*
c*(2) key = -1 & -2 :
c*
c*    F.T. of real 3d array ra(0:id-1,0:n2-1,0:n3-1),
c*
c*    here the definition of fourier-transform is
c*
c*     cb(k1,k2,k3) 
c*   = sum(i1=0:n1-1,i2=0:n2-1,i3=0:n3-1) 
c*     ra(i1,i2,i3) exp [- 2 * pai * ci * ( k1*i1/n1 + k2*i2/n2 + k3*i3/n3 ) ]
c*     
c*     where 0 <= k1 <= n1/2, 0 <= k2 <= n2-1, 0 <= k3 <= n3-1.
c*           and ci is the imaginary unit.
c*
c*  The result(complex array cb(0:id/2-1,0:n2-1,0:n3-1)) is overwritten on 'ra'.
c*
c*(3) key = +1 & +2 :
c*
c*     Inverse F.T. of complex 3d array cb(0:id/2-1,0:n2-1,0:n3-1)
c*                   to ra(0:id-1,0:n2-1,0:n3-1).
c*
c*******************************************************************************
c*  How to set the mask.
c*
c*  kc1,kc2 kc3 and key are integer parameters specifying the mask for
c*  input data or output data.
c*
c*     key = -1 : Mask is for Output data ( cb ),
c*     key = +1 : Mask is for Input  data ( cb ),
c*     key = -2 : Mask is for Input  data ( ca ),
c*     key = +2 : Mask is for Output data ( ca ),
c*
c*     If kc1.ge.n1/2.or.kc1.lt.0, then kc1 is forced to be 0. 
c*     If kc2.ge.n2/2.or.kc2.lt.0, then kc2 is forced to be 0. 
c*     If kc3.ge.n3/2.or.kc3.lt.0, then kc3 is forced to be 0. 
c*
c*  where ca(0:id/2-1,0:n2-1,0:n3-1) are equivalent to ra(0:id-1,0:n2-1,0:n3-1).
c*
c*******************************************************************************
c*  Mask for Output data:
c*
c*     If kc1.eq.0.and.kc2.eq.0.and.kc3.eq.0, then the full 
c*     range is calculated.
c*
c*     If kc1.ne.0, then only "0 <= k1 <= kc1" range is calculated.
c*
c*     If kc2.ne.0, then only "0 <= k2 <= kc2" and "n2-kc2 <= k2 <= n2-1" 
c*     range is calculated.
c*
c*     If kc3.ne.0, then only "0 <= k3 <= kc3" and "n3-kc3 <= k3 <= n3-1" 
c*     range is calculated.
c*
c*******************************************************************************
c*  Mask for Input data:
c*
c*     If kc1.eq.0.and.kc2.eq.0.and.kc3.eq.0, then the full wavenumber
c*     range is used to obtain real array 'ra'.
c*
c*     If kc1.ne.0, then only "0 <= k1 <= kc1" range is used.
c*
c*     If kc2.ne.0, then only "0 <= k2 <= kc2" and "n2-kc2 <= k2 <= n2-1" 
c*     range is used.
c*
c*     If kc3.ne.0, then only "0 <= k3 <= kc3" and "n3-kc3 <= k3 <= n3-1" 
c*     range is used.
c*
c*******************************************************************************
c
      call gettod(t_start)

      if(mod(n1,2).ne.0) then
         write(6,*) 'ERROR in JRCAT_R3FT: n1 is not an even number.'
         stop
      end if
c*******************************************************************************
      if(key.eq.0) then
c** set up of FFT.
         call r3ft_0(cw1,cw2,cw3,n1,n2,n3)
         return
      end if
c*******************************************************************************
      if(id.ne.n1+2) then
         write(6,*) 'ERROR in JRCAT_R3FT: id is not n1+2.'
         stop
      end if
c*******************************************************************************
      if(kc1.ge.n1/2.or.kc1.lt.0) then 
         write(6,*) 'warning in JRCAT_R3FT: kc1 is irrelevant.'
         write(6,*) 'kc1 has changed to be 0.'
         kc1 = 0
      end if

      if(kc2.ge.n2/2.or.kc2.lt.0) then 
         write(6,*) 'warning in JRCAT_R3FT: kc2 is irrelevant.'
         write(6,*) 'kc2 has changed to be 0.'
         kc2 = 0
      end if

      if(kc3.ge.n3/2.or.kc3.lt.0) then 
         write(6,*) 'warning in JRCAT_R3FT: kc3 is irrelevant.'
         write(6,*) 'kc3 has changed to be 0.'
         kc3 = 0
      end if
c*******************************************************************************
      if(key.eq.-1) then  
c** Forword FFT with mask for output.
         call r3ft_f_mask_for_out(ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                            kc1,kc2,kc3)
      else if(key.eq.-2) then
c** Forword FFT with mask for input.
         call r3ft_f_mask_for_in (ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                            kc1,kc2,kc3)
      else if(key.eq.+1) then
c** Backword FFT with mask for input.
         call r3ft_b_mask_for_in (ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                            kc1,kc2,kc3)
      else if(key.eq.+2) then
c** Backword FFT with mask for output.
         call r3ft_b_mask_for_out(ra,work,id,n1,n2,n3,cw1,cw2,cw3,
     &                            kc1,kc2,kc3)
      end if
c*******************************************************************************
c -------->  CPU cost estimation
      call gettod(t_end)
      tcpu = (t_end - t_start)*UMICRO
      icount = icount + 1
      ecpu = ecpu + tcpu
c <-------
      return

      entry jrc_r3strt
      icount = 0
      ecpu = 0.d0
      return
c--------------------------
      entry jrc_r3end
      cpudif = dabs(cpu0ol - ecpu)
      if(ecpu.gt.CRTVL) then
         rcpudf = cpudif/ecpu * 100.0
      else if(cpu0ol.le.CRTVL) then
         rcpudf = 0.0
      else
         rcpudf = 100.0
      endif
c               <-- Ratio in percent of CPU time difference
c                 between previous one and present one.
      cpu0ol = ecpu

c$$$      call eqivvl(rcpudf)

      if(rcpudf.gt.PCPUDF) then
         if(icount.gt.0) then
            tcpu = ecpu/dfloat(icount)
         endif
         write(6,9001) ecpu, icount, tcpu
 9001    format(1H ,' <<CPU TIME for JRCAT_R3FT = ',f11.3
     &        ,'(Sec.) = (',i6,' *',f10.5,')>>')
      endif
      return
      end  
c---------------------------------------------
      subroutine c3ft_0(cw1,cw2,cw3,n1,n2,n3)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      dimension cw1(0:n1-1)
      dimension cw2(0:n2-1)
      dimension cw3(0:n3-1)

         call setcw(cw1,n1)
         call setcw(cw2,n2)
         call setcw(cw3,n3) 

      return
      end  
c---------------------------------------------
      subroutine c3ft_conj(cw,nn)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension cw(nn) 

      do 10 ii=1,nn
         cw(ii) = dconjg(cw(ii))
  10  continue
c 10  end do

      return
      end 
c---------------------------------------------
      subroutine c3ft_mask_for_in(ca,cwork,id,n1,n2,n3,
     &                            cw1,cw2,cw3,kc1,kc2,kc3,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      dimension ca   (0:id-1,0:n2-1,0:n3-1)
      dimension cwork(*)

      dimension cw1(0:n1-1)
      dimension cw2(0:n2-1)
      dimension cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer key
      integer lp(8,3)
c**
      if(kc2.eq.0) then
           nk2 = n2
      else
           nk2 = kc2+1
      end if
      if(kc3.eq.0) then
           nk3 = n3
      else
           nk3 = kc3+1
      end if
c**
      call setlp(n1,lp(1,1))
      call setlp(n2,lp(1,2))
      call setlp(n3,lp(1,3))
c**
      call c3ft_zeroset(ca,id,n1,n2,n3,kc1,kc2,kc3)

c** Length:n1&n2 CFFT    
      do 10 i3=0,n3-1
         if(i3.le.nk3-1.or.i3.ge.n3-kc3) then
         do 11 i2=0,nk2-1
            call fsb_lp235(ca(0,i2,i3),cwork,cw1,n1,lp(1,1),key)
  11     continue
c 11     end do
         do 12 i2=n2-kc2,n2-1 
            call fsb_lp235(ca(0,i2,i3),cwork,cw1,n1,lp(1,1),key)
  12     continue
c 12     end do
         call fsb_lp235v(ca(0,0,i3),cwork,cw2,n2,id,1,n1,lp(1,2),key) 
         end if
  10  continue
c 10  end do

c** Length:n3 CFFT  
      call fsb_lp235v(ca,cwork,cw3,n3,id*n2,1,id*n2,lp(1,3),key)
c**
      return
      end
c---------------------------------------------
      subroutine c3ft_mask_for_out(ca,cwork,id,n1,n2,n3,
     &                             cw1,cw2,cw3,kc1,kc2,kc3,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      dimension ca   (0:id-1,0:n2-1,0:n3-1)
      dimension cwork(*)

      dimension cw1(0:n1-1)
      dimension cw2(0:n2-1)
      dimension cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer key         
      integer lp(8,3)
c**
      if(kc2.eq.0) then
           nk2 = n2
      else
           nk2 = kc2+1
      end if
      if(kc3.eq.0) then
           nk3 = n3
      else
           nk3 = kc3+1
      end if
c**
      call setlp(n1,lp(1,1))
      call setlp(n2,lp(1,2))
      call setlp(n3,lp(1,3))

c** Length:n3 CFFT  
      call fsb_lp235v(ca,cwork,cw3,n3,id*n2,1,id*n2,lp(1,3),key)

c** Length:n2 & n1 CFFT    
      do 10 i3=0,n3-1
         if(i3.le.nk3-1.or.i3.ge.n3-kc3) then
            call fsb_lp235v(ca(0,0,i3),cwork,cw2,n2,id,1,n1,lp(1,2),key) 
         do 11 i2=0,nk2-1
            call fsb_lp235(ca(0,i2,i3),cwork,cw1,n1,lp(1,1),key)
  11     continue
c 11     end do
         do 12 i2=n2-kc2,n2-1 
            call fsb_lp235(ca(0,i2,i3),cwork,cw1,n1,lp(1,1),key)
  12     continue
c 12     end do
         end if
  10  continue
c 10  end do
c**
      call c3ft_zeroset(ca,id,n1,n2,n3,kc1,kc2,kc3)
c**
      return
      end
c---------------------------------------------
      subroutine c3ft_zeroset(ca,id,n1,n2,n3,kc1,kc2,kc3)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca(0:id-1,0:n2-1,0:n3-1)

      do 10 i3=0,n3-1
      do 10 i2=0,n2-1
      do 10 i1=n1,id-1
         ca(i1,i2,i3) = (0.0d0,0.0d0)
 10   continue
c10   end do

      if(kc1.ne.0) then
      do 20 i3=0,n3-1
      do 20 i2=0,n2-1
      do 20 i1=kc1+1,n1-kc1-1
         ca(i1,i2,i3) = (0.0d0,0.0d0)
 20   continue
c20   end do
      end if

      if(kc2.ne.0) then
      do 30 i3=0,n3-1
      do 30 i2=kc2+1,n2-kc2-1
      do 30 i1=0,id-1
         ca(i1,i2,i3) = (0.0d0,0.0d0)
 30   continue
c30   end do
      end if

      if(kc3.ne.0) then
      do 40 i3=kc3+1,n3-kc3-1
      do 40 i2=0,n2-1
      do 40 i1=0,id-1
         ca(i1,i2,i3) = (0.0d0,0.0d0)
 40   continue
c40   end do
      end if

      return
      end 
c---------------------------------------------
      subroutine r3ft_0(cw1,cw2,cw3,n1,n2,n3)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      dimension cw1(0:n1/2-1,2)
      dimension cw2(0:n2-1)
      dimension cw3(0:n3-1)
c**
      n1h = n1/2

      call setcw(cw1,n1h)
      call setcw(cw2,n2 )
      call setcw(cw3,n3 ) 

      pai=3.14159265358979323846d0
      pc =2.0d0*pai/dble(n1)
      ci=(0.0d0,1.0d0)

      do i=0,n1h-1
         tr=dcos(pc*dble(i))
         ti=dsin(pc*dble(i))
c        cw1(i,2)=ci*dcmplx(tr,ti)
         cw1(i,2)=dcmplx(-ti,tr)
      end do   
c**
      return
      end  

c---------------------------------------------
      subroutine r3ft_b_mask_for_in (ca,cwork,id,n1,n2,n3,
     &                               cw1,cw2,cw3,kc1,kc2,kc3)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      dimension ca   (0:id/2-1,0:n2-1,0:n3-1)
      dimension cwork(*)

      dimension cw1(0:n1/2-1,2)
      dimension cw2(0:n2-1)
      dimension cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer lp(8,3)
c**
      n1h = n1/2
      idh = id/2
c**
      if(kc1.eq.0) then
           nk1 = idh
      else
           nk1 = kc1+1
      end if

      if(kc3.eq.0) then
           nk3 = n3
      else
           nk3 = kc3+1
      end if
c**
      call setlp(n1h,lp(1,1))
      call setlp(n2 ,lp(1,2))
      call setlp(n3 ,lp(1,3))
c**
      call r3ft_zeroset(ca,id,n1,n2,n3,kc1,kc2,kc3)
    
c** Length:n2 CFFT
      do 10 i3=0,n3-1
         if(i3.le.nk3-1.or.i3.ge.n3-kc3) then
      call fsb_lp235v(ca(0,0,i3),cwork,cw2,n2,idh,1,nk1,lp(1,2),+1)
         end if
  10  end do

c** Length:n3 CFFT
      if(kc1.eq.0) then
         call fsb_lp235v(ca,cwork,cw3,n3,idh*n2,1,idh*n2,lp(1,3),+1)
      else
         do 20 nn1=1,idh*(n2-1)+1,idh
            nn2=nn1+nk1-1
         call fsb_lp235v(ca,cwork,cw3,n3,idh*n2,nn1,nn2,lp(1,3),+1)
  20     continue
c 20     end do
      end if

c** Length:n1h RFFT
      do 30 i3=0,n3-1
      do 30 i2=0,n2-1
         call trans_b(ca(0,i2,i3),cw1(0,2),n1h,0)
         call fsb_lp235(ca(0,i2,i3),cwork,cw1,n1h,lp(1,1),+1)
  30  continue
c 30  end do
c**  
      return
      end  

c---------------------------------------------
      subroutine r3ft_b_mask_for_out(ca,cwork,id,n1,n2,n3,
     &                               cw1,cw2,cw3,kc1,kc2,kc3)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      dimension ca   (0:id/2-1,0:n2-1,0:n3-1)
      dimension cwork(*)

      dimension cw1(0:n1/2-1,2)
      dimension cw2(0:n2-1)
      dimension cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer lp(8,3)
c**
      n1h = n1/2
      idh = id/2

      if(kc2.eq.0) then
           nk2 = n2
      else
           nk2 = kc2+1
      end if

      if(kc3.eq.0) then
           nk3 = n3
      else
           nk3 = kc3+1
      end if
c**
      call setlp(n1h,lp(1,1))
      call setlp(n2 ,lp(1,2))
      call setlp(n3 ,lp(1,3))

c** Length:n3 CFFT
      call fsb_lp235v(ca,cwork,cw3,n3,idh*n2,1,idh*n2,lp(1,3),+1)

      do 30 i3=0,n3-1
         if(i3.le.nk3-1.or.i3.ge.n3-kc3) then
c** Length:n2 CFFT
         call fsb_lp235v(ca(0,0,i3),cwork,cw2,n2,idh,1,idh,lp(1,2),+1)
      do 10 i2=0,nk2-1
c** Length:n1h RFFT
         call trans_b(ca(0,i2,i3),cw1(0,2),n1h,0)
         call fsb_lp235(ca(0,i2,i3),cwork,cw1,n1h,lp(1,1),+1)
  10  end do
      do 20 i2=n2-kc2,n2-1
c** Length:n1h RFFT
         call trans_b(ca(0,i2,i3),cw1(0,2),n1h,0)
         call fsb_lp235(ca(0,i2,i3),cwork,cw1,n1h,lp(1,1),+1)
  20  end do
         end if
  30  end do
c**
      call r3ft_zeroset(ca,id,n1,n2,n3,kc1,kc2,kc3)
c**
      return
      end  

c---------------------------------------------
      subroutine r3ft_f_mask_for_in (ca,cwork,id,n1,n2,n3,
     &                               cw1,cw2,cw3,kc1,kc2,kc3)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      dimension ca   (0:id/2-1,0:n2-1,0:n3-1)
      dimension cwork(*)

      dimension cw1(0:n1/2-1,2)
      dimension cw2(0:n2-1)
      dimension cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer lp(8,3)
c**
      n1h = n1/2
      idh = id/2

      if(kc2.eq.0) then
           nk2 = n2
      else
           nk2 = kc2+1
      end if

      if(kc3.eq.0) then
           nk3 = n3
      else
           nk3 = kc3+1
      end if
c**   
      call setlp(n1h,lp(1,1))
      call setlp(n2 ,lp(1,2))
      call setlp(n3 ,lp(1,3))
c**   
      call c3ft_conj(cw1,n1)
      call c3ft_conj(cw2,n2)
      call c3ft_conj(cw3,n3)
c**   
      call r3ft_zeroset(ca,id,n1,n2,n3,kc1,kc2,kc3)
c**   
      do 30 i3=0,n3-1
         if(i3.le.nk3-1.or.i3.ge.n3-kc3) then
      do 10 i2=0,nk2-1
c** Length:n1h RFFT
         call fsb_lp235(ca(0,i2,i3),cwork,cw1,n1h,lp(1,1),-1)
         call trans_f(ca(0,i2,i3),cw1(0,2),n1h,0)
  10  end do
      do 20 i2=n2-kc2,n2-1
c** Length:n1h RFFT
         call fsb_lp235(ca(0,i2,i3),cwork,cw1,n1h,lp(1,1),-1)
         call trans_f(ca(0,i2,i3),cw1(0,2),n1h,0)
  20  end do
c** Length:n2 CFFT  
         call fsb_lp235v(ca(0,0,i3),cwork,cw2,n2,idh,1,idh,lp(1,2),-1)   
         end if
  30  end do

c** Length:n3 CFFT  
      call fsb_lp235v(ca,cwork,cw3,n3,idh*n2,1,idh*n2,lp(1,3),-1)
c**   
      call c3ft_conj(cw1,n1)
      call c3ft_conj(cw2,n2)
      call c3ft_conj(cw3,n3)
c**   
      return
      end  

c---------------------------------------------
      subroutine r3ft_f_mask_for_out(ca,cwork,id,n1,n2,n3,
     &                               cw1,cw2,cw3,kc1,kc2,kc3)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)

      dimension ca   (0:id/2-1,0:n2-1,0:n3-1)
      dimension cwork(*)

      dimension cw1(0:n1/2-1,2)
      dimension cw2(0:n2-1)
      dimension cw3(0:n3-1)

      integer kc1,kc2,kc3
      integer lp(8,3)
c**
      n1h = n1/2
      idh = id/2
c**
      if(kc1.eq.0) then
           nk1 = idh
      else
           nk1 = kc1+1
      end if

      if(kc3.eq.0) then
           nk3 = n3
      else
           nk3 = kc3+1
      end if
c**   
      call setlp(n1h,lp(1,1))
      call setlp(n2 ,lp(1,2))
      call setlp(n3 ,lp(1,3))
c**   
      call c3ft_conj(cw1,n1)
      call c3ft_conj(cw2,n2)
      call c3ft_conj(cw3,n3)
      
c** Length:n1h RFFT
      do 10 i3=0,n3-1
      do 10 i2=0,n2-1
         call fsb_lp235(ca(0,i2,i3),cwork,cw1,n1h,lp(1,1),-1)
         call trans_f(ca(0,i2,i3),cw1(0,2),n1h,kc1)
  10  continue
c 10  end do

c** Length:n3 CFFT  
      if(kc1.eq.0) then
         call fsb_lp235v(ca,cwork,cw3,n3,idh*n2,1,idh*n2,lp(1,3),-1)
      else
         do 20 nn1=1,idh*(n2-1)+1,idh
            nn2=nn1+nk1-1
         call fsb_lp235v(ca,cwork,cw3,n3,idh*n2,nn1,nn2,lp(1,3),-1)
  20     continue
c 20     end do
      end if

c** Length:n2 CFFT  
      do 30 i3=0,n3-1
         if(i3.le.nk3-1.or.i3.ge.n3-kc3) then
      call fsb_lp235v(ca(0,0,i3),cwork,cw2,n2,idh,1,nk1,lp(1,2),-1)   
         end if
  30  end do
c**   
      call r3ft_zeroset(ca,id,n1,n2,n3,kc1,kc2,kc3)
c**   
      call c3ft_conj(cw1,n1)
      call c3ft_conj(cw2,n2)
      call c3ft_conj(cw3,n3)
c**   
      return
      end  

c---------------------------------------------
      subroutine r3ft_zeroset(ca,id,n1,n2,n3,kc1,kc2,kc3)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca(0:id/2-1,0:n2-1,0:n3-1)

      idh = id/2

      if(kc1.ne.0) then
      do 20 i3=0,n3-1
      do 20 i2=0,n2-1
      do 20 i1=kc1+1,idh-1
         ca(i1,i2,i3) = (0.0d0,0.0d0)
 20   continue
c20   end do
      end if

      if(kc2.ne.0) then
      do 30 i3=0,n3-1
      do 30 i2=kc2+1,n2-kc2-1
      do 30 i1=0,idh-1
         ca(i1,i2,i3) = (0.0d0,0.0d0)
 30   continue
c30   end do
      end if

      if(kc3.ne.0) then
      do 40 i3=kc3+1,n3-kc3-1
      do 40 i2=0,n2-1
      do 40 i1=0,idh-1
         ca(i1,i2,i3) = (0.0d0,0.0d0)
 40   continue
c40   end do
      end if

      return
      end 
c---------------------------------------------
      subroutine fsb_lp235(ca,cb,cw,n,lp,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca(0:n-1),cb(0:n-1)
      dimension cw(0:n-1)
      dimension lp(8)

      k =1
      la=1

c*** radix 2 fft.

      do 2 i=1,lp(2)
      if(k.eq.1) then
         call fsb_lp2(ca,cb,cw,la,n,key)
      else
         call fsb_lp2(cb,ca,cw,la,n,key)
      end if
         k=k*(-1)
         la=la*2
    2 continue

c*** radix 3 fft.

      do 3 i=1,lp(3)
      if(k.eq.1) then
         call fsb_lp3(ca,cb,cw,la,n,key)
      else
         call fsb_lp3(cb,ca,cw,la,n,key)
      end if
         k=k*(-1)
         la=la*3
    3 continue

c*** radix 4 fft.

      do 4 i=1,lp(4)
      if(k.eq.1) then
         call fsb_lp4(ca,cb,cw,la,n,key)
      else
         call fsb_lp4(cb,ca,cw,la,n,key)
      end if
         k=k*(-1)
         la=la*4
    4 continue

c*** radix 5 fft.

      do 5 i=1,lp(5)
      if(k.eq.1) then
         call fsb_lp5(ca,cb,cw,la,n,key)
      else
         call fsb_lp5(cb,ca,cw,la,n,key)
      end if
         k=k*(-1)
         la=la*5
    5 continue

c*** radix 6 fft.

      do 6 i=1,lp(6)
      if(k.eq.1) then
         call fsb_lp6(ca,cb,cw,la,n,key)
      else
         call fsb_lp6(cb,ca,cw,la,n,key)
      end if
         k=k*(-1)
         la=la*6
    6 continue

c*** radix 8 fft.

      do 8 i=1,lp(8)
      if(k.eq.1) then
         call fsb_lp8(ca,cb,cw,la,n,key)
      else
         call fsb_lp8(cb,ca,cw,la,n,key)
      end if
         k=k*(-1)
         la=la*8
    8 continue
c***
      if(k.eq.-1) then
         do 10 i=0,n-1
            ca(i)=cb(i)
   10    continue
      end if
c***
      return
      end
c---------------------------------------------
      subroutine fsb_lp2(ca,cb,cw,la,n,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca(0:n-1),cb(0:n-1)
      dimension cw(0:n-1)

      m=n/2

      if(la.eq.1) go to 22

      do 20 l=0,la-1

         cb(l   )=(ca(l)+ca(l+m))
         cb(l+la)=(ca(l)-ca(l+m))

   20 continue

      do 21 kpla=la,m-la,la
      do 21 l=kpla,kpla+la-1

         j0=l+kpla         

         cb(j0   )=(ca(l)+ca(l+m))
         cb(j0+la)=(ca(l)-ca(l+m))*cw(kpla)

   21 continue

      return

   22 cb(0)=(ca(0)+ca(m))
      cb(1)=(ca(0)-ca(m))

      do 23 l=1,m-1

         j0=l*2         

         cb(j0  )=(ca(l)+ca(l+m))
         cb(j0+1)=(ca(l)-ca(l+m))*cw(l)

   23 continue

      return
      end
c---------------------------------------------
      subroutine fsb_lp3(ca,cb,cw,la,n,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca(0:n-1),cb(0:n-1)
      dimension cw(0:n-1)

      m=n/3

      sin60=0.5d0*dsqrt(3.0d0)
      if(key.gt.0) then
         cisin60=dcmplx(0.0d0,+sin60)
      else
         cisin60=dcmplx(0.0d0,-sin60)
      end if

      if(la.eq.1) go to 32

      do 30 l=0,la-1

         ct1=ca(l+m)+ca(l+m*2)
         ct2=ca(l  )-0.5d0*ct1       
         ct3=cisin60*(ca(l+m)-ca(l+m*2))

         cb(l     )=ca(l)+ct1
         cb(l+la  )=(ct2+ct3)
         cb(l+la*2)=(ct2-ct3)

   30 continue

      do 31 kpla=la,m-la,la
      do 31 l=kpla,kpla+la-1

         j0=l+kpla*2         

         ct1=ca(l+m)+ca(l+m*2)
         ct2=ca(l  )-0.5d0*ct1       
         ct3=cisin60*(ca(l+m)-ca(l+m*2))

         cb(j0     )=ca(l)+ct1
         cb(j0+la  )=(ct2+ct3)*cw(kpla  )
         cb(j0+la*2)=(ct2-ct3)*cw(kpla*2)

   31 continue

      return

   32 ct1=ca(m)+ca(m*2)
      ct2=ca(0)-0.5d0*ct1       
      ct3=cisin60*(ca(m)-ca(m*2))

      cb(0)=ca(0)+ct1
      cb(1)=(ct2+ct3)
      cb(2)=(ct2-ct3)

      do 33 l=1,m-1

         j0=l*3         

         ct1=ca(l+m)+ca(l+m*2)
         ct2=ca(l  )-0.5d0*ct1       
         ct3=cisin60*(ca(l+m)-ca(l+m*2))

         cb(j0  )=ca(l)+ct1
         cb(j0+1)=(ct2+ct3)*cw(l  )
         cb(j0+2)=(ct2-ct3)*cw(l*2)

   33 continue

      return
      end
c---------------------------------------------
      subroutine fsb_lp4(ca,cb,cw,la,n,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca(0:n-1),cb(0:n-1)
      dimension cw(0:n-1)

      m=n/4

      if(key.gt.0) then
         ci=(0.0d0,+1.0d0)
      else
         ci=(0.0d0,-1.0d0)
      end if
   
      if(la.eq.1) go to 42

      do 40 l=0,la-1

         cc0 = ca(l  )+ca(l+m*2)
         cc1 = ca(l+m)+ca(l+m*3)
         cc2 = ca(l  )-ca(l+m*2)
         cc3 =(ca(l+m)-ca(l+m*3))*ci

         cb(l     )= cc0+cc1
         cb(l+la  )= cc2+cc3
         cb(l+la*2)= cc0-cc1
         cb(l+la*3)= cc2-cc3

   40 continue
   
      do 41 kpla=la,m-la,la
      do 41 l=kpla,kpla+la-1

         j0=l+kpla*3

         cc1 = ca(l  )+ca(l+m*2)
         cc2 = ca(l+m)+ca(l+m*3)
         cc3 = ca(l  )-ca(l+m*2)
         cc4 =(ca(l+m)-ca(l+m*3))*ci

         cb(j0     )= cc1+cc2
         cb(j0+la  )=(cc3+cc4)*cw(kpla  )
         cb(j0+la*2)=(cc1-cc2)*cw(kpla*2)
         cb(j0+la*3)=(cc3-cc4)*cw(kpla*3)

   41 continue
         
      return

   42 cc0 = ca(0)+ca(m*2)
      cc1 = ca(m)+ca(m*3)
      cc2 = ca(0)-ca(m*2)
      cc3 =(ca(m)-ca(m*3))*ci

      cb(0)= cc0+cc1
      cb(1)= cc2+cc3
      cb(2)= cc0-cc1
      cb(3)= cc2-cc3

      do 43 l=1,m-1

         j0=l*4

         cc1 = ca(l  )+ca(l+m*2)
         cc2 = ca(l+m)+ca(l+m*3)
         cc3 = ca(l  )-ca(l+m*2)
         cc4 =(ca(l+m)-ca(l+m*3))*ci

         cb(j0  )= cc1+cc2
         cb(j0+1)=(cc3+cc4)*cw(l  )
         cb(j0+2)=(cc1-cc2)*cw(l*2)
         cb(j0+3)=(cc3-cc4)*cw(l*3)

   43 continue
         
      return
      end
c---------------------------------------------
      subroutine fsb_lp5(ca,cb,cw,la,n,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca(0:n-1),cb(0:n-1)
      dimension cw(0:n-1)

      m=n/5

      r54=dsqrt(5.0d0)/4.0d0
      pai=3.14159265358979323846d0
      sin36=dsin(pai*0.2d0)
      sin72=dsin(pai*0.4d0)
      if(key.gt.0) then
         cisin36=dcmplx(0.0d0,+sin36)
         cisin72=dcmplx(0.0d0,+sin72)
      else
         cisin36=dcmplx(0.0d0,-sin36)
         cisin72=dcmplx(0.0d0,-sin72)
      end if

      if(la.eq.1) go to 52

      do 50 l=0,la-1

         ct1=ca(l+m  )+ca(l+m*4)
         ct2=ca(l+m*2)+ca(l+m*3)
         ct3=ca(l+m  )-ca(l+m*4)
         ct4=ca(l+m*2)-ca(l+m*3)
         ct5=     ct1+ct2
         ct6=r54*(ct1-ct2)
         ct7=ca(l   )-0.25d0*ct5
         ct8=ct7+ct6
         ct9=ct7-ct6
         ct10=cisin72*ct3+cisin36*ct4
         ct11=cisin36*ct3-cisin72*ct4

         cb(l     )=ca(l)+ct5
         cb(l+la  )=(ct8+ct10)
         cb(l+la*2)=(ct9+ct11)
         cb(l+la*3)=(ct9-ct11)
         cb(l+la*4)=(ct8-ct10)

   50 continue

      do 51 kpla=la,m-la,la
      do 51 l=kpla,kpla+la-1

         j0=l+kpla*4

         ct1=ca(l+m  )+ca(l+m*4)
         ct2=ca(l+m*2)+ca(l+m*3)
         ct3=ca(l+m  )-ca(l+m*4)
         ct4=ca(l+m*2)-ca(l+m*3)
         ct5=     ct1+ct2
         ct6=r54*(ct1-ct2)
         ct7=ca(l  )-0.25d0*ct5
         ct8=ct7+ct6
         ct9=ct7-ct6
         ct10=cisin72*ct3+cisin36*ct4
         ct11=cisin36*ct3-cisin72*ct4

         cb(j0     )=ca(l)+ct5
         cb(j0+la  )=(ct8+ct10)*cw(kpla  )
         cb(j0+la*2)=(ct9+ct11)*cw(kpla*2)
         cb(j0+la*3)=(ct9-ct11)*cw(kpla*3)
         cb(j0+la*4)=(ct8-ct10)*cw(kpla*4)

   51 continue

      return

   52 ct1=ca(m  )+ca(m*4)
      ct2=ca(m*2)+ca(m*3)
      ct3=ca(m  )-ca(m*4)
      ct4=ca(m*2)-ca(m*3)
      ct5=     ct1+ct2
      ct6=r54*(ct1-ct2)
      ct7=ca(0)-0.25d0*ct5
      ct8=ct7+ct6
      ct9=ct7-ct6
      ct10=cisin72*ct3+cisin36*ct4
      ct11=cisin36*ct3-cisin72*ct4

      cb(0)=ca(0)+ct5
      cb(1)=(ct8+ct10)
      cb(2)=(ct9+ct11)
      cb(3)=(ct9-ct11)
      cb(4)=(ct8-ct10)

      do 53 l=1,m-1

         j0=l*5

         ct1=ca(l+m  )+ca(l+m*4)
         ct2=ca(l+m*2)+ca(l+m*3)
         ct3=ca(l+m  )-ca(l+m*4)
         ct4=ca(l+m*2)-ca(l+m*3)
         ct5=     ct1+ct2
         ct6=r54*(ct1-ct2)
         ct7=ca(l  )-0.25d0*ct5
         ct8=ct7+ct6
         ct9=ct7-ct6
         ct10=cisin72*ct3+cisin36*ct4
         ct11=cisin36*ct3-cisin72*ct4

         cb(j0  )=ca(l)+ct5
         cb(j0+1)=(ct8+ct10)*cw(l  )
         cb(j0+2)=(ct9+ct11)*cw(l*2)
         cb(j0+3)=(ct9-ct11)*cw(l*3)
         cb(j0+4)=(ct8-ct10)*cw(l*4)

   53 continue

      return
      end
c---------------------------------------------
      subroutine fsb_lp6(ca,cb,cw,la,n,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca(0:n-1),cb(0:n-1)
      dimension cw(0:n-1)

      m=n/6

      sin60=0.5d0*dsqrt(3.0d0)
      if(key.gt.0) then
         cisin60=dcmplx(0.0d0,+sin60)
      else
         cisin60=dcmplx(0.0d0,-sin60)
      end if

      if(la.eq.1) go to 62

      do 60 l=0,la-1

         ct0=ca(l+m*2)+ca(l+m*4)
         ct1=ca(l+m  )+ca(l+m*5)
         ct2=ca(l    )-0.5d0*ct0
         ct3=ca(l+m*3)-0.5d0*ct1
         ct4=cisin60*(ca(l+m*2)-ca(l+m*4))
         ct5=cisin60*(ca(l+m*5)-ca(l+m  ))

         cd0 = ca(l    )+ct0
         cd1 = ct3-ct5
         cd2 = ct2+ct4
         cd3 = ca(l+m*3)+ct1
         cd4 = ct2-ct4
         cd5 = ct3+ct5

         cb(l     )=(cd0+cd3)
         cb(l+la  )=(cd2-cd5)
         cb(l+la*2)=(cd4+cd1)
         cb(l+la*3)=(cd0-cd3)
         cb(l+la*4)=(cd2+cd5)
         cb(l+la*5)=(cd4-cd1)

   60 continue

      do 61 kpla=la,m-la,la
      do 61 l=kpla,kpla+la-1

         j0=l+kpla*5

         ct0=ca(l+m*2)+ca(l+m*4)
         ct1=ca(l+m  )+ca(l+m*5)
         ct2=ca(l    )-0.5d0*ct0
         ct3=ca(l+m*3)-0.5d0*ct1
         ct4=cisin60*(ca(l+m*2)-ca(l+m*4))
         ct5=cisin60*(ca(l+m*5)-ca(l+m  ))

         cd0 = ca(l    )+ct0
         cd1 = ct3-ct5
         cd2 = ct2+ct4
         cd3 = ca(l+m*3)+ct1
         cd4 = ct2-ct4
         cd5 = ct3+ct5

         cb(j0     )=(cd0+cd3)
         cb(j0+la  )=(cd2-cd5)*cw(kpla  )
         cb(j0+la*2)=(cd4+cd1)*cw(kpla*2)
         cb(j0+la*3)=(cd0-cd3)*cw(kpla*3)
         cb(j0+la*4)=(cd2+cd5)*cw(kpla*4)
         cb(j0+la*5)=(cd4-cd1)*cw(kpla*5)

   61 continue

      return

   62 ct0=ca(m*2)+ca(m*4)
      ct1=ca(m  )+ca(m*5)
      ct2=ca(0  )-0.5d0*ct0
      ct3=ca(m*3)-0.5d0*ct1
      ct4=cisin60*(ca(m*2)-ca(m*4))
      ct5=cisin60*(ca(m*5)-ca(m  ))

      cd0=ca(0  )+ct0
      cd1=ct3-ct5
      cd2=ct2+ct4
      cd3=ca(m*3)+ct1
      cd4=ct2-ct4
      cd5=ct3+ct5

      cb(0)=(cd0+cd3)
      cb(1)=(cd2-cd5)
      cb(2)=(cd4+cd1)
      cb(3)=(cd0-cd3)
      cb(4)=(cd2+cd5)
      cb(5)=(cd4-cd1)

      do 63 l=1,m-1

         j0=l*6

         ct0=ca(l+m*2)+ca(l+m*4)
         ct1=ca(l+m  )+ca(l+m*5)
         ct2=ca(l    )-0.5d0*ct0
         ct3=ca(l+m*3)-0.5d0*ct1
         ct4=cisin60*(ca(l+m*2)-ca(l+m*4))
         ct5=cisin60*(ca(l+m*5)-ca(l+m  ))

         cd0=ca(l    )+ct0
         cd1=ct3-ct5
         cd2=ct2+ct4
         cd3=ca(l+m*3)+ct1
         cd4=ct2-ct4
         cd5=ct3+ct5

         cb(j0  )=(cd0+cd3)
         cb(j0+1)=(cd2-cd5)*cw(l  )
         cb(j0+2)=(cd4+cd1)*cw(l*2)
         cb(j0+3)=(cd0-cd3)*cw(l*3)
         cb(j0+4)=(cd2+cd5)*cw(l*4)
         cb(j0+5)=(cd4-cd1)*cw(l*5)

   63 continue

      return
      end
c---------------------------------------------
      subroutine fsb_lp8(ca,cb,cw,la,n,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca(0:n-1),cb(0:n-1)
      dimension cw(0:n-1)
   
      m=n/8

      x=dsqrt(0.5d0)
      if(key.gt.0) then
         ci1=dcmplx(x, +x)
      else
         ci1=dcmplx(x, -x)
      end if
      ci2=ci1*ci1
      ci3=ci1*ci2

      if(la.eq.1) go to 82

      do 80 l=0,la-1

         cc0 = ca(l    )+ca(l+m*4)
         cc1 = ca(l+m  )+ca(l+m*5)
         cc2 = ca(l+m*2)+ca(l+m*6)
         cc3 = ca(l+m*3)+ca(l+m*7)
         cc4 = ca(l    )-ca(l+m*4)
         cc5 = ca(l+m  )-ca(l+m*5)
         cc6 =(ca(l+m*2)-ca(l+m*6))*ci2
         cc7 =(ca(l+m*3)-ca(l+m*7))*ci2

         cd0 = cc0+cc2
         cd1 = cc1+cc3
         cd2 = cc4+cc6
         cd3 =(cc5+cc7)*ci1
         cd4 = cc0-cc2
         cd5 =(cc1-cc3)*ci2
         cd6 = cc4-cc6
         cd7 =(cc5-cc7)*ci3

         cb(l     ) = cd0+cd1
         cb(l+la  ) = cd2+cd3
         cb(l+la*2) = cd4+cd5
         cb(l+la*3) = cd6+cd7
         cb(l+la*4) = cd0-cd1
         cb(l+la*5) = cd2-cd3
         cb(l+la*6) = cd4-cd5
         cb(l+la*7) = cd6-cd7

   80 continue
   
      do 81 kpla=la,m-la,la
      do 81 l=kpla,kpla+la-1

         j0=l+kpla*7

         cc0 = ca(l    )+ca(l+m*4)
         cc1 = ca(l+m  )+ca(l+m*5)
         cc2 = ca(l+m*2)+ca(l+m*6)
         cc3 = ca(l+m*3)+ca(l+m*7)
         cc4 = ca(l    )-ca(l+m*4)
         cc5 = ca(l+m  )-ca(l+m*5)
         cc6 =(ca(l+m*2)-ca(l+m*6))*ci2
         cc7 =(ca(l+m*3)-ca(l+m*7))*ci2

         cd0 = cc0+cc2
         cd1 = cc1+cc3
         cd2 = cc4+cc6
         cd3 =(cc5+cc7)*ci1
         cd4 = cc0-cc2
         cd5 =(cc1-cc3)*ci2
         cd6 = cc4-cc6
         cd7 =(cc5-cc7)*ci3

         cb(j0     ) = cd0+cd1
         cb(j0+la  ) =(cd2+cd3)*cw(kpla  )
         cb(j0+la*2) =(cd4+cd5)*cw(kpla*2)
         cb(j0+la*3) =(cd6+cd7)*cw(kpla*3)
         cb(j0+la*4) =(cd0-cd1)*cw(kpla*4)
         cb(j0+la*5) =(cd2-cd3)*cw(kpla*5)
         cb(j0+la*6) =(cd4-cd5)*cw(kpla*6)
         cb(j0+la*7) =(cd6-cd7)*cw(kpla*7)

   81 continue
    
      return

   82 cc0 = ca(0  )+ca(m*4)
      cc1 = ca(m  )+ca(m*5)
      cc2 = ca(m*2)+ca(m*6)
      cc3 = ca(m*3)+ca(m*7)
      cc4 = ca(0  )-ca(m*4)
      cc5 = ca(m  )-ca(m*5)
      cc6 =(ca(m*2)-ca(m*6))*ci2
      cc7 =(ca(m*3)-ca(m*7))*ci2

      cd0 = cc0+cc2
      cd1 = cc1+cc3
      cd2 = cc4+cc6
      cd3 =(cc5+cc7)*ci1
      cd4 = cc0-cc2
      cd5 =(cc1-cc3)*ci2
      cd6 = cc4-cc6
      cd7 =(cc5-cc7)*ci3

      cb(0) = cd0+cd1
      cb(1) = cd2+cd3
      cb(2) = cd4+cd5
      cb(3) = cd6+cd7
      cb(4) = cd0-cd1
      cb(5) = cd2-cd3
      cb(6) = cd4-cd5
      cb(7) = cd6-cd7
   
      do 83 l=1,m-1

         j0=l*8

         cc0 = ca(l    )+ca(l+m*4)
         cc1 = ca(l+m  )+ca(l+m*5)
         cc2 = ca(l+m*2)+ca(l+m*6)
         cc3 = ca(l+m*3)+ca(l+m*7)
         cc4 = ca(l    )-ca(l+m*4)
         cc5 = ca(l+m  )-ca(l+m*5)
         cc6 =(ca(l+m*2)-ca(l+m*6))*ci2
         cc7 =(ca(l+m*3)-ca(l+m*7))*ci2

         cd0 = cc0+cc2
         cd1 = cc1+cc3
         cd2 = cc4+cc6
         cd3 =(cc5+cc7)*ci1
         cd4 = cc0-cc2
         cd5 =(cc1-cc3)*ci2
         cd6 = cc4-cc6
         cd7 =(cc5-cc7)*ci3

         cb(j0  ) = cd0+cd1
         cb(j0+1) =(cd2+cd3)*cw(l  )
         cb(j0+2) =(cd4+cd5)*cw(l*2)
         cb(j0+3) =(cd6+cd7)*cw(l*3)
         cb(j0+4) =(cd0-cd1)*cw(l*4)
         cb(j0+5) =(cd2-cd3)*cw(l*5)
         cb(j0+6) =(cd4-cd5)*cw(l*6)
         cb(j0+7) =(cd6-cd7)*cw(l*7)

   83 continue

      return
      end
c---------------------------------------------
      subroutine fsb_lp235v(ca,cb,cw,n,ndim,nn1,nn2,lp,key)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca(ndim,0:n-1),cb(0:n-1,2)
      dimension cw(0:n-1)
      dimension lp(8)

      do 10 i=nn1,nn2

         do 20 j=0,n-1
            cb(j,1) = ca(i,j)
  20     continue
 
         call fsb_lp235(cb(0,1),cb(0,2),cw,n,lp,key)

         do 30 j=0,n-1
            ca(i,j) = cb(j,1)
  30     continue

  10  continue
  
c***
      return
      end
c---------------------------------------------
      subroutine setcw(cw,n)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      complex*16 cw(0:n-1)

      pai=3.14159265358979323846d0
      pc =2.0d0*pai/dble(n)

      do 10 i=0,n-1
         tr=dcos(pc*dble(i))
         ti=dsin(pc*dble(i))
         cw(i)=dcmplx(tr,ti)
   10 continue

      return
      end
c---------------------------------------------
      subroutine setlp(n,lp)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      integer lp(8)

         nn =n

         lp(8)=0
         lp(6)=0
         lp(5)=0
         lp(4)=0
         lp(3)=0
         lp(2)=0

      do while(mod(nn,8).eq.0)
         lp(8)=lp(8)+1
         nn=nn/8
      end do

c     do while(mod(nn,6).eq.0)
c        lp(6)=lp(6)+1
c        nn=nn/6
c     end do

      do while(mod(nn,5).eq.0)
         lp(5)=lp(5)+1
         nn=nn/5
      end do

      do while(mod(nn,4).eq.0)
         lp(4)=lp(4)+1
         nn=nn/4
      end do

      do while(mod(nn,3).eq.0)
         lp(3)=lp(3)+1
         nn=nn/3
      end do

      do while(mod(nn,2).eq.0)
         lp(2)=lp(2)+1
         nn=nn/2
      end do

      if(nn.ne.1) stop 'n is an improper number.'

      return
      end
c---------------------------------------------
      subroutine trans_b(ca,cw1,n1h,kc1)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca (0:n1h)
      dimension cw1(0:n1h-1)
c**
      r0 = dble(ca(  0))
      r1 = dble(ca(n1h))
       
      ca(  0)=dcmplx( r0 + r1 , r0 - r1 )
      ca(n1h)=(0.0d0,0.0d0)
c**   
      if(kc1.eq.0) then
         nn=n1h/2
      else
         nn=min(n1h/2,kc1) 
      end if

c**COMMENT.
c* When n1h is an even number and k1 is n1h/2, k1 is eqaul to n1h-k1.
c* This does not make any problem.
c**
      do 10 k1 = 1,nn

      cc1 = ca(k1)
      cc2 = ca(n1h-k1)
      cc1j = dconjg(cc1)
      cc2j = dconjg(cc2)

      ca(k1    ) = cc1+cc2j + (cc1-cc2j)*cw1(k1    )
      ca(n1h-k1) = cc2+cc1j + (cc2-cc1j)*cw1(n1h-k1)

  10  continue
c 10  end do
c**   
      return
      end

c---------------------------------------------
      subroutine trans_f(ca,cw1,n1h,kc1)
c---------------------------------------------
      implicit real*8(a-b,d-h,o-z)
      implicit complex*16(c)
      dimension ca (0:n1h)
      dimension cw1(0:n1h-1)
c**
      rr = dble (ca(0))
      ri = dimag(ca(0))
       
      ca(0  )=dcmplx(rr+ri,0.0d0)
      ca(n1h)=dcmplx(rr-ri,0.0d0)
c**   
      if(kc1.eq.0) then
         nn=n1h/2
      else
         nn=min(n1h/2,kc1) 
      end if

c**COMMENT.
c* When n1h is an even number and k1 is n1h/2, k1 is eqaul to n1h-k1.
c* This does not make any problem.
c**
      do 10 k1 = 1,nn

      cc1 = ca(k1)
      cc2 = ca(n1h-k1)
      cc1j = dconjg(cc1)
      cc2j = dconjg(cc2)

      ca(k1    ) = ( cc1+cc2j + (cc1-cc2j)*cw1(k1    ) )*0.5d0
      ca(n1h-k1) = ( cc2+cc1j + (cc2-cc1j)*cw1(n1h-k1) )*0.5d0

  10  continue
c 10  end do
c**   
      return
      end
#endif

subroutine ThomasFermiWeiz_loop

  use m_Control_Parameters, only : sw_modified_TFW_functional, &
       &                           sw_spherical_averaged_nonlocal, &
       &                           printable, ipritfwfunc, &
       &                           max_iteration_loop, &
       &                           threshold_exit_loop, &
       &                           threshold_skip_loop, &
       &                           threshold_enter_loop, &
       &                           use_deltaV, use_deltaW, use_averaged_nonlocal, &
       &                           kimg, nspin, sw_potential_mixing, &
       &                           m_CtrlP_rmx_now, noncol, ekmode, sw_hubbard, &
       &                           use_preconditioning, &
       &                           max_iter_linmin => max_iteration_linmin, &
       &                           threshold_linmin, iprinegativecharge

  use m_Const_Parameters,  only : ON, OFF, DP, PAI
  use m_ThomasFermiW_Potential,  only : m_TFW_calc_nonlocal_pot_avg_A, &
       &                                m_TFW_calc_nonlocal_pot_avg_B, &
       &                                m_TFW_CGoptimize_init, &
       &                                m_TFW_CGoptimize_finalize, &
       &                                m_TFW_calc_SD_direction, &
       &                                m_TFW_calc_CG_direction, &
       &                                m_TFW_calc_deltaW, &
       &                                m_TFW_store_Psi, &
       &                                m_TFW_try_new_Psi_and_charge, &
       &                                m_TFW_calc_energy_terms, &
       &                                m_TFW_remove_negative_charge, &
       &                                deltaV, &
       &                                m_TFW_alloc_deltaV, &
       &                                m_TFW_alloc_deltaW, &
       &                                m_TFW_dealloc_deltaV, &
       &                                m_TFW_dealloc_deltaW, &
       &                                m_TFW_init_Psi, &
       &                                Vin_tfw, Vlda_tfw, Vout_tfw, &
       &                                m_TFW_Kerker_mixing, &
       &                                m_TFW_calc_phi_MatH_phi

  use m_Total_Energy,  only : get_local_potential_energy_3D, get_hartree_energy_3D, &
       &                      ene_hartree => ehartr, &
       &                      ene_local  => elocal, m_TE_what_is_edeltb_now
  use m_XC_Potential,  only : ene_exc => exc

  use m_IterationNumbers,    only : iteration_electronic
  use m_Ionic_System,       only : natm
  use m_Electronic_Structure,  only : vlhxc_l, vlhxc_l_old, vlhxcQ, totch, dhub_aimag

  use m_Files,       only : nfout
  use m_Parallelization, only : mype, ista_kngp, iend_kngp
  use m_Charge_Density,  only : m_CD_cp_chgq_to_chgqo, chgq_l
  use m_CD_Mixing,       only : rmxtrc

  use m_IterationNumbers,    only : iteration_electronic, iteration_ionic
  use m_PlaneWaveBasisSet,  only : kg, kg1, kg_tfw
  use m_PseudoPotential,   only : flg_paw
  use m_Potential_Mixing,  only : vnonlocal_i,  m_Pot_add_vnonlocal_to_vlhxcQ
  use m_ES_Intgr_VlhxcQlm,   only : m_ESiVQ_integrate_VlhxcQlm_3D
  use m_ES_NonCollinear,   only : m_ES_update_Mat_dion0_noncl, &
       &                          m_ES_set_Mat_dion_scr_noncl
  use m_Orbital_Population,    only :  m_OP_cp_om_to_ommix

  implicit none

! -----------
! variables
! -----------
  logical :: reset_cg
  integer :: niter, succession
  integer :: max_iter, i, flag, is
  integer :: iprinegativecharge_save

  real(kind=DP) :: zeta_product, zeta_product_old
  real(kind=DP) :: Ene(2), Ene_old, deltaE, E_first
  real(kind=DP) :: ekin_TF, ekin_Weiz, ene_deltaW, ene_deltaV
  real(kind=DP) :: ene_nonlocal_avg, dx
  real(kind=DP) :: psi_MatH_psi, phi_MatH_psi, phi_MatH_phi, theta
  real(kind=DP) :: threshold0, threshold1, threshold2
  real(kind=DP) :: edeltab_per_atom, edelta, zeta_norm, rmxt

  real(kind=DP), allocatable :: chgq_l_save(:,:,:)

! -----------
! parameters 
! -----------
  integer, parameter :: linmin_method = 2
  real(kind=DP), parameter :: min_zeta_norm = 1.0D-8

! --------------------------
!!
!!! initialization
!!
! --------------------------
  if ( sw_modified_TFW_functional == OFF ) return

!-----------------------------------------------------
!  if ( iteration_electronic < 5 ) return
  if ( iteration_electronic < 3 ) return
! --------------------------------------------------

  max_iter   = max_iteration_loop
  threshold0 = threshold_enter_loop
  threshold1 = threshold_skip_loop
  threshold2 = threshold_exit_loop

  edelta = m_TE_what_is_edeltb_now()
  edeltab_per_atom = m_TE_what_is_edeltb_now() / natm
  edeltab_per_atom = abs(edeltab_per_atom )

  if ( edeltab_per_atom > threshold0 ) return
  if ( edeltab_per_atom < threshold1 ) return

! --------------------------
!!
!!! set arrays for TFW 
!!
! --------------------------
  call m_TFW_CGoptimize_init
  if ( use_deltaW ) call m_TFW_alloc_deltaW
  if ( use_deltaV ) call m_TFW_alloc_deltaV

!!!!!!!!!  call m_TFW_remove_negative_charge
  call m_TFW_init_Psi

  if ( use_averaged_nonlocal ) then
     if ( sw_spherical_averaged_nonlocal == OFF ) then
        call m_TFW_calc_nonlocal_pot_avg_A
     else
        call m_TFW_calc_nonlocal_pot_avg_B
     endif
  endif

! 
! ---- Now, chgq_l (vlhxc_l) is the variable set after charge/potential mixing --
!
  if ( sw_potential_mixing == ON ) then
     Vout_tfw = vlhxc_l
  else
     call Renewal_of_Potential
     Vout_tfw = vlhxc_l
  endif

  if ( use_deltaW ) call m_TFW_calc_deltaW
  if ( use_deltaV ) call set_deltaV

  if ( sw_potential_mixing == OFF ) then
     allocate( chgq_l_save(ista_kngp:iend_kngp,kimg,nspin) )
     chgq_l_save = chgq_l
  endif

  iprinegativecharge_save = iprinegativecharge
  iprinegativecharge = 0
! --------------------------
!!
!!!  start scf loop 
!!
! --------------------------
  niter = 0;   succession = 0

  zeta_product_old = 0.0d0;  
  Ene_Old = 0.0d0;  deltaE = 0.0d0;

  vlhxc_l = Vin_tfw
! -----------
!
  do while (.true.)
     call m_TFW_calc_SD_direction( psi_MatH_psi, zeta_product )
     zeta_norm = zeta_product /totch
     if ( zeta_norm < min_zeta_norm ) then
        if ( mype == 0 ) then
           write(nfout,'(A,E12.5,A,E12.5)') "!** zeta_norm ", zeta_norm, &
                &                           " is lower than ", min_zeta_norm
        endif
        goto 1000
     endif

     call m_TFW_store_Psi
     call m_TFW_try_new_Psi_and_charge( 0.0d0 )        ! for numerical accuracy

     call m_TFW_calc_energy_terms( ekin_TF, ekin_Weiz, &
          &                        ene_nonlocal_avg, ene_deltaV, ene_deltaW )
     call Renewal_of_Potential
     call get_local_potential_energy_3D
     call get_hartree_energy_3D


     Ene(1) = ekin_TF +ekin_Weiz +ene_local +ene_hartree +ene_exc &
          &       +ene_nonlocal_avg  +ene_deltaV +ene_deltaW
     deltaE = ( Ene(1) -Ene_Old ) /dble(natm)

     if ( printable .and. ipritfwfunc >=2 ) then
        if ( mype == 0 )then
           write(nfout,*) "**** TFW functional info ***"
           write(nfout,*) "!- iter.   TF        Weiz     local    Hartree     Exc     AvgNonl    dV     dW"
           write(nfout,'(I7,8F10.4)') niter, ekin_TF, ekin_Weiz, &
                &                     ene_local, ene_hartree, &
                &                     ene_exc, ene_nonlocal_avg, ene_deltaV, ene_deltaW

           write(nfout,*) "!  iter.   Total      deltaE"
           write(nfout,'(I7,F15.6,E15.6)') niter, Ene(1), deltaE
           write(nfout,*) "**** *** ***"
        endif
     endif

     if ( abs(deltaE) < threshold2 )  succession = succession  +1
     if ( succession == 2 ) exit 

#if 0
     if ( niter == 0 ) E_first = Ene(1)
     if ( Ene(1) > E_first ) exit
#endif

! ------------
     reset_cg = .false.
!     if ( mod(niter,20) == 0 ) reset_cg = .true.
     if ( niter == 0 ) reset_cg = .true.
     
     call m_TFW_calc_CG_direction( reset_cg, zeta_product, zeta_product_old, &
          &                        phi_MatH_psi )
#if 0
     call check_differential
     stop
#endif

     select case (linmin_method)
     case(1)
        call line_minimization_rough( dx )
     case(2)
        call line_minimization_accurate( dx )
     end select

     if ( printable .and. ipritfwfunc >=2 ) then
        if ( mype == 0 ) write(nfout,*) '!! dx for psi update = ', dx
     endif
     call m_TFW_try_new_Psi_and_charge( dx )

     call Renewal_of_Potential

! -------------
     zeta_product_old = zeta_product
     ene_old = Ene(1)

     niter = niter + 1
     if ( niter == max_iter ) exit
  End do

1000  continue

  call m_TFW_CGoptimize_finalize
  call m_TFW_dealloc_deltaV
  call m_TFW_dealloc_deltaW

  call Renewal_of_Potential

! --------------------------
!!
!!!  set next chgq_l/vlhxc_l 
!!
! --------------------------
  rmxt = m_CtrlP_rmx_now(iteration_electronic, iteration_ionic)

  if ( sw_potential_mixing == ON ) then
     call m_TFW_Kerker_mixing( Vout_tfw, vlhxc_l, rmxt )   
  else
     call m_TFW_Kerker_mixing( chgq_l_save, chgq_l, rmxt )  
  endif

  call recover_higer_G_terms

  if ( sw_potential_mixing == OFF ) then

     call Renewal_of_Potential
  endif

! --------------------------
!!
!!!  set next vlhxcQ and related variables
!!
! --------------------------
  if ( sw_potential_mixing == ON ) then
     call update_nonlocal_for_potmix
  else
     call update_nonlocal_for_chgmix
  endif

  if ( allocated( chgq_l_save ) ) deallocate( chgq_l_save )

  iprinegativecharge = iprinegativecharge_save

contains

  subroutine line_minimization1( x )
    real(kind=DP), intent(out) :: x
    
    real(kind=DP) :: c1, c2
    
    call m_TFW_calc_phi_MatH_phi( phi_MatH_phi )
    c1 = psi_MatH_psi -phi_MatH_phi
    c2 = 2.0d0 *phi_MatH_psi
    x = atan(c2/c1) /2.0d0

  end subroutine line_minimization1
  
  subroutine line_minimization_rough( x )
    real(kind=DP), intent(out) :: x
    
    real(kind=DP) :: x0, c1, c2
    
    x0 = 1.0d0
    
    call m_TFW_try_new_Psi_and_charge( x0 )
    call m_TFW_calc_energy_terms( ekin_TF, ekin_Weiz, &
         &                        ene_nonlocal_avg, ene_deltaV, ene_deltaW )
    call Renewal_of_Potential
    call get_local_potential_energy_3D
    call get_hartree_energy_3D
    Ene(2) = ekin_TF +ekin_Weiz +ene_local +ene_hartree +ene_exc &
         &       +ene_nonlocal_avg +ene_deltaV +ene_deltaW

    c2 = phi_MatH_psi *2.0d0
    c1 = ( Ene(2) - c2 *x0 - Ene(1) ) / x0**2
    x = -c2 /c1/2.0d0
  end subroutine line_minimization_rough
  
  subroutine line_minimization_accurate( x )
    real(kind=DP), intent(out) :: x

    real(kind=DP) :: dx, df, d2f
    real(kind=DP), parameter :: x0 = 0.10d0

    integer :: num

    num = 0;  x = x0;   dx = 0.0d0
    Do while (.true.)
       call calc_df_and_d2f( x, df, d2f )
       dx = -df / abs(d2f);    x = x +dx

       if ( ipritfwfunc >=3 ) then
          if ( mype == 0 ) write(nfout,*) 'xnew = ', x
       endif
       num = num +1
       if ( num > max_iter_linmin ) exit
       if ( abs(dx) < threshold_linmin ) exit
    End do
    if ( dx > x0)  dx =  x0
    if ( dx <-x0 ) dx = -x0

  end subroutine line_minimization_accurate

  subroutine calc_df_and_d2f( x, df, d2f )
    real(kind=DP), intent(in) :: x
    real(kind=DP), intent(out) :: df, d2f
    real(kind=DP) :: dx, x1, x2, x3, e1, e2, e3

    dx = 1.0D-3
    x1 = x -dx;  x2 = x;  x3 = x + dx

    call m_TFW_try_new_Psi_and_charge( x1 )
    call m_TFW_calc_energy_terms( ekin_TF, ekin_Weiz, &
         &                        ene_nonlocal_avg, ene_deltaV, ene_deltaW )
    call Renewal_of_Potential
    call get_local_potential_energy_3D
    call get_hartree_energy_3D
    e1 = ekin_TF +ekin_Weiz +ene_local +ene_hartree +ene_exc &
         &       +ene_nonlocal_avg +ene_deltaV +ene_deltaW

    call m_TFW_try_new_Psi_and_charge( x2 )
    call m_TFW_calc_energy_terms( ekin_TF, ekin_Weiz, &
         &                        ene_nonlocal_avg, ene_deltaV, ene_deltaW )
    call Renewal_of_Potential
    call get_local_potential_energy_3D
    call get_hartree_energy_3D
    e2 = ekin_TF +ekin_Weiz +ene_local +ene_hartree +ene_exc &
         &       +ene_nonlocal_avg +ene_deltaV +ene_deltaW

    call m_TFW_try_new_Psi_and_charge( x3 )
    call m_TFW_calc_energy_terms( ekin_TF, ekin_Weiz, &
         &                        ene_nonlocal_avg, ene_deltaV, ene_deltaW )
    call Renewal_of_Potential
    call get_local_potential_energy_3D
    call get_hartree_energy_3D
    e3 = ekin_TF +ekin_Weiz +ene_local +ene_hartree +ene_exc &
         &       +ene_nonlocal_avg +ene_deltaV +ene_deltaW

    df = ( e3 -e1 ) / (2.0d0*dx)
    d2f = ( e1 +e3 -2.d0 *e2 ) /dx**2

  end subroutine calc_df_and_d2f

  subroutine check_differential
    real(kind=DP) :: x0

    x0 = 1.0D-5
    
    call m_TFW_try_new_Psi_and_charge( x0 )
    call m_TFW_calc_energy_terms( ekin_TF, ekin_Weiz, &
         &                        ene_nonlocal_avg, ene_deltaV, ene_deltaW )
    call Renewal_of_Potential
    call get_local_potential_energy_3D
    call get_hartree_energy_3D
    Ene(2) = ekin_TF +ekin_Weiz +ene_local +ene_hartree +ene_exc &
         &       +ene_nonlocal_avg +ene_deltaV +ene_deltaW
!
    if ( mype == 0 ) then
       write(nfout,*) 'EDiff numerical, analtical =', &
            &                  (Ene(2)-Ene(1))/x0, 2*phi_MatH_Psi
    endif

  end subroutine check_differential

  subroutine update_nonlocal_for_chgmix

    call Renewal_of_Potential

    if (sw_hubbard==ON) then
!       call Renewal_of_Hubbard_Parameters
       call Renewal_of_Hubbard_Potential
    end if

  end subroutine update_nonlocal_for_chgmix

  subroutine update_nonlocal_for_potmix
    call m_ESiVQ_integrate_VlhxcQlm_3D(nfout) ! (lclchh) -> vlhxcQ
    call m_Pot_add_vnonlocal_to_vlhxcQ

    if ( noncol ) then
       if ( flg_paw ) then
          if ( ekmode==ON .or. iteration_electronic >= 1 ) then
             call m_ES_update_Mat_dion0_noncl
          endif
       endif
       call m_ES_set_Mat_dion_scr_noncl( VlhxcQ, vnonlocal_i )
    endif
  end subroutine update_nonlocal_for_potmix

  subroutine recover_higer_G_terms
    integer :: i

    if ( sw_potential_mixing == ON ) then
       Do i=ista_kngp, iend_kngp
          if ( i > kg_tfw ) then
             vlhxc_l(i,:,:) = vout_tfw(i,:,:)
          endif
       End do
    else
       Do i=ista_kngp, iend_kngp
          if ( i > kg_tfw ) then
             chgq_l(i,:,:) = chgq_l_save(i,:,:)
          endif
       End do
    endif
  end subroutine recover_higer_G_terms

  subroutine set_deltaV
    integer :: which_deltaV

    if ( sw_potential_mixing == ON ) then
       which_deltaV = 1
    else
       which_deltaV = 3
    endif

    select case (which_deltaV)
    case (1)
       deltaV = vout_tfw -vlda_tfw     
    case (2)
       deltaV = -( vout_tfw -vlda_tfw )
    case (3)
       deltaV = vout_tfw -vin_tfw  
    case (4) 
       deltaV = -( vout_tfw -vin_tfw )
    end select

  end subroutine set_deltaV

end subroutine ThomasFermiWeiz_loop

!
! =========== Contributions ===================================
!
! Through the courtesy of contributors, the following functions are added.
!
! Company:  ASMS Co.,Ltd.
! Functions:  [Identifier: 13.1R]
!            Dielectric functions can be calculated when condition = INITIAL 
!
! Functions:  [Identifier: 13.1XI]
!            Dielectric functions can be calculated in the EXCITATION module
!
! =============================================================
subroutine Epsilon_Postscf

  use m_Const_Parameters, only : ON
  use m_Control_Parameters,  only : sw_phonon_with_epsilon, sw_excitation
  use m_Epsilon_ek,  only : sw_epsilon

  implicit none

!  if ( sw_phonon_with_epsilon == ON ) then
     if ( sw_epsilon == ON ) then
        call using_epsilon_ek
     else if ( sw_excitation == ON ) then
        call using_excitation
     endif
!  else
!     if ( sw_excitation == ON ) call using_excitation
!     if ( sw_epsilon == ON )    call using_epsilon_ek
!  endif


end subroutine Epsilon_Postscf

subroutine using_epsilon_ek

  use m_Control_Parameters, only : sw_phonon_with_epsilon
  use m_Const_Parameters,  only : on

  use m_KPoints, only : kv3, kv3_ek, m_Kp_cp_vkxyz_to_vkxyz_ek, &
       &                m_Kp_alloc_kpoints_ek
  use m_IterationNumbers, only : nk_in_the_process, nk_converged
!
  use m_Electronic_Structure, only : m_ES_cp_eko_l_to_eko_ek2, &
       &                             m_ES_alloc_eko_ek

  use m_Epsilon_ek,  only : set_dielectric_tensor
  use m_Raman,  only : m_Raman_write_dielec_tensors

  implicit none

  logical, save :: FirstFlag = .true.

  nk_in_the_process = 1
  nk_converged = kv3

  call m_Kp_alloc_kpoints_ek
  call m_Kp_cp_vkxyz_to_vkxyz_ek
  call m_ES_alloc_eko_ek
  call m_ES_cp_eko_l_to_eko_ek2
!
  if ( FirstFlag ) then
     call Initialization_Epsilon
     FirstFlag = .false.
  endif

  call Transition_moment_Epsilon
  call Prep_for_Calc_Epsilon
  call Calc_Epsilon
  call Calc_Nonlinear_optics

  if ( sw_phonon_with_epsilon  == ON ) then
     call set_dielectric_tensor
     call m_Raman_write_dielec_tensors
  else
     call WriteDownData_onto_Files_Eps
  endif

end subroutine Using_epsilon_ek

subroutine using_excitation
  use m_Const_Parameters,  only : ON, CMPLDP
  use m_Control_Parameters,  only : sw_phonon_with_epsilon, sw_use_add_proj, &
       &                            sw_corelevel_spectrum

  use m_Excitation,  only : m_XI_set_ilmt_val, m_XI_init_spectrum, &
       &                    m_XI_set_ngpt_XI, &
       &                    m_XI_set_qitg_XI_vv, &
       &                    m_XI_set_dl2p_XI_vv, &
       &                    m_XI_set_mat_dipole_corr_vv, &
       &                    m_XI_calc_transition_moment_vv, &
       &                    m_XI_set_RhoTilde_vv, &
       &                    m_XI_calc_spectr_fn_vv, &
       &                    m_XI_calc_spectr_tensor_vv, &
       &                    SpectrFn_vv, SpectrTensor_vv, &
       &                    m_XI_set_qitg_XI_vc, &
       &                    m_XI_set_dl2p_XI_vc, &
       &                    m_XI_set_ilmt_core, &
       &                    m_XI_set_mat_dipole_corr_vc, &
       &                    m_XI_calc_transition_moment_vc,  &
       &                    m_XI_set_RhoTilde_vc, &
       &                    m_XI_calc_spectr_fn_vc, &
       &                    m_XI_calc_transition_moment_cc,  &
       &                    m_XI_set_RhoTilde_cc, &
       &                    m_XI_dealloc_arrays, &
       &                    SpectrFn_vc, &
       &                    nstep, e_step, sw_tddft, sw_bse, &
       &                    Kernel_Coulomb, m_XI_set_Kernel_Coulomb, epsinv_omega0, &
       &                    sw_spin_decomposition, m_XI_calc_spectr_fn_vv_spindec

  use m_ValenceBand_Spectrum,  only : m_VBS_set_data_ppc_from_pp
  use m_CoreLevel_Spectrum,   only : m_CLS_set_data_core2val_from_pp, &
       &                             m_CLS_alloc_wfn_core_states, &
       &                             m_CLS_set_wfn_core_states, &
       &                             m_CLS_set_corelevels_virtually, &
       &                             m_CLS_set_ene_core_states

  use m_ES_nonlocal,    only : m_ES_add_betar_dot_WFs
  use m_Files,  only : nfout
  use m_Raman,  only : dielectric, m_Raman_write_dielec_tensors
  use m_Kpoints,  only : m_Kp_set_star_of_k

  implicit none

  if ( sw_phonon_with_epsilon == ON ) then        ! nmax_G == 1
     call case_phonon_with_epsilon
  else
     call case_epsilon_fn
  endif

contains

  subroutine case_phonon_with_epsilon
    logical :: First = .true.

    if ( First ) then
       call m_Kp_set_star_of_k
       call m_XI_set_ilmt_val
       call m_VBS_set_data_ppc_from_pp
       call m_XI_set_mat_dipole_corr_vv
       call m_XI_init_spectrum
       First = .false.
    endif

    if ( sw_use_add_proj == ON ) call m_ES_add_betar_dot_WFs(nfout)

    call m_XI_calc_transition_moment_vv
    call m_XI_calc_spectr_tensor_vv

#ifdef USE_ASMS_EXCITATION
    call ASMS_XI_set_dielectric_tensor( SpectrTensor_vv, dielectric )
#endif

    call m_Raman_write_dielec_tensors

  end subroutine case_phonon_with_epsilon

  subroutine case_epsilon_fn
    integer :: i

    logical :: First = .true.

    if ( First ) then
       call m_Kp_set_star_of_k
       call m_XI_set_ilmt_val
       call m_XI_set_ngpt_XI
!
       if ( sw_corelevel_spectrum == ON ) then
          call m_CLS_set_data_core2val_from_pp
          call m_CLS_alloc_wfn_core_states
          call m_CLS_set_wfn_core_states
!          call m_CLS_set_corelevels_virtually
          call m_CLS_set_ene_core_states
          call m_XI_set_ilmt_core
          call m_XI_set_mat_dipole_corr_vc
!
          call m_XI_set_qitg_XI_vc
          call m_XI_set_dl2p_XI_vc

          if ( sw_bse == ON ) then
             call m_VBS_set_data_ppc_from_pp
             call m_XI_set_mat_dipole_corr_vv
          endif
       else
          call m_XI_set_qitg_XI_vv
          call m_XI_set_dl2p_XI_vv
          call m_VBS_set_data_ppc_from_pp
          call m_XI_set_mat_dipole_corr_vv
       endif

       call m_XI_init_spectrum
       First = .false.
    endif

    if ( sw_use_add_proj == ON ) call m_ES_add_betar_dot_WFs(nfout)

    if ( sw_corelevel_spectrum == ON ) then
       if ( sw_bse == ON ) then
          call m_XI_calc_transition_moment_vv
          call m_XI_calc_transition_moment_vc
          call m_XI_calc_transition_moment_cc
          call m_XI_set_RhoTilde_vv
          call m_XI_set_RhoTilde_vc
          call m_XI_set_RhoTilde_cc

          call m_XI_calc_spectr_fn_vv
          call m_XI_set_Kernel_Coulomb
#ifdef USE_ASMS_EXCITATION
          call ASMS_XI_epsinv_omg0_fr_spctrfn( SpectrFn_vv, Kernel_Coulomb, &
               &                               epsinv_omega0 )
#endif

       else if ( sw_tddft == ON ) then
          call m_XI_calc_transition_moment_vc
          call m_XI_set_RhoTilde_vc
          call m_XI_calc_spectr_fn_vc
          call m_XI_set_Kernel_Coulomb
#ifdef USE_ASMS_EXCITATION
          call ASMS_XI_calc_tddft_spectrum( SpectrFn_vc, Kernel_Coulomb )
#endif
       else
          call m_XI_calc_transition_moment_vc
          call m_XI_calc_spectr_fn_vc
#ifdef USE_ASMS_EXCITATION
          call ASMS_XI_calc_indep_spectrum( SpectrFn_vc )
#endif
       endif

    else
       if ( sw_bse == ON ) then
          call m_XI_calc_transition_moment_vv
          call m_XI_set_RhoTilde_vv
          call m_XI_calc_spectr_fn_vv
          call m_XI_set_Kernel_Coulomb
#ifdef USE_ASMS_EXCITATION
          call ASMS_XI_epsinv_omg0_fr_spctrfn( SpectrFn_vv, Kernel_Coulomb, &
               &                               epsinv_omega0 )
#endif
          stop "PPP"
       else if ( sw_tddft == ON ) then
          call m_XI_calc_transition_moment_vv
          call m_XI_set_RhoTilde_vv

!!          call m_XI_calc_spectr_fn_vv
          if ( sw_spin_decomposition == ON ) then
             call m_XI_calc_spectr_fn_vv_spindec
          else
             call m_XI_calc_spectr_fn_vv
          endif

          call m_XI_set_Kernel_Coulomb
#ifdef USE_ASMS_EXCITATION
          call ASMS_XI_calc_tddft_spectrum( SpectrFn_vv, Kernel_Coulomb )
#endif
       else
          call m_XI_calc_transition_moment_vv

!!          call m_XI_calc_spectr_fn_vv

          if ( sw_spin_decomposition == ON ) then
             call m_XI_calc_spectr_fn_vv_spindec
          else
             call m_XI_calc_spectr_fn_vv
          endif
#ifdef USE_ASMS_EXCITATION
          call ASMS_XI_calc_indep_spectrum( SpectrFn_vv )
#endif
       endif
    endif

  end subroutine case_epsilon_fn

end subroutine Using_excitation

!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 440 $)
!
!  PROGRAM: TDLRMAIN
!
!  AUTHOR(S): K. Tagami et al   Aug. 1 2011
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is a collection of subroutines for calculating exchange correlation kernels.
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.  
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

!------------------------------------------------------------------
!!
!!!        Calc Ex on the mesh   (GGAPBE96)
!!
!-------------------------------------------------------------------
subroutine calc_kt_ex_ggapbe( nspin, ispin, chgrhr_l, grad_rho, f2or1, &
     &                        ktmp_ex )

  use m_Const_Parameters,  only : PAI, PAI4, DP
  use m_Parallelization,   only : ista_fftph, iend_fftph
  use m_Crystal_Structure, only : univol

  implicit none

  integer,intent(in)        :: nspin,ispin
  real(kind=DP),intent(in)  :: chgrhr_l(ista_fftph:iend_fftph,ispin)
  real(kind=DP),intent(in)  :: grad_rho(ista_fftph:iend_fftph,nspin)
  real(kind=DP),intent(in)  :: f2or1(ista_fftph:iend_fftph)
  real(kind=DP),intent(out) :: ktmp_ex(ista_fftph:iend_fftph,nspin)
!-------------------------
  if ( ispin==1 ) then
     call ktmp_exchange_spinless
  else
     call ktmp_exchange_polarized
  endif

contains
  
  subroutine ktmp_exchange_spinless
    integer        :: is, i
    real(kind=DP)  :: ctmp1, ctmp2

!    real(kind=DP)  :: density_minimum = 1.0d-20
!    real(kind=DP)  :: density_minimum = 1.0d-6
!    real(kind=DP)  :: density_minimum = 1.0d-8
!    real(kind=DP)  :: density_minimum = 1.0d-12
    real(kind=DP)  :: density_minimum = 1.0d-5
!!
    real(kind=DP) :: fac1, fac2, rho, grho, kf, s, exunif
    real(kind=DP) :: Fx, dFx_ds, d2Fx_ds2
    real(kind=DP) :: ds_drho, d2s_drho2
! ------------------------------ start -------------
    fac1 = ( 3.0d0 *PAI**2 )**(1./3.)
    fac2 = -3.0d0 / PAI4
! ---------------------------- main ---------------
    do is = 1, ispin
       do i = ista_fftph, iend_fftph
          if ( chgrhr_l(i,is) < density_minimum ) cycle
          rho = chgrhr_l(i, is)
          grho = grad_rho(i,is)

          kf = fac1 *rho**(1./3.)
          s = grho / 2.0d0 / kf /rho

          exunif = fac2 *kf
          call derivative_Fx_s( s, Fx, dFx_ds, d2Fx_ds2 )
          call derivaitive_s_rho( rho, s, ds_drho, d2s_drho2 )

          ktmp_ex(i,is ) = exunif *Fx
       End do
    End do
  end subroutine ktmp_exchange_spinless

  subroutine ktmp_exchange_polarized
    integer        :: is, i
    real(kind=DP)  :: ctmp1, ctmp2

!    real(kind=DP)  :: density_minimum = 1.0d-20
!    real(kind=DP)  :: density_minimum = 1.0d-6
!    real(kind=DP)  :: density_minimum = 1.0d-8
    real(kind=DP)  :: density_minimum = 1.0d-12
!!
    real(kind=DP) :: fac1, fac2, rho, grho, kf, s, exunif
    real(kind=DP) :: Fx, dFx_ds, d2Fx_ds2
    real(kind=DP) :: ds_drho, d2s_drho2
! ---------------------------------start ----------------    
    fac1 = ( 3.0d0 *PAI**2 )**(1./3.)
    fac2 = -3.0d0 / PAI4
! ---------------------------------- main ---------
    do is = 1, ispin
       do i = ista_fftph, iend_fftph
          if ( chgrhr_l(i,is) < density_minimum ) cycle
          rho = chgrhr_l(i, is)*2.0d0
          grho = grad_rho(i,is)*2.0d0

          kf = fac1 *rho**(1./3.)
          s = grho / 2.0d0 / kf /rho

          exunif = fac2 *kf
          call derivative_Fx_s( s, Fx, dFx_ds, d2Fx_ds2 )
          call derivaitive_s_rho( rho, s, ds_drho, d2s_drho2 )

          ktmp_ex(i,is ) = exunif* Fx
       End do
    End do
  end subroutine ktmp_exchange_polarized

  subroutine derivaitive_s_rho( rho, s, fn1, fn2 )
    Real(kind=DP), intent(in) :: s, rho
    Real(kind=DP), intent(out) ::fn1, fn2

    fn1 = -4.0D0 /3.0D0  * s /rho               ! ds / drho
    fn2 = -7.0D0 /3.0D0  *fn1 /rho          ! d2s / drho2
  end subroutine derivaitive_s_rho

  subroutine derivative_Fx_s( s, fn0, fn1, fn2 )
    Real(kind=DP), intent(in) :: s
    Real(kind=DP), intent(out) ::fn0, fn1, fn2
    
    Real(kind=DP) :: stmp1, c1, c2
    Real(kind=DP) :: kappa, mu
    Parameter( kappa = 0.804D0,  mu = 0.21951D0 )
! --------------------------------------------    
    stmp1 = s*s
    c1 = 1.0D0 + mu *stmp1 / kappa
    c2 = 1.0D0 - 3.0d0 *mu *stmp1 / kappa
    
    fn0 = 1.0D0 + kappa - kappa / c1
    fn1 = 2.0D0 *mu *s /c1**2                         ! dFx / ds
    fn2 = 2.0D0 *mu *c2 /c1**3                        ! d2Fx / ds2
  end subroutine derivative_Fx_s

end subroutine calc_kt_ex_ggapbe

!------------------------------------------------------------------
!!
!!!        Calc Ec on the mesh   (GGAPBE96)
!!
!-------------------------------------------------------------------
subroutine calc_kt_cr_ggapbe( nspin, ispin, chgrhr_l, grad_trho, f2or1, &
     &                          ktmp_cr )
  use m_Const_Parameters,  only : PAI, PAI4, DP
  use m_Parallelization,   only : ista_fftph, iend_fftph
  use m_Crystal_Structure, only : univol

  implicit none

  integer,intent(in)        :: nspin,ispin
  real(kind=DP),intent(in)  :: chgrhr_l(ista_fftph:iend_fftph,ispin)
  real(kind=DP),intent(in)  :: grad_trho(ista_fftph:iend_fftph)
  real(kind=DP),intent(in)  :: f2or1(ista_fftph:iend_fftph)
  real(kind=DP),intent(out) :: ktmp_cr(ista_fftph:iend_fftph,nspin,nspin)

! --------------------------------
  Real(kind=DP) :: beta, gamma
  Parameter( beta = 0.066725D0, gamma = 0.031091D0 )
!-------------------------
  if ( ispin==1 ) then
     call ktmp_correlation_spinless
  else
     call ktmp_correlation_polarized
  endif

contains

  subroutine ktmp_correlation_spinless
!    real(kind=DP)  :: density_minimum = 1.0d-20
!    real(kind=DP)  :: density_minimum = 1.0d-6
!    real(kind=DP)  :: density_minimum = 1.0d-8
!    real(kind=DP)  :: density_minimum = 1.0d-12
    real(kind=DP)  :: density_minimum = 1.0d-5
! ---------------
    Real(kind=DP) :: rho, grho, ks, kf, rs, t
    real(kind=DP) :: fac1, fac2
    real(kind=DP) :: ec, dec_drs, d2ec_drs2
    real(kind=DP) :: H, dH_drs_tot, d2H_drs2_tot
    Real(kind=DP) :: c1, ctmp1
! 
    integer       :: i
! ------------------------------ start ---------
    fac1 = ( 3.0d0 *PAI**2 )**(1./3.)
    fac2 = -3.0d0 / PAI4
! ----------------------------- main ------------
    Do i = ista_fftph, iend_fftph
       rho  = chgrhr_l(i,1)
       grho = grad_trho(i)

       if ( rho < density_minimum ) cycle

       kf = fac1 *rho**(1.00/3.0d0)
       ks = ( 4.0d0*kf /PAI )**(1.0d0/2.0d0)
       t = abs(grho) / 2.0d0 / ks /rho
       rs   = ( 3.0d0 / PAI4 / rho )**(1.0d0/3.0d0)

       call differential_ec_rs_only( rs, ec, dec_drs, d2ec_drs2 )
       call differeintial_HPBE_rs_only( rs, t, ec, dec_drs, d2ec_drs2, &
            &                           H, dH_drs_tot, d2H_drs2_tot )

       c1 = rs /3.0d0
       ctmp1 = -c1*( dec_drs + dH_drs_tot - c1*d2ec_drs2 - c1*d2H_drs2_tot )
       ktmp_cr( i,1,1 ) = ec +H
    End do
  end subroutine ktmp_correlation_spinless
  
  subroutine ktmp_correlation_polarized
    write(*,*) '!!!!!! Correlation Kernel for GGAPBE96 is not supported '
    stop
  end subroutine ktmp_correlation_polarized

  subroutine differeintial_HPBE_rs_only( rs, t, ec, dec_drs, d2ec_drs2, &
       &                                 f0, f1, f2 )
     Real(kind=DP), intent(in) :: rs, t, ec, dec_drs, d2ec_drs2
     Real(kind=DP), intent(out) :: f0, f1, f2

     Real(kind=DP) :: t2, t4, At2, A2t4
     Real(kind=DP) :: dt_drs, d2t_drs2
     Real(kind=DP) :: A, dA_drs, d2A_drs2
!
     Real(kind=DP) :: dH_drs, d2H_drs2, dH_dt, d2H_dt2
     Real(kind=DP) :: d2H_drsdt
     Real(kind=DP) :: kfn, dkfn_drs, d2kfn_drs2
     Real(kind=DP) :: dkfn_dt, d2kfn_dt2
     Real(kind=DP) :: d2kfn_drsdt
!
     Real(kind=DP) :: ctmp1
     Real(kind=DP) :: phi, gphi3
! ----------------------------- experimental---------------------
     Real(kind=DP) :: prefactor1
     prefactor1 = 0.5d0
! ------------------------- start -----------------------------
     phi = 1.0d0;    gphi3 = gamma *phi**3
! -------------------------------------------------------------
     call derivative_t_rs( rs, t, dt_drs, d2t_drs2 )
     call derivative_A_rs( rs, ec, dec_drs, d2ec_drs2, A, dA_drs, d2A_drs2 )
     call derivative_kfunc1_rs_t( rs, t, A, dA_drs, d2A_drs2, &
          &                       kfn, dkfn_drs, d2kfn_drs2, &
          &                       dkfn_dt,  d2kfn_dt2, &
          &                       d2kfn_drsdt ) 
     ctmp1 = 1.0d0 +kfn
! 
     dH_drs = gphi3 * dkfn_drs / ctmp1
     d2H_drs2 = gphi3 *( -dkfn_drs**2 /ctmp1**2 + d2kfn_drs2 /ctmp1 )

     dH_dt = gphi3 *dkfn_dt / ctmp1
     d2H_dt2 = gphi3 *( -dkfn_dt**2 /ctmp1**2 + d2kfn_dt2 /ctmp1 )

     d2H_drsdt = gphi3*( -dkfn_drs *dkfn_dt /ctmp1**2 + d2kfn_drsdt /ctmp1 )
! ---------
     f0  = gphi3 *log( ctmp1 )
     f1 = dH_drs + dt_drs * dH_dt              ! total derivative
     f2 = d2H_drs2 + 2.0d0 *dt_drs *d2H_drsdt &
          & + d2t_drs2 *dH_dt + dt_drs**2 *d2H_dt2 
! ---------------------------- experimental --------
     f2 = f2 + d2t_drs2 *dH_dt *prefactor1            ! naze ? 0.5
! --------------------------------------------------
   end subroutine differeintial_HPBE_rs_only

   subroutine derivative_kfunc1_rs( rs, t, A, dA_drs, d2A_drs2, f0, f1, f2 )
     Real(kind=DP), intent(in) :: rs, t, A, dA_drs, d2A_drs2
     Real(kind=DP), intent(out) :: f0, f1, f2
!
     Real(kind=DP) :: t2, t4, At2, A2t4, A3t6
     Real(kind=DP) :: q1, q2
     Real(kind=DP) :: ctmp1, ctmp2, ctmp3
!----------------------------- start ------------
     t2 = t*t;  t4 = t2**2
     At2 = A *t2;    A2t4 = At2 **2;  A3t6 = A2t4 *At2

     q1 = 1.0D0 + At2;  q2 = q1 + A2t4
! ----
     ctmp1 = beta /gamma *t2
     ctmp2 = t2*( -2.0d0 *At2 - A2t4 )
     ctmp3 = t4*( -2.0d0 + 6.0d0 *A2t4 + 2.0d0*A3t6 )
! ---------------------------------------------
     f0 = ctmp1 * q1/q2
     f1 = ctmp1 *ctmp2 / q2**2 *dA_drs
     f2 = ctmp1 *( ctmp3 /q2**3 *dA_drs**2 + ctmp2 *d2A_drs2 )
   end subroutine derivative_kfunc1_rs

   subroutine derivative_kfunc1_rs_t( rs, t, A, dA_drs, d2A_drs2, &
        &                               kfn, dkfn_drs, d2kfn_drs2, &
        &                               dkfn_dt, d2kfn_dt2, &
        &                               d2kfn_drsdt )
     Real(kind=DP), intent(in) :: rs, t, A, dA_drs, d2A_drs2
     Real(kind=DP), intent(out) :: kfn, dkfn_drs, d2kfn_drs2
     Real(kind=DP), intent(out) :: dkfn_dt, d2kfn_dt2
     Real(kind=DP), intent(out) :: d2kfn_drsdt
!
     Real(kind=DP) :: t2, t4, At2, A2t4, A3t6
     Real(kind=DP) :: q1, q2
     Real(kind=DP) :: ctmp0, ctmp1, ctmp2, ctmp3, ctmp4, ctmp5, ctmp6
! ------------------------- start ----------------------------
     t2 = t*t;  t4 = t2**2
     At2 = A *t2;    A2t4 = At2 **2;  A3t6 = A2t4 *At2
     q1 = 1.0D0 + At2;  q2 = q1 + A2t4
! -------------
     ctmp0 = beta /gamma
     ctmp1 = ctmp0 *t2
     ctmp2 = t2*( -2.0d0 *At2 - A2t4 )
     ctmp3 = t4*( -2.0d0 + 6.0d0 *A2t4 + 2.0d0*A3t6 )
     ctmp4 = t *( 2.0d0 + 4.0d0 *At2 )
     ctmp5 = 2.0d0 + 6.0d0 *At2 - 18.0d0 *A2t4 - 20.0d0*A3t6
     ctmp6 = -12.0d0 *t *( At2 + A2t4 )
! -----------------------
     kfn = ctmp1 * q1/q2
     dkfn_drs = ctmp1 *ctmp2 / q2**2 *dA_drs
     d2kfn_drs2 = ctmp1 *( ctmp3 /q2**3 *dA_drs**2 + ctmp2 /q2**2 *d2A_drs2 )
!
     dkfn_dt = ctmp0 *ctmp4 / q2**2
     d2kfn_dt2 = ctmp0 *ctmp5 / q2**3
!
     d2kfn_drsdt = ctmp1 *ctmp6 / q2**3 *dA_drs
   end subroutine derivative_kfunc1_rs_t

   subroutine derivative_A_rs( rs, ec, dec_drs, d2ec_drs2, f0, f1, f2 )
     Real(kind=DP), intent(in) :: rs, ec, dec_drs, d2ec_drs2
     Real(kind=DP), intent(out) :: f0, f1, f2

     Real(kind=DP) :: c1, c2, c3
     Real(kind=DP) :: ctmp1, ctmp2, ctmp3
     Real(kind=DP) :: phi, gphi3
! ------------------------------ start ------------
     phi = 1.0d0;       gphi3 = gamma * phi
! ---------------------------------------------
     c1 = ec / gphi3
     c2 = exp( -c1 );    c3 = c2 -1.0D0

     ctmp1 = -beta / gamma /c3**2
     ctmp2 = -1.0d0 /gphi3 *c2
     ctmp3 = -2.0d0 *ctmp1 / c3
! --------------------------------------------------
     f0 = beta / gamma /c3            ! value of A
     f1 = ctmp1 *ctmp2 *dec_drs       ! dA/drs
     f2 = ctmp3 *ctmp2**2 *dec_drs**2  &
          & -ctmp1 *ctmp2 /gphi3 *dec_drs**2 &
          & +ctmp1 *ctmp2 *d2ec_drs2 
   end subroutine derivative_A_rs

   subroutine derivative_t_rs( rs, t, f1, f2 )
     Real(kind=DP), intent(in) :: t, rs
     Real(kind=DP), intent(out) :: f1, f2

     f1 = 3.5D0 *t / rs
     f2 = 2.5D0 *f1 /rs
   end subroutine derivative_t_rs

  subroutine differential_ec_rs_only( rs, ec, dec_drs, d2ec_drs2 )
    real(kind=DP), intent(in) :: rs
    real(kind=DP), intent(out):: ec, dec_drs
    real(kind=DP), intent(out):: d2ec_drs2
    
    real(kind=DP) :: eu, deu_1, deu_2

    call derivative_ec_rs_zeta0( rs, eu, deu_1, deu_2 )
    ec = eu;  dec_drs = deu_1;   d2ec_drs2 = deu_2
  end subroutine differential_ec_rs_only

  subroutine derivative_ec_rs_zeta0( rs, ec0, ec1, ec2 )
    real(kind=DP), intent(in) :: rs
    real(kind=DP), intent(out):: ec0, ec1, ec2
! ---------------------------- const -------------------
    real(kind=DP), parameter :: p = 1.0d0
    real(kind=DP), parameter :: A  = 0.0310907d0,     alpha1 = 0.21370d0
    real(kind=DP), parameter :: beta1 = 7.5957d0,     beta2  = 3.5876d0
    real(kind=DP), parameter :: beta3 = 1.6382d0,     beta4  = 0.49294d0
! --
    call derivative_G_rs( rs, ec0, ec1, ec2, &
       &                  A, alpha1, beta1, beta2, beta3, beta4, p )
  end subroutine derivative_ec_rs_zeta0

  subroutine derivative_G_rs( rs, g0, g1, g2, &
       &           A, alpha1, beta1, beta2, beta3, beta4, p )
    implicit none

    real(kind=DP), intent(in) :: rs, A, alpha1, p
    real(kind=DP), intent(in) :: beta1, beta2, beta3, beta4
    real(kind=DP), intent(out):: g0, g1, g2

    real(kind=DP) :: ctmp1, ctmp2, ctmp3, ctmp4, ctmp5, ctmp6, ctmp7
    real(kind=DP) :: c1, c2
    real(kind=DP) :: Q0, Q1, Q0p, Q1p, Q1p2

    ctmp1 = rs **(1.0d0/2.0d0 )  ! rs **(1/2)
    ctmp2 = ctmp1 *rs            ! rs **(3/2)
    ctmp3 = ctmp1 /rs            ! rs **(-1/2)
    ctmp4 = ctmp3 /rs            ! rs **(-3/2)
    ctmp5 = rs **(p+1.0d0)       ! rs **(p+1)
    ctmp6 = ctmp5 / rs           ! rs **(p)
    ctmp7 = ctmp6 / rs           ! rs **(p-1)

    Q0   = -2.0d0 *A *( 1.0d0 + alpha1 *rs )
    Q1   =  2.0d0 *A *( beta1*ctmp1 + beta2*rs + beta3*ctmp2 +beta4*ctmp5 )
    Q1p  =  A *( beta1*ctmp3 + 2.0d0*beta2 + 3.0d0*beta3*ctmp1 &
         &       + 2.0d0*(p+1.0d0)*beta4*ctmp6 )
    Q0p  = -2.0d0 *A *alpha1

    Q1p2 =  A *( -beta1*ctmp4 + 3.0d0*beta3*ctmp3 &
         &        + 4.0d0 *p*(p+1.0d0)*beta4*ctmp7 ) / 2.0d0

    c1 = log( 1.0d0 + 1.0d0 /Q1 );   c2 = Q1**2 + Q1
    g0 = Q0 *c1
    g1 = -2.0d0 *A *alpha1 *c1 - Q0 *Q1p / c2

    g2 = 2.0d0 *A *alpha1 *Q1p / c2 -( Q0p*Q1p +Q0*Q1p2 )/c2 &
         & + Q0*( 2.0d0*Q1 + 1.0d0 ) *Q1p**2 / c2**2
  end subroutine derivative_G_rs
  
end subroutine calc_kt_cr_ggapbe

#ifdef NEC_TIMER
#  define START_TIMER(a) call start_timer(a)
#  define STOP_TIMER(a)  call stop_timer(a)
#else
#  define START_TIMER(a)
#  define STOP_TIMER(a)
#endif
!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 440 $)
!
!  SUBROUINE: Forces
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Forces
! $Id: Forces.F90 440 2015-08-03 07:18:01Z ktagami $
  use m_Const_Parameters,  only : WITHOUTTAG, WITHTAG, ON
  use m_Parallelization,   only : mype
  use m_Control_Parameters,only : ipriforce, sw_calc_force, sw_dipole_correction &
       &                        , sw_fef, sw_hybrid_functional
  use m_Files,             only : nfout, nfdynm
  use m_IterationNumbers,  only : iteration_ionic, iteration
  use m_Kpoints,           only : kv3
  use m_Ionic_System, only : pos, napt, fxyzew_l, fxyzvdw_l
  use m_Force,        only : forc_l, fexx_l &
!!$       &                   , m_Force_alloc_zfsin_zfcos &
       &                   , m_Force_initialize &
       &                   , m_Force_sumup_and_symmetrize &
!!$       &                   , m_Force_dealloc_zfsin_zfcos &
       &                   , m_Force_cal_forcmx &
       &                   , m_Force_term_dipole &
       &                   , m_Force_term_fef &
!fj$$#ifndef PARA3D
       &                   , m_Force_term_Elocal_and_Epc &
       &                   , m_Force_term_drv_of_VlhxcQ &
       &                   , m_Force_term_drv_of_flmt  
!fj$$#endif
  use m_Phonon,       only : m_Phonon_write_forces
#ifdef __TIMER__
  use m_Parallelization,     only : mpi_comm_group
#endif
#ifdef NEC_TIMER
  use nec_timer
#endif
  use m_ES_ExactExchange, only : m_ES_EXX_Force

! ================================ added by K. Tagami ============= 11.0
  use m_Control_Parameters,      only : noncol
  use m_Force,                   only : m_Force_term_drv_of_flmt_noncl
! ================================================================ 11.0


  implicit none
  integer, save :: flag_wd_force = 0

#ifdef __TIMER__
  integer :: ierr
  call mpi_barrier(mpi_comm_group, ierr)
  call timer_sta(19)
#endif

  if(ipriforce >= 2) write(nfout,'(" -- Forces -- ")')
!!$  call m_Force_alloc_zfsin_zfcos()
  call m_Force_initialize()
!fj$$#ifndef PARA3D
START_TIMER('Force')

! ==================== modified by K. Tagami ============== 11.0
!  call m_Force_term_drv_of_flmt(kv3,pos,napt)      ! (vnlsum) ->fnlxyz_l
!
    if ( noncol ) then
      call m_Force_term_drv_of_flmt_noncl(kv3,pos,napt)
    else
      call m_Force_term_drv_of_flmt(kv3,pos,napt)      ! (vnlsum) ->fnlxyz_l
    endif
! =========================================================== 11.0

STOP_TIMER('Force')
  call m_Force_term_drv_of_VlhxcQ(nfout,pos,napt)  ! (lclchg) ->flhxcq_l
  call m_Force_term_Elocal_and_Epc(nfout,pos)      ! (force)  ->forc_l
!fj$$#endif
  if(sw_dipole_correction == ON) then
     call m_Force_term_dipole()                       ! -> fdip_l,fext_l
  end if
  if(sw_fef==ON) call m_Force_term_fef()           ! -> ffef_l
  if(sw_hybrid_functional==ON) call m_ES_EXX_Force(fexx_l)
  call m_Force_sumup_and_symmetrize(nfout,fxyzew_l,napt)
  !                         forc_l,fnlxyz_l,flhxcq_l,fxyzew_l  --> forc_l
!!$  call m_Force_dealloc_zfsin_zfcos()
  call m_Force_cal_forcmx()                        ! -> forcmx
  if(sw_calc_force == ON) call m_Phonon_write_forces()

!!$  call m_IS_evaluate_v_verlet(forc_l)
!!$

#ifdef __TIMER__
  call timer_end(19)
#endif
end subroutine Forces

#ifdef HIUX
*option MP(P(0))
#endif
!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 482 $)
!
!  MODULE: m_Parallelization
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, August/23/2006
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
! ***************************************************************
!
! This module "m_Parallelization" is for mpi-parallelization and was
! coded by T. Yamasaki (JRCAT-ATP, Fujitsu Laboratories Ltd.) in 1999.
!
#ifdef __TIMER__
#   define __TIMER_START(a) call timer_init() ; call timer_sta(a)
#   define __TIMER_STOP     call timer_fin()
#else
#   define __TIMER_START(a)
#   define __TIMER_STOP
#endif
#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_INICOMM__
#   define __TIMER_INICOMM_START_w_BARRIER(str,a)   call timer_barrier(str) ; call timer_sta(a)
#   define __TIMER_INICOMM_STOP(a)         call timer_end(a)
#else
#   define __TIMER_INICOMM_START_w_BARRIER(str,a)
#   define __TIMER_INICOMM_STOP(a)
#endif

module m_Parallelization
!   (m_Parallel)
! $Id: m_Parallelization.F90 482 2016-04-08 08:40:45Z jkoga $
  use m_Const_Parameters, only       : ON, OFF, tag_npes_etc
  use m_ErrorMessages

  implicit none
  integer :: npes, mype, nrank_e, nrank_k, nrank_g

  integer :: nrank_g1
  integer, allocatable, dimension(:) :: map_e, map_z              ! d(neg)  --> expl.1 and 5
  integer                            :: myrank_e,ista_e,iend_e,istep_e,np_e,mp_e ! --> expl.2 to 4

#ifdef NEC_TUNE_SOFT
  integer, allocatable, dimension(:) :: ista_e_smp, iend_e_smp
  integer                            :: itask
#elif NEC_TUNE_FFT
  integer                            :: itask
#endif
  integer, allocatable, dimension(:) :: nis_e, nie_e, nel_e, idisp_e   ! d(nrank_e)
  integer, allocatable, dimension(:) :: map_k                     ! d(kv3)  
  integer, allocatable, dimension(:,:):: map_ek                   ! d(neg,kv3)
  integer                            :: myrank_k,ista_k,iend_k
  integer, allocatable, dimension(:) :: nis_k,  nie_k,  nel_k


!!$#ifdef TRANSPOSE
  integer                            :: ista_g1, iend_g1, np_g1, mp_g1
  integer, allocatable, dimension(:) :: nis_g1, nie_g1, nel_g1      !d(0:nrank_g1-1)
  integer, allocatable, dimension(:) :: ista_g1k, iend_g1k, np_g1k, mp_g1k !d(kv3)
  integer, allocatable, dimension(:,:):: nis_g1k, nie_g1k, nel_g1k  !d(0:nrank_g1-1,kv3)

  integer                            :: ista_fs, iend_fs, np_fs, mp_fs
  integer, allocatable, dimension(:) :: nis_fs, nie_fs, nel_fs      !d(0:nrank_g-1)
  integer                            :: ista_fs_atm, iend_fs_atm, np_fs_atm, mp_fs_atm
  integer, allocatable, dimension(:) :: nis_fs_atm, nie_fs_atm, nel_fs_atm !d(0:nrank_e-1)
  integer                            :: myrank_g

!!$#endif
  integer, allocatable, dimension(:) :: mpi_k_world  ! kd(0:nrank_k-1)
  integer, allocatable, dimension(:) :: mpi_e_world  ! kd(0:nrank_k-1)
  integer                            :: ista_kngp, iend_kngp, np_kngp, mp_kngp
  integer, allocatable, dimension(:) :: is_kngp, ie_kngp, nel_kngp
  integer                            :: ista_kngp_exx, iend_kngp_exx, np_kngp_exx, mp_kngp_exx
  integer, allocatable, dimension(:) :: is_kngp_exx, ie_kngp_exx, nel_kngp_exx
! natm for fxyzew_l
  integer                            :: ista_atm, iend_atm, np_atm, mp_atm
  integer, allocatable, dimension(:) :: is_atm, ie_atm, nel_atm

  integer                            :: ista_rspace_aug, iend_rspace_aug, np_rspace_aug, mp_rspace_aug
  integer, allocatable, dimension(:) :: ista_rspace_aug_atm, iend_rspace_aug_atm
  integer, allocatable, dimension(:) :: is_rspace_aug, ie_rspace_aug, nel_rspace_aug

  integer                            :: ista_nn,iend_nn,np_nn,mp_nn
  integer, allocatable, dimension(:) :: is_nn, ie_nn, nel_nn

  integer                            :: ista_nq, iend_nq, np_nq, mp_nq
  integer, allocatable, dimension(:) :: is_nq, ie_nq, nel_nq, map_nq, map_z_nq

!  integer                            :: ista_nval,iend_nval,np_nval,mp_nval
!  integer, allocatable, dimension(:) :: is_nval, ie_nval, nel_nval

! natm2 for s_ew in m_Ionic_System
  integer                            :: ista_atm2, iend_atm2, np_atm2, mp_atm2
  integer, allocatable, dimension(:) :: is_atm2, ie_atm2, nel_atm2

! BROYDEN or DFP MIXING METHOD
  integer                            :: ista_kgpm,iend_kgpm, np_kgpm, mp_kgpm
  integer, allocatable, dimension(:) :: is_kgpm,  ie_kgpm, nel_kgpm

! FFT BOX
  integer                            :: npes_cdfft, nrank_ggacmp, nrest_cdfft
!!$  integer                            :: myrank_cdfft, myrank_ggacmp, max_ggacmp
  integer                            :: myrank_cdfft, myrank_ggacmp
  integer, allocatable, dimension(:) :: map_ggacmp ! d(3)
  integer, allocatable, dimension(:) :: mpi_ggacmp_cross_world ! d(0:npes_cdfft-1)
  integer, allocatable, dimension(:) :: mpi_cdfft_world        ! d(0:nrank_ggacmp-1)
  integer, allocatable, dimension(:) :: map_pe2ggacmp, map_pe2cdfft    ! d(0:npes-1)

  integer                            :: ista_sfftp, iend_sfftp, np_sfftp, mp_sfftp
  integer                            :: ista_sfftph,iend_sfftph
  integer, allocatable, dimension(:) :: nis_sfftp,  nie_sfftp,  nel_sfftp, idisp_sfftp
  integer, allocatable, dimension(:) :: nis_sfftph, nie_sfftph, nel_sfftph
  integer                            :: ista_fftp, iend_fftp, np_fftp, mp_fftp
  integer                            :: ista_fftph,iend_fftph
  integer, allocatable, dimension(:) :: nis_fftp,  nie_fftp,  nel_fftp,  idisp_fftp
  integer, allocatable, dimension(:) :: nis_fftph, nie_fftph, nel_fftph, idisp_fftph
  

! NonLocalPotential snl
  integer                            :: ista_snl, iend_snl

! nbmx
  integer  :: ng_nbmx, myrank_nbmx, nrank_nbmx, np_nbmx, mp_nbmx,ista_nbmx, iend_nbmx
  integer  :: nbmx_ext
  integer, allocatable, dimension(:) :: nis_nbmx,nie_nbmx,nel_nbmx, idisp_nbmx
  integer, allocatable, dimension(:) :: mpi_nbmx_world  ! kd(0:nrank_nbmx-1)
  integer  :: ng_nbmx_k, myrank_nbmx_k, nrank_nbmx_k, np_nbmx_k, mp_nbmx_k &
       & ,ista_nbmx_k, iend_nbmx_k
  integer, allocatable, dimension(:) :: nis_nbmx_k, nie_nbmx_k, nel_nbmx_k, idisp_nbmx_k
! kg1
  integer, allocatable, dimension(:) :: mpi_nbmx_world_k  ! kd(0:nrank_nbmx_k-1)
  integer  :: np_kg1_k, mp_kg1_k, ista_kg1_k, iend_kg1_k
  integer  :: kg1_ext
  integer, allocatable, dimension(:) :: nis_kg1_k, nie_kg1_k, nel_kg1_k, idisp_kg1_k

  integer                            :: ierr
  character(len=50)                  :: workdir
  integer                            :: sw_wdir = 0

  integer                            :: mpi_comm_group
  integer                            :: color,key

  logical,save                       :: conf_para = .false.
  integer,save                       :: mype_conf = 0
  integer                            :: nrank_conf


! for nfft
  integer                            :: ista_ffth, iend_ffth, np_ffth, mp_ffth
  integer, allocatable, dimension(:) :: is_ffth, ie_ffth, nel_ffth

! 1. map_e(neg)
! rank# = map_e(ieg) : rank# is the rank number which operates ieg-th data
!  -- examples --
!  (case 1) cyclic partitioning case (assuming nrank_e == 3 and neg == 8)
!   ieg :   1   2   3   4   5   6   7   8
! rank# :   0   1   2   0   1   2   0   1
!
!  (case 2) block  partitioning case (also assuming nrank_e == 3 and neg == 8)
!   ieg :   1   2   3   4   5   6   7   8
! rank# :   0   0   0   1   1   1   2   2
!
! 2. myrank_e
!  This lets each node know its rank number according to an axis-e.
!  -- an example --
!  Assuming nrank_e == 4 and nrank_k == 2
!   #rank (or #pe)  0  1  2  3  4  5  6  7
!   myrank_e        0  1  2  3  0  1  2  3
!
! 3. ista_e, iend_e, istep_e, nis_e, nie_e
!  ista_e, iend_e : Bounds of a window which is a range 'e' runs in each nrank_e.
!  nis_e,  nie_e  : Bounds of windows. This shows all windows ranges.
!  istep_e        : = nrank_e (the cyclic partitioning case)
!                   = 1       (the block partitioning case)
!  -- examples --
!  Assuming nrank_e == 3, nrank_k == 2 and neg ==  8
!  (case 1) cyclic partitioning case
!   #rank (or #pe)  0  1  2  3  4  5
!   ista_e          1  2  3  1  2  3
!   iend_e          7  8  6  7  8  6
!   istep_e         3  3  3  3  3  3
!   nis_e(#rank)    1  2  3  1  2  3
!   nie_e(#rank)    7  8  6  7  8  6
!
!  (case 2) block partitioning case
!   #rank (or #pe)  0  1  2  3  4  5
!   ista_e          1  4  7  1  4  7
!   iend_e          3  6  8  3  6  8
!   istep_e         1  1  1  1  1  1
!   nis_e(#rank)    1  4  7  1  4  7
!   nie_e(#rank)    3  6  8  3  6  8
!
! 4. np_e, mp_e, nel_e
!  np_e is the number of elements of e which each rank_e operates
!  mp_e is the maximum of np_e's over all nodes
!  -- examples --
!  Assuming nrank_e == 3, nrank_k == 2 and neg ==  8
!   #rank (or #pe)  0  1  2  3  4  5
!   np_e            3  3  2  3  3  2
!   mp_e            3  3  3  3  3  3
!   nel_e(#rank)    3  3  2  3  3  2
!
! 5. map_z(neg)
! j = map_z(ieg) : ieg-th data is mapped on j-th position on the
!                 map_e(i)-th array. Common on all ranks
!  -- examples --
! Assuming nrank_e = 3 and neg = 8
!  (case 1) cyclic partitioning case
!   ieg    :   1   2   3   4   5   6   7   8
!  rank_e# :   0   1   2   0   1   2   0   1
!    j     :   1   1   1   2   2   2   3   3
!  (case 2) block partitioning case
!   ieg    :   1   2   3   4   5   6   7   8
!  rank_e# :   0   0   0   1   1   1   2   2
!    j     :   1   2   3   1   2   3   1   2
!
! 6. map_k(kv3)
! rank_k# = map_k(ik) : rank_k# is the rank number which operates ik-th data
!  -- an examples --
!  Assuming nrank_k == 2 and kv3 == 9)
!    ik   :   1   2   3   4   5   6   7   8   9
! rank_k# :   0   0   0   0   0   1   1   1   1
!
! 7. map_ek(neg,kv3)
! rank# = map_ek(ie,ik) : rank# is,  in the whole using nodes, the rank number which operates
!                         ie-th and -k-th data
!  -- an example --
!  Assuming nrank_e == 2, nrank_k = 2, npes == 4, neg == 8 and kv3 = 5
!  and taking block partitioning for an axis-'e'.
!   ik   : 1 1 1 1 1 1 1 1 2 2 2 2 2 2 2 2 3 3 3 3 3 3 3 3 4 4 4 4 4 4 4 4 5 5 5 5 5 5 5 5
!   ie   : 1 2 3 4 5 6 7 8 1 2 3 4 5 6 7 8 1 2 3 4 5 6 7 8 1 2 3 4 5 6 7 8 1 2 3 4 5 6 7 8
! rank_k#: 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
! rank_e#: 0 0 0 0 1 1 1 1 0 0 0 0 1 1 1 1 0 0 0 0 1 1 1 1 0 0 0 0 1 1 1 1 0 0 0 0 1 1 1 1
! rank#  : 0 0 0 0 1 1 1 1 0 0 0 0 1 1 1 1 0 0 0 0 1 1 1 1 2 2 2 2 3 3 3 3 2 2 2 2 3 3 3 3
!
! 8. myrank_k
!  This lets each node know its rank number according to an axis-k.
!  -- an example --
!  Assuming nrank_e == 4 and nrank_k == 2
!   #rank (or #pe)  0  1  2  3  4  5  6  7
!   myrank_k        0  0  0  0  1  1  1  1
!   myrank_e        0  1  2  3  0  1  2  3  (for reference, assuming block partitioning)
!
! 9. ista_k, iend_k
!  ista_k, iend_k : bounds of a window which is a range each nrank_k node operates
!
!10. ista_g1, iend_g1, nis_g1, nie_g1, nel_g1
!  ista_g1,iend_g1: bounds of a window which is a range 'g' runs in each nrank_e after transpose.
!  -- An example --
!  Assuming nrank_e == 3, nrank_k == 2 and kg1 == 101
!   #rank (or #pe)  0   1   2   3   4   5
!   ista_e          1  35  69   1  35  69
!   iend_e         34  68 101  34  68 101
!
!11. np_g1, mp_g1
!  np_g1 is the number of elements of 'g' which each rank_e operates
!  mp_g1 is the maximum of np_g1's over all nodes
!  -- examples --
!  Assuming nrank_e == 3, nrank_k == 2 and kg1 ==  101
!   #rank (or #pe)  0  1  2  3  4  5
!   np_g1          34 34 33 34 34 33
!   mp_g1          34 34 34 34 34 34
!
!12. mpi_k_world(0:nrank_k-1)
! Sub-group of rank_k
!
!13. ng_nbmx, myrank_nbmx, nrank_nbmx,np_nbmx, mp_nbmx, nel_nbmx(#rank_nbmx),
!    ista_nbmx, and iend_nbmx
!  np_nbmx is the number of elements of G which each rank_nbmx operates
!  mp_nbmx is the maximum of np_nbmx's over all nodes in a mpi_nbmx_world
!  -- example --
!  Assuming nbmx = 152, nrank_nbmx = 3 or 2, npe = 5, and ngnode_nbmx = 2
!  #rank (or #pe)               0   1   2   3   4
!  ng_nbmx                      0   1   0   1   0
!  myrank_nbmx                  0   0   1   1   2
!  nrank_nbmx                   3   2   3   2   3
!  np_nbmx                     51  76  51  76  50
!  mp_nbmx                     51  76  51  76  51
!  nel_nbmx(#rank_nbmx)        51  76  51  76  50
!  ista_nbmx                    1   1  52  77 103
!  iend_nbmx                   51  76 102 152 152
!
!                          ||
!
!  ng_nbmx            (      0       ) (    1    )
!  #rank ( or #node)    0    2    4       1   3
!  nrank_nbmx           3    3    3       2   2
!  myrank_nbmx          0    1    2       0   1
!    np_nbmx           51   51   50      76  76
!    mp_nbmx           51   51   51      76  76
! nel_nbmx(#rank_nbmx) 51   51   50      76  76
!    ista_nbmx          1   52  103       1  77
!    iend_nbmx         51  102  152      76 152
! 
!14. mpi_nbmx_world(0:nrank_nbmx-1)
! Sub-group of rank_nbmx
!
  include 'mpif.h'             ! MPI
  integer                            :: istatus(MPI_STATUS_SIZE)
contains

  subroutine m_Parallel_init_comm_world(init_mpi)
!!$    character :: F_OUT*13, name_mype*3
!!$    character :: name_jobstep*3
!!$    integer ::   i, js
!!$    logical ::   existance
    integer, optional, intent(in) :: init_mpi
    integer :: inimpi
    integer :: i,lenc,lencom,ntmp,numdir,np,hispe
    logical :: exist_dirlist
    character(len=50) :: buf
    character(len=50), allocatable :: workdir_array(:)

    integer, allocatable :: color(:),key(:),nproc(:)
    integer :: my_color, my_key
    integer :: maxproc, count, idir, npes1, numdir1

    workdir = ''

    inimpi=ON
    if(present(init_mpi)) inimpi = init_mpi

    if(inimpi==ON) then

    call mpi_init(ierr)
    call mpi_comm_size(mpi_comm_world, npes, ierr)
    call mpi_comm_rank(mpi_comm_world, mype, ierr)
                                    __TIMER_START(17)
#ifdef FJ_TIMER
                 call timer_sta(21)
#endif

!! Group creation
    inquire(file='dirlist',exist=exist_dirlist)
    if(.not.exist_dirlist) then

       call mpi_comm_dup(mpi_comm_world,mpi_comm_group,ierr)

       !!write(*,*) 'mpi_comm_world=',mpi_comm_world
       !!write(*,*) 'mpi_comm_group=',mpi_comm_group

    else
       !!write(*,*) 'dirlist exists.'
       !! switching working directory
       sw_wdir = 1

       if(mype == 0) then
          open(unit=100,file="dirlist",form='formatted')
          read(100,*) numdir
          !! debug
          !!write(*,*) 'numdir=',numdir
          allocate(workdir_array(numdir))
          ntmp=0
          do i=1,numdir
             buf(1:50) = ' '
             read(100,*,err=500,end=500) buf
             ntmp=ntmp+1
             lenc = len_trim(buf)
             buf(lenc+1:lenc+1) = '/'
             workdir_array(i) = buf
          end do
500       continue
          numdir = ntmp
          
          allocate(color(npes))
          allocate(key(npes))
          allocate(nproc(npes))

          npes1 = npes
          numdir1 = numdir
          count = 0
          my_color = 0
          do while(npes1 > 0)
             maxproc = npes1/numdir1
             if(npes1-maxproc*numdir1>0) maxproc=maxproc+1
             my_color = my_color + 1
             do i=1,maxproc
                nproc(i+count) = maxproc
                color(i+count) = my_color
                key(i+count) = i-1
             end do 
             count = count + maxproc
             npes1 = npes1 - maxproc
             numdir1 = numdir1 -1
          end do

          !!do i=1,npes
          !!   key(i) = mod(i-1,maxproc)
          !!   color(i) = (i-key(i))/maxproc
          !!end do
          !!write(*,'("nproc:",50(1x,i2))') nproc
          !!write(*,'("color:",50(1x,i2))') color
          !!write(*,'("key:",50(1x,i2))') key

          do i=1,npes
             idir = color(i)
             buf = workdir_array(idir)
             !!$write(*,*) buf(1:lenc)
             hispe = i-1
             if(mype /= hispe) then
                call MPI_Send(workdir_array(idir),50,MPI_CHARACTER &
                           & ,hispe,1,MPI_COMM_WORLD,ierr)
                call MPI_Send(color(i),1,MPI_INTEGER &
                           & ,hispe,1,MPI_COMM_WORLD,ierr)
                call MPI_Send(key(i),1,MPI_INTEGER &
                           & ,hispe,1,MPI_COMM_WORLD,ierr)
             else
                workdir = workdir_array(idir)
                my_color = color(i)
                my_key = key(i)
             end if
          end do

          deallocate(workdir_array)
       else
          call MPI_Recv(workdir,50,MPI_CHARACTER, &
                   & MPI_ANY_SOURCE,MPI_ANY_TAG,MPI_COMM_WORLD,istatus,ierr)
          call MPI_Recv(my_color,1,MPI_INTEGER, &
                   & MPI_ANY_SOURCE,MPI_ANY_TAG,MPI_COMM_WORLD,istatus,ierr)
          call MPI_Recv(my_key,1,MPI_INTEGER, &
                   & MPI_ANY_SOURCE,MPI_ANY_TAG,MPI_COMM_WORLD,istatus,ierr)
       end if
       call MPI_barrier(MPI_COMM_WORLD,ierr)
       !!write(*,*) 'workdir=',trim(workdir)
       !!my_color = mype
       !!my_key = 0
       call mpi_comm_split(MPI_COMM_WORLD,my_color,my_key,mpi_comm_group,ierr)
       call mpi_comm_size(mpi_comm_group, npes, ierr)
       call mpi_comm_rank(mpi_comm_group, mype, ierr)
       !!write(*,*) 'mpi_comm_group=',mpi_comm_group
       !!write(*,*) 'npes=',npes
       !!write(*,*) 'myes=',mype
       !!write(*,*) 'workdir=',trim(workdir)

       !! debug
       !!call mpi_Finalize(ierr)
       !!stop 'group_creation end'

    end if
!! Group creation

    else

    call mpi_comm_size(mpi_comm_group, npes, ierr)
    call mpi_comm_rank(mpi_comm_group, mype, ierr)

    endif



!!$    if(npes > 1) then
!!$       write(name_mype,'(i3)') mype
!!$       do i = 1, 3
!!$          if(name_mype(i:i) == ' ') name_mype(i:i)='0'
!!$       enddo
!!$
!!$       if(mype==0) then
!!$          do js = 0, 999
!!$             write(name_jobstep,'(i3)') js
!!$             do i = 1, 3
!!$                if(name_jobstep(i:i) == ' ') name_jobstep(i:i)='0'
!!$             enddo
!!$             F_OUT = 'output'//name_jobstep
!!$             inquire(file=F_OUT, exist=existance)
!!$             if(.not.existance) goto 1001
!!$          end do
!!$1001      if(js >=1000) js = 999
!!$       end if
!!$       if(npes > 1) call mpi_bcast(js,1,mpi_integer,0,mpi_comm_world,ierr)
!!$       write(name_jobstep,'(i3)') js
!!$       do i = 1, 3
!!$          if(name_jobstep(i:i) == ' ') name_jobstep(i:i)='0'
!!$       enddo
!!$
!!$       if(mype==0) then
!!$          F_OUT = 'output'//name_jobstep
!!$       else
!!$          F_OUT = 'output'//name_jobstep//'_'//name_mype
!!$       end if
!!$    else if(npes == 1) then
!!$       do js = 0, 999
!!$          write(name_jobstep,'(i3)') js
!!$          do i = 1, 3
!!$             if(name_jobstep(i:i) == ' ') name_jobstep(i:i)='0'
!!$          enddo
!!$          F_OUT = 'output'//name_jobstep
!!$          inquire(file=F_OUT, exist=existance)
!!$          if(.not.existance) goto 1000
!!$       end do
!!$1000   continue
!!$    end if
!!$    open(6, file=F_OUT, status='unknown', form='formatted')

  end subroutine m_Parallel_init_comm_world

  subroutine m_Parallel_init_mpi(printable)
    logical, intent(in) :: printable
    integer   :: i
    integer, dimension(8) :: ipresent_time

!!$    call mpi_init(ierr)
!!$    call mpi_comm_size(mpi_comm_world, npes, ierr)
!!$    call mpi_comm_rank(mpi_comm_world, mype, ierr)

    call date_and_time(values=ipresent_time)

    if(printable) then
       write(6,'(" !|| program start    ",i2,":",i2,":",i2,"  ",i2,"/",i2,"/",i4)') &
            & ipresent_time(5:7),ipresent_time(3),ipresent_time(2),ipresent_time(1)
    
       write(6,'(" npes = ",i6)') npes
       write(6,'(" mype = ",i3," mpi_comm_world = ",i3)') mype,mpi_comm_group
       write(6,'(" mype = ",i3," mpi_comm_world = ",i3)') mype,mpi_comm_group
    end if

    call mpi_barrier(mpi_comm_group,ierr)
    if(printable) write(6,'(" mpi_comm_world = ",i5," mype = ",i5)') mpi_comm_group, mype
    call mpi_barrier(mpi_comm_group,ierr)

  end subroutine m_Parallel_init_mpi

  subroutine m_Parallel_get_nproc_from_arg(printable)
    logical, intent(in) :: printable
#ifndef IRIX64
    character(100) :: q1
    integer     :: narg, iargc
#endif
    integer     :: n1, n2
!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.02.27 !!!!!!!!!!!!!!
    integer     :: nn , neflag, nkflag
!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.02.27 !!!!!!!!!!!!!!

    if(printable) then
      if(conf_para) then
        write(6,'(a)') ''
        write(6,'(a)') '-- configuration-parallelization scheme enabled --'
        write(6,'(a,i8)')  '   nrank_config : ',nrank_conf
        write(6,'(a,i8)')  '   mype_config  : ',mype_conf
        write(6,'(a,i20)') '   communicator : ',mpi_comm_group
        write(6,'(a)') ''
      endif
      if(sw_wdir==1)then
        write(6,'(a)') ''
        write(6,'(a)') '-- directory-parallelization scheme enabled --'
        write(6,'(a)') '   current working directory : '//trim(workdir)
        write(6,'(a)') ''
      endif
!!$       write(6,'(" << m_Parallel_get_nproc_from_arg>>")')
       write(6,'(" npes = ",i6," << m_Parallel_get_nproc_from_arg>>")') npes
!!$       write(6,'(" mype = ",i3," mpi_comm_world = ",i3)') mype,mpi_comm_world
!!$       write(6,'(" mype = ",i3," mpi_comm_world = ",i3)') mype,mpi_comm_world
    end if

#ifndef IRIX64

!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.02.27 !!!!!!!!!!!!!!
    if(mype==0) then

       neflag=0
       nkflag=0
       narg = iargc()
!!$       if(printable) write(6,'(" narg = ", i3)') narg

       do nn = 1,narg
          call getarg(nn,q1)

!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.03.20 !!!!!!!!!!!!!!
          q1 = trim(adjustl(q1))
!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.03.20 !!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.03.20 !!!!!!!!!!!!!!
!!          if(index(trim(adjustl(q1)),"ne").ne.0) then

          if(q1(1:1) == "n".and. q1(2:2) == "e") then
!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.03.20 !!!!!!!!!!!!!!
             neflag = neflag+1
             if((q1(3:3) == "=".or.q1(3:3) == ":") .and. len_trim(q1(4:)).ne.0) then
                 q1 = q1(4:)
                 if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                    read(q1,*) n1
                 else
                    if(printable) write(6,*) 'wrong ne'
                    stop "wrong ne "
                 end if
             else if(q1(3:3) == "=".or. q1(3:3) == ":") then
                 call getarg(nn+1,q1)
                 if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                    read(q1,*) n1
                 else
                    if(printable) write(6,*) 'wrong ne'
                    stop "wrong ne "
                 end if
             else
                  call getarg(nn+1,q1)
                  if(q1(1:1) == ":".and. len_trim(q1(2:)).ne.0) then 
                      q1 = q1(2:)
                      if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                         read(q1,*) n1
                      else
                         if(printable) write(6,*) 'wrong ne'
                         stop "wrong ne "
                      end if
                  else if((q1(1:1) == "=".or.q1(1:1) == ":").and. len_trim(q1(2:)).eq.0) then
                      call getarg(nn+2,q1) 
                      if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                         read(q1,*) n1
                      else
                         if(printable) write(6,*) 'wrong ne'
                         stop "wrong ne "
                      end if
                   else
                      if(printable) write(6,*) 'wrong ne'
                      stop "wrong ne "
                   end if                   
             end if
          end if

!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.03.20 !!!!!!!!!!!!!!
!!          if(index(trim(adjustl(q1)),"nk").ne.0) then

          if(q1(1:1) == "n".and. q1(2:2) == "k") then
!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.03.20 !!!!!!!!!!!!!!

             nkflag = nkflag+1
             if((q1(3:3) == "=".or.q1(3:3) == ":") .and. len_trim(q1(4:)).ne.0) then
                 q1 = q1(4:)
                 if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                    read(q1,*) n2
                 else
                    if(printable) write(6,*) 'wrong nk'
                    stop "wrong nk "
                 end if
             else if(q1(3:3) == "=".or.q1(3:3) == ":") then
                 call getarg(nn+1,q1)
                 if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                    read(q1,*) n2
                 else
                    if(printable) write(6,*) 'wrong nk'
                    stop "wrong nk "
                 end if
             else
                  call getarg(nn+1,q1)
                  if(q1(1:1) == ":".and. len_trim(q1(2:)).ne.0) then 
                      q1 = q1(2:)
                      if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                         read(q1,*) n2
                      else
                         if(printable) write(6,*) 'wrong nk'
                         stop "wrong nk "
                      end if
                  else if((q1(1:1) == "=".or.q1(1:1) == ":").and. len_trim(q1(2:)).eq.0) then 
                      call getarg(nn+2,q1) 
                      if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                         read(q1,*) n2
                      else
                         if(printable) write(6,*) 'wrong nk'
                         stop "wrong nk "
                      end if
                   else
                      if(printable) write(6,*) 'wrong nk'
                      stop "wrong nk "
                   end if                   
             end if
          end if

       end do        


       if(neflag == 0 .or. nkflag == 0) then
          if(printable) write(6,*) 'set default ne and nk'
          n1 = npes
          n2 = npes/n1
       end if

       if(neflag >= 2 .or. nkflag >= 2) then
          if(printable) write(6,*) 'wrong ne and nk'
          stop "wrong nk and nk "
       end if

    end if
!  <---- ! modified by mizouchi@adv 2003.02.27 !!!!!!!!!!!!!!

    if(npes>1) call mpi_bcast(n1,1,mpi_integer,0,mpi_comm_group,ierr)
    if(npes>1) call mpi_bcast(n2,1,mpi_integer,0,mpi_comm_group,ierr)
!!$    if(printable) write(6,*) 'ne, nk = ',n1,n2
#else
    n1 = 1       ! in-chiki
    n1 = npes/2  ! in-chiki
    if(n1 == 0 .or. n1 > npes) n1 = npes
    n2 = npes/n1
#endif
    if(n1*n2 /= npes) then
       call phase_execution_error(PARALLELIZATION_INVALID_2D)
    else
       nrank_e  = n1
       nrank_k  = n2
       if(printable) then
          !!$ if(mype == 0) print '(" nrank_e = ", i3)', nrank_e
          write(6,'(" nrank_e = ",i3)') nrank_e
          !!$ if(mype == 0) print '(" nrank_k = ", i3)', nrank_k
          write(6,'(" nrank_k = ",i3)') nrank_k
       end if
    end if
!!$#ifdef TRANSPOSE
    nrank_g1 = nrank_e
!!$#endif  
  end subroutine m_Parallel_get_nproc_from_arg

  subroutine m_Parallel_wd_npes_etc(nfcntn)
    integer, intent(in) :: nfcntn
    if(mype==0) then
       write(nfcntn,*) tag_npes_etc
       write(nfcntn,'(3i10)') npes,nrank_e,nrank_k
    end if
  end subroutine m_Parallel_wd_npes_etc


  subroutine m_Parallel_init_mpi_nbmx(nfout,ipri,printable,nbmx,kg1,ngnode_nbmx,flag_mpi,flag_mpi_k)
    integer, intent(in) :: nfout,ipri,nbmx, kg1, ngnode_nbmx
    logical, intent(in) :: printable,flag_mpi,flag_mpi_k
    integer             :: i, j, ip, icolor, key, np
    integer             :: newpes, newmype
                                                  __TIMER_SUB_START(1235)

    if(.not.flag_mpi) then
! (( ng_nbmx, myrank_nbmx, nrank_nbmx, np_nbmx, mp_nbmx, ista_nbmx, iend_nbmx
       ng_nbmx = mype
       myrank_nbmx = 0
       nrank_nbmx  = 1
       np_nbmx = nbmx
       mp_nbmx = nbmx
       ista_nbmx = 1
       iend_nbmx = nbmx
       nbmx_ext = nbmx
       if(ipri >= 2 .and. printable) then
          write(nfout,'(" !|| -- parallelization parameters for nbmx --")')
          write(nfout,'(" !||  - ng_nbmx     = ",i12)') ng_nbmx
          write(nfout,'(" !||  - myrank_nbmx = ",i12)') myrank_nbmx
          write(nfout,'(" !||  - nrank_nbmx  = ",i12)') nrank_nbmx
          write(nfout,'(" !||  - nbmx, nbmx_ext = ",2i12)') nbmx, nbmx_ext
          write(nfout,'(" !||  - np_nbmx     = ",i12)') np_nbmx
          write(nfout,'(" !||  - mp_nbmx     = ",i12)') mp_nbmx
          write(nfout,'(" !||  - ista_nbmx   = ",i12)') ista_nbmx
          write(nfout,'(" !||  - iend_nbmx   = ",i12)') iend_nbmx
       end if
    else
! (( ng_nbmx, myrank_nbmx, nrank_nbmx, np_nbmx, mp_nbmx, ista_nbmx, iend_nbmx
!      , nis_nbmx, nie_nbmx, nel_nbmx, idisp_nbmx))
       ng_nbmx     = floor(mod(mype+1, ngnode_nbmx) - 0.5)
       if(ng_nbmx < 0) ng_nbmx = ng_nbmx + ngnode_nbmx
       myrank_nbmx = floor((mype+0.5)/ngnode_nbmx)
       nrank_nbmx  = (npes - ng_nbmx-1)/ngnode_nbmx + 1

       allocate(mpi_nbmx_world(0:ngnode_nbmx-1))

       allocate(nis_nbmx(0:nrank_nbmx-1))
       allocate(nie_nbmx(0:nrank_nbmx-1))
       allocate(nel_nbmx(0:nrank_nbmx-1))
       allocate(idisp_nbmx(0:nrank_nbmx-1))

       call set_block_range4allgather(nbmx,nrank_nbmx,nel_nbmx,nis_nbmx,nie_nbmx,idisp_nbmx)
       ista_nbmx = nis_nbmx(myrank_nbmx)
       iend_nbmx = nie_nbmx(myrank_nbmx)
       np_nbmx = nel_nbmx(myrank_nbmx)
       mp_nbmx = maxval(nel_nbmx)
       nbmx_ext = mp_nbmx*nrank_nbmx

       if(ipri >= 1 .and. printable) then
          write(nfout,'(" !|| -- parallelization parameters for nbmx --")')
          write(nfout,'(" !||  - ng_nbmx     = ",i12)') ng_nbmx
          write(nfout,'(" !||  - myrank_nbmx = ",i12)') myrank_nbmx
          write(nfout,'(" !||  - nrank_nbmx  = ",i12)') nrank_nbmx
          write(nfout,'(" !||  - nbmx, nbmx_ext = ",2i12)') nbmx, nbmx_ext
          write(nfout,'(" !||  - np_nbmx     = ",i12)') np_nbmx
          write(nfout,'(" !||  - mp_nbmx     = ",i12)') mp_nbmx
          write(nfout,'(" !||  - ista_nbmx   = ",i12)') ista_nbmx
          write(nfout,'(" !||  - iend_nbmx   = ",i12)') iend_nbmx
          write(nfout,'(" !||   ( nis_nbmx )",8i10)') (nis_nbmx(i),i=0,nrank_nbmx-1)
          write(nfout,'(" !||   ( nie_nbmx )",8i10)') (nie_nbmx(i),i=0,nrank_nbmx-1)
          write(nfout,'(" !||   ( nel_nbmx )",8i10)') (nel_nbmx(i),i=0,nrank_nbmx-1)
          write(nfout,'(" !||   (idisp_nbmx)",8i10)') (idisp_nbmx(i),i=0,nrank_nbmx-1)
       end if
       
! (( mpi_nbmx_world ))
       do j = 0, ngnode_nbmx-1
          icolor = 0
          key = 0
          if(ng_nbmx == j) then
             icolor = 1
             key = myrank_nbmx
          end if
          call mpi_comm_split(mpi_comm_group, icolor, key, mpi_nbmx_world(j),ierr)
          call mpi_comm_size(mpi_nbmx_world(j), newpes, ierr)
          call mpi_comm_rank(mpi_nbmx_world(j), newmype,ierr)
       end do
    end if

    if(.not.flag_mpi_k) then
! (( ng_nbmx_k, myrank_nbmx_k, nrank_nbmx_k, np_nbmx_k, mp_nbmx_k, ista_nbmx_k, iend_nbmx_k,
!    ista_kg1_k, iend_kg1_k ))
       ng_nbmx_k = myrank_k
       myrank_nbmx_k = 0
       nrank_nbmx_k  = 1
       np_nbmx_k = nbmx
       mp_nbmx_k = nbmx
       ista_nbmx_k = 1
       iend_nbmx_k = nbmx

       ista_kg1_k = 1
       iend_kg1_k = kg1
       kg1_ext = kg1 
    else
! (( ng_nbmx_k, myrank_nbmx_k, nrank_nbmx_k, np_nbmx_k, mp_nbmx_k, nel_nbmx_k,
!  , ista_nbmx_k, iend_nbmx_k,  nis_kg1_k, nie_kg1_k, nel_kg1_k, ista_kg1_k, iend_kg1_k ))
       ng_nbmx_k     = floor(mod(myrank_e+1, ngnode_nbmx) - 0.5)
       if(ng_nbmx_k < 0) ng_nbmx_k = ng_nbmx_k + ngnode_nbmx
       myrank_nbmx_k = floor((myrank_e+0.5)/ngnode_nbmx)
       nrank_nbmx_k  = (nrank_e - ng_nbmx-1)/ngnode_nbmx + 1

       allocate(nel_nbmx_k(0:nrank_nbmx_k-1))
       allocate(nis_nbmx_k(0:nrank_nbmx_k-1))
       allocate(nie_nbmx_k(0:nrank_nbmx_k-1))
       allocate(idisp_nbmx_k(0:nrank_nbmx_k-1))
       allocate(mpi_nbmx_world_k(0:ngnode_nbmx-1))

       call set_block_range4allgather(nbmx,nrank_nbmx_k,nel_nbmx_k,nis_nbmx_k,nie_nbmx_k,idisp_nbmx_k)
       ista_nbmx_k = nis_nbmx_k(myrank_nbmx_k)
       iend_nbmx_k = nie_nbmx_k(myrank_nbmx_k)
       np_nbmx_k = nel_nbmx_k(myrank_nbmx_k)
       mp_nbmx_k = maxval(nel_nbmx_k)
       np = mp_nbmx_k*nrank_nbmx_k
       if(np .gt. nbmx_ext) nbmx_ext = np

! (( np_kg1_k, mp_kg1_k, nel_kg1_k, ista_kg1_k, iend_kg1_k, idisp_kg1_k ))
       allocate(nel_kg1_k(0:nrank_nbmx_k-1))
       allocate(nis_kg1_k(0:nrank_nbmx_k-1))
       allocate(nie_kg1_k(0:nrank_nbmx_k-1))
       allocate(idisp_kg1_k(0:nrank_nbmx_k-1))

       call set_block_range4allgather(kg1,nrank_nbmx_k,nel_kg1_k,nis_kg1_k,nie_kg1_k,idisp_kg1_k)
       np_kg1_k = nel_kg1_k(myrank_nbmx_k)
       mp_kg1_k = maxval(nel_kg1_k)
       ista_kg1_k = nis_kg1_k(myrank_nbmx_k)
       iend_kg1_k = nie_kg1_k(myrank_nbmx_k)
       kg1_ext = mp_kg1_k*nrank_nbmx_k

       if(ipri >= 1 .and. printable) then
          write(nfout,'(" !|| -- parallelization parameters for nbmx in mpi_k_world--")')
          write(nfout,'(" !||  - ng_nbmx_k     = ",i12)') ng_nbmx_k
          write(nfout,'(" !||  - myrank_nbmx_k = ",i12)') myrank_nbmx_k
          write(nfout,'(" !||  - nrank_nbmx_k  = ",i12)') nrank_nbmx_k
          write(nfout,'(" !||  - nbmx, nbmx_ext = ",2i12)') nbmx, nbmx_ext
          write(nfout,'(" !||  - np_nbmx_k     = ",i12)') np_nbmx_k
          write(nfout,'(" !||  - mp_nbmx_k     = ",i12)') mp_nbmx_k
          write(nfout,'(" !||  - ista_nbmx_k   = ",i12)') ista_nbmx_k
          write(nfout,'(" !||  - iend_nbmx_k   = ",i12)') iend_nbmx_k
          write(nfout,'(" !||   ( nis_nbmx_k )",8i10)') (nis_nbmx_k(i),i=0,nrank_nbmx_k-1)
          write(nfout,'(" !||   ( nie_nbmx_k )",8i10)') (nie_nbmx_k(i),i=0,nrank_nbmx_k-1)
          write(nfout,'(" !||   ( nel_nbmx_k )",8i10)') (nel_nbmx_k(i),i=0,nrank_nbmx_k-1)
          write(nfout,'(" !||   (idisp_nbmx_k)",8i10)') (idisp_nbmx_k(i),i=0,nrank_nbmx_k-1)
          write(nfout,'(" !||  - kg1, kg1_ext  = ",2i12)') kg1, kg1_ext
          write(nfout,'(" !||  - np_kg1_k      = ",i12)') np_kg1_k
          write(nfout,'(" !||  - mp_kg1_k      = ",i12)') mp_kg1_k
          write(nfout,'(" !||  - ista_kg1_k    = ",i12)') ista_kg1_k
          write(nfout,'(" !||  - iend_kg1_k    = ",i12)') iend_kg1_k
          write(nfout,'(" !||   ( nis_kg1_k )",8i10)') (nis_kg1_k(i),i=0,nrank_nbmx_k-1)
          write(nfout,'(" !||   ( nie_kg1_k )",8i10)') (nie_kg1_k(i),i=0,nrank_nbmx_k-1)
          write(nfout,'(" !||   ( nel_kg1_k )",8i10)') (nel_kg1_k(i),i=0,nrank_nbmx_k-1)
          write(nfout,'(" !||   (idisp_kg1_k)",8i10)') (idisp_kg1_k(i),i=0,nrank_nbmx_k-1)
       end if
       
! (( mpi_nbmx_world ))
       do i = 0, nrank_k-1
          if(i == myrank_k) then
             do j = 0, ngnode_nbmx-1
                icolor = 0
                key = 0
                if(ng_nbmx_k == j) then
                   icolor = 1
                   key = myrank_nbmx_k
                end if
                call mpi_comm_split(mpi_k_world(myrank_k), icolor, key, mpi_nbmx_world_k(j),ierr)
                call mpi_comm_size(mpi_nbmx_world_k(j), newpes, ierr)
                call mpi_comm_rank(mpi_nbmx_world_k(j), newmype,ierr)
             end do
          end if
       end do
    end if
                                                  __TIMER_SUB_STOP(1235)
  end subroutine m_Parallel_init_mpi_nbmx

  subroutine set_block_range4allgather(ne,np,nel_p,nis_p,nie_p,idisp_p)
    integer, intent(in)                     :: ne ! number of total elements
    integer, intent(in)                     :: np ! number of ranks (or processors)
    integer, intent(out), dimension(0:np-1) :: nel_p,nis_p,nie_p,idisp_p

    integer :: i, j, npf

    nel_p = 0
    i = ne/np
    j = i*np
    if(j == ne) then
       nel_p = i
    else
       npf = ne/(i+1)
       nel_p(0:npf-1) = i+1
       nel_p(npf)     = ne - (i+1)*npf
    end if
    nis_p(0) = 1
    do i = 1, np-1
       nis_p(i)   = nis_p(i-1) + nel_p(i-1)
       nie_p(i-1) = nis_p(i)   - 1
    end do
    nie_p(np-1) = ne
    do i = 0, np-1
       idisp_p(i) = nis_p(i)-1
    end do
  end subroutine set_block_range4allgather

! === necessary to make 3D_Parallel, too!!! by tkato ===========================
!!BRANCH_P ORG_Parallel
! ==============================================================================
  subroutine m_Parallel_init_mpi_elec(nfout,ipri,printable,neg,kv3,nspin,kg1)
    integer, intent(in) :: nfout,ipri,neg, kv3, nspin, kg1
    logical, intent(in) :: printable

#ifdef NEC_TUNE_SOFT
    character*4 F_RSVTASK
    integer :: tmp_a1,tmp_a2,tmp_b1,tmp_b2
#elif NEC_TUNE_FFT
    character*4 F_RSVTASK
#endif

    integer             :: i, j, ip, icolor, key, kv3_half

!!$! =========================================== added by K. Tagami ======== 11.0
!!$    integer ::           kv3_div
!!$! ======================================================================= 11.0

    integer             :: newpes, newmype
    logical             :: set_mapping_func
    integer, pointer, dimension(:) :: nproc2rank_k, nproc2rank_e

    integer, parameter  :: nc = 24
    integer, parameter  :: nc1 = 16
!!$    integer, parameter  :: nc2 = 18
    integer             :: i0, i1, sw_title
    character*7         :: strmap

    sw_title = 1
    if(ipri >= 2 .and. printable) then
       write(nfout,'(" !|| << m_Parallel_init_mpi_elec >>")')
       write(nfout,'(" !|| neg, kv3 = ",i5, i8)') neg, kv3
    end if
    if(neg <= 0 ) stop " neg is not positive value "
    if(kv3 <= 0 ) stop " kv3 is not positive value "

!!!!!!!!!!!!!!!!! added by mizouchi@adv 2003.02.26 !!!!!!!!!!!!!!
#ifdef IRIX64

! ====================================== modified by K. Tagami =============== 11.0
!!    if((kv3 == 1.and.nspin ==1).or.(kv3 == 2.and.nspin ==2)) then
    if ( kv3/nspin == 1 ) then
! ===========================================================================  11.0

       nrank_e  = npes
       nrank_k  = 1
       if(ipri >= 1 .and. printable) then
          write(nfout,'(" !| modified nrank_e and nrank_k due to 1 kpoint calculation  ")')
          write(nfout,'(" !| modified nrank_e = ", i4)') nrank_e
          write(nfout,'(" !| modified nrank_k = ", i4)') nrank_k
       end if
#endif
!!!!!!!!!!!!!!!!! added by mizouchi@adv 2003.02.26 !!!!!!!!!!!!!!

!    if(nrank_k > kv3) stop ' nrank_k > kv3 (m_Parallel_init_mpi_elec)'
    if(nrank_k > kv3) call phase_execution_error(PARALLELIZATION_INVALID_NK)
!!$    if(nrank_e > neg) call phase_execution_error(PARALLELIZATION_INVALID_NE) !! not here !!

    allocate(map_e(neg))
    allocate(map_z(neg))
    allocate(map_k(kv3))
    allocate(map_ek(neg,kv3))
    if(.not.allocated(mpi_k_world)) allocate(mpi_k_world(0:nrank_k-1))
    if(.not.allocated(mpi_e_world)) allocate(mpi_e_world(0:nrank_e-1))
    allocate(nis_e(0:nrank_e-1)); nis_e = neg+1
    allocate(nie_e(0:nrank_e-1)); nie_e = 0
    allocate(nel_e(0:nrank_e-1)); nel_e = 0
    allocate(idisp_e(0:nrank_e-1)); idisp_e = 0
!!$#ifdef TRANSPOSE
    allocate(nis_g1(0:nrank_g1-1)); nis_g1 = kg1 + 1
    allocate(nie_g1(0:nrank_g1-1)); nie_g1 = 0
    allocate(nel_g1(0:nrank_g1-1)); nel_g1 = 0
!!$#endif
    allocate(nis_k(0:nrank_k-1)); nis_k = 0
    allocate(nie_k(0:nrank_k-1))
    allocate(nel_k(0:nrank_k-1))

! (( myrank_e, myrank_k ))
    allocate(nproc2rank_e(0:npes-1))
    allocate(nproc2rank_k(0:npes-1))
    ip = 0
    do i = 0, nrank_k-1
       do j = 0, nrank_e-1
          nproc2rank_k(ip) = i
          nproc2rank_e(ip) = j
          ip = ip + 1
       end do
    end do
    myrank_k = nproc2rank_k(mype)
    myrank_e = nproc2rank_e(mype)
    deallocate(nproc2rank_k)
    deallocate(nproc2rank_e)
! (( map_e, nis_e, nie_e, nel_e, ista_e, iend_e, istep_e, np_e, mp_e  ))
!!$#ifdef TRANSPOSE
    set_mapping_func = .true.
    call set_block_range(neg,nrank_e,nel_e,nis_e,nie_e, set_mapping_func, map_e)
    do i = 0, nrank_e-1
       idisp_e(i) = nis_e(i)-1
    end do
    if(ipri >= 2) call wd_e_range
    istep_e = 1
!!$#else
!!$    do i = 1, neg
!!$       map_e(i) = mod(i-1,nrank_e)
!!$    end do
!!$    do i = 1, neg
!!$       ip = map_e(i)
!!$       nel_e(ip) = nel_e(ip) + 1
!!$       if(nis_e(ip) > i) nis_e(ip) = i
!!$       if(nie_e(ip) < i) nie_e(ip) = i
!!$    end do
!!$    istep_e = nrank_e
!!$
!!$#endif
    if(ipri >= 2 .and. printable) then
       strmap = "   i   "
       call wd_maparray(neg,map_e,strmap," map_e ",sw_title)
    end if

    ista_e = nis_e(myrank_e)
    iend_e = nie_e(myrank_e)
    np_e = nel_e(myrank_e)
    mp_e = maxval(nel_e)
    if(ipri==1 .and. printable) then
       if(mp_e < 100000) then
          write(nfout,'(" !|| ista_e, iend_e = ",i5,",",i5,", mp_e = ",i5,", neg = ",i12,", kv3 = ",i5 &
               & ," << m_Parallel_init_mpi_elec >>")') ista_e,iend_e,mp_e,neg,kv3
       else if(mp_e <100000000) then
          write(nfout,'(" !|| ista_e, iend_e = ",i8,",",i8,", mp_e = ",i8,", neg = ",i13,", kv3 = ",i5 &
               & ," << m_Parallel_init_mpi_elec >>")') ista_e,iend_e,mp_e,neg,kv3
       else
          write(nfout,'(" !|| ista_e, iend_e = ",i0,",",i0,", mp_e = ",i0,", neg = ",i0,", kv3 = ",i5 &
               & ," << m_Parallel_init_mpi_elec >>")') ista_e,iend_e,mp_e,neg,kv3
       end if
    end if


#ifdef NEC_TUNE_SOFT
    call getenv('F_RSVTASK',F_RSVTASK)
    read (F_RSVTASK,'(i4)') itask
    allocate(ista_e_smp(itask))
    allocate(iend_e_smp(itask))

    tmp_a1 = (iend_e-ista_e+1)/istep_e
    tmp_a2 = mod(iend_e-ista_e+1,istep_e)
    if (tmp_a2 .ne. 0) tmp_a1=tmp_a1+1
    tmp_b1 = tmp_a1/itask
    tmp_b2 = mod(tmp_a1,itask)
    if (tmp_b2 .ne. 0) tmp_b1=tmp_b1+1

    do i=1,itask
      ista_e_smp(i) = ista_e + tmp_b1 * istep_e * (i -1)
      iend_e_smp(i) = min((ista_e + tmp_b1 * istep_e * i -1),iend_e)
    end do
#elif NEC_TUNE_FFT
    call getenv('F_RSVTASK',F_RSVTASK)
    read (F_RSVTASK,'(i4)') itask
#endif

    if(ipri >= 2 .and. printable) &
         & write(nfout,'(" !|| -- ista_e, iend_e, istep_e, np_e, mp_e = ",5i6)') &
         &  ista_e,iend_e,istep_e, np_e, mp_e

! (( map_z ))
!!$#ifdef TRANSPOSE
    j = 0
    do ip = 1, nrank_e
       do i = 1, nel_e(ip-1)
          j = j + 1
          map_z(j) = i
       end do
    end do
!!$#else
!!$    ip = 1
!!$    do i = 1, neg
!!$       map_z(i) = ip
!!$       if(mod(i,nrank_e) == 0) ip = ip + 1
!!$    end do
!!$#endif
    if(ipri >= 2 .and. printable) then
       strmap = "   i   "
       call wd_maparray(neg,map_z,strmap," map_z ",sw_title)
    end if
! (( map_k, nis_k, nie_k, nel_k, ista_k, iend_k ))
    if(kv3/nspin < nrank_k) then
       if(ipri >= 1 .and. printable) then
          write(nfout,'(" ******")')
          write(nfout,'(" ** The nrank_k that you have specified is smaller than the number of k-points (kv3/nspin).")')
          write(nfout,'(" ** kv3/nspin = ",i8," nrank_k = ",i8)') kv3/nspin, nrank_k
          write(nfout,'(" ** Reduce the size of the rank for k-point division (nrank_k) &
  &                     which is set in nk= option when you run this program, please")')
          call flush(nfout)
       end if
       stop ' ** The nrank_k that is specified is smaller than the number of generated or read k-points (=kv3/nspin).'
    end if
    if(nspin == 1) then
       set_mapping_func = .true.
       call set_block_range(kv3,nrank_k,nel_k,nis_k,nie_k, set_mapping_func,map_k)
       ista_k = nis_k(myrank_k)
       iend_k = nie_k(myrank_k)
    else if(nspin == 2) then
       set_mapping_func = .false.
       kv3_half = kv3/nspin
       call set_block_range(kv3_half,nrank_k,nel_k,nis_k,nie_k, set_mapping_func)
       nel_k = nel_k*nspin
       nie_k = nie_k*nspin
       nis_k = nis_k*nspin-1
       j = 0
       do i = 1, kv3
          if(nie_k(j) < i) j = j + 1
          map_k(i) = j
       end do
       ista_k = nis_k(myrank_k)
       iend_k = nie_k(myrank_k)
    end if

    if(ipri >= 2 .and. printable) then
       strmap = "   i   "
       call wd_maparray(kv3,map_k,strmap," map_k ",sw_title)
       write(nfout,'(" !|| -- myrank_k = ",i8)') myrank_k
       write(nfout,'(" !|| -- ista_k, iend_k = ",2i8)') ista_k,iend_k
    end if
   if(ista_k > iend_k) stop ' !! illegal combination of ista_k, and iend_k'
 
! (( map_ek ))
    do j = 1, kv3
       do i = 1, neg
          map_ek(i,j) = map_e(i) + map_k(j)*(nrank_e)
       end do
    end do

    if(ipri >= 2 .and. printable) then
       write(nfout,'(" !|| --- map_ek ---")')
       sw_title = 0
       do j = 1, kv3
          write(strmap,'("ik=",i4)') j
          call wd_maparray(neg,map_ek(1,j),strmap,"map_ek ",sw_title)
       end do
    end if

!!$#ifdef TRANSPOSE
! (( ista_g1, iend_g1 ))
    set_mapping_func = .false.
    if(ipri >= 2 .and. printable) write(nfout,'(" !|| kg1 = ",i10)') kg1
    call set_block_range(kg1,nrank_e,nel_g1,nis_g1,nie_g1, set_mapping_func)
    ista_g1 = nis_g1(myrank_e)
    iend_g1 = nie_g1(myrank_e)
    np_g1   = nel_g1(myrank_e)
    mp_g1   = maxval(nel_g1) 
    if(ipri >= 2 .and. printable) then
       write(nfout,'(" !|| --- mis_g1,nie_g1,nel_g1 ---")')
       write(nfout,'(" !|| ( rank_e  )",15i7)')(i,i=1,nrank_e)
       write(nfout,'(" !|| ( nis_g1  )",15i7)')(nis_g1(i),i=0,nrank_e-1)
       write(nfout,'(" !|| ( nie_g1  )",15i7)')(nie_g1(i),i=0,nrank_e-1)
       write(nfout,'(" !|| ( nel_g1  )",15i7)')(nel_g1(i),i=0,nrank_e-1)
       write(nfout,'(" !|| (myrank_e = ",i3," kg1,ista_g1,iend_g1,np_g1,mp_g1 = ",5i7)') &
            & myrank_e,kg1,ista_g1,iend_g1,np_g1,mp_g1
    end if
!!$#endif

! (( mpi_k_world ))
    do j = 0, nrank_k-1
       icolor = 0
       key = 0
       do i = 0, nrank_e-1
          if(mype == i + nrank_e*j) then
             icolor = 1
             key = i
          end if
       end do
       call mpi_comm_split(mpi_comm_group, icolor, key, mpi_k_world(j),ierr)
       call mpi_comm_size(mpi_k_world(j), newpes,ierr)
       call mpi_comm_rank(mpi_k_world(j), newmype,ierr)
!!$       print '(" mype = ",i3," newmype = ", i3," newpes = ",i3," mpi_k_world = ", i3 &
!!$            &, " icolor = ",i3," key = ",i3)' &
!!$            & ,mype,newmype, newpes,mpi_k_world(j),icolor, key
    end do

    do j=0,nrank_e-1
       icolor = myrank_e
       key = mype
       call mpi_comm_split(mpi_comm_group, icolor, key, mpi_e_world(j),ierr)
       call mpi_comm_size(mpi_e_world(j), newpes,ierr)
       call mpi_comm_rank(mpi_e_world(j), newmype,ierr)
    enddo
  contains
    subroutine wd_maparray(nelement,map_a,map_title0,map_title,sw_title)
      integer, intent(in) ::                 nelement
      integer, dimension(nelement), intent(in) :: map_a
      character*7, intent(in) ::             map_title0,map_title
      integer, intent(in) ::                 sw_title
      integer :: nca, j, i0, i1, i, iloop

      if(sw_title==1)  write(nfout,'(" !|| --- ",a7," ---")') map_title
      if(nelement < 100) then
         nca = nc      ! = 24
      else if(nelement < 1000) then
         nca = nc*3/4  ! = 18
      else if(nelement < 10000) then
         nca = nc*3/5  ! = 14
      else if(nelement < 100000) then
         nca = nc*3/6  ! = 12
      else
         nca = nc*3/9  ! = 8
      end if
      iloop = ceiling(dble(nelement)/nca)
      do j = 1, iloop
         i0 = (j-1)*nca + 1
         i1 = i0 + nca -1
         if(i1 > nelement) i1 = nelement
         if(nelement < 100) then
            write(nfout,'(" !|| (",a7,")",24i3)') map_title0,(i,i=i0,i1)
            write(nfout,'(" !|| (",a7,")",24i3)') map_title, (map_a(i),i=i0,min(nelement,i1))
         else if(nelement < 1000) then
            write(nfout,'(" !|| (",a7,")",18i4)') map_title0,(i,i=i0,i1)
            write(nfout,'(" !|| (",a7,")",18i4)') map_title, (map_a(i),i=i0,i1)
         else if(nelement < 10000) then
            write(nfout,'(" !|| (",a7,")",14i5)') map_title0,(i,i=i0,i1)
            write(nfout,'(" !|| (",a7,")",14i5)') map_title, (map_a(i),i=i0,i1)
         else if(nelement < 100000) then
            write(nfout,'(" !|| (",a7,")",12i5)') map_title0,(i,i=i0,i1)
            write(nfout,'(" !|| (",a7,")",12i5)') map_title, (map_a(i),i=i0,i1)
         else
            write(nfout,'(" !|| (",a7,")",8i9)') map_title0,(i,i=i0,i1)
            write(nfout,'(" !|| (",a7,")",8i9)') map_title, (map_a(i),i=i0,i1)
         end if
      end do
    end subroutine wd_maparray

    subroutine wd_e_range
      if(printable) then
         write(nfout,'(" !|| nrank_e")')
         write(nfout,'(" !||    i    : ",20i4)')(i,i=0,nrank_e-1)
         write(nfout,'(" !|| nis_e   : ",20i4)')(nis_e(i),i=0,nrank_e-1)
         write(nfout,'(" !|| nie_e   : ",20i4)')(nie_e(i),i=0,nrank_e-1)
         write(nfout,'(" !|| nel_e   : ",20i4)')(nel_e(i),i=0,nrank_e-1)
!!$         write(nfout,'(" !||    i : ",20i4)')(i,i=0,nrank_e-1)
!!$         write(nfout,'(" !|| nis_e : ",20i4)')(nis_e(i),i=0,nrank_e-1)
!!$         write(nfout,'(" !|| nie_e : ",20i4)')(nie_e(i),i=0,nrank_e-1)
!!$         write(nfout,'(" !|| nel_e : ",20i4)')(nel_e(i),i=0,nrank_e-1)
!!$#ifdef TRANSPOSE
         write(nfout,'(" !|| idisp_e : ",20i4)')(idisp_e(i),i=0,nrank_e-1)
!!$#endif
      end if
    end subroutine wd_e_range

  end subroutine m_Parallel_init_mpi_elec
! === necessary to make 3D_Parallel, too!!! by tkato ===========================
!!BRANCH_P_END ORG_Parallel
! ==============================================================================

  subroutine m_Parallel_dealloc_mpi_elec()

    deallocate(map_e)
    deallocate(map_z)
    deallocate(map_k)
    deallocate(map_ek)
!fj    deallocate(mpi_k_world)
    deallocate(nis_e)
    deallocate(nie_e)
    deallocate(nel_e)
    deallocate(idisp_e)
    deallocate(nis_g1)
    deallocate(nie_g1)
    deallocate(nel_g1)
    deallocate(nis_k)
    deallocate(nie_k)
    deallocate(nel_k)

#ifdef NEC_TUNE_SOFT
    deallocate(ista_e_smp)
    deallocate(iend_e_smp)
#endif


  end subroutine m_Parallel_dealloc_mpi_elec

  subroutine m_Parallel_init_mpi_iba(nfout,ipri,printable,kv3,iba)
    integer, intent(in) :: nfout,ipri, kv3, iba(kv3)
    logical, intent(in) :: printable

    logical             :: set_mapping_func
    integer             :: i, ik
    integer, parameter  :: nc = 24
    integer, parameter  :: nc1 = 16

!!$#ifdef TRANSPOSE
    if(nrank_k > kv3) stop ' nrank_k > kv3 (m_Parallel_init_mpi_elec)'

! (( ista_g1k, iend_g1k ))
    if(allocated(np_g1k)) deallocate(np_g1k);  allocate(np_g1k(kv3))
    if(allocated(mp_g1k)) deallocate(mp_g1k);  allocate(mp_g1k(kv3))
    if(allocated(ista_g1k)) deallocate(ista_g1k); allocate(ista_g1k(kv3))
    if(allocated(iend_g1k)) deallocate(iend_g1k); allocate(iend_g1k(kv3))

    if(allocated(nis_g1k)) deallocate(nis_g1k);  allocate(nis_g1k(0:nrank_g1-1,kv3))
    do ik = 1, kv3
       nis_g1k(:,ik) = iba(ik)
    end do

    if(allocated(nie_g1k)) deallocate(nie_g1k); allocate(nie_g1k(0:nrank_g1-1,kv3))
    nie_g1k = 0

    if(allocated(nel_g1k)) deallocate(nel_g1k); allocate(nel_g1k(0:nrank_g1-1,kv3))
    nel_g1k = 0

    do ik = 1, kv3
       set_mapping_func = .false.
       if((ipri >= 2 .and. printable).or. &
            & (ipri >= 1 .and. printable .and. (ik<=3 .or. ik>=kv3-2))) &
            & write(nfout,'(" !|| ik = ",i10 &
            & ," iba(",i6,") = ",i10," <<m_Parallel_init_mpi_iba>>")') ik, ik, iba(ik)

       call set_block_range(iba(ik),nrank_e,nel_g1k(0,ik),nis_g1k(0,ik) &
            & ,nie_g1k(0,ik), set_mapping_func)
       ista_g1k(ik) = nis_g1k(myrank_e,ik)
       iend_g1k(ik) = nie_g1k(myrank_e,ik)
       np_g1k(ik)   = nel_g1k(myrank_e,ik)
       mp_g1k(ik)   = maxval(nel_g1k(0:nrank_g1-1,ik)) 
       if((ipri >= 3 .and. printable) .or. &
            & (ipri >= 2 .and. printable .and. (ik<=3 .or. ik>=kv3-2))) then
          write(nfout,'(" !|| --- mis_g1k,nie_g1k,nel_g1k ---")')
          write(nfout,'(" !|| ( rank_e  )",15i7)')(i,i=1,nrank_e)
          write(nfout,'(" !|| ( nis_g1k )",15i7)')(nis_g1k(i,ik),i=0,nrank_e-1)
          write(nfout,'(" !|| ( nie_g1k )",15i7)')(nie_g1k(i,ik),i=0,nrank_e-1)
          write(nfout,'(" !|| ( nel_g1k )",15i7)')(nel_g1k(i,ik),i=0,nrank_e-1)
          write(nfout,'(" !|| (myrank_e = ",i3," iba(ik),ista_g1k,iend_g1k,np_g1k,mp_g1k = ",5i7)') &
               & myrank_e,iba(ik),ista_g1k(ik),iend_g1k(ik),np_g1k(ik),mp_g1k(ik)
       end if
       if(ipri>=1 .and. printable .and. kv3 >=7 .and. ik == 3) then
          write(nfout,'(" !||  ......")')
       end if
    end do
!!$#endif
  end subroutine m_Parallel_init_mpi_iba

  subroutine m_Parallel_end_mpi
                                                  __TIMER_STOP
    call mpi_finalize(ierr)
  end subroutine m_Parallel_end_mpi

  subroutine set_block_range(ne,np,nel_p,nis_p,nie_p,set_mapping_func,map_p)
    integer, intent(in)                     :: ne ! number of total elements
    integer, intent(in)                     :: np ! number of ranks (or processors)
    integer, intent(out), dimension(0:np-1) :: nel_p,nis_p,nie_p
    logical, intent(in)                     :: set_mapping_func
    integer, intent(out), optional, dimension(ne)  :: map_p

    integer :: j,i

    if(np == 0) stop ' np == 0'
    nel_p = ne/np
    j = mod(ne,np)
    do i = 0, j-1
       nel_p(i) = nel_p(i) + 1
    end do

    nis_p(0) = 1
    do i = 1, np-1
       nis_p(i)   = nis_p(i-1) + nel_p(i-1)
       nie_p(i-1) = nis_p(i) - 1
    end do
    nie_p(np-1) = ne

    if(set_mapping_func) then
       j = 0
       do i = 1, ne
          if(nie_p(j) < i) j = j + 1
          map_p(i) = j
       end do
    end if

  end subroutine set_block_range

  subroutine m_Parallel_init_mpi_kngp(nfout,ipri,kngp)
    integer, intent(in) :: nfout,ipri,kngp
    integer :: iwork, i
    allocate(is_kngp(0:npes-1))
    allocate(ie_kngp(0:npes-1))
    allocate(nel_kngp(0:npes-1))
    iwork = ( kngp - 1 ) / npes + 1
    do i = 0, npes-1
       is_kngp(i) = min(i*iwork+1, kngp+1)
       ie_kngp(i) = min(is_kngp(i)+iwork-1, kngp)
       nel_kngp(i) = ie_kngp(i) - is_kngp(i) + 1
    enddo
    ista_kngp = is_kngp(mype)
    iend_kngp = ie_kngp(mype)
    np_kngp   = nel_kngp(mype)
    mp_kngp   = maxval(nel_kngp)
    if(ipri==1) then
       if(mp_kngp < 100000) then
          write(nfout,'(" !|| ista_kngp, iend_kngp = ",i5,",",i5,", mp_kngp = ",i5,", kngp = ",i12&
               & ," << m_Parallel_init_mpi_kngp >>")') ista_kngp,iend_kngp,mp_kngp,kngp
       else
          write(nfout,'(" !|| ista_kngp, iend_kngp = ",i10,",",i10,", mp_kngp = ",i10,", kngp = ",i12&
               & ," << m_Parallel_init_mpi_kngp >>")') ista_kngp,iend_kngp,mp_kngp,kngp
       end if
    else if(ipri>=2) then
       write(nfout,'(" << m_Parallel_init_mpi_kngp >>")')
       write(nfout,'(" !|| kngp = ",i12)') kngp
       write(nfout,'(" !|| -- npe, is_kngp(ista_kngp),  ie_kngp(iend_kngp) --")')
       do i = 0, npes-1
          write(nfout,'(" !|| ",i0,2i10)') i,is_kngp(i),ie_kngp(i)
       end do
    end if
  end subroutine m_Parallel_init_mpi_kngp

  subroutine m_Parallel_init_mpi_cdfft(nfout,ipri,ggacmp_parallel)
    integer, intent(in)  :: nfout,ipri,ggacmp_parallel
    integer :: i, iprilevel

    if(ggacmp_parallel == ON) then
       call split_into_ggablock_cdfft(npes,nrank_ggacmp,npes_cdfft,nrest_cdfft)
    else
       nrank_ggacmp = 1
       npes_cdfft   = npes
       nrest_cdfft  = 0
    end if
    if(ipri >= 1) write(nfout,'(" !|| ggacmp_parallel = ",i3)') ggacmp_parallel
    if(ggacmp_parallel==ON) then
       iprilevel=1
    else
       iprilevel=2
    end if
    if(ipri >= iprilevel) write(nfout,'(" !|| nrank_ggacmp, npes_cdfft, nrest_cdfft",/ &
         & ," !||   = ",3i10," <<m_Parallel_init_mpi_cdfft>>")') &
         & nrank_ggacmp, npes_cdfft, nrest_cdfft
    myrank_ggacmp = mype/npes_cdfft
    myrank_cdfft  = mype - myrank_ggacmp*npes_cdfft
    if(ipri >= iprilevel) write(nfout,'(" !|| myrank_ggacmp, myrank_cdfft",/ &
         & ," !|| = ",2i10," <<m_Parallel_init_mpi_cdfft>>")') &
         & myrank_ggacmp, myrank_cdfft
    allocate(map_pe2ggacmp(0:npes-1))
    allocate(map_pe2cdfft(0:npes-1))
    do i = 0, npes-1
       map_pe2ggacmp(i) = i/npes_cdfft
       map_pe2cdfft(i) = i - map_pe2ggacmp(i)*npes_cdfft
    end do
    if(ipri >= iprilevel) write(nfout,'(" !|| map_pe2ggacmp",/,99( " !|| ",10i5,/))') &
         & (map_pe2ggacmp(i),i=0,npes-1)
    if(ipri >= iprilevel) write(nfout,'(" !|| map_pe2cdfft",/,99( " !|| ",10i5,/))') &
         & (map_pe2cdfft(i),i=0,npes-1)
  end subroutine m_Parallel_init_mpi_cdfft

  subroutine m_Parallel_init_mpi_gga(nfout,ipri,printable,nfftp,nfftps)
    integer, intent(in)  :: nfout,ipri,nfftp,nfftps
    logical, intent(in)  :: printable
    integer              :: nfftph, i
    logical              :: set_mapping_func
    integer              :: icolor, key, j, newpes, newmype
                                                  __TIMER_SUB_START(1236)
                                                  __TIMER_SUB_STOP(1236)

    allocate(map_ggacmp(3)); map_ggacmp = 0
    allocate(nis_fftp(0:npes_cdfft-1)); nis_fftp = 0
    allocate(nie_fftp(0:npes_cdfft-1)); nie_fftp = 0
    allocate(nel_fftp(0:npes_cdfft-1)); nel_fftp = 0
    allocate(idisp_fftp(0:npes_cdfft-1)); idisp_fftp = 0
    allocate(nis_fftph(0:npes_cdfft-1));nis_fftph = 0
    allocate(nie_fftph(0:npes_cdfft-1)); nie_fftph = 0
    allocate(nel_fftph(0:npes_cdfft-1)); nel_fftph = 0
    allocate(idisp_fftph(0:npes_cdfft-1)); idisp_fftph = 0
    allocate(mpi_cdfft_world(0:nrank_ggacmp-1)); mpi_cdfft_world = 0
    allocate(mpi_ggacmp_cross_world(0:npes_cdfft-1)); mpi_ggacmp_cross_world = 0

    if(nrank_ggacmp > 1) then
       do i = 1, 3
          map_ggacmp(i) = i-1
       end do
    else
       map_ggacmp(1:3) = 0
    end if

    set_mapping_func = .false.
    nfftph = nfftp/2
    if(ipri >= 1) write(nfout,'(" !|| nfftp, nfftph = ",2i10," <<m_Parallel_init_mpi_gga>>")') nfftp, nfftph
    call set_block_range(nfftph,npes_cdfft,nel_fftph,nis_fftph,nie_fftph,set_mapping_func)

    ista_fftph = nis_fftph(myrank_cdfft)
    iend_fftph = nie_fftph(myrank_cdfft)

    if(ipri >= 1) write(nfout,'(" !|| ista_fftph, iend_fftph = ",2i10 &
         & ," <<m_Parallel_init_mpi_gga>>")') ista_fftph, iend_fftph

    do i = 0, npes_cdfft -1
       nis_fftp(i) = nis_fftph(i)*2 - 1
       nie_fftp(i) = nie_fftph(i)*2
       nel_fftp(i) = nel_fftph(i)*2
       idisp_fftp(i) = nis_fftp(i) - 1
       idisp_fftph(i) = nis_fftph(i) - 1
    end do
    ista_fftp = nis_fftp(myrank_cdfft)
    iend_fftp = nie_fftp(myrank_cdfft)
    mp_fftp = maxval(nel_fftp)
    np_fftp = nel_fftp(myrank_cdfft)

    if(ipri >= 2 .and. printable) then
       write(nfout,'(" !|| --- nis_fftp,nie_fftp,nel_fftp,idisp_fftp ---")')
       write(nfout,'(" !||  npes_cdfft = ",i12)') npes_cdfft
       write(nfout,'(" !|| ( npe_cdfft )",10i12)') (i,i=1,npes_cdfft)
       write(nfout,'(" !|| ( nis_fftp )",10i12)') (nis_fftp(i),i=0,npes_cdfft-1)
       write(nfout,'(" !|| ( nie_fftp )",10i12)') (nie_fftp(i),i=0,npes_cdfft-1)
       write(nfout,'(" !|| ( nel_fftp )",10i12)') (nel_fftp(i),i=0,npes_cdfft-1)
       write(nfout,'(" !|| (idisp_fftp)",10i12)') (idisp_fftp(i),i=0,npes_cdfft-1)
       write(nfout,'(" !|| ( ista_fftp,  iend_fftp )",2i12)') ista_fftp, iend_fftp
       write(nfout,'(" !|| --- nis_fftph,nie_fftph,nel_fftph ---")')
       write(nfout,'(" !|| ( npe_cdfft )",10i12)') (i,i=1,npes_cdfft)
       write(nfout,'(" !|| ( nis_fftph)",10i12)') (nis_fftph(i),i=0,npes_cdfft-1)
       write(nfout,'(" !|| ( nie_fftph)",10i12)') (nie_fftph(i),i=0,npes_cdfft-1)
       write(nfout,'(" !|| ( nel_fftph)",10i12)') (nel_fftph(i),i=0,npes_cdfft-1)
       write(nfout,'(" !|| ( ista_fftph, iend_fftph)",2i12)') ista_fftph, iend_fftph
    end if

    allocate(nis_sfftp(0:npes-1)); nis_sfftp = 0
    allocate(nie_sfftp(0:npes-1)); nie_sfftp = 0
    allocate(nel_sfftp(0:npes-1)); nel_sfftp = 0
    allocate(idisp_sfftp(0:npes-1)); idisp_sfftp = 0
    allocate(nis_sfftph(0:npes-1)); nis_sfftph = 0
    allocate(nie_sfftph(0:npes-1)); nie_sfftph = 0
    allocate(nel_sfftph(0:npes-1)); nel_sfftph = 0
    set_mapping_func = .false.
    if(ipri >= 1 .and. printable) write(nfout,'(" !|| nfftp = ",i10," <<m_Parallel_init_mpi_gga>>")') nfftp

!!$    call set_block_range(nfftp,npes,nel_sfftp,nis_sfftp,nie_sfftp,set_mapping_func)
!!$    ista_sfftp = nis_sfftp(mype)
!!$    iend_sfftp = nie_sfftp(mype)
!!$    idisp_sfftp(0) = 0
!!$    do i = 1, npes-1
!!$       idisp_sfftp(i) = idisp_sfftp(i-1) + nel_sfftp(i-1)
!!$    end do

    nfftph = nfftps/2
    call set_block_range(nfftph,npes,nel_sfftph,nis_sfftph,nie_sfftph,set_mapping_func)
    ista_sfftph = nis_sfftph(mype)
    iend_sfftph = nie_sfftph(mype)

    do i = 0, npes -1
       nis_sfftp(i) = nis_sfftph(i)*2 - 1
       nie_sfftp(i) = nie_sfftph(i)*2
       nel_sfftp(i) = nel_sfftph(i)*2
       idisp_sfftp(i) = nis_sfftp(i) - 1
    end do
    ista_sfftp = nis_sfftp(mype)
    iend_sfftp = nie_sfftp(mype)
    mp_sfftp = maxval(nel_sfftp)
    np_sfftp = nel_sfftp(mype)

    if(ipri >= 2 .and. printable) then
       write(nfout,'(" !|| --- nis_sfftp,nie_sfftp,nel_sfftp,idisp_sfftp ---")')
       write(nfout,'(" !|| ( npe      )",10i12)') (i,i=1,npes)
       write(nfout,'(" !|| ( nis_sfftp )",10i12)') (nis_sfftp(i),i=0,npes-1)
       write(nfout,'(" !|| ( nie_sfftp )",10i12)') (nie_sfftp(i),i=0,npes-1)
       write(nfout,'(" !|| ( nel_sfftp )",10i12)') (nel_sfftp(i),i=0,npes-1)
       write(nfout,'(" !|| (idisp_sfftp)",10i12)') (idisp_sfftp(i),i=0,npes-1)
       write(nfout,'(" !|| ( ista_sfftp,  iend_sfftp )",2i12)') ista_sfftp, iend_sfftp
       write(nfout,'(" !|| --- nis_sfftph,nie_sfftph,nel_sfftph ---")')
       write(nfout,'(" !|| ( npe       )",10i12)') (i,i=1,npes)
       write(nfout,'(" !|| ( nis_sfftph )",10i12)') (nis_sfftph(i),i=0,npes-1)
       write(nfout,'(" !|| ( nie_sfftph )",10i12)') (nie_sfftph(i),i=0,npes-1)
       write(nfout,'(" !|| ( nel_sfftph )",10i12)') (nel_sfftph(i),i=0,npes-1)
       write(nfout,'(" !|| ( ista_sfftph, iend_sfftph)",2i12)') ista_sfftph, iend_sfftph
    end if

    do j = 0, nrank_ggacmp-1
       icolor = 0
       key = 0
       if(myrank_ggacmp == j) then
          icolor = 1
          key = myrank_cdfft
       end if
!!$       do i = 0, npes_cdfft-1
!!$          if(mype == i + npes_cdfft*j) then
!!$             icolor = 1
!!$             key = i
!!$          end if
!!$       end do
       call mpi_comm_split(mpi_comm_group,icolor,key,mpi_cdfft_world(j),ierr)
       call mpi_comm_size(mpi_cdfft_world(j), newpes, ierr)
       call mpi_comm_rank(mpi_cdfft_world(j), newmype, ierr)
    end do

    do j = 0, npes_cdfft-1
       icolor = 0
       key = 0
       if(myrank_cdfft == j) then
          icolor = 1
          key = myrank_ggacmp
       end if
!!$       do i = 0, nrank_ggacmp-1
!!$          if(mype == i + nrank_ggacmp*j) then
!!$             icolor = 1
!!$             key = i
!!$          end if
!!$       end do
       call mpi_comm_split(mpi_comm_group,icolor,key,mpi_ggacmp_cross_world(j),ierr)
       call mpi_comm_size(mpi_ggacmp_cross_world(j),newpes,ierr)
       call mpi_comm_rank(mpi_ggacmp_cross_world(j),newmype,ierr)
       if(ipri >= 2) then
! === DEBUG by tkato 2011/07/12 ================================================
!         write(nfout,'(" !|| mype, newmype, newpes, mpi_ggacmp_cross_world = ",4i8)') &
!              & mype, newmype,newpes,mpi_ggacmp_cross_world(j)
          write(nfout,'(" !|| mype, newmype, newpes, mpi_ggacmp_cross_world = ",4i12)') &
               & mype, newmype,newpes,mpi_ggacmp_cross_world(j)
! ==============================================================================
       end if
    end do
  end subroutine m_Parallel_init_mpi_gga
    
  subroutine m_Parallel_init_mpi_mix(nfout,ipri,printable,kgpm)
    integer, intent(in) :: nfout,ipri,kgpm
    logical, intent(in) :: printable
    integer :: iwork, i
    allocate(is_kgpm(0:npes-1))
    allocate(ie_kgpm(0:npes-1))
    allocate(nel_kgpm(0:npes-1))
    iwork = ( kgpm - 1 ) / npes + 1
    if(ipri >= 2 .and. printable) then
       write(nfout,'(" !|| << init_mpi_mix >>")')
       write(nfout,'(" !|| kgpm = ",i12)') kgpm
       write(nfout,'(" !|| -- is_kgpm, ie_kgpm --")')
    end if
    do i = 0, npes-1
       is_kgpm(i) = min(i*iwork+1, kgpm+1)
       ie_kgpm(i) = min(is_kgpm(i)+iwork-1, kgpm)
       nel_kgpm(i) = ie_kgpm(i) - is_kgpm(i) + 1
       if(ipri >= 2 .and. printable) write(nfout,'(" !|| ",2i12)') is_kgpm(i),ie_kgpm(i)
    enddo
    ista_kgpm = is_kgpm(mype)
    iend_kgpm = ie_kgpm(mype)
    np_kgpm   = nel_kgpm(mype)
    mp_kgpm   = maxval(nel_kgpm)
    if(ipri == 1 .and. printable) then
       if(iend_kgpm <1000000) then
          write(nfout,'(" !|| ista_kgpm, iend_kgpm = ",i6,",",i6,", mp_kgpm = ",i6,", kgpm = ",i12 &
               & ,"  << m_Parallel_init_mpi_mix>>")') ista_kgpm,iend_kgpm,mp_kgpm,kgpm
       elseif(iend_kgpm <100000000)then
          write(nfout,'(" !|| ista_kgpm, iend_kgpm = ",i8,",",i8,", mp_kgpm = ",i8,", kgpm = ",i12 &
               & ,"  << m_Parallel_init_mpi_mix>>")') ista_kgpm,iend_kgpm,mp_kgpm,kgpm
       else
          write(nfout,'(" !|| ista_kgpm, iend_kgpm = ",i12,",",i12,", mp_kgpm = ",i12,", kgpm = ",i0 &
               & ,"  << m_Parallel_init_mpi_mix>>")') ista_kgpm,iend_kgpm,mp_kgpm,kgpm
       end if
    end if
  end subroutine m_Parallel_init_mpi_mix

  subroutine m_Parallel_init_mpi_snl(nfout,ipri,printable,nspin)
    integer, intent(in) :: nfout,ipri,nspin
    logical, intent(in) :: printable

    ista_snl = (ista_k + nspin - 1)/nspin
    iend_snl = iend_k/nspin
    if(ipri >= 1 .and. printable) then
       write(nfout,'(" !|| ista_snl, iend_snl = ",i5,",",i5," << m_Parallel_init_mpi_snl >>")') &
            & ista_snl,iend_snl
    end if
  end subroutine m_Parallel_init_mpi_snl

  subroutine m_Parallel_init_mpi_ffth(nfout,ipri,printable,nfft)
    integer, intent(in) :: nfout,ipri,nfft
    logical, intent(in) :: printable
    integer :: iwork, i, nffth
    nffth = nfft/2

    if ( .not. allocated(is_ffth) ) allocate(is_ffth(0:npes-1))
    if ( .not. allocated(ie_ffth) ) allocate(ie_ffth(0:npes-1))
    if ( .not. allocated(nel_ffth) ) allocate(nel_ffth(0:npes-1))

    iwork = ( nffth - 1 ) / npes + 1
    if(ipri >= 2 .and. printable) then
       write(nfout,'(" !|| << init_mpi_ffth >>")')
       write(nfout,'(" !|| nffth = ",i12)') nffth
       write(nfout,'(" !|| -- is_ffth, ie_ffth --")')
    end if
    do i = 0, npes-1
       is_ffth(i) = min(i*iwork+1, nffth+1)
       ie_ffth(i) = min(is_ffth(i)+iwork-1, nffth)
       nel_ffth(i) = ie_ffth(i) - is_ffth(i) + 1
       if(ipri >= 2 .and. printable) write(nfout,'(" !|| ",2i12)') is_ffth(i),ie_ffth(i)
    enddo
    ista_ffth = is_ffth(mype)
    iend_ffth = ie_ffth(mype)
    np_ffth   = nel_ffth(mype)
    mp_ffth   = maxval(nel_ffth)
    if(ipri == 1 .and. printable) then
       if(iend_ffth <1000) then
          write(nfout,'(" !|| ista_ffth, iend_ffth = ",i3,",",i3,", mp_ffth = ",i3,", nffth = ",i5 &
               & ,"  << m_Parallel_init_mpi_ffth >>")') ista_ffth,iend_ffth,mp_ffth,nffth
       elseif(iend_ffth <100000)then
          write(nfout,'(" !|| ista_ffth, iend_ffth = ",i5,",",i5,", mp_ffth = ",i5,", ffth = ",i6 &
               & ,"  << m_Parallel_init_mpi_ffth >>")') ista_ffth,iend_ffth,mp_ffth,nffth
       else
          write(nfout,'(" !|| ista_ffth, iend_ffth = ",i0,",",i0,", mp_atm = ",i0,", natm = ",i0 &
               & ,"  << m_Parallel_init_mpi_ffth >>")') ista_ffth,iend_ffth,mp_ffth,nffth
       end if
    end if
  end subroutine m_Parallel_init_mpi_ffth


  subroutine m_Parallel_init_mpi_nn(nfout,ipri,printable,nn)
    integer, intent(in) :: nfout,ipri,nn
    logical, intent(in) :: printable
    integer :: iwork, i,ia

    allocate(is_nn(0:nrank_e-1))
    allocate(ie_nn(0:nrank_e-1))
    allocate(nel_nn(0:nrank_e-1))
    iwork = ( nn - 1 ) / nrank_e + 1
    do i = 0, nrank_e-1
       is_nn(i) = min(i*iwork+1, nn+1)
       ie_nn(i) = min(is_nn(i)+iwork-1, nn)
       nel_nn(i) = ie_nn(i) - is_nn(i) + 1
       if(ipri >= 2 .and. printable) write(nfout,'(" !|| ",2i12)') is_nn(i),ie_nn(i)
    enddo
    ista_nn = is_nn(myrank_e)
    iend_nn = ie_nn(myrank_e)
  end subroutine m_Parallel_init_mpi_nn

  subroutine m_Parallel_init_mpi_rspace_aug(nfout,ipri,printable,natm,nmesh_rs_aug)
    integer, intent(in) :: nfout,ipri,natm
    logical, intent(in) :: printable
    integer, dimension(natm), intent(in) :: nmesh_rs_aug
    integer :: iwork, i,ia

    allocate(is_rspace_aug(0:npes-1))
    allocate(ie_rspace_aug(0:npes-1))
    allocate(nel_rspace_aug(0:npes-1))
    allocate(ista_rspace_aug_atm(natm));ista_rspace_aug_atm=0
    allocate(iend_rspace_aug_atm(natm));iend_rspace_aug_atm=0
    do ia=1,natm 
    iwork = ( nmesh_rs_aug(ia) - 1 ) / npes + 1
    if(ipri >= 2 .and. printable) then
       write(nfout,'(" !|| << init_mpi_rspace_aug >>")')
       write(nfout,'(" !|| nmesh_rs_aug = ",i12)') nmesh_rs_aug(ia)
       write(nfout,'(" !|| -- is_rspace_aug, ie_rspace_aug --")')
    end if
    do i = 0, npes-1
       is_rspace_aug(i) = min(i*iwork+1, nmesh_rs_aug(ia)+1)
       ie_rspace_aug(i) = min(is_rspace_aug(i)+iwork-1, nmesh_rs_aug(ia))
       nel_rspace_aug(i) = ie_rspace_aug(i) - is_rspace_aug(i) + 1
       if(ipri >= 2 .and. printable) write(nfout,'(" !|| ",2i12)') is_rspace_aug(i),ie_rspace_aug(i)
    enddo
    ista_rspace_aug_atm(ia) = is_rspace_aug(mype)
    iend_rspace_aug_atm(ia) = ie_rspace_aug(mype)
    if(ipri == 1 .and. printable) then
       if(iend_rspace_aug_atm(ia) <1000) then
          write(nfout,'(" !|| ista_rspace_aug, iend_rspace_aug = ",i3,",",i3,", mp_rspace_aug = ",i3,", nmesh_rs_aug_max = ",i5 &
          & ,"  << m_Parallel_init_mpi_rspace_aug >>")') &
          & ista_rspace_aug_atm(ia),iend_rspace_aug_atm(ia),mp_rspace_aug,nmesh_rs_aug(ia)
       else
          write(nfout,'(" !|| ista_rspace_aug, iend_rspace_aug = ",i0,",",i0,", mp_rspace_aug = ",i0,", nmesh_rs_aug_max = ",i0 &
          & ,"  << m_Parallel_init_mpi_atm >>")') ista_rspace_aug_atm(ia),iend_rspace_aug_atm(ia),mp_rspace_aug,nmesh_rs_aug(ia)
       end if
    end if
    enddo
  end subroutine m_Parallel_init_mpi_rspace_aug

  subroutine m_Parallel_init_mpi_nq(nfout,ipri,printable,nq)
    integer, intent(in) :: nfout, ipri,nq
    logical, intent(in) :: printable
    integer :: i,j,ip

    allocate(is_nq(0:npes-1));ista_nq=nq+1
    allocate(ie_nq(0:npes-1));iend_nq=0
    allocate(nel_nq(0:npes-1));nel_nq=0
    allocate(map_nq(nq));map_nq=0
    allocate(map_z_nq(nq));map_z_nq=0

    call set_block_range(nq,npes,nel_nq,is_nq,ie_nq,.true.,map_nq)
    ista_nq = is_nq(mype)
    iend_nq = ie_nq(mype)
    np_nq = nel_nq(mype)
    mp_nq = maxval(nel_nq)
    j = 0
    do ip = 1, npes
       do i = 1, nel_nq(ip-1)
          j = j + 1
          map_z_nq(j) = i
       end do
    end do
  end subroutine m_Parallel_init_mpi_nq

  subroutine m_Parallel_init_mpi_atm(nfout,ipri,printable,natm)
    integer, intent(in) :: nfout,ipri,natm
    logical, intent(in) :: printable
    integer :: iwork, i

    allocate(is_atm(0:npes-1))
    allocate(ie_atm(0:npes-1))
    allocate(nel_atm(0:npes-1))
    iwork = ( natm - 1 ) / npes + 1
    if(ipri >= 2 .and. printable) then
       write(nfout,'(" !|| << init_mpi_atm >>")')
       write(nfout,'(" !|| natm = ",i12)') natm
       write(nfout,'(" !|| -- is_natm, ie_natm --")')
    end if
    do i = 0, npes-1
       is_atm(i) = min(i*iwork+1, natm+1)
       ie_atm(i) = min(is_atm(i)+iwork-1, natm)
       nel_atm(i) = ie_atm(i) - is_atm(i) + 1
       if(ipri >= 2 .and. printable) write(nfout,'(" !|| ",2i12)') is_atm(i),ie_atm(i)
    enddo
    ista_atm = is_atm(mype)
    iend_atm = ie_atm(mype)
    np_atm   = nel_atm(mype)
    mp_atm   = maxval(nel_atm)
    if(ipri == 1 .and. printable) then
       if(iend_atm <1000) then
          write(nfout,'(" !|| ista_atm, iend_atm = ",i3,",",i3,", mp_atm = ",i3,", natm = ",i5 &
               & ,"  << m_Parallel_init_mpi_atm >>")') ista_atm,iend_atm,mp_atm,natm
       elseif(iend_kgpm <100000)then
          write(nfout,'(" !|| ista_atm, iend_atm = ",i5,",",i5,", mp_atm = ",i5,", natm = ",i6 &
               & ,"  << m_Parallel_init_mpi_atm >>")') ista_atm,iend_atm,mp_atm,natm
       else
          write(nfout,'(" !|| ista_atm, iend_atm = ",i0,",",i0,", mp_atm = ",i0,", natm = ",i0 &
               & ,"  << m_Parallel_init_mpi_atm >>")') ista_atm,iend_atm,mp_atm,natm
       end if
    end if
  end subroutine m_Parallel_init_mpi_atm

  subroutine m_Parallel_init_mpi_atm2(nfout,ipri,printable,natm2)
    integer, intent(in) :: nfout,ipri,natm2
    logical, intent(in) :: printable
    integer :: iwork, i
    allocate(is_atm2(0:npes-1))
    allocate(ie_atm2(0:npes-1))
    allocate(nel_atm2(0:npes-1))
    iwork = ( natm2 - 1 ) / npes + 1
    if(ipri >= 2 .and. printable) then
       write(nfout,'(" !|| << init_mpi_atm2 >>")')
       write(nfout,'(" !|| natm2 = ",i12)') natm2
       write(nfout,'(" !|| -- is_natm2, ie_natm2 --")')
    end if
    do i = 0, npes-1
       is_atm2(i) = min(i*iwork+1, natm2+1)
       ie_atm2(i) = min(is_atm2(i)+iwork-1, natm2)
       nel_atm2(i) = ie_atm2(i) - is_atm2(i) + 1
       if(ipri >= 2 .and. printable) write(nfout,'(" !|| ",2i12)') is_atm2(i),ie_atm2(i)
    enddo
    ista_atm2 = is_atm2(mype)
    iend_atm2 = ie_atm2(mype)
    np_atm2   = nel_atm2(mype)
    mp_atm2   = maxval(nel_atm2)

    if(ipri == 1 .and. printable) then
       if(iend_atm2 <1000) then
          write(nfout,'(" !|| ista_atm2, iend_atm2 = ",i3,",",i3,", mp_atm2 = ",i3,", natm2 = ",i5 &
               & ,"  << m_Parallel_init_mpi_atm2 >>")') ista_atm2,iend_atm2,mp_atm2,natm2
       elseif(iend_kgpm <100000)then
          write(nfout,'(" !|| ista_atm2, iend_atm2 = ",i5,",",i5,", mp_atm2 = ",i5,", natm2 = ",i6 &
               & ,"  << m_Parallel_init_mpi_atm2 >>")') ista_atm2,iend_atm2,mp_atm2,natm2
       else
          write(nfout,'(" !|| ista_atm2, iend_atm2 = ",i0,",",i0,", mp_atm2 = ",i0,", natm2 = ",i0 &
               & ,"  << m_Parallel_init_mpi_atm2 >>")') ista_atm2,iend_atm2,mp_atm2,natm2
       end if
    end if
  end subroutine m_Parallel_init_mpi_atm2


!!$#ifdef TRANSPOSE
  subroutine m_Parallel_init_mpi_nlmta(nfout,ipri,nlmta,nlmt,natm,lmta,ntyp,ilmt,ityp)
    integer, intent(in) :: nfout, ipri, nlmta, nlmt,natm,ntyp
!!$ASASASASAS
!!$    integer, intent(in), dimension(nlmt,ntyp) :: lmta
    integer, intent(in), dimension(nlmt,natm) :: lmta
!!$ASASASASAS
    integer, intent(in), dimension(ntyp)      :: ilmt
    integer, intent(in), dimension(natm)      :: ityp

    integer :: ip, ia, it, it0, n1, i, nsum
!!$ASASASASAS
    integer :: itmp
!!$ASASASASAS
    real(kind=8), allocatable, dimension(:) :: np
    real(kind=8) :: n_l, n_r
    allocate(np(0:nrank_e-1)); np = 0.d0
    

    allocate(nis_fs(0:nrank_e-1))
    allocate(nie_fs(0:nrank_e-1))
    allocate(nel_fs(0:nrank_e-1))
    allocate(nis_fs_atm(0:nrank_e-1))
    allocate(nie_fs_atm(0:nrank_e-1))
    allocate(nel_fs_atm(0:nrank_e-1))

    do ip = 1, nrank_e
       np(ip-1) = dble(nlmta)/nrank_e *ip
       if(ipri >= 2) write(nfout,'(" !|| ip = ",i5," np = ",f12.4)') ip,np(ip-1)
    end do

    ip = 0
    do ia = 1, natm
       it = ityp(ia)
!!$ASASASASAS
       itmp=ilmt(it)
       if(itmp==0)cycle
!!$ASASASASAS
       n1 = lmta(ilmt(it),ia)
       if(abs(n1-np(ip)) < 1.d-10) then
          ip = ip + 1
          nie_fs(ip-1) = n1
          nie_fs_atm(ip-1) = ia
       else if(n1 > np(ip)) then
          ip = ip+1
          if(ia == 1) then
             n_l = np(ip-1)+1
          else if(ia >= 2) then
             it0 = ityp(ia-1)
             itmp=ilmt(it0)
!!$ASASASASAS
             if(itmp/=0) n_l = np(ip-1)-lmta(ilmt(it0),ia-1)
!!$             n_l = np(ip-1)-lmta(ilmt(it0),ia-1)
!!$ASASASASAS
          end if
          n_r = n1 - np(ip-1)
          if(n_l >= n_r) then
             nie_fs(ip-1) = n1
             nie_fs_atm(ip-1) = ia
          else
             nie_fs(ip-1) = np(ip-1) - n_l
!!$ASASASASAS
!!$             if(nie_fs(ip-1) < 0) nie_fs(ip-1) = n1
             if(nie_fs(ip-1) < 0) nie_fs(ip-1) = 0
!!$ASASASASAS
             nie_fs_atm(ip-1) = ia-1
          end if
       end if
    end do
    do i = ip+1, nrank_e
       nie_fs(i-1) = nlmta
       nie_fs_atm(i-1) = natm
    end do
    nis_fs_atm(0) = 1
    nis_fs(0) = 1
    nel_fs(0) = nie_fs(0)
    nel_fs_atm(0) = nie_fs_atm(0)
    do ip = 1, nrank_e-1
       nis_fs_atm(ip) = nie_fs_atm(ip-1)+1
       nis_fs(ip)  = nie_fs(ip-1)+1
       nel_fs(ip) = nie_fs(ip) - nie_fs(ip-1)
       nel_fs_atm(ip) = nie_fs_atm(ip) - nie_fs_atm(ip-1)
    end do

    ista_fs = nis_fs(myrank_e)
    iend_fs = nie_fs(myrank_e)
    np_fs   = nel_fs(myrank_e)
    mp_fs   = maxval(nel_fs)
    ista_fs_atm = nis_fs_atm(myrank_e)
    iend_fs_atm = nie_fs_atm(myrank_e)
    np_fs_atm = nel_fs_atm(myrank_e)
    mp_fs_atm = maxval(nel_fs_atm)

    if(ipri >= 2) then
       nsum = 0
       write(nfout,'(" !||",9x,"ip",4x,"nis_fs",4x,"nie_fs",7x,"nel",11x &
         & ,"atm(nis,nie)",5x,"lmta")')
       do ip = 1, nrank_e
          it = ityp(nie_fs_atm(ip-1))
          if(nie_fs_atm(ip-1) > 0 .and. nie_fs_atm(ip-1) <= natm ) then
             write(nfout,'(" !|| ",4i10,2x,3i10)') &
                  &   ip,nis_fs(ip-1),nie_fs(ip-1),nel_fs(ip-1), nis_fs_atm(ip-1), nie_fs_atm(ip-1) &
                  & , lmta(ilmt(it),nie_fs_atm(ip-1))
          else
             write(nfout,'(" !|| ",4i10,2x,2i10)') &
                  &   ip,nis_fs(ip-1),nie_fs(ip-1),nel_fs(ip-1), nis_fs_atm(ip-1), nie_fs_atm(ip-1)
          end if

          nsum = nsum + nel_fs(ip-1)
       end do
       write(nfout,'(" !|| nsum = ", i5)') nsum

       write(nfout,'(" !|| --- nis_fs,nie_fs,nel_fs ---")')
       write(nfout,'(" !|| ( rank_e  )",15i7)')(i,i=1,nrank_e)
       write(nfout,'(" !|| ( nis_fs  )",15i7)')(nis_fs(i),i=0,nrank_e-1)
       write(nfout,'(" !|| ( nie_fs  )",15i7)')(nie_fs(i),i=0,nrank_e-1)
       write(nfout,'(" !|| ( nel_fs  )",15i7)')(nel_fs(i),i=0,nrank_e-1)
       write(nfout,'(" !|| myrank_e = ",i3 &
            & ," nlmta,ista_fs,iend_fs,np_fs,mp_fs = ",/,10x,5i7)') &
            & myrank_e,nlmta,ista_fs,iend_fs,np_fs,mp_fs

       write(nfout,'(" !|| --- nis_fs_atm,nie_fs_atm,nel_fs_atm ---")')
       write(nfout,'(" !|| ( rank_e  )",15i7)')(i,i=1,nrank_e)
       write(nfout,'(" !|| ( nis_fs_atm  )",15i7)')(nis_fs_atm(i),i=0,nrank_e-1)
       write(nfout,'(" !|| ( nie_fs_atm  )",15i7)')(nie_fs_atm(i),i=0,nrank_e-1)
       write(nfout,'(" !|| ( nel_fs_atm  )",15i7)')(nel_fs_atm(i),i=0,nrank_e-1)
       write(nfout,'(" !|| myrank_e = ",i3 &
            & ," nlmta,ista_fs_atm,iend_fs_atm,np_fs_atm,mp_fs_atm = ",/,10x,5i7)') &
            & myrank_e,nlmta,ista_fs_atm,iend_fs_atm,np_fs_atm,mp_fs_atm

    end if

    deallocate(np)
  end subroutine m_Parallel_init_mpi_nlmta
!!$#endif

  subroutine split_into_ggablock_cdfft(npes,nrank_ggacmp,npes_cdfft,nrest_cdfft)
    integer, intent(in)  :: npes
    integer, intent(out) :: nrank_ggacmp, npes_cdfft, nrest_cdfft

#ifdef _NO_GGA_SPLIT_
    nrank_ggacmp = 1
    npes_cdfft  = npes
    nrest_cdfft = 0
#else
    if(npes <= 2) then
       nrank_ggacmp = 1
       npes_cdfft  = npes
       nrest_cdfft = 0
    else
       nrank_ggacmp = 3
       npes_cdfft  = npes/nrank_ggacmp
       nrest_cdfft = npes - npes_cdfft*nrank_ggacmp
    end if
#endif
  end subroutine split_into_ggablock_cdfft
  
  subroutine m_Parallel_dealloc_mpi_nlmta()
    if(allocated(nis_fs)) deallocate(nis_fs)
    if(allocated(nie_fs)) deallocate(nie_fs)
    if(allocated(nel_fs)) deallocate(nel_fs)
    if(allocated(nis_fs_atm)) deallocate(nis_fs_atm)
    if(allocated(nie_fs_atm)) deallocate(nie_fs_atm)
    if(allocated(nel_fs_atm)) deallocate(nel_fs_atm)
  end subroutine m_Parallel_dealloc_mpi_nlmta

  subroutine m_Parallel_dealloc(neb_mode)
    logical, intent(in), optional :: neb_mode
    logical :: neb
    neb = .false.
    if(present(neb_mode)) neb = neb_mode

    if(allocated(is_kngp)) deallocate(is_kngp)
    if(allocated(ie_kngp)) deallocate(ie_kngp)
    if(allocated(nel_kngp)) deallocate(nel_kngp)

    if(.not.neb)then
    if(allocated(map_e)) deallocate(map_e)
    if(allocated(map_z)) deallocate(map_z)
    if(allocated(map_k)) deallocate(map_k)
    if(allocated(map_ek)) deallocate(map_ek)
    if(allocated(mpi_k_world)) deallocate(mpi_k_world)
    if(allocated(nis_e)) deallocate(nis_e)
    if(allocated(nie_e)) deallocate(nie_e)
    if(allocated(nel_e)) deallocate(nel_e)
    if(allocated(idisp_e)) deallocate(idisp_e)
#ifdef NEC_TUNE_SOFT
    if(allocated(ista_e_smp)) deallocate(ista_e_smp)
    if(allocated(iend_e_smp)) deallocate(iend_e_smp)
#endif
    if(allocated(nis_k)) deallocate(nis_k)
    if(allocated(nie_k)) deallocate(nie_k)
    if(allocated(nel_k)) deallocate(nel_k)

    if(allocated(ista_g1k)) deallocate(ista_g1k)
    if(allocated(iend_g1k)) deallocate(iend_g1k)
    if(allocated(np_g1k)) deallocate(np_g1k)
    if(allocated(mp_g1k)) deallocate(mp_g1k)
    
    if(allocated(nis_fftp)) deallocate(nis_fftp)
    if(allocated(nie_fftp)) deallocate(nie_fftp)
    if(allocated(nel_fftp)) deallocate(nel_fftp)
    if(allocated(idisp_fftp)) deallocate(idisp_fftp)
    if(allocated(nis_fftph)) deallocate(nis_fftph)
    if(allocated(nie_fftph)) deallocate(nie_fftph)
    if(allocated(nel_fftph)) deallocate(nel_fftph)

    if(allocated(is_kgpm)) deallocate(is_kgpm)
    if(allocated(ie_kgpm)) deallocate(ie_kgpm)
    if(allocated(nel_kgpm)) deallocate(nel_kgpm)

    if(allocated(is_atm)) deallocate(is_atm)
    if(allocated(ie_atm)) deallocate(ie_atm)
    if(allocated(nel_atm)) deallocate(nel_atm)

    if(allocated(is_atm2)) deallocate(is_atm2)
    if(allocated(ie_atm2)) deallocate(ie_atm2)
    if(allocated(nel_atm2)) deallocate(nel_atm2)
!!$#ifndef TRANSPOSE
!!$    endif
!!$#endif
!!$#ifdef TRANSPOSE
    if(allocated(nis_g1)) deallocate(nis_g1)
    if(allocated(nie_g1)) deallocate(nie_g1)
    if(allocated(nel_g1)) deallocate(nel_g1)
    if(allocated(nis_fs)) deallocate(nis_fs)
    if(allocated(nie_fs)) deallocate(nie_fs)
    if(allocated(nel_fs)) deallocate(nel_fs)
    if(allocated(nis_fs_atm)) deallocate(nis_fs_atm)
    if(allocated(nie_fs_atm)) deallocate(nie_fs_atm)
    if(allocated(nel_fs_atm)) deallocate(nel_fs_atm)
    endif

    if(allocated(nis_g1k)) deallocate(nis_g1k)
    if(allocated(nie_g1k)) deallocate(nie_g1k)
    if(allocated(nel_g1k)) deallocate(nel_g1k)
!!$#endif

    if(allocated(map_pe2ggacmp)) deallocate(map_pe2ggacmp)
    if(allocated(map_pe2cdfft)) deallocate(map_pe2cdfft)

    if(.not.neb)then
    if(allocated(map_ggacmp)) deallocate(map_ggacmp)
    if(allocated(idisp_fftph)) deallocate(idisp_fftph)
    if(allocated(mpi_cdfft_world)) deallocate(mpi_cdfft_world)
    if(allocated(mpi_ggacmp_cross_world)) deallocate(mpi_ggacmp_cross_world)

    if(allocated(nis_sfftp)) deallocate(nis_sfftp)
    if(allocated(nie_sfftp)) deallocate(nie_sfftp)
    if(allocated(nel_sfftp)) deallocate(nel_sfftp)
    if(allocated(idisp_sfftp)) deallocate(idisp_sfftp)
    if(allocated(nis_sfftph)) deallocate(nis_sfftph)
    if(allocated(nie_sfftph)) deallocate(nie_sfftph)
    if(allocated(nel_sfftph)) deallocate(nel_sfftph)

    if(allocated(mpi_nbmx_world)) deallocate(mpi_nbmx_world)
    if(allocated(nel_nbmx)) deallocate(nel_nbmx)
    if(allocated(nis_nbmx)) deallocate(nis_nbmx)
    if(allocated(nie_nbmx)) deallocate(nie_nbmx)
    if(allocated(idisp_nbmx)) deallocate(idisp_nbmx)

    if(allocated(nel_nbmx_k)) deallocate(nel_nbmx_k)
    if(allocated(nis_nbmx_k)) deallocate(nis_nbmx_k)
    if(allocated(nie_nbmx_k)) deallocate(nie_nbmx_k)
    if(allocated(idisp_nbmx_k)) deallocate(idisp_nbmx_k)
    if(allocated(mpi_nbmx_world_k)) deallocate(mpi_nbmx_world_k)
    if(allocated(nel_kg1_k)) deallocate(nel_kg1_k)
    if(allocated(nis_kg1_k)) deallocate(nis_kg1_k)
    if(allocated(nie_kg1_k)) deallocate(nie_kg1_k)
    if(allocated(idisp_kg1_k)) deallocate(idisp_kg1_k)
    endif
  end subroutine m_Parallel_dealloc

 logical function m_Parallel_resolve_conf_para()
   integer :: i,nn
   integer :: n1
   integer iargc,narg
   character(100) :: q1
   character(100) arg
   nrank_conf=-1
   m_Parallel_resolve_conf_para = .false.
   narg = iargc()
   n1 = -1
   do nn=1,narg
      call getarg(nn,q1)

!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.03.20 !!!!!!!!!!!!!!
      q1 = trim(adjustl(q1))
!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.03.20 !!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.03.20 !!!!!!!!!!!!!!
!!          if(index(trim(adjustl(q1)),"ne").ne.0) then

      if(q1(1:1) == "n".and. (q1(2:2) == "r".or.q1(2:2) == "c" .or. q1(2:2) == "i")) then
!!!!!!!!!!!!!!!!! modified by mizouchi@adv 2003.03.20 !!!!!!!!!!!!!!
         if((q1(3:3) == "=".or.q1(3:3) == ":") .and. len_trim(q1(4:)).ne.0) then
             q1 = q1(4:)
             if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                read(q1,*) n1
             else
                stop "wrong nr "
             end if
         else if(q1(3:3) == "=".or. q1(3:3) == ":") then
             call getarg(nn+1,q1)
             if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                read(q1,*) n1
             else
                stop "wrong nr "
             end if
         else
              call getarg(nn+1,q1)
              if(q1(1:1) == ":".and. len_trim(q1(2:)).ne.0) then 
                  q1 = q1(2:)
                  if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                     read(q1,*) n1
                  else
                     stop "wrong nr "
                  end if
              else if((q1(1:1) == "=".or.q1(1:1) == ":").and. len_trim(q1(2:)).eq.0) then
                  call getarg(nn+2,q1) 
                  if(iachar(q1(1:1)).ge.iachar("0").and.iachar(q1(1:1)).le.iachar("9")) then
                     read(q1,*) n1
                  else
                     stop "wrong nr "
                  end if
               else
                  stop "wrong nr "
               end if                   
         end if
      end if
   enddo
   
   nrank_conf = n1

   if(nrank_conf>=1) m_Parallel_resolve_conf_para = .true.
   conf_para = m_Parallel_resolve_conf_para
   if(conf_para)then
     call config_parallel_init()
   endif

   contains

   subroutine config_parallel_init()
     integer :: i,j
     integer npestmp,mypetmp,icolor,ikey,mpi_err
     integer mype_e, npes_e
     integer, allocatable ::  new_comm_world(:)
     call mpi_init(mpi_err)
     call mpi_comm_size(mpi_comm_world,npestmp,mpi_err)
     call mpi_comm_rank(mpi_comm_world,mypetmp,mpi_err)
     allocate(new_comm_world(0:nrank_conf-1))
     do i=0,nrank_conf-1
       icolor = 0
       ikey = 0
       do j=0, npestmp/nrank_conf-1
         if(mypetmp == j + (npestmp/nrank_conf)*i ) then
           icolor = 1
           ikey = i
         end if
       end do
       call mpi_comm_split( mpi_comm_world, icolor, ikey, new_comm_world(i), mpi_err )
     end do
 
     mype_conf = mypetmp/(npestmp/nrank_conf)
     mpi_comm_group = new_comm_world(mype_conf)
   end subroutine config_parallel_init

 end function m_Parallel_resolve_conf_para


end module m_Parallelization

!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 440 $)
!
!  MODULE: m_Hubbard
!
!  AUTHOR(S): T. Yamamoto   October/11/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!
module m_Hubbard
! $Id: m_Hubbard.f90 440 2015-08-03 07:18:01Z ktagami $
  use m_Const_Parameters,     only : DP,ON,ATOMIC_ORBITAL,SPHERICAL_HARMONICS
  use m_Files,                only : nfout
  use m_Control_Parameters,   only : nspin,ipri,printable,num_projectors &
       &                           , proj_attribute, af, projector_type &
       &                           , sw_constraint, const_site, const_alpha &
       &                           , iprihubbard
  use m_Ionic_System,         only : natm,ntyp,ityp,ihubbard
  use m_PseudoPotential,      only : prodphi,ilmt,ltp,mtp,taup,nlmt,ntau,nlmtt
  use m_Crystal_Structure,    only : op,nopr
  use m_Ionic_System,         only : napt
  use m_Orbital_Population,   only : i2lp,nyy,ilmt_yy,ommix
  use m_Electronic_Structure, only : dhub

! =============================== added by K. Tagami =============== 5.0
  use m_Const_Parameters, only :  OccMat_Type1, OccMat_Type2
  use m_Orbital_Population,   only : om
  use m_Control_Parameters,   only : occmat_type, sw_eval_energy_before_charge

! =================================================================== 5.0

! =============================== added by K. Tagami =============== 11.0
  use m_Const_Parameters, only :  CMPLDP
  use m_Control_Parameters, only : ndim_chgpot, ndim_magmom, ndim_spinor
  use m_ES_NonCollinear,  only : m_ES_MagMom_To_DensMat_porb, &
       &                         m_ES_DensMat_To_MagMom_dhub
  use m_Orbital_Population,  only : max2lp
! ================================================================== 11.0

  use m_Orbital_Population,   only : om_aimag, ommix_aimag
  use m_Electronic_Structure, only : dhub_aimag

  implicit none

! ======================== added by K. Tagami======================== 5.0
  real(kind=DP) :: Ueff_prefactor = 1.0D0
! =================================================================== 5.0

contains

  subroutine m_Hubbard_energy(energy)
    real(kind=DP), intent(out) :: energy

    integer :: is,ia,it,i1,i2,ih,ie
    real(kind=DP) :: omsum


    energy=0.d0
    if(sw_constraint == ON) return
    do is=1,nspin,af+1
       do ia=1,natm
          ih = ihubbard(ia)
! === Debug by Intel "-check all" option! by T.Kato 2011/03/28 =================
!         ie = proj_attribute(ih)%ielem
!         if(ih /= 0) then
          if(ih /= 0) then
             ie = proj_attribute(ih)%ielem
! ==============================================================================
             it=ityp(ia)
             omsum=0.d0
!
! ========================== modified by K. Tagami ======================= 5.0
!             do i2=1,i2lp(ih)
!                omsum = omsum + ommix(i2,i2,ie,ia,is)
!                do i1=1,i2lp(ih)
!                   omsum = omsum - ommix(i2,i1,ie,ia,is)*ommix(i1,i2,ie,ia,is)
!                end do
!             end do

             if ( sw_eval_energy_before_charge==ON) then
                do i2=1,i2lp(ih)
                   omsum = omsum + ommix(i2,i2,ie,ia,is)
                   do i1=1,i2lp(ih)
                      omsum = omsum - ommix(i2,i1,ie,ia,is)*ommix(i1,i2,ie,ia,is)
                   end do
                end do
             else
                do i2=1,i2lp(ih)
                   omsum = omsum + om(i2,i2,ie,ia,is)
                   do i1=1,i2lp(ih)
                      omsum = omsum - om(i2,i1,ie,ia,is)*om(i1,i2,ie,ia,is)
                   end do
                end do
             endif
! ======================================================================== 5.0

             energy = energy + 0.5d0*proj_attribute(ih)%Ueff*omsum
          end if
       end do
    end do
    energy=energy*(af+1)
    if(nspin==1) energy=energy*2.d0

! =============================== added by K. Tagami ==================== 5.0
    energy = energy *Ueff_prefactor
! ======================================================================= 5.0

  end subroutine m_Hubbard_energy

! ======================== added by K. Tagami ======================== 11.0
  subroutine m_Hubbard_energy_noncl(energy)
    real(kind=DP), intent(out) :: energy

    real(kind=DP), allocatable :: dmmat_r_magmom( :,:,: )
    real(kind=DP), allocatable :: dmmat_i_magmom( :,:,: )
    complex(kind=CMPLDP), allocatable :: dmmat_ssrep( :,:,: )

    integer :: ia, it,i1,i2,ih,ie
    integer :: is, size1
    complex(kind=CMPLDP) :: dsum

    if(sw_constraint == ON) return

    energy=0.d0

    do ia=1,natm
       ih = ihubbard(ia)
       if(ih /= 0) then
          ie = proj_attribute(ih)%ielem
          it=ityp(ia)

          size1 = i2lp(ih)
          allocate( dmmat_r_magmom(size1,size1,ndim_magmom) ); dmmat_r_magmom = 0.0d0
          allocate( dmmat_i_magmom(size1,size1,ndim_magmom) ); dmmat_i_magmom = 0.0d0
          allocate( dmmat_ssrep(size1,size1,ndim_chgpot) );    dmmat_ssrep = 0.0d0

          if ( sw_eval_energy_before_charge == ON ) then
             dmmat_r_magmom(:,:,:) = ommix(:,:,ie,ia,:)
             dmmat_i_magmom(:,:,:) = ommix_aimag(:,:,ie,ia,:)
          else
             dmmat_r_magmom(:,:,:) = om(:,:,ie,ia,:)
             dmmat_i_magmom(:,:,:) = om_aimag(:,:,ie,ia,:)
          endif
          call m_ES_MagMom_To_DensMat_porb( size1**2, dmmat_r_magmom, dmmat_i_magmom, &
               &                            dmmat_ssrep )

          dsum=0.d0
          Do is=1, ndim_chgpot
             if ( is==1 .or. is==ndim_chgpot ) then
                do i2=1,i2lp(ih)
                   dsum = dsum + dmmat_ssrep(i2,i2,is)
                end do
             endif
          End do
          Do is=1, ndim_chgpot
             do i2=1,i2lp(ih)
                do i1=1,i2lp(ih)
                   dsum = dsum - dmmat_ssrep(i1,i2,is) &
                        &        *conjg( dmmat_ssrep(i1,i2,is) )
                end do
             end do
          End do

          energy = energy + 0.5d0*proj_attribute(ih)%Ueff *real(dsum)

          deallocate( dmmat_r_magmom, dmmat_i_magmom )
          deallocate( dmmat_ssrep )
       end if
    end do

    energy = energy *Ueff_prefactor

  end subroutine m_Hubbard_energy_noncl

  subroutine m_Hubbard_energy2_noncl(energy)           ! for safety
    real(kind=DP), intent(out) :: energy

    real(kind=DP), allocatable :: dmmat_r_magmom( :,:,: )
    real(kind=DP), allocatable :: dmmat_i_magmom( :,:,: )
    complex(kind=CMPLDP), allocatable :: dmmat_ssrep( :,:,: )

    integer :: ia, it,i1,i2,ih,ie
    integer :: is, size1
    complex(kind=CMPLDP) :: dsum

    if(sw_constraint == ON) return

    energy=0.d0

    allocate( dmmat_r_magmom(max2lp,max2lp,ndim_magmom) )
    allocate( dmmat_i_magmom(max2lp,max2lp,ndim_magmom) )
    allocate( dmmat_ssrep(max2lp,max2lp,ndim_chgpot) )

    do ia=1,natm
       ih = ihubbard(ia)
       if(ih /= 0) then
          ie = proj_attribute(ih)%ielem
          it=ityp(ia)

          dmmat_r_magmom = 0.0d0
          dmmat_i_magmom = 0.0d0
          dmmat_ssrep = 0.0d0

          if ( sw_eval_energy_before_charge == ON ) then
             dmmat_r_magmom(:,:,:) = ommix(:,:,ie,ia,:)
             dmmat_i_magmom(:,:,:) = ommix_aimag(:,:,ie,ia,:)
          else
             dmmat_r_magmom(:,:,:) = om(:,:,ie,ia,:)
             dmmat_i_magmom(:,:,:) = om_aimag(:,:,ie,ia,:)
          endif
          call m_ES_MagMom_To_DensMat_porb( max2lp**2, dmmat_r_magmom, dmmat_i_magmom, &
               &                            dmmat_ssrep )

          dsum=0.d0
          Do is=1, ndim_chgpot
             if ( is==1 .or. is==ndim_chgpot ) then
                do i2=1,i2lp(ih)
                   dsum = dsum + dmmat_ssrep(i2,i2,is)
                end do
             endif
          End do
          Do is=1, ndim_chgpot
             do i2=1,i2lp(ih)
                do i1=1,i2lp(ih)
                   dsum = dsum - dmmat_ssrep(i1,i2,is) &
                        &        *conjg( dmmat_ssrep(i1,i2,is) )
                end do
             end do
          End do

          energy = energy + 0.5d0*proj_attribute(ih)%Ueff *real(dsum)

       end if
    end do

    energy = energy *Ueff_prefactor

    deallocate( dmmat_r_magmom, dmmat_i_magmom )
    deallocate( dmmat_ssrep )

  end subroutine m_Hubbard_energy2_noncl

  subroutine m_Hubbard_energy3_noncl(energy)           ! for safety
    real(kind=DP), intent(out) :: energy

    real(kind=DP), allocatable :: dmmat_r_magmom( :,:,: )
    real(kind=DP), allocatable :: dmmat_i_magmom( :,:,: )
    complex(kind=CMPLDP), allocatable :: dmmat_ssrep( :,:,: )
    complex(kind=CMPLDP), allocatable :: dm_large( :,: )

    integer :: ia, it,i1,i2,ih,ie
    integer :: is1, is2,  size1
    complex(kind=CMPLDP) :: dsum

    if(sw_constraint == ON) return

    energy=0.d0

    allocate( dmmat_r_magmom(max2lp,max2lp,ndim_magmom) )
    allocate( dmmat_i_magmom(max2lp,max2lp,ndim_magmom) )
    allocate( dmmat_ssrep(max2lp,max2lp,ndim_chgpot) )

    allocate( dm_large( max2lp*ndim_spinor, max2lp*ndim_spinor ) )
    dm_large = 0.0d0

    do ia=1,natm
       ih = ihubbard(ia)
       if(ih /= 0) then
          ie = proj_attribute(ih)%ielem
          it=ityp(ia)

          dmmat_r_magmom = 0.0d0
          dmmat_i_magmom = 0.0d0
          dmmat_ssrep = 0.0d0

          if ( sw_eval_energy_before_charge == ON ) then
             dmmat_r_magmom(:,:,:) = ommix(:,:,ie,ia,:)
             dmmat_i_magmom(:,:,:) = ommix_aimag(:,:,ie,ia,:)
          else
             dmmat_r_magmom(:,:,:) = om(:,:,ie,ia,:)
             dmmat_i_magmom(:,:,:) = om_aimag(:,:,ie,ia,:)
          endif
          call m_ES_MagMom_To_DensMat_porb( max2lp**2, dmmat_r_magmom, dmmat_i_magmom, &
               &                            dmmat_ssrep )

          dm_large = 00.0d0

          Do is1=1, ndim_spinor
             Do is2=1, ndim_spinor
                do i1=1,i2lp(ih)
                   do i2=1,i2lp(ih)
                      dm_large( max2lp*(is1-1) +i1, max2lp*(is2-1)+i2 ) &
                           &  = dmmat_ssrep( i1,i2, (is1-1)*ndim_spinor +is2 )
                   end do
                end do
             end do
          end do

          dsum=0.d0
          Do i1=1, ndim_spinor *max2lp
             dsum = dsum + dm_large( i1,i1 )
          End do
          Do i1=1, ndim_spinor *max2lp
             Do i2=1, ndim_spinor *max2lp
                dsum = dsum - dm_large( i1,i2 )*dm_large(i2,i1)
             end do
          End do

          energy = energy + 0.5d0*proj_attribute(ih)%Ueff *real(dsum)

       end if
    end do

    energy = energy *Ueff_prefactor

    deallocate( dm_large )
    deallocate( dmmat_r_magmom, dmmat_i_magmom )
    deallocate( dmmat_ssrep )

  end subroutine m_Hubbard_energy3_noncl
! ===================================================================== 11.0

  subroutine m_Hubbard_Potential(nfout)
    integer, intent(in) :: nfout
    integer :: is,ia,iyy
    integer :: ilmt1,m1,t1,ilmt2,m2,t2
    integer :: ih,it,ie,t0
    real(kind=DP) :: Ueff

    dhub = 0.d0
    do is=1,nspin,af+1
       do ia=1,natm
          if(sw_constraint == ON .and. ia /= const_site) cycle
          ih = ihubbard(ia)
          if(ih == 0) cycle
          Ueff = proj_attribute(ih)%Ueff
          it = proj_attribute(ih)%ityp
          ie = proj_attribute(ih)%ielem
          if(projector_type == SPHERICAL_HARMONICS) then
             do iyy=1,nyy(ih)
                ilmt1=ilmt_yy(1,iyy,ih)
                m1=mtp(ilmt1,it)
                t1=taup(ilmt1,it)
                ilmt2=ilmt_yy(2,iyy,ih)
                m2=mtp(ilmt2,it)
                t2=taup(ilmt2,it)
                !!$write(nfout,'("m1,t1,m2,t2=",4i3)') m1,t1,m2,t2
                if(sw_constraint == ON) then
                   if(m1==m2) then
                      dhub(ilmt1,ilmt2,ia,is)=const_alpha*prodphi(ih,t1,t2)
                   end if
                else
                   if(m1==m2) then
                      dhub(ilmt1,ilmt2,ia,is)=Ueff &
                      & *(0.5d0-ommix(m1,m2,ie,ia,is))*prodphi(ih,t1,t2)
                   else
                      dhub(ilmt1,ilmt2,ia,is)=-Ueff &
                      & *ommix(m1,m2,ie,ia,is)*prodphi(ih,t1,t2)
                   end if
                end if
                dhub(ilmt2,ilmt1,ia,is)=dhub(ilmt1,ilmt2,ia,is)
                !!$write(nfout,'("ilmt1,ilmt2,ia,is,dhub=",4i3,e12.5)') ilmt1,ilmt2,ia,is,dhub(ilmt1,ilmt2,ia,is)
                !!$write(nfout,'("ueff,ommix,prodphi=",3e12.5)') Ueff,ommix(m1,m2,ie,ia,is),prodphi(ih,t1,t2)
             end do
          else if(projector_type == ATOMIC_ORBITAL) then
             t0 = proj_attribute(ih)%t
             do iyy=1,nyy(ih)
                ilmt1=ilmt_yy(1,iyy,ih)
                m1=mtp(ilmt1,it)
                t1=taup(ilmt1,it)
                ilmt2=ilmt_yy(2,iyy,ih)
                m2=mtp(ilmt2,it)
                t2=taup(ilmt2,it)
                !!$write(nfout,'("m1,t1,m2,t2=",4i3)') m1,t1,m2,t2
                if(sw_constraint == ON) then
                   if(m1==m2) then
                      dhub(ilmt1,ilmt2,ia,is)=const_alpha*prodphi(ih,t1,t0)*prodphi(ih,t0,t2)
                   end if
                else
                   if(m1==m2) then
                      dhub(ilmt1,ilmt2,ia,is)=Ueff &
                      & *(0.5d0-ommix(m1,m2,ie,ia,is))*prodphi(ih,t1,t0)*prodphi(ih,t0,t2)
                   else
                      dhub(ilmt1,ilmt2,ia,is)=-Ueff &
                      & *ommix(m1,m2,ie,ia,is)*prodphi(ih,t1,t0)*prodphi(ih,t0,t2)
                   end if
                end if
                dhub(ilmt2,ilmt1,ia,is)=dhub(ilmt1,ilmt2,ia,is)
                !!$write(nfout,'("ilmt1,ilmt2,ia,is,dhub=",4i3,e12.5)') ilmt1,ilmt2,ia,is,dhub(ilmt1,ilmt2,ia,is)
                !!$write(nfout,'("ie,ueff,ommix,prodphi=",i3,3e12.5)') ie,Ueff,ommix(m1,m2,ie,ia,is),prodphi(ih,t1,t2)
             end do
          end if
       end do
    end do

    if(iprihubbard >2) then
       write(nfout,'("m_Hubbard_Potential")')
       do is=1,nspin,af+1
          do ia=1,natm
             ih=ihubbard(ia)
             if(ih==0) cycle
             it=ityp(ia)
             write(nfout,'("is,ia,it=",3i3)') is,ia,it
             do ilmt1=1,ilmt(it)
                write(nfout,'(14f8.3)') (dhub(ilmt1,ilmt2,ia,is),ilmt2=1,ilmt(it))
             end do
          end do
       end do
    end if
  end subroutine m_Hubbard_Potential

! =============================- added by K. Tagami ================ 5.0
  subroutine m_Hubbard_Potential2(nfout)
    integer, intent(in) :: nfout
    integer :: is,ia,iyy
    integer :: ilmt1,m1,t1,ilmt2,m2,t2
    integer :: ih,it,ie,t0
    real(kind=DP) :: Ueff, ctmp
! 
    integer :: ilmt3, ilmt4
    integer :: l1, l2, l3, l4, m3, m4, t3, t4, ilp
!
    if(.not.allocated(dhub)) then
       write(nfout,'(" dhub is not allocated (subroutine m_Hubbard_Potential2)")')
       call flush(nfout)
       stop ' dhub is not allocated (subroutine m_Hubbard_Potential2)'
    end if
    dhub = 0.d0
    do is=1,nspin,af+1
       do ia=1,natm
          if(sw_constraint == ON .and. ia /= const_site) cycle
          ih = ihubbard(ia)
          if(ih == 0) cycle
          Ueff = proj_attribute(ih)%Ueff

          it = proj_attribute(ih)%ityp
          ie = proj_attribute(ih)%ielem
          
          t0 = proj_attribute(ih)%t

          if ( occmat_type == OCCMAT_Type1 ) then
             do iyy=1,nyy(ih)
                ilmt1=ilmt_yy(1,iyy,ih); m1=mtp(ilmt1,it); t1=taup(ilmt1,it)
                ilmt2=ilmt_yy(2,iyy,ih); m2=mtp(ilmt2,it); t2=taup(ilmt2,it)

                if(sw_constraint == ON) then
                   if(m1==m2) then
                      dhub(ilmt1,ilmt2,ia,is)=const_alpha*prodphi(ih,t1,t2)
                   end if
                else
                   if(m1==m2) then
                      dhub(ilmt1,ilmt2,ia,is)=Ueff &
                      & *(0.5d0-ommix(m1,m2,ie,ia,is))*prodphi(ih,t1,t2)
                   else
                      dhub(ilmt1,ilmt2,ia,is)=-Ueff &
                      & *ommix(m1,m2,ie,ia,is)*prodphi(ih,t1,t2)
                   end if
                end if
                dhub(ilmt2,ilmt1,ia,is)=dhub(ilmt1,ilmt2,ia,is)
             end do
          else if ( occmat_type == OCCMAT_Type2 ) then
             t0 = proj_attribute(ih)%t
             do iyy=1,nyy(ih)
                ilmt1=ilmt_yy(1,iyy,ih); m1=mtp(ilmt1,it); t1=taup(ilmt1,it)
                ilmt2=ilmt_yy(2,iyy,ih); m2=mtp(ilmt2,it); t2=taup(ilmt2,it)
                ctmp = prodphi(ih,t1,t0)*prodphi(ih,t0,t2)

                if(sw_constraint == ON) then
                   if(m1==m2) then
                      dhub(ilmt1,ilmt2,ia,is)=const_alpha *ctmp
                   end if
                else
                   if(m1==m2) then
                      dhub(ilmt1,ilmt2,ia,is)=Ueff &
                      & *(0.5d0-ommix(m1,m2,ie,ia,is)) *ctmp
                   else
                      dhub(ilmt1,ilmt2,ia,is)=-Ueff &
                      & *ommix(m1,m2,ie,ia,is)*ctmp
                   end if
                end if
                dhub(ilmt2,ilmt1,ia,is)=dhub(ilmt1,ilmt2,ia,is)
             end do
          end if
       end do
    end do
! ======================================= addd by K. Tagami ============= 5.2
    dhub = dhub *Ueff_prefactor
! ======================================================================= 5.2

! --- for debug --
!    Do is=1, ndim_magmom
!       write(920,*) 'is = ', is
!       Do ia=1, natm
!          write(920,*) 'ia = ' , ia
!          Do ilmt1=1, ilmt(it)
!             Do ilmt2=1, ilmt(it)
!                write(920,*) 'ilmt1 ilmt2 = ' ,ilmt1, ilmt2
!                write(920,*) dhub(ilmt1,ilmt2,ia,is)
!             End do
!          End do
!       End do
!    End do
! ---------------

    if(iprihubbard >2) then
       write(nfout,'("m_Hubbard_Potential")')
       do is=1,nspin,af+1
          do ia=1,natm
             ih=ihubbard(ia)
             if(ih==0) cycle
             it=ityp(ia)
             write(nfout,'("is,ia,it=",3i3)') is,ia,it
             do ilmt1=1,ilmt(it)
                write(nfout,'(14f8.3)') (dhub(ilmt1,ilmt2,ia,is),ilmt2=1,ilmt(it))
              end do
          end do
       end do
    end if
  end subroutine m_Hubbard_Potential2
! ============================================================== 5.0

! ================== added by K. Tagami ================= 11.0
  subroutine m_Hubbard_Potential2_noncl(nfout)          
!                                        This does not work properly.
    integer, intent(in) :: nfout
    integer :: is,ia,iyy
    integer :: ilmt1,m1,t1,ilmt2,m2,t2
    integer :: ih,it,ie,t0
    real(kind=DP) :: Ueff, ctmp
! 
    integer :: ilmt3, ilmt4
    integer :: l1, l2, l3, l4, m3, m4, t3, t4, ilp
!
    dhub = 0.d0
    do ia=1,natm
       if(sw_constraint == ON .and. ia /= const_site) cycle

       ih = ihubbard(ia)
       if(ih == 0) cycle

       Ueff = proj_attribute(ih)%Ueff

       it = proj_attribute(ih)%ityp
       ie = proj_attribute(ih)%ielem
          
       t0 = proj_attribute(ih)%t

       Do is=1, ndim_magmom
          if ( occmat_type == OCCMAT_Type1 ) then
             do iyy=1,nyy(ih)
                ilmt1=ilmt_yy(1,iyy,ih); m1=mtp(ilmt1,it); t1=taup(ilmt1,it)
                ilmt2=ilmt_yy(2,iyy,ih); m2=mtp(ilmt2,it); t2=taup(ilmt2,it)
                
                if (sw_constraint == ON) then        
                   if ( is==1 .and. m1==m2) then     ! uncertain
                      dhub(ilmt1,ilmt2,ia,is)=const_alpha*prodphi(ih,t1,t2)
                   end if
                else
                   if ( is == 1 .and. m1==m2 ) then
                      dhub(ilmt1,ilmt2,ia,is)=Ueff &
                           & *(0.5d0-ommix(m1,m2,ie,ia,is))*prodphi(ih,t1,t2)
                   else
                      dhub(ilmt1,ilmt2,ia,is)=-Ueff &
                           & *ommix(m1,m2,ie,ia,is)*prodphi(ih,t1,t2)
                   end if
                end if
                dhub(ilmt2,ilmt1,ia,is)=dhub(ilmt1,ilmt2,ia,is)
             end do
          else if ( occmat_type == OCCMAT_Type2 ) then
             t0 = proj_attribute(ih)%t
             do iyy=1,nyy(ih)
                ilmt1=ilmt_yy(1,iyy,ih); m1=mtp(ilmt1,it); t1=taup(ilmt1,it)
                ilmt2=ilmt_yy(2,iyy,ih); m2=mtp(ilmt2,it); t2=taup(ilmt2,it)
                ctmp = prodphi(ih,t1,t0)*prodphi(ih,t0,t2)

                if (sw_constraint == ON) then
                   if ( is==1 .and. m1==m2 ) then            ! uncertain
                      dhub(ilmt1,ilmt2,ia,is)=const_alpha *ctmp
                   end if
                else
                   if ( is==1 .and. m1==m2 ) then
                      dhub(ilmt1,ilmt2,ia,is)=Ueff &
                           & *(0.5d0-ommix(m1,m2,ie,ia,is)) *ctmp
                   else
                      dhub(ilmt1,ilmt2,ia,is)=-Ueff &
                           & *ommix(m1,m2,ie,ia,is)*ctmp
                   end if
                end if
                dhub(ilmt2,ilmt1,ia,is)=dhub(ilmt1,ilmt2,ia,is)
             end do
          end if
       end do
    end do

    dhub = dhub *Ueff_prefactor

! --- for debug --
!    Do is=1, ndim_magmom
!       write(920,*) 'is = ', is
!       Do ia=1, natm
!          write(920,*) 'ia = ' , ia
!          Do ilmt1=1, ilmt(it)
!             Do ilmt2=1, ilmt(it)
!                write(920,*) 'ilmt1 ilmt2 = ' ,ilmt1, ilmt2
!                write(920,*) dhub(ilmt1,ilmt2,ia,is)
!             End do
!          End do
!       End do
!    End do
! ---------------

    if (iprihubbard >2) then
       write(nfout,'("m_Hubbard_Potential2_noncl")')
       do is=1,ndim_magmom,af+1
          do ia=1,natm
             ih=ihubbard(ia)
             if(ih==0) cycle
             it=ityp(ia)
             write(nfout,'("is,ia,it=",3i3)') is,ia,it
             do ilmt1=1,ilmt(it)
                write(nfout,'(14f8.3)') (dhub(ilmt1,ilmt2,ia,is),ilmt2=1,ilmt(it))
              end do
          end do
       end do
    end if
  end subroutine m_Hubbard_Potential2_noncl

  subroutine m_Hubbard_Potential3_noncl(nfout)
    integer, intent(in) :: nfout
    integer :: is,ia,iyy
    integer :: ilmt1,m1,t1,ilmt2,m2,t2
    integer :: ih,it,ie,t0
    real(kind=DP) :: Ueff, ctmp
! 
    integer :: ilmt3, ilmt4
    integer :: l1, l2, l3, l4, m3, m4, t3, t4, ilp

    real(kind=DP), allocatable :: dmmat_r_magmom( :,:,: )
    real(kind=DP), allocatable :: dmmat_i_magmom( :,:,: )
    complex(kind=CMPLDP), allocatable :: dmmat_ssrep( :,:,: )
!
    complex(kind=CMPLDP), allocatable :: dhub_ssrep( :,:,:,: )
!

    dhub = 0.d0

    allocate( dhub_ssrep(nlmt,nlmt,natm,ndim_magmom) )
    dhub_ssrep = 0.0d0

    allocate( dmmat_r_magmom(max2lp,max2lp,ndim_magmom) )
    allocate( dmmat_i_magmom(max2lp,max2lp,ndim_magmom) )
    allocate( dmmat_ssrep(max2lp,max2lp,ndim_chgpot) )

    do ia=1,natm
       if(sw_constraint == ON .and. ia /= const_site) cycle

       ih = ihubbard(ia)
       if(ih == 0) cycle

       Ueff = proj_attribute(ih)%Ueff

       it = proj_attribute(ih)%ityp
       ie = proj_attribute(ih)%ielem
          
       t0 = proj_attribute(ih)%t
       ilp = proj_attribute(ih)%l +1

       dmmat_r_magmom = 0.0d0;   dmmat_i_magmom = 0.0d0;  dmmat_ssrep = 0.0d0
       dmmat_r_magmom(:,:,:) = ommix(:,:,ie,ia,:)
       dmmat_i_magmom(:,:,:) = ommix_aimag(:,:,ie,ia,:)

       call m_ES_MagMom_To_DensMat_porb( max2lp**2, dmmat_r_magmom, dmmat_i_magmom, &
            &                            dmmat_ssrep )

       Do is=1, ndim_chgpot
          if ( occmat_type == OCCMAT_Type1 ) then
             do ilmt1=1, ilmt(it)
                do ilmt2=1, ilmt(it)
                   l1 = ltp(ilmt1,it); m1 = mtp(ilmt1,it); t1 = taup(ilmt1,it)
                   l2 = ltp(ilmt2,it); m2 = mtp(ilmt2,it); t2 = taup(ilmt2,it)
                   
                   if ( l1 /= l2 .or. l1 /= ilp ) cycle
                   
                   if (sw_constraint == ON) then        
                      stop 'kt : not supported. '
                   else
                      if ( (is == 1 .or. is==ndim_chgpot) .and. m1==m2 ) then
                         dhub_ssrep(ilmt1,ilmt2,ia,is) = Ueff &
                              & *( 0.5d0 - dmmat_ssrep(m1,m2,is) )*prodphi(ih,t1,t2)
                      else
                         dhub_ssrep(ilmt1,ilmt2,ia,is) = -Ueff &
                           & *dmmat_ssrep(m1,m2,is) *prodphi(ih,t1,t2)
!                           & *conjg( dmmat_ssrep(m1,m2,is) ) *prodphi(ih,t1,t2)
                      end if
                   end if
                end do
             end do

          else if ( occmat_type == OCCMAT_Type2 ) then
             t0 = proj_attribute(ih)%t

             do ilmt1=1, ilmt(it)
                do ilmt2=1, ilmt(it)
                   l1 = ltp(ilmt1,it); m1 = mtp(ilmt1,it); t1 = taup(ilmt1,it)
                   l2 = ltp(ilmt2,it); m2 = mtp(ilmt2,it); t2 = taup(ilmt2,it)
                   
                   if ( l1 /= l2 .or. l1 /= ilp ) cycle
                   ctmp = prodphi(ih,t1,t0)*prodphi(ih,t0,t2)
                   
                   if (sw_constraint == ON) then        
                      stop 'kt : not supported. '
                   else
                      if ( (is == 1 .or. is==ndim_chgpot) .and. m1==m2 ) then
                         dhub_ssrep(ilmt1,ilmt2,ia,is) = Ueff &
                              & *( 0.5d0 - dmmat_ssrep(m1,m2,is) )*ctmp
                      else
                         dhub_ssrep(ilmt1,ilmt2,ia,is) = -Ueff &
                           & *dmmat_ssrep(m1,m2,is) *ctmp
                      end if
                   end if
                end do
             end do

          end if
       end do
    end do
!
    call m_ES_DensMat_to_MagMom_Dhub( dhub_ssrep, dhub, dhub_aimag )
!
    dhub = dhub *Ueff_prefactor
    dhub_aimag = dhub_aimag *Ueff_prefactor
!
    goto 1200

! --- for debug --
    Do is=1, ndim_magmom
       write(920,*) 'is = ', is
       Do ia=1, natm
          write(920,*) 'ia = ' , ia
          Do ilmt1=1, ilmt(it)
             Do ilmt2=1, ilmt(it)
                write(920,*) 'ilmt1 ilmt2 = ' ,ilmt1, ilmt2
                write(920,*) dhub_ssrep(ilmt1,ilmt2,ia,is)
             End do
          End do
       End do
    End do
! ---------------

    do ia=1,natm
       do is=1, ndim_magmom

          Do ilmt1=1, ilmt(it)
             Do ilmt2=1, ilmt(it)
                write(960,*) ' ia lmt1 lmtm2 istmp = ', ia, ilmt1, ilmt2, is
                write(960,*) 'A ', dhub(ilmt1,ilmt2,ia,is), dhub(ilmt2,ilmt1,ia,is)
                write(960,*) 'B ', dhub_aimag(ilmt1,ilmt2,ia,is), dhub_aimag(ilmt2,ilmt1,ia,is)
             end do
          end do
       end do
    end do

1200 continue

    if (iprihubbard >2) then
       write(nfout,'("m_Hubbard_Potential3_noncl")')
       do is=1,ndim_magmom,af+1
          do ia=1,natm
             ih=ihubbard(ia)
             if(ih==0) cycle
             it=ityp(ia)
             write(nfout,'("is,ia,it=",3i3)') is,ia,it
             do ilmt1=1,ilmt(it)
                write(nfout,'(14f8.3)') (dhub(ilmt1,ilmt2,ia,is),ilmt2=1,ilmt(it))
              end do
          end do
       end do
    end if

    deallocate( dhub_ssrep )
    deallocate( dmmat_ssrep )
    deallocate( dmmat_r_magmom, dmmat_i_magmom )

  end subroutine m_Hubbard_Potential3_noncl
! ============================================================== 11.0

end module m_Hubbard

!================================================
!  Software name : STM
!  Module m_Timing
!  Subroutine(s) : tstatc0_begin, wd_the_subroutine_name, tstac0_end
!                  tstatc_init, tstatc_wd0, tstatc_wd, tstatc_iter
!  Author(s)     : Takahiro Yamasaki (June 7, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.

module m_Timing
! $Id: m_Timing.f90,v 1.1.1.1 2004/06/26 11:21:37 yamasaki Exp $
  use m_Const_Parameters,   only : DP
  !use m_Control_Parameters, only : ipri

  implicit none
  integer :: ipri=0
  integer, parameter :: MSBRNM         = 100
  integer, parameter :: long_name_size = 32
  character*(long_name_size), dimension(0:MSBRNM) :: subroutine_names
  character*(long_name_size)                 :: temp_str
  real(DP), dimension(0:MSBRNM)              :: tstart=0, ecpu=0
  integer, dimension(MSBRNM)  :: iorder
  integer                     :: n_sub_names = 0

  real(DP)               :: ecpu_previous = 0.d0
  real(DP), parameter    :: UMICRO = 1.d-6
  real(DP), parameter    :: PCPUDF = 0.03
  integer, parameter     :: N_SUBROUTINES = 10

contains
  subroutine tstatc0_begin(a_sub_name,id)
    character*(*), intent(in) :: a_sub_name
    integer, intent(inout)    :: id

    real(kind=DP)             :: t_start
    integer                   :: i, len

    len = len_trim(a_sub_name)

! -- finding the pointer of subroutine_names --'    
    if(id <= 0) then
       do i = 1, n_sub_names
          if(a_sub_name(1:len) == subroutine_names(i)(1:len)) then
             id = i
             exit
          end if
       end do
    end if
    if(id <= 0) then
       if( n_sub_names < MSBRNM) then
          n_sub_names = n_sub_names + 1
          id          = n_sub_names
          write(subroutine_names(id),'(a32)') a_sub_name
       else
          print *,' !! Size of an array of subroutine_names should be enlarged (->m_Timing)'
       end if
    end if

    if(ipri >= 2) call wd_the_subroutine_name
!!$   if(ipri >= 2) print '(" <<< ",a32," >>>")',subroutine_names(id)

    if(id >= 1 .and. id <= MSBRNM) then
       call gettod(t_start)
       tstart(id) = t_start
    end if
  contains
    subroutine wd_the_subroutine_name
      integer :: i, ip
      ip = long_name_size - len
      ip = ip / 2
      do i = 1, ip
         temp_str(i:i) = '-'
      end do
      do i = 1, len
         temp_str(i+ip:i+ip) = a_sub_name(i:i)
      end do
      do i = ip + len + 1, long_name_size
         temp_str(i:i) = '-'
      end do
      print '(" <<<",a32,">>>")',temp_str
    end subroutine wd_the_subroutine_name
  end subroutine tstatc0_begin

  subroutine tstatc0_end(id)
    integer, intent(in) :: id
    real(kind=DP) :: t_end, t_used

    call gettod(t_end)
    t_used = t_end - tstart(id)
    ecpu(id) = ecpu(id) + t_used * UMICRO
  end subroutine tstatc0_end

  subroutine tstatc_init
    tstart(1:MSBRNM) = 0.d0; ecpu(1:MSBRNM) = 0.d0
  end subroutine tstatc_init

  subroutine tstatc_wd0
    integer i, ip, nsub
    print '(" n_sub_names = ",i5)', n_sub_names
    print '(" << cpu time statistics >>")'

    call tsort(ecpu(1),MSBRNM,iorder)

    nsub = n_sub_names

    do i = 1, nsub
       ip = iorder(i)
       if(ecpu(ip) < UMICRO) exit
       print '(i5,2x,a32,f11.5,"(sec.)")',i,subroutine_names(ip),ecpu(ip)
    end do
  end subroutine tstatc_wd0

  subroutine tstatc_wd(iteration)
    integer, intent(in) :: iteration
    integer i, ip, nsub
    real(kind=DP) :: cpudif, pecpu

    cpudif = dabs(ecpu(0) - ecpu_previous)
    if(cpudif < ecpu_previous * PCPUDF .or. ecpu(0) < UMICRO) then
!!$       print '(" ! cpudif  = ",f20.10," ecpu_prev = ",f20.10)', cpudif, ecpu_previous
!!$       print '(" ! ecpu(0) = ",f20.10)',ecpu(0)
       goto 1001
    end if

    print '(" << CPU Time Consumption -- TOP",i4," Subroutines (",i5,") >>")' &
         & , N_SUBROUTINES, iteration
    call tsort(ecpu(1),MSBRNM,iorder)

    nsub = min(n_sub_names, N_SUBROUTINES)
    do i = 1, nsub
       ip = iorder(i)
       if(ecpu(ip) < UMICRO) exit
       pecpu = ecpu(ip)/ecpu(0) * 100
       print '(2i4,2x,a32,f11.5,"(sec.)",f6.2,"(%)")' &
            & ,i,ip, subroutine_names(ip),ecpu(ip),pecpu
    end do
    print '(6x,"Total cpu time of this iteration",4x,f11.5,"(sec.)")',ecpu(0)

1001 ecpu_previous = ecpu(0)
  end subroutine tstatc_wd

  subroutine tstatc_iter(iteration, first_iteration_of_this_job)
    integer, intent(in) :: iteration, first_iteration_of_this_job
    real(kind=DP) :: t_end, t_used
    call gettod(t_end)
    if(iteration > first_iteration_of_this_job) then
       t_used  = t_end - tstart(0)
       ecpu(0) = t_used * UMICRO
    end if
    tstart(0) = t_end
  end subroutine tstatc_iter

end module m_Timing

!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 440 $)
!
!  MODULE: m_PAW_Hartree
!
!  AUTHOR(S): T. Yamasaki, T. Yamamoto and T. Ohno November/2009
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_PAW_Hartree
  use m_Const_Parameters,     only   : DP
  use m_Control_Parameters,   only   : nspin,af,printable,ipripp
  use m_Ionic_System,         only   : ntyp,ivan,iatomn,iatom,natm, iwei, ityp
  use m_Charge_Density,       only   : hsr,hsro
  use m_PseudoPotential,      only   : dion_hartree,dion_hartree_now, ilmt,ipaw &
       , n_cijkclmk,ilmt3_cijkclmk,ilmt4_cijkclmk &
       , CijkClmkVVVVijlm_k &
       , CijkClmkVVVVijlm_k_ae &
       , flg_symmtry,ia2ia_symmtry_op &
       , n_cijkclmn,ilmt3_cijkclmn,ilmt4_cijkclmn &
       , CijkClmnVVVVijlm_kn &
       , CijkClmnVVVVijlm_kn_ae
  use m_Crystal_Structure,    only   : nopr
  use m_Files,                only   : nfout
  
! =========================== added by K. Tagami ============= 11.0
  use m_Control_Parameters,   only : noncol
! ============================================================ 11.0

  implicit none
  private
  
  real(DP),pointer,dimension(:):: eh_paw,eho_paw
  
  public:: m_PAW_Hartree_alloc_ehs
  public:: m_PAWH_get_dion_hartree
  public:: m_PAWH_get_dion_hartree_now
  public:: m_PAWH_get_energy_hartree
    
contains
    
  subroutine m_PAW_Hartree_alloc_ehs
    allocate(eh_paw(natm));eh_paw=0.d0
    allocate(eho_paw(natm));eho_paw=0.d0
    return
  end subroutine m_PAW_Hartree_alloc_ehs
  
  subroutine m_PAW_Hartree_dealloc_ehs
    deallocate(eh_paw,eho_paw)
    return
  end subroutine m_PAW_Hartree_dealloc_ehs
  
  subroutine m_PAWH_get_dion_hartree(nfout)
    integer,intent(in):: nfout
    integer:: ia,ja,it,lmt1,lmt2,lmt3,lmt4,is,mp,nlmt
    real(DP):: fac,sum,sum_ae
    real(DP),pointer:: dion_hartree_ae(:,:,:)
    integer:: iopr
    integer, parameter :: PRINTLEVEL = 2
    logical,pointer:: flg_done(:)
    
! ========================== added by K. Tagami ================== 11.0
    integer :: ismax
    if ( noncol ) then
       ismax = 1
    else
       ismax = nspin
    endif
! ================================================================ 11.0

!    write(801,*) hsr
!    stop

    nlmt=maxval(ilmt)
    allocate(dion_hartree_ae(nlmt,nlmt,natm))
    dion_hartree_ae=0.d0
    
    do ia=1,natm
       it=ityp(ia)
!TypeLoop:   do it=1,ntyp
!                if(ityp(ia)/=it) cycle
       if(ipaw(it)/=1) then
          dion_hartree(:,:,ia)=0.d0
!                    exit TypeLoop
          cycle
       end if
       
       if(.not.flg_symmtry) then
          do lmt1=1,ilmt(it)
             do lmt2=lmt1,ilmt(it)
                sum=0.d0
                sum_ae=0.d0
                do mp=1,n_cijkclmk(lmt1,lmt2,it)
                   lmt3=ilmt3_cijkclmk(lmt1,lmt2,mp,it)
                   lmt4=ilmt4_cijkclmk(lmt1,lmt2,mp,it)
                   if(lmt3.gt.lmt4) then
                      write(nfout,*) 'Error in calcDionHartree !'
                      write(nfout,'(a,i4)') 'lmt3 = ',lmt3
                      write(nfout,'(a,i4)') 'lmt4 = ',lmt4
                      stop
                   end if
                   fac=2.d0;if(lmt3.eq.lmt4) fac=1.d0

! ========================== modified by K. Tagami ================== 11.0
!                   do is=1,nspin
                   do is=1, ismax
! =================================================================== 11.0
                      sum=sum+CijkClmkVVVVijlm_k(lmt1,lmt2,mp,it)* &
                           hsr(ia,lmt3,lmt4,is)*fac
                      sum_ae=sum_ae+CijkClmkVVVVijlm_k_ae(lmt1,lmt2,mp,it)* &
                           hsr(ia,lmt3,lmt4,is)*fac
                   end do

                end do
                dion_hartree(lmt1,lmt2,ia)=sum
                dion_hartree_ae(lmt1,lmt2,ia)=sum_ae
             end do
          end do
       else
          do lmt1=1,ilmt(it)
             do lmt2=lmt1,ilmt(it)
                sum=0.d0
                sum_ae=0.d0
                do iopr=1,nopr
                   do mp=1,n_cijkclmn(lmt1,lmt2,ia,iopr)
                      lmt3=ilmt3_cijkclmn(lmt1,lmt2,mp,ia,iopr)
                      lmt4=ilmt4_cijkclmn(lmt1,lmt2,mp,ia,iopr)
                      if(lmt3.gt.lmt4) then
                         write(nfout,*) 'Error in calcDionHartree !'
                         write(nfout,'(a,i4)') 'lmt3 = ',lmt3
                         write(nfout,'(a,i4)') 'lmt4 = ',lmt4
                         stop
                      end if
                      fac=2.d0;if(lmt3.eq.lmt4) fac=1.d0

! ========================== modified by K. Tagami ================== 11.0
!                      do is=1,nspin
                      do is=1, ismax
! =================================================================== 11.0

                         sum=sum+CijkClmnVVVVijlm_kn(lmt1,lmt2,mp,ia,iopr)* &
                              hsr(abs(ia2ia_symmtry_op(ia,iopr)),lmt3,lmt4,is)*fac
                         sum_ae=sum_ae+CijkClmnVVVVijlm_kn_ae(lmt1,lmt2,mp,ia,iopr)* &
                              hsr(abs(ia2ia_symmtry_op(ia,iopr)),lmt3,lmt4,is)*fac
                         !print *,CijkClmnVVVVijlm_kn_ae(lmt1,lmt2,mp,ia,iopr)
                      end do
                   end do
                end do
                dion_hartree(lmt1,lmt2,ia)=sum/dble(nopr)
                dion_hartree_ae(lmt1,lmt2,ia)=sum_ae/dble(nopr)
             end do
          end do
       end if
            
!            end do TypeLoop
    end do

    if(af /= 0) then
       allocate(flg_done(natm))
       flg_done=.false.
       do ia=1,natm
          if(flg_done(ia)) cycle
          ja=ia2ia_symmtry_op(ia,nopr+af)
          dion_hartree(:,:,ia)=(dion_hartree(:,:,ia)+dion_hartree(:,:,ja))/2.d0
          dion_hartree(:,:,ja)=dion_hartree(:,:,ia)
          flg_done(ja)=.true.
       end do
       deallocate(flg_done)
    end if
    
    if(ipripp>=PRINTLEVEL.and.printable)then
       write(nfout,*)
       write(nfout,*) ' -- dion_hartree ---'
       do ia=1,natm
          write(nfout,'(a,i2)') 'ia = ',ia
          it=ityp(ia)
          if(ipaw(it)/=1) cycle
          do lmt1 = 1, ilmt(it)
             write(nfout,'(i3,15f15.9/15f15.9)') lmt1 &
                  &               ,(dion_hartree(lmt1,lmt2,ia),lmt2 = 1, ilmt(it))
          enddo
       end do
       write(nfout,*)
       write(nfout,*) ' -- dion_hartree_ae ---'
       do ia=1,natm
          write(nfout,'(a,i2)') 'ia = ',ia
          it=ityp(ia)
          if(ipaw(it)/=1) cycle
          do lmt1 = 1, ilmt(it)
             write(nfout,'(i3,15f15.9/15f15.9)') lmt1 &
                  &               ,(dion_hartree_ae(lmt1,lmt2,ia),lmt2 = 1, ilmt(it))
          enddo
       end do
    endif
    
    deallocate(dion_hartree_ae)
!    do lmt1=1,8
!    print '(8f19.6)',(dion_hartree(lmt1,lmt2,1),lmt2=1,8)
!    end do
!    stop
    return
  end subroutine m_PAWH_get_dion_hartree
    
  subroutine m_PAWH_get_dion_hartree_now(nfout)
    integer,intent(in):: nfout
    integer:: ia,ja,it,lmt1,lmt2,lmt3,lmt4,is,mp
    real(DP):: fac,sum
    integer:: iopr
    logical,pointer:: flg_done(:)
    
! ========================== added by K. Tagami ================== 11.0
    integer :: ismax
    if ( noncol ) then
       ismax = 1
    else
       ismax = nspin
    endif
! ================================================================ 11.0

!    write(802,*) hsr
!    stop

    do ia=1,natm
       it=ityp(ia)
       !TypeLoop:   do it=1,ntyp
       !                if(ityp(ia)/=it) cycle
       if(ipaw(it)/=1) then
          dion_hartree_now(:,:,ia)=0.d0
!                    exit TypeLoop
          cycle
       end if
       
       if(.not.flg_symmtry) then
          
          do lmt1=1,ilmt(it)
             do lmt2=lmt1,ilmt(it)
                sum=0.d0
                do mp=1,n_cijkclmk(lmt1,lmt2,it)
                   lmt3=ilmt3_cijkclmk(lmt1,lmt2,mp,it)
                   lmt4=ilmt4_cijkclmk(lmt1,lmt2,mp,it)
                   if(lmt3.gt.lmt4) then
                      write(nfout,*) 'Error in calcDionHartree !'
                      write(nfout,'(a,i4)') 'lmt3 = ',lmt3
                      write(nfout,'(a,i4)') 'lmt4 = ',lmt4
                      stop
                   end if
                   fac=2.d0;if(lmt3.eq.lmt4) fac=1.d0
! ========================== modified by K. Tagami ================== 11.0
!                   do is=1,nspin
                   do is=1, ismax
! =================================================================== 11.0
                      sum=sum+CijkClmkVVVVijlm_k(lmt1,lmt2,mp,it)* &
                           hsr(ia,lmt3,lmt4,is)*fac
                   end do
                end do
                dion_hartree_now(lmt1,lmt2,ia)=sum
             end do
          end do
          
       else
          
          do lmt1=1,ilmt(it)
             do lmt2=lmt1,ilmt(it)
                sum=0.d0
                do iopr=1,nopr
                   do mp=1,n_cijkclmn(lmt1,lmt2,ia,iopr)
                      lmt3=ilmt3_cijkclmn(lmt1,lmt2,mp,ia,iopr)
                      lmt4=ilmt4_cijkclmn(lmt1,lmt2,mp,ia,iopr)
                      if(lmt3.gt.lmt4) then
                         write(nfout,*) 'Error in calcDionHartree !'
                         write(nfout,'(a,i4)') 'lmt3 = ',lmt3
                         write(nfout,'(a,i4)') 'lmt4 = ',lmt4
                         stop
                      end if
                      fac=2.d0;if(lmt3.eq.lmt4) fac=1.d0
! ========================== modified by K. Tagami ================== 11.0
!                   do is=1,nspin
                      do is=1, ismax
! =================================================================== 11.0
                         sum=sum+CijkClmnVVVVijlm_kn(lmt1,lmt2,mp,ia,iopr)* &
                              hsr(abs(ia2ia_symmtry_op(ia,iopr)),lmt3,lmt4,is)*fac
                      end do
                   end do
                end do
                dion_hartree_now(lmt1,lmt2,ia)=sum/dble(nopr)
             end do
          end do
          
       end if
                
!            end do TypeLoop
    end do
!        write(nfout,*)
!        write(nfout,*) ' -- dion_hartree ---'
!        do ia=1,natm
!            write(nfout,'(a,i2)') 'ia = ',ia
!            it=ityp(ia)
!            if(.not.ipaw(it)) cycle
!            do lmt1 = 1, ilmt(it)
!                write(nfout,'(i3,9f8.5/9f8.5)') lmt1 &
!                  &               ,(dion_hartree(lmt1,lmt2,ia),lmt2 = 1, ilmt(it))
!            enddo
!        end do
!    do lmt1=1,8
!    print '(8f19.6)',(dion_hartree(lmt1,lmt2,1),lmt2=1,8)
!    end do
!    stop

    if(af /= 0) then
       allocate(flg_done(natm))
       flg_done=.false.
       do ia=1,natm
          if(flg_done(ia)) cycle
          ja=ia2ia_symmtry_op(ia,nopr+af)
          dion_hartree_now(:,:,ia)=(dion_hartree_now(:,:,ia)+dion_hartree_now(:,:,ja))/2.d0
          dion_hartree_now(:,:,ja)=dion_hartree_now(:,:,ia)
          flg_done(ja)=.true.
       end do
       deallocate(flg_done)
    end if
    return
  end subroutine m_PAWH_get_dion_hartree_now
    
  subroutine m_PAWH_get_energy_hartree
    integer:: lmt1,lmt2,is,ia,it
    real(DP):: fac

! ========================== added by K. Tagami ================== 11.0
    integer :: ismax
    if ( noncol ) then
       ismax = 1
    else
       ismax = nspin
    endif
! ================================================================ 11.0

    do ia=1,natm
       eho_paw(ia)=0.d0
       do it=1,ntyp
          if(ityp(ia)/=it .or. ipaw(it)/=1) cycle
          
          do lmt1=1,ilmt(it)
             do lmt2=lmt1,ilmt(it)
                fac=2.d0*iwei(ia);if(lmt1.eq.lmt2) fac=iwei(ia)
! ========================== modified by K. Tagami ================== 11.0
!                do is=1,nspin
                do is=1, ismax
! =================================================================== 11.0
                   eho_paw(ia)=eho_paw(ia)+ &
                        fac*hsr(ia,lmt1,lmt2,is)* &
                        dion_hartree(lmt1,lmt2,ia)
                end do
             end do
          end do
          eho_paw(ia)=eho_paw(ia)/2.d0
       end do
    end do
    
    call m_PAWH_get_dion_hartree(nfout)
    
    do ia=1,natm
       eh_paw(ia)=0.d0
       do it=1,ntyp
          if(ityp(ia)/=it .or. ipaw(it)/=1) cycle
          
          do lmt1=1,ilmt(it)
             do lmt2=lmt1,ilmt(it)
                fac=2.d0*iwei(ia);if(lmt1.eq.lmt2) fac=iwei(ia)
! ========================== modified by K. Tagami ================== 11.0
!                do is=1,nspin
                do is=1, ismax
! =================================================================== 11.0
                   eh_paw(ia)=eh_paw(ia)+ &
                        fac*hsr(ia,lmt1,lmt2,is)* &
                        dion_hartree(lmt1,lmt2,ia)
                end do
             end do
          end do
          eh_paw(ia)=eh_paw(ia)/2.d0
       end do
    end do
    return
    
  end subroutine m_PAWH_get_energy_hartree
  

end module m_PAW_Hartree

!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 483 $)
!
!  SUBROUINE:  check_gncpp_type, PP_construction_paramset
!             PseudoPotential_Construction, PseudoPotential_ek
!
!  AUTHOR(S): T. Yamasaki and M. Okamoto   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
! =====================================================================
!   patch 10.1 by K. Tagami@adv    2011/06/18
!
!   patch 10.1:  allocation of vec_q_plus_G_LR etc for TDDFT
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine PseudoPotential_Construction
! $Id: PseudoPotential_Construction.F90 483 2016-04-27 04:02:48Z ktagami $
  use m_PseudoPotential,      only : m_PP_alloc0_ps_ntyp,   m_PP_alloc_ps_ntyp &
       &                           , m_PP_dealloc_ps_ntyp  &
       &                           , m_PP_set_mmesh,        m_PP_set_nloc &
       &                           , m_PP_set_m_non0_lmtxlmt &
       &                           , m_PP_alloc_ps0,        m_PP_alloc_psc_qitg_rhpcg &
       &                           , m_PP_alloc_ps,         m_PP_check_gncpp_type &
! === m_PP_vanderbilt_type and m_PP_vanderbilt_type_3D look the same!!! by tkato 2011/08/04 ========
       &                           , m_PP_vanderbilt_type &
       &                           , m_PP_local_part,       m_PP_partial_core_CD &
! ==================================================================================================
       &                           , m_PP_wd_schgpc,        m_PP_make_index_lmtt_2_dl2p &
       &                           , m_PP_make_index_lmtt_phi &
       &                           , m_PP_make_index_lmtt_add &
       &                           , m_PP_make_index_lmtt_pao &
       &                           , m_PP_wd_variables,     m_PP_dealloc_ps &
       &                           , m_PP_rd_betar &
       &                           , m_PP_rd_PP_parameters &
       &                           , m_PP_make_qorb, iflag_ft &
       &                           , m_PP_cnstrct_crotylm &
       &                           , flg_paw, m_PP_rd_PAW_parameters &
       &                           , m_PP_cnstrct_crotylm_paw &
       &                           , m_PP_check_file_format
  use m_PseudoPotential,      only : nlmta,nlmt,lmta,ilmt
  use m_Parallelization,      only : m_Parallel_init_mpi_nlmta
  use m_PseudoPotential, only : ae_wavefunctions_are_detected
  use m_PseudoPotential, only : m_PP_alloc_qitg_wan, m_PP_set_dk_wan &
                              , m_PP_alloc_qitg_fef, m_PP_set_dk_fef
  use m_Wannier,         only : nwght,ghat
  use m_Crystal_Structure,  only :  rltv

  use m_Const_Parameters,     only : INITIAL,CONTINUATION &
       &                           , FIXED_CHARGE,FIXED_CHARGE_CONTINUATION &
       &                           , ON, OFF, by_pseudo_atomic_orbitals, ALL_AT_ONCE, pp_CIAOPP, pp_PAW
  use m_Kpoints,              only : kv3, vkxyz, mp_index
  use m_NonLocal_Potential,   only : m_NLP_alloc_snl  &
                                   , m_NLP_betar_dot_PWs_diff,  m_NLP_betar_dot_PWs &
       &                           , m_NLP_rd_snl &
       &                           , m_NLP_alloc_phig, m_NLP_phir_dot_PWs &
       &                           , m_NLP_alloc_snl_add, m_NLP_add_betar_dot_PWs &
       &                           , m_NLP_alloc_paog, m_NLP_paor_dot_PWs &
       &                           , m_NLP_build_snl_in_rspace, m_NLP_alloc_betar_optimized
  use m_Ionic_System,         only : ityp, natm
  use m_Ionic_System,         only : ntyp, iatomn, ivan
  use m_Control_Parameters,   only : paramset,icond,istress,evaluation_eko_diff &
       &                           , sw_orb_popu, sw_use_add_proj &
       &                           , sw_phonon, sw_calc_force, ipripp, ipriparallel &
       &                           , num_projectors, projector_type, intzaj &
       &                           , sw_wannier, sw_berry_phase, corecharge_cntnbin, sw_fef &
       &                           , ekmode, fixed_charge_k_parallel, continuation_using_ppdata &
       &                           , m_CtrlP_set_ppprinted,sw_rspace, sw_rspace_hyb, sw_hybrid_functional &
       &                           , sw_ldos, sw_rspace_ldos, m_CtrlP_rspace_integ_all_OK,nmax_G_hyb
  use m_PlaneWaveBasisSet,    only : kgp,gr_l,ngshell,ngshell_range
  use m_Const_Parameters,     only : OLD,ON, SPHERICAL_HARMONICS, NO
  use m_Files,                only : m_Files_open_ps_files,m_Files_close_ps_files,nfcntn_bin &
       &                           , m_Files_open_nfcntn_bin,nfpot,nfout &
       &                           , F_CNTN_BIN_in_partitioned &
       &                           , m_Files_open_nfcntn_bin_paw, nfcntn_bin_paw &
       &                           , m_Files_open_ps_file, m_Files_close_ps_file
    
  use m_Orbital_Population,   only : m_OP_ilmt_yy,m_OP_crotylm
  use m_FiniteElectricField,  only : numef,elec_id,m_FEF_Constract_of_ftq

  use m_Charge_Density,       only : m_CD_alloc_chgsoft
  use m_PAW_ChargeDensity,    only : m_PAWCD_init_surf_integration
  use m_PAW_XC_Potential,     only : m_PAW_XC_alloc_vxc
#ifdef FJ_TIMER
  use m_Parallelization,      only : mpi_comm_group
#endif
! =================================== addded by K. Tagami =============== 5.0
  use m_Control_Parameters,   only : sw_mix_charge_hardpart
! ======================================================================= 5.0
  use m_Control_Parameters,   only : sw_hybrid_functional,m_CtrlP_set_hybrid_parameters
! ======================== Added by K. Tagami ================ 10.1
  use m_Control_Parameters,        only : sw_LinearResponse
  use m_PseudoPotential,           only : norm_q_plus_G_LR, &
       &                                  vec_q_plus_G_LR
!
  use m_LinearResponse_Qpt, only : m_LR_alloc_Vecs_q_plus_G, &
       &                           m_LR_set_Vecs_q_plus_G, &
       &                           m_LR_alloc_Qitg
! ============================================================ 10.1

! ============================== added by K. Tagami ============= 11.0
  use m_Control_Parameters,    only : noncol
  use m_PseudoPotential,    only : pot_has_soc, m_PP_check_spinorbit
! =============================================================== 11.0

! === KT_add === 2014/08/01
  use m_Orbital_QuantumNum,  only : m_OP_Qnum_init, m_OP_Qnum_read_orbital_index &
       &                          , m_OP_Qnum_orb_ind_data_num,m_OP_Qnum_read_orbital_index_it  &
       &                          , m_OP_Qnum_alloc_orb_ind_data
! ============== 2014/08/01

  use m_Realspace, only : m_RS_resolve_mesh_soft,m_RS_resolve_mesh_hard, m_RS_build_qr_clm_ylm

  use m_ES_ExactExchange, only : m_ES_EXX_set_nmax_G_hyb

  use m_FFT, only : fft_box_size_CD_exx,fft_box_size_CD_exx_nonpara

! ==== KT_add === 2014/09/19
  use m_Control_Parameters,  only : sw_calc_ekin_density, sw_rspace_ekin_density
! =============== 2014/09/19

! ==== ASMS_add === 2015/02/23
  use m_Control_Parameters,   only : sw_wannier90
  use m_PseudoPotential,      only : m_PP_set_dk_wan
  use m_Wannier90,           only : nntot, m_Wan90_set_dk_wan
! ================= 2015/02/23

  implicit none

  integer       :: it, nfpp, is_gncpp , ierror
#ifdef FJ_TIMER
  integer :: ierr
#endif

! ====================== KT_Test ========================= 12.5Exp
  if(sw_hybrid_functional == ON) then
     call m_CtrlP_set_hybrid_parameters
     call m_ES_EXX_set_nmax_G_hyb
  endif
! ======================================================== 12.5Exp

  call m_PP_alloc0_ps_ntyp()
  call m_PP_alloc_ps_ntyp(.true.)
  call PP_construction_paramset                !-(contained here)
  if(paramset) return
  call m_PP_dealloc_ps_ntyp
  call m_PP_alloc_ps_ntyp(.false.)

!!$#ifndef PARAMSET
  call m_PP_alloc_ps0()
  call m_PP_alloc_psc_qitg_rhpcg()
  if(sw_wannier == ON) then
     call m_PP_alloc_qitg_wan(nwght)
     call m_PP_set_dk_wan(mp_index,ghat,rltv)
  end if
  if(sw_fef == ON) then
     call m_PP_alloc_qitg_fef(numef)
     call m_PP_set_dk_fef(mp_index,rltv,elec_id)
  end if
! ==== KT_add === 2015/02/23
  if ( sw_wannier90 == ON ) then
     call m_PP_alloc_qitg_wan( nntot )
     call m_Wan90_set_dk_wan
  endif
! =============== 2015/02/23

! ================================= Added by K. Tagami ======= 10.1
  if ( sw_LinearResponse == ON ) then
     call m_LR_alloc_Vecs_q_plus_G
     call m_LR_set_Vecs_q_plus_G
!     if ( modnrm == EXECUT ) then
        call m_LR_alloc_Qitg
!     endif
  endif
! ============================================================ 10.1

#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
                    call timer_sta(29)
#endif
! ----------- Written by T.Yamasaki, 1 Aug. 2014 ---------->>
!!$  if(sw_rspace/=ON) call m_NLP_alloc_snl()
  if(sw_rspace/=ON .or. .not. m_CtrlP_rspace_integ_all_OK()) call m_NLP_alloc_snl()
! <<--------------------------------------------------------
#ifdef FJ_TIMER
                    call timer_end(29)
#endif
  call m_NLP_alloc_snl_add()
  call m_NLP_alloc_phig()
  call m_NLP_alloc_paog()

  if(flg_paw .and. ekmode==ON .and. icond==FIXED_CHARGE) then
     call m_Files_open_nfcntn_bin_paw()
     call m_PP_rd_PAW_parameters(nfout,nfcntn_bin_paw)
  end if

  if(sw_phonon == ON .and. sw_calc_force == OFF) return

  if(icond == INITIAL .or. icond == FIXED_CHARGE .or. continuation_using_ppdata == NO) then
!     call m_Files_open_ps_files(ivan,iatomn,ntyp,ierror)
!     if(ierror /= 0) call mpi_stop(nfout)
     call m_PP_alloc_ps()
     nfpp  = 0
     do it = 1, ntyp
        call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierror)
        if(ierror /= 0) call mpi_stop(nfout)
        if(ipripp >= 2) write(nfout,'(" !! PP_Construction: it = ",i3)') it
        if(ivan(it) /= OLD) then
           nfpp = nfpp + 1
           call m_PP_check_gncpp_type(nfpot(nfpp),nfout,is_gncpp)
           if(is_gncpp == pp_PAW) then
              ae_wavefunctions_are_detected(nfpp) = .true.
              if(ipripp >= 2) write(nfout,'(" !! AE wavefunction was detected.")')
           end if

! ============================== added by K. Tagami =================== 11.0
           call m_PP_check_spinorbit( nfpot(nfpp), nfout, pot_has_soc(it) )
! ===================================================================== 11.0

! === m_PP_vanderbilt_type and m_PP_vanderbilt_type_3D look the same!!! by tkato 2011/08/04 ========
           call m_PP_vanderbilt_type(nfpot(nfpp),it,nfout,gr_l,ngshell,ngshell_range,.false.,is_gncpp)
! ==================================================================================================
        else if(ivan(it) == OLD) then
!!$        call pseudo_potential_norm_conserving_type(it,nfpkb,nfpd,nfpcc &
!!$            & ,iatomn(it), univol,nfout,ipri)
        endif
        call m_PP_local_part(it,nfout,gr_l,ngshell,ngshell_range)   ! (psloc), ->(vlocr,psc_l,etot1)
        call m_PP_partial_core_CD(nfout,it,gr_l,paramset=.false.)
        !                                      -(m_P.P.) epseud_pc, pcc
        call m_Files_close_ps_file(it)
     enddo

     call m_PP_wd_schgpc(nfout)  ! write down schgpc
     call m_PP_make_index_lmtt_2_dl2p(nfout,paramset)
     !           -(m_PseudoPotential) ->lmtt,il2p,lmta,nlmta,nlmtt,dl2p

     if(sw_rspace==ON)then
        !!call m_NLP_resolve_mesh_for_rspace(nfout)
        call m_RS_resolve_mesh_soft(nfout)
     endif
     if(sw_ldos==ON .and. sw_rspace_ldos==ON)then
        call m_RS_resolve_mesh_hard(nfout)
        call m_RS_build_qr_clm_ylm(deriv=.false.)
     else if (sw_hybrid_functional==ON .and. sw_rspace_hyb==ON ) then
        call m_RS_resolve_mesh_hard(nfout,fft_box_size_CD_exx,fft_box_size_CD_exx_nonpara)
        call m_RS_build_qr_clm_ylm(deriv=.true.,box_size=fft_box_size_CD_exx)
! == KT_add == 2014/09/19
     else if ( sw_calc_ekin_density == ON .and. sw_rspace_ekin_density == ON ) then
        call m_RS_resolve_mesh_hard(nfout)
! =========== 2014/09/19
     endif

     if(sw_orb_popu == ON) then
        call m_PP_make_index_lmtt_phi(nfout,paramset)
     end if
     !           -(m_PseudoPotential) ->lmtt_phi,lmta_phi,nlmta_phi,nlmtt_phi
     if(sw_use_add_proj == ON) then
        call m_PP_make_index_lmtt_add(nfout,paramset)
     end if
     !           -(m_PseudoPotential) ->lmtt_add,lmta_add,nlmta_add,nlmtt_add
     if(intzaj == by_pseudo_atomic_orbitals) then
        call m_PP_make_index_lmtt_pao(nfout,paramset)
     end if
     !           -(m_PseudoPotential) ->lmtt_pao,lmta_pao,nlmta_pao,nlmtt_pao
     call m_PP_wd_variables(nfout)

! ========================= ASMS_Test =========================== 12.1
!     if(icond == INITIAL .or. (icond == FIXED_CHARGE .and. ekmode==OFF &
!!!$          & .and. fixed_charge_k_parallel == ALL_AT_ONCE)) then
!          & .and. fixed_charge_k_parallel == ALL_AT_ONCE) .or. &
!          & (continuation_using_ppdata == NO .and. .not.(icond == FIXED_CHARGE .and. ekmode==ON))) then
!
     if ( icond == INITIAL &
          & .or. ( ( icond==FIXED_CHARGE .or. icond==FIXED_CHARGE_CONTINUATION ) &
          &                   .and. ekmode==OFF &
          &                   .and. fixed_charge_k_parallel == ALL_AT_ONCE )&  
          & .or. ( .not. ( (icond==FIXED_CHARGE .or. icond==FIXED_CHARGE_CONTINUATION) &
          &                   .and. ekmode==ON ) &
          &                   .and. continuation_using_ppdata == NO ) ) then
! =============================================================== 12.1
        if(ipripp >= 2) then
           write(nfout,'(" icond  = ",i8)') icond
           write(nfout,'(" ekmode = ",i8)') ekmode
           write(nfout,'(" fixed_charge_k_parallel = ",i8)') fixed_charge_k_parallel
           write(nfout,'(" continuation_using_ppdata = ",i8)') continuation_using_ppdata
        end if
        if(istress == OFF) then
           if(sw_rspace == ON) then
              call m_NLP_alloc_betar_optimized()
              call m_NLP_build_snl_in_rspace(nfout)
              !!$call m_NLP_betar_dot_PWs(nfout,kv3,vkxyz) !(kbint) --> snl
! ----------- Revised by T.Yamasaki, 1 Aug. 2014 ---------->>
           end if
           if(sw_rspace/=ON .or. .not. m_CtrlP_rspace_integ_all_OK()) then
              call m_NLP_betar_dot_PWs(nfout,kv3,vkxyz) !(kbint) --> snl
! <<--------------------------------------------------------
           endif
        else if(istress == ON) then
           call m_NLP_betar_dot_PWs_diff(nfout,kv3,vkxyz) !(kbint_diff) --> snl,snld
        else
           if(ipripp >= 1) write(nfout,'("  istress =",i4," <<PseudoPotential_Construction>>")') istress
           stop ' istress is not 0 or 1'
        endif
        if(ipripp >= 2) write(nfout,'(" sw_orb_popu = ",i8)') sw_orb_popu
        if(sw_orb_popu == ON) then
           if(ipripp >= 2) write(nfout,'(" m_PP_make_qorb")')
           call m_PP_make_qorb(nfout)
           call m_NLP_phir_dot_PWs(nfout,kv3,vkxyz) !(kbint) --> phig
           call m_PP_cnstrct_crotylm(nfout) !-> crotylm
        end if
        if(sw_use_add_proj == ON) then
           call m_NLP_add_betar_dot_PWs(nfout,kv3,vkxyz) !(kbint) --> snl_add
        end if
        if(intzaj == by_pseudo_atomic_orbitals) then
           call m_NLP_paor_dot_PWs(nfout,kv3,vkxyz) !(kbint) --> paog
        end if
        if(num_projectors > 0) then
           call m_OP_ilmt_yy
           call m_OP_crotylm(nfout)
        end if
     end if
     if(icond==CONTINUATION.and.flg_paw) then
         call m_Files_open_nfcntn_bin_paw()
         call m_PP_rd_PAW_parameters(nfout,nfcntn_bin_paw)
     end if
! ============= ASMS_DEBUG =========================== 12.1
     if(icond==FIXED_CHARGE_CONTINUATION.and.flg_paw) then
         call m_Files_open_nfcntn_bin_paw()
         call m_PP_rd_PAW_parameters(nfout,nfcntn_bin_paw)
     end if
! ============= ASMS_DEBUG =========================== 12.1
!
! ====== KT_mod ==== 13.0S
!     if( icond == FIXED_CHARGE .and. ekmode==ON ) then
!
     if( ( icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION ) &
          &  .and. ekmode==ON ) then
! =================13.0S

#ifdef EXP_WFN_PROJ
        call m_NLP_betar_dot_PWs(nfout,kv3,vkxyz) !(kbint) --> snl
#endif
        if(sw_orb_popu == ON) then
           call m_PP_make_qorb(nfout)
#ifdef EXP_WFN_PROJ
           call m_NLP_phir_dot_PWs(nfout,kv3,vkxyz) !(kbint) --> phig
#endif
           call m_PP_cnstrct_crotylm(nfout) !-> crotylm
        end if

        if(sw_use_add_proj == ON) then
#ifdef EXP_WFN_PROJ
           call m_NLP_add_betar_dot_PWs(nfout,kv3,vkxyz) !(kbint) --> snl_add
#endif
        end if
        if(intzaj == by_pseudo_atomic_orbitals) then
#ifdef EXP_WFN_PROJ
           call m_NLP_paor_dot_PWs(nfout,kv3,vkxyz) !(kbint) --> paog
#endif
        end if

        if(num_projectors > 0) then
           call m_OP_ilmt_yy
           call m_OP_crotylm(nfout)
        end if
     endif
!
     call m_PP_dealloc_ps
!     call m_Files_close_ps_files
  else if(icond == CONTINUATION .or. icond == FIXED_CHARGE_CONTINUATION) then
!!$  else if(icond == CONTINUATION .or. (icond == FIXED_CHARGE_CONTINUATION .and.ekmode==OFF &
!!$       & .and. fixed_charge_k_parallel == ALL_AT_ONCE)  &
!!$       & .or. (icond == FIXED_CHARGE_CONTINUATION .and. ekmode == ON)) then
     call m_Files_open_nfcntn_bin()
!!$     if(istress == ON) call m_PP_alloc_ps_stress()
     call m_PP_rd_PP_parameters(nfout,nfcntn_bin,F_CNTN_BIN_in_partitioned, kgp)
     if(ipripp >= 2) write(nfout,'(" ! PP_parameters were read!")')
     if(icond == CONTINUATION) &
          & call m_NLP_rd_snl(nfout,nfcntn_bin,F_CNTN_BIN_in_partitioned,kv3)
     if(icond == FIXED_CHARGE_CONTINUATION ) call m_PP_rd_betar(nfcntn_bin) !->betar

     if(flg_paw) then
         call m_Files_open_nfcntn_bin_paw()
         call m_PP_rd_PAW_parameters(nfout,nfcntn_bin_paw)
     end if

     if(sw_orb_popu == ON .or. sw_use_add_proj == ON .or. num_projectors>0 &
          & .or. sw_berry_phase == ON .or. sw_wannier == ON &
          & .or. sw_fef == ON &
          & .or. corecharge_cntnbin == OFF) then
        iflag_ft = OFF
        if(ipripp >= 2) then
           write(nfout,'(" !pp sw_orb_popu     = ",i8)') sw_orb_popu
           write(nfout,'(" !pp sw_use_add_proj = ",i8)') sw_use_add_proj
           write(nfout,'(" !pp num_projectors  = ",i8)') num_projectors
           write(nfout,'(" !pp sw_berry_phase  = ",i8)') sw_berry_phase
           write(nfout,'(" !pp sw_wannier      = ",i8)') sw_wannier
           write(nfout,'(" !pp sw_fef          = ",i8)') sw_fef
           write(nfout,'(" !pp corecharge_cntnbin = ",i8)') corecharge_cntnbin
        end if
!        call m_Files_open_ps_files(ivan,iatomn,ntyp,ierror)
!        if(ierror/=0) call mpi_stop(nfout)
        call m_PP_alloc_ps()
        nfpp  = 0
        do it = 1, ntyp
           call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierror)
           if(ierror/=0) call mpi_stop(nfout)
           if(ipripp >= 2) write(nfout,'(" !! PP_Construction for PDOS: it = ",i3)') it
           if(ivan(it) /= OLD) then
              nfpp = nfpp + 1
              call m_PP_check_gncpp_type(nfpot(nfpp),nfout,is_gncpp)
              if(is_gncpp == -2) then
                 !!$is_gncpp = 2
                 ae_wavefunctions_are_detected(nfpp) = .true.
!!$                 if(ipripp >= 2 ) write(nfout,'(" !! AE wavefunction was detected.")')
              end if

! ============================== added by K. Tagami =================== 11.0
              call m_PP_check_spinorbit( nfpot(nfpp), nfout, pot_has_soc(it) )
! ===================================================================== 11.0

! === m_PP_vanderbilt_type and m_PP_vanderbilt_type_3D look the same!!! by tkato 2011/08/04 ========
              call m_PP_vanderbilt_type(nfpot(nfpp),it,nfout,gr_l,ngshell,ngshell_range,.false.,is_gncpp)
! ==================================================================================================
           else
           end if
!!$ASASASASAS
           call m_PP_partial_core_CD(nfout,it,gr_l,.true.)
!!$ASASASASAS
           call m_Files_close_ps_file(it)
        enddo

        if(sw_orb_popu == ON) then
           call m_PP_make_index_lmtt_phi(nfout,paramset)
           call m_PP_make_qorb(nfout)
           call m_NLP_phir_dot_PWs(nfout,kv3,vkxyz) !(kbint) --> phig
           call m_PP_cnstrct_crotylm(nfout) !-> crotylm
        end if
        if(sw_use_add_proj == ON) then
           call m_PP_make_index_lmtt_add(nfout,paramset)
           call m_NLP_add_betar_dot_PWs(nfout,kv3,vkxyz) !(kbint) --> snl_add
        end if
        if(num_projectors > 0) then
           call m_OP_ilmt_yy
           call m_OP_crotylm(nfout)
        end if
        call m_PP_dealloc_ps
!        call m_Files_close_ps_files
     end if
  end if

  if(flg_paw) then
     call m_PAWCD_init_surf_integration
     call m_PAW_XC_alloc_vxc

     call m_CD_alloc_chgsoft
     call m_PP_cnstrct_crotylm_paw
! =============================== modified by K. Tagami ================ 5.0
!  end if

  else if ( sw_mix_charge_hardpart == ON ) then
     call m_PAWCD_init_surf_integration
     call m_PP_cnstrct_crotylm_paw
  end if
! ====================================================================== 5.0

  call m_Parallel_init_mpi_nlmta(nfout,ipriparallel &
       & ,nlmta,nlmt,natm,lmta,ntyp,ilmt,ityp) ! -> np_fsri
!!$#endif

! ==== KT_add ==== 2014/08/01
!  call m_Files_open_ps_files(ivan,iatomn,ntyp,ierror)
!  if(ierror /= 0) call mpi_stop(nfout)
!  call m_OP_Qnum_init
!  call m_OP_Qnum_read_orbital_index
!  call m_Files_close_ps_files

  call m_OP_Qnum_init
  do it=1,ntyp
     call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierror)
     call m_OP_Qnum_orb_ind_data_num(it)
     call m_Files_close_ps_file(it)
  enddo
  call m_OP_Qnum_alloc_orb_ind_data()
  do it=1,ntyp
     call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierror)
     call m_OP_Qnum_orb_ind_data_num(it)
     call m_OP_Qnum_read_orbital_index_it(it)
     call m_Files_close_ps_file(it)
  enddo
! ================ 2014/08/01

contains
  subroutine PP_construction_paramset
!    call m_Files_open_ps_files(ivan, iatomn, ntyp,ierror)
!    if(ierror/=0) call mpi_stop(nfout)
    nfpp = 0
    do it = 1, ntyp
       call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierror)
       if(ierror/=0) call mpi_stop(nfout)
       if(ipripp >= 2) write(nfout,'(" !!PP_construction_paramset: it = ",i3)') it
       if(ivan(it) /= OLD) then
          nfpp = nfpp + 1
           call m_PP_check_gncpp_type(nfpot(nfpp),nfout,is_gncpp)
           if(is_gncpp == -2) then
             !!$is_gncpp = 2
             ae_wavefunctions_are_detected(nfpp) = .true.
             if(ipripp >= 2) write(nfout,'(" !! AE wavefunction was detected.")')
           end if

! ============================== added by K. Tagami =================== 11.0
              call m_PP_check_spinorbit( nfpot(nfpp), nfout, pot_has_soc(it) )
! ===================================================================== 11.0

! === m_PP_vanderbilt_type and m_PP_vanderbilt_type_3D look the same!!! by tkato 2011/08/04 ========
           call m_PP_vanderbilt_type(nfpot(nfpp),it,nfout,gr_l,ngshell,ngshell_range,.true.,is_gncpp)
! ==================================================================================================
       else if(ivan(it) == OLD) then
!!$        call pseudo_potential_norm_conserving_type(it,nfpkb,nfpd,nfpcc &
!!$             & ,iatomn(it), univol,nfout,ipri)
       endif
           call m_PP_partial_core_CD(nfout,it,gr_l,.true.)
       ! epseud_pc, pcc
       call m_Files_close_ps_file(it)
    enddo
    call m_PP_make_index_lmtt_2_dl2p(nfout,.true.) ! ->nlmt,nlmta,nlmtt
    if(sw_orb_popu == ON) then
       call m_PP_make_index_lmtt_phi(nfout,.true.)    ! ->nlmt_phi,nlmta_phi,nlmtt_phi
    end if
    if(sw_use_add_proj == ON) then
       call m_PP_make_index_lmtt_add(nfout,.true.) ! ->lmtt_add,lmta_add,nlmta_add,nlmtt_add
    end if
    if(intzaj == by_pseudo_atomic_orbitals) then
       call m_PP_make_index_lmtt_pao(nfout,.true.) ! ->lmtt_pao,lmta_pao,nlmta_pao,nlmtt_pao
    end if

    call m_PP_set_mmesh
    call m_PP_set_nloc(nfout)
    call m_PP_set_m_non0_lmtxlmt
!    call m_Files_close_ps_files
    call m_CtrlP_set_ppprinted(ON)
  end subroutine PP_construction_paramset
        
end subroutine PseudoPotential_Construction

subroutine PseudoPotential_ek
  use m_Const_Parameters,     only : FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, ON, OFF
  use m_Control_Parameters,   only : icond, sw_orb_popu, sw_pdos, sw_use_add_proj, uvsormode,sw_rspace &
       &                            ,m_CtrlP_rspace_integ_all_OK
  
  use m_Kpoints,              only : kv3, vkxyz, kv3_previous
  use m_NonLocal_Potential,   only : m_NLP_rd_snl, m_NLP_betar_dot_PWs &
       &                           , m_NLP_betar_dot_PWs_diff &
       &                           , m_NLP_phir_dot_PWs &
       &                           , m_NLP_add_betar_dot_PWs &
       &                           , m_NLP_build_snl_in_rspace
  use m_PseudoPotential,      only : m_PP_alloc_NLP, m_PP_dealloc_NLP, m_PP_betar_calculated
  use m_IterationNumbers,     only : iteration_electronic,nk_in_the_process
  use m_Files,                only : nfout, nfcntn_bin, m_Files_open_nfcntn_bin &
       &                           , F_CNTN_BIN_in_partitioned
! ======================================= Added by K. Tagami ========= 0.2
!!$  use m_Control_Parameters,   only : num_projectors, projector_type, paramset &
!!$       &                           , intzaj, by_pseudo_atomic_orbitals 
!!$  use m_Orbital_Population,   only : m_OP_ilmt_yy,m_OP_crotylm
!!$  use m_PseudoPotential,      only : m_PP_make_qorb, m_PP_cnstrct_crotylm &
!!$       &                           , m_PP_make_index_lmtt_phi &
!!$       &                           , m_PP_make_index_lmtt_add &
!!$       &                           , m_PP_make_index_lmtt_pao &
!!$       &                           , m_PP_alloc_ps, m_PP_dealloc_ps
! =====================================================================
  implicit none

  if(icond == FIXED_CHARGE &
       & .or. (icond == FIXED_CHARGE_CONTINUATION &
       &           .and.( iteration_electronic == 0 .or. kv3_previous /= kv3))) then
     call m_PP_alloc_NLP()
     if(sw_rspace == ON) then
        call m_NLP_build_snl_in_rspace(nfout)
! ----------- Revised by T.Yamasaki, 1 Aug. 2014 ---------->>
     end if
     if(sw_rspace/=ON .or. .not. m_CtrlP_rspace_integ_all_OK()) then
        call m_NLP_betar_dot_PWs(nfout,kv3,vkxyz) !(kbint) --> snl
! <<--------------------------------------------------------
     endif
     if(sw_orb_popu == ON .or. sw_pdos == ON) then
! ==================================== modified by K. Tagami ========= 0.2
!        call m_NLP_phir_dot_PWs(nfout,kv3,vkxyz) !(kbint) --> phig
! ====================================================================
     end if
     if(sw_use_add_proj == ON) then
        call m_NLP_add_betar_dot_PWs(nfout,kv3,vkxyz) !(kbint) --> snl_add
     end if
     if(uvsormode == OFF) call m_PP_dealloc_NLP()
!!$     if(nk_in_the_process == 3) stop 'PseudoPotential_ek'
  else if(icond == FIXED_CHARGE_CONTINUATION) then
!!$     call m_Files_open_nfcntn_bin()
     call m_NLP_rd_snl(nfout,nfcntn_bin,F_CNTN_BIN_in_partitioned,kv3)
  end if
end subroutine PseudoPotential_ek

!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 472 $)
!
!  MODULE:  m_Total_Energy
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_Total_Energy
!    ( m_TE )
! $Id: m_Total_Energy.F90 472 2015-11-28 09:01:17Z ktagami $
  use m_Charge_Density,       only : chgq_l, chgqo_l, hsr
!fj$$  use m_XC_Potential,         only : vxc_l, exc, m_XC_cal_potential
  use m_XC_Potential,         only : vxc_l, exc,eex,ecor
  use m_Electronic_Structure, only : nrvf_ordr, occup_l, eko_l, totch &
      &                            , band_entropy, dhub &
      &                            , m_ES_eekdif_cond &
      &                            , zaj_l, vloc_esm, m_ES_what_is_evdff_now
  use m_PseudoPotential,      only : psc_l,etot1,ilmt,ltp,mtp,epc,dion, ival &
                                    , flg_paw,ipaw &
                                    , dion_hartree,dion_vxc,dion_paw &
                                    , dion_hartree_now, dion_kin_ion &
                                    , flg_symmtry,ia2ia_symmtry_op, epc_paw
  use m_PlaneWaveBasisSet,    only : gr_l,m_pwBS_kinetic_energies,iba,kg1,igfp_l
  use m_FFT,                  only : nfftps
! === DEBUG by tkato 2012/11/05 ================================================
!!$  use m_PlaneWaveBasisSet,    only : gr_l,m_pwBS_kinetic_energies_3D,iba,kg1
  use m_Parallelization,      only : np_g1k, ista_g1k, iend_g1k
! ==============================================================================
  use m_Crystal_Structure,    only : univol,nopr,op
  use m_Ionic_System,         only : ntyp,natm,natm2,iwei,ityp,zfm3_l &
      &                            , eewald, ihubbard &
      &                            , evdw, ntyp_vdw
  use m_Timing,               only : tstatc0_begin, tstatc0_end
!!$  use m_Control_Parameters,   only : af, kimg, ipri, nspin, edelta, neg &
  use m_Control_Parameters,   only : af, kimg, ipri, nspin, neg &
       &                           , num_extra_bands, printable &
       &                           , width, way_of_smearing, icond &
       &                           , m_CtrlP_ntcnvg_incre &
       &                           , m_CtrlP_ntcnvg_clear &
       &                           , m_CtrlP_ntcnvg_reset &
       &                           , m_CtrlP_get_edelta &
       &                           , m_CtrlP_sub_ntcnvg_incre &
       &                           , m_CtrlP_solver_for_WFs_now &
       &                           , sub_delta_factor_is_given &
       &                           , sub_delta_factor &
       &                           , sw_dipole_correction, sw_screening_correction &
       &                           , sw_hubbard, proj_attribute &
       &                           , critical_ehub, delta_ehub &
       &                           , num_conduction_bands_lmm &
       &                           , sw_hybrid_functional, sw_eval_vexx, sw_retard_eigval_evaluation, sw_fef &
       &                           , in_line_minimization &
       &                           , sw_external_potential, ekmode, icond, sw_rsb, sw_output_xc_seperately &
#ifdef ENABLE_ESM_PACK
       &                           , number_of_solvers_applied, solver_names_applied, len_solvername,sw_esm
#else
       &                           , number_of_solvers_applied, solver_names_applied, len_solvername
#endif
  use m_Kpoints,              only : qwgt,kv3,vkxyz,k_symmetry
  use m_IterationNumbers,     only : iteration, iteration_electronic,iteration_ionic
  use m_Parallelization,      only : mpi_comm_group,map_k,myrank_k,ierr,np_e &
       &                           , ista_kngp,iend_kngp,npes,mype &
       &                           , myrank_e, map_e, map_z   &
       &                           , ista_atm, iend_atm, myrank_g, nrank_g, nrank_e &
       &                           , ista_e, iend_e, istep_e
  use m_Const_Parameters,     only : Valence_plus_PC_Charge,PAI4,UP,DOWN&
       &                           , EXC_ONLY, VXC_AND_EXC, IINCRE_CRITICAL,DP,CMPLDP &
       &                           , len_tag_total_energy, tag_total_energy &
       &                           , PARABOLIC, COLD, ON, OFF &
       &                           , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, GAMMA, DELTA &
       &                           , MDKOSUGI, MDDAVIDSON, INITIAL, CONTINUATION, COORDINATE_CONTINUATION &
       &                           , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION
  use m_Dipole,               only : edip_ion, eext_ion, vdip_l, vext_l
  use m_Screening,            only : screening
  use m_Hubbard,              only : m_Hubbard_energy
  use m_FiniteElectricField,  only : m_FEF_polarization
  use m_ES_ExactExchange,     only : m_ES_EXX_gather_valence_states,m_ES_EXX_energy &
       &                           , m_ES_EXX_energy2
#if 0
       &  , m_ES_EXX_gather_valence_states_k
#endif
  use m_PAW_XC_Potential,     only : m_PAW_XC_cal_potential,exc_ae,exc_ps &
       &                           , m_PAW_XC_cal_potential_sphex2 
!!$                                    , m_PAW_XC_cal_potential_sym
  use m_PAW_Hartree,          only : m_PAWH_get_dion_hartree_now
  use m_External_Potential,   only : espot_g
  use m_PAW_ChargeDensity,    only : calcGaussLegendreIntegration &
       &                            , calcSphericalHarmonicsExpansion

  use m_PlaneWaveBasisSet,    only : kgp, kg


! ====================================== added by K. Tagami ================ 11.0
  use m_Control_Parameters,    only : noncol, ndim_spinor, ndim_magmom, ndim_chgpot
  use m_PseudoPotential,       only : dion0_noncl, nlmt
  use m_Charge_Density,         only : hsi
  use m_ES_NonCollinear,       only : m_ES_MagMom_To_DensMat_hsr, &
       &                              m_ES_MagMom_to_DensMat_Dhub
!
  use m_Crystal_Structure,     only :  sw_magnetic_constraint
  use m_ES_Mag_Constraint,      only : m_ES_calc_MagConstraint_Energy
  use m_Hubbard,              only : m_Hubbard_energy_noncl, &
       &                             m_Hubbard_energy2_noncl, &
       &                             m_Hubbard_energy3_noncl
! ========================================================================== 11.0

! ====================================== added by K. Tagami ================ 11.0
  use m_Control_Parameters,    only : SpinOrbit_Mode
  use m_Const_Parameters,      only : ByPawPot, CMPLDP, BuiltIn, EXECUT
  use m_SpinOrbit_Potential,   only : dsoc, m_SO_set_Dsoc_potential2
  use m_SpinOrbit_RadInt,    only : m_SO_calc_SOC_strength_pawpot
  use m_PseudoPotential,      only : lmta,  m_PP_include_vanderbilt_pot, dion_scr_noncl
  use m_Electronic_Structure,   only : fsr_l, fsi_l, dhub_aimag
! ========================================================================== 11.0

! ======================= KT_add ================== 13.0E
  use m_Const_Parameters,   only : Fermi_Dirac
! ================================================= 13.0E

! =========== KT_add ========== 13.0U2
  use m_Control_Parameters,  only : sw_potential_mixing
! ============================= 13.0U2

  use m_Control_Parameters,  only : m_CtrlP_get_isolver_now

! === Positron SCF ==== 2015/11/28
  use m_Control_Parameters,  only : sw_positron, npeg, positron_method
  use m_Const_Parameters,   only :  positron_GGGC
  use m_epc_potential,  only : ecorr_pztr => epc, m_epc_cal_potential, vepc_l
  use m_PlaneWaveBasisSet, only : kg1_pwf
  use m_Positron_Wave_Functions,  only : pzaj, nprvf_ordr, pchg_l, pchgo_l, pev
  use m_PlaneWaveBasisSet,    only : m_pwBS_pstrn_kinetic_energies
! ==================== 2015/11/28

  implicit none
  include 'mpif.h'

  real(kind=DP),private          :: eband ! band energy
  real(kind=DP),private          :: eband_extendedrange
  real(kind=DP),private          :: eohxc ! exchange correlation and &
  !                                         Hartree with old charge

! ==== KT_mod === 13.0U2
!!  real(kind=DP),private          :: elocal ! local potential
  real(kind=DP)            :: elocal ! local potential
! =============== 13.0U2

  real(kind=DP),private          :: eloca1
  real(kind=DP),private          :: enonlc ! non-local
!!$  real(kind=DP),private          :: ehartr ! hartree energy with new charge
  real(kind=DP)                  :: ehartr ! hartree energy with new charge
  real(kind=DP),private          :: ekinet ! kinetic energy
  real(kind=DP),private          :: eentropy ! entropic term of free energy (-TS)

  real(kind=DP),private          :: edip   ! dipole energy
  real(kind=DP),private          :: evdip  ! dipole potential
  real(kind=DP),private          :: evext  ! external potential

  real(kind=DP),private          :: etoold ! previous total energy
  real(kind=DP),private          :: edeltb = 1.d99 ! etotal - etoold
  real(kind=DP)                  :: etotal ! total free energy: F(simga)
  real(kind=DP)                  :: etotal0 ! total energy: E(sigma=0)

  real(kind=DP)                  :: eespot ! electrostatic potential

  !
  ! Free energy:
  !F(sigma) = E(sigma) - sigma*S(sigma)
  !
  ! 1. E(sigma=0) exprapolation for the cold smearing method
  !E(sigma=0) ~ (2*F(sigma)+E(sigma))/3
  !
  ! 2. E(sigma=0) exprapolation for the parabolic broadening method
  !F(sigma) = E(sigma) - sigma*S(sigma)
  !E(sigma=0) ~ (F(sigma)+E(sigma))/2
  !

  ! DFT+U
  real(kind=DP),private          :: ehub0 ! Hubbard energy
  real(kind=DP),private          :: ehub0_old = 1.d+20 ! Old Hubbard energy
  real(kind=DP),private          :: ehub1 ! Hubbard potential energy

  ! PAW
  real(kind=DP),private          :: eohxc_paw, ehartr_paw, ekin_ion_paw

  ! Hybrid functional method
  real(kind=DP),private          :: vexx,eexx

  ! Finite electric field method
  real(kind=DP),private          :: eplr  ! -EP term

! ============================== added by K. Tagami ================== 11.0
! Magnetic constraint
!
  real(kind=DP),private          :: emag0      ! magnetic constraint energy
  real(kind=DP),private          :: emag1      ! double counting energy
! ==================================================================== 11.0

! ====================================== added by K. Tagami ================ 11.0
! Spin Orbit
!
  real(kind=DP),private          :: espinorb_old, espinorb_now
! ========================================================================== 11.0

! === positron
  real(kind=DP) :: ekin_pztr, elocal_pztr, ehartr_ep, eohxc_pztr
! ===

  integer,private, parameter     :: len_str = 132
  character(len=len_str),private    ::  str

contains
  real(DP) function m_TE_what_is_edeltb_now()
     m_TE_what_is_edeltb_now = edeltb
  end function m_TE_what_is_edeltb_now


! ==== KT_add === 2015/01/30
  subroutine get_kinetic_local_energy_paw(nfout)
    integer, intent(in) :: nfout
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    integer :: ismax
    real(kind=DP) :: fac

    ekin_ion_paw = 0.0d0
    if ( noncol ) then
       ismax = 1
    else
       ismax = nspin
    endif
    do ispin = 1, ismax, af+1
       do it = 1, ntyp
          if(ipaw(it)==0) cycle
          do lmt1 = 1, ilmt(it)
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
             do lmt2 = lmt1, ilmt(it)
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
                if( il1 /= il2 .or. im1 /= im2) cycle
                do ia = 1, natm
                   if(ityp(ia) /= it) cycle
                   fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                   ekin_ion_paw = ekin_ion_paw &
                        & + fac*dion_kin_ion(lmt1,lmt2,it)*hsr(ia,lmt1,lmt2,ispin)
                end do
             end do
          end do
       end do
    end do
    ekin_ion_paw = ekin_ion_paw*(af+1)
  end subroutine get_kinetic_local_energy_paw
! ============ 2015/01/30

  subroutine get_kinetic_energy(nfout)
    integer, intent(in) :: nfout
#ifdef __TIMER_SUB__
    call timer_sta(747)
#endif
    ekinet = eband - eohxc - eloca1 - enonlc
    if(sw_dipole_correction == ON) then
       ekinet = ekinet - evdip - evext
    end if
    if(sw_hubbard==ON) then
       ekinet = ekinet - ehub1
    end if
    if(sw_hybrid_functional == ON) then
       ekinet = ekinet - vexx
    end if
! ========================= added by K. Tagami ====================== 11.0
    if ( sw_magnetic_constraint==ON ) then
       ekinet = ekinet - emag1
    endif
! =================================================================== 11.0

! === KT_add === 2014/08/01
!!!#ifdef USE_ESPINORB
! ============== 2014/08/01

    if(ipri >= 2) then
       write(nfout,'(" !D EBAND  = ",f12.5)') eband
       write(nfout,'(" !D EOHXC  = ",f12.5)') eohxc
       write(nfout,'(" !D ELOCA1 = ",f12.5)') eloca1
       write(nfout,'(" !D ENONLC = ",f12.5)') enonlc
       if(sw_dipole_correction == ON) then
          write(nfout,'(" !D EVDIP  = ",f12.5)') evdip
          write(nfout,'(" !D EVEXT  = ",f12.5)') evext
       end if
       if(sw_hubbard==ON) write(nfout,'(" !D EHUB1  = ",f12.5)') ehub1
       if(sw_hybrid_functional == ON) write(nfout,'(" !D VEXX   = ",f12.5)') vexx
    endif
#ifdef __TIMER_SUB__
    call timer_end(747)
#endif
  end subroutine get_kinetic_energy

! === DEBUG by tkato 2012/11/05 ================================================
  subroutine get_kinetic_energy_directly(nfout)
     integer,intent(in) :: nfout
     integer :: ik,ib,ig,iadd
     real(kind=DP), allocatable, dimension(:)       :: ekin
     real(kind=DP) :: ekinet_tmp,ekinet_mpi
     allocate(ekin(1:maxval(np_g1k(:))));ekin=0.d0
     ekinet = 0.d0
     do ik=1,kv3,af+1
        call m_pwBS_kinetic_energies(ik,vkxyz,ekin)
        if(map_k(ik)/=myrank_k)cycle
        do ib=1,np_e
           ekinet_tmp=0.d0
           if (kimg==1) then
              do ig=ista_g1k(ik), iend_g1k(ik)
                 iadd = ig - ista_g1k(ik) + 1
                 ekinet_tmp = ekinet_tmp+2.d0*ekin(iadd)*zaj_l(iadd,ib,ik,1)**2
              enddo
           else if (kimg==2) then
              do ig=ista_g1k(ik), iend_g1k(ik)
                 iadd = ig - ista_g1k(ik) + 1
                 ekinet_tmp = ekinet_tmp+2.d0*ekin(iadd)*(zaj_l(iadd,ib,ik,1)**2 &
              & +zaj_l(iadd,ib,ik,2)**2)
              enddo
           endif
           if(k_symmetry(ik)==GAMMA) ekinet_tmp = ekinet_tmp*2.d0
           ekinet = ekinet+occup_l(ib,ik)/dble(kv3)*ekinet_tmp
        enddo
     enddo
     if(af==1) ekinet = ekinet*2.d0
     ekinet_mpi = 0.d0
     call mpi_allreduce(ekinet,ekinet_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
     ekinet = ekinet_mpi
     deallocate(ekin)
  end subroutine get_kinetic_energy_directly
! ==============================================================================


  
  subroutine get_xc_and_HE_of_old_CD_paw_sym
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    real(kind=DP) :: fac
    integer :: iopr,ja
    eohxc_paw = 0.d0
    
    do iopr=1,nopr
    
    do ispin = 1, nspin, af+1
       do it = 1, ntyp
          if(ipaw(it)==0) cycle  
          do lmt1 = 1, ilmt(it)
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
             do lmt2 = lmt1, ilmt(it)
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!                if( il1 /= il2 .or. im1 /= im2) cycle     ! ASMS 2015/02/06
!xocl spread do/ind_katm
                do ia = 1, natm
                   if(ityp(ia) /= it) cycle
                   ja=abs(ia2ia_symmtry_op(ia,iopr))
                   fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                   eohxc_paw = eohxc_paw &
                        & + fac*(dion_hartree(lmt1,lmt2,ia)+ &
                                dion_vxc(lmt1,lmt2,ispin,ja))*hsr(ja,lmt1,lmt2,ispin)
                end do
!xocl end spread
             end do
          end do
       end do
    end do
    
    end do
    eohxc_paw = eohxc_paw*(af+1)/dble(nopr)
  end subroutine get_xc_and_HE_of_old_CD_paw_sym
  
! ================================= added by K. Tagami ============= 11.0
  subroutine get_xc_HE_old_CD_paw_sym_noncl
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    real(kind=DP) :: fac
    integer :: iopr,ja
    eohxc_paw = 0.d0
    
    do iopr=1,nopr
    
       do ispin = 1, ndim_magmom
          do it = 1, ntyp
             if(ipaw(it)==0) cycle  

             do lmt1 = 1, ilmt(it)
                il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
                do lmt2 = lmt1, ilmt(it)
                   il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!                   if( il1 /= il2 .or. im1 /= im2) cycle     !! ASMS 2015/02/06
!xocl spread do/ind_katm
                   do ia = 1, natm
                      if(ityp(ia) /= it) cycle
                      ja=abs(ia2ia_symmtry_op(ia,iopr))
                      fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0

                      if ( ispin==1 ) then
                         eohxc_paw = eohxc_paw &
                              &     + fac *( dion_hartree(lmt1,lmt2,ia) &
                              &             +dion_vxc(lmt1,lmt2,ispin,ja) ) &
                              &           *hsr(ja,lmt1,lmt2,ispin)
                      else
                         eohxc_paw = eohxc_paw &
                              &     + fac *dion_vxc(lmt1,lmt2,ispin,ja)  &
                              &           *hsr(ja,lmt1,lmt2,ispin)
                      endif
                   end do
!xocl end spread
                end do
             end do
          end do
       end do
       
    end do
    eohxc_paw = eohxc_paw /dble(nopr)

  end subroutine get_xc_HE_old_CD_paw_sym_noncl
! ============================================================= 11.0

  
  subroutine get_hartree_energy_paw_sym
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    real(kind=DP) :: fac
    integer :: iopr,ja
    
    ehartr_paw = 0.d0
    
    do iopr=1,nopr
    
    do ispin = 1, nspin, af+1
       do it = 1, ntyp
          if(ipaw(it)==0) cycle  
          do lmt1 = 1, ilmt(it)
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
             do lmt2 = lmt1, ilmt(it)
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!                if( il1 /= il2 .or. im1 /= im2) cycle     !! ASMS 2015/02/06
!xocl spread do/ind_katm
                do ia = 1, natm
                   if(ityp(ia) /= it) cycle
                   ja=abs(ia2ia_symmtry_op(ia,iopr))
                   fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                   ehartr_paw = ehartr_paw &
                        & + fac*dion_hartree_now(lmt1,lmt2,ja)*hsr(ja,lmt1,lmt2,ispin)
!print *,fac*dion_hartree_now(lmt1,lmt2,ja)*hsr(ja,lmt1,lmt2,ispin)/det,det
                end do
!xocl end spread
             end do
          end do
       end do
    end do
    
    end do
    ehartr_paw = ehartr_paw*(af+1)*0.5d0/dble(nopr)
  end subroutine get_hartree_energy_paw_sym

! ============================== added by K. Tagami ============== 11.0
  subroutine get_hartree_ene_paw_sym_noncl
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    real(kind=DP) :: fac
    integer :: iopr,ja
    
    ehartr_paw = 0.d0
    
    do iopr=1,nopr
    
       do ispin = 1, 1
          do it = 1, ntyp
             if(ipaw(it)==0) cycle  
             do lmt1 = 1, ilmt(it)
                il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
                do lmt2 = lmt1, ilmt(it)
                   il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!!                   if( il1 /= il2 .or. im1 /= im2) cycle      !! ASMS 2015/02/06
!xocl spread do/ind_katm
                   do ia = 1, natm
                      if(ityp(ia) /= it) cycle
                      ja=abs(ia2ia_symmtry_op(ia,iopr))
                      fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                      ehartr_paw = ehartr_paw &
                           & + fac*dion_hartree_now(lmt1,lmt2,ja)*hsr(ja,lmt1,lmt2,ispin)
                   end do
!xocl end spread
                end do
             end do
          end do
       end do
    
    end do
    ehartr_paw = ehartr_paw*0.5d0/dble(nopr)

  end subroutine get_hartree_ene_paw_sym_noncl
! ================================================================= 11.0

  subroutine get_entropic_term(nfout)
    integer, intent(in) :: nfout
#ifdef __TIMER_SUB__
    call timer_sta(748)
#endif
    eentropy = -width*band_entropy
    if(ipri >= 2) then
       write(nfout,'(" !D EENTROPY = ",f20.14)') eentropy
    endif
#ifdef __TIMER_SUB__
    call timer_end(748)
#endif
  end subroutine get_entropic_term



  subroutine sumup_all_energies(nfout,exc,display_on)
    integer, intent(in) :: nfout
    logical, intent(in) :: display_on
    real(kind=DP), intent(in) :: exc

    real(kind=DP) :: edel
#ifdef __TIMER_SUB__
    call timer_sta(749)
#endif

! ===== KT_mod ==== 13.0S
!    etotal0 = ekinet+ehartr+exc+elocal+enonlc+eewald-epc
!    if(flg_paw) etotal0=etotal0-eohxc_paw+ehartr_paw+exc_ae-exc_ps
!
    if ( flg_paw ) then
#if 0
       ekin_ion_paw = enonlc -eohxc_paw      !! ??
#else
       eohxc_paw = enonlc -ekin_ion_paw      ! meaningless, this is just for output
#endif
       etotal0 = ekinet +ehartr +exc +elocal +ekin_ion_paw +eewald -epc_paw
       etotal0 = etotal0 +ehartr_paw +exc_ae -exc_ps    
    else
       etotal0 = ekinet+ehartr+exc+elocal+enonlc+eewald-epc
    endif
! ================= 13.0S

! ==== POSITRON SCF == 2015/11/28
    if ( sw_positron /= OFF ) then
       if ( positron_method == Positron_GGGC ) then
          etotal0 = etotal0 +ekin_pztr +elocal_pztr +ecorr_pztr +ehartr_ep
       endif
    endif
! =================== 2015/11/28

    if(sw_dipole_correction == ON) etotal0 = etotal0 + edip
    if(sw_hubbard == ON) etotal0 = etotal0 + ehub0
    if(sw_hybrid_functional == ON) etotal0 = etotal0 + eexx
    if(sw_fef == ON) etotal0 = etotal0 + eplr
    if(ntyp_vdw>0) etotal0 = etotal0 + evdw

! =============================== added by K. Tagami =================== 11.0
    if ( sw_magnetic_constraint == ON ) etotal0 = etotal0 + emag0
! ====================================================================== 11.0

! =============================== added by K. Tagami =================== 11.0
!!!#ifdef USE_ESPINORB
!!!#endif
! ====================================================================== 11.0

    etotal = etotal0+eentropy
    if(way_of_smearing == COLD) etotal0 = (2.d0*etotal+etotal0)/3.d0
    if(way_of_smearing == PARABOLIC) etotal0 = (etotal+etotal0)*0.5d0

! =============== KT_add ============================================= 13.0E
    if(way_of_smearing == Fermi_Dirac) etotal0 = (etotal+etotal0)*0.5d0
! ==================================================================== 13.0E

    if(display_on .and. ipri >= 1) then
       edel = etotal - etoold
!!$       write(nfout,600) iteration,etotal,etotal
!!$       write(nfout,600) iteration,etotal,edel
       if(number_of_solvers_applied == 1) then
          write(nfout,'(" TOTAL ENERGY FOR",I6," -TH ITER=",F20.12,"  edel = ",D14.6," : SOLVER = ",A)') &
               & iteration, etotal, edel, trim(solver_names_applied(1))
       else if(number_of_solvers_applied == 2) then
          write(nfout,'(" TOTAL ENERGY FOR",I6," -TH ITER=",F20.12,"  edel = ",D14.6," : SOLVER = ",A," + ",A)') &
               & iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2))
       else
          write(nfout,600) iteration,etotal,edel
       end if

       if(sw_output_xc_seperately==OFF)then
          if ( flg_paw ) then
             write(nfout,610) ekinet,ehartr,exc,elocal, &
                  &                   enonlc,eewald,-epc_paw,eentropy
          else
             write(nfout,610) ekinet,ehartr,exc,elocal, &
                  &                   enonlc,eewald,-epc,eentropy
          endif
       else
          if ( flg_paw ) then
             write(nfout,615) ekinet,ehartr,eex,ecor,exc,elocal, &
                  &                   enonlc,eewald,-epc_paw,eentropy
          else
             write(nfout,615) ekinet,ehartr,eex,ecor,exc,elocal, &
                  &                   enonlc,eewald,-epc,eentropy
          endif
       endif

       if(sw_dipole_correction == ON) write(nfout,630) evdip,evext,edip
       if(sw_hubbard == ON) write(nfout,640) ehub0,ehub1
       if(sw_hybrid_functional == ON.and.sw_eval_vexx==ON) write(nfout,650) vexx,eexx,eexx-vexx
       if(sw_hybrid_functional == ON.and.sw_eval_vexx==OFF) write(nfout,655) eexx
       if(sw_external_potential==ON) write(nfout,670) eespot
       if(sw_fef == ON) write(nfout,680) eplr
       if(ntyp_vdw>0) write(nfout,690) evdw
       if(way_of_smearing == COLD .or. way_of_smearing == PARABOLIC &
            & .and. abs(eentropy)>=DELTA ) write(nfout,620) etotal0

! =============== KT_add =========================================== 13.0E
       if (way_of_smearing == Fermi_Dirac ) write(nfout,620) etotal0
! ================================================================== 13.0E

! === DEBUG by tkato 2011/10/07 ================================================
!      if(flg_paw) &
!      write(nfout,650) eohxc_paw,ehartr_paw,exc_ae,exc_ps,exc_ae-exc_ps
       if(flg_paw) then
          if(dabs(exc_ae) >1.d6 .or. dabs(exc_ps)>1.d6 )then
             write(nfout,661) eohxc_paw,ehartr_paw,exc_ae,exc_ps,exc_ae-exc_ps
          else
             write(nfout,660) eohxc_paw,ehartr_paw,exc_ae,exc_ps,exc_ae-exc_ps
          end if
       end if
! ==============================================================================

! ====================================== added by K. Tagami =============== 11.0
       if ( sw_magnetic_constraint == ON ) write(nfout,700) emag0, emag1
! ========================================================================= 11.0       

! ====================================== added by K. Tagami =============== 11.0
!!#ifdef USE_ESPINORB
!!!#endif
! ========================================================================= 11.0       

       call flush(nfout)
    end if
#ifdef __TIMER_SUB__
    call timer_end(749)
#endif
600 FORMAT(' ','TOTAL ENERGY FOR',I6,' -TH ITER=',F20.12,2x,' edel = ',D14.6)
610 FORMAT(' KI=',F20.12,' HA=',F20.12,' XC=',F20.12,' LO=',F20.12,/ &
    &      ,' NL=',F20.12,' EW=',F20.12,' PC=',F20.12,' EN=',F20.12)
615 FORMAT(' KI=',F20.12,' HA=',F20.12,' EX=',F20.12,' CR=',F20.12,' XC=',F20.12,' LO=',F20.12,/ &
    &      ,' NL=',F20.12,' EW=',F20.12,' PC=',F20.12,' EN=',F20.12)
620 FORMAT(' ','PHYSICALLY CORRECT ENERGY = ',F20.12)
630 FORMAT(' VD=',F15.7,' VE=',F15.7,' ED=',F15.7)
640 FORMAT(" HE=",F15.7," HP=",F15.7)
650 FORMAT(" VEXX=",F20.12," EEXX=",F20.12," EXX-VEXX=",F20.12)
655 FORMAT(" EXX=",F20.12)
660 FORMAT(' EOHXC_PAW=',F15.7,' HA_PAW=',F15.7,/ &
            ' XC_PAW_AE=',F15.7,' XC_PAW_PS=',F15.7,/ &
            '!XC_PAW_AE-XC_PAW_PS=',F15.7)
661 FORMAT(' EOHXC_PAW=',F15.7,' HA_PAW=',F15.7,/ &
            ' XC_PAW_AE=',d20.8,' XC_PAW_PS=',d20.8,/ &
            '!XC_PAW_AE-XC_PAW_PS=',F15.7)
670 FORMAT(' ES=',F20.12)
680 FORMAT(" EP=",F20.12)
690 FORMAT(" VDW=",F20.12)

! ================================== added by K. Tagami ================== 11.0
700 FORMAT(" Emag0=",F15.7," Emag1=",F15.7)
710 FORMAT(" ESpinOrb_old=",F15.7," ESpinOrb_now=",F15.7)
720 FORMAT(" ESpinOrb=",F15.7)
! ======================================================================== 11.0

  end subroutine sumup_all_energies

  logical function m_TE_is_Divergent_core(nfout)
    integer, intent(in) :: nfout
    integer :: iincre = 0

    if(iteration_electronic == 1) iincre = 0
    edeltb = etotal - etoold
    if(ipri >= 2) write(nfout,'(" ! edeltb = ",d14.6 &
	& ," hr (= ",d14.6," hr/atom ) ( iter = ",i7," )")') edeltb,edeltb/natm2,iteration

    if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
       m_TE_is_Divergent_core = .false.
       etoold = etotal
       return
    end if

!!$    if(edeltb > 1.d-1) then
!!$       iincre = iincre + 100
!!$    else if(edeltb > 1.d-2) then
!!$       iincre = iincre + 100
!!$    else if(edeltb >1.d-3) then
!!$       iincre = iincre + 70
!!$    else if(edeltb > 1.d-4) then
!!$       iincre = iincre + 20
!!$    else if(edeltb > 1.d-5) then
!!$       iincre = iincre + 10
!!$    else if(edeltb > 1.d-6) then
!!$       iincre = iincre + 5
!!$    else if(iincre > 0) then
!!$       iincre = iincre - 1
!!$    end if
    if(edeltb > 1.d-7 .and. iincre /= 0 .and. printable) &
         &    write(nfout,*) ' !W IINCRE is increasing as ', iincre
    if(iincre > IINCRE_CRITICAL) then
       if(printable) write(nfout,*)  ' !S IINCRE exceeds ',IINCRE_CRITICAL,'!'
       m_TE_is_Divergent_core = .true.
    else
       m_TE_is_Divergent_core = .false.
    end if
    etoold = etotal
  end function m_TE_is_Divergent_core

  subroutine m_TE_set_etotal_old
    etoold = 0.d0
  end subroutine m_TE_set_etotal_old

! --> T. Yamasaki 08 Aug. 2009 
  real(kind=DP) function m_TE_edeltb()
    m_TE_edeltb = edeltb
  end function m_TE_edeltb
! <--
  logical function m_TE_is_converged(nfout)
    integer, intent(in) :: nfout
    integer   :: ncnv
    real(kind=DP) :: edelta

    call m_CtrlP_get_edelta(edelta)

    if(dabs(edeltb) < edelta*natm2 .and. m_ES_eekdif_cond()) then
       ncnv = m_CtrlP_ntcnvg_incre()
       if(printable) write(nfout,'(" edeltb = ",d12.4, " edelta = ",d12.4 &
            & , " ntcnvg = ",i7)') edeltb, edelta, ncnv
! --> T. Yamasaki, 25 July 2008
    else if(sub_delta_factor_is_given .and. dabs(edeltb) <edelta*sub_delta_factor*natm2) then
       ncnv = m_CtrlP_sub_ntcnvg_incre()
       if(printable) write(nfout,'(" edeltb = ",d12.4, " sub_edelta = ",d12.4 &
            & , " sub_ntcnvg = ",i7)') edeltb, edelta*sub_delta_factor, ncnv
    else
! <--
       call m_CtrlP_ntcnvg_reset()! k .Mae 030808	
    end if
    m_TE_is_converged = m_CtrlP_ntcnvg_clear()
    if(m_TE_is_converged) call m_CtrlP_ntcnvg_reset()
  end function m_TE_is_converged

  function m_TE_tell_total_energy()
    real(kind=DP)::  m_TE_tell_total_energy
    m_TE_tell_total_energy = etotal
  end function m_TE_tell_total_energy

!!$! --> T. Yamasaki 17th Aug. 2009
!!$  function m_TE_tell_total_energy_mdfy()
!!$    real(kind=DP)::  m_TE_tell_total_energy_mdfy
!!$    if(sw_hubbard == ON) then
!!$       m_TE_tell_total_energy_mdfy = etotal - ehub0*0.5d0
!!$    else
!!$       m_TE_tell_total_energy_mdfy = etotal
!!$    end if
!!$  end function m_TE_tell_total_energy_mdfy
!!$! <--

  function m_TE_tell_total_energy0()
    real(kind=DP)::  m_TE_tell_total_energy0
    m_TE_tell_total_energy0 = etotal0
  end function m_TE_tell_total_energy0



  subroutine m_TE_wd_total_energy(nfcntn)
    integer, intent(in) :: nfcntn
    !!$ print *,' tag_total_energy'
    if(mype==0) then
       write(nfcntn,*) tag_total_energy
       write(nfcntn,'(2d24.16)') etotal, etoold
       edeltb = etotal - etoold
    endif
  end subroutine m_TE_wd_total_energy

  subroutine m_TE_rd_total_energy(nfcntn)
    integer, intent(in) :: nfcntn
    logical             :: EOF_reach, tag_is_found

    if(mype==0) then
       call rewind_to_tag0(nfcntn,len_tag_total_energy,tag_total_energy &
            &, EOF_reach, tag_is_found,str,len_str)
       if(.not.tag_is_found) then
          stop ' tag_total_energy is not found'
       else
          read(nfcntn,*) etotal, etoold
          etoold = etotal
       end if
    endif
    call mpi_bcast(etotal,1 &
         & ,mpi_double_precision,0,mpi_comm_group,ierr)
    call mpi_bcast(etoold,1 &
         & ,mpi_double_precision,0,mpi_comm_group,ierr)
  end subroutine m_TE_rd_total_energy

  logical function m_TE_Converged_Hubbard_Energy(nfout)
    integer, intent(in) :: nfout

    m_TE_Converged_Hubbard_Energy = .false.
    !!$if(ehub0 <= critical_ehub) then
    !!$   m_TE_Converged_Hubbard_Energy = .true.
    !!$   write(nfout,'(" Interation will be stoped &
    !!$   &because Hubbard energy is lower than ",f10.5,".")') critical_ehub
    !!$end if

    if(abs(ehub0-ehub0_old) <= delta_ehub) then
       m_TE_Converged_Hubbard_Energy = .true.
       write(nfout,'(" Interation will be stoped &
       &because Hubbard energy is converged within ",f10.5,".")') delta_ehub
    else
       ehub0_old = ehub0
    end if

  end function m_TE_Converged_Hubbard_Energy


!===============================================================================
!!$  subroutine m_TE_total_energy_3D(nfout,display_on,kv3)
  subroutine m_TE_total_energy(nfout,display_on,kv3)
    use m_XC_Potential,         only : m_XC_cal_potential_3D
#if 0
    use m_Control_Parameters,   only : sw_distribute_wf,force_exx_energy1
#else
    use m_Control_Parameters,   only : force_exx_energy1
#endif
    integer, intent(in) :: nfout
    logical, intent(in) :: display_on
    integer, intent(in) :: kv3
    real(kind=DP) :: edeltb_now
    integer :: isolver,sw_submat
    integer             :: id_sname = -1   , i
#ifdef __TIMER_SUB__
    call timer_sta(739)
#endif
    call tstatc0_begin('Total_Energy(including xc_pot) ',id_sname)
    call get_band_energy_3D(kv3)
    call get_xc_and_HE_of_old_CD_3D(vxc_l)
    call get_local_potential_energy_3D
    call get_hubbard_energy_3D(nfout)
    call get_nonlocal_potential_energy_3D
! === DEBUG by tkato 2012/11/07 ================================================
    if(in_line_minimization) then
       call m_XC_cal_potential_3D(nfout,Valence_plus_PC_Charge, chgq_l, EXC_ONLY)
    else
       call m_XC_cal_potential_3D(nfout,Valence_plus_PC_Charge, chgq_l, VXC_AND_EXC)
    endif
! ==============================================================================
#ifdef ENABLE_ESM_PACK
    if(sw_esm==OFF)then
       call get_hartree_energy_3D
    endif
#else
    call get_hartree_energy_3D
#endif
    if(sw_dipole_correction ==  ON) then
       call get_dipole_energy_3D(vdip_l,vext_l)
    end if
! === Support Hybrid on 3D_Parallel by tkato 2013/02/10 ========================
    if(sw_hybrid_functional == ON) then
       if(sw_eval_vexx==ON) call m_ES_EXX_energy(vexx)
       if(icond == INITIAL .or. icond == CONTINUATION .or. icond == COORDINATE_CONTINUATION .or. &
       & ((icond==FIXED_CHARGE.or.icond==FIXED_CHARGE_CONTINUATION)&
       &                             .and. ekmode == OFF)   ) then
          edeltb_now = m_TE_what_is_edeltb_now()/natm2
!!$     write(nfout,'(" edeltb_per_atom = ", d20.12)') edeltb_per_atom
       else
          edeltb_now = m_ES_what_is_evdff_now()
       end if
       !isolver = m_CtrlP_solver_for_WFs_now(iteration_electronic,iteration_ionic,0 &
       !&                              ,edeltb_now,sw_submat)
       isolver = m_CtrlP_get_isolver_now()
       if(sw_retard_eigval_evaluation==OFF.or.isolver==MDDAVIDSON.or.isolver==MDKOSUGI.or.force_exx_energy1) then
#if 0
          if(sw_distribute_wf==ON)then
             call m_ES_EXX_gather_valence_states_k(nfout)
          else
             call m_ES_EXX_gather_valence_states(nfout)
          endif
#else
          call m_ES_EXX_gather_valence_states(nfout)
#endif

          call m_ES_EXX_energy(eexx)
       else
          call m_ES_EXX_energy2(eexx)
       endif
    end if
    force_exx_energy1 = .false.

    call get_entropic_term(nfout)
    if(flg_paw) then
#if 0
        call get_xc_and_HE_of_old_CD_paw_3D
#endif
! === DEBUG by tkato 2011/10/04 ================================================
!       call m_PAW_XC_cal_potential(nfout,EXC_ONLY,flg_symmtry)
        if(calcSphericalHarmonicsExpansion) then
           call m_PAW_XC_cal_potential_sphex2(nfout,EXC_ONLY)
        end if
        if(calcGaussLegendreIntegration)then
           call m_PAW_XC_cal_potential(nfout,EXC_ONLY,flg_symmtry)
        endif
! ==============================================================================
        call m_PAWH_get_dion_hartree_now(nfout)
        call get_hartree_energy_paw_3D
#if 1
        call get_kinetic_local_energy_paw(nfout)
#endif        
    end if
! ==============================================================================
! === DEBUG by tkato 2012/11/05 ================================================
!   call get_kinetic_energy(nfout)
#ifdef ENABLE_ESM_PACK
    if(sw_esm==ON.or.sw_hybrid_functional==ON)then
       call get_kinetic_energy_directly(nfout)
    else
       if(iteration_electronic == 1) then
          call get_kinetic_energy_directly(nfout)
       else
          call get_kinetic_energy(nfout)
       end if
    endif
#else
    if(sw_hybrid_functional==ON.or.iteration_electronic==1)then
       call get_kinetic_energy_directly(nfout)
    else
       call get_kinetic_energy(nfout)
    endif
#endif
! ==============================================================================
    call sumup_all_energies(nfout,exc,display_on)
    call tstatc0_end(id_sname)
#ifdef __TIMER_SUB__
    call timer_end(739)
#endif
  end subroutine m_TE_total_energy

!===============================================================================
  subroutine get_band_energy_3D(kv3)
    use m_Parallelization,      only : mpi_kg_world
! === DEBUG by tkato 2012/04/04 ================================================
    use m_Parallelization,      only : mpi_ge_world, nrank_k
! ==============================================================================

    integer, intent(in) :: kv3
    integer             :: ib, ik
    real(kind=DP)       :: eband_mpi   ! MPI
#ifdef __TIMER_SUB__
    call timer_sta(740)
#endif
    eband = 0.d0
#ifdef __TIMER_DO__
  call timer_sta(863)
#endif
    do ik =1, kv3, af+1
       if(map_k(ik) /= myrank_k) cycle ! MPI
       do ib = 1, np_e                 ! MPI
          eband = eband + occup_l(ib,ik)*eko_l(ib,ik)
       end do
    end do
#ifdef __TIMER_DO__
  call timer_end(863)
#endif

    if(nrank_e > 1) then
#ifdef __TIMER_COMM__
  call timer_barrier(mpi_kg_world)
  call timer_sta(864)
#endif
       call mpi_allreduce(eband,eband_mpi,1,mpi_double_precision,mpi_sum,mpi_kg_world,ierr) !MPI
#ifdef __TIMER_COMM__
  call timer_end(864)
#endif
       eband = eband_mpi
    end if
! === DEBUG by tkato 2012/04/04 ================================================
    if(nrank_k > 1) then
       call mpi_allreduce(eband,eband_mpi,1,mpi_double_precision,mpi_sum,mpi_ge_world,ierr) !MPI
       eband = eband_mpi
    end if
! ==============================================================================
    eband = 2*eband/kv3 * (af+1)
#ifdef __TIMER_SUB__
    call timer_end(740)
#endif
  end subroutine get_band_energy_3D

!===============================================================================
  subroutine get_xc_and_HE_of_old_CD_3D(vxc_l)
    use m_Parallelization,     only : mpi_ke_world, mpi_kg_world

    real(kind=DP), intent(in) :: vxc_l(ista_kngp:iend_kngp,kimg,nspin)
    integer ik, i, ispin
    integer ist !mpi
    real(kind=DP) :: eohxc_mpi

#ifdef __TIMER_SUB__
    call timer_sta(741)
#endif
    eohxc = 0.d0
    do ik = 1, kimg
#ifdef __TIMER_DO__
  call timer_sta(865)
#endif
       do ispin = 1, nspin
          if(myrank_g==0) then
             eohxc = eohxc + vxc_l(1,ik,ispin)*chgq_l(1,ik,ispin)
          endif
       end do
#ifdef __TIMER_DO__
  call timer_end(865)
#endif
       ist = ista_kngp
       if(ist == 1) ist = 2

#ifdef __TIMER_DO__
  call timer_sta(866)
#endif
       if(nspin == 1) then
          do i = ist, iend_kngp  !for mpi
             eohxc = eohxc &
                  & + (vxc_l(i,ik,1)+PAI4*chgqo_l(i,ik,1)/gr_l(i)**2) &
                  &   * chgq_l(i,ik,1)
          end do
       else if(nspin == 2) then
          do i = ist, iend_kngp  !for mpi
             eohxc = eohxc &
                  & +  (vxc_l(i,ik,UP)*chgq_l(i,ik,UP)&
                  &   + vxc_l(i,ik,DOWN)*chgq_l(i,ik,DOWN)) &
                  & + PAI4*(chgqo_l(i,ik,UP)+chgqo_l(i,ik,DOWN))&
                  & /gr_l(i)**2 &
                  &  *(chgq_l(i,ik,UP)+chgq_l(i,ik,DOWN))
          end do
       end if
#ifdef __TIMER_DO__
  call timer_end(866)
#endif
    end do
    if(nrank_g > 1) then
#ifdef __TIMER_COMM__
  call timer_barrier(mpi_ke_world)
  call timer_sta(867)
#endif
       call mpi_allreduce(eohxc,eohxc_mpi,1,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
#ifdef __TIMER_COMM__
  call timer_end(867)
#endif
       eohxc = eohxc_mpi
    end if

    eohxc = univol*eohxc
#ifdef __TIMER_SUB__
    call timer_end(741)
#endif
  end subroutine get_xc_and_HE_of_old_CD_3D

!===============================================================================
  subroutine get_local_potential_energy_3D
    use m_Parallelization,     only : mpi_ke_world

    integer       :: ik, it, i, ig
    real(kind=DP) :: eloca1_mpi
    real(kind=DP) :: eloclr,eloclr_mpi

#ifdef __TIMER_SUB__
    call timer_sta(742)
#endif
    eloca1 = 0.d0
#ifdef __TIMER_DO__
  call timer_sta(868)
#endif
    do ik = 1, kimg
       if(nspin == 1) then
!OCL NOFLTLD
          do it = 1,ntyp
             do i = ista_kngp, iend_kngp !for mpi
                eloca1 = eloca1 &
                     & + psc_l(i,it)*zfm3_l(i,it,ik)*chgq_l(i,ik,1)
             end do
          end do
       else
!OCL NOFLTLD
          do it = 1, ntyp
             do i = ista_kngp, iend_kngp  !for mpi
                eloca1 = eloca1 &
                     &   + psc_l(i,it)*zfm3_l(i,it,ik)&
                     &             *(chgq_l(i,ik,UP)+chgq_l(i,ik,DOWN))
             end do
          end do
       endif
    end do
#ifdef __TIMER_DO__
  call timer_end(868)
#endif
    if(nrank_g > 1) then
#ifdef __TIMER_COMM__
  call timer_barrier(mpi_ke_world)
  call timer_sta(869)
#endif
       call mpi_allreduce(eloca1,eloca1_mpi,1,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
#ifdef __TIMER_COMM__
  call timer_end(869)
#endif
       eloca1 = eloca1_mpi
    end if

    eloca1    = univol*eloca1
#ifdef ENABLE_ESM_PACK
    if(sw_esm==OFF) then
       elocal    = eloca1 + etot1*totch
    else
       elocal = eloca1
    endif
#else
    elocal    = eloca1 + etot1*totch
#endif

#ifdef ENABLE_ESM_PACK
    if(sw_esm==ON)then
!add the long-range part
      eloclr=0.d0
      if(nspin.eq.1)then
        if(kimg==2)then
          do ig=ista_kngp,iend_kngp
            eloclr=eloclr+dble(vloc_esm(igfp_l(ig)))*chgq_l(ig,1,1)+aimag(vloc_esm(igfp_l(ig)))*chgq_l(ig,2,1)
          enddo
        else if(kimg==1)then
          do ig=ista_kngp,iend_kngp
            eloclr=eloclr+dble(vloc_esm(igfp_l(ig)))*chgq_l(ig,1,1)
          enddo
        endif
      else
        if(kimg==2)then
          do ig=ista_kngp,iend_kngp
            eloclr=eloclr+dble(vloc_esm(igfp_l(ig))) &
   &                     *(chgq_l(ig,1,1)+chgq_l(ig,1,2)) &
   &                     +aimag(vloc_esm(igfp_l(ig))) &
   &                     *(chgq_l(ig,2,1)+chgq_l(ig,2,2))
          enddo                                           
        else if(kimg==1)then
          do ig=ista_kngp,iend_kngp
            eloclr=eloclr+dble(vloc_esm(igfp_l(ig))) &
   &                     *(chgq_l(ig,1,1)+chgq_l(ig,1,2))
          enddo                                           
        endif
      endif
      eloclr_mpi=0.d0
      call mpi_allreduce(eloclr,eloclr_mpi,1,&
      & mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
      eloclr = eloclr_mpi
      eloclr = univol*eloclr
      elocal = elocal + eloclr
    endif
#endif

#ifdef __TIMER_SUB__
    call timer_end(742)
#endif
  end subroutine get_local_potential_energy_3D

!===============================================================================
  subroutine get_hubbard_energy_3D(nfout)
    integer, intent(in) :: nfout
#ifdef __TIMER_SUB__
    call timer_sta(743)
#endif
    ehub0 = 0.d0
    ehub1 = 0.d0
    if(sw_hubbard==ON) then
      call m_Hubbard_energy(ehub0)
      call get_hubbard_potential_energy_3D(ehub1)
    end if
    if(ipri >= 2) then
       write(nfout,'(" !D EHUB0 = ",f20.14)') ehub0
       write(nfout,'(" !D EHUB1 = ",f20.14)') ehub1
    endif
#ifdef __TIMER_SUB__
    call timer_end(743)
#endif
  end subroutine get_hubbard_energy_3D

!===============================================================================
  subroutine get_hubbard_potential_energy_3D(ehub1)
    use m_Parallelization,     only : mpi_ke_world
    real(kind=DP), intent(out) :: ehub1
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    integer :: ih, l1p, ierr
    real(kind=DP) :: fac, mpi
    ehub1 = 0.d0
    do ispin = 1, nspin, af+1
       do ia = ista_atm, iend_atm
          ih = ihubbard(ia)
          if(ih == 0) cycle
          it = ityp(ia)
          l1p = proj_attribute(ih)%l+1
          do lmt1 = 1, ilmt(it)
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
             if(il1 /= l1p) cycle
             do lmt2 = lmt1, ilmt(it)
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
                if(il2 /= l1p) cycle
                !!$if(im1 /= im2) cycle
                fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                ehub1 = ehub1 &
                      & + fac*dhub(lmt1,lmt2,ia,ispin)*hsr(ia,lmt1,lmt2,ispin)
             end do
          end do
       end do
    end do
    if(nrank_g > 1) then
       call mpi_allreduce(ehub1,mpi,1,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
       ehub1 = mpi
    end if
    ehub1 = ehub1*(af+1)
  end subroutine get_hubbard_potential_energy_3D

!===============================================================================
  subroutine get_nonlocal_potential_energy_3D
    use m_Parallelization,     only : mpi_ke_world

    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia, ierr
    real(kind=DP) :: fac, mpi
#ifdef __TIMER_SUB__
    call timer_sta(744)
#endif
    enonlc = 0.d0
#ifdef __TIMER_DO__
  call timer_sta(870)
#endif
    do ispin = 1, nspin, af+1
       do it = 1, ntyp
          if(ipaw(it)==0) then   
              do lmt1 = 1, ilmt(it)
                 il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
                 do lmt2 = lmt1, ilmt(it)
                    il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
                    if( il1 /= il2 .or. im1 /= im2) cycle
    !xocl spread do/ind_katm
                    do ia = ista_atm, iend_atm
                       if(ityp(ia) /= it) cycle
                       fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                       enonlc = enonlc &
                            & + fac*dion(lmt1,lmt2,it)*hsr(ia,lmt1,lmt2,ispin)
                    end do
    !xocl end spread
                 end do
              end do
          else 
              do lmt1 = 1, ilmt(it)
                 do lmt2 = lmt1, ilmt(it)
    !xocl spread do/ind_katm
                    do ia = ista_atm, iend_atm
                       if(ityp(ia) /= it) cycle
                       fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                       enonlc = enonlc &
                            & + fac*dion_paw(lmt1,lmt2,ispin,ia)*hsr(ia,lmt1,lmt2,ispin)
                    end do
    !xocl end spread
                 end do
              end do
          end if
       end do
    end do
#ifdef __TIMER_DO__
  call timer_end(870)
#endif
    if(nrank_g > 1) then
#ifdef __TIMER_COMM__
  call timer_barrier(mpi_ke_world)
  call timer_sta(871)
#endif
       call mpi_allreduce(enonlc,mpi,1,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
#ifdef __TIMER_COMM__
  call timer_end(871)
#endif
       enonlc = mpi
    end if
    enonlc = enonlc*(af+1)
    !!$if(sw_hubbard==ON) enonlc = enonlc - ehub1
#ifdef __TIMER_SUB__
    call timer_end(744)
#endif
  end subroutine get_nonlocal_potential_energy_3D
!===============================================================================

  subroutine get_hartree_energy_3D
    use m_Parallelization,     only : mpi_ke_world

    integer ik, i
    integer :: ist !mpi
    real(kind=DP) :: ehartr_mpi

#ifdef __TIMER_SUB__
    call timer_sta(745)
#endif
    ehartr_mpi = 0.d0
    ehartr = 0.d0
#ifdef __TIMER_DO__
  call timer_sta(872)
#endif
    do ik = 1, kimg
       ist = ista_kngp
       if(ist == 1) ist = 2

       if(nspin == 1) then
          do i = ist, iend_kngp !for mpi
             ehartr_mpi  = ehartr_mpi + (chgq_l(i,ik,1)/gr_l(i))**2
          end do
       else if(nspin == 2) then
          do i = ist, iend_kngp  !for mpi
             ehartr_mpi  = ehartr_mpi &
                  &  +((chgq_l(i,ik,UP)+chgq_l(i,ik,DOWN))/gr_l(i))**2
          end do
       end if
    end do
#ifdef __TIMER_DO__
  call timer_end(872)
#endif
#ifdef __TIMER_COMM__
  call timer_barrier(mpi_ke_world)
  call timer_sta(873)
#endif
    call mpi_allreduce(ehartr_mpi,ehartr,1,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
#ifdef __TIMER_COMM__
  call timer_end(873)
#endif
    ehartr    = univol*PAI4*ehartr*0.5d0
#ifdef __TIMER_SUB__
    call timer_end(745)
#endif
  end subroutine get_hartree_energy_3D
!===============================================================================

  subroutine get_dipole_energy_3D(vdip_l,vext_l)
    use m_Parallelization,     only : mpi_ke_world

    real(kind=DP), intent(in) :: vdip_l(ista_kngp:iend_kngp,kimg)
    real(kind=DP), intent(in) :: vext_l(ista_kngp:iend_kngp,kimg)
    integer ik, i, ispin, ierr
    integer ist !mpi
    real(kind=DP) :: evdip_mpi
    real(kind=DP) :: evext_mpi
#ifdef __TIMER_SUB__
    call timer_sta(746)
#endif

    evdip = 0.d0
    evext = 0.d0
#ifdef __TIMER_DO__
  call timer_sta(874)
#endif
    do ik = 1, kimg
       do ispin = 1, nspin
          if(myrank_g==0) then
             evdip = evdip + vdip_l(1,ik)*chgq_l(1,ik,ispin)
             evext = evext + vext_l(1,ik)*chgq_l(1,ik,ispin)
          endif
       end do
       ist = ista_kngp
       if(ist == 1) ist = 2

       if(nspin == 1) then
          do i = ist, iend_kngp  !for mpi
             evdip = evdip + vdip_l(i,ik)*chgq_l(i,ik,1)
             evext = evext + vext_l(i,ik)*chgq_l(i,ik,1)
          end do
       else if(nspin == 2) then
          do i = ist, iend_kngp  !for mpi
             evdip = evdip + vdip_l(i,ik)*(chgq_l(i,ik,UP)+chgq_l(i,ik,DOWN))
             evext = evext + vext_l(i,ik)*(chgq_l(i,ik,UP)+chgq_l(i,ik,DOWN))
          end do
       end if
    end do
#ifdef __TIMER_DO__
  call timer_end(874)
#endif
    if(nrank_g > 1) then
#ifdef __TIMER_COMM__
  call timer_barrier(mpi_ke_world)
  call timer_sta(875)
#endif
       call mpi_allreduce(evdip,evdip_mpi,1,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
#ifdef __TIMER_COMM__
  call timer_end(875)
#endif
       evdip =evdip_mpi
    end if
    evdip = evdip * univol
    evext = evext * univol
    edip = edip_ion + eext_ion + evdip*0.5d0 + evext
#ifdef __TIMER_SUB__
    call timer_end(746)
#endif
  end subroutine get_dipole_energy_3D
!===============================================================================

  subroutine get_xc_and_HE_of_old_CD_paw_3D
    use m_Parallelization,     only :mpi_ke_world

    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia, ierr
    real(kind=DP) :: fac,mpi
    eohxc_paw = 0.d0
    do ispin = 1, nspin, af+1
       do it = 1, ntyp
          if(ipaw(it)==0) cycle  
          do lmt1 = 1, ilmt(it)
! === DEBUG by tkato 2012/11/08 ================================================
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
! ==============================================================================
             do lmt2 = lmt1, ilmt(it)
! === DEBUG by tkato 2012/11/08 ================================================
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!                if( il1 /= il2 .or. im1 /= im2) cycle      !! ASMS 2015/02/06
! ==============================================================================
!xocl spread do/ind_katm
                do ia = ista_atm,iend_atm
                   if(ityp(ia) /= it) cycle
                   fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                   eohxc_paw = eohxc_paw &
                        & + fac*(dion_hartree(lmt1,lmt2,ia)+ &
                                dion_vxc(lmt1,lmt2,ispin,ia))*hsr(ia,lmt1,lmt2,ispin)
                end do
!xocl end spread
             end do
          end do
       end do
    end do
    if(nrank_g > 1) then
       call mpi_allreduce(eohxc_paw,mpi,1,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
       eohxc_paw = mpi
    end if
    eohxc_paw = eohxc_paw*(af+1)
  end subroutine get_xc_and_HE_of_old_CD_paw_3D
!===============================================================================

  subroutine get_hartree_energy_paw_3D
    use m_Parallelization,     only :mpi_ke_world
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia, ierr
    real(kind=DP) :: fac, mpi
    
    ehartr_paw = 0.d0
    do ispin = 1, nspin, af+1
       do it = 1, ntyp
          if(ipaw(it)==0) cycle  
          do lmt1 = 1, ilmt(it)
! === DEBUG by tkato 2012/11/07 ================================================
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
! ==============================================================================
             do lmt2 = lmt1, ilmt(it)
! === DEBUG by tkato 2012/11/07 ================================================
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!                if( il1 /= il2 .or. im1 /= im2) cycle    !! ASMS 2015/02/06
! ==============================================================================
!xocl spread do/ind_katm
                do ia = ista_atm, iend_atm
                   if(ityp(ia) /= it) cycle
                   fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                   ehartr_paw = ehartr_paw &
                        & + fac*dion_hartree_now(lmt1,lmt2,ia)*hsr(ia,lmt1,lmt2,ispin)
                end do
!xocl end spread
             end do
          end do
       end do
    end do
    if(nrank_g > 1) then
       call mpi_allreduce(ehartr_paw,mpi,1,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
       ehartr_paw = mpi
    end if
    ehartr_paw = ehartr_paw*(af+1)*0.5d0
  end subroutine get_hartree_energy_paw_3D
!===============================================================================

  function m_TE_tell_band_energy_3D(nfout,kv3)
    real(kind=DP)::  m_TE_tell_band_energy_3D
    integer, intent(in) :: nfout,kv3
    integer :: ib, ik
    call sum_eigenvalues_3D(kv3)
    m_TE_tell_band_energy_3D = eband
    if(ipri >= 2) then
       if(map_k(ik) == myrank_k) then
          write(nfout,'(" -- sum_eigenvalues (m_TE_tell_band_energy) --")')
          write(nfout,'("   -- num_extra_bands = ",i8)') num_extra_bands
          do ik = 1, kv3
             write(nfout,'("  ik = ",i5)') ik
             write(nfout,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
          end do
       end if
    endif
  end function m_TE_tell_band_energy_3D

  function m_TE_tell_extended_band_energy_3D(nfout,kv3)
    real(kind=DP)::  m_TE_tell_extended_band_energy_3D
    integer, intent(in) :: nfout,kv3
    integer :: ib, ik
    call sum_wholeeigenvalues_3D(nfout,kv3)
    m_TE_tell_extended_band_energy_3D = eband_extendedrange
    if(ipri >= 2) then
       if(map_k(ik) == myrank_k) then
          write(nfout,'(" -- sum_eigenvalues (m_TE_tell_band_energy) --")')
          write(nfout,'("   -- num_conduction_bands_lmm = ",i8)') num_conduction_bands_lmm
          do ik = 1, kv3
             write(nfout,'("  ik = ",i5)') ik
             write(nfout,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
          end do
       end if
    endif
  end function m_TE_tell_extended_band_energy_3D

  subroutine sum_eigenvalues_3D(kv3)
   use m_Parallelization,     only : neg_g                   &
  &                                , mpi_kg_world
    integer, intent(in) :: kv3
    integer             :: ib, ik
    real(kind=DP)       :: eband_mpi   ! MPI
    eband = 0.d0
    do ik =1, kv3, af+1
       if(map_k(ik) /= myrank_k) cycle ! MPI
       do ib = 1, np_e                 ! MPI
!fj$$       if(nrvf_ordr(ib,ik) > neg - num_extra_bands) cycle
          if(neg_g(ib) > neg - num_extra_bands) cycle
          eband = eband + eko_l(ib,ik)*occup_l(ib,ik)
       end do
    end do
    call mpi_allreduce(eband,eband_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr) !MPI
    eband = eband_mpi                  ! MPI
    eband = 2*eband/kv3 * (af+1)
  end subroutine sum_eigenvalues_3D

  subroutine sum_wholeeigenvalues_3D(nfout,kv3)
   use m_Parallelization,     only : neg_g                   &
  &                                , mpi_kg_world
    integer, intent(in) :: nfout,kv3
    integer             :: ib, ik
    real(kind=DP)       :: eband_mpi   ! MPI
    integer             :: iband
    real(kind=DP)       :: weight, weight0

    if(num_conduction_bands_lmm < 0) then
       iband = neg
    else
       iband = ceiling(totch/2.0) + num_conduction_bands_lmm
    end if
    if(iband > neg - num_extra_bands) iband = neg - num_extra_bands
    eband_extendedrange = 0.d0
    weight = 0.d0; weight0 = 0.d0
    do ik =1, kv3, af+1
       weight = weight + qwgt(ik)
       if(map_k(ik) /= myrank_k) cycle ! MPI
       do ib = 1, np_e                 ! MPI
          if(ik==1 .and. ib == 1) weight0 = weight0 + occup_l(1,ik)
!!$          if(nrvf_ordr(ib,ik) > neg - num_extra_bands) cycle
!!$       if(nrvf_ordr(ib,ik) > iband) cycle
          if(neg_g(ib) > iband) cycle
          eband_extendedrange = eband_extendedrange + eko_l(ib,ik)*qwgt(ik)
       end do
    end do
    if(nrank_e > 1) then
       call mpi_allreduce(eband_extendedrange,eband_mpi,1,mpi_double_precision, &
      &                   mpi_sum,mpi_kg_world,ierr) !MPI
       eband_extendedrange = eband_mpi                  ! MPI
       call mpi_allreduce(weight0, eband_mpi,1,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
       weight0 = eband_mpi
    end if
    eband_extendedrange = (3.0-nspin) * eband_extendedrange * (af+1)
    if(ipri >= 1) then
       weight = weight * (af+1)
       write(nfout,'("   -- num_conduction_bands_lmm = ",i8)') num_conduction_bands_lmm
       write(nfout,'(" weight (sum_wholeeigenvalues) = ", f8.4, " iband = ",i10)') weight,iband
       write(nfout,'(" weight0 (occup_l)             = ", f8.4)') weight0
       write(nfout,'(" eband_extendedrange = ", f16.8, "   eband = ",f16.8)') eband_extendedrange, eband
    end if
  end subroutine sum_wholeeigenvalues_3D

end module m_Total_Energy

!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 440 $)
!
!  PROGRAM: EPSMAIN
!
!  AUTHOR(S): T. Hamada   MAY/8/2007
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is the main program for caclulating spectra based on the LR-TDDFT .
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.  
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

program LinearResponseMain

  use m_LinearResponse_Control, only : sw_tddft, sw_LinearResponse, sw_LongWaveLimit,&
       &                               xc_kernel_type, ALDA_R, &
       &                               tddft_eqn_type, DYSON, BS
  use m_Control_Parameters,   only : Num_q_Points 

  implicit none

  logical  :: EigenValues_are_Converged, AllKpoints_are_Calculated
  logical  :: Already_Converged
  logical  :: Ending_Time

  logical  :: all_conv = .true.
  logical  :: Additional_EndFlag = .false.

  integer i

!!  write(*,*) 'First  ', Additional_EndFlag

  call Initialization_set_ekmode_ON  ! set `ekmode' ON in m_Control_Parameters
  call Initialization(1)                ! Initialization of mpi and file-setting
  call InputData_Analysis
  Call InputData_Analysis_LR
  if ( sw_LinearResponse==1 )  Call Gen_q_Points

!--
  call Preparation                ! Basis set, symmetry check etc.
  call Preparation_for_mpi(1)           ! mpi

  call PseudoPotential_Construction
  call Ewald_and_Structure_Factor    ! Calculate Structure Factor

  call Initial_Electronic_Structure()! read Charge Density, (lclchh)

  call Initialization_LR

! -------------------------- kokoga memory kuu --
  call Initialization_Spectrum
  if ( sw_LinearResponse==1 ) then
     Call Alloc_WorkArray_LR1
     Call Alloc_WorkArray_LR2
  endif
  Additional_EndFlag = .false.
!
! ------------------------------------- main -----------
  KPOINTS: do
     call KpointNumber_Setting()
     call Preparation_ek             ! (basnum)
     call Preparation_for_mpi_ek     ! mpi  -> np_g1k, mp_g1k
     call PseudoPotential_ek_Epsilon ! (kbint)                  ! Epsilon
     call Initial_WaveFunctions_ek   ! (rndzaj|rdzaj),(fsrfsi),(lclchh)

     if(.not.Already_Converged()) then
        all_conv = .false.
        SolveWaveFunctions: do
           if(Ending_Time())                 exit KPOINTS
           call IterationNumber_Setting()
           call Renewal_of_WaveFunctions()
           if(EigenValues_are_Converged())   exit SolveWaveFunctions
        enddo SolveWaveFunctions
     else
        exit KPOINTS
     end if
     Call Copy_Wfn_etc_To_WorkArray( 0 ) 

     if ( sw_LongWaveLimit==1 ) then
        Call Calc_RhoTilde_LWLimit
        if ( tddft_eqn_type == DYSON .and. xc_kernel_type == ALDA_R ) then
           call Calc_MatrixG_LWLimit
        endif
     else
        call Calc_Band_Q_Nonzero( Additional_EndFlag )
        if ( Additional_EndFlag ) then
           exit KPOINTS
        endif
        Call Calc_RhoTilde_General
        if ( tddft_eqn_type == DYSON .and. xc_kernel_type == ALDA_R ) then
           call Calc_MatrixG_General
        endif
     endif
! ===============================================
100  continue 
!
     if(AllKpoints_are_Calculated())   then
        all_conv = .true.
        exit KPOINTS
     endif

  End do KPOINTS
!  stop
!! ----
  if ( tddft_eqn_type == BS ) then
     Call Calc_Spectrum_Mol
  else
     Call Calc_Spectrum
  endif
  call Free_WorkArray_LR1
! =============
  call Postprocessing(.false.)
  call WriteDownData_onto_Files_ek()
! ---
  call Free_WorkArray_LR2

999 continue

  if ( sw_LinearResponse==1 ) then
     call Finalization_LR
     call Finalization_Spectrum
     Call Del_q_points
  endif
  call Finalization_of_mpi           ! mpi

contains

  subroutine Calc_Band_Q_Nonzero( EndFlag )
    logical, intent(inout) :: EndFlag 
    integer  :: nq

    Do nq=1, Num_Q_Points
!============================================= k - q ======== 
       call KpointNumber_Setting()
       call Preparation_ek             ! (basnum)
       call Preparation_for_mpi_ek     ! mpi  -> np_g1k, mp_g1k
       call PseudoPotential_ek_Epsilon ! (kbint)                  ! Epsilon
       call Initial_WaveFunctions_ek   ! (rndzaj|rdzaj),(fsrfsi),(lclchh)
       
       if(.not.Already_Converged()) then
          all_conv = .false.
          SolveWaveFunctions2: do
             if(Ending_Time())   then
                EndFlag = .true.
                return
             endif
             call IterationNumber_Setting()
             call Renewal_of_WaveFunctions()
             if (EigenValues_are_Converged()) then
                exit SolveWaveFunctions2
             endif
          enddo SolveWaveFunctions2
       else
          ENDFlag = .true.
          return
       end if
       ! --------
       Call Copy_Wfn_etc_To_WorkArray( 1 )
!       write(*,*) 'nk _ in _ the pro d = ', nk_in_the_process, ENDFLAG
    End do
  end subroutine Calc_Band_Q_Nonzero

end program LinearResponseMain

!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 440 $)
!
!  SUBROUINE:  MDiterationNumber_Setting, MDiterationNumber_Setting_ep,
!             IterationNumber_Setting, IterationNumber_Setting_g,
!             KpointNumber_Setting, KpointNumber_Setting2
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!      Further modification by T. Yamasaki   May 2004
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
! $Id: IterationNumbers_Setting.f90 440 2015-08-03 07:18:01Z ktagami $
subroutine MDiterationNumber_Setting
  use m_IterationNumbers,   only : m_Iter_mdIterN_increment&
       &, m_Iter_electronic_reset
  use m_Control_Parameters, only : m_CtrlP_reset_dtim_1Dsearch
  implicit none

  call m_CtrlP_reset_dtim_1Dsearch()
  call m_Iter_mdIterN_increment
  call m_Iter_electronic_reset
end subroutine MDiterationNumber_Setting

subroutine MDiterationNumber_Setting2
  use m_IterationNumbers,   only : m_Iter_mdIterN_increment&
       &, m_Iter_electronic_reset,iteration_electronic,m_Iter_reset_iter_ionic &
       &, m_Iter_unitcell_increment
  use m_Control_Parameters, only : m_CtrlP_reset_dtim_1Dsearch, sw_optimize_lattice,m_CtrlP_reset_iconvergence
  use m_Const_Parameters, only : ON
  implicit none
  if(sw_optimize_lattice==ON)then
     call m_Iter_electronic_reset
     call m_Iter_reset_iter_ionic()
     call m_Iter_unitcell_increment()
     call m_CtrlP_reset_iconvergence()
  endif
end subroutine MDiterationNumber_Setting2

subroutine MDiterationNumber_Setting_ep
  use m_IterationNumbers,   only : m_Iter_mdIterN_increment&
       &                         , m_Iter_total_increment
  implicit none
  call m_Iter_mdIterN_increment()
  call m_Iter_total_increment()
end subroutine MDiterationNumber_Setting_ep

subroutine IterationNumber_Setting
  use m_Control_Parameters,only: icond, ipritiming0&
       &                       , iprijobstatus, jobstatus_series, jobstatus_format
  use m_IterationNumbers, only : m_Iter_electronic_incre &
       &                       , m_Iter_total_increment &
       &                       , iteration, first_iteration_of_this_job &
       &                       , iteration_electronic, iteration_ionic &
       &                       , iteration_unit_cell
  use m_Timing,           only : tstatc_wd, tstatc_wd0, tstatc_init, tstatc_iter &
       &                       , m_Timing_wd_status
  use m_Const_Parameters, only : INITIAL, CONTINUATION &
       &                       , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION &
       &                       , START, ITERATIVE, ON, OFF
  use m_Files,            only : nfstatus,nfout &
       &                       , m_Files_open_nfstatus &
       &                       , m_Files_close_nfstatus &
       &                       , m_Files_skiptoend
  implicit none
  integer :: it, status_wdmode
  logical :: unitcell_can_change

  call tstatc_iter(iteration, first_iteration_of_this_job)
  it = iteration
  if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) it = iteration_electronic
  if(iteration == first_iteration_of_this_job) then
     call tstatc_wd0
     call flush(nfout)
  else
     if(ipritiming0 >= 1) call tstatc_wd(it)
  end if
  call tstatc_init

  if(iprijobstatus >=1 ) then
     call m_Files_open_nfstatus()
     if(iteration == first_iteration_of_this_job) then
        status_wdmode = START
     else
        status_wdmode = ITERATIVE
        if(jobstatus_series == ON) then
           call m_Files_skiptoend(nfstatus)
        else
        end if
     end if
     call m_Timing_wd_status(nfstatus,jobstatus_format,jobstatus_series,status_wdmode &
          & ,iteration,iteration_ionic,iteration_electronic)
     call m_Files_close_nfstatus()
  end if

  call m_Iter_electronic_incre()
  call m_Iter_total_increment()

  if(iprijobstatus >=1 ) then
     if(.not.unitcell_can_change()) then
       write(nfout,'(" ---- iteration(total, ionic, elelctronic) = ",3i8," ----")') &
          & iteration, iteration_ionic, iteration_electronic
     else
       write(nfout,'(" ---- iteration(total, unitcell, ionic, elelctronic) = ",4i8," ----")') &
          & iteration, iteration_unit_cell,iteration_ionic, iteration_electronic
     endif
  end if

end subroutine IterationNumber_Setting

subroutine IterationNumber_Setting_g()
  use m_Control_Parameters,only: icond,ipritiming0
  use m_IterationNumbers, only : iteration, first_iteration_of_this_job &
       &                       , iteration_electronic &
       &                       , m_Iter_total_increment &
       &                       , m_Iter_electronic_incre
  use m_Timing          , only : tstatc_wd, tstatc_wd0, tstatc_init, tstatc_iter
  use m_Const_Parameters, only : INITIAL, CONTINUATION, FIXED_CHARGE, FIXED_CHARGE_CONTINUATION
  implicit none
  integer :: it

  call tstatc_iter(iteration, first_iteration_of_this_job)
  it = iteration
  if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) it = iteration_electronic
  if(iteration_electronic == 0) then
     call tstatc_wd0()
  else
     if(ipritiming0 >= 1) call tstatc_wd(it)
  end if
  call tstatc_init()

  call m_Iter_electronic_incre()
  call m_Iter_total_increment()

end subroutine IterationNumber_Setting_g

subroutine IterationNumber_reset()
  use m_Timing          , only : tstatc_init
  use m_IterationNumbers, only : m_Iter_electronic_reset

  call m_Iter_electronic_reset()
  call tstatc_init()
end subroutine IterationNumber_reset

subroutine KpointNumber_Setting()
  use m_IterationNumbers, only : nk_in_the_process, first_kpoint_in_this_job &
       &                       , iteration_electronic, first_iteration_electronic &
       &                       , m_Iter_nk_incre &
       &                       , m_Iter_wd_electronic &
       &                       , m_Iter_wd_nk &
       &                       , m_Iter_electronic_reset &
       &                       , m_Iter_electronic_set
  use m_Control_Parameters,only: nspin, ipriekzaj, m_CtrlP_ntcnvg_reset
  use m_Files,only             : nfout

! ===================== added by K. Tagami ================== 11.0
  use m_Control_Parameters,   only : noncol, ndim_spinor

  implicit none
! =========================================================== 11.0

  call m_CtrlP_ntcnvg_reset()
! =================================== modified by K. Tagami ======== 11.0
!!  call m_Iter_nk_incre(nspin)
  if ( noncol ) then
    call m_Iter_nk_incre(ndim_spinor)
  else
    call m_Iter_nk_incre(nspin)
  endif
! ================================================================== 11.0

  if(nk_in_the_process == first_kpoint_in_this_job) then
     call m_Iter_electronic_set()
  else
     call m_Iter_electronic_reset()
  end if
  if(ipriekzaj <= 0) call m_Iter_electronic_reset()
  call m_Iter_wd_nk(nfout)
  call m_Iter_wd_electronic(nfout)
  
end subroutine KpointNumber_Setting

subroutine KpointNumber_Setting2()
  use m_IterationNumbers, only : nk_in_the_process, first_kpoint_in_this_job &
       &                       , iteration_electronic, first_iteration_electronic &
       &                       , m_Iter_nk_incre2 &
       &                       , m_Iter_wd_electronic &
       &                       , m_Iter_wd_nk2 &
       &                       , m_Iter_electronic_reset &
       &                       , m_Iter_electronic_set
!!$       &                       , m_Iter_nkgroup_set
  use m_Control_Parameters,only: nspin, ipriekzaj, m_CtrlP_ntcnvg_reset
  use m_Kpoints, only          : kv3, kv3_ek
  use m_Files,only             : nfout

! ===================== added by K. Tagami ================== 11.0
  use m_Control_Parameters,   only : noncol, ndim_spinor

  implicit none
! =========================================================== 11.0

  call m_CtrlP_ntcnvg_reset()

! ======================================= added by K. Tagami ============ 11.0
!  call m_Iter_nk_incre2(nspin,kv3_ek)
  if ( noncol ) then
    call m_Iter_nk_incre2( ndim_spinor,kv3_ek )
  else
    call m_Iter_nk_incre2( nspin,kv3_ek )
  endif
! ====================================================================== 11.0

  if(nk_in_the_process == first_kpoint_in_this_job) then
     call m_Iter_electronic_set()
!!$     call m_Iter_nkgroup_set(kv3)
  else
     call m_Iter_electronic_reset()
  end if
  if(ipriekzaj <= 0) call m_Iter_electronic_reset()
  call m_Iter_wd_nk2(nfout,kv3)
  call m_Iter_wd_electronic(nfout)
  
end subroutine KpointNumber_Setting2

!!$subroutine pIterationNumber_Setting()
!!$  use m_IterationNumbers, only : m_Iter_positron_set()
!!$  implicit none
!!$  call m_Iter_positron_set()
!!$end subroutine pIterationNumber_Setting

!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 440 $)
!
!  PROGRAM: TDLRMAIN
!
!  AUTHOR(S): K. Tagami et al   Aug. 1 2011
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is a collection of subroutines for spectra called in the main program.
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.  
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

!---------------------------------------------------
!!
!!!           Calc Density etc. 
!!
!---------------------------------------------------
subroutine Calc_RhoTilde_General
  use m_LinearResponse_Density,   only : Add_SoftPart_General, Add_HardPart_General
  use m_PseudoPotential,          only : modnrm
  use m_Const_Parameters,         only : EXECUT

  implicit none

  call Add_SoftPart_General
  if ( modnrm == EXECUT ) call Add_HardPart_General
end subroutine Calc_RhoTilde_General

subroutine Calc_RhoTilde_LWLimit
  use m_LinearResponse_Density,   only : Add_SoftPart_LWLimit, Add_HardPart_LWLimit, &
       &                                 Add_Correction_To_G0, Add_KageShira_To_G0
  use m_PseudoPotential,          only : modnrm
  use m_Const_Parameters,         only : EXECUT

  implicit none

  Call Add_SoftPart_LWLimit
  if ( modnrm == EXECUT )  Call Add_HardPart_LWLimit
  Call Add_Correction_To_G0
  Call Add_KageShira_To_G0
end subroutine Calc_RhoTilde_LWLimit

!------------------------------------------------------
!!
!!!      calc  Matrix G ( DYSON, xc_kernel_type == ALDA_R )
!!
!------------------------------------------------------
subroutine Calc_MatrixG_General
  use m_LinearResponse_ALDA,     only : Add_SoftPart_MatG_General

  implicit none

  Call Add_SoftPart_MatG_General
end subroutine Calc_MatrixG_General

subroutine Calc_MatrixG_LWLimit
  use m_LinearResponse_ALDA,     only : Add_SoftPart_MatG_LWLimit

  implicit none

  call Add_SoftPart_MatG_LWLimit

end subroutine Calc_MatrixG_LWLimit

!---------------------------------------------------
!!
!!!           Open/close file for Spectrum  
!!
!---------------------------------------------------
subroutine Open_File_Spectrum
  use m_Files,              only  : m_Files_open_nf_LR
  use m_Parallelization,    only :  mype
  implicit none

  if ( mype == 0 ) call m_Files_open_nf_LR()
end subroutine Open_File_Spectrum

subroutine Close_File_Spectrum
  use m_Files,              only  : m_Files_close_nf_LR
  use m_Parallelization,    only :  mype
  implicit none

  if ( mype == 0 ) call m_Files_close_nf_LR
end subroutine Close_File_Spectrum

!---------------------------------------------------
!!
!!!         Initialize / Finalize Spectrum  
!!
!---------------------------------------------------
subroutine Initialization_Spectrum
  use m_Const_Parameters,           only : Valence_plus_PC_Charge
  use m_LinearResponse_ALDA,        only : m_LR_alloc_Matrix_G, m_LR_alloc_Matrix_T,&
       &                                   m_LR_alloc_RKernels_ALDA, &
       &                                   m_LR_alloc_igfp, m_LR_set_igfp
  use m_LinearResponse_Control,     only : xc_kernel_type, ALDA_R, ALDA_G, &
       &                                   tddft_eqn_type, DYSON, BS
  use m_LinearResponse_Kernel,      only : m_LR_alloc_Coulomb_Kernels, &
       &                                   m_LR_alloc_XC_Kernels
!  use m_LinearResponse_Spectrum,    only : m_LR_alloc_Chi_Head
  use m_LinearResponse_NonInt,      only : m_LR_alloc_Mat_Chi0
  !!use m_LinearResponse_ALDA,        only : m_LR_alloc_igfp, m_LR_set_igfp
  !!use m_LinearResponse_Control,     only : tddft_eqn_type, DYSON, BS
  implicit none

! -------------------------------- start ----------------
  call m_LR_alloc_Coulomb_Kernels
  if ( tddft_eqn_type == DYSON ) call m_LR_alloc_XC_Kernels
  call m_LR_alloc_Mat_Chi0
  !call m_LR_alloc_Chi_Head
  call alloc_chi_head()

  if ( xc_kernel_type == ALDA_R .or. xc_kernel_type == ALDA_G ) then
     call m_LR_alloc_RKernels_ALDA
     call m_LR_alloc_igfp
     call m_LR_set_igfp
  endif
!
  if ( tddft_eqn_type == DYSON .and. xc_kernel_type == ALDA_R ) then
     Call m_LR_alloc_Matrix_G
     Call m_LR_alloc_Matrix_T
  endif
  call set_Coulomb_and_XC_Kernels
  call Open_File_Spectrum
! ------------------------------- end ----------------
end subroutine Initialization_Spectrum

subroutine Finalization_Spectrum
  use m_LinearResponse_ALDA,        only : m_LR_dealloc_Matrix_G, &
       &                                   m_LR_dealloc_Matrix_T, &
       &                                   m_LR_dealloc_RKernels_ALDA, &
       &                                   m_LR_dealloc_igfp
  use m_LinearResponse_Kernel,      only : m_LR_dealloc_Coulomb_Kernels, &
       &                                   m_LR_dealloc_XC_Kernels
  use m_LinearResponse_NonInt,      only : m_LR_dealloc_Mat_Chi0
!  use m_LinearResponse_Spectrum,    only : &
!       &                                   m_LR_dealloc_Chi_Head, &
!       &                                   m_LR_dealloc_MatL
  use m_LinearResponse_Control,     only : xc_kernel_type, ALDA_R, ALDA_G, &
       &                                   tddft_eqn_type, DYSON, BS
  !!use m_LinearResponse_ALDA,        only : m_LR_dealloc_igfp
  use m_LinearResponse_BS,        only : m_LR_dealloc_MatV, &
       &                                   m_LR_dealloc_MatK_ALDA, &
       &                                   m_LR_dealloc_MatXi, &
       &                                   m_LR_dealloc_MatL0 
  !!use m_LinearResponse_Control,     only : tddft_eqn_type, DYSON, BS

  implicit none

! ---------------------------------- start ---------
  Call m_LR_dealloc_Coulomb_Kernels
  if ( tddft_eqn_type == DYSON ) Call m_LR_dealloc_XC_Kernels
  Call m_LR_dealloc_Mat_Chi0
!  Call m_LR_dealloc_Chi_Head
  call dealloc_chi_head()

  if ( xc_kernel_type == ALDA_R .or. xc_kernel_type == ALDA_G ) then
     call m_LR_dealloc_RKernels_ALDA
     call m_LR_dealloc_igfp
  end if
  if ( tddft_eqn_type == DYSON .and. xc_kernel_type == ALDA_R ) then
     call m_LR_dealloc_Matrix_G
     call m_LR_dealloc_Matrix_T
  endif

  if ( tddft_eqn_type == BS ) then
     if ( xc_kernel_type == ALDA_R ) then
        call m_LR_dealloc_MatK_ALDA
     endif
     call m_LR_dealloc_MatV
     call m_LR_dealloc_MatXi
     call m_LR_dealloc_MatL0
!     call m_LR_dealloc_MatL
     call dealloc_matl()
  endif

  call Close_File_Spectrum
! --------------------------------- end -----------
end subroutine Finalization_Spectrum

!---------------------------------------------------
!!
!!!          Calc Spectrum  in the case of DYSON
!!
!---------------------------------------------------
subroutine Calc_Spectrum
!  use m_LinearResponse_Spectrum,    only :  Write_Spectrum_Header, &
!       &                                    Write_Spectrum_Data, &
!       &                                    Calc_Chi_Head, Mat_Chi0, &
!       &                                    set_nband_LR
  use m_LinearResponse_Density,     only : Calc_FermiLevel_ek
  use m_LinearResponse_Control,     only : nrd_efermi, e, nstep, sw_LongWaveLimit, &
       &                                   xc_kernel_type, ALDA_R
  use m_LinearResponse_NonInt,      only : Calc_Chi0_LWLimit, Calc_Chi0_General, &
       &                                   Check_Total_Charge
  use m_Const_Parameters,           only : Hartree, DP, Valence_plus_PC_Charge
  !!$use m_LinearResponse_Control,     only : xc_kernel_type, ALDA_R
  use m_LinearResponse_ALDA,        only : Calc_MatrixT_LWLimit, Calc_MatrixT_General
!
  !!use m_LinearResponse_Spectrum,  only : set_nband_LR
  use m_Files,                      only : nfout

  implicit none

  integer            :: istep
  real(kind=DP)      :: ene
! ------------------------------------ start -------------
  Call Calc_FermiLevel_ek( nrd_efermi )
! --debug
!  Call Check_Total_Charge
!  stop
! --
!  call Write_Spectrum_Header
!  call set_nband_LR
  call write_header()
  call set_nb()
! ------------------------------------- main ---------------
  Do istep=1, nstep
     ene = e(istep)
     if ( sw_LongWaveLimit==1 ) then
        Call Calc_Chi0_LWLimit( ene )
        if ( xc_kernel_type == ALDA_R ) call Calc_MatrixT_LWLimit( ene )
     else
        Call Calc_Chi0_General( ene )
        if ( xc_kernel_type == ALDA_R ) call Calc_MatrixT_General( ene )
     endif
!     Call Calc_Chi_Head( ene )
!     Call Write_Spectrum_Data( ene )
     Call chi_head( ene )
     call write_data(ene)
     write(nfout,*) '! spectrum at ', istep, '-th ( e=', ene ,' ) is finished.'
  End do
end subroutine Calc_Spectrum

!---------------------------------------------------
!!
!!!         Calc Spectrum in the case of BS && ALDA_R
!!
!---------------------------------------------------
subroutine Calc_Spectrum_Mol
!  use m_LinearResponse_Spectrum,    only :  Write_Spectrum_Header, &
!       &                                    Write_Spectrum_Data, &
!       &                                    Calc_Chi_Head, Mat_Chi0, &
!       &                                    set_nband_LR, m_LR_Alloc_MatL, &
!       &                                    Calc_MatL, Calc_Chi_Head_Mol
  use m_LinearResponse_Density,     only : Calc_FermiLevel_ek
  use m_LinearResponse_Control,     only : nrd_efermi, e, nstep, sw_LongWaveLimit, &
       &                                   xc_kernel_type, ALDA_R
  use m_LinearResponse_NonInt,      only : Calc_Chi0_LWLimit, Calc_Chi0_General, &
       &                                   Check_Total_Charge
  use m_Const_Parameters,           only : Hartree, DP, Valence_plus_PC_Charge
  !!$use m_LinearResponse_Control,     only : xc_kernel_type, ALDA_R
!
!  use m_LinearResponse_BS,  only : m_LR_Alloc_MatK_ALDA, m_LR_Alloc_MatV
!  use m_LinearResponse_BS,  only : m_LR_Alloc_MatXi
!  use m_LinearResponse_BS,  only : m_LR_Alloc_MatL0
!  use m_LinearResponse_BS,  only : Calc_MatV, Calc_MatK_ALDA, Calc_MatXi
!  use m_LinearResponse_BS,  only : Calc_MatL0
  use m_LinearResponse_BS,  only : m_LR_Alloc_MatK_ALDA, m_LR_Alloc_MatV &
   ,m_LR_Alloc_MatXi &
   ,m_LR_Alloc_MatL0 &
   ,Calc_MatV, Calc_MatK_ALDA, Calc_MatXi &
   ,Calc_MatL0 &
   ,Check_Charge_on_mesh, Check_exc_energy &
   ,Print_MatV, Print_MatK


  !!use m_LinearResponse_Spectrum,  only : set_nband_LR, m_LR_Alloc_MatL, &
  !!     &                                 Calc_MatL, Calc_Chi_Head_Mol
  use m_Files,                     only : nfout

  !use m_LinearResponse_BS,  only : Check_Charge_on_mesh, Check_exc_energy
  !use m_LinearResponse_BS,  only : Print_MatV, Print_MatK


! --
  implicit none
  integer :: istep
  Real(kind=DP) :: ene
! --------------------------
  Call Calc_FermiLevel_ek( nrd_efermi )
!  Call Check_Total_Charge
!  stop
! --
!  call Write_Spectrum_Header
!  call set_nband_LR
  call write_header()
  call set_nb()
! --
!  Call Check_Charge_on_mesh
!  Call Check_Exc_energy
!  stop

! ------------
  call m_LR_Alloc_MatV
  call Calc_MatV
  if ( xc_kernel_type == ALDA_R ) then
     call m_LR_Alloc_MatK_ALDA
     call Calc_MatK_ALDA
  endif
! --
!!!!!!!!!!!  Call print_MatV
!!!!!!!!!!!!  if ( xc_kernel_type == ALDA_R ) Call print_MatK
!  stop

  call m_LR_Alloc_MatXi
  call Calc_MatXi
!
  call m_LR_Alloc_MatL0
!  call m_LR_Alloc_MatL
  call alloc_matl()
! ------------------------------------- main ---------------
  Do istep=1, nstep
     ene = e(istep)
!     write(*,*) 'istep = ', istep, ene
     call Calc_MatL0( ene )
!     Call Calc_MatL
     call mat_l()
!     call Calc_Chi_Head_Mol( ene )
!     Call Write_Spectrum_Data( ene )
     call chi_head_mol( ene )
     call write_data(ene)
     write(nfout,*) '! spectrum at ', istep, '-th ( e=', ene ,' ) is finished.'
  End do
!
end subroutine Calc_Spectrum_Mol

! -----------------------------------------------------
!!
!!!               set Coulomb + XC Kernels
!!
!-------------------------------------------------------
subroutine set_Coulomb_and_XC_Kernels
  use m_LinearResponse_Control,   only : xc_kernel_type, RPA, ALDA_G, ALDA_R, &
       &                                LRC, LRC_alpha, &
       &                                sw_Coulomb_Screening
  use m_LinearResponse_Kernel,   only : set_Coulomb_Kernel, &
       &                                set_Screened_Coulomb_Kernel, &
       &                                set_XC_Kernel_RPA, &
       &                                set_XC_Kernel_ALDA_G, &
       &                                set_XC_Kernel_ALDA_R, &
       &                                set_XC_Kernel_LRC
  use m_Const_Parameters,         only : Valence_Plus_PC_Charge
  use m_Control_Parameters,       only : xctype

  implicit none

! -------------------------------- start ----------
!  write(*,*) 'xc_type = ',xctype, xc_kernel_type
  if ( sw_Coulomb_Screening==1 ) then
     Call set_Screened_Coulomb_Kernel
  else
     Call set_Coulomb_Kernel
  endif

  select case (xc_kernel_type)
  case (RPA)
     Call set_XC_Kernel_RPA
  case (LRC)
     Call set_XC_Kernel_LRC( LRC_alpha )
  case (ALDA_G)
     Call set_XC_kernel_ALDA_G( Valence_plus_PC_Charge )
  case (ALDA_R)
     Call set_XC_kernel_ALDA_R( Valence_plus_PC_Charge )
  end select

end subroutine set_Coulomb_and_XC_Kernels

subroutine alloc_chi_head()
  use m_LinearResponse_Spectrum,    only : m_LR_alloc_Chi_Head
  call m_LR_alloc_Chi_Head()
end subroutine alloc_chi_head

subroutine dealloc_chi_head()
  use m_LinearResponse_Spectrum, only : m_LR_dealloc_Chi_Head
  Call m_LR_dealloc_Chi_Head
end subroutine dealloc_chi_head

subroutine dealloc_matl()
  use m_LinearResponse_Spectrum, only : m_LR_dealloc_MatL
  call m_LR_dealloc_MatL
end subroutine dealloc_matl

subroutine write_header()
  use m_LinearResponse_Spectrum,    only :  Write_Spectrum_Header
  implicit none
  call Write_Spectrum_Header()
end subroutine write_header

subroutine chi_head(ene)
  use m_Const_Parameters, only : DP
  use m_LinearResponse_Spectrum, only : Calc_Chi_Head
  implicit none
  real(kind=DP), intent(in) :: ene   
  call Calc_Chi_Head(ene)
end subroutine chi_head

subroutine chi_head_mol(ene)
  use m_Const_Parameters, only : DP
  use m_LinearResponse_Spectrum, only : Calc_Chi_Head_Mol
  implicit none
  real(kind=DP), intent(in) :: ene   
  call Calc_Chi_Head_Mol(ene)
end subroutine chi_head_mol

subroutine write_data(ene)
  use m_LinearResponse_Spectrum,    only :  Write_Spectrum_Data
  use m_Const_Parameters, only : DP
  implicit none
  real(kind=DP), intent(in) :: ene
  call Write_Spectrum_Data(ene)
end subroutine write_data

subroutine set_nb()
  use m_LinearResponse_Spectrum, only : set_nband_LR
  implicit none
  call set_nband_LR
end subroutine set_nb

subroutine alloc_matl()
  use m_LinearResponse_Spectrum, only : m_LR_Alloc_MatL
  implicit none
  call m_LR_Alloc_MatL
end subroutine

subroutine mat_l()
  use m_LinearResponse_Spectrum, only : Calc_MatL
  implicit none
  call Calc_MatL
end subroutine mat_l

#ifdef HIUX
*option MP(P(0))
#endif
!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 440 $)
!
!  MODULE: m_BP_Properties
!
!  AUTHOR(S): T. Yamamoto   Oct/01/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_BP_Properties
  ! $ID: $
  !
  ! Properties:
  ! 1. Berry-phase polarization
  !
  !    P_a = -qe/V sum_j Z_ion(j) * r(j)_a - qe/V * f/(2*pi) sum_i A_ia * phi_i
  !
  ! 2. Effective charge tensor
  !
  !    Z_ab = Z_ion + f/(2*pi) sum_i A_ia * d(phi_i)/d(u_b)
  !
  ! 3. piezoelectirc stress tensor
  !
  !    C_ab = f/(2*pi*V) sum_i A_ia * d(phi_i)/d(e_b)
  !
  
  use m_Files, only : nfout
  use m_Control_Parameters, only : polar_prop,nspin,printable, ndim_spinor
  use m_Const_Parameters,   only : DP, PAI, PAI2, ON, OFF &
       &      , POLARIZATION, EFFECTIVE_CHARGE &
       &      , PIEZOELECTRIC_CONST, UNIT_PIEZO_CONST
  use m_Parallelization,    only : mpi_comm_group,mype,npes,ierr

  implicit none
  include 'mpif.h'

  integer, private :: num_berry_phase,max_num_kpoints
  integer, private, allocatable :: num_kpoints(:) ! dim(num_berry_phase)
  integer, private, allocatable :: g_index(:) ! dim(num_berry_phase)
  integer, private, allocatable :: direction(:) ! dim(num_berry_phase) 
  integer, private, allocatable :: displaced_atom(:) ! dim(num_berry_phase)
  ! 1 -> x, 2 -> y, 3 -> z
  real(kind=DP), private, allocatable :: u(:) ! dim(num_berry_phase)

! atomic displacement
  real(kind=DP), private, allocatable :: displacement(:,:) ! dim(3,num_berry_phase)
  complex(kind=DP), private, allocatable :: cphi(:,:,:) ! dim(nkprep_max,nspin,num_berry_phase)
  real(kind=DP), private, allocatable :: wgh(:,:) ! dim(nkprep_max,num_berry_phase)
  real(kind=DP), private, allocatable :: epsstr(:) ! dim(num_berry_phase)
  real(kind=DP), private, allocatable :: posstr(:,:,:) ! dim(natm,3,num_berry_phase)
  integer, private, allocatable :: istrain(:) ! dim(num_berry_phase)

! Properties
  real(kind=DP), allocatable :: zeff(:,:,:) ! dim(3,3,natm)
  real(kind=DP), allocatable :: piezo(:,:) ! dim(3,6)

contains

  subroutine m_BP_read_Berry_phase(paramset)
    use m_Files, only : m_Files_open_nfberry, nfberry
    use m_Ionic_System, only : natm
    implicit none

    logical, intent(in) :: paramset

! local variables
    integer :: i,k,ia,is, ismax
    integer :: idummy
    real(kind=DP) :: dummy,cphi_re,cphi_im,phi
    real(kind=DP) :: d(3),tmp,epstmp(3,3)

    ! debug
    !write(nfout,*) 'DEBUG: reading berry.data (1)'
    ! end debug
       
! === KT_add === 2015/03/23
       ismax = nspin /ndim_spinor
! ============== 2015/03/23

    if(.not.paramset) then
       allocate(num_kpoints(1),g_index(1),displaced_atom(1),displacement(3,1))
       allocate(wgh(1,1))
    else
       ! debug
       !   write(nfout,*) 'DEBUG: num_berry_phase = ',num_berry_phase
       !   write(nfout,*) 'DEBUG: max_num_kpoints = ',max_num_kpoints
       ! end debug
       allocate(num_kpoints(num_berry_phase))
       allocate(g_index(num_berry_phase))
       allocate(displaced_atom(num_berry_phase))
       allocate(displacement(3,num_berry_phase))

       
! === KT_mod === 2015/03/23
!       allocate(cphi(max_num_kpoints,nspin,num_berry_phase))
       allocate(cphi(max_num_kpoints,ismax,num_berry_phase))
! ============== 2015/03/23

       allocate(wgh(max_num_kpoints,num_berry_phase))
       allocate(direction(num_berry_phase))
       allocate(u(num_berry_phase))

       if( polar_prop == PIEZOELECTRIC_CONST ) then
          allocate(istrain(num_berry_phase))
          allocate(epsstr(num_berry_phase))
          allocate(posstr(natm,3,num_berry_phase))
       end if
    end if

    ! debug
    !write(nfout,*) 'DEBUG: reading berry.data (2)'
    ! end debug

    if(mype == 0) then

       if(.not.paramset) max_num_kpoints = 0

       call m_Files_open_nfberry()
       rewind nfberry
       read(nfberry,*) num_berry_phase

       ! debug
       write(nfout,*) 'DEBUG: num_berry_phase = ',num_berry_phase
       call flush(nfout)
       ! end debug

       if(.not.paramset) then
          do i=1,num_berry_phase
             ! debug
             write(nfout,'("m_BP_read_Berry_phase: "i7,"-th berry data is reading.")') i
             call flush(nfout)
             ! end debug
             read(nfberry,*) num_kpoints(1), g_index(1), displaced_atom(1), &
                  &                                     displacement(1:3,1)
             do is=1, ismax
                do k=1,num_kpoints(1)
                   read(nfberry,*) idummy,cphi_re,cphi_im,phi,wgh(1,1)
                end do
             end do
             if(num_kpoints(1) .gt. max_num_kpoints) then
                max_num_kpoints = num_kpoints(1)
             end if
             if( polar_prop == PIEZOELECTRIC_CONST ) then
                do k=1,3
                   read(nfberry,*)
                end do
                read(nfberry,*) idummy
                do k=1,idummy
                   read(nfberry,*)
                end do
             end if
          end do
          ! debug
          write(nfout,*) 'DEBUG: max_num_kpoints = ',max_num_kpoints
          call flush(nfout)
          ! end debug
       else
          do i=1,num_berry_phase
             ! debug
             write(nfout,'("m_BP_read_Berry_phase: "i7,"-th berry data is reading.")') i
             call flush(nfout)
             ! end debug

             read(nfberry,*) num_kpoints(i),g_index(i), displaced_atom(i), &
                  &                                     displacement(1:3,i)

             ! debug
             write(nfout,'("DEBUG: the header was read.")')
             call flush(nfout)
             ! end debug

             if(polar_prop == EFFECTIVE_CHARGE) then
                direction(i) = 1
                u(i) = 0.d0
                do k=1,3
                   if(abs(displacement(k,i)) > 1.d-10) then
                      ! debug
                      !write(nfout,'("m_BP_read_Berry_phase: displacement = ",e25.14)') displacement(k,i)
                      direction(i) = k
                      u(i) = displacement(k,i)
                      !write(nfout,'("m_BP_read_Berry_phase: "i7,"-th data. u=",e25.14)') i,u(i)
                      ! end debug
                   end if
                end do

                d(1:3) = displacement(1:3,i)
                d(direction(i)) = d(direction(i)) - u(i)
                if(abs(sum(d(1:3)**2)) > 1.d-10) then
                   if(printable) then
                      write(nfout,'("Displacement vector of ",i4,"-th atom =",3(1x,f10.5))') &
                           & displaced_atom(i),displacement(1:3,i)
                   end if
                   return
                   !stop 'Error of displacement in <<<m_BP_read_Berry_phase>>>'
                end if
                if(displaced_atom(i) <= 0) direction(i) = -1
             end if

             ! debug
             write(nfout,'("DEBUG: berry phase is reading.")')
             call flush(nfout)
             ! end debug

             do is=1, ismax
                do k=1,num_kpoints(i)
                   read(nfberry,*) idummy,cphi_re,cphi_im,phi,wgh(k,i)
                   cphi(k,is,i) = dcmplx(cphi_re,cphi_im)
                end do
             end do

             if( polar_prop == PIEZOELECTRIC_CONST ) then
                ! debug
                write(nfout,'("DEBUG: strain tensor is reading.")')
                call flush(nfout)
                ! end debug
                read(nfberry,*) epstmp(1,1:3)
                read(nfberry,*) epstmp(2,1:3)
                read(nfberry,*) epstmp(3,1:3)
                call set_istrain(epstmp,istrain(i),epsstr(i))
                read(nfberry,*) idummy
                if(idummy /= natm) then
                   stop 'natm in berry.data differs from natm in PHASE.'
                end if
                do ia=1,natm
                   read(nfberry,*) idummy,posstr(ia,1:3,i)
                end do
             end if
             if(printable) write(nfout,'(i7,"-th berry data was read.")') i
             call flush(nfout)
          end do
       end if

    end if

    if(.not.paramset) then
       deallocate(num_kpoints,g_index,displaced_atom,displacement)
       deallocate(wgh)
    end if

    if(npes > 1) then
       if(.not.paramset) then
          call mpi_bcast(num_berry_phase,1,mpi_integer,0,mpi_comm_group,ierr) ! MPI
          call mpi_bcast(max_num_kpoints,1,mpi_integer,0,mpi_comm_group,ierr) ! MPI
       else
          call mpi_bcast(num_kpoints,num_berry_phase,mpi_integer,0,mpi_comm_group,ierr)
          call mpi_bcast(g_index,num_berry_phase,mpi_double_precision,0,mpi_comm_group,&
               &         ierr) ! MPI
          call mpi_bcast(displaced_atom,num_berry_phase,mpi_integer,0,mpi_comm_group,&
               &         ierr) ! MPI
          call mpi_bcast(displacement,num_berry_phase*3,mpi_double_precision,0,&
               &         mpi_comm_group,ierr) ! MPI
          call mpi_bcast(cphi,max_num_kpoints*ismax*num_berry_phase*2,&
               &         mpi_double_complex,0,mpi_comm_group,ierr) ! MPI
          call mpi_bcast(wgh,max_num_kpoints*num_berry_phase,mpi_double_precision, &
               &         0,mpi_comm_group,ierr) ! MPI
          call mpi_bcast(direction,num_berry_phase,mpi_integer,0,mpi_comm_group,ierr)
          call mpi_bcast(u,num_berry_phase,mpi_double_precision,0,mpi_comm_group,ierr)
       end if
    end if

  contains

    subroutine set_istrain(eps,istrain,str)
      real(kind=DP), intent(in) :: eps(3,3)
      integer, intent(out) :: istrain
      real(kind=DP), intent(out) :: str

      integer :: i
      real(kind=DP) :: dst(6)

      dst(1) = eps(1,1)
      dst(2) = eps(2,2)
      dst(3) = eps(3,3)
      dst(4) = eps(2,3)+eps(3,2)
      dst(5) = eps(3,1)+eps(1,3)
      dst(6) = eps(1,2)+eps(1,2)

      ! debug
      if(printable) then
         write(nfout,*) 'debug: set_istrain'
         do i=1,6
            write(nfout,*) i,dst(i)
         end do
         write(nfout,*) 'end debug: set_istrain'
      end if
      ! end debug

      istrain = 0
      do i=1,6 
         if(abs(dst(i)) > 0.d0) then
            istrain = i
            str = dst(i)
            return
         end if
      end do

    end subroutine set_istrain

  end subroutine m_BP_read_Berry_phase

  subroutine m_BP_get_Berry_phase(atom_id,g_id,dir_id,cphi_out,wgh_out,nkp,u_out,exists)
    implicit none
    integer, intent(in) :: atom_id, g_id, dir_id
    complex(kind=DP), intent(out) :: cphi_out(max_num_kpoints,nspin/ndim_spinor)
    real(kind=DP), intent(out) :: wgh_out(max_num_kpoints)
    integer, intent(out) :: nkp
    real(kind=DP), intent(out) :: u_out
    logical, intent(out) :: exists

! lcoal variables
    integer :: i,k,is, ismax

! === KT_add === 2015/03/23
    ismax = nspin /ndim_spinor
! ============== 2015/03/23

    exists = .false.
    do i=1,num_berry_phase
       ! debug
       !write(6,*) 'atom_id,g_id,dir_id=',atom_id,g_id,dir_id,': i=',i
       ! end debug
       if(displaced_atom(i).eq.atom_id .and. &
            & g_index(i).eq.g_id .and. &
            & direction(i).eq.dir_id) then
          nkp = num_kpoints(i)

          do is=1,ismax
             do k=1,nkp
                cphi_out(k,is) = cphi(k,is,i)
                wgh_out(k) = wgh(k,i)
             end do
          end do
          u_out = u(i)
          exists = .true.
          return
       end if
    end do

    return
  end subroutine m_BP_get_Berry_phase

  subroutine m_BP_calc_diff_Berry_phase(dphi,present_atom)
    use m_Ionic_System, only : natm
    implicit none
    real(kind=DP), intent(out) :: dphi(3,3,natm)
    logical, intent(out) :: present_atom(natm)

! local variables
    integer :: ia,ig,id,k,ia0,is, ismax
    integer :: nkp0,nkp1
    complex(kind=DP) :: cphi0(max_num_kpoints,nspin/ndim_spinor)
    complex(kind=DP) :: cphi1(max_num_kpoints,nspin/ndim_spinor)
    real(kind=DP) :: wgh0(max_num_kpoints)
    real(kind=DP) :: wgh1(max_num_kpoints)
    real(kind=DP) :: phi(max_num_kpoints)
    real(kind=DP) :: u0,u1
!!$logical :: exists
    logical :: exists1, exists2

    present_atom(1:natm) = .false.

! === KT_add === 2015/03/23
    ismax = nspin /ndim_spinor
! ============== 2015/03/23

    ATOM: do ia=1,natm
       do ig=1,3
          ia0 = 0
          id = -1
!!$call m_BP_get_Berry_phase(ia0,ig,id,cphi0,wgh0,nkp0,u0,exists)
!!$if(.not.exists) cycle ATOM
          call m_BP_get_Berry_phase(ia0,ig,id,cphi0,wgh0,nkp0,u0,exists1)
          do id=1,3
!!$call m_BP_get_Berry_phase(ia,ig,id,cphi1,wgh1,nkp1,u1,exists)
!!$if(.not.exists) cycle ATOM
             call m_BP_get_Berry_phase(ia,ig,id,cphi1,wgh1,nkp1,u1,exists2)
             if(.not.(exists1.and.exists2)) cycle
             present_atom(ia) = .true.
             if(nkp0.ne.nkp1) then
                if(printable) then
                   write(nfout,*) 'nkp0=',nkp0
                   write(nfout,*) 'nkp1=',nkp1
                end if
                stop 'nkp0 and nkp1 are different in <<<m_BP_calc_diff_Berry_phase>>'
             end if

             ! debug
             !   write(nfout,*) 'ia,ig,id =',ia,ig,id
             ! end debug

             dphi(id,ig,ia) = 0.d0

             do is=1,ismax
                do k=1,nkp0
                   if(wgh0(k).ne.wgh1(k)) then
                      if(printable) then
                         write(nfout,*) 'wgh0=',wgh0(k)
                         write(nfout,*) 'wgh1=',wgh1(k)
                      end if
                      stop 'wgh0 and wgh1 are different in <<<m_BP_calc_diff_Berry_phase>>'
                   end if
                   phi(k) = dimag(log(cphi1(k,is)/cphi0(k,is)))
                   ! debug
                   !     write(nfout,*) 'k=',k,' phi=',phi(k)
                   ! end debug
                   dphi(id,ig,ia) = dphi(id,ig,ia) + phi(k)*wgh0(k)
                end do
             end do
             ! debug
             !   write(nfout,*) 'ia,id,ig=',id,ig,ia,' dphi=',dphi(id,ig,ia)
             ! end debug
             dphi(id,ig,ia) = 2.d0*dphi(id,ig,ia)/u1
             ! debug
             !   write(nfout,*) 'ia,id,ig=',id,ig,ia,' dphi/u=',dphi(id,ig,ia)
             ! end debug
          end do
       end do
!!$present_atom(ia) = .true.
    end do ATOM
    return

  end subroutine m_BP_calc_diff_Berry_phase

  subroutine m_BP_calc_Polarization()
    use m_Crystal_Structure, only : altv
    use m_Ionic_System, only : natm,ntyp,ityp,cps
    use m_Crystal_Structure, only : univol
    use m_PseudoPotential, only : ival
    implicit none

! local variables
    integer :: i,ia,nkp,is, ismax
    real(kind=DP) :: polar_ion(3), polar_ele(3), polar_tot(3)
    real(kind=DP) :: phi(3)
    real(kind=DP) :: fac

    do ia=1,natm
       polar_ion(1:3) = polar_ion + ival(ityp(ia))*cps(ia,1:3)
    end do
    fac = 2.d0/(PAI2*univol)
    polar_ele(1:3) = 0.d0

! === KT_add === 2015/03/23
    ismax = nspin /ndim_spinor
! ============== 2015/03/23

    do i=1,3
       nkp = num_kpoints(i)
       phi(i) = 0.d0
       do is=1, ismax
          phi(i) = phi(i) +  sum(dimag(log(cphi(1:nkp,is,i)))*wgh(1:nkp,i))
       end do
       polar_ele(1:3) = polar_ele(1:3) + fac*altv(1:3,i)*phi(i)
    end do
    polar_tot(1:3) = polar_ion(1:3) + polar_ele(1:3)

! print polarization
    if(printable) then
       write(nfout,*) ' --- Berry phase ---'
       write(nfout,'("phi =",3(1x,f20.10))') phi(1:3)
       write(nfout,*) ' --- Polarization ---'
       write(nfout,'("P_ion =",3(1x,f20.10))') polar_ion(1:3)
       write(nfout,'("P_ele =",3(1x,f20.10))') polar_ele(1:3)
       write(nfout,'("P_tot =",3(1x,f20.10))') polar_tot(1:3)
    end if

    return
  end subroutine m_BP_calc_Polarization

  subroutine m_BP_calc_Effective_charge()
    use m_Crystal_Structure, only : altv,nopr,op
    use m_Ionic_System, only : natm,ntyp,ityp,cps,napt
    use m_Crystal_Structure, only : univol
    use m_PseudoPotential, only : ival
    use m_Files, only : nfeffchg, m_Files_open_nfeffchg
    use m_Control_Parameters,  only : sw_check_sumrule_born_charge

    implicit none

! local variables
    integer :: i,j,k,ia,ja,iopr
    real(kind=DP) :: dphi(3,3,natm)
    logical :: present_atom(natm)
    real(kind=DP) :: zeff_el(3,3,natm)
    !real(kind=DP) :: zeff(3,3,natm)

    real(kind=DP) :: fac
    real(kind=DP) :: ztmp(3,3)

! == ASMS DEBUG ==
!!!real(kind=DP) :: nsym
    integer :: nsym
! ===============

    real(kind=DP) :: nonzero(3,3)

    if(.not.allocated(zeff)) then
       allocate(zeff(3,3,natm))
       zeff = 0.0d0
    endif

    if( polar_prop == EFFECTIVE_CHARGE ) then

       call m_BP_calc_diff_Berry_phase(dphi,present_atom)
       fac = 1.d0/PAI2
       do ia=1,natm
          if(.not.present_atom(ia)) cycle
          do j=1,3
             do i=1,3
                zeff_el(i,j,ia) = fac*sum(altv(i,1:3)*dphi(j,1:3,ia))
                zeff(i,j,ia) = zeff_el(i,j,ia)
             end do
          end do
          do i=1,3
             zeff(i,i,ia) = zeff(i,i,ia) + ival(ityp(ia))
          end do
       end do

! print electronic effective charges
       if(printable) then
          write(nfout,*) ' --- Calculated electronic effective charges ---'
          do ia=1,natm
             if(.not.present_atom(ia)) cycle
             write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff_el(1,1:3,ia)
             write(nfout,'("Zel (",i3,") = [",3(1x,f10.5),1x,"]")') ia,zeff_el(2,1:3,ia)
             write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff_el(3,1:3,ia)
             write(nfout,*)
          end do

! print effective charges
          write(nfout,*) ' --- Calculated effective charges ---'
          do ia=1,natm
             if(.not.present_atom(ia)) cycle
             write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(1,1:3,ia)
             write(nfout,'("Zeff(",i3,") = [",3(1x,f10.5),1x,"]")') ia,zeff(2,1:3,ia)
             write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(3,1:3,ia)
             write(nfout,*)
          end do
       end if
    else
       call m_BP_read_Effective_charge(zeff,present_atom)
    end if

! Symmetrization
    ATOM: do ia=1,natm
       if(.not.present_atom(ia)) cycle ATOM
       ztmp(1:3,1:3) = 0.d0
       nsym=0
       OPERATION: do iopr=1,nopr
          if(napt(ia,iopr).ne.ia) cycle OPERATION
          nsym=nsym+1
          do j=1,3
             do i=1,3
                do k=1,3
                   ztmp(i,j) = ztmp(i,j)+sum(op(i,1:3,iopr)*zeff(1:3,k,ia))*op(j,k,iopr) 
                end do
             end do
          end do
       end do OPERATION
       zeff(1:3,1:3,ia) = ztmp(1:3,1:3)/nsym
    end do ATOM

! print effective charges
    if(printable) then
       write(nfout,*) ' --- Symmetrized effective charges ---'
       do ia=1,natm
          if(.not.present_atom(ia)) cycle
          write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(1,1:3,ia)
          write(nfout,'("Zsym(",i3,") = [",3(1x,f10.5),1x,"]")') ia,zeff(2,1:3,ia)
          write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(3,1:3,ia)
          write(nfout,*)
       end do
    end if

! calculate effective chareges of equivalent atoms
    ATOM2: do ia=1,natm
       ! debug
       !  print *,'DEGUG: ia=',ia
       if(.not.present_atom(ia)) cycle ATOM2
       OPERATION2: do iopr=1,nopr
          ja = napt(ia,iopr)
          ! debug
          !  print *,'DEGUG: operation iopr=',iopr
          !  print *,'DEGUG: equivalent atom ja=',ja

          if(ja.eq.ia) cycle OPERATION2
          if(present_atom(ja)) cycle OPERATION2
          zeff(1:3,1:3,ja) = 0.d0
          do j=1,3
             do i=1,3
                do k=1,3
                   zeff(i,j,ja) = zeff(i,j,ja) &
                        &        + sum(op(i,1:3,iopr)*zeff(1:3,k,ia))*op(j,k,iopr) 
                end do
             end do
          end do
          present_atom(ja) = .true.
       end do OPERATION2
    end do ATOM2

! print effective charges of all atoms
    if(printable) then
       write(nfout,*) ' --- Effective charges of all atoms ---'
       do ia=1,natm
          write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(1,1:3,ia)
          write(nfout,'("Zeff(",i3,") = [",3(1x,f10.5),1x,"]")') ia,zeff(2,1:3,ia)
          write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(3,1:3,ia)
          write(nfout,*)
       end do
    end if

! === KT_add === 2014/06/30
    if ( sw_check_sumrule_born_charge == OFF ) goto 100
! ============== 2014/06/30

! check zero sum rule
    ztmp(1:3,1:3) = 0.d0
    nonzero(1:3,1:3) = 0
    do ia=1,natm
       do j=1,3
          do i=1,3
             if(dabs(zeff(i,j,ia)).gt.1.d-10) nonzero(i,j)=nonzero(i,j)+1
             ztmp(i,j) = ztmp(i,j) + zeff(i,j,ia)
          end do
       end do
    end do
    do j=1,3
       do i=1,3
          if(nonzero(i,j)==0) nonzero(i,j)=1
       end do
    end do
    ztmp(1:3,1:3) = ztmp(1:3,1:3)/nonzero(1:3,1:3)
! print averaged effective charge
    if(printable) then
       write(nfout,*) ' --- Averaged effective charges ---'
       write(nfout,'("       [",3(1x,f10.5),1x,"]")') ztmp(1,1:3)
       write(nfout,'("Zave = [",3(1x,f10.5),1x,"]")') ztmp(2,1:3)
       write(nfout,'("       [",3(1x,f10.5),1x,"]")') ztmp(3,1:3)
       write(nfout,*)
    end if

! correct effective charges
    do ia=1,natm
       do j=1,3
          do i=1,3
             if(dabs(zeff(i,j,ia)).lt.1.d-10) cycle
             zeff(i,j,ia) = zeff(i,j,ia) - ztmp(i,j)
          end do
       end do
    end do

! print corrected effective charges
    if(printable) then
       write(nfout,*) ' --- Corrected effective charges ---'
       do ia=1,natm
          write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(1,1:3,ia)
          write(nfout,'("Zeff(",i3,") = [",3(1x,f10.5),1x,"]")') ia,zeff(2,1:3,ia)
          write(nfout,'("     ",3x,"    [",3(1x,f10.5),1x,"]")') zeff(3,1:3,ia)
          write(nfout,*)
       end do
    end if

100 continue

! ==== KT_add === 13.1R
    if ( mype == 0 ) then
       call m_Files_open_nfeffchg()

       write(nfeffchg,*) natm
       do ia=1,natm
          write(nfeffchg,'(I6)') ia
          write(nfeffchg,'(3F18.12)') zeff(1,1:3,ia)
          write(nfeffchg,'(3F18.12)') zeff(2,1:3,ia)
          write(nfeffchg,'(3F18.12)') zeff(3,1:3,ia)
       end do
       close( nfeffchg )
    endif
! =============== 13.1R
    return

  end subroutine m_BP_calc_Effective_charge

  subroutine m_BP_read_Effective_charge(zeff,present_atom)
    use m_Ionic_System, only : natm
    use m_Files, only : nfeffchg, m_Files_open_nfeffchg
    implicit none
    real(kind=DP), intent(out) :: zeff(3,3,natm)
    logical, intent(out) :: present_atom(natm)

    integer :: num_zeff
    integer :: i,ia

    if( polar_prop == EFFECTIVE_CHARGE ) return

    present_atom(1:natm) = .false.

    call m_Files_open_nfeffchg()
    if(mype == 0) then
       rewind nfeffchg
       read(nfeffchg,*) num_zeff
       do i=1,num_zeff
          read(nfeffchg,*) ia 
          read(nfeffchg,*) zeff(1,1:3,ia)
          read(nfeffchg,*) zeff(2,1:3,ia)
          read(nfeffchg,*) zeff(3,1:3,ia)
          present_atom(ia) = .true.
       end do
       close( nfeffchg )  !ASMS
    end if

    if(npes>1) then
       call mpi_bcast(zeff,3*3*natm,mpi_double_precision,0,mpi_comm_group,ierr) ! MPI
       call mpi_bcast(present_atom,natm,mpi_logical,0,mpi_comm_group,ierr) ! MPI
    end if

    return
  end subroutine m_BP_read_Effective_charge

  subroutine m_BP_get_Berry_phase_strain(g_id,eps_id,cphi_out,wgh_out,nkp,eps_out, &
       &                                 posstr_out,exists)
    use m_Ionic_System, only : natm
    implicit none
    integer, intent(in) :: g_id, eps_id
    complex(kind=DP), intent(out) :: cphi_out(max_num_kpoints,nspin/ndim_spinor)
    real(kind=DP), intent(out) :: wgh_out(max_num_kpoints)
    integer, intent(out) :: nkp
    real(kind=DP), intent(out) :: eps_out
    real(kind=DP), intent(out) :: posstr_out(natm,3)
    logical, intent(out) :: exists

    integer :: i,k,is, ismax

! === KT_add === 2015/03/23
    ismax = nspin /ndim_spinor
! ============== 2015/03/23

    exists = .false.
    do i=1,num_berry_phase
       if(g_index(i).eq.g_id .and. &
            & istrain(i).eq.eps_id) then
          nkp = num_kpoints(i)

          do is=1,ismax
             do k=1,nkp
                cphi_out(k,is) = cphi(k,is,i)
                wgh_out(k) = wgh(k,i)
             end do
          end do
          eps_out = epsstr(i) 
          posstr_out(1:natm,1:3) = posstr(1:natm,1:3,i)
          exists = .true.
          return
       end if
    end do

  end subroutine m_BP_get_Berry_phase_strain

  subroutine m_BP_calc_diff_Berry_strain(dphi,present_strain)
    use m_Ionic_System, only : natm
    implicit none
    real(kind=DP), intent(out) :: dphi(3,6)
    logical, intent(out) :: present_strain(6)

! local variables
    integer :: ia,ig,id,k,ist,is, ismax
    integer :: nkp0,nkp1
    complex(kind=DP) :: cphi0(max_num_kpoints,nspin/ndim_spinor)
    complex(kind=DP) :: cphi1(max_num_kpoints,nspin/ndim_spinor)
    real(kind=DP) :: wgh0(max_num_kpoints)
    real(kind=DP) :: wgh1(max_num_kpoints)
    real(kind=DP) :: phi(max_num_kpoints,nspin/ndim_spinor)
    real(kind=DP) :: eps0,eps1
    real(kind=DP) :: pos0(natm,3),pos1(natm,3)
    logical :: exists
    real(kind=DP) :: dphi_ion

! === KT_add === 2015/03/23
    ismax = nspin /ndim_spinor
! ============== 2015/03/23

    present_strain(1:6) = .false.

    do ig=1,3
       ist = 0
       call m_BP_get_Berry_phase_strain(ig,ist,cphi0,wgh0,nkp0,eps0,pos0,exists)
       if(.not.exists) cycle
       STRAIN: do ist=1,6
          call m_BP_get_Berry_phase_strain(ig,ist,cphi1,wgh1,nkp1,eps1,pos1,exists)
          if(.not.exists) cycle STRAIN
          present_strain(ist) = .true.
          if(nkp0.ne.nkp1) then
             if(printable) then
                write(nfout,*) 'nkp0=',nkp0
                write(nfout,*) 'nkp1=',nkp1
             end if
             stop 'nkp0 and nkp1 are different in <<<m_BP_calc_diff_Berry_strain>>'
          end if
          ! debug
          !   write(nfout,*) 'ig,ist =',ig,ist
          ! end debug

          dphi(ig,ist) = 0.d0

          do is=1, ismax
             do k=1,nkp0
                if(wgh0(k).ne.wgh1(k)) then
                   if(printable) then
                      write(nfout,*) 'wgh0=',wgh0(k)
                      write(nfout,*) 'wgh1=',wgh1(k)
                   end if
                   stop 'wgh0 and wgh1 are different in <<<m_BP_calc_diff_Berry_strain>>'
                end if
                phi(k,is) = dimag(log(cphi1(k,is)/cphi0(k,is)))

                ! debug
                if(printable) write(nfout,*) 'k=',k,' is=',is,' phi=',phi(k,is)
                ! end debug

                dphi(ig,ist) = dphi(ig,ist) + phi(k,is)*wgh0(k)
             end do
          end do
          dphi(ig,ist) = 2.d0*dphi(ig,ist)

          ! debug
          if(printable) write(nfout,*) 'ig,ist=',ig,ist,' dphi=',dphi(ig,ist)
          ! end debug

          call ionic_part(pos0,pos1,ig,dphi_ion)

          ! debug
          if(printable) then
             write(nfout,*) 'ig,ist=',ig,ist,' dphi_ion=',dphi_ion
             write(nfout,*) 'ig,ist=',ig,ist,' dphi_tot=',dphi_ion+dphi(ig,ist)
             write(nfout,*) 'ig,ist=',ig,ist,' dphi_tot(mod.)=',4.d0*atan(tan(0.25d0*(dphi_ion + dphi(ig,ist))))
          end if
          ! end debug

          dphi(ig,ist) = 4.d0*atan(tan(0.25d0*(dphi_ion + dphi(ig,ist))))/eps1

          ! debug
          if(printable) then
             write(nfout,*) 'ig,ist=',ig,ist,' eps=',eps1
             write(nfout,*) 'ig,ist=',ig,ist,' dphi/eps=',dphi(ig,ist)
          end if
          ! end debug
       end do STRAIN
    end do

  contains

    subroutine ionic_part(pos0,pos1,ig,dphi)
      use m_Crystal_Structure, only : rltv
      use m_PseudoPotential, only : ival
      use m_Ionic_System, only : ityp
      real(kind=DP), intent(in) :: pos0(natm,3) ! internal coordinates
      real(kind=DP), intent(in) :: pos1(natm,3)
      integer, intent(in) :: ig
      real(kind=DP), intent(out) :: dphi

! local variables
      integer :: ia

      dphi = 0.d0
      do ia=1,natm
         dphi = dphi + ival(ityp(ia))*(pos1(ia,ig) - pos0(ia,ig))*PAI2
      end do

    end subroutine ionic_part

  end subroutine m_BP_calc_diff_Berry_strain

  subroutine m_BP_calc_piezoelectric_const
    use m_Crystal_Structure, only : altv
    use m_Ionic_System, only : natm,ntyp,ityp,cps,napt
    use m_Crystal_Structure, only : univol
    implicit none

! local variables
    integer :: i,ia,ist
    real(kind=DP) :: dphi(3,6)
    real(kind=DP) :: fac
    logical :: present_strain(natm)

    if(.not.allocated(piezo)) allocate(piezo(3,6))
    piezo = 0.d0

    if( polar_prop == PIEZOELECTRIC_CONST ) then
       dphi = 0.d0
       call m_BP_calc_diff_Berry_strain(dphi,present_strain)
       fac = 1.d0/(PAI2*univol)
       ! debug
       if(printable) then
          write(nfout,*) 'fac=',fac
          write(nfout,*) 'present_strain=',present_strain(1:6)
       end if
       ! end debug
       do ist=1,6
          if(.not.present_strain(ist)) cycle
          ! debug
          if(printable) then
             write(nfout,*) 'ist=',ist
             write(nfout,'(" dphi=",3(1x,f10.5))') dphi(1:3,ist)
          end if
          ! end debug
 
         do i=1,3
             ! debug
             if(printable) then
                write(nfout,'(" a1i,a2i,a3i=",3(1x,f10.5))') altv(i,1:3)
             end if
             ! end debug
             piezo(i,ist) = fac*sum(altv(i,1:3)*dphi(1:3,ist))
          end do
       end do
    end if

    if(printable) then
       write(nfout,*) '=== Piezoelectric constant (a.u.) ==='
       do ist=1,6
          write(nfout,'(i5,3(1x,f18.10))') ist,piezo(1:3,ist)
       end do
       write(nfout,*) '=== Piezoelectric constant (C/m^2) ==='
       do ist=1,6
          write(nfout,'(i5,3(1x,f18.10))') ist,piezo(1:3,ist)*UNIT_PIEZO_CONST
       end do
    end if

  end subroutine m_BP_calc_piezoelectric_const

end module m_BP_Properties

!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 493 $)
!
!  MODULE: m_XC_Potential
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004, August/23/2006
!                                     September/19/2006
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
! =========== Contributions ===================================
!
! Through the courtesy of contributors, the following functions are added.
!
! Company:  ASMS Co.,Ltd.
! Functions:  [Identifier: 13.0XX]
!                 modified BJ meta-gga functional is implemented (experimental)
!
! =============================================================
!
#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_DO__
#   define __TIMER_DO_START(a)   call timer_sta(a)
#   define __TIMER_DO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_DO_START(a)
#   define __TIMER_DO_STOP(a)
#endif
#ifdef __TIMER_COMM__
#   define __TIMER_COMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_COMM_START(a)       call timer_sta(a)
#   define __TIMER_COMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_COMM_START_w_BARRIER(str,a)
#   define __TIMER_COMM_START(a)
#   define __TIMER_COMM_STOP(a)
#endif

#define XC_PACK_FFT
module m_XC_Potential
! $Id: m_XC_Potential.F90 493 2016-06-01 04:57:01Z ktagami $
!
!  Upgraded on 23rd Aug. 2006 by T. Yamasaki
!    Differentials of the charge density function in GGA calculation are
!    parallelized according to the components of x, y, and z.
!  Upgraded on 19th Sep. 2006 by T. Yamasaki
!    FFTs in GGA calculations are parallelized.
!
  use m_PlaneWaveBasisSet,    only : ngabc,gr_l,igfp_l,kg,kgp,kgp_reduced, ylm_l&
       &                           , m_pwBS_sphrp2
  use m_PlaneWaveBasisSet,    only : m_pwBS_sphrp2_diff
#ifdef _MPIFFT_
  use m_PlaneWaveBasisSet,    only : igfp_l_c
#endif
  use m_PseudoPotential,      only : itpcc,ilmt,ltp,taup,il2p,isph,iqitg,rhpcg_l,qitg_l&
       &                           , rhpcg_diff_l,qitg_diff_l,dl2p &
       &                           , m_PP_include_vanderbilt_pot&
       &                           , m_PP_find_maximum_l,nlmt
  use m_Crystal_Structure,    only : rltv,univol
  use m_Ionic_System,         only : ntyp,natm,iwei,ityp,pos,zfm3_l  
  use m_FFT,                  only : fft_box_size_CD, fft_box_size_CD_c, nfftp &
       &                           , m_FFT_CD_inverse_c &
       &                           , m_FFT_CD_direct_c  &
       &                           , m_FFT_check_of_negative_CD, fft_box_size_CD_nonpara
#ifdef _MPIFFT_
  use m_FFT,                  only : m_FFT_set_cdata  &
       &                           , lx,ly,lz,ly_d,lz_d, ny_d,nz_d
#else
  use m_FFT,                  only : m_FFT_alloc_CD_box &
       &                           , m_FFT_dealloc_CD_box
#endif
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,   only : xctype,len_xctype,ipri,iprixc,nspin,kimg,af,nel_Ylm     &
                                   , sw_hybrid_functional,sw_exchange_only,alpha_exx &
       &                           , sw_screened_exchange,omega_exx_pbe &
       &                           , iprinegativecharge, iprinegativecharge0,sw_output_xc_seperately &
#ifdef ENABLE_ESM_PACK
       &                           , max_warnings_negativecharge,sw_esm
#else
       &                           , max_warnings_negativecharge
#endif
  use m_Const_Parameters,     only : DP,DOWN,UP,Partial_Core_Charge,Valence_plus_PC_Charge &
       &                           , LDA,GGA,PAI,PAI2,VXC_AND_EXC,STRESS_,zi,SKIP, OFF, ON
  use m_Parallelization,      only : mp_kngp,ista_kngp,iend_kngp,npes,mype, ierr &
       &                           , npes_cdfft,nrank_ggacmp, myrank_cdfft, myrank_ggacmp &
       &                           , ista_fftp, iend_fftp, ista_fftph, iend_fftph &
       &                           , nis_fftp, nie_fftp, nel_fftp, idisp_fftp,np_fftp,mp_fftp &
       &                           , nel_fftph, idisp_fftph, nrest_cdfft &
       &                           , mpi_ggacmp_cross_world,mpi_cdfft_world, map_ggacmp &
       &                           , map_pe2ggacmp, map_pe2cdfft, mpi_comm_group &
       &                           , myrank_g, myrank_e, nrank_g, nrank_e
!!$       &                           , ista_sfftp,iend_sfftp,ista_sfftph,iend_sfftph &
!!$       &                           , nis_sfftp,nie_sfftp,nel_sfftp,idisp_sfftp,np_sfftp,mp_sfftp &
!!$       &                 , npes_cdfft,nrank_ggacmp, myrank_cdfft, myrank_ggacmp, max_ggacmp &

! ================================ added by K. Tagami ================ 11.0
  use m_Control_Parameters,    only : noncol, ndim_chgpot, ndim_magmom
  use m_Const_Parameters,      only : Valence_Charge_Only
  use m_ES_NonCollinear,       only : m_ES_cp_VxcR_to_afft, &
       &                              m_ES_DensMat_To_MagMom_Gspace, &
       &                              m_ES_get_Angles_MagMom_Rspace, &
       &                              m_ES_SpinDens_Along_QuantzAxis, &
       &                              m_ES_DensMat_to_MagMom_vlhxcl, &
       &                              m_ES_get_Angles_MagMom_Rspace2, &
       &                              m_ES_cp_VxcR_to_afft2, &
       &                              m_ES_SpinDens_Along_QuantzAxis2,&
       &                              m_ES_Chgsoft_Along_QuantzAxis, &
       &                          m_ES_QuantzAxis_inv_flg_atm, &
       &                          m_ES_Chghard_Along_QuantzAxis, &
       &                          m_ES_GradCorr_Along_QuantzAxis2
  use m_Crystal_Structure,  only : sw_constrain_on_grad_correction
! ==================================================================== 11.0

! ================================ added by K. Tagami ================ 11.0
!!!  use m_PseudoPotential,  only : flg_paw
!!  use m_Charge_Density,   only : magmom_local_now
! ==================================================================== 11.0

! ===== KT_add ====== 13.0XX, 2014/09/19
  use m_Control_Parameters,     only : use_metagga, ekin_density_is_active,oneshot, &
       &                               use_modeled_ekin_density, &
       &                               use_asymm_ekin_density, use_symm_ekin_density, &
       &                               sw_rspace_ekin_density, &
       &                               sw_calc_ekin_density_hardpart, &
       &                               sw_add_ekin_hardpart_on_Gspace
  use m_KineticEnergy_Density,  only : ekins_l, ekina_l, &
       &                               m_KE_set_modeled_ekin_density, &
       &                               m_KE_add_ekindens_hard_rspace
! =================== 13.0XX. 2014/09/19

! === KT_add === 2014/08/04
  use m_Crystal_Structure,  only : sw_neglect_low_vorticity, sw_neglect_low_helicity, &
       &                           sw_monitor_magnetic_vorticity
  use m_ES_Noncollinear,   only : m_ES_add_contrib_to_Vorticity, &
       &                          m_ES_neglect_low_Helicity, &
       &                          m_ES_neglect_low_Vorticity
! ============== 2014/08/04

  implicit none

  include 'mpif.h'
  integer istatus(mpi_status_size)

  real(kind=DP), allocatable, dimension(:,:,:) :: vxc_l    ! d(ista_kngp:iend_kngp,kimg,nspin)  MPI
  real(kind=DP), allocatable, dimension(:,:,:) :: vxco_l   ! d(ista_kngp:iend_kngp,kimg,nspin)  MPI
  real(kind=DP), allocatable, dimension(:,:)   :: vxcpc_l  ! d(ista_kngp:iend_kngp,kimg)        MPI
  real(kind=DP)                                :: exc
  real(kind=DP)                                :: eex, ecor
  real(kind=DP),private,allocatable,dimension(:):: afft        ! d(ista_fftp:iend_fftp)
  real(kind=DP),private,pointer,dimension(:,:)  :: chgrhr_l    ! MPI d(ista_fftph:iend_fftph,ispin)
! GGA arrays
  integer, private,pointer,dimension(:)         :: inx,jnx,knx ! MPI d(ista_fftp:iend_fftp)
  real(kind=DP),private,pointer,dimension(:,:)  :: chden_l         ! MPI d(ista_fftp :iend_fftp)
  real(kind=DP),private,pointer,dimension(:)    :: grad_trho       ! MPI d(ista_fftph:iend_fftph)
  real(kind=DP),private,allocatable,dimension(:,:)  :: grad_rho    ! MPI d(ista_fftph:iend_fftph, nspin)
#ifndef _XC_SAVE_MEMORY_
  real(kind=DP),private,allocatable,dimension(:,:,:):: cgrad_rho ! MPI d(ista_fftph:iend_fftph,3,nspin)
#else
  real(kind=DP),private,allocatable,dimension(:):: cggawk13 ! MPI d(ista_fftph:iend_fftph)
#endif
  real(kind=DP),private,pointer,dimension(:,:)  :: dF_drho,dF_dgradrho ! MPI d(ista_fftph:iend_fftph,nspin)

! ===== KT_add ===== 13.0XX
  real(kind=DP),private,allocatable,dimension(:,:) :: grad2_rho, ekin_dens
                                                 ! MPI d(ista_fftph:iend_fftph,nspin)
! ================== 13.0XX

  real(kind=DP),        allocatable, dimension(:,:) :: s_gga1,s_gga2      ! d(3,3)

  real(kind=DP),private, pointer, dimension(:)      :: grinv,zfcos,zfsin  ! MPI d(ista_kngp:iend_kngp)
  real(kind=DP),private, pointer, dimension(:)      :: flchgq             ! MPI d(nspin)
  real(kind=DP),private, pointer, dimension(:)      :: chgfft             ! MPI d(ista_fftp:iend_fftp)
  real(kind=DP),private, pointer, dimension(:,:)    :: alinvt,g
  real(kind=DP),private, allocatable, dimension(:,:,:) :: drhodh,flchgqd,ylmd
  real(kind=DP),private, pointer, dimension(:)      :: ylm
  real(kind=DP),private, pointer, dimension(:)      :: f2or1 ! MPI d(ista_fftph,iend_fftph)
  real(kind=DP),private, pointer, dimension(:)      :: chgfft_mpi            ! MPI
  logical,      private, dimension(3)               :: lmn_even

!!$  integer, private, allocatable, dimension(:,:)     :: np_send_map_charge2fftbox  ! d(0:npes-1,0:npes-1)
!!$  integer, private, allocatable, dimension(:)       :: ip_map_charge2fftbox ! d(ista_kngp:iend_kngp)
  logical, private                                  :: np_send_is_set = .false.

  integer, allocatable, dimension(:)  :: ip ! d(ista_kngp:iend_kngp,3)
  integer, allocatable, dimension(:,:):: igfp_ijk ! d(ista_kngp:iend_kngp+(0,1),3)
  integer, allocatable, dimension(:,:):: np_send ! d(0:npes-1,0:npes-1)
  real(kind=DP), private :: ecnl = 0.d0

! =================================== added by K. Tagami ============== 11.0
!  integer :: sw_constrain_on_grad_correction = OFF
!  integer :: sw_constrain_on_grad_correction = ON
! ===================================================================== 11.0

!   1. check_of_xctype (function)
!   2. m_XC_alloc_vxc
!   3. m_XC_dealloc_vxc
!   4. cp_vxc_to_vxco
!   5. xc_allocate
!       set_f2or1
!   6. xc_deallocate
!   7. m_XC_alloc_s_gga
!   8. m_XC_dealloc_s_gga
!   9. m_XC_cal_potential
!       ggaxcp, ggaxcp_diff, ggaxcp0, sum_s_gga12, stress_exchange_part
!      ,stress_correlation_part, rhos_diff, rhopc_diff, rhoh_diff, even_case
!      ,odd_case, real_case, complex_case, map_drhodh1, subst_A_into_A_reduced, map_drhodh2
!      ,dgrhodh1, dgrhodh2, gradrho1, gradrho2, allocate_for_stress, deallocate_for_stress
!      ,abs_grad_rho_up_down_total, dFxc_over_ddgradrho, finally_gga_xc_pot
!      ,add_negative_afft_to_grad_rho,G_xyz_afft, dFxc_dgradrho_dot_gradrho
!      ,dFxc_dgradrho_dot_gradrho2, x_dot_cggawk13_into_afft, cp_afft_to_cggawk13
!      ,g_xyz_total_chden_l,add_sq_afft_to_grad_trho,add_sq_afft_to_grad_rho
!      ,g_xyz_chden_l,check_lmn_even
!      ,boundary_zero_into_afft, initialize_cggawk_arrays
!      ,cp_afft_to_cgrad_rho, cp_afft_to_chgrhr, wd_small_part_of_vxc
!      ,wd_small_part_of_afft, map_charge_onto_a_fft_box, set_ispin,cpafft_to_vxc_or_vxcpc
!      ,cpafft
!  10. xcpotf          <-- (9)
!  11. check_of_pcc
!  12. afft_allgatherv

contains
  integer function check_of_xctype()
    if(xctype == 'ggapw91' .or. xctype == 'ldapw91' .or. xctype == 'ggabp  ' &
         & .or. xctype == 'ggapbe ' .or. xctype == 'ldapbe '&
         & .or. xctype == 'ggapbex' .or. xctype == 'vdwdf'  &
         & .or. xctype == 'ggapbey' &
! =========================================== KT_add =============== 13.0A
         & .or. xctype == 'rpbe   ' &
         & .or. xctype == 'wc06   ' &
         & .or. xctype == 'htbs   ' &
! ================================================================== 13.0A
         & .or. xctype == 'revpbe ' &

         & .or. xctype == 'katopbe' .or. xctype == 'ggapbek' ) then
       check_of_xctype = GGA
    else
       check_of_xctype = LDA
    endif

! ==== KT_add ==== 13.0XX
    if ( xctype == "mbj09" ) then
       check_of_xctype = GGA
    endif
! ================ 13.0XX
  end function check_of_xctype

  subroutine m_XC_alloc_vxc
! ============================== modified by K. Tagami =========== 11.0
!    allocate(vxc_l(ista_kngp:iend_kngp,kimg,nspin)); vxc_l = 0.d0
!    allocate(vxco_l(ista_kngp:iend_kngp,kimg,nspin)); vxco_l = 0.d0
!    allocate(vxcpc_l(ista_kngp:iend_kngp,kimg)); vxcpc_l = 0.d0

    if ( noncol ) then
       allocate(vxc_l(ista_kngp:iend_kngp,kimg,ndim_chgpot)); vxc_l = 0.d0
       allocate(vxco_l(ista_kngp:iend_kngp,kimg,ndim_chgpot)); vxco_l = 0.d0
       allocate(vxcpc_l(ista_kngp:iend_kngp,kimg)); vxcpc_l = 0.d0
    else
       allocate(vxc_l(ista_kngp:iend_kngp,kimg,nspin)); vxc_l = 0.d0
       allocate(vxco_l(ista_kngp:iend_kngp,kimg,nspin)); vxco_l = 0.d0
       allocate(vxcpc_l(ista_kngp:iend_kngp,kimg)); vxcpc_l = 0.d0
    endif
! ==================================================================== 11.0
  end subroutine m_XC_alloc_vxc

  subroutine m_XC_dealloc_vxc
!f    deallocate(vxc_l)
!f    deallocate(vxco_l)
!f    deallocate(vxcpc_l)
    if(allocated(vxc_l))     deallocate(vxc_l)
    if(allocated(vxco_l))    deallocate(vxco_l)
    if(allocated(vxcpc_l))   deallocate(vxcpc_l)
  end subroutine m_XC_dealloc_vxc

  subroutine cp_vxc_to_vxco
    vxco_l = vxc_l
  end subroutine cp_vxc_to_vxco

  subroutine xc_allocate(ispin,nfout)
!#ifdef PARA3D
!    use m_Parallelization,      only : np_fftcd_y
!#endif
    integer, intent(in)      :: ispin,nfout

    integer                  :: idp,nlp,nmp,nnp,nd2p,nd3p,ip, idph, nlph
    integer                  :: n, nn, i, j, k
#ifdef _MPIFFT_
    integer                  :: np0, j0, i2, j2, k2, n0
#endif

#ifndef _MPIFFT_
    call m_FFT_alloc_CD_box()
#endif
    allocate(afft(ista_fftp:iend_fftp));afft=0.d0
    allocate(chgrhr_l(ista_fftph:iend_fftph,ispin))    ! MPI
    allocate(f2or1(ista_fftph:iend_fftph))
 
    nlp  = fft_box_size_CD(1,1)
    nmp  = fft_box_size_CD(2,1)
    nnp  = fft_box_size_CD(3,1)
#ifdef _MPIFFT_
    idp  = fft_box_size_CD_c(1,0)
    nd2p = fft_box_size_CD_c(2,0)
    nd3p = fft_box_size_CD_c(3,0)
#else
    idp  = fft_box_size_CD(1,0)
    nd2p = fft_box_size_CD(2,0)
    nd3p = fft_box_size_CD(3,0)
#endif

    call set_f2or1(npes_cdfft,ista_fftph,iend_fftph,f2or1)

    if(check_of_xctype() == GGA) then
       allocate(inx(ista_fftp:iend_fftp)); inx = 0
       allocate(jnx(ista_fftp:iend_fftp)); jnx = 0
       allocate(knx(ista_fftp:iend_fftp)); knx = 0

#ifdef _MPIFFTTESTTEST_
       if(kimg == 1) then
          do n = ista_fftp, iend_fftp
             nn = n
             if(nn == ista_fftp-1) write(nfout,'(" n == ista_fftp-1 = ",i8)') nn
             np0 = nn - idp*ly_d*lz*myrank_cdfft
             i  = mod(np0-1,idp)+1
             j0 = mod((np0-i)/idp,ly_d) + 1
             j  = j0 + ny_d*myrank_cdfft
             k  = (np0-i-(j0-1)*idp)/(idp*ly_d) + 1
             if(i >= idp) i = i - idp
             inx(n) = i - 1;  if(2*inx(n) > nlp) inx(n) = inx(n) - nlp
             jnx(n) = j - 1;  if(2*jnx(n) > nmp) jnx(n) = jnx(n) - nmp
             knx(n) = k - 1;  if(2*knx(n) > nnp) knx(n) = knx(n) - nnp
          end do

!!$          do k = 0, nnp-1
!!$             k2 = k; if(2*k2 > nnp) k2 = k2 - nnp
!!$             do j0 = 0, min(ny_d, nmp-ny_d*myrank_cdfft)-1
!!$                j = j0 + ny_d*myrank_cdfft
!!$                j2 = j; if(2*j2 > nmp) j2 = j2 - nmp
!!$                n0 = 1+j0*idp + k*idp*ly_d + ista_fftp-1
!!$                do i = 0, nlp-1
!!$                   n = i+n0
!!$                   inx(n) = i; if(2*inx(n) > nlp) inx(n) = inx(n) - nlp
!!$                   if(n == ista_fftp-1) write(nfout,'(" n = ista_fftp-1 = ",i8)') n 
!!$                   jnx(n) = j2
!!$                   knx(n) = k2
!!$                end do
!!$             end do
!!$          end do

!!$          do i = 0, nlp-1
!!$             i2 = i; if(2*i2 > nlp) i2 = i2 - nlp
!!$             do j0 = 0, min(ny_d, nmp-ny_d*myrank_cdfft)-1
!!$                j = j0 + ny_d*myrank_cdfft
!!$                j2 = j; if(2*j2 > nmp) j2 = j2 - nmp
!!$                do k = 0, nnp/2
!!$                   n = i+1 + j0*idp + k*idp*ly_d + ista_fftp-1
!!$                   inx(n) = i2
!!$                   jnx(n) = j2
!!$                   knx(n) = k
!!$                end do
!!$                do k = nnp/2+1, nnp-1
!!$                   n = i+1 + j0*idp + k*idp*ly_d + ista_fftp-1
!!$                   inx(n) = i2
!!$                   jnx(n) = j2
!!$                   knx(n) = k - nnp
!!$                end do
!!$             end do
!!$          end do
       else if(kimg == 2) then
          do k = 0, nnp-1
             k2 = k; if(2*k2 > nnp) k2 = k2 - nnp
             do j0 = 0, min(ny_d, nmp-ny_d*myrank_cdfft)-1
                j = j0 + ny_d*myrank_cdfft
                j2 = j; if(2*j2 > nmp) j2 = j2 - nmp
                do i = 0, nlp/2
                   n = i+1 + j0*idp + k*idp*ly_d
                   nn = n*2-1 + ista_fftp-1
                   inx(nn) = i ; inx(nn+1) = i
                   jnx(nn) = j2; jnx(nn+1) = j2
                   knx(nn) = k2; knx(nn+1) = k2
                end do
                do i = nlp/2+1, nlp-1
                   n = i+1 + j0*idp + k*idp*ly_d
                   nn = n*2-1 + ista_fftp-1
                   inx(nn) = i-nlp ; inx(nn+1) = i-nlp
                   jnx(nn) = j2; jnx(nn+1) = j2
                   knx(nn) = k2; knx(nn+1) = k2
                end do
             end do
          end do
       end if
#else
       do n = ista_fftp, iend_fftp
          nn = (n+kimg-1)/kimg    ! nn = n (when kimg=1), nn = (n+1)/2 (when kimg=2)
#ifdef _MPIFFT_
!!$          if(nn == ista_fftp-1) write(nfout,'(" n == ista_fftp-1 = ",i8)') nn
          np0 = nn - idp*ly_d*lz*myrank_cdfft
          i  = mod(np0-1,idp)+1
          j0 = mod((np0-i)/idp,ly_d) + 1
          j  = j0 + ny_d*myrank_cdfft
          k  = (np0-i-(j0-1)*idp)/(idp*ly_d) + 1
          if(i >= idp) i = i - idp
#else
          i  = mod(nn,idp)
          j  = mod((nn-1)/idp,nd2p) + 1
          k  = (nn - (j-1)*idp - i)/(idp*nd2p) + 1
#endif
          inx(n) = i - 1;  if(2*inx(n) > nlp) inx(n) = inx(n) - nlp
          jnx(n) = j - 1;  if(2*jnx(n) > nmp) jnx(n) = jnx(n) - nmp
          knx(n) = k - 1;  if(2*knx(n) > nnp) knx(n) = knx(n) - nnp
       end do
#endif

! =============================== modified by K. Tagami ================ 11.0
!       allocate(chden_l(ista_fftp:iend_fftp,nspin)); chden_l = 0.d0 ! MPI
!       allocate(grad_trho(ista_fftph:iend_fftph))                   ! MPI
!       allocate(grad_rho(ista_fftph:iend_fftph,nspin)); grad_rho = 0.d0  ! MPI

       if ( noncol .and. sw_constrain_on_grad_correction == OFF ) then
          allocate(chden_l(ista_fftp:iend_fftp,ndim_magmom)); chden_l = 0.d0
          allocate(grad_trho(ista_fftph:iend_fftph))
          allocate(grad_rho(ista_fftph:iend_fftph,nspin)); grad_rho = 0.d0
       else
          allocate(chden_l(ista_fftp:iend_fftp,nspin)); chden_l = 0.d0 ! MPI
          allocate(grad_trho(ista_fftph:iend_fftph))                   ! MPI
          allocate(grad_rho(ista_fftph:iend_fftph,nspin)); grad_rho = 0.d0  ! MPI
       endif
! ======================================================================= 11.0

#ifndef _XC_SAVE_MEMORY_
       if(nrank_ggacmp > 1) then
          allocate(cgrad_rho(ista_fftph:iend_fftph,myrank_ggacmp+1:myrank_ggacmp+1,nspin))  ! MPI
       else
          allocate(cgrad_rho(ista_fftph:iend_fftph,3,nspin))  ! MPI
       end if
       cgrad_rho =0.d0
#else
       allocate(cggawk13(ista_fftph:iend_fftph))           ! MPI
#endif
       allocate(dF_drho(ista_fftph:iend_fftph,nspin))      ! MPI
       dF_drho = 0.d0
       allocate(dF_dgradrho(ista_fftph:iend_fftph,nspin))  ! MPI
       dF_dgradrho = 0.d0
    end if

! ====== KT_add ======== 13.0XX
    if ( use_metagga ) then
       allocate( ekin_dens(ista_fftph:iend_fftph,nspin) ); ekin_dens = 0.0d0
       allocate( grad2_rho(ista_fftph:iend_fftph,nspin) ); grad2_rho = 0.0d0
    endif
! ====================== 13.0XX

  contains
    subroutine set_f2or1(npes,ista,iend,f2or1)
      integer, intent(in) :: npes,ista, iend
      real(kind=DP), intent(out), dimension(ista:iend) :: f2or1
      integer :: idph,nlph,ip,i,j,k

      if(kimg == 1) then
         idph = idp/2
         nlph = nlp/2
#ifdef _MPIFFT_

         f2or1 = 0.d0
!!$         do j = 1, min(nz_d,nnp-nz_d*myrank_cdfft)*nmp
!!$         do j = 1, min(nz_d,nnp-nz_d*myrank_cdfft)*nd2p
         do k = 1, min(nz_d, nnp-nz_d*myrank_cdfft)
            do j = 1, nmp
               do i = 1, nlph
!!$                  ip = i + idph*(j-1) + idph*ly*lz_d*myrank_cdfft
                  ip = i + idph*(j-1) + idph*ly*(k-1) + idph*ly*lz_d*myrank_cdfft
                  f2or1(ip) = 2.d0
               end do
               ip = 1 + idph*(j-1) + idph*ly*(k-1) + idph*ly*lz_d*myrank_cdfft
               f2or1(ip) = 1.d0
               ip = nlph+1 + idph*(j-1) + idph*ly*(k-1) + idph*ly*lz_d*myrank_cdfft
               f2or1(ip) = 1.d0
            end do
         end do
!!$            ip = idph*(j-1) + 1 + idph*ly*lz_d*myrank_cdfft
!!$            f2or1(ip) = 1.d0
!!$            ip = idph*(j-1)+ nlph + 1 + idph*ly*lz_d*myrank_cdfft
!!$            f2or1(ip) = 1.d0
!!$         end do
#else
         f2or1 = 2.d0
         if(npes >= 2) then
            do i = 1, nd2p*nnp
               ip = idph*(i-1) + 1
               if(ip>= ista .and. ip <= iend) f2or1(ip) = 1.d0
            end do
            do i = 1, nd2p*nnp
               ip = idph*(i-1) + nlph + 1
               if(ip>= ista .and. ip <= iend) f2or1(ip) = 1.d0
            end do
            do j = nlph+2, idph
               do i = 1,nd2p*nnp
                  ip = idph*(i-1)+j
                  if(ip>= ista .and. ip <= iend) f2or1(ip) = 0.d0
               end do
            end do
            do j = nmp+1, nd2p
               do k = 1, nnp
                  do i = 1, nlph
                     ip = i + idph*(j-1) + idph*nd2p*(k-1)
                     if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
                  end do
               end do
            end do
! for SX6 ASL 20040817
            do k = nnp+1, nd3p
               do i = 1, idph*nd2p
                  ip = i + idph*nd2p*(k-1)
                  if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
               end do
            end do
         else
            do i = 1, nd2p*nnp
               ip = idph*(i-1) + 1
               f2or1(ip) = 1.d0
            end do
            do i = 1, nd2p*nnp
               ip = idph*(i-1) + nlph + 1
               f2or1(ip) = 1.d0
            end do
            do j = nlph+2, idph
               do i = 1,nd2p*nnp
                  ip = idph*(i-1)+j
                  f2or1(ip) = 0.d0
               end do
            end do
            do j = nmp+1, nd2p
               do k = 1, nnp
                  do i = 1, nlph
                     ip = i + idph*(j-1) + idph*nd2p*(k-1)
                     f2or1(ip) = 0.d0
                  end do
               end do
            end do
! for SX6 ASL 20040817
            do k = nnp+1, nd3p
               do i = 1, idph*nd2p
                  ip = i + idph*nd2p*(k-1)
                  f2or1(ip) = 0.d0
               end do
            end do
         end if
!!$       do i = ista, iend
!!$          if(mod(i*2,idp) == 2 .or. mod(i*2,idp) == 0) f2or1(i) = 1.d0
!!$       end do
#endif
      else
#ifdef _MPIFFT_
!!$         f2or1 = 0.d0                               ! f2or1 works to the fft data in R space.
!!$         do k = 1, min(nz_d,nnp-nz_d*myrank_cdfft)
!!$            do j = 1, nmp     ! nmp = fft_box_size_CD(2,1)
!!$               do i = 1, nlp  ! nlp = fft_box_size_CD(1,1)
!!$                  ip = i+(j-1)*idp+(k-1)*idp*nd2p+idp*nd2p*lz_d*myrank_cdfft
!!$                  f2or1(ip) = 1.d0
!!$               end do
!!$            end do
!!$         end do
         if(iprixc >= 2 ) write(nfout,'(" ix kimg = 2 <<set_f2or1>>")')
         f2or1 = 1.d0
         do j = nlp+1, idp      ! x
            do i = 1, ly*nz_d
               ip = idp*(i-1)+j+ista-1
               f2or1(ip) = 0.d0
            end do
         end do
         if(iprixc >= 2 ) write(nfout,'(" iy kimg = 2 <<set_f2or1>>")')
         do j = nmp+1,ly         ! y
            do k = 1, nz_d
               do i = 1, nlp
                  ip = i + idp*(j-1) + idp*ly*(k-1) + ista-1
                  f2or1(ip) = 0.d0
               end do
            end do
         end do
         if(iprixc >= 2 ) write(nfout,'(" iz kimg = 2 <<set_f2or1>>")')
         do  k = nz_d+1, lz_d   ! z
            do i = 1, idp*ly
               ip = i + idp*ly*(k-1) + ista-1
               f2or1(ip) = 0.d0
            end do
         end do
#else
         f2or1 = 1.d0
         if(npes >= 2) then
            do j = nlp+1, idp    ! x
               do i = 1, nd2p*nnp
                  ip = idp*(i-1)+j
                  if(ip>= ista .and. ip <= iend) f2or1(ip) = 0.d0
               end do
            end do
            do j = nmp+1, nd2p   ! y
               do k = 1, nnp
                  do i = 1, nlp
                     ip = i + idp*(j-1) + idp*nd2p*(k-1)
                     if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
                  end do
               end do
            end do
! for SX6 ASL 20040817
            do k = nnp+1, nd3p   ! z
               do i = 1, idp*nd2p
                  ip = i + idp*nd2p*(k-1)
                  if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
               end do
            end do
         else
            do j = nlp+1, idp    ! x
               do i = 1, nd2p*nnp
                  ip = idp*(i-1)+j
! ================================ modifed by K. Tagami ====( uncertain )== 11.0
!                  f2or1(ip) = 0.d0
                  if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
! ===================================================================== 11.0
               end do
            end do
            do j = nmp+1, nd2p   ! y
               do k = 1, nnp
                  do i = 1, nlp
                     ip = i + idp*(j-1) + idp*nd2p*(k-1)
! ================================ modifed by K. Tagami ====( uncertain )== 11.0
!                     f2or1(ip) = 0.d0
                     if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
! ===================================================================== 11.0
                  end do
               end do
            end do
! for SX6 ASL 20040817
            do k = nnp+1, nd3p   ! z
               do i = 1, idp*nd2p
                  ip = i + idp*nd2p*(k-1)
! ================================ modifed by K. Tagami ====( uncertain )== 11.0
!                  f2or1(ip) = 0.d0
                  if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
! ===================================================================== 11.0
               end do
            end do
         end if
#endif
      end if
    end subroutine set_f2or1
  end subroutine xc_allocate

  subroutine xc_deallocate
#ifndef _MPIFFT_
    call m_FFT_dealloc_CD_box()
#endif
    deallocate(afft)
    deallocate(chgrhr_l)
    deallocate(f2or1)

    if(check_of_xctype() == GGA) then
       deallocate(inx); deallocate(jnx); deallocate(knx)
       deallocate(chden_l)
       deallocate(grad_trho)
#ifndef _XC_SAVE_MEMORY_
       deallocate(cgrad_rho)
#else
       deallocate(cggawk13)
#endif
       deallocate(grad_rho); deallocate(dF_drho)
       deallocate(dF_dgradrho)
    end if

! ====== KT_add ======== 13.0XX
    if ( use_metagga ) then
       deallocate( ekin_dens )
       deallocate( grad2_rho )
    endif
! ====================== 13.0XX
  end subroutine xc_deallocate

  subroutine m_XC_alloc_s_gga
    allocate(s_gga1(3,3)); s_gga1=0.d0
    allocate(s_gga2(3,3)); s_gga2=0.d0
  end subroutine m_XC_alloc_s_gga

  subroutine m_XC_dealloc_s_gga
    deallocate(s_gga1)
    deallocate(s_gga2)
  end subroutine m_XC_dealloc_s_gga

  subroutine m_XC_cal_potential(nfout,input_charge,chgq_l, vflag  &
    &  , chgsoft,hsr,hsrd)
!   Upgraded on 19th Sep. 2006 by T. Yamasaki
!     * MPIFFT
    integer, intent(in) :: nfout, input_charge

! =================================== modified by K. Tagami =============== 11.0
!    real(DP),intent(in) :: chgq_l(ista_kngp:iend_kngp,kimg,nspin)
    real(DP),intent(in) :: chgq_l(ista_kngp:iend_kngp,kimg,ndim_magmom )
! ========================================================================= 11.0
    !                                    charge density
    integer, intent(in) :: vflag

! ================================== modified by K. Tagami ================ 11.0
!    real(DP),intent(in),optional,dimension(ista_kngp:iend_kngp,kimg,nspin) &
!         &              :: chgsoft  ! soft charge density
!    real(DP),intent(in),optional,dimension(natm,nlmt,nlmt,nspin)     :: hsr
!    real(DP),intent(in),optional,dimension(natm,nlmt,nlmt,nspin,3,3) :: hsrd
!
    real(DP),intent(in),optional,dimension(ista_kngp:iend_kngp,kimg,ndim_magmom) &
         &              :: chgsoft  ! soft charge density
    real(DP),intent(in),optional,dimension(natm,nlmt,nlmt,ndim_magmom)     :: hsr
    real(DP),intent(in),optional,dimension(natm,nlmt,nlmt,ndim_magmom,3,3) :: hsrd
!
! ========================================================================== 11.0

! ================================== added by K. Tagami ================== 11.0
    Real(kind=DP), allocatable :: RhoMag_G(:,:,:)
    Real(kind=DP), allocatable :: RhoMag_R(:,:)
    Real(kind=DP), allocatable :: Rot_Angles(:,:)
    Real(kind=DP), allocatable :: bfft_kt(:,:)
    Real(kind=DP), allocatable :: bfft(:)
    integer, allocatable :: quantz_axis_inversion_flg_mesh(:)
! ======================================================================== 11.0

! ================================== added by K. Tagami ================== 11.0
!!!!!    integer, allocatable :: quantz_axis_inversion_flg_atm(:)
    real(kind=DP), allocatable :: chgsoft_projected_on_Gspace(:,:,:)
    real(kind=DP), allocatable :: chgsoft_on_Rspace(:,:)
    real(kind=DP), allocatable :: chgsoft_along_QuantzAxis(:,:)
    real(kind=DP), allocatable :: hsr_along_QuantzAxis(:,:,:,:)
    real(kind=DP), allocatable :: hsrd_along_QuantzAxis(:,:,:,:,:,:)
! ======================================================================= 11.0

! ==== KT_add === 2014/08/04
    Real(kind=DP), allocatable :: MagVorticity(:,:)
! =============== 2014/08/04

    integer       :: ispin, iloop, i
    logical       :: nopcc
    real(kind=DP) :: rinplw
    integer       :: id_sname = -1
    call tstatc0_begin('m_XC_cal_potential ',id_sname,level=1)

    rinplw = 1.d0/product(fft_box_size_CD(1:3,1))

    if(input_charge == Partial_Core_Charge) then
       if(iprixc >= 1) write(nfout, '(" input_charge == Partial_Core_Charge")')
       call check_of_pcc(nopcc)
       if(nopcc) goto 4001
    endif

! ============================= added by K. Tagami ================== 11.0
    if ( noncol ) then
      if ( input_charge == Valence_plus_PC_Charge ) then
!        allocate( Rot_Angles(ista_fftph:iend_fftph,2 )) ; Rot_Angles = 0.0d0
        call check_of_pcc(nopcc)
      endif
    endif
! ===================================================================== 11.0
    call set_ispin(ispin)
          if(iprixc >= 2) write(nfout,*) ' ! ispin = ', ispin
    call xc_allocate(ispin,nfout)

! ========================== modified by K. Tagami ==================== 11.0
!    do iloop = 1, ispin
!       if(iprixc >= 2) write(nfout,'(" ! (m_XC_cal_potential) , iloop = ",i5)') iloop
!#ifdef _OLD_MAP_CHARGE_
!       call map_charge_onto_a_fft_box(chgq_l)     !-(m_XC_Pot.) -> afft(*) (xcchg2)
!#else
!       call map_charge_onto_a_fft_box2(nfout,chgq_l)     !-(m_XC_Pot.) -> afft(*) (xcchg2)
!#endif
!             if(iprixc >= 2) write(nfout,*) " just after map_charge_onto_a_fft_box "
!             if(iprixc >= 2) call wd_small_part_of_afft(7,'G space',120)
!             if(iprixc >= 2) then
!                write(nfout,'(" ista_fftp, iend_fftp, np_fftp, mp_fftp = ",4i8)') &
!                     & ista_fftp, iend_fftp, np_fftp, mp_fftp
!             end if
!       if(check_of_xctype() == GGA) then
!          chden_l(ista_fftp:iend_fftp,iloop) = afft(ista_fftp:iend_fftp)
!       end if
!       if(myrank_ggacmp < nrank_ggacmp) then
!          call m_FFT_CD_inverse_c(nfout,afft)  ! afft(G_sp.) -> afft(R_sp.)
!             if(iprixc >= 2) call wd_small_part_of_afft(7,'R space',120)
!          call m_FFT_check_of_negative_CD(npes_cdfft,ista_fftp,iend_fftp&
!               & ,ista_fftph,iend_fftph,afft,nfout,nspin,iloop)
!       else
!          call m_FFT_CD_inverse_c(nfout,afft,mode=0)
!       end if
!!!$       if(npes > 1 .and. max_ggacmp >= nrank_ggacmp) call mpi_barrier(mpi_comm_group,ierr)
!       if(iprixc >= 2) write(nfout,'(" ! out of m_FFT_check_of_negative_CD <<m_XC_cal_potential>>")')
!
!       call cp_afft_to_chgrhr        ! -(contained here) afft -> chgrhr_l
!    end do

    if ( noncol ) then
!!!!!      call set_chgrhr_case_noncollinear

       if ( sw_constrain_on_grad_correction == ON ) then
          call set_chgrhr_case_noncollinear2
       else
          call set_chgrhr_case_noncollinear3
       endif
    else
      call set_chgrhr_case_collinear( ispin )
    endif

! --
!    write(nfout,*) 'chden_l'
!    Do i=ista_fftp, iend_fftp
!       write(nfout,*) i, chden_l(i,1), chden_l(i,2)
!   End do
!   stop
! ======================================================================== 11.0
! ======================================================================== 11.0

! ==== KT_add ==== 13.0XX, 2014/09/19
    if ( use_metagga .and. .not. use_modeled_ekin_density ) then
       if ( noncol ) then
       else
          if ( use_asymm_ekin_density ) then
             call set_ekindens_case_collinear( ispin, ekina_l, ekin_dens )
                         ! (asymmetric) ekin_l (G) -> ekin_dens (R)
          else if ( use_symm_ekin_density ) then
             call set_ekindens_case_collinear( ispin, ekins_l, ekin_dens )
                         ! (symmetric) ekin_l (G) -> ekin_dens (R)
             if ( sw_rspace_ekin_density == ON &
                  &        .and. sw_calc_ekin_density_hardpart == ON &
                  &        .and. sw_add_ekin_hardpart_on_Gspace == OFF ) then
                call m_KE_add_ekindens_hard_rspace( ekin_dens )
             endif
          endif
       endif
    endif
! ================= 13.0XX, 2014/09/19

    call check_lmn_even  ! -(contained in subr. m_XC_cal_potential) ->lmn_even

    if(check_of_xctype() == GGA) then
       if(vflag == STRESS_) then
          call ggaxcp_diff           ! -(contained here) ->chgrhr,exc,etc.
          !    ~~~~~~~~~~~
       else
          call ggaxcp()              ! -(contained here) ->chgrhr,exc
          !    ~~~~~~
       endif
    else
       call xcpotf(ispin,input_charge) ! -(m_XC_Potential) ->chgrhr,exc
       !    ~~~~~~
    end if
    if(vflag == VXC_AND_EXC .or. vflag == STRESS_) then
! ======================= modified by K. Tagami ====================== 11.0
!       do iloop = 1, ispin
!          if(myrank_ggacmp < nrank_ggacmp) then
!             call cpafft(iloop)                     ! chgrhr_l -> afft
!             call m_FFT_CD_direct_c(nfout,afft)     ! afft(R space) -> afft(G sp.)
!          else
!             call m_FFT_CD_direct_c(nfout,afft,mode=0)
!          end if
!             if(iprixc >= 2) call wd_small_part_of_afft(7,'G space',120)
!             if(npes > 1) call mpi_barrier(mpi_comm_group,ierr)
!          call cpafft_to_vxc_or_vxcpc(iloop)      ! -> vxc_l, vxcpc_l
!       end do
!       if(iprixc >= 2) call wd_small_part_of_vxc
!
        if ( noncol ) then
!!!!!          call set_vxc_case_noncollinear
          call set_vxc_case_noncollinear2
        else
          call set_vxc_case_collinear(ispin)
        endif
! ===================================================================== 11.0
    end if

    call xc_deallocate

! ============================= added by K. Tagami ================== 11.0
    if ( noncol ) then
!       deallocate( Rot_Angles )
    endif
! ===================================================================== 11.0

! ==== KT_add === 2014/08/04
    if ( noncol .and. sw_monitor_magnetic_vorticity == ON ) then
       if ( allocated( MagVorticity) ) deallocate( MagVorticity)
    endif
! =============== 2014/08/04

4001 continue

    call tstatc0_end(id_sname)
  contains

! ============================== added by K. Tagami ================ 11.0
    subroutine set_chgrhr_case_collinear( ispin )
      integer, intent(in) :: ispin
      integer :: iloop

      do iloop = 1, ispin
         if(iprixc >= 2) write(nfout,'(" ! (m_XC_cal_potential) , iloop = ",i5)') iloop
#ifdef _OLD_MAP_CHARGE_
         call map_charge_onto_a_fft_box( chgq_l, nspin, iloop, input_charge )
	                                     !-(m_XC_Pot.) -> afft(*) (xcchg2)
#else
         call map_charge_onto_a_fft_box2( nfout, chgq_l, nspin, iloop, &
	&                                 input_charge )
                                              !-(m_XC_Pot.) -> afft(*) (xcchg2)
#endif
         if(iprixc >= 2) write(nfout,*) " just after map_charge_onto_a_fft_box "
         if(iprixc >= 2) call wd_small_part_of_afft(7,'G space',120)
         if(iprixc >= 2) then
            write(nfout,'(" ista_fftp, iend_fftp, np_fftp, mp_fftp = ",4i8)') &
                     & ista_fftp, iend_fftp, np_fftp, mp_fftp
         end if
         if(check_of_xctype() == GGA) then
            chden_l(ista_fftp:iend_fftp,iloop) = afft(ista_fftp:iend_fftp)

         end if

         if(myrank_ggacmp < nrank_ggacmp) then
            call m_FFT_CD_inverse_c(nfout,afft)  ! afft(G_sp.) -> afft(R_sp.)
            if(iprixc >= 2) call wd_small_part_of_afft(7,'R space',120)
            call m_FFT_check_of_negative_CD(npes_cdfft,ista_fftp,iend_fftp&
               & ,ista_fftph,iend_fftph,afft,nfout,nspin,iloop)
         else
            call m_FFT_CD_inverse_c(nfout,afft,mode=0)
         end if
!!$       if(npes > 1 .and. max_ggacmp >= nrank_ggacmp) call mpi_barrier(mpi_comm_group,ierr)
         if(iprixc >= 2) write(nfout,'(" ! out of m_FFT_check_of_negative_CD <<m_XC_cal_potential>>")')

         call cp_afft_to_chgrhr(iloop)        ! -(contained here) afft -> chgrhr_l
      end do
    end subroutine set_chgrhr_case_collinear

    subroutine set_chgrhr_case_noncollinear3
      integer :: iloop
! --
      allocate( RhoMag_R(ista_fftph:iend_fftph,ndim_magmom)) ; RhoMag_R = 0.0d0
! --------------------------------------------
! 1) calc pcc
! -------------------------------------------
      if ( .not. nopcc ) then
         allocate( bfft(ista_fftp:iend_fftp) ); bfft = 0.0d0
#ifdef _OLD_MAP_CHARGE_
         call map_charge_onto_a_fft_box( chgq_l, ndim_magmom, 1, Partial_Core_Charge )
#else
         call map_charge_onto_a_fft_box2( nfout, chgq_l, ndim_magmom, 1, &
              &                           Partial_Core_Charge )
#endif
         bfft = afft
      endif
! --------------------------------------------
! 2) add valence contribution
! -------------------------------------------
      Do iloop = 1, ndim_magmom
         afft = 0.0d0
#ifdef _OLD_MAP_CHARGE_
         call map_charge_onto_a_fft_box( chgq_l, ndim_magmom, iloop, &
        &                                Valence_Charge_Only )
                                            !-(m_XC_Pot.) -> afft(*) (xcchg2)
#else
         call map_charge_onto_a_fft_box2( nfout, chgq_l, ndim_magmom, iloop, &
        &                                 Valence_Charge_Only )
                                              !-(m_XC_Pot.) -> afft(*) (xcchg2)
#endif
         if(iprixc >= 2) write(nfout,*) " just after map_charge_onto_a_fft_box p1"
         if(iprixc >= 2) call wd_small_part_of_afft(7,'G space',120)
!

         if ( (.not. nopcc) .and. iloop == 1 ) afft = afft + bfft

         if (check_of_xctype() == GGA) then
            chden_l(ista_fftp:iend_fftp,iloop) = afft(ista_fftp:iend_fftp)
         end if

         call m_FFT_CD_inverse_c(nfout,afft)  ! afft(G_sp.) -> afft(R_sp.)
         if (iprixc >= 2) then
            write(nfout,'(" ! out of m_FFT_check_of_negative_CD <<m_XC_cal_potential>>")')
         endif
         call cp_afft_to_MagMom_Rspace(iloop)

      End do

      if (allocated( bfft )) deallocate( bfft )

! -----------------
! 3) project on local quan. axis
! -----------------
      allocate( quantz_axis_inversion_flg_mesh(ista_fftph:iend_fftph ) )
      quantz_axis_inversion_flg_mesh = 0

      call m_ES_SpinDens_Along_QuantzAxis2( RhoMag_R, chgrhr_l, &
           &                                quantz_axis_inversion_flg_mesh, .false. )

    end subroutine set_chgrhr_case_noncollinear3

    subroutine set_chgrhr_case_noncollinear2
      integer :: iloop
! -----------------------------------------------------------------
!! 
!!! 1) calculate the up/down spin densities along the local quantization axis
!!                             ( valence electron )
! ----------------------------------------------------------------
      integer :: i

      allocate( RhoMag_R(ista_fftph:iend_fftph,ndim_magmom)) ; RhoMag_R = 0.0d0
      call get_MagMom_on_Rspace                ! chgq_l --> RhoMag_R
!
      allocate( quantz_axis_inversion_flg_mesh(ista_fftph:iend_fftph ) )
      quantz_axis_inversion_flg_mesh = 0

      call m_ES_SpinDens_Along_QuantzAxis2( RhoMag_R, chgrhr_l, &
           &                                quantz_axis_inversion_flg_mesh, .true. )

! ----------------------------------------------------------------
!!
!!! 2) add pcc contribution to chgrhr_l
!!
! ---------------------------------------------------------------
      if ( .not. nopcc ) then
         allocate( bfft(ista_fftp:iend_fftp) ); bfft = 0.0d0
      endif

      Do iloop=1, nspin
! --------------------- set valence charge on G-space ----------
        afft = 0.0d0

!!! ------------------------------- origial ----
!!!        if ( myrank_ggacmp < nrank_ggacmp ) then
!!!	  call cp_MagMom_to_afft_Rspace( iloop )
!!!          call m_FFT_CD_direct_c( nfout, afft )
!!!        else
!!!          call m_FFT_CD_direct_c( nfout, afft, mode=0 )
!!!        end if

! ---- for debug ----
        call cp_MagMom_to_afft_Rspace( iloop )
        call m_FFT_CD_direct_c( nfout, afft )
! -
!
! --
        afft = afft * rinplw

! -- dbug
!        goto 1200
! --------------------- set core charge on G-space ----------
        if ( .not. nopcc ) then

           bfft = afft                ! save afft
           afft = 0.0d0
!
! ----
!                      In the followings, chgq_l is a dummy matrix.
! ----                  
!
#ifdef _OLD_MAP_CHARGE_
           call map_charge_onto_a_fft_box( chgq_l, ndim_magmom, iloop, &
	&                                  Partial_Core_Charge )
#else
           call map_charge_onto_a_fft_box2( nfout, chgq_l, ndim_magmom, iloop, &
	&                                   Partial_Core_Charge )
#endif

           afft = bfft + afft / dble(nspin)         ! nspin == 2 
        end if
! --
1200    continue

        if ( check_of_xctype() == GGA ) then
           chden_l(ista_fftp:iend_fftp,iloop) = afft(ista_fftp:iend_fftp)
        end if

! -----------------------------------------------
!  This if-sentence is not necessary. 
!
!!!!!!!!        if ( .not. nopcc ) then
! -----------------------------------------------

           if ( myrank_ggacmp < nrank_ggacmp ) then
              call m_FFT_CD_inverse_c( nfout, afft )    ! afft(G_sp.) -> afft(R_sp.)
              if ( iprixc >= 2 ) call wd_small_part_of_afft( 7,'R space',120 )
              call m_FFT_check_of_negative_CD( npes_cdfft, ista_fftp, iend_fftp, &
                   &                           ista_fftph, iend_fftph, afft, &
                   &                           nfout, nspin, iloop )
           else
              call m_FFT_CD_inverse_c( nfout, afft, mode=0 )
           end if
           if (iprixc >= 2) then
              write(nfout,'(" ! out of m_FFT_check_of_negative_CD <<m_XC_cal_potential>>")')
           endif

           call cp_afft_to_chgrhr(iloop)       ! -(contained here) afft -> chgrhr_l

! ------------------------------
!!!!!!!!!!!!!!        endif
! -----------------------------
      end do

      if ( allocated(bfft) ) deallocate( bfft )

    end subroutine set_chgrhr_case_noncollinear2

    subroutine set_chgrhr_case_noncollinear
      integer :: iloop
! -----------------------------------------------------------------
!! 
!!! 1) calculate the up/down spin densities along the local quantization axis
!!                             ( valence electron )
! ----------------------------------------------------------------
      integer :: i

      allocate( RhoMag_R(ista_fftph:iend_fftph,ndim_magmom)) ; RhoMag_R = 0.0d0
      call get_MagMom_on_Rspace                ! chgq_l --> RhoMag_R
!
      call m_ES_get_Angles_MagMom_Rspace2( RhoMag_R, Rot_Angles )
      call m_ES_SpinDens_Along_QuantzAxis( RhoMag_R, Rot_Angles, chgrhr_l )

      deallocate( RhoMag_R )

! ----------------------------------------------------------------
!!
!!! 2) add pcc contribution to chgrhr_l
!!
! ---------------------------------------------------------------
      if ( .not. nopcc ) then
         allocate( bfft(ista_fftp:iend_fftp) ); bfft = 0.0d0
      endif

      Do iloop=1, nspin
! --------------------- set valence charge on G-space ----------
        afft = 0.0d0

!!! ------------------------------- origial ----
!!!        if ( myrank_ggacmp < nrank_ggacmp ) then
!!!	  call cp_MagMom_to_afft_Rspace( iloop )
!!!          call m_FFT_CD_direct_c( nfout, afft )
!!!        else
!!!          call m_FFT_CD_direct_c( nfout, afft, mode=0 )
!!!        end if

! ---- for debug ----
        call cp_MagMom_to_afft_Rspace( iloop )
        call m_FFT_CD_direct_c( nfout, afft )
! -
!
! --
        afft = afft * rinplw

! -- dbug
!        goto 1200
! --------------------- set core charge on G-space ----------
        if ( .not. nopcc ) then

           bfft = afft                ! save afft
           afft = 0.0d0
!
! ----
!                      In the followings, chgq_l is a dummy matrix.
! ----                  
!
#ifdef _OLD_MAP_CHARGE_
           call map_charge_onto_a_fft_box( chgq_l, ndim_magmom, iloop, &
	&                                  Partial_Core_Charge )
#else
           call map_charge_onto_a_fft_box2( nfout, chgq_l, ndim_magmom, iloop, &
	&                                   Partial_Core_Charge )
#endif

           afft = bfft + afft / dble(nspin)         ! nspin == 2 
        end if
! --
1200    continue

        if ( check_of_xctype() == GGA ) then
           chden_l(ista_fftp:iend_fftp,iloop) = afft(ista_fftp:iend_fftp)
        end if

! -----------------------------------------------
!  This if-sentence is not necessary. 
!
!!!!!!!!        if ( .not. nopcc ) then
! -----------------------------------------------

           if ( myrank_ggacmp < nrank_ggacmp ) then
              call m_FFT_CD_inverse_c( nfout, afft )    ! afft(G_sp.) -> afft(R_sp.)
              if ( iprixc >= 2 ) call wd_small_part_of_afft( 7,'R space',120 )
              call m_FFT_check_of_negative_CD( npes_cdfft, ista_fftp, iend_fftp, &
                   &                           ista_fftph, iend_fftph, afft, &
                   &                           nfout, nspin, iloop )
           else
              call m_FFT_CD_inverse_c( nfout, afft, mode=0 )
           end if
           if (iprixc >= 2) then
              write(nfout,'(" ! out of m_FFT_check_of_negative_CD <<m_XC_cal_potential>>")')
           endif

           call cp_afft_to_chgrhr(iloop)       ! -(contained here) afft -> chgrhr_l

! ------------------------------
!!!!!!!!!!!!!!        endif
! -----------------------------
      end do

      if ( allocated(bfft) ) deallocate( bfft )

    end subroutine set_chgrhr_case_noncollinear

! ------------------------------------------------------------
!!
!!!  n(G), mx(G), my(G), mz(G) ---> n(R), mx(R), my(R), mz(R)
!!
! -------------------------------------------------------------
    subroutine get_MagMom_on_Rspace
      integer :: iloop

      do iloop = 1, ndim_magmom
         afft = 0.0d0
#ifdef _OLD_MAP_CHARGE_
         call map_charge_onto_a_fft_box( chgq_l, ndim_magmom, iloop, &
	&                                Valence_Charge_Only )
	                                     !-(m_XC_Pot.) -> afft(*) (xcchg2)
#else
         call map_charge_onto_a_fft_box2( nfout, chgq_l, ndim_magmom, iloop, &
	&                                 Valence_Charge_Only )
                                              !-(m_XC_Pot.) -> afft(*) (xcchg2)
#endif
         if(iprixc >= 2) write(nfout,*) " just after map_charge_onto_a_fft_box p1"
         if(iprixc >= 2) call wd_small_part_of_afft(7,'G space',120)

!!! ------------ original ---
!         if(myrank_ggacmp < nrank_ggacmp) then
!            call m_FFT_CD_inverse_c(nfout,afft)  ! afft(G_sp.) -> afft(R_sp.)
!            if(iprixc >= 2) call wd_small_part_of_afft(7,'R space',120)
!            call m_FFT_check_of_negative_CD( npes_cdfft, ista_fftp, iend_fftp, &
!                 &                           ista_fftph, iend_fftph, afft, &
!                 &                           nfout, 100, iloop )
!         else
!            call m_FFT_CD_inverse_c(nfout,afft,mode=0)
!         end if

!----
!         if ( .not. nopcc ) then
!            call m_FFT_CD_inverse_c(nfout,afft)  ! afft(G_sp.) -> afft(R_sp.)
!         else
!            if(myrank_ggacmp < nrank_ggacmp) then
!               call m_FFT_CD_inverse_c(nfout,afft)  ! afft(G_sp.) -> afft(R_sp.)
!!               if(iprixc >= 2) call wd_small_part_of_afft(7,'R space',120)
!               call m_FFT_check_of_negative_CD( npes_cdfft, ista_fftp, iend_fftp, &
!                    &                           ista_fftph, iend_fftph, afft, &
!                    &                           nfout, 100, iloop )
!            else
!               call m_FFT_CD_inverse_c(nfout,afft,mode=0)
!            end if
!         endif

! ------ for debug --
         call m_FFT_CD_inverse_c(nfout,afft)  ! afft(G_sp.) -> afft(R_sp.)
! --
         call cp_afft_to_MagMom_Rspace(iloop)
      end do

    end subroutine get_MagMom_on_Rspace

    subroutine cp_MagMom_to_afft_Rspace( iloop )
      integer, intent(in) :: iloop
      integer :: i

      do i = ista_fftph, iend_fftph    ! MPI
         afft(2*i-1) = chgrhr_l(i,iloop)
      end do
    end subroutine cp_MagMom_to_afft_Rspace

    subroutine cp_afft_to_MagMom_Rspace(iloop)
      integer, intent(in) :: iloop
      integer :: i

! ==================
!      if(myrank_ggacmp < nrank_ggacmp) then
!         do i = ista_fftph, iend_fftph    ! MPI
!            RhoMag_R(i,iloop) = afft(i*2-1)
!         end do
!      else
!         do i = ista_fftph, iend_fftph    ! MPI
!            RhoMag_R(i,iloop) = 0.d0
!         end do
!      end if           

! --- for debug -------------- This does not resolve the problem.
!
      do i = ista_fftph, iend_fftph    ! MPI
         RhoMag_R(i,iloop) = afft(i*2-1)
      end do
! ----

! ----------------
!      Do i = ista_fftph, iend_fftph
!         if ( RhoMag_R( i,iloop ) < 0.0 ) then
!            RhoMag_R( i,iloop ) = 0.0d0
!         end if
!      End Do

      if(iprixc >= 2) then
         write(nfout,*) "!XC == "
         write(nfout,*) "!XC        iloop = ", iloop

         write(nfout,'(" !XC -- RhoMag_R -- <<cp_afft_to_MagMom_Rspace>>")')
         write(nfout,'(" !XC ",6f12.6)') (RhoMag_R(i,iloop),i=ista_fftph,ista_fftph+17)
         write(nfout,'(" !XC -- afft --     <<cp_afft_to_MagMom_Rspace>>")')
         write(nfout,'(" !XC ",6f12.6)') (afft(i*2-1),i=ista_fftph,ista_fftph+17)
      end if
    end subroutine cp_afft_to_MagMom_Rspace

    subroutine set_vxc_case_collinear(ispin)
      integer, intent(in) :: ispin
      integer :: iloop

      do iloop = 1, ispin
         if(myrank_ggacmp < nrank_ggacmp) then
            call cpafft(iloop)                     ! chgrhr_l -> afft
            call m_FFT_CD_direct_c(nfout,afft)     ! afft(R space) -> afft(G sp.)
         else
            call m_FFT_CD_direct_c(nfout,afft,mode=0)
         end if
            if(iprixc >= 2) call wd_small_part_of_afft(7,'G space',120)
            if(npes > 1) call mpi_barrier(mpi_comm_group,ierr)
         call cpafft_to_vxc_or_vxcpc(iloop)      ! -> vxc_l, vxcpc_l
      end do
      if(iprixc >= 2) call wd_small_part_of_vxc
    end subroutine set_vxc_case_collinear

    subroutine set_vxc_case_noncollinear
      integer :: iloop
      real(kind=DP), allocatable :: vxc_magmom(:,:,:)

      do iloop = 1, ndim_chgpot
         if ( myrank_ggacmp < nrank_ggacmp ) then
            call m_ES_cp_VxcR_to_afft( iloop, chgrhr_l, Rot_Angles, afft )
            call m_FFT_CD_direct_c(nfout,afft)     ! afft(R space) -> afft(G sp.)
         else
            call m_FFT_CD_direct_c(nfout,afft,mode=0)
         end if
         if(iprixc >= 2) call wd_small_part_of_afft(7,'G space',120)
         if(npes > 1) call mpi_barrier(mpi_comm_group,ierr)

         call cpafft_to_vxc_or_vxcpc(iloop)      ! -> vxc_l, vxcpc_l
      end do

! ---
      if(iprixc >= 2) call wd_small_part_of_vxc_ssrep   
                                                 !ss-representation

! -- convert to magmom-representation

      allocate( vxc_magmom( ista_kngp:iend_kngp,kimg,ndim_magmom ) )
      vxc_magmom = 0.0d0
      call m_ES_DensMat_to_MagMom_vlhxcl( vxc_l, vxc_magmom )
      vxc_l = vxc_magmom
      deallocate( vxc_magmom )

    end subroutine set_vxc_case_noncollinear

    subroutine set_vxc_case_noncollinear2
      integer :: iloop

      do iloop = 1, ndim_magmom
         if ( myrank_ggacmp < nrank_ggacmp ) then
            call m_ES_cp_VxcR_to_afft2( iloop, quantz_axis_inversion_flg_mesh, &
                 &                      RhoMag_R, chgrhr_l, afft )
            call m_FFT_CD_direct_c(nfout,afft)     ! afft(R space) -> afft(G sp.)
         else
            call m_FFT_CD_direct_c(nfout,afft,mode=0)
         end if
         if(iprixc >= 2) call wd_small_part_of_afft(7,'G space',120)
         if(npes > 1) call mpi_barrier(mpi_comm_group,ierr)

         call cpafft_to_vxc_or_vxcpc(iloop)      ! -> vxc_l, vxcpc_l
      end do

! ---
!!      if(iprixc >= 2) call wd_small_part_of_vxc_ssrep   
!!                                                 !ss-representation

      deallocate( RhoMag_R )
      deallocate( quantz_axis_inversion_flg_mesh )

    end subroutine set_vxc_case_noncollinear2
! ====================================================================== 11.0

! ==== KT_add ==== 13.0XX
    subroutine set_ekindens_case_collinear( ispin, ekin_l, ekin_dens )
      integer, intent(in) :: ispin
      real(kind=DP), intent(in)  :: ekin_l(ista_kngp:iend_kngp,kimg,nspin)
      real(kind=DP), intent(out) :: ekin_dens(ista_fftph:iend_fftph,nspin)

      integer :: iloop, i

      do iloop = 1, ispin
         call map_charge_onto_a_fft_box2( nfout, ekin_l, nspin, iloop, &
        &                                 input_charge )
         if(myrank_ggacmp < nrank_ggacmp) then
            call m_FFT_CD_inverse_c(nfout,afft)  ! afft(G_sp.) -> afft(R_sp.)
            do i = ista_fftph, iend_fftph    ! MPI
               ekin_dens(i,iloop) = afft(i*2-1)
            end do
         else
            call m_FFT_CD_inverse_c(nfout,afft,mode=0)
            do i = ista_fftph, iend_fftph    ! MPI
               ekin_dens(i,iloop) = 0.d0
            end do
         end if
      end do
    end subroutine set_ekindens_case_collinear
! ================= 13.0XX

    subroutine ggaxcp()
      !        ~~~~~~
      integer       :: is, id_sname = -1
      real(kind=DP) :: exc_mpi
      integer :: i,ierr
      call tstatc0_begin('ggaxcp(in xc_pot.) ',id_sname)

      if(iprixc >= 2) write(nfout,*) " -- start ggaxcp -- "
!!$      if(xctype /= 'ldapw91') call charge_in_gspace() ! chgrhr --> chden_l
      call ggaxcp0()
      !    ~~~~~~~
             !   dF/d|rho(r)| (=vxc) --> dF_drho
             !   dFx/d|grad(rho(r))| --> dF_dgradrho
             !   dFc/d|grad(rho(r))| --> grad_trho
             !   ->exc

      if (iprixc >= 2) write(nfout,'(" !XC after ggaxcp0 <<ggaxcp>>")') 

      if (vflag == VXC_AND_EXC .or. vflag == STRESS_) then
         if (xctype /= 'ldapw91' .and. xctype /= 'ldapbe ') then

! ======================================== modified by K. Tagami ============= 11.0
!            call dFxc_over_ddgradrho()
                    !   sum(q=xyz)(dFxc/dq(d|grad(rho)|)) --> grad_rho
!
            if ( noncol .and. sw_constrain_on_grad_correction == OFF ) then
               call dFxc_over_ddgradrho_noncl()
            else
               call dFxc_over_ddgradrho()
            endif
! ============================================================================== 11.0
         end if

! ==== KT_add ====== 13.0XX
         if ( xctype == "mbj09" ) grad_rho = 0.0d0
! ================== 13.0XX

         do is = 1, ispin
            call finally_gga_xc_pot(is)
            ! dFxc/d(rho)  dF_drho + grad_rho --> chgrhr 
         end do
      end if

      exc  = exc*univol*rinplw
      if(sw_output_xc_seperately==ON.or.xctype=='ggapbey')then
         eex  = eex*univol*rinplw
         ecor = ecor*univol*rinplw
      endif

      if(npes_cdfft >= 2) then               ! MPI
         if(myrank_ggacmp < nrank_ggacmp) then
            call mpi_allreduce(exc,exc_mpi,1,mpi_double_precision,mpi_sum &
                 & ,mpi_cdfft_world(myrank_ggacmp),ierr)  ! MPI
            exc = exc_mpi
            if(sw_output_xc_seperately==ON.or.xctype=='ggapbey')then
               call mpi_allreduce(eex,exc_mpi,1,mpi_double_precision,mpi_sum &
                    & ,mpi_cdfft_world(myrank_ggacmp),ierr)  ! MPI
               eex = exc_mpi
               call mpi_allreduce(ecor,exc_mpi,1,mpi_double_precision,mpi_sum &
                    & ,mpi_cdfft_world(myrank_ggacmp),ierr)  ! MPI
               ecor = exc_mpi
            endif
         end if
      end if

      if(nrest_cdfft >=1 ) then
         if(mype > npes_cdfft*nrank_ggacmp-1) then
            call mpi_recv(exc,1,mpi_double_precision &
                 &   , mype-npes_cdfft*nrank_ggacmp,1,mpi_comm_group,istatus,ierr)
            if(sw_output_xc_seperately==ON.or.xctype=='ggapbey')then
               call mpi_recv(eex,1,mpi_double_precision &
                    &   , mype-npes_cdfft*nrank_ggacmp,1,mpi_comm_group,istatus+1,ierr)
               call mpi_recv(ecor,1,mpi_double_precision &
                    &   , mype-npes_cdfft*nrank_ggacmp,1,mpi_comm_group,istatus+2,ierr)
            endif
         end if
         if(mype < nrest_cdfft) then
            call mpi_send(exc,1,mpi_double_precision &
                 &   , mype+npes_cdfft*nrank_ggacmp,1,mpi_comm_group,ierr)
            if(sw_output_xc_seperately==ON.or.xctype=='ggapbey')then
               call mpi_send(eex,1,mpi_double_precision &
                    &   , mype+npes_cdfft*nrank_ggacmp,1,mpi_comm_group,ierr)
               call mpi_send(ecor,1,mpi_double_precision &
                    &   , mype+npes_cdfft*nrank_ggacmp,1,mpi_comm_group,ierr)
            endif
         end if
      end if

      if(xctype.eq.'vdwdf' .and. .not.oneshot) exc = exc + ecnl

      if(iprixc >= 2) write(nfout,'(" !XC exc = ",f20.8)') exc

      call tstatc0_end(id_sname)
    end subroutine ggaxcp

    subroutine ggaxcp_diff
      !        ~~~~~~~~~~~
      real(DP):: exc_mpi               ! MPI
      integer :: is,i1,i2,in

!!$      call charge_in_gspace()  ! chgrhr -> chden_l
      call ggaxcp0()
      !    ~~~~~~~
             !   dF/d|rho(r)| (=vxc) --> dF_drho
             !   dFx/d|grad(rho(r))| --> dF_dgradrho
             !   dFc/d|grad(rho(r))| --> grad_trho
             !   ->exc

      exc = exc*univol*rinplw

      if(npes_cdfft >= 2) then               ! MPI
         if(myrank_ggacmp < nrank_ggacmp) then
            call mpi_allreduce(exc,exc_mpi,1,mpi_double_precision,mpi_sum &
                 & ,mpi_cdfft_world(myrank_ggacmp),ierr)  ! MPI
            exc = exc_mpi
         end if
      end if
      if(nrest_cdfft >=1 ) then
         if(mype > npes_cdfft*nrank_ggacmp-1) then
            call mpi_recv(exc,1,mpi_double_precision &
                 &   , mype-npes_cdfft*nrank_ggacmp,1,mpi_comm_group,istatus,ierr)
         end if
         if(mype < nrest_cdfft) then
            call mpi_send(exc,1,mpi_double_precision &
                 &   , mype+npes_cdfft*nrank_ggacmp,1,mpi_comm_group,ierr)
         end if
      end if
!!$      if(npes_cdfft >= 2) then               ! MPI
!!$         call mpi_allreduce(exc,exc_mpi,1,mpi_double_precision,mpi_sum &
!!$              & ,mpi_cdfft_world(myrank_ggacmp),ierr)  ! MPI
!!$         exc = exc_mpi
!!$      end if


      if (xctype.eq.'vdwdf') exc = exc + ecnl

      chgrhr_l = dF_drho

! stress tensor comes from gradient correction
!
! ==================================== added by K. Tagami ================ 11.0
      if ( noncol ) then
         if ( sw_constrain_on_grad_correction == ON ) then
            call calc_contrib_for_stress_nonclA
         else
            call calc_contrib_for_stress_nonclB
         endif
      else
         call calc_contrib_for_stress
      endif
! ========================================================================== 11.0
    end subroutine ggaxcp_diff


! ==================================== added by K. Tagami ================ 11.0
    subroutine calc_contrib_for_stress
      integer :: is,i1,i2,in

      call allocate_for_stress

      do i1=1,3
         do i2=1,3
            call rhos_diff(i1,i2);  call rhopc_diff(i1,i2);  call rhoh_diff(i1,i2)

            do is=1,nspin-af
               call map_drhodh1(is) ! drhodh -> chgfft
               do in=1,3
                  if(map_ggacmp(in) /= myrank_ggacmp) cycle
#ifdef _XC_SAVE_MEMORY_
                  cggawk13=0.d0
#endif
                  grad_rho(ista_fftph:iend_fftph,is)=0.d0
                  dF_drho(ista_fftph:iend_fftph,is)=0.d0
                  call dgrhodh1(i1,i2,in,is)
#ifndef _XC_SAVE_MEMORY_
                  call stress_exchange_part(i1,i2,in,is)   ! ->(s_gga1,s_gga2)
#else
                  call gradrho1(in,is)
                  call stress_exchange_part(i1,i2,is)   ! ->(s_gga1,s_gga2)
#endif
               enddo !in
            enddo !is

            if(nspin==2) then
               if(af == 1) then
                  is = 1
                  call map_drhodh1(is) ! drhodh -> chgfft
                  do in = 1, 3
                     if(map_ggacmp(in) /= myrank_ggacmp) cycle
                     call dgrhodh1(i1,i2,in,is)
#ifndef _XC_SAVE_MEMORY_
                     call stress_correlation_part(i1,i2,in)   ! ->(s_gga2)
#else
                     call gradrho2(in)
                     call stress_correlation_part(i1,i2)   ! ->(s_gga2)
#endif
                  end do
               else
                  call map_drhodh2
                  do in=1,3
                     if(map_ggacmp(in) /= myrank_ggacmp) cycle
                     call dgrhodh2(i1,i2,in)
#ifndef _XC_SAVE_MEMORY_
                     call stress_correlation_part(i1,i2,in)   ! ->(s_gga2)
#else
                     call gradrho2(in)
                     call stress_correlation_part(i1,i2)   ! ->(s_gga2)
#endif
                  end do
               end if
            end if
         enddo
      enddo

      call sum_s_gga12
      call deallocate_for_stress

    end subroutine calc_contrib_for_stress

    subroutine calc_contrib_for_stress_nonclA
      integer :: is,i1,i2,in

      call allocate_for_stress
      call alloc_chgsoft_project_noncol
      call set_chgsoft_projected_noncol
      call alloc_chghard_project_noncol
      call set_chghard_projected_noncol

      do i1=1,3
         do i2=1,3
            call rhos_diff_noncl(i1,i2);  call rhopc_diff_noncl(i1,i2)
            call rhoh_diff(i1,i2)

            do is=1,nspin
               call map_drhodh1(is) ! drhodh -> chgfft
               do in=1,3
                  if(map_ggacmp(in) /= myrank_ggacmp) cycle
#ifdef _XC_SAVE_MEMORY_
                  cggawk13=0.d0
#endif
                  grad_rho(ista_fftph:iend_fftph,is)=0.d0
                  dF_drho(ista_fftph:iend_fftph,is)=0.d0
                  call dgrhodh1(i1,i2,in,is)
#ifndef _XC_SAVE_MEMORY_
                  call stress_exchange_part(i1,i2,in,is)   ! ->(s_gga1,s_gga2)
#else
                  call gradrho1(in,is)
                  call stress_exchange_part(i1,i2,is)   ! ->(s_gga1,s_gga2)
#endif
               enddo !in
            enddo !is

            call map_drhodh2
            do in=1,3
               if(map_ggacmp(in) /= myrank_ggacmp) cycle
               call dgrhodh2(i1,i2,in)
#ifndef _XC_SAVE_MEMORY_
               call stress_correlation_part(i1,i2,in)   ! ->(s_gga2)
#else
               call gradrho2(in)
               call stress_correlation_part(i1,i2)   ! ->(s_gga2)
#endif
            end do

         enddo
      enddo

      call sum_s_gga12
      call deallocate_for_stress
      call dealloc_chgsoft_project_noncol
      call dealloc_chghard_project_noncol

    end subroutine calc_contrib_for_stress_nonclA

    subroutine calc_contrib_for_stress_nonclB
      integer :: is,i1,i2,in,nn

      call allocate_for_stress
      allocate( bfft_kt( ista_fftp:iend_fftp,ndim_magmom )); bfft_kt = 0.0d0

      do i1=1,3
         do i2=1,3
            call rhos_diff_noncl(i1,i2)
            call rhopc_diff_noncl(i1,i2)
            call rhoh_diff(i1,i2)                      ! drohdh is 1:ndim_magmom

            do in=1,3
               if (map_ggacmp(in) /= myrank_ggacmp) cycle

               bfft_kt = 0.0d0
               do is=1,ndim_magmom
                  call map_drhodh1(is)                  ! drhodh -> chgfft
                  call dgrhodh1_noncl(i1,i2,in,is)      ! chgfft, chden_l --> afft
                  bfft_kt(:,is) = afft(:)
               end do

               call m_ES_GradCorr_Along_QuantzAxis2( RhoMag_R, bfft_kt, &
                    &                                quantz_axis_inversion_flg_mesh )

! ====== KT_DEBUG ========== 2013/10/30
!               Do is=1, nspin
!                  dF_drho(:,is) = bfft_kt(:,is)
!               End do
!
               Do is=1, nspin
                  do nn = ista_fftph, iend_fftph              ! MPI
                     dF_drho(nn,is) = bfft_kt(2*nn,is)
                  enddo
               End Do
! =========================== 2013/10/30

#ifndef _XC_SAVE_MEMORY_
               Do is=1, nspin
                  call stress_exchange_part(i1,i2,in,is)   ! ->(s_gga1,s_gga2)
               End do
#else
               Do is=1, ndim_magmom
                  call gradrho1(in,is)
                  bfft_kt(:,is) = afft(:)
               End do

               call m_ES_GradCorr_Along_QuantzAxis2( RhoMag_R, bfft_kt, &
                    &                                quantz_axis_inversion_flg_mesh )

               Do is=1, nspin
                  cggawk13(:) = bfft_kt(:,is)
                  call stress_exchange_part(i1,i2,is)   ! ->(s_gga1,s_gga2)
               End do
#endif
            end do

            is = 1
            call map_drhodh1(is)                  ! drhodh -> chgfft

            do in=1,3
               if(map_ggacmp(in) /= myrank_ggacmp) cycle

               call dgrhodh1(i1,i2,in,is)
#ifndef _XC_SAVE_MEMORY_
               call stress_correlation_part(i1,i2,in)   ! ->(s_gga2)
#else
               call gradrho1(in,is)
               call stress_correlation_part(i1,i2)   ! ->(s_gga2)
#endif
            end do

         enddo
      enddo

      call sum_s_gga12

      call deallocate_for_stress
      deallocate( bfft_kt )

    end subroutine calc_contrib_for_stress_nonclB
! ======================================================================= 11.0

    subroutine ggaxcp0
      integer :: pot_type

! ==== KT_add ======== 13.0XX
      real(kind=DP), allocatable :: dummy1(:,:), dummy2(:)
! ==================== 13.0XX

      call initialize_cggawk_arrays

!!$      if(myrank_ggacmp >= nrank_ggacmp) goto 1002

      if(xctype == 'ldapw91' .or. xctype == 'ldapbe ') then
         grad_rho = 0.d0; grad_trho = 0.d0
#ifndef _XC_SAVE_MEMORY_
         cgrad_rho = 0.d0
#endif
      else
! ===================================== modiifed by K. Tagami ============= 11.0
!!         call abs_grad_rho_up_down_total()
      !   chden_l ->
      !   |grad(rho_up(r))|,|grad(rho_down(r))|  --> grad_rho
      !   |grad(rho_up(r) + rho_down(r))|        --> grad_trho
         if ( noncol .and. sw_constrain_on_grad_correction == OFF ) then
            call abs_grad_rho_updown_total_noncl()
         else
            call abs_grad_rho_up_down_total()
         endif
! ========================================================================== 11.0
      end if

! ====== KT_add ======= 13.0XX
      if ( use_metagga ) then
         call grad2_rho_up_down()

         if ( use_modeled_ekin_density ) then
            call m_KE_set_modeled_ekin_density( chgrhr_l, grad_rho, grad2_rho, &
                 &                              ekin_dens )
         else if ( use_asymm_ekin_density ) then
!            ekin_dens = ekin_dens + 0.25d0 *grad2_rho       ! ????
         endif
      endif

      if ( use_metagga ) then
         if ( xctype /= 'mbj09' ) then
            write(nfout,'(" xctype = ",a7)') xctype
            stop ' xctype is not set properly (ggaxcp0)'
         endif
      else
         if (xctype /= 'ggapw91' .and. xctype /= 'ldapw91' &
                 & .and. xctype /= 'ggapbe' .and. xctype /= 'ldapbe' &
                 & .and. xctype /= 'katopbe' .and. xctype /= 'ggapbek' &
! ==================================  KT_add ================ 13.0A
                 & .and. xctype /= 'rpbe' &
                 & .and. xctype /= 'wc06' &
                 & .and. xctype /= 'htbs' &
! =========================================================== 13.0A
                 & .and. xctype /= 'revpbe' &
                 & .and. xctype /= 'ggapbe'.and. xctype /= 'ggapbex' &
#ifdef DISABLE_VDWDF
                 & .and. xctype /= 'ggapbey') then 
#else
                 & .and. xctype /= 'ggapbey' &
                 & .and. xctype /= 'vdwdf' ) then
#endif
            write(nfout,'(" xctype = ",a7)') xctype
            stop ' xctype is not set properly (ggaxcp0)'
         end if
      endif
! ===================== 13.0XX

      if(myrank_ggacmp < nrank_ggacmp) then
      if(xctype == 'ggapw91' .or. xctype == 'ldapw91') then
!!$         call ex_ggapw91(nspin,ispin,chgrhr_l,grad_rho,f2or1,exc,dF_drho,dF_dgradrho)
         call ex_ggapw91(nspin,ispin,ista_fftph,iend_fftph,chgrhr_l,grad_rho,f2or1,exc,dF_drho,dF_dgradrho)
         if(sw_hybrid_functional==ON) call scale_exchange(alpha_exx)
         if(sw_exchange_only==OFF) &
              & call cr_ggapw91(nspin,ispin,ista_fftph,iend_fftph,chgrhr_l,grad_trho,f2or1,exc,dF_drho)
      else if(xctype == 'ggapbe ' .or. xctype == 'ldapbe '.or. xctype=='ggapbey'.or.xctype=='revpbe') then
!!$         call ex_ggapbe (nspin,ispin,chgrhr_l,grad_rho,f2or1,exc,dF_drho,dF_dgradrho)
         call ex_ggapbe (nspin,ispin,ista_fftph,iend_fftph,chgrhr_l,grad_rho,f2or1,exc,dF_drho,dF_dgradrho,xctype=='revpbe')
         eex = exc
         if(sw_hybrid_functional==ON) then
            if(sw_screened_exchange==ON) then
               call ex_omegapbe(-alpha_exx,omega_exx_pbe,nspin,ispin,ista_fftph,iend_fftph,chgrhr_l, &
             &      grad_rho,f2or1,exc,dF_drho,dF_dgradrho)
            else
               call scale_exchange(alpha_exx)
            end if
         end if
         if(sw_exchange_only==OFF) &
              & call cr_ggapbe (nspin,ispin,ista_fftph,iend_fftph,chgrhr_l,grad_trho,f2or1,exc,dF_drho,ecor)

      else if(xctype == 'ggapbex') then
         call ex_ggapbe (nspin,ispin,ista_fftph,iend_fftph,chgrhr_l,grad_rho,f2or1,exc,dF_drho,dF_dgradrho,xctype=='revpbe')

! =========================== KT_add ========================= 13.0A
      else if ( xctype == 'rpbe' .or. xctype == 'wc06' .or. xctype == 'htbs' ) then
         if ( xctype == 'ggapbe' )  pot_type = 1
         if ( xctype == 'revpbe' )  pot_type = 2
         if ( xctype == 'rpbe' )    pot_type = 3
         if ( xctype == 'wc06' )    pot_type = 4
         if ( xctype == 'htbs' )    pot_type = 5

         call ex_ggapbe_family( nspin, ispin, ista_fftph, iend_fftph, chgrhr_l, &
              &                 grad_rho, f2or1, exc, dF_drho, dF_dgradrho, pot_type )

         eex = exc
         if ( sw_hybrid_functional == ON ) then
            if ( sw_screened_exchange == ON ) then
               call ex_omegapbe( -alpha_exx, omega_exx_pbe, nspin, ispin, &
                    &            ista_fftph, iend_fftph, chgrhr_l, &
                    &            grad_rho, f2or1, exc, dF_drho, dF_dgradrho )
            else
               call scale_exchange( alpha_exx )
            end if
         end if
         if ( sw_exchange_only == OFF ) then
            call cr_ggapbe( nspin, ispin, ista_fftph, iend_fftph, chgrhr_l, &
                 &          grad_trho, f2or1, exc, dF_drho, ecor )
         endif
! ============================================================= 13.0A
#ifndef DISABLE_VDWDF
      else if(xctype == 'vdwdf') then
         call ex_ggapbe (nspin,ispin,ista_fftph,iend_fftph,chgrhr_l,grad_rho,f2or1,exc,dF_drho,dF_dgradrho,xctype=='revpbe')
         eex = exc
         if(sw_hybrid_functional==ON) then
            if(sw_screened_exchange==ON) then
               call ex_omegapbe(-alpha_exx,omega_exx_pbe,nspin,ispin,ista_fftph,iend_fftph,chgrhr_l, &
             &      grad_rho,f2or1,exc,dF_drho,dF_dgradrho)
            else
               call scale_exchange(alpha_exx)
            end if
         end if
         if(sw_exchange_only==OFF) then
            grad_trho=0.d0
            call cr_ggapbe (nspin,ispin,ista_fftph,iend_fftph,chgrhr_l,grad_trho,f2or1,exc,dF_drho,ecor)
         endif
         if (.not. oneshot ) call add_vdwdf_nonlocal_energy

#endif
      else if(xctype == 'katopbe' .or. xctype == 'ggapbek') then
!!$         call ex_ggapbe (nspin,ispin,chgrhr_l,grad_rho,f2or1,exc,dF_drho,dF_dgradrho)
         call ex_ggapbe (nspin,ispin,ista_fftph,iend_fftph,chgrhr_l,grad_rho,f2or1,exc,dF_drho,dF_dgradrho,xctype=='revpbe')
         if(sw_hybrid_functional==ON) then
            if(sw_screened_exchange==ON) then
               call ex_omegapbe(-alpha_exx,omega_exx_pbe,nspin,ispin,ista_fftph,iend_fftph,chgrhr_l, &
             & grad_rho,f2or1,exc,dF_drho,dF_dgradrho)
            else
               call scale_exchange(alpha_exx)
            end if
         end if
         if(sw_exchange_only==OFF) &
              & call cr_ggapbe (nspin,ispin,ista_fftph,iend_fftph,chgrhr_l,grad_trho,f2or1,exc,dF_drho)
      else if(xctype == 'ggabp  ') then
!!$         call xclda(nspin,ispin,chgrhr_l,f2or1,exc,dF_drho)
!!$         call ggabek(nspin,ispin,chgrhr_l,f2or1,exc,dF_dgradrho)
!!$         call ggaprd(nspin,ispin,chgrhr_l,grad_rho,f2or1,exc,dF_drho,dF_dgradrho)
         call xclda(nspin,ispin,ista_fftph,iend_fftph,chgrhr_l,f2or1,exc,dF_drho)
         call ggabek(nspin,ispin,ista_fftph,iend_fftph,chgrhr_l,grad_rho,f2or1,exc,dF_drho,dF_dgradrho)
         call ggaprd(nspin,ispin,ista_fftph,iend_fftph,chgrhr_l,grad_rho,f2or1,exc,dF_drho,dF_dgradrho)
      end if
      else
        exc = 0.d0
      end if
             !   dF/d|rho(r)| (=vxc) --> dF_drho
             !   dFx/d|grad(rho(r))| --> dF_dgradrho
             !   dFc/d|grad(rho(r))| --> grad_trho
!!$1002  continue

! ====== KT_add ===== 13.0XX
      if ( use_metagga ) then
         if (myrank_ggacmp < nrank_ggacmp ) then

            if ( xctype == "mbj09" ) then
               allocate( dummy1(ista_fftph:iend_fftph,nspin ) ); dummy1 = 0.0d0
               allocate( dummy2(ista_fftph:iend_fftph ) );       dummy2 = 0.0d0

               call ex_ggapbe( nspin, ispin, ista_fftph, iend_fftph, &
                    &          chgrhr_l, dummy1, f2or1, exc, dF_drho, dF_dgradrho,xctype=='revpbe' )

               if ( ekin_density_is_active ) then
                  call ex_mgga_mbj09( nspin, ispin, ista_fftph, iend_fftph, &
                       &              chgrhr_l, grad_rho, grad2_rho, ekin_dens, &
                       &              dF_drho, f2or1 )
               endif
               call cr_ggapbe( nspin, ispin, ista_fftph, iend_fftph, &
                    &          chgrhr_l, dummy2, f2or1, exc, dF_drho )

               deallocate( dummy1 ); deallocate( dummy2 )
               dF_dgradrho = 0.0d0
            endif
         end if

      endif
! =================== 13.0XX

      if(iprixc >= 2) then
         write(nfout,'(" !XC -- chgrhr_l -- <<ggaxcp0>>")')
         write(nfout,'(" !XC ",6f12.6)') (chgrhr_l(i,1),i=ista_fftph,ista_fftph+17)
         write(nfout,'(" !XC -- grad_rho -- <<ggaxcp0>>")')
         write(nfout,'(" !XC ",6f12.6)') (grad_rho(i,1),i=ista_fftph,ista_fftph+17)
         write(nfout,'(" !XC -- grad_trho -- <<ggaxcp0>>")')
         write(nfout,'(" !XC ",6f12.6)') (grad_trho(i),i=ista_fftph,ista_fftph+17)
         write(nfout,'(" !XC -- dF_drho -- <<ggaxcp0>>")')
         write(nfout,'(" !XC ",6f12.6)') (dF_drho(i,1),i=ista_fftph,ista_fftph+17)
         write(nfout,'(" !XC -- dF_dgradrho -- <<ggaxcp0>>")')
         write(nfout,'(" !XC ",6f12.6)') (dF_dgradrho(i,1),i=ista_fftph,ista_fftph+17)
      end if
    end subroutine ggaxcp0

    subroutine add_vdwdf_nonlocal_energy
      integer :: i, nfftcd,nfftx,nffty,nfftz,ix,iy,iz,ixyz
      integer :: ix2, iy2, iz2, nlphf,idp, mmp

      real(kind=DP),allocatable,dimension(:) :: chgrhr_red
      real(kind=DP),allocatable,dimension(:) :: grad_rho_red
      real(kind=DP),allocatable,dimension(:,:) :: dF_drho_red
      real(kind=DP),allocatable,dimension(:,:,:) :: dfdrho_vdw,dfddrho_vdw

      idp = fft_box_size_CD_nonpara(1,0)
      mmp = fft_box_size_CD_nonpara(2,0)

      nfftx = fft_box_size_CD(1,1)
      nffty = fft_box_size_CD(2,1)
      nfftz = fft_box_size_CD(3,1)
      nfftcd = nfftx*nffty*nfftz

      allocate(dfdrho_vdw (nfftx,nffty,nfftz));dfdrho_vdw=0.d0
      allocate(dfddrho_vdw(nfftx,nffty,nfftz));dfddrho_vdw=0.d0
      allocate(chgrhr_red(nfftcd));chgrhr_red=0.0d0
      allocate(grad_rho_red(nfftcd));grad_rho_red=0.d0

      if(ispin==1)then
         do i=ista_fftph,iend_fftph
            chgrhr_red(i)   = chgrhr_l(i,1)
            grad_rho_red(i) = grad_rho(i,1)
         enddo
      else
         do i=ista_fftph,iend_fftph
            chgrhr_red(i)   = chgrhr_l(i,1) +chgrhr_l(i,2)
            grad_rho_red(i) = grad_rho(i,1) +grad_rho(i,2)
         enddo
      endif
      call mpi_allreduce( MPI_IN_PLACE, chgrhr_red, nfftcd, mpi_double_precision, &
           &              mpi_sum, mpi_cdfft_world(myrank_ggacmp), ierr )
      call mpi_allreduce( MPI_IN_PLACE, grad_rho_red, nfftcd, mpi_double_precision,&
           &              mpi_sum, mpi_cdfft_world(myrank_ggacmp), ierr )
      call vdW_scf( nspin, ispin, nfftx, nffty, nfftz, chgrhr_red, grad_rho_red, &
           &        ecnl, dfdrho_vdw, dfddrho_vdw )

      if(kimg == 1) then
         nlphf = idp/2
      else
         nlphf = idp
      end if

      if ( kimg == 1 ) then
        do ix=1,nfftx
            do iy=1,nffty
               do iz=1,nfftz
                  if ( ix > nlphf ) then
                     ix2 = idp -ix
                     iy2 = nffty +2 -iy
                     iz2 = nfftz +2 -iz
                     if ( iy2 > nffty ) iy2 = iy2 -nffty
                     if ( iz2 > nfftz ) iz2 = iz2 -nfftz
                     cycle
                  else
                     ix2 = ix;  iy2 = iy;   iz2 = iz
                  endif
                  ixyz = (iz2-1)*mmp*nlphf +(iy2-1)*nlphf +ix2

                  if(ixyz<ista_fftph.or.ixyz>iend_fftph) cycle

                  dF_drho(ixyz,1:ispin) = dF_drho(ixyz,1:ispin) &
                       &                  +dfdrho_vdw(ix,iy,iz)
                  dF_dgradrho(ixyz,1:ispin) = dF_dgradrho(ixyz,1:ispin) &
                       &                     +dfddrho_vdw(ix,iy,iz)
               enddo
            enddo
         enddo
      else
         do ix=1, nfftx
            do iy=1,nffty
               do iz=1,nfftz
                  ixyz = (iz-1)*nffty*nfftx +(iy-1)*nfftx +ix
                  if ( ixyz<ista_fftph .or. ixyz>iend_fftph ) cycle

                  dF_drho(ixyz,1:ispin) = dF_drho(ixyz,1:ispin) &
                       &                  +dfdrho_vdw(ix,iy,iz)
                  dF_dgradrho(ixyz,1:ispin) = dF_dgradrho(ixyz,1:ispin) &
                       &                     +dfddrho_vdw(ix,iy,iz)
               enddo
            enddo
         enddo
      endif

      deallocate(dfdrho_vdw); deallocate(dfddrho_vdw)
      deallocate(chgrhr_red); deallocate(grad_rho_red)
    end subroutine add_vdwdf_nonlocal_energy

    subroutine scale_exchange(alpha)
      implicit none
      real(kind=DP), intent(in) :: alpha

      real(kind=DP) :: fexx

      fexx = 1.d0-alpha
      exc = fexx * exc
      dF_drho = fexx * dF_drho
      dF_dgradrho = fexx * dF_dgradrho
    end subroutine scale_exchange

    subroutine sum_s_gga12
      real(kind=DP), allocatable, dimension(:,:)    :: s_gga_mpi        ! MPI d(3,3)

      if(npes>=2 .and. (nrank_ggacmp>1.or.npes_cdfft>1)) allocate(s_gga_mpi(3,3))
      if(nrank_ggacmp > 1) then
         call mpi_allreduce(s_gga1,s_gga_mpi,9,mpi_double_precision &
              & , mpi_sum,mpi_ggacmp_cross_world(myrank_cdfft),ierr)
         s_gga1 = s_gga_mpi

         call mpi_allreduce(s_gga2,s_gga_mpi,9,mpi_double_precision &
              & , mpi_sum,mpi_ggacmp_cross_world(myrank_cdfft),ierr)
         s_gga2 = s_gga_mpi
      end if

      if(npes_cdfft >= 2)  then
         if(myrank_ggacmp < nrank_ggacmp) then
            call mpi_allreduce(s_gga1,s_gga_mpi,9,mpi_double_precision &
                 & ,mpi_sum,mpi_cdfft_world(myrank_ggacmp),ierr)
            s_gga1 = s_gga_mpi
            call mpi_allreduce(s_gga2,s_gga_mpi,9,mpi_double_precision &
                 & ,mpi_sum,mpi_cdfft_world(myrank_ggacmp),ierr)
            s_gga2 = s_gga_mpi
         end if
      end if
      if(nrest_cdfft >= 1) then
         if(mype > npes_cdfft*nrank_ggacmp - 1) then
            call mpi_recv(s_gga1,9,mpi_double_precision &
                 & ,mype - npes_cdfft*nrank_ggacmp,1,mpi_comm_group,istatus,ierr)
         end if
         if(mype < nrest_cdfft) then
            call mpi_send(s_gga1,9,mpi_double_precision &
                 & ,mype + npes_cdfft*nrank_ggacmp,1,mpi_comm_group,ierr)
         end if
         if(mype > npes_cdfft*nrank_ggacmp - 1) then
            call mpi_recv(s_gga2,9,mpi_double_precision &
                 & ,mype - npes_cdfft*nrank_ggacmp,1,mpi_comm_group,istatus,ierr)
         end if
         if(mype < nrest_cdfft) then
            call mpi_send(s_gga2,9,mpi_double_precision &
                 & ,mype + npes_cdfft*nrank_ggacmp,1,mpi_comm_group,ierr)
         end if
      end if

!!$         call mpi_allreduce(s_gga1,s_gga_mpi,9 &
!!$              &, mpi_double_precision,mpi_sum,mpi_comm_group,ierr)   ! MPI
!!$         s_gga1 = s_gga_mpi                  ! MPI
!!$
!!$         call mpi_allreduce(s_gga2,s_gga_mpi,9 &
!!$              &, mpi_double_precision,mpi_sum,mpi_comm_group,ierr)   ! MPI
!!$         s_gga2 = s_gga_mpi                  ! MPI

      if(npes >= 2 .and. (nrank_ggacmp>1.or.npes_cdfft>1)) deallocate(s_gga_mpi)

    end subroutine sum_s_gga12

#ifndef _XC_SAVE_MEMORY_
      
    subroutine stress_exchange_part(i1,i2,in,is)
      integer, intent(in) :: i1,i2,in,is
      integer :: m

      do m = ista_fftph, iend_fftph       ! MPI
         s_gga1(i1,i2)=s_gga1(i1,i2) &
              &  - univol * rinplw * dF_dgradrho(m,is) &
              &    * cgrad_rho(m,in,is) * dF_drho(m,is) * f2or1(m)
      end do

      ! correlation part -->
      if(nspin.eq.1) then
         do m = ista_fftph, iend_fftph    ! MPI
            s_gga2(i1,i2)=s_gga2(i1,i2) &
                 &  - univol * rinplw * grad_trho(m) &
                 &    * cgrad_rho(m,in,is) * dF_drho(m,1) * f2or1(m) 
         end do
      endif
      ! <--
    end subroutine stress_exchange_part

    subroutine stress_correlation_part(i1,i2,in)
      integer, intent(in) :: i1,i2,in
      integer :: m
      real(kind=DP) :: strs
      strs = 0.d0
      do m = ista_fftph, iend_fftph         ! MPI
         strs=strs &
              &  - univol * rinplw * grad_trho(m) &
              &    * (cgrad_rho(m,in,1)+cgrad_rho(m,in,2)) * dF_drho(m,1) * f2or1(m)
      end do
      s_gga2(i1,i2) = s_gga2(i1,i2) + strs
    end subroutine stress_correlation_part
#else
    subroutine stress_exchange_part(i1,i2,is)
      integer, intent(in) :: i1,i2,is
      integer :: m

      do m = ista_fftph, iend_fftph       ! MPI
         s_gga1(i1,i2)=s_gga1(i1,i2) &
              &  + univol * rinplw * dF_dgradrho(m,is) &
              &    * cggawk13(m) * dF_drho(m,is) * f2or1(m)
      end do

      if(nspin.eq.1) then
         do m = ista_fftph, iend_fftph    ! MPI
            s_gga2(i1,i2)=s_gga2(i1,i2) &
                 &  + univol * rinplw * grad_trho(m) &
                 &    * cggawk13(m) * dF_drho(m,1) * f2or1(m) 
         end do
      endif
    end subroutine stress_exchange_part

    subroutine stress_correlation_part(i1,i2)
      integer, intent(in) :: i1,i2
      integer :: m
      real(kind=DP) :: strs
      strs=0.d0
      do m = ista_fftph, iend_fftph         ! MPI
         strs=strs &
              &  + univol * rinplw * grad_trho(m) &
              &    * cggawk13(m) * dF_drho(m,1) * f2or1(m)
      end do

      s_gga2(i1,i2) = s_gga2(i1,i2) + strs
    end subroutine stress_correlation_part
#endif



! ================== added by K. Tagami ================ 11.0
    subroutine get_chgsoft_on_Rspace
      integer :: iloop

      do iloop = 1, ndim_magmom
         afft = 0.0d0
#ifdef _OLD_MAP_CHARGE_
         call map_charge_onto_a_fft_box( chgsoft, ndim_magmom, iloop, &
        &                                Valence_Charge_Only )
                                             !-(m_XC_Pot.) -> afft(*) (xcchg2)
#else
         call map_charge_onto_a_fft_box2( nfout, chgsoft, ndim_magmom, iloop, &
        &                                 Valence_Charge_Only )
                                              !-(m_XC_Pot.) -> afft(*) (xcchg2)
#endif
!         if(iprixc >= 2) write(nfout,*) " just after map_charge_onto_a_fft_box p1"
!         if(iprixc >= 2) call wd_small_part_of_afft(7,'G space',120)

         call m_FFT_CD_inverse_c(nfout,afft)  ! afft(G_sp.) -> afft(R_sp.)
! --
         do i = ista_fftph, iend_fftph    ! MPI
            chgsoft_on_Rspace(i,iloop) = afft(i*2-1)
         end do
      end do

    end subroutine get_chgsoft_on_Rspace

    subroutine alloc_chgsoft_project_noncol
      allocate( chgsoft_projected_on_Gspace(ista_kngp:iend_kngp,kimg,ndim_magmom) )
      chgsoft_projected_on_Gspace = 0.0d0
    end subroutine alloc_chgsoft_project_noncol

    subroutine dealloc_chgsoft_project_noncol
      deallocate( chgsoft_projected_on_Gspace )
    end subroutine dealloc_chgsoft_project_noncol

    subroutine set_chgsoft_projected_noncol
      integer :: iloop

      allocate( chgsoft_on_Rspace(ista_fftph:iend_fftph,ndim_magmom) );
      allocate( chgsoft_along_QuantzAxis(ista_fftph:iend_fftph,nspin) );
      chgsoft_on_Rspace  = 0.0d0
      chgsoft_along_QuantzAxis  = 0.0d0

      call get_chgsoft_on_Rspace
      call m_ES_Chgsoft_Along_QuantzAxis( chgsoft_on_Rspace, &
           &                              chgsoft_along_QuantzAxis, &
           &                              quantz_axis_inversion_flg_mesh )
      !
      deallocate( chgsoft_on_Rspace )
      !
      Do iloop=1, nspin
         afft = 0.0d0
         do i = ista_fftph, iend_fftph    ! MPI
            afft(2*i-1) = chgsoft_along_QuantzAxis(i,iloop)
         end do

         call m_FFT_CD_direct_c( nfout, afft )
!!         afft = afft * rinplw
         call cpafft_to_chgsoft_proj( iloop )

      End do
      deallocate( chgsoft_along_QuantzAxis )

    end subroutine set_chgsoft_projected_noncol

    subroutine cpafft_to_chgsoft_proj( iloop )
      integer, intent(in) :: iloop

      integer :: i, ik, ip
      real(kind=DP),allocatable,dimension(:)    :: afft_mpi1   ! MPI d(nfftp)
      integer :: id_sname = -1

      call tstatc0_begin('cpafft_to_chgsoft_proj ',id_sname)

      allocate(afft_mpi1(nfftp))

      call afft_allgatherv(afft,afft_mpi1)

      do ik = 1, kimg
         do i = ista_kngp, min(kgp_reduced,iend_kngp)  ! mpi
#ifdef _MPIFFT_
            ip = (igfp_l_c(i)-1)*kimg + ik
#else
            ip = (igfp_l(i)-1)*kimg + ik
#endif
            chgsoft_projected_on_Gspace(i,ik,iloop) = afft_mpi1(ip)*rinplw
         end do
      end do

      deallocate(afft_mpi1)
      call tstatc0_end(id_sname)
    end subroutine cpafft_to_chgsoft_proj

    subroutine alloc_chghard_project_noncol
      allocate( hsr_along_QuantzAxis(natm,nlmt,nlmt,nspin) )
      allocate( hsrd_along_QuantzAxis(natm,nlmt,nlmt,nspin,3,3) )
      hsr_along_QuantzAxis = 0.0d0
      hsrd_along_QuantzAxis = 0.0d0
    end subroutine alloc_chghard_project_noncol

    subroutine dealloc_chghard_project_noncol
      deallocate( hsr_along_QuantzAxis )
      deallocate( hsrd_along_QuantzAxis )
    end subroutine dealloc_chghard_project_noncol

    subroutine set_chghard_projected_noncol
      integer :: iloop
      integer :: ia
!
! -----
!      if ( .not. flg_paw ) then
!         call m_CD_estim_magmom_local(nfout)
!      endif
!
!      allocate( quantz_axis_inversion_flg_atm(natm) )
!
!      call m_ES_QuantzAxis_inv_flg_atm( magmom_local_now, &
!       &                                quantz_axis_inversion_flg_atm )
!      call m_ES_Chghard_Along_QuantzAxis( hsr, hsrd,  hsr_along_QuantzAxis, &
!       &                                  hsrd_along_QuantzAxis, &
!       &                                  quantz_axis_inversion_flg_atm )
! --------
      call m_ES_Chghard_Along_QuantzAxis( hsr, hsrd,  hsr_along_QuantzAxis, &
       &                                  hsrd_along_QuantzAxis )

!!      deallocate( quantz_axis_inversion_flg_atm )

    end subroutine set_chghard_projected_noncol

! ====================================================== 11.0

    subroutine rhos_diff(i1,i2)
      integer, intent(in) :: i1,i2
      integer :: is,ig
      integer :: iend  !mpi
      drhodh = 0.d0
      if(kimg.eq.1) then
         do is = 1, nspin - af
            iend = iend_kngp
            if( iend_kngp > kg ) iend = kg
            if( ista_kngp <= iend ) then
               do ig = ista_kngp, iend  !for mpi
                  drhodh(ig,1,is) = - chgsoft(ig,1,is) * alinvt(i1,i2)
               enddo
            endif
!!xocl end spread sum(drhodh)
         enddo
      else
         do is = 1, nspin - af
            iend = iend_kngp
            if( iend_kngp > kg ) iend = kg
            if( ista_kngp <= iend ) then

               do ig = ista_kngp, iend  !for mpi
                  drhodh(ig,1,is) = - chgsoft(ig,1,is) * alinvt(i1,i2)
                  drhodh(ig,kimg,is) = - chgsoft(ig,kimg,is) * alinvt(i1,i2)
               enddo
            endif
!!xocl end spread sum(drhodh)
         enddo
      endif
    end subroutine rhos_diff


! ======================================== added by K. Tagami ============= 11.0
    subroutine rhos_diff_noncl(i1,i2)
      integer, intent(in) :: i1,i2
      integer :: is,ig
      integer :: iend  !mpi
      drhodh = 0.d0

      if ( sw_constrain_on_grad_correction == ON ) then
         do is = 1, nspin
            iend = iend_kngp

            if( iend_kngp > kg ) iend = kg
            if( ista_kngp <= iend ) then
               do ig = ista_kngp, iend  !for mpi
                  drhodh(ig,1,is) = -chgsoft_projected_on_Gspace(ig,1,is) &
                       &             *alinvt(i1,i2)
                  drhodh(ig,kimg,is) = -chgsoft_projected_on_Gspace(ig,kimg,is) &
                       &               *alinvt(i1,i2)
               enddo
            endif
         end do
      else
         do is = 1, ndim_magmom
            iend = iend_kngp

            if( iend_kngp > kg ) iend = kg
            if( ista_kngp <= iend ) then
               do ig = ista_kngp, iend  !for mpi
                  drhodh(ig,1,is) = - chgsoft(ig,1,is) * alinvt(i1,i2)
                  drhodh(ig,kimg,is) = - chgsoft(ig,kimg,is) * alinvt(i1,i2)
               enddo
            endif
         end do
      endif
    end subroutine rhos_diff_noncl
! ====================================================================== 11.0

    subroutine rhopc_diff(i1,i2)
      integer, intent(in) :: i1,i2
      integer :: ia,it,ipc,ig
      real(kind=DP) :: pc
      do ia=1,natm
      it=ityp(ia)
      if(itpcc(it)==0) cycle
      call calc_phase2(natm,pos,ia,kgp,ngabc,ista_kngp,iend_kngp,zfcos,zfsin)
                       ! -(b_Elec.)  -> zfcos, zfsin
      ipc=itpcc(it)
      if(nspin.eq.1 .or. af.eq.1) then
         if(kimg.eq.1) then
            do ig = ista_kngp, iend_kngp  !for mpi
               pc = (rhpcg_l(ig,ipc)*alinvt(i1,i2) &
                 &   +rhpcg_diff_l(ig,ipc)*grinv(ig)*g(ig,i1) &
                 &   *(g(ig,1)*alinvt(1,i2)+g(ig,2)*alinvt(2,i2) &
                 &    +g(ig,3)*alinvt(3,i2))) &
                 &   * dble(iwei(ia))
               drhodh(ig,1,1) = drhodh(ig,1,1) &
                 &   - zfcos(ig) * pc / nspin
            enddo
         elseif(kimg.eq.2) then
            do ig = ista_kngp, iend_kngp  !for mpi
               pc = (rhpcg_l(ig,ipc)*alinvt(i1,i2) &
                 &   +rhpcg_diff_l(ig,ipc)*grinv(ig)*g(ig,i1) &
                 &   *(g(ig,1)*alinvt(1,i2)+g(ig,2)*alinvt(2,i2) &
                 &    +g(ig,3)*alinvt(3,i2))) &
                 &   * dble(iwei(ia))
               drhodh(ig,1,1) = drhodh(ig,1,1) &
                 &   - zfcos(ig) * pc / nspin
               drhodh(ig,kimg,1) = drhodh(ig,kimg,1) &
                 &   + zfsin(ig) * pc / nspin
            enddo
         endif
      else
         if(kimg.eq.1) then
            do ig = ista_kngp, iend_kngp  !for mpi
               pc = (rhpcg_l(ig,ipc)*alinvt(i1,i2) &
                 &   +rhpcg_diff_l(ig,ipc)*grinv(ig)*g(ig,i1) &
                 &   *(g(ig,1)*alinvt(1,i2)+g(ig,2)*alinvt(2,i2) &
                 &    +g(ig,3)*alinvt(3,i2))) &
                 &   * dble(iwei(ia))
               drhodh(ig,1,1) = drhodh(ig,1,1) &
                 &   - zfcos(ig) * pc / nspin
               drhodh(ig,1,nspin) = drhodh(ig,1,nspin) &
                 &   - zfcos(ig) * pc / nspin
            enddo
         elseif(kimg.eq.2) then
            do ig = ista_kngp, iend_kngp  !for mpi
               pc = (rhpcg_l(ig,ipc)*alinvt(i1,i2) &
                 &   +rhpcg_diff_l(ig,ipc)*grinv(ig)*g(ig,i1) &
                 &   *(g(ig,1)*alinvt(1,i2)+g(ig,2)*alinvt(2,i2) &
                 &    +g(ig,3)*alinvt(3,i2))) &
                 &   * dble(iwei(ia))
               drhodh(ig,1,1) = drhodh(ig,1,1) &
                 &   - zfcos(ig) * pc / nspin
               drhodh(ig,1,nspin) = drhodh(ig,1,nspin) &
                 &   - zfcos(ig) * pc / nspin
               drhodh(ig,kimg,1) = drhodh(ig,kimg,1) &
                 &   + zfsin(ig) * pc / nspin
               drhodh(ig,kimg,nspin) = drhodh(ig,kimg,nspin) &
                 &   + zfsin(ig) * pc / nspin
            enddo
         endif
      endif
      enddo
    end subroutine rhopc_diff

! ========================================= added by K. Tagami ============ 11.0
    subroutine rhopc_diff_noncl(i1,i2)
      integer, intent(in) :: i1,i2
      integer :: ia,it,ipc,ig
      real(kind=DP) :: pc, ctmp

      if ( sw_constrain_on_grad_correction == ON ) then
         do ia=1, natm
            it = ityp(ia);      ipc = itpcc(it)
            if ( itpcc(it)==0 ) cycle

            call calc_phase2( natm, pos, ia, kgp, ngabc, ista_kngp, iend_kngp, &
                 &            zfcos, zfsin )
                                      ! -(b_Elec.)  -> zfcos, zfsin

            do ig = ista_kngp, iend_kngp  !for mpi
               ctmp = g(ig,1)*alinvt(1,i2) +g(ig,2)*alinvt(2,i2) +g(ig,3)*alinvt(3,i2)
               pc = rhpcg_l(ig,ipc)* alinvt(i1,i2) &
                    &   +rhpcg_diff_l(ig,ipc) *grinv(ig) *g(ig,i1) *ctmp
               pc = pc *dble(iwei(ia))
               drhodh(ig,1,1)        = drhodh(ig,1,1)        -zfcos(ig) *pc /nspin
               drhodh(ig,1,nspin)    = drhodh(ig,1,nspin)    -zfcos(ig) *pc /nspin
               drhodh(ig,kimg,1)     = drhodh(ig,kimg,1)     +zfsin(ig) *pc /nspin
               drhodh(ig,kimg,nspin) = drhodh(ig,kimg,nspin) +zfsin(ig) *pc /nspin
            end do
         end do

      else
         do ia=1, natm
            it = ityp(ia);   ipc = itpcc(it)
            if ( itpcc(it)==0 ) cycle

            call calc_phase2( natm, pos, ia, kgp, ngabc, ista_kngp, iend_kngp, &
                 &            zfcos, zfsin )
                                      ! -(b_Elec.)  -> zfcos, zfsin

            do ig = ista_kngp, iend_kngp  !for mpi
               ctmp = g(ig,1)*alinvt(1,i2) +g(ig,2)*alinvt(2,i2) +g(ig,3)*alinvt(3,i2)
               pc = rhpcg_l(ig,ipc)* alinvt(i1,i2) &
                    &   +rhpcg_diff_l(ig,ipc) *grinv(ig) *g(ig,i1) *ctmp
               pc = pc *dble(iwei(ia))
               drhodh(ig,1,1)    = drhodh(ig,1,1)    -zfcos(ig) *pc
               drhodh(ig,kimg,1) = drhodh(ig,kimg,1) +zfsin(ig) *pc
            enddo
         end do
      endif

    end subroutine rhopc_diff_noncl
! ======================================================================== 11.0

    subroutine rhoh_diff(i1,i2)
      integer, intent(in) :: i1,i2
      integer    :: n,ilm3,i,it,mdvdb,ia
      integer    :: lmt1,lmt2,il1,il2,tau1,tau2,l3,iiqitg
      real(kind=DP) :: fac,dga
      integer, pointer, dimension(:)  :: il3       ! d(n**2)
      real(kind=DP),allocatable,target,dimension(:) :: ylm_t
      real(kind=DP), pointer, dimension(:,:)   :: ylmd_mpi

      if(iprixc >= 2) write(6,'(" << rhoh_diff >>")')
      call m_PP_find_maximum_l(n)   ! n-1: maximum l
      n = (n-1) + (n-1) + 1
      allocate(il3(n**2)); call substitute_il3(n**2,il3) ! -(b_Elec..)
      allocate(ylm_t(ista_kngp:iend_kngp));ylm_t = 0.d0
      allocate(ylmd(ista_kngp:iend_kngp,3,n**2)); ylmd = 0.d0
      allocate(ylmd_mpi(ista_kngp:iend_kngp,3)); ylmd_mpi = 0.d0
      do ilm3 = 1, n**2
!!$!mpi         call m_pwBS_sphrp2(ilm3,rltv,ylm2(1,ilm3))
!!$         call m_pwBS_sphrp2(ilm3,rltv,ylm2_mpi)
!!$         do i = ista_kngp, iend_kngp  !for mpi
!!$            ylm2(i,ilm3) = ylm2_mpi(i)
!!$         enddo
!mpi         call m_pwBS_sphrp2_diff(ilm3,rltv,ylmd(1,1,ilm3))
         call m_pwBS_sphrp2_diff(ilm3,rltv,ylmd_mpi)
         do i = ista_kngp, iend_kngp  !for mpi
            ylmd(i,1,ilm3) = ylmd_mpi(i,1)
            ylmd(i,2,ilm3) = ylmd_mpi(i,2)
            ylmd(i,3,ilm3) = ylmd_mpi(i,3)
         enddo
      end do
      deallocate(ylmd_mpi)

      do ia = 1, natm
         it = ityp(ia)
         mdvdb = m_PP_include_vanderbilt_pot(it)
         if(mdvdb == SKIP) cycle
         call calc_phase2(natm,pos,ia,kgp,ngabc,ista_kngp,iend_kngp,zfcos,zfsin)
            ! -(b_Elec.)  -> zfcos, zfsin
         do lmt1 = 1,ilmt(it)
            il1 = ltp(lmt1,it); tau1 = taup(lmt1,it)
            do lmt2 = lmt1, ilmt(it)
              il2 = ltp(lmt2,it); tau2 = taup(lmt2,it)
              fac = 2.d0 ; if(lmt1 == lmt2) fac = 1.d0
              do n = 1, il2p(lmt1,lmt2,it)
                ilm3 = isph(lmt1,lmt2,n,it)
                l3   =  il3(ilm3)
                iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
                if(iiqitg == 0) cycle
                if(ilm3 <= nel_Ylm) then
                   ylm => ylm_l(ista_kngp:iend_kngp,ilm3)
                else
                   call m_pwBS_sphrp2(ilm3,rltv,ista_kngp,iend_kngp,ylm_t)
                   ylm => ylm_t(ista_kngp:iend_kngp)
                end if
                dga = dl2p(lmt1,lmt2,n,it)

! ===============================- modified by K. Tagami ================ 11.0
!                if(mod(il1+il2,2) == 0) then
!                   call even_case(i1,i2,ilm3,iiqitg,l3,ia,lmt1,lmt2,fac,dga)
!                else
!                   call odd_case(i1,i2,ilm3,iiqitg,l3,ia,lmt1,lmt2,fac,dga)
!                endif
                if ( noncol ) then
                   if(mod(il1+il2,2) == 0) then
                      call even_case_noncl(i1,i2,ilm3,iiqitg,l3,ia,lmt1,lmt2,fac,dga)
                   else
                      call odd_case_noncl(i1,i2,ilm3,iiqitg,l3,ia,lmt1,lmt2,fac,dga)
                   endif
                else
                   if(mod(il1+il2,2) == 0) then
                      call even_case(i1,i2,ilm3,iiqitg,l3,ia,lmt1,lmt2,fac,dga)
                   else
                      call odd_case(i1,i2,ilm3,iiqitg,l3,ia,lmt1,lmt2,fac,dga)
                   endif
                endif
! ========================================================================== 11.0

              enddo
            enddo
         enddo
      enddo
      deallocate(il3);deallocate(ylm_t);deallocate(ylmd)
    end subroutine rhoh_diff

    subroutine even_case(i1,i2,ilm3,iiqitg,l3,ia,lmt1,lmt2,fac,dga)
      integer, intent(in) :: i1,i2,ilm3,iiqitg,l3,ia,lmt1,lmt2
      real(kind=DP), intent(in) :: fac,dga
      integer :: is

      do is=1,nspin,af+1
        flchgq(is) = fac*real(zi**(-l3))*dga &
                   & *hsr(ia,lmt1,lmt2,is)
        flchgqd(i1,i2,is) = fac*real(zi**(-l3))*dga &
                          & *hsrd(ia,lmt1,lmt2,is,i1,i2)
      enddo
      if(kimg == 1) then
         call real_case(i1,i2,ilm3,iiqitg,ia,zfcos)
      else
         call complex_case(i1,i2,ilm3,iiqitg,zfcos,-zfsin)
      endif
    end subroutine even_case

! =================================== added by K. Tagami ================= 11.0
    subroutine even_case_noncl( i1, i2, ilm3, iiqitg, l3, ia, lmt1, lmt2, fac, dga )
      integer, intent(in) :: i1,i2,ilm3,iiqitg,l3,ia,lmt1,lmt2
      real(kind=DP), intent(in) :: fac,dga
      integer :: is

      if ( sw_constrain_on_grad_correction == ON ) then
         do is=1,nspin,af+1
            flchgq(is) = fac *real(zi**(-l3)) *dga &
                 &           *hsr_along_QuantzAxis(ia,lmt1,lmt2,is)
            flchgqd(i1,i2,is) = fac *real(zi**(-l3)) *dga &
                 &                  *hsrd_along_QuantzAxis(ia,lmt1,lmt2,is,i1,i2)
         enddo
         call complex_case(i1,i2,ilm3,iiqitg,zfcos,-zfsin)
      else
         do is=1,ndim_magmom
            flchgq(is) = fac *real(zi**(-l3)) *dga &
                 &           *hsr(ia,lmt1,lmt2,is)
            flchgqd(i1,i2,is) = fac *real(zi**(-l3)) *dga &
                 &                  *hsrd(ia,lmt1,lmt2,is,i1,i2)
         enddo
         call complex_case_noncl(i1,i2,ilm3,iiqitg,zfcos,-zfsin)
      endif

    end subroutine even_case_noncl
! ================================================================= 11.0

    subroutine odd_case(i1,i2,ilm3,iiqitg,l3,ia,lmt1,lmt2,fac,dga)
      integer, intent(in) :: i1,i2,ilm3,iiqitg,l3,ia,lmt1,lmt2
      real(kind=DP), intent(in) :: fac,dga
      integer :: is

      do is=1,nspin,af+1
        flchgq(is) = fac*aimag(zi**(-l3))*dga &
                   & *hsr(ia,lmt1,lmt2,is)
        flchgqd(i1,i2,is) = fac*aimag(zi**(-l3))*dga &
                          & *hsrd(ia,lmt1,lmt2,is,i1,i2)
      enddo
      if(kimg == 1) then
         call real_case(i1,i2,ilm3,iiqitg,ia,zfsin)
      else
         call complex_case(i1,i2,ilm3,iiqitg,zfsin,zfcos)
      endif
    end subroutine odd_case

! =================================== added by K. Tagami ================= 11.0
    subroutine odd_case_noncl( i1, i2, ilm3, iiqitg, l3, ia, lmt1, lmt2, fac, dga )
      integer, intent(in) :: i1,i2,ilm3,iiqitg,l3,ia,lmt1,lmt2
      real(kind=DP), intent(in) :: fac,dga
      integer :: is

      if ( sw_constrain_on_grad_correction == ON ) then
         do is=1, nspin, af+1
            flchgq(is) = fac *aimag(zi**(-l3)) *dga &
                 &           *hsr_along_QuantzAxis(ia,lmt1,lmt2,is)
            flchgqd(i1,i2,is) = fac *aimag(zi**(-l3)) *dga &
                 &                  *hsrd_along_QuantzAxis(ia,lmt1,lmt2,is,i1,i2)
         enddo
         call complex_case(i1,i2,ilm3,iiqitg,zfsin,zfcos)
      else
         do is=1,ndim_magmom
            flchgq(is) = fac *aimag(zi**(-l3)) *dga &
                 &           *hsr(ia,lmt1,lmt2,is)
            flchgqd(i1,i2,is) = fac *aimag(zi**(-l3)) *dga &
                 &                  *hsrd(ia,lmt1,lmt2,is,i1,i2)
         enddo
         call complex_case_noncl(i1,i2,ilm3,iiqitg,zfsin,zfcos)
      endif

    end subroutine odd_case_noncl
! ================================================================= 11.0

    subroutine real_case(i1,i2,ilm3,iiqitg,ia,zf)
      integer,       intent(in) :: i1,i2,ilm3,iiqitg,ia
      real(kind=DP), intent(in), dimension(ista_kngp:iend_kngp) :: zf
      integer :: is, i, iy
      real(kind=DP) :: c1,c2,c3up,c3dn

      do is=1,nspin,af+1
        flchgq(is) = flchgq(is) * dble(iwei(ia))
        flchgqd(i1,i2,is) = flchgqd(i1,i2,is) * dble(iwei(ia))
      enddo
      if(nspin==1 .or. af==1) then
         do i = ista_kngp, iend_kngp  !for mpi
            iy = i - ista_kngp + 1
            c1=(  g(i,1)*alinvt(1,i2) &
             &  + g(i,2)*alinvt(2,i2) &
             &  + g(i,3)*alinvt(3,i2) )  *g(i,i1) * grinv(i)
            c2=(  ylmd(i,1,ilm3)*alinvt(1,i2) &
             &  + ylmd(i,2,ilm3)*alinvt(2,i2) &
             &  + ylmd(i,3,ilm3)*alinvt(3,i2) )  *g(i,i1)
            c3up =  &
             &  - flchgq(1) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,1)*ylm(iy)*qitg_l(i,iiqitg)
            drhodh(i,1,1) = drhodh(i,1,1) &
             &  + c3up * zf(i)
         enddo
      else
         do i = ista_kngp, iend_kngp  !for mpi
            iy = i - ista_kngp + 1
            c1=(  g(i,1)*alinvt(1,i2) &
             &  + g(i,2)*alinvt(2,i2) &
             &  + g(i,3)*alinvt(3,i2) )  *g(i,i1) * grinv(i)
            c2=(  ylmd(i,1,ilm3)*alinvt(1,i2) &
             &  + ylmd(i,2,ilm3)*alinvt(2,i2) &
             &  + ylmd(i,3,ilm3)*alinvt(3,i2) )  *g(i,i1)
            c3up =  &
             &  - flchgq(1) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,1)*ylm(iy)*qitg_l(i,iiqitg)
            c3dn =  &
             &  - flchgq(nspin) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,nspin)*ylm(iy)*qitg_l(i,iiqitg)
            drhodh(i,1,1) = drhodh(i,1,1) &
             &  + c3up * zf(i)
            drhodh(i,1,nspin) = drhodh(i,1,nspin) &
             &  + c3dn * zf(i)
         enddo
      endif
    end subroutine real_case

    subroutine complex_case(i1,i2,ilm3,iiqitg,zf1,zf2)
      integer,       intent(in) :: i1,i2,ilm3,iiqitg
      real(kind=DP), intent(in), dimension(ista_kngp:iend_kngp) &
           &        :: zf1,zf2      ! MPI
      real(kind=DP) :: c1,c2,c3up,c3dn
      integer       :: i, iy

      if(nspin==1 .or. af==1) then
         do i = ista_kngp, iend_kngp  !for mpi
            iy = i - ista_kngp+1
            c1=(  g(i,1)*alinvt(1,i2) &
             &  + g(i,2)*alinvt(2,i2) &
             &  + g(i,3)*alinvt(3,i2) )  *g(i,i1) * grinv(i)
            c2=(  ylmd(i,1,ilm3)*alinvt(1,i2) &
             &  + ylmd(i,2,ilm3)*alinvt(2,i2) &
             &  + ylmd(i,3,ilm3)*alinvt(3,i2) )  *g(i,i1)
            c3up =  &
             &  - flchgq(1) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,1)*ylm(iy)*qitg_l(i,iiqitg)
            drhodh(i,1,1) = drhodh(i,1,1) &
             &  + c3up * zf1(i)
            drhodh(i,kimg,1) = drhodh(i,kimg,1) &
             &  + c3up * zf2(i)
         enddo
      else
         do i = ista_kngp, iend_kngp  !for mpi
            iy = i - ista_kngp+1
            c1=(  g(i,1)*alinvt(1,i2) &
             &  + g(i,2)*alinvt(2,i2) &
             &  + g(i,3)*alinvt(3,i2) )  *g(i,i1) * grinv(i)
            c2=(  ylmd(i,1,ilm3)*alinvt(1,i2) &
             &  + ylmd(i,2,ilm3)*alinvt(2,i2) &
             &  + ylmd(i,3,ilm3)*alinvt(3,i2) )  *g(i,i1)
            c3up =  &
             &  - flchgq(1) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,1)*ylm(iy)*qitg_l(i,iiqitg)
            c3dn =  &
             &  - flchgq(nspin) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,nspin)*ylm(iy)*qitg_l(i,iiqitg)
            drhodh(i,1,1) = drhodh(i,1,1) &
                 &  + c3up * zf1(i)
            drhodh(i,kimg,1) = drhodh(i,kimg,1) &
                 &  + c3up * zf2(i)
            drhodh(i,1,nspin) = drhodh(i,1,nspin) &
                 &  + c3dn * zf1(i)
            drhodh(i,kimg,nspin) = drhodh(i,kimg,nspin) &
                 &  + c3dn * zf2(i)
        enddo
      endif
    end subroutine complex_case

! ======================================= added by K. Tagami ================= 11.0
    subroutine complex_case_noncl(i1,i2,ilm3,iiqitg,zf1,zf2)
      integer,       intent(in) :: i1,i2,ilm3,iiqitg
      real(kind=DP), intent(in), dimension(ista_kngp:iend_kngp) &
           &        :: zf1,zf2      ! MPI
      real(kind=DP) :: c1,c2,c3
      integer       :: i, is, iy

      do i = ista_kngp, iend_kngp  !for mpi
         iy = i - ista_kngp+1
         c1=(  g(i,1)*alinvt(1,i2) &
              &  + g(i,2)*alinvt(2,i2) &
              &  + g(i,3)*alinvt(3,i2) )  *g(i,i1) * grinv(i)
         c2=(  ylmd(i,1,ilm3)*alinvt(1,i2) &
              &  + ylmd(i,2,ilm3)*alinvt(2,i2) &
              &  + ylmd(i,3,ilm3)*alinvt(3,i2) )  *g(i,i1)

         Do is=1, ndim_magmom
            c3 =  -flchgq(is) &
                 &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
                 &  +qitg_diff_l(i,iiqitg)*c1) &
                 &  +c2*qitg_l(i,iiqitg)) &
                 &  + flchgqd(i1,i2,is)*ylm(iy)*qitg_l(i,iiqitg)
            drhodh(i,1,is)    = drhodh(i,1,is)    +c3 *zf1(i)
            drhodh(i,kimg,is) = drhodh(i,kimg,is) +c3 *zf2(i)
         End do
      enddo

    end subroutine complex_case_noncl
! ==================================================================== 11.0

    subroutine map_drhodh1(is)
      integer, intent(in) :: is
      integer :: i,ip,ri
      real(kind=DP), allocatable, dimension(:) :: chgfft_mpi4

      chgfft_mpi = 0.d0
      do ri = 1, kimg
         do i = ista_kngp, min(kgp_reduced, iend_kngp)  !for mpi
#ifdef _MPIFFT_
            ip = igfp_l_c(i)*kimg - kimg + ri
#else
            ip = igfp_l(i)*kimg - kimg + ri
#endif
            chgfft_mpi(ip)  = chgfft_mpi(ip) + drhodh(i,ri,is)
         end do
      end do

      if(npes >= 2) then
         allocate(chgfft_mpi4(nfftp))
         call mpi_allreduce(chgfft_mpi,chgfft_mpi4,nfftp &
              & ,mpi_double_precision, mpi_sum, mpi_comm_group,ierr)
         chgfft(ista_fftp:iend_fftp) = chgfft_mpi4(ista_fftp:iend_fftp)
         deallocate(chgfft_mpi4)
      else
         chgfft = chgfft_mpi
      end if
!!$      call subst_A_into_A_reduced  ! -(contained in subrt. m_XC_cal_potential) MPI
!!$      !   A=chgfft_mpi,A_reduced=chgfft, using work arrays; chgfft_mpi -> chgfft
    end subroutine map_drhodh1

!!$    subroutine subst_A_into_A_reduced
!!$      real(kind=DP), pointer, dimension(:)      :: chgfft_mpi_reduced &
!!$           &          ,                            chgfft_mpi_reduced2   ! MPI
!!$      integer :: i, ip
!!$      if(npes_cdfft >= 2) then
!!$         allocate(chgfft_mpi_reduced(mp_fftp))   ! MPI
!!$         allocate(chgfft_mpi_reduced2(mp_fftp))  ! MPI
!!$         do i = 0, npes_cdfft-1                                            ! MPI
!!$            do ip = 1, nel_fftp(i)                                        ! MPI
!!$               chgfft_mpi_reduced(ip) = chgfft_mpi(ip + nis_fftp(i) - 1)  ! MPI
!!$            end do! MPI
!!$            if(myrank_ggacmp < nrank_ggacmp) then
!!$               call mpi_allreduce(chgfft_mpi_reduced,chgfft_mpi_reduced2, nel_fftp(i) &
!!$                    &, mpi_double_precision, mpi_sum, mpi_cdfft_world(myrank_ggacmp), ierr)  ! MPI
!!$            end if
!!$
!!$            if(myrank_cdfft == i) then                                            ! MPI
!!$               do ip = 1, nel_fftp(i)                                     ! MPI
!!$                  chgfft(ip + ista_fftp - 1) = chgfft_mpi_reduced2(ip)    ! MPI
!!$               end do                                                     ! MPI
!!$            end if                                                        ! MPI
!!$         end do                                                           ! MPI
!!$         deallocate(chgfft_mpi_reduced)
!!$         deallocate(chgfft_mpi_reduced2)
!!$      else if(npes_cdfft == 1) then
!!$         chgfft = chgfft_mpi
!!$      end if
!!$    end subroutine subst_A_into_A_reduced

    subroutine map_drhodh2
      integer :: i,ip,ri
      real(kind=DP), allocatable, dimension(:) :: chgfft_mpi4

      chgfft_mpi = 0.d0
      do ri = 1, kimg
         do i = ista_kngp, min(kgp_reduced, iend_kngp)  ! for mpi
#ifdef _MPIFFT_
            ip = igfp_l_c(i)*kimg - kimg + ri
#else
            ip = igfp_l(i)*kimg - kimg + ri
#endif
            chgfft_mpi(ip) = chgfft_mpi(ip) + drhodh(i,ri,1) + drhodh(i,ri,nspin)
         end do
      end do

      if(npes >= 2) then
         allocate(chgfft_mpi4(nfftp))
         call mpi_allreduce(chgfft_mpi, chgfft_mpi4, nfftp &
              & , mpi_double_precision, mpi_sum, mpi_comm_group,ierr)
         chgfft(ista_fftp:iend_fftp) = chgfft_mpi4(ista_fftp:iend_fftp)
      else
         chgfft = chgfft_mpi
      end if

!!$      call subst_A_into_A_reduced   ! -(contained in subrt. m_XC_cal_potential) MPI
!!$      !   A=chgfft_mpi,A_reduced=chgfft, using work arrays; chgfft_mpi -> chgfft
    end subroutine map_drhodh2

    subroutine dgrhodh1(i1,i2,in,is)
      integer, intent(in) :: i1,i2,in,is
      integer       :: n
      real(kind=DP) :: g1,g2

      do n = ista_fftp, iend_fftp                     ! MPI
         g1 = rltv(in,1)*inx(n)+rltv(in,2)*jnx(n)+rltv(in,3)*knx(n)
         g2 = rltv(i1,1)*inx(n)+rltv(i1,2)*jnx(n)+rltv(i1,3)*knx(n)
         afft(n) = g1*chgfft(n) - chden_l(n,is)*g2*alinvt(in,i2)
      enddo
      call boundary_zero_into_afft(in)  ! -(contained in subr. m_XC_cal_potential)

      call m_FFT_CD_inverse_c(nfout,afft)

      do n = ista_fftph, iend_fftph     ! MPI
         dF_drho(n,is) = afft(2*n)
      enddo
    end subroutine dgrhodh1

! ======================================== added by K. Tagami ================ 11.0
    subroutine dgrhodh1_noncl(i1,i2,in,is)
      integer, intent(in) :: i1,i2,in,is
      integer       :: n
      real(kind=DP) :: g1,g2

      do n = ista_fftp, iend_fftp                     ! MPI
         g1 = rltv(in,1)*inx(n)+rltv(in,2)*jnx(n)+rltv(in,3)*knx(n)
         g2 = rltv(i1,1)*inx(n)+rltv(i1,2)*jnx(n)+rltv(i1,3)*knx(n)
         afft(n) = g1*chgfft(n) - chden_l(n,is)*g2*alinvt(in,i2)
      enddo
      call boundary_zero_into_afft(in)  ! -(contained in subr. m_XC_cal_potential)

      call m_FFT_CD_inverse_c(nfout,afft)

    end subroutine dgrhodh1_noncl
! ===================================================================== 11.0

    subroutine dgrhodh2(i1,i2,in)
      integer, intent(in) :: i1,i2,in
      integer       :: n
      real(kind=DP) :: g1,g2

      do n = ista_fftp, iend_fftp
         g1 = rltv(in,1)*inx(n)+rltv(in,2)*jnx(n)+rltv(in,3)*knx(n)
         g2 = rltv(i1,1)*inx(n)+rltv(i1,2)*jnx(n)+rltv(i1,3)*knx(n)
         afft(n) = g1*chgfft(n) &
              &   - (chden_l(n,1)+chden_l(n,nspin))*g2*alinvt(in,i2)
      enddo
      call boundary_zero_into_afft(in)   ! -(contained in subr. m_XC_cal_potential)

      call m_FFT_CD_inverse_c(nfout,afft)

      do n = ista_fftph, iend_fftph      ! MPI
         dF_drho(n,1) = afft(2*n)
      enddo
    end subroutine dgrhodh2

#ifdef _XC_SAVE_MEMORY_
    subroutine gradrho1(in,is)
      integer, intent(in) :: in,is
      integer :: m
      call g_xyz_chden_l(in,is)          ! G_xyz * rho(G) --> afft
      call m_FFT_CD_inverse_c(nfout,afft)  ! (-i)*d(rho(r))/d(x|y|z)
      do m = ista_fftph, iend_fftph      ! MPI
         cggawk13(m) = afft(2*m)
      enddo
    end subroutine gradrho1

    subroutine gradrho2(in)
      integer, intent(in) ::in
      integer :: m
      call g_xyz_total_chden_l(in)       ! G_xyz*(rho(G)up+rho(G)down) -> afft
      call m_FFT_CD_inverse_c(nfout,afft)  !(-i)*d(rho_total(r))/d(x|y|z)
      do m = ista_fftph, iend_fftph      ! MPI
         cggawk13(m) = afft(2*m)
      enddo
    end subroutine gradrho2
#endif

    subroutine allocate_for_stress
      integer :: i
      real(kind=DP) :: ga,gb,gc
      allocate(alinvt(3,3)); alinvt = rltv / PAI2
      allocate(zfcos(ista_kngp:iend_kngp)); zfcos = 0.d0
      allocate(zfsin(ista_kngp:iend_kngp)); zfsin = 0.d0

! ========== KT_mod ============ 2013/10/29
!      allocate(drhodh(ista_kngp:iend_kngp,kimg,nspin)); drhodh = 0.d0
!      allocate(flchgq(nspin)); flchgq = 0.d0
!      allocate(flchgqd(3,3,nspin)); flchgqd = 0.d0
!
      if ( noncol .and. sw_constrain_on_grad_correction == OFF ) then
         allocate(drhodh(ista_kngp:iend_kngp,kimg,ndim_magmom)); drhodh = 0.d0
         allocate(flchgq(ndim_magmom)); flchgq = 0.d0
         allocate(flchgqd(3,3,ndim_magmom)); flchgqd = 0.d0
      else
         allocate(drhodh(ista_kngp:iend_kngp,kimg,nspin)); drhodh = 0.d0
         allocate(flchgq(nspin)); flchgq = 0.d0
         allocate(flchgqd(3,3,nspin)); flchgqd = 0.d0
      endif
! ============================= 2013/10/29

      allocate(chgfft(ista_fftp:iend_fftp)); chgfft = 0.d0  ! MPI
      allocate(grinv(ista_kngp:iend_kngp)); grinv = 0.d0
      allocate(g(ista_kngp:iend_kngp,3)); g = 0.d0

      do i = ista_kngp, iend_kngp  !for mpi
        if(gr_l(i).lt.1.0d-20) then
          grinv(i)=0.d0
        else
          grinv(i)=1.d0/gr_l(i)
        endif
      enddo

      do i = ista_kngp, iend_kngp  !for mpi
        ga = ngabc(i,1)
        gb = ngabc(i,2)
        gc = ngabc(i,3)
        g(i,1) = rltv(1,1)*ga+rltv(1,2)*gb+rltv(1,3)*gc
        g(i,2) = rltv(2,1)*ga+rltv(2,2)*gb+rltv(2,3)*gc
        g(i,3) = rltv(3,1)*ga+rltv(3,2)*gb+rltv(3,3)*gc
      enddo
      allocate(chgfft_mpi(nfftp))             ! MPI

    end subroutine allocate_for_stress

    subroutine deallocate_for_stress
      deallocate(alinvt)
      deallocate(drhodh)
      deallocate(zfcos)
      deallocate(zfsin)
      deallocate(flchgq)
      deallocate(flchgqd)
      deallocate(chgfft)
      deallocate(grinv)
      deallocate(g)
      deallocate(chgfft_mpi)
    end subroutine deallocate_for_stress

    subroutine abs_grad_rho_up_down_total()
      real(kind=DP),allocatable,dimension(:)    :: grad_rho_c2  ! MPI d(ista_fftph:iend_fftph)

      integer  :: is, in, i
      real(kind=DP) :: x,y,z

#ifdef _DETAIL_GGA_TIMING_
      integer :: id_sname = -1
#endif

      if(nrank_ggacmp > 1) allocate(grad_rho_c2(ista_fftph:iend_fftph))    ! MPI

      do is = 1, ispin
         grad_rho(:,is) = 0.d0
         do in = 1, 3
            if(map_ggacmp(in) /= myrank_ggacmp) cycle
            call g_xyz_chden_l(in,is)        ! G_xyz * rho_{up|down}(G)-->afft
            if(iprixc >= 2) call wd_small_part_of_afft(34,'G space before<m_FFT_CD_inverse_c)',120)
            call m_FFT_CD_inverse_c(nfout,afft)! (-i)*d(rho_{up|down}(r))/d(x|y|z)
            if(iprixc >= 2) call wd_small_part_of_afft(34,'R space after <m_FFT_CD_inverse_c)',120)
#ifndef _XC_SAVE_MEMORY_
            call cp_afft_to_cgrad_rho(is,in) ! -> cgrad_rho(i,in,is) = -afft(i*2)
#endif
            call add_sq_afft_to_grad_rho(is) ! grad_rho <--  + afft**2
            if(iprixc >= 2) then
               write(nfout,'(" !XC after add_sq_afft_to_grad_rho: is, in = ",2i8)') is, in
               write(nfout,'(" !XC -- grad_rho -- <<abs_grad_rho_up_down_total>>")')
               write(nfout,'(" !XC ",6f12.6)') (grad_rho(i,1),i=ista_fftph,ista_fftph+17)
               write(nfout,'(" !XC ",6f12.6)') (grad_rho(i,1),i=iend_fftph-17,iend_fftph)
#ifndef _XC_SAVE_MEMORY_
               write(nfout,'(" !XC -- cgrad_rho -- <<abs_grad_rho_up_down_total>>")')
               write(nfout,'(" !XC ",6f12.6)') (cgrad_rho(i,in,1),i=ista_fftph,ista_fftph+17)
               write(nfout,'(" !XC ",6f12.6)') (cgrad_rho(i,in,1),i=iend_fftph-17,iend_fftph)
#endif
            end if

         end do

         if(iprixc >= 2) write(nfout,'(" !XC after add_sq_afft_to_grad_rho")')

         ! --> grad_rho_c
         if(nrank_ggacmp > 1) then
            grad_rho_c2(:) = grad_rho(:,is)
#ifdef _DETAIL_GGA_TIMING_
            call tstatc0_begin('mpi_allreduce(ggaxcp) ',id_sname)
#endif
            call mpi_allreduce(grad_rho_c2,grad_trho,iend_fftph-ista_fftph+1 &
                 & ,mpi_double_precision, mpi_sum, mpi_ggacmp_cross_world(myrank_cdfft),ierr)
#ifdef _DETAIL_GGA_TIMING_
            call tstatc0_end(id_sname)
#endif
            grad_rho(:,is) = dsqrt(grad_trho(:))
         else
            grad_rho(:,is) = dsqrt(grad_rho(:,is)) ! grad_rho(s) <-- |grad(rho_s(r))|
         end if
      enddo
      if(ispin == 2) then
#ifndef _XC_SAVE_MEMORY_
         if(nrank_ggacmp > 1) then
            grad_rho_c2 = 0.d0
!!$            if(myrank_ggacmp >= 0 .and. myrank_ggacmp <=2) then
            do i = ista_fftph, iend_fftph
               x = cgrad_rho(i,myrank_ggacmp+1,1) + cgrad_rho(i,myrank_ggacmp+1,2)
               grad_rho_c2(i) = grad_rho_c2(i) + x*x
            end do
#ifdef _DETAIL_GGA_TIMING_
            call tstatc0_begin('mpi_allreduce(ggaxcp) ',id_sname)
#endif
            call mpi_allreduce(grad_rho_c2,grad_trho,iend_fftph-ista_fftph+1 &
                 & , mpi_double_precision, mpi_sum, mpi_ggacmp_cross_world(myrank_cdfft),ierr)
#ifdef _DETAIL_GGA_TIMING_
            call tstatc0_end(id_sname)
#endif
            grad_trho = dsqrt(grad_trho)
         else
            do in = ista_fftph, iend_fftph
               x = cgrad_rho(in,1,1) + cgrad_rho(in,1,2)
               y = cgrad_rho(in,2,1) + cgrad_rho(in,2,2)
               z = cgrad_rho(in,3,1) + cgrad_rho(in,3,2)
               grad_trho(in) = dsqrt(x*x+y*y+z*z)
            end do
         end if
#else
         do in = 1, 3
            call g_xyz_total_chden_l(in)     ! G_xyz*(rho(G)up+rho(G)down) -> afft
            call m_FFT_CD_inverse_c(nfout,afft)!(-i)*d(rho_total(r))/d(x|y|z)
            call add_sq_afft_to_grad_trho
         end do
         grad_trho = dsqrt(grad_trho)     ! grad_trho <-- |grad(rho_total(r))|
#endif
      else
         grad_trho(:) = grad_rho(:,1)
      end if

! ========================== added by K. Tagami ============ experimental === 11.0
#ifdef APPROX_GGA_NONCL
      if ( noncol ) then
         grad_trho(:) = grad_rho(:,1) + grad_rho(:,2)
      endif
#endif
! ============================================================================ 11.0

      if(nrank_ggacmp > 1) deallocate(grad_rho_c2)
    end subroutine abs_grad_rho_up_down_total

! ======================================== added by K. Tagami =============== 11.0
    subroutine abs_grad_rho_updown_total_noncl()
      real(kind=DP),allocatable,dimension(:)    :: grad_rho_c2
                                                    ! MPI d(ista_fftph:iend_fftph)

      integer  :: is, in, i
      real(kind=DP) :: x,y,z

#ifdef _DETAIL_GGA_TIMING_
      integer :: id_sname = -1
#endif

! ==== KT_add === 2014/08/04
      if ( sw_monitor_magnetic_vorticity == ON ) then
         allocate( MagVorticity(ista_fftph:iend_fftph, 3 ) )
         MagVorticity = 0.0d0
      endif
! =============== 2014/08/04

      allocate( bfft_kt( ista_fftp:iend_fftp,ndim_magmom )); bfft_kt = 0.0d0
      if (nrank_ggacmp > 1) allocate( grad_rho_c2(ista_fftph:iend_fftph) )    ! MPI

      grad_rho = 0.0d0;  grad_trho = 0.0d0

      do in = 1, 3
         if(map_ggacmp(in) /= myrank_ggacmp) cycle

         bfft_kt = 0.0d0

         Do is=1, ndim_magmom
            call g_xyz_chden_l(in,is)        ! G_xyz * rho_{up|down}(G)-->afft
            if ( iprixc >= 2 ) then
               call wd_small_part_of_afft(34,'G space before<m_FFT_CD_inverse_c)',120)
            endif
            call m_FFT_CD_inverse_c(nfout,afft)! (-i)*d(rho_{up|down}(r))/d(x|y|z)

            if (iprixc >= 2) then
               call wd_small_part_of_afft(34,'R space after <m_FFT_CD_inverse_c)',120)
            endif
            bfft_kt(:,is) = afft(:)
         End Do

! ====== KT_add ==== 2014/08/04
         if ( sw_monitor_magnetic_vorticity == ON ) then
            call m_ES_add_contrib_to_Vorticity( in, bfft_kt, MagVorticity )
         endif
! ================== 2014/08/04

         call m_ES_GradCorr_Along_QuantzAxis2( RhoMag_R, bfft_kt, &
              &                                quantz_axis_inversion_flg_mesh )

         afft = 0.0d0

         do is = 1, ispin
            afft(:) = bfft_kt(:,is)
#ifndef _XC_SAVE_MEMORY_
            call cp_afft_to_cgrad_rho(is,in) ! -> cgrad_rho(i,in,is) = -afft(i*2)
#endif
            call add_sq_afft_to_grad_rho(is) ! grad_rho <--  + afft**2

            if(iprixc >= 2) then
               write(nfout,'(" !XC after add_sq_afft_to_grad_rho: is, in = ",2i8)') is,in
               write(nfout,'(" !XC -- grad_rho -- <<abs_grad_rho_up_down_total>>")')
               write(nfout,'(" !XC ",6f12.6)') (grad_rho(i,1),i=ista_fftph,ista_fftph+17)
               write(nfout,'(" !XC ",6f12.6)') (grad_rho(i,1),i=iend_fftph-17,iend_fftph)

#ifndef _XC_SAVE_MEMORY_
               write(nfout,'(" !XC -- cgrad_rho -- <<abs_grad_rho_up_down_total>>")')
               write(nfout,'(" !XC ",6f12.6)') &
                    &               (cgrad_rho(i,in,1),i=ista_fftph,ista_fftph+17)
               write(nfout,'(" !XC ",6f12.6)') &
                    &               (cgrad_rho(i,in,1),i=iend_fftph-17,iend_fftph)
#endif
            end if

         end do

      end do

      if(iprixc >= 2) write(nfout,'(" !XC after add_sq_afft_to_grad_rho")')

      Do is=1, ispin
! --> grad_rho_c
         if(nrank_ggacmp > 1) then
            grad_rho_c2(:) = grad_rho(:,is)
#ifdef _DETAIL_GGA_TIMING_
            call tstatc0_begin('mpi_allreduce(ggaxcp) ',id_sname)
#endif
            call mpi_allreduce( grad_rho_c2, grad_trho, iend_fftph -ista_fftph +1, &
                 &              mpi_double_precision, mpi_sum, &
                 &              mpi_ggacmp_cross_world(myrank_cdfft), ierr )
#ifdef _DETAIL_GGA_TIMING_
            call tstatc0_end(id_sname)
#endif
            grad_rho(:,is) = dsqrt(grad_trho(:))
         else
            grad_rho(:,is) = dsqrt(grad_rho(:,is)) ! grad_rho(s) <-- |grad(rho_s(r))|
         end if
      enddo

      if (ispin == 2) then
#ifndef _XC_SAVE_MEMORY_
         if (nrank_ggacmp > 1) then
            grad_rho_c2 = 0.d0
!!$            if(myrank_ggacmp >= 0 .and. myrank_ggacmp <=2) then
            do i = ista_fftph, iend_fftph
               x = cgrad_rho(i,myrank_ggacmp+1,1) + cgrad_rho(i,myrank_ggacmp+1,2)
               grad_rho_c2(i) = grad_rho_c2(i) + x*x
            end do
#ifdef _DETAIL_GGA_TIMING_
            call tstatc0_begin('mpi_allreduce(ggaxcp) ',id_sname)
#endif
            call mpi_allreduce( grad_rho_c2, grad_trho, iend_fftph -ista_fftph +1, &
                 &              mpi_double_precision, mpi_sum, &
                 &              mpi_ggacmp_cross_world(myrank_cdfft), ierr )
#ifdef _DETAIL_GGA_TIMING_
            call tstatc0_end(id_sname)
#endif
            grad_trho = dsqrt(grad_trho)

         else
            do in = ista_fftph, iend_fftph
               x = cgrad_rho(in,1,1) + cgrad_rho(in,1,2)
               y = cgrad_rho(in,2,1) + cgrad_rho(in,2,2)
               z = cgrad_rho(in,3,1) + cgrad_rho(in,3,2)
               grad_trho(in) = dsqrt(x*x+y*y+z*z)
            end do
         end if
#else
         do in = 1, 3
!            call g_xyz_total_chden_l(in)     ! G_xyz*(rho(G)up+rho(G)down) -> afft
            call g_xyz_chden_l(in,1)     ! G_xyz*(rho(G)up+rho(G)down) -> afft
            call m_FFT_CD_inverse_c(nfout,afft)!(-i)*d(rho_total(r))/d(x|y|z)
            call add_sq_afft_to_grad_trho
         end do
         grad_trho = dsqrt(grad_trho)     ! grad_trho <-- |grad(rho_total(r))|
#endif
      else
         grad_trho(:) = grad_rho(:,1)
      end if

#ifdef APPROX_GGA_NONCL
      if ( noncol ) then
         grad_trho(:) = grad_rho(:,1) + grad_rho(:,2)
      endif
#endif

      if (nrank_ggacmp > 1) deallocate(grad_rho_c2)
      deallocate( bfft_kt )

    end subroutine abs_grad_rho_updown_total_noncl
! ============================================================================= 11.0

! ==== KT_add ================================= 13.0XX
    subroutine grad2_rho_up_down()
      integer  :: is, i

      real(kind=DP) :: x,y,z
      real(kind=DP), allocatable :: grad_rho_c2(:)   ! d(ista_fftph:iend_fftph)

      if (nrank_ggacmp > 1) allocate(grad_rho_c2(ista_fftph:iend_fftph))    ! MPI

      do is = 1, ispin
         grad2_rho(:,is) = 0.d0

         call g2_xyz_chden_l(is)        ! G2 * rho_{up|down}(G)-->afft
         call m_FFT_CD_inverse_c(nfout,afft)   !  Laplacian of (rho_up/dn (r) )
         call cp_afft_to_grad2_rho(is)

         ! --> grad_rho_c
         if (nrank_ggacmp > 1) then
            grad_rho_c2(:) = grad2_rho(:,is)
            call mpi_allreduce( grad_rho_c2, grad2_rho(:,is), iend_fftph-ista_fftph+1, &
                 &              mpi_double_precision, mpi_sum, &
                 &              mpi_ggacmp_cross_world(myrank_cdfft), ierr )
         end if

      enddo
      if (nrank_ggacmp > 1) deallocate(grad_rho_c2)

    end subroutine grad2_rho_up_down
! =============================================== 13.0XX

!!$    subroutine c2g2r_sfftph(grad_rho_c2,grad_rho)
!!$      real(kind=DP),intent(in), dimension(ista_fftph:iend_fftph) :: grad_rho_c2
!!$      real(kind=DP),intent(out),dimension(ista_sfftph: iend_sfftph)  :: grad_rho
!!$      real(kind=DP), allocatable, dimension(:) :: grad_rho_g ! d(nfftp)
!!$
!!$      if(npes_cdfft >= 2) then
!!$         allocate(grad_rho_g(nfftp))
!!$         if(myrank_ggacmp < nrank_ggacmp ) then
!!$            call mpi_allgatherv(grad_rho_c2,nel_fftph(myrank_cdfft),mpi_double_precision &
!!$                 & , grad_rho_g, nel_fftph, idisp_fftph &
!!$                 & , mpi_double_precision,mpi_cdfft_world(myrank_ggacmp),ierr)
!!$         end if
!!$         if(nrest_cdfft >= 1) then
!!$            if(mype > npes_cdfft*nrank_ggacmp - 1) then
!!$               call mpi_recv(grad_rho_g,nfftp,mpi_double_precision &
!!$                    & ,mype - npes_cdfft*nrank_ggacmp,1,mpi_comm_group,istatus,ierr)
!!$            end if
!!$            if(mype < nrest_cdfft) then
!!$               call mpi_send(grad_rho_g,nfftp,mpi_double_precision &
!!$                    & ,mype + npes_cdfft*nrank_ggacmp,1,mpi_comm_group,ierr)
!!$            end if
!!$         end if
!!$               ! -- scatter --
!!$         grad_rho(ista_sfftph:iend_sfftph) = grad_rho_g(ista_sfftph:iend_sfftph)
!!$         deallocate(grad_rho_g)
!!$      else
!!$         grad_rho(ista_sfftph:iend_sfftph) = grad_rho_c2(ista_sfftph:iend_sfftph)
!!$      end if
!!$    end subroutine c2g2r_sfftph

    subroutine dFxc_over_ddgradrho()
      real(kind=DP),allocatable,dimension(:)    :: grad_rho_c2  ! MPI d(ista_fftph:iend_fftph)
      real(kind=DP),allocatable,dimension(:)    :: grad_rho_c4  ! MPI d(ista_fftph:iend_fftph)
      integer  :: is, in
      real(kind=DP),pointer,dimension(:)  :: x
#ifdef _DETAIL_GGA_TIMING_
      integer :: id_sname = -1
#endif

!!$      if(myrank_ggacmp >= nrank_ggacmp) goto 1003

      if(nrank_ggacmp > 1)  allocate(grad_rho_c2(ista_fftph:iend_fftph),grad_rho_c4(ista_fftph:iend_fftph))   ! MPI

#ifndef _XC_SAVE_MEMORY_
      do is = 1, ispin
         grad_rho(:,is) = 0.d0
         do in = 1, 3
            if(map_ggacmp(in) /= myrank_ggacmp) cycle
            call dFxc_dgradrho_dot_gradrho2(rinplw,in,ispin,is)
            ! grad_{in}(rho_{is})*dFx/d|grad(rho_{is})| + grad_{in}(rho)*dFc/d|grad(rho)|  -> afft
            if(iprixc >= 2) write(nfout,'(" is, in = ",2i8)') is, in
            if(iprixc >= 2) call wd_small_part_of_afft(33,'R space before<m_FFT_CD_direct_c)',120)
            call m_FFT_CD_direct_c(nfout,afft)     ! afft (= q_{in}(G))
            if(iprixc >= 2) call wd_small_part_of_afft(33,'G space after <m_FFT_CD_direct_c)',120)
            call G_xyz_afft(in)                    ! G_{in}q_{in}(G)  -> afft
            call m_FFT_CD_inverse_c(nfout,afft)    ! afft -> afft
            if(iprixc >= 2) call wd_small_part_of_afft(33,'R space after <m_FFT_CD_direct_c)',120)
            call add_negative_afft_to_grad_rho(is) ! afft -> grad_rho
         end do
         if(nrank_ggacmp > 1) then
            grad_rho_c2(:) = grad_rho(:,is)
            call mpi_allreduce(grad_rho_c2,grad_rho_c4,iend_fftph-ista_fftph+1 &
                 & ,mpi_double_precision, mpi_sum, mpi_ggacmp_cross_world(myrank_cdfft),ierr)
            grad_rho(:,is) = grad_rho_c4(:)
         end if
      end do
#else
      if(ispin == 1) then
         is = 1
         grad_rho(:,is) = 0.d0
         do in = 1, 3
            if(map_ggacmp(in) /= myrank_ggacmp) cycle
            call g_xyz_chden_l(in,is)          ! G_xyz * rho(G) --> afft
            call m_FFT_CD_inverse_c(nfout,afft)  ! (-i)*d(rho(r))/d(x|y|z)
            call cp_afft_to_cggawk13           ! -afft --> cggawk13
            call dFxc_dgradrho_dot_gradrho(rinplw) ! grad(rho)*dFxc/d|grad(rho)| -> afft
            ! Calculation i-th component df/d(d|grad n|) in recip. space
            call m_FFT_CD_direct_c(nfout,afft)
            call G_xyz_afft(in)
            call m_FFT_CD_inverse_c(nfout,afft)
            call add_negative_afft_to_grad_rho(1)
            !  --> grad_rho
         end do
         if(nrank_ggacmp > 1) then
            grad_rho_c2(:) = grad_rho(:,is)
#ifdef _DETAIL_GGA_TIMING_
            call tstatc0_begin('mpi_allreduce(ggaxcp) ',id_sname)
#endif
            call mpi_allreduce(grad_rho_c2,grad_rho_c4,iend_fftph-ista_fftph+1 &
                 & ,mpi_double_precision, mpi_sum, mpi_ggacmp_cross_world(myrank_cdfft),ierr)
#ifdef _DETAIL_GGA_TIMING_
            call tstatc0_end(id_sname)
#endif
            grad_rho(:,is) = grad_rho_c4(:)
         end if
      else if(ispin == 2) then
         do is = 1, 2
            grad_rho(:,is) = 0.d0
            do in = 1, 3
               if(map_ggacmp(in) /= myrank_ggacmp) cycle
               call g_xyz_chden_l(in,is)          ! G_xyz * rho_{is}(G) --> afft
               call m_FFT_CD_inverse_c(nfout,afft)  ! (-i)*d(rho_{is}(r))/d(x|y|z)
               call cp_afft_to_cggawk13           ! -afft --> cggawk13
               x => dF_dgradrho(ista_fftph:iend_fftph,is)
               call x_dot_cggawk13_into_afft(rinplw,x)
               !  grad(rho) * dFx/d|grad(rho)|

               ! Calculation i-th component df/d(d|grad n|) in recip. space
               call m_FFT_CD_direct_c(nfout,afft)
               call G_xyz_afft(in)
               call m_FFT_CD_inverse_c(nfout,afft)
               call add_negative_afft_to_grad_rho(is)
               !  --> grad_rho
            end do
         end do
         !--> correlation part
         do in = 1, 3
            if(map_ggacmp(in) /= myrank_ggacmp) cycle
            call g_xyz_total_chden_l(in)
            call m_FFT_CD_inverse_c(nfout,afft) ! (-i)*d(rho(r))/d(x|y|z)
            call cp_afft_to_cggawk13        ! -afft --> cggawk13
            x => grad_trho(ista_fftph:iend_fftph)
            call x_dot_cggawk13_into_afft(rinplw,x)
            call m_FFT_CD_direct_c(nfout,afft)
            call G_xyz_afft(in)             ! 
            call m_FFT_CD_inverse_c(nfout,afft)
            do is = 1, 2
               call add_negative_afft_to_grad_rho(is)
            end do
         end do
         if(nrank_ggacmp > 1) then
            Do is=1, 2
               grad_rho_c2(:) = grad_rho(:,is)
#ifdef _DETAIL_GGA_TIMING_
               call tstatc0_begin('mpi_allreduce(ggaxcp) ',id_sname)
#endif
               call mpi_allreduce(grad_rho_c2,grad_rho_c4,iend_fftph-ista_fftph+1 &
                    & ,mpi_double_precision, mpi_sum, mpi_ggacmp_cross_world(myrank_cdfft),ierr)
#ifdef _DETAIL_GGA_TIMING_
               call tstatc0_end(id_sname)
#endif
               grad_rho(:,is) = grad_rho_c4(:)
            End Do
         end if
      end if
#endif
!!$1003 continue
      if(nrank_ggacmp > 1)  deallocate(grad_rho_c4,grad_rho_c2)    ! MPI

    end subroutine dFxc_over_ddgradrho

! ============================= added by K. Tagami ================= 11.0
    subroutine dFxc_over_ddgradrho_noncl()
      real(kind=DP),allocatable,dimension(:)    :: grad_rho_c2
                                                   ! MPI d(ista_fftph:iend_fftph)
      real(kind=DP),allocatable,dimension(:)    :: grad_rho_c4
                                                   ! MPI d(ista_fftph:iend_fftph)
      integer  :: is, in
      real(kind=DP),pointer,dimension(:)  :: x

#ifdef _DETAIL_GGA_TIMING_
      integer :: id_sname = -1
#endif

      if ( nrank_ggacmp >1 ) then
         allocate( grad_rho_c2(ista_fftph:iend_fftph) )
         allocate( grad_rho_c4(ista_fftph:iend_fftph) )       ! MPI
      endif

#ifndef _XC_SAVE_MEMORY_
      grad_rho = 0.0d0

      do is = 1, ispin
         do in = 1, 3
            if (map_ggacmp(in) /= myrank_ggacmp) cycle
            call dFxc_dgradrho_dot_gradrho2(rinplw,in,ispin,is)
                                     ! grad_{in}(rho_{is})*dFx/d|grad(rho_{is})|
                                     ! + grad_{in}(rho)*dFc/d|grad(rho)|  -> afft
            if (iprixc >= 2) write(nfout,'(" is, in = ",2i8)') is, in
            if (iprixc >= 2) then
               call wd_small_part_of_afft(33,'R space before<m_FFT_CD_direct_c)',120)
            endif

            call m_FFT_CD_direct_c(nfout,afft)     ! afft (= q_{in}(G))
            if (iprixc >= 2) then
               call wd_small_part_of_afft(33,'G space after <m_FFT_CD_direct_c)',120)
            endif

            call G_xyz_afft(in)                    ! G_{in}q_{in}(G)  -> afft
            call m_FFT_CD_inverse_c(nfout,afft)    ! afft -> afft
            if (iprixc >= 2) then
               call wd_small_part_of_afft(33,'R space after <m_FFT_CD_direct_c)',120)
            endif

            call add_negative_afft_to_grad_rho(is) ! afft -> grad_rho
         end do

         if (nrank_ggacmp > 1) then
            grad_rho_c2(:) = grad_rho(:,is)
            call mpi_allreduce( grad_rho_c2, grad_rho_c4, iend_fftph -ista_fftph +1, &
                 &              mpi_double_precision, mpi_sum, &
                 &              mpi_ggacmp_cross_world(myrank_cdfft), ierr )
            grad_rho(:,is) = grad_rho_c4(:)
         end if
      end do
#else
      allocate( bfft_kt( ista_fftp:iend_fftp,ndim_magmom )); bfft_kt = 0.0d0

      grad_rho = 0.0d0

      do in = 1, 3
         if(map_ggacmp(in) /= myrank_ggacmp) cycle

         bfft_kt = 0.0d0
         Do is=1, ndim_magmom
            call g_xyz_chden_l(in,is)          ! G_xyz * rho_{is}(G) --> afft
            call m_FFT_CD_inverse_c(nfout,afft)  ! (-i)*d(rho_{is}(r))/d(x|y|z)
            bfft_kt(:,is) = afft(:)
         End do

         call m_ES_GradCorr_Along_QuantzAxis2( RhoMag_R, bfft_kt, &
              &                                quantz_axis_inversion_flg_mesh )

         do is = 1, nspin
            afft(:) = bfft_kt(:,is)
            call cp_afft_to_cggawk13           ! -afft --> cggawk13
            x => dF_dgradrho(ista_fftph:iend_fftph,is)
            call x_dot_cggawk13_into_afft(rinplw,x)
                                               !  grad(rho) * dFx/d|grad(rho)|

            ! Calculation i-th component df/d(d|grad n|) in recip. space
            call m_FFT_CD_direct_c(nfout,afft)
            call G_xyz_afft(in)
            call m_FFT_CD_inverse_c(nfout,afft)
            call add_negative_afft_to_grad_rho(is)
            !  --> grad_rho
         end do
      end do

!--> correlation part
      do in = 1, 3
         if(map_ggacmp(in) /= myrank_ggacmp) cycle

         is = 1
         call g_xyz_chden_l(in,is)          ! G_xyz * rho_{is}(G) --> afft
         call m_FFT_CD_inverse_c(nfout,afft)  ! (-i)*d(rho_{is}(r))/d(x|y|z)

         call cp_afft_to_cggawk13        ! -afft --> cggawk13
         x => grad_trho(ista_fftph:iend_fftph)
         call x_dot_cggawk13_into_afft(rinplw,x)
         call m_FFT_CD_direct_c(nfout,afft)
         call G_xyz_afft(in)             !
         call m_FFT_CD_inverse_c(nfout,afft)
         do is = 1, nspin
            call add_negative_afft_to_grad_rho(is)
         end do
      end do

      if (nrank_ggacmp > 1) then
         Do is=1, nspin
            grad_rho_c2(:) = grad_rho(:,is)
#ifdef _DETAIL_GGA_TIMING_
            call tstatc0_begin('mpi_allreduce(ggaxcp) ',id_sname)
#endif
            call mpi_allreduce( grad_rho_c2, grad_rho_c4, iend_fftph -ista_fftph +1, &
                 &              mpi_double_precision, mpi_sum, &
                 &              mpi_ggacmp_cross_world(myrank_cdfft), ierr )

#ifdef _DETAIL_GGA_TIMING_
            call tstatc0_end(id_sname)
#endif
            grad_rho(:,is) = grad_rho_c4(:)
         End do
      end if

      deallocate( bfft_kt )
#endif

      if(nrank_ggacmp > 1)  deallocate(grad_rho_c4,grad_rho_c2)    ! MPI

    end subroutine dFxc_over_ddgradrho_noncl
! ======================================================================= 11.0

    subroutine finally_gga_xc_pot(is)
      integer, intent(in) :: is
      integer       :: m

! ==== KT_add ==== 2014/08/04
      if ( noncol ) then
         if ( sw_neglect_low_helicity == ON ) then
            call m_ES_neglect_low_Helicity( RhoMag_R, MagVorticity, grad_rho(:,is) )
         endif
         if ( sw_neglect_low_vorticity == ON ) then
            call m_ES_neglect_low_Vorticity( RhoMag_R, MagVorticity, grad_rho(:,is) )
         endif
      endif
! ================ 2014/08/04

      do m = ista_fftph, iend_fftph   ! MPI
         chgrhr_l(m,is) = dF_drho(m,is)+grad_rho(m,is)
      end do

      if(iprixc >= 2) then
         write(nfout,'(" !XC -- chgrhr_l -- <<finally_gga_xc_pot>>")')
         write(nfout,'(" !XC ",6f12.6)') (chgrhr_l(i,1),i=ista_fftph,ista_fftph+17)
         write(nfout,'(" !XC -- grad_rho -- <<finally_gga_xc_pot>>")')
         write(nfout,'(" !XC ",6f12.6)') (grad_rho(i,1),i=ista_fftph,ista_fftph+17)
         write(nfout,'(" !XC -- dF_drho -- <<finally_gga_xc_pot>>")')
         write(nfout,'(" !XC ",6f12.6)') (dF_drho(i,1),i=ista_fftph,ista_fftph+17)
      end if
    end subroutine finally_gga_xc_pot

    subroutine add_negative_afft_to_grad_rho(is)
      integer, intent(in) :: is
      integer             :: m
      do m = ista_fftph, iend_fftph      ! MPI
         grad_rho(m,is) = grad_rho(m,is) - afft(2*m-1)
      end do
      if(iprixc >= 2) then 
         write(6,'(" !XC -- afft -- ,is = ",i8," <<add_negative_afft_to_grad_rho>>")') is
         write(6,'(" !XC ",6f12.6)') (afft(m*2-1),m=ista_fftph,ista_fftph+17)

         write(6,'(" !XC -- grad_rho -- ,is = ",i8," <<add_negative_afft_to_grad_rho>>")') is
         write(6,'(" !XC ",6f12.6)') (grad_rho(m,is),m=ista_fftph,ista_fftph+17)
      end if

    end subroutine add_negative_afft_to_grad_rho

    subroutine G_xyz_afft(in)
      integer, intent(in) :: in
      integer       :: n, i,j,k,ip
      real(kind=DP) :: gxyz

      do n = ista_fftp, iend_fftp   ! MPI
         gxyz = rltv(in,1)*inx(n)+rltv(in,2)*jnx(n)+rltv(in,3)*knx(n)
         afft(n) = gxyz*afft(n)
      enddo
      call boundary_zero_into_afft(in)  ! -(contained in subr. m_XC_cal_potential)

!!$      do k = 1, lz
!!$         do j = min(ly-ny_d*myrank_cdfft,ny_d)+1, ly_d
!!$            do i = 1, lx*2
!!$               ip = 2*((j-1)*lx+(k-1)*lx*ly_d)+ista_fftp-1 + i
!!$               afft(ip) = 0.d0
!!$            end do
!!$         end do
!!$      end do
!!$      do k = nz_d*npes_cdfft+1, lz
!!$         do j = 1, ly_d
!!$            do i = 1, lx*2
!!$               ip = 2*((j-1)*lx+(k-1)*lx*ly_d)+ista_fftp-1 + i
!!$               afft(ip) = 0.d0
!!$            end do
!!$         end do
!!$      end do
!!$      do k = 1, lz
!!$         do j = 1, ly_d
!!$            do i = fft_box_size_CD(1,1)+1, fft_box_size_CD_c(1,0)
!!$               ip = 2*((j-1)*lx+(k-1)*lx*ly_d)+ista_fftp-1 + 2*i-1
!!$               afft(ip) = 0.d0
!!$               afft(ip+1) = 0.d0
!!$            end do
!!$         end do
!!$      end do
    end subroutine G_xyz_afft

#ifndef _XC_SAVE_MEMORY_
    subroutine dFxc_dgradrho_dot_gradrho2(rinplw,in,ispin,is)
      real(kind=DP), intent(in) :: rinplw
      integer, intent(in)       :: ispin,in,is
      integer                   :: m
      afft = 0.d0
      if(ispin == 2) then
         do m = ista_fftph, iend_fftph
            afft(2*m) = rinplw*(dF_dgradrho(m,is)*cgrad_rho(m,in,is) &
                 &            +grad_trho(m)*(cgrad_rho(m,in,1)+cgrad_rho(m,in,2)) )
         end do
      else if(ispin == 1) then
         do m = ista_fftph, iend_fftph
            afft(2*m) = rinplw*(dF_dgradrho(m,is)+grad_trho(m))*cgrad_rho(m,in,is)
         end do
      end if
    end subroutine dFxc_dgradrho_dot_gradrho2

#else
    subroutine dFxc_dgradrho_dot_gradrho(rinplw)
      real(kind=DP), intent(in) :: rinplw
      integer                   :: m
      afft = 0.d0
      do m = ista_fftph, iend_fftph
         afft(2*m) = rinplw*(dF_dgradrho(m,1)+grad_trho(m))*cggawk13(m)
      end do
    end subroutine dFxc_dgradrho_dot_gradrho

    subroutine x_dot_cggawk13_into_afft(rinplw,x)
      real(kind=DP), intent(in) :: rinplw
      real(kind=DP), intent(in) :: x(ista_fftph:iend_fftph)
      integer                   :: m
      afft = 0.d0
      do m = ista_fftph, iend_fftph   ! MPI
         afft(2*m) = rinplw*x(m) *cggawk13(m)
      end do
    end subroutine x_dot_cggawk13_into_afft

    subroutine cp_afft_to_cggawk13
      integer  :: m

      do m = ista_fftph, iend_fftph  ! MPI
         cggawk13(m) = - afft(2*m)
      end do
    end subroutine cp_afft_to_cggawk13
#endif


    subroutine g_xyz_total_chden_l(in)
      integer, intent(in) ::in
      integer       :: n
      real(kind=DP) :: gxyz

      do n = ista_fftp, iend_fftp   ! MPI
         gxyz = rltv(in,1)*inx(n)+rltv(in,2)*jnx(n)+rltv(in,3)*knx(n)
         afft(n) = gxyz*(chden_l(n, 1)+chden_l(n,ispin))
      enddo
      call boundary_zero_into_afft(in)  ! -(contained in subr. m_XC_cal_potential)

    end subroutine g_xyz_total_chden_l

    subroutine add_sq_afft_to_grad_trho
      integer   :: i
      do i = ista_fftph, iend_fftph     ! MPI
         grad_trho(i) = grad_trho(i) + afft(i*2)**2
      end do
    end subroutine add_sq_afft_to_grad_trho

    subroutine add_sq_afft_to_grad_rho(is)
      integer, intent(in) :: is
      integer :: i
      do i = ista_fftph, iend_fftph     ! MPI
         grad_rho(i,is) = grad_rho(i,is) + afft(i*2)**2
      end do
    end subroutine add_sq_afft_to_grad_rho

    subroutine g_xyz_chden_l(in,is)
      integer, intent(in) :: in,is
      integer       :: n
      real(kind=DP) :: gxyz

!!$      deallocate(afft)
!!$      allocate(afft(ista_fftp:iend_fftp))

      afft = 0.d0
      do n = ista_fftp, iend_fftp  ! MPI
         gxyz = rltv(in,1)*inx(n)+rltv(in,2)*jnx(n)+rltv(in,3)*knx(n)
         afft(n) = gxyz*chden_l(n,is)
      enddo
      call boundary_zero_into_afft(in)  ! -(contained in subr. m_XC_cal_potential)
    end subroutine g_xyz_chden_l

! ==== KT_add ======= 13.0XX
    subroutine g2_xyz_chden_l(is)
      integer, intent(in) :: is
      integer       :: n
      real(kind=DP) :: gx, gy, gz, g2

      afft = 0.d0
      do n = ista_fftp, iend_fftp  ! MPI
         gx = rltv(1,1)*inx(n) +rltv(1,2)*jnx(n) +rltv(1,3)*knx(n)
         gy = rltv(2,1)*inx(n) +rltv(2,2)*jnx(n) +rltv(2,3)*knx(n)
         gz = rltv(3,1)*inx(n) +rltv(3,2)*jnx(n) +rltv(3,3)*knx(n)
         g2 = gx**2 +gy**2 +gz**2
         afft(n) = g2 *chden_l(n,is)
      enddo

    end subroutine g2_xyz_chden_l
! =================== 13.0XX

    subroutine check_lmn_even
      integer             :: nlmn, i

      do i = 1, 3
         nlmn = fft_box_size_CD(i,1)/2
         if(2*nlmn == fft_box_size_CD(i,1)) then
            lmn_even(i) = .true.
         else
            lmn_even(i) = .false.
         end if
      end do
    end subroutine check_lmn_even

    subroutine boundary_zero_into_afft(in)
      integer, intent(in) :: in
      integer             :: i,j,k,nn,n,idp,nlp,nmp,nnp,nd2p, j0

      nlp = fft_box_size_CD(1,1)
      nmp = fft_box_size_CD(2,1)
      nnp = fft_box_size_CD(3,1)
#ifdef _MPIFFT_
      idp = fft_box_size_CD_c(1,0)
      nd2p = fft_box_size_CD_c(2,0)
#else
      idp = fft_box_size_CD(1,0)
      nd2p = fft_box_size_CD(2,0)
#endif

      if(kimg == 1) then
         if(lmn_even(in)) then
            if( in == 1) then
#ifdef _MPIFFT_
               do j = 1, ly_d*lz
!!$               do j0 = 1, ly_d
!!$                  do k = 1, nnp
!!$                     nn = nlp/2 + 1 + idp*(j0-1) + idp*ly_d*(k-1) + idp*ly_d*lz*myrank_cdfft
                  nn = nlp/2 + 1 + idp*(j-1) + idp*ly_d*lz*myrank_cdfft
                  afft(nn) = 0.d0
!!$                  end do
               end do
#else
               do j = 1, nmp      ! y
                  do k = 1, nnp   ! z
!!$                  nn = nlp/2 + 1 + idp*(j-1) + idp*nmp*(k-1)
                     nn = nlp/2 + 1 + idp*(j-1) + idp*nd2p*(k-1)
                     if(nn >= ista_fftp .and. nn <= iend_fftp) afft(nn) = 0.d0
                  end do
               end do
#endif
            else if( in == 2) then
#ifdef _MPIFFT_
               j0 = nmp/2 + 1 - ny_d*myrank_cdfft
               if(j0 >= 1 .and. j0 <= ny_d) then
                  do i = 1, idp
                     do k = 1, nnp
                        nn = i + idp*(j0-1) + idp*ly_d*(k-1) + idp*ly_d*lz*myrank_cdfft
                        afft(nn) = 0.d0
                     end do
                  end do
               end if
#else
               do i = 1, idp      ! x
                  do k = 1, nnp   ! z
                     nn = i + idp*(nmp/2) + idp*nd2p*(k-1)
                     if(nn >= ista_fftp .and. nn <= iend_fftp) afft(nn) = 0.d0
                  end do
               end do
#endif
            else if(in == 3) then
#ifdef _MPIFFT_
               do i = 1, idp
                  do j = 1+ny_d*myrank_cdfft, min(nmp,ny_d*(myrank_cdfft+1))
                     nn = i + idp*(j-1-ny_d*myrank_cdfft) + idp*ly_d*(nnp/2) &
                          &                          + idp*ly_d*lz*myrank_cdfft
                     afft(nn) = 0.d0
                  end do
               end do
#else
               do i = 1, idp      ! x
                  do j = 1, nmp   ! y
                     nn = i + idp*(j-1) + idp*nd2p*(nnp/2)
                     if(nn >= ista_fftp .and. nn <= iend_fftp) afft(nn) = 0.d0
                  end do
               end do
#endif
            end if
         end if
      else if(kimg == 2) then
         if(lmn_even(in)) then
            if( in == 1) then
#ifdef _MPIFFT_
               do j = 1, ly_d*lz
                  nn = nlp/2 + 1 + idp*(j-1) + idp*ly_d*lz*myrank_cdfft
                  n = nn*2 - 1
                  afft(n) = 0.d0
                  afft(n+1) = 0.d0
               end do
#else               
               do j = 1, nmp
                  do k = 1, nnp
!!$                  nn = nlp/2 + 1 + idp*(j-1) + idp*nmp*(k-1)
                     nn = nlp/2 + 1 + idp*(j-1) + idp*nd2p*(k-1)
!!$                     nn = nlp/2 + 1 + idp*(j-1) -idp*ly_d*myrank_cdfft &
!!$                          & +idp*ly_d*(k-1+myrank_cdfft)
                     n  = nn*2 - 1
                     if(n >= ista_fftp .and. n <= iend_fftp) afft(n) = 0.d0
                     n  = nn*2
                     if(n >= ista_fftp .and. n <= iend_fftp) afft(n) = 0.d0
                  end do
               end do
#endif
            else if( in == 2) then
#ifdef _MPIFFT_
               j0 = nmp/2 + 1 - ny_d*myrank_cdfft
               if(j0 >= 1 .and. j0 <= ny_d) then
                  do i = 1, idp
                     do k = 1, nnp
                        nn = i + idp*(j0-1) + idp*ly_d*(k-1) + idp*ly_d*lz*myrank_cdfft
                        n  = nn*2 - 1
                        afft(n) = 0.d0; afft(n+1) = 0.d0
                     end do
                  end do
               end if
#else
               do i = 1, idp
                  do k = 1, nnp
!!$                     nn = i + idp*(nmp/2) + idp*nmp*(k-1)
                     nn = i + idp*(nmp/2) + idp*nd2p*(k-1)
                     n  = nn*2 - 1
                     if(n >= ista_fftp .and. n <= iend_fftp) afft(n) = 0.d0
                     n  = nn*2
                     if(n >= ista_fftp .and. n <= iend_fftp) afft(n) = 0.d0
                  end do
               end do
#endif
            else if(in == 3) then
#ifdef _MPIFFT_
               do i = 1, idp
                  do j = 1+ny_d*myrank_cdfft, min(nmp,ny_d*(myrank_cdfft+1))
                     nn = i + idp*(j-1-ny_d*myrank_cdfft) + idp*ly_d*(nnp/2) &
                          &                          + idp*ly_d*lz*myrank_cdfft
                     n  = nn*2 - 1
                     afft(n) = 0.d0
                     afft(n+1) = 0.d0
                  end do
               end do
#else
               do i = 1, idp
                  do j = 1, nmp
!!$                  nn = i + idp*(j-1) + idp*nmp*(nnp/2)
                     nn = i + idp*(j-1) + idp*nd2p*(nnp/2)
                     n  = nn*2 - 1
                     if(n >= ista_fftp .and. n <= iend_fftp) afft(n) = 0.d0
                     n  = nn*2
                     if(n >= ista_fftp .and. n <= iend_fftp) afft(n) = 0.d0
                  end do
               end do
#endif
            end if
         end if
      end if
    end subroutine boundary_zero_into_afft

    subroutine initialize_cggawk_arrays
      grad_trho = 0.d0
#ifndef _XC_SAVE_MEMORY_
      cgrad_rho = 0.d0
#else
      cggawk13 = 0.d0
#endif
      grad_rho = 0.d0
      dF_drho = 0.d0
      dF_dgradrho = 0.d0
    end subroutine initialize_cggawk_arrays

!!$    subroutine cp_chgrhr_onto_afft(is)
!!$      integer, intent(in) :: is
!!$      integer   :: i
!!$
!!$      afft = 0.d0
!!$      do i = ista_fftph, iend_fftph   ! MPI
!!$         afft(2*i-1) = chgrhr_l(i,is)*rinplw
!!$      end do
!!$    end subroutine cp_chgrhr_onto_afft

#ifndef _XC_SAVE_MEMORY_
    subroutine cp_afft_to_cgrad_rho(is,in)
      integer, intent(in) :: is, in
      integer :: i
      do i = ista_fftph, iend_fftph
         cgrad_rho(i,in,is) = -afft(i*2)
      end do
    end subroutine cp_afft_to_cgrad_rho

#endif

! ===== KT_add ====== 13.0XX
    subroutine cp_afft_to_grad2_rho(is)
      integer, intent(in) :: is
      integer :: i

      do i = ista_fftph, iend_fftph
         grad2_rho(i,is) = -afft(2*i-1)
      end do
    end subroutine cp_afft_to_grad2_rho
! =================== 13.0XX

! ================================== modified by K. Tagami =============== 11.0
!    subroutine cp_afft_to_chgrhr
!
    subroutine cp_afft_to_chgrhr(iloop)
      integer, intent(in) :: iloop
! ======================================================================== 11.0

      integer  :: i
      if(myrank_ggacmp < nrank_ggacmp) then
         do i = ista_fftph, iend_fftph    ! MPI
            chgrhr_l(i,iloop) = afft(i*2-1)
         end do
      else
         do i = ista_fftph, iend_fftph    ! MPI
            chgrhr_l(i,iloop) = 0.d0
         end do
      end if

      if(iprixc >= 2) then
! =============================== added by K. Tagami ============ 11.0
         write(nfout,*) "!XC "
         write(nfout,*) "!XC         iloop = ", iloop
! =============================================================== 11.0
         write(nfout,'(" !XC -- chgrhr_l -- <<cp_afft_to_chgrhr>>")')

! ============================== modified by K. Tagami ============= 11.0
!         write(nfout,'(" !XC ",6f12.6)') (chgrhr_l(i,1),i=ista_fftph,ista_fftph+17)
         write(nfout,'(" !XC ",6f12.6)') (chgrhr_l(i,iloop),i=ista_fftph,ista_fftph+17)
! ================================================================== 11.0

         write(nfout,'(" !XC -- afft --     <<cp_afft_to_chgrhr>>")')
         write(nfout,'(" !XC ",6f12.6)') (afft(i*2-1),i=ista_fftph,ista_fftph+17)
      end if
    end subroutine cp_afft_to_chgrhr

    subroutine wd_small_part_of_vxc
      integer :: i

!!$      if(mype /= 0) return
      if(kimg==1) then
         write(nfout,*) 'vxc'
         if(input_charge == Partial_Core_Charge) then
            do i = ista_kngp, min(ista_kngp+14, iend_kngp)
               write(nfout,200) vxcpc_l(i,1), i
            end do
         else
            if(nspin == 1) then
               do i = ista_kngp, min(ista_kngp+14,iend_kngp)
                  write(nfout,200) vxc_l(i,1,1), i
               end do
            else
               do i = ista_kngp, min(ista_kngp+14, iend_kngp)
                  write(nfout,201) vxc_l(i,1,1),vxc_l(i,1,nspin), i
               end do
            end if
         endif
200      format(' ',d20.12,i8)
201      format(' ','(',d12.4,',',d12.4,')',i8)
         write(nfout,*) 'exc'
         write(nfout,200) exc
      else if(kimg == 2) then
         write(nfout,*) 'vxc'
         if(input_charge == Partial_Core_Charge) then
            do i = ista_kngp, min(ista_kngp+29,iend_kngp)
               write(nfout,203) vxcpc_l(i,1   ),vxcpc_l(i,kimg), i
            end do
         else
            if(ispin == 1) then
               do i = ista_kngp, min(ista_kngp+29,iend_kngp)
                  write(nfout,203) vxc_l(i,1   ,1), vxc_l(i,kimg,1), i
               end do
            else
               do i = ista_kngp, min(ista_kngp+29,iend_kngp)
                  write(nfout,202) vxc_l(i,1   ,1),vxc_l(i,1,   nspin), i,1
                  write(nfout,202) vxc_l(i,kimg,1),vxc_l(i,kimg,nspin), i,2
               end do
            endif
         end if
203      format(' ','(',d12.4,',',d12.4,')',i8)
202      format(' ','(',d12.4,',',d12.4,')',i8, ' kimg= ',i3)
         write(nfout,*) 'exc'
         write(nfout,200) exc
      end if
    end subroutine wd_small_part_of_vxc

! =============================== added by K. Tagami ==================== 11.0
    subroutine wd_small_part_of_vxc_ssrep

      integer :: i

!!$      if(mype /= 0) return
      if(kimg==1) then
         write(nfout,*) 'vxc'
         if(input_charge == Partial_Core_Charge) then
            do i = ista_kngp, min(ista_kngp+14, iend_kngp)
               write(nfout,200) vxcpc_l(i,1), i
            end do
         else
            do i = ista_kngp, min(ista_kngp+14, iend_kngp)
               write(nfout,201) vxc_l(i,1,1),vxc_l(i,1,ndim_chgpot), i
            end do
         endif

200      format(' ',d20.12,i8)
201      format(' ','(',d12.4,',',d12.4,')',i8)
         write(nfout,*) 'exc'
         write(nfout,200) exc

      else if(kimg == 2) then

         write(nfout,*) 'vxc'
         if(input_charge == Partial_Core_Charge) then
            do i = ista_kngp, min(ista_kngp+29,iend_kngp)
               write(nfout,203) vxcpc_l(i,1   ),vxcpc_l(i,kimg), i
            end do
         else
            do i = ista_kngp, min(ista_kngp+29,iend_kngp)
               write(nfout,202) vxc_l(i,1   ,1),vxc_l(i,1,   ndim_chgpot), i,1
               write(nfout,202) vxc_l(i,kimg,1),vxc_l(i,kimg,ndim_chgpot), i,2
            end do
         end if
203      format(' ','(',d12.4,',',d12.4,')',i8)
202      format(' ','(',d12.4,',',d12.4,')',i8, ' kimg= ',i3)
         write(nfout,*) 'exc'
         write(nfout,200) exc
      end if
    end subroutine wd_small_part_of_vxc_ssrep
! ================================================================= 11.0

    subroutine wd_small_part_of_afft(len_str,str,ne)
      integer, intent(in)        :: len_str
      character(len=len_str),intent(in) :: str
      integer, intent(in)        :: ne

      integer                    :: i
!!$      if(mype == 0) then
         write(nfout, *) 'afft (',str,')'
         if(nspin == 2) write(nfout,*) ' #spin = ', iloop
         if(ne*2 > np_fftp) then
            write(nfout,*)  ' all elements'
            write(nfout,'(6f12.6)') (afft(i),i=ista_fftp, iend_fftp)
         else
            write(nfout,*) ' first ',ne,' elements'
!!$            write(nfout,'(6f12.6)') (afft(i),i=1,ne)
            write(nfout,'(6f12.6)') (afft(ista_fftp-1+i),i=1,ne)
            write(nfout,*) ' last ', ne,' elements'
            write(nfout,'(6f12.6)') (afft(iend_fftp-ne+i),i=1,ne)
         endif
!!$         write(nfout,'(" iend_fftp = ",i8)') iend_fftp
!!$         write(nfout,*) ' last ', lx*2,' elements'
!!$         write(nfout,'(" j, k = ", 2i8)') ly_d+ly_d*myrank_cdfft, lz
!!$         n = 2*((ly_d-1)*lx + (lz-1)*lx*ly_d) + ista_fftp - 1
!!$         write(nfout,'(8d12.4)') (afft( n+i),i=1,lx*2)
!!$         write(nfout,'(" n+lx*2 = ",i8)') n+lx*2
!!$            end do
!!$         end do
!!$         n = 0
!!$         do i = ista_fftp, iend_fftp
!!$            if(abs(afft(i)) > 1.d-8) n = n+1
!!$         end do
!!$         write(nfout,'(" number of non-zero term of afft = ",i8)') n
!!$      end if
    end subroutine wd_small_part_of_afft

! ==================================== modified by K. Tagami =============== 11.0
!!!    subroutine map_charge_onto_a_fft_box(chgq_l)
!!      real(DP),intent(in) :: chgq_l(ista_kngp:iend_kngp,kimg,nspin)

    subroutine map_charge_onto_a_fft_box( chgq_l, ndim_dens, iloop, operation_mode )
      integer, intent(in) :: ndim_dens, iloop
      integer, intent(in) :: operation_mode
      real(DP),intent(in) :: chgq_l(ista_kngp:iend_kngp,kimg,ndim_dens)
! ========================================================================== 11.0

      real(kind=DP)      :: fac
      integer            :: mm, it, i, j, ip
      real(kind=DP),allocatable,dimension(:)    :: afft_mpi2,afft_mpi3   ! MPI d(mp_fftp)
      real(kind=DP),allocatable,dimension(:)    :: afft_mpi1,afft_mpi4   ! MPI d(nfftp)
      integer :: id_sname = -1
      call tstatc0_begin('map_charge_onto_a_fft_box ',id_sname)

      allocate(afft_mpi1(nfftp))

! =========================== modified by K. Tagami ============== 11.0
!      if(input_charge == Valence_plus_PC_Charge) then
!         fac = 1.d0/nspin
!      else if(input_charge == Partial_Core_Charge) then
!         fac = 1.d0
!      else
!        stop ' Error of ixc in <<<map_charge_onto_a_fft_box>>>'
!      endif

      if ( operation_mode == Valence_plus_PC_Charge ) then
         fac = 1.d0/nspin
      else if ( operation_mode == Valence_Charge_Only ) then
         fac = 1.d0
      else if ( operation_mode == Partial_Core_Charge ) then
         fac = 1.d0
      else
        stop ' Error of ixc in <<<map_charge_onto_a_fft_box>>>'
      endif
! ================================================================= 11.0

      mm = 0
      afft_mpi1 = 0.d0

! ================================= added by K. Tagami =================== 11.0
      if ( operation_mode == Valence_Charge_Only ) goto 1200
! ======================================================================== 11.0

      do it = 1, ntyp
         if(itpcc(it) == 0) cycle
         mm = mm + 1
         do j = 1, kimg
#ifdef NEC_TUNE_MXCP
!CDIR NODEP
!CDIR INNER
#endif
            do i = ista_kngp, min(kgp_reduced, iend_kngp)  !for mpi
#ifdef _MPIFFT_
               ip = (igfp_l_c(i)-1)*kimg + j
#else
               ip = (igfp_l(i)-1)*kimg + j
#endif
               afft_mpi1(ip) = afft_mpi1(ip) &   !mpi
                    & + fac*zfm3_l(i,it,j)*rhpcg_l(i,mm)   !mpi
            end do
         end do
      end do

! ==================================== added by K. Tagami ============== 11.0
1200  continue
! ====================================================================== 11.0

! ================================== modified by K. Tagami ============== 11.0
!!      if(input_charge == Valence_plus_PC_Charge) then
      if ( operation_mode /= Partial_Core_Charge ) then
! ======================================================================== 11.0

         do j = 1, kimg
#ifdef NEC_TUNE_MXCP
!CDIR NODEP
!CDIR INNER
#endif
            do i = ista_kngp, min(kgp_reduced, iend_kngp)  !for mpi
#ifdef _MPIFFT_
               ip = (igfp_l_c(i)-1)*kimg + j
#else
               ip = (igfp_l(i)-1)*kimg + j
#endif
               afft_mpi1(ip) = afft_mpi1(ip) + chgq_l(i,j,iloop) !mpi
            end do
         end do
      end if

      if(npes_cdfft > 1) then
         call mpi_barrier(mpi_comm_group,ierr)
         allocate(afft_mpi2(mp_fftp))
         allocate(afft_mpi3(mp_fftp))
         do j = 0, npes_cdfft-1
#ifdef _MPIFFT_
            call set_cdata(j,afft_mpi1,afft_mpi2)
#else
            do i = nis_fftp(j), nie_fftp(j)
               afft_mpi2(i-nis_fftp(j)+1) = afft_mpi1(i)
            end do
#endif
            call mpi_allreduce(afft_mpi2,afft_mpi3,mp_fftp &
                 &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)

            if(j == myrank_cdfft) then
               do i = ista_fftp, iend_fftp
                  afft(i) = afft_mpi3(i - ista_fftp + 1)
               end do
            end if
         end do
         deallocate(afft_mpi3,afft_mpi2)
      else
         if(nrank_ggacmp > 1) then
            allocate(afft_mpi4(nfftp))
            call mpi_allreduce(afft_mpi1, afft_mpi4, nfftp &
                 & , mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
            afft = afft_mpi4
            deallocate(afft_mpi4)
         else
            afft = afft_mpi1
         end if
      end if

      deallocate(afft_mpi1)
      call tstatc0_end(id_sname)
    end subroutine map_charge_onto_a_fft_box

! ============================= modified by K. Tagami ============== 11.0
!    subroutine map_charge_onto_a_fft_box2(nfout,chgq_l)
!      integer, intent(in) :: nfout
!      real(DP),intent(in) :: chgq_l(ista_kngp:iend_kngp,kimg,nspin)
!
    subroutine map_charge_onto_a_fft_box2( nfout, chgq_l, ndim_dens, iloop, &
	&                                  operation_mode )
      integer, intent(in) :: nfout, ndim_dens, iloop
      integer, intent(in) :: operation_mode
      real(DP),intent(in) :: chgq_l(ista_kngp:iend_kngp,kimg,ndim_dens)
! ================================================================== 11.0

      real(kind=DP)      :: fac
      integer            :: mm, it, i, j
      real(kind=DP),allocatable,dimension(:)    :: tmp_s, tmp_r ! MPI d(nfftp/npes)
      real(kind=DP),allocatable,dimension(:,:)  :: chgqplus_l ! MPI d(ista_kngp:iend_kngp)
!      integer, save, allocatable, dimension(:)  :: ip ! d(ista_kngp:iend_kngp,3)
      integer, allocatable, dimension(:)        :: igfp_s, igfp_r ! d(nfftp/npes)
!      integer, save, allocatable, dimension(:,:):: igfp_ijk ! d(ista_kngp:iend_kngp+(0,1),3)
      integer, allocatable, dimension(:)        :: ipout_s, ipout_r ! d(nfftp/npes)
      integer, allocatable, dimension(:)        :: np ! d(0:npes_cdfft-1)
!      integer, save, allocatable, dimension(:,:):: np_send ! d(0:npes-1,0:npes-1)
      integer, allocatable, dimension(:,:)      :: np_tmp ! d(0:npes-1,0:npes-1)
      integer :: pe_s, pe_r, datasize_s, datasize_r, nfp, igp, nb, npc, maxdatasize
      integer :: nstart, nend, lx, lxy, ipout, j0, k, l, np0, idp, icdfft
      integer, allocatable, dimension(:) :: req_r,req_s

      integer :: id_sname = -1
#ifdef _DETAIL_MAP_CHARGE_TIMING_
      integer :: id_sname2 = -1, id_sname3=-1, id_sname4=-1, id_sname5=-1
#endif
      call tstatc0_begin('map_charge_onto_a_fft_box2 ',id_sname)

#ifdef _DETAIL_MAP_CHARGE_TIMING_
      call tstatc0_begin('map_charge2fftbox2_part1 ',id_sname2)
#endif

      allocate(chgqplus_l(ista_kngp:iend_kngp,kimg))

! ============================== modified by K. Tagami ================ 11.0
!      if(input_charge == Valence_plus_PC_Charge) then
!         fac = 1.d0/nspin
!      else if(input_charge == Partial_Core_Charge) then
!         fac = 1.d0
!      else
!        stop ' Error of ixc in <<<map_charge_onto_a_fft_box2>>>'
!      endif

      if ( operation_mode == Valence_plus_PC_Charge) then
         fac = 1.d0/nspin
      else if ( operation_mode == Valence_Charge_Only ) then
         fac = 1.d0
      else if( operation_mode == Partial_Core_Charge ) then
         fac = 1.d0
      else
        stop ' Error of ixc in <<<map_charge_onto_a_fft_box2>>>'
      endif
! ====================================================================== 11.0

      chgqplus_l = 0.d0
      mm = 0

! ================================= added by K. Tagami =================== 11.0
      if ( operation_mode == Valence_Charge_Only ) goto 1200
! ======================================================================== 11.0

      do it = 1, ntyp
         if(itpcc(it) == 0) cycle
         mm = mm + 1
         do j = 1, kimg
#ifdef NEC_TUNE_MXCP
!CDIR NODEP
!CDIR INNER
#endif
            do i = ista_kngp, iend_kngp  !for mpi
               chgqplus_l(i,j) = chgqplus_l(i,j) &
                    & + fac*zfm3_l(i,it,j)*rhpcg_l(i,mm)   !mpi
            end do
         end do
      end do

! ==================================== added by K. Tagami ============== 11.0
1200  continue
! ====================================================================== 11.0

! ================================== modified by K. Tagami ============== 11.0
!!      if(input_charge == Valence_plus_PC_Charge) then
      if ( operation_mode /= Partial_Core_Charge ) then
! ======================================================================== 11.0

         do j = 1, kimg
#ifdef NEC_TUNE_MXCP
!CDIR NODEP
!CDIR INNER
#endif
            do i = ista_kngp, iend_kngp  !for mpi
               chgqplus_l(i,j) = chgqplus_l(i,j) + chgq_l(i,j,iloop)
            end do
         end do
      end if

      afft = 0.d0
      if(npes > 1) then
         if(.not.np_send_is_set) then
            allocate(ip(ista_kngp:iend_kngp)); ip = -1
            allocate(np_send(0:npes-1,0:npes-1))
            allocate(np(0:npes-1)); np = 0
         end if
!!$         allocate(ip(ista_kngp:iend_kngp)); ip = -1
!!$         allocate(np(0:npes-1)); np = 0
!!$         allocate(np_send(0:npes-1,0:npes-1))
      end if

#ifdef _MPIFFT_
      if(.not.np_send_is_set) then
         if(mod(iend_kngp-ista_kngp+1,2) == 1) then
            allocate(igfp_ijk(ista_kngp:min(kgp_reduced,iend_kngp),3))
         else
            allocate(igfp_ijk(ista_kngp:min(kgp_reduced,iend_kngp)+1,3))
         end if
         idp = fft_box_size_CD_c(1,0)
         do l = ista_kngp, min(kgp_reduced,iend_kngp)
            np0 = igfp_l_c(l)
            i   = mod(np0-1,idp)+1
            j   = mod((np0-i)/idp, ly) + 1
            k   = (np0-i-(j-1)*idp)/(idp*ly)+1
            igfp_ijk(l,1)  = i
            igfp_ijk(l,2)  = j
            igfp_ijk(l,3)  = k
         end do
      end if
      lx     = fft_box_size_CD_c(1,0)
      lxy    = lx*ly_d
#endif

      if(npes > 1) then
         if(.not.np_send_is_set) then
            np_send = 0
            np = 0
            do k = 0, npes-1
               if(map_pe2ggacmp(k) >= nrank_ggacmp) cycle
#ifdef _MPIFFT_
               icdfft = map_pe2cdfft(k)
               nstart = icdfft*ny_d+1
               nend   = min(fft_box_size_CD(2,1),(icdfft+1)*ny_d)
               do l = ista_kngp, min(kgp_reduced, iend_kngp)
                  j   = igfp_ijk(l,2)
                  if(j >= nstart .and. j <= nend) then
                     if(map_pe2ggacmp(k) == 0) ip(l) = k
                     np(k) = np(k) + 1
                  end if
               end do
#else
               icdfft = mod(k,npes_cdfft)
               do l = ista_kngp, min(kgp_reduced, iend_kngp)
                  igp = (igfp_l(l)-1)*kimg+1
                  if(igp >= nis_fftp(icdfft) .and. igp <= nie_fftp(icdfft)) then
                     ip(l) = map_pe2cdfft(k)
                     np(k) = np(k) + 1
                  end if
               end do
#endif
               if(iprixc >=2)  write(nfout,'(" np(",i5,") = ",i8)') k, np(k)
            end do

            np_send(:,mype) = np(:)  ! number element sent from mype to j

            allocate(np_tmp(0:npes-1,0:npes-1))
            call mpi_allreduce(np_send,np_tmp,npes*npes,mpi_integer, mpi_sum, mpi_comm_group,ierr)
            np_send = np_tmp
            deallocate(np_tmp)

         end if
         maxdatasize = 0
         do j = 0, npes-1
            do i = 0, npes-1
               if(maxdatasize < np_send(i,j)) maxdatasize = np_send(i,j)
            end do
         end do
         if(iprixc>=2) write(nfout,'(" maxdatasize = ",i8)') maxdatasize
      end if
      np_send_is_set = .true.

#ifdef _DETAIL_MAP_CHARGE_TIMING_
      call tstatc0_end(id_sname2)
      call tstatc0_begin('map_charge2fftbox2_part2 ',id_sname3)
#endif

#ifdef _MPIFFT_
      allocate(ipout_s(ista_kngp:min(kgp_reduced,iend_kngp)))
      do l = ista_kngp, min(kgp_reduced,iend_kngp)
         i = igfp_ijk(l,1)
         j = igfp_ijk(l,2)
         k = igfp_ijk(l,3)
         icdfft = (j-1)/ny_d
         j0 = j - ny_d*icdfft
         ipout_s(l) = kimg*(i + (j0-1)*lx + (k-1)*lxy - 1)  + nis_fftp(icdfft)
      end do
#endif

      ! mype -> mype
      if(myrank_ggacmp < nrank_ggacmp) then
#ifdef _MPIFFT_
         nstart = myrank_cdfft*ny_d+1
         nend   = min(fft_box_size_CD(2,1),(myrank_cdfft+1)*ny_d)
         if(kimg == 1) then
            if(npes > 1) then
               do l = ista_kngp, min(kgp_reduced,iend_kngp)
                  i   = igfp_ijk(l,1)
                  if(i < 1 .or. i > fft_box_size_CD(1,1)) cycle
                  j   = igfp_ijk(l,2)
                  if(j >= nstart .and. j <= nend) then
                     ipout = ipout_s(l)
                     afft(ipout) = chgqplus_l(l,1)
                  end if
               end do
            else
               do l = ista_kngp, min(kgp_reduced,iend_kngp)
                  ipout = ipout_s(l)
                  afft(ipout) = chgqplus_l(l,1)
               end do
            end if
         else
            if(npes > 1) then
               do l = ista_kngp, min(kgp_reduced,iend_kngp)
                  i   = igfp_ijk(l,1)
                  if(i < 1 .or. i > fft_box_size_CD(1,1)) cycle
                  j   = igfp_ijk(l,2)
                  if(j >= nstart .and. j <= nend) then
                     ipout = ipout_s(l)
                     afft(ipout)   = chgqplus_l(l,1)
                     afft(ipout+1) = chgqplus_l(l,2)
                  end if
               end do
            else
               do l = ista_kngp, min(kgp_reduced,iend_kngp)
                  ipout = ipout_s(l)
                  afft(ipout)   = chgqplus_l(l,1)
                  afft(ipout+1) = chgqplus_l(l,2)
               end do
            end if
         end if
#else
         if(kimg == 1) then
            do l = ista_kngp, min(kgp_reduced,iend_kngp)
               igp = igfp_l(l)
               if(igp >= ista_fftp .and. igp <= iend_fftp) then
                  afft(igp) = chgqplus_l(l,1)
               end if
            end do
         else
#ifdef NEC_TUNE_MXCP
!CDIR NODEP
#endif
            do l = ista_kngp, min(kgp_reduced,iend_kngp)
               igp = (igfp_l(l)-1)*kimg+1
               if(igp >= ista_fftp .and. igp <= iend_fftp) then
                  afft(igp)   = chgqplus_l(l,1)
                  afft(igp+1) = chgqplus_l(l,2)
               end if
            end do
         end if
#endif
      end if

#ifdef _DETAIL_MAP_CHARGE_TIMING_
      call tstatc0_end(id_sname3)
      call tstatc0_begin('map_charge2fftbox2_part3 ',id_sname4)
#endif

      if(npes > 1) then
         allocate(tmp_s(maxdatasize*kimg))
         allocate(tmp_r(maxdatasize*kimg))
         allocate(igfp_s(maxdatasize),igfp_r(maxdatasize))
         allocate(req_r(npes-1))
         allocate(req_s(npes-1))
         do nb = 1, npes-1
            pe_s = mod(mype+nb,      npes)
            pe_r = mod(mype-nb+npes, npes)
#ifdef _MPIFFT_
            icdfft = map_pe2cdfft(pe_s)
#endif

            if(map_pe2ggacmp(pe_s) < nrank_ggacmp .and. np_send(pe_s,mype) > 0) then
               tmp_s = 0.d0
               igfp_s = 0
               nfp = 0

#ifdef _DETAIL_MAP_CHARGE_TIMING_
          call tstatc0_begin('map_charge2fftbox2_part4 ',id_sname5)
#endif
          if(kimg==1) then
               do l = ista_kngp, min(kgp_reduced,iend_kngp)
                  if(ip(l) == map_pe2cdfft(pe_s)) then
                     nfp = nfp+1
#ifdef _MPIFFT_
                     igfp_s(nfp) = ipout_s(l)
#else
                     igfp_s(nfp) = kimg*(igfp_l(l)-1)+1
#endif
                        tmp_s(nfp) = chgqplus_l(l,1)
                  end if
               end do
          else
               do l = ista_kngp, min(kgp_reduced,iend_kngp)
                  if(ip(l) == map_pe2cdfft(pe_s)) then
                     nfp = nfp+1
#ifdef _MPIFFT_
                     igfp_s(nfp) = ipout_s(l)
#else
                     igfp_s(nfp) = kimg*(igfp_l(l)-1)+1
#endif
                        tmp_s(2*nfp-1) = chgqplus_l(l,1)
                        tmp_s(2*nfp)   = chgqplus_l(l,2)
                  end if
               end do
          endif

#ifdef _DETAIL_MAP_CHARGE_TIMING_
          call tstatc0_end(id_sname5)
#endif

               datasize_s = np_send(pe_s,mype)*kimg
               if(iprixc>=2) then
                  write(nfout,'(" nb, pe_s,pe_r = ",3i8)') nb, pe_s,pe_r
                  write(nfout,'(" nfp*kimg   = ", i8)') nfp*kimg
                  write(nfout,'(" datasize_s = ",i8)') datasize_s
               end if
               if(datasize_s /= nfp*kimg) stop ' datasize_s /= nfp*kimg'
               call mpi_isend(tmp_s,datasize_s,mpi_double_precision, &
                    & pe_s, mype, mpi_comm_group,req_s(nb),ierr)
            end if

            if(myrank_ggacmp < nrank_ggacmp .and. np_send(mype,pe_r) > 0) then
               datasize_r = np_send(mype,pe_r)*kimg
               if(iprixc>=2) write(nfout,'(" datasize_r = ",i8)') datasize_r
               call mpi_irecv(tmp_r,datasize_r,mpi_double_precision, &
                    & pe_r, pe_r,  mpi_comm_group,req_r(nb),ierr)
            end if
            if(map_pe2ggacmp(pe_s) < nrank_ggacmp .and. np_send(pe_s,mype) > 0) &
                 & call mpi_wait(req_s(nb),istatus,ierr) 
            if(myrank_ggacmp < nrank_ggacmp .and. np_send(mype,pe_r) > 0) &
                 & call mpi_wait(req_r(nb),istatus,ierr)
            if(iprixc>=2) write(nfout,'( " tmp_s , tmp_r  completed")')

            datasize_s = np_send(pe_s,mype)
            datasize_r = np_send(mype,pe_r)
            if(map_pe2ggacmp(pe_s) < nrank_ggacmp .and. np_send(pe_s,mype) > 0) then
               call mpi_isend(igfp_s,datasize_s,mpi_integer, &
                    & pe_s, mype, mpi_comm_group, req_s(nb),ierr)
            end if
            if(myrank_ggacmp < nrank_ggacmp .and. np_send(mype,pe_r) > 0) then
               call mpi_irecv(igfp_r,datasize_r,mpi_integer, &
                    & pe_r, pe_r,  mpi_comm_group, req_r(nb),ierr)
            end if
            if(map_pe2ggacmp(pe_s) <nrank_ggacmp .and. np_send(pe_s,mype) > 0) &
                 & call mpi_wait(req_s(nb),istatus,ierr)
            if(myrank_ggacmp < nrank_ggacmp .and. np_send(mype,pe_r) > 0) &
                 & call mpi_wait(req_r(nb),istatus,ierr)
            if(iprixc>=2) write(nfout,'( " igfp_s , igfp_r  completed")')

            if(myrank_ggacmp < nrank_ggacmp) then
               if(kimg == 1) then
                  do l = 1, np_send(mype,pe_r)
                     ipout = igfp_r(l)
                     afft(ipout) = tmp_r(l)
                  end do
               else
#ifdef NEC_TUNE_MXCP
!CDIR NODEP
#endif
                  do l = 1, np_send(mype,pe_r)
                     ipout = igfp_r(l)
                     afft(ipout)   = tmp_r(2*l-1)
                     afft(ipout+1) = tmp_r(2*l)
                  end do
               end if
            end if
         end do
         deallocate(req_s, req_r)
         deallocate(igfp_r, igfp_s)
         deallocate(tmp_r,tmp_s)
      end if
#ifdef _MPIFFT_
      deallocate(ipout_s)
!!$      deallocate(igfp_ijk)
#endif
      if(npes > 1) then
         if(allocated(np)) deallocate(np)
!!$         deallocate(np_send,np, ip)
      end if
      deallocate(chgqplus_l)
#ifdef _DETAIL_MAP_CHARGE_TIMING_
      call tstatc0_end(id_sname4)
#endif

      call tstatc0_end(id_sname)

    end subroutine map_charge_onto_a_fft_box2

#ifdef _MPIFFT_
    subroutine set_cdata(np,aa,a)
      integer, intent(in) :: np
      real(kind=DP), dimension(nfftp), intent(in) :: aa
      real(kind=DP), dimension(mp_fftp), intent(out) :: a
      integer :: i, j, jj, k, nstart, nend, ipin, ipout
      integer :: lx, lxy, llx, lly, llxy

      nstart = np*ny_d+1
      nend   = min(fft_box_size_CD(2,1),(np+1)*ny_d)

      lx   = fft_box_size_CD_c(1,0)
      lxy  = lx*ly_d
      llx  = fft_box_size_CD_c(1,0)
      lly  = fft_box_size_CD_c(2,0)
      llxy = llx*lly

      a = 0.d0
      if(kimg==1)then
         do i = 1, fft_box_size_CD(1,1)
            do j = nstart, nend
               jj = j-nstart+1
               do k = 1, fft_box_size_CD(3,1)
                  ipin  =  i + (j-1)*llx + (k-1)*llxy
                  ipout =  i +(jj-1)* lx + (k-1)*lxy
                  A(ipout) = aa(ipin)
               end do
            end do
         end do
      else if(kimg == 2) then
         do i = 1, fft_box_size_CD(1,1)
            do j = nstart, nend
               jj = j-nstart+1
               do k = 1, fft_box_size_CD(3,1)
                  ipin  = 2*(i + (j-1)*llx + (k-1)*llxy)-1
                  ipout = 2*(i + (jj-1)*lx + (k-1)*lxy)-1
                  A(ipout  ) = aa(ipin)
                  A(ipout+1) = aa(ipin+1)
               end do
            end do
         end do
      end if
    end subroutine set_cdata
#endif

    subroutine set_ispin(ispin)
      integer, intent(out) :: ispin
      if(nspin == 2 .and. input_charge == Valence_plus_PC_Charge) then
         ispin = 2
      else
         ispin = 1
      endif
    end subroutine set_ispin
      
    subroutine cpafft_to_vxc_or_vxcpc(is)
      integer, intent(in) :: is
      integer :: i, ik, ip
      real(kind=DP),allocatable,dimension(:)    :: afft_mpi1   ! MPI d(nfftp)
      integer :: id_sname = -1
      call tstatc0_begin('cpafft_to_vxc_or_vxcpc ',id_sname)

      allocate(afft_mpi1(nfftp))

      call afft_allgatherv(afft,afft_mpi1)

      do ik = 1, kimg
         if(input_charge == Partial_Core_Charge) then
            do i = ista_kngp, min(kgp_reduced,iend_kngp)  ! mpi
#ifdef _MPIFFT_
               ip = (igfp_l_c(i)-1)*kimg + ik
#else
               ip = (igfp_l(i)-1)*kimg + ik
#endif
               vxcpc_l(i,ik) = afft_mpi1(ip)*rinplw
            end do
         else if(input_charge == Valence_plus_PC_Charge) then
            do i = ista_kngp, min(kgp_reduced,iend_kngp)  ! mpi
#ifdef _MPIFFT_
               ip = (igfp_l_c(i)-1)*kimg + ik
#else
               ip = (igfp_l(i)-1)*kimg + ik
#endif
               vxc_l(i,ik,is)   = afft_mpi1(ip)*rinplw
            end do
         end if
      end do
      deallocate(afft_mpi1)
      call tstatc0_end(id_sname)
    end subroutine cpafft_to_vxc_or_vxcpc
      
    subroutine cpafft(is)
      integer, intent(in) :: is
      integer             :: i

      afft = 0.d0
      do i = ista_fftph, iend_fftph                  ! MPI
         afft(2*i-1) = chgrhr_l(i,is)
      end do

    end subroutine cpafft

  end subroutine m_XC_cal_potential

  subroutine xcpotf(ispin,input_charge)
    integer, intent(in) :: ispin,input_charge

! #1) 1994/11/08 by T.Yamasaki
!    Coding for the case of xctype='PERZUN ' and  'XALPHA ' are done.
! #2) Spin-polarization is introduced by T. Yamasaki at 15th Dec. 1994
! #3) f77 -> f90     4th April 1999  by T. Yamasaki 

    real(kind=DP) :: rinplw
    real(kind=DP) :: exc_mpi     ! MPI

    real(kind=DP) :: DELTA
    data DELTA/1.d-40/

    rinplw = 1.d0/product(fft_box_size_CD(1:3,1))

    exc = 0.d0
    if(xctype == 'wign   '.or. xctype == 'wigner ')then
       call xcpotf_wigner(ispin,ista_fftph,iend_fftph,input_charge,DELTA,chgrhr_l,f2or1,exc)
    else if(  xctype ==  'pzold  ') then
       call xcpotf_pzold(ispin,ista_fftph,iend_fftph,input_charge,DELTA,chgrhr_l,f2or1,exc)
    else if(  xctype ==  'xalfa  ') then
       call xcpotf_xalfa(ispin,ista_fftph,iend_fftph,input_charge,DELTA,chgrhr_l,f2or1,exc)
    else if(  xctype == 'perzun '.or. xctype == 'pz     ') then
       call xcpotf_pz(ispin,ista_fftph,iend_fftph,input_charge,DELTA,chgrhr_l,f2or1,exc)
    else if(  xctype == 'vwn    ') then
       call xcpotf_vwn(ispin,ista_fftph,iend_fftph,input_charge,DELTA,chgrhr_l,f2or1,exc)
    else if(  xctype=='mjw    '.or. xctype=='bh     ' .or.xctype=='gl     ') then
       call xcpotf_mjw_bh_gl(len_xctype,xctype,ispin,ista_fftph,iend_fftph,input_charge,DELTA,chgrhr_l,f2or1,exc)
    endif
                        ! all xcpotf_* subroutines are in -(b_XC_Potential) ->chgrhr_l,exc
    exc = exc*univol*rinplw

    if(npes >= 2) then               ! MPI
       call mpi_allreduce(exc,exc_mpi,1,mpi_double_precision,mpi_sum &
            & ,mpi_comm_group,ierr)  ! MPI
       exc = exc_mpi                 ! MPI
    end if

  end subroutine xcpotf

  subroutine check_of_pcc(nopcc)
    logical, intent(out) :: nopcc
    integer              :: i

    nopcc = .true.

    do i = 1, ntyp
       if(itpcc(i) /= 0) then
          nopcc = .false.
          goto 2201
       endif
    end do

    vxcpc_l = 0.d0
    exc = 0.d0
2201 continue
  end subroutine check_of_pcc

  subroutine afft_allgatherv(afft_mpi0,afft)
!  Upgraded on 19 Sep. 2006 by T. Yamasaki
!    * MPIFFT
    real(kind=DP),intent(in),dimension(:) :: afft_mpi0(ista_fftp:iend_fftp)
    real(kind=DP),intent(out),dimension(:):: afft(nfftp)
#ifdef _MPIFFT_
    real(kind=DP), allocatable, dimension(:) :: afft_tmp
    integer  :: nstart, nend, lx, lxy, llx, lly, llxy, i, j, jj, k, ipin, ipout
    integer  :: nb, datasize, pe_s, pe_r
    integer, allocatable, dimension(:) :: req_s, req_r
    real(kind=DP), allocatable, dimension(:) :: tmp_s, tmp_r
#endif

    integer  :: id_sname = -1
    call tstatc0_begin('afft_allgatherv(in m_XC_Potential) ',id_sname)
    if(npes>=2)  call mpi_barrier(mpi_comm_group,ierr)

    if(npes_cdfft >= 2) then
       if(myrank_ggacmp < nrank_ggacmp) then
#ifdef _MPIFFT_
          afft = 0.d0
#ifndef _ALLREDUCE_AFFT_ALLGAHTERV_

          datasize = nfftp/npes_cdfft
          allocate(tmp_s(datasize)); tmp_s = 0.d0
          allocate(tmp_r(datasize)); tmp_r = 0.d0
          allocate(req_r(npes-1),req_s(npes-1))

          lx     = fft_box_size_CD_c(1,0)
          lxy    = lx*ly_d
          llx    = fft_box_size_CD_c(1,0)
          lly    = fft_box_size_CD_c(2,0)
          llxy   = llx*lly

          do i = 1, iend_fftp-ista_fftp+1
             tmp_s(i) = afft_mpi0(i+ista_fftp-1)
          end do

          do nb = 1, npes_cdfft-1
             pe_s = mod(myrank_cdfft+nb,           npes_cdfft) 
             pe_r = mod(myrank_cdfft-nb+npes_cdfft,npes_cdfft)
             call mpi_irecv(tmp_r,datasize,mpi_double_precision, &
                  & pe_r,pe_r,        mpi_cdfft_world(myrank_ggacmp),req_r(nb),ierr)
             call mpi_isend(tmp_s,datasize,mpi_double_precision, &
                  & pe_s,myrank_cdfft,mpi_cdfft_world(myrank_ggacmp),req_s(nb),ierr)
             call mpi_wait(req_r(nb),istatus,ierr)
             call mpi_wait(req_s(nb),istatus,ierr)

             nstart = pe_r*ny_d+1
             nend   = min(fft_box_size_CD(2,1),(pe_r+1)*ny_d)

             if(kimg == 1) then
                do k = 1, fft_box_size_CD(3,1)
                   do j = nstart, nend
                      jj = j - nstart + 1
                      do i = 1, fft_box_size_CD(1,1)
                         ipin  = i + (jj-1)* lx + (k-1)* lxy
                         ipout = i + ( j-1)*llx + (k-1)*llxy
                         afft(ipout)   = tmp_r(ipin)
                      end do
                   end do
                end do
             else if(kimg == 2) then
                do k = 1, fft_box_size_CD(3,1)
                   do j = nstart, nend
                      jj = j - nstart + 1
                      do i = 1, fft_box_size_CD(1,1)
                         ipin  = 2*(i + (jj-1)* lx + (k-1)* lxy)-1
                         ipout = 2*(i + ( j-1)*llx + (k-1)*llxy)-1
                         afft(ipout)   = tmp_r(ipin)
                         afft(ipout+1) = tmp_r(ipin+1)
                      end do
                   end do
                end do
             end if
          end do
          deallocate(req_s,req_r)
          deallocate(tmp_s)
          deallocate(tmp_r)

! diagonal part
          nstart = myrank_cdfft*ny_d+1
          nend   = min(fft_box_size_CD(2,1),(myrank_cdfft+1)*ny_d)
!!$          allocate(afft_tmp(nfftp))

          if(kimg == 1) then
             do k = 1, fft_box_size_CD(3,1)
                do j = nstart, nend
                   jj = j - nstart + 1
                   do i = 1, fft_box_size_CD(1,1)
                      ipin  = ista_fftp-1 + (i + (jj-1)* lx + (k-1)* lxy)
                      ipout =               (i + ( j-1)*llx + (k-1)*llxy)
                      afft(ipout)   = afft_mpi0(ipin)
                   end do
                end do
             end do
          else if(kimg == 2) then
             do k = 1, fft_box_size_CD(3,1)
                do j = nstart, nend
                   jj = j - nstart + 1
                   do i = 1, fft_box_size_CD(1,1)
                      ipin  = ista_fftp-1 + 2*(i + (jj-1)* lx + (k-1)* lxy)-1
                      ipout =               2*(i + ( j-1)*llx + (k-1)*llxy)-1
                      afft(ipout)   = afft_mpi0(ipin)
                      afft(ipout+1) = afft_mpi0(ipin+1)
                   end do
                end do
             end do
          end if

#else
          nstart = myrank_cdfft*ny_d+1
          nend   = min(fft_box_size_CD(2,1),(myrank_cdfft+1)*ny_d)
          lx     = fft_box_size_CD_c(1,0)
          lxy    = lx*ly_d
          llx    = fft_box_size_CD_c(1,0)
          lly    = fft_box_size_CD_c(2,0)
          llxy   = llx*lly
          allocate(afft_tmp(nfftp))

          if(kimg == 1) then
             do k = 1, fft_box_size_CD(3,1)
                do j = nstart, nend
                   jj = j - nstart + 1
                   do i = 1, fft_box_size_CD(1,1)
                      ipin  = ista_fftp-1 + (i + (jj-1)* lx + (k-1)* lxy)
                      ipout =               (i + ( j-1)*llx + (k-1)*llxy)
                      afft(ipout)   = afft_mpi0(ipin)
                   end do
                end do
             end do
          else if(kimg == 2) then
             do k = 1, fft_box_size_CD(3,1)
                do j = nstart, nend
                   jj = j - nstart + 1
                   do i = 1, fft_box_size_CD(1,1)
                      ipin  = ista_fftp-1 + 2*(i + (jj-1)* lx + (k-1)* lxy)-1
                      ipout =               2*(i + ( j-1)*llx + (k-1)*llxy)-1
                      afft(ipout)   = afft_mpi0(ipin)
                      afft(ipout+1) = afft_mpi0(ipin+1)
                   end do
                end do
             end do
          end if
          call mpi_allreduce(afft, afft_tmp, nfftp, mpi_double_precision, mpi_sum &
               &                                  , mpi_cdfft_world(myrank_ggacmp),ierr)
          afft = afft_tmp
#endif

#else
          call mpi_allgatherv(afft_mpi0,nel_fftp(myrank_cdfft),mpi_double_precision &  ! MPI
               &       ,afft,nel_fftp,idisp_fftp,mpi_double_precision,mpi_cdfft_world(myrank_ggacmp),ierr)
#endif
       end if
    else
       afft = afft_mpi0
    end if

    if(nrest_cdfft >= 1) then
       if(mype > npes_cdfft*nrank_ggacmp-1) then
          call mpi_recv(afft,nfftp,mpi_double_precision &
               & , mype-npes_cdfft*nrank_ggacmp,1,mpi_comm_group,istatus,ierr)
       end if
       if(mype < nrest_cdfft) then
          call mpi_send(afft,nfftp,mpi_double_precision &
               & , mype+npes_cdfft*nrank_ggacmp,1,mpi_comm_group,ierr)
       end if
    end if

    call tstatc0_end(id_sname)

  end subroutine afft_allgatherv


  subroutine m_XC_rst_npsend()
     np_send_is_set = .false.
     if(allocated(ip)) deallocate(ip)
     if(allocated(igfp_ijk)) deallocate(igfp_ijk)
     if(allocated(np_send)) deallocate(np_send)
  end subroutine m_XC_rst_npsend

end module m_XC_Potential

!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 440 $)
!
!  MAIN PROGRAM: PHASE
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!  $Id: mdmain.F90 440 2015-08-03 07:18:01Z ktagami $
!
#ifdef FJ_TIMER
#  define __TIMER_FJ_START_w_BARRIER(str,a)  call mpi_barrier(str,ierr); call timer_sta(a)
#  define __TIMER_FJ_START(a)                call timer_sta(a)
#  define __TIMER_FJ_STOP(a)                 call timer_end(a)
#else
#  define __TIMER_FJ_START_w_BARRIER(str,a)
#  define __TIMER_FJ_START(a)
#  define __TIMER_FJ_STOP(a)
#endif
#ifdef __TIMER__
#  define __TIMER_START_w_BARRIER(str,a)  call mpi_barrier(str,ierr) ;   call timer_sta(a)
#  define __TIMER_START(a)                call timer_sta(a)
#  define __TIMER_STOP(a)                 call timer_end(a)
#else
#  define __TIMER_START_w_BARRIER(str,a)
#  define __TIMER_START(a)
#  define __TIMER_STOP(a)
#endif
!
program PHASE


  use m_Const_Parameters,    only : DRIVER_NEB,DRIVER_CONSTRAINT,DRIVER_MTD
  use m_Parallelization,     only : mpi_comm_group


  implicit none
  logical  :: ChargeDensity_is_Converged, TotalEnergy_is_Divergent
  logical  :: Already_Converged, Already_Converged2
  logical  :: Positron_bulk, Positron_defect, Structure_is_fixed
  logical  :: Hubbard_model
  logical  :: Forces_are_Converged, Ending_Time, Force_errors_are_tolerable
  logical  :: from_Initialize
!!$  logical  :: ChargeDensity_is_Fixed
   interface
     subroutine Initialization(init_mpi)
       integer, intent(in), optional :: init_mpi
     end subroutine Initialization
   end interface
#ifdef NEC_ITER_REG
  integer  :: count_for_ftrace
#endif

  integer :: ispin, ik, iksnl, ierR

  integer :: initmpi
  logical :: confpara
  integer :: driver
  
#ifdef NEC_ITER_REG
     count_for_ftrace = 0
     call FTRACE_REGION_BEGIN("INITIAL")
#endif

  confpara = Resolve_Config_Parallel()
  initmpi=1
  if(confpara) initmpi=0
                                                  __TIMER_START(17)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,21)
!  call Initialization(init_mpi=1)
  call Initialization(initmpi)
                                                  __TIMER_FJ_STOP(21)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,22)
  call InputData_Analysis

  driver   = Resolve_Driver()
  if (driver==DRIVER_NEB)then
#ifndef DISABLE_CONSTRAINTS
      call do_neb()
  else if (driver==DRIVER_CONSTRAINT) then
      call constrained_dynamics()
  else if (driver==DRIVER_MTD) then
      call meta_dynamics()
#endif
  else
                                                  __TIMER_FJ_STOP(22)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,23)
  call Preparation                   ! Basis set, symmetry check etc.
                                                  __TIMER_FJ_STOP(23)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,24)
  call Preparation_for_mpi(1)        ! mpi
                                                  __TIMER_FJ_STOP(24)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,25)
  call PseudoPotential_Construction
                                                  __TIMER_FJ_STOP(25)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,26)
#ifdef ENABLE_ESM_PACK
  call Preparation_for_ESM
#endif

  call Ewald_and_Structure_Factor
                                                  __TIMER_FJ_STOP(26)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,27)
  call Initial_Electronic_Structure
                                                  __TIMER_FJ_STOP(27)
                                                  __TIMER_STOP(17)

 
  if(ChargeDensity_is_Fixed() .and. One_by_one_in_each_rank_k()) then ! icond=2, 3
     call ekcal  ! contained here
  else
     call Initial_MD_Condition
#ifdef NEC_ITER_REG
     call FTRACE_REGION_END("INITIAL")
#endif

     if(.not.Already_Converged()) then
#ifdef NEC_ITER_REG
        call FTRACE_REGION_BEGIN("SOLVE-FIRST")
#endif
        StressLoop: do
           AtomicConfiguration: do
              ChargeDensity:    do

#ifdef NEC_ITER_REG
                 count_for_ftrace = count_for_ftrace + 1
                 if(count_for_ftrace .eq. 2) then
                    call FTRACE_REGION_END("SOLVE-FIRST")
                    call FTRACE_REGION_BEGIN("SOLVE-CORE")
                 end if
#endif
                 call IterationNumber_Setting
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,16)
!!$                 call ReadCheckPointData_if_needed
                 call Renewal_of_WaveFunctions
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,11)
                 call ChargeDensity_Construction(0)
                 call ChargeDensity_Mixing
                                                  __TIMER_STOP(11)
                 if(Ending_Time()) then
                                                  __TIMER_STOP(16)
                    exit StressLoop
                 end if
                 if(TotalEnergy_is_Divergent()) then
                                                  __TIMER_STOP(16)
                    exit StressLoop
                 end if
                                                  __TIMER_START_w_BARRIER(mpi_comm_group,11)
                 call Renewal_of_Potential
                                                  __TIMER_STOP(11)
                 if(Hubbard_model()) then
                    call Renewal_of_Hubbard_Potential
                 end if
!!$                 call WriteCheckPointData  ! if necessary
                 if(ChargeDensity_is_Converged()) then
                                                  __TIMER_STOP(16)
                    exit ChargeDensity
                 end if
                                                  __TIMER_STOP(16)
              enddo ChargeDensity


              if(Positron_defect()) then
                 call Renewal_of_pPotential()
                 call Solve_pWaveFunctions()
              end if
              if(Structure_is_fixed()) then
                  exit StressLoop
              end if
              call Forces
              if(Forces_are_Converged()) then
                exit AtomicConfiguration
              endif
              if(Force_errors_are_tolerable()) then
                 call Postprocessing_during_MD()
                 call Move_Ions
                 call Ewald_and_Structure_Factor
                 call MDIterationNumber_Setting
              end if
           enddo AtomicConfiguration
           call Stress
           exit StressLoop
        end do StressLoop



#ifdef NEC_ITER_REG
        if(count_for_ftrace .eq. 1) then
           call FTRACE_REGION_END("SOLVE-FIRST")
        else
           call FTRACE_REGION_END("SOLVE-CORE")
        end if
#endif
     end if

     if(Already_Converged2() .and. .not.Positron_defect() .and. Positron_bulk()) then
#ifdef NEC_ITER_REG
        call FTRACE_REGION_BEGIN("POSITRON")
#endif
        call Renewal_of_pPotential()
        call Solve_pWaveFunctions()
#ifdef NEC_ITER_REG
        call FTRACE_REGION_END("POSITRON")
#endif
     end if

#ifdef NEC_ITER_REG
     call FTRACE_REGION_BEGIN("FINAL")
#endif
  end if

  if(ChargeDensity_is_Fixed() .and. One_by_one_in_each_rank_k()) then ! icond=2, 3
     call WriteDownData_onto_Files_ek()
  else
     call Postprocessing(.false.)
                                                  __TIMER_FJ_START_w_BARRIER(mpi_comm_group,39)
     call rttddft_main
     call WriteDownData_onto_Files(.true.)
                                                  __TIMER_FJ_STOP(39)
  end if

  endif

  if(driver/=DRIVER_NEB) call Finalization_of_mpi           ! mpi
#ifdef NEC_ITER_REG
  call FTRACE_REGION_END("FINAL")
#endif
contains
  subroutine ekcal()
    logical :: AllKpoints_are_Calculated2, Already_Converged_for_Kgroup
    logical :: EigenValues_are_Converged, AllKpoints_are_Converged
    integer :: nk
    nk = 0
    KPOINT_GROUP: do
       call KpointNumber_Setting2()
       if(AllKpoints_are_Converged()) exit KPOINT_GROUP
       call Preparation_ek()
       call Preparation_for_mpi_ek
       call PseudoPotential_ek
       call Initial_WaveFunctions_ek
       if(.not.Already_Converged_for_kgroup()) then
          SolveWaveFunctions: do
             if(Ending_Time())                 exit KPOINT_GROUP
             call IterationNumber_Setting()
             call Renewal_of_WaveFunctions()
             if(EigenValues_are_Converged())   exit SolveWaveFunctions
          enddo SolveWaveFunctions
!!$          call Postprocessing_k()
          if(AllKpoints_are_Calculated2(nk))     exit KPOINT_GROUP
       else
          exit KPOINT_GROUP
       end if
    enddo KPOINT_GROUP
  end subroutine ekcal

  logical function ChargeDensity_is_Fixed()
    use m_Control_Parameters, only : icond
    use m_Const_Parameters,   only : FIXED_CHARGE, FIXED_CHARGE_CONTINUATION
    if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
       ChargeDensity_is_Fixed = .true.
    else
       ChargeDensity_is_Fixed = .false.
    end if
  end function ChargeDensity_is_Fixed

  logical function One_by_one_in_each_rank_k()
    use m_Control_Parameters, only : fixed_charge_k_parallel
    use m_Const_Parameters,   only : ONE_BY_ONE
    if(fixed_charge_k_parallel == ONE_BY_ONE) then
       One_by_one_in_each_rank_k = .true.
    else
       One_by_one_in_each_rank_k = .false.
    end if
  end function One_by_one_in_each_rank_k


  integer function Resolve_Driver()
    use m_Control_Parameters, only : driver
    Resolve_Driver = driver
  end function Resolve_Driver

  logical function Resolve_Config_Parallel()
    use m_Parallelization, only : m_Parallel_resolve_conf_para
    implicit none
    Resolve_Config_Parallel = m_Parallel_resolve_conf_para()
  end function Resolve_Config_Parallel

  subroutine Postprocessing_during_MD()
    use m_IterationNumbers, only : iteration_ionic
    use m_Control_Parameters, only : postproc_frequency
    if(postproc_frequency<=0) return
    if(mod(iteration_ionic,postproc_frequency)==0)then
       call Postprocessing(.true.)
    endif
  end subroutine Postprocessing_during_MD

end program PHASE

#define NEC_TUNE
!#undef NEC_TUNE
! AAS for Modified Davidson and Modified Kosugi
module m_ES_WF_by_ModifiedDavidson
#ifdef TRANSPOSE
#ifdef VPP
#define _ODD_BOUNDARY_
#endif
#ifdef SX
#define _ODD_BOUNDARY_
#endif
#ifdef NEC_TUNE1
#define _ODD_BOUNDARY_
#endif
  use m_Const_Parameters,    only : DP,SP,DIRECT,ON,OFF,SCF,GAMMA,OTHER_BANDS,SKIP,EXECUT,ELECTRON, OLD
  use m_Parallelization,     only : mpi_comm_group &
       &                          , myrank_e,myrank_k,map_e,map_k,ista_e,iend_e,istep_e &
       &                          , ista_k,iend_k,np_g1k,ista_g1,mpi_k_world,ierr,map_z &
       &                          , np_e,npes,nrank_e,mype
  use m_Control_Parameters,  only : nspin,ipridavidson,kimg,neg,af,npartition_david &
       &                          , delta_eig_empty &
       &                          , delta_eig_occup &
       &                          , eps_mdkosugi, eps_residual_mdkosugi, sw_fft_xzy &
       &                          , max_iter_david, sw_MRCV_only,eps_david &
       &                          , nblocksize_fftw, nblocksize_fftw_is_given &
#ifdef SAVE_FFT_TIMES
       &                          , sw_divide_subspace, sw_save_fft, sw_hybrid_functional
#else
       &                          , sw_divide_subspace, sw_hybrid_functional
#endif
  use m_Files,               only : nfout
  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_FFT,                 only : nfft,fft_box_size_WF, m_FFT_Vlocal_W_3D, m_FFT_Direct_3D &
#ifdef FFT_3D_DIVISION
 &                                , m_FFT_Vlocal_W_3DIV_3D, m_FFT_Direct_3DIV_3D             &
#endif
 &                                , m_FFT_Direct_XYZ_3D
  use m_ES_WF_by_SDorCG,     only : map_fft_to_WF_3D
  use m_Kpoints,             only : kv3,vkxyz, k_symmetry
  use m_PlaneWaveBasisSet,   only : kg1, iba, igf, nbase, m_pwBS_kinetic_energies
  use m_Electronic_Structure,only : zaj_l, neordr, nrvf_ordr, eko_l, vlhxcQ &
       &                          , occup_l &
       &                          , fsr_l,fsi_l, vnlph_l, vlhxc_l &
#ifdef SAVE_FFT_TIMES
       &                          , status_saved_phifftr &
#endif
       &                          , m_ES_Vlocal_in_Rspace_3D &
       &                          , m_ES_WF_in_Rspace_3D &
       &                          , m_ES_wd_zaj_small_portion_3D &
       &                          , m_ES_wd_eko_3D &
       &                          , m_ES_sort_eigen_values_3D
  use m_ES_ortho,           only : np_g1k_x                                          &
       &                         , m_ES_orthogonal_phi_to_WFs
  use m_ES_nonlocal,        only : m_ES_Vnonlocal_W_3D                               &
       &                         , m_ES_betar_dot_WFs_4_each_k_3D                    &
       &                         , m_ES_alloc_scss_etc_3D                            &
       &                         , m_ES_dealloc_scss_etc                             &
       &                         , m_ES_betar_dot_Psi_4_each_k_3D
  use m_Ionic_System,       only : natm, iwei, ityp, ntyp
  use m_PseudoPotential,    only : ilmt,nlmta,lmta,q,dion &
       &                         , lmtt,ltp,mtp &
       &                         , m_PP_include_vanderbilt_pot &
       &                         , ipaw,dion_paw,modnrm
  use m_NonLocal_Potential, only : snl
  use m_Parallelization,    only : nel_fft_x , nel_fft_y, nel_fft_z        &
       &                         , fft_X_x_nel, fft_X_y_nel, fft_X_z_nel   &
       &                         , mp_g1k, myrank_g                        &
       &                         , ista_g1k, iend_g1k, neg_g, mpi_ke_world &
       &                         , mpi_kg_world            &
       &                         , np_fs, myrank_g, nis_fs
#ifdef NEC_TUNE
  use m_Parallelization,    only : ista_atm, iend_atm, ista_fs, iend_fs, np_fs
#endif
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
use mod_timer
#endif
! === TIMERTIMERTIMER ==========================================================


!!$! ============================== added by K. Tagami ================== 11.0
!!$  use m_Const_Parameters,   only : CMPLDP, Neglected
!!$  use m_Control_Parameters,  only : ndim_spinor, noncol, ndim_chgpot, SpinOrbit_mode, &
!!$       &                            sw_hubbard
!!$  use m_PseudoPotential,     only : q_noncl, dion_scr_noncl
!!$!  use m_Electronic_Structure,  only : m_ES_Vlocal_in_Rspace_noncl
!!$
!!$!  use m_FFT,                 only : m_FFT_Vlocal_W_noncl
!!$!  use m_ES_ortho,              only : m_ES_orthogonl_SD_to_WFs_noncl
!!$!  use m_Electronic_Structure,      only : m_ES_sort_eigen_vals_noncl
!!$! ==================================================================== 11.0

  use m_ES_ExactExchange, only : m_ES_Vexx_W,m_ES_EXX_potential &
     , m_ES_EXX_gather_valence_states

  implicit none
  integer, private, parameter                         :: sw_timing_2ndlevel = ON

  private
  
  integer, allocatable, dimension(:) :: nsize_subspace, nsize_matrix
  integer, allocatable, dimension(:) :: ista_e_l,iend_e_l,ielm_e_l
  integer :: nsize_sb_now, nsize_mt_now, nsize_mt_old,msize_matrix
  integer :: nblock,msize_subspace
  real(kind=DP), allocatable, target, dimension(:) :: w1hw2,w1hw2_mpi
  real(kind=DP), allocatable, target, dimension(:) :: w1sw2,w1sw2_mpi
  real(kind=DP), allocatable, target, dimension(:,:,:,:) :: zat_l
  real(kind=DP), allocatable, target, dimension(:,:,:,:) :: zah_l
  real(kind=DP), allocatable, target, dimension(:,:,:) :: fsr,fsi
  real(kind=DP), pointer, dimension(:,:,:) :: fsr_p,fsi_p
  real(kind=DP), allocatable, target, dimension(:,:,:) :: fsr_t,fsi_t
  real(kind=DP), allocatable, dimension(:,:,:) :: fsr_mpi,fsi_mpi
  real(kind=DP), pointer, dimension(:,:,:,:) :: zat_l_p, zah_l_p
  real(kind=DP), allocatable, target, dimension(:,:,:,:) :: zat_l_t,zah_l_t
  logical, allocatable, target, dimension(:)   :: feigconv_t
  logical, allocatable, dimension(:)   :: feigconv_mpi
  logical, pointer, dimension(:)   :: feigconv_p
  real(kind=DP), allocatable, dimension(:,:,:) :: zajold_l
  real(kind=DP), allocatable, dimension(:,:,:) :: zaj_l_backup
  real(kind=DP), allocatable, dimension(:,:) :: fsrold_l,fsiold_l
  real(kind=DP), allocatable, dimension(:,:,:,:):: wfsd_l  !d(kg1,np_e,ik:ik,kimg)
  real(kind=DP), allocatable, dimension(:,:,:)  :: bsdr_l, bsdi_l !d(np_e,nlmta,1)
  real(kind=DP) :: eps_residual
  logical, allocatable, target, dimension(:)   :: feigconv
  integer, allocatable, dimension(:,:) :: ibover

  real(kind=DP), allocatable,dimension(:) ::     eko_d
  real(kind=DP), allocatable,dimension(:) ::     eko_d_mpi
  integer, allocatable,dimension(:) ::     occup
  
  public :: m_ESmddavid_Renew_WF
  public :: m_ESmddavid_Subspace_Rotation
    
  
! ================================= added by K. Tagami ================= 11.0
  real(kind=DP), allocatable, dimension(:,:,:,:,:) :: zat_l_noncl
  real(kind=DP), allocatable, dimension(:,:,:,:,:) :: zah_l_noncl
  real(kind=DP), allocatable, dimension(:,:,:,:) :: fsr_noncl, fsi_noncl
  real(kind=DP), allocatable, dimension(:,:,:,:) :: zaj_l_backup_noncl
!
  real(kind=DP), allocatable, dimension(:,:,:,:) :: zajold_l_noncl
  real(kind=DP), allocatable, dimension(:,:,:) :: fsrold_l_noncl,fsiold_l_noncl
! ===================================================================== 11.0

  include 'mpif.h'

contains
  


  
  subroutine SD_direction_3D(precon,ik,ibo,ekin_l,VlocalW,p_l,lsize)
    integer     , intent(in)                   :: precon,ik,ibo,lsize
    real(kind=DP), intent(in), dimension(maxval(np_g1k))  :: ekin_l
#ifdef FFT_3D_DIVISION
    real(kind=DP), intent(in), dimension(lsize*2   ,1) :: VlocalW
#else
    real(kind=DP), intent(in), dimension(lsize*kimg,1) :: VlocalW
#endif
    real(kind=DP)             , dimension(maxval(np_g1k))  :: p_l

    integer       :: i, ib, iadd
    real(kind=DP) :: devr,denom, e1, devi, norm

!   ib = map_z(ibo)                                  ! MPI
    ib = ibo
    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    norm = 0.d0

    if(kimg == 1) then
       do i = ista_g1k(ik), iend_g1k(ik)
          iadd = i - ista_g1k(ik) + 1
          devr  = (ekin_l(iadd)-eko_l(ib,ik))*zaj_l(iadd,ib,ik,1)&
               & + VlocalW(iadd,1)*denom + vnlph_l(iadd,ib,1)
          wfsd_l(iadd,ib,ik,1) = - devr
          norm = norm + devr*devr
       end do
    else if(kimg == 2) then
       do i = ista_g1k(ik), iend_g1k(ik)
          iadd = i - ista_g1k(ik) + 1
          e1    = ekin_l(iadd) - eko_l(ib,ik)
          devr  = e1*zaj_l(iadd,ib,ik,1) + VlocalW(2*iadd-1,1)*denom+vnlph_l(iadd,ib,1)
          devi  = e1*zaj_l(iadd,ib,ik,2) + VlocalW(2*iadd,  1)*denom+vnlph_l(iadd,ib,2)
          wfsd_l(iadd,ib,ik,1) = - devr
          wfsd_l(iadd,ib,ik,2) = - devi
          norm = norm + devr*devr + devi*devi
       end do
       if(k_symmetry(ik) == GAMMA) then
          if(ista_g1k(ik) == 1) then
             devr=wfsd_l(1,ib,ik,1)
             devi=wfsd_l(1,ib,ik,2)
             norm = norm*2.d0 - devr*devr - devi*devi
          end if
       end if
    end if
    call mpi_allreduce(MPI_IN_PLACE,norm,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
    
    feigconv(ib)=.false.
    if(sqrt(norm) .lt. eps_residual) feigconv(ib)=.true.
    
    if(precon==ON) then
      call decide_precon_factor_wfsd_3D(ik,ibo,ekin_l,p_l)
!call decide_precon_factor_david(ik,hdiag,sdiag,eko_l(ib,ik),p)
      if(kimg == 1) then
         do i = ista_g1k(ik), iend_g1k(ik)
            iadd = i - ista_g1k(ik) + 1
            wfsd_l(iadd,ib,ik,1) = p_l(iadd)*wfsd_l(iadd,ib,ik,1)
         end do
      else if(kimg == 2) then
         do i = ista_g1k(ik), iend_g1k(ik)
            iadd = i - ista_g1k(ik) + 1
            wfsd_l(iadd,ib,ik,1) = p_l(iadd)*wfsd_l(iadd,ib,ik,1)
            wfsd_l(iadd,ib,ik,2) = p_l(iadd)*wfsd_l(iadd,ib,ik,2)
         end do
      end if
    end if
  end subroutine SD_direction_3D
  
  subroutine SD_direction_3D2(precon,ik,ib1,ib2,ibesize,ekin_l,VlocalW,lsize,p_l)
    integer     , intent(in)                   :: precon,ik,ib1,ib2,ibesize,lsize
    real(kind=DP), intent(in), dimension(maxval(np_g1k))  :: ekin_l
    real(kind=DP), intent(in), dimension(lsize*kimg,ibesize) :: VlocalW
    real(kind=DP)             , dimension(maxval(np_g1k))  :: p_l

    integer       :: i, ib, iadd
    real(kind=DP) :: devr,denom, e1, devi, norm
    real(kind=DP),allocatable,dimension(:) :: normb

!   ib = map_z(ibo)                                  ! MPI
!!$    ib = ibo
    denom = 1.d0/product(fft_box_size_WF(1:3,1))
!!$    norm = 0.d0
    allocate(normb(ib1:ib2)); normb = 0.d0

    if(kimg == 1) then
       do i = ista_g1k(ik), iend_g1k(ik)
          iadd = i - ista_g1k(ik) + 1
          do ib = ib1, ib2
             devr  = (ekin_l(iadd)-eko_l(ib,ik))*zaj_l(iadd,ib,ik,1)&
                  & + VlocalW(iadd,ib-ib1+1)*denom + vnlph_l(iadd,ib,1)
             wfsd_l(iadd,ib,ik,1) = - devr
             normb(ib) = normb(ib) + devr*devr
          end do
       end do
    else if(kimg == 2) then
       do i = ista_g1k(ik), iend_g1k(ik)
          iadd = i - ista_g1k(ik) + 1
          do ib = ib1, ib2
             e1    = ekin_l(iadd) - eko_l(ib,ik)
             devr  = e1*zaj_l(iadd,ib,ik,1) + VlocalW(2*iadd-1,ib-ib1+1)*denom+vnlph_l(iadd,ib,1)
             devi  = e1*zaj_l(iadd,ib,ik,2) + VlocalW(2*iadd,  ib-ib1+1)*denom+vnlph_l(iadd,ib,2)
             wfsd_l(iadd,ib,ik,1) = - devr
             wfsd_l(iadd,ib,ik,2) = - devi
             normb(ib) = normb(ib) + devr*devr + devi*devi
          end do
       end do
       if(k_symmetry(ik) == GAMMA) then
          if(ista_g1k(ik) == 1) then
             do ib = ib1, ib2
                devr=wfsd_l(1,ib,ik,1)
                devi=wfsd_l(1,ib,ik,2)
                normb(ib) = normb(ib)*2.d0 - devr*devr - devi*devi
             end do
          end if
       end if
    end if
    call mpi_allreduce(MPI_IN_PLACE,normb,ib2-ib1+1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
    
    do ib = ib1, ib2
       feigconv(ib)=.false.
       if(sqrt(normb(ib)) .lt. eps_residual) feigconv(ib)=.true.

       if(precon==ON) then
!!$      call decide_precon_factor_wfsd_3D(ik,ibo,ekin_l,p_l)
          call decide_precon_factor_wfsd_3D(ik,ib,ekin_l,p_l)
!call decide_precon_factor_david(ik,hdiag,sdiag,eko_l(ib,ik),p)
          if(kimg == 1) then
             do i = ista_g1k(ik), iend_g1k(ik)
                iadd = i - ista_g1k(ik) + 1
                wfsd_l(iadd,ib,ik,1) = p_l(iadd)*wfsd_l(iadd,ib,ik,1)
             end do
          else if(kimg == 2) then
             do i = ista_g1k(ik), iend_g1k(ik)
                iadd = i - ista_g1k(ik) + 1
                wfsd_l(iadd,ib,ik,1) = p_l(iadd)*wfsd_l(iadd,ib,ik,1)
                wfsd_l(iadd,ib,ik,2) = p_l(iadd)*wfsd_l(iadd,ib,ik,2)
             end do
          end if
       end if
    end do
    deallocate(normb)

  end subroutine SD_direction_3D2

  subroutine decide_precon_factor_wfsd_3D(ik,ibo,ekin_l,p_l)
    integer, intent(in)                         :: ik,ibo
    real(kind=DP), intent(in),  dimension(maxval(np_g1k))  :: ekin_l
    real(kind=DP), intent(out), dimension(maxval(np_g1k))  :: p_l

    integer       :: i, iadd
    real(kind=DP) :: ektot, x, x1, x2, d_ektot

!    call kinetic_energy_wfsd(ik,ibo,ekin,ektot)   ! -here
    call kinetic_energy_3D(ik,ibo,ekin_l,ektot)   ! -here
    d_ektot = 4.d0/ektot/3.d0
    p_l = 0.d0
    do i = ista_g1k(ik), iend_g1k(ik)
       iadd = i - ista_g1k(ik) + 1
       x = ekin_l(iadd)*d_ektot
       x1 = (x*x+9.d0)*(x+3.d0)
       x2 = (x*x)*(x*x)
       p_l(iadd)  = x1/(x1 + x2 )
    end do
!    p=p*d_ektot
  end subroutine decide_precon_factor_wfsd_3D
  
  subroutine kinetic_energy_wfsd(ik,ibo,dekin,ektot)
    integer, intent(in) :: ik, ibo
    real(kind=DP), intent(in), dimension(kg1)  :: dekin
    real(kind=DP), intent(out)                 :: ektot
    integer  :: i, ri, ib
    ektot = 0.d0
    ib=map_z(ibo)
    do ri = 1, kimg
       do i = 1, iba(ik)
          ektot = ektot + dekin(i)*wfsd_l(i,ib,ik,ri)**2   ! MPI
       end do
    end do

    if(k_symmetry(ik) == GAMMA) ektot = ektot*2.d0

  end subroutine kinetic_energy_wfsd
  
  subroutine kinetic_energy_3D(ik,ibo,dekin,ektot)
    integer, intent(in) :: ik, ibo
    real(kind=DP), intent(in), dimension(maxval(np_g1k)) :: dekin
    real(kind=DP), intent(out)                 :: ektot
    integer  :: i, ib, iadd
    ektot = 0.d0
!   ib = map_z(ibo)
    ib = ibo
    if(kimg == 1) then
       do i = ista_g1k(ik), iend_g1k(ik)
          iadd = i - ista_g1k(ik) + 1
          ektot = ektot + dekin(iadd)*zaj_l(iadd,ib,ik,1)**2
       end do
    else
       do i = ista_g1k(ik), iend_g1k(ik)
          iadd = i - ista_g1k(ik) + 1
          ektot = ektot + dekin(iadd)*( zaj_l(iadd,ib,ik,1)**2 &
               &                      + zaj_l(iadd,ib,ik,2)**2)
       end do
    end if
    call mpi_allreduce(MPI_IN_PLACE,ektot,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
    if(k_symmetry(ik) == GAMMA)  ektot = ektot*2.d0
  end subroutine kinetic_energy_3D
  
  

  subroutine normalize_wfsd_3D(ik)
    integer,intent(in) :: ik
    real(kind=DP) :: norm, wfsdr, wfsdi
    integer :: ib1,ii,ib,iadd
  
    do ib1 = 1, np_e
!      ib=map_z(ib1)
       ib=ib1
       norm = 0.d0
       if(kimg==1) then
          do ii=ista_g1k(ik),iend_g1k(ik)
             iadd = ii - ista_g1k(ik) + 1
             wfsdr = wfsd_l(iadd,ib,ik,kimg)
             norm = norm + wfsdr*wfsdr
          end do
          call mpi_allreduce(MPI_IN_PLACE,norm,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
          norm = 1.d0/sqrt(norm)
          do ii=ista_g1k(ik),iend_g1k(ik)
             iadd = ii - ista_g1k(ik) + 1
             wfsd_l(iadd,ib,ik,1) = wfsd_l(iadd,ib,ik,1)*norm
          end do
!!$          bsdr_l(ib,1:nlmta,ik) = bsdr_l(ib,1:nlmta,ik)*norm
!!$          bsdi_l(ib,1:nlmta,ik) = bsdi_l(ib,1:nlmta,ik)*norm
          bsdr_l(ib,:,ik) = bsdr_l(ib,:,ik)*norm
          bsdi_l(ib,:,ik) = bsdi_l(ib,:,ik)*norm
       else
          do ii=ista_g1k(ik),iend_g1k(ik)
             iadd = ii - ista_g1k(ik) + 1
             wfsdr = wfsd_l(iadd,ib,ik,1   )
             wfsdi = wfsd_l(iadd,ib,ik,kimg)
             norm = norm + wfsdr*wfsdr+wfsdi*wfsdi
          end do
          call mpi_allreduce(MPI_IN_PLACE,norm,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
          norm = 1.d0/sqrt(norm)
          do ii=ista_g1k(ik),iend_g1k(ik)
             iadd = ii - ista_g1k(ik) + 1
             wfsd_l(iadd,ib,ik,1) = wfsd_l(iadd,ib,ik,1)*norm
             wfsd_l(iadd,ib,ik,2) = wfsd_l(iadd,ib,ik,2)*norm
          enddo
          if(k_symmetry(ik) == GAMMA) then
            bsdr_l(ib,:,ik) = bsdr_l(ib,:,ik)*norm
          else
            bsdr_l(ib,:,ik) = bsdr_l(ib,:,ik)*norm
            bsdi_l(ib,:,ik) = bsdi_l(ib,:,ik)*norm
          end if
       end if
    end do
    
  end subroutine normalize_wfsd_3D
  

  
  subroutine m_ESmddavid_Subspace_Rotation(nfout)
    integer, intent(in) :: nfout     
    
    integer             :: ispin, ik, iksnl, switch_of_eko_part
    real(kind=DP), allocatable, dimension(:) ::  afft, bfft
    real(kind=DP), allocatable, dimension(:) :: ekin
    real(kind=DP), allocatable, dimension(:) :: afft_l
    real(kind=DP), allocatable, dimension(:,:) :: wk_bfft_l
    real(kind=DP), allocatable, dimension(:,:) :: bfft_l
    integer :: lsize, ibsize, isrsize, fft_l_size
    real(kind=DP), allocatable, dimension(:) :: ekin_l
    integer :: ipri0
    integer :: ng
    real(kind=DP), allocatable, dimension(:,:,:) :: vexx
    real(kind=DP) :: exx
#ifdef FFT_3D_DIVISION
    lsize = fft_X_x_nel*fft_X_y_nel*fft_X_z_nel
!.. allocate(afft_l(lsize*2), stat=ierr)
#else
    lsize = max(maxval(nel_fft_x(:)),maxval(nel_fft_y(:)),maxval(nel_fft_z(:)))
!.. allocate(afft_l(lsize*kimg), stat=ierr)
#endif
    if(ierr /= 0) then
       write(nfout,*)' m_ESmddavid_Subspace_Rotation: Not allocated afft_l array'
       call flush(nfout)
       call mpi_abort(mpi_comm_world, 201, ierr)
    endif
    ibsize = 1

    allocate(ekin_l(maxval(np_g1k)))
    call m_ES_alloc_scss_etc_3D()
    allocate(afft(nfft)); allocate(bfft(nfft))  
    call allocate_fsri_3D
    
    do ispin = 1, nspin, (af+1)
       call m_ES_Vlocal_in_Rspace_3D(ispin,afft_l,lsize,1,OFF)      ! (ptfft1) vlhxc_l->afft
       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle          ! MPI
          isrsize = min(lsize,mp_g1k(ik))
          fft_l_size  = nel_fft_x(myrank_g)
#ifdef FFT_3D_DIVISION
          allocate(wk_bfft_l(lsize*2   ,ibsize) ,stat=ierr)
          allocate(bfft_l(lsize*2   ,ibsize) ,stat=ierr)
#else
          allocate(wk_bfft_l(lsize*kimg,ibsize) ,stat=ierr)
          allocate(bfft_l(lsize*kimg,ibsize) ,stat=ierr)
#endif
          if (ierr /= 0) then
             write(nfout,*)' m_ESmddavid_Subspace_Rotation:  Not allocate '
             call flush(nfout)
             call mpi_abort(mpi_comm_world, 205, ierr)
          endif
          iksnl = (ik-1)/nspin + 1
          
          call allocate_t_matrix_sr_3D(ik) ! -> np_g1k_x
          call m_pwBS_kinetic_energies(ik,vkxyz,ekin_l) ! (diakin) ->ekin
          call m_ES_Vnonlocal_W_3D(ik,iksnl,ispin,switch_of_eko_part=OFF) ! -> vnlph_l
          if(sw_hybrid_functional==ON) call m_ES_Vexx_W(ik)
          call allreduce_fs_sr_3D(ik) ! -> fsr,fsi
          call evolve_WFs_in_subspace_sr_3D& !-(m_ES_WF_by_ModifiedDavidson)
                                      &(ik,ispin,ekin_l,afft_l,bfft_l, &
                                        wk_bfft_l,lsize,ibsize,isrsize,fft_l_size) !-> zaj_l
          if(ik==1.and.ipridavidson>= 2) &
            & call m_ES_wd_zaj_small_portion_3D(nfout,ik," -- after davidson subspace rotation --",21)
          call m_ES_betar_dot_WFs_4_each_k_3D(nfout,ik)   ! -> fsr_l,fsi_l
          if(ipridavidson>=2) then
             write(nfout,'("Davidson Subspace Rotation: ik=",i5," subspace=",i5)') ik, nsize_sb_now
          end if
          call deallocate_t_matrix_sr
          deallocate(wk_bfft_l)
          deallocate(bfft_l)
          
       enddo      ! k-point loop
    enddo      ! spin loop
    
    call deallocate_fsri

!!  ( in case of af=1 )
    if(af /= 0) then
       call cp_eigen_values_for_af       !-(contained here)
       call expand_neordr_and_nrvf_ordr  !-(contained here)
    end if

    call get_ipri0(ipridavidson,ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko_3D(nfout,mode=SCF)

    deallocate(bfft);   deallocate(afft)
    call m_ES_dealloc_scss_etc()
    deallocate(ekin_l)
    
  contains
  
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    subroutine cp_eigen_values_for_af
      integer :: ik,ib
      do ik = 1, kv3, af+1
         if(map_k(ik) /= myrank_k) cycle    ! MPI
         do ib = 1, np_e                    ! MPI
            eko_l(ib,ik+af) = eko_l(ib,ik)
         enddo
      enddo
    end subroutine cp_eigen_values_for_af

    subroutine expand_neordr_and_nrvf_ordr
      integer :: ik
      do ik = 1, kv3, af+1
         if(map_k(ik) /= myrank_k) cycle     ! MPI
         neordr(1:neg,ik+af) = neordr(1:neg,ik)
         nrvf_ordr(1:neg,ik+af) = nrvf_ordr(1:neg,ik)
      end do
    end subroutine expand_neordr_and_nrvf_ordr
  
  end subroutine m_ESmddavid_Subspace_Rotation
  


  subroutine allocate_fsri_3D
    nsize_sb_now = neg
    nsize_mt_now =  nsize_sb_now*(nsize_sb_now+1)/2
    allocate(fsr(neg,nlmta,1))
    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
       allocate(fsi(neg,nlmta,1))
    end if
    allocate(zaj_l_backup(maxval(np_g1k),np_e,kimg)) ! MPI
  end subroutine allocate_fsri_3D

  subroutine deallocate_fsri
    deallocate(fsr)
    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
       deallocate(fsi)
    end if
    deallocate(zaj_l_backup)
  end subroutine deallocate_fsri
    

  subroutine allocate_t_matrix_sr_3D(ik)
    integer, intent(in) :: ik
    integer :: kimg_t
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if    
#ifdef _ODD_BOUNDARY_
    if(mod(np_g1k(ik),2) == 0) then
       np_g1k_x = np_g1k(ik) + 1
    else
       np_g1k_x = np_g1k(ik)
    end if
#else
    np_g1k_x = np_g1k(ik)
#endif
    allocate(zat_l(maxval(np_g1k),neg,kimg,1)) ! MPI
    allocate(zah_l(maxval(np_g1k),np_e,kimg,1)) ! MPI
    allocate(w1hw2(nsize_mt_now*kimg_t))
    allocate(w1sw2(nsize_mt_now*kimg_t))
    if(npes>1) then
       allocate(w1hw2_mpi(nsize_mt_now*kimg_t))
       allocate(w1sw2_mpi(nsize_mt_now*kimg_t))
    end if
    zaj_l_backup(:,:,:) = zaj_l(:,:,ik,:)
  end subroutine allocate_t_matrix_sr_3D

  subroutine deallocate_t_matrix_sr
! ============================ modified by K. Tagami ========== 11.0
!    deallocate(zat_l) ! MPI
!    deallocate(zah_l) ! MPI

       deallocate(zat_l) ! MPI
       deallocate(zah_l) ! MPI
! ============================================================== 11.0
    deallocate(w1hw2)
    deallocate(w1sw2)
    if(npes>1) then
       deallocate(w1hw2_mpi)
       deallocate(w1sw2_mpi)
    end if
  end subroutine deallocate_t_matrix_sr
  
  subroutine allreduce_fs_sr_3D(ik)
    integer, intent(in) :: ik
    integer :: ib,ib1,kimg_t,is,is1
    real(kind=DP), allocatable, dimension(:,:) :: fs_mpi

    allocate(fs_mpi(neg,nlmta))
    
    fs_mpi=0.d0
    do is = 1, np_fs ! MPI
       is1=nis_fs(myrank_g)+is-1
       do ib = 1, np_e ! MPI
          ib1=neg_g(ib)
          fs_mpi(ib1,is1) = fsr_l(ib,is,ik)
       end do
    end do
    call mpi_allreduce(MPI_IN_PLACE,fs_mpi,neg*nlmta &
      & ,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)       ! MPI
    fsr(1:neg,1:nlmta,1) = fs_mpi(1:neg,1:nlmta)
    if(.not. k_symmetry(ik) == GAMMA) then
       fs_mpi=0.d0
       do is = 1, np_fs ! MPI
          is1=nis_fs(myrank_g)+is-1
          do ib = 1, np_e ! MPI
             ib1=neg_g(ib)
             fs_mpi(ib1,is1) = fsi_l(ib,is,ik)
          end do
       end do
       call mpi_allreduce(MPI_IN_PLACE,fs_mpi,neg*nlmta &
         & ,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)       ! MPI
       fsi(1:neg,1:nlmta,1) = fs_mpi(1:neg,1:nlmta)
    end if
    deallocate(fs_mpi)
  end subroutine allreduce_fs_sr_3D
  
  subroutine evolve_WFs_in_subspace_sr_3D(ik,ispin,ekin_l,afft_l,bfft_l, &
                                          wk_bfft_l,lsize,ibsize,isrsize,fft_l_size)
    integer, intent(in) :: ik,ispin,lsize,ibsize,isrsize,fft_l_size
    real(kind=DP), intent(in)  :: ekin_l(maxval(np_g1k))
#ifdef FFT_3D_DIVISION
    real(kind=DP), intent(in)  :: afft_l(lsize*2   )
    real(kind=DP), intent(out) :: bfft_l(lsize*2   ,1)
    real(kind=DP), intent(inout) :: wk_bfft_l(lsize*2   ,ibsize)
#else
    real(kind=DP), intent(in)  :: afft_l(lsize*kimg)
    real(kind=DP), intent(out) :: bfft_l(lsize*kimg,1)
    real(kind=DP), intent(inout) :: wk_bfft_l(lsize*kimg,ibsize)
#endif
    integer :: iadd, ib2_
! (allocatable variables)
    real(kind=DP), allocatable,dimension(:) ::     eig
    real(kind=DP), allocatable,dimension(:,:) ::   vec

    integer       :: ib1,ib2,ib1to,ib2to,i1,ii,ri,ib
!    integer       :: ibb1,ibb2
!    integer       :: ii1,ii2,iter,iter1,iter2
    real(kind=DP) :: denom, eko1, eko2, ekod
    real(kind=DP) :: hr2,hi2,dr1,dr2,di1,di2,dd
    integer :: ip0,ip0b,ip1,ip1b,ib1n,ib2n,ndata,nshift,kimg_t,ig1
    integer :: noffset
!    integer :: nsize_max_sb_now
    integer :: ierr_diag
    integer :: id_sname = -1, ipri0
    call tstatc0_begin('evolve_WFs_in_subspace_sr_3D(davidson) ', id_sname,1)

    call get_ipri0(ipridavidson,ipri0)

    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if
    
!    nsize_sb_now = nsize_subspace(1)
!    nsize_mt_now = nsize_matrix(1)

    allocate(eig(nsize_sb_now)); eig=0.d0
    allocate(vec(nsize_sb_now*kimg_t,nsize_sb_now))
    allocate(eko_d(neg));     eko_d = 0.d0
    allocate(occup(neg)); occup=0

    if(ipridavidson >=2) then
       write(nfout,*) 'MdDavidson Subspace Rotation:ik,nsize_sb_now=', ik,nsize_sb_now
    end if


    do ib1 = 1, np_e
       eko_d(neg_g(ib1)) = eko_l(ib1,ik)  ! MPI
    end do
    call mpi_allreduce(MPI_IN_PLACE,eko_d,neg,mpi_double_precision,mpi_sum &
         & ,mpi_kg_world,ierr) ! MPI
    eko1 = sum(eko_d(1:neg))

    do ib1=1,neg
       if(map_e(ib1) == myrank_e) then !MPI
          if( occup_l(map_z(ib1),ik) > 0.d0 ) occup(ib1) = 1  ! MPI
       end if
    end do
    call mpi_allreduce(MPI_IN_PLACE,occup,neg,mpi_integer,mpi_sum &
         & ,mpi_k_world(myrank_k),ierr)       ! MPI

! (zaj_l <- (T+Vloc)|phi> )
!!    zaj_l(:,:,ik,:) = zajold_l(:,:,:,idavid)
!( tenchi ) (zat_l <- zaj_l)
    zat_l(:,:,:,1) = 0.0d0
    do ib1 = 1, np_e
       zat_l(:,neg_g(ib1),:,1) = zaj_l(:,ib1,ik,:)
    enddo
    call mpi_allreduce(MPI_IN_PLACE,zat_l(:,:,:,1),maxval(np_g1k)*neg*kimg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_kg_world,ierr)
    do ib1 = 1, np_e ! MPI
       ib = ib1 ! MPI
#ifdef __TIMER_COMM__
       call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l,0)
#else
       call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l)
#endif
#ifdef FFT_3D_DIVISION
         call m_FFT_Vlocal_W_3DIV_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_x(myrank_g))
         call m_FFT_Direct_3DIV_3D(nfout,wk_bfft_l,lsize,ibsize)
#else
         if (sw_fft_xzy > 0) then
            call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_y(myrank_g))
            call m_FFT_Direct_3D(nfout,wk_bfft_l,lsize,ibsize)
         else
            call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_z(myrank_g))
            call m_FFT_Direct_XYZ_3D(nfout,wk_bfft_l,lsize,ibsize)
         end if
#endif
       call map_fft_to_WF_3D(ik,lsize,ibsize,wk_bfft_l,bfft_l,isrsize,fft_l_size)
       if(kimg == 1) then
          do ii=ista_g1k(ik),iend_g1k(ik)
             iadd = ii - ista_g1k(ik) + 1
             dr1 = zaj_l(iadd,ib,ik,1)
             dr2 = bfft_l(iadd,1)*denom
             zaj_l(iadd,ib,ik,1)= ekin_l(iadd)*dr1+dr2
          enddo
       else
          do ii=ista_g1k(ik),iend_g1k(ik)
             iadd = ii - ista_g1k(ik) + 1
             dr1  = zaj_l(iadd,ib,ik,1)
             di1  = zaj_l(iadd,ib,ik,kimg)
             zaj_l(iadd,ib,ik,1)    = ekin_l(iadd)*dr1+bfft_l(2*iadd-1,1)*denom
             zaj_l(iadd,ib,ik,kimg) = ekin_l(iadd)*di1+bfft_l(2*iadd,  1)*denom
          enddo
       endif
#ifdef SAVE_FFT_TIMES
       if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
    enddo
!( tenchi ) (zah_l <- zaj_l)
    zah_l(:,:,:,1) = zaj_l(:,:,ik,:)

! (make matrix elements )
! parallel loop
    ! <n|T+Vloc|m> G-wise parallel
    w1hw2 = 0.d0
    w1sw2 = 0.d0
!   do ib2 = 1,nsize_sb_now
    do ib2_ = 1, np_e
       ib2 = neg_g(ib2_)
       ip0b = ib2*(ib2-1)/2
       do ib1 = 1,ib2
          ip0 = ip0b + ib1
          if(kimg == 1) then
             do ii = ista_g1k(ik), iend_g1k(ik) ! MPI
                iadd = ii - ista_g1k(ik) + 1
                hr2 = zah_l(iadd,ib2_,1,1)
                dr2 = zat_l(iadd,ib2, 1,1)
                dr1 = zat_l(iadd,ib1, 1,1)
                w1hw2(ip0) = w1hw2(ip0) + dr1*hr2
                w1sw2(ip0) = w1sw2(ip0) + dr1*dr2
             end do
          else
             if(k_symmetry(ik) == GAMMA) then
                do ii = max(ista_g1k(ik),2), iend_g1k(ik) ! MPI
                   iadd = ii - ista_g1k(ik) + 1
                   hr2 = zah_l(iadd,ib2_,1,1) ! MPI
                   hi2 = zah_l(iadd,ib2_,2,1) ! MPI
                   dr2 = zat_l(iadd,ib2, 1,1) ! MPI
                   di2 = zat_l(iadd,ib2, 2,1) ! MPI
                   dr1 = zat_l(iadd,ib1, 1,1) ! MPI
                   di1 = zat_l(iadd,ib1, 2,1) ! MPI
                   w1hw2(ip0) =w1hw2(ip0)+(dr1*hr2+di1*hi2)*2.d0
                   w1sw2(ip0) =w1sw2(ip0)+(dr1*dr2+di1*di2)*2.d0
                end do
                if(ista_g1k(ik) == 1) then
                   hr2 = zah_l(1,ib2_,1,1) ! MPI
                   hi2 = zah_l(1,ib2_,2,1) ! MPI
                   dr2 = zat_l(1,ib2, 1,1) ! MPI
                   di2 = zat_l(1,ib2, 2,1) ! MPI
                   dr1 = zat_l(1,ib1, 1,1) ! MPI
                   di1 = zat_l(1,ib1, 2,1) ! MPI
                   w1hw2(ip0) =w1hw2(ip0)+dr1*hr2+di1*hi2
                   w1sw2(ip0) =w1sw2(ip0)+dr1*dr2+di1*di2
                end if
             else
                do ii = ista_g1k(ik), iend_g1k(ik) ! MPI
                   iadd = ii - ista_g1k(ik) + 1
                   hr2 = zah_l(iadd,ib2_,1,1) ! MPI
                   hi2 = zah_l(iadd,ib2_,2,1) ! MPI
                   dr2 = zat_l(iadd,ib2, 1,1) ! MPI
                   di2 = zat_l(iadd,ib2, 2,1) ! MPI
                   dr1 = zat_l(iadd,ib1, 1,1) ! MPI
                   di1 = zat_l(iadd,ib1, 2,1) ! MPI
                   w1hw2(2*ip0-1) =w1hw2(2*ip0-1)+dr1*hr2+di1*hi2
                   w1hw2(2*ip0  ) =w1hw2(2*ip0  )+dr1*hi2-di1*hr2
                   w1sw2(2*ip0-1) =w1sw2(2*ip0-1)+dr1*dr2+di1*di2
                   w1sw2(2*ip0  ) =w1sw2(2*ip0  )+dr1*di2-di1*dr2
                end do
             end if
          end if
       end do
    end do
    if(ipridavidson >= 3) call wd_w1hw2(" -- w1hw2 without nl part--")
    ! <n|Vnl|m> G-wise parallel
    if(myrank_g == 0) then
    call add_nonlocal_part ! w1hw2 = w1hw2 + w1Vnlw2
                           ! w1sw2 = w1sw2 + w1qw2
    endif
    if(ipridavidson >= 3) call wd_w1hw2(" -- w1hw2 with nl part--")

!! (spread sum of w1hw2 and w1sw2)
    if(npes > 1) then
       w1hw2_mpi = 0.d0
       w1sw2_mpi = 0.d0
       nshift = 0
       ndata = nsize_mt_now*kimg_t
       call mpi_allreduce(w1hw2(nshift+1),w1hw2_mpi,ndata,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
       w1hw2(nshift+1:nshift+ndata) = w1hw2_mpi(1:ndata) ! MPI
       call mpi_allreduce(w1sw2(nshift+1),w1sw2_mpi,ndata,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
       w1sw2(nshift+1:nshift+ndata) = w1sw2_mpi(1:ndata) ! MPI
    end if

    if(ipridavidson >= 2) call wd_w1hw2(" -- just after making w1hw2 --")
    if(ipridavidson >= 2) then
       write(nfout,*) 'neordr for ik = ',ik
       write(nfout,9002) (neordr(ib1,ik),ib1=1,neg)
       write(nfout,*) 'nrvf_ordr for ik = ',ik
       write(nfout,9002) (nrvf_ordr(ib1,ik),ib1=1,neg)
       write(nfout,*) 'eig'
       write(nfout,'(5x,10f8.4)') (eko_l(ib1,ik),ib1=1,np_e)
    endif
9002 format(5x,10i8)

!! (Diagonalization )  !!

    if(kimg_t == 1) then
       call dspgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
    else
       call zhpgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag)
    endif

    if(ierr_diag /= 0) then
       zaj_l(:,:,ik,:) = zaj_l_backup(:,:,:)
#ifdef SAVE_FFT_TIMES
       if(sw_save_fft == ON) status_saved_phifftr(:,ik) = OLD
#endif
       do ib1 = 1, np_e
          eko_l(ib1,ik)=eko_d(neg_g(ib1))
       end do
       if(ipridavidson >= 2) then
          write(nfout,*) '** Mod Davidson SR error **'
          stop
       end if
    else

!!$       if(ipridavidson >= 2) then
       if(ipri0 >= 2) then
          write(nfout,*) 'eko_d for ik = ',ik
          write(nfout,9001) (eko_d(ib),ib=1,neg)
          write(nfout,*) 'eig for ik = ',ik
          write(nfout,9001) (eig(ib),ib=1,neg)
          call wd_w1hw2(" -- after diagonalization --")
!sum eko
          dr1=0.d0;dr2=0.d0
          do ib1=1,np_e
             ib1to = neordr(neg_g(ib1),ik)
             if(map_e(ib1to) == myrank_e) dr1=dr1+eko_l(ib1,ik) ! MPI
             dr2=dr2+eig(neg_g(ib1))
          enddo
          call mpi_allreduce(MPI_IN_PLACE,dr1,1,mpi_double_precision,mpi_sum,mpi_kg_world,ierr) ! MPI
          write(nfout,'(" sum of eko_l, eig, abs diff =",3e25.10)') dr1,dr2,abs(dr2-dr1)
       endif
!! (subspace rotation) !!
       call subspace_rotation ! vec,zat_l -> zat_l
!( tenchi ) (zaj_l <- zat_l)
       if(ipridavidson>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
       do ib1 = 1, np_e
          zaj_l(:,ib1,ik,:) = zat_l(:,neg_g(ib1),:,1)
#ifdef SAVE_FFT_TIMES
          if(sw_save_fft == ON) status_saved_phifftr(ib1,ik) = OLD
#endif
       enddo
       zaj_l_backup(:,:,:) = zaj_l(:,:,ik,:)
!! (eko_l)
       do ib1 = 1, np_e
          eko_l(ib1,ik)=eig(neg_g(ib1))
       end do
       if(ipridavidson >= 2) then
          eko2 = sum(eig(1:neg))
          write(nfout,1201) ik,eko1,ekod,eko2

          write(nfout,*) 'eko_l'
          write(nfout,9001) (eko_l(ib1,ik),ib1=1,np_e)
       endif
1201 format(' %% for ik = ',i4,4x,' eko1&ekod&eko2 = ',3f14.7)
9001 format(5x,6f12.5)
!! (neordr & nrvf_ordr)

    end if

    neordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)
    nrvf_ordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)

! (deallocate)  
    deallocate(eko_d)
    deallocate(eig)
    deallocate(vec)
    deallocate(occup)

    call tstatc0_end(id_sname)

  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_k_world(myrank_k),ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    subroutine wd_w1hw2(somecomment)
      character(len=*), intent(in) :: somecomment
      integer :: ib1, ib2, neg_wd, nsb_wd
      write(nfout,'(a35)') somecomment
      write(nfout,*) 'w1hw2 for ik = ',ik
      neg_wd = 8
      nsb_wd = 8
      if(neg_wd > neg) neg_wd = neg
      if(nsb_wd > nsize_sb_now) nsb_wd = nsize_sb_now
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      else
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(2*ip0-1),ip0=ip0b+1,ip0b+ib2)
         end do
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(2*ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      end if
      write(nfout,*) 'w1sw2 for ik = ',ik
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      else
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(2*ip0-1),ip0=ip0b+1,ip0b+ib2)
         end do
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(2*ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      end if
9001  format(5x,9f12.5)
      write(nfout,*) 'eko_l for ik = ',ik
      write(nfout,9001) (eko_d(neordr(ib1,ik)),ib1=1,neg_wd)
    end subroutine wd_w1hw2

    subroutine add_nonlocal_part
      integer :: ip,ib1,ib2
      integer       :: ia, lmt1, lmt2, it, p, s, ib
      real(kind=DP) :: facv,facq,vr,vi,qr,qi
      real(kind=DP) :: tmpr,tmpi
! ========================== added by K. Tagami ========== 11.0
#ifdef forsafe
      integer :: ipaw_tmp
#endif
! ======================================================== 11.0
      do ib2 = 1,nsize_sb_now
         ip0b = ib2*(ib2-1)/2
         do ib1 = 1,ib2
            ip0 = ip0b + ib1
            if(mod(ip0-1,nrank_e)/=myrank_e) cycle
            if(kimg_t==1) then
               vr=0.d0
               qr=0.d0
            else
               vr=0.d0
               vi=0.d0
               qr=0.d0
               qi=0.d0
            end if
            do ia = 1, natm
               it = ityp(ia)
! ========================== added by K. Tagami =================== 11.0
#ifdef forsafe
               ipaw_tmp = ipaw(it)
#endif
! ================================================================= 11.0
               do lmt1 = 1, ilmt(it)
                  p = lmta(lmt1,ia)
!OCL NOPREEX
                  do lmt2 = 1, ilmt(it)
                     s = lmta(lmt2,ia)
! ========================== modified by K. Tagami =================== 11.0
!                     if(ipaw(it)==0)then
#ifdef forsafe
                     if ( ipaw_tmp == 0 ) then
#else
                     if (ipaw(it)==0 ) then
#endif
! ================================================================= 11.0
                        facv   = iwei(ia)*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     else
                        facv   = iwei(ia)*(dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     endif
                     facq   = iwei(ia)*q(lmt1,lmt2,it)
                     if(kimg==1) then
                        tmpr = fsr(ib1,p,1)*fsr(ib2,s,1)&
                    &        + fsi(ib1,p,1)*fsi(ib2,s,1)
                        vr = vr + facv*tmpr
                        qr = qr + facq*tmpr
                     else
                        if(k_symmetry(ik) == GAMMA) then
                           tmpr = fsr(ib1,p,1)*fsr(ib2,s,1)
                           vr = vr + facv*tmpr
                           qr = qr + facq*tmpr
                        else
                           tmpr = fsr(ib1,p,1)*fsr(ib2,s,1)&
                    &        + fsi(ib1,p,1)*fsi(ib2,s,1)
                           tmpi = fsr(ib1,p,1)*fsi(ib2,s,1)&
                    &        - fsi(ib1,p,1)*fsr(ib2,s,1)
                           vr = vr + facv*tmpr
                           vi = vi + facv*tmpi
                           qr = qr + facq*tmpr
                           qi = qi + facq*tmpi
                        end if
                     end if
                  end do
               end do
            end do
            if(kimg_t==1) then
               w1hw2(ip0) = w1hw2(ip0) + vr
               w1sw2(ip0) = w1sw2(ip0) + qr
            else
               w1hw2(2*ip0-1) = w1hw2(2*ip0-1) + vr
               w1hw2(2*ip0  ) = w1hw2(2*ip0  ) + vi
               w1sw2(2*ip0-1) = w1sw2(2*ip0-1) + qr
               w1sw2(2*ip0  ) = w1sw2(2*ip0  ) + qi
            end if
         end do
      end do
    end subroutine add_nonlocal_part

    subroutine subspace_rotation
      integer :: ib1,ib2,ibb2,iadd
!!$      real(kind=DP), dimension(np_g1k_x,neg,kimg) :: zaj_wk
      real(kind=DP), allocatable, dimension(:,:,:) :: zaj_wk
!     allocate(zaj_wk(np_g1k_x,neg,kimg))
      allocate(zaj_wk(maxval(np_g1k),np_e,kimg))

      zaj_wk(:,:,:) = 0.d0
      if(kimg==1) then
         do ib1=1,np_e
            do ib2=1,neg
               do ii=ista_g1k(ik),iend_g1k(ik)
                  iadd = ii - ista_g1k(ik) + 1
                  zaj_wk(iadd,ib1,kimg) = zaj_wk(iadd,ib1,kimg) + zat_l(iadd,ib2,kimg,1)*vec(ib2,neg_g(ib1))
               end do
            end do
         end do
      else
         if(k_symmetry(ik) == GAMMA) then
            do ib1=1,np_e
               do ib2=1,neg
                  hr2=vec(ib2,neg_g(ib1))
                  do ii=ista_g1k(ik),iend_g1k(ik)
                     iadd = ii - ista_g1k(ik) + 1
                     dr1=zat_l(iadd,ib2,1   ,1)
                     di1=zat_l(iadd,ib2,kimg,1)
                     zaj_wk(iadd,ib1,1   ) = zaj_wk(iadd,ib1,1   ) + dr1*hr2
                     zaj_wk(iadd,ib1,kimg) = zaj_wk(iadd,ib1,kimg) + di1*hr2
                  end do
               end do
            end do
         else
            do ib1=1,np_e
               do ib2=1,neg
                  hr2=vec(2*ib2-1,neg_g(ib1))
                  hi2=vec(2*ib2  ,neg_g(ib1))
                  do ii=ista_g1k(ik),iend_g1k(ik)
                     iadd = ii - ista_g1k(ik) + 1
                     dr1=zat_l(iadd,ib2,1   ,1)
                     di1=zat_l(iadd,ib2,kimg,1)
                     zaj_wk(iadd,ib1,1   ) = zaj_wk(iadd,ib1,1   ) + dr1*hr2 - di1*hi2
                     zaj_wk(iadd,ib1,kimg) = zaj_wk(iadd,ib1,kimg) + dr1*hi2 + di1*hr2
                  end do
               end do
            end do
         end if
      end if
      zat_l(:,:,:,1) = 0.0d0
      do ib1 = 1, np_e
         zat_l(:,neg_g(ib1),:,1) = zaj_wk(:,ib1,:)
      enddo
      call mpi_allreduce(MPI_IN_PLACE,zat_l(:,:,:,1),maxval(np_g1k)*neg*kimg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_kg_world,ierr)
      deallocate(zaj_wk)
    end subroutine subspace_rotation

  end subroutine evolve_WFs_in_subspace_sr_3D


  subroutine dspgvx_driver(eig,vec,w1hw2,w1sw2,ierr,nel)
    real(kind=DP), intent(out) ,dimension(nsize_sb_now) :: eig
    real(kind=DP), intent(out) ,dimension(nsize_sb_now*neg) :: vec
    real(kind=DP), intent(inout) ,dimension(nsize_mt_now) :: w1hw2,w1sw2
    integer, intent(out) :: ierr
    integer, intent(in), optional :: nel
    
    integer :: ITYPE
    character(len=1) :: JOBZ,RANGE,UPLO
    integer :: il,iu
    real(kind=DP),allocatable,dimension(:) :: work_lapack
    integer, allocatable, dimension(:) :: iwork_lapack, ifail_lapack
    real(kind=DP) :: vl,vu,abstol
    integer :: info,m
    real(kind=DP), external :: dlamch
    !!$real(kind=DP), dimension(nsize_mt_now) :: ap,bp
    real(kind=DP), allocatable, dimension(:) :: ap,bp

    allocate(ap(nsize_mt_now),bp(nsize_mt_now))
    abstol = 2*dlamch('S')

    il=1; iu=neg
    if(present(nel)) iu=nel
!(LAPACK)  ITYPE = 1:  A*x = (lambda)*B*x, 2:  A*B*x = (lambda)*x, 3:  B*A*x = (lambda)*x
    ITYPE = 1
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  RANGE = A : all eigenvalues, V: all eigenvalues in (VL, VU], I: the IL-th through IU-th eigenvalues
    RANGE = 'I'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'
    allocate(work_lapack(8*nsize_sb_now))
    allocate(iwork_lapack(5*nsize_sb_now))
    allocate(ifail_lapack(nsize_sb_now))

    ap = w1hw2
    bp = w1sw2

    call dspgvx(ITYPE,JOBZ,RANGE,UPLO,nsize_sb_now,ap,bp &
    &          ,vl,vu,il,iu,abstol,m,eig,vec,nsize_sb_now &
    &          ,work_lapack,iwork_lapack,ifail_lapack,info)

    if(ipridavidson >=2 .and. info/=0) then
       write(nfout,*) "debug(dspgvx) info=",info
       write(nfout,*) "debug(dspgvx) ifail"
       write(nfout,'(8(1x,i3))') ifail_lapack
       write(nfout,*) "debug(dspgvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if

    deallocate(work_lapack)
    deallocate(iwork_lapack)
    deallocate(ifail_lapack)

    deallocate(ap,bp)

    if(info/=0) then
       !!write(nfout,*) "dspgvx: info=",info
       !!stop 'error in dspgvx_driver'
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine dspgvx_driver
  
  subroutine dspgvx_driver_loc(eig,vec,w1hw2,w1sw2,ierr,nel)
    integer, intent(in) :: nel
    real(kind=DP), intent(out) ,dimension(nsize_sb_now) :: eig
    real(kind=DP), intent(out) ,dimension(nsize_sb_now*nel) :: vec
    real(kind=DP), intent(inout) ,dimension(nsize_mt_now) :: w1hw2,w1sw2
    integer, intent(out) :: ierr
    
    integer :: ITYPE
    character(len=1) :: JOBZ,RANGE,UPLO
    integer :: il,iu
    real(kind=DP),allocatable,dimension(:) :: work_lapack
    integer, allocatable, dimension(:) :: iwork_lapack, ifail_lapack
    real(kind=DP) :: vl,vu,abstol
    integer :: info,m
    real(kind=DP), external :: dlamch
    !!$real(kind=DP), dimension(nsize_mt_now) :: ap,bp
    real(kind=DP), allocatable, dimension(:) :: ap,bp

    allocate(ap(nsize_mt_now),bp(nsize_mt_now))
    abstol = 2*dlamch('S')

    il=1; iu=nel
!(LAPACK)  ITYPE = 1:  A*x = (lambda)*B*x, 2:  A*B*x = (lambda)*x, 3:  B*A*x = (lambda)*x
    ITYPE = 1
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  RANGE = A : all eigenvalues, V: all eigenvalues in (VL, VU], I: the IL-th through IU-th eigenvalues
    RANGE = 'I'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'
    allocate(work_lapack(8*nsize_sb_now))
    allocate(iwork_lapack(5*nsize_sb_now))
    allocate(ifail_lapack(nsize_sb_now))

    ap = w1hw2
    bp = w1sw2

    call dspgvx(ITYPE,JOBZ,RANGE,UPLO,nsize_sb_now,ap,bp &
    &          ,vl,vu,il,iu,abstol,m,eig,vec,nsize_sb_now &
    &          ,work_lapack,iwork_lapack,ifail_lapack,info)

!    if(ipridavidson >=2 .and. info/=0) then
    if(info/=0) then
       write(nfout,*) "debug(dspgvx) info=",info
       write(nfout,*) "debug(dspgvx) ifail"
       write(nfout,'(8(1x,i3))') ifail_lapack
       write(nfout,*) "debug(dspgvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if

    deallocate(work_lapack)
    deallocate(iwork_lapack)
    deallocate(ifail_lapack)

    deallocate(ap,bp)

    if(info/=0) then
       !!write(nfout,*) "dspgvx: info=",info
       !!stop 'error in dspgvx_driver'
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine dspgvx_driver_loc
#ifdef NEC_TUNE
  subroutine dsygvx_driver(eig, vec, w1hw2, w1sw2, ierr, nel)
    integer, intent(in) :: nel
    real(kind=DP), intent(out),   dimension(nsize_sb_now)               :: eig
    real(kind=DP), intent(out),   dimension(nsize_sb_now*nel)           :: vec
    real(kind=DP), intent(inout), dimension(nsize_sb_now, nsize_sb_now) :: w1hw2, w1sw2
    integer, intent(out) :: ierr
    integer :: ITYPE, il, iu, lwork, info, m
    character(len=1) :: JOBZ, RANGE, UPLO
    real(kind=DP) :: vl, vu, abstol, work_tmp
    real(kind=DP), allocatable, dimension(:) :: work
    integer, allocatable, dimension(:) :: iwork, ifail
    real(kind=DP), external :: dlamch

    abstol = 2*dlamch('S')
    il = 1; iu = nel
    ITYPE = 1; JOBZ = 'V'; RANGE = 'I'; UPLO = 'U'

    allocate(iwork(5*nsize_sb_now))
    allocate(ifail(nsize_sb_now))

    call dsygvx(ITYPE, JOBZ, RANGE, UPLO, nsize_sb_now, &
   &            w1hw2, nsize_sb_now, w1sw2, nsize_sb_now, &
   &            vl, vu, il, iu, abstol, m, eig, vec, nsize_sb_now, &
   &            work_tmp, -1, iwork, ifail, info)

    lwork = int(work_tmp)
    allocate(work(lwork))

    call dsygvx(ITYPE, JOBZ, RANGE, UPLO, nsize_sb_now, &
   &            w1hw2, nsize_sb_now, w1sw2, nsize_sb_now, &
   &            vl, vu, il, iu, abstol, m, eig, vec, nsize_sb_now, &
   &            work, lwork, iwork, ifail, info)

    if(info /= 0) then
       write(nfout,*) "debug(dsygvx) info=",info
       write(nfout,*) "debug(dsygvx) ifail"
       write(nfout,'(8(1x,i3))') ifail
       write(nfout,*) "debug(dsygvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if

    deallocate(work)
    deallocate(iwork)
    deallocate(ifail)

    if(info /= 0) then
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine dsygvx_driver
#endif

  subroutine zhpgvx_driver(eig,vec,w1hw2,w1sw2,ierr,nel)
    real(kind=DP), intent(out) ,dimension(nsize_sb_now) :: eig
    real(kind=DP), intent(out) ,dimension(nsize_sb_now*kimg,nsize_sb_now) :: vec
    real(kind=DP), intent(in) ,dimension(nsize_mt_now*kimg) :: w1hw2,w1sw2
    integer, intent(out) :: ierr
    integer, intent(in), optional :: nel
    integer :: ITYPE
    character(len=1) :: JOBZ,RANGE,UPLO
    integer :: il,iu
    real(kind=DP),allocatable,dimension(:) :: work_lapack
    real(kind=DP),allocatable,dimension(:) :: rwork_lapack
    integer, allocatable, dimension(:) :: iwork_lapack, ifail_lapack
    real(kind=DP) :: vl,vu,abstol
    integer :: info,m
    real(kind=DP), external :: dlamch
!!$    real(kind=DP), dimension(nsize_mt_now*kimg) :: ap,bp
    real(kind=DP), allocatable, dimension(:) :: ap,bp
    integer :: ib,i

    abstol = 2*dlamch('S')

    il=1; iu=neg
    if(present(nel)) iu=nel
!(LAPACK)  ITYPE = 1:  A*x = (lambda)*B*x, 2:  A*B*x = (lambda)*x, 3:  B*A*x = (lambda)*x
    ITYPE = 1
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  RANGE = A : all eigenvalues, V: all eigenvalues in (VL, VU], I: the IL-th through IU-th eigenvalues
    RANGE = 'I'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'
    allocate(work_lapack(2*nsize_sb_now*kimg)); work_lapack = 0.d0
    allocate(rwork_lapack(7*nsize_sb_now)); rwork_lapack = 0.d0
    allocate(iwork_lapack(5*nsize_sb_now)); iwork_lapack = 0
    allocate(ifail_lapack(nsize_sb_now)); ifail_lapack=0
    allocate(ap(nsize_mt_now*kimg));ap=0.d0
    allocate(bp(nsize_mt_now*kimg));bp=0.d0

    if(ipridavidson >=3 ) then
       write(nfout,*) "debug(zhpgvx) i,w1hw2,w1sw2"
       do ib=1,nsize_sb_now
          i = ib*(ib-1)/2 + ib
          write(nfout,*) ib,w1hw2(2*i-1),w1sw2(2*i-1)
       end do
       ap = w1sw2
       write(nfout,*) "debug(zhpgvx) i,ap,w1sw2"
       do i=1,nsize_mt_now
          write(nfout,*) i,ap(2*i-1),w1sw2(2*i-1)
       end do
       call zhpevx('N','A','U',nsize_sb_now,ap,vl,vu,il,iu,abstol,m &
    &          ,eig,vec,nsize_sb_now &
    &          ,work_lapack,rwork_lapack,iwork_lapack,ifail_lapack,info)
       write(nfout,*) "debug(zhpgvx) eig of w1sw2"
       do ib=1,nsize_sb_now
          write(nfout,*) ib,eig(ib)
       end do
    end if

    ap = w1hw2
    bp = w1sw2

    call zhpgvx(ITYPE,JOBZ,RANGE,UPLO,nsize_sb_now,ap,bp &
    &          ,vl,vu,il,iu,abstol,m,eig,vec,nsize_sb_now &
    &          ,work_lapack,rwork_lapack,iwork_lapack,ifail_lapack,info)

!    if(ipridavidson >=2 .and. info/=0) then
    if(info/=0) then
       write(nfout,*) "debug(zhpgvx) info=",info
       write(nfout,*) "debug(zhpgvx) ifail"
       write(nfout,'(8(1x,i3))') ifail_lapack
       write(nfout,*) "debug(zhpgvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if
    
    deallocate(work_lapack)
    deallocate(rwork_lapack)
    deallocate(iwork_lapack)
    deallocate(ifail_lapack)
    deallocate(ap,bp)

    if(info/=0) then
       !!write(nfout,*) "zhpgvx: info=",info
       !!stop 'error in zhpgvx_driver'
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine zhpgvx_driver
#ifdef NEC_TUNE
  subroutine zhegvx_driver(eig, vec, w1hw2, w1sw2, ierr, nel)
    integer, intent(in):: nel
    real(kind=DP), intent(out),   dimension(nsize_sb_now) :: eig
    real(kind=DP), intent(out),   dimension(nsize_sb_now*kimg, nel) :: vec
    real(kind=DP), intent(inout), dimension(nsize_sb_now*kimg, nsize_sb_now) :: w1hw2, w1sw2
    integer, intent(out) :: ierr
    integer :: ITYPE, il, iu, lwork, info, m
    character(len=1) :: JOBZ, RANGE, UPLO
    complex(kind=DP) :: work_tmp
    complex(kind=DP), allocatable, dimension(:) :: work
    real(kind=DP), allocatable, dimension(:) :: rwork
    integer, allocatable, dimension(:) :: iwork, ifail
    real(kind=DP) :: vl, vu, abstol
    real(kind=DP), external :: dlamch

    abstol = 2*dlamch('S')
    il = 1; iu = nel
    ITYPE = 1; JOBZ = 'V'; RANGE = 'I'; UPLO = 'U'

    allocate(rwork(7*nsize_sb_now))
    allocate(iwork(5*nsize_sb_now))
    allocate(ifail(nsize_sb_now))

    call zhegvx(ITYPE, JOBZ, RANGE, UPLO, nsize_sb_now, &
   &            w1hw2, nsize_sb_now, w1sw2, nsize_sb_now, &
   &            vl, vu, il, iu, abstol, m, eig, vec, nsize_sb_now, &
   &            work_tmp, -1, rwork, iwork, ifail, info)

    lwork = int(real(work_tmp))
    allocate(work(lwork))

    call zhegvx(ITYPE, JOBZ, RANGE, UPLO, nsize_sb_now, &
   &            w1hw2, nsize_sb_now, w1sw2, nsize_sb_now, &
   &            vl, vu, il, iu, abstol, m, eig, vec, nsize_sb_now, &
   &            work, lwork, rwork, iwork, ifail, info)

    if(info /= 0) then
       write(nfout,*) "debug(zhegvx) info=",info
       write(nfout,*) "debug(zhegvx) ifail"
       write(nfout,'(8(1x,i3))') ifail
       write(nfout,*) "debug(zhegvx) eig"
       write(nfout,'(8(1x,f10.5))') eig
    end if
    
    deallocate(work)
    deallocate(rwork)
    deallocate(iwork)
    deallocate(ifail)

    if(info /= 0) then
       ierr = 1
    else
       ierr = 0
    end if

  end subroutine zhegvx_driver
#endif
  
  subroutine m_ESmddavid_Renew_WF(nfout,precon)
    integer, intent(in) :: nfout,precon
    integer             :: ispin, ik, iksnl, switch_of_eko_part
    integer :: iblock,itot
    real(kind=DP), allocatable, dimension(:) ::  afft, bfft
    real(kind=DP), allocatable, dimension(:) :: ekin,p
    real(kind=DP), allocatable, dimension(:) :: afft_l
    real(kind=DP), allocatable, dimension(:,:) :: wk_bfft_l
    real(kind=DP), allocatable, dimension(:,:) :: bfft_l
    integer :: lsize, ibsize, isrsize, fft_l_size
    real(kind=DP), allocatable, dimension(:) :: ekin_l,p_l
    logical :: frestart
    integer :: iblock_now, itot_now, ipri0
    integer :: n_unconv
    real(kind=DP), allocatable, dimension(:,:,:) :: vexx
    real(kind=DP) :: exx
    integer :: ng

!!$    integer :: id_sname = -1

    integer, save :: print_ibsize = ON
#ifdef FFT_3D_DIVISION
    lsize = fft_X_x_nel*fft_X_y_nel*fft_X_z_nel
    allocate(afft_l(lsize*2   ), stat=ierr)
#else
    lsize = max(maxval(nel_fft_x(:)),maxval(nel_fft_y(:)),maxval(nel_fft_z(:)))
    allocate(afft_l(lsize*kimg), stat=ierr)
#endif
    if(ierr /= 0) then
       write(nfout,*)' m_ESmddavid_Renew_WF: Not allocated afft_l array'
       call flush(nfout)
       call mpi_abort(mpi_comm_world, 201, ierr)
    endif
    ibsize = 1
! === FFT Marge. by T. Yamasaki after T.Kato's prescrition in m_ES_WF_by_SDorCG.F90. 2013/02/21 ==
    if (nblocksize_fftw_is_given) then
       ibsize = nblocksize_fftw
       if (ibsize < 1) ibsize = 1
    endif
    if(ipridavidson>=1 .and. print_ibsize == ON) then
       write(nfout,'(" !! ibsize in m_ESmddavid_Renew_WF = ",i8)') ibsize
       print_ibsize = OFF
    end if
!!$! ========================================================================================


    allocate(ekin_l(maxval(np_g1k)),p_l(maxval(np_g1k)))
    call m_ES_alloc_scss_etc_3D()
    allocate(afft(nfft)); allocate(bfft(nfft))

    call allocate_matrix_3D
    if(sw_hybrid_functional==ON)then
       call m_ES_EXX_gather_valence_states(nfout)
    endif
    do ispin = 1, nspin, (af+1)
       call m_ES_Vlocal_in_Rspace_3D(ispin,afft_l,lsize,1,OFF)      ! (ptfft1) vlhxc_l->afft
!!$       call tstatc0_begin('m_ESmddavid_Renew_WF ', id_sname,1)
       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle          ! MPI
          isrsize = min(lsize,mp_g1k(ik))
          fft_l_size  = nel_fft_x(myrank_g)
#ifdef FFT_3D_DIVISION
          allocate(wk_bfft_l(lsize*2   ,ibsize) ,stat=ierr)
          allocate(bfft_l(lsize*2   ,ibsize) ,stat=ierr)
#else
          allocate(wk_bfft_l(lsize*kimg,ibsize) ,stat=ierr)
          allocate(bfft_l(lsize*kimg,ibsize) ,stat=ierr)
#endif
          if (ierr /= 0) then
             write(nfout,*)' m_ESmddavid_Renew_WF:  Not allocate '
             call flush(nfout)
             call mpi_abort(mpi_comm_world, 205, ierr)
          endif
          iksnl = (ik-1)/nspin + 1
          call allocate_t_matrix_3D(ik) ! alloc(zat_l,zah_l,w1hw2,w1sw2,wfsd_l,bsd[ri]_l)
          call m_pwBS_kinetic_energies(ik,vkxyz,ekin_l) ! (diakin) ->ekin
          feigconv = .false.
          call mpi_barrier(mpi_k_world(myrank_k),ierr)
          Loop: do itot=1,max_iter_david
             itot_now = itot
             call m_ES_Vnonlocal_W_3D(ik,iksnl,ispin,switch_of_eko_part=ON) ! -> vnlph_l
             if(sw_hybrid_functional==ON) call m_ES_Vexx_W(ik)
             call decide_correction_vector_3D(precon,ik,ekin_l,afft_l,bfft_l, &
                  &                    wk_bfft_l,lsize,ibsize,isrsize,fft_l_size,p_l)
             call prepare_Hloc_phi_3D(ik,ispin,ekin_l,afft_l,bfft_l, &
                  &                    wk_bfft_l,lsize,ibsize,isrsize,fft_l_size,itot)  
!print *,ik,itot  
!write(nfout,*) 'B',feigconv     
             Block_Loop: do iblock=1,nblock
                iblock_now = iblock
                call evolve_WFs_in_subspace_3D(ik,ispin,iblock,itot,frestart)
             end do Block_Loop
!write(nfout,*) 'A',feigconv
!             call m_ES_betar_dot_WFs_4_each_k(nfout,ik)   ! -> fsr_l,fsi_l
          end do Loop
          if(ipridavidson>=2) then
             write(nfout,'("Mddavid: ik=",i5," itot=",i5," subspace=",i5)') &
                                                                 ik, itot_now, nsize_sb_now
          end if
          call deallocate_t_matrix
! === DEBUG by tkato 2012/06/14 ================================================
          deallocate(wk_bfft_l)
          deallocate(bfft_l)
! ==============================================================================
       enddo      ! k-point loop
!!$       call tstatc0_end(id_sname)
    enddo      ! spin loop
    call deallocate_matrix
!    if(ipridavidson>=2) then
!       write(nfout,'("Modified Davidson: max_itot=",i5)') max_itot
!    end if
!
! ========================================================================================
! === NOTE: m_ES_sort_eigen_values_3D causes difference with ORG_Parallel!!! =============
! ========================================================================================
!   call m_ES_sort_eigen_values_3D()
! ========================================================================================
! ========================================================================================
! ========================================================================================
!!!  ( in case of af=1 )
!    if(af /= 0) then
!       call cp_eigen_values_for_af       !-(contained here)
!       call expand_neordr_and_nrvf_ordr  !-(contained here)
!    end if

    call get_ipri0(ipridavidson,ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko_3D(nfout,mode=SCF)
!
    deallocate(bfft);   deallocate(afft)
    call m_ES_dealloc_scss_etc()
    deallocate(ekin_l,p_l)
!.. deallocate(afft_l)
!deallocate(vnldi,hdiag,sdiag)
  contains

    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    logical function eigenvalues_are_converged(n_unconv)
       integer, intent(out) :: n_unconv
       integer :: ib

       n_unconv = 0
       eigenvalues_are_converged = .true.
       do ib=1,np_e
          if(.not.feigconv(ib)) then
             eigenvalues_are_converged = .false.
             n_unconv = n_unconv + 1
          end if
       end do
    end function eigenvalues_are_converged
    
  end subroutine m_ESmddavid_Renew_WF
  

  subroutine allocate_matrix_3D()
    integer:: i,j
    
    nblock = npartition_david
    if(np_e .lt. npartition_david) nblock = np_e
!!$    nblock = npartition_mddavid
!!$    if(np_e .lt. npartition_mddavid) nblock = np_e
    
    allocate(nsize_subspace(nblock))
    allocate(nsize_matrix(nblock))
    allocate(ista_e_l(nblock))
    allocate(iend_e_l(nblock))
    allocate(ielm_e_l(nblock))
    ielm_e_l=np_e/nblock
    j = mod(np_e,nblock)
    do i = 1, j
       ielm_e_l(i) = ielm_e_l(i) + 1
    end do
    ista_e_l(1) = 1
    do i = 2, nblock
       ista_e_l(i) = ista_e_l(i-1) + ielm_e_l(i-1)
       iend_e_l(i-1) = ista_e_l(i) - 1
    end do
    iend_e_l(nblock) = np_e
    do i=1,nblock
      if(sw_MRCV_only==ON)then
         nsize_subspace(i)=ielm_e_l(i)*2
         nsize_matrix(i)=nsize_subspace(i)*(nsize_subspace(i)+1)/2
      else
         nsize_subspace(i)=ielm_e_l(i)*(max_iter_david+1)
         nsize_matrix(i)=nsize_subspace(i)*(nsize_subspace(i)+1)/2
      endif
    end do
    msize_subspace=maxval(nsize_subspace)
    msize_matrix=maxval(nsize_matrix)
    allocate(feigconv(np_e))
    allocate(ibover(msize_subspace,nblock))
    if(sw_MRCV_only==ON)then
       allocate(fsr(np_e,nlmta,2));fsr=0.d0
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          allocate(fsi(np_e,nlmta,2));fsi=0.d0
       end if
    else
       allocate(fsr(np_e,nlmta,max_iter_david+1))
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          allocate(fsi(np_e,nlmta,max_iter_david+1))
       end if
    endif
    eps_residual = eps_david
    if(sw_MRCV_only==OFF)then
       allocate(zajold_l(maxval(np_g1k),np_e,kimg))
       allocate(fsrold_l(np_e,np_fs))
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
         allocate(fsiold_l(np_e,np_fs))
       end if
    endif
  end subroutine allocate_matrix_3D
  
  subroutine deallocate_matrix
    deallocate(nsize_subspace)
    deallocate(nsize_matrix)
    deallocate(ista_e_l)
    deallocate(iend_e_l)
    deallocate(ielm_e_l)
    deallocate(feigconv)
    deallocate(ibover)
    deallocate(fsr)
    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
       deallocate(fsi)
    end if
    if(sw_MRCV_only==OFF)then
       deallocate(zajold_l)
       deallocate(fsrold_l)
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
         deallocate(fsiold_l)
       end if
    endif
  end subroutine deallocate_matrix

  subroutine allocate_t_matrix_3D(ik)
    integer, intent(in) :: ik
    integer :: kimg_t
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if    
    allocate(zat_l(maxval(np_g1k),np_e,kimg,max_iter_david+1)) ! MPI
    allocate(zah_l(maxval(np_g1k),np_e,kimg,max_iter_david+1)) ! MPI
    allocate(w1hw2(msize_matrix*kimg_t))
    allocate(w1sw2(msize_matrix*kimg_t))
    allocate(wfsd_l(maxval(np_g1k),np_e,ik:ik,kimg)); wfsd_l = 0.d0
!!$    allocate(bsdr_l(np_e,nlmta,ik:ik)); bsdr_l = 0.d0
!!$    allocate(bsdi_l(np_e,nlmta,ik:ik)); bsdi_l = 0.d0
    allocate(bsdr_l(np_e,np_fs,ik:ik)); bsdr_l = 0.d0
    allocate(bsdi_l(np_e,np_fs,ik:ik)); bsdi_l = 0.d0
    if(sw_MRCV_only==OFF)then
       zajold_l(:,:,:)=zaj_l(:,:,ik,:)
       fsrold_l(:,:)=fsr_l(:,:,ik)
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
         fsiold_l(:,:)=fsi_l(:,:,ik)
       endif
    end if
    
  end subroutine allocate_t_matrix_3D

  subroutine deallocate_t_matrix
! ================================== modified by K. Tagami =========== 11.0
!    deallocate(zat_l) ! MPI
!    deallocate(zah_l) ! MPI

       deallocate(zat_l) ! MPI
       deallocate(zah_l) ! MPI
! ==================================================================== 11.0
    deallocate(w1hw2)
    deallocate(w1sw2)
    deallocate(wfsd_l)
    deallocate(bsdr_l)
    deallocate(bsdi_l)
    if(sw_divide_subspace==OFF)then
       if ( allocated( zat_l_t ) ) deallocate(zat_l_t)
       if ( allocated( zah_l_t ) ) deallocate(zah_l_t)
       if ( allocated( feigconv_t ) ) deallocate(feigconv_t)
       if ( allocated( fsr_t) ) deallocate(fsr_t)
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          if ( allocated( fsi_t) ) deallocate(fsi_t)
       endif
       deallocate(w1hw2_mpi)
       deallocate(w1sw2_mpi)
    endif
  end subroutine deallocate_t_matrix
  
  subroutine prepare_Hloc_phi_3D(ik,ispin,ekin_l,afft_l,bfft_l, &
                                     wk_bfft_l,lsize,ibsize,isrsize,fft_l_size,itot)
    integer, intent(in) :: ik,ispin,lsize,ibsize,isrsize,fft_l_size
    integer, intent(in) :: itot
    real(kind=DP), intent(in)  :: ekin_l(maxval(np_g1k))
#ifdef FFT_3D_DIVISION
    real(kind=DP), intent(in)  :: afft_l(lsize*2   )
    real(kind=DP), intent(out) :: bfft_l(lsize*2   ,1)
    real(kind=DP), intent(inout) :: wk_bfft_l(lsize*2   ,ibsize)
#else
    real(kind=DP), intent(in)  :: afft_l(lsize*kimg)
    real(kind=DP), intent(out) :: bfft_l(lsize*kimg,ibsize)
    real(kind=DP), intent(inout) :: wk_bfft_l(lsize*kimg,ibsize)
#endif

    integer       :: ib1,i1,ii,ib,iadd
!!$    real(kind=DP), allocatable, dimension(:,:) :: fs_mpi,fs_mpi2
    real(kind=DP), allocatable, dimension(:,:) :: fs_mpi
    real(kind=DP), allocatable, dimension(:,:) :: zah_t ! d(maxval(np_g1k),kimg)
    real(kind=DP) :: denom
    real(kind=DP) :: dr1,dr2,di1,di2,dd
    integer :: is,is1,ib2,ibesize
    integer :: id_sname = -1, id_sname1=-1, id_sname2=-1, id_sname3=-1, ipri0
    real(kind=DP), allocatable, dimension(:,:) :: vexx
    real(kind=DP) :: exx
    integer :: niter
    integer :: ng
    call tstatc0_begin('prepare_Hloc_phi_3D ', id_sname,1)

    call get_ipri0(ipridavidson,ipri0)

    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    if(sw_hybrid_functional==ON) then
        ng = maxval(np_g1k)
        allocate(vexx(ng,kimg))
        vexx = 0.0d0
    endif
! (zaj_l <- (T+Vloc)|phi> )
!!    zaj_l(:,:,ik,:) = zajold_l(:,:,:,idavid)
!( tenchi ) (zat_l <- zaj_l)

    call tstatc0_begin('prepare_Hloc(1)', id_sname1)
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call start_timer('prepare_Hloc_phi_3D_000')
#endif
! === TIMERTIMERTIMER ==========================================================

    allocate(fs_mpi(np_e,nlmta))
    if(sw_MRCV_only==ON)then
       zat_l(:,:,:,1) = zaj_l(:,:,ik,:)
       zat_l(:,:,:,2) = wfsd_l(:,:,ik,:)
       fs_mpi=0.d0
       do is = 1, np_fs ! MPI
          is1=nis_fs(myrank_g)+is-1
          do ib = 1, np_e ! MPI
             fs_mpi(ib,is1) = fsr_l(ib,is,ik)
          end do
       end do
       call mpi_allreduce(MPI_IN_PLACE,fs_mpi,np_e*nlmta &
         & ,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
       fsr(1:np_e,1:nlmta,1) = fs_mpi(1:np_e,1:nlmta)
!!$       fsr(:,:,2)=bsdr_l(:,:,ik)
       fs_mpi=0.d0
       do is = 1, np_fs ! MPI
          is1=nis_fs(myrank_g)+is-1
          do ib = 1, np_e ! MPI
             fs_mpi(ib,is1) = bsdr_l(ib,is,ik)
          end do
       end do
       call mpi_allreduce(MPI_IN_PLACE,fs_mpi,np_e*nlmta &
         & ,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
       fsr(1:np_e,1:nlmta,2) = fs_mpi(1:np_e,1:nlmta)

       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          fs_mpi=0.d0
          do is = 1, np_fs ! MPI
             is1=nis_fs(myrank_g)+is-1
             do ib = 1, np_e ! MPI
                fs_mpi(ib,is1) = fsi_l(ib,is,ik)
             end do
          end do
          call mpi_allreduce(MPI_IN_PLACE,fs_mpi,np_e*nlmta &
            & ,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
          fsi(1:np_e,1:nlmta,1) = fs_mpi(1:np_e,1:nlmta)

!!$          fsi(:,:,2)=bsdi_l(:,:,ik)
          fs_mpi=0.d0
          do is = 1, np_fs ! MPI
             is1=nis_fs(myrank_g)+is-1
             do ib = 1, np_e ! MPI
                fs_mpi(ib,is1) = bsdi_l(ib,is,ik)
             end do
          end do
          call mpi_allreduce(MPI_IN_PLACE,fs_mpi,np_e*nlmta &
               & ,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)       ! MPI
          fsi(1:np_e,1:nlmta,2) = fs_mpi(1:np_e,1:nlmta)
       end if
    else
       zat_l(:,:,:,itot+1) = wfsd_l(:,:,ik,:)
!!$       fsr(:,:,itot+1)=bsdr_l(:,:,ik)
       fs_mpi=0.d0
       do is = 1, np_fs ! MPI
          is1=nis_fs(myrank_g)+is-1
          do ib = 1, np_e ! MPI
             fs_mpi(ib,is1) = bsdr_l(ib,is,ik)
          end do
       end do
       call mpi_allreduce(MPI_IN_PLACE,fs_mpi,np_e*nlmta &
         & ,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)       ! MPI
       fsr(1:np_e,1:nlmta,itot+1) = fs_mpi(1:np_e,1:nlmta)

       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
!!$          fsi(:,:,itot+1)=bsdi_l(:,:,ik)
          fs_mpi=0.d0
          do is = 1, np_fs ! MPI
             is1=nis_fs(myrank_g)+is-1
             do ib = 1, np_e ! MPI
                fs_mpi(ib,is1) = bsdi_l(ib,is,ik)
             end do
          end do
          call mpi_allreduce(MPI_IN_PLACE,fs_mpi,np_e*nlmta &
               & ,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)       ! MPI
          fsi(1:np_e,1:nlmta,itot+1) = fs_mpi(1:np_e,1:nlmta)
       end if
    endif
    deallocate(fs_mpi)
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('prepare_Hloc_phi_3D_000')
#endif
! === TIMERTIMERTIMER ==========================================================

    call tstatc0_end(id_sname1)

    call tstatc0_begin('prepare_Hloc(2)', id_sname2)
    if(itot == 1) then
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call start_timer('prepare_Hloc_phi_3D_001')
#endif
! === TIMERTIMERTIMER ==========================================================
!!$      do ib1 = 1, np_e ! MPI
      do ib1 = 1, np_e, ibsize
!!$         ib = ib1
         ib2 = min(ib1+ibsize-1,np_e)
         ibesize = ib2 - ib1 + 1

! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call start_timer('- 001 m_ES_WF_in_Rspace_3D')
#endif
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_COMM__
         call m_ES_WF_in_Rspace_3D(ik,ib1,ib2,ibsize,lsize,wk_bfft_l,0)
#else
         call m_ES_WF_in_Rspace_3D(ik,ib1,ib2,ibsize,lsize,wk_bfft_l)
#endif
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('- 001 m_ES_WF_in_Rspace_3D')
call start_timer('- 001 m_FFT_Vlocal_W_3D')
#endif
! === TIMERTIMERTIMER ==========================================================
#ifdef FFT_3D_DIVISION
       call m_FFT_Vlocal_W_3DIV_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_x(myrank_g))
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('- 001 m_FFT_Vlocal_W_3D')
call start_timer('- 001 m_FFT_Direct_3D')
#endif
! === TIMERTIMERTIMER ==========================================================
       call m_FFT_Direct_3DIV_3D(nfout,wk_bfft_l,lsize,ibsize)
#else
       if (sw_fft_xzy > 0) then
          call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_y(myrank_g))
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('- 001 m_FFT_Vlocal_W_3D')
call start_timer('- 001 m_FFT_Direct_3D')
#endif
! === TIMERTIMERTIMER ==========================================================
          call m_FFT_Direct_3D(nfout,wk_bfft_l,lsize,ibsize)
       else
          call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_z(myrank_g))
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('- 001 m_FFT_Vlocal_W_3D')
call start_timer('- 001 m_FFT_Direct_3D')
#endif
! === TIMERTIMERTIMER ==========================================================
          call m_FFT_Direct_XYZ_3D(nfout,wk_bfft_l,lsize,ibsize)
       end if
#endif
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('- 001 m_FFT_Direct_3D')
call start_timer('- 001 map_fft_to_WF_3D')
#endif
! === TIMERTIMERTIMER ==========================================================
         call map_fft_to_WF_3D(ik,lsize,ibesize,wk_bfft_l,bfft_l,isrsize,fft_l_size)
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('- 001 map_fft_to_WF_3D')
call start_timer('- 001 others')
#endif
! === TIMERTIMERTIMER ==========================================================
         do ib = ib1, ib2

            if(sw_hybrid_functional==ON) then
               if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
                  call m_ES_EXX_potential(nfout,ispin,ib,ik,ng,fsr_l(ib,:,ik),fsi_l(ib,:,ik),vexx,0)
               else
                  call m_ES_EXX_potential(nfout,ispin,ib,ik,ng,fsr_l(ib,:,ik),fsr_l(ib,:,ik),vexx,0)
               endif
            endif

            if(kimg == 1) then
               do ii=ista_g1k(ik),iend_g1k(ik)
                  iadd = ii - ista_g1k(ik) + 1
                  dr1 = zaj_l(iadd,ib,ik,1)
                  dr2 = bfft_l(iadd,ib-ib1+1)*denom
                  zah_l(iadd,ib,1,1) = ekin_l(iadd)*dr1+dr2
               enddo
               if(sw_hybrid_functional==ON)then
                  zah_l(:,ib,1,1) = zah_l(:,ib,1,1) + vexx(:,1)
               endif
            else
               do ii=ista_g1k(ik),iend_g1k(ik)
                  iadd = ii - ista_g1k(ik) + 1
                  dr1  = zaj_l(iadd,ib,ik,1)
                  di1  = zaj_l(iadd,ib,ik,kimg)
                  zah_l(iadd,ib,1,   1)= ekin_l(iadd)*dr1+bfft_l(2*iadd-1,ib-ib1+1)*denom
                  zah_l(iadd,ib,kimg,1)= ekin_l(iadd)*di1+bfft_l(2*iadd,  ib-ib1+1)*denom
               enddo
               if(sw_hybrid_functional==ON)then
                  zah_l(:,ib,1,1) = zah_l(:,ib,1,1) + vexx(:,1)
                  zah_l(:,ib,kimg,1) = zah_l(:,ib,kimg,1) + vexx(:,kimg)
               endif
            endif
         end do
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('- 001 others')
#endif
! === TIMERTIMERTIMER ==========================================================
      enddo
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('prepare_Hloc_phi_3D_001')
#endif
! === TIMERTIMERTIMER ==========================================================
    end if
    call tstatc0_end(id_sname2)
    
    call tstatc0_begin('prepare_Hloc(3)', id_sname3)
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call start_timer('prepare_Hloc_phi_3D_002')
#endif
! === TIMERTIMERTIMER ==========================================================
!!( tenchi ) (zah_l <- zaj_l)
    zaj_l(:,:,ik,:) = wfsd_l(:,:,ik,:)
#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) status_saved_phifftr(:,ik) = OLD
#endif
    
!!$    do ib1 = 1, np_e ! MPI
    do ib1 = 1, np_e, ibsize
       ib2 = min(ib1+ibsize-1,np_e)
       ibesize = ib2 - ib1 + 1
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call start_timer('- 002 m_ES_WF_in_Rspace_3D')
#endif
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_COMM__
       call m_ES_WF_in_Rspace_3D(ik,ib1,ib2,ibsize,lsize,wk_bfft_l,0)
#else
       call m_ES_WF_in_Rspace_3D(ik,ib1,ib2,ibsize,lsize,wk_bfft_l)
#endif
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('- 002 m_ES_WF_in_Rspace_3D')
call start_timer('- 002 m_FFT_Vlocal_W_3D')
#endif
! === TIMERTIMERTIMER ==========================================================
#ifdef FFT_3D_DIVISION
       call m_FFT_Vlocal_W_3DIV_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_x(myrank_g))
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('- 002 m_FFT_Vlocal_W_3D')
call start_timer('- 002 m_FFT_Direct_3D')
#endif
! === TIMERTIMERTIMER ==========================================================
       call m_FFT_Direct_3DIV_3D(nfout,wk_bfft_l,lsize,ibsize)
#else
       if (sw_fft_xzy > 0) then
          call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_y(myrank_g))
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('- 002 m_FFT_Vlocal_W_3D')
call start_timer('- 002 m_FFT_Direct_3D')
#endif
! === TIMERTIMERTIMER ==========================================================
          call m_FFT_Direct_3D(nfout,wk_bfft_l,lsize,ibsize)
       else
          call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_z(myrank_g))
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('- 002 m_FFT_Vlocal_W_3D')
call start_timer('- 002 m_FFT_Direct_3D')
#endif
! === TIMERTIMERTIMER ==========================================================
          call m_FFT_Direct_XYZ_3D(nfout,wk_bfft_l,lsize,ibsize)
       end if
#endif
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('- 002 m_FFT_Direct_3D')
call start_timer('- 002 map_fft_to_WF_3D')
#endif
! === TIMERTIMERTIMER ==========================================================
       call map_fft_to_WF_3D(ik,lsize,ibesize,wk_bfft_l,bfft_l,isrsize,fft_l_size)

! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('- 002 map_fft_to_WF_3D')
call start_timer('- 002 others')
#endif
! === TIMERTIMERTIMER ==========================================================
       allocate(zah_t(maxval(np_g1k),kimg))
!!$       if(sw_MRCV_only==ON) then
       do ib = ib1, ib2
          if(sw_hybrid_functional==ON) then
             if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
                call m_ES_EXX_potential(nfout,ispin,ib,ik,ng,bsdr_l(ib,:,ik),bsdi_l(ib,:,ik),vexx)
             else
                call m_ES_EXX_potential(nfout,ispin,ib,ik,ng,bsdr_l(ib,:,ik),bsdr_l(ib,:,ik),vexx)
             endif
          endif
          if(kimg == 1) then
             do ii=ista_g1k(ik),iend_g1k(ik)
                iadd = ii - ista_g1k(ik) + 1
                dr1 = zaj_l(iadd,ib,ik,1)
                dr2 = bfft_l(iadd,ib-ib1+1)*denom
!!$                zah_l(iadd,ib,1,2) = ekin_l(iadd)*dr1+dr2
                zah_t(iadd,1) = ekin_l(iadd)*dr1+dr2
             enddo
             if(sw_MRCV_only == ON) then
                zah_l(:,ib,1,2) = zah_t(:,1)
             else
                zah_l(:,ib,1,itot+1) = zah_t(:,1)
             end if
             if(sw_hybrid_functional==ON)then
                if(sw_MRCV_only==ON)then
                   zah_l(:,ib,1,2) = zah_l(:,ib,1,2) + vexx(:,1)
                else
                   zah_l(:,ib,1,itot+1) = zah_l(:,ib,1,itot+1) + vexx(:,1)
                endif
             endif
          else
             do ii=ista_g1k(ik),iend_g1k(ik)
                iadd = ii - ista_g1k(ik) + 1
                dr1  = zaj_l(iadd,ib,ik,1)
                di1  = zaj_l(iadd,ib,ik,kimg)
!!$                zah_l(iadd,ib,1,   2) = ekin_l(iadd)*dr1+bfft_l(2*iadd-1,ib-ib1+1)*denom
!!$                zah_l(iadd,ib,kimg,2) = ekin_l(iadd)*di1+bfft_l(2*iadd,  ib-ib1+1)*denom
                zah_t(iadd,1   ) = ekin_l(iadd)*dr1+bfft_l(2*iadd-1,ib-ib1+1)*denom
                zah_t(iadd,kimg) = ekin_l(iadd)*di1+bfft_l(2*iadd,  ib-ib1+1)*denom
             enddo
             if(sw_MRCV_only==ON) then
                zah_l(:,ib,1,   2) = zah_t(:,1)
                zah_l(:,ib,kimg,2) = zah_t(:,kimg)
             else
                zah_l(:,ib,1,   itot+1) = zah_t(:,1   )
                zah_l(:,ib,kimg,itot+1) = zah_t(:,kimg)
             end if
             if(sw_hybrid_functional==ON)then
                if(sw_MRCV_only==ON)then
                   zah_l(:,ib,1,2)= zah_l(:,ib,1,2)+vexx(:,1)
                   zah_l(:,ib,kimg,2)= zah_l(:,ib,kimg,2)+vexx(:,kimg)
                else
                   zah_l(:,ib,1,itot+1)= zah_l(:,ib,1,itot+1)+vexx(:,1)
                   zah_l(:,ib,kimg,itot+1)= zah_l(:,ib,kimg,itot+1)+vexx(:,kimg)
                endif
             endif
          endif
       end do
       deallocate(zah_t)
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('- 002 others')
#endif
! === TIMERTIMERTIMER ==========================================================
    end do
! === TIMERTIMERTIMER ==========================================================
#ifdef __TIMER_FFT__
call stop_timer('prepare_Hloc_phi_3D_002')
#endif
! === TIMERTIMERTIMER ==========================================================

    if(sw_hybrid_functional==ON) deallocate(vexx)

    call tstatc0_end(id_sname3)
    
    call tstatc0_end(id_sname)

  contains
  
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_k_world(myrank_k),ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

  end subroutine prepare_Hloc_phi_3D
  
  subroutine evolve_WFs_in_subspace_3D(ik,ispin,iblock,itot,frestart)
    integer, intent(in) :: ik,ispin
    integer, intent(in) :: iblock,itot
    logical, intent(out) :: frestart
! (allocatable variables)
    real(kind=DP), allocatable,dimension(:) ::     eig
    real(kind=DP), allocatable,dimension(:,:) ::   vec

    integer :: i,iel

    integer       :: ib1,ib2,ib1to,ib2to,i1,ii,ri,ib,iadd
    integer       :: ibb1,ibb2
    integer       :: ii1,ii2,iter,iter1,iter2
    real(kind=DP) :: eko1, eko2, ekod
    real(kind=DP) :: hr2,hi2,dr1,dr2,di1,di2,dd
    integer :: ip0,ip0b,ip1,ip1b,ib1n,ib2n,ndata,nshift,kimg_t,ig1
    integer :: noffset
    integer :: nsize_max_sb_now
    integer :: ierr_diag
    integer :: nel,nsta,nend
    integer :: ng
    integer :: id_sname = -1, ipri0
#ifdef NEC_TUNE
    integer :: num, k, lda, ldb, ldc
    real(kind=DP), allocatable, dimension(:,:) :: w1hw2_, w1sw2_
    real(kind=DP), allocatable, dimension(:,:,:) :: zat_t, zah_t
    real(kind=DP), allocatable, dimension(:,:) :: zat_t1, zah_t1
    complex(kind=DP), parameter :: c0 = (0.0d0, 0.0d0), c1 = (1.0d0, 0.0d0)
#endif
    call tstatc0_begin('evolve_WFs_in_subspace  ', id_sname,1)

    call get_ipri0(ipridavidson,ipri0)
    
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if
    
    nel =ielm_e_l(iblock)
    nsta=ista_e_l(iblock)
    nend=iend_e_l(iblock)
    
    if(sw_divide_subspace==OFF)then
       nel=neg
       nsta=1
       nend=neg
    endif
    allocate(eko_d(neg));eko_d=0.d0
    allocate(occup(neg));occup=0.d0
    if(sw_divide_subspace==ON)then
        zah_l_p => zah_l
        zat_l_p => zat_l
        fsr_p   => fsr
        fsi_p   => fsi
        feigconv_p => feigconv
        do iel=1,nel
           eko_d(nsta+iel-1) = eko_l(iel,ik)
           occup(nsta+iel-1) = occup_l(iel,ik)
        enddo
    else
    endif
    if(ipridavidson>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')

    if(sw_MRCV_only==ON)then
       ip0=nel
       do ib=1,nel
         ibover(ib,iblock)=ib
         if(.not.feigconv_p(nsta+ib-1)) then
           ip0=ip0+1
           ibover(nel+ib,iblock) = ip0 
         else
           ibover(nel+ib,iblock) = -1
         end if
       end do
       nsize_sb_now = ip0
       nsize_mt_now = nsize_sb_now*(nsize_sb_now+1)/2
       nsize_max_sb_now = nsize_subspace(iblock)
    else
       if(itot==1) then
         do ib=1,nel
           ibover(ib,iblock)=ib
         end do
         nsize_subspace(iblock)=nel
       end if

       noffset=nel*itot
       ip0=nsize_subspace(iblock)
       do ib=1,nel
         if(.not.feigconv_p(nsta+ib-1)) then
           ip0=ip0+1
           ibover(noffset+ib,iblock) = ip0 
         else
           ibover(noffset+ib,iblock) = -1
         end if
       end do

       nsize_sb_now = ip0
       nsize_subspace(iblock) = ip0
       nsize_mt_now = nsize_sb_now*(nsize_sb_now+1)/2
       nsize_max_sb_now = nel*(itot+1)                   !nsize_subspace(iblock)
    endif
    
    if(ipridavidson >=2) then
       write(nfout,*) 'ibover=',ibover(1:nsize_max_sb_now,iblock)
    end if
!
    allocate(eig(nsize_sb_now)); eig=0.d0
    allocate(vec(nsize_sb_now*kimg_t,nsize_sb_now))

    if(ipridavidson >=2) then
       write(nfout,*) 'Modified Davidson:ik,iblock,nsize_sb_now=', ik,iblock,nsize_sb_now
    end if
    
    ng = iba(ik)
    if(sw_divide_subspace==OFF) ng = np_g1k(ik)
    eko1 = sum(eko_d(1:neg))
!! (make matrix elements )
!    ! <n|T+Vloc|m> !
#ifdef NEC_TUNE
    allocate(w1hw2_(nsize_sb_now*kimg_t,nsize_sb_now))
    allocate(w1sw2_(nsize_sb_now*kimg_t,nsize_sb_now))

    if(kimg == 1) then
       allocate(zah_t(maxval(np_g1k),nsize_sb_now,1))
       allocate(zat_t(maxval(np_g1k),nsize_sb_now,1))
       num = 0
       do ibb1 = 1, nsize_max_sb_now
          if(ibover(ibb1,iblock) < 0) cycle
          iter1 = (ibb1-1)/nel+1
          ii1  = ibb1-nel*(iter1-1)
          ii1  = nsta+ii1-1
          num = num + 1
          zah_t(:,num,1) = zah_l(:,ii1,1,iter1)
          zat_t(:,num,1) = zat_l(:,ii1,1,iter1)
       end do
       k = np_g1k(ik); lda = maxval(np_g1k); ldb = maxval(np_g1k); ldc = nsize_sb_now
       call dgemm('T','N',num,num,k,1.0d0,zat_t,lda,zah_t,ldb,0.0d0,w1hw2_,ldc)
       call dgemm('T','N',num,num,k,1.0d0,zat_t,lda,zat_t,ldb,0.0d0,w1sw2_,ldc)
    else
      if(k_symmetry(ik) == GAMMA) then
         allocate(zah_t(maxval(np_g1k),nsize_sb_now,kimg))
         allocate(zat_t(maxval(np_g1k),nsize_sb_now,kimg))
         allocate(zah_t1(nsize_sb_now,kimg))
         allocate(zat_t1(nsize_sb_now,kimg))
         num = 0
         do ibb1 = 1, nsize_max_sb_now
            if(ibover(ibb1,iblock) < 0) cycle
            iter1 = (ibb1-1)/nel+1
            ii1  = ibb1-nel*(iter1-1)
            ii1  = nsta+ii1-1
            num = num + 1
            zah_t(:,num,1) = zah_l(:,ii1,1,iter1)
            zah_t(:,num,2) = zah_l(:,ii1,2,iter1)
            zat_t(:,num,1) = zat_l(:,ii1,1,iter1)
            zat_t(:,num,2) = zat_l(:,ii1,2,iter1)
         end do
         if(ista_g1k(ik) == 1) then
            zat_t1(:,:) = zat_t(1,:,:)
            zah_t1(:,:) = zah_t(1,:,:)
            zat_t(1,:,:) = zat_t(1,:,:)/sqrt(2.0d0)
            zah_t(1,:,:) = zah_t(1,:,:)/sqrt(2.0d0)
         end if
         k = np_g1k(ik); lda = maxval(np_g1k); ldb = maxval(np_g1k); ldc = nsize_sb_now
         call dgemm('T','N',num,num,k,2.0d0,zat_t(1,1,1),lda,zah_t(1,1,1),ldb,0.0d0,w1hw2_,ldc)
         call dgemm('T','N',num,num,k,2.0d0,zat_t(1,1,2),lda,zah_t(1,1,2),ldb,1.0d0,w1hw2_,ldc)
         call dgemm('T','N',num,num,k,2.0d0,zat_t(1,1,1),lda,zat_t(1,1,1),ldb,0.0d0,w1sw2_,ldc)
         call dgemm('T','N',num,num,k,2.0d0,zat_t(1,1,2),lda,zat_t(1,1,2),ldb,1.0d0,w1sw2_,ldc)
         if(ista_g1k(ik) == 1) then
            zat_t(1,:,:) = zat_t1(:,:)
            zah_t(1,:,:) = zah_t1(:,:)
         end if
         deallocate(zah_t1)
         deallocate(zat_t1)
      else
         allocate(zah_t(maxval(np_g1k)*kimg,nsize_sb_now,1))
         allocate(zat_t(maxval(np_g1k)*kimg,nsize_sb_now,1))
         num = 0
         do ibb1 = 1, nsize_max_sb_now
            if(ibover(ibb1,iblock) < 0) cycle
            iter1 = (ibb1-1)/nel+1
            ii1  = ibb1-nel*(iter1-1)
            ii1  = nsta+ii1-1
            num = num + 1
            do ii = 1, np_g1k(ik)
               zah_t(2*ii-1,num,1) = zah_l(ii,ii1,1,iter1)
               zah_t(2*ii,  num,1) = zah_l(ii,ii1,2,iter1)
               zat_t(2*ii-1,num,1) = zat_l(ii,ii1,1,iter1)
               zat_t(2*ii,  num,1) = zat_l(ii,ii1,2,iter1)
            end do
         end do
         k = np_g1k(ik); lda = maxval(np_g1k); ldb = maxval(np_g1k); ldc = nsize_sb_now
         call zgemm('C','N',num,num,k,c1,zat_t,lda,zah_t,ldb,c0,w1hw2_,ldc)
         call zgemm('C','N',num,num,k,c1,zat_t,lda,zat_t,ldb,c0,w1sw2_,ldc)
      end if
    end if
#else
    do ibb2 = 1,nsize_max_sb_now
       if(ibover(ibb2,iblock)<0) cycle
       ib2 = ibover(ibb2,iblock)
       iter2 = (ibb2-1)/nel+1
       ii2  = ibb2-nel*(iter2-1)
       ii2  = nsta+ii2-1
       ip0b = ib2*(ib2-1)/2
       do ibb1 = 1,ibb2
          if(ibover(ibb1,iblock)<0) cycle
          ib1 = ibover(ibb1,iblock)
          iter1 = (ibb1-1)/nel+1
          ii1 = ibb1-nel*(iter1-1)
          ii1 = nsta+ii1-1
          ip0 = ip0b + ib1
          if(kimg == 1) then
             w1hw2(ip0) = 0.d0
             w1sw2(ip0) = 0.d0
             do ii = ista_g1k(ik),iend_g1k(ik) ! MPI
                iadd = ii - ista_g1k(ik) + 1
                hr2 = zah_l(iadd,ii2,1,iter2)
                dr2 = zat_l(iadd,ii2,1,iter2)
                dr1 = zat_l(iadd,ii1,1,iter1)
                w1hw2(ip0) = w1hw2(ip0) + dr1*hr2
                w1sw2(ip0) = w1sw2(ip0) + dr1*dr2
             end do
             call mpi_allreduce(MPI_IN_PLACE,w1hw2(ip0),1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
             call mpi_allreduce(MPI_IN_PLACE,w1sw2(ip0),1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
          else
             if(k_symmetry(ik) == GAMMA) then
                w1hw2(ip0) = 0.d0
                w1sw2(ip0) = 0.d0
                do ii = max(2,ista_g1k(ik)), iend_g1k(ik) ! MPI
                   iadd = ii - ista_g1k(ik) + 1
                   hr2 = zah_l(iadd,ii2,1,iter2) ! MPI
                   hi2 = zah_l(iadd,ii2,2,iter2) ! MPI
                   dr2 = zat_l(iadd,ii2,1,iter2) ! MPI
                   di2 = zat_l(iadd,ii2,2,iter2) ! MPI
                   dr1 = zat_l(iadd,ii1,1,iter1) ! MPI
                   di1 = zat_l(iadd,ii1,2,iter1) ! MPI
                   w1hw2(ip0) =w1hw2(ip0)+(dr1*hr2+di1*hi2)*2.d0
                   w1sw2(ip0) =w1sw2(ip0)+(dr1*dr2+di1*di2)*2.d0
                end do
                if(ista_g1k(ik) == 1) then
                   hr2 = zah_l(1,ii2,1,iter2) ! MPI
                   hi2 = zah_l(1,ii2,2,iter2) ! MPI
                   dr2 = zat_l(1,ii2,1,iter2) ! MPI
                   di2 = zat_l(1,ii2,2,iter2) ! MPI
                   dr1 = zat_l(1,ii1,1,iter1) ! MPI
                   di1 = zat_l(1,ii1,2,iter1) ! MPI
                   w1hw2(ip0) =w1hw2(ip0)+dr1*hr2+di1*hi2
                   w1sw2(ip0) =w1sw2(ip0)+dr1*dr2+di1*di2
                end if
                call mpi_allreduce(MPI_IN_PLACE,w1hw2(ip0),1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                call mpi_allreduce(MPI_IN_PLACE,w1sw2(ip0),1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
             else
                w1hw2(2*ip0-1:2*ip0) = 0.d0
                w1sw2(2*ip0-1:2*ip0) = 0.d0
                do ii = ista_g1k(ik), iend_g1k(ik)
                   iadd = ii - ista_g1k(ik) + 1
                   hr2 = zah_l(iadd,ii2,1,iter2) ! MPI
                   hi2 = zah_l(iadd,ii2,2,iter2) ! MPI
                   dr2 = zat_l(iadd,ii2,1,iter2) ! MPI
                   di2 = zat_l(iadd,ii2,2,iter2) ! MPI
                   dr1 = zat_l(iadd,ii1,1,iter1) ! MPI
                   di1 = zat_l(iadd,ii1,2,iter1) ! MPI
                   w1hw2(2*ip0-1) =w1hw2(2*ip0-1)+dr1*hr2+di1*hi2
                   w1hw2(2*ip0  ) =w1hw2(2*ip0  )+dr1*hi2-di1*hr2
                   w1sw2(2*ip0-1) =w1sw2(2*ip0-1)+dr1*dr2+di1*di2
                   w1sw2(2*ip0  ) =w1sw2(2*ip0  )+dr1*di2-di1*dr2
                end do
                call mpi_allreduce(MPI_IN_PLACE,w1hw2(2*ip0-1),2,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                call mpi_allreduce(MPI_IN_PLACE,w1sw2(2*ip0-1),2,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
             end if
          end if
       end do
    end do
#endif
    if(ipridavidson >= 3 .and. ik == 1 .and. iblock == 1) call wd_w1hw2(" -- w1hw2 without nl part--",iblock)
    ! <n|Vnl|m> 
!   if(myrank_g == 0) then
    call add_nonlocal_part ! w1hw2 = w1hw2 + w1Vnlw2
                           ! w1sw2 = w1sw2 + w1qw2
!   endif
#ifdef NEC_TUNE
    call mpi_allreduce(MPI_IN_PLACE,w1hw2_,nsize_sb_now*nsize_sb_now*kimg_t,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
    call mpi_allreduce(MPI_IN_PLACE,w1sw2_,nsize_sb_now*nsize_sb_now*kimg_t,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
#endif
    if(ipridavidson >= 3 .and. ik == 1 .and. iblock == 1) call wd_w1hw2(" -- w1hw2 with nl part--",iblock)
!
!!$    if(ipridavidson >= 2) call wd_w1hw2(" -- just after making w1hw2 --",iblock)
!    if(ipridavidson >= 2) then
!       write(nfout,*) 'neordr for ik = ',ik
!       write(nfout,9002) (neordr(ib1,ik),ib1=1,neg)
!       write(nfout,*) 'nrvf_ordr for ik = ',ik
!       write(nfout,9002) (nrvf_ordr(ib1,ik),ib1=1,neg)
!       write(nfout,*) 'eig'
!       write(nfout,'(5x,10f8.4)') (eko_l(ib1,ik),ib1=1,np_e)
!    endif
!9002 format(5x,10i8)

!! (Diagonalization )  !!

#ifdef NEC_TUNE
    if(kimg_t == 1) then
       call dsygvx_driver(eig, vec, w1hw2_, w1sw2_, ierr_diag, nel)
    else
       call zhegvx_driver(eig, vec, w1hw2_, w1sw2_, ierr_diag, nel)
    endif
    deallocate(w1hw2_)
    deallocate(w1sw2_)
#else
    if(kimg_t == 1) then
       call dspgvx_driver_loc(eig,vec,w1hw2,w1sw2,ierr_diag,nel)
    else
       call zhpgvx_driver(eig,vec,w1hw2,w1sw2,ierr_diag,nel)
    endif
#endif

    frestart = .false.
    if(ierr_diag /= 0) then
!       zaj_l(:,:,ik,:) = zaj_l_backup(:,:,:)
!       do ib1 = 1, neg
!          if(map_e(ib1) == myrank_e) then         ! MPI
!             eko_l(map_z(ib1),ik)=eko_d(ib1)
!          end if
!       end do
      frestart = .true.
! === DEBUG by T.Kato 2013/08/01 ===============================================
!     do i=1,np_e
      do i=1,nel
! ==============================================================================
         zaj_l(:,i-1+nsta,ik,:)=zat_l(:,i,:,1)
      enddo
#ifdef SAVE_FFT_TIMES
      if(sw_save_fft == ON) then
         do i=1,nel
            status_saved_phifftr(i-1+nsta,ik) = OLD
         end do
      end if
#endif
      if(ipridavidson >= 2) then
        write(nfout,*) '** restart Modified Davidson iteration **'
        write(nfout,*) 'ik=',ik,' iblock=',iblock,' itot=',itot
      end if
      write(nfout,*) '** restart Modified Davidson **'
      write(nfout,*) 'ik=',ik,' iblock=',iblock,' itot=',itot
      call wd_w1hw2(" -- restart Modified Davidson iteration --",iblock)
!!$ print *,'Restart'
      goto 9000
    else

      feigconv_p(nsta:nend) = .false.
      do ib=1,nel
         if(occup(nsta+ib-1) > 0.d0) then
            if(abs(eko_d(nsta+ib-1)-eig(ib)) < delta_eig_occup) &
                                                   feigconv_p(nsta+ib-1) = .true.
         else
            if(abs(eko_d(nsta+ib-1)-eig(ib)) < delta_eig_empty) &
                                                   feigconv_p(nsta+ib-1) = .true.
         end if
      end do 
      if(ipri0 >= 2) then
         if(ik == 1 .and. iblock == 1) then
            write(nfout,*) 'eko_l for ik = ',ik
            write(nfout,*) 'iblock       = ',iblock
            write(nfout,9001) (eko_d(nsta+ib-1),ib=1,nel)
            write(nfout,*) 'eig for ik = ',ik
            write(nfout,9001) (eig(ib),ib=1,nel)
            if(ik == 1 .and. iblock == 1) call wd_w1hw2(" -- w1hw2 with nl part--",iblock)
            call wd_w1hw2(" -- after diagonalization --",iblock)
!sum eko
            dr1=0.d0;dr2=0.d0
            do ib1=1,nel
               dr1=dr1+eko_d(nsta+ib1-1) ! MPI
               dr2=dr2+eig(ib1)
            enddo
            write(nfout,'(" sum of eko_l, eig, abs diff =",3e25.10)') dr1,dr2,abs(dr2-dr1)
         end if
      endif
    endif

!!! (subspace rotation) !!
       call subspace_rotation ! vec,zat_l -> zat_l
       if(ipridavidson>=2 .and. ik==1 .and. iblock == 1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
!!( tenchi ) (zaj_l <- zat_l)
!       iter = min(idavid+1,ndavid)
!       call m_ES_W_transpose_back(ista_k,iend_k,ik,zaj_l,zat_l(1,1,1,iter))
!!       zaj_l_backup(:,nsta:nend,:) = zaj_l(:,nsta:nend,ik,:)
!! (eko_l)
    if(sw_divide_subspace==ON)then
       do ib1 = 1, nel
          eko_l(nsta+ib1-1,ik)=eig(ib1)
       end do
    else
       do ib1 = 1,neg
          if(map_e(ib1)==myrank_e) eko_l(map_z(ib1),ik) = eig(ib1)
       enddo
    endif

    if(ipridavidson >= 2) then
       if(ik == 1 .and. iblock == 1) then
          eko2 = sum(eig(1:nel))
          write(nfout,1201) ik,eko1,eko2

          write(nfout,*) 'eko_l'
          write(nfout,9001) (eko_d(nsta+ib1-1),ib1=1,nel)
       end if
    endif

1201 format(' %% for ik = ',i4,4x,' eko1&ekod&eko2 = ',3f14.7)
9001 format(5x,6f12.5)
!!! (neordr & nrvf_ordr)
!
9000 continue
!    neordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)
!    nrvf_ordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)
!
!! (deallocate)  
#ifdef NEC_TUNE
    deallocate(zah_t)
    deallocate(zat_t)
#endif
    deallocate(eko_d)
    deallocate(occup)

    deallocate(eig)
    deallocate(vec)
    nullify(zah_l_p,zat_l_p,fsr_p,fsi_p,feigconv_p)
!
    call tstatc0_end(id_sname)
!
  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_k_world(myrank_k),ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0
!
    subroutine wd_w1hw2(somecomment,iblock)
      character(len=*), intent(in) :: somecomment
      integer,intent(in) :: iblock
      integer :: ib1, ib2, nel_wd, nsb_wd
      write(nfout,'(a35)') somecomment
      write(nfout,*) 'w1hw2 for ik = ',ik
      nel_wd = 8
      nsb_wd = 8
      if(nel_wd > nel) nel_wd = nel
      if(nsb_wd > nsize_sb_now) nsb_wd = nsize_sb_now
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      else
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(2*ip0-1),ip0=ip0b+1,ip0b+ib2)
         end do
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1hw2(2*ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      end if
      write(nfout,*) 'w1sw2 for ik = ',ik
      if(kimg_t==1) then
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      else
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(2*ip0-1),ip0=ip0b+1,ip0b+ib2)
         end do
         do ib2=1,nsb_wd
            ip0b = ib2*(ib2-1)/2
            write(nfout,9001) (w1sw2(2*ip0),ip0=ip0b+1,ip0b+ib2)
         end do
      end if
9001  format(5x,9f12.5)
      write(nfout,*) 'eko_l for ik = ',ik
      write(nfout,9001) (eko_l(nsta+ib1-1,ik),ib1=1,nel_wd)
    end subroutine wd_w1hw2


    subroutine add_nonlocal_part
      integer :: ip,ib1,ib2,ibb1,ibb2
      integer       :: ia, lmt1, lmt2, it, p, s, ib
      real(kind=DP) :: facv,facq,vr,vi,qr,qi
      real(kind=DP) :: tmpr,tmpi
#ifdef NEC_TUNE
      real(kind=DP), dimension(nlmta,nel,itot+1) :: fsr_t, fsr_v, fsr_q
      real(kind=DP), dimension(nlmta,nel,itot+1) :: fsi_t, fsi_v, fsi_q
      real(kind=DP), allocatable, dimension(:,:) :: fsr_tt, fsr_vt, fsr_qt
      real(kind=DP), allocatable, dimension(:,:) :: fsi_tt, fsi_vt, fsi_qt
      integer :: iter, ncount, i,itot0
      itot0 = itot
      if(sw_MRCV_only==ON) itot0 = 1
      if(kimg == 1) then
         fsr_v = 0.0d0
         fsr_q = 0.0d0
         fsi_v = 0.0d0
         fsi_q = 0.0d0
         do iter = 1, itot0+1
            ncount = 0
            do ia = ista_atm, iend_atm
               it = ityp(ia)
               do lmt1 = 1, ilmt(it)
                  ncount = ncount + 1
                  p = lmta(lmt1,ia)
                  do ibb1 = 1, nel
                     ibb2 = nsta+ibb1-1
                     fsr_t(ncount,ibb1,iter) = fsr(ibb2,p,iter)
                     fsi_t(ncount,ibb1,iter) = fsi(ibb2,p,iter)
                  end do ! ibb1
                  do lmt2 = 1, ilmt(it)
                     s = lmta(lmt2,ia)
                     if(ipaw(it) == 0)then
                        facv   = iwei(ia)*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     else
                        facv   = iwei(ia)*(dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     endif
                     facq   = iwei(ia)*q(lmt1,lmt2,it)
                     do ibb1 = 1, nel
                        ibb2 = nsta+ibb1-1
                        fsr_v(ncount,ibb1,iter) = fsr_v(ncount,ibb1,iter) + facv*fsr(ibb2,s,iter)
                        fsr_q(ncount,ibb1,iter) = fsr_q(ncount,ibb1,iter) + facq*fsr(ibb2,s,iter)
                        fsi_v(ncount,ibb1,iter) = fsi_v(ncount,ibb1,iter) + facv*fsi(ibb2,s,iter)
                        fsi_q(ncount,ibb1,iter) = fsi_q(ncount,ibb1,iter) + facq*fsi(ibb2,s,iter)
                     end do ! ibb1
                  end do ! lmt2
               end do ! lmt1
            end do ! ia
         end do ! iter
         allocate(fsr_tt(ncount,nsize_sb_now))
         allocate(fsr_vt(ncount,nsize_sb_now))
         allocate(fsr_qt(ncount,nsize_sb_now))
         allocate(fsi_tt(ncount,nsize_sb_now))
         allocate(fsi_vt(ncount,nsize_sb_now))
         allocate(fsi_qt(ncount,nsize_sb_now))
         num = 0
         do ibb1 = 1, nsize_max_sb_now
            if(ibover(ibb1,iblock)<0) cycle
            iter1=(ibb1-1)/nel+1
            ii1  = ibb1-nel*(iter1-1)
            num = num + 1
            fsr_tt(1:ncount,num) = fsr_t(1:ncount,ii1,iter1)
            fsr_vt(1:ncount,num) = fsr_v(1:ncount,ii1,iter1)
            fsr_qt(1:ncount,num) = fsr_q(1:ncount,ii1,iter1)
            fsi_tt(1:ncount,num) = fsi_t(1:ncount,ii1,iter1)
            fsi_vt(1:ncount,num) = fsi_v(1:ncount,ii1,iter1)
            fsi_qt(1:ncount,num) = fsi_q(1:ncount,ii1,iter1)
         end do
         ldc = nsize_sb_now
         if(ncount>0)then
            call dgemm('T','N',num,num,ncount,1.0d0,fsr_tt,ncount,fsr_vt,ncount,1.0d0,w1hw2_,ldc)
            call dgemm('T','N',num,num,ncount,1.0d0,fsi_tt,ncount,fsi_vt,ncount,1.0d0,w1hw2_,ldc)
            call dgemm('T','N',num,num,ncount,1.0d0,fsr_tt,ncount,fsr_qt,ncount,1.0d0,w1sw2_,ldc)
            call dgemm('T','N',num,num,ncount,1.0d0,fsi_tt,ncount,fsi_qt,ncount,1.0d0,w1sw2_,ldc)
         endif
         deallocate(fsr_tt)
         deallocate(fsr_vt)
         deallocate(fsr_qt)
         deallocate(fsi_tt)
         deallocate(fsi_vt)
         deallocate(fsi_qt)
      else ! if(kimg == 1)
         if(k_symmetry(ik) == GAMMA) then
            fsr_v = 0.0d0
            fsr_q = 0.0d0
            do iter = 1, itot0+1
               ncount = 0
               do ia = ista_atm, iend_atm
                  it = ityp(ia)
                  do lmt1 = 1, ilmt(it)
                     ncount = ncount + 1
                     p = lmta(lmt1,ia)
                     do ibb1 = 1, nel
                        ibb2 = nsta+ibb1-1
                        fsr_t(ncount,ibb1,iter) = fsr(ibb2,p,iter)
                     end do ! ibb1
                     do lmt2 = 1, ilmt(it)
                        s = lmta(lmt2,ia)
                        if(ipaw(it) == 0)then
                           facv   = iwei(ia)*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin))
                        else
                           facv   = iwei(ia)*(dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin))
                        endif
                        facq   = iwei(ia)*q(lmt1,lmt2,it)
                        do ibb1 = 1, nel
                           ibb2 = nsta+ibb1-1
                           fsr_v(ncount,ibb1,iter) = fsr_v(ncount,ibb1,iter) + facv*fsr(ibb2,s,iter)
                           fsr_q(ncount,ibb1,iter) = fsr_q(ncount,ibb1,iter) + facq*fsr(ibb2,s,iter)
                        end do ! ibb1
                     end do ! lmt2
                  end do ! lmt1
               end do ! ia
            end do ! iter
            allocate(fsr_tt(ncount,nsize_sb_now))
            allocate(fsr_vt(ncount,nsize_sb_now))
            allocate(fsr_qt(ncount,nsize_sb_now))
            num = 0
            do ibb1 = 1, nsize_max_sb_now
               if(ibover(ibb1,iblock)<0) cycle
               iter1=(ibb1-1)/nel+1
               ii1  = ibb1-nel*(iter1-1)
               num = num + 1
               fsr_tt(1:ncount,num) = fsr_t(1:ncount,ii1,iter1)
               fsr_vt(1:ncount,num) = fsr_v(1:ncount,ii1,iter1)
               fsr_qt(1:ncount,num) = fsr_q(1:ncount,ii1,iter1)
            end do
            ldc = nsize_sb_now
            if(ncount>0) then
               call dgemm('T','N',num,num,ncount,1.0d0,fsr_tt,ncount,fsr_vt,ncount,1.0d0,w1hw2_,ldc)
               call dgemm('T','N',num,num,ncount,1.0d0,fsr_tt,ncount,fsr_qt,ncount,1.0d0,w1sw2_,ldc)
            end if
            deallocate(fsr_tt)
            deallocate(fsr_vt)
            deallocate(fsr_qt)
         else ! if(k_symmetry(ik) == GAMMA)
            fsr_v = 0.0d0
            fsr_q = 0.0d0
            fsi_v = 0.0d0
            fsi_q = 0.0d0
            do iter = 1, itot0+1
               ncount = 0
               do ia = ista_atm, iend_atm
                  it = ityp(ia)
                  do lmt1 = 1, ilmt(it)
                     ncount = ncount + 1
                     p = lmta(lmt1,ia)
                     do ibb1 = 1, nel
                        ibb2 = nsta+ibb1-1
                        fsr_t(ncount,ibb1,iter) = fsr(ibb2,p,iter)
                        fsi_t(ncount,ibb1,iter) = fsi(ibb2,p,iter)
                     end do ! ibb1
                     do lmt2 = 1, ilmt(it)
                        s = lmta(lmt2,ia)
                        if(ipaw(it) == 0)then
                           facv   = iwei(ia)*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin))
                        else
                           facv   = iwei(ia)*(dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin))
                        endif
                        facq   = iwei(ia)*q(lmt1,lmt2,it)
                        do ibb1 = 1, nel
                           ibb2 = nsta+ibb1-1
                           fsr_v(ncount,ibb1,iter) = fsr_v(ncount,ibb1,iter) + facv*fsr(ibb2,s,iter)
                           fsr_q(ncount,ibb1,iter) = fsr_q(ncount,ibb1,iter) + facq*fsr(ibb2,s,iter)
                           fsi_v(ncount,ibb1,iter) = fsi_v(ncount,ibb1,iter) + facv*fsi(ibb2,s,iter)
                           fsi_q(ncount,ibb1,iter) = fsi_q(ncount,ibb1,iter) + facq*fsi(ibb2,s,iter)
                        end do ! ibb1
                     end do ! lmt2
                  end do ! lmt1
               end do ! ia
            end do ! iter
            allocate(fsr_tt(ncount*kimg,nsize_sb_now))
            allocate(fsr_vt(ncount*kimg,nsize_sb_now))
            allocate(fsr_qt(ncount*kimg,nsize_sb_now))
            num = 0
            do ibb1 = 1, nsize_max_sb_now
               if(ibover(ibb1,iblock)<0) cycle
               iter1=(ibb1-1)/nel+1
               ii1  = ibb1-nel*(iter1-1)
               num = num + 1
               do i = 1, ncount
                  fsr_tt(i*2-1,num) = fsr_t(i,ii1,iter1)
                  fsr_tt(i*2,  num) = fsi_t(i,ii1,iter1)
                  fsr_vt(i*2-1,num) = fsr_v(i,ii1,iter1)
                  fsr_vt(i*2,  num) = fsi_v(i,ii1,iter1)
                  fsr_qt(i*2-1,num) = fsr_q(i,ii1,iter1)
                  fsr_qt(i*2,  num) = fsi_q(i,ii1,iter1)
               end do
            end do
            ldc = nsize_sb_now
            if(ncount>0)then
               call zgemm('C','N',num,num,ncount,c1,fsr_tt,ncount,fsr_vt,ncount,c1,w1hw2_,ldc)
               call zgemm('C','N',num,num,ncount,c1,fsr_tt,ncount,fsr_qt,ncount,c1,w1sw2_,ldc)
            endif
            deallocate(fsr_tt)
            deallocate(fsr_vt)
            deallocate(fsr_qt)
         end if ! if(k_symmetry(ik) == GAMMA)
      end if ! if(kimg == 1)
#else
      do ibb2 = 1,nsize_max_sb_now
         if(ibover(ibb2,iblock)<0) cycle
         ib2 = ibover(ibb2,iblock)
         iter2= (ibb2-1)/nel+1
         ii2  = ibb2-nel*(iter2-1)
         ii2  = nsta+ii2-1
         ip0b = ib2*(ib2-1)/2
         do ibb1 = 1,ibb2
            if(ibover(ibb1,iblock)<0) cycle
            ib1 = ibover(ibb1,iblock)
            iter1=(ibb1-1)/nel+1
            ii1  = ibb1-nel*(iter1-1)
            ii1  = nsta+ii1-1
            ip0 = ip0b + ib1
!            if(mod(ip0-1,nrank_e)/=myrank_e) cycle
            if(kimg_t==1) then
               vr=0.d0
               qr=0.d0
            else
               vr=0.d0
               vi=0.d0
               qr=0.d0
               qi=0.d0
            end if
            do ia = 1, natm
               it = ityp(ia)
               do lmt1 = 1, ilmt(it)
                  p = lmta(lmt1,ia)
                  do lmt2 = 1, ilmt(it)
                     s = lmta(lmt2,ia)
                     if(ipaw(it)==0)then
                        facv   = iwei(ia)*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     else
                        facv   = iwei(ia)*(dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin))
                     endif
                     facq   = iwei(ia)*q(lmt1,lmt2,it)
                     if(kimg==1) then
                        tmpr = fsr(ii1,p,iter1)*fsr(ii2,s,iter2)&
                    &        + fsi(ii1,p,iter1)*fsi(ii2,s,iter2)
                        vr = vr + facv*tmpr
                        qr = qr + facq*tmpr
                     else
                        if(k_symmetry(ik) == GAMMA) then
                           tmpr = fsr(ii1,p,iter1)*fsr(ii2,s,iter2)
                           vr = vr + facv*tmpr
                           qr = qr + facq*tmpr
                        else
                           tmpr = fsr(ii1,p,iter1)*fsr(ii2,s,iter2)&
                    &        + fsi(ii1,p,iter1)*fsi(ii2,s,iter2)
                           tmpi = fsr(ii1,p,iter1)*fsi(ii2,s,iter2)&
                    &        - fsi(ii1,p,iter1)*fsr(ii2,s,iter2)
                           vr = vr + facv*tmpr
                           vi = vi + facv*tmpi
                           qr = qr + facq*tmpr
                           qi = qi + facq*tmpi
                        end if
                     end if
                  end do
               end do
            end do
            if(kimg_t==1) then
               w1hw2(ip0) = w1hw2(ip0) + vr
               w1sw2(ip0) = w1sw2(ip0) + qr
            else
               w1hw2(2*ip0-1) = w1hw2(2*ip0-1) + vr
               w1hw2(2*ip0  ) = w1hw2(2*ip0  ) + vi
               w1sw2(2*ip0-1) = w1sw2(2*ip0-1) + qr
               w1sw2(2*ip0  ) = w1sw2(2*ip0  ) + qi
            end if
         end do
      end do
#endif
    end subroutine add_nonlocal_part


    subroutine subspace_rotation
      integer :: ib1,ib2,ibb2,iadd,is,is1
!!$      real(kind=DP), dimension(np_g1k_x,neg,kimg) :: zaj_wk
      real(kind=DP), allocatable, dimension(:,:,:) :: zaj_wk
      real(kind=DP), allocatable, dimension(:,:,:) :: zah_wk
      real(kind=DP), allocatable, dimension(:,:)   :: fsr_wk
      real(kind=DP), allocatable, dimension(:,:)   :: fsi_wk
#ifdef NEC_TUNE
      integer :: i
      real(kind=DP), allocatable, dimension(:,:)   :: fsr_t, fsi_t

      if(kimg==1) then
         allocate(zaj_wk(maxval(np_g1k),nel,kimg))
         if(itot /= max_iter_david) allocate(zah_wk(maxval(np_g1k),nel,kimg))
         allocate(fsr_wk(nel,np_fs),fsi_wk(nel,np_fs))
         allocate(fsr_t(nsize_sb_now,np_fs),fsi_t(nsize_sb_now,np_fs))
         num = 0
         do ibb2 = 1, nsize_max_sb_now
            if(ibover(ibb2,iblock) < 0) cycle
            iter2=(ibb2-1)/nel+1
            ii2=ibb2-nel*(iter2-1)
            ii2=nsta+ii2-1
            num = num + 1
            do ii = ista_fs, iend_fs
               i = ii - ista_fs + 1
               fsr_t(num,i) = fsr(ii2,ii,iter2)
               fsi_t(num,i) = fsi(ii2,ii,iter2)
            end do
         end do
         call dgemm('N','N',np_g1k(ik),nel,nsize_sb_now,1.0d0,zat_t,maxval(np_g1k),vec,nsize_sb_now,0.0d0,zaj_wk,maxval(np_g1k))
         call dgemm('T','N',nel,np_fs,nsize_sb_now,1.0d0,vec,nsize_sb_now,fsr_t,nsize_sb_now,0.0d0,fsr_wk,nel)
         call dgemm('T','N',nel,np_fs,nsize_sb_now,1.0d0,vec,nsize_sb_now,fsi_t,nsize_sb_now,0.0d0,fsi_wk,nel)
         if(itot /= max_iter_david) then
            call dgemm('N','N',np_g1k(ik),nel,nsize_sb_now,1.0d0,zah_t,maxval(np_g1k),vec,nsize_sb_now,0.0d0,zah_wk,maxval(np_g1k))
         end if
         zaj_l(:,nsta:nend,ik,:) = zaj_wk(:,:,:)
#ifdef SAVE_FFT_TIMES
         if(sw_save_fft == ON) status_saved_phifftr(nsta:nend,ik) = OLD
#endif
         if(itot /= max_iter_david) zah_l(:,nsta:nend,:,1) = zah_wk(:,:,:)
         do is = 1, np_fs ! MPI
            do ib = nsta, nend ! MPI
               fsr_l(ib,is,ik) = fsr_wk(ib-nsta+1,is)
               fsi_l(ib,is,ik) = fsi_wk(ib-nsta+1,is)
            end do
         end do
         deallocate(fsr_t,fsi_t)
         deallocate(zaj_wk,fsr_wk,fsi_wk)
         if(itot /= max_iter_david) deallocate(zah_wk)
      else
         if(k_symmetry(ik) == GAMMA) then
            allocate(zaj_wk(maxval(np_g1k),nel,kimg))
            if(itot /= max_iter_david) allocate(zah_wk(maxval(np_g1k),nel,kimg))
            allocate(fsr_wk(nel,np_fs))
            allocate(fsr_t(nsize_sb_now,np_fs))
            num = 0
            do ibb2 = 1, nsize_max_sb_now
               if(ibover(ibb2,iblock) < 0) cycle
               iter2=(ibb2-1)/nel+1
               ii2=ibb2-nel*(iter2-1)
               ii2=nsta+ii2-1
               num = num + 1
               do ii = ista_fs, iend_fs
                  i = ii - ista_fs + 1
                  fsr_t(num,i) = fsr(ii2,ii,iter2)
               end do
            end do
            call dgemm('N','N',np_g1k(ik),nel,nsize_sb_now,1.0d0,zat_t(1,1,1),   maxval(np_g1k), &
            & vec,nsize_sb_now,0.0d0,zaj_wk(1,1,1),   maxval(np_g1k))
            call dgemm('N','N',np_g1k(ik),nel,nsize_sb_now,1.0d0,zat_t(1,1,kimg),maxval(np_g1k), &
            & vec,nsize_sb_now,0.0d0,zaj_wk(1,1,kimg),maxval(np_g1k))
            call dgemm('T','N',nel,np_fs,nsize_sb_now,1.0d0,vec,nsize_sb_now,fsr_t,nsize_sb_now,0.0d0,fsr_wk,nel)
            if(itot /= max_iter_david) then
               call dgemm('N','N',np_g1k(ik),nel,nsize_sb_now,1.0d0,zah_t(1,1,1),   maxval(np_g1k), &
            & vec,nsize_sb_now,0.0d0,zah_wk(1,1,1),   maxval(np_g1k))
               call dgemm('N','N',np_g1k(ik),nel,nsize_sb_now,1.0d0,zah_t(1,1,kimg),maxval(np_g1k), &
            & vec,nsize_sb_now,0.0d0,zah_wk(1,1,kimg),maxval(np_g1k))
            end if
            zaj_l(:,nsta:nend,ik,:) = zaj_wk(:,:,:)
#ifdef SAVE_FFT_TIMES
            if(sw_save_fft == ON) status_saved_phifftr(nsta:nend,ik) = OLD
#endif
            if(itot /= max_iter_david) zah_l(:,nsta:nend,:,1) = zah_wk(:,:,:)
            do is = 1, np_fs ! MPI
               do ib = nsta, nend ! MPI
                  fsr_l(ib,is,ik) = fsr_wk(ib-nsta+1,is)
               end do
            end do
            deallocate(fsr_t)
            deallocate(zaj_wk,fsr_wk)
            if(itot /= max_iter_david) deallocate(zah_wk)
         else
            allocate(zaj_wk(maxval(np_g1k)*kimg,nel,1))
            if(itot /= max_iter_david) allocate(zah_wk(maxval(np_g1k)*kimg,nel,1))
            allocate(fsr_wk(nel*kimg,np_fs))
            allocate(fsr_t(nsize_sb_now*kimg,np_fs))
            num = 0
            do ibb2 = 1, nsize_max_sb_now
               if(ibover(ibb2,iblock) < 0) cycle
               iter2=(ibb2-1)/nel+1
               ii2=ibb2-nel*(iter2-1)
               ii2=nsta+ii2-1
               num = num + 1
               do ii = ista_fs, iend_fs
                  i = ii - ista_fs + 1
                  fsr_t(2*num-1,i) = fsr(ii2,ii,iter2)
                  fsr_t(2*num,  i) = fsi(ii2,ii,iter2)
               end do
            end do
            call zgemm('N','N',np_g1k(ik),nel,nsize_sb_now,c1,zat_t,maxval(np_g1k),vec,nsize_sb_now,c0,zaj_wk,maxval(np_g1k))
            call zgemm('T','N',nel,np_fs,nsize_sb_now,c1,vec,nsize_sb_now,fsr_t,nsize_sb_now,c0,fsr_wk,nel)
            if(itot /= max_iter_david) then
               call zgemm('N','N',np_g1k(ik),nel,nsize_sb_now,c1,zah_t,maxval(np_g1k),vec,nsize_sb_now,c0,zah_wk,maxval(np_g1k))
            end if
            do ib = nsta, nend
               i = ib - nsta + 1
               do ii = 1, np_g1k(ik)
                  zaj_l(ii,ib,ik,1)    = zaj_wk(2*ii-1,i,1)
                  zaj_l(ii,ib,ik,kimg) = zaj_wk(2*ii,  i,1)
               end do
            end do
#ifdef SAVE_FFT_TIMES
            if(sw_save_fft == ON) status_saved_phifftr(nsta:nend,ik) = OLD
#endif
            if(itot /= max_iter_david) then
               do ib = nsta, nend
                  i = ib - nsta + 1
                  do ii = 1, np_g1k(ik)
                     zah_l(ii,ib,1,   1) = zah_wk(2*ii-1,i,1)
                     zah_l(ii,ib,kimg,1) = zah_wk(2*ii,  i,1)
                  end do
               end do
            end if
            do is = 1, np_fs ! MPI
               do ib = nsta, nend ! MPI
                  i = ib - nsta + 1
                  fsr_l(ib,is,ik) = fsr_wk(2*i-1,is)
                  fsi_l(ib,is,ik) = fsr_wk(2*i,  is)
               end do
            end do
            deallocate(fsr_t)
            deallocate(zaj_wk,fsr_wk)
            if(itot /= max_iter_david) deallocate(zah_wk)
         end if
      end if
#else
      allocate(zaj_wk(maxval(np_g1k),nel,kimg))
      if(itot /= max_iter_david) then
        allocate(zah_wk(maxval(np_g1k),nel,kimg))
        zah_wk(:,:,:) = 0.d0
      end if
      allocate(fsr_wk(nel,nlmta))
      if(k_symmetry(ik) /= GAMMA) then
        allocate(fsi_wk(nel,nlmta))
        fsi_wk(:,:)=0.d0
      end if

      zaj_wk(:,:,:) = 0.d0
      fsr_wk(:,:)=0.d0
      if(kimg==1) then
         do ib1=1,nel
            do ibb2=1,nsize_max_sb_now
               if(ibover(ibb2,iblock)<0) cycle
               ib2 = ibover(ibb2,iblock)
               iter2=(ibb2-1)/nel+1
               ii2=ibb2-nel*(iter2-1)
               ii2=nsta+ii2-1
               hr2=vec(ib2,ib1)
               do ii=ista_g1k(ik),iend_g1k(ik)
                  iadd = ii - ista_g1k(ik) + 1
                  zaj_wk(iadd,ib1,kimg) = zaj_wk(iadd,ib1,kimg) + zat_l(iadd,ii2,kimg,iter2)*hr2
               end do
               do ii=1,nlmta
                 fsr_wk(ib1,ii) = fsr_wk(ib1,ii) + fsr(ii2,ii,iter2)*hr2
                 fsi_wk(ib1,ii) = fsi_wk(ib1,ii) + fsi(ii2,ii,iter2)*hr2
               end do
               if(itot /= max_iter_david) then
                 do ii=ista_g1k(ik),iend_g1k(ik)
                    iadd = ii - ista_g1k(ik) + 1
                    zah_wk(iadd,ib1,kimg) = zah_wk(iadd,ib1,kimg) + zah_l(iadd,ii2,kimg,iter2)*hr2
                 end do
               end if
            end do
         end do
      else
         if(k_symmetry(ik) == GAMMA) then
            do ib1=1,nel
               do ibb2=1,nsize_max_sb_now
                  if(ibover(ibb2,iblock)<0) cycle
                  ib2 = ibover(ibb2,iblock)
                  iter2=(ibb2-1)/nel+1
                  ii2=ibb2-nel*(iter2-1)
                  ii2=nsta+ii2-1
                  hr2=vec(ib2,ib1)
                  do ii=ista_g1k(ik),iend_g1k(ik)
                     iadd = ii - ista_g1k(ik) + 1
                     dr1=zat_l(iadd,ii2,1   ,iter2)
                     di1=zat_l(iadd,ii2,kimg,iter2)
                     zaj_wk(iadd,ib1,1   ) = zaj_wk(iadd,ib1,1   ) + dr1*hr2
                     zaj_wk(iadd,ib1,kimg) = zaj_wk(iadd,ib1,kimg) + di1*hr2
                  end do
                  do ii=1,nlmta
                    fsr_wk(ib1,ii) = fsr_wk(ib1,ii) + fsr(ii2,ii,iter2)*hr2
                  end do
                  if(itot /= max_iter_david) then
                    do ii=ista_g1k(ik),iend_g1k(ik)
                       iadd = ii - ista_g1k(ik) + 1
                       dr1=zah_l(iadd,ii2,1   ,iter2)
                       di1=zah_l(iadd,ii2,kimg,iter2)
                       zah_wk(iadd,ib1,1   ) = zah_wk(iadd,ib1,1   ) + dr1*hr2
                       zah_wk(iadd,ib1,kimg) = zah_wk(iadd,ib1,kimg) + di1*hr2
                    end do
                  end if
               end do
            end do
         else
            do ib1=1,nel
               do ibb2=1,nsize_max_sb_now
                  if(ibover(ibb2,iblock)<0) cycle
                  ib2 = ibover(ibb2,iblock)
                  iter2=(ibb2-1)/nel+1
                  ii2=ibb2-nel*(iter2-1)
                  ii2=nsta+ii2-1
                  hr2=vec(2*ib2-1,ib1)
                  hi2=vec(2*ib2  ,ib1)
                  do ii=ista_g1k(ik),iend_g1k(ik)
                     iadd = ii - ista_g1k(ik) + 1
                     dr1=zat_l(iadd,ii2,1   ,iter2)
                     di1=zat_l(iadd,ii2,kimg,iter2)
                     zaj_wk(iadd,ib1,1   ) = zaj_wk(iadd,ib1,1   ) + dr1*hr2 - di1*hi2
                     zaj_wk(iadd,ib1,kimg) = zaj_wk(iadd,ib1,kimg) + dr1*hi2 + di1*hr2
                  end do
                  do ii=1,nlmta
                     dr1=fsr(ii2,ii,iter2)
                     di1=fsi(ii2,ii,iter2)
                     fsr_wk(ib1,ii) = fsr_wk(ib1,ii) + dr1*hr2 - di1*hi2
                     fsi_wk(ib1,ii) = fsi_wk(ib1,ii) + dr1*hi2 + di1*hr2
                  end do
                  if(itot /= max_iter_david) then
                    do ii=ista_g1k(ik),iend_g1k(ik)
                       iadd = ii - ista_g1k(ik) + 1
                       dr1=zah_l(iadd,ii2,1   ,iter2)
                       di1=zah_l(iadd,ii2,kimg,iter2)
                       zah_wk(iadd,ib1,1   ) = zah_wk(iadd,ib1,1   ) + dr1*hr2 - di1*hi2
                       zah_wk(iadd,ib1,kimg) = zah_wk(iadd,ib1,kimg) + dr1*hi2 + di1*hr2
                    end do
                  end if
               end do
            end do
         end if
      end if
!print *,itot,  itot /= max_iter_david    
      zaj_l(:,nsta:nend,ik,:) = zaj_wk(:,:,:)
#ifdef SAVE_FFT_TIMES
      if(sw_save_fft == ON) status_saved_phifftr(nsta:nend,ik) = OLD
#endif
      if(itot /= max_iter_david) zah_l(:,nsta:nend,:,1) = zah_wk(:,:,:)
!     fsr_l(nsta:nend,:,ik) = fsr_wk(:,:)
      do is = 1, np_fs ! MPI
         is1=nis_fs(myrank_g)+is-1
         do ib = nsta, nend ! MPI
             fsr_l(ib,is,ik) = fsr_wk(ib-nsta+1,is1)
         end do
      end do
!     if(k_symmetry(ik) /= GAMMA) fsi_l(nsta:nend,:,ik) = fsi_wk(:,:)
      if(k_symmetry(ik) /= GAMMA) then
         do is = 1, np_fs ! MPI
            is1=nis_fs(myrank_g)+is-1
            do ib = nsta, nend ! MPI
               fsi_l(ib,is,ik) = fsi_wk(ib-nsta+1,is1)
            end do
         end do
      end if
      
      deallocate(zaj_wk,fsr_wk)
      if(itot /= max_iter_david) deallocate(zah_wk)
      if(k_symmetry(ik) /= GAMMA) deallocate(fsi_wk)
#endif
    end subroutine subspace_rotation

  end subroutine evolve_WFs_in_subspace_3D
  
  subroutine decide_correction_vector_3D(precon,ik,ekin_l,afft_l,bfft_l, &
                                             wk_bfft_l,lsize,ibsize,isrsize,fft_l_size,p_l)
    integer, intent(in)       :: precon, ik, lsize, ibsize, isrsize, fft_l_size
    real(kind=DP), intent(in)  :: ekin_l(maxval(np_g1k))
#ifdef FFT_3D_DIVISION
    real(kind=DP), intent(in)  :: afft_l(lsize*2   )
    real(kind=DP), intent(out) :: bfft_l(lsize*2   ,1)
    real(kind=DP), intent(inout) :: wk_bfft_l(lsize*2   ,ibsize)
#else
    real(kind=DP), intent(in)  :: afft_l(lsize*kimg)
!!$    real(kind=DP), intent(out) :: bfft_l(lsize*kimg,1)
    real(kind=DP), intent(out) :: bfft_l(lsize*kimg,ibsize)
    real(kind=DP), intent(inout) :: wk_bfft_l(lsize*kimg,ibsize)
#endif
    real(kind=DP)              :: p_l(maxval(np_g1k))
    integer :: ib,ib1,ib2,ibesize
    integer :: id_sname = -1, id_sname1 = -1, id_sname2 = -1, id_sname3 = -1, id_sname4 = -1, id_sname5 = -1
    call tstatc0_begin('decide_correction_vector_3D(0) ', id_sname,1)

!!$    do ib = 1, np_e ! MPI
    do ib1 = 1, np_e, ibsize
       ib2 = min(ib1+ibsize-1,np_e)
       ibesize = ib2 - ib1 + 1

       if (sw_timing_2ndlevel == ON) call tstatc0_begin('decide_correction_3D(1) ',id_sname1)

#ifdef __TIMER_COMM__
!!$       ib = ib1
       call m_ES_WF_in_Rspace_3D(ik,ib1,ib2,ibsize,lsize,wk_bfft_l,0)
#else
       call m_ES_WF_in_Rspace_3D(ik,ib1,ib2,ibsize,lsize,wk_bfft_l)
#endif
       if (sw_timing_2ndlevel == ON) call tstatc0_end(id_sname1)
       if (sw_timing_2ndlevel == ON) call tstatc0_begin('decide_correction_3D(2) ',id_sname2)
#ifdef FFT_3D_DIVISION
       call m_FFT_Vlocal_W_3DIV_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_x(myrank_g))
       call m_FFT_Direct_3DIV_3D(nfout,wk_bfft_l,lsize,ibsize)
#else
       if (sw_fft_xzy > 0) then
          call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_y(myrank_g))
          call m_FFT_Direct_3D(nfout,wk_bfft_l,lsize,ibsize)
       else
          call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_z(myrank_g))
          call m_FFT_Direct_XYZ_3D(nfout,wk_bfft_l,lsize,ibsize)
       end if
#endif
       call map_fft_to_WF_3D(ik,lsize,ibesize,wk_bfft_l,bfft_l,isrsize,fft_l_size)
       if (sw_timing_2ndlevel == ON) call tstatc0_end(id_sname2)
       if (sw_timing_2ndlevel == ON) call tstatc0_begin('decide_correction_3D(3) ',id_sname3)
       if(ibsize == 1) then
          call SD_direction_3D(precon,ik,ib1,ekin_l,bfft_l,p_l,lsize) !-here
       else
          call SD_direction_3D2(precon,ik,ib1,ib2,ibesize,ekin_l,bfft_l,lsize,p_l) !-here
       end if
       if (sw_timing_2ndlevel == ON) call tstatc0_end(id_sname3)
    end do

    if (sw_timing_2ndlevel == ON) call tstatc0_begin('barrier in correction_3D(4) ',id_sname4)
    call mpi_barrier(mpi_k_world(myrank_k),ierr)
    if (sw_timing_2ndlevel == ON) call tstatc0_end(id_sname4)
    if (sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)

!    call orthogonalize_SD_drctns(ik,to=OTHER_BANDS)  ! -(m_ES_WF_by_SDorCG) ->(wfsd_l, bsd(ri)_l)
    call orthogonalize_SD_drctns(ik,to=OTHER_BANDS)
    if(ipridavidson>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
!    call orthogonalize_SD_drctns(ik,to=ALL_BANDS)  ! -(m_ES_WF_by_SDorCG) ->(wfsd_l, bsd(ri)_l)
    
    if (sw_timing_2ndlevel == ON) call tstatc0_begin('decide_correction_3D(4) ',id_sname5)
    call normalize_wfsd_3D(ik)

    if (sw_timing_2ndlevel == ON) call tstatc0_end(id_sname5)
  end subroutine decide_correction_vector_3D
  
  subroutine orthogonalize_SD_drctns(ik,to)
    integer, intent(in) :: ik,to

    integer :: itmp
    integer :: id_sname = -1
    real(kind=DP), allocatable, dimension(:,:) :: fs_mpi
    integer :: is, is1, ib
    call tstatc0_begin('orthogonalize_SD_drctns(Mddavid) ', id_sname,1)

!    if(modnrm == EXECUT) call m_ES_betar_dot_Psi_4_each_k(nfout,wfsd_l,ik,ik,ik,bsdr_l,bsdi_l)
    !                                        ->bsd(ri)_l
    
    if(sw_MRCV_only==OFF)then    
       zat_l(:,:,:,1) = zaj_l(:,:,ik,:)
       allocate(fs_mpi(np_e,nlmta))
!!$       allocate(fs_mpi2(np_e,nlmta))

       fs_mpi=0.d0
       do is = 1, np_fs ! MPI
          is1=nis_fs(myrank_g)+is-1
          do ib = 1, np_e ! MPI
             fs_mpi(ib,is1) = fsr_l(ib,is,ik)
          end do
       end do
       call mpi_allreduce(MPI_IN_PLACE,fs_mpi,np_e*nlmta &
         & ,mpi_double_precision,mpi_sum, mpi_ke_world,ierr)       ! MPI
       fsr(1:np_e,1:nlmta,1) = fs_mpi(1:np_e,1:nlmta)
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          fs_mpi=0.d0
          do is = 1, np_fs ! MPI
             is1=nis_fs(myrank_g)+is-1
             do ib = 1, np_e ! MPI
                fs_mpi(ib,is1) = fsi_l(ib,is,ik)
             end do
          end do
          call mpi_allreduce(MPI_IN_PLACE,fs_mpi,np_e*nlmta &
            & ,mpi_double_precision,mpi_sum ,mpi_ke_world,ierr)       ! MPI
          fsi(1:np_e,1:nlmta,1) = fs_mpi(1:np_e,1:nlmta)
       end if
       deallocate(fs_mpi)
    
       zaj_l(:,:,ik,:) = zajold_l(:,:,:)
       fsr_l(:,:,ik) = fsrold_l(:,:)
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          fsi_l(:,:,ik) = fsiold_l(:,:)
       end if
#ifdef SAVE_FFT_TIMES
       if(sw_save_fft == ON) status_saved_phifftr(:,ik) = OLD
#endif
    endif
    
    call tstatc0_end(id_sname)
!!$    itmp=modnrm
!!$    modnrm=EXECUT
!!$    itmp=modnrm
!!$    modnrm=EXECUT
!!$    call m_ES_betar_dot_Psi_4_each_k_3D(wfsd_l,ik,ik,ik,bsdr_l,bsdi_l)
!!$    call m_ES_orthogonalize_SD_to_WFs_3D(ik,to,wfsd_l,bsdr_l,bsdi_l) ! ->(wfsd_l,bsd(ri)_l)
!!$    modnrm=itmp
    if(modnrm==EXECUT) then
       call m_ES_betar_dot_Psi_4_each_k_3D(nfout,wfsd_l,ik,ik,ik,bsdr_l,bsdi_l)
       call m_ES_orthogonal_phi_to_WFs(ik,wfsd_l,bsdr_l,bsdi_l) ! ->(wfsd_l,bsd(ri)_l)
    else
       call m_ES_orthogonal_phi_to_WFs(ik,wfsd_l,bsdr_l,bsdi_l) ! ->(wfsd_l,bsd(ri)_l)
       call m_ES_betar_dot_Psi_4_each_k_3D(nfout,wfsd_l,ik,ik,ik,bsdr_l,bsdi_l)
    end if
  end subroutine orthogonalize_SD_drctns
  
#endif
end module m_ES_WF_by_ModifiedDavidson

      SUBROUTINE ZHEMM(SIDE,UPLO,M,N,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
*     .. Scalar Arguments ..
      DOUBLE COMPLEX ALPHA,BETA
      INTEGER LDA,LDB,LDC,M,N
      CHARACTER SIDE,UPLO
*     ..
*     .. Array Arguments ..
      DOUBLE COMPLEX A(LDA,*),B(LDB,*),C(LDC,*)
*     ..
*
*  Purpose
*  =======
*
*  ZHEMM  performs one of the matrix-matrix operations
*
*     C := alpha*A*B + beta*C,
*
*  or
*
*     C := alpha*B*A + beta*C,
*
*  where alpha and beta are scalars, A is an hermitian matrix and  B and
*  C are m by n matrices.
*
*  Arguments
*  ==========
*
*  SIDE   - CHARACTER*1.
*           On entry,  SIDE  specifies whether  the  hermitian matrix  A
*           appears on the  left or right  in the  operation as follows:
*
*              SIDE = 'L' or 'l'   C := alpha*A*B + beta*C,
*
*              SIDE = 'R' or 'r'   C := alpha*B*A + beta*C,
*
*           Unchanged on exit.
*
*  UPLO   - CHARACTER*1.
*           On  entry,   UPLO  specifies  whether  the  upper  or  lower
*           triangular  part  of  the  hermitian  matrix   A  is  to  be
*           referenced as follows:
*
*              UPLO = 'U' or 'u'   Only the upper triangular part of the
*                                  hermitian matrix is to be referenced.
*
*              UPLO = 'L' or 'l'   Only the lower triangular part of the
*                                  hermitian matrix is to be referenced.
*
*           Unchanged on exit.
*
*  M      - INTEGER.
*           On entry,  M  specifies the number of rows of the matrix  C.
*           M  must be at least zero.
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry, N specifies the number of columns of the matrix C.
*           N  must be at least zero.
*           Unchanged on exit.
*
*  ALPHA  - COMPLEX*16      .
*           On entry, ALPHA specifies the scalar alpha.
*           Unchanged on exit.
*
*  A      - COMPLEX*16       array of DIMENSION ( LDA, ka ), where ka is
*           m  when  SIDE = 'L' or 'l'  and is n  otherwise.
*           Before entry  with  SIDE = 'L' or 'l',  the  m by m  part of
*           the array  A  must contain the  hermitian matrix,  such that
*           when  UPLO = 'U' or 'u', the leading m by m upper triangular
*           part of the array  A  must contain the upper triangular part
*           of the  hermitian matrix and the  strictly  lower triangular
*           part of  A  is not referenced,  and when  UPLO = 'L' or 'l',
*           the leading  m by m  lower triangular part  of the  array  A
*           must  contain  the  lower triangular part  of the  hermitian
*           matrix and the  strictly upper triangular part of  A  is not
*           referenced.
*           Before entry  with  SIDE = 'R' or 'r',  the  n by n  part of
*           the array  A  must contain the  hermitian matrix,  such that
*           when  UPLO = 'U' or 'u', the leading n by n upper triangular
*           part of the array  A  must contain the upper triangular part
*           of the  hermitian matrix and the  strictly  lower triangular
*           part of  A  is not referenced,  and when  UPLO = 'L' or 'l',
*           the leading  n by n  lower triangular part  of the  array  A
*           must  contain  the  lower triangular part  of the  hermitian
*           matrix and the  strictly upper triangular part of  A  is not
*           referenced.
*           Note that the imaginary parts  of the diagonal elements need
*           not be set, they are assumed to be zero.
*           Unchanged on exit.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in the  calling (sub) program. When  SIDE = 'L' or 'l'  then
*           LDA must be at least  max( 1, m ), otherwise  LDA must be at
*           least max( 1, n ).
*           Unchanged on exit.
*
*  B      - COMPLEX*16       array of DIMENSION ( LDB, n ).
*           Before entry, the leading  m by n part of the array  B  must
*           contain the matrix B.
*           Unchanged on exit.
*
*  LDB    - INTEGER.
*           On entry, LDB specifies the first dimension of B as declared
*           in  the  calling  (sub)  program.   LDB  must  be  at  least
*           max( 1, m ).
*           Unchanged on exit.
*
*  BETA   - COMPLEX*16      .
*           On entry,  BETA  specifies the scalar  beta.  When  BETA  is
*           supplied as zero then C need not be set on input.
*           Unchanged on exit.
*
*  C      - COMPLEX*16       array of DIMENSION ( LDC, n ).
*           Before entry, the leading  m by n  part of the array  C must
*           contain the matrix  C,  except when  beta  is zero, in which
*           case C need not be set on entry.
*           On exit, the array  C  is overwritten by the  m by n updated
*           matrix.
*
*  LDC    - INTEGER.
*           On entry, LDC specifies the first dimension of C as declared
*           in  the  calling  (sub)  program.   LDC  must  be  at  least
*           max( 1, m ).
*           Unchanged on exit.
*
*  Further Details
*  ===============
*
*  Level 3 Blas routine.
*
*  -- Written on 8-February-1989.
*     Jack Dongarra, Argonne National Laboratory.
*     Iain Duff, AERE Harwell.
*     Jeremy Du Croz, Numerical Algorithms Group Ltd.
*     Sven Hammarling, Numerical Algorithms Group Ltd.
*
*  =====================================================================
*
*     .. External Functions ..
      LOGICAL LSAME
      EXTERNAL LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC DBLE,DCONJG,MAX
*     ..
*     .. Local Scalars ..
      DOUBLE COMPLEX TEMP1,TEMP2
      INTEGER I,INFO,J,K,NROWA
      LOGICAL UPPER
*     ..
*     .. Parameters ..
      DOUBLE COMPLEX ONE
      PARAMETER (ONE= (1.0D+0,0.0D+0))
      DOUBLE COMPLEX ZERO
      PARAMETER (ZERO= (0.0D+0,0.0D+0))
*     ..
*
*     Set NROWA as the number of rows of A.
*
      IF (LSAME(SIDE,'L')) THEN
          NROWA = M
      ELSE
          NROWA = N
      END IF
      UPPER = LSAME(UPLO,'U')
*
*     Test the input parameters.
*
      INFO = 0
      IF ((.NOT.LSAME(SIDE,'L')) .AND. (.NOT.LSAME(SIDE,'R'))) THEN
          INFO = 1
      ELSE IF ((.NOT.UPPER) .AND. (.NOT.LSAME(UPLO,'L'))) THEN
          INFO = 2
      ELSE IF (M.LT.0) THEN
          INFO = 3
      ELSE IF (N.LT.0) THEN
          INFO = 4
      ELSE IF (LDA.LT.MAX(1,NROWA)) THEN
          INFO = 7
      ELSE IF (LDB.LT.MAX(1,M)) THEN
          INFO = 9
      ELSE IF (LDC.LT.MAX(1,M)) THEN
          INFO = 12
      END IF
      IF (INFO.NE.0) THEN
          CALL XERBLA('ZHEMM ',INFO)
          RETURN
      END IF
*
*     Quick return if possible.
*
      IF ((M.EQ.0) .OR. (N.EQ.0) .OR.
     +    ((ALPHA.EQ.ZERO).AND. (BETA.EQ.ONE))) RETURN
*
*     And when  alpha.eq.zero.
*
      IF (ALPHA.EQ.ZERO) THEN
          IF (BETA.EQ.ZERO) THEN
              DO 20 J = 1,N
                  DO 10 I = 1,M
                      C(I,J) = ZERO
   10             CONTINUE
   20         CONTINUE
          ELSE
              DO 40 J = 1,N
                  DO 30 I = 1,M
                      C(I,J) = BETA*C(I,J)
   30             CONTINUE
   40         CONTINUE
          END IF
          RETURN
      END IF
*
*     Start the operations.
*
      IF (LSAME(SIDE,'L')) THEN
*
*        Form  C := alpha*A*B + beta*C.
*
          IF (UPPER) THEN
              DO 70 J = 1,N
                  DO 60 I = 1,M
                      TEMP1 = ALPHA*B(I,J)
                      TEMP2 = ZERO
                      DO 50 K = 1,I - 1
                          C(K,J) = C(K,J) + TEMP1*A(K,I)
                          TEMP2 = TEMP2 + B(K,J)*DCONJG(A(K,I))
   50                 CONTINUE
                      IF (BETA.EQ.ZERO) THEN
                          C(I,J) = TEMP1*DBLE(A(I,I)) + ALPHA*TEMP2
                      ELSE
                          C(I,J) = BETA*C(I,J) + TEMP1*DBLE(A(I,I)) +
     +                             ALPHA*TEMP2
                      END IF
   60             CONTINUE
   70         CONTINUE
          ELSE
              DO 100 J = 1,N
                  DO 90 I = M,1,-1
                      TEMP1 = ALPHA*B(I,J)
                      TEMP2 = ZERO
                      DO 80 K = I + 1,M
                          C(K,J) = C(K,J) + TEMP1*A(K,I)
                          TEMP2 = TEMP2 + B(K,J)*DCONJG(A(K,I))
   80                 CONTINUE
                      IF (BETA.EQ.ZERO) THEN
                          C(I,J) = TEMP1*DBLE(A(I,I)) + ALPHA*TEMP2
                      ELSE
                          C(I,J) = BETA*C(I,J) + TEMP1*DBLE(A(I,I)) +
     +                             ALPHA*TEMP2
                      END IF
   90             CONTINUE
  100         CONTINUE
          END IF
      ELSE
*
*        Form  C := alpha*B*A + beta*C.
*
          DO 170 J = 1,N
              TEMP1 = ALPHA*DBLE(A(J,J))
              IF (BETA.EQ.ZERO) THEN
                  DO 110 I = 1,M
                      C(I,J) = TEMP1*B(I,J)
  110             CONTINUE
              ELSE
                  DO 120 I = 1,M
                      C(I,J) = BETA*C(I,J) + TEMP1*B(I,J)
  120             CONTINUE
              END IF
              DO 140 K = 1,J - 1
                  IF (UPPER) THEN
                      TEMP1 = ALPHA*A(K,J)
                  ELSE
                      TEMP1 = ALPHA*DCONJG(A(J,K))
                  END IF
                  DO 130 I = 1,M
                      C(I,J) = C(I,J) + TEMP1*B(I,K)
  130             CONTINUE
  140         CONTINUE
              DO 160 K = J + 1,N
                  IF (UPPER) THEN
                      TEMP1 = ALPHA*DCONJG(A(J,K))
                  ELSE
                      TEMP1 = ALPHA*A(K,J)
                  END IF
                  DO 150 I = 1,M
                      C(I,J) = C(I,J) + TEMP1*B(I,K)
  150             CONTINUE
  160         CONTINUE
  170     CONTINUE
      END IF
*
      RETURN
*
*     End of ZHEMM .
*
      END

!
! =========== Contributions ===================================
!
! Through the courtesy of contributors, the following functions are added.
!
! Company:  ASMS Co.,Ltd.
! Functions:  [Identifier: 13.1R]
!            Dielectric functions can be calculated when condition = INITIAL 
!
! Functions:  [Identifier: 13.1XI]
!            Dielectric functions can be calculated in the EXCITATION module
!
! =============================================================
subroutine Epsilon_Postscf


end subroutine Epsilon_Postscf

! Copyright (c) 2012, Minoru Otani <minoru.otani@aist.go.jp> 
! 
! Permission is hereby granted, free of charge, to any person 
! obtaining a copy of this software and associated documentation 
! files (the "Software"), to deal in the Software without restriction, 
! including without limitation the rights to use, copy, modify, merge, 
! publish, distribute, sublicense, and/or sell copies of the Software, 
! and to permit persons to whom the Software is furnished to do so, 
! subject to the following conditions:
 
! The above copyright notice and this permission notice shall be 
! included in all copies or substantial portions of the Software.
 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
! EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
! OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
! NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
! HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
! WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
! DEALINGS IN THE SOFTWARE.

Subroutine cft_1z(c, nsl, nz, ldz, isign, cout)
  Implicit None
#ifndef SX
  Include "fftw3.f"
#endif

  Integer,    Intent(In)  :: nsl, nz, ldz, isign
  Complex(8), Intent(In)  :: c(0:nsl*ldz-1)
  Complex(8), Intent(Out) :: cout(0:nsl*ldz-1)
  
#ifndef SX
  Integer(8) :: plan
  Integer :: FFTW_WARD, isl

  If ( isign < 0 ) Then
     FFTW_WARD = FFTW_FORWARD
  Else
     FFTW_WARD = FFTW_BACKWARD
  End If

  Do isl = 0, nsl-1
     Call dfftw_plan_dft_1d ( plan, nz, c(isl*ldz), cout(isl*ldz), FFTW_WARD, &
          FFTW_ESTIMATE )
     Call dfftw_execute ( plan )
     Call dfftw_destroy_plan ( plan )
  End Do

  If( isign < 0 ) Then
     cout(:) = cout(:) / nz
  End If
#else
  Integer, save :: isw=0
  Integer :: n,ierr,isl
  Real(8),allocatable,dimension(:) :: rpart,ipart
  Integer,save :: ifax(20)
  Real(8),allocatable,dimension(:),save :: trigs
  Real(8),allocatable,dimension(:) :: wk
  allocate(rpart(0:nsl*ldz-1));rpart(:) = dble(c(:))
  allocate(ipart(0:nsl*ldz-1));ipart(:) = dimag(c(:))
  n = nsl*ldz
  if(isw==0) allocate(trigs(2*n))
  allocate(wk(2*n))

  if(isw.eq.0)then
     do isl=0,nsl-1
        call dfc1fb(nz,rpart(isl*ldz),ipart(isl*ldz),nz,isw,ifax,trigs,wk,ierr)
     enddo
     isw=1
  else
     if(isign<0)then
        isw = 1
     else
        isw = -1
     endif
     do isl=0,nsl-1
        call dfc1bf(nz,rpart(isl*ldz),ipart(isl*ldz),nz,isw,ifax,trigs,wk,ierr)
     enddo
  endif
  cout(:) = dcmplx(rpart(:),ipart(:))
  if(isign<0) cout(:) = cout(:)/nz
  deallocate(rpart)
  deallocate(ipart)
  deallocate(wk)
#endif


End Subroutine cft_1z

!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 471 $)
!
!  MODULE: m_Ldos
!
!  AUTHOR(S): T. Yamasaki   January/18/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
module m_Ldos
! $Id: m_Ldos.F90 471 2015-11-13 01:14:05Z jkoga $
  use m_Const_Parameters, only   : DP, CMPLDP, REGULAR_INTERVALS, BY_ATOMIC_POSITIONS &
       &                         , DELTA10, EXECUT, ON, SOFTPART, HARDPART, DIRECT, PAI2 &
       &                         , ALDOS, LAYERDOS, NO, OFF, ELECTRON
  use m_Control_Parameters, only : kimg, sw_aldos, sw_layerdos, crtdst_aldos, naldos_from, naldos_to &
       &                         , slicing_way_winlay, deltaz_winlay, normal_axis_winlay &
       &                         , crtdst_winlay, nspin, neg, ipridos, ekmode, sw_save_ldos_weight &
       &                         , af, printable &
       &                         , m_CtrlP_check_naldos_range, hardpart_subroutine,sw_rspace_ldos
  use m_Files, only              : nfout, nfldos &
       &                         , m_Files_open_nfldos, m_Files_close_nfldos
  use m_Crystal_Structure, only :  altv, rltv, univol
  use m_Ionic_System,   only :     natm2,natm,cps,numlay,ityp,iwei,if_aldos
  use m_Parallelization, only :    ista_e,iend_e,istep_e, np_e, map_z, npes, ierr, mype &
       &                         , map_k, myrank_k, map_ek, ista_kngp, iend_kngp, ista_k, iend_k &
       &                         , nrank_e, nrank_k, myrank_e, map_e, mpi_k_world &
       &                         , mpi_comm_group
  use m_Kpoints, only :            kv3, kv3_ek
  use m_FFT, only :                nfft, nfftp,nfftp_nonpara, fft_box_size_WF, fft_box_size_CD &
       &                         , fft_box_size_CD_nonpara &
       &                         , m_FFT_alloc_CD_box, m_FFT_dealloc_CD_box &
       &                         , m_FFT_CD_inverse0 &
       &                         , m_FFT_alloc_WF_work, m_FFT_dealloc_WF_work
  use m_PlaneWaveBasisSet, only :  kg, igf, ngabc, kgp
  use m_PseudoPotential, only :    modnrm
!$$  use m_Electronic_Structure,only :neordr, totch, efermi &
!$$       &                         , m_ES_WF_in_Rspace &
!$$       &                         , m_ES_wd_zaj_small_portion
  use m_Electronic_Structure,only :neordr, totch, efermi 
  use m_Electronic_Structure,only :m_ES_WF_in_Rspace_3D &
       &                         , m_ES_wd_zaj_small_portion_3D
  use m_Charge_Density, only :     chgq_l, chgq_enl &
       &                         , m_CD_hardpart_sub &
       &                         , m_CD_map_valence_charge_to_fft_box &
       &                         , m_CD_restore_chgq &
       &                         , m_CD_map_chgq_to_fft_box &
       &                         , m_CD_set_ylm_enl_etc &
       &                         , m_CD_dealloc_ylm_enl_etc &
       &                         , m_CD_keep_retrieve_hsr


! ============================== added by K. Tagami ============== 11.0
  use m_Control_Parameters,    only : noncol, ndim_magmom, ndim_spinor, sw_fft_xzy
!  use m_Charge_Density, only :    m_CD_hardpart_sub_noncl, &
!       &                          m_CD_hardpart_sub2_noncl, &
!       &                          m_CD_map_chgqenl_to_fft_box_kt
! ================================================================ 11.0
  use m_Parallelization, only : nel_fft_x, nel_fft_y, nel_fft_z, neg_g &
                              , map_fft_x, map_fft_y                   &
                              , fft_X_x_nel, fft_X_y_nel, fft_X_z_nel  &
                              , mpi_kg_world, mpi_ke_world, myrank_g
  use m_PlaneWaveBasisSet, only :  ngabc_kngp_l
  use m_FFT, only : m_FFT_Direct_3D,m_FFT_Direct_XYZ_3D
  use m_Parallelization, only : mpi_ge_world

  implicit none

  integer, private, target, allocatable, dimension(:,:,:) ::  mesh, meshp
  
  integer ::  nlayer = 0
  integer ::  mlayer = 1
  integer ::  naldos = 0
  integer, private :: naldos_write = 0
  integer ::  maldos = 1
  integer, private ::  n_total_ldoscal = 0
  real(kind=DP),private,allocatable,dimension(:,:)  :: winlay ! d(mlayer,2)
!  real(kind=DP),public,allocatable,dimension(:,:,:,:) :: weiwsc ! d(maldos,neg|np_e,1|ista_k:iend_k,nspin)
!  real(kind=DP),public,allocatable,dimension(:,:,:,:) :: weilay ! d(mlayer,neg|np_e,1|ista_k:iend_k,nspin)
  real(kind=DP),public,allocatable,dimension(:,:,:) :: weiwsc ! d(maldos,neg|np_e,1|ista_k:iend_k)
  real(kind=DP),public,allocatable,dimension(:,:,:) :: weilay ! d(mlayer,neg|np_e,1|ista_k:iend_k)
!  real(kind=DP),private,allocatable,dimension(:) ::    bfft   ! d(nfft)
  real(kind=DP),private :: maxhv, maxv
  real(kind=DP),private :: height
  integer,private,allocatable,dimension(:) :: if_aldos_full ! d(natm2)

! ============================= added by K. Tagami ===================== 11.0
  real(kind=DP),public,allocatable,dimension(:,:,:,:) :: weiwsc_noncl
  real(kind=DP),public,allocatable,dimension(:,:,:,:) :: weilay_noncl
! ====================================================================== 11.0

  integer, parameter :: ilen = 5

  include 'mpif.h'
  integer istatus(mpi_status_size)

contains
  integer function m_Ldos_what_is_n_total_ldos()
!!$    m_Ldos_what_is_n_total_ldos = n_total_ldos
    m_Ldos_what_is_n_total_ldos = naldos_write + mlayer
  end function m_Ldos_what_is_n_total_ldos

  subroutine m_Ldos_preparation()

    if(sw_aldos == ON ) then
       call set_naldos()      ! -> naldos, maldos
       call m_CtrlP_check_naldos_range(nfout,maldos)
!!$       call check_naldos_range()
       call set_if_aldos_full()
       call set_naldos_write()
       call alloc_mesh()
       call fillup_mesh()
    end if
    call set_nlayer()
    if(sw_layerdos == ON ) then
       call alloc_winlay()
       call set_winlay()
!!$       call dealloc_winlay()
    end if
  end subroutine m_Ldos_preparation

  subroutine set_naldos()
    naldos = natm2
    maldos = naldos + 1
  end subroutine set_naldos

!!$  subroutine check_naldos_range()
!!$    if(naldos_from == 0 .and. naldos_to == 0) then
!!$       naldos_from = 1
!!$       naldos_to   = maldos
!!$    else
!!$       if(naldos_from < 1)     naldos_from = 1
!!$       if(naldos_from > maldos) naldos_from = maldos
!!$       if(naldos_to < 1)       naldos_to   = 1
!!$       if(naldos_to > maldos)   naldos_to   = maldos
!!$       if(naldos_to < naldos_from) naldos_to = naldos_from
!!$    end if
!!$    write(nfout,'(" !!ldos naldos_from         = ",i6," <<check_naldos_range>>")') naldos_from
!!$    write(nfout,'(" !!ldos naldos_to           = ",i6," <<check_naldos_range>>")') naldos_to
!!$  end subroutine check_naldos_range

  subroutine set_if_aldos_full()
    integer, allocatable, dimension(:) :: ip_atom
    integer :: i, nb

    allocate(if_aldos_full(naldos_from:naldos_to))
    allocate(ip_atom(natm2+1)); ip_atom = 0

    nb = natm
    do i = 1, natm
       ip_atom(i) = i
       if(iwei(i) == 2) then
          nb = nb + 1
          ip_atom(nb) = i
       end if
    end do

    do i = 1, natm2
       if(ip_atom(i) == 0) then
          if(ipridos>=1) write(nfout,'(" !!ldos i, ip_atom = ",i5,i5)') i,ip_atom(i)
          stop ' ip_atom is illegal <<set_if_aldos_full>>'
       end if
    end do

    if_aldos_full = OFF
    do i = naldos_from, naldos_to
       if(i <= natm2) then
          if_aldos_full(i) = if_aldos(ip_atom(i))
       else
          if_aldos_full(i) = ON
       end if
    end do

    nb = 0
    ip_atom = 0
    do i = naldos_from, naldos_to
       if(if_aldos_full(i) == ON) then
          nb = nb + 1
          ip_atom(nb) = i
       end if
    end do
    if(ipridos>=1) write(nfout,'(" !!ldos aldos_atoms = ",10i5)') (ip_atom(i),i=1,nb)

    deallocate(ip_atom)
  end subroutine set_if_aldos_full

  subroutine set_naldos_write()
    integer :: i
    naldos_write = 0
    do i = naldos_from, naldos_to
       if(if_aldos_full(i) == ON) naldos_write = naldos_write + 1
    end do
    if(ipridos>=1) write(nfout,'(" !!ldos naldos_write = ",i5)') naldos_write
!!$    naldos_write = naldos_to - naldos_from + 1
  end subroutine set_naldos_write
    
  subroutine set_nlayer()
    integer :: i,j, io,jo
    real(kind=DP) :: h
    integer, allocatable, dimension(:) :: layer_index, layer_order

    if(sw_layerdos == ON) then
       call get_height(h)
       height = h
       if(slicing_way_winlay == REGULAR_INTERVALS) then
!!$       call get_height(h)
          if(kimg == 1) h = h*0.5d0
          nlayer = h/deltaz_winlay + (1-DELTA10)
          mlayer = nlayer + 1
       else if(slicing_way_winlay == BY_ATOMIC_POSITIONS) then
          allocate(layer_index(natm))
          nlayer = 1
          layer_index(nlayer) = numlay(1)
          do i = 2, natm
             do j = 1, nlayer
                if(layer_index(j) == numlay(i)) goto 1001
             end do
             nlayer = nlayer + 1
             layer_index(nlayer) = numlay(i)
1001         continue
          end do
          if(minval(layer_index(1:nlayer)) /= 1 .or. maxval(layer_index(1:nlayer)) /= nlayer) then
             allocate(layer_order(nlayer)); layer_order(:) = (/(i,i=1,nlayer)/)
             do i = 1, nlayer-1
                do j = i+1, nlayer
                   io = layer_order(i)
                   jo = layer_order(j)
                   if(layer_index(io) < layer_index(io)) then
                      layer_order(j) = io
                      layer_order(i) = jo
                   end if
                end do
             end do
             if(ipridos>=1) then
                write(nfout,'(" !!ldos i, layer_index, layer_order <<m_Ldos.set_nlayer>>")')
                do i = 1, nlayer
                   write(nfout,'(" !!ldos ",3i8)') i, layer_index(i), layer_order(i)
                end do
             end if
             do i = 1, natm
                do j = 1, nlayer
                   if(layer_index(j) == numlay(i)) then
                      numlay(i) = layer_order(j)
                      goto 1002
                   end if
                end do
1002            continue
             end do
             if(ipridos>=1) then
                write(nfout,'(" !!ldos #atom, numlay <<m_Ldos.set_nlayer>>")')
                do i = 1, natm
                   write(nfout,'(" !!ldos ",3i8)') i, numlay(i)
                end do
             end if
             deallocate(layer_order)
          end if
          deallocate(layer_index)
          mlayer = nlayer + 1
       end if
       if(ipridos>=1) write(nfout,'(" !!ldos nlayer, mlayer = ",2i8)') nlayer, mlayer
    else
       nlayer = 0
       mlayer = 0
    end if
  end subroutine set_nlayer

  subroutine alloc_mesh()
    integer :: id,nd2,nn
    id  = fft_box_size_WF(1,0)
    nd2 = fft_box_size_WF(2,0)
    nn  = fft_box_size_WF(3,1)
    allocate(mesh(id,nd2,nn))
    id  = fft_box_size_CD_nonpara(1,0)
    nd2 = fft_box_size_CD_nonpara(2,0)
    nn  = fft_box_size_CD(3,1)
    allocate(meshp(id,nd2,nn))
  end subroutine alloc_mesh

  subroutine m_Ldos_dealloc_mesh()
    deallocate(mesh)
    deallocate(meshp)
  end subroutine m_Ldos_dealloc_mesh

  subroutine alloc_winlay()
    allocate(winlay(mlayer,2))
  end subroutine alloc_winlay

  subroutine dealloc_winlay()
    deallocate(winlay)
  end subroutine dealloc_winlay

  subroutine fillup_mesh()
    integer :: id, nd2, nl, nm, nn
    real(kind=DP),allocatable,dimension(:,:) :: wk_catoms, cps_full ! d(natm2,3)
    real(kind=DP),allocatable,dimension(:) :: wk_dstnc  ! d(natm2)
    integer, allocatable, dimension(:) ::     wk_ioddst, ityp_full ! d((natm2+1)*4)

    allocate(wk_catoms(natm2,3))
    allocate(wk_dstnc(natm2))
    allocate(wk_ioddst((natm2+1)*4))
    allocate(cps_full(natm2,3))
    allocate(ityp_full(natm2))

    cps_full(1:natm,1:3) = cps(1:natm,1:3)
    ityp_full(1:natm) = ityp(1:natm)
    call rplcps(cps_full,ityp_full,1,natm2,natm,iwei)
        

    id  = fft_box_size_WF(1,0)
    nd2 = fft_box_size_WF(2,0)
    nl  = fft_box_size_WF(1,1)
    nm  = fft_box_size_WF(2,1)
    nn  = fft_box_size_WF(3,1)
    call anlmes(nfout,ipridos,mesh,id,nd2,nl,nm,nn,altv,rltv,cps_full,natm2,crtdst_aldos,DELTA10,wk_catoms,wk_ioddst,wk_dstnc)
    id  = fft_box_size_CD_nonpara(1,0)
    nd2 = fft_box_size_CD_nonpara(2,0)
    nl  = fft_box_size_CD(1,1)
    nm  = fft_box_size_CD(2,1)
    nn   = fft_box_size_CD(3,1)
    call anlmes(nfout,ipridos-1,meshp,id,nd2,nl,nm,nn,altv,rltv,cps_full,natm2,crtdst_aldos,DELTA10,wk_catoms,wk_ioddst,wk_dstnc)

    deallocate(ityp_full,cps_full,wk_ioddst,wk_dstnc,wk_catoms)
  end subroutine fillup_mesh

  subroutine get_height(h)
    real(kind=DP), intent(out) :: h
    integer :: iaxis,i2,i3
    real(kind=DP) :: a,b,S

    iaxis = normal_axis_winlay
    i2 = iaxis + 1
    if(i2 >= 4) i2 = i2 - 3
    i3 = i2 + 1
    if(i3 >= 4) i3 = i3 - 3
    a = dsqrt(altv(1,i2)**2 + altv(2,i2)**2 + altv(3,i2)**2)
    b = dsqrt(altv(1,i3)**2 + altv(2,i3)**2 + altv(3,i3)**2)
! ----------------------------
!        29 Jan. 2008
!     Revised by M. Usami
!!$    S = a*a * b*b - (altv(1,i2)*altv(1,i3)+altv(2,i2)*altv(2,i3)+altv(3,i2)*altv(3,i3))
    S = a*a * b*b - (altv(1,i2)*altv(1,i3)+altv(2,i2)*altv(2,i3)+altv(3,i2)*altv(3,i3))**2
! --------------------------
    S = dsqrt(S)
    h = univol/S
    if(ipridos>=1) write(nfout,'(" !!ldos S, h, V = ",3f16.8," <<m_Ldos.set_nlayer>>")') S,h,univol
  end subroutine get_height

  subroutine set_winlay()
! ----------------------------------------------
!       Nov. 17th 1992 by T.Yamasaki
!
!    the original subroutine name was "dwinly2"
!
!       modified by T. Yamasaki, 09th Feb 2004
! ----------------------------------------------
    real(kind=DP) :: zmin, tmp, h
    integer ::  i, nl
    i = normal_axis_winlay
!!$    call get_height(h)
    h = height
    if(kimg == 1) then
       maxhv = h*0.5d0
       maxv  = maxhv*2
    else
       maxhv = h
       maxv  = maxhv
    end if

    winlay = 0.d0
    if(slicing_way_winlay == REGULAR_INTERVALS) then
       if(ipridos>=1) then
          write(nfout,'(" !!ldos slicing_way = REGULAR_INTERVALS")')
          write(nfout,'(" !!ldos nlayer, mlayer = ",2i6)') nlayer, mlayer
          write(nfout,'(" !!ldos maxhv, maxv = ",2f8.4)') maxhv, maxv
          write(nfout,'(" !!deltaz_winlay = ",f8.4)') deltaz_winlay
       end if
       if(kimg == 1) then
          winlay(1,1) = 0.d0
          winlay(mlayer,2) = maxhv
          do i = 1, nlayer
             winlay(i,2) = deltaz_winlay * i
             if(winlay(i,2) > maxhv) winlay(i,2) = maxhv
             if(i+1 <= mlayer) winlay(i+1,1) = winlay(i,2)
          end do
       else if(kimg == 2) then
          zmin = minval(cps(1:natm,normal_axis_winlay))
          winlay(1,1) = zmin - crtdst_winlay
          winlay(mlayer,2) = winlay(1,1) + maxv
          do i = 1, nlayer
             winlay(i,2) = winlay(i,1) + deltaz_winlay
             if(winlay(i,2) > winlay(mlayer,2)) winlay(i,2) = winlay(mlayer,2)
             if(i+1 <= mlayer) winlay(i+1,1) = winlay(i,2)
          end do
       end if
    else if(slicing_way_winlay == BY_ATOMIC_POSITIONS) then
       if(ipridos>=1) &
            & write(nfout,'(" !!ldos slicing_selection = BY_ATOMIC_POSITIONS")')

       do i = 1, mlayer
          winlay(i,1) = +maxv*30
          winlay(i,2) = -maxv*30
       end do

       do i = 1, natm
          nl = numlay(i)
          if(winlay(nl,1) > cps(i,normal_axis_winlay)) winlay(nl,1) = cps(i,normal_axis_winlay)
          if(winlay(nl,2) < cps(i,normal_axis_winlay)) winlay(nl,2) = cps(i,normal_axis_winlay)
       end do

       if(ipridos>=1) then
          write(nfout,'(" !!ldos a range of atomic positions of each layer ")')
          do i = 1, nlayer
             write(nfout,'(2x,i4,2f20.8)') i, winlay(i,1), winlay(i,2)
          end do
       end if

       tmp = winlay(1,1) - crtdst_winlay
       if(kimg == 2) then
          if( tmp < winlay(nlayer,2) - maxhv + crtdst_winlay ) then
!     ( a unit cell has no vacuum region )
             winlay(1,1) = (winlay(1,1) + winlay(nlayer,2) - maxv)*0.5
             winlay(nlayer,2) = winlay(1,1)+maxv
             winlay(mlayer,1) = winlay(1,1)
             winlay(mlayer,2) = winlay(1,1)
          else
!     ( a unit cell has a vacuum region)
             winlay(1,1) = winlay(1,1) - crtdst_winlay
             winlay(nlayer,2) = winlay(nlayer,2) + crtdst_winlay
             winlay(mlayer,1) = winlay(nlayer,2)
             winlay(mlayer,2) = winlay(1,1) + maxv
          endif
       else if(kimg == 1) then
          winlay(1,1) = 0.d0
          winlay(mlayer,2) = maxhv
          winlay(nlayer,2) = winlay(nlayer,2) + crtdst_winlay
          winlay(mlayer,1) = winlay(nlayer,2)
       end if

       do i = 1, nlayer-1
          winlay(i,2) = (winlay(i,2) + winlay(i+1,1))*0.5
          winlay(i+1,1) = winlay(i,2)
       end do
    else
       if(ipridos>=1) write(nfout,'(" !!ldos slicing_selection is illegal")')
    end if
             
    if(ipridos>=1) then
       write(nfout,'(" !!ldos     no,        min,           max ")')
       do i = 1, nlayer
          write(6,'(" !!ldos ",i4,2f20.8)') i, winlay(i,1), winlay(i,2)
       enddo
       if(mlayer > nlayer) then
          write(6,'(" !!ldos ",i4,2f20.8)') mlayer, winlay(mlayer,1), winlay(mlayer,2)
       endif
    end if

  end subroutine set_winlay

  subroutine m_Ldos_alloc_weiwsc_etc()
    integer :: n_ldos_allocated
    n_total_ldoscal = 0
! ======================== modified by K. Tagami ========== 11.0
!    if(sw_aldos == ON) then
!       call alloc_weiwsc(n_ldos_allocated)
!       n_total_ldoscal = n_total_ldoscal + n_ldos_allocated
!    end if
!    if(sw_layerdos == ON) then
!       call alloc_weilay(n_ldos_allocated)
!       n_total_ldoscal = n_total_ldoscal + n_ldos_allocated
!    end if
!
    if ( noncol ) then
       if(sw_aldos == ON) then
          call alloc_weiwsc_noncl(n_ldos_allocated)
          n_total_ldoscal = n_total_ldoscal + n_ldos_allocated
       end if
       if(sw_layerdos == ON) then
          call alloc_weilay_noncl(n_ldos_allocated)
          n_total_ldoscal = n_total_ldoscal + n_ldos_allocated
       end if
    else
       if(sw_aldos == ON) then
          call alloc_weiwsc(n_ldos_allocated)
          n_total_ldoscal = n_total_ldoscal + n_ldos_allocated
       end if
       if(sw_layerdos == ON) then
          call alloc_weilay(n_ldos_allocated)
          n_total_ldoscal = n_total_ldoscal + n_ldos_allocated
       end if
    endif
! ========================================================= 11.0
  end subroutine m_Ldos_alloc_weiwsc_etc

  subroutine m_Ldos_dealloc_weiwsc_etc()
! ===================================== modiifed by K. Tagami ====== 11.0
!    if(sw_aldos == ON) then
!       call dealloc_weiwsc()
!    end if
!    if(sw_layerdos == ON) then
!       call dealloc_weilay()
!    end if
!
    if ( noncol ) then
       if(sw_aldos == ON) then
          call dealloc_weiwsc_noncl()
       end if
       if(sw_layerdos == ON) then
          call dealloc_weilay_noncl()
       end if
    else
       if(sw_aldos == ON) then
          call dealloc_weiwsc()
       end if
       if(sw_layerdos == ON) then
          call dealloc_weilay()
       end if
    endif
! ========================================================================== 11.0
  end subroutine m_Ldos_dealloc_weiwsc_etc

  subroutine alloc_weiwsc(n_ldos_allocated)
    integer, intent(out) :: n_ldos_allocated
    n_ldos_allocated = 0
    if(ekmode == ON) then
       allocate(weiwsc(maldos,neg,1)); weiwsc = 0.d0
    else if(ekmode == OFF) then
       if(hardpart_subroutine==2.or.sw_rspace_ldos==ON)then
          allocate(weiwsc(maldos,np_e,ista_k:iend_k)); weiwsc = 0.d0
       else
          allocate(weiwsc(maldos,neg,kv3)); weiwsc = 0.d0
       endif
    end if
    n_ldos_allocated = maldos
  end subroutine alloc_weiwsc

! ================================= added by K. Tagami ============= 11.0
  subroutine alloc_weiwsc_noncl(n_ldos_allocated)
    integer, intent(out) :: n_ldos_allocated
    n_ldos_allocated = 0
    if(ekmode == ON) then
       allocate(weiwsc_noncl(maldos,neg,1,ndim_magmom))
    else if(ekmode == OFF) then
       if(hardpart_subroutine==2.or.sw_rspace_ldos==ON)then
          allocate(weiwsc_noncl(maldos,np_e,ista_k:iend_k,ndim_magmom))
       else
          allocate(weiwsc_noncl(maldos,neg,kv3,ndim_magmom))
       endif
    end if

    weiwsc_noncl = 0.0d0
    n_ldos_allocated = maldos

  end subroutine alloc_weiwsc_noncl
! =============================================================== 11.0

  subroutine dealloc_weiwsc()
    deallocate(weiwsc)
  end subroutine dealloc_weiwsc

! ================================== added by K. Tagami ========== 11.0
  subroutine dealloc_weiwsc_noncl()
    deallocate(weiwsc_noncl)
  end subroutine dealloc_weiwsc_noncl
! =============================================================== 11.0

  subroutine alloc_weilay(n_ldos_allocated)
    integer, intent(out) :: n_ldos_allocated
!!$    allocate(weilay(mlayer,np_e)); weilay = 0.d0
    n_ldos_allocated = 0
    if(ekmode == ON) then
       allocate(weilay(mlayer,neg,1)); weilay = 0.d0
    else if(ekmode == OFF) then
       if(hardpart_subroutine==2.or.sw_rspace_ldos==ON)then
          allocate(weilay(mlayer,np_e,ista_k:iend_k)); weilay = 0.d0
       else
          allocate(weilay(mlayer,neg,kv3)); weilay = 0.d0
       endif
    end if
    n_ldos_allocated = mlayer
  end subroutine alloc_weilay

! ============================ added by K. Tagami ================= 11.0
  subroutine alloc_weilay_noncl(n_ldos_allocated)
    integer, intent(out) :: n_ldos_allocated

    n_ldos_allocated = 0
    if(ekmode == ON) then
       allocate(weilay_noncl(mlayer,neg,1,ndim_magmom))
    else if(ekmode == OFF) then
       if(hardpart_subroutine==2.or.sw_rspace_ldos==ON)then
          allocate(weilay_noncl(mlayer,np_e,ista_k:iend_k,ndim_magmom))
       else
          allocate(weilay_noncl(mlayer,neg,kv3,ndim_magmom))
       endif
    end if
    weilay_noncl = 0.d0
    n_ldos_allocated = mlayer
  end subroutine alloc_weilay_noncl
! =============================================================== 11.0

  subroutine dealloc_weilay()
    deallocate(weilay)
  end subroutine dealloc_weilay

! ============================== added by K. Tagami ========== 11.0
  subroutine dealloc_weilay_noncl()
    deallocate(weilay_noncl)
  end subroutine dealloc_weilay_noncl
! ============================================================= 11.0

  subroutine m_Ldos_wd_natm2_and_totch()
    if(mype == 0 .and. ipridos>=0 ) then
       write(nfldos,'(" natm2 = ",i8)') naldos ! natm2
       write(nfldos,'(" totch = ",f20.8)') totch
    end if
  end subroutine m_Ldos_wd_natm2_and_totch

  subroutine m_Ldos_cal()
    integer,allocatable,dimension(:,:) :: meshwk
    integer :: ik,is,ip, ib,j,i
    integer :: ekmode_t

    real(kind=DP) :: denom, chgq0
    real(kind=DP), allocatable, dimension(:) :: zrhoik ! d(kg*kimg)
    real(kind=DP), allocatable, dimension(:) :: bfft   ! d(nfft)

    real(kind=DP), allocatable, dimension(:,:,:) :: wsctmp,laytmp
    integer :: ibsize, lsize
    real(kind=DP), allocatable, dimension(:,:) :: wk_bfft_l
    integer, allocatable, dimension(:) :: mapg2lx, mapg2ly
    if(sw_layerdos == ON) allocate(zrhoik(kg*kimg))

    ibsize = 1

#ifdef FFT_3D_DIVISION
    lsize = fft_X_x_nel*fft_X_y_nel*fft_X_z_nel
#else
    lsize = max(maxval(nel_fft_x(:)),maxval(nel_fft_y(:)),maxval(nel_fft_z(:)))
#endif
    allocate(mapg2ly(nfft))
    mapg2ly = 0
    allocate(mapg2lx(nfft))
    mapg2lx = 0
    call make_map()
    denom = 1.d0/product(fft_box_size_WF(1:3,1))

    call m_CD_keep_retrieve_hsr(.true.)
       if(modnrm == EXECUT) call m_CD_set_ylm_enl_etc()
       if(sw_save_ldos_weight == ON) call m_Ldos_wd_natm2_and_totch()

! ==================================== added by K. Tagami ============= 11.0
       if ( sw_aldos == ON ) weiwsc = 0.d0
       if ( sw_layerdos == ON ) weilay = 0.d0
! ===================================================================== 11.0

       do is = 1, nspin, af+1
! ========================= modiifed by K. Tagami ============= 11.0
!             weiwsc = 0.d0
!             weilay = 0.d0
! ============================================================= 11.0
             
             do ik = is, kv3+is-nspin, nspin
                if(map_k(ik) /= myrank_k) cycle
                if(ipridos >= 2) write(nfout,'(" !!ldos ik = ",i6)') ik
                call m_FFT_alloc_WF_work()
                if(sw_aldos == ON) call fillup_meshwk(mode=SOFTPART)
                
                allocate(bfft(nfft));bfft=0.d0
                allocate(wk_bfft_l(lsize*kimg,ibsize) ,stat=ierr); wk_bfft_l = 0.0d0
                if(ipridos >= 2 .and. printable) write(nfout,'(" !!ldos nfft = ",i6," <<m_Ldos_cal>>")') nfft
                if(ipridos >= 2 .and. printable) &
                     & call m_ES_wd_zaj_small_portion_3D(nfout,ik," -- before m_ES_WF_in_Rspace <<m_Ldos_cal>> --",46)
                do ib = 1, np_e
                   bfft = 0.d0
                   wk_bfft_l = 0.0d0
#ifdef __TIMER_COMM__
                    call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l,0)
#else
                    call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l)
#endif
                   if(sw_aldos == ON) call substitute_weiwsc(ik,ib,.true.)
                   if(sw_layerdos == ON) call substitute_weilay(ik,ib,.true.)
                end do
                deallocate(bfft)
                deallocate(wk_bfft_l)
                call m_FFT_dealloc_WF_work()
             enddo
             do ik=is,kv3+is-nspin,nspin
                call check_sum(ik,"softpart",.false.)
             enddo
                if(sw_aldos==ON)then
                   allocate(wsctmp(maldos,neg,kv3));wsctmp=0.d0
                   do ik = is, kv3+is-nspin, nspin
                      if(map_k(ik) /= myrank_k) cycle
                      do ib = 1, np_e
                         wsctmp(:,neg_g(ib),ik) = weiwsc(:,ib,ik)
                      end do
                   end do
                   call mpi_allreduce( MPI_IN_PLACE, wsctmp, kv3*maldos*neg, &
                        &              mpi_double_precision, &
                        &              mpi_sum,mpi_kg_world,ierr )
                   call mpi_allreduce( MPI_IN_PLACE, wsctmp, kv3*maldos*neg, &
                        &              mpi_double_precision, &
                        &              mpi_sum,mpi_ge_world,ierr )
! ============================== modified by K. Tagami =============== 11.0
!                   weiwsc = wsctmp

                   Do ik=is, kv3+is-nspin,nspin
                      weiwsc(:,:,ik) = wsctmp(:,:,ik)
                   End do
! ==================================================================== 11.0
                   deallocate(wsctmp)
                endif
                if(sw_layerdos == ON)then
                   allocate(laytmp(mlayer,neg,kv3));laytmp=0.d0
                   do ik = is, kv3+is-nspin, nspin
                      if(map_k(ik) /= myrank_k) cycle
                      do ib = 1, np_e
                         laytmp(:,neg_g(ib),ik) = weilay(:,ib,ik)
                      end do
                   end do
                   call mpi_allreduce( MPI_IN_PLACE, laytmp, kv3*mlayer*neg, &
                        &              mpi_double_precision, &
                        &              mpi_sum,mpi_kg_world,ierr )
                   call mpi_allreduce( MPI_IN_PLACE, laytmp, kv3*mlayer*neg, &
                        &              mpi_double_precision, &
                        &              mpi_sum,mpi_ge_world,ierr )
! ============================== modified by K. Tagami =============== 11.0
!                   weilay = laytmp

                   Do ik=is, kv3+is-nspin,nspin
                      weilay(:,:,ik) = laytmp(:,:,ik)
                   End do
! ==================================================================== 11.0
                   deallocate(laytmp)
                endif
             
             if(modnrm == EXECUT) then
                allocate(bfft(nfftp_nonpara))
                do ik = is, kv3+is-nspin, nspin
                   call m_FFT_alloc_CD_box()
                   if(sw_aldos == ON) call fillup_meshwk(mode=HARDPART) 
                   do ib = 1,neg
                      if(ipridos>=2) write(nfout,'(" !ldos   ib = ", i5)') ib
                      call m_CD_hardpart_sub(nfout,is,ik,ib,chgq0)  ! -> chgq_enl
                      call m_CD_map_valence_charge_to_fft_box(is,nfftp_nonpara,bfft)
                      call m_FFT_CD_inverse0(nfout,bfft) ! bfft(G_sp.) -> bfft(R_sp.)
                      if(sw_aldos == ON) call substitute_weiwsc_cd(ik,ib,.true.)
                      if(sw_layerdos == ON) call substitute_weilay_cd(ik,ib,chgq0,.true.)
                   end do
                   if(sw_aldos == ON) deallocate(meshwk)
                   call m_FFT_dealloc_CD_box()
                   call check_sum(ik,"total   ",.true.)
                enddo
                deallocate(bfft)
             endif

       enddo

       if(npes > 1) call mpi_barrier(mpi_comm_group,ierr)
       if(sw_save_ldos_weight == ON) then
          if(hardpart_subroutine==2.or.sw_rspace_ldos==ON)then
          if(sw_aldos == ON) call wd_weight(ALDOS)
          if(sw_layerdos == ON) call wd_weight(LAYERDOS)
          else
          if(sw_aldos == ON) call wd_weight_serial(ALDOS)
          if(sw_layerdos == ON) call wd_weight_serial(LAYERDOS)
          endif
       end if


    call m_CD_keep_retrieve_hsr(.false.)

    deallocate(mapg2ly)
    deallocate(mapg2lx)
    if(modnrm == EXECUT) call m_CD_dealloc_ylm_enl_etc()
    if(hardpart_subroutine/=2.and.sw_rspace_ldos==OFF) call m_CD_restore_chgq()
    if(allocated(meshwk)) deallocate(meshwk)

    if(sw_layerdos == ON) deallocate(zrhoik)
  contains
    subroutine make_map()
      use m_FFT, only : xyz_fft_y, xyz_fft_x
      integer :: id1, id2, nl, nm, nn, index_l, index_g
      integer :: i, j, k, ri, i_, j_, k_

      id1 = fft_box_size_WF(1,0)
      id2 = fft_box_size_WF(2,0)

      nl = xyz_fft_y(2,1) - xyz_fft_y(1,1) + 1
      nm = xyz_fft_y(2,2) - xyz_fft_y(1,2) + 1
      nn = xyz_fft_y(2,3) - xyz_fft_y(1,3) + 1

      if(kimg == 1) then
         do k = xyz_fft_y(1,3), xyz_fft_y(2,3)
            do j = xyz_fft_y(1,2), xyz_fft_y(2,2)
               do i = xyz_fft_y(1,1), xyz_fft_y(2,1), 2
                  do ri = 0, 1
                     i_ = i - xyz_fft_y(1,1) + 1
                     j_ = j - xyz_fft_y(1,2) + 1
                     k_ = k - xyz_fft_y(1,3) + 1
                     index_g = id1*id2*(k-1)+id1*(j-1)+i+ri
                     index_l = nl*nm*(k_-1)+2*nm*((i_-1)/2)+2*(j_-1)+1+ri
                     mapg2ly(index_g) = index_l
                  end do
               end do
            end do
         end do
      else
         do k = xyz_fft_y(1,3), xyz_fft_y(2,3)
            do j = xyz_fft_y(1,2), xyz_fft_y(2,2)
               do i = xyz_fft_y(1,1), xyz_fft_y(2,1)
                  do ri = 0, 1
                     i_ = i - xyz_fft_y(1,1) + 1
                     j_ = j - xyz_fft_y(1,2) + 1
                     k_ = k - xyz_fft_y(1,3) + 1
                     index_g = id1*id2*2*(k-1)+id1*2*(j-1)+2*(i-1)+ri+1
                     index_l = nl*nm*2*(k_-1)+nm*2*(i_-1)+2*(j_-1)+ri+1
                     mapg2ly(index_g) = index_l
                  end do
               end do
            end do
         end do
      end if

      nl = xyz_fft_x(2,1) - xyz_fft_x(1,1) + 1
      nm = xyz_fft_x(2,2) - xyz_fft_x(1,2) + 1
      nn = xyz_fft_x(2,3) - xyz_fft_x(1,3) + 1

      if(kimg == 1) then
         do k = xyz_fft_x(1,3), xyz_fft_x(2,3)
            do j = xyz_fft_x(1,2), xyz_fft_x(2,2)
               do i = xyz_fft_x(1,1), xyz_fft_x(2,1)
                  i_ = i - xyz_fft_x(1,1) + 1
                  j_ = j - xyz_fft_x(1,2) + 1
                  k_ = k - xyz_fft_x(1,3) + 1
                  index_g = id1*id2*(k-1)+id1*(j-1)+i
                  index_l = nl*nm*(k_-1)+nl*(j_-1)+i_
                  mapg2lx(index_g) = index_l
               end do
            end do
         end do
      else
         do k = xyz_fft_x(1,3), xyz_fft_x(2,3)
            do j = xyz_fft_x(1,2), xyz_fft_x(2,2)
               do i = xyz_fft_x(1,1), xyz_fft_x(2,1)
                  do ri = 0, 1
                     i_ = i - xyz_fft_x(1,1) + 1
                     j_ = j - xyz_fft_x(1,2) + 1
                     k_ = k - xyz_fft_x(1,3) + 1
                     index_g = id1*id2*2*(k-1)+id1*2*(j-1)+2*(i-1)+ri+1
                     index_l = nl*nm*2*(k_-1)+nl*2*(j_-1)+2*(i_-1)+ri+1
                     mapg2lx(index_g) = index_l
                  end do
               end do
            end do
         end do
      end if
    end subroutine make_map
    subroutine wd_weight(mode)
      integer, intent(in) :: mode
      integer :: m, ik, ib, ib_ordr, kend, kstep, iws, ip
      real(kind=DP),allocatable,dimension(:):: wei

      if(mode==ALDOS) then
         m = maldos
      else if(mode==LAYERDOS) then
         m = mlayer
      end if

      allocate(wei(m))

      if(ekmode==OFF) then
         kend = kv3; kstep = af+1
      else if(ekmode==ON) then
         kend = 1;   kstep = 1
      end if

      if(ipridos >= 3) then
         do ik = 1, kv3, af+1
            if(map_k(ik) /= myrank_k) cycle
            write(nfout,'(" !ldos: ik = ",i8)') ik
            do ib = 1, neg
               write(nfout,'(" !ldos: ib, ib_ordr = ",2i20)') ib, neordr(ib,ik)
            end do
         end do
      end if

      do ik = 1, kend, kstep
         if(mype == 0) then
            if(mode==ALDOS) then
               write(nfldos,'(" weight for each atomic cell    nk = ",i8)') ik
            else if(mode==LAYERDOS) then
               write(nfldos,'(" weight for each layer          nk = ",i8)') ik
            end if
         end if

         do ib = 1, neg

            if(nrank_k >= 2) then
               if(map_ek(ib,ik) == mype) ib_ordr = neordr(ib,ik)
               call mpi_bcast(ib_ordr,1,mpi_integer,map_ek(ib,ik),mpi_comm_group,ierr)
            else
               ib_ordr = neordr(ib,ik)
            end if

            if(map_ek(ib_ordr,ik) == mype) then
               if(mode == ALDOS) then
                  wei(1:m) = weiwsc(1:m,map_z(ib_ordr),ik)
               else if(mode == LAYERDOS) then
                  wei(1:m) = weilay(1:m,map_z(ib_ordr),ik)
               end if
               if(map_ek(ib_ordr,ik) /= 0) &
                  call mpi_send(wei,m,mpi_double_precision,0,1,mpi_comm_group,ierr)
             else if(mype == 0 .and. map_ek(ib_ordr,ik) /= 0) then
                call mpi_recv(wei,m,mpi_double_precision,map_ek(ib_ordr,ik),1,mpi_comm_group,istatus,ierr)
             end if
             if(mype == 0)  then
               if(ilen >= m) then
                  write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws),iws=1,m)
               else
                  write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws),iws=1,ilen)
                  write(nfldos,'(5x,5f15.10)') (wei(iws),iws=ilen+1,m)
               end if
             end if
          end do
       end do

       deallocate(wei)
     end subroutine wd_weight

    subroutine wd_weight_serial(mode)
      integer, intent(in) :: mode
      integer :: m, ik, ib, ib_ordr, kend, kstep, iws, ip
      real(kind=DP),allocatable,dimension(:):: wei

      if(mode==ALDOS) then
         m = maldos
      else if(mode==LAYERDOS) then
         m = mlayer
      end if

      allocate(wei(m))

      if(ekmode==OFF) then
         kend = kv3; kstep = af+1
      else if(ekmode==ON) then
         kend = 1;   kstep = 1
      end if

      if(ipridos >= 3) then
         do ik = 1, kv3, af+1
            if(map_k(ik) /= myrank_k) cycle
            write(nfout,'(" !ldos: ik = ",i8)') ik
            do ib = 1, neg
               write(nfout,'(" !ldos: ib, ib_ordr = ",2i20)') ib, neordr(ib,ik)
            end do
         end do
      end if

      do ik = 1, kend, kstep
         if(mype == 0) then
            if(mode==ALDOS) then
               write(nfldos,'(" weight for each atomic cell    nk = ",i8)') ik
            else if(mode==LAYERDOS) then
               write(nfldos,'(" weight for each layer          nk = ",i8)') ik
            end if
         end if

         do ib = 1, neg

             if(mode == ALDOS) then
                wei(1:m) = weiwsc(1:m,ib,ik)
             else if(mode == LAYERDOS) then
                wei(1:m) = weilay(1:m,ib,ik)
             end if
             if(mype == 0)  then
               if(ilen >= m) then
                  write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws),iws=1,m)
               else
                  write(nfldos,'(i4,")",5f15.10)') ib,(wei(iws),iws=1,ilen)
                  write(nfldos,'(5x,5f15.10)') (wei(iws),iws=ilen+1,m)
               end if
             end if
         end do
      end do

       deallocate(wei)
     end subroutine wd_weight_serial

    subroutine check_sum(ik,aword,serial)
      integer,intent(in) :: ik
      character*(*),intent(in) :: aword
      logical, intent(in) :: serial

      integer :: ib, ia, ilay, ib_ordr, ik_t
      real(kind=DP), allocatable, dimension(:) :: sum_aldos, sum_layer, sum_mpi

      if(sw_aldos == ON) allocate(sum_aldos(neg))
      if(sw_layerdos == ON) allocate(sum_layer(neg))

      if(ekmode /= ON) then
         ik_t = ik
      else if(ekmode == ON) then
         ik_t = 1
      end if
      if(sw_aldos == ON .or. sw_layerdos == ON) then
            allocate(sum_mpi(neg)); sum_mpi = 0.d0
      end if

      if(sw_aldos == ON) then
         sum_aldos = 0.d0
         if(.not.serial)then
            do ib = 1, np_e
               do ia = 1, natm2 + 1
                  sum_aldos(neg_g(ib)) = sum_aldos(neg_g(ib)) + weiwsc(ia,ib,ik_t)
               end do
            end do
         else
            do ib = 1, neg
               do ia = 1, natm2 + 1
                  sum_aldos(ib) = sum_aldos(ib) + weiwsc(ia,ib,ik_t)
               end do
            end do
         end if
         if(.not.serial)then
               sum_mpi = 0.d0
               call mpi_allreduce(sum_aldos,sum_mpi,neg,mpi_double_precision &
                    & , mpi_sum, mpi_kg_world,ierr)
               sum_aldos = sum_mpi
               call mpi_allreduce(sum_aldos,sum_mpi,neg,mpi_double_precision &
                    & , mpi_sum, mpi_ge_world,ierr)
               sum_aldos = sum_mpi
         endif
      end if

      if(sw_layerdos == ON) then
         sum_layer = 0.d0
         if(.not.serial)then
            do ib = 1, np_e
               do ilay = 1, mlayer
                  sum_layer(neg_g(ib)) = sum_layer(neg_g(ib)) + weilay(ilay,ib,ik_t)
               end do
            end do
         else
            do ib = 1, neg
               do ilay = 1, mlayer
                  sum_layer(ib) = sum_layer(ib) + weilay(ilay,ib,ik_t)
               end do
            end do
         end if
         if(.not.serial)then
               sum_mpi = 0.d0
               call mpi_allreduce(sum_layer,sum_mpi,neg,mpi_double_precision &
                    & , mpi_sum, mpi_kg_world,ierr)
               sum_layer = sum_mpi
               call mpi_allreduce(sum_layer,sum_mpi,neg,mpi_double_precision &
                    & , mpi_sum, mpi_ge_world,ierr)
               sum_layer = sum_mpi
         endif
      end if

!!$      if(mype == 0) then
      if(ipridos>=1) then
         if(sw_aldos == ON .and. sw_layerdos == ON) then
            write(nfout,'(" !!ldos ",a8," -- iban , sum(atomic, layer) --  neg = ",i6 &
                 & ," natm2 = ",i6, " ik = ",i6)') aword,neg,natm2,ik
            do ib = 1, neg
               if(serial) then
                  ib_ordr = ib
               else
                  ib_ordr = ib
               endif
               write(nfout,'(" !!ldos ", i4,2f16.8)') ib, sum_aldos(ib_ordr), sum_layer(ib_ordr)
            end do
         else if(sw_aldos == ON) then
            write(nfout,'(" !!ldos ",a8," -- iban , sum(atomic) --  neg = ",i6 &
                 & ," natm2 = ",i6," ik = ",i6)') aword,neg,natm2,ik
            do ib = 1, neg
               if(serial) then
                  ib_ordr = ib
               else
                  ib_ordr = ib
               endif
               write(nfout,'(" !!ldos ", i4,f16.8)') ib, sum_aldos(ib_ordr)
            end do
         else if(sw_layerdos == ON) then
            write(nfout,'(" !!ldos ",a8," -- iban , sum(layer ) --  neg = ",i6 &
                 & ," natm2 = ",i6," ik = ",i6)') aword,neg,natm2,ik
            do ib = 1, neg
               if(serial) then
                  ib_ordr = ib
               else
                  ib_ordr = ib
               endif
               write(nfout,'(" !!ldos ",i4,f16.8)') ib, sum_layer(ib_ordr)
            end do
         end if
      end if

      if(sw_aldos == ON) deallocate(sum_aldos)
      if(sw_layerdos == ON) deallocate(sum_layer)
      if(allocated(sum_mpi)) deallocate(sum_mpi)
!!$      if(ekmode /= ON .and. (sw_aldos == ON .or. sw_layerdos == ON) .and. npes >= 2) deallocate(sum_mpi)

    end subroutine check_sum

    subroutine substitute_weilay(ik,ib,serial)
!   *********************************
!     by T.Yamasaki
!           10th Jun 1992
!   *********************************
!     Revised by T. Yamasaki, Feb. 2004
!
      integer, intent(in) :: ik,ib
      logical, intent(in) :: serial

      integer :: i, ilay, iax1, iax2, iax3, ib_t
      real(kind=DP) :: a1,a2,width, g,ss
      complex(kind=CMPLDP) :: zi,zsum,zchg
      real(kind=DP),allocatable,dimension(:) :: zsum_layer, zsum_layer_mpi

      allocate(zsum_layer(mlayer)); zsum_layer = 0.d0

!!$      zi = cmplx(0.d0,1.d0)
      zi = cmplx(0.d0,1.d0)*PAI2

      iax1 = normal_axis_winlay
      iax2 = iax1 + 1
      if(iax2 >= 4) iax2 = iax2 - 3
      iax3 = iax2 + 1
      if(iax3 >= 4) iax3 = iax3 - 3


!!$      rl11 = rltv(iax1,iax1)
!!$      ss = 1.d0/maxhv
      ss = 3.d0 - kimg

!!$      call get_height(height)

!!$      n = fft_box_size_WF(1,0)*fft_box_size_WF(2,0)*fft_box_size_WF(3,1)
!!$      n = nfft*kimg/kimg/2
      do i = 1, lsize*kimg/2
         wk_bfft_l(2*i-1,1) = wk_bfft_l(2*i-1,1)**2 + wk_bfft_l(2*i,1)**2
         wk_bfft_l(2*i,  1) = 0.d0
      end do
      if(sw_fft_xzy>0)then
      call m_FFT_Direct_3D(nfout,wk_bfft_l,lsize,ibsize)
      else
      call m_FFT_Direct_XYZ_3D(nfout,wk_bfft_l,lsize,ibsize)
      endif
      bfft = 0.0d0
      if(kimg == 1) then
         do i = 1, nfft
            if(map_fft_x(i)-1 == myrank_g) then
               bfft(i) = wk_bfft_l(mapg2lx(i),1)
            end if
         end do
      else
         do i = 1, nfft/2
            if(map_fft_x(i)-1 == myrank_g) then
               bfft(2*i-1) = wk_bfft_l(mapg2lx(2*i-1),1)
               bfft(2*i  ) = wk_bfft_l(mapg2lx(2*i  ),1)
            end if
         end do
      end if
      call mpi_allreduce(MPI_IN_PLACE,bfft,nfft,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
      if(kimg == 1) then
         do i = 1, kg
            zrhoik(i) = bfft(igf(i))*denom
         end do
      else
         do i = 1, kg
            zrhoik(i*2-1) = bfft(igf(i)*2-1)*denom
            zrhoik(i*2  ) = bfft(igf(i)*2  )*denom
         end do
      end if

      do ilay = 1, mlayer
!!$         a2 = winlay(ilay,2)
!!$         a1 = winlay(ilay,1)
         a2 = winlay(ilay,2)/height
         a1 = winlay(ilay,1)/height
         width = a2 - a1
         zsum = cmplx(zrhoik(1)*width,0.d0)
!!$         zsum = univol*cmplx(zrhoik(1)*width,0.d0)
         if(kimg == 1) then
            do i = 2, kg
               if(ngabc(i,iax2) == 0 .and. ngabc(i,iax3) == 0) then
!!$                  g = rl11*ngabc(i,iax1)
                  g = ngabc(i,iax1)
                  zsum = zsum  &
                       & + zrhoik(i)*((cdexp(zi*g*a2)-cdexp(zi*g*a1))/( zi*g ))
               end if
            end do
         else if(kimg == 2) then
            do i = 2, kg
               if(ngabc(i,iax2) ==  0 .and. ngabc(i,iax3) == 0) then
!!$                  g = rl11*ngabc(i,iax1)
                  g = ngabc(i,iax1)
                  zchg = dcmplx(zrhoik(i*2-1),zrhoik(i*2))
                  zsum = zsum  &
                       & + zchg*((cdexp(zi*g*a2)-cdexp(zi*g*a1))/( zi*g ))
               endif
            enddo
         endif
         zsum_layer(ilay) = real(zsum)*ss
      end do

      if(ekmode == ON.or.serial) then
         ib_t = ib
      else
         ib_t = map_z(ib)
      end if

      do ilay = 1, mlayer
         weilay(ilay,ib_t,ik) = zsum_layer(ilay)
      end do

      deallocate(zsum_layer)
      
    end subroutine substitute_weilay

    subroutine substitute_weiwsc(ik,ib,serial)
      integer, intent(in) :: ik,ib
      logical, intent(in) :: serial
!   *********************************
!     by T.Yamasaki
!           10th Jun 1992
!   *********************************
!     Revised by T. Yamasaki, Feb. 2004
!
      integer :: ijk, nwsc,n, nel, ib_t
      real(kind=DP) :: xx, denom
      integer :: i

      nel = product(fft_box_size_WF(1:3,1))
      denom = 1.d0/dble(nel)
      if(ipridos >= 2) write(nfout,'(" !!ldos: ib, nfft, natm2 = ",i6,i12,i6,"  <<substitute_weiwsc>>")') ib, nfft, natm2

      if(ekmode == ON.or.serial) then
         ib_t = ib
      else if(ekmode == OFF) then
         ib_t = ib
      end if
      bfft = 0.0d0
      if(kimg == 1) then
         do i = 1, nfft
            if(map_fft_y(i)-1 == myrank_g) then
               bfft(i) = wk_bfft_l(mapg2ly(i),1)
            end if
         end do
      else
         do i = 1, nfft/2
            if(map_fft_y(i)-1 == myrank_g) then
               bfft(2*i-1) = wk_bfft_l(mapg2ly(2*i-1),1)
               bfft(2*i  ) = wk_bfft_l(mapg2ly(2*i  ),1)
            end if
         end do
      end if
      call mpi_allreduce(MPI_IN_PLACE,bfft,nfft,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
         
      do ijk = 1, nel
         nwsc = meshwk(ijk,1)
         n    = meshwk(ijk,2)
         if((n < 1 .or. 2*n > nfft) .or. (nwsc < 1 .or. nwsc >natm2+1) ) then
            if(ipridos>=1) then
               write(nfout,'(" !!ldos: n = ",i6," ijk = ",i6)') n, ijk
               write(nfout,'(" !!ldos: nwsc = ",i9)') nwsc
            end if
         else
            xx = denom*(bfft(2*n-1)**2 + bfft(2*n)**2)
            weiwsc(nwsc,ib_t,ik) = weiwsc(nwsc,ib_t,ik) + xx
         end if
      end do

      if(ipridos >= 2) then
         write(nfout,'(" !ldos: ik, ib = ",2i8," <<substitute_weiwsc>>")') ik, ib
         write(nfout,'(" !ldos: ",8f10.5)') (weiwsc(nwsc,ib_t,ik),nwsc=1,maldos)
      end if

    end subroutine substitute_weiwsc

    subroutine substitute_weiwsc_cd(ik,ib,serial)
      integer, intent(in) :: ik,ib
      logical, intent(in) :: serial
!   *********************************
!     by T.Yamasaki
!           10th Jun 1992
!   *********************************
!     Revised by T. Yamasaki, Feb. 2004
!
      integer :: ijk, nwsc,n, ib_t
      real(kind=DP) :: denom

      denom = 0.5d0*univol/product(fft_box_size_CD(1:3,1))

      if(ekmode == ON.or.serial) then
         ib_t = ib
      else if(ekmode == OFF) then
         ib_t = map_z(ib)
      end if

      do ijk = 1, product(fft_box_size_CD(1:3,1))
         nwsc = meshwk(ijk,1)
         n    = meshwk(ijk,2)
         if((n < 1 .or. 2*n > nfftp_nonpara) .or. (nwsc < 1 .or. nwsc >natm2+1) ) then
            if(ipridos>=1) then
               write(nfout,'(" !!ldos: n = ",i6," ijk = ",i6)') n, ijk
               write(nfout,'(" !!ldos: nwsc = ",i9)') nwsc
            end if
         else
            weiwsc(nwsc,ib_t,ik) = weiwsc(nwsc,ib_t,ik) + denom*bfft(2*n-1)
! =============================== modified by K. Tagami ============ 11.0
!            weiwsc(nwsc,ib_t,ik) = weiwsc(nwsc,ib_t,ik) + denom*bfft(2*n-1)
!
!            if (map_ek(ib,ik) == mype) then
!               weiwsc(nwsc,ib_t,ik) = weiwsc(nwsc,ib_t,ik) + denom*bfft(2*n-1)
!            endif
! ================================================================== 11.0
         end if
      end do

      if(ipridos >=2) then
         write(nfout,'(" !ldos: ik ,ib = ",2i8)') ik, ib
         write(nfout,'(" !ldos: ",8f10.5)') (weiwsc(nwsc,ib_t,ik),nwsc=1,maldos)
      end if

    end subroutine substitute_weiwsc_cd

    subroutine substitute_weilay_cd(ik,ib,chgq0,serial)
      integer, intent(in) :: ik, ib
      real(kind=DP), intent(in) :: chgq0
      logical, intent(in) :: serial
!   *********************************
!     by T.Yamasaki
!           10th Jun 1992
!   *********************************
!     Revised by T. Yamasaki, Feb. 2004
!
      integer :: i, ista, iax1, iax2, iax3, ilay,  ib_t
      real(kind=DP) :: g, z_work, ss, a1, a2, width
      complex(kind=CMPLDP) :: zi,zsum,zchg
      real(kind=DP),allocatable,dimension(:,:) :: zsum_layer, zsum_layer_mpi

      allocate(zsum_layer(mlayer,2)); zsum_layer = 0.d0

      zi = cmplx(0.d0,1.d0)*PAI2

      iax1 = normal_axis_winlay
      iax2 = iax1 + 1
      if(iax2 >= 4) iax2 = iax2 - 3
      iax3 = iax2 + 1
      if(iax3 >= 4) iax3 = iax3 - 3

!!$      rl11 = rltv(iax1,iax1)
!!$      ss = 0.5d0*univol/maxhv
      ss = 0.5d0*univol*(3.d0-kimg)


      ista = ista_kngp
      if(ista == 1) ista = 2
      do ilay = 1, mlayer
         if(ipridos >= 2) write(nfout,'(" !!ldos: ib = ",i6," ilay = ",i6 &
              & ," <<substitute_weilay_cd>>")') ib,ilay
         a2 = winlay(ilay,2)/height
         a1 = winlay(ilay,1)/height
         width = a2 - a1
         z_work = chgq0*width
         if(serial)then
            if(ista/=2) z_work=0.d0
         endif
         zsum = 0.d0

         if(kimg == 1) then
            if(ekmode == ON.or.serial) then
               do i = ista, iend_kngp
                  if(ngabc_kngp_l(i,iax2) == 0 .and. ngabc_kngp_l(i,iax3) == 0) then
                     g = ngabc_kngp_l(i,iax1)
                     zsum = zsum  &
                          & + chgq_l(i,1,1)*( ( cdexp(zi*g*a2) - cdexp(zi*g*a1))/(zi*g))
                  end if
               end do
            else if(ekmode == OFF) then
               do i = 2, kgp
                  if(ngabc_kngp_l(i,iax2) == 0 .and. ngabc_kngp_l(i,iax3) == 0) then
                     g = ngabc_kngp_l(i,iax1)
                     zsum = zsum  &
                          & + chgq_enl(i,1)*( ( cdexp(zi*g*a2) - cdexp(zi*g*a1))/(zi*g))
                  end if
               end do
            end if
         else if(kimg == 2) then
            if(ekmode == ON.or.serial) then
               do i = ista, iend_kngp
                  if(ngabc_kngp_l(i,iax2) == 0 .and. ngabc_kngp_l(i,iax3) == 0) then
                     g = ngabc_kngp_l(i,iax1)
                     zchg = cmplx(chgq_l(i,1,1),chgq_l(i,2,1))
                     zsum = zsum &
                          & + zchg * ((cdexp(zi*g*a2) - cdexp(zi*g*a1))/(zi*g))
                  end if
               end do
            else if(ekmode == OFF) then
               do i = 2, kgp
                  if(ngabc_kngp_l(i,iax2) == 0 .and. ngabc_kngp_l(i,iax3) == 0) then
                     g = ngabc_kngp_l(i,iax1)
                     zchg = cmplx(chgq_enl(i,1),chgq_enl(i,2))
                     zsum = zsum &
                          & + zchg * ((cdexp(zi*g*a2) - cdexp(zi*g*a1))/(zi*g))
                  end if
               end do
            end if
         end if
         zsum = zsum + cmplx(z_work,0.d0)

         zsum_layer(ilay,1) = real(zsum)
         zsum_layer(ilay,2) = dimag(zsum)
         
      end do
      if(ekmode == ON.or.serial) then
         if(npes > 1) then
            allocate(zsum_layer_mpi(mlayer,2))
            call mpi_allreduce(zsum_layer,zsum_layer_mpi,mlayer*2 &
                 & ,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
            zsum_layer = zsum_layer_mpi
            deallocate(zsum_layer_mpi)
         end if
      end if

      if(mype == 0) then
         do ilay = 1, mlayer
            if(zsum_layer(ilay,2) > 1.d-6) then
               write(6,'(" !!ldos: zsum,ne.real imag = ",d16.8," ilay = ",i6)') &
                    & zsum_layer(ilay,2), ilay
            endif
!!$            write(6,'(" !!ldos zsum_layer = ",d16.8," ilay = ",i6)') &
!!$                 & zsum_layer(ilay,1), ilay
         end do
      end if

      if(ekmode == ON.or.serial) then
         ib_t = ib
      else
         ib_t = map_z(ib)
      end if

      do ilay = 1, mlayer
         weilay(ilay,ib_t,ik) = weilay(ilay,ib_t,ik) + zsum_layer(ilay,1)*ss
      end do
! ========================= modified by K. Tagami =============== 11.0
!      do ilay = 1, mlayer
!         weilay(ilay,ib_t,ik) = weilay(ilay,ib_t,ik) + zsum_layer(ilay,1)*ss
!      end do
!
!      if (map_ek(ib,ik) == mype) then
!         do ilay = 1, mlayer
!            weilay(ilay,ib_t,ik) = weilay(ilay,ib_t,ik) + zsum_layer(ilay,1)*ss
!         end do
!      endif
! ============================================================== 11.0

      deallocate(zsum_layer)

    end subroutine substitute_weilay_cd

    subroutine fillup_meshwk(mode)
!   *********************************
!     by T.Yamasaki
!           10th Jun 1992
!   *********************************
!     Revised by T. Yamasaki, Feb. 2004
!
      integer, intent(in) :: mode
!!$ASASASASAS
!!$      integer, pointer, dimension(:,:,:) :: mesh_t
      integer, allocatable :: mesh_t(:,:,:)
!!$ASASASASAS
      integer :: i,j,k, icount, nwsc, max_nwsc, min_nwsc, n, nl, nm,nn, nd2,id, nfftwk &
           &    , inew, jnew, knew, idr2, idh

      if(mode == SOFTPART) then

         nl = fft_box_size_WF(1,1)
         nm = fft_box_size_WF(2,1)
         nn = fft_box_size_WF(3,1)

         id  = fft_box_size_WF(1,0)
         nd2 = fft_box_size_WF(2,0)
         allocate(mesh_t(id,nd2,nn))
         mesh_t = mesh

         nfftwk = product(fft_box_size_WF(1:3,1))
      else if(mode == HARDPART) then

         nl = fft_box_size_CD(1,1)
         nm = fft_box_size_CD(2,1)
         nn = fft_box_size_CD(3,1)

         id  = fft_box_size_CD_nonpara(1,0)
         nd2 = fft_box_size_CD_nonpara(2,0)
         allocate(mesh_t(id,nd2,nn))
         mesh_t = meshp
         nfftwk = product(fft_box_size_CD(1:3,1))
      end if
      idr2 = (nl+2)/2
      idh  = id/2

      if(allocated(meshwk)) deallocate(meshwk)
      allocate(meshwk(nfftwk,2)); meshwk = 0

      if(ipridos>=1) write(nfout,'(" !! nfftwk = ",i8)') nfftwk

      max_nwsc = 0
      min_nwsc = natm2+2
      icount = 1
      do k = 1, nn
         do j = 1, nm
            do i = 1, nl
!!$               if(icount > nfftwk) then
!!$                  write(nfout,'(" ! icount = ",i7," > nfftwk")') icount
!!$                  stop  ' large icount <<fillup_meshwk.m_Ldos_cal>>'
!!$               end if
               nwsc = mesh_t(i,j,k)
               if(nwsc > max_nwsc) max_nwsc = nwsc
               if(nwsc < min_nwsc) min_nwsc = nwsc
               meshwk(icount,1) = nwsc
               if(kimg == 1) then
                  if( i <= idr2 ) then
                     n = idh*nd2*(k-1) + idr2*(j-1) + i
                  else
                     inew = nl + 2 - i
                     jnew = nm + 2 - j
                     knew = nn + 2 - k
                     if(jnew > nm) jnew = jnew - nm
                     if(knew > nn) knew = knew - nn
                     n = idh*nd2*(knew-1) + idh*(jnew-1) + inew
                  end if
               else
                  n = id*nd2*(k-1) + id*(j-1) + i
               end if
               meshwk(icount,2) = n
               icount = icount + 1
            end do
         end do
      end do
      if(ipridos>=1) then
         write(nfout,*) ' !!ldos:  max_nwsc =  ', max_nwsc
         write(nfout,*) ' !!ldos:  min_nwsc =  ', min_nwsc
#ifdef DEBUG_MESH
         n = 1000
         if(n*2 > nfftwk) n = nfftwk/2
         write(nfout,'(" !ldos nfftwk = ",i8)') nfftwk
         write(nfout,'(" !ldos: meshwk(*,1) first ",i8," elements")') n
         write(nfout,'(14i5)') (meshwk(i,1),i=1,n)
         write(nfout,'(" !ldos: meshwk(*,1) last  ",i8," elements")') n
         write(nfout,'(14i6)') (meshwk(i,1),i=nfftwk-n+1, nfftwk)

         write(nfout,'(" !ldos: meshwk(*,2) first ",i8," elements")') n
         write(nfout,'(14i5)') (meshwk(i,2),i=1,n)
         write(nfout,'(" !ldos: meshwk(*,2) last  ",i8," elements")') n
         write(nfout,'(14i6)') (meshwk(i,2),i=nfftwk-n+1, nfftwk)
#endif
      end if
      deallocate(mesh_t)
    end subroutine fillup_meshwk

  end subroutine m_Ldos_cal


  subroutine m_Ldos_get_ldos_index(ip,aldos_or_layerdos,ipdos)
    integer, intent(in) ::  ip
    integer, intent(out) :: aldos_or_layerdos, ipdos
    integer :: i, na

    aldos_or_layerdos = NO
    ipdos = 0
    if(sw_aldos == ON) then
!!$       if(1 <= ip .and. ip <= maldos ) then
       if(1 <= ip .and. ip <= naldos_write ) then
          aldos_or_layerdos = ALDOS
!!$          ipdos = naldos_from + ip - 1
          na = 0
          do i = naldos_from, naldos_to
             if(if_aldos_full(i) == ON) na = na + 1
             if(na == ip) then
                ipdos = i
                exit
             end if
          end do
!!$          ipdos = naldos_from - 1 + na

          if(ipdos > maldos .or. ipdos < 1 ) then
             write(nfout,'(" !! ipdos ( = ",i8," ) is illegal << m_Ldos_get_ldos_index>>")') ipdos
             stop ' ipdos is illegal << m_Ldos_get_ldos_index>>'
          end if
!!$       else if( ip > maldos ) then
       else if( ip > naldos_write ) then
          if(sw_layerdos == ON) then
             aldos_or_layerdos = LAYERDOS
!!$             ipdos = ip - maldos
             ipdos = ip - naldos_write
          end if
       end if
    else if(sw_layerdos == ON) then
       if( 1 <= ip .and. ip <= mlayer) then
          aldos_or_layerdos = LAYERDOS
          ipdos = ip
       end if
    end if

  end subroutine m_Ldos_get_ldos_index

  subroutine m_Ldos_get_dos_weight(aldos_or_layerdos,ip,nfldos,ne,nk,dos_weight)
    integer, intent(in) :: aldos_or_layerdos, ip, nfldos
    integer, intent(in) :: ne, nk
    real(kind=DP), intent(out), dimension(ne,nk) :: dos_weight

    real(kind=DP), allocatable, dimension(:,:) :: dos_weight_mpi

    integer :: i, j
    real(kind=DP) :: w
    logical :: serial
    serial = .false.
    if(hardpart_subroutine/=2.and.sw_rspace_ldos==OFF) serial=.true.

    if(ne < neg) then
       if(ipridos>=1) write(nfout,'(" !ldos: ne (= ",i6," ) < neg (= ",i6 &
            & ," ) <<m_Ldos_get_dos_weight>>")') ne, neg
       stop ' ne < neg <<m_Ldos_get_dos_weight>>'
    end if

    if(ekmode == OFF) then
       if(nk < kv3_ek) then
          if(ipridos>=1) write(nfout,'(" !ldos: nk (= ",i6," ) < kv3_ek (= ",i6 &
               & ," ) <<m_Ldos_get_dos_weight>>")') nk, kv3_ek
          stop ' nk < kv3_ek <<m_Ldos_get_dos_weight>>'
       end if

!       if(ne <= iend_e .and. nk <= iend_k) then
        if(ne <= neg .and. nk <= kv3) then
          dos_weight = 0.d0
          if(aldos_or_layerdos == ALDOS) then
             if(.not.serial)then
               do j = ista_k, iend_k
                  do i = ista_e, iend_e, istep_e
                     dos_weight(i,j) = weiwsc(ip,map_z(i),j)
                  end do
               end do
             else
               do j = 1,kv3
                  do i = 1,neg
                     dos_weight(i,j) = weiwsc(ip,i,j)
                  end do
               end do
             endif
          else if(aldos_or_layerdos == LAYERDOS) then
             if(.not.serial)then
               do j = ista_k, iend_k
                  do i = ista_e, iend_e, istep_e
                     dos_weight(i,j) = weilay(ip,map_z(i),j)
                  end do
               end do
             else
               do j = 1, kv3
                  do i = 1,neg
                     dos_weight(i,j) = weilay(ip,i,j)
                  end do
               end do
             endif
          end if
          if(npes > 1.and..not.serial) then
            allocate(dos_weight_mpi(ne,nk))
            call mpi_allreduce(dos_weight, dos_weight_mpi,ne*nk &
                 & ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
            dos_weight = dos_weight_mpi
            deallocate(dos_weight_mpi)
          end if
        end if
    else if(ekmode == ON) then
       if(nk < kv3) then
          if(ipridos>=1) write(nfout,'(" !ldos: nk (= ",i6," ) < kv3 (= ",i6 &
               & ," ) <<m_Ldos_get_dos_weight>>")') nk, kv3_ek
          stop ' nk < kv3 <<m_Ldos_get_dos_weight>>'
       end if

       call m_Files_open_nfldos()
       call skip_headerpart()
       if(aldos_or_layerdos == ALDOS) then
          do j = 1, nk
             do i = 1, ne
                call read_aldos_weight(ip,w)
                dos_weight(i,j) = w
             end do
          end do
       else if(aldos_or_layerdos == LAYERDOS) then
          do j = 1, nk
             do i = 1, ne
                call read_layerdos_weight(ip,w)
                dos_weight(i,j) = w
             end do
          end do
       end if
       call m_Files_close_nfldos()
    end if
  contains
    subroutine skip_headerpart()
      read(nfldos,*)
    end subroutine skip_headerpart

    subroutine read_aldos_weight(ip,w)
      integer, intent(in) :: ip
      real(kind=DP), intent(out) :: w
      w = 0.d0
    end subroutine read_aldos_weight

    subroutine read_layerdos_weight(ip,w)
      integer, intent(in) :: ip
      real(kind=DP), intent(out) :: w
      w = 0.d0
    end subroutine read_layerdos_weight

  end subroutine m_Ldos_get_dos_weight

! ============================== added by K. Tagami ================== 11.0
  subroutine m_Ldos_get_dos_weight_noncl( aldos_or_layerdos, ip, nfldos, &
       &                                  ne, nk, dos_weight_noncl )
    integer, intent(in) :: aldos_or_layerdos, ip, nfldos
    integer, intent(in) :: ne, nk
    real(kind=DP), intent(out), dimension(ne,nk,ndim_magmom) :: dos_weight_noncl

    real(kind=DP), allocatable, dimension(:,:,:) :: dos_weight_mpi

    integer :: i, j
    real(kind=DP) :: w
    logical :: serial

    serial = .false.
    if(hardpart_subroutine/=2.and.sw_rspace_ldos==OFF) serial=.true.

    if(ne < neg) then
       if(ipridos>=1) write(nfout,'(" !ldos: ne (= ",i6," ) < neg (= ",i6 &
            & ," ) <<m_Ldos_get_dos_weight>>")') ne, neg
       stop ' ne < neg <<m_Ldos_get_dos_weight>>'
    end if

    if(ekmode == OFF) then
       if(nk < kv3_ek) then
          if(ipridos>=1) write(nfout,'(" !ldos: nk (= ",i6," ) < kv3_ek (= ",i6 &
               & ," ) <<m_Ldos_get_dos_weight>>")') nk, kv3_ek
          stop ' nk < kv3_ek <<m_Ldos_get_dos_weight>>'
       end if

!       if(ne <= iend_e .and. nk <= iend_k) then
        if(ne <= neg .and. nk <= kv3) then
          dos_weight_noncl = 0.d0
          if(aldos_or_layerdos == ALDOS) then
             if(.not.serial)then
               do j = ista_k, iend_k
                  do i = ista_e, iend_e, istep_e
                     dos_weight_noncl(i,j,:) = weiwsc_noncl(ip,map_z(i),j,:)
                  end do
               end do
             else
               do j = 1,kv3
                  do i = 1,neg
                     dos_weight_noncl(i,j,:) = weiwsc_noncl(ip,i,j,:)
                  end do
               end do
             endif
          else if(aldos_or_layerdos == LAYERDOS) then
             if(.not.serial)then
               do j = ista_k, iend_k
                  do i = ista_e, iend_e, istep_e
                     dos_weight_noncl(i,j,:) = weilay_noncl(ip,map_z(i),j,:)
                  end do
               end do
             else
               do j = 1, kv3
                  do i = 1,neg
                     dos_weight_noncl(i,j,:) = weilay_noncl(ip,i,j,:)
                  end do
               end do
             endif
          end if

          if(npes > 1.and..not.serial) then
            allocate(dos_weight_mpi(ne,nk,ndim_magmom))
            call mpi_allreduce( dos_weight_noncl, dos_weight_mpi, ne*nk*ndim_magmom, &
                 &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
            dos_weight_noncl = dos_weight_mpi
            deallocate(dos_weight_mpi)
          end if
        end if

    else if(ekmode == ON) then
       if(nk < kv3) then
          if(ipridos>=1) write(nfout,'(" !ldos: nk (= ",i6," ) < kv3 (= ",i6 &
               & ," ) <<m_Ldos_get_dos_weight>>")') nk, kv3_ek
          stop ' nk < kv3 <<m_Ldos_get_dos_weight>>'
       end if

       call m_Files_open_nfldos()
       call skip_headerpart()
       if(aldos_or_layerdos == ALDOS) then
          do j = 1, nk
             do i = 1, ne
                call read_aldos_weight(ip,w)
                dos_weight_noncl(i,j,:) = w
             end do
          end do
       else if(aldos_or_layerdos == LAYERDOS) then
          do j = 1, nk
             do i = 1, ne
                call read_layerdos_weight(ip,w)
                dos_weight_noncl(i,j,:) = w
             end do
          end do
       end if
       call m_Files_close_nfldos()
    end if
  contains
    subroutine skip_headerpart()
      read(nfldos,*)
    end subroutine skip_headerpart

    subroutine read_aldos_weight(ip,w)
      integer, intent(in) :: ip
      real(kind=DP), intent(out) :: w
      w = 0.d0
    end subroutine read_aldos_weight

    subroutine read_layerdos_weight(ip,w)
      integer, intent(in) :: ip
      real(kind=DP), intent(out) :: w
      w = 0.d0
    end subroutine read_layerdos_weight

  end subroutine m_Ldos_get_dos_weight_noncl
! ==================================================================== 11.0

  subroutine m_Ldos_dealloc()
     if(allocated(if_aldos_full)) deallocate(if_aldos_full)
     if(allocated(mesh)) deallocate(mesh)
     if(allocated(meshp)) deallocate(meshp)
     if(allocated(winlay)) deallocate(winlay)
  end subroutine m_Ldos_dealloc

end module m_Ldos

!#========================================================================
!#                                                                       #
!# Software Name : UVSOR ver. 3.00                                       #
!#                                                                       #
!#      Sub Routine : Transition_moment_Epsilon                          #
!#                                                                       #
!#                                Written by T. Hamada 2006/4/28         #
!#                                                                       #
!#      Contact address :  IIS,The University of Tokyo RSS21 project     #
!#                                                                       #
!#"Multiscale Simulation System for Functional Analysis of Nanomaterials"#
!#                                                                       #
!#========================================================================
!
!
! $Id: Transition_moment_Epsilon.f90 376 2014-06-17 07:48:31Z jkoga $
   subroutine Transition_moment_Epsilon
     use m_Epsilon_ek,            only : eigen_value_ordering_eps_ek &
        &                              ,calc_transition_moment_eps_ek
     call eigen_value_ordering_eps_ek
     call calc_transition_moment_eps_ek
   end subroutine Transition_moment_Epsilon

!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 481 $)
!
!  MODULE:  m_PlaneWaveBasisSet
!
!  AUTHOR(S): T. Yamasaki, M. Okamoto,   August/20/2003
!
!  FURTHER MODIFICATION: T. Yamasaki, April/15/2006
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!   Revised for the GAMMA point (k=(0,0,0)) by T. Yamasaki, April 2006.
!

#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_DO__
#   define __TIMER_DO_START(a)   call timer_sta(a)
#   define __TIMER_DO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_DO_START(a)
#   define __TIMER_DO_STOP(a)
#endif
#ifdef FJ_TIMER
#   define __TIMER_FJ_START_w_BARRIER(str,a)   call mpi_barrier(str,ierr) ;   call timer_sta(a)
#   define __TIMER_FJ_START(a)   call timer_sta(a)
#   define __TIMER_FJ_STOP(a)    call timer_end(a)
#else
#   define __TIMER_FJ_START_w_BARRIER(str,a)
#   define __TIMER_FJ_START(a)
#   define __TIMER_FJ_STOP(a)
#endif
#ifdef __TIMER_INIDO__
#   define __TIMER_INIDO_START(a)   call timer_sta(a)
#   define __TIMER_INIDO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_INIDO_START(a)
#   define __TIMER_INIDO_STOP(a)
#endif

module m_PlaneWaveBasisSet
!    ( m_pwBS )
! $Id: m_PlaneWaveBasisSet.F90 481 2016-03-25 02:51:57Z jkoga $
  use m_Crystal_Structure,  only : nopr, altv,rltv, m_CS_op_in_PUCV
  use m_Kpoints,            only : kv3,kv3_ek,vkxyz,qwgt, k_symmetry
  use m_FFT,                only : fft_box_size_WF, fft_box_size_CD, fft_box_size_pWF &
	&                        , fft_box_size_CD_c, fft_box_size_CD_nonpara
  use m_Files,              only : nfout
  use m_Timing,             only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters, only : ipri,iprifftmap,printable,gmax,gmaxp,gmaxp_reduced, gmax_positron &
       &                         , intzaj,cutoff_mix,af,neg,nel_Ylm, sw_positron &
       &                         , fixed_charge_k_parallel
  use m_Const_Parameters,   only : CARTS, BUCS, CRDTYP, OFF &
       &                         , SURFACE, WHOLE_BZ, SIMPLE_CUBIC &
       &                         , BCC,  FCC, DIAMOND, HEXAGONAL, ORTHORHOMBIC, RUTILE &
       &                         , C2v_SURFACE, Csy_SURFACE, GENERAL, GENERAL_LARGER, DP &
       &                         , by_matrix_diagon, by_random_numbers &
       &                         , PAI, PAI4,SMALL,MEDIUM,LARGE, DELTA, DELTA10, DELTA07 &
       &                         , SmallestPositiveNumber, GAMMA, GAMMA_base_symmetrization &
       &                         , ONE_BY_ONE
  use m_Parallelization,    only : is_kngp,ie_kngp,ista_k,iend_k,ista_kngp,iend_kngp &
       &                         , npes,mype,ierr, mpi_comm_group, myrank_g, nrank_g

! =================== KT_add ========================= 13.0F&13.0U2
  use m_Control_Parameters,  only : sw_hybrid_functional, gmax_exx, gmaxp_exx, use_fft_exx, &
       &                            sw_modified_TFW_functional
  use m_FFT, only : fft_box_size_exx, fft_box_size_CD_exx, fft_box_size_CD_nonpara
! ==================================================== 13.0F&13.0U2

  implicit none
  include 'mpif.h'

  integer, parameter                    :: how_give_initial_zaj = 0
  integer, public,allocatable,target,dimension(:,:)  :: ngabc  !d(kgp,3)
  integer, public,allocatable,target,dimension(:,:)  :: ngabc_kngp_l
  integer, public,allocatable,target,dimension(:,:)  :: ngabc_kngp_B_l
  real(DP),allocatable, dimension(:,:)    :: fp_l
  integer, allocatable, dimension(:,:)  :: ngpt_l !d(ista_kngp:iend_kngp,nopr+af)
  real(DP),allocatable, dimension(:)    :: gr_l   !d(ista_kngp:iend_kngp)
  integer, allocatable, dimension(:)    :: igfp_l !d(ista_kngp:iend_kngp)
  integer, allocatable, dimension(:)    :: igfp_nonpara !d(ista_kngp:iend_kngp)
#ifdef _MPIFFT_
  integer, allocatable, dimension(:)    :: igfp_l_c !d(ista_kngp:iend_kngp)
#endif  
  integer, allocatable, dimension(:)    :: igf    !d(kg)
  integer                               :: kg, kgp, kgp_reduced, kg1_ext=0, kg1=0, kgpm &
	&                                , kg0, kg_gamma = 0, kg2_gamma = 0
  integer                               :: ngshell ! depending on mype
  integer, allocatable, dimension(:,:)  :: ngshell_range ! d(ngshell,2)
  integer                               :: ngshell_GAMMA ! not depend on mype
  ! ------- Positron start
  integer ::                               kg_pwf, kg1_pwf=0
  integer, dimension(3) ::                 n_rGv_pstrn
  integer, allocatable, dimension(:) ::    igf_pstrn !d(kg_pwf)
  ! ------- Positron end

! ======= KT_add ==================================== 13.0F
  integer ::                               kg_exx, kgp_exx, kg1_exx=0,kg1p_exx=0
  integer, dimension(3) ::                 n_rGv_exx,n_rGpv_exx
  integer, allocatable, dimension(:) ::    igf_exx !d(kg_exx)
  integer, allocatable, dimension(:) ::    igfp_exx !d(kgp_exx)
! =================================================== 13.0F

! ====== KT_add ============ 13.0U2
  integer :: kg_tfw = 0
! ========================== 13.0U2

! ===== EXP_CELLOPT ==== 2015/09/24
  integer :: kg1_prev = 0
  integer :: kgp_prev = 0
! ====================== 2015/09/24

  integer, dimension(3)                 :: n_rGv
  integer, dimension(3)                 :: n_rGpv
  integer, dimension(3)                 :: n_rGpv_reduced
  ! n_rG(p)v is the size of a rhombohedron that contains
  ! a sphere whose radius is 2*Gmax (Gmaxp) .

  integer, allocatable, dimension(:,:)  :: nbase !d(kg1_ext,kv3) PW Basis Set for each k-points
  integer, allocatable, dimension(:,:)  :: nbmat ! sub PWBS for each k-points
  !                                                  d(nmatsz,ista_k:iend_k)
  integer, allocatable, dimension(:,:)  :: nbmat2! sub PWBS for each k-points
  !                                                  d(nmatsz,ista_k:iend_k)
  integer, allocatable, dimension(:)    :: iba    !d(kv3)
  integer, allocatable, dimension(:)    :: iba_ek !d(kv3_ek)
  integer, allocatable, dimension(:)    :: iba2   !d(kv3*how_give_initial_zaj)
  integer, allocatable, dimension(:,:)  :: nbase_gamma !d(kg_gamma,2)
  integer                               :: nbmx   ! maximum # of elements in PWBSs
  real(kind=DP),private                 :: gmaxs
  integer                               :: nmatsz ! subspace Hermitian matrix size
  integer                               :: nmatsz2
  integer, dimension(3)                 :: n_rGsv
  ! n_rGhv(1:3) is the size of a rhombohedron that contains a sphare whose
  ! redius is 2*Gmaxs
  integer, allocatable, dimension(:,:,:):: igpo
  !             d(-n_rGsv(1):n_rGsv(1),-n_rGsv(2):n_rGsv(2),-n_rGsv(3):n_rGsv(3))

  real(kind=DP), dimension(6) :: ttr
  real(kind=DP), allocatable,         dimension(:,:,:) :: op_br
  real(kind=DP), allocatable, target, dimension(:,:)   :: ylm_l !d(ista_kngp:iend_kngp, nel_Ylm)

!  1-1.  m_pwBS_alloc_ylm_l            <- Initilal_Electronic_Structure
!  1-2.  m_pwBS_dealloc_ylm_l          <- Initilal_Electronic_Structure
!  1-3.  m_pwBS_alloc_igpo             <- m_ES_WF_by_MatDiagon
!  1-4.  m_pwBS_dealloc_igpo           <- m_ES_WF_by_MatDiagon
!  1-5.  alloc_nbase                   <- (3)
!  1-6.  reduce_nbase                  <- (3)
!  1-7.  alloc_iba                     <- (3)
!  1-8.  G_vectors_alloc               <- (7)
!  1-9.  m_pwBS_alloc_nbmat_and_iba2   <- m_ES_WF_by_MatDiagon
!  1-10. m_pwBS_dealloc_nbmat_and_iba2 <- m_ES_WF_by_MatDiagon
!  1-11. m_pwBS_alloc_ngpt_igfp_gr     <- Preparation
!  1-12. m_pwBS_dealloc_ngpt_igfp_gr   <- Finalization
!  2.    m_pwBS_mat_for_each_WF        <- m_ES_WF_by_MatDiagon
!  3.    m_pwBS_for_each_WF            <- Preparation
!        - wd_ngshell_range
!  4.    m_pwBS_positronWF             <- Preparation
!  5.    m_pwBS_set_gmaxs              <- m_ES_WF_by_MatDiagon
!        - check_gmax
!  6.    m_pwBS_assume_G_rhombohedron  <- Preparation
!        - size_of_Gvector_rhombohedron, - check_the_size_of_rhombohedron
!        - wd_n_rGv_and_n_rGpv
!  7.    m_pwBS_generate_G_vectors     <- Preparation
!        - get_Gvectors_in_a_gmaxp_sphere, - count_Gvectors_in_spheres
!        - adjust_n_rGv_to_2l3m5n
!  8.    m_pwBS_calc_length_of_G       <- Preparation
!  9.    m_pwBS_setup_FFTmapfunctions  <- Preparation
!  10.   m_pwBS_GminusGmapfunction     <- m_ES_WF_by_MatDiagon
!  11.   decide_g_list_size            <- (12)
!  12.   m_pwBS_G_trans_functions      <- Preparation
!        - substitute_g_list, - symmetric_G_points_using_g_list
!        - counting_error_points, - symmetric_G_points
!  13.   m_pwBS_sphrp_l                <- Initial_Electronic_Structure
!  14.   m_pwBS_sphrp2                 <- m_Chargek_Density, m_ES_Intgr_VlhxcQlm,
!                                         m_Force, m_Stress, m_XC_Potential
!  15.   m_pwBS_sphrp2_diff            <- m_Stress, m_XC_Potential, m_epc_potential
!  16.   m_pwBS_kinetic_energies       <- m_ES_WF_by_Davidson, m_ES_WF_by_RMM,
!                                         m_ES_WF_by_SDorCG, m_ES_WF_by_submat,
!                                         m_Electronic_Structure
!  17.   m_pwBS_pstrn_kinetic_energies <- m_Positron_Wave_Functions
!  18.   m_pwBS_find_min_max_G         <- m_ES_WF_by_RMM
!  19.   m_pwBS_decide_cutoff_mix      <- Preparation
!  20.   m_pwBS_wd_ngabc_etc           <- Postprocessing
!  21.   m_pwBS_increase_kg1           <- Preparation

contains
  subroutine m_pwBS_alloc_ylm_l()
    if(nel_Ylm >= 1) then
       if(.not.allocated(ylm_l)) allocate(ylm_l(ista_kngp:iend_kngp,nel_Ylm))
    end if
  end subroutine m_pwBS_alloc_ylm_l

  subroutine m_pwBS_dealloc_ylm_l()
    if(allocated(ylm_l)) deallocate(ylm_l)
  end subroutine m_pwBS_dealloc_ylm_l

  subroutine m_pwBS_alloc_igpo()
    integer :: i,j,k
    if(.not.allocated(igpo)) then
       i = n_rGsv(1); j = n_rGsv(2); k = n_rGsv(3)
       allocate(igpo(-i:i,-j:j,-k:k))
    end if
  end subroutine m_pwBS_alloc_igpo

  subroutine m_pwBS_dealloc_igpo()
    if(allocated(igpo)) deallocate(igpo)
  end subroutine m_pwBS_dealloc_igpo

  subroutine alloc_nbase
    integer :: ik
    logical :: tf
    if(.not.allocated(nbase)) then
       allocate(nbase(kg1_ext,kv3))
!!$       write(6,'(" nbase is allocated, kg1_ext = ",i8,"<<alloc_nbase>>")') kg1_ext
    else
!!$       write(6,'(" nbase has already been allocated, kg1_ext = ",i8,"<<alloc_nbase>>")') kg1_ext
    end if
    tf = .false.
    do ik = 1, kv3
       if(k_symmetry(ik) == GAMMA .or. k_symmetry(ik) == GAMMA_base_symmetrization) then
          tf = .true.
       end if
    end do
    if(tf) then
       if(.not.allocated(nbase_gamma)) then
          allocate(nbase_gamma(kg_gamma,2)); nbase_gamma = -1
       end if
! === Debug by Intel "-check all" option! by T.Kato 2011/03/28 =================
!   end if
    else
       if(.not.allocated(nbase_gamma)) then
          allocate(nbase_gamma(1,1)); nbase_gamma = -1
       end if
    end if
! ==============================================================================
  end subroutine alloc_nbase

  subroutine reduce_nbase()
    real(kind=DP), allocatable, dimension(:,:) :: nbase_tmp
    integer :: i, k
    allocate(nbase_tmp(kg1,kv3)); nbase_tmp = 0
    do k = 1, kv3
       do i = 1, iba(k)
          nbase_tmp(i,k) = nbase(i,k)
       end do
    end do
    deallocate(nbase)
    allocate(nbase(kg1,kv3))
    nbase(:,:) = nbase_tmp(:,:)

    deallocate(nbase_tmp)
  end subroutine reduce_nbase

  subroutine alloc_iba
    if(.not.allocated(iba)) then
       allocate(iba(kv3))
       if(ipri >= 3) write(nfout,'(" iba is allocated")')
    else
       if(ipri >= 3) write(nfout,'(" iba is not allocated")')
    end if
  end subroutine alloc_iba

  subroutine G_vectors_alloc
    allocate(ngabc(kgp,3))
  end subroutine G_vectors_alloc

  subroutine m_pwBS_alloc_nbmat_and_iba2()
    if(nmatsz <= 0) stop ' nmatsz <= 0 (alloc_nbmat_and_iba2)'
    if(ipri >= 2 ) write(6,'(" nmatsz = ",i5," kv3 = ",i5," (alloc_nbmat_and_iba2)")') nmatsz,kv3
!!$    allocate(nbmat(nmatsz,ista_k:iend_k))
!!$    allocate(iba2(ista_k:iend_k))
    allocate(nbmat(nmatsz,kv3)); nbmat = 0.d0
    allocate(nbmat2(nmatsz,kv3)); nbmat2 = 0.d0
    allocate(iba2(kv3))
  end subroutine m_pwBS_alloc_nbmat_and_iba2

  subroutine m_pwBS_dealloc_nbmat_and_iba2()
    if(allocated(nbmat)) deallocate(nbmat)
    if(allocated(nbmat2)) deallocate(nbmat2)
    if(allocated(iba2))  deallocate(iba2)
  end subroutine m_pwBS_dealloc_nbmat_and_iba2

  subroutine m_pwBS_alloc_ngpt_igfp_gr
    allocate(ngpt_l(ista_kngp:iend_kngp,nopr+af)); ngpt_l = 0.d0
    allocate(igfp_l(ista_kngp:iend_kngp));      igfp_l = 0
#ifdef _MPIFFT_
    allocate(igfp_nonpara(ista_kngp:iend_kngp)); igfp_nonpara = 0
    allocate(igfp_l_c(ista_kngp:iend_kngp));    igfp_l_c = 0
#endif
    allocate(igf(kg));                          igf    = 0
    allocate(gr_l(ista_kngp:iend_kngp));        gr_l   = 0.d0
    ! ------- Positron start 
    if(sw_positron /= OFF) then
       allocate(igf_pstrn(kg_pwf)) ; igf_pstrn = 0
    end if
    ! ------- Positron end

! ========== KT_add ========================== 13.0F
    if (sw_hybrid_functional /= OFF .and. use_fft_exx ) then
       allocate(igf_exx(kg_exx)) ; igf_exx = 0
    end if
    if (sw_hybrid_functional /= OFF) then
       allocate(igfp_exx(kgp_exx)) ; igfp_exx = 0
    endif
! ============================================ 13.0F

  end subroutine m_pwBS_alloc_ngpt_igfp_gr

  subroutine m_pwBS_dealloc_ngpt_igfp_gr
    if(allocated(gr_l)) deallocate(gr_l)
    if(allocated(ngpt_l)) deallocate(ngpt_l)
    if(allocated(igfp_l)) deallocate(igfp_l)
#ifdef _MPIFFT_
    if(allocated(igfp_nonpara)) deallocate(igfp_nonpara)
    if(allocated(igfp_l_c)) deallocate(igfp_l_c)
#endif
    if(allocated(igf)) deallocate(igf)
    ! ------- Positron start 
    if(sw_positron /= OFF) deallocate(igf_pstrn)
    ! ------- Positron end

! ========== KT_add ========================== 13.0F
    if (sw_hybrid_functional /= OFF .and. use_fft_exx ) deallocate(igf_exx)
    if (sw_hybrid_functional /= OFF ) deallocate(igfp_exx)
! ============================================ 13.0F

  end subroutine m_pwBS_dealloc_ngpt_igfp_gr

  subroutine m_pwBS_mat_for_each_WF()
    integer          :: i,j,k,kk, icycle, istart, iend, ic, ig, max_elements, icolumn &
         &            , kk_gamma, n1,n2,n3
    real(kind=DP)    :: ga,gb,gc,grvv
    integer          :: id_sname = -1
    call tstatc0_begin('m_pwBS_mat_for_each_WF ',id_sname)

    do i = 1, kv3
       kk = 0
       if(k_symmetry(i) == GAMMA .or. k_symmetry(i) == GAMMA_base_symmetrization) then
          kk_gamma = 0
          do j = 1, kg
             n1 = ngabc(j,1); n2 = ngabc(j,2); n3 = ngabc(j,3)
             grvv = dsqrt(ttr(1)*n1*n1 + ttr(2)*n2*n2 + ttr(3)*n3*n3 &
                  &   +   ttr(4)*n1*n2 + ttr(5)*n2*n3 + ttr(6)*n3*n1)
             if(grvv <= gmaxs) then
                kk = kk + 1
                nbmat(kk,i) = j
                if(n3 >  SmallestPositiveNumber) then
                   kk_gamma = kk_gamma + 1
                else if(n3 == 0) then
                   if((n1 >= 0 .and. n2 >= 0 ) .or. (n1 < 0 .and. n2 > 0)) then
                      kk_gamma = kk_gamma + 1
                   end if
                end if
             end if
          end do
          kg2_gamma = kk_gamma
       else
          do j = 1, kg
             ga = vkxyz(i,1,BUCS) + ngabc(j,1)
             gb = vkxyz(i,2,BUCS) + ngabc(j,2)
             gc = vkxyz(i,3,BUCS) + ngabc(j,3)
             grvv = dsqrt(ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
                  &   +   ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga)
             if(grvv <= gmaxs) then
                kk = kk + 1
                nbmat(kk,i) = j
             end if
          end do
       end if
       iba2(i) = kk
       if(iba2(i) < neg) then
          write(nfout,'(" iba2(",i4,") < neg = ",i4)') i,neg
          stop ' m_pwBS_mat_for_each_WF'
       end if
       if(k_symmetry(i) == GAMMA .or. k_symmetry(i) == GAMMA) then
          do j=1,iba2(i)
             nbmat2(j,i) = nbmat(j,i)
!!$             if(nbmat(j,i) == nbase_gamma(1,1)) nbmat2(j,i) = 1
!!$             if(nbmat2(j,i) == 0) then
!!$                do k=2, kg_gamma
!!$                   if(nbmat(j,i) == nbase_gamma(k,1)) then
!!$                      nbmat2(j,i) = nbase_gamma(k,1)
!!$                      exit
!!$                   else if(nbmat(j,i) == nbase_gamma(k,2)) then
!!$                      nbmat2(j,i) = nbase_gamma(k,2)
!!$                      exit
!!$                   end if
!!$                end do
!!$             end if
          end do
       else
          do j = 1, iba2(i)
             do k=1,iba(i)
                if(nbmat(j,i) == nbase(k,i)) then
                   nbmat2(j,i) = k
                   exit
                end if
             end do
          end do
       end if
       if(ipri >= 2) then
          ! --- nbmat, nbmat2 ---
          max_elements = iba2(i)
          icolumn = 10
          write(nfout,'(" !pwbs -- nbmat, nbase --")')
          write(nfout,'(" !pwbs k = ",i4," iba2= ",i6)') i,iba2(i)
          icycle = ceiling(dble(min(max_elements,iba2(i)))/icolumn)
          istart = 1
          do ic = 1, icycle
             iend = min(istart+icolumn-1,max_elements,iba2(i))
             if(ipri >= 3 .or. (ipri>=2 .and. (ic <= 3 .or. ic >= icycle-2))) then
                write(nfout,'(" ! nbmat  ",10i10)') (nbmat(ig,i),ig=istart,iend)
                write(nfout,'(" ! nbmat2 ",10i10)') (nbmat2(ig,i),ig=istart,iend)
             end if
             istart = iend+1
          end do

          ! --- nbase ---
!!$          max_elements = kg1_ext
          max_elements = iba(i)
          icolumn = 10
          write(nfout,'(" !pwbs -- nbase --")')
!!$          icycle = ceiling(dble(min(max_elements,kg1_ext))/icolumn)
          icycle = ceiling(dble(min(max_elements,iba(i)))/icolumn)
          istart = 1
          do ic = 1, icycle
!!$             iend = min(istart+icolumn-1,max_elements,kg1_ext)
             iend = min(istart+icolumn-1,max_elements,iba(i))
             if(ipri >= 2 .or. (ipri>=1 .and. (ic <= 3 .or. ic >= icycle-2))) then
                write(nfout,'(" ! nbase ",10i10)') (nbase(ig,i),ig=istart,iend)
             end if
             istart = iend+1
          end do

          ! --- nbase_gamma ---
          if(kg_gamma > 0 .and. (k_symmetry(i) == GAMMA .or. k_symmetry(i) == GAMMA_base_symmetrization)) then
             max_elements = kg_gamma
             icolumn = 6
             write(nfout,'(" !pwbs -- nbase_gamma --")')
             write(nfout,'(" !pwbs k = ",i4," kg_gamma = ",i6)') i,kg_gamma
             if(kg2_gamma > 0) write(nfout,'(" !pwbs kg2_gamma = ",i6)') kg2_gamma
             icycle = ceiling(dble(min(max_elements,kg_gamma))/icolumn)
             istart = 1
             do ic = 1, icycle
                iend = min(istart+icolumn-1,max_elements,kg_gamma)
                if(ipri >= 2 .or. (ipri>=1 .and. (ic <= 3 .or. ic >= icycle-2))) then
                   write(nfout,'(" !nbase_gamma1 (",i9,"-",i9,") ",6i10)') &
                        &  istart, iend, (nbase_gamma(ig,1),ig=istart,iend)
                   write(nfout,'(" !nbase_gamma2 (",i9,"-",i9,") ",6i10)') &
                        &  istart, iend, (nbase_gamma(ig,2),ig=istart,iend)
                end if
                istart = iend+1
             end do
          end if
       end if
    end do

    call tstatc0_end(id_sname)
  end subroutine m_pwBS_mat_for_each_WF
    
  recursive subroutine m_pwBS_for_each_WF(preallocation)
!   Revised on 19th September 2006 by T. Yamasaki
!      A finding algorism of nbase_gamma(*,2) is revised for the case that
!     ngshell_range_G's are not properly prepared.
    logical, intent(in)       :: preallocation

    integer :: jjt, i, jj, jj_gamma, j, n1, n2, n3, j2, jg, k, iloop &
         &   , j2s, j2e, jg1, jg2, kg_gamma_part, max_elements, icolumn, icycle &
         &   , istart, ic, iend, ig, idelta
    real(kind=DP)    :: ga,gb,gc, grvv, grvt, grvmx, length_start, length
    logical :: found
    integer, allocatable, dimension(:)   :: ngshell_range_G !d(ngshell_GAMMA)
    integer, allocatable, dimension(:)   :: ngbshell !d(kg0)
    integer, parameter :: CRITICAL_VECTOR_LENGTH = 10000

    integer          :: id_sname = -1
                                                     __TIMER_SUB_START(1221)
    call tstatc0_begin('m_pwBS_for_each_WF ',id_sname)

    if(ipri >= 2) then
       if(     preallocation) write(nfout,*) ' ! preallocation = .true.'
       if(.not.preallocation) write(nfout,*) ' ! preallocation = .false.'
    end if

    if(allocated(iba))then
       if(ipri >= 3) write(nfout,'(" iba is allocated <<m_pwBS_for_each_WF>>")')
    else
       if(ipri >= 3) write(nfout,'(" iba is not allocated <<m_pwBS_for_each_WF>>")')
    end if

    call alloc_iba()
    if(.not.preallocation) then
       !!$call alloc_iba()
       if(kg1_ext == 0) call m_pwBS_for_each_WF(.true.)
       call alloc_nbase()
!!$       write(6,'(" alloc_nbase")')
    else
!!$       write(6,'(" alloc_nbase is not called")')
    end if

    if(preallocation .and. ipri >= 1) write(nfout,'(/" <<< m_pwBS_for_each_WF >>>")')

    call getttr(rltv,ttr)

    if(preallocation) kg1_ext = 0; if(preallocation) nbmx = 0
    if(preallocation) kg1 = 0;

    if(preallocation) then
       jjt = 0
       grvt = 0.d0
    else if(.not.preallocation) then
       nbase = 0
    end if

    do i = 1, kv3
       if(k_symmetry(i) == GAMMA .or. k_symmetry(i) == GAMMA_base_symmetrization) then
          if(preallocation) then
             grvmx = 0.d0
             ngshell_GAMMA = 1
             length_start = 0.d0
             jj_gamma = 0
!CDIR NOVECTOR
             g_search_loop:do j = 1, kg0
                n1 = ngabc(j,1)
                n2 = ngabc(j,2)
                n3 = ngabc(j,3)
                grvv = dsqrt(ttr(1)*n1*n1 + ttr(2)*n2*n2 + ttr(3)*n3*n3 &
                     &   +   ttr(4)*n1*n2 + ttr(5)*n2*n3 + ttr(6)*n3*n1)
!!$                grvv = ( ttr(1)*n1*n1 + ttr(2)*n2*n2 + ttr(3)*n3*n3 &
!!$                     & + ttr(4)*n1*n2 + ttr(5)*n2*n3 + ttr(6)*n3*n1)
                if(grvv > length_start + DELTA10) then
!!$                if(grvv > length_start + DELTA07) then
                   ngshell_GAMMA = ngshell_GAMMA+1
                   length_start = grvv
                end if
                if(grvv > grvmx) grvmx=grvv
                if(n3 >  SmallestPositiveNumber) then
                   jj_gamma = jj_gamma + 1
                else if(n3 == 0) then
                   if((n1 >= 0 .and. n2 >= 0 ) .or. (n1 < 0 .and. n2 > 0)) then
                      jj_gamma = jj_gamma + 1
                   end if
                end if
             end do g_search_loop
!!$             grvmx = dsqrt(grvmx)

             if(ipri >= 1 ) write(nfout,'(" !pwbs ngshell_GAMMA = ",i8)') ngshell_GAMMA
             jj = kg0
!!$             kg_gamma = jj_gamma
             kg_gamma = (kg0+1)/2

             if(nbmx < kg0) nbmx = kg0
             iba(i) = kg0
             if(ipri >= 1) write(nfout,'(" !# iba(",i4,") = ",i8," (preallocation)<<m_pwBS_for_each_WF>>")')&
                  & i, iba(i)
          else if(.not.preallocation) then
             allocate(ngshell_range_G(ngshell_GAMMA))
             allocate(ngbshell(kg0))
             jj = 0
             jg = 1
             ngshell_range_G(jg) = 1
             length_start = 0.d0
             g_search_loop2:do j = 1, kg0
                n1 = ngabc(j,1)
                n2 = ngabc(j,2)
                n3 = ngabc(j,3)
                grvv = dsqrt(ttr(1)*n1*n1 + ttr(2)*n2*n2 + ttr(3)*n3*n3 &
                     &   +   ttr(4)*n1*n2 + ttr(5)*n2*n3 + ttr(6)*n3*n1)
                nbase(j,i)=j
                if(grvv > length_start + DELTA10) then
!!$                if(grvv > length_start + DELTA07) then
                   jg = jg+1
                   ngshell_range_G(jg) = j
                   length_start = grvv
                end if
                ngbshell(j) = jg
                if(n3 >  SmallestPositiveNumber) then
                   jj = jj + 1
                   nbase_gamma(jj,1) = j
                else if(n3 == 0) then
                   if((n1 >= 0 .and. n2 >= 0 ) .or. (n1 < 0 .and. n2 > 0)) then
                      jj = jj + 1
                      nbase_gamma(jj,1) = j
                   end if
                end if
             end do g_search_loop2

             do j = 1, ngshell_GAMMA-1
                if(ngshell_range_G(j+1) < ngshell_range_G(j)) then
                   write(nfout,'("!! ngshell_range order illegal <<m_pwBS_for_each_WF>>")')
                   write(nfout,'("!! j = ",i5," ngshell_range_G(j+1), ngshell_range_G(j) = ",2i8)') &
                        & ngshell_range_G(j+1), ngshell_range_G(j)
                   stop ' ngshell_range_G order is illegl << m_pwBS_for_each_WF>>'
                end if
             end do
             if(ipri >= 1) call wd_ngshell_range()

             kg_gamma_part = ceiling(dble(kg_gamma)/npes)
             if(kg_gamma_part > CRITICAL_VECTOR_LENGTH) then
                if(kg_gamma_part == 0) kg_gamma_part = 1
                jg1 = kg_gamma_part*mype + 1
                jg2 = kg_gamma_part*(mype+1)
                if(jg2 > kg_gamma) jg2 = kg_gamma
                if(ipri >= 2) write(nfout,'(" !pwBS jg1, jg2 = ", 2i5)') jg1, jg2
             else
                jg1 = 1; jg2 = kg_gamma
             end if

             nbase_gamma(1:kg_gamma,2) = 0
             if(jg1 == 1) then
                nbase_gamma(1,2) = -1
                jg1 = 2
             end if
             do jg = jg1, jg2
                j = nbase_gamma(jg,1)
                k = ngbshell(j)
                n1 = ngabc(j,1); n2 = ngabc(j,2); n3 = ngabc(j,3)
                j2s = ngshell_range_G(k)
                if(k<=ngshell_GAMMA-1) then; j2e = ngshell_range_G(k+1)-1; else; j2e = iba(i); end if ! j2e
                   idelta = 0
1003               found = .false.
                G_search: do j2 = j2s, j2e
                   if(ngabc(j2,1) == -n1 .and. ngabc(j2,2) == -n2 .and. ngabc(j2,3) == -n3) then
                      nbase_gamma(jg,2) = j2
                      if(j2 == j) nbase_gamma(jg,2) = -1
                      found = .true.
                      exit G_search
                   end if
                end do G_search
                if(.not.found) then
                   idelta = idelta + 1
                   if(k-idelta >= 1) then
                      j2s = ngshell_range_G(k-idelta)
                   else
                      j2s = 1
                   end if
                   if(k+idelta <= ngshell_GAMMA-1) then
                      j2e = ngshell_range_G(k+idelta+1)-1
                   else
                      j2e = iba(i)
                   end if
                   goto 1003
                end if
             end do
             if(npes > 1) then
                if(kg_gamma_part > CRITICAL_VECTOR_LENGTH) then
                   call mpi_allreduce(nbase_gamma(1:kg_gamma,2),ngbshell,kg_gamma,mpi_integer,mpi_sum,mpi_comm_group,ierr)
                   nbase_gamma(1:kg_gamma,2) = ngbshell(1:kg_gamma)
                end if
             end if

             if(k_symmetry(i) == GAMMA) then
                do jg = 1, kg_gamma
                   nbase(jg,i) = nbase_gamma(jg,1)
                end do
                do jg = kg_gamma+1, kg1_ext
                   nbase(jg,i) = 0
                end do
                iba(i) = kg_gamma
             end if
             deallocate(ngbshell,ngshell_range_G)
          end if
          if(k_symmetry(i) == GAMMA) then
             if(preallocation .and. kg_gamma > kg1 ) kg1 = kg_gamma
          else
!!$             if(preallocation .and. jj > kg1) kg1 = jj
             if(preallocation .and. kg0 > kg1) kg1 = kg0
          end if
       else
          if(preallocation) grvmx = 0.d0
          jj = 0
          do j = 1, kg
             ga = vkxyz(i,1,BUCS) + ngabc(j,1)
             gb = vkxyz(i,2,BUCS) + ngabc(j,2)
             gc = vkxyz(i,3,BUCS) + ngabc(j,3)
             grvv = dsqrt(ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
                  &   +   ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga)
             if(grvv <= gmax) then
                jj = jj + 1
                if(preallocation .and. nbmx < j ) nbmx = j
                if(preallocation) then
                   if(grvv > grvmx) grvmx=grvv
                end if

! ===== KT_mod ===================== 13.0S [OK??]
!
!  The values of vkxyz when prealloc=true are different
!  from those values when prealloc=false
!                     ( see Preparation.F90, ekmode=on )
!
!  Thus, "jj" (when prealloc=false) may be over "kg1_ext" set when prealloc=true.
!
! ------------------------------
!                if(.not.preallocation) nbase(jj,i)=j
                if(.not.preallocation) then
                   if ( jj <= kg1_ext ) nbase(jj,i)=j
                endif
! ================================== 13.0S

             end if
          enddo
          if(preallocation) then
             if(jj > kg1) kg1 = jj
             iba(i) = jj
             jjt    = jjt + jj
             grvt   = grvt + grvmx*qwgt(i)
          end if
       end if

       if(ipri >= 3) then
          if(preallocation) then
             write(nfout,'(" !# K= ",i4," iba= ",i6," GRV= ",F12.8)') i,iba(i),grvmx
          else
             write(nfout,'(" !# K= ",i4," iba= ",i6," nbase(",i6,",",i4,")= ",i7)') &
                  & i,iba(i),iba(i),i,nbase(iba(i),i)
             if(iba(i) > kg1_ext) then
                write(nfout,'(" ! iba(",i3,") > kg1_ext (= ",i9)') i,kg1_ext
                stop ' iba(i) > kg1_ext <<m_pwBS_for_each_WF>>'
             else if(iba(i) == 0) then
                write(nfout,'(" ! iba(",i3,") = ",i6)') i,iba(i)
                stop ' iba(i) == 0 <<m_pwBS_for_each_WF>>'
             end if
             if(ipri >= 2) then
                if(kg_gamma > 0 .and.(k_symmetry(i) == GAMMA &
                     &              .or. k_symmetry(i) == GAMMA_base_symmetrization)) then
                   max_elements = kg_gamma
                   icolumn = 10
                   write(nfout,'(" !pwbs -- nbase_gamma --")')
                   write(nfout,'(" !pwbs k = ",i4," kg_gamma = ",i6)') i,kg_gamma
                   if(kg2_gamma > 0) write(nfout,'(" !pwbs kg2_gamma = ",i6)') kg2_gamma
                   icycle = ceiling(dble(min(max_elements,kg_gamma))/icolumn)
                   istart = 1
                   do ic = 1, icycle
                      iend = min(istart+icolumn-1,max_elements,kg_gamma)
                      if(ipri >= 2 .or. (ipri>=1 .and. (ic <= 3 .or. ic >= icycle-2))) then
                         write(nfout,'(" ! nbase_gamma 1 ",10i10)') (nbase_gamma(ig,1),ig=istart,iend)
                         write(nfout,'(" ! nbase_g1 (nx) ",10i10)') (ngabc(nbase_gamma(ig,1),1),ig=istart,iend)
                         write(nfout,'(" ! nbase_g1 (ny) ",10i10)') (ngabc(nbase_gamma(ig,1),2),ig=istart,iend)
                         write(nfout,'(" ! nbase_g1 (nz) ",10i10)') (ngabc(nbase_gamma(ig,1),3),ig=istart,iend)
                         write(nfout,'(" ! nbase_gamma 2 ",10i10)') (nbase_gamma(ig,2),ig=istart,iend)
                         write(nfout,'(" ! nbase_g2 (nx) ",10i10)') (ngabc(nbase_gamma(ig,2),1),ig=istart,iend)
                         write(nfout,'(" ! nbase_g2 (ny) ",10i10)') (ngabc(nbase_gamma(ig,2),2),ig=istart,iend)
                         write(nfout,'(" ! nbase_g2 (nz) ",10i10)') (ngabc(nbase_gamma(ig,2),3),ig=istart,iend)
                      end if
                      istart = iend+1
                   end do
                end if
             end if
          end if
       end if
       if(preallocation .and. jj > kg1_ext ) kg1_ext = jj
    end do ! k-point loop

    if(.not.preallocation) then
       if(kg1 < kg1_ext) then
          call reduce_nbase()
       end if
    end if

    if(ipri >= 1) then
       if(preallocation) then
          write(nfout,130) kg1_ext,kg1,nbmx
          write(nfout,140) jjt,grvt
          write(nfout,'(" !# pwbs kg_gamma = ",i8)') kg_gamma
130       format(' ','!# ** kg1_ext, kg1, nbmx (=matrix size) = ',3i8)
140       format(' ','!#  JJT(=sum(iba)) = ',I8,' MEAN GRV = ',f12.8)
          write(nfout,*)
       else
          if(ipri >= 2 .or. (ipri>=1 .and. kv3 <=10)) then
             do i = 1, kv3
                write(nfout,'(" ! iba(",i6,") = ",i6,",  nbase(",i6,",",i6,") = ",i7)') i, iba(i),iba(i),i,nbase(iba(i),i)
             end do
          else
             if(kv3 > 10) then
                do iloop = 1, 2
                   do i = (kv3-4)*(iloop-1)+1, (kv3-4)*(iloop-1)+4
                      write(nfout,'(" ! iba(",i6,") = ",i6,",  nbase(",i6,",",i6,") = ",i7)') i, iba(i),iba(i),i,nbase(iba(i),i)
                   end do
                   if(iloop == 1) write(nfout,'(" ! ......")')
                end do
             end if
          end if
       end if
    end if

    call tstatc0_end(id_sname)
                                                     __TIMER_SUB_STOP(1221)
  contains
    subroutine wd_ngshell_range
      integer :: jg, j,n1,n2,n3
      real(kind=DP) :: gr1, gr2

      write(nfout,'(" !pwbs ngshell_range_G")') 
      write(nfout,'(" !pwbs  ngshell_G, range1 - range2, nelement, gr1, gr2")')
      do jg = 1, ngshell_GAMMA
         if(ipri >= 2 .or.&
              & (ipri==1 .and. (jg <= 5 .or. jg >= ngshell_GAMMA - 4))) then
            j = ngshell_range_G(jg)
            n1 = ngabc(j,1);  n2 = ngabc(j,2);  n3 = ngabc(j,3)
            gr1 = dsqrt(ttr(1)*n1*n1 + ttr(2)*n2*n2 + ttr(3)*n3*n3 &
                 &  +   ttr(4)*n1*n2 + ttr(5)*n2*n3 + ttr(6)*n3*n1)
            if(jg == ngshell_GAMMA) then
               j = iba(i)
            else
               j = ngshell_range_G(jg+1)-1
            end if
            n1 = ngabc(j,1);  n2 = ngabc(j,2);  n3 = ngabc(j,3)
            gr2 = dsqrt(ttr(1)*n1*n1 + ttr(2)*n2*n2 + ttr(3)*n3*n3 &
                 &  +   ttr(4)*n1*n2 + ttr(5)*n2*n3 + ttr(6)*n3*n1)
            write(nfout,'(" !pwbs ",i8, " [",i8," : ",i8," ] ", i8, 2f20.8)') &
                 & jg, ngshell_range_G(jg),j &
                 & ,j-ngshell_range_G(jg)+1,gr1, gr2
         else if(ipri == 1 .and. jg == 6) then
            write(nfout,'(" !pwbs  ..........")')
         end if
      end do
      if(ipri >= 3) then
         write(nfout,'(" !pwBS -- ngbshell --")')
         write(nfout,'(5("(",i8,i6,")"))') (j,ngbshell(j),j=1,iba(i))
      end if
    end subroutine wd_ngshell_range
  end subroutine m_pwBS_for_each_WF

  ! ------- Positron start
  recursive subroutine m_pwBS_positronWF()

    integer          :: j
    real(kind=DP)    :: ga,gb,gc, grvv
    integer          :: id_sname = -1
    call tstatc0_begin('m_pwBS_positronWF ',id_sname)


    call getttr(rltv,ttr)

    kg1_pwf = 0

    do j = 1, kg_pwf
       ga = ngabc(j,1)
       gb = ngabc(j,2)
       gc = ngabc(j,3)
       grvv = dsqrt(ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
            &     + ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga )
       if(grvv <= gmax_positron) then
          kg1_pwf = kg1_pwf + 1
       end if
    enddo

    if(ipri>=1) write(nfout,'(" !pwbs kg1_pwf = ",i7)') kg1_pwf
    call tstatc0_end(id_sname)
  end subroutine m_pwBS_positronWF
  ! ------- Positron end

! =================== KT_add ====================== 13.0F
  recursive subroutine m_pwBS_exxWF()

    integer          :: j
    real(kind=DP)    :: ga,gb,gc, grvv
    integer          :: id_sname = -1
    call tstatc0_begin('m_pwBS_exxWF ',id_sname)

    call getttr(rltv,ttr)
    kg1_exx = 0

    do j = 1, kg_exx
       ga = ngabc(j,1);    gb = ngabc(j,2);    gc = ngabc(j,3)
       grvv = dsqrt(ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
            &     + ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga )
       if(grvv <= gmax_exx) then
          kg1_exx = kg1_exx + 1
       end if
    enddo

    if(ipri>=1) write(nfout,'(" !pwbs kg1_exx = ",i7)') kg1_exx
    call tstatc0_end(id_sname)

  end subroutine m_pwBS_exxWF

  recursive subroutine m_pwBS_exxCD()

    integer          :: j
    real(kind=DP)    :: ga,gb,gc, grvv
    integer          :: id_sname = -1
    call tstatc0_begin('m_pwBS_exxCD ',id_sname)

    call getttr(rltv,ttr)
    kg1p_exx = 0

    do j = 1, kgp_exx
       ga = ngabc(j,1);    gb = ngabc(j,2);    gc = ngabc(j,3)
       grvv = dsqrt(ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
            &     + ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga )
       if(grvv <= gmaxp_exx) then
          kg1p_exx = kg1p_exx + 1
       end if
    enddo

    if(ipri>=1) write(nfout,'(" !pwbs kg1p_exx = ",i7)') kg1p_exx
    call tstatc0_end(id_sname)

  end subroutine m_pwBS_exxCD

! ================================================ 13.0F

  subroutine m_pwBS_set_gmaxs(n_matrix_size,gmaxs_given)
    integer, intent(in) ::       n_matrix_size
    real(kind=DP), intent(in) :: gmaxs_given

    real(kind=DP)    :: grvv,ga,gb,gc
    integer          :: negg,i,j,kk,nmatsz_min,counter

!!$    if(intzaj == by_matrix_diagon) then
       call check_gmax(gmaxs_given)
       gmaxs = gmaxs_given
       if(gmaxs < SmallestPositiveNumber*1.d5 .and. n_matrix_size == 0) then
          if(kg < 15000) then
             negg = kg/15
          else if(neg < 1000) then
             negg = 1000
          else
             negg = neg
          end if
          if(negg < neg) negg = neg+20
          gmaxs = 2.05*gmax*(dble(neg)/dble(kg))**(1.d0/3.d0)
          if(printable) write(nfout,*) ' ! Both gmaxs and n_matrix_size were not given'
       else if(n_matrix_size > 0) then
          if(n_matrix_size < neg) then
             negg = neg + 20
          else
             negg = n_matrix_size
          end if
          gmaxs = 2.05*gmax*(dble(neg)/dble(kg))**(1.d0/3.d0)
          if(printable) write(nfout,*) ' ! n_matrix_size is given'
       else
          negg = kg * (gmaxs/(2.05*gmax))**3
          if(negg < neg) then
             negg = neg + 20
          end if
!!$          write(6,*) ' ! gmaxs is given'
       end if
!!$       write(nfout,'(" ! negg  = ",i8)') negg
!!$       write(nfout,'(" ! gmaxs = ",f8.4)') gmaxs

       counter = 0
1      nmatsz = 0
       nmatsz_min = kg
       n_rGsv = 0
       counter = counter+1
       do i = 1, kv3
          kk = 0
          do j = 1, kg
             ga = vkxyz(i,1,BUCS) + ngabc(j,1)
             gb = vkxyz(i,2,BUCS) + ngabc(j,2)
             gc = vkxyz(i,3,BUCS) + ngabc(j,3)
             grvv = dsqrt(ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
                  &   +   ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga)
             if(grvv <= gmaxs) then
                kk = kk + 1
                if(n_rGsv(1) < abs(ngabc(j,1))) n_rGsv(1) = abs(ngabc(j,1))
                if(n_rGsv(2) < abs(ngabc(j,2))) n_rGsv(2) = abs(ngabc(j,2))
                if(n_rGsv(3) < abs(ngabc(j,3))) n_rGsv(3) = abs(ngabc(j,3))
             end if
          end do
          if(kk > nmatsz) nmatsz = kk
          if(kk < nmatsz_min) nmatsz_min = kk
!!$          if(nmatsz_min < neg) exit
       end do
!!$       if(nmatsz < negg) then

!!$       write(nfout,'(" ! negg = ",i8," kg = ",i8)') negg,kg
       if(ipri >= 1) then
          write(nfout,'(" ! nmatsz = ",i8," nmatsz_min = ",i8)') nmatsz, nmatsz_min
          write(nfout,'(" ! gmaxs = ",f20.8)') gmaxs
       end if
       if(nmatsz_min < negg) then
          gmaxs = gmaxs*1.05
          if(ipri >= 1) then
             write(nfout,'(" ---- trial ",i4," ----")') counter
             write(nfout,'(" ! gmaxs is enlarged")')
          end if
          goto 1
       end if

       if(gmaxs > gmax) then
          if(ipri >= 1) write(nfout,'(" gmaxs(=",f10.4,") > gmax(=",f10.4,")")') gmaxs,gmax
          gmaxs = gmax
          if(ipri >= 1) write(nfout,'(" gmaxs is set gmax")')
       end if
       n_rGsv = 2*n_rGsv
       if(ipri >= 1) then
          write(nfout,'(" n_rGsv(1:3) = ",3i8)') n_rGsv(1:3)
          write(nfout,'(" nmatsz (m_pwBS_set_gmaxs) = ",i8)') nmatsz
       end if

  contains
    subroutine check_gmax(givenvalue)
      real(kind=DP),intent(in) :: givenvalue
      if(givenvalue < SmallestPositiveNumber*1.d5) then
         if(printable) write(nfout,'(" gmax_given is not given")')
!!$         stop ' illegal value of gmax (m_pwBS_set_gmaxs)'
      end if
    end subroutine check_gmax
  end subroutine m_pwBS_set_gmaxs

  subroutine m_pwBS_assume_G_rhombohedron
    real(kind=DP)   :: gmax2, gmax2_pstrn

! ============== KT_add ============================= 13.0F
    real(kind=DP)   :: gmax2_exx
! =================================================== 13.0F

    gmax2 = gmax*2
    call size_of_Gvector_rhombohedron  ! ->n_rGv, n_rGpv
    if(ipri >=1) call check_the_size_of_rhombohedron
  contains
    subroutine size_of_Gvector_rhombohedron
      integer i
      real(kind=DP)   :: alen
      do i = 1, 3
         alen = ( rltv(1,i)*altv(1,i) + rltv(2,i)*altv(2,i) + rltv(3,i)*altv(3,i) ) &
              & /dsqrt(altv(1,i)*altv(1,i) + altv(2,i)*altv(2,i) + altv(3,i)*altv(3,i))
         n_rGv(i)  = abs(int(gmax2/alen)) + 1
         n_rGpv(i) = abs(int(gmaxp/alen)) + 1
         n_rGpv_reduced(i) = abs(int(gmaxp_reduced/alen)) + 1
  ! ------- Positron start
         if(sw_positron /= OFF) then
            gmax2_pstrn = gmax_positron * 2
            n_rGv_pstrn(i) = abs(int(gmax2_pstrn/alen)) + 1
         end if
  ! ------- Positron end

! ============== KT_add ============================= 13.0F
         if ( sw_hybrid_functional /= OFF .and. use_fft_exx ) then
            gmax2_exx = gmax_exx * 2
            n_rGv_exx(i) = abs(int(gmax2_exx/alen)) + 1
         end if
         if ( sw_hybrid_functional /= OFF ) then
            n_rGpv_exx(i) = abs(int(gmaxp_exx/alen)) + 1
         endif
! =================================================== 13.0F

      enddo
    end subroutine size_of_Gvector_rhombohedron

    subroutine check_the_size_of_rhombohedron
      
      integer, dimension(3) :: kmax = (/0,0,0/), kmaxp = (/0,0,0/)
      real(kind=DP)         :: length_of_G
      integer i, j, k

      if(ipri >= 1) call wd_n_rGv_and_n_rGpv
      call getttr(rltv,ttr)
      Kloop: do k = - n_rGpv(3), n_rGpv(3)
         Jloop: do j = - n_rGpv(2), n_rGpv(2)
            Iloop: do i = - n_rGpv(1), n_rGpv(1)
               length_of_G = dsqrt(ttr(1)*i*i + ttr(2)*j*j + ttr(3)*k*k &
                    &            +      ttr(4)*i*j + ttr(5)*j*k + ttr(6)*k*i )
               if(length_of_G <= gmax2) then
                  if(kmax(1) < abs(i)) kmax(1) = abs(i)
                  if(kmax(2) < abs(j)) kmax(2) = abs(j)
                  if(kmax(3) < abs(k)) kmax(3) = abs(k)
               else if(length_of_G <= gmaxp) then
                  if(kmaxp(1) < abs(i)) kmaxp(1) = abs(i)
                  if(kmaxp(2) < abs(j)) kmaxp(2) = abs(j)
                  if(kmaxp(3) < abs(k)) kmaxp(3) = abs(k)
               endif
            enddo Iloop
         enddo Jloop
      enddo Kloop

      do i = 1, 3
         kmaxp(i) = max(kmax(i),kmaxp(i))
         kmax(i)  = kmax(i) + 1
         kmaxp(i) = kmaxp(i) + 1
      enddo

    end subroutine check_the_size_of_rhombohedron

    subroutine wd_n_rGv_and_n_rGpv
      if(ipri >= 1) then
         write(nfout,*) ' ! Size of rhombohedrons which contain spheres of G_vectors being smaller than gmax and gmaxp'
         write(nfout,110) n_rGv(1), n_rGv(2), n_rGv(3)
         write(nfout,111) n_rGpv(1), n_rGpv(2), n_rGpv(3)
         write(nfout,112) n_rGpv_reduced(1:3)
      end if
110   FORMAT(' ',' KNX ,KNY ,KNZ  = ',3I6)
111   FORMAT(' ',' KNXP,KNYP,KNZP = ',3I6)
112   format(' ',' knxp_reduced, knyp_reduced, knzp_reduced = ',3i6)
      if(sw_positron /= OFF .and. ipri >= 1) &
           & write(nfout,'("  knx, kny, knz (positron) = ",3i6)') n_rGv_pstrn(1:3)
    end subroutine wd_n_rGv_and_n_rGpv
  end subroutine m_pwBS_assume_G_rhombohedron

  subroutine m_pwBS_generate_G_vectors
    real(kind=DP)         :: gmax2, gmax2_pstrn

! =========== KT_add ================================ 13.0F
    real(kind=DP)         :: gmax2_exx
! =================================================== 13.0F

    real(kind=DP), allocatable, dimension(:,:,:) :: G_length_in_cube
    real(kind=DP), allocatable, dimension(:)     :: gr_t !d(kgp)
    integer               :: id_sname = -1

    call tstatc0_begin('m_pwBS_generate_G_vectors ',id_sname)

    gmax2 = gmax*2
    gmax2_pstrn = gmax_positron*2

! =========== KT_add ================================ 13.0F
    gmax2_exx = gmax_exx*2
! =================================================== 13.0F

    call adjust_n_rGv_to_2l3m5n  ! -(contained here) fft_box_size_WF,CD -> n_rGV,n_rGpv

    allocate(G_length_in_cube(2*n_rGpv(1)+3,2*n_rGpv(2)+3, 2*n_rGpv(3)+3))
    call count_Gvectors_in_spheres

    call G_vectors_alloc           ! ngabc
    allocate(gr_t(kgp))

    call get_Gvectors_in_a_gmaxp_sphere

    deallocate(gr_t)
    deallocate(G_length_in_cube)

    if(ipri>=1) write(nfout,*) ' !kg  = ', kg
    if(ipri>=1) write(nfout,*) ' !kgp = ', kgp
    if(ipri>=1) write(nfout,*) ' !kgp_reduced = ',kgp_reduced

    if(sw_positron /= OFF .and. ipri>=1) write(nfout,*) ' !kg_pwf = ', kg_pwf

! =========== KT_add ================================ 13.0F
    if (sw_hybrid_functional /= OFF .and. use_fft_exx ) then
       if (ipri>=1) write(nfout,*) ' !kg_exx  = ', kg_exx
    endif
    if (sw_hybrid_functional /= OFF ) then
       if (ipri>=1) write(nfout,*) ' !kgp_exx = ', kgp_exx
    endif
! =================================================== 13.0F

    call tstatc0_end(id_sname)
  contains
    subroutine get_Gvectors_in_a_gmaxp_sphere
      integer             :: i, j, k
      real(kind=DP)       :: length_of_Gvector

      call getttr(rltv,ttr)     

      kg = 0
      kgp = 0
!!$      if(sw_positron /= OFF) kg_pwf = 0
      do k = -n_rGpv(3)-1, n_rGpv(3)+1
         do j = -n_rGpv(2)-1, n_rGpv(2)+1
            do i = -n_rGpv(1)-1, n_rGpv(1)+1
               length_of_Gvector = G_length_in_cube(i+n_rGpv(1)+2,j+n_rGpv(2)+2, k+n_rGpv(3)+2)
!!$               length_of_Gvector = dsqrt(ttr(1)*i*i+ttr(2)*j*j+ttr(3)*k*k &
!!$                    &                  + ttr(4)*i*j+ttr(5)*j*k+ttr(6)*k*i)
               if(length_of_Gvector <= gmax2) kg  = kg + 1
!!$               if(sw_positron/=OFF .and. length_of_Gvector<=gmax2_pstrn) kg_pwf=kg_pwf+1
               if(length_of_Gvector <= gmaxp) then
                  kgp = kgp + 1
                  ngabc(kgp,1) = i
                  ngabc(kgp,2) = j
                  ngabc(kgp,3) = k
                  gr_t(kgp) = length_of_Gvector
               endif
            enddo
         enddo
      enddo
      if(ipri >= 2) then
         write(nfout,'(" -- gr_t -- <<m_pwBS_generate_G_vectors>>")') 
         do i = 1, min(20, kgp)
            write(nfout,'(" gr(",3i4,") = ",d12.4)') ngabc(i,1),ngabc(i,2),ngabc(i,3),gr_t(i)
         end do
      end if

#ifdef _HEAP_SORT_
     ! Sorting G using heap sorting (M.Okamoto)
!!$      call sort_gvec_heap(ttr,kgp,kgp,ngabc)
!!$      call shellsort(nfout,ipri,ttr,kgp,kgp,ngabc)
      !!$call sort_gvec_heap2(ttr,kgp,kgp,ngabc,gr_t)
      call sort_gvec_heap3(ttr,kgp,kgp,ngabc,gr_t)
      if(ipri >= 2) then
         write(nfout,'(" -- gr after (sort_gvec_heap2) -- <<m_pwBS_generate_G_vectors>>")') 
         do i = 1, min(20, kgp)
            write(nfout,'(" gr(",3i4,") = ",d12.4)') ngabc(i,1),ngabc(i,2),ngabc(i,3),gr_t(i)
         end do
      end if
      call shellsort2(nfout,ipri,ttr,kgp,kgp,ngabc,gr_t)
#elif _SIMPLE_SORT_
     ! Sorting G simply (M.Okamoto)
      call sort_gvec_simple(ttr,kgp,kgp,ngabc)
#else
      call sort_gvec_heap3(ttr,kgp,kgp,ngabc,gr_t)
      if(ipri >= 2) then
         write(nfout,'(" -- gr after (sort_gvec_heap2) -- <<m_pwBS_generate_G_vectors>>")') 
         do i = 1, min(20, kgp)
            write(nfout,'(" gr(",3i4,") = ",d12.4)') ngabc(i,1),ngabc(i,2),ngabc(i,3),gr_t(i)
         end do
      end if
      call shellsort2(nfout,ipri,ttr,kgp,kgp,ngabc,gr_t)
#endif
      if(ipri >= 2) then
         write(nfout,'(" -- gr after sorted -- <<m_pwBS_generate_G_vectors>>")') 
         do i = 1, min(20, kgp)
            write(nfout,'(" gr(",3i4,") = ",d12.4)') ngabc(i,1),ngabc(i,2),ngabc(i,3),gr_t(i)
         end do
      end if

    end subroutine get_Gvectors_in_a_gmaxp_sphere

    subroutine count_Gvectors_in_spheres()
      integer i, j, k
      integer, parameter  :: DP = kind(1.d0)
      real(kind=DP)       :: length_of_Gvector
      call getttr(rltv,ttr)
      kg = 0
      kgp = 0
      kgp_reduced = 0
      kg0 = 0
      if(sw_positron /= OFF) kg_pwf = 0

! =========== KT_add ================================ 13.0F
      if (sw_hybrid_functional /= OFF .and. use_fft_exx ) then
         kg_exx = 0
      endif
      if (sw_hybrid_functional /= OFF ) kgp_exx = 0
! =================================================== 13.0F

! ==== KT_add ============= 13.0U2
      if ( sw_modified_TFW_functional /= OFF ) kg_tfw = 0
! ========================= 13.0U2

      do k = -n_rGpv(3)-1, n_rGpv(3)+1
         do j = -n_rGpv(2)-1, n_rGpv(2)+1
            do i = -n_rGpv(1)-1, n_rGpv(1)+1
               length_of_Gvector = dsqrt(ttr(1)*i*i + ttr(2)*j*j &
                    &                  + ttr(3)*k*k + ttr(4)*i*j &
                    &                  + ttr(5)*j*k + ttr(6)*k*i)
               if(length_of_Gvector <= gmax2) kg = kg + 1
               if(length_of_Gvector <= gmax)  kg0 = kg0 + 1
               if(sw_positron/=OFF .and. length_of_Gvector<=gmax2_pstrn) kg_pwf=kg_pwf+1

! =========== KT_add ================================ 13.0F
               if(sw_hybrid_functional/=OFF .and. use_fft_exx ) then
                  if ( length_of_Gvector<=gmax2_exx) then
                     kg_exx = kg_exx +1
                  endif
               endif
               if(sw_hybrid_functional /= OFF) then
                  if( length_of_Gvector <= gmaxp_exx) then
                     kgp_exx = kgp_exx+1
                  endif
               endif
! =================================================== 13.0F

! ============ KT_add ========== 13.0U2
               if ( sw_modified_TFW_functional /= OFF ) then
                  if ( length_of_Gvector<= gmaxp/2 ) then
                     kg_tfw = kg_tfw +1
                  endif
               endif
! ============================== 13.0U2

               if(length_of_Gvector <= gmaxp) kgp = kgp + 1
               if(length_of_Gvector <= gmaxp_reduced) kgp_reduced = kgp_reduced + 1
               G_length_in_cube(i+n_rGpv(1)+2,j+n_rGpv(2)+2, k+n_rGpv(3)+2) = length_of_Gvector
            enddo
         enddo
      enddo
      if(ipri >= 1) then
         write(nfout,'(" !pwBS kg0, kg, kgp = ",3i10)') kg0, kg, kgp
         write(nfout,'(" !pwBS kgp_reduced  = ",i10)') kgp_reduced
         write(nfout,'(" !pwBS   kg0 = (#G(<=Gmax)), kg = (#G(<=2Gmax)), kgp = (#G(<=Gmaxp))")')
      end if
    end subroutine count_Gvectors_in_spheres

    subroutine adjust_n_rGv_to_2l3m5n
      integer :: i
      do i = 1, 3
         if(n_rGv(i) > fft_box_size_WF(i,1)/2) n_rGv(i)   = fft_box_size_WF(i,1)/2
!!$         if(n_rGpv(i) > fft_box_size_CD(i,1)/2) n_rGpv(i) = fft_box_size_CD(i,1)/2
         if(n_rGpv_reduced(i) > fft_box_size_CD(i,1)/2) n_rGpv_reduced(i) = fft_box_size_CD(i,1)/2
      enddo
    end subroutine adjust_n_rGv_to_2l3m5n
  end subroutine m_pwBS_generate_G_vectors

  subroutine m_pwBS_rebuild_gr_l()
    integer :: i
    call getttr(rltv,ttr)
    gr_l = 0.d0
    do i = ista_kngp, iend_kngp       !for mpi
       gr_l(i) =      dsqrt(ttr(1)*ngabc(i,1)*ngabc(i,1) &
            &             + ttr(2)*ngabc(i,2)*ngabc(i,2) &
            &             + ttr(3)*ngabc(i,3)*ngabc(i,3) &
            &             + ttr(4)*ngabc(i,1)*ngabc(i,2) &
            &             + ttr(5)*ngabc(i,2)*ngabc(i,3) &
            &             + ttr(6)*ngabc(i,3)*ngabc(i,1))
    enddo
    if(ipri >= 2 ) then
       do i = ista_kngp, iend_kngp  !for mpi
          write(nfout,'(" ", i9," = ",f10.5, 3i5)') i, gr_l(i) &
               &, ngabc(i,1),ngabc(i,2),ngabc(i,3)
       enddo
    end if
  end subroutine m_pwBS_rebuild_gr_l

  subroutine m_pwBS_calc_length_of_G
    integer :: id_sname = -1
    integer :: i, k, ngs
    real(kind=DP) :: length_start, length

    call tstatc0_begin('m_pwBS_calc_length_of_G ',id_sname)

    do i = ista_kngp, iend_kngp       !for mpi
       gr_l(i) =      dsqrt(ttr(1)*ngabc(i,1)*ngabc(i,1) &
            &             + ttr(2)*ngabc(i,2)*ngabc(i,2) &
            &             + ttr(3)*ngabc(i,3)*ngabc(i,3) &
            &             + ttr(4)*ngabc(i,1)*ngabc(i,2) &
            &             + ttr(5)*ngabc(i,2)*ngabc(i,3) &
            &             + ttr(6)*ngabc(i,3)*ngabc(i,1))
    enddo

    if(ipri >= 2 ) then
       do i = ista_kngp, iend_kngp  !for mpi
          write(nfout,'(" ", i9," = ",f10.5, 3i5)') i, gr_l(i) &
               &, ngabc(i,1),ngabc(i,2),ngabc(i,3)
       enddo
    end if

    ngshell = 1
    k = ista_kngp+1
    if(iend_kngp < k) goto 11
    length_start = gr_l(ista_kngp)
1   continue
    shellloop: do i = k, iend_kngp
       length = gr_l(i)
       if(length > length_start + DELTA) then
          exit shellloop
       else if(i == iend_kngp) then
          go to 11
       end if
    end do shellloop
    length_start = length
    k = i
    if(k <= iend_kngp) then
       ngshell = ngshell + 1
       goto 1
    end if
11 continue
    if(ipri >= 1 ) write(nfout,'(" !pwbs  ngshell = ",i8)') ngshell

    allocate(ngshell_range(ngshell,2))
    ngs = 1
    k = ista_kngp+1
    length_start = gr_l(ista_kngp)
    ngshell_range(1,1) = ista_kngp
    if(iend_kngp < k) goto 22

2   continue
    shellloop2: do i = k, iend_kngp
       length = gr_l(i)
       if(length > length_start + DELTA) then
          ngshell_range(ngs,2)   = i - 1
          if(ngs+1 <= ngshell) ngshell_range(ngs+1,1) = i
          exit shellloop2
       else if( i == iend_kngp) then
          go to 22
       end if
    end do shellloop2
    length_start = length
    k = i
    if( k <= iend_kngp) then
       ngs = ngs+1
       goto 2
    end if
22 continue
    ngshell_range(ngshell,2) = iend_kngp
    if(ipri >= 2) then
       write(nfout,'(" !pwbs ngshell_range")') 
       write(nfout,'(" !pwbs  ngshell, range1 - range2, nelement, gr")')
       do ngs = 1, ngshell
          write(nfout,'(" !pwbs ",i8, i8," - ",i8, i8, f20.8)') ngs, ngshell_range(ngs,1)&
               & ,ngshell_range(ngs,2),ngshell_range(ngs,2)-ngshell_range(ngs,1)+1,gr_l(ngshell_range(ngs,1))
       end do
    end if

    call tstatc0_end(id_sname)
  end subroutine m_pwBS_calc_length_of_G

  subroutine m_pwBS_setup_FFTmapfunctions
    integer :: id, i
    integer :: igf1, igf2, igf3
    integer :: id_sname = -1
    integer, parameter :: NPRINTLINE = 20
    call tstatc0_begin('m_pwBS_setup_FFTmapfunctions ',id_sname)

    id = fft_box_size_WF(1,0)
    do i = 1, kg
       igf1 = ngabc(i,1) + 1
       igf2 = ngabc(i,2) + 1
       igf3 = ngabc(i,3) + 1
       if(ngabc(i,1) <= -1) igf1 = igf1 + fft_box_size_WF(1,1)
       if(ngabc(i,2) <= -1) igf2 = igf2 + fft_box_size_WF(2,1)
       if(ngabc(i,3) <= -1) igf3 = igf3 + fft_box_size_WF(3,1)
       igf(i) = igf1 + (igf2-1)*id + (igf3-1)*id*fft_box_size_WF(2,0)
    enddo

    ! ------- Positron start 
    if(sw_positron /= OFF) then
       if(    fft_box_size_WF(1,1) == fft_box_size_pWF(1,1) .and. &
            & fft_box_size_WF(2,1) == fft_box_size_pWF(2,1) .and. &
            & fft_box_size_WF(3,1) == fft_box_size_pWF(3,1) .and. &
            & kg == kg_pwf ) then
          igf_pstrn(1:kg_pwf) = igf(1:kg_pwf)
       else
          id = fft_box_size_pWF(1,0)
          do i = 1, kg_pwf
             igf1 = ngabc(i,1) + 1
             igf2 = ngabc(i,2) + 1
             igf3 = ngabc(i,3) + 1
             if(ngabc(i,1) <= -1) igf1 = igf1 + fft_box_size_pWF(1,1)
             if(ngabc(i,2) <= -1) igf2 = igf2 + fft_box_size_pWF(2,1)
             if(ngabc(i,3) <= -1) igf3 = igf3 + fft_box_size_pWF(3,1)
             igf_pstrn(i) = igf1 + (igf2-1)*id + (igf3-1)*id*fft_box_size_pWF(2,0)
          end do
       end if
    end if
    ! ------- Positron end

! ==============  KT_add ============================= 13.0F
    if ( sw_hybrid_functional /= OFF .and. use_fft_exx ) then
       if(    fft_box_size_WF(1,1) == fft_box_size_exx(1,1) .and. &
            & fft_box_size_WF(2,1) == fft_box_size_exx(2,1) .and. &
            & fft_box_size_WF(3,1) == fft_box_size_exx(3,1) .and. &
            & kg == kg_exx ) then
          igf_exx(1:kg_exx) = igf(1:kg_exx)
       else
          id = fft_box_size_exx(1,0)
          do i = 1, kg_exx
             igf1 = ngabc(i,1) + 1
             igf2 = ngabc(i,2) + 1
             igf3 = ngabc(i,3) + 1
             if(ngabc(i,1) <= -1) igf1 = igf1 + fft_box_size_exx(1,1)
             if(ngabc(i,2) <= -1) igf2 = igf2 + fft_box_size_exx(2,1)
             if(ngabc(i,3) <= -1) igf3 = igf3 + fft_box_size_exx(3,1)
             igf_exx(i) = igf1 + (igf2-1)*id + (igf3-1)*id*fft_box_size_exx(2,0)
          end do
       end if
    endif
! ==================================================== 13.0F

    id = fft_box_size_CD(1,0)
    do i = ista_kngp, iend_kngp  !for mpi
       if(i <= kgp_reduced) then
          igf1 = ngabc(i,1) + 1
          igf2 = ngabc(i,2) + 1
          igf3 = ngabc(i,3) + 1
          if(ngabc(i,1) <= -1) igf1 = igf1 + fft_box_size_CD(1,1)
          if(ngabc(i,2) <= -1) igf2 = igf2 + fft_box_size_CD(2,1)
          if(ngabc(i,3) <= -1) igf3 = igf3 + fft_box_size_CD(3,1)
          igfp_l(i) = igf1 + (igf2-1)*id + (igf3-1)*id*fft_box_size_CD(2,0)
#ifdef _MPIFFT_
          igfp_l_c(i) = igf1 + fft_box_size_CD_c(1,0)*( &
               &                    (igf2-1)+ (igf3-1)*fft_box_size_CD_c(2,0))
          igfp_nonpara(i) = igf1 + fft_box_size_CD_nonpara(1,0)*( &
               &                    (igf2-1)+ (igf3-1)*fft_box_size_CD_nonpara(2,0))
#endif
       else
          igfp_l(i) = -1
#ifdef _MPIFFT_
          igfp_l_c(i) = -1
          igfp_nonpara(i) = -1
#endif
       end if
    enddo

    if(iprifftmap >= 2) then
       if(mype == 0) then
          if(sw_positron == OFF) then
             write(nfout,*) ' -- ngabc(1-3),igf,igfp_l --'
             id = NPRINTLINE
             if(id > iend_kngp) id = iend_kngp
             do i = 1, id
                write(nfout,'(" ",8i8)') &
                     & i,ngabc(i,1),ngabc(i,2),ngabc(i,3),igf(i),igfp_l(i)
             end do
          else
             write(nfout,*) ' -- ngabc(1-3),igf,igfp_l,igf_pstrn --'
             id = NPRINTLINE
             if(id > iend_kngp) id = iend_kngp
             do i = 1, id
                write(nfout,'(" ",8i8)') &
                     & i,ngabc(i,1),ngabc(i,2),ngabc(i,3),igf(i),igfp_l(i),igf_pstrn(i)
             end do
          end if
#ifdef _MPIFFT_
          write(nfout,*) ' -- ngabc(1-3),igf,igfp_nonpara --'
          id = NPRINTLINE
          if(id > iend_kngp) id = iend_kngp
          do i = 1, id
             write(nfout,'(" ",8i8)') &
                  & i,ngabc(i,1),ngabc(i,2),ngabc(i,3),igf(i),igfp_nonpara(i)
          end do
#endif          
       endif
       if(mype == npes-1) then
          id = kg-(NPRINTLINE-1)
          if(id < ista_kngp) id = ista_kngp
          if(sw_positron == OFF) then
             do i = id,kg
                write(nfout,'(" ",8i8)') &
                     & i,ngabc(i,1),ngabc(i,2),ngabc(i,3),igf(i),igfp_l(i)
             end do
          else
             if(kg > kg_pwf) kg = kg_pwf
             do i = id,kg
                write(nfout,'(" ",8i8)') &
                     & i,ngabc(i,1),ngabc(i,2),ngabc(i,3),igf(i),igfp_l(i),igf_pstrn(i)
             end do
          end if
       endif
    end if

    if ( sw_hybrid_functional /= OFF ) then
       if(    fft_box_size_CD(1,1) == fft_box_size_CD_exx(1,1) .and. &
            & fft_box_size_CD(2,1) == fft_box_size_CD_exx(2,1) .and. &
            & fft_box_size_CD(3,1) == fft_box_size_CD_exx(3,1) .and. &
            & kgp == kgp_exx ) then
          igfp_exx(ista_kngp:iend_kngp) = igfp_l(ista_kngp:iend_kngp)
          call mpi_allreduce(MPI_IN_PLACE,igfp_exx,kgp_exx,mpi_integer,mpi_sum,mpi_comm_group,ierr)
       else
          id = fft_box_size_CD_exx(1,0)
          do i = 1, kgp_exx
             igf1 = ngabc(i,1) + 1
             igf2 = ngabc(i,2) + 1
             igf3 = ngabc(i,3) + 1
             if(ngabc(i,1) <= -1) igf1 = igf1 + fft_box_size_CD_exx(1,1)
             if(ngabc(i,2) <= -1) igf2 = igf2 + fft_box_size_CD_exx(2,1)
             if(ngabc(i,3) <= -1) igf3 = igf3 + fft_box_size_CD_exx(3,1)
             igfp_exx(i) = igf1 + (igf2-1)*id + (igf3-1)*id*fft_box_size_CD_exx(2,0)
          end do
       end if
    endif
    call tstatc0_end(id_sname)
  end subroutine m_pwBS_setup_FFTmapfunctions
  
  subroutine m_pwBS_GminusGmapfunction()
    integer :: i,igf1,igf2,igf3
    igpo = 0
    nmatsz2 = 0
    do i = 1, kg
       igf1 = ngabc(i,1); igf2 = ngabc(i,2); igf3 = ngabc(i,3)
       if(          igf1 >= -n_rGsv(1) .and. igf1 <= n_rGsv(1) &
            & .and. igf2 >= -n_rGsv(2) .and. igf2 <= n_rGsv(2) &
            & .and. igf3 >= -n_rGsv(3) .and. igf3 <= n_rGsv(3)) then
          igpo(igf1,igf2,igf3) = i
          nmatsz2 = i
       end if
    end do
    if(ipri >= 1) write(nfout,'(" !pwbs nmatsz2 = ",i8 &
         &                ," <<m_pwBS_GminusGmapfunction>>")') nmatsz2
  end subroutine m_pwBS_GminusGmapfunction

  subroutine decide_g_list_size(nfout, mmdim1, mmdim2, mmdim3)
    integer, intent(in)   :: nfout
    integer, intent(out)  :: mmdim1, mmdim2, mmdim3
    mmdim1 = 2*n_rGpv(1)
    mmdim2 = 2*n_rGpv(2)
    mmdim3 = 2*n_rGpv(3)
    if(ipri>=1) then
       write(nfout,*) ' n_rGpv = ', n_rGpv
       write(nfout,*) ' mmdim  = ', mmdim1, mmdim2, mmdim3
    end if
  end subroutine decide_g_list_size
  
  subroutine m_pwBS_G_trans_functions
!              -> ngpt_l
    integer, pointer ,dimension(:,:,:) ::g_list
    integer :: mmdim1, mmdim2, mmdim3
    integer error_count

    if(ipri >= 2) then
       write(nfout,'(" !pwBS: nopr+af = ",i6," <<m_pwBS_G_trans_functions>>")') nopr+af
       write(nfout,'(" !pwBS: nopr, af = ",2i6,"<<m_pwBS_G_trans_functions>>")') nopr,af
    end if
    if(nopr+af > 100) stop ' !! illegal number of nopr+af'
    allocate(op_br(3,3,nopr+af))
    call m_CS_op_in_PUCV(nfout,op_br,nopr+af)
    call decide_g_list_size(nfout, mmdim1, mmdim2,mmdim3 )
    if(ipri >= 1) write(nfout,'(" !pwBS: g_list size = ",3i9)') mmdim1, mmdim2, mmdim3
    allocate(g_list(0:mmdim1,0:mmdim2,0:mmdim3))

    call substitute_g_list
!TS** conjecture of the symmetry point by using the list vector g_list...
    call symmetric_G_points_using_g_list
    call counting_error_points(error_count)
    if(error_count > 0) then
       if(ipri>=1) write(nfout &
            & ,'(" !pwBS: (G_vector_transformation_functions) error_count = ",i9)') error_count
       call symmetric_G_points
    else
       if(ipri>=1) write(nfout,'(" !pwBS: (ngpt_l)s are all decided by using g_list")')
    endif

    deallocate(g_list)
    deallocate(op_br)
  contains

    subroutine substitute_g_list
      integer i, int_gx, int_gy, int_gz
      real(kind=DP) :: gxL, gyL, gzL

      g_list = 0

      if(2*n_rGpv(1)-mmdim1 /=0 .and. 2*n_rGpv(2)-mmdim2 /= 0 .and. 2*n_rGpv(3)-mmdim3 /=0) then
         gxL = 2.d0*n_rGpv(1); gyL = 2.d0*n_rGpv(2); gzL = 2.d0*n_rGpv(3)
!** (This do-loop can be vectorizable.)
!xocl spread do/ind_kngp
         do  i = 1, kgp
            int_gx = (dble(ngabc(i,1))+n_rGpv(1))/gxL*dble(mmdim1)
            int_gy = (dble(ngabc(i,2))+n_rGpv(2))/gyL*dble(mmdim2)
            int_gz = (dble(ngabc(i,3))+n_rGpv(3))/gzL*dble(mmdim3)
            int_gx = max(int_gx,0)
            int_gy = max(int_gy,0)
            int_gz = max(int_gz,0)
            g_list(int_gx,int_gy,int_gz) = i
         enddo
!xocl end spread max(g_list)
      else
!xocl spread do/ind_kngp
         do  i = 1, kgp
            int_gx = ngabc(i,1)+n_rGpv(1)
            int_gy = ngabc(i,2)+n_rGpv(2)
            int_gz = ngabc(i,3)+n_rGpv(3)
            int_gx = max(int_gx,0)
            int_gy = max(int_gy,0)
            int_gz = max(int_gz,0)
            g_list(int_gx,int_gy,int_gz) = i
         enddo
!xocl end spread max(g_list)
      endif
    end subroutine substitute_g_list

    subroutine symmetric_G_points_using_g_list
      integer i
      integer no
      real(kind=DP) :: fx,fy,fz, px,py,pz, distance
      integer       :: int_fx, int_fy, int_fz, nng
      real(kind=DP),  parameter :: epsilon = 1.0d-5
      real(kind=DP) :: gxL, gyL, gzL

      if(2*n_rGpv(1)-mmdim1 /=0 .and. 2*n_rGpv(2)-mmdim2 /= 0 .and. 2*n_rGpv(3)-mmdim3 /=0) then
         gxL = 2.d0*n_rGpv(1); gyL = 2.d0*n_rGpv(2); gzL = 2.d0*n_rGpv(3)
         do i = ista_kngp, iend_kngp  !for mpi
            do no = 1, nopr + af

               px = ngabc(i,1)
               py = ngabc(i,2)
               pz = ngabc(i,3)

               fx=op_br(1,1,no)*px +op_br(1,2,no)*py +op_br(1,3,no)*pz
               fy=op_br(2,1,no)*px +op_br(2,2,no)*py +op_br(2,3,no)*pz
               fz=op_br(3,1,no)*px +op_br(3,2,no)*py +op_br(3,3,no)*pz

               int_fx = (fx + n_rGpv(1)+epsilon)/gxL*dble(mmdim1)
               int_fy = (fy + n_rGpv(2)+epsilon)/gyL*dble(mmdim2)
               int_fz = (fz + n_rGpv(3)+epsilon)/gzL*dble(mmdim3)

               int_fx = max(int_fx,0)
               int_fy = max(int_fy,0)
               int_fz = max(int_fz,0)

               int_fx = min(int_fx,mmdim1)
               int_fy = min(int_fy,mmdim2)
               int_fz = min(int_fz,mmdim3)

               nng = g_list(int_fx,int_fy,int_fz)

               if(nng /= 0) then
                  distance =  abs(ngabc(nng,1)-fx) + abs(ngabc(nng,2)-fy) &
                       &    + abs(ngabc(nng,3)-fz)
                  if(distance < epsilon) then
                     ngpt_l(i,no) = nng
                  else
                     ngpt_l(i,no) = -1
                  end if
               else
                  ngpt_l(i,no) = -1
               end if
            enddo
         enddo
      else

         do i = ista_kngp, iend_kngp  !for mpi
            do no = 1, nopr + af

               px = ngabc(i,1)
               py = ngabc(i,2)
               pz = ngabc(i,3)

               fx=op_br(1,1,no)*px +op_br(1,2,no)*py +op_br(1,3,no)*pz
               fy=op_br(2,1,no)*px +op_br(2,2,no)*py +op_br(2,3,no)*pz
               fz=op_br(3,1,no)*px +op_br(3,2,no)*py +op_br(3,3,no)*pz

               int_fx = fx + n_rGpv(1) + epsilon
               int_fy = fy + n_rGpv(2) + epsilon
               int_fz = fz + n_rGpv(3) + epsilon

               int_fx = max(int_fx,0)
               int_fy = max(int_fy,0)
               int_fz = max(int_fz,0)

               int_fx = min(int_fx,mmdim1)
               int_fy = min(int_fy,mmdim2)
               int_fz = min(int_fz,mmdim3)

               nng = g_list(int_fx,int_fy,int_fz)

               if(nng /= 0) then
                  distance =  abs(ngabc(nng,1)-fx) + abs(ngabc(nng,2)-fy) &
                       &    + abs(ngabc(nng,3)-fz)
                  if(distance < epsilon) then
                     ngpt_l(i,no) = nng
                  else
                     ngpt_l(i,no) = -1
                  end if
               else
                  ngpt_l(i,no) = -1
               end if
            enddo
         enddo
      endif
    end subroutine symmetric_G_points_using_g_list

    subroutine counting_error_points(error_count)
      integer, intent(out) :: error_count

      integer :: i, no
      integer :: e_mpi  ! mpi
      error_count = 0

      do i = ista_kngp, iend_kngp  !for mpi
         do no=1,nopr + af
            if(ngpt_l(i,no) == -1) error_count = error_count + 1
         enddo
      enddo

      if(npes > 1 ) then
         call mpi_allreduce(error_count,e_mpi,1,mpi_integer,mpi_sum,mpi_comm_group,ierr)
         error_count = e_mpi
      end if

    end subroutine counting_error_points

    subroutine symmetric_G_points
      integer :: ierr, i, no, loop, jstart, jend, jstep, j
      integer, parameter :: Nequiv = 50
      integer, parameter :: MAXERR = 100
      real(kind=DP) :: px,py,pz, fx,fy,fz, ff1
      ierr = 0

      do i = ista_kngp, iend_kngp  !for mpi
         px = ngabc(i,1)
         py = ngabc(i,2)
         pz = ngabc(i,3)
         do no=1,nopr + af

            if(ngpt_l(i,no).eq.-1) then

               fx=op_br(1,1,no)*px +op_br(1,2,no)*py +op_br(1,3,no)*pz
               fy=op_br(2,1,no)*px +op_br(2,2,no)*py +op_br(2,3,no)*pz
               fz=op_br(3,1,no)*px +op_br(3,2,no)*py +op_br(3,3,no)*pz
               do loop = 1, 2
                  if(loop.eq.1) then
                     jstart = i - Nequiv + 1
                     if(jstart.le.0) jstart = 1
                     jend = kgp
                     jstep = 1
                  else if(loop.eq.2) then
                     jstart = i - Nequiv
                     jend = 1
                     jstep = -1
                  endif
!*vocl loop, vi(j)
                  do j = jstart, jend, jstep
                     ff1 = abs(ngabc(j,1)-fx) +abs(ngabc(j,2)-fy) +abs(ngabc(j,3)-fz)
                     if (ff1.le.1.d-5) then
                        ngpt_l(i,no) = j
                        goto 111
                     end if
                  enddo
               enddo
               if(ipri >= 1) write(nfout,130) i,no
               ierr = ierr + 1
               if(ierr.ge.MAXERR) goto 1001
111            continue

            endif

         enddo
      enddo

130   FORMAT(' ','THERE IS NO PAIR FOR NG,NOP=',2I8)
1001  if(ierr.ge.1) then
         if(ipri >= 1 ) write(nfout,*) ' No pair was discovered for at least ',ierr &
              &       ,'s combinations'
         stop
      endif
      
    end subroutine symmetric_G_points

  end subroutine m_pwBS_G_trans_functions

  subroutine m_pwBS_sphrp_l()
    integer :: is
    real(kind=DP), allocatable, dimension(:) :: ylm
    allocate(ylm(ista_kngp:iend_kngp))
    if(ipri >= 1) write(nfout,'(" !pwBS: nel_Ylm = ",i5," (m_pwBS_sphrp)")') nel_Ylm
    if(nel_Ylm >= 1 .and. .not.allocated(ylm_l)) stop ' ylm_l is not allocated (m_pwBS_sphrp_l)'
    do is = 1, nel_Ylm
       call m_pwBS_sphrp2(is,rltv,ista_kngp,iend_kngp,ylm)
       ylm_l(:,is) = ylm(:)
    end do
    deallocate(ylm)
  end subroutine m_pwBS_sphrp_l

  subroutine m_pwBS_sphrp2(is,rltv,ista_ylm,iend_ylm,ylm)
    integer, intent(in) :: is
    real(kind=DP), intent(in), dimension(3,3)  :: rltv
    integer, intent(in) :: ista_ylm, iend_ylm
    real(kind=DP), intent(inout), dimension(ista_ylm:iend_ylm) :: ylm
!!$C spherical harmonics.
!!$c     Some lines are rewritten by T.Yamasaki according to Y.Morikawa's
!!$c   e-mail. at 4th May 1994

    integer :: i,ni
    real(kind=DP) a,b,c,d,e,f,gx,gy,gz
    real(kind=DP) b1x,b1y,b1z,b2x,b2y,b2z,b3x,b3y,b3z

    b1x = rltv(1,1);  b1y = rltv(2,1);  b1z = rltv(3,1)
    b2x = rltv(1,2);  b2y = rltv(2,2);  b2z = rltv(3,2)
    b3x = rltv(1,3);  b3y = rltv(2,3);  b3z = rltv(3,3)

    ni = ista_ylm
    if(ngabc(1,1) == 0 .and. ngabc(1,2) == 0 .and. ngabc(1,3) == 0) then
       if(ni == 1) then
          ni = 2
          ylm(1) = dsqrt(1.d0/PAI4)
       endif
    end if
    if(is == 1) then
       a = dsqrt(1.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          ylm(i) = a
       end do
    else if(is == 2) then
       a = dsqrt(3.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          ylm(i) = a*gx/gr_l(i)
       end do
    else if(is == 3) then
       a = dsqrt(3.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          gy =   b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          ylm(i) = a*gy/gr_l(i)
       end do
    else if(is == 4) then
       a = dsqrt(3.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          gz =   b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          ylm(i) = a*gz/gr_l(i)
       end do
    else if(is == 5) then
       a = dsqrt(5.d0/(16*PAI))
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2)  + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2)  + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2)  + b3z*ngabc(i,3)
          d = gz**2
          e = gx**2+gy**2+d
          ylm(i) = a*(3*d-e)/e
       end do
    else if(is == 6) then
       a = dsqrt(15.d0/(16*PAI))
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2)  + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2)  + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2)  + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          e = b+c+gz**2
          ylm(i) = a*(b-c)/e
       end do
    else if(is == 7) then
       a = dsqrt(15.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          e = gr_l(i)**2
          ylm(i) = a*gx*gy/e
       end do
    else if(is == 8) then
       a = dsqrt(15.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2)  + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2)  + b3z*ngabc(i,3)
          e = gr_l(i)**2
          ylm(i) = a*gy*gz/e
       end do
    else if(is == 9) then
       a = dsqrt(15.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          e = gr_l(i)**2
          ylm(i) = a*gz*gx/e
       end do
    else if(is == 10) then
       a = dsqrt(7.d0/(16*PAI))
       do i = ni, iend_ylm  !for mpi
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          d = gz**2
          e = gr_l(i)**2
          f = e * gr_l(i)
          ylm(i) = a*gz*(5*d-3*e)/f
       end do
    else if(is == 11) then
       a = dsqrt(21.d0/(32*PAI))
       do i = ni, iend_ylm  !for mpi
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2)  + b3z*ngabc(i,3)
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2)  + b3x*ngabc(i,3)
          d = gz**2
          e = gr_l(i)**2
          f = e * gr_l(i)
          ylm(i) = a*gx*(5*d-e)/f
       end do
    else if(is == 12) then
       a = dsqrt(21.d0/(32*PAI))
       do i = ni, iend_ylm  !for mpi
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          d = gz**2
          e = gr_l(i)**2
          f = e * gr_l(i)
          ylm(i) = a*gy*(5*d-e)/f
       end do
    else if(is == 13) then
       a = dsqrt(105.d0/(16*PAI))
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          e = gr_l(i)**2
          f = e * gr_l(i)
          ylm(i) = a*gz*(b-c)/f
       end do
    else if(is == 14) then
       a = dsqrt(105.d0/PAI4)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2)  + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2)  + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2)  + b3z*ngabc(i,3)
          f = gr_l(i)**3
          ylm(i) = a*gx*gy*gz/f
       end do
    else if(is == 15) then
       a = dsqrt(35.d0/(32*PAI))
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          f = gr_l(i)**3
          ylm(i) = a*gx*(b-3*c)/f
       end do
    else if(is == 16) then
       a = dsqrt(35.d0/(32*pai))
       do i = ni, iend_ylm !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          f = gr_l(i)**3
          ylm(i) = a*gy*(3*b-c)/f
       end do
    else if(is == 17) then
       a = 3.d0/8.d0/dsqrt(PAI4)
       do i = ni, iend_ylm  !for mpi
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          d = gz**2
          e = gr_l(i)**2
          f = e**2
          ylm(i) = a*(5*d*(7*d-6*e)/f+3.d0)
       end do
    else if(is == 18) then
       a = 15.d0/4.d0/dsqrt(10*PAI)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          d = gz**2
          e = gr_l(i)**2
          f = e**2
          ylm(i) = a*gz*gx*(7*d-3*e)/f
       end do
    else if(is == 19) then
       a = 15.d0/4.d0/dsqrt(10.d0*PAI)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2)  + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2)  + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2)  + b3z*ngabc(i,3)
          d = gz**2
          e = gr_l(i)**2
          f = e**2
          ylm(i) = a*gy*gz*(7*d-3*e)/f
       end do
    else if(is == 20) then
       a = 15.d0/8.d0/dsqrt(5*PAI)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2)  + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2)  + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2)  + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b+c+d
          f = e**2
          ylm(i) = a*(7*d-e)*(b-c)/f
       end do
    else if(is == 21) then
       a = 15.d0/4.d0/dsqrt(5*PAI)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          d = gz**2
          e = gr_l(i)**2
          f = e**2
          ylm(i) = a*(7*d-e)*gx*gy/f
       end do
    else if(is == 22) then
       a = 105.d0/4.d0/dsqrt(70*pai)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          f = (b+c+gz**2)**2
          ylm(i) = a*(b-3*c)*gz*gx/f
       end do
    else if(is == 23) then
       a = 105.d0/4.d0/dsqrt(70*PAI)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          f = (b+c+gz**2)**2
          ylm(i) = a*(3.d0*b-c)*gy*gz/f
       end do
    else if(is == 24) then
       a = 105.d0/16.d0/dsqrt(35*PAI)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2)  + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2)  + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2)  + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          f = (b+c+gz**2)**2
          ylm(i) = a*((b-c)**2-4*b*c)/f
       end do
    else if(is == 25) then
       a = 105.d0/4.d0/dsqrt(35*PAI)
       do i = ni, iend_ylm  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2)  + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2)  + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2)  + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          f = (b+c+gz**2)**2
          ylm(i) = a*(b-c)*gx*gy/f
       end do
    end if
  end subroutine m_pwBS_sphrp2

  subroutine m_pwBS_sphrp2_diff(is,rltv,ylmd)
!!$C derivative of spherical harmonics coded by H. Sawada 8th May 1997

    integer, intent(in) :: is
    real(kind=DP), intent(in),  dimension(3,3)                   :: rltv
    real(kind=DP), intent(out), dimension(ista_kngp:iend_kngp,3) :: ylmd

    integer       :: i,ni
    real(kind=DP) :: a,b,c,d,e,e2,e3,gr,gr3,gr5,gx,gy,gz,t
    real(kind=DP) :: b1x,b1y,b1z,b2x,b2y,b2z,b3x,b3y,b3z

    b1x = rltv(1,1);  b1y = rltv(2,1);  b1z = rltv(3,1)
    b2x = rltv(1,2);  b2y = rltv(2,2);  b2z = rltv(3,2)
    b3x = rltv(1,3);  b3y = rltv(2,3);  b3z = rltv(3,3)

    ni = ista_kngp
    if(ngabc(1,1) == 0 .and. ngabc(1,2) == 0 .and. ngabc(1,3) == 0) then
       if(ista_kngp ==1) then
          ni = 2
          ylmd(1,1) = 0.d0
          ylmd(1,2) = 0.d0
          ylmd(1,3) = 0.d0
       endif
    end if
    if(is == 1) then
       a = 0.d0
       do i = ni, iend_kngp !for mpi
          ylmd(i,1) = a
          ylmd(i,2) = a
          ylmd(i,3) = a
       end do
    else if(is == 2) then
       a = dsqrt(3.d0/PAI4)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          gr = dsqrt( e )
          gr3 = gr * e
          ylmd(i,1) = a* ( -b/gr3 + 1.d0/gr )
          ylmd(i,2) = a* ( -gx*gy/gr3 )
          ylmd(i,3) = a* ( -gx*gz/gr3 )
       enddo
    else if(is == 3) then
       a = dsqrt(3.d0/PAI4)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          gr = dsqrt( e )
          gr3 = gr * e
          ylmd(i,1) = a* ( -gx*gy/gr3 )
          ylmd(i,2) = a* ( -c/gr3 + 1.d0/gr )
          ylmd(i,3) = a* ( -gy*gz/gr3 )
       enddo
    else if(is == 4) then
       a = dsqrt(3.d0/PAI4)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          gr = sqrt( e )
          gr3 = gr * e
          ylmd(i,1) = a* ( -gx*gz/gr3 )
          ylmd(i,2) = a* ( -gy*gz/gr3 )
          ylmd(i,3) = a* ( -d/gr3 + 1.d0/gr )
       enddo
    else if(is == 5) then
       a = dsqrt(5.d0/(16*PAI))
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          t  = 2*(3*d - e)/e2
          ylmd(i,1) = a* ( -2*gx/e - t*gx)
          ylmd(i,2) = a* ( -2*gy/e - t*gy)
          ylmd(i,3) = a* (  4*gz/e - t*gz)
       enddo
    else if(is == 6) then
       a = dsqrt(15.d0/(16*PAI))
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          t = -2*(b-c)/e2
          ylmd(i,1) = a* ( t*gx + 2*gx/e )
          ylmd(i,2) = a* ( t*gy - 2*gy/e )
          ylmd(i,3) = a* ( t*gz )
       enddo
    else if(is == 7) then
       a = dsqrt(15.d0/PAI4)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          ylmd(i,1) = a* ( -2*b*gy/e2 + gy/e )
          ylmd(i,2) = a* ( -2*c*gx/e2 + gx/e )
          ylmd(i,3) = a* ( -2*gx*gy*gz/e2 )
       enddo
    else if(is == 8) then
       a = dsqrt(15.d0/PAI4)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          ylmd(i,1) = a* ( -2*gx*gy*gz/e2 )
          ylmd(i,2) = a* ( -2*c*gz/e2 + gz/e )
          ylmd(i,3) = a* ( -2*d*gy/e2 + gy/e )
       enddo
    else if(is == 9) then
       a = dsqrt(15.d0/PAI4)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          ylmd(i,1) = a* ( -2*b*gz/e2 + gz/e )
          ylmd(i,2) = a* ( -2*gx*gy*gz/e2 )
          ylmd(i,3) = a* ( -2*d*gx/e2 + gx/e )
       enddo
    else if(is == 10) then
       a = dsqrt(7.d0/(16*PAI))
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          gr = dsqrt( e )
          gr3 = gr * e
          gr5 = gr3 * e
          t   = 3*(5*d-3*e)/gr5
          ylmd(i,1) = a* ( -6*gx*gz/gr3 - gx*gz*t )
          ylmd(i,2) = a* ( -6*gy*gz/gr3 - gy*gz*t )
          ylmd(i,3) = a* ( 4*d/gr3 - d*t + (5*d-3*e)/gr3 )
       enddo
    else if(is == 11) then
       a = dsqrt(21.d0/(32*PAI))
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          gr = dsqrt( e )
          gr3 = gr * e
          gr5 = gr3 * e
          t   = 3*(5*d-e)/gr5
          ylmd(i,1) = a* ( -2*b/gr3      - b*t     + (5*d-e)/gr3 )
          ylmd(i,2) = a* ( -2*gx*gy/gr3  - gx*gy*t )
          ylmd(i,3) = a* ( 8*gx*gz/gr3   - gx*gz*t )
       enddo
    else if(is == 12) then
       a = dsqrt(21.d0/(32*PAI))
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          gr = dsqrt( e )
          gr3 = gr * e
          gr5 = gr3 * e
          t   = 3*(5*d-e)/gr5
          ylmd(i,1) = a* ( -2*gx*gy/gr3 - gx*gy*t )
          ylmd(i,2) = a* ( -2*c/gr3     - c*t     + (5*d-e)/gr3 )
          ylmd(i,3) = a* ( 8*gy*gz/gr3  - gy*gz*t )
       enddo
    else if(is == 13) then
       a = dsqrt(105.d0/(16*PAI))
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          gr = dsqrt( e )
          gr3 = gr * e
          gr5 = gr3 * e
          t = 3*(b-c)/gr5
          ylmd(i,1) = a* ( -gx*gz*t + 2*gx*gz/gr3 )
          ylmd(i,2) = a* ( -gy*gz*t - 2*gy*gz/gr3 )
          ylmd(i,3) = a* ( -d*t     + (b-c)/gr3 )
       enddo
    else if(is == 14) then
       a = dsqrt(105.d0/PAI4)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          gr = dsqrt( e )
          gr3 = gr * e
          gr5 = gr3 * e
          ylmd(i,1) = a* ( -3*b*gy*gz/gr5   + gy*gz/gr3 )
          ylmd(i,2) = a* ( -3*gx*c*gz/gr5   + gx*gz/gr3 )
          ylmd(i,3) = a* ( -3*gx*gy*d/gr5   + gx*gy/gr3 )
       enddo
    else if(is == 15) then
       a = dsqrt(35.d0/(32*PAI))
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          gr = dsqrt( e )
          gr3 = gr * e
          gr5 = gr3 * e
          t   = 3*(b-3*c)/gr5
          ylmd(i,1) = a* ( -b*t     + 3*(b-c)/gr3 )
          ylmd(i,2) = a* ( -gx*gy*t - 6*gx*gy/gr3 )
          ylmd(i,3) = a* ( -gx*gz*t )
       enddo
    else if(is == 16) then
       a = dsqrt(35.d0/(32*PAI))
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          gr = dsqrt( e )
          gr3 = gr * e
          gr5 = gr3 * e
          t   = 3*(3*b-c)/gr5
          ylmd(i,1) = a* ( -t*gx*gy  + 6*gx*gy/gr3 )
          ylmd(i,2) = a* ( -t*c      + 3*(b-c)/gr3 )
          ylmd(i,3) = a* ( -t*gy*gz )
       enddo
    else if(is == 17) then
       a = 3.d0/8.d0/dsqrt(PAI4)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          e3 = e * e2
          t  = 20*d*(7*d - 6*e)/e3
          ylmd(i,1) = a* ( -60*gx*d/e2 - t*gx )
          ylmd(i,2) = a* ( -60*gy*d/e2 - t*gy )
          ylmd(i,3) = a* ( 10*gz*d/e2  - t*gz + 10*gz*(7*d-6*e)/e2 )
       enddo
    else if(is == 18) then
       a = 15.d0/4.d0/dsqrt(10*PAI)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          e3 = e * e2
          t  = 4*(7*d - 3*e)/e3
          ylmd(i,1) = a* ( -6*b*gz/e2     - t*b*gz + gz*(7*d-3*e)/e2 )
          ylmd(i,2) = a* ( -6*gx*gy*gz/e2 - t*gx*gy*gz )
          ylmd(i,3) = a* ( 8*gx*d/e2      - t*gx*d + gx*(7*d-3*e)/e2 )
       enddo
    else if(is == 19) then
       a = 15.d0/4.d0/dsqrt(10*PAI)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          e3 = e * e2
          t  = 4*(7*d-3*e)/e3
          ylmd(i,1) = a* ( -6*gx*gy*gz/e2 - t*gx*gy*gz )
          ylmd(i,2) = a* ( -6*c*gz/e2     - t*c*gz     + gz*(7*d-3*e)/e2 )
          ylmd(i,3) = a* ( 8*gy*d/e2      - t*gy*d     + gy*(7*d-3*e)/e2 )
       enddo
    else if(is == 20) then
       a = 15.d0/8.d0/dsqrt(5*PAI)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          e3 = e * e2
          t  = 4*(b-c)*(7*d-e)/e3
          ylmd(i,1) = a* ( -2*gx*(b-c)/e2 - t*gx + 2*gx*(7*d-e)/e2 )
          ylmd(i,2) = a* ( -2*gy*(b-c)/e2 - t*gy - 2*gy*(7*d-e)/e2 )
          ylmd(i,3) = a* ( 12*gz*(b-c)/e2 - t*gz )
       enddo
    else if(is == 21) then
       a = 15.d0/4.d0/dsqrt(5*PAI)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          e3 = e * e2
          t  = 4*(7*d-e)/e3
          ylmd(i,1) = a* ( -2*b*gy/e2 - t*b*gy + gy*(7*d-e)/e2 )
          ylmd(i,2) = a* ( -2*gx*c/e2 - t*gx*c + gx*(7*d-e)/e2 )
          ylmd(i,3) = a* ( 12*gx*gy*gz/e2 - t*gx*gy*gz )
       enddo
    else if(is == 22) then
       a = 105.d0/4.d0/dsqrt(70*PAI)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          e3 = e * e2
          t  = 4*(b-3*c)/e3
          ylmd(i,1) = a* ( -t*b*gz     + 3*gz*(b-c)/e2 )
          ylmd(i,2) = a* ( -t*gx*gy*gz - 6*gx*gy*gz/e2 )
          ylmd(i,3) = a* ( -t*gx*d     + gx*(b-3*c)/e2 )
       enddo
    else if(is == 23) then
       a = 105.d0/4.d0/dsqrt(70*PAI)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          e3 = e * e2
          t  = 4*(3*b-c)/e3
          ylmd(i,1) = a* ( -t*gx*gy*gz + 6*gx*gy*gz/e2 )
          ylmd(i,2) = a* ( -t*c*gz     + 3*gz*(b-c)/e2 )
          ylmd(i,3) = a* ( -t*gy*d     + gy*(3*b-c)/e2 )
       enddo
    else if(is == 24) then
       a = 105.d0/16.d0/dsqrt(35*PAI)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          e3 = e * e2
          t = 4*(-4*b*c+(b-c)**2)/e3
          ylmd(i,1) = a* ( -t*gx + (-8*gx*c+4*gx*(b-c))/e2 )
          ylmd(i,2) = a* ( -t*gy + (-8*b*gy-4*gy*(b-c))/e2 )
          ylmd(i,3) = a* ( -t*gz )
       enddo
    else if(is == 25) then
       a = 105.d0/4.d0/dsqrt(35*PAI)
       do i = ni, iend_kngp  !for mpi
          gx = b1x*ngabc(i,1) + b2x*ngabc(i,2) + b3x*ngabc(i,3)
          gy = b1y*ngabc(i,1) + b2y*ngabc(i,2) + b3y*ngabc(i,3)
          gz = b1z*ngabc(i,1) + b2z*ngabc(i,2) + b3z*ngabc(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b + c + d
          e2 = e**2
          e3 = e * e2
          t = 4*(b-c)/e3
          ylmd(i,1) = a* ( -t*b*gy + gy*(3*b-c)/e2 )
          ylmd(i,2) = a* ( -t*gx*c + gx*(b-3*c)/e2 )
          ylmd(i,3) = a* ( -t*gx*gy*gz )
       enddo
    end if
  end subroutine m_pwBS_sphrp2_diff

! === necessary to make 3D_Parallel, too!!! by tkato ===========================
!!BRANCH_P ORG_Parallel
! ==============================================================================
  subroutine m_pwBS_kinetic_energies(ik,vkxyz,ekin)
    integer, intent(in)       :: ik
    real(kind=DP), intent(in) :: vkxyz(kv3,3,CRDTYP)
    real(kind=DP), intent(out):: ekin(kg1)

    integer i, nb
    real(kind=DP) :: ga,gb,gc
    integer       :: id_sname = -1
    call tstatc0_begin('m_pwBS_kinetic_energies ',id_sname)
    call getttr(rltv,ttr)

    do i = 1, iba(ik)
       nb = nbase(i,ik)
       ga = vkxyz(ik,1,BUCS) + ngabc(nb,1)
       gb = vkxyz(ik,2,BUCS) + ngabc(nb,2)
       gc = vkxyz(ik,3,BUCS) + ngabc(nb,3)
       ekin(i) = ( ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
            &  +   ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga)*0.5d0
    end do
    call tstatc0_end(id_sname)
  end subroutine m_pwBS_kinetic_energies
! === necessary to make 3D_Parallel, too!!! by tkato ===========================
!!BRANCH_P_END ORG_Parallel
! ==============================================================================

  ! ------- Positron start
  subroutine m_pwBS_pstrn_kinetic_energies(ekin)
    real(kind=DP), intent(out):: ekin(kg1_pwf)

    integer i, nb
    real(kind=DP) :: ga,gb,gc
    integer       :: id_sname = -1
    call tstatc0_begin('m_pwBS_pstrn_kinetic_energies ',id_sname)
    call getttr(rltv,ttr)

    do i = 1, kg1_pwf
       nb = i
       ga = ngabc(nb,1)
       gb = ngabc(nb,2)
       gc = ngabc(nb,3)
       ekin(i) = ( ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
            &  +   ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga)*0.5d0
    end do
    call tstatc0_end(id_sname)
  end subroutine m_pwBS_pstrn_kinetic_energies
  ! ------- Positron end

  subroutine m_pwBS_find_min_max_G(nfout,nspin,ng_max,ng_min,n_max,n_min)
    integer, intent(in)    :: nfout,nspin
    integer, intent(inout) :: ng_max, ng_min
    integer, intent(out)   :: n_max(3),n_min(3)

    integer             :: nb, ik, i

    if(ng_max == 0 .and. ng_min == 0) then
       nb = nbase(1,1)
       ng_max=max(ngabc(nb,1),ngabc(nb,2),ngabc(nb,3))
       ng_min=min(ngabc(nb,1),ngabc(nb,2),ngabc(nb,3))

       n_max(1)=ngabc(nb,1); n_max(2)=ngabc(nb,2); n_max(3)=ngabc(nb,3)
       n_min(1)=ngabc(nb,1); n_min(2)=ngabc(nb,2); n_min(3)=ngabc(nb,3)
       do ik = 1, kv3, nspin
          do i=1,iba(ik)
             nb = nbase(i,ik)
             ng_max=max(ng_max,ngabc(nb,1),ngabc(nb,2),ngabc(nb,3))
             ng_min=min(ng_min,ngabc(nb,1),ngabc(nb,2),ngabc(nb,3))
             n_max(1) = max(n_max(1), ngabc(nb,1))
             n_max(2) = max(n_max(2), ngabc(nb,2))
             n_max(3) = max(n_max(3), ngabc(nb,3))
             n_min(1) = min(n_min(1), ngabc(nb,1))
             n_min(2) = min(n_min(2), ngabc(nb,2))
             n_min(3) = min(n_min(3), ngabc(nb,3))
          end do
       end do
       if(ipri >= 1) then
          write(nfout,*) ' n_min1,n_max1 = ',n_min(1),n_max(1)
          write(nfout,*) ' n_min2,n_max2 = ',n_min(2),n_max(2)
          write(nfout,*) ' n_min3,n_max3 = ',n_min(3),n_max(3)
          write(nfout,*) ' ng_min,ng_max = ',ng_min,  ng_max
       end if
    end if
  end subroutine m_pwBS_find_min_max_G

  subroutine m_pwBS_decide_cutoff_mix
    if(cutoff_mix == SMALL) then
       kgpm = kg1_ext
    else if(cutoff_mix == MEDIUM) then
       kgpm = kg
    else if(cutoff_mix == LARGE) then 
       kgpm  = kgp
    end if
    if(mype == 0) then
      !!$ print '(" !! cutoff_mix = ",i4)', cutoff_mix
      !!$ print '(" !! kgpm       = ",i8)', kgpm
    end if
  end subroutine m_pwBS_decide_cutoff_mix

  subroutine m_pwBS_wd_ngabc_etc(nfcntn_bin)
    integer,intent(in) :: nfcntn_bin

    integer,pointer,dimension(:) :: igfp_mpi,igfp_mpi2
    integer :: i

    if(mype == 0) write(nfcntn_bin) ngabc
    if(mype == 0) write(nfcntn_bin) igf
    if(npes > 1) then
       allocate(igfp_mpi(kgp));allocate(igfp_mpi2(kgp))
       igfp_mpi = 0
#ifdef _MPIFFT_
       do i = ista_kngp, iend_kngp
          igfp_mpi(i) = igfp_nonpara(i)
       end do
#else
       do i = ista_kngp, iend_kngp
          igfp_mpi(i) = igfp_l(i)
       end do
#endif
       call mpi_allreduce(igfp_mpi,igfp_mpi2,kgp,mpi_integer,mpi_sum &
            &            ,mpi_comm_group,ierr)
       if(mype == 0) write(nfcntn_bin) igfp_mpi2
    else
#ifdef _MPIFFT_
       write(nfcntn_bin) igfp_nonpara
#else
       write(nfcntn_bin) igfp_l
#endif
    end if
    if(mype == 0) write(nfcntn_bin) kg,kgp
    if(mype == 0) write(nfcntn_bin) nbase
    if(mype == 0) write(nfcntn_bin) iba
    if(mype == 0) write(nfcntn_bin) ttr
  end subroutine m_pwBS_wd_ngabc_etc

  subroutine m_pwBS_increase_kg1(iadd)
    integer, intent(in) :: iadd
    kg1 = kg1 + iadd
    kg1_ext = kg1_ext + iadd
    if(ipri >= 1) write(nfout,'(" !pwBS: kg1 is increased to be ",i9)') kg1
    if(ipri >= 1) write(nfout,'(" !pwBS: kg1_ext is increased to be ",i9)') kg1_ext
  end subroutine m_pwBS_increase_kg1

  subroutine m_pwBS_cp_iba_to_iba_ek()
     integer :: i
     if(.not.allocated(iba_ek)) allocate(iba_ek(kv3_ek))
     iba_ek = iba

     if(ipri >= 3) then
        do i = 1, kv3_ek
           write(nfout,'(" iba_ek(",i6,") = ",i6 &
                & ," <<m_pwBS_cp_iba_to_iba_ek>>")') i, iba_ek(i)
        end do
     end if

  end subroutine m_pwBS_cp_iba_to_iba_ek

  subroutine m_pwBS_cp_iba_ek_to_iba(nk)
     integer, intent(in) :: nk
     integer :: kvt, i

     call mpi_barrier(mpi_comm_group,ierr)
     if(allocated(iba)) then
        deallocate(iba)
        allocate(iba(kv3))
        if(ipri >= 3) write(nfout,'(" iba is allocated <<m_pwBS_cp_iba_ek_to_iba>>")')
     end if

     if(nk > kv3_ek ) then
        if(ipri >= 1) write(nfout,'(" nk = ",i6," > kv3_ek = ",i6)') nk, kv3_ek
        stop ' nk > kv3_ek <<m_pwBS_cp_iba_ek_to_iba>>'
     end if

     if(fixed_charge_k_parallel == ONE_BY_ONE .and. nk+kv3-1 > kv3_ek) then
        kvt = kv3_ek - nk + 1
        iba(1:kvt) = iba_ek(nk:kv3_ek)
        do i = kvt+1, kv3
           iba(i) = iba_ek(kv3_ek)
        end do
     else
        iba(1:kv3) = iba_ek(nk:nk+kv3-1)
     end if
     if(ipri >= 2) then
        do i = 1, kv3
           write(nfout,'(" iba(",i6,") = ",i6 &
                & ," <<m_pwBS_cp_iba_ek_to_iba>>")') i, iba(i)
        end do
     end if
   end subroutine m_pwBS_cp_iba_ek_to_iba

   subroutine m_pwBS_get_igfp(ista,iend,igfp,idp,idp2,nboxsize)
     integer, intent(in) :: ista,iend,idp,idp2,nboxsize(3)
     integer, intent(out),dimension(ista:iend) :: igfp

     integer :: igf1, igf2, igf3, i, nlp,nnm,nnn
     nlp = nboxsize(1)
     nnm = nboxsize(2)
     nnn = nboxsize(3)

     do i = ista, iend  !for mpi
        igf1 = ngabc(i,1) + 1
        igf2 = ngabc(i,2) + 1
        igf3 = ngabc(i,3) + 1
        if(ngabc(i,1) <= -1) igf1 = igf1 + nlp
        if(ngabc(i,2) <= -1) igf2 = igf2 + nnm
        if(ngabc(i,3) <= -1) igf3 = igf3 + nnn
        igfp(i) = igf1 + (igf2-1)*idp + (igf3-1)*idp*idp2
     end do
   end subroutine m_pwBS_get_igfp

   subroutine m_pwBS_dealloc
     if(allocated(ngabc)) deallocate(ngabc)
 
     if(allocated(ngpt_l)) deallocate(ngpt_l)
     if(allocated(igfp_l)) deallocate(igfp_l)
     if(allocated(igf)) deallocate(igf)
     if(allocated(gr_l)) deallocate(gr_l)
 
     if(allocated(ngshell_range)) deallocate(ngshell_range)
 
     if(allocated(nbase)) deallocate(nbase)
 
     if(allocated(ylm_l)) deallocate(ylm_l)

     if(allocated(nbase_gamma)) deallocate(nbase_gamma)
 
#ifdef _MPIFFT_
     if(allocated(igfp_l_c)) deallocate(igfp_l_c)
     if(allocated(igfp_nonpara)) deallocate(igfp_nonpara)
#endif

     if(allocated(iba)) deallocate(iba)

     kg1_ext = 0

   end subroutine m_pwBS_dealloc

!------------------------------------------------------------------------------
!------------------------------------------------------------------------------


  subroutine m_pwBS_sphrp_exx(is,rltv,ista_ylm,iend_ylm,gqmk,gqmkr,ylm)
    integer, intent(in) :: is
    real(kind=DP), intent(in), dimension(3,3)  :: rltv
    integer, intent(in) :: ista_ylm, iend_ylm
    real(kind=DP), intent(in), dimension(ista_ylm:iend_ylm,3) :: gqmk
    real(kind=DP), intent(inout), dimension(ista_ylm:iend_ylm) :: gqmkr
    real(kind=DP), intent(out), dimension(ista_ylm:iend_ylm) :: ylm
!!$C spherical harmonics.
!!$c     Some lines are rewritten by T.Yamasaki according to Y.Morikawa's
!!$c   e-mail. at 4th May 1994

    integer :: i,ni
    real(kind=DP) a,b,c,d,e,f,gx,gy,gz
    real(kind=DP) b1x,b1y,b1z,b2x,b2y,b2z,b3x,b3y,b3z
    real(kind=DP) :: gqmkr0

    b1x = rltv(1,1);  b1y = rltv(2,1);  b1z = rltv(3,1)
    b2x = rltv(1,2);  b2y = rltv(2,2);  b2z = rltv(3,2)
    b3x = rltv(1,3);  b3y = rltv(2,3);  b3z = rltv(3,3)

    ni = 0
    do i=ista_ylm,iend_ylm
       if(gqmkr(i) < DELTA) then
          ni = i
          gqmkr0 = gqmkr(i)
          gqmkr(i) = 1.d0
       end if
    end do

    if(is == 1) then
       a = dsqrt(1.d0/PAI4)
       do i = ista_ylm, iend_ylm  !for mpi
          ylm(i) = a
       end do
    else if(is == 2) then
       a = dsqrt(3.d0/PAI4)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2) + b3x*gqmk(i,3)
          ylm(i) = a*gx/gqmkr(i)
       end do
    else if(is == 3) then
       a = dsqrt(3.d0/PAI4)
       do i = ista_ylm, iend_ylm  !for mpi
          gy =   b1y*gqmk(i,1) + b2y*gqmk(i,2) + b3y*gqmk(i,3)
          ylm(i) = a*gy/gqmkr(i)
       end do
    else if(is == 4) then
       a = dsqrt(3.d0/PAI4)
       do i = ista_ylm, iend_ylm  !for mpi
          gz =   b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          ylm(i) = a*gz/gqmkr(i)
       end do
    else if(is == 5) then
       a = dsqrt(5.d0/(16*PAI))
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2)  + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2)  + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2)  + b3z*gqmk(i,3)
          d = gz**2
          e = gx**2+gy**2+d
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*(3*d-e)/e
          if(abs(e) > tiny(e)) then
             ylm(i) = a*(3*d-e)/e
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 6) then
       a = dsqrt(15.d0/(16*PAI))
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2)  + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2)  + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2)  + b3z*gqmk(i,3)
          b = gx**2
          c = gy**2
          e = b+c+gz**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*(b-c)/e
          if(abs(e) > tiny(e)) then
             ylm(i) = a*(b-c)/e
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 7) then
       a = dsqrt(15.d0/PAI4)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2) + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2) + b3y*gqmk(i,3)
          e = gqmkr(i)**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gx*gy/e
          if(abs(e) > tiny(e)) then
             ylm(i) = a*gx*gy/e
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 8) then
       a = dsqrt(15.d0/PAI4)
       do i = ista_ylm, iend_ylm  !for mpi
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2)  + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2)  + b3z*gqmk(i,3)
          e = gqmkr(i)**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gy*gz/e
          if(abs(e) > tiny(e)) then
             ylm(i) = a*gy*gz/e
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 9) then
       a = dsqrt(15.d0/PAI4)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2) + b3x*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          e = gqmkr(i)**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gz*gx/e
          if(abs(e) > tiny(e)) then
             ylm(i) = a*gz*gx/e
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 10) then
       a = dsqrt(7.d0/(16*PAI))
       do i = ista_ylm, iend_ylm  !for mpi
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          d = gz**2
          e = gqmkr(i)**2
          f = e * gqmkr(i)
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gz*(5*d-3*e)/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*gz*(5*d-3*e)/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 11) then
       a = dsqrt(21.d0/(32*PAI))
       do i = ista_ylm, iend_ylm  !for mpi
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2)  + b3z*gqmk(i,3)
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2)  + b3x*gqmk(i,3)
          d = gz**2
          e = gqmkr(i)**2
          f = e * gqmkr(i)
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gx*(5*d-e)/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*gx*(5*d-e)/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 12) then
       a = dsqrt(21.d0/(32*PAI))
       do i = ista_ylm, iend_ylm  !for mpi
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2) + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          d = gz**2
          e = gqmkr(i)**2
          f = e * gqmkr(i)
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gy*(5*d-e)/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*gy*(5*d-e)/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 13) then
       a = dsqrt(105.d0/(16*PAI))
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2) + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2) + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          b = gx**2
          c = gy**2
          e = gqmkr(i)**2
          f = e * gqmkr(i)
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gz*(b-c)/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*gz*(b-c)/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 14) then
       a = dsqrt(105.d0/PAI4)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2)  + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2)  + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2)  + b3z*gqmk(i,3)
          f = gqmkr(i)**3
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gx*gy*gz/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*gx*gy*gz/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 15) then
       a = dsqrt(35.d0/(32*PAI))
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2) + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2) + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          b = gx**2
          c = gy**2
          f = gqmkr(i)**3
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gx*(b-3*c)/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*gx*(b-3*c)/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 16) then
       a = dsqrt(35.d0/(32*pai))
       do i = ista_ylm, iend_ylm !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2) + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2) + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          b = gx**2
          c = gy**2
          f = gqmkr(i)**3
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gy*(3*b-c)/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*gy*(3*b-c)/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 17) then
       a = 3.d0/8.d0/dsqrt(PAI4)
       do i = ista_ylm, iend_ylm  !for mpi
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          d = gz**2
          e = gqmkr(i)**2
          f = e**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*(5*d*(7*d-6*e)/f+3.d0)
          if(abs(f) > tiny(f)) then
             ylm(i) = a*(5*d*(7*d-6*e)/f+3.d0)
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 18) then
       a = 15.d0/4.d0/dsqrt(10*PAI)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2) + b3x*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          d = gz**2
          e = gqmkr(i)**2
          f = e**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gz*gx*(7*d-3*e)/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*gz*gx*(7*d-3*e)/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 19) then
       a = 15.d0/4.d0/dsqrt(10.d0*PAI)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2)  + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2)  + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2)  + b3z*gqmk(i,3)
          d = gz**2
          e = gqmkr(i)**2
          f = e**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*gy*gz*(7*d-3*e)/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*gy*gz*(7*d-3*e)/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 20) then
       a = 15.d0/8.d0/dsqrt(5*PAI)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2)  + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2)  + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2)  + b3z*gqmk(i,3)
          b = gx**2
          c = gy**2
          d = gz**2
          e = b+c+d
          f = e**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*(7*d-e)*(b-c)/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*(7*d-e)*(b-c)/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 21) then
       a = 15.d0/4.d0/dsqrt(5*PAI)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2) + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2) + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          d = gz**2
          e = gqmkr(i)**2
          f = e**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*(7*d-e)*gx*gy/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*(7*d-e)*gx*gy/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 22) then
       a = 105.d0/4.d0/dsqrt(70*pai)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2) + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2) + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          b = gx**2
          c = gy**2
          f = (b+c+gz**2)**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*(b-3*c)*gz*gx/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*(b-3*c)*gz*gx/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 23) then
       a = 105.d0/4.d0/dsqrt(70*PAI)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2) + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2) + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2) + b3z*gqmk(i,3)
          b = gx**2
          c = gy**2
          f = (b+c+gz**2)**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*(3.d0*b-c)*gy*gz/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*(3.d0*b-c)*gy*gz/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 24) then
       a = 105.d0/16.d0/dsqrt(35*PAI)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2)  + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2)  + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2)  + b3z*gqmk(i,3)
          b = gx**2
          c = gy**2
          f = (b+c+gz**2)**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*((b-c)**2-4*b*c)/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*((b-c)**2-4*b*c)/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    else if(is == 25) then
       a = 105.d0/4.d0/dsqrt(35*PAI)
       do i = ista_ylm, iend_ylm  !for mpi
          gx = b1x*gqmk(i,1) + b2x*gqmk(i,2)  + b3x*gqmk(i,3)
          gy = b1y*gqmk(i,1) + b2y*gqmk(i,2)  + b3y*gqmk(i,3)
          gz = b1z*gqmk(i,1) + b2z*gqmk(i,2)  + b3z*gqmk(i,3)
          b = gx**2
          c = gy**2
          f = (b+c+gz**2)**2
! === DEBUG by tkato 2015/03/19 ================================================
!         ylm(i) = a*(b-c)*gx*gy/f
          if(abs(f) > tiny(f)) then
             ylm(i) = a*(b-c)*gx*gy/f
          else
             ylm(i) = 0.0d0
          end if
! ==============================================================================
       end do
    end if

    if(ni > 0) then
       ylm(ni) = dsqrt(1.d0/PAI4)
       gqmkr(ni) = gqmkr0
    end if
  end subroutine m_pwBS_sphrp_exx


! ==== EXP_CELLOPT === 2015/09/24
  subroutine m_pwBS_store_prev_kg1_kgp
    kg1_prev = kg1;   kgp_prev = kgp
    if ( mype == 0 ) then
       write(nfout,*) '** kg1_prev is ', kg1_prev
       write(nfout,*) '** kgp_prev is ', kgp_prev
    endif
  end subroutine m_pwBS_store_prev_kg1_kgp
! =================== 2015/09/24

end module m_PlaneWaveBasisSet

#ifdef ENABLE_ESM_PACK
subroutine Preparation_for_ESM()
    use m_Const_Parameters, only : ON,BARE,PE1,PE2,DP
    use m_Control_Parameters, only : gmaxp,kimg,nspin,sw_esm,esm_z1,esm_izwall &
  &                                , esm_iexpot,esm_z_wall,esm_bar_height,esm_bar_width, esm_e_field &
  &                                , esm_fix_ef,esm_add_elec,esm_gps,esm_gpe,ipriesm,nspin,esm_bc,esm_w &
  &                                , esm_izwall, esm_z_wall, esm_bar_height, esm_bar_width
    use m_Ionic_System, only : natm,natm2,ityp,iatomn,ntyp,ival,cps
    use m_FFT, only : fft_box_size_CD
    use m_Crystal_Structure, only : altv
    use m_Parallelization, only : npes,mype, ista_kngp, iend_kngp, mpi_ke_world
    use m_PlaneWaveBasisSet, only : ngabc_kngp_l,igfp_l,kgp

    implicit none
    include 'mpif.h'
    character(len=3) :: esm_bc_c
    real(kind=DP), allocatable,dimension(:) :: ival_at
    real(kind=DP), allocatable, dimension(:,:) :: cps_tmp
    integer, allocatable, dimension(:,:) :: ngabc_esm
    integer, allocatable, dimension(:) :: igfp_l_esm
    integer :: i,j,ierr

    if(sw_esm/=ON) return
    if(esm_bc==BARE)then 
       esm_bc_c = 'bc1'
    else if (esm_bc == PE1) then
       esm_bc_c = 'bc2'
    else if (esm_bc == PE2) then
       esm_bc_c = 'bc3'
    endif
    allocate(ival_at(natm));ival_at=0.d0
    do i=1,natm
       ival_at(i) = ival(ityp(i))
    enddo
!    allocate(ngabc_esm(3,1:iend_kngp-ista_kngp+1));ngabc_esm=0
    allocate(ngabc_esm(3,1:kgp));ngabc_esm=0
    do i=1,3
       do j=ista_kngp,iend_kngp
          ngabc_esm(i,j) = ngabc_kngp_l(j,i)
       enddo
    enddo
    call mpi_allreduce(mpi_in_place,ngabc_esm,3*kgp,mpi_integer,mpi_sum,mpi_ke_world,ierr)
    allocate(cps_tmp(3,natm))
    do i=1,3
       do j=1,natm
          cps_tmp(i,j) = cps(j,i)
       enddo
    enddo
    allocate(igfp_l_esm(1:kgp));igfp_l_esm=0
    do i=ista_kngp,iend_kngp
       igfp_l_esm(i) = igfp_l(i)
    enddo
    call mpi_allreduce(mpi_in_place,igfp_l_esm,kgp,mpi_integer,mpi_sum,mpi_ke_world,ierr)

    call Esm_interface_map_parameters(natm,ival_at,cps_tmp,1.0d0,altv, &
    & fft_box_size_CD(1,0),fft_box_size_CD(2,0),fft_box_size_CD(3,0),  &
    & esm_bc_c,.false.,kgp,nspin,ngabc_esm,                            &
    & igfp_l_esm,igfp_l_esm,esm_w,2.0d0*esm_e_field, esm_izwall,       &
    & esm_z_wall, esm_bar_height,esm_bar_width)
    call Esm_interface_set_communicator(mpi_ke_world)
    deallocate(igfp_l_esm)
    deallocate(ival_at)
    deallocate(ngabc_esm)
    deallocate(cps_tmp)
end subroutine Preparation_for_ESM
#endif

!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 443 $)
!
!  MODULE:  m_ES_WF_by_SDorCG
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
#undef NEC_TIMER
#ifdef NEC_TIMER
#  define START_TIMER(a) call start_timer(a)
#  define STOP_TIMER(a)  call stop_timer(a)
#else
#  define START_TIMER(a)
#  define STOP_TIMER(a)
#endif
!
#ifdef __TIMER__
#   define __TIMER_START_w_BARRIER(str,a)   call mpi_barrier(str,ierr) ;   call timer_sta(a)
#   define __TIMER_START(a)       call timer_sta(a)
#   define __TIMER_STOP(a)        call timer_end(a)
#else
#   define __TIMER_START_w_BARRIER(str,a)
#   define __TIMER_START(a)
#   define __TIMER_STOP(a)
#endif
#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_DO__
#   define __TIMER_DO_START(a)   call timer_sta(a)
#   define __TIMER_DO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_DO_START(a)
#   define __TIMER_DO_STOP(a)
#endif
#ifdef __TIMER_COMM__
#   define __TIMER_COMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_COMM_START(a)       call timer_sta(a)
#   define __TIMER_COMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_COMM_START_w_BARRIER(str,a)
#   define __TIMER_COMM_START(a)
#   define __TIMER_COMM_STOP(a)
#endif
module m_ES_WF_by_SDorCG
!     (m_ESsd or m_ESSD)
! $Id: m_ES_WF_by_SDorCG.F90 443 2015-08-03 13:03:48Z ktagami $
! This module evolves wave functions.
! MSD: modified steepest descent algorithm (Original subroutine name was
! "msdv").
! Following lines are comments in the "msdv".
!
!!$C ref.: Williams and Soler, Bull.Am.Phys.Soc.32 ('87),p562.
!!$c
!!$c      revised by T.Yamasaki
!!$c         #1) 2 folding inline expansion at an do loop of NEG is 
!!$c            rewrited as before as a simple do loop
!!$c                                               5th May 1994
!!$c         #2) Parallelization                   9th May 1994
!!$c         #3) Parallelization transient
!!$c                         by T.Yamasaki        15th May 1994
!!$c
!!$c         #4)  Following arrays are removed from the arguments.
!!$c                                  ----> 31th May '94 Y.M
!!$cc   >        VXC,CHGQ,PSC,ZFM3,
!!$c                                  ----> 3rd June '94, Y.M.
!!$cc   W        W31,
!!$c                                  ----> 3rd June '94, Y.M.
!!$cc   W        W310,
!!$c
!!$c         #5)  data array size is reduced by T.Yamasaki
!!$c             snlfmc(kng1,klmt),snlfms(kng1,klmt)
!!$c          -->  snlfmc(kng1), snlfms(kng1)       on 17th Jun. 1994
!!$c
!!$c         #6) Data parallelization               on 24th Jun. 1994
!!$c                 eko --> eko_l             by T.Yamasaki  
!!$c         #7) indx0 is removed                      26th Jun. 1994
!!$c         #8) Interface has changed                 27th Jun. 1994
!!$c         #9) imsd is added in the argument list     4th Aug. 1994
!!$cc      imsd = 1
!!$cc    for preconditioning IMSD=2   '94.6.14 Tsuyoshi Miyazaki
!!$cc      imsd = 2
!!$c         #10) ivanl is inserted in the arugment list  13th Sep. 1994
!!$c         #11) A do loop of 450 is tuned up.        15th Sep. 1994
!!$c         #12) Spin polarization is introduced.     11th Dec. 1994
!!$c         #13) vlhxc --> vlhxc_l                    31st Jan. 1995
!!$c                                          by T.Yamasaki
!!$c         #14) gx,gy,gz --> ngabc, vx,vy,vz --> vkxyz
!!$c                   by T.Yamasaki                on 15th Feb. 1995
!!$c         #15) antiferromagnetic calculation is added on 9th Jul. 1996
!!$c                                          by H.Sawada
!
! The "msdv" subroutine was translated into a subroutine,
! "evolve_WFs_in_MSD_direction" by T. Yamasaki in 1999.
!
  use m_Control_Parameters,  only : nspin,ipri,iprisolver,kimg,neg,af,sw_hybrid_functional, sw_fef &
#ifdef SAVE_FFT_TIMES
 &                                , sw_modified_cg_formula, sw_save_fft, sw_retard_eigval_evaluation
#else
 &                                , sw_modified_cg_formula, sw_retard_eigval_evaluation
#endif
  use m_Const_Parameters,    only : DP,SP,DIRECT,ON,SD,MSD,eazyCG,CG,SKIP,EXECUT,zi &
 &                                , ORTHONORMALIZATION, NORMALIZATION, ELECTRON &
 &                                , OTHER_BANDS, SAME_BAND, ALL_BANDS, SCF, OFF, GAMMA, OLD
  use m_Crystal_Structure,   only : rltv
  use m_Electronic_Structure,only : zaj_l, afft,bfft &
 &                                , eko_l,vnlph_l,vlhxcQ &
 &                                , vlhxc_l &
#ifdef SAVE_FFT_TIMES
 &                                , status_saved_phifftr &
#endif
 &                                , m_ES_WF_in_Rspace &
 &                                , m_ES_sort_eigen_values &
 &                                , m_ES_Vlocal_in_Rspace  &
 &                                , m_ES_eigen_values_for_each_k  &
 &                                , m_ES_wd_zaj_small_portion &
 &                                , m_ES_wd_eko &
 &                                , m_ES_decide_precon_factor     &
 &                                , m_ES_sum_of_LocalPart  &
 &                                , m_ES_sum_of_LocalPart2 &
 &                                , m_ES_sum_of_LocalPart3

  use m_ES_ortho            ,only : m_ES_MGS_4_each_k   
  use m_ES_ortho            ,only : m_ES_orthogonalize_SD_to_WFs                      
  use m_ES_nonlocal         ,only : sc,ss,qc                                          &
 &                                , m_ES_alloc_afft_scss_etc                          &
 &                                , m_ES_dealloc_afft_scss_etc                        
  use m_ES_nonlocal         ,only : m_ES_Vnonlocal_W                                  &
 &                                , m_ES_betar_dot_Psi_4_each_k                       
  use m_FFT,                 only : nfft, fft_box_size_WF
  use m_FFT,                 only : m_FFT_Vlocal_W, m_FFT_WF
  use m_Ionic_System,        only : ntyp, natm, ityp, iwei
  use m_Kpoints,             only : kv3,vkxyz,k_symmetry
  use m_NonLocal_Potential,  only : snl
  use m_Files,               only : nfout
  use m_Parallelization,     only : mpi_comm_group,is_kngp,ie_kngp,npes,mype &
       &, nrank_e, myrank_e, map_e, ista_e, iend_e, istep_e, map_z, np_e &
       &, nrank_k, myrank_k, map_k, ista_k, iend_k, mpi_k_world, nis_k, nel_k, ierr
  use m_PlaneWaveBasisSet,   only : kg1,iba, igf, nbase, m_pwBS_kinetic_energies
  use m_PseudoPotential,     only : ilmt, lmtt, ltp, mtp, q, dion, modnrm, nlmta &
       &                           ,m_PP_include_vanderbilt_pot,ipaw,dion_paw
  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_ES_ExactExchange,    only : m_ES_Vexx_W, m_ES_EXX_eigenvalue_for_each_k &
       &                          , m_ES_EXX_Diagonal_part, m_ES_EXX_add_Diagonal_part &
                                  , m_ES_EXX_cp_eigenvalue, m_ES_EXX_gather_valence_states
#ifdef NEC_TIMER
  use nec_timer
#endif
  use m_FiniteElectricField, only : m_FEF_add_grad_to_vnlph, m_FEF_build_grad
       
! ==================================== added by K. Tagami ============= 11.0
  use m_Control_Parameters,    only : noncol, ndim_spinor, ndim_chgpot, ndim_magmom, &
       &                              SpinOrbit_mode, sw_hubbard
  use m_Const_Parameters,    only : CMPLDP, Neglected
  use m_PseudoPotential,       only : dion_scr_noncl, q_noncl
  use m_ES_ortho,              only : m_ES_orthogonl_SD_to_WFs_noncl, &
       &                              m_ES_MGS_4_each_k_noncl

  use m_Electronic_Structure,   only : m_ES_sum_of_LocalPart2_noncl, &
       &                               m_ES_Vlocal_in_Rspace_noncl, &
       &                               m_ES_sort_eigen_vals_noncl, &
       &                               m_ES_eigen_vals_each_k_noncl, &
       &                               m_ES_sum_of_LocalPart_noncl, &
       &                               m_ES_sum_of_LocalPart3_noncl

  use m_ES_nonlocal,            only : m_ES_alloc_scss_etc, &
       &                               m_ES_dealloc_scss_etc
  use m_FFT,                    only : m_FFT_Vlocal_W_noncl
!! for debug
  use m_Electronic_Structure,     only : fsr_l, fsi_l
! ===================================================================== 11.0

! === 0 divide occurs if abs(wdi) < epsilon. by tkato 2012/12/18 ===============
  use m_Const_Parameters, only : SmallestPositiveNumber
! ==============================================================================

  use m_IterationNumbers, only : iteration_electronic

  implicit none
  real(kind=DP),private,allocatable,dimension(:,:,:,:):: zaj_old !d(kg1,np_e,ista_k:iend_k,kimg)
  real(kind=DP),private,allocatable,dimension(:,:,:,:):: wfsd_l  !d(kg1,np_e,ik:ik,kimg)
! ----------- Added by T. Yamasaki, 28 June 2008 -----
  real(kind=DP),private,allocatable,dimension(:,:,:,:):: wfred_l !d(kg1,np_e,ista_k:iend_k,kimg)
  logical, private                                    :: wfred_is_allocated = .false.
! ----------------------------------------------------
  real(kind=DP),public ,allocatable,dimension(:,:,:,:):: wfsd_old!d(kg1,np_e,ista_k:iend_k,kimg)
  real(kind=DP),private,allocatable,dimension(:,:,:,:):: wfsd_np !d(kg1,np_e,1,kimg)
  real(kind=DP),private,allocatable,dimension(:,:,:)  :: bsdr_l, bsdi_l !d(np_e,nlmta,1)
  real(kind=DP),private,allocatable,dimension(:,:,:)  :: bsdr_old, bsdi_old !d(np_e,nlmta,1)
  real(kind=DP),private,allocatable,dimension(:,:,:)  :: bsdr_np, bsdi_np !d(np_e,nlmta,1)

  real(kind=DP),private,allocatable,dimension(:)          :: dzajn2  !d(kv3)
  real(kind=DP),private                               :: betacg

!   1. m_ESsd_alloc_dzajn2            <-(Initial_Electronic_Structure)
!   2. m_ESsd_dealloc_dzajn2          <-(Finalization_of_mpi)
!   3. m_ESsd_alloc_zaj_old           <-(Initial_Electronic_Structure)
!   4. m_ESsd_evolve_WFs_again        <-(Renewal_of_WaveFunctions) ->(5)
!   5. evolve_each_WF_again           <-(4)
!   6. m_ESsd_decide_CG_direction     <-(Renewal_of_WaveFunctions) ->(7)
!   7. decide_CG_direction_core       <-(6,) ->(16,29)
!   8. m_ESsd_renew_WF_by_SDorCG      <-(Renewal_of_WaveFunctions) ->(9,10,11,12,13,14)
!   9. evolve_WFs_in_MSD_direction    <-(8) ->(15,19)
!  10. evolve_WFs_in_SD_direction     <-(8)
!  11. evolve_WFs_in_eazyCG_direction <-(8) ->(16,17,18,26,28,30,33)
!  12. evolve_WFs_in_CG_direction     <-(8) ->(18,26,28,29)
!  13. evolve_WFs_in_CG_direction0    <-(8) ->(26,27)
!  14. vlhxc_l_zero_term              <-(8)
!  15. modified_steepest_descent      <-(9)
!  16. square_of_SD_direction(ik,ibo,dz) <-(7,11)
!  17. square_of_SD_direction2(ik,ibo,dz) <-(11)
!  18. SD_direction                   <-(11,12)
!  19. Vnonlocal_Diagonal_part        <-(9)
!  20.  - Vnonlocal_D_vanderbilt_case, - Vnonlocal_D_norm_conserve_case
!  21. m_ESsd_reset_dzajn2            <-(Renewal_of_WaveFunctions)
!  22. m_ESsd_copy_zaj_to_zaj_old     <-(Renewal_of_WaveFunctions)
!  23. m_ESsd_copy_zaj_old_to_zaj     <-(m_ES_WF_by_RMM.zajold2zaj_phi2zaj_old)
!  24. m_ESsd_copy_phi_to_zaj_old     <-(m_ES_WF_by_RMM.zajold2zaj_phi2zaj_old)
!  25. m_ESsd_diff_WFs_to_zaj_old     <-(m_ES_WF_by_RMM.m_ESrmm_renew_WF)
!  26. WF_conjugate_gradient          <-(11,12,13)
!  27. WF_conjugate_gradient0         <-(13)
!  28. make_CG_direction              <-(11,12)
!  29. orthogonalize_SD_drctns        <-(7,12)
!  30. Precon_dot_SD                  <-(11)  ->(31)
!  31. decide_precon_factor_wfsd      <-(30)  ->(32)
!  32. kinetic_energy_wfsd            <-(31)
!  33. cp_wfsd_to_wfsd_old            <-(11)

  include 'mpif.h'

contains
  subroutine m_ESsd_alloc_dzajn2
    allocate(dzajn2(ista_k:iend_k)); dzajn2 = 0.d0
  end subroutine m_ESsd_alloc_dzajn2

  subroutine m_ESsd_dealloc_dzajn2
    if(allocated(zaj_old)) deallocate(zaj_old)
    if(allocated(dzajn2)) deallocate(dzajn2)
  end subroutine m_ESsd_dealloc_dzajn2

  subroutine m_ESsd_alloc_zaj_old
    allocate(zaj_old(kg1,np_e,ista_k:iend_k,kimg))
  end subroutine m_ESsd_alloc_zaj_old

  subroutine m_ESsd_alloc_wfsd
    if(.not.allocated(wfsd_old)) then
       allocate(wfsd_old(kg1,np_e,ista_k:iend_k,kimg))
       wfsd_old = 0.d0
    end if
    if(.not.allocated(bsdr_old)) then
       allocate(bsdr_old(np_e,nlmta,ista_k:iend_k));bsdr_old=0.0d0
    endif
    if(.not.allocated(bsdi_old)) then
       allocate(bsdi_old(np_e,nlmta,ista_k:iend_k));bsdi_old=0.0d0
    endif
  end subroutine m_ESsd_alloc_wfsd

  subroutine m_ESsd_dealloc_wfsd
    if(allocated(wfsd_old)) deallocate(wfsd_old)
    if(allocated(bsdr_old)) deallocate(bsdr_old)
    if(allocated(bsdi_old)) deallocate(bsdi_old)
  end subroutine m_ESsd_dealloc_wfsd

! -------------------- Added by T. Yamasaki, 28 June 2008 --->>
  subroutine m_ESsd_alloc_wfred()
    allocate(wfred_l(kg1,np_e,ista_k:iend_k,kimg)); wfred_l = 0.d0
    wfred_is_allocated = .true.
  end subroutine m_ESsd_alloc_wfred

  subroutine m_ESsd_dealloc_wfred()
    deallocate(wfred_l)
    wfred_is_allocated = .false.
  end subroutine m_ESsd_dealloc_wfred

  subroutine cp_wfred(ik)
    integer, intent(in) :: ik
    integer :: ir, ib, ig
    do ir = 1, kimg
       do ib = 1, np_e
          do ig = 1, iba(ik)
             wfred_l(ig,ib,ik,ir) = zaj_l(ig,ib,ik,ir) - zaj_old(ig,ib,ik,ir)
          end do
       end do
    end do
  end subroutine cp_wfred
! ----------------------------------<<

  subroutine alloc_wfsd_bsdri(ik)
    integer, intent(in) :: ik
    allocate(wfsd_l(kg1,np_e,ik:ik,kimg)); wfsd_l = 0.d0
    allocate(bsdr_l(np_e,nlmta,ik:ik))
    allocate(bsdi_l(np_e,nlmta,ik:ik)); bsdi_l = 0.0d0
!!$    write(nfout,'(" -- bsdr_l, bsdi_l have been allocated --  np_e, nlmta, ik = ",3i5)') np_e,nlmta,ik
  end subroutine alloc_wfsd_bsdri

! ==================================== added by K. Tagami ============== 11.0
  subroutine alloc_wfsd_bsdri_noncl( ik1, ik2 )
    integer, intent(in) :: ik1, ik2
    allocate(wfsd_l(kg1,np_e,ik1:ik2,kimg)); wfsd_l = 0.d0
    allocate(bsdr_l(np_e,nlmta,ik1:ik2))
    allocate(bsdi_l(np_e,nlmta,ik1:ik2)); bsdi_l = 0.0d0
  end subroutine alloc_wfsd_bsdri_noncl
! ====================================================================== 11.0

  subroutine dealloc_wfsd_bsdri()
    deallocate(wfsd_l)
    deallocate(bsdr_l)
    deallocate(bsdi_l)
  end subroutine dealloc_wfsd_bsdri

  subroutine alloc_wfsdnp_bsdrinp(ik)
    integer, intent(in) :: ik
    allocate(wfsd_np(kg1,np_e,ik:ik,kimg))
    allocate(bsdr_np(np_e,nlmta,ik:ik))
    allocate(bsdi_np(np_e,nlmta,ik:ik))
  end subroutine alloc_wfsdnp_bsdrinp

! ========================================= added by K. Tagami =========== 11.0
  subroutine alloc_wfsdnp_bsdrinp_noncl(ik1, ik2)
    integer, intent(in) :: ik1, ik2
    allocate(wfsd_np(kg1,np_e,ik1:ik2,kimg))
    allocate(bsdr_np(np_e,nlmta,ik1:ik2))
    allocate(bsdi_np(np_e,nlmta,ik1:ik2))
  end subroutine alloc_wfsdnp_bsdrinp_noncl
! ====================================================================== 11.0

  subroutine dealloc_wfsdnp_bsdrinp()
    deallocate(wfsd_np)
    deallocate(bsdr_np)
    deallocate(bsdi_np)
  end subroutine dealloc_wfsdnp_bsdrinp

  subroutine m_ESsd_dealloc_zaj_old
    if(allocated(zaj_old)) deallocate(zaj_old)
!!$    deallocate(wfsd_l)
!!$    deallocate(wfsd_np)
!!$    deallocate(bsdr_l)
!!$    deallocate(bsdi_l)
!!$    deallocate(bsdr_np)
!!$    deallocate(bsdi_np)
  end subroutine m_ESsd_dealloc_zaj_old

  subroutine m_ESsd_evolve_WFs_again(nfout,isolver2,mode,dtim_old,dtim_new,iupdate)
#ifdef __TIMER__
    use m_Const_Parameters,   only : VDB, NORMCONSERVATION
#endif
    integer,       intent(in) :: nfout,isolver2 &
         &                     , mode   ! mode = {ORTHONORMALIZATION | NORMALIZATION}
    real(kind=DP), intent(in) :: dtim_old, dtim_new
    integer, intent(in), optional :: iupdate
    integer       :: ispin, ik, iksnl
    real(kind=DP), pointer, dimension(:) :: ekin
#ifdef __TIMER__
    integer       :: ierr
#endif

    call m_ES_alloc_afft_scss_etc()
    ekin => sc(1:kg1)

    do ispin = 1, nspin, af+1

       call m_ES_Vlocal_in_Rspace(ispin,afft)                 ! (ptfft1)

       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) == myrank_k ) then                     ! MPI
             call m_pwBS_kinetic_energies(ik,vkxyz,ekin) !-(PWBS) (diakin) ->ekin
             call evolve_each_WF_again(ik,isolver2,dtim_new,dtim_old)  !-(m_ES_WF_by_SDorCG)
             if(ipri>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
!!$             if(modnrm == EXECUT) call m_ES_betar_dot_WFs_4_each_k(nfout,ik)       ! -> fsr_l, fsi_l
             call m_ES_MGS_4_each_k(nfout,ik,mode)
             if(sw_hybrid_functional==ON) then
                if(sw_retard_eigval_evaluation==OFF)then
                   call m_ES_EXX_eigenvalue_for_each_k(ispin,ik,iupdate=iupdate)
                else
                   call m_ES_EXX_cp_eigenvalue(ik)
                endif
             endif
             call m_ES_eigen_values_for_each_k(ispin,ik,ekin,afft)
          end if
       end do
    end do
    if(sw_hybrid_functional==ON.and.sw_retard_eigval_evaluation==ON)then
       call m_ES_EXX_gather_valence_states(nfout)
       do ispin=1,nspin,af+1
          do ik=ispin, kv3+ispin-nspin, nspin
             if(map_k(ik) /= myrank_k) cycle ! MPI
             call m_ES_EXX_eigenvalue_for_each_k(ispin,ik,update_eko=.false.,iupdate=iupdate)
          enddo
       enddo
    endif
#ifdef LMM_PREVIOUS
    call m_ES_sort_eigen_values    !-(m_Elec.)
! --> T. Yamasaki, 21th Jul. 2009 
!!$    call m_ES_sort_eigen_values    !-(m_Elec.)
! <--
#endif
    call m_ES_dealloc_afft_scss_etc()

  end subroutine m_ESsd_evolve_WFs_again

! ============================= added by K. Tagami ======================== 11.0
  subroutine m_ESsd_evolve_WFs_again_noncl(nfout,isolver2,mode,dtim_old,dtim_new,iupdate)
    integer,       intent(in) :: nfout,isolver2 &
         &                     , mode   ! mode = {ORTHONORMALIZATION | NORMALIZATION}
    real(kind=DP), intent(in) :: dtim_old, dtim_new
    integer, intent(in), optional :: iupdate

    integer       :: ispin, ik, iksnl
    integer :: is

    real(kind=DP), pointer, dimension(:) :: ekin

    real(kind=DP), allocatable :: afft_kt(:,:)
    real(kind=DP), allocatable :: bfft_kt(:,:)

!    return

    call m_ES_alloc_scss_etc()
    allocate(afft_kt(nfft,ndim_chgpot)); afft_kt = 0.0d0      ! pot
    allocate(bfft_kt(nfft,ndim_spinor)); bfft_kt = 0.0d0      ! wfn

    ekin => sc(1:kg1)

    call m_ES_Vlocal_in_Rspace_noncl( afft_kt )   ! vlhxc_ss -> afft_kt

    Do ik=1, kv3, ndim_spinor
       if (map_k(ik) /= myrank_k ) cycle
       iksnl = (ik-1)/ndim_spinor + 1

       call m_pwBS_kinetic_energies( ik, vkxyz, ekin )     !-(PWBS) (diakin) ->ekin

       Do is=1, ndim_spinor
         call evolve_each_WF_again( ik+is-1, isolver2, dtim_new, dtim_old ) 
                          !-(m_ES_WF_by_SDorCG)
       End do

       call m_ES_MGS_4_each_k_noncl( nfout, ik, mode )

       if (sw_hybrid_functional==ON) call m_ES_EXX_eigenvalue_for_each_k(ispin,ik,iupdate=iupdate)

       call m_ES_eigen_vals_each_k_noncl( ik, ekin, afft_kt, bfft_kt )

    End do

#ifdef LMM_PREVIOUS
    call m_ES_sort_eigen_vals_noncl           !-(m_Elec.)

#endif
    call m_ES_dealloc_scss_etc()
    deallocate( afft_kt, bfft_kt )

  end subroutine m_ESsd_evolve_WFs_again_noncl
! ========================================================================= 11.0

  subroutine evolve_each_WF_again(ik,isolver2,dt_new,dt_old)
    integer,       intent(in) :: ik,isolver2
    real(kind=DP), intent(in) :: dt_new,dt_old
    integer ::        ir, ib, ig
    real(kind=DP) ::  dtt
    integer   :: id_sname = -1
    call tstatc0_begin('evolve_each_WF_again ', id_sname,1)

!!$    if(isolver2 == CG .or. isolver2 == eazyCG) then
#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) then
       do ib = 1, np_e
          status_saved_phifftr(ib,ik) = OLD
       end do
    end if
#endif

  if(isolver2 == eazyCG) then
       do ir = 1, kimg
          do ib = 1, np_e
             do ig = 1, iba(ik)
                zaj_l(ig,ib,ik,ir) = zaj_old(ig,ib,ik,ir) + dt_new*wfsd_l(ig,ib,ik,ir)
             end do
          end do
       end do
    else
       dtt = dt_new/dt_old
!!$       if(ipri >= 3) write(nfout,'(" dtt = ",f8.4)') dtt
! ------------------- Revised by T. Yamasaki,  31 Oct 2008 --->>
       if(wfred_is_allocated) then
          do ir = 1, kimg
             do ib = 1, np_e
                do ig = 1, iba(ik)
! ------------------- Revised by T. Yamasaki,  03 July 2008 --->>
                   zaj_l(ig,ib,ik,ir) = zaj_old(ig,ib,ik,ir) + dtt*wfred_l(ig,ib,ik,ir)
! ------------------------------------<<
                end do
             end do
          end do
       else if(.not.wfred_is_allocated) then
          do ir = 1, kimg
             do ib = 1, np_e
                do ig = 1, iba(ik)
                   zaj_l(ig,ib,ik,ir) = (1-dtt)*zaj_old(ig,ib,ik,ir) + dtt*zaj_l(ig,ib,ik,ir)
                end do
             end do
          end do
       end if
! <----------------
    end if
!!$    do ir = 1, kimg
!!$       do ib = 1, np_e                         ! MPI
!!$          do i = 1, iba(ik)
!!$             dzz = zaj_l(i,ib,ik,ir) - zaj_old(i,ib,ik,ir)
!!$             zaj_l(i,ib,ik,ir) = zaj_old(i,ib,ik,ir) + dtt*dzz
!!$          end do
!!$       end do
!!$    end do
    call tstatc0_end(id_sname)
  end subroutine evolve_each_WF_again
             
  subroutine m_ESsd_decide_CG_direction(precon)
    integer, intent(in) :: precon

    integer ispin, iksnl, ik
    real(kind=DP), parameter             :: Delta = 1.d-10
    real(kind=DP), pointer, dimension(:) :: ekin, p
    real(kind=DP)                        :: gmgm, gmmgmm, sumdz2, sumdz

    if(sw_fef==ON) call m_FEF_build_grad() !->grad_fef

    call m_ES_alloc_afft_scss_etc()
    ekin => sc(1:kg1); p => ss(1:kg1)
    gmgm = 0.d0; gmmgmm = 0.d0

    do ispin = 1, nspin, (af+1)
       call m_ES_Vlocal_in_Rspace(ispin,afft)      ! (ptfft1) -> afft
       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) == myrank_k) then           ! MPI
             iksnl = (ik-1)/nspin + 1
             call alloc_wfsd_bsdri(ik)
             call m_ES_Vnonlocal_W(ik,iksnl,ispin,ON)    ! (nonloc) ->(vnlph_l)
             if(sw_hybrid_functional==ON) call m_ES_Vexx_W(ik) ! (exx) ->(vnlph_l)
             if(sw_fef==ON) call m_FEF_add_grad_to_vnlph(ik) !->vnlph_l
             call m_pwBS_kinetic_energies(ik,vkxyz,ekin) ! -(m_PWBS) (diakin) ->ekin
             call decide_CG_direction_core &     ! -(m_ES_WF_by_SDorCG) ->wfsd_l
                  &(precon,ik,ekin,afft,bfft,p,sumdz2,sumdz)
             gmgm   = gmgm + sumdz
             gmmgmm = gmmgmm + dzajn2(ik)
             dzajn2(ik) = sumdz2
             if(ipri >= 2) write(nfout,'(" dzajn2(",i3,") = ",d20.8)') ik,dzajn2(ik)
             call dealloc_wfsd_bsdri()
          end if
       enddo
    enddo

    if(npes > 1) then
       call mpi_allreduce(MPI_IN_PLACE,gmgm,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)    ! MPI
       call mpi_allreduce(MPI_IN_PLACE,gmmgmm,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)    ! MPI
    end if

    if(gmmgmm > Delta) then
       betacg = gmgm/gmmgmm
    else
       betacg = 0.d0
    endif
    if(ipri >= 1) write(nfout,'(" ! betacg = ",d20.8," gmgm = ",d20.8," gmmgmm = ",d20.8)') betacg,gmgm,gmmgmm
    if(betacg > 1.d0) then
       betacg = 0.d0
       if(ipri >= 1) write(nfout,*) ' beta for CG is too large, and it sets to be zero'
    else if(betacg < 0.d0) then
       betacg = 0.d0
       if(ipri >= 1) write(nfout,*) ' beta for CG is less than zero, and it sets to be zero'
    end if

    call m_ES_dealloc_afft_scss_etc()
!!$  contains
!!$    subroutine bcast_dzajn2                     ! MPI
!!$      integer       :: i
!!$
!!$      do i = 0, nrank_k-1
!!$         call mpi_bcast(dzajn2(nis_k(i)),nel_k(i),mpi_double_precision &
!!$              & ,i*nrank_e,mpi_comm_group,ierr)
!!$      end do
!!$    end subroutine bcast_dzajn2
  end subroutine m_ESsd_decide_CG_direction

! ====================================== added by K. Tagami ============== 11.0
  subroutine m_ESsd_decide_CG_direc_noncl(precon)
    integer, intent(in) :: precon

    integer ispin, iksnl, ik
    integer :: is1, is2, k2, istmp

    real(kind=DP), parameter             :: Delta = 1.d-10
    real(kind=DP), pointer, dimension(:) :: ekin, p
    real(kind=DP)                        :: gmgm, gmmgmm, sumdz2, sumdz

    real(kind=DP), allocatable :: vnlph_noncl(:,:,:,:)
    real(kind=DP), allocatable :: afft_kt(:,:)
    real(kind=DP), allocatable :: bfft_kt(:,:)

    call m_ES_alloc_scss_etc()
    ekin => sc(1:kg1); p => ss(1:kg1)
    allocate(afft_kt(nfft,ndim_chgpot)); afft_kt = 0.0d0      ! pot
    allocate(bfft_kt(nfft,ndim_spinor)); bfft_kt = 0.0d0      ! wfn

    allocate(vnlph_noncl(kg1,np_e,kimg,ndim_spinor)); vnlph_noncl = 0.0d0

    gmgm = 0.d0; gmmgmm = 0.d0

    call m_ES_Vlocal_in_Rspace_noncl( afft_kt )     

    do ik = 1, kv3, ndim_spinor

      if (map_k(ik) /= myrank_k) cycle
      iksnl = (ik-1)/ndim_spinor + 1

      call alloc_wfsd_bsdri_noncl( ik, ik+ndim_spinor-1 )

      vnlph_noncl = 0.0d0

      Do is1=1, ndim_spinor
          Do is2=1, ndim_spinor
            istmp = ( is1-1 )*ndim_spinor +is2
            k2 = ik +is2 -1

            call m_ES_Vnonlocal_W( k2, iksnl, istmp, ON )  ! (nonloc) ->(vnlph_l)

            vnlph_noncl(:,:,:,is1) = vnlph_noncl(:,:,:,is1) &
             &                     + vnlph_l(:,:,:)
          End do
       End do

      if (sw_hybrid_functional==ON) call m_ES_Vexx_W(ik) ! (exx) ->(vnlph_l)

      call m_pwBS_kinetic_energies( ik, vkxyz, ekin ) ! -(m_PWBS) (diakin) ->ekin

      call decide_CG_direction_core_noncl( precon, ik, ekin, &
              &                               afft_kt, bfft_kt, vnlph_noncl, &
              &                               p, sumdz2, sumdz )

!!!!!!!!!!!!!      gmgm   = gmgm + sumdz2
      gmgm   = gmgm + sumdz
      gmmgmm = gmmgmm + dzajn2(ik)
      dzajn2(ik) = sumdz2

      if(ipri >= 2) write(nfout,'(" dzajn2(",i3,") = ",d20.8)') ik,dzajn2(ik)
      call dealloc_wfsd_bsdri()

    enddo

    if(npes > 1) then
       call mpi_allreduce(MPI_IN_PLACE, gmgm,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)    ! MPI
       call mpi_allreduce(MPI_IN_PLACE, gmmgmm,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)    ! MPI
    end if

    if(gmmgmm > Delta) then
       betacg = gmgm/gmmgmm
    else
       betacg = 0.d0
    endif
    if(ipri >= 1) write(nfout,'(" ! betacg = ",d20.8," gmgm = ",d20.8," gmmgmm = ",d20.8)') betacg,gmgm,gmmgmm
    if(betacg > 1.d0) then
       betacg = 0.d0
       if(ipri >= 1) write(nfout,*) ' beta for CG is too large, and it sets to be zero'
    else if(betacg < 0.d0) then
       betacg = 0.d0
       if(ipri >= 1) write(nfout,*) ' beta for CG is less than zero, and it sets to be zero'
    end if

    call m_ES_dealloc_scss_etc()
    deallocate( afft_kt, bfft_kt )
    deallocate( vnlph_noncl )

  end subroutine m_ESsd_decide_CG_direc_noncl
! ================================================================ 11.0

  subroutine decide_CG_direction_core(precon,ik,ekin,afft,bfft,p,sumdz2,sumdz)
    integer, intent(in)        :: precon, ik
    real(kind=DP), intent(in)  :: ekin(kg1)
    real(kind=DP), intent(in)  :: afft(nfft)
    real(kind=DP), intent(out) :: bfft(nfft)
    real(kind=DP)              :: p(kg1)
    real(kind=DP), intent(out) :: sumdz2,sumdz

    integer :: ib
    integer :: id_sname = -1
    call tstatc0_begin('decide_CG_direction_core ', id_sname,1)

    do ib = ista_e, iend_e, istep_e      ! MPI
       call m_ES_WF_in_Rspace(ik,ib,bfft)! (swffft)
       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft) -> (bfft)
       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON) ! bfft: G-space repres.
       call SD_direction(precon,ik,ib,ekin,bfft,p) !-(m_ES_WF_by_SDorCG)
    end do

    call orthogonalize_SD_drctns(ik,to=OTHER_BANDS)  ! -(m_ES_WF_by_SDorCG) ->(wfsd_l, bsd(ri)_l)

    call WFSD_dot_WFSD                   ! -(contained here)
    !    ~~~~~~~~~~~~~
    call tstatc0_end(id_sname)
  contains
    subroutine WFSD_dot_WFSD
      real(kind=DP) :: dz,dz2
      integer :: ib

      sumdz2 = 0.d0
      sumdz = 0.0d0
      do ib = ista_e, iend_e, istep_e      ! MPI
         call square_of_SD_direction(ik,ib,dz)
         dz2 = 0.d0
         if(sw_modified_cg_formula==ON) call square_of_SD_direction3(ik,ib,dz2)
         sumdz2 = sumdz2 + dz
         sumdz = sumdz + (dz-dz2)
!!$         sumdz = sumdz + dz
      end do
      if(npes > 1) then
         call mpi_allreduce(MPI_IN_PLACE, sumdz2,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
         call mpi_allreduce(MPI_IN_PLACE, sumdz ,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
      end if
    end subroutine WFSD_dot_WFSD
  end subroutine decide_CG_direction_core

! ================================== added by K. Tagami ================== 11.0
  subroutine decide_CG_direction_core_noncl( precon, ik, ekin, afft_kt, bfft_kt, &
       &                                    vnlph_noncl, p, sumdz2, sumdz )
    integer, intent(in)        :: precon, ik
    real(kind=DP), intent(in)  :: ekin(kg1)

    real(kind=DP), intent(inout)  :: afft_kt(nfft,ndim_chgpot)
    real(kind=DP), intent(out) :: bfft_kt(nfft,ndim_spinor)
    real(kind=DP), intent(in)  :: vnlph_noncl(kg1,np_e,kimg,ndim_spinor)

    real(kind=DP)              :: p(kg1)
    real(kind=DP), intent(out) :: sumdz2, sumdz

    integer :: ib, is
    integer :: id_sname = -1
    call tstatc0_begin('decide_CG_direction_core_noncl ', id_sname,1)

    do ib = ista_e, iend_e, istep_e      ! MPI

       Do is=1, ndim_spinor
         call m_ES_WF_in_Rspace( ik+is-1, ib, bfft_kt(:,is) )! (swffft)
       End do

       call m_FFT_Vlocal_W_noncl( afft_kt, bfft_kt, ndim_chgpot, ndim_spinor )
                                           ! (afft, bfft)-> (bfft)
       Do is=1, ndim_spinor
         call m_FFT_WF( ELECTRON, nfout, bfft_kt(:,is), DIRECT, ON )
       End do

       call SD_direction_noncl( precon, ik, ib, ekin, bfft_kt, vnlph_noncl, p )
    end do

    call orthogonalize_SD_drctns_noncl( ik,to=OTHER_BANDS )
                               ! -(m_ES_WF_by_SDorCG) ->(wfsd_l, bsd(ri)_l)

    call WFSD_dot_WFSD_noncl                   ! -(contained here)

    call tstatc0_end(id_sname)

  contains

    subroutine WFSD_dot_WFSD_noncl
      real(kind=DP) :: dz, dz2
      integer :: ib

      sumdz2 = 0.d0
      sumdz = 0.0
      do ib = ista_e, iend_e, istep_e
         call square_of_SD_direction_noncl( ik, ib, dz )
         dz2 = 0.0d0

         if(sw_modified_cg_formula==ON) call square_of_SD_direction3_noncl(ik,ib,dz2)

         sumdz2 = sumdz2 + dz
         sumdz = sumdz + ( dz - dz2 )
      end do
      if(npes > 1) then
         call mpi_allreduce(MPI_IN_PLACE,sumdz2,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
         call mpi_allreduce(MPI_IN_PLACE,sumdz, 1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
      end if
    end subroutine WFSD_dot_WFSD_noncl

  end subroutine decide_CG_direction_core_noncl
! ====================================================================== 11.0

  subroutine m_ESsd_renew_WF_by_SDorCG(nfout,isolver,precon,dtim,iupdate)
#ifdef __TIMER__
    use m_Const_Parameters,   only : VDB, NORMCONSERVATION
#endif
    integer, intent(in) :: nfout,isolver, precon
    integer, intent(in), optional :: iupdate
    real(kind=DP)       :: dtim

    integer                              :: ispin, iksnl, ik, mode, ipri0
    real(kind=DP), pointer, dimension(:) :: ekin, p, vnldi
    real(kind=DP)                        :: vlhxc0

    call m_ES_alloc_afft_scss_etc()
    ekin => sc(1:kg1); p => ss(1:kg1); vnldi => qc(1:kg1)

    mode = ORTHONORMALIZATION

    if(iprisolver >= 2) then
       if(isolver == SD) then
          write(nfout,'(" !! isolver_core = SD")')
       else if(isolver == MSD) then
          write(nfout,'(" !! isolver_core = MSD")')
       else if(isolver == CG) then
          write(nfout,'(" !! isolver_core = CG")')
       end if
    end if


    if(sw_fef==ON) call m_FEF_build_grad() !->grad_fef

    do ispin = 1, nspin, (af+1)
       if(isolver == MSD) call vlhxc_l_zero_term(vlhxc0,ispin) ! -(m_ES_WF_by_SDorCG) ->vlhxc0
       call m_ES_Vlocal_in_Rspace(ispin,afft)      ! (ptfft1) vlhxc_l->afft
       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) == myrank_k) then           ! MPI
             iksnl = (ik-1)/nspin + 1
             call m_ES_Vnonlocal_W(ik,iksnl,ispin,ON)    ! (nonloc) ->(vnlph_l)
             if(sw_hybrid_functional==ON) call m_ES_Vexx_W(ik) ! (exx) ->(vnlph_l)
             if(sw_fef==ON) call m_FEF_add_grad_to_vnlph(ik) !->vnlph_l
             call m_pwBS_kinetic_energies(ik,vkxyz,ekin) ! (diakin) ->ekin
             if(isolver == SD) then
                call evolve_WFs_in_SD_direction&      ! -(m_ES_WF_by_SDorCG)
                     &(precon,ik,dtim,ekin, afft,bfft,p)
             else if(isolver == MSD ) then
                call evolve_WFs_in_MSD_direction&     !-(m_ES_WF_by_SDorCG) 
                     &(precon,ik,iksnl,ispin,dtim,ekin, afft,bfft,p,vnldi,vlhxc0)
                if(ipri>=3.and.ik==1) &
                     & call m_ES_wd_zaj_small_portion(nfout,ik," -- after MSD --",16)
             else if(isolver == eazyCG) then
                call evolve_WFs_in_eazyCG_direction(precon,ik,dtim,ekin,afft,bfft,p)
             else if(isolver == CG) then
                call evolve_WFs_in_CG_direction(precon,ik,dtim,ekin,afft,bfft,p)
!!$                call evolve_WFs_in_CG_direction0(precon,ik,dtim,ekin,afft,bfft,p)
             endif
!!$             if(modnrm == EXECUT) call m_ES_betar_dot_WFs_4_each_k(nfout,ik) !-> fsr_l,fsi_l
! --------------- Added by T. Yamasaki, 28 June 2008 ---
             if(wfred_is_allocated) call cp_wfred(ik)
! ------------------------------------------------------<<
             call m_ES_MGS_4_each_k(nfout,ik,mode)
             if(sw_hybrid_functional==ON) then
                if(sw_retard_eigval_evaluation==OFF)then
                   call m_ES_EXX_eigenvalue_for_each_k(ispin,ik,iupdate=iupdate)
                else
                   call m_ES_EXX_cp_eigenvalue(ik)
                endif
             endif
             call m_ES_eigen_values_for_each_k(ispin,ik,ekin,afft)
          end if
       enddo
    enddo
    if(sw_hybrid_functional==ON.and.sw_retard_eigval_evaluation==ON)then
       call m_ES_EXX_gather_valence_states(nfout)
       do ispin=1,nspin,af+1
          do ik=ispin, kv3+ispin-nspin, nspin
             if(map_k(ik) /= myrank_k) cycle ! MPI
             call m_ES_EXX_eigenvalue_for_each_k(ispin,ik,update_eko=.false.,iupdate=iupdate)
          enddo
       enddo
    endif

!!$    if(nspin == 2 .and. sw_so == ON) then
!!$       do ik = 1, kv3, nspin

#ifdef LMM_PREVIOUS
    call m_ES_sort_eigen_values()   ! -> neordr, nrvf_ordr
! --> T. Yamasaki, 21th Jul. 2009
!!$    call m_ES_sort_eigen_values()   ! -> neordr, nrvf_ordr
! <--
#endif
    call get_ipri0(ipri, ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko(nfout,mode=SCF)
    call m_ES_dealloc_afft_scss_etc()
  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0
  end subroutine m_ESsd_renew_WF_by_SDorCG
  
! =============================== added by K. Tagami ================== 11.0
  subroutine m_ESsd_renew_WF_by_SDorCG_noncl(nfout,isolver,precon,dtim,iupdate)
    integer, intent(in) :: nfout,isolver, precon
    integer, intent(in), optional :: iupdate
    real(kind=DP)       :: dtim

    integer                              :: ispin, iksnl, ik, mode, ipri0
    integer :: is1, is2, istmp, k2

    real(kind=DP), pointer, dimension(:) :: ekin, p, vnldi

    real(kind=DP)                        :: vlhxc0( ndim_chgpot )
    real(kind=DP), allocatable :: afft_kt(:,:)
    real(kind=DP), allocatable :: bfft_kt(:,:)
    real(kind=DP), allocatable :: vnlph_noncl(:,:,:,:)

    call m_ES_alloc_scss_etc()

! --
!   Note : The followig is done in order to prevent allocating new arrays.
!
    ekin => sc(1:kg1); p => ss(1:kg1); vnldi => qc(1:kg1)
! --
    allocate(afft_kt(nfft,ndim_chgpot)); afft_kt = 0.0d0      ! pot
    allocate(bfft_kt(nfft,ndim_spinor)); bfft_kt = 0.0d0      ! wfn

    allocate(vnlph_noncl(kg1,np_e,kimg,ndim_spinor)); vnlph_noncl = 0.0d0

    mode = ORTHONORMALIZATION

    if(iprisolver >= 2) then
       if(isolver == SD) then
          write(nfout,'(" !! isolver_core = SD")')
       else if(isolver == MSD) then
          write(nfout,'(" !! isolver_core = MSD")')
       else if(isolver == CG) then
          write(nfout,'(" !! isolver_core = CG")')
       end if
    end if

    call m_ES_Vlocal_in_Rspace_noncl( afft_kt )      ! (ptfft1) vlhxc_l->afft
    if ( isolver == MSD ) then
       call vlhxc_l_zero_term_noncl( vlhxc0 )
    endif

    Do ik=1, kv3, ndim_spinor
       if (map_k(ik) /= myrank_k) cycle
       iksnl = (ik-1)/ndim_spinor + 1
       
       vnlph_noncl = 0.0d0

       Do is1=1, ndim_spinor
          Do is2=1, ndim_spinor
             istmp = ( is1-1 )*ndim_spinor +is2
             k2 = ik +is2 -1
             
             call m_ES_Vnonlocal_W( k2, iksnl, istmp, ON )
             ! (nonloc) ->(vnlph_l)
             
             vnlph_noncl(:,:,:,is1) = vnlph_noncl(:,:,:,is1) &
                  &                     + vnlph_l(:,:,:)
          End do
       End do
       
       if (sw_hybrid_functional==ON) call m_ES_Vexx_W(ik) ! (exx) ->(vnlph_l)
       
       call m_pwBS_kinetic_energies(ik,vkxyz,ekin) ! (diakin) ->ekin

       select case (isolver)
       case (SD)
          call evolve_WFs_in_SD_direc_noncl( precon, ik, dtim, ekin, &
               &                             afft_kt, bfft_kt, vnlph_noncl, p )
       case (MSD)
          call evolve_WFs_in_MSD_direc_noncl( precon, ik, iksnl, &
               &                              dtim, ekin, afft_kt, bfft_kt,&
               &                              vnlph_noncl, p, vnldi, vlhxc0 )
          if ( ipri>=3.and.ik==1 ) then
             Do is1=1, ndim_spinor
                write(nfout,*) 'is = ', is1
                call m_ES_wd_zaj_small_portion( nfout, ik+is1-1, " -- after MSD  --",21)
             End do
          endif
       case (eazyCG)
          call evolve_WFs_in_ezCG_direc_noncl( precon, ik, dtim, ekin, &
               &                               afft_kt, bfft_kt, vnlph_noncl, p )
          
       case (CG)
          call evolve_WFs_in_CG_direc_noncl( precon, ik, dtim, ekin, &
               &                             afft_kt, bfft_kt, vnlph_noncl, p )
       end select
       

       if (wfred_is_allocated) then
          Do is1=1, ndim_spinor
             call cp_wfred(ik+is1-1)
          End do
       endif
       
       call m_ES_MGS_4_each_k_noncl( nfout, ik, mode )
       
       if (sw_hybrid_functional==ON) call m_ES_EXX_eigenvalue_for_each_k(ispin,ik,iupdate=iupdate)
       
       call m_ES_eigen_vals_each_k_noncl( ik, ekin, afft_kt, bfft_kt )

    End do


#ifdef LMM_PREVIOUS
    call m_ES_sort_eigen_vals_noncl
#endif
    call get_ipri0(ipri, ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko(nfout,mode=SCF)
    call m_ES_dealloc_scss_etc()
    deallocate( afft_kt, bfft_kt )

    deallocate( vnlph_noncl )

  contains

    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0
  end subroutine m_ESsd_renew_WF_by_SDorCG_noncl
! ======================================================================== 11.0

  subroutine evolve_WFs_in_MSD_direction&
       &(precon,ik,iksnl,ispin,dtim,ekin,afft,bfft,p,vnldi,vlhxc0)
    integer, intent(in)        :: precon, ik, iksnl, ispin
    real(kind=DP), intent(in)  :: dtim,ekin(kg1)
    real(kind=DP), intent(in)  :: afft(nfft)
    real(kind=DP), intent(out) :: bfft(nfft)
    real(kind=DP)              :: p(kg1), vnldi(kg1)
    real(kind=DP), intent(in)  :: vlhxc0

    real(kind=DP), allocatable :: vxdi(:) !d(kg1)

    integer ib, ig
    integer :: id_sname = -1
    call tstatc0_begin('evolve_WFs_in_MSD_direction ', id_sname,1)

    if(sw_hybrid_functional==ON) then
       allocate(vxdi(kg1))
       call m_ES_EXX_Diagonal_part(ispin,ik,vxdi)
    end if

#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO private(bfft,vnldi,p)
#endif
    do ib = ista_e, iend_e, istep_e      ! MPI
       call m_ES_WF_in_Rspace(ik,ib,bfft)! (swffft)

       if(ipri >= 2) then
          write(nfout,'(" --- afft and bfft <<evolve_WFs_in_MSD_direction>>,  ib = ",i5)') ib
          write(nfout,'(" afft: ",5d16.8)') (afft(ig),ig=1,min(5,nfft))
          write(nfout,'(" bfft: ",5d16.8)') (bfft(ig),ig=1,min(5,nfft))
       end if

       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft)-> (bfft)
       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)
       call Vnonlocal_Diagonal_part(ispin,ik,iksnl,ib,vnldi)
                                         ! -(m_ES_WF_by_SDorCG) (nonldj)
       if(sw_hybrid_functional==ON) call m_ES_EXX_add_Diagonal_part(ik,ib,vxdi,vnldi)
       if(ipri >= 2) then
          write(nfout,'(" --- vnlph_l <<evolve_WFs_in_MSD_direction>>,  ib = ",i5)') ib
                       write(nfout,'(" vnlph_l: Re ",5d16.8)') (vnlph_l(ig,ib,1),ig=1,min(5,iba(ik)))
          if(kimg== 2) write(nfout,'(" vnlph_l: Im ",5d16.8)') (vnlph_l(ig,ib,2),ig=1,min(5,iba(ik)))

          write(nfout,'(" vnldi ",5d16.8)') (vnldi(ig),ig=1,min(5,iba(ik)))
          write(nfout,'(" VlocalW: Re ",5d16.8)') (bfft(2*igf(nbase(ig,ik))-1),ig=1,min(5,iba(ik)))
          write(nfout,'(" VlocalW: Im ",5d16.8)') (bfft(2*igf(nbase(ig,ik))),ig=1,min(5,iba(ik)))
          write(nfout,'(" vlhxc0 = ",5d16.8)') vlhxc0
       end if
       call modified_steepest_descent&   ! -(m_ES_WF_by_SDorCG)
            &(precon,ik,ib,dtim,vnldi,vlhxc0,ekin,bfft,p)
    end do
    if(ipri>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')

    if(sw_hybrid_functional==ON) deallocate(vxdi)

    call tstatc0_end(id_sname)
  end subroutine evolve_WFs_in_MSD_direction

! ========================================= added by K. Tagami =============== 11.0
 subroutine evolve_WFs_in_MSD_direc_noncl( precon, ik, iksnl, &
       &                                    dtim, ekin, afft_kt, bfft_kt, &
       &                                    vnlph_noncl, p, vnldi, vlhxc0 )

    integer, intent(in)        :: precon, ik, iksnl
    real(kind=DP), intent(in)  :: dtim,ekin(kg1)
    real(kind=DP), intent(inout)  :: afft_kt(nfft,ndim_chgpot)
    real(kind=DP), intent(out) :: bfft_kt(nfft,ndim_spinor)
    real(kind=DP), intent(in)  :: vnlph_noncl(kg1,np_e,kimg,ndim_spinor)

    real(kind=DP)              :: p(kg1), vnldi(kg1)
    real(kind=DP), intent(in)  :: vlhxc0(ndim_chgpot)
!
#ifdef USE_COMPLEX_VNLDI
    complex(kind=CMPLDP), allocatable :: vnldi_noncl(:,:)
#else
    real(kind=DP), allocatable :: vnldi_noncl(:,:)
#endif
!
    integer ib, ig, is, istmp
    integer :: is1, is2

    integer :: id_sname = -1

    call tstatc0_begin('evolve_WFs_in_MSD_direc_noncl ', id_sname,1)

! ---------------------
    allocate( vnldi_noncl( kg1, ndim_spinor)); vnldi_noncl = 0.0d0
!    Do is=1, ndim_spinor
!      vnldi_noncl(:,is) = vnldi(:)
!    End do
! -----------------------

#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO private(bfft,vnldi,p)
#endif
    do ib = ista_e, iend_e, istep_e      ! MPI

       Do is=1, ndim_spinor
          call m_ES_WF_in_Rspace( ik +is -1, ib, bfft_kt(:,is) ) ! (swffft)
       End do

       call m_FFT_Vlocal_W_noncl( afft_kt, bfft_kt, ndim_chgpot, ndim_spinor )
                                                       ! (afft, bfft)-> (bfft)
       Do is=1, ndim_spinor
         call m_FFT_WF( ELECTRON, nfout, bfft_kt(:,is), DIRECT, ON )
       End do

       vnldi_noncl = 0.0d0
       Do is1=1, ndim_spinor
          Do is2=1, ndim_spinor
             istmp = ( is1 -1 )*ndim_spinor +is2

             call Vnonlocal_Diagonal_part_noncl( istmp, ik, iksnl, ib, &
                  &                              vnldi_noncl(:,is1) )
!             call Vnonlocal_Diagonal_part_noncl( istmp, ik, iksnl, ib, &
!                  &                              vnldi_noncl(:,is2) )
                                                    ! -(m_ES_WF_by_SDorCG) (nonldj)
          End do
       End do

       call modified_steepest_desc_noncl( precon, ik, ib, dtim, &
            &                             vnldi_noncl, vlhxc0, ekin,&
            &                             bfft_kt, vnlph_noncl, p )
    end do

    call tstatc0_end(id_sname)
    deallocate( vnldi_noncl)

  end subroutine evolve_WFs_in_MSD_direc_noncl
! ========================================================================= 11.0

  subroutine evolve_WFs_in_SD_direction&
       &(precon,ik,dtim,ekin,afft,bfft,p)
    integer, intent(in)        :: precon, ik
    real(kind=DP), intent(in)  :: dtim,ekin(kg1)
    real(kind=DP), intent(in)  :: afft(nfft)
    real(kind=DP), intent(out) :: bfft(nfft)
    real(kind=DP)              :: p(kg1)

    integer :: ib
    integer :: id_sname = -1
    call tstatc0_begin('evolve_WFs_in_SD_direction ', id_sname,1)

    do ib = ista_e, iend_e, istep_e      ! MPI
       call m_ES_WF_in_Rspace(ik,ib,bfft)! (swffft)
       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft)-> (bfft)
       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)
       call steepest_descent(precon,ik,ib,dtim,ekin,bfft,p)
                                         ! -(m_ES_WF_by_SDorCG)
    end do
    if(ipri>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
    call tstatc0_end(id_sname)
  end subroutine evolve_WFs_in_SD_direction

! =============================== added by K. Tagami =================== 11.0
  subroutine evolve_WFs_in_SD_direc_noncl( precon, ik, dtim, ekin, &
       &                                   afft_kt, bfft_kt, vnlph_noncl, p )
    integer, intent(in)        :: precon, ik
    real(kind=DP), intent(in)  :: dtim,ekin(kg1)
    real(kind=DP), intent(inout)  :: afft_kt( nfft,ndim_chgpot )
    real(kind=DP), intent(out) :: bfft_kt(nfft,ndim_spinor)
    real(kind=DP), intent(in)  :: vnlph_noncl(kg1,np_e,kimg,ndim_spinor)

    real(kind=DP)              :: p(kg1)

    integer :: ib, is
    integer :: id_sname = -1
    call tstatc0_begin('evolve_WFs_in_SD_direc_noncl ', id_sname,1)

    do ib = ista_e, iend_e, istep_e      ! MPI
       Do is=1, ndim_spinor
         call m_ES_WF_in_Rspace( ik+is-1, ib, bfft_kt(:,is) )  ! (swffft)
       End do

       call m_FFT_Vlocal_W_noncl( afft_kt, bfft_kt, nspin, ndim_spinor )

       Do is=1, ndim_spinor
         call m_FFT_WF( ELECTRON, nfout, bfft_kt(:,is), DIRECT, ON )
       End do

       call steepest_descent_noncl( precon, ik, ib, dtim, ekin, bfft_kt, &
            &                       vnlph_noncl, p )
    end do

    call tstatc0_end(id_sname)

  end subroutine evolve_WFs_in_SD_direc_noncl
! =========================================================================== 11.0

  subroutine evolve_WFs_in_eazyCG_direction(precon,ik,dtim,ekin,afft,bfft,p)
    integer, intent(in)        :: precon, ik
    real(kind=DP), intent(in)  :: dtim,ekin(kg1)
    real(kind=DP), intent(in)  :: afft(nfft)
    real(kind=DP), intent(out) :: bfft(nfft)
    real(kind=DP)              :: p(kg1)

    real(kind=DP), parameter   :: Delta = 1.d-10
!!$    real(kind=DP)   :: dz, sumdz2
    integer :: ib
    integer :: id_sname = -1
    call tstatc0_begin('evolve_WFs_in_eazyCG_direction ', id_sname,1)

    if(modnrm == EXECUT) call alloc_wfsd_bsdri(ik)
    if(modnrm == EXECUT .and. precon == ON) call alloc_wfsdnp_bsdrinp(ik)

    do ib = ista_e, iend_e, istep_e      ! MPI
       call m_ES_WF_in_Rspace(ik,ib,bfft)! (swffft)
       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft) -> (bfft)
       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON) ! bfft: G-space repres.
       call SD_direction(precon,ik,ib,ekin,bfft,p)! -(m_ES_WF_by_SDorCG) zaj_l, etc -> wfsd_l
       !    ~~~~~~~~~~~~
    end do

!!$    call orthogonalize_SD_drctns(ik,to=OTHER_BANDS)   ! -(m_ES_WF_by_SDorCG) ->wfsd_l
    if(precon == ON) call Precon_dot_SD(ik,ekin,p)  ! -(m_ES_WF_by_SDorCG) -> wfsd_np, wfsd_l
!!$    call orthogonalize_SD_drctns(ik,to=ALL_BANDS)     ! -(m_ES_WF_by_SDorCG) ->wfsd_l
    !                                      wfsd_l is orthogonalized to zaj_l's
    if(modnrm == EXECUT) call m_ES_betar_dot_Psi_4_each_k(nfout,wfsd_l,ik,ik,ik,bsdr_l,bsdi_l) 
    if(modnrm == EXECUT .and. precon == ON ) then
       write(6,'(" m_ES_betar_dot_Psi_4_each_k is being called (evolve_WFs_in_eazyCG_direction)")')
       call m_ES_betar_dot_Psi_4_each_k(nfout,wfsd_np,ik,ik,ik,bsdr_np,bsdi_np)
    end if
    call get_betacg                      ! -(contained here) wfsd_l ->betacg, dzajn2
    !    ~~~~~~~~~~
!!$    do ib = ista_e, iend_e, istep_e      ! MPI
!!$       call m_ES_WF_in_Rspace(ik,ib,bfft)! (swffft)
!!$       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft) -> (bfft)
!!$       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON) ! bfft: G-space repres.
!!$       call SD_direction(precon,ik,ib,ekin,bfft,p)! -(m_ES_WF_by_SDorCG) zaj_l, etc -> wfsd_l
!!$       !    ~~~~~~~~~~~~
!!$    end do
!!$
!!$    sumdz2 = 0.d0
!!$    do ib = ista_e, iend_e, istep_e      ! MPI
!!$       call square_of_SD_direction(ik,ib,dz)  ! wfsd_l dot wfsd_l
!!$       write(nfout,'(" dz = ",d20.8)') dz
!!$       sumdz2 = sumdz2 + dz
!!$    end do

    call make_CG_direction(ik)
!!$    write(6,'(" -- before orthonormalization -- ")')
!!$    call check_of_orthonormality(ik)  ! z = <wfsd_l(i)|zaj_l(j)>
!!$    call orthogonalize_SD_drctns(ik,to=OTHER_BANDS)     ! -(m_ES_WF_by_SDorCG) ->wfsd_l
    call cp_wfsd_to_wfsd_old(ik)                        ! -(m_ES_WF_by_SDorCG) wfsd_l ->wfsd_old
!!$    write(6,'(" -- after orthonormalization -- ")')
!!$    call check_of_orthonormality(ik)  ! z = <wfsd_l(i)|zaj_l(j)>

!!$    write(6,'(" -- before evolution -- ")')
!!$    call check_of_orthonormality2(ik)  ! <zaj_l(i)|zaj_l(j)>
    do ib = ista_e, iend_e, istep_e      ! MPI
       call WF_conjugate_gradient(ik,ib,dtim) !-(m_ES_WF_by_SDorCG)
    end do
    if(ipri>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
!!$    write(6,'(" -- after evolution -- ")')
!!$    call check_of_orthonormality2(ik)  ! <zaj_l(i)|zaj_l(j)>

!!$    do ib = ista_e, iend_e, istep_e      ! MPI
!!$       call m_ES_WF_in_Rspace(ik,ib,bfft)! (swffft)
!!$       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft) -> (bfft)
!!$       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)
!!$       call WF_conjugate_gradient0(precon,ik,ib,dtim,ekin,bfft,p)
!!$       !    ~~~~~~~~~~~~~~~~~~~~~~         -(m_ES_WF_by_SDorCG)
!!$    end do
    if(modnrm == EXECUT) call dealloc_wfsd_bsdri()
    if(modnrm == EXECUT .and. precon == ON) call dealloc_wfsdnp_bsdrinp()
    call tstatc0_end(id_sname)
  contains
    subroutine get_betacg
      real(kind=DP) :: sumdz2, dz, avbetacg, betacg_min, betacg_max, avnewbetacg
      integer       :: ib

      if(ik == ista_k) then
         betacg_min = 1.d+10; betacg_max = -1.d+10; avbetacg = 0.d0
         avnewbetacg = 0.d0
      end if

      sumdz2 = 0.d0
      do ib = ista_e, iend_e, istep_e
         if(ipri >=1 ) write(6,'(" !! square_of_SD_direction(2?) is being called (evolve_WFs_in_eazyCG_direction.betacg)")')
         if(Precon == ON) then
            call square_of_SD_direction2(ik,ib,dz)
         else
            call square_of_SD_direction(ik,ib,dz)
         end if
         sumdz2 = sumdz2 + dz
      end do
      if(npes>1) call mpi_allreduce(MPI_IN_PLACE,sumdz2,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)

      if(dabs(dzajn2(ik)) > Delta) then
         betacg = sumdz2/dzajn2(ik)
      else
         betacg = 0.d0
      endif
      dzajn2(ik) = sumdz2

      if(ipri >= 1) write(nfout,'(" ik = ",i5," sumdz2 = ", d20.8, " betacg = ",d20.8)') ik,sumdz2,betacg
      if(betacg_min > betacg) betacg_min = betacg
      if(betacg_max < betacg) betacg_max = betacg
      avbetacg = avbetacg + betacg/kv3

      if(betacg > 1.d0) betacg = 1.d0
      if(betacg < 0.d0) betacg = 0.d0

      if(kv3 > 1 .and. ik == iend_k) then              ! MPI
         avnewbetacg = avnewbetacg + betacg/kv3
         if(ipri >= 1) write(nfout, '(" ! average of betacg = ",2f10.6," range ",f10.6,"-" &
              &,       f10.6)') avbetacg, avnewbetacg, betacg_min, betacg_max
      end if
    end subroutine get_betacg

    subroutine check_of_orthonormality(ik)
      integer, intent(in) :: ik
      integer             :: i, j, ig
      real(kind=DP)       :: wz

      if(k_symmetry(ik) == GAMMA) then
         do j = ista_e, iend_e, istep_e
            do i = ista_e, iend_e, istep_e
               wz = 0.d0
               do ig = 2, iba(ik)
                  wz = wz + wfsd_l(ig,i,ik,1)*zaj_l(ig,j,ik,1)
               end do
               wz = wz*2.d0 + wfsd_l(1,i,ik,1)*zaj_l(1,j,ik,1)
               if(ipri >= 1) write(6,'(" (i,j) = ",2i5, " wz = ",d20.8)') i,j, wz
            end do
         end do
      else
         do j = ista_e, iend_e, istep_e
            do i = ista_e, iend_e, istep_e
               wz = 0.d0
               do ig = 1, iba(ik)
                  wz = wz + wfsd_l(ig,i,ik,1)*zaj_l(ig,j,ik,1)
               end do
               if(ipri >= 1) write(6,'(" (i,j) = ",2i5, " wz = ",d20.8)') i,j, wz
            end do
         end do
      end if
    end subroutine check_of_orthonormality

    subroutine check_of_orthonormality2(ik)
      integer, intent(in) :: ik
      integer             :: i, j, ig
      real(kind=DP)       :: wz

      if(k_symmetry(ik) == GAMMA) then
         do j = ista_e, iend_e, istep_e
            do i = ista_e, iend_e, istep_e
               wz = 0.d0
               do ig = 2, iba(ik)
                  wz = wz + zaj_l(ig,i,ik,1)*zaj_l(ig,j,ik,1)
               end do
               wz = wz*2.d0 + zaj_l(1,i,ik,1)*zaj_l(1,j,ik,1)
               if(ipri >=1 ) write(6,'(" (i,j) = ",2i5, " zz = ",d20.8)') i,j, wz
            end do
         end do
      else
         do j = ista_e, iend_e, istep_e
            do i = ista_e, iend_e, istep_e
               wz = 0.d0
               do ig = 1, iba(ik)
                  wz = wz + zaj_l(ig,i,ik,1)*zaj_l(ig,j,ik,1)
               end do
               wz = wz*2.d0
               if(ipri >=1 ) write(6,'(" (i,j) = ",2i5, " zz = ",d20.8)') i,j, wz
            end do
         end do
      end if
    end subroutine check_of_orthonormality2
  end subroutine evolve_WFs_in_eazyCG_direction

! ============================ added by K. Tagami ========================= 11.0
  subroutine evolve_WFs_in_ezCG_direc_noncl( precon, ik, dtim, ekin,&
       &                                     afft_kt, bfft_kt, vnlph_noncl,  p )
    integer, intent(in)        :: precon, ik
    real(kind=DP), intent(in)  :: dtim,ekin(kg1)
    real(kind=DP), intent(inout)  :: afft_kt(nfft,ndim_chgpot)
    real(kind=DP), intent(out) :: bfft_kt(nfft,ndim_spinor)
    real(kind=DP), intent(in)  :: vnlph_noncl(kg1,np_e,kimg,ndim_spinor)
    real(kind=DP)              :: p(kg1)

    real(kind=DP), parameter   :: Delta = 1.d-10

    integer :: ib, is
    integer :: id_sname = -1
    call tstatc0_begin('evolve_WFs_in_eazyCG_dire_noncl ', id_sname,1)

    if (modnrm==EXECUT) call alloc_wfsd_bsdri_noncl(ik,ik+ndim_spinor-1)

    if (modnrm==EXECUT .and. precon==ON) then
	call alloc_wfsdnp_bsdrinp_noncl( ik,ik+ndim_spinor-1 )
    endif	

    do ib = ista_e, iend_e, istep_e      ! MPI
       Do is=1, ndim_spinor
         call m_ES_WF_in_Rspace( ik+is-1, ib, bfft_kt(:,is) )  ! (swffft)
       End do

       call m_FFT_Vlocal_W_noncl( afft_kt, bfft_kt, nspin, ndim_spinor )

       Do is=1, ndim_spinor
         call m_FFT_WF( ELECTRON, nfout, bfft_kt(:,is), DIRECT, ON )
                                           ! bfft: G-space repres.
       End do
!
       call SD_direction_noncl( precon, ik, ib, ekin, bfft_kt, vnlph_noncl, p )

    end do

    if (precon == ON) then
       call Precon_dot_SD_noncl( ik, ekin, p ) 
                   ! -(m_ES_WF_by_SDorCG) -> wfsd_np, wfsd_l
    endif

    if (modnrm == EXECUT) then
       Do is=1, ndim_spinor
          call m_ES_betar_dot_Psi_4_each_k(nfout, wfsd_l, ik, ik+ndim_spinor-1, &
	&                                   ik+is-1, bsdr_l, bsdi_l) 
       End do
    endif
    if (modnrm == EXECUT .and. precon == ON ) then
       Do is=1, ndim_spinor
          call m_ES_betar_dot_Psi_4_each_k(nfout, wfsd_np, ik, ik+ndim_spinor-1, &
	&                                   ik+is-1, bsdr_np, bsdi_np ) 
       End do
    end if

    call get_betacg_noncl
                                     ! -(contained here) wfsd_l ->betacg, dzajn2
    Do is=1, ndim_spinor
      call cp_wfsd_to_wfsd_old(ik+is-1)
                                   ! -(m_ES_WF_by_SDorCG) wfsd_l ->wfsd_old
      call make_CG_direction(ik+is-1)
    End do

    do ib = ista_e, iend_e, istep_e      ! MPI
       Do is=1, ndim_spinor
          call WF_conjugate_gradient( ik+is-1, ib, dtim ) !-(m_ES_WF_by_SDorCG)
       End do
    end do

    if(modnrm == EXECUT) call dealloc_wfsd_bsdri()
    if(modnrm == EXECUT .and. precon == ON) call dealloc_wfsdnp_bsdrinp()

    call tstatc0_end(id_sname)

  contains

    subroutine get_betacg_noncl
      real(kind=DP) :: sumdz2, dz, avbetacg, betacg_min, betacg_max, avnewbetacg
      integer       :: ib

      if(ik == ista_k) then                ! MPI
         betacg_min = 1.d+10; betacg_max = -1.d+10; avbetacg = 0.d0
         avnewbetacg = 0.d0
      end if

      sumdz2 = 0.d0
      do ib = ista_e, iend_e, istep_e
         if(ipri >=1 ) write(6,'(" !! square_of_SD_direction(2?) is being called (evolve_WFs_in_eazyCG_direction.betacg)")')
         if(Precon == ON) then
            call square_of_SD_direction2_noncl(ik,ib,dz)
         else
            call square_of_SD_direction_noncl(ik,ib,dz)
         end if
         sumdz2 = sumdz2 + dz
      end do

      if(npes>1) call mpi_allreduce(MPI_IN_PLACE,sumdz2,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)

      if(dabs(dzajn2(ik)) > Delta) then
         betacg = sumdz2/dzajn2(ik)
      else
         betacg = 0.d0
      endif
      dzajn2(ik) = sumdz2

      if(ipri >= 1) write(nfout,'(" ik = ",i5," sumdz2 = ", d20.8, " betacg = ",d20.8)') ik,sumdz2,betacg
      if(betacg_min > betacg) betacg_min = betacg
      if(betacg_max < betacg) betacg_max = betacg
      avbetacg = avbetacg + betacg / ( kv3/ndim_spinor )

      if(betacg > 1.d0) betacg = 1.d0
      if(betacg < 0.d0) betacg = 0.d0

      if(kv3 > 1 .and. ik == iend_k-ndim_spinor+1 )  then              ! MPI
         avnewbetacg = avnewbetacg + betacg/ ( kv3 /ndim_spinor )
         if(ipri >= 1) write(nfout, '(" ! average of betacg = ",2f10.6," range ",f10.6,"-" &
              &,       f10.6)') avbetacg, avnewbetacg, betacg_min, betacg_max
      end if
    end subroutine get_betacg_noncl

    subroutine check_of_orthonormality_noncl(ik)
      integer, intent(in) :: ik
      integer             :: i, j, ig
      real(kind=DP)       :: wz
      real(kind=DP)       :: wz1, wz2

      if(k_symmetry(ik) == GAMMA) then
         do j = ista_e, iend_e, istep_e
            do i = ista_e, iend_e, istep_e
               wz1 = 0.d0; wz2 = 0.0d0
               Do is=1, ndim_spinor
                 do ig = 2, iba(ik)
                    wz1 = wz1 + wfsd_l(ig,i,ik+is-1,1)*zaj_l(ig,j,ik+is-1,1)
                 end do
               End do
               Do is=1, ndim_spinor
                  wz2 = wz2 + wfsd_l(1,i,ik+is-1,1)*zaj_l(1,j,ik+is-1,1)
               End do
               wz = wz1*2.d0 + wz2
               if(ipri >= 1) write(6,'(" (i,j) = ",2i5, " wz = ",d20.8)') i,j, wz
            end do
         end do
      else
         do j = ista_e, iend_e, istep_e
            do i = ista_e, iend_e, istep_e
               wz = 0.d0
               Do is=1, ndim_spinor
                  do ig = 1, iba(ik)
                     wz = wz + wfsd_l(ig,i,ik+is-1,1)*zaj_l(ig,j,ik+is-1,1)
                  end do
               End do
               if(ipri >= 1) write(6,'(" (i,j) = ",2i5, " wz = ",d20.8)') i,j, wz
            end do
         end do
      end if
    end subroutine check_of_orthonormality_noncl

    subroutine check_of_orthonormality2_noncl(ik)
      integer, intent(in) :: ik
      integer             :: i, j, ig
      real(kind=DP)       :: wz
      real(kind=DP)       :: wz1, wz2

      if(k_symmetry(ik) == GAMMA) then
         do j = ista_e, iend_e, istep_e
            do i = ista_e, iend_e, istep_e
               wz1 = 0.d0; wz2 = 0.0d0
               Do is=1, ndim_spinor
                 do ig = 2, iba(ik)
                    wz1 = wz1 + zaj_l(ig,i,ik+is-1,1)*zaj_l(ig,j,ik+is-1,1)
                 end do
               End do
               Do is=1, ndim_spinor
                  wz2 = wz2 + zaj_l(1,i,ik+is-1,1)*zaj_l(1,j,ik+is-1,1)
               End do
               wz = wz1*2.d0 + wz2

               if(ipri >=1 ) write(6,'(" (i,j) = ",2i5, " zz = ",d20.8)') i,j, wz
            end do
         end do
      else
         do j = ista_e, iend_e, istep_e
            do i = ista_e, iend_e, istep_e
               wz = 0.d0
               Do is=1, ndim_spinor
                 do ig = 1, iba(ik)
                    wz = wz + zaj_l(ig,i,ik+is-1,1)*zaj_l(ig,j,ik+is-1,1)
                 end do
               End do
               wz = wz*2.d0
               if(ipri >=1 ) write(6,'(" (i,j) = ",2i5, " zz = ",d20.8)') i,j, wz
            end do
         end do
      end if
    end subroutine check_of_orthonormality2_noncl

  end subroutine evolve_WFs_in_ezCG_direc_noncl
! ===================================================================== 11.0

  subroutine evolve_WFs_in_CG_direction(precon,ik,dtim,ekin,afft,bfft,p)
    integer, intent(in)        :: precon, ik
    real(kind=DP), intent(in)  :: dtim,ekin(kg1)
    real(kind=DP), intent(in)  :: afft(nfft)
    real(kind=DP), intent(out) :: bfft(nfft)
    real(kind=DP)              :: p(kg1)

    integer :: ib
    integer :: id_sname = -1
    call tstatc0_begin('evolve_WFs_in_CG_direction ', id_sname,1)

    call alloc_wfsd_bsdri(ik)

    do ib = ista_e, iend_e, istep_e
       call m_ES_WF_in_Rspace(ik,ib,bfft)! (swffft)
       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft) -> (bfft)
       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON) ! bfft: G-space repres.
       call SD_direction(precon,ik,ib,ekin,bfft,p)     ! -(m_ES_WF_by_SDorCG) -> wfsd_l
       !                wfsd_l : -(H-e_{k\mu}^m)\Psi_{k\mu}^m
    end do

    call orthogonalize_SD_drctns(ik,to=SAME_BAND) ! -(m_ES_WF_by_SDorCG) ->(wfsd_l,bsd(ri)_l)
    call make_CG_direction(ik)       ! -(m_ES_WF_by_SDorCG) -> wfsd_l + betacg*wfsd_old -> wfsd_l
!!$    call orthogonalize_SD_drctns(ik,to=SAME_BAND) ! Actually, CG direction ->(wfsd_l,bsd(ri)_l)

    do ib = ista_e, iend_e, istep_e
       call WF_conjugate_gradient(ik,ib,dtim) !-(m_ES_WF_by_SDorCG)
    end do

    call cp_wfsd_to_wfsd_old(ik)    ! -(m_ES_WF_by_SDorCG) wfsd_l ->wfsd_old

    call dealloc_wfsd_bsdri()
    call tstatc0_end(id_sname)
  end subroutine evolve_WFs_in_CG_direction

! ======================================= added by K. Tagami ================= 11.0
  subroutine evolve_WFs_in_CG_direc_noncl( precon, ik, dtim, ekin, &
       &                                   afft_kt, bfft_kt, vnlph_noncl, p)
    integer, intent(in)        :: precon, ik
    real(kind=DP), intent(in)  :: dtim,ekin(kg1)
    real(kind=DP), intent(inout)  :: afft_kt(nfft,ndim_chgpot)
    real(kind=DP), intent(out) :: bfft_kt(nfft,ndim_spinor)
    real(kind=DP), intent(in)  :: vnlph_noncl(kg1,np_e,kimg,ndim_spinor)
    real(kind=DP)              :: p(kg1)

    integer :: ib, is
    integer :: id_sname = -1
    call tstatc0_begin('evolve_WFs_in_CG_direc_noncl ', id_sname,1)

    call alloc_wfsd_bsdri_noncl( ik,ik+ndim_spinor-1 )

    do ib = ista_e, iend_e, istep_e

       Do is=1, ndim_spinor
          call m_ES_WF_in_Rspace( ik+is-1, ib, bfft_kt(:,is) )   ! (swffft)
       End do

       call m_FFT_Vlocal_W_noncl( afft_kt, bfft_kt, ndim_chgpot, ndim_spinor )

       Do is=1, ndim_spinor
         call m_FFT_WF( ELECTRON, nfout, bfft_kt(:,is), DIRECT, ON )
       End do

       call SD_direction_noncl( precon, ik, ib, ekin, bfft_kt, vnlph_noncl, p )
                                 ! -(m_ES_WF_by_SDorCG) -> wfsd_l
                                  !        wfsd_l : -(H-e_{k\mu}^m)\Psi_{k\mu}^m

    end do

    call orthogonalize_SD_drctns_noncl( ik,to=SAME_BAND )
                       ! -(m_ES_WF_by_SDorCG) ->(wfsd_l,bsd(ri)_l)
    
    Do is=1, ndim_spinor
      call make_CG_direction(ik+is-1)
                  ! -(m_ES_WF_by_SDorCG) -> wfsd_l + betacg*wfsd_old -> wfsd_l
    End do
    do ib = ista_e, iend_e, istep_e           ! MPI
       Do is=1, ndim_spinor
          call WF_conjugate_gradient( ik+is-1, ib, dtim )   !-(m_ES_WF_by_SDorCG)
       End do
    end do

    Do is=1, ndim_spinor
       call cp_wfsd_to_wfsd_old( ik+is-1 ) 
                                       ! -(m_ES_WF_by_SDorCG) wfsd_l ->wfsd_old
    End do

    call dealloc_wfsd_bsdri()
    call tstatc0_end(id_sname)
  end subroutine evolve_WFs_in_CG_direc_noncl
! ================================================================= 11.0

  subroutine evolve_WFs_in_CG_direction0 &
       &(precon,ik,dtim,ekin,afft,bfft,p)
    integer, intent(in)        :: precon, ik
    real(kind=DP), intent(in)  :: dtim,ekin(kg1)
    real(kind=DP), intent(in)  :: afft(nfft)
    real(kind=DP), intent(out) :: bfft(nfft)
    real(kind=DP)              :: p(kg1)

    integer :: ib
    integer :: id_sname = -1
    call tstatc0_begin('evolve_WFs_in_CG_direction0 ', id_sname,1)

    do ib = ista_e, iend_e, istep_e
       call m_ES_WF_in_Rspace(ik,ib,bfft)! (swffft)
       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft) -> (bfft)
       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)
       call WF_conjugate_gradient0(precon,ik,ib,dtim,ekin,bfft,p) !-(m_ES_WF_by_SDorCG)
    end do
    if(ipri>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
    call tstatc0_end(id_sname)
  end subroutine evolve_WFs_in_CG_direction0

  subroutine vlhxc_l_zero_term(vlhxc0,ispin)
    real(kind=DP), intent(out) :: vlhxc0
    integer, intent(in)        :: ispin

    if(mype == 0) vlhxc0 = vlhxc_l(1,1,ispin)
    call mpi_bcast(vlhxc0,1,mpi_double_precision,0,mpi_comm_group,ierr)
  end subroutine vlhxc_l_zero_term

! ===================================== added by K. Tagami ============== 11.0
  subroutine vlhxc_l_zero_term_noncl( vlhxc0 )
    real(kind=DP), intent(out) :: vlhxc0(ndim_chgpot)

    vlhxc0 = 0.0d0
! 
    if (mype == 0) then
! ------------------------------ uncertain ----
!        vlhxc0(1)           = vlhxc_l(1,1,1) + vlhxc_l(1,1,ndim_magmom)
!        vlhxc0(ndim_chgpot) = vlhxc_l(1,1,1) - vlhxc_l(1,1,ndim_magmom)
!
       vlhxc0 = vlhxc_l(1,1,1)
! --------------------------
    endif
    call mpi_bcast( vlhxc0, ndim_chgpot, mpi_double_precision,0,mpi_comm_group,ierr)
  end subroutine vlhxc_l_zero_term_noncl
! ========================================================================= 11.0

  subroutine modified_steepest_descent&
       &(precon,ik,ibo,dtim,vnldi,vlhxc0,ekin,VlocalW,p)
    integer      , intent(in)                  :: precon,ik,ibo
    real(kind=DP), intent(in)                  :: dtim
    real(kind=DP), intent(in), dimension(kg1)  :: vnldi
    real(kind=DP), intent(in)                  :: vlhxc0
    real(kind=DP), intent(in), dimension(kg1)  :: ekin
    real(kind=DP), intent(in), dimension(nfft) :: VlocalW
    real(kind=DP)            , dimension(kg1)  :: p

    integer       :: i, i1, ib
    real(kind=DP) :: evr,devr,denom, wdi, evi,e1, devi, fdexp
!!$    integer :: id_sname = -1
!!$    call tstatc0_begin('modified_steepest_descent ', id_sname)

    ib = map_z(ibo)                            ! MPI
    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    call m_ES_decide_precon_factor(precon,ik,ibo,ekin,p)  ! -> p(1:iba(ik))
    if(ipri >= 3) then
       write(nfout,'(" ekin : ",5d16.8)') (ekin(i),i=1,iba(ik))
       write(nfout,'(" p    : ",5d16.8)') (p(i),i=1,iba(ik))
    end if

#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
    if(kimg == 1) then
       do i = 1, iba(ik)
          i1    = igf(nbase(i,ik))
          evr   = zaj_l(i,ib,ik,1)
          devr  = (ekin(i)-eko_l(ib,ik))*evr&
               & + VlocalW(i1)*denom + vnlph_l(i,ib,1)
          wdi   = ekin(i) + vlhxc0 + vnldi(i) - eko_l(ib,ik)
! === 0 divide occurs if abs(wdi) < epsilon. by tkato 2012/12/18 ===============
!         fdexp = dexp( -p(i) * wdi * dtim)
!         zaj_l(i,ib,ik,1) = (fdexp - 1)*devr/wdi + evr
          if(dabs(wdi) < SmallestPositiveNumber) then
             zaj_l(i,ib,ik,1) = -p(i)*devr*dtim + evr
          else
             fdexp = dexp( -p(i) * wdi * dtim)
             zaj_l(i,ib,ik,1) = (fdexp - 1)*devr/wdi + evr
          end if
! ==============================================================================
       end do
    else if(kimg == 2) then
       do i = 1, iba(ik)
          i1    = igf(nbase(i,ik))
          evr   = zaj_l(i,ib,ik,1);    evi   = zaj_l(i,ib,ik,2)
          e1    = ekin(i) - eko_l(ib,ik)
          devr  = e1*evr+VlocalW(2*i1-1)*denom+vnlph_l(i,ib,1)
          devi  = e1*evi+VlocalW(2*i1  )*denom+vnlph_l(i,ib,2)
          wdi   = ekin(i) + vlhxc0 + vnldi(i) - eko_l(ib,ik)
! === 0 divide occurs if abs(wdi) < epsilon. by tkato 2012/12/18 ===============
!         fdexp = dexp( -p(i) * wdi * dtim)
!         zaj_l(i,ib,ik,1) = (fdexp - 1)*devr/wdi + evr
!         zaj_l(i,ib,ik,2) = (fdexp - 1)*devi/wdi + evi
          if(dabs(wdi) < SmallestPositiveNumber) then
             zaj_l(i,ib,ik,1) = -p(i)*devr*dtim + evr
             zaj_l(i,ib,ik,2) = -p(i)*devi*dtim + evi
          else
             fdexp = dexp( -p(i) * wdi * dtim)
             zaj_l(i,ib,ik,1) = (fdexp - 1)*devr/wdi + evr
             zaj_l(i,ib,ik,2) = (fdexp - 1)*devi/wdi + evi
          end if
! ==============================================================================
       end do
    end if
!!$    call tstatc0_end(id_sname)
  end subroutine modified_steepest_descent

! ================================ added by K. Tagami =================== 11.0
  subroutine modified_steepest_desc_noncl( precon, ik, ibo, dtim, &
       &                                   vnldi_noncl, vlhxc0, ekin, &
       &                                   VlocalW_noncl, vnlph_noncl, p )
    integer      , intent(in)                  :: precon,ik,ibo
    real(kind=DP), intent(in)                  :: dtim

#ifdef USE_COMPLEX_VNLDI
    complex(kind=CMPLDP), intent(in), dimension(kg1,ndim_spinor)  :: vnldi_noncl
#else
    real(kind=DP), intent(in), dimension(kg1,ndim_spinor)  :: vnldi_noncl
#endif

    real(kind=DP), intent(in)                  :: vlhxc0(ndim_chgpot)
    real(kind=DP), intent(in), dimension(kg1)  :: ekin
    real(kind=DP), intent(in), dimension(nfft,ndim_spinor) :: VlocalW_noncl
    real(kind=DP), intent(in), dimension(kg1,np_e,kimg,ndim_spinor) :: vnlph_noncl

    real(kind=DP)            , dimension(kg1)  :: p

    integer       :: i, i1, ib
    integer  :: is, k1, istmp

#ifdef USE_COMPLEX_VNLDI
    real(kind=DP) :: evr,devr,denom, evi, e1, devi
    complex(kind=CMPLDP) :: zwdi, zfdexp, ztmp1
    real(kind=DP) :: ctmp1, stmp1
#else
    real(kind=DP) :: evr,devr,denom, wdi, evi,e1, devi, fdexp
#endif

    ib = map_z(ibo)                            ! MPI
    denom = 1.d0/product(fft_box_size_WF(1:3,1))

    call m_ES_decide_precon_factor(precon,ik,ibo,ekin,p)  ! -> p(1:iba(ik))

    if(ipri >= 3) then
       write(nfout,'(" ekin : ",5d16.8)') (ekin(i),i=1,iba(ik))
       write(nfout,'(" p    : ",5d16.8)') (p(i),i=1,iba(ik))
    end if

#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) then
       do is = 1, ndim_spinor
          k1 = ik+is-1
          status_saved_phifftr(ib,k1) = OLD
       end do
    end if
#endif
#ifdef USE_COMPLEX_VNLDI
    if(kimg == 1) then

    else if(kimg == 2) then

       Do is=1, ndim_spinor
         k1 = ik +is -1
         istmp = ( is -1 )*ndim_spinor + is

         do i = 1, iba(ik)
            i1    = igf(nbase(i,ik))
            evr   = zaj_l(i,ib,k1,1);    evi   = zaj_l(i,ib,k1,2)
            e1    = ekin(i) - eko_l(ib,ik)

            devr  = e1*evr+VlocalW_noncl(2*i1-1,is)*denom +vnlph_noncl(i,ib,1,is)
            devi  = e1*evi+VlocalW_noncl(2*i1,  is)*denom +vnlph_noncl(i,ib,2,is)

            zwdi   = ekin(i) + vlhxc0(istmp) + vnldi_noncl(i,is) - eko_l(ib,ik)

            ztmp1 = -p(i) * zwdi * dtim
            zfdexp = exp( ztmp1 )

            ztmp1 = ( zfdexp - 1.0d0 ) / zwdi
            ztmp1 = ztmp1 *cmplx( devr, devi )

            ctmp1 = real(ztmp1);  stmp1 = aimag(ztmp1)

            zaj_l(i,ib,k1,1) = ctmp1 + evr
            zaj_l(i,ib,k1,2) = stmp1 + evi
          End do
       end do
    end if

#else
    if(kimg == 1) then
       Do is=1, ndim_spinor
         k1 = ik +is -1
         istmp = ( is -1 )*ndim_spinor + is

         do i = 1, iba(ik)
            i1    = igf(nbase(i,ik))
            evr   = zaj_l(i,ib,k1,1)
            devr  = (ekin(i)-eko_l(ib,ik))*evr&
               & + VlocalW_noncl(i1,is)*denom + vnlph_noncl(i,ib,1,is)
            wdi   = ekin(i) + vlhxc0(istmp) + vnldi_noncl(i,is) - eko_l(ib,ik)
        
            fdexp = dexp( -p(i) * wdi * dtim)
            zaj_l(i,ib,k1,1) = (fdexp - 1)*devr/wdi + evr
          End do
       end do
    else if(kimg == 2) then
       Do is=1, ndim_spinor
         k1 = ik +is -1
         istmp = ( is -1 )*ndim_spinor + is

         do i = 1, iba(ik)
            i1    = igf(nbase(i,ik))
            evr   = zaj_l(i,ib,k1,1);    evi   = zaj_l(i,ib,k1,2)
            e1    = ekin(i) - eko_l(ib,ik)

            devr  = e1*evr+VlocalW_noncl(2*i1-1,is)*denom +vnlph_noncl(i,ib,1,is)
            devi  = e1*evi+VlocalW_noncl(2*i1,  is)*denom +vnlph_noncl(i,ib,2,is)

            wdi   = ekin(i) + vlhxc0(istmp) + vnldi_noncl(i,is) - eko_l(ib,ik)

            fdexp = dexp( -p(i) * wdi * dtim)

            zaj_l(i,ib,k1,1) = (fdexp - 1)*devr/wdi + evr
            zaj_l(i,ib,k1,2) = (fdexp - 1)*devi/wdi + evi
          End do
       end do
    end if

#endif

  end subroutine modified_steepest_desc_noncl
! ================================================================== 11.0

  subroutine steepest_descent(precon,ik,ibo,dtim,ekin,VlocalW,p)
    integer      , intent(in)                  :: precon,ik,ibo
    real(kind=DP), intent(in)                  :: dtim
    real(kind=DP), intent(in), dimension(kg1)  :: ekin
    real(kind=DP), intent(in), dimension(nfft) :: VlocalW
    real(kind=DP)            , dimension(kg1)  :: p

    integer       :: i, i1, ib
    real(kind=DP) :: evr,devr,denom, evi,e1, devi

    ib = map_z(ibo)                            ! MPI
    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    call m_ES_decide_precon_factor(precon,ik,ibo,ekin,p)  ! -> p(1:iba(ik))

#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
    if(kimg == 1) then
       do i = 1, iba(ik)
          i1    = igf(nbase(i,ik))
          evr   = zaj_l(i,ib,ik,1)
          devr  = (ekin(i)-eko_l(ib,ik))*evr + VlocalW(i1)*denom + vnlph_l(i,ib,1)
          zaj_l(i,ib,ik,1) = evr - p(i)*dtim*devr
       end do
    else if(kimg == 2) then
       do i = 1, iba(ik)
          i1    = igf(nbase(i,ik))
          evr   = zaj_l(i,ib,ik,1);    evi   = zaj_l(i,ib,ik,2)
          e1    = ekin(i) - eko_l(ib,ik)
          devr  = e1*evr+VlocalW(2*i1-1)*denom+vnlph_l(i,ib,1)
          devi  = e1*evi+VlocalW(2*i1  )*denom+vnlph_l(i,ib,2)
          zaj_l(i,ib,ik,1) = evr - p(i)*dtim*devr
          zaj_l(i,ib,ik,2) = evi - p(i)*dtim*devi
       end do
    end if
  end subroutine steepest_descent

! ================================== added by K. Tagami ======================= 11.0
  subroutine steepest_descent_noncl( precon, ik, ibo, dtim, ekin, VlocalW_noncl, &
       &                             vnlph_noncl, p )
    integer      , intent(in)                  :: precon,ik,ibo
    real(kind=DP), intent(in)                  :: dtim
    real(kind=DP), intent(in), dimension(kg1)  :: ekin
    real(kind=DP), intent(in), dimension(nfft,ndim_spinor) :: VlocalW_noncl
    real(kind=DP), intent(in), dimension(kg1,np_e,kimg,ndim_spinor) :: vnlph_noncl

    real(kind=DP)            , dimension(kg1)  :: p

    integer       :: i, i1, ib
    integer :: is, istmp, k1
    real(kind=DP) :: evr,devr,denom, evi,e1, devi

    ib = map_z(ibo)                            ! MPI
    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    call m_ES_decide_precon_factor(precon,ik,ibo,ekin,p)  ! -> p(1:iba(ik))
#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) then
       do is = 1, ndim_spinor
          k1 = ik+is-1
          status_saved_phifftr(ib,k1) = OLD
       end do
    end if
#endif
    if(kimg == 1) then
       Do is=1, ndim_spinor
          k1 = ik +is -1
          istmp = ( is -1 )*ndim_spinor + is

          do i = 1, iba(ik)
             i1    = igf(nbase(i,ik))
             evr   = zaj_l(i,ib,k1,1)
             devr  = ( ekin(i)-eko_l(ib,ik))*evr + VlocalW_noncl(i1,is)*denom &
	&           + vnlph_noncl(i,ib,1,is)
             zaj_l(i,ib,k1,1) = evr - p(i)*dtim*devr
          End do
       end do
    else if(kimg == 2) then
       Do is=1, ndim_spinor
          k1 = ik +is -1
          istmp = ( is -1 )*ndim_spinor + is

          do i = 1, iba(ik)
             i1    = igf(nbase(i,ik))
             evr   = zaj_l(i,ib,k1,1);    evi   = zaj_l(i,ib,k1,2)
             e1    = ekin(i) - eko_l(ib,ik)
             devr  = e1*evr+VlocalW_noncl(2*i1-1,is)*denom+vnlph_noncl(i,ib,1,is)
             devi  = e1*evi+VlocalW_noncl(2*i1,  is)*denom+vnlph_noncl(i,ib,2,is)
             zaj_l(i,ib,k1,1) = evr - p(i)*dtim*devr
             zaj_l(i,ib,k1,2) = evi - p(i)*dtim*devi
          End do
       end do
    end if
  end subroutine steepest_descent_noncl
! ============================================================================ 11.0

  subroutine square_of_SD_direction(ik,ibo,dz)
    integer,       intent(in)       :: ik,ibo
    real(kind=DP), intent(out)      :: dz  ! dz = <wfsd|w|wfsd>
    integer                         :: i,ib

    dz = 0.d0
    if(modnrm == EXECUT) then
       call m_ES_sum_of_LocalPart(ik,ibo,bsdr_l,bsdi_l,dz)
    end if
    ib = map_z(ibo)                     ! MPI
    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          dz = dz + wfsd_l(1,ib,ik,1)*wfsd_l(1,ib,ik,1)
          do i = 2, iba(ik)
             dz = dz + 2.d0*wfsd_l(i,ib,ik,1)*wfsd_l(i,ib,ik,1)
          end do
       else
          dz = dz + wfsd_l(1,ib,ik,1)**2 + wfsd_l(1,ib,ik,2)**2
          do i = 2, iba(ik)
             dz = dz + 2.d0*(wfsd_l(i,ib,ik,1)**2 + wfsd_l(i,ib,ik,2)**2)
          end do
       end if
    else
       if(kimg == 1) then
          do i = 1, iba(ik)
             dz = dz + wfsd_l(i,ib,ik,1)*wfsd_l(i,ib,ik,1)
          end do
       else
          do i = 1, iba(ik)
             dz = dz + wfsd_l(i,ib,ik,1)**2 + wfsd_l(i,ib,ik,2)**2
          end do
       end if
    end if
  end subroutine square_of_SD_direction

! ==================================== added by K. Tagami ================== 11.0
  subroutine square_of_SD_direction_noncl( ik,ibo,dz )
    integer,       intent(in)       :: ik,ibo
    real(kind=DP), intent(out)      :: dz  ! dz = <wfsd|w|wfsd>
    integer                         :: i,ib
    integer :: is, k1

    dz = 0.d0
    if(modnrm == EXECUT) then
       call m_ES_sum_of_LocalPart_noncl( ik, ibo, ik, ik+ndim_spinor-1, &
     &                                   bsdr_l, bsdi_l, dz )
    end if

    ib = map_z(ibo)                     ! MPI
    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          Do is=1, ndim_spinor
            k1 = ik + is -1
            dz = dz + wfsd_l(1,ib,k1,1)*wfsd_l(1,ib,k1,1)
          End do
          Do is=1, ndim_spinor
            k1 = ik + is -1
            do i = 2, iba(ik)
              dz = dz + 2.d0*wfsd_l(i,ib,k1,1)*wfsd_l(i,ib,k1,1)
            end do
          End do
       else
          Do is=1, ndim_spinor
            k1 = ik + is -1
            dz = dz + wfsd_l(1,ib,k1,1)**2 + wfsd_l(1,ib,k1,2)**2
          End do
          Do is=1, ndim_spinor
            do i = 2, iba(ik)
               k1 = ik + is -1
               dz = dz + 2.d0*(wfsd_l(i,ib,k1,1)**2 + wfsd_l(i,ib,k1,2)**2)
            end do
          End do
       end if
    else
       if(kimg == 1) then
          Do is=1, ndim_spinor
            do i = 1, iba(ik)
               k1 = ik + is -1
               dz = dz + wfsd_l(i,ib,k1,1)*wfsd_l(i,ib,k1,1)
            end do
          End do
       else
          Do is=1, ndim_spinor
            do i = 1, iba(ik)
               k1 = ik + is -1
               dz = dz + wfsd_l(i,ib,k1,1)**2 + wfsd_l(i,ib,k1,2)**2
            end do            
          End do
       end if
    end if
  end subroutine square_of_SD_direction_noncl
! ======================================================================== 11.0

  subroutine square_of_SD_direction2(ik,ibo,dz)
    integer,       intent(in)       :: ik,ibo
    real(kind=DP), intent(out)      :: dz  ! dz = <wfsd|w|wfsd>
    integer                         :: i,ib

    ib = map_z(ibo)                     ! MPI
    dz = 0.d0
    if(modnrm == EXECUT) then
       call m_ES_sum_of_LocalPart2(ik,ibo,bsdr_l,bsdi_l,bsdr_np,bsdi_np,dz)
    end if
    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          dz = dz + wfsd_l(1,ib,ik,1)*wfsd_np(1,ib,ik,1)
          do i = 2, iba(ik)
             dz = dz + 2.d0*wfsd_l(i,ib,ik,1)*wfsd_np(i,ib,ik,1)
          end do
       else
          dz = dz + wfsd_l(1,ib,ik,1)*wfsd_np(1,ib,ik,1)
          do i = 2, iba(ik)
             dz = dz + 2.d0*( wfsd_l(i,ib,ik,1)*wfsd_np(i,ib,ik,1) &
                  &         + wfsd_l(i,ib,ik,2)*wfsd_np(i,ib,ik,2))
          end do
       end if
    else
       if(kimg == 1) then
          do i = 1, iba(ik)
             dz = dz + wfsd_l(i,ib,ik,1)*wfsd_np(i,ib,ik,1)
          end do
       else
          do i = 1, iba(ik)
             dz = dz + wfsd_l(i,ib,ik,1)*wfsd_np(i,ib,ik,1) &
                  &  + wfsd_l(i,ib,ik,2)*wfsd_np(i,ib,ik,2)
          end do
       end if
    end if
  end subroutine square_of_SD_direction2

! =================================== added by K. Tagami =================== 11.0
  subroutine square_of_SD_direction2_noncl( ik,ibo,dz )
    integer,       intent(in)       :: ik,ibo
    real(kind=DP), intent(out)      :: dz  ! dz = <wfsd|w|wfsd>
    integer                         :: i,ib, is, k1

    ib = map_z(ibo)                     ! MPI
    dz = 0.d0
    if(modnrm == EXECUT) then
       call m_ES_sum_of_LocalPart2_noncl( ik, ibo, ik, ik+ndim_spinor-1, &
	&                                 bsdr_l, bsdi_l, bsdr_np, bsdi_np, dz )
    end if
    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          Do is=1, ndim_spinor
            k1 = ik + is -1
            dz = dz + wfsd_l(1,ib,k1,1)*wfsd_np(1,ib,k1,1)
          End do
          Do is=1, ndim_spinor
            k1 = ik + is -1
            do i = 2, iba(ik)
               dz = dz + 2.d0*wfsd_l(i,ib,k1,1)*wfsd_np(i,ib,k1,1)
            end do
          End do
       else
          Do is=1, ndim_spinor
            k1 = ik + is -1
            dz = dz + wfsd_l(1,ib,k1,1)*wfsd_np(1,ib,k1,1) &
                 &  + wfsd_l(1,ib,k1,2)*wfsd_np(1,ib,k1,2)
          End do
          Do is=1, ndim_spinor
            k1 = ik + is -1
            do i = 2, iba(ik)
               dz = dz + 2.d0*( wfsd_l(i,ib,k1,1)*wfsd_np(i,ib,k1,1) &
                    &         + wfsd_l(i,ib,k1,2)*wfsd_np(i,ib,k1,2))
            end do
          End do
       end if
    else
       if(kimg == 1) then
          Do is=1, ndim_spinor
            k1 = ik + is -1
            do i = 1, iba(ik)
               dz = dz + wfsd_l(i,ib,k1,1)*wfsd_np(i,ib,k1,1)
            end do
          End do
       else
          Do is=1, ndim_spinor
            k1 = ik + is -1
            do i = 1, iba(ik)
               dz = dz + wfsd_l(i,ib,k1,1)*wfsd_np(i,ib,k1,1) &
                    &  + wfsd_l(i,ib,k1,2)*wfsd_np(i,ib,k1,2)
            end do
          End do
       end if
    end if
  end subroutine square_of_SD_direction2_noncl
! ========================================================================== 11.0
!fj$$#endif

  subroutine square_of_SD_direction3(ik,ibo,dz)
    integer,       intent(in)       :: ik,ibo
    real(kind=DP), intent(out)      :: dz  ! dz = <wfsd|w|wfsd>
    integer                         :: i,ib

    dz = 0.d0
    if(modnrm == EXECUT) then
       call m_ES_sum_of_LocalPart3(ik,ibo,bsdr_l,bsdi_l,bsdr_old,bsdi_old,dz)
    end if
    ib = map_z(ibo)                     ! MPI
    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          dz = dz + wfsd_l(1,ib,ik,1)*wfsd_old(1,ib,ik,1)
          do i = 2, iba(ik)
             dz = dz + 2.d0*wfsd_l(i,ib,ik,1)*wfsd_old(i,ib,ik,1)
          end do
       else
          dz = dz + wfsd_l(1,ib,ik,1)*wfsd_old(1,ib,ik,1) + wfsd_l(1,ib,ik,2)*wfsd_old(1,ib,ik,2)
          do i = 2, iba(ik)
             dz = dz + 2.d0*(wfsd_l(i,ib,ik,1)*wfsd_old(i,ib,ik,1) + wfsd_l(i,ib,ik,2)*wfsd_old(i,ib,ik,2))
          end do
       end if
    else
       if(kimg == 1) then
          do i = 1, iba(ik)
             dz = dz + wfsd_l(i,ib,ik,1)*wfsd_old(i,ib,ik,1)
          end do
       else
          do i = 1, iba(ik)
             dz = dz + wfsd_l(i,ib,ik,1)*wfsd_old(i,ib,ik,1) + wfsd_l(i,ib,ik,2)*wfsd_old(i,ib,ik,2)
          end do
       end if
    end if
  end subroutine square_of_SD_direction3

! =================================== added by K. Tagami =================== 11.0
  subroutine square_of_SD_direction3_noncl( ik,ibo,dz )
    integer,       intent(in)       :: ik,ibo
    real(kind=DP), intent(out)      :: dz  ! dz = <wfsd|w|wfsd>
    integer                         :: i,ib, is, k1

    dz = 0.d0
    if (modnrm == EXECUT) then
       call m_ES_sum_of_LocalPart3_noncl( ik, ibo, ik, ik+ndim_spinor-1, &
	&                                 bsdr_l, bsdi_l, bsdr_old, bsdi_old, dz )
    end if
    ib = map_z(ibo)                     ! MPI
 
    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          Do is=1, ndim_spinor
             k1 = ik + is -1
             dz = dz + wfsd_l(1,ib,k1,1) *wfsd_old(1,ib,k1,1)
          End do
          Do is=1, ndim_spinor
             k1 = ik + is -1
             do i = 2, iba(ik)
                dz = dz + 2.d0*wfsd_l(i,ib,k1,1)*wfsd_old(i,ib,k1,1)
             end do
          End do
       else
          Do is=1, ndim_spinor
             k1 = ik + is -1
             dz = dz + wfsd_l(1,ib,k1,1)*wfsd_old(1,ib,k1,1) &
                  &  + wfsd_l(1,ib,k1,2)*wfsd_old(1,ib,k1,2)
          End do
          Do is=1, ndim_spinor
             k1 = ik + is -1
             do i = 2, iba(ik)
                dz = dz + 2.d0*( wfsd_l(i,ib,k1,1)*wfsd_old(i,ib,k1,1) &
                     &         + wfsd_l(i,ib,k1,2)*wfsd_old(i,ib,k1,2))
             end do
          End do
       end if
    else
       if(kimg == 1) then
          Do is=1, ndim_spinor
             k1 = ik + is -1
             do i = 1, iba(ik)
                dz = dz + wfsd_l(i,ib,k1,1)*wfsd_old(i,ib,k1,1)
             end do
          End do
       else
          Do is=1, ndim_spinor
             k1 = ik + is -1
             do i = 1, iba(ik)
                dz = dz + wfsd_l(i,ib,k1,1)*wfsd_old(i,ib,k1,1) &
                     &  + wfsd_l(i,ib,k1,2)*wfsd_old(i,ib,k1,2)
             end do
          End do
       end if
    end if
  end subroutine square_of_SD_direction3_noncl
! =========================================================================== 11.0

  subroutine SD_direction(precon,ik,ibo,ekin,VlocalW,p)
    integer      , intent(in)                  :: precon,ik,ibo
    real(kind=DP), intent(in), dimension(kg1)  :: ekin
    real(kind=DP), intent(in), dimension(nfft) :: VlocalW
    real(kind=DP)            , dimension(kg1)  :: p

    integer       :: i, i1, ib
    real(kind=DP) :: devr,denom, e1, devi

    ib = map_z(ibo)                                  ! MPI
    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    call m_ES_decide_precon_factor(precon,ik,ibo,ekin,p)  ! -> p(1:iba(ik))

    if(kimg == 1) then
       do i = 1, iba(ik)
          i1    = igf(nbase(i,ik))
          devr  = (ekin(i)-eko_l(ib,ik))*zaj_l(i,ib,ik,1)&
               & + VlocalW(i1)*denom + vnlph_l(i,ib,1)
          wfsd_l(i,ib,ik,1) = - p(i)*devr
       end do
    else if(kimg == 2) then
       do i = 1, iba(ik)
          i1    = igf(nbase(i,ik))
          e1    = ekin(i) - eko_l(ib,ik)
          devr  = e1*zaj_l(i,ib,ik,1) + VlocalW(2*i1-1)*denom+vnlph_l(i,ib,1)
          devi  = e1*zaj_l(i,ib,ik,2) + VlocalW(2*i1  )*denom+vnlph_l(i,ib,2)
          wfsd_l(i,ib,ik,1) = - p(i)*devr
          wfsd_l(i,ib,ik,2) = - p(i)*devi
       end do
    end if
  end subroutine SD_direction

! =================================== added by K. Tagami ================= 11.0
  subroutine SD_direction_noncl( precon, ik, ibo, ekin, VlocalW_noncl, &
       &                         vnlph_noncl, p )
    integer      , intent(in)                  :: precon,ik,ibo
    real(kind=DP), intent(in), dimension(kg1)  :: ekin
    real(kind=DP), intent(in), dimension(nfft,ndim_spinor) :: VlocalW_noncl
    real(kind=DP), intent(in), dimension(kg1,np_e,kimg,ndim_spinor) :: vnlph_noncl

    real(kind=DP)            , dimension(kg1)  :: p

    integer       :: i, i1, ib
    integer :: is, k1
    real(kind=DP) :: devr,denom, e1, devi

    ib = map_z(ibo)                                  ! MPI
    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    call m_ES_decide_precon_factor(precon,ik,ibo,ekin,p)  ! -> p(1:iba(ik))

    if(kimg == 1) then
       Do is=1, ndim_spinor
         k1 = ik + is -1
         do i = 1, iba(ik)
            i1    = igf(nbase(i,ik))
            devr  = (ekin(i)-eko_l(ib,ik))*zaj_l(i,ib,k1,1)&
               &     + VlocalW_noncl(i1,is)*denom + vnlph_noncl(i,ib,1,is)
            wfsd_l(i,ib,k1,1) = - p(i)*devr
         end do
       End do
    else if(kimg == 2) then
       Do is=1, ndim_spinor
         k1 = ik + is -1
         do i = 1, iba(ik)
            i1    = igf(nbase(i,ik))
            e1    = ekin(i) - eko_l(ib,ik)
            devr  = e1*zaj_l(i,ib,k1,1) + VlocalW_noncl(2*i1-1,is)*denom &
	&           +vnlph_noncl(i,ib,1,is)
            devi  = e1*zaj_l(i,ib,k1,2) + VlocalW_noncl(2*i1,  is)*denom &
	&           +vnlph_noncl(i,ib,2,is)
            wfsd_l(i,ib,k1,1) = - p(i)*devr
            wfsd_l(i,ib,k1,2) = - p(i)*devi
         end do
       End do
    end if
  end subroutine SD_direction_noncl
! ===================================================================== 11.0

  subroutine Vnonlocal_Diagonal_part(ispin,ik,iksnl,ibo,vnldi)
    integer, intent(in)                        :: ispin, ik, iksnl,ibo
    real(kind=DP), intent(out), dimension(kg1) :: vnldi

    integer :: it,mdvdb,ib

!!$    integer :: id_sname = -1
!!$    call tstatc0_begin('Vnonlocal_Diagonal_part ', id_sname)

    ib = map_z(ibo)                ! MPI

    vnldi = 0.d0

    do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb == SKIP) then
          call Vnonlocal_D_norm_conserve_case
       else if(mdvdb == EXECUT) then
          call Vnonlocal_D_vanderbilt_case
       end if
    end do

!!$    call tstatc0_end(id_sname)
  contains

    subroutine Vnonlocal_D_vanderbilt_case
      integer       :: ia, p1,p2,lmtt1,il1,lmtt2,il2,i
      real(kind=DP) :: ph,fac, dion_eq

      do p1 = 1, ilmt(it)
         lmtt1 = lmtt(p1,it); il1 = ltp(p1,it)
         do p2 = p1, ilmt(it)
            lmtt2 = lmtt(p2,it); il2 = ltp(p2,it)
            if( p1 /= p2) then
               ph = 2.d0*real(zi**(il2-il1))
            else
               ph = 1.d0
            endif
            if(mod(il1+il2,2) == 1) cycle
            dion_eq = dion(p1,p2,it)-eko_l(ib,ik)*q(p1,p2,it)
            fac = 0.d0
            do ia = 1, natm
               if(ityp(ia) /= it) cycle
!!$               fac = fac + ph*iwei(ia) * (dion_eq+vlhxcQ(p1,p2,ia,ispin))
               if(ipaw(it)==0) then
                   fac = fac + ph*iwei(ia) * (dion_eq+vlhxcQ(p1,p2,ia,ispin))
               else
! ======================================== modified by K. Tagami ============= 11.0
!                   fac = ph*iwei(ia) * &
!                        & (dion_paw(p1,p2,ispin,ia)-eko_l(ib,ik)*q(p1,p2,it)+vlhxcQ(p1,p2,ia,ispin))
!
                   fac = fac + ph*iwei(ia) &
        &                   * (dion_paw(p1,p2,ispin,ia)-eko_l(ib,ik)*q(p1,p2,it) &
	&                     +vlhxcQ(p1,p2,ia,ispin) )
! ============================================================================ 11.0
               end if
            end do

            do i = 1, iba(ik)
               vnldi(i) = vnldi(i)+fac*snl(i,lmtt1,iksnl)*snl(i,lmtt2,iksnl)
            end do
         end do
      end do

!!$      do p1 = 1, ilmt(it)
!!$         lmtt1 = lmtt(p1,it); il1 = ltp(p1,it)
!!$         do p2 = p1, ilmt(it)
!!$            lmtt2 = lmtt(p2,it); il2 = ltp(p2,it)
!!$            if( p1 /= p2) then
!!$               ph = 2.d0*real(zi**(il2-il1))
!!$            else
!!$               ph = 1.d0
!!$            endif
!!$            if(mod(il1+il2,2) == 1) cycle
!!$            dion_eq = dion(p1,p2,it)-eko_l(ib,ik)*q(p1,p2,it)
!!$            do ia = 1, natm
!!$               if(ityp(ia) /= it) cycle
!!$!!$               fac = ph*iwei(ia) * &
!!$!!$                    & (dion(p1,p2,it)-eko_l(ib,ik)*q(p1,p2,it)+vlhxcQ(p1,p2,ia,ispin))
!!$               fac = ph*iwei(ia) * (dion_eq+vlhxcQ(p1,p2,ia,ispin))
!!$               do i = 1, iba(ik)
!!$                  vnldi(i) = vnldi(i)+fac*snl(i,lmtt1,iksnl)*snl(i,lmtt2,iksnl)
!!$               end do
!!$            end do
!!$         end do
!!$      end do
    end subroutine Vnonlocal_D_vanderbilt_case

    subroutine Vnonlocal_D_norm_conserve_case
      integer       :: ia, lmt1,lmt2,lmtt1,il1,im1,il2,im2,i
      real(kind=DP) :: ph,fac

      ph = 0.d0
      do ia = 1, natm
         if(ityp(ia) /= it) cycle
         ph = ph + iwei(ia)
      end do
      do lmt1 = 1, ilmt(it)
         lmtt1 = lmtt(lmt1,it); il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
         do lmt2 = lmt1, ilmt(it)
            il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
            if(il1 /= il2 .or. im1 /= im2) cycle
            if(mod(il1+il2,2) == 1) cycle

! ====================================== modified by K. Tagami ============= 11.0
!!            fac = ph * dion(lmt1,lmt2,it)
!
            fac = 0.d0
            Do ia=1, natm
              if(ityp(ia) /= it) cycle
              if(ipaw(it)==0)then
                 fac = fac + iwei(ia) * dion(lmt1,lmt2,it)
              else
                 fac = fac + iwei(ia) * dion_paw(lmt1,lmt2,ispin,ia)
              endif
            End do
! ========================================================================== 11.0

            do i = 1, iba(ik)
               vnldi(i)  = vnldi(i) + fac * snl(i,lmtt1,iksnl)**2
            end do
         end do
      end do
    end subroutine Vnonlocal_D_norm_conserve_case

  end subroutine Vnonlocal_Diagonal_part

! ====================================== added by K. Tagami ================ 11.0
  subroutine Vnonlocal_Diagonal_part_noncl(ispin,ik,iksnl,ibo,vnldi)
    integer, intent(in)                        :: ispin, ik, iksnl,ibo

#ifdef USE_COMPLEX_VNLDI
    complex(kind=CMPLDP), intent(out), dimension(kg1) :: vnldi
#else
    real(kind=DP), intent(out), dimension(kg1) :: vnldi
#endif

    integer :: it,mdvdb,ib

!!$    integer :: id_sname = -1
!!$    call tstatc0_begin('Vnonlocal_Diagonal_part ', id_sname)

    ib = map_z(ibo)                ! MPI

!    vnldi = 0.d0

    do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb == SKIP) then
          call Vnonlocal_D_norm_consv_noncl
       else if(mdvdb == EXECUT) then
         call Vnonlocal_D_vanderbilt_noncl
       end if
    end do

!!$    call tstatc0_end(id_sname)
  contains

    subroutine Vnonlocal_D_vanderbilt_noncl
      integer       :: ia, p1,p2,lmtt1,il1,lmtt2,il2,i
      integer :: im1, im2
      complex(kind=CMPLDP) :: ph, fac

      do p1 = 1, ilmt(it)
         lmtt1 = lmtt(p1,it); il1 = ltp(p1,it);  im1 = mtp(p1,it)

         do p2 = 1, ilmt(it)
            lmtt2 = lmtt(p2,it); il2 = ltp(p2,it);  im2 = mtp(p2,it)


! ---------------------------------------------------- 11.0S
#ifdef SKIP_TEST
            if ( il1 /= il2 ) cycle
            if ( SpinOrbit_mode == Neglected .and. sw_hubbard == OFF ) then
               if ( im1 /= im2 ) cycle
            endif
#endif
! ---------------------------------------------------- 11.0S

            if( p1 /= p2 ) then
               ph = zi**(il2-il1)
           else
               ph = 1.d0
            endif

!            if(mod(il1+il2,2) == 1) cycle

            fac = 0.d0

            do ia = 1, natm
               if(ityp(ia) /= it) cycle
               fac = fac + ph*iwei(ia)* ( dion_scr_noncl( p1,p2,ispin,ia ) &
        &                                -eko_l(ib,ik) *q_noncl( p1, p2, ispin, it ) )
            end do

            do i = 1, iba(ik)
               vnldi(i) = vnldi(i)+fac*snl(i,lmtt1,iksnl)*snl(i,lmtt2,iksnl)
            end do
         end do
      end do

    end subroutine Vnonlocal_D_vanderbilt_noncl

    subroutine Vnonlocal_D_norm_consv_noncl
      integer       :: ia, p1,p2,lmtt1,il1,lmtt2,il2,i
      integer :: im1, im2
      complex(kind=CMPLDP) :: ph, fac

      do p1 = 1, ilmt(it)
         lmtt1 = lmtt(p1,it); il1 = ltp(p1,it);  im1 = mtp(p1,it)

         do p2 = 1, ilmt(it)
            lmtt2 = lmtt(p2,it); il2 = ltp(p2,it);  im2 = mtp(p2,it)

! ---------------------------------------------------- 11.0S
            if ( il1 /= il2 ) cycle
            if ( SpinOrbit_mode == Neglected .and. sw_hubbard == OFF ) then
               if ( im1 /= im2 ) cycle
            endif
! ---------------------------------------------------- 11.0S

            if( p1 /= p2 ) then
               ph = zi**(il2-il1)
            else
               ph = 1.d0
            endif

!            if(mod(il1+il2,2) == 1) cycle

            fac = 0.d0

            do ia = 1, natm
               if(ityp(ia) /= it) cycle
               fac = fac + ph*iwei(ia)* dion_scr_noncl( p1,p2,ispin,ia )

            end do

            do i = 1, iba(ik)
               vnldi(i) = vnldi(i)+fac*snl(i,lmtt1,iksnl)*snl(i,lmtt2,iksnl)
            end do
         end do
      end do

    end subroutine Vnonlocal_D_norm_consv_noncl

  end subroutine Vnonlocal_Diagonal_part_noncl
! ==================================================================== 11.0


  subroutine m_ESsd_reset_dzajn2
    dzajn2 = 0.d0
  end subroutine m_ESsd_reset_dzajn2
       
  subroutine m_ESsd_copy_zaj_to_zaj_old
    integer :: ik, ir
    do ir = 1, kimg
       do ik = 1, kv3, af+1
          if(map_k(ik) /= myrank_k) cycle                       ! MPI
          zaj_old(:,:,ik,ir) = zaj_l(:,:,ik,ir)
       end do
    end do
  end subroutine m_ESsd_copy_zaj_to_zaj_old

  subroutine m_ESsd_copy_zaj_old_to_zaj(ik,ibo)
    integer, intent(in)                           :: ik, ibo

    integer    :: ir, ib

    ib = map_z(ibo)
     do ir = 1, kimg
       zaj_l(:,ib,ik,ir) = zaj_old(:,ib,ik,ir)
    end do
#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
  end subroutine m_ESsd_copy_zaj_old_to_zaj

  subroutine m_ESsd_copy_phi_to_zaj_old(ik,ibo,phi)
    integer, intent(in)                           :: ik, ibo
    real(kind=DP),intent(in),dimension(kg1,kimg)  :: phi

    integer    :: ir, ib

    ib = map_z(ibo)
     do ir = 1, kimg
       zaj_old(:,ib,ik,ir) = phi(:,ir)
    end do
  end subroutine m_ESsd_copy_phi_to_zaj_old
!!$!BRANCH_P 3D_Parallel
!!$  subroutine m_ESsd_copy_phi_to_zaj_old_3D(ik,ibo,phi)
!!$    integer, intent(in)                           :: ik, ibo
!!$    real(kind=DP),intent(in),dimension(maxval(np_g1k),kimg)  :: phi
!!$
!!$    integer    :: ir, ib
!!$
!!$     do ir = 1, kimg
!!$       zaj_old(:,ib,ik,ir) = phi(:,ir)
!!$    end do
!!$  end subroutine m_ESsd_copy_phi_to_zaj_old_3D
!!$!BRANCH_P_END 3D_Parallel

  subroutine m_ESsd_diff_WFs_to_zaj_old(dt)
    real(kind=DP), intent(in) :: dt
    integer                   :: ik, ir
    real(kind=DP), parameter  :: Delta = 1.d-10
    real(kind=DP)             :: rdt

    if(dt < Delta ) then
       if(ipri >=1 ) write(nfout,'(" !! dt is smaller than ",d20.8)') Delta
       rdt = 0.d0
    else
       rdt = 1.d0/dt
    end if

    do ir = 1, kimg
       do ik = 1, kv3, af+1
          if(map_k(ik) /= myrank_k) cycle                ! MPI
          zaj_old(:,:,ik,ir) = rdt * (zaj_l(:,:,ik,ir) - zaj_old(:,:,ik,ir))
       end do
    end do
  end subroutine m_ESsd_diff_WFs_to_zaj_old

  subroutine WF_conjugate_gradient(ik,ibo,dtim)
! \Psi_{k\mu}^{m+1} = \Psi_{k\mu}^{m} + \Delta t_{opt}^{m} d^{m}
!   d^{m} = g^{m} + \beta_CG d^{m-1}
!   g^{m} = - \Phi_{k\mu}^{m}
!   d^{m-1} = (\Psi_{k\mu}^{m} - \Psi_{k\mu}^{m-1})\frac{1}{\Delta t_{opt}^{m-1}}
!
    integer      , intent(in)                  :: ik,ibo
    real(kind=DP), intent(in)                  :: dtim

    integer       :: i,ib
    real(kind=DP) :: evr,evi

    ib = map_z(ibo)                    ! MPI
#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
    if(kimg == 1) then
       do i = 1, iba(ik)
          evr   = zaj_l(i,ib,ik,1)
          zaj_l(i,ib,ik,1) = evr + dtim*wfsd_l(i,ib,ik,1)
       end do
    else if(kimg == 2) then
       do i = 1, iba(ik)
          evr   = zaj_l(i,ib,ik,1);  evi   = zaj_l(i,ib,ik,kimg)
          zaj_l(i,ib,ik,1) = evr + dtim*wfsd_l(i,ib,ik,1)
          zaj_l(i,ib,ik,2) = evi + dtim*wfsd_l(i,ib,ik,2)
       end do
    end if
  end subroutine WF_conjugate_gradient

  subroutine WF_conjugate_gradient0 &
       &(precon,ik,ibo,dtim,ekin,VlocalW,p)
! \Psi_{k\mu}^{m+1} = \Psi_{k\mu}^{m} + \Delta t_{opt}^{m} d^{m}
!   d^{m} = g^{m} + \beta_CG d^{m-1}
!   g^{m} = - \Phi_{k\mu}^{m}
!   d^{m-1} = (\Psi_{k\mu}^{m} - \Psi_{k\mu}^{m-1})\frac{1}{\Delta t_{opt}^{m-1}}
!
    integer      , intent(in)                  :: precon,ik,ibo
    real(kind=DP), intent(in)                  :: dtim
    real(kind=DP), intent(in), dimension(kg1)  :: ekin
    real(kind=DP), intent(in), dimension(nfft) :: VlocalW
    real(kind=DP)            , dimension(kg1)  :: p

    integer       :: i, i1, ib
    real(kind=DP) :: evr,devr,denom, evi,e1, devi

    ib = map_z(ibo)
    denom = 1.d0/product(fft_box_size_WF(1:3,1))
    call m_ES_decide_precon_factor(precon,ik,ibo,ekin,p)  ! ->p(1:iba(ik))

#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
    if(kimg == 1) then
       do i = 1, iba(ik)
          i1    = igf(nbase(i,ik))
          evr   = zaj_l(i,ib,ik,1)
          devr  = (ekin(i)-eko_l(ib,ik))*evr&
               & + VlocalW(i1)*denom + vnlph_l(i,ib,1)
          zaj_l(i,ib,ik,1) = evr + dtim*(-p(i)*devr+betacg*zaj_old(i,ib,ik,1))
          zaj_old(i,ib,ik,1) = evr
       end do
    else if(kimg == 2) then
       do i = 1, iba(ik)
          i1    = igf(nbase(i,ik))
          evr   = zaj_l(i,ib,ik,1)
          evi   = zaj_l(i,ib,ik,kimg)
          e1    = ekin(i) - eko_l(ib,ik)
          devr  = e1*evr+VlocalW(2*i1-1)*denom+vnlph_l(i,ib,1)
          devi  = e1*evi+VlocalW(2*i1  )*denom+vnlph_l(i,ib,2)
          zaj_l(i,ib,ik,1) = evr +dtim*(-p(i)*devr+betacg*zaj_old(i,ib,ik,1))
          zaj_l(i,ib,ik,2) = evi +dtim*(-p(i)*devi+betacg*zaj_old(i,ib,ik,2))
          zaj_old(i,ib,ik,1) = evr; zaj_old(i,ib,ik,2) = evi
       end do
    end if
  end subroutine WF_conjugate_gradient0

  subroutine make_CG_direction(ik)
    integer, intent(in) :: ik

    real(kind=DP), parameter             :: Delta = 1.d-20
    integer :: i, ib
    integer :: id_sname = -1
    call tstatc0_begin('make_CG_direction', id_sname)

    if(betacg > Delta) then
       if(kimg == 1) then
          do ib = 1, np_e
             do i = 1, iba(ik)
                wfsd_l(i,ib,ik,1) = wfsd_l(i,ib,ik,1) + betacg*wfsd_old(i,ib,ik,1)
             end do
          end do
       else
          do ib = 1, np_e
             do i = 1, iba(ik)
                wfsd_l(i,ib,ik,1) = wfsd_l(i,ib,ik,1) + betacg*wfsd_old(i,ib,ik,1)
                wfsd_l(i,ib,ik,2) = wfsd_l(i,ib,ik,2) + betacg*wfsd_old(i,ib,ik,2)
             end do
          end do
       end if
    end if
    call tstatc0_end(id_sname)
  end subroutine make_CG_direction

  subroutine orthogonalize_SD_drctns(ik,to)
    integer, intent(in) :: ik,to

    integer :: id_sname = -1
    call tstatc0_begin('orthogonalize_SD_drctns ', id_sname)

!!$    if(modnrm == EXECUT) call m_ES_betar_dot_Psi_4_each_k(wfsd_l,ista_k,iend_k,ik,bsdr_l,bsdi_l)
    if(modnrm == EXECUT) call m_ES_betar_dot_Psi_4_each_k(nfout,wfsd_l,ik,ik,ik,bsdr_l,bsdi_l)
    !                                                          ->bsd(ri)_l
    call m_ES_orthogonalize_SD_to_WFs(ik,to,wfsd_l,bsdr_l,bsdi_l) ! ->(wfsd_l,bsd(ri)_l)

!!$    call orthogonalize_SD(ik,wfsd_l,bsdr_l,bsdi_l)           !-(m_E.S.) ->(wfsd_l)
    call tstatc0_end(id_sname)
  end subroutine orthogonalize_SD_drctns

! =============================== added by K. Tagami =================== 11.0
  subroutine orthogonalize_SD_drctns_noncl( ik,to )
    integer, intent(in) :: ik,to

    integer :: is
    integer :: id_sname = -1

    call tstatc0_begin('orthogonalize_SD_drctns_noncl ', id_sname)

    if (modnrm == EXECUT) then
       Do is=1, ndim_spinor
          call m_ES_betar_dot_Psi_4_each_k(nfout, wfsd_l, ik, ik+ndim_spinor-1, &
	&                                   ik +is -1, bsdr_l, bsdi_l )
                                               !           ->bsd(ri)_l
       End do
    endif

    call m_ES_orthogonl_SD_to_WFs_noncl( ik, to, ik, ik+ndim_spinor-1, &
	&                                wfsd_l, bsdr_l, bsdi_l)
                                             ! ->(wfsd_l,bsd(ri)_l)

    call tstatc0_end(id_sname)

  end subroutine orthogonalize_SD_drctns_noncl
! ========================================================================= 11.0

  subroutine Precon_dot_SD(ik,ekin,p)
    integer,      intent(in)                 :: ik
    real(kind=DP),intent(in),dimension(kg1)  :: ekin
    real(kind=DP),           dimension(kg1)  :: p

    integer :: ib, ri, i

    do ri = 1, kimg
       do ib = ista_e, iend_e, istep_e
          do i = 1, iba(ik)
             wfsd_np(i,map_z(ib),ik,ri) = wfsd_l(i,map_z(ib),ik,ri)
          end do
       end do
    end do

    do ib = ista_e, iend_e, istep_e   ! MPI
       call decide_precon_factor_wfsd(ik,ib,ekin,p)
       if(kimg == 1) then
          do i = 1, iba(ik)
             wfsd_l(i,map_z(ib),ik,1) = p(i)*wfsd_l(i,map_z(ib),ik,1)
          end do
       else if(kimg == 2) then
          do i = 1, iba(ik)
             wfsd_l(i,map_z(ib),ik,1) = p(i)*wfsd_l(i,map_z(ib),ik,1)
             wfsd_l(i,map_z(ib),ik,2) = p(i)*wfsd_l(i,map_z(ib),ik,2)
          end do
       end if
    end do

  end subroutine Precon_dot_SD

! ======================================== added by K. Tagami =============== 11.0
  subroutine Precon_dot_SD_noncl( ik,ekin,p )
    integer,      intent(in)                 :: ik
    real(kind=DP),intent(in),dimension(kg1)  :: ekin
    real(kind=DP),           dimension(kg1)  :: p

    integer :: ib, ri, i
    integer :: is, k1

    do ri = 1, kimg
       Do is=1, ndim_spinor
         k1 = ik + is -1
         do ib = ista_e, iend_e, istep_e
            do i = 1, iba(ik)
               wfsd_np(i,map_z(ib),k1,ri) = wfsd_l(i,map_z(ib),k1,ri)
            end do
         end do
       End do
    end do

    do ib = ista_e, iend_e, istep_e   ! MPI
       call decide_precon_factor_wfsd( ik, ib, ekin, p )

       if (kimg == 1) then
          Do is=1, ndim_spinor
            k1 = ik + is -1
            do i = 1, iba(ik)
               wfsd_l(i,map_z(ib),k1,1) = p(i)*wfsd_l(i,map_z(ib),k1,1)
            end do
          End do
       else if(kimg == 2) then
          Do is=1, ndim_spinor
            k1 = ik + is -1
            do i = 1, iba(ik)
               wfsd_l(i,map_z(ib),k1,1) = p(i)*wfsd_l(i,map_z(ib),k1,1)
               wfsd_l(i,map_z(ib),k1,2) = p(i)*wfsd_l(i,map_z(ib),k1,2)
            end do
          End do
       end if
    end do

  end subroutine Precon_dot_SD_noncl
! ===================================================================== 11.0

  subroutine decide_precon_factor_wfsd(ik,ib,ekin,p)
    integer, intent(in)                         :: ik,ib
    real(kind=DP), intent(in),  dimension(kg1)  :: ekin
    real(kind=DP), intent(out), dimension(kg1)  :: p

    integer       :: i
    real(kind=DP) :: ektot, x, x1, x2, d_ektot

! ===================================== modified by K. Tagami ========== 11.0
!    call kinetic_energy_wfsd(ik,ib,ekin,ektot)   ! -(m_ES_WF_by_SDorCG)
!
    if ( noncol ) then    
       call kinetic_energy_wfsd_noncl(ik,ib,ekin,ektot)  
    else
       call kinetic_energy_wfsd(ik,ib,ekin,ektot)   ! -(m_ES_WF_by_SDorCG)
    endif
! ====================================================================== 11.0

    d_ektot = 1.d0/ektot
    p = 0.d0
    do i = 1, iba(ik)
       x = ekin(i)*d_ektot
       x1 = 27 + ( 18 + (12 + 8*x) *x) *x
       x2 = 16*(x*x)*(x*x)
       p(i)  = x1/(x1 + x2 )
    end do
  end subroutine decide_precon_factor_wfsd

  subroutine kinetic_energy_wfsd(ik,ib,dekin,ektot)
    integer, intent(in) :: ik, ib
    real(kind=DP), intent(in), dimension(kg1)  :: dekin
    real(kind=DP), intent(out)                 :: ektot
    integer  :: i, ri
    ektot = 0.d0

    do ri = 1, kimg
       do i = 1, iba(ik)
          ektot = ektot + dekin(i)*wfsd_l(i,map_z(ib),ik,ri)**2   ! MPI
       end do
    end do

    if(k_symmetry(ik) == GAMMA) ektot = ektot*2.d0

  end subroutine kinetic_energy_wfsd

! ====================================== added by K. Tagami ================ 11.0
  subroutine kinetic_energy_wfsd_noncl( ik,ib,dekin,ektot )
    integer, intent(in) :: ik, ib
    real(kind=DP), intent(in), dimension(kg1)  :: dekin
    real(kind=DP), intent(out)                 :: ektot
    integer  :: i, ri
    integer :: is, k1

    ektot = 0.d0

    do ri = 1, kimg
       Do is=1, ndim_spinor
         k1 = ik + is -1
         do i = 1, iba(ik)
            ektot = ektot + dekin(i)*wfsd_l(i,map_z(ib),k1,ri)**2   ! MPI
         end do
       End do
    end do

    if(k_symmetry(ik) == GAMMA) ektot = ektot*2.d0

  end subroutine kinetic_energy_wfsd_noncl
! ========================================================================= 11.0


  subroutine cp_wfsd_to_wfsd_old(ik)
    integer, intent(in) :: ik
    wfsd_old(:,:,ik,:) = wfsd_l(:,:,ik,:)
    bsdr_old(:,:,ik) = bsdr_l(:,:,ik)
    bsdi_old(:,:,ik) = bsdi_l(:,:,ik)
  end subroutine cp_wfsd_to_wfsd_old

  subroutine m_ESsd_dealloc
    if(allocated(zaj_old)) deallocate(zaj_old)
    if(allocated(dzajn2)) deallocate(dzajn2)


  end subroutine m_ESsd_dealloc

end module m_ES_WF_by_SDorCG

!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 494 $)
!
!  SUBROUINE: ChargeDensity_Construction, FermiEnergyLevel, 
!             CD_Softpart_plus_Hardpart
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!  
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine ChargeDensity_Construction(ic)
! $Id: ChargeDensity_Construction.F90 494 2016-06-02 00:54:16Z jkoga $
  use m_Total_Energy,         only : m_TE_total_energy, ehartr
  use m_Charge_Density,       only : m_CD_convergence_check &
       &                           , m_CD_softpart, m_CD_hardpart &
       &                           , chgq_l &
       &                           , m_CD_hardpart_hsr
  use m_ES_occup,             only : m_ESoc_fermi_parabolic, m_ESoc_fermi_tetrahedron &
       &                           , m_ESoc_fermi_ColdSmearing, m_ESoc_check_num_bands &
       &                           , m_ESoc_occup_fix
  use m_ES_IO,                only : m_ESIO_wd_EigenValues
  use m_Kpoints,              only : kv3
  use m_Files,                only : nfout
  use m_Crystal_Structure,    only : sw_bandgap_constraint, imag
  use m_Control_Parameters,   only : iprieigenvalue, projector_type, num_projectors &
       &                           , sw_hubbard, alpha_hubbard, icond, ekmode &
#ifdef ENABLE_ESM_PACK
       &                           , m_CtrlP_way_of_smearing,sw_esm, kimg, nspin
#else
       &                           , m_CtrlP_way_of_smearing
#endif
  use m_Const_Parameters,     only : PARABOLIC, MP, TETRAHEDRON, COLD, YES, OFF, ON &
       &                           , SPHERICAL_HARMONICS, ATOMIC_ORBITAL &
       &                           , INITIAL,CONTINUATION,FIXED_CHARGE,FIXED_CHARGE_CONTINUATION,CMPLDP
  use m_Orbital_Population,   only : m_OP_occ_mat_is_not_read

! ============================= added by K. Tagami =================== 5.0
  use m_Control_Parameters,  only : sw_eval_energy_before_charge, &
       &                            sw_update_charge_total
! ==================================================================== 5.0

  use m_Parallelization,      only : ista_kngp,iend_kngp,mpi_comm_group,mype

! =========================================== added by K. Tagami ========== 11.0
  use m_Control_Parameters,      only : noncol
  use m_Charge_Density,        only : m_CD_hardpart_hsr_noncl, &
       &                              m_CD_softpart_noncl, &
       &                              m_CD_hardpart_noncl
  use m_Total_Energy,          only : m_TE_total_energy_noncl
! ========================================================================= 11.0


  use m_PlaneWaveBasisSet,       only : kgp
  use m_FFT,                     only : fft_box_size_CD


! ============================= KT_add ================ 13.0E
  use m_Const_Parameters,       only : FERMI_Dirac
  use m_ES_Occup,               only : m_ESoc_fermi_Dirac
! ===================================================== 13.0E

! ============================= KT_add ================ 13.0U
  use m_CD_Mag_Moment,        only : m_CD_calc_ChgMagMom_in_sphere, &
       &                             m_CD_print_ChgMagmom_on_atom, &
       &                             sw_monitor_atomcharge
! ===================================================== 13.0U

! ======= KT_add ==== 13.0XX
  use m_Control_Parameters,     only : sw_calc_ekin_density, use_symm_ekin_density, &
       &                               use_asymm_ekin_density, ekin_density_is_active
  use m_KineticEnergy_Density,  only : m_KE_calc_symm_ekin_density, &
       &                               m_KE_calc_asymm_ekin_density, &
       &                               m_KE_cp_ekin_density_to_old
! =================== 13.0XX

! === KT_add === 2014/09/26
  use m_Crystal_Structure,  only : sw_fix_global_quantz_axis, sw_neglect_magmom
  use m_ES_Mag_Constraint,  only : m_ES_proj_magmom_G_quantz_axis, m_ES_set_magmom_zero
! ============== 2014/09/26

! === KT_add === 2014/08/26
  use m_Control_Parameters, only : sw_calc_orbital_moment, sw_use_add_proj, &
       &                          Orbital_decomp_mode
  use m_Charge_Density,    only : m_CD_hardpart_hsr_add, m_CD_hardpart_hsr_add_noncl
  use m_OP_Moment,  only :        m_OP_calc_OrbMagMom_in_sphere, &
       &                          m_OP_calc_OrbMagMom_method1, &
       &                          m_OP_calc_OrbMagMom_method2
! ============== 2014/08/26

! ==== Positron SCF === 2015/11/28
  use m_Control_Parameters,  only : sw_positron, positron_method
  use m_Const_Parameters,    only : positron_CONV
  use m_Positron_Wave_Functions, only : m_pWF_construct_pcharge, m_pWF_charge_rspace
! ===================== 2015/11/28

  implicit none
  include 'mpif.h'

  integer, intent(in) :: ic
  logical             :: display_on, enough_bands
  complex(kind=CMPLDP),allocatable,dimension(:) :: vhar
  complex(kind=CMPLDP),allocatable, dimension(:,:) :: chgc
  integer :: ig,is,nfftcd,ierr
#ifdef __TIMER_SUB__
  call timer_sta(701)
#endif

  if(ic == 0) display_on = .true.
  if(ic /= 0) display_on = .false.


  enough_bands = m_ESoc_check_num_bands()
  if(enough_bands) then
     call FermiEnergyLevel()            ! -(contained here)
  else
     if(iprieigenvalue >= 1) write(nfout,'(" the number of bands is not enough")')
     stop ' the number of bands is not enough'
  end if

! =================== added by K. Tagami ============ 5.0
  if ( sw_eval_energy_before_charge == ON ) then
! ================================= modified by K.Tagami ====== 11.0
!     call m_TE_total_energy(nfout,display_on,kv3)
!
     if ( noncol ) then
        call m_TE_total_energy_noncl(nfout,display_on,kv3)
     else
        call m_TE_total_energy(nfout,display_on,kv3)
     endif
! ============================================================= 11.0
  endif
! =================================================== 5.0

! ======================== modified by K. Tagami ======= 5.0
!  if(icond == INITIAL .or. icond == CONTINUATION) then
!     call CD_Softpart_plus_Hardpart()   ! -(contained here)
!     if(ic == 0) call m_CD_conversion_check(nfout)
!  else if ((icond==FIXED_CHARGE.or.icond==FIXED_CHARGE_CONTINUATION).and.ekmode==OFF) then
!     call m_CD_hardpart_hsr(nfout,kv3)  ! fsr_l, fsi_l -> hsr
!  end if
  if ( sw_update_charge_total == ON ) then
     if ( icond == INITIAL .or. icond == CONTINUATION ) then
! ======================== modifided by K. Tagami ========================= 11.0
!       call CD_Softpart_plus_Hardpart()   ! -(contained here)
!
        if ( noncol ) then
           call CD_Softpart_plus_Hardpart_noncl()   ! -(contained here)
        else
           call CD_Softpart_plus_Hardpart()   ! -(contained here)
        endif
! ========================================================================= 11.0

! === KT_add == 2014/09/26
        if ( noncol ) then
           if ( sw_fix_global_quantz_axis == ON ) then
              call m_ES_proj_magmom_G_quantz_axis
           endif
           if ( sw_neglect_magmom == ON ) then
              call m_ES_set_magmom_zero
           endif
        endif
! ============= 2014/09/26

        if ( ic == 0 ) call m_CD_convergence_check(nfout)
     else if ( ( icond==FIXED_CHARGE.or.icond==FIXED_CHARGE_CONTINUATION ) &
          &         .and. ekmode==OFF ) then
! ======================== modifided by K. Tagami ========================= 11.0
!!     call m_CD_hardpart_hsr(nfout,kv3)             ! fsr_l, fsi_l -> hsr
        if ( noncol ) then
           call m_CD_hardpart_hsr_noncl(nfout,kv3)
        else
           call m_CD_hardpart_hsr(nfout,kv3)             ! fsr_l, fsi_l -> hsr
        endif
! ========================================================================== 11.0
     end if
     if( icond == INITIAL .or. icond == CONTINUATION .or. &
          & ((icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION ) .and. &
          & m_OP_occ_mat_is_not_read())) then
        call Renewal_of_OccMat( .false., OFF )            ! evaluated with new om, hsr
     end if
  endif
! ========================================================= 5.0


#ifdef ENABLE_ESM_PACK
  if(sw_esm==ON)then
     nfftcd = fft_box_size_CD(1,0)*fft_box_size_CD(2,0)*fft_box_size_CD(3,0)
     allocate(vhar(nfftcd));vhar=(0.d0,0.d0)
!     allocate(chgc(iend_kngp-ista_kngp+1,nspin));chgc=(0.d0,0.d0)
     allocate(chgc(1:kgp,nspin));chgc=(0.d0,0.d0)
     if(kimg==1)then
        do ig=ista_kngp,iend_kngp
!           chgc(ig-ista_kngp+1,1:nspin) = dcmplx(chgq_l(ig,1,1:nspin),0.d0)
           chgc(ig,1:nspin) = dcmplx(chgq_l(ig,1,1:nspin),0.d0)
        enddo
     else
        do ig=ista_kngp,iend_kngp
!           chgc(ig-ista_kngp+1,1:nspin) = dcmplx(chgq_l(ig,1,1:nspin),chgq_l(ig,2,1:nspin))
           chgc(ig,1:nspin) = dcmplx(chgq_l(ig,1,1:nspin),chgq_l(ig,2,1:nspin))
        enddo
     endif
     call mpi_allreduce(mpi_in_place,chgc,kgp*nspin,mpi_double_complex,mpi_sum,mpi_comm_group,ierr)
     call esm_hartree(chgc,ehartr,vhar)
     ehartr  = 0.5d0*ehartr  !Ry -> Ha
     deallocate(chgc)
     deallocate(vhar)
  endif
#endif

! ======= KT_add ===== 13.0XX
!  if ( sw_calc_ekin_density == ON .and. ekin_density_is_active ) then
  if ( sw_calc_ekin_density == ON ) then
     call m_KE_cp_ekin_density_to_old

     if ( use_symm_ekin_density )  call m_KE_calc_symm_ekin_density
     if ( use_asymm_ekin_density ) call m_KE_calc_asymm_ekin_density
  endif
! ==================== 13.0XX

! ============================= KT_add ================ 13.0U
  if ( sw_monitor_atomcharge == ON ) then
     call m_CD_calc_ChgMagMom_in_sphere
  endif
! ===================================================== 13.0U

! === KT_add === 2014/08/26
  if ( noncol .and. sw_calc_orbital_moment == ON ) then
!     call m_OP_calc_OrbMagMom_in_sphere

     if ( Orbital_decomp_mode == 1 ) then
        call m_OP_calc_OrbMagMom_method1
#if 0
     else if ( Orbital_decomp_mode == 2 ) then
        call m_OP_calc_OrbMagMom_method2
#endif
     endif
  endif
! ============== 2014/08/26

  if ( sw_positron /= OFF ) then
     if ( positron_method /= Positron_CONV ) then
        call m_pWF_construct_pcharge
        call m_pWF_charge_rspace
     endif
  endif

  if ( sw_eval_energy_before_charge == OFF ) then
! ================================== modified by K. Tagami ================ 11.0
     if ( noncol ) then
        call m_TE_total_energy_noncl(nfout,display_on,kv3)
     else
        call m_TE_total_energy(nfout,display_on,kv3)
     endif
! ========================================================================== 11.0
  endif
! ======================================================== 5.0

  if(ic == 0) call m_ESIO_wd_EigenValues(nfout,iprieigenvalue,nooccupation=YES)

#ifdef __TIMER_SUB__
  call timer_end(701)
#endif
contains
  subroutine FermiEnergyLevel()
    integer :: way_of_smearing
#ifdef __TIMER_SUB__
  call timer_sta(702)
#endif
    way_of_smearing = m_CtrlP_way_of_smearing()
    if(way_of_smearing == PARABOLIC) then
       call m_ESoc_fermi_parabolic(nfout)
!!$  else if(way_of_smearing == MP) then
!!$     call fermi_mesfessel_paxton(nfout)
    else if(way_of_smearing == TETRAHEDRON) then
        call m_ESoc_fermi_tetrahedron(nfout)
    else if(way_of_smearing == COLD) then
        call m_ESoc_fermi_ColdSmearing(nfout)

! ================ KT_add ========================= 13.0E
    else if(way_of_smearing == FERMI_DIRAC) then
        call m_ESoc_fermi_Dirac(nfout)
! ================================================= 13.0E

    end if
    if(sw_bandgap_constraint == ON) then
       call m_ESoc_occup_fix(nfout)
    end if
#ifdef __TIMER_SUB__
  call timer_end(702)
#endif
  end subroutine FermiEnergyLevel

  subroutine CD_Softpart_plus_Hardpart
! $Id: ChargeDensity_Construction.F90 494 2016-06-02 00:54:16Z jkoga $
!fj#ifdef __TIMER_SUB__
!fj  call timer_sta(716)
!fj#endif
    call m_CD_softpart(nfout,kv3)
    call m_CD_hardpart(nfout,kv3)
!fj#ifdef __TIMER_SUB__
!fj  call timer_end(716)
!fj#endif
  end subroutine CD_Softpart_plus_Hardpart

! ============================ added by K. Tagami ============== 11.0
  subroutine CD_Softpart_plus_Hardpart_noncl
    call m_CD_softpart_noncl(nfout,kv3)
    call m_CD_hardpart_noncl(nfout,kv3)
  end subroutine CD_Softpart_plus_Hardpart_noncl
! ============================================================= 11.0

end subroutine ChargeDensity_Construction

!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 464 $)
!
!  MODULE: m_Crystal_Structure
!
!  AUTHORS: T. Yamasaki, K. Betsuyaku,    August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_Crystal_Structure
!      (m_CS)
! $Id: m_Crystal_Structure.F90 464 2015-09-23 14:29:53Z ktagami $
!!$  use m_Files,              only : nfout,nfopgr,nfmatbp &
  use m_Timing,             only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters, only : ipri, af, m_CtrlP_set_af, m_CtrlP_set_nspin_and_af &
#ifndef ENABLE_ESM_PACK
       &                         , ipriinputfile, ipri_spg, printable, nspin, iprisym
#else
       &                         , ipriinputfile, ipri_spg, printable, nspin &
       &                         , sw_esm,esm_z1_defined,esm_z1,esm_w, iprisym
#endif
  use m_Const_Parameters,   only : DP,PAI,PAI2,CRDTYP,CARTS,BUCS,GENERAL &
       &                         , GENERAL_LARGER, HCP,SIMPLE_CUBIC, BCC, FCC &
       &                         , DIAMOND, HEXAGONAL, TRIGONAL, FMAXVALLEN &
       &                         , TRIGONAL_lattice, HEXAGONAL_lattice, PRIMITIVE_lattice &
       &                         , FCC_lattice, BCC_lattice, BottomCenteredCubic_lattice &
       &                         , num_d6h, num_oh, d6h_symbol, oh_symbol &
       &                         , PARA, NONMAG, ANTIFERRO, FERRO, NOCONV, LOWER, UPPER, ON, OFF &
       &                         , AUTOMATIC, MANUAL, BRAVAIS, PRIMITIVE, YES, NO &
       &                         , WHOLE, INITIALLY
  use m_Parallelization,    only : mype

! ================================== added by K. Tagami =============== 11.0 & 13.2S
  use m_Control_Parameters,  only : noncol, SpinOrbit_mode
  use m_Const_Parameters,    only : NONCOLLINEAR, Neglected
! ===================================================================== 11.0 & 13.2S

! =============================== KT_add ========================= 13.0U
  use m_Control_Parameters,  only : num_projectors
  use m_Const_Parameters,    only : MAG_MOMENT_VALS_GLOBAL, MAG_MOMENT_DIREC_GLOBAL, &
       &                            MAG_MOMENT_VALS_LOCAL,  MAG_MOMENT_DIREC_LOCAL, &
       &                            MAG_MOMENT_VALS_OCCMAT, &
       &                            MAG_MOMENT_DIREC_HARDPART, &
       &                            ABRUPT, STEPWISE, LINEAR
! ================================================================ 13.0U

! === KT_add ==== 13.1R
  use m_Control_Parameters,  only : sw_keep_symmetry_strict, icond
  use m_Const_Parameters,    only : COORDINATE_CONTINUATION
! =============== 13.1R

  implicit none

!!$  integer :: input_coordinate_system             ! ncord

  integer ::                          inv = 0    ! flag for moving the origin (0:nomove, 1:move)
  integer :: inversion_symmetry = 0              ! ninv , same as inv.  {0|1} 0=noinversion nomove,1=inversion move
!!$  integer :: ntyp = 1
!!$  integer :: natm = 1
  integer :: nbztyp = GENERAL
  integer :: nbztyp_spg = 0      

  !!$integer :: symmetry_method = AUTOMATIC
  integer :: symmetry_method = MANUAL
  integer :: sw_supercell_symmetry = ON
  real(kind=DP) :: misalignment = 0.1D0    ! Bohr

  real(kind=DP) ::                          univol, rvol
  real(kind=DP) ::                          univol_super, rvol_super
  real(kind=DP) ::                          univol_prim, rvol_prim
  real(kind=DP) ::                          symmetry_check_criterion = 1.d-12
  real(kind=DP), dimension(3,3) ::          altv, rltv
  real(kind=DP), dimension(3,3) ::          altv_super, rltv_super
  real(kind=DP), dimension(3,3) ::          altv_prim, rltv_prim

! ===================================== Added by K. Tagami ==========
  integer :: kt_iuctype
! ===================================================================

  ! ---- nfspg ---
  integer ::                                      il         ! lattice system
  character, private, dimension(-1:4)  ::         Char_lattice_system
  data Char_lattice_system /'R','H','P','F','I','C'/ 
                   ! Trigonal|Hexagonal|Simple|FaceCentered|BodyCentered|BaseCentered(C-basecentered)
                   ! Each of them corresponds to il= -1, 0, 1, 2, 3, and 4, respectively.
  integer ::                                      imag = NONMAG ! para(nonmag), antiferro, ferro
  integer ::                                      sw_fix_total_spin = NO ! effective when imag==FERRO
  integer ::                                      sw_fix_total_spin_in = NO
  integer ::                                      sw_bandgap_constraint = NO
  integer ::                                      spin_fix_period  = WHOLE
  real(kind=DP) ::                                total_spin = 0.d0 ! effecitve when imag=FERRO
  real(kind=DP) ::                                a,b,c      ! lattice parameter (length)
  real(kind=DP) ::                                ca,cb,cc   ! lattice parameter (cos(angle))
  real(kind=DP),dimension(3) ::                   Bravais_lattice_length ! unit:Bohr
  real(kind=DP),dimension(3) ::                   Bravais_lattice_angle  ! unit:degrees
  integer ::                                      ngen = 1   ! # of generators
  integer, allocatable, dimension(:)::            igen       ! d(ngen) rotation of generater
  integer, allocatable, dimension(:,:,:) ::       jgen       ! d(2,3,ngen) nonprimitive translation vector of genertor 
  integer                              ::         iaf=1      ! rotation of generater for AF case
  integer, dimension(2,3)              ::         jaf=reshape((/0,1,0,1,0,1/),(/2,3/)) ! nonprimitive translation vector of generator for AF case
!  integer, dimension(2,3)              ::         jaf ! nonprimitive translation vector of generator for AF case
  
  integer ::                                      nopr ! (=ng1) # of group elements
  integer ::                                      phonon_nopr ! for Phonon code
  real(kind=DP),allocatable,dimension(:,:,:) :: tau ! (=ta1) d(3,nopr,CRDTYP), nonprimitive translation vector (A system)
  real(kind=DP),allocatable,dimension(:,:,:) :: op ! (=ra1) d(3,3,nopr),rotation matrix in real space (A system)

  integer ::                                ngen_tl = 0 ! # of additional generators for supercell
!!$  integer, allocatable,dimension(:)::       igen_tl ! d(ngen_tl) rotation of generater
  integer, allocatable,dimension(:,:,:) ::  jgen_tl ! d(2,3,ngen_tl) nonprimitive translation vector of generator
  integer ::                                nopr_tl = 0 ! (=ng1) # of additional group elements for supercell
  real(kind=DP),allocatable,dimension(:,:,:):: tau_tl !(=ta1)d(3,ngen_tl,CRDTYP),nonprimitive translation vector (A system)
  real(kind=DP),allocatable,dimension(:,:,:):: op_tl !(=ra1)d(3,3,ngen_tl),rotation matrix in real space (A system)
  real(kind=DP), allocatable, dimension(:,:,:) :: sa1  ! d(3,3,nopr), rotation matrix in reciprocal space (A system)
  integer, dimension(48)                       :: ig01 ! symmetry operation numbers
  real(kind=DP) :: b2pmat(3,3) = 0.d0 ! transformation matrix (Bravais -> Primitive)
! ==================== Modified by K. Tagami =======
!  real(kind=DP) :: p2bmat(3,3) = 0.d0 ! transformation matrix (Bravais -> Primitive)
  real(kind=DP) :: p2bmat(3,3) = 0.d0 ! transformation matrix (Bravais <- Primitive)
! ===============================================


  character(len=9) :: pg_symbol_system = 'cubic'

 ! strain tensor
  real(kind=DP), dimension(1:3,1:3) :: strain
  integer,save                      :: sw_strained_cell = OFF
  character(len("strain")),private,parameter ::    tag_strain    = "strain"
  character(len("sw_strained_cell")),private,parameter :: tag_sw_strained_cell = "sw_strained_cell"

  ! supercell
  integer :: sw_supercell = OFF
  integer :: supercell_unit_type = BRAVAIS
  integer :: n1_sc=1, n2_sc=1, n3_sc=1
  integer :: nlpnt = 1
  real(kind=DP), allocatable :: lpnt(:,:) ! dim(nlpnt,3)
  character(len("supercell")), private,parameter :: tag_supercell = 'supercell'
  character(len("sw_supercell")), private,parameter :: tag_sw_supercell = 'sw_supercell'
  character(len("size")), private,parameter :: tag_size = 'size'
  character(len("n1")), private,parameter :: tag_n1 = 'n1'
  character(len("n2")), private,parameter :: tag_n2 = 'n2'
  character(len("n3")), private,parameter :: tag_n3 = 'n3'

  ! space group
  character(len("method")),private,parameter ::    tag_method    = "method"
  character(len("automatic")),private,parameter ::    tag_automatic    = "automatic"
  character(len("manual")),private,parameter ::    tag_manual    = "manual"
  character(len("misalignment")),private,parameter :: tag_misalignment = "misalignment"
  character(len("tspace")),private,parameter ::    tag_tspace    = "tspace"
  ! sw_supercell_symmetry
  character(len("sw_supercell_symmetry")),private,parameter :: &
       &                                           tag_sw_supercell_symmetry = "sw_supercell_symmetry"
  ! ---> input tag terms
  ! --- Structure ---
  character(len("structure")),public,parameter ::  tag_structure = "structure"
  character(len("unit_cell")),private,parameter :: tag_unit_cell = "unit_cell"
  character(len("unit_cell_type")),private,parameter :: tag_unit_cell_type = "unit_cell_type"
  character(len("a_vector")), private,parameter :: tag_avector  = 'a_vector'
  character(len("b_vector")), private,parameter :: tag_bvector  = 'b_vector'
  character(len("c_vector")), private,parameter :: tag_cvector  = 'c_vector'
  character(len("a")), private,parameter ::        tag_a        = 'a'
  character(len("b")), private,parameter ::        tag_b        = 'b'
  character(len("c")), private,parameter ::        tag_c        = 'c'
  character(len("alpha")),private,parameter ::     tag_alpha    = 'alpha'
  character(len("beta")), private,parameter ::     tag_beta      = 'beta'
  character(len("gamma")), private,parameter ::    tag_gamma     = 'gamma'

  character(len("symmetry")),private,parameter ::  tag_symmetry  = "symmetry"
  character(len("symmetry_check_criterion")),private,parameter :: tag_symmetry_check_criterion = "symmetry_check_criterion"
  character(len("crystal_structure")),private,parameter ::  tag_crystal_structure = "crystal_structure"
  character(len("crystal")),private,parameter ::            tag_crystal           = "crystal"
  character(len("simple_cubic")),private,parameter ::       tag_simple_cubic      = "simple_cubic"
  character(len("diamond")),private,parameter ::            tag_diamond           = "diamond"

  character(len("lattice_system")),private,parameter ::     tag_lattice_system = "lattice_system"
  character(len("system")),private,parameter ::             tag_system    = "system"
  character(len("rhombohedral")),private,parameter ::       tag_rhombohedral = "rhombohedral"
  character(len("trigonal")),private,parameter ::           tag_trigonal  = "trigonal"
  character(len("hexagonal")),private,parameter ::          tag_hexagonal = "hexagonal"
  character(len("hcp")),private,parameter ::                tag_hcp       = "hcp"
  character(len("primitive")),private,parameter ::          tag_primitive = "primitive"
  character(len("simple")),private,parameter ::             tag_simple    = "simple"
  character(len("facecentered_cubic")),private,parameter::  tag_facecentered = "facecentered_cubic"
  character(len("bodycentered_cubic")),private,parameter::  tag_bodycentered = "bodycentered_cubic"
  character(len("bcc")),private,parameter ::                tag_bcc       = "bcc"
  character(len("fcc")),private,parameter ::                tag_fcc       = "fcc"
  character(len("onefacecentered")),private,parameter ::    tag_onefacecentered = "onefacecentered"
  character(len("bottomcentered")),private,parameter ::     tag_bottomcentered = "bottomcentered"
  character(len("basecentered")),private,parameter ::       tag_basecentered = "basecentered"
  character(len("num_generators")),private,parameter ::     tag_num_generators = "num_generators"
  character(len("generators")),private,parameter ::         tag_generators = "generators"
  character(len("additional_translations")),private,parameter::tag_additional_tl = "additional_translations"
  character(len("af_generator")),private,parameter ::       tag_af_generator = "af_generator"
  character(len("rotation")),private,parameter ::           tag_rotation  = "rotation"
  character(len("tx")),private,parameter ::                 tag_tx        = "tx"
  character(len("ty")),private,parameter ::                 tag_ty        = "ty"
  character(len("tz")),private,parameter ::                 tag_tz        = "tz"
  character(len("sw_inversion")),private,parameter ::       tag_sw_inversion = "sw_inversion"
  character(len("bandgap_constraint")),private,parameter :: tag_bandgap_constraint  = "bandgap_constraint"
  character(len("magnetic_state")),private,parameter ::     tag_magnetic_state  = "magnetic_state"
  character(len("para")),private,parameter ::               tag_para      = "para"
  character(len("nonmagnetic")),private,parameter ::        tag_nonmagnetic = "nonmagnetic"
  character(len("nonmag")),private,parameter ::             tag_nonmag    = "nonmag"
  character(len("none")),private,parameter ::               tag_none      = "none"
  character(len("af")),private,parameter ::                 tag_af        = "af"
  character(len("antiferro")),private,parameter ::          tag_antiferro = "antiferro"
  character(len("ferro")),private,parameter ::              tag_ferro     = "ferro"
  character(len("ferromagnetic_state")),private,parameter:: tag_ferromagnetic_state = "ferromagnetic_state"

  character(len("sw_fix_total_spin")),private,parameter ::  tag_sw_fix_total_spin = "sw_fix_total_spin"
  character(len("spin_fix_period")),private,parameter   ::  tag_spin_fix_period = "spin_fix_period"
  character(len("whole")),private,parameter ::              tag_whole     = "whole"
  character(len("initially")),private,parameter ::          tag_initially = "initially"
  character(len("total_spin")),private,parameter ::         tag_total_spin = "total_spin" 

  character(len("primitive")),private,parameter ::          val_primitive     = "primitive"

! --> T. Yamasaki 18th Aug. 2009 
  integer, parameter :: len_str = 132
  character(len=len_str) :: str
  character(len("fix_spin_status")),private,parameter ::    tag_fix_spin_status = "fix_spin_status" 
! <--

! ================================== added by K. Tagami =============== 11.0
!
!!  -- NonCollinear --
!
  character(len("noncollinear")),private,parameter ::   tag_noncollinear = "noncolliear"
  character(len("noncol")),      private,parameter ::   tag_noncol = "noncol"
!
  character(len("noncollinear_state")),private,parameter :: &
       &                         tag_noncollinear_state = "noncollinear_state"
!
!
  character(len("use_magnetic_symmetry")), private, parameter :: &
       &             tag_use_magnetic_symmetry = "use_magnetic_symmetry"
  character(len("use_mag_symm")), private, parameter :: &
       &             tag_use_mag_symm = "use_mag_symm"
  character(len("reduce_sym_by_magmom")), private, parameter :: &
       &             tag_reduce_sym_by_magmom = "reduce_sym_by_magmom"
  character(len("reduce_sym_by_orbital")), private, parameter :: &
       &             tag_reduce_sym_by_orbital = "reduce_sym_by_orbital"

! --- GGA noncl -
  character(len("constrain_on_grad_correction")), private, parameter :: &
       &             tag_constrain_on_grad_corr = "constrain_on_grad_correction"
! ---- PAW noncl --
  character(len("level_of_projection_paw_charge")), private, parameter :: &
       &             tag_level_projection_paw_charge = "level_of_projection_paw_charge"

! --- magnetic moment
  character(len("axis")),private,parameter :: tag_axis = "axis"
  character(len("direction")),private,parameter :: tag_direction = "direction"
  character(len("moment")),private,parameter :: tag_moment = "moment"
  character(len("magnetic_moment")),private,parameter :: tag_magnetic_moment &
       &                                       = "magnetic_moment"

  character(len("mx")),private,parameter :: tag_mx = "mx"
  character(len("my")),private,parameter :: tag_my = "my"
  character(len("mz")),private,parameter :: tag_mz = "mz"
  character(len("mdx")),private,parameter :: tag_mdx = "mdx"
  character(len("mdy")),private,parameter :: tag_mdy = "mdy"
  character(len("mdz")),private,parameter :: tag_mdz = "mdz"

  character(len("norm")),private,parameter :: tag_norm = "norm"
  character(len("theta")),private,parameter :: tag_theta = "theta"
  character(len("phi")),private,parameter :: tag_phi = "phi"
!
  real(kind=DP) :: norm
!
  integer :: sw_use_magnetic_symmetry = ON
  integer :: sw_reduce_sym_by_magmom = ON
  integer :: sw_reduce_sym_by_orbital = OFF
!!
  integer :: sw_constrain_on_grad_correction = OFF
  integer :: level_of_projection_paw_charge = 1
!
  real(kind=DP) :: mag_moment0_global(3) = (/ 0.0d0, 0.0d0, 0.0d0 /)
  real(kind=DP) :: mag_direc0_global(3) = (/ 0.0d0, 0.0d0, 1.0d0 /)
! ================================================================== 11.0

! === KT_add === 2014/08/04
!
! -- lowering contanumation in the case of noncol+GGA
!
  character(len("sw_neglect_low_helicity")),private,parameter :: &
       &          tag_sw_neglect_low_helicity = "sw_neglect_low_helicity"
  character(len("sw_neglect_low_vorticity")),private,parameter :: &
       &          tag_sw_neglect_low_vorticity = "sw_neglect_low_vorticity"
  character(len("threshold_helicity")),private,parameter :: &
       &          tag_threshold_helicity = "threshold_helicity"
  character(len("threshold_vorticity")),private,parameter :: &
       &          tag_threshold_vorticity = "threshold_vorticity"
!
  integer :: sw_neglect_low_helicity = OFF
  integer :: sw_neglect_low_vorticity = OFF
!
  integer :: sw_monitor_magnetic_vorticity = OFF
!
  real(kind=DP) :: threshold_helicity = 1.0D-6
  real(kind=DP) :: threshold_vorticity = 1.0D-4
! ============== 2014/08/04

! === KT_add ==== 2014/09/26
  character(len("sw_neglect_magmom")),private,parameter :: &
       &          tag_sw_neglect_magmom = "sw_neglect_magmom"
  integer :: sw_neglect_magmom = OFF
! =============== 2014/09/26

! ==== KT_add ==== 2014/08/09 & 13.2S
  character(len("magnetic_restriction")),private,parameter :: &
       &          tag_magnetic_restriction = "magnetic_restriction"
  character(len("sw_fix_global_quantz_axis")),private,parameter :: &
       &          tag_sw_fix_global_quantz_axis = "sw_fix_global_quantz_axis"
  character(len("global_quantz_axis")),private,parameter :: &
       &        tag_global_quantz_axis = "global_quantz_axis"
  character(len("sx")),private,parameter :: tag_sx = "sx"
  character(len("sy")),private,parameter :: tag_sy = "sy"
  character(len("sz")),private,parameter :: tag_sz = "sz"
!
  integer :: sw_fix_global_quantz_axis = OFF
  real(kind=DP) :: Global_Quantz_Axis_Fixed(3) = (/0.0d0, 0.0d0, 1.0d0/)
! ================ 2014/08/09 & 13.2S

! =========================== KT_add ===================== 13.0U
!
! -- constraint on magnetic moment --
!
  character(len("magnetic_constraint")), private, parameter :: &
       &             tag_magnetic_constraint = "magnetic_constraint"
  character(len("constraint_type")), private, parameter :: &
       &             tag_constraint_type = "constraint_type"

  character(len("vals_global")), private, parameter :: &
       &                             tag_moment_vals_global = "vals_global"
  character(len("direc_global")), private, parameter :: &
       &                             tag_moment_direc_global = "direc_global"
  character(len("vals_local")), private, parameter :: &
       &                             tag_moment_vals_local = "vals_local"
  character(len("direc_local")), private, parameter :: &
       &                             tag_moment_direc_local = "direc_local"
  character(len("vals_occmat")), private, parameter :: &
       &                             tag_moment_vals_occmat = "vals_occmat"
  character(len("direc_hardpart")), private, parameter :: &
       &                             tag_moment_direc_hardpart = "direc_hardpart"
!
  character(len("damping_method")), private, parameter :: &
       &                            tag_damping_method = "damping_method"
  character(len("abrupt")), private, parameter :: &
       &                            tag_damp_abrupt = "abrupt"
  character(len("stepwise")), private, parameter :: &
       &                            tag_damp_stepwize = "stepwise"
  character(len("linear")), private, parameter :: &
       &                            tag_damp_linear = "linear"
! --
  character(len("lambda")), private, parameter ::  tag_lambda = "lambda"
  character(len("num_intermid_lambda")), private, parameter :: &
       &                          tag_num_intermid_lambda = "num_intermid_lambda"

  character(len("edelta_change_lambda_first")), private, parameter :: &
       &                 tag_edelta_change_lambda_first = "edelta_change_lambda_first"
  character(len("edelta_change_lambda_last")), private, parameter :: &
       &                 tag_edelta_change_lambda_last = "edelta_change_lambda_last"
!
  character(len("max_iter_elec_mag_constraint")), private, parameter :: &
       &                 tag_max_iter_elec_mag_constr = "max_iter_elec_mag_constraint"
  character(len("max_iter_ion_mag_constraint")), private, parameter :: &
       &                 tag_max_iter_ion_mag_constr = "max_iter_ion_mag_constraint"
  character(len("max_iter_cell_mag_constraint")), private, parameter :: &
       &                 tag_max_iter_cell_mag_constr = "max_iter_cell_mag_constraint"
!
  character(len("sw_fix_charge_after_constraint")), private, parameter :: &
       &              tag_sw_fix_charge_after_constr = "sw_fix_charge_after_constraint"

  integer, parameter :: nmax_intermid_lambda = 100
!
  integer :: sw_magnetic_constraint = OFF
  integer :: mag_constraint_type = 0
  integer :: damping_method_mag_constraint = ABRUPT
  integer :: num_intermid_lambda = 2
!
  integer :: max_iter_elec_mag_constraint = 50
  integer :: max_iter_ion_mag_constraint = 1
!  integer :: max_iter_cell_mag_constraint = 100
  integer :: max_iter_cell_mag_constraint = 1

  integer :: sw_fix_charge_after_constraint = OFF
!
  real(kind=DP) :: mag_constraint_lambda = 0.20d0
  real(kind=DP) :: edelta_change_lambda_first = 1.0D-4     ! hartree
  real(kind=DP) :: edelta_change_lambda_last = 1.0D-4     ! hartree
! ======================================================== 13.0U

! === KT_add === 2014/06/08
! Charged state
!
  character(len("charged_state")),private,parameter :: &
       &               tag_charged_state  = "charged_state"
  character(len("extra_charge")),private,parameter :: &
       &               tag_extra_charge  = "extra_charge"
  character(len("additional_charge")),private,parameter :: &
       &               tag_additional_charge  = "additional_charge"
!
  real(kind=DP) :: additional_charge = 0.0d0
! ============== 2014/06/08

! === KT_add === 13.2S
  integer :: sw_spinorbit_force_theorem = off
! ============== 13.2S

! =============================== added by K. Tagami ============ 12.0A
  logical :: use_altv_rltv = .false.
  character(len("use_altv_rltv")), private, parameter :: &
       &                tag_use_altv_rltv = "use_altv_rltv"
!
  logical :: gen_name_in_carts = .false.
  character(len("gen_name_in_carts")), private, parameter :: &
       &                tag_gen_name_in_carts = "gen_name_in_carts"
! =============================================================== 12.0A

! == KT_add == 13.1R
  integer, save :: nopr_previous
  real(kind=DP), allocatable :: op_previous(:,:,:), tau_previous(:,:,:)
! ============ 13.1R

  logical, private :: symmetry_not_printed  = .true.

contains
  subroutine m_CS_put_Bravais_lattice(length,angle)
    real(kind=DP), dimension(3) :: length, angle
    Bravais_lattice_length = length
    Bravais_lattice_angle  = angle
  end subroutine m_CS_put_Bravais_lattice

  subroutine m_CS_set_total_spin(nfout,total_spin_new)
    integer,       intent(in) :: nfout 
    real(kind=DP), intent(in) :: total_spin_new
    total_spin = total_spin_new
    if(ipri>=1) write(nfout,'(" total_spin_new = ", f12.6)') total_spin_new
  end subroutine m_CS_set_total_spin

  subroutine m_CS_free_fixed_total_spin(nfout)
    integer,       intent(in) :: nfout 
    sw_fix_total_spin = NO
    if(ipri >=1) write(nfout,'(" !** (new setting) sw_fix_total_spin = NO <<m_CS_free_fixed_total_spin>>")')
  end subroutine m_CS_free_fixed_total_spin
! <--
! --> T. Yamasaki 17th Aug. 2009
  subroutine m_CS_fix_total_spin(nfout)
    integer,       intent(in) :: nfout 
    sw_fix_total_spin = YES
    if(ipri >=1) write(nfout,'(" !** (new setting) sw_fix_total_spin = YES <<m_CS_fix_total_spin>>")')
  end subroutine m_CS_fix_total_spin
! <--

  subroutine m_CS_rd_n(nfout)
    ! <m_CS_rd_n> reads the information of crystal system from an input file
    !    formatted in a new style.
    ! This subroutine was coded by T. Yamasaki (FUJITSU LABORATORIES LTD.), Jun. 2003

    integer, intent(in) :: nfout
    character(len=FMAXVALLEN) :: rstr, dummy
    integer :: i, iret, rint, iuctype=BRAVAIS, ucinptype     !!! iuctype=0:bravais, 1:premitive;  ucinptype=0:length, 1:vector
    integer :: f_selectBlock, f_getStringValue, f_getIntValue
    integer :: f_selectParentBlock, f_getRealValue
    integer :: f_readUnitCell, f_readAfTauVec
    real(kind=DP),allocatable,dimension(:) :: avec,bvec,cvec
    logical :: number_is_given, prealloc, is_hexagonal
    real(kind=DP) :: dret

    il = PRIMITIVE_lattice !!! K.Mae 040121
    if(ipriinputfile >= 2 .and. printable) write(nfout,'(" !** << m_CS_rd_n >>")')
    ! --- Structure ---
    if( f_selectBlock( tag_structure) == 0) then
       if(ipriinputfile >= 2 .and. printable) write(nfout,'(" !** -- tag_structure --")')
       ! --- magnetic_state

! =============================================== modified by K. Tagami ========= 11.0
!       if( f_getStringValue( tag_magnetic_state, rstr, LOWER) == 0) call set_imag(rstr) ! imag = {PARA|ANTIFERRO|FERRO}

       if( f_getStringValue( tag_magnetic_state, rstr, LOWER) == 0) then
         call set_imag(rstr) ! imag = {PARA|ANTIFERRO|FERRO|NONCOLLINEAR}
       endif
! ============================================================================== 11.0

       if(ipriinputfile >= 1 .and. printable) write(nfout,'(" !** imag = ", i6)') imag
       call m_CtrlP_set_nspin_and_af(nfout,imag)

       ! --- bandgap_constraint
       if( f_getIntValue( tag_bandgap_constraint, iret) == 0) then
          sw_bandgap_constraint = iret
          if(ipriinputfile >= 1 .and. printable) write(nfout,'(" !** bandgap_constraint = ",i6)') &
               & sw_bandgap_constraint
          if(imag .ne. NONMAG .and. sw_bandgap_constraint .ne. NO) then
             sw_bandgap_constraint = OFF
             if(ipriinputfile >=1 .and. printable) write(nfout,'(" !** bandgap_constraint(reset) = ",i6)') &
                  & sw_bandgap_constraint
          end if
       end if

       if(imag == FERRO) then
          if( f_selectBlock(tag_ferromagnetic_state) == 0) then
             if(f_getIntValue( tag_sw_fix_total_spin,iret) == 0) sw_fix_total_spin_in = iret
             if(sw_fix_total_spin_in /= YES .and. sw_fix_total_spin_in /= NO) sw_fix_total_spin_in = NO
             sw_fix_total_spin = sw_fix_total_spin_in
             if(f_getRealValue(tag_total_spin,dret,'') == 0) total_spin = dret
             if( f_getStringValue( tag_spin_fix_period, rstr, LOWER) == 0) &
                  & call set_spin_fix_period(rstr) ! spin_fix_period = {WHOLE|INITIALLY}
             if( f_getIntValue(tag_spin_fix_period,iret)==0) spin_fix_period=iret
             iret = f_selectParentBlock()
             if(ipriinputfile >= 1) then
                write(nfout,'(" !** sw_fix_total_spin_in = ",i3)') sw_fix_total_spin_in
                write(nfout,'(" !** set_spin_fix_period = ",i3," : 0=WHOLE, 1=INITIALLY")') spin_fix_period
                write(nfout,'(" !** total_spin        = ",f15.10)') total_spin
             end if
          end if
       end if

! == KT_add == 13.2S
#ifdef USE_ASMS_SPINORBIT
       if ( .not. noncol ) then
          if ( SpinOrbit_mode /= Neglected ) sw_spinorbit_force_theorem = on
       endif
#endif
! ============ 13.2S

! =========================== added by K. Tagami ===================== 11.0
       if ( imag == NONCOLLINEAR ) then
          if( f_selectBlock( tag_noncollinear_state ) == 0 ) then

             call set_sw_reduce_sym_by_magmom
             call set_sw_reduce_sym_by_orbital
             call set_sw_magnetic_symmetry
! ============ KT_mod ================== 13.0U
!             if( f_selectBlock( tag_magnetic_constraint ) == 0 ) then
!                call set_magnetic_constraint
!                iret = f_selectParentBlock()
!             end if
! =======================================13.0U
! ==== KT_add === 2014/09/26
             call set_sw_neglect_magmom
! =============== 2014/09/26
             call set_sw_constrain_on_grad_corr
             call set_level_projection_paw_charge

! ==== KT_add === 2014/08/04
             call set_threshold_lowering_contami     ! vorticity, helicity
! =============== 2014/08/04
             iret = f_selectParentBlock()
          end if
       end if
! ===================================================================== 11.0

! ==== KT_add === 2014/08/09
       call set_magnetic_restriction
! =============== 2014/08/09
! ====================== KT_add ======================= 13.0U
       if( f_selectBlock( tag_magnetic_constraint ) == 0 ) then
          call set_magnetic_constraint
          iret = f_selectParentBlock()
       end if
! ===================================================== 13.0U

! == KT_add === 2014/06/08
       if ( f_selectBlock( tag_charged_state ) == 0 ) then
          if (f_getRealValue(tag_extra_charge,dret,'') == 0) &
               &                        additional_charge = dret
          if (f_getRealValue(tag_additional_charge,dret,'') == 0) &
               &                        additional_charge = dret
          if ( additional_charge > 0.0 ) then
             write(nfout,*) "** The system is positively charged : ", additional_charge
          else if ( additional_charge < 0.0 ) then
             write(nfout,*) "** The system is negatively charged : ", -additional_charge
          endif
          iret = f_selectParentBlock()
       endif
! ============= 2014/06/08

       ! --- symmetry ---
       if( f_selectBlock( tag_symmetry) == 0) then
          if(ipriinputfile >= 2 .and. printable) write(nfout,'(" !** -- tag_symmetry --")')
          if( f_getIntValue( tag_sw_inversion, iret) == 0) inversion_symmetry = iret
          if(ipriinputfile >= 1 .and. printable) write(nfout,'(" !** inversion_symmetry = ",i6)') inversion_symmetry
          ! --- symmetry_check_criterion
          if(f_getRealValue(tag_symmetry_check_criterion,dret,'') == 0) symmetry_check_criterion = dret
          if(ipriinputfile >= 1 .and. printable) then
             write(nfout,'(" !** symmetry_check_criterion = ",d20.8)') symmetry_check_criterion
          end if
          ! --- method ---
          call set_symmetry_method(symmetry_method)
          if(f_getRealValue(tag_misalignment,dret,'bohr') == 0) misalignment = dret
          if(ipriinputfile >= 1 .and. printable) then
             write(nfout,'(" !** symmetry_method = ",i6)') symmetry_method
             if(symmetry_method == AUTOMATIC) then
                write(nfout,'(" !** misalignment = ",f15.10)') misalignment 
             end if
          end if
          ! --- sw_supercell_symmetry ---
          if(f_getIntValue( tag_sw_supercell_symmetry, iret) == 0) sw_supercell_symmetry = iret
          if(ipriinputfile >= 1 .and. printable) then
             write(nfout,'(" !** sw_supercell_symmetry = ",i6)') sw_supercell_symmetry
          end if
             
          ! --- tspace ---
          if( f_selectBlock( tag_tspace) == 0) then
             if(ipriinputfile >= 1 .and. printable) write(nfout,'(" !*  tag_tspace is found")')
             call set_lattice_system()  ! -> il
             number_is_given = f_getIntValue( tag_num_generators, iret) == 0
             if(number_is_given) then
                ngen = iret
                if( ngen >= 4 .or. ngen <= 0) then
                   if(ipriinputfile >= 0 .and. printable) &
                        & write(nfout,'(" !* <ngen> given is not proper, so it is redefined to be 1")')
                   ngen = 1
                end if
             end if
             ! --- generators ---
             prealloc = .true.
             !   --- count generators
             call set_igen_jgen(prealloc,iret)
             if(iret < 0) stop ' symmetry operation generators are not given properly <<m_CS_rd_n>>'
             if(.not.number_is_given) ngen = iret
             if(number_is_given .and. ngen > iret) ngen = iret
             if(ngen > 3) stop ' number of operation generators sould be smaller than 4 <<m_CS_rd_n>>'
                if(ipriinputfile >= 1 .and. printable) write(nfout,'(" !** ngen = ",i5," <<m_CS_rd_n>>")') ngen
             !   --- allocate and set generatos for supercell
             call alloc_igen_jgen()
             prealloc = .false.
             call set_igen_jgen(prealloc,iret)  ! -> igen, jgen
             if(imag==ANTIFERRO) call set_iaf_jaf(iret)  ! -> iaf, jaf

             if(sw_supercell_symmetry == ON) then
                ! --- additional translation operators ---
                prealloc = .true.
                !   --- count additional translation vectors ---
                call set_jgen_tl(prealloc,iret)
                if(iret < 0) stop ' symmetry operation generators for sc are not given properly <<m_CS_rd_n>>'
                ngen_tl = iret
                if(ipriinputfile>=1.and.printable) write(nfout,'(" !** ngen_tl = ",i5," <<m_CS_rd_n>>")') ngen_tl
                !   --- allocate and set additional translations for supercell
                call alloc_jgen_tl()
                prealloc = .false.
                call set_jgen_tl(prealloc,iret)  ! -> jgen_tl
             end if

! =================================== added by K. Tagami ==================== 12.0A
             if (symmetry_method == AUTOMATIC .and. il>=1 ) then
                gen_name_in_carts = .true.
                if(printable)then
                write(nfout,*) '** ** ** ** ** ** **'
                write(nfout,*) '* Generators are assumed to be in Cartesian system'
                write(nfout,*) '** ** ** ** ** ** **'
                endif
             else
                if ( f_getIntValue( tag_gen_name_in_carts, iret) == 0 ) then
                   if ( iret == YES ) then
                      gen_name_in_carts = .true.
                      if(printable)then
                      write(nfout,*) '** ** ** ** ** ** **'
                      write(nfout,*) '* Generators are assumed to be in Cartesian system'
                      write(nfout,*) '** ** ** ** ** ** **'
                      endif
                   else
                      if(printable)then
                      write(nfout,*) '** ** ** ** ** ** **'
                      write(nfout,*) '* Generators are assumed to be in Bravais system'
                      write(nfout,*) '** ** ** ** ** ** **'
                      endif
                   endif
                endif
             endif
!
             if ( f_getIntValue( tag_use_altv_rltv, iret) == 0 ) then
                if ( iret == YES ) then
                   use_altv_rltv = .true.
                   if(printable)then
                   write(nfout,*) '** use_altv_rltv is set to ', use_altv_rltv
                   write(nfout,*) '** ** ** ** ** ** **'
                   endif
                else
                   if(printable)then
                   write(nfout,*) '** use_altv_rltv is set to .false. '
                   write(nfout,*) '** ** ** ** ** ** **'
                   endif
                endif
             endif
! =========================================================================== 12.0A

             iret = f_selectParentBlock()

          else
             call set_crystal_structure()  ! -> nbztyp_spg
             call m_CS_set_default_symm_op(nfout) ! -> igen, jgen
          end if
          iret = f_selectParentBlock()
       else !!! K.Mae 040121
          call set_crystal_structure()
          call m_CS_set_default_symm_op(nfout) 
       end if

       if(ipriinputfile >= 1 .and. printable) then
          write(nfout,'(" !** il = ",i0, 3x, a)') il, Char_lattice_system(il)
       end if

       ! --- strain
       if( f_selectBlock( tag_strain) == 0) then
          call set_strain_tensor()
          if(ipriinputfile >= 1 .and. printable) then
             write(nfout,'(" !** Strain tensor <<m_CS_rd_n>>")')
             write(nfout,'(" !**      [",3(1x,f10.5)," ]")') strain(1,1:3)
             write(nfout,'(" !**  e = [",3(1x,f10.5)," ]")') strain(2,1:3)
             write(nfout,'(" !**      [",3(1x,f10.5)," ]")') strain(3,1:3)
          end if
          if( f_getIntValue( tag_sw_strained_cell, iret) == 0) sw_strained_cell = iret
          iret = f_selectParentBlock()
       end if

       ! supercell
       if( f_selectBlock( tag_supercell) == 0) then
          if( f_getIntValue( tag_sw_supercell, iret) == 0) sw_supercell = iret
          ! --- unit_cell ---
          iret = f_getStringValue(tag_unit_cell_type,rstr, LOWER)
          if( rstr == val_primitive ) then
             supercell_unit_type = PRIMITIVE ! 1
          else
             supercell_unit_type = BRAVAIS   ! 0
          end if
          if( f_selectBlock( tag_size) == 0) then
             if( f_getIntValue( tag_n1, iret) == 0) n1_sc = iret
             if( f_getIntValue( tag_n2, iret) == 0) n2_sc = iret
             if( f_getIntValue( tag_n3, iret) == 0) n3_sc = iret
             iret = f_selectParentBlock()
          end if
          iret = f_selectParentBlock()
       end if

       ! --- unit_cell ---
       iret = f_getStringValue(tag_unit_cell_type,rstr, LOWER)
       if( rstr == val_primitive ) then
          iuctype = PRIMITIVE ! 1
       else
          iuctype = BRAVAIS   ! 0
       end if
! ================================ Added by K. Tagami ===============
       kt_iuctype = iuctype
! ==================================================================

       if(ipriinputfile >= 1 .and. printable) then
          if(iret == 0) then
             write(nfout,'(" !** unit_cell_type = ",i6," [",a,"] <<m_CS_rd_n>>")') iuctype, trim(rstr)
          else
             write(nfout,'(" !** unit_cell_type is not given")')
          end if
       end if
       if( f_selectBlock( tag_unit_cell) == 0) then
          allocate(avec(1:3)); allocate(bvec(1:3)); allocate(cvec(1:3))
          iret = f_readUnitCell(avec,bvec,cvec,a,b,c,ca,cb,cc,ucinptype,'Bohr' &
               & ,tag_avector,tag_bvector,tag_cvector,tag_a,tag_b,tag_c &
               & ,tag_alpha,tag_beta,tag_gamma,printable)
          if(ipriinputfile >= 1 .and. printable) then
             if(iret == 0) then
                write(nfout,'(" !** a,b,c,ca,cb,cc = ",6f12.6," <<m_CS_rd_n>>")') a,b,c,ca,cb,cc
                write(nfout,'(" !** avec = ",3f12.6)') avec(1:3)
                write(nfout,'(" !** bvec = ",3f12.6)') bvec(1:3)
                write(nfout,'(" !** cvec = ",3f12.6)') cvec(1:3)
                write(nfout,'(" !** ucinptype = ",i6)') ucinptype
             else
                write(nfout,'(" !** iret /= 0: iret = ",i6)') iret
             end if
          end if
!!!!
          call m_CS_gnrt_tmatrices(il)

          if ( sw_strained_cell == OFF ) then
             if(is_hexagonal(ca,cb,cc).and. il==1 .and. symmetry_method == AUTOMATIC) then
                if(printable) then
                   write(nfout,'(" !** lattice_system is converted to hexagonal")')
                endif
                il = 0
             endif
          endif

          if (iuctype == BRAVAIS) then ! Bravais: 0
!             if (ucinptype == 0) then ! length: 0
                call bravais2primitive(nfout,b2pmat,a,b,c,ca,cb,cc,avec,bvec,cvec,il) ! in b_CS

                if ( icond /= COORDINATE_CONTINUATION ) then
                   if(ipriinputfile >= 1 .and. printable) then
                      write(nfout,*) '!** primitive unit cell vectors are given as'
                      write(nfout,'(" !** avec = ",3f12.6)') avec(1:3)
                      write(nfout,'(" !** bvec = ",3f12.6)') bvec(1:3)
                      write(nfout,'(" !** cvec = ",3f12.6)') cvec(1:3)
                   end if
                endif

             else                ! Primitive
                if  (ucinptype == 0) then ! length: 0
                   if(printable) write(nfout,*) 'You must give a lattice system by the Vector expression for the primitive cell.'
                   stop 'You must give a lattice system by the Vector expression for the primitive cell.'
                end if
                call primitive2bravais(nfout,p2bmat,avec,bvec,cvec,a,b,c,ca,cb,cc,il) ! in b_CS
!             end if
          end if
          if(sw_strained_cell == ON) then
             call set_strained_cell(avec,bvec,cvec)
             if(ipriinputfile >= 1 .and. printable) then
                write(nfout,'(" !** << Strained cell >>")')
                write(nfout,'(" !** avec = ",3f12.6)') avec(1:3)
                write(nfout,'(" !** bvec = ",3f12.6)') bvec(1:3)
                write(nfout,'(" !** cvec = ",3f12.6)') cvec(1:3)
             end if
             call primitive2bravais(nfout,p2bmat,avec,bvec,cvec,a,b,c,ca,cb,cc,il) ! in b_CS
          end if
          if(sw_supercell == ON) then
             if(ipriinputfile >= 1 .and. printable) then
                write(nfout,'(" !** << supercell >>")')
                write(nfout,'(" !** unit_cell_type =",i5)') supercell_unit_type
                write(nfout,'(" !** n1,n2,n3 = ",3i5)') n1_sc,n2_sc,n3_sc
             end if
          end if
!!!!
          altv(1:3,1) = avec(1:3); altv(1:3,2) = bvec(1:3); altv(1:3,3) = cvec(1:3)
          deallocate(avec); deallocate(bvec); deallocate(cvec)
          call altv_2_rltv(altv,rltv,univol,rvol)  ! in b_CS
#ifdef ENABLE_ESM_PACK
          if(sw_esm==ON .and. esm_z1_defined)then
             esm_w = esm_z1-altv(3,3)*0.5d0
          endif
#endif
          iret = f_selectParentBlock()
       else
          if(ipriinputfile >= 1 .and. printable) write(nfout,'(" !* tag_unit_cell is not found")')
       end if
       iret = f_selectParentBlock()
    else
       if(ipriinputfile >= 1 .and. printable) write(nfout,'(" !* tag_structure is not found")')
    end if

    if ( icond /= COORDINATE_CONTINUATION ) then
       if(ipriinputfile >= 1 .and. printable) then
          write(nfout,'(" !** univol = ",f20.12," <<m_CS_rd_n>>")') univol
       end if
    endif

  contains
    subroutine set_symmetry_method(symmetry_method)
      integer, intent(inout) :: symmetry_method
      integer :: iret
      logical :: tf
      iret = f_getStringValue( tag_method, rstr,LOWER)
      if(iret == 0) then
         if(ipriinputfile >= 1 .and. printable) write(nfout,'(" !*  tag_method is found")')
         call strncmp0(trim(rstr),tag_automatic,tf)
         if(tf) then
            symmetry_method = AUTOMATIC
            goto 1001
         end if
         call strncmp0(trim(rstr),tag_manual,tf)
         if(tf) then
            symmetry_method = MANUAL
            goto 1001
         end if
      end if
1001  continue
    end subroutine set_symmetry_method

    subroutine set_crystal_structure()
      integer :: iret
      logical :: tf
      nbztyp_spg = 0
      iret = f_getStringValue( tag_crystal_structure, rstr,LOWER)
      if(iret /= 0) iret = f_getStringValue( tag_crystal, rstr,LOWER)
      if(iret == 0) then
         if(ipriinputfile >= 1 .and. printable) write(nfout,'(" !*  tag_crystal is found")')
         call strncmp0(trim(rstr),tag_trigonal,tf)
         if(tf) then
            nbztyp_spg = TRIGONAL
            goto 1001
         end if
         call strncmp0(trim(rstr),tag_hexagonal,tf)
         if(tf) then
            nbztyp_spg = HEXAGONAL
            goto 1001
         end if
         call strncmp0(trim(rstr),tag_hcp,tf)
         if(tf) then
            nbztyp_spg = HCP
            goto 1001
         end if
         call strncmp0(trim(rstr),tag_simple_cubic,tf)
         if(tf) then
            nbztyp_spg = SIMPLE_CUBIC
            goto 1001
         end if
         call strncmp0(trim(rstr),tag_diamond, tf)
         if(tf) then
            nbztyp_spg = DIAMOND
            goto 1001
         end if

         call strncmp0(trim(rstr),tag_facecentered, tf)
         if(.not.tf) call strncmp0(trim(rstr),tag_fcc, tf)
         if(tf) then
            nbztyp_spg = FCC
            goto 1001
         end if

         call strncmp0(trim(rstr),tag_bodycentered,  tf)
         if(.not.tf) call strncmp0(trim(rstr),tag_bcc, tf)
         if(tf) then
            nbztyp_spg = BCC
            goto 1001
         end if
      end if
1001  continue
    end subroutine set_crystal_structure
         
    subroutine set_imag(rstr)
      character(len=FMAXVALLEN),intent(in) :: rstr
      logical :: tf
      call strncmp2(rstr, FMAXVALLEN, tag_para, len(tag_para), tf)
      if(.not.tf) call strncmp2(rstr, FMAXVALLEN, tag_nonmagnetic,len(tag_nonmagnetic),tf)
      if(.not.tf) call strncmp2(rstr, FMAXVALLEN, tag_nonmag, len(tag_nonmag),tf)
      if(.not.tf) call strncmp2(rstr, FMAXVALLEN, tag_none,   len(tag_nonmag),tf)
      if(.not.tf) call strncmp2(rstr, FMAXVALLEN, '0', 1, tf)
      if(tf) then
         imag = NONMAG
         goto 1001
      end if
      call strncmp2(rstr, FMAXVALLEN, tag_af, len(tag_af), tf)
      if(.not.tf) call strncmp2(rstr, FMAXVALLEN, tag_antiferro ,len(tag_antiferro), tf)
      if(.not.tf) call strncmp2(rstr, FMAXVALLEN, '1', 1, tf)
      if(tf) then
         imag = ANTIFERRO
         goto 1001
      end if
      call strncmp2(rstr, FMAXVALLEN, tag_ferro, len(tag_ferro), tf)
      if(.not.tf) call strncmp2(rstr, FMAXVALLEN, '2', 1, tf)
      if(tf) then
         imag = FERRO
         goto 1001
      end if

! =========================== added by K. Tagami ================= 11.0
      call strncmp2(rstr, FMAXVALLEN, tag_noncollinear, len(tag_noncollinear), tf)
      if(.not.tf) call strncmp2(rstr, FMAXVALLEN, tag_noncol, len(tag_noncol), tf)
      if(tf) then
         imag = NONCOLLINEAR
         goto 1001
      end if
! ================================================================ 11.0

1001  continue
    end subroutine set_imag

! --> T. Yamasaki, 06th Aug. 2009
    subroutine set_spin_fix_period(rstr)
      character(len=FMAXVALLEN),intent(in) :: rstr
      logical :: tf
      call strncmp2(rstr, FMAXVALLEN, tag_whole, len(tag_whole), tf)
      if(tf) then
         spin_fix_period = WHOLE
         goto 1001
      end if
      call strncmp2(rstr, FMAXVALLEN, tag_initially, len(tag_initially), tf)
      if(tf) then
         spin_fix_period = INITIALLY
         goto 1001
      end if
1001  continue
    end subroutine set_spin_fix_period
! <--

! =========================== Added by K. Tagami =============== 11.0
    subroutine set_sw_magnetic_symmetry

      sw_use_magnetic_symmetry = OFF
      if ( sw_reduce_sym_by_magmom == ON .or. sw_reduce_sym_by_orbital == ON ) then
         sw_use_magnetic_symmetry = ON
      endif

    end subroutine set_sw_magnetic_symmetry

    subroutine set_sw_reduce_sym_by_magmom
      logical :: tf

      tf = ( f_getIntValue( tag_reduce_sym_by_magmom, iret ) == 0 )
      if (tf) then
         if ( iret == ON ) then
            sw_reduce_sym_by_magmom = ON
            write(nfout,*) '**** sw_reduce_sym_by_magmom is set ON'
         else
            sw_reduce_sym_by_magmom = OFF
            write(nfout,*) '**** sw_reduce_sym_by_magmom is set OFF'
         endif
      else
         write(nfout,*) '**** sw_reduce_sym_by_magmom is set to default, ON'
      endif

    end subroutine set_sw_reduce_sym_by_magmom

    subroutine set_sw_reduce_sym_by_orbital
      logical :: tf

      tf = ( f_getIntValue( tag_reduce_sym_by_orbital, iret ) == 0 )
      if (tf) then
         if ( iret == ON ) then
            sw_reduce_sym_by_orbital = ON
            write(nfout,*) '**** sw_reduce_sym_by_orbital is set ON'
         else
            sw_reduce_sym_by_orbital = OFF
            write(nfout,*) '**** sw_reduce_sym_by_orbital is set OFF'
         endif
      else
         write(nfout,*) '**** sw_reduce_sym_by_orbital is set to default, OFF'
      endif

    end subroutine set_sw_reduce_sym_by_orbital

! ==== KT_add === 2014/08/09 & 13.2S
    subroutine set_magnetic_restriction
      if ( (.not. noncol) .and. (sw_spinorbit_force_theorem == ON) ) then
         sw_fix_global_quantz_axis = on

         if ( f_selectBlock( tag_magnetic_restriction ) == 0 ) then
            call set_global_quantz_axis
            iret = f_selectParentBlock()
         endif
      else
         if ( f_selectBlock( tag_magnetic_restriction ) == 0 ) then
            if ( f_getIntValue( tag_sw_fix_global_quantz_axis, iret ) == 0 ) then
               sw_fix_global_quantz_axis = iret
            endif
            if ( sw_fix_global_quantz_axis == ON ) call set_global_quantz_axis
            iret = f_selectParentBlock()
         endif
      endif
    end subroutine set_magnetic_restriction

    subroutine set_global_quantz_axis
      integer :: Flag
      Real(kind=DP) :: mdx, mdy, mdz, cnorm
      Real(kind=DP) :: ctmp, theta, phi

      Flag = 0
      mdx = 0.0d0; mdy = 0.0d0; mdz = 0.0d0
      theta = 0.0d0;   phi = 0.0d0

      Global_Quantz_Axis_Fixed(1) = 0.0d0
      Global_Quantz_Axis_Fixed(2) = 0.0d0
      Global_Quantz_Axis_Fixed(3) = 1.0d0

      if ( f_selectBlock( tag_global_quantz_axis ) == 0 ) then
         if( f_getRealValue( tag_sx, dret, '') == 0 ) then
            mdx = dret;   Flag = 1
         endif
         if( f_getRealValue( tag_sy, dret, '') == 0 ) then
            mdy = dret;   Flag = 1
         endif
         if( f_getRealValue( tag_sz, dret, '') == 0 ) then
            mdz = dret;   Flag = 1
         endif
         cnorm = sqrt( mdx**2 + mdy**2 + mdz**2 )

         if ( abs(cnorm) > 1.0E-4 ) then
            Global_Quantz_Axis_Fixed(1) = mdx / cnorm;
            Global_Quantz_Axis_Fixed(2) = mdy / cnorm;
            Global_Quantz_Axis_Fixed(3) = mdz / cnorm;
         endif
         !
         if ( Flag == 0 ) then
            if ( f_getRealValue( tag_theta, dret, "" ) == 0 ) then
               theta = dret
            end if
            if ( f_getRealValue( tag_phi, dret, "" ) == 0 ) then
               phi = dret
            end if

            theta  = theta / 180.0d0 *PAI
            phi  =  phi / 180.0d0 *PAI
!
            Global_Quantz_Axis_Fixed(1) = sin( theta ) *cos( phi )
            Global_Quantz_Axis_Fixed(2) = sin( theta ) *sin( phi )
            Global_Quantz_Axis_Fixed(3) = cos( theta )
         endif

         iret = f_selectParentBlock()
      endif
!
      write(nfout,*) '!************* Magnetic Restriction ************'
      write(nfout,'(A,F10.5,A,F10.5,A,F10.5)' ) &
           &             '!** global axis : sx = ', Global_Quantz_Axis_Fixed(1), &
           &             ' sy = ', Global_Quantz_Axis_Fixed(2), &
           &             ' sz = ', Global_Quantz_Axis_Fixed(3)

    end subroutine set_global_quantz_axis
! ============== 2014/08/09 & 13.2S

    subroutine set_sw_constrain_on_grad_corr
      logical :: tf

      tf = ( f_getIntValue( tag_constrain_on_grad_corr, iret ) == 0 )
      if (tf) then
         if ( iret == ON ) then
            sw_constrain_on_grad_correction = ON
            write(nfout,*) '**** sw_constrain_on_grad_correction is set ON'
         else
            sw_constrain_on_grad_correction = OFF
            write(nfout,*) '**** sw_constrain_on_grad_correction is set OFF'
         endif
      else
         write(nfout,*) '**** sw_constrain_on_grad_correction is set to default, OFF'
      endif

! === KT_add == 2014/08/09
      if ( sw_fix_global_quantz_axis == ON ) then
         sw_constrain_on_grad_correction = ON
         write(nfout,*) '**** sw_constrain_on_grad_correction is turned ON'
      endif
! ============== 2014/08/09

    end subroutine set_sw_constrain_on_grad_corr

    subroutine set_level_projection_paw_charge
      logical :: tf

      tf = ( f_getIntValue( tag_level_projection_paw_charge, iret ) == 0 )

      if (tf) then
         level_of_projection_paw_charge = iret

         if ( iret > 0 .and. iret < 4 ) then
            write(nfout,*) '**** level_of_projection_paw_charge is set to ', iret
         else
            level_of_projection_paw_charge = 1
            write(nfout,*) '**** level_of_projection_paw_charge is set to ', 1
         endif

      else
         write(nfout,*) '**** level_of_projection_paw_charge is set to default', 1
      endif

    end subroutine set_level_projection_paw_charge
! =============================================================== 11.0

! ==== KT_add ==== 2014/08/04
    subroutine set_threshold_lowering_contami        ! in case of GGA+noncl
      if ( f_getIntValue( tag_sw_neglect_low_vorticity, iret ) == 0 ) then
         sw_neglect_low_vorticity = iret
      endif
      if ( f_getIntValue( tag_sw_neglect_low_helicity, iret ) == 0 ) then
         sw_neglect_low_helicity = iret
      endif

      if ( sw_neglect_low_vorticity == ON .and. sw_neglect_low_helicity == ON ) then
         stop "Select either sw_neglect_low_vorticity or sw_neglect_low_helicty"
      endif
!
      if ( sw_neglect_low_vorticity == ON ) then
         sw_monitor_magnetic_vorticity = ON
         if ( f_getRealValue( tag_threshold_vorticity, dret, '' ) == 0 ) then
            threshold_vorticity = dret
         endif
         write(nfout,*) '!** sw_neglect_low_vorticity is ', sw_neglect_low_vorticity
         write(nfout,*) '!** threshold_vorticity is ', threshold_vorticity
      endif
      if ( sw_neglect_low_helicity == ON ) then
         sw_monitor_magnetic_vorticity = ON
         if ( f_getRealValue( tag_threshold_helicity, dret, '' ) == 0 ) then
            threshold_helicity = dret
         endif
         write(nfout,*) '!** sw_neglect_low_helicity is ', sw_neglect_low_helicity
         write(nfout,*) '!** threshold_helicity is ', threshold_helicity
      endif
!
    end subroutine set_threshold_lowering_contami
! ================ 2014/08/04

! ==== KT_add === 2014/09/26
    subroutine set_sw_neglect_magmom
      if ( f_getIntValue( tag_sw_neglect_magmom, iret ) == 0 ) then
         sw_neglect_magmom = iret
      endif
      write(nfout,*) '!** sw_neglect_magmom is ', sw_neglect_magmom
    end subroutine set_sw_neglect_magmom
! =============== 2014/09/26

! ================================= KT_add =================== 11.0&13.0U
    subroutine set_magnetic_constraint
      logical :: tf
!
      if ( f_getStringValue( tag_constraint_type,rstr,LOWER ) == 0 ) then

         call strncmp0( tag_moment_vals_global, trim(rstr), tf )
         if ( tf ) mag_constraint_type = MAG_MOMENT_VALS_GLOBAL

         call strncmp0( tag_moment_direc_global, trim(rstr), tf )
         if ( tf ) mag_constraint_type = MAG_MOMENT_DIREC_GLOBAL

         call strncmp0( tag_moment_vals_local, trim(rstr), tf )
         if ( tf ) mag_constraint_type = MAG_MOMENT_VALS_LOCAL

         call strncmp0( tag_moment_direc_local, trim(rstr), tf )
         if ( tf ) mag_constraint_type = MAG_MOMENT_DIREC_LOCAL

         call strncmp0( tag_moment_vals_occmat, trim(rstr), tf )
         if ( tf ) mag_constraint_type = MAG_MOMENT_VALS_OCCMAT

         call strncmp0( tag_moment_direc_hardpart, trim(rstr), tf )
         if ( tf ) mag_constraint_type = MAG_MOMENT_DIREC_HARDPART

      endif

      write(nfout,*) '!**************************************************'

      if ( mag_constraint_type == MAG_MOMENT_VALS_GLOBAL ) then
         call set_mag_constraint_type1;    sw_magnetic_constraint = ON
         write(nfout,*) '!*** Magnetic constraint type : MOMENT_VALS_GLOBAL'

      else if ( mag_constraint_type == MAG_MOMENT_DIREC_GLOBAL ) then
         call set_mag_constraint_type2;    sw_magnetic_constraint = ON
         write(nfout,*) '!*** Magnetic constraint type : MOMENT_DIREC_GLOBAL'

      else if ( mag_constraint_type == MAG_MOMENT_VALS_LOCAL ) then
         sw_magnetic_constraint = ON
         write(nfout,*) '!*** Magnetic constraint type : MOMENT_VALS_LOCAL'

      else if ( mag_constraint_type == MAG_MOMENT_DIREC_LOCAL ) then
         sw_magnetic_constraint = ON
         write(nfout,*) '!*** Magnetic constraint type : MOMENT_DIREC_LOCAL'

      else if ( mag_constraint_type == MAG_MOMENT_DIREC_HARDPART ) then
         sw_magnetic_constraint = ON
         write(nfout,*) '!*** Magnetic constraint type : MOMENT_DIREC_HARDPART'

      else if ( mag_constraint_type == MAG_MOMENT_VALS_OCCMAT ) then
         if ( num_projectors > 0 ) then
            sw_magnetic_constraint = ON
            write(nfout,*) '!*** Magnetic constraint type : MOMENT_VALS_OCCMAT'
         else
            write(nfout,*) '!!!! ---- This constraint requires projectors'
         endif

      endif

! ------------
      if ( sw_magnetic_constraint == OFF ) then
         write(nfout,*) '! mag_constraint is not set '; return
      endif
! ------------

      if ( f_getRealValue( tag_lambda,dret,"hartree" ) == 0 ) then
         mag_constraint_lambda = dret
      end if

      if ( f_getStringValue( tag_damping_method, rstr,LOWER ) == 0 ) then
         call strncmp0( tag_damp_abrupt, trim(rstr), tf )
         if ( tf ) damping_method_mag_constraint = ABRUPT

         call strncmp0( tag_damp_stepwize, trim(rstr), tf )
         if ( tf ) damping_method_mag_constraint = STEPWISE

         call strncmp0( tag_damp_linear, trim(rstr), tf )
         if ( tf ) damping_method_mag_constraint = LINEAR
      endif

      if ( damping_method_mag_constraint == STEPWISE ) then
         if ( f_getIntValue( tag_num_intermid_lambda, iret ) == 0 ) then
            if ( iret < 0 ) num_intermid_lambda = 0
            if ( iret > nmax_intermid_lambda ) num_intermid_lambda = nmax_intermid_lambda
            num_intermid_lambda = iret
         endif

         if ( f_getRealValue( tag_edelta_change_lambda_first,dret,"hartree" )==0 ) then
            edelta_change_lambda_first = dret
         endif
         if ( f_getRealValue( tag_edelta_change_lambda_last,dret,"hartree" )==0 ) then
            edelta_change_lambda_last = dret
         endif
         if ( num_intermid_lambda == 0 ) then
            edelta_change_lambda_last = edelta_change_lambda_first
         endif
      endif

      if ( damping_method_mag_constraint == ABRUPT .or. &
           &  damping_method_mag_constraint == LINEAR ) then

         if ( f_getIntValue( tag_max_iter_elec_mag_constr, iret ) == 0 ) then
            if ( iret < 0 ) max_iter_elec_mag_constraint = 0
            max_iter_elec_mag_constraint = iret
         endif
      endif

      write(nfout,*) '! mag_constraint_lambda is set to ', &
           &            mag_constraint_lambda
      write(nfout,*) '! damping_method is set to ', &
           &            damping_method_mag_constraint

      if ( damping_method_mag_constraint == STEPWISE ) then
         write(nfout,*) '! number_of_intermidiate lambda is ', num_intermid_lambda
         write(nfout,*) '! edelta_change_lambda_first is ', edelta_change_lambda_first
         write(nfout,*) '! edelta_change_lambda_last  is ', edelta_change_lambda_last
      endif

      if ( damping_method_mag_constraint == ABRUPT .or. &
           &  damping_method_mag_constraint == LINEAR ) then
         write(nfout,*) '! max_iter_elec_mag_constraint is ', &
              &            max_iter_elec_mag_constraint
      endif

      if ( f_getIntValue( tag_max_iter_ion_mag_constr, iret ) == 0 ) then
         if ( iret < 0 ) max_iter_ion_mag_constraint = 0
         max_iter_ion_mag_constraint = iret
      endif
      if ( f_getIntValue( tag_max_iter_cell_mag_constr, iret ) == 0 ) then
         if ( iret < 0 ) max_iter_cell_mag_constraint = 0
         max_iter_cell_mag_constraint = iret
      endif

      if ( f_getIntValue( tag_sw_fix_charge_after_constr, iret ) == 0 ) then
         sw_fix_charge_after_constraint = iret
         write(nfout,*) '! sw_fix_charge_after_constraint is ', &
              &             sw_fix_charge_after_constraint
      endif

      write(nfout,*) '! max_iter_ion_mag_constraint is ', max_iter_ion_mag_constraint
      write(nfout,*) '! max_iter_cell_mag_constraint is ', max_iter_cell_mag_constraint

      write(nfout,*) '! *********************************************** '

    end subroutine set_magnetic_constraint

!--
    subroutine set_mag_constraint_type1
      integer :: Flag
      Real(kind=DP) :: mx, my, mz, cnorm
      Real(kind=DP) :: ctmp, theta, phi

      Flag = 0
      mx = 0.0d0; my = 0.0d0; mz = 0.0d0
      theta = 0.0d0;   phi = 0.0d0

      mag_moment0_global = 0.0d0

      if ( f_selectBlock( tag_magnetic_moment ) == 0 ) then

         if ( noncol ) then
            if( f_getRealValue( tag_mx, dret, '') == 0 ) then
               mx = dret;   Flag = 1
            endif
            if( f_getRealValue( tag_my, dret, '') == 0 ) then
               my = dret;   Flag = 1
            endif
            if( f_getRealValue( tag_mz, dret, '') == 0 ) then
               mz = dret;   Flag = 1
            endif

            mag_moment0_global(1) = mx
            mag_moment0_global(2) = my
            mag_moment0_global(3) = mz
            norm = sqrt( mx**2 + my**2 +mz**2 )
         !
            if ( Flag == 0 ) then
               if ( f_getRealValue( tag_norm, dret, "" ) == 0 ) then
                  norm = dret
               end if
               if ( f_getRealValue( tag_moment, dret, "" ) == 0 ) then
                  norm = dret
               end if
               if ( f_getRealValue( tag_theta, dret, "" ) == 0 ) then
                  theta = dret
               end if
               if ( f_getRealValue( tag_phi, dret, "" ) == 0 ) then
                  phi = dret
               end if

               theta  = theta / 180.0d0 *PAI
               phi  =  phi / 180.0d0 *PAI
!
               mag_moment0_global(1) = norm *sin( theta ) *cos( phi )
               mag_moment0_global(2) = norm *sin( theta ) *sin( phi )
               mag_moment0_global(3) = norm *cos( theta )
            endif

         else
            if ( f_getRealValue( tag_norm, dret, "" ) == 0 ) then
               norm = dret;   mag_moment0_global(1) = norm
            end if
            if ( f_getRealValue( tag_moment, dret, "" ) == 0 ) then
               norm = dret;   mag_moment0_global(1) = norm
            end if

         endif

         iret = f_selectParentBlock()
      endif
!
      write(nfout,*) '!************* Magnetic constraint : type 1 ************'
      write(nfout,'(A,F10.5)') '!** magnetic moment is wanted to reach ', norm

      if ( noncol ) then
         write(nfout,'(A,F10.5,A,F10.5,A,F10.5)' ) &
              &             '!** The xyz component is mx =', mag_moment0_global(1), &
              &               ' my = ', mag_moment0_global(2), &
              &               ' mz = ', mag_moment0_global(3)

      else
         call m_CS_set_total_spin( nfout, mag_moment0_global(1) )
      endif

    end subroutine set_mag_constraint_type1

    subroutine set_mag_constraint_type2
      integer :: Flag
      Real(kind=DP) :: mdx, mdy, mdz, cnorm
      Real(kind=DP) :: ctmp, theta, phi

      Flag = 0
      mdx = 0.0d0; mdy = 0.0d0; mdz = 0.0d0
      theta = 0.0d0;   phi = 0.0d0

      mag_direc0_global(1) = 0.0d0
      mag_direc0_global(2) = 0.0d0
      mag_direc0_global(3) = 1.0d0

      if ( f_selectBlock( tag_direction ) == 0 .or. &
           &  f_selectBlock( tag_magnetic_moment ) == 0 ) then

         if( f_getRealValue( tag_mdx, dret, '') == 0 ) then
            mdx = dret;   Flag = 1
         endif
         if( f_getRealValue( tag_mdy, dret, '') == 0 ) then
            mdy = dret;   Flag = 1
         endif
         if( f_getRealValue( tag_mdz, dret, '') == 0 ) then
            mdz = dret;   Flag = 1
         endif

         if( f_getRealValue( tag_mx, dret, '') == 0 ) then
            mdx = dret;   Flag = 1
         endif
         if( f_getRealValue( tag_my, dret, '') == 0 ) then
            mdy = dret;   Flag = 1
         endif
         if( f_getRealValue( tag_mz, dret, '') == 0 ) then
            mdz = dret;   Flag = 1
         endif
         cnorm = sqrt( mdx**2 + mdy**2 + mdz**2 )

         if ( abs(cnorm) > 1.0E-4 ) then
            mag_direc0_global(1) = mdx / cnorm;
            mag_direc0_global(2) = mdy / cnorm;
            mag_direc0_global(3) = mdz / cnorm;
         endif
         !
         if ( Flag == 0 ) then
            if ( f_getRealValue( tag_theta, dret, "" ) == 0 ) then
               theta = dret
            end if
            if ( f_getRealValue( tag_phi, dret, "" ) == 0 ) then
               phi = dret
            end if

            theta  = theta / 180.0d0 *PAI
            phi  =  phi / 180.0d0 *PAI
!
            mag_direc0_global(1) = sin( theta ) *cos( phi )
            mag_direc0_global(2) = sin( theta ) *sin( phi )
            mag_direc0_global(3) = cos( theta )
         endif

         iret = f_selectParentBlock()
      endif
!
      write(nfout,*) '!************* Magnetic constraint : type 2 ************'
      write(nfout,'(A,F10.5,A,F10.5,A,F10.5)' ) &
           &             '!** The xyz component is mdx =', mag_direc0_global(1), &
           &               ' mdy = ', mag_direc0_global(2), &
           &               ' mdz = ', mag_direc0_global(3)

    end subroutine set_mag_constraint_type2
! ============================================================ 11.0&13.0U

    subroutine set_igen_jgen(prealloc,iret)
      logical, intent(in) ::  prealloc
      integer, intent(out) :: iret
      integer :: ip, linecounter
      integer, parameter :: limit_number_of_generators = 50
!!$      integer :: f_selectParentBlock, f_selectFirstTableLine, f_selectNextTableLine
      integer :: f_selectFirstTableLine, f_selectNextTableLine
      integer :: f_readSymmetryGenerator
      integer :: txu,txd,tyu,tyd,tzu,tzd
      if( f_selectBlock( tag_generators) == 0) then
         ip = 1
         linecounter = 0
         Generators: do while(.true.)
            linecounter = linecounter+1
            if(ip == 1) then
               if( f_selectFirstTableLine() /= 0) then
                  exit Generators
               end if
            else
               if( f_selectNextTableLine() /= 0) then
                  exit Generators
               end if
            end if
            if( f_readSymmetryGenerator(il, rint ,txu,txd,tyu,tyd,tzu,tzd, tag_rotation, tag_tx,tag_ty,tag_tz,printable) == 0) then
               if(.not.prealloc) then
                  if(ip > ngen) exit
                  igen(ip) = rint
                  jgen(1,1,ip) = txu; jgen(2,1,ip) = txd
                  jgen(1,2,ip) = tyu; jgen(2,2,ip) = tyd
                  jgen(1,3,ip) = tzu; jgen(2,3,ip) = tzd
               
                  if(ipriinputfile >= 1 .and. printable) then
                     write(nfout,'(" !** igen = ",i6,"  jgen = ",6i5)') igen(ip), jgen(1,1,ip), jgen(2,1,ip) &
                          & , jgen(1,2,ip),jgen(2,2,ip),jgen(1,3,ip),jgen(2,3,ip)
                  end if
               end if
               ip = ip + 1
            end if
            if(linecounter > limit_number_of_generators) then
               write(nfout,'(" linecounter exceeds limit_number_of_generatos: ip = ",i8," at <<set_igen_jgen>>")') ip
               write(nfout,'(" check tag names in <generatos block> of the input file")')
               stop ' linecounter exceeds limit_number_of_generators at <<set_igen_jgen>>'
            end if
         end do Generators
         iret = f_selectParentBlock()
         iret = ip - 1
      else
         iret = 1
         if(.not.prealloc) call set_igen_jgen_default(1)
      end if
    end subroutine set_igen_jgen

    subroutine set_jgen_tl(prealloc,iret)
      logical, intent(in) ::  prealloc
      integer, intent(out) :: iret
      integer :: ip, linecounter
      integer, parameter :: limit_number_of_generators = 50
      integer :: f_selectFirstTableLine, f_selectNextTableLine
      integer :: f_readSymmetryGenerator, f_readTranslationVectors
      integer :: txu,txd,tyu,tyd,tzu,tzd
      if( f_selectBlock( tag_additional_tl) == 0) then
         ip = 1
         linecounter = 0
         Generators: do while(.true.)
            linecounter = linecounter+1
            if(ip == 1) then
               if( f_selectFirstTableLine() /= 0) then
                  exit Generators
               end if
            else
               if( f_selectNextTableLine() /= 0) then
                  exit Generators
               end if
            end if
            if( f_readTranslationVectors(il, txu,txd,tyu,tyd,tzu,tzd, tag_tx,tag_ty,tag_tz,printable) == 0) then
               if(.not.prealloc) then
                  if(ip > ngen_tl) exit
                  jgen_tl(1,1,ip) = txu; jgen_tl(2,1,ip) = txd
                  jgen_tl(1,2,ip) = tyu; jgen_tl(2,2,ip) = tyd
                  jgen_tl(1,3,ip) = tzu; jgen_tl(2,3,ip) = tzd
               
                  if(ipriinputfile >= 1 .and. printable) then
                     write(nfout,'(" !** jgen_tl = ",6i5)') &
                          &  jgen_tl(1:2,1,ip), jgen_tl(1:2,2,ip),jgen_tl(1:2,3,ip)
                  end if
               end if
               ip = ip + 1
            end if
            if(linecounter > limit_number_of_generators) then
               write(nfout,'(" linecounter exceeds limit_number_of_generatos: ip = ",i8," at <<set_igen_jgen>>")') ip
               write(nfout,'(" check tag names in <generatos block> of the input file")')
               stop ' linecounter exceeds limit_number_of_generators at <<set_igen_jgen>>'
            end if
         end do Generators
         iret = f_selectParentBlock()
         iret = ip - 1
      else
         iret = 0
!!$         if(.not.prealloc) call set_jgen_default_tl(1)
      end if
    end subroutine set_jgen_tl

    subroutine set_iaf_jaf(iret)
      integer, intent(out) :: iret
      integer :: ip
      integer :: f_selectFirstTableLine, f_selectNextTableLine
      integer :: f_readSymmetryGenerator
      integer :: txu,txd,tyu,tyd,tzu,tzd
      if( f_selectBlock( tag_af_generator) == 0) then
         ip = 1
         Generators: do while(.true.)
            if(ip == 1) then
               if( f_selectFirstTableLine() /= 0) then
                  exit Generators
               end if
            else
               if( f_selectNextTableLine() /= 0) then
                  exit Generators
               end if
            end if
            if( f_readSymmetryGenerator(il, rint ,txu,txd,tyu,tyd,tzu,tzd, tag_rotation, tag_tx,tag_ty,tag_tz,printable) == 0) then
                  if(ip > 1) exit
                  iaf = rint
                  jaf(1,1) = txu; jaf(2,1) = txd
                  jaf(1,2) = tyu; jaf(2,2) = tyd
                  jaf(1,3) = tzu; jaf(2,3) = tzd

                  if(ipriinputfile >= 1 .and. printable) then
                     write(nfout,'(" !** iaf  = ",i6,"  jaf  = ",6i5)') iaf, jaf(1,1), jaf(2,1) &
                          & , jaf(1,2),jaf(2,2),jaf(1,3),jaf(2,3)
                  end if
               ip = ip + 1
            end if
         end do Generators
         iret = f_selectParentBlock()
         iret = ip - 1
      end if
    end subroutine set_iaf_jaf

    subroutine set_igen_jgen_default(i)
      integer, intent(in) :: i
      integer :: j
      igen(i) = 1
      do j = 1, 3
         jgen(1,j,i) = 0
         jgen(2,j,i) = 1
      end do
    end subroutine set_igen_jgen_default

    subroutine set_jgen_default_tl(i)
      integer, intent(in) :: i
      integer :: j
!!$      igen_tl(i) = 1
      do j = 1, 3
         jgen_tl(1,j,i) = 0
         jgen_tl(2,j,i) = 1
      end do
    end subroutine set_jgen_default_tl

    subroutine set_lattice_system()
      integer :: iret
      logical :: proper_lattice_system
      proper_lattice_system = .false.
      iret = f_getstringValue( tag_lattice_system, rstr, LOWER)
      if(iret /= 0) iret = f_getstringValue( tag_system, rstr, LOWER)
      if(iret == 0) then
         proper_lattice_system = set_lattice_system0(rstr) ! -->il
         if(.not.proper_lattice_system) then
            if(ipriinputfile>= 0 .and. printable)  &
                 & write(nfout,'(" !* lattice_system defined in the [tspace] block is not approprieate (",a32,")")') rstr
            il = PRIMITIVE_lattice
            if(ipriinputfile>= 0 .and. printable) &
                 & write(nfout,'(" !* lattice_system is set to be PRIMITIVE lattice at <<m_CS_rd_n.set_lattice_system>>")')
         end if
      else
         il = PRIMITIVE_lattice !!! K. Mae 040121
         if(ipriinputfile >= 0 .and. printable) then
            write(nfout,'(" ! lattice_system is not defined in the [tspace] block")')
            write(nfout,'(" ! lattice_system is set to be PRIMITIVE lattice at <<m_CS_rd_n.set_lattice_system>>")')
         end if
      end if
      if(ipriinputfile >= 1 .and. printable) then
         write(nfout,'(" !** il = ",i5," <<m_CS_rd_n.set_lattice_system>>")') il
         if(il == -1) write(nfout,'(" !** il = ",a32)') tag_trigonal
         if(il ==  0) write(nfout,'(" !** il = ",a32)') tag_hexagonal
         if(il ==  1) write(nfout,'(" !** il = ",a32)') tag_primitive
         if(il ==  2) write(nfout,'(" !** il = ",a32)') tag_facecentered
         if(il ==  3) write(nfout,'(" !** il = ",a32)') tag_bodycentered
         if(il ==  4) write(nfout,'(" !** il = ",a32)') tag_basecentered
      end if
    end subroutine set_lattice_system

    logical function set_lattice_system0(rstr)
      character(len=FMAXVALLEN), intent(in) :: rstr
      logical :: tf
      integer :: lenstr
      set_lattice_system0 = .false.
      lenstr = len(trim(rstr))
      if(lenstr >= 1) call strncmp0(tag_rhombohedral, trim(rstr), tf)
      if(.not.tf .and. lenstr >= 1) call strncmp0(tag_trigonal, trim(rstr), tf)
      if(.not.tf .and. lenstr == 2) call strncmp0(trim(rstr), "-1", tf)
      if(tf) then
         il = TRIGONAL_lattice
         set_lattice_system0 = .true.
         goto 1001
      end if

      if(lenstr >= 1) call strncmp0(tag_hexagonal, trim(rstr), tf)
      if(.not.tf .and. lenstr == 1) call strncmp0(trim(rstr), "0", tf)
      if(tf) then
         il = HEXAGONAL_lattice
         set_lattice_system0 = .true.
         goto 1001
      end if

      if(lenstr >= 1) call strncmp0(tag_primitive, trim(rstr), tf)
      if(.not.tf .and. lenstr >= 1) call strncmp0(tag_simple, trim(rstr), tf)
      if(.not.tf .and. lenstr == 1) call strncmp0(trim(rstr),"1",tf)
      if(tf) then
         il = PRIMITIVE_lattice
         set_lattice_system0 = .true.
         goto 1001
      end if

      if(lenstr >= 1) call strncmp0(tag_facecentered, trim(rstr), tf)
      if(.not.tf .and. lenstr >= 1) call strncmp0(tag_fcc, trim(rstr), tf)
      if(.not.tf .and. lenstr == 1) call strncmp0(trim(rstr),"2",tf)
      if(tf) then
         il = FCC_lattice
         set_lattice_system0 = .true.
         goto 1001
      end if

      if(lenstr >= 3) call strncmp0(tag_bodycentered, trim(rstr), tf)
      if(.not.tf .and. lenstr >= 2) call strncmp0(tag_bcc, trim(rstr), tf)
      if(.not.tf .and. lenstr == 1) call strncmp0(trim(rstr),"3",tf)
      if(tf) then
         il = BCC_lattice
         set_lattice_system0 = .true.
         goto 1001
      end if

      if(lenstr >= 3) call strncmp0(tag_bottomcentered, trim(rstr), tf)
      if(.not.tf .and. lenstr >= 2) call strncmp0(tag_basecentered, trim(rstr), tf)
      if(.not.tf .and. lenstr >= 1) call strncmp0(tag_onefacecentered, trim(rstr),tf)
      if(.not.tf .and. lenstr == 1) call strncmp0(trim(rstr),"4",tf)
      if(tf) then
         il = BottomCenteredCubic_lattice
         set_lattice_system0 = .true.
         goto 1001
      end if
1001  continue
    end function set_lattice_system0

!!$    integer function f_readUnitCell(avec,bvec,cvec,a,b,c,alpha,beta,gamma)
!!$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!$! intelligent reading of unit cell
!!$! This function has been coded by K. Mae(adv), May-Jun. 2003
!!$! Subtle modifications( (8) -> (DP), PI -> PAI ) were done
!!$!        by  T. Yamasaki(FUJITSU LABORATORIES LTD.),  9th Jun. 2003
!!$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!$      real(DP), dimension(3), intent(out) :: avec
!!$      real(DP), dimension(3), intent(out) :: bvec
!!$      real(DP), dimension(3), intent(out) :: cvec
!!$      real(DP), intent(out) :: a, b, c
!!$      real(DP), intent(out) :: alpha, beta, gamma
!!$      real(DP) :: s, al, be, ga, cos_al, sin_be, cos_be, sin_ga, cos_ga
!!$      integer :: getRealVectorValue
!!$      integer :: getRealValue
!!$      integer :: iret
!!$
!!$      if( getRealVectorValue( trim(TAG_AVECTOR)//char(0), avec ) == 0 ) then
!!$         iret = getRealVectorValue( trim(TAG_BVECTOR)//char(0), bvec )
!!$         iret = getRealVectorValue( trim(TAG_CVECTOR)//char(0), cvec )
!!$         a = sqrt( sum(avec(:)*avec(:)) )
!!$         b = sqrt( sum(bvec(:)*bvec(:)) )
!!$         c = sqrt( sum(cvec(:)*cvec(:)) )
!!$         alpha = acos( dot_product(bvec,cvec)/(b*c) )*180.d0/PAI
!!$         beta = acos( dot_product(cvec,avec)/(c*a) )*180.d0/PAI
!!$         gamma = acos( dot_product(avec,bvec)/(a*b) )*180.d0/PAI
!!$      else if( getRealValue( trim(TAG_A)//char(0), a ) == 0 ) then
!!$         iret = getRealValue( trim(TAG_B)//char(0), b )
!!$         iret = getRealValue( trim(TAG_C)//char(0), c )
!!$         iret = getRealValue( trim(TAG_ALPHA)//char(0), alpha )
!!$         iret = getRealValue( trim(TAG_BETA)//char(0), beta )
!!$         iret = getRealValue( trim(TAG_GAMMA)//char(0), gamma )
!!$         al = alpha*PAI/180.d0
!!$         be = beta*PAI/180.d0
!!$         ga = gamma*PAI/180.d0
!!$         cos_al = cos(al)
!!$         sin_be = sin(be)
!!$         cos_be = cos(be)
!!$         sin_ga = sin(ga)
!!$         cos_ga = cos(ga)
!!$         s = (cos_ga*cos_be-cos_al)/sin_ga/cos_be
!!$         avec(1) = a
!!$         avec(2) = 0.d0
!!$         avec(3) = 0.d0
!!$         bvec(1) = b*cos_ga
!!$         bvec(2) = b*sin_ga
!!$         bvec(3) = 0.d0
!!$
!!$         cvec(1) = c*cos_be
!!$         cvec(2) = (b*c*cos_al - bvec(2)*cvec(1))/bvec(2)
!!$         cvec(3) = sqrt(c*c - cvec(1)**2 - cvec(2)**2)
!!$		cvec(1) = c*cos_be
!!$		cvec(2) = c*abs(s)*cos_be
!!$		cvec(3) = c*sqrt(sin_be*sin_be-s*s*cos_be*cos_be)
!!$      else
!!$         f_readUnitCell = -1
!!$         return
!!$      end if
!!$	
!!$      f_readUnitCell = 0
!!$      return
!!$    end function f_readUnitCell
  end subroutine m_CS_rd_n

  subroutine m_CS_altv_2_rltv()
    call altv_2_rltv(altv,rltv,univol,rvol)
  end subroutine m_CS_altv_2_rltv

  subroutine m_CS_set_nbztyp_spg()
    nbztyp_spg = nbztyp
  end subroutine m_CS_set_nbztyp_spg

  subroutine m_CS_set_nbztyp(type)
    integer, intent(in) :: type
    nbztyp    = type
  end subroutine m_CS_set_nbztyp

  subroutine m_CS_alloc_op_tau(nfout)
    integer, intent(in) :: nfout
    if(printable) then
       write(nfout,'(" -- m_CS_alloc_op_tau --")')
       write(nfout,'(" !! nopr, af = ",2i5)') nopr,af
    end if
    if(nopr == 0) stop ' nopr is invalid'
    allocate(op(3,3,nopr+af))
    allocate(tau(3,nopr+af,CRDTYP))
  end subroutine m_CS_alloc_op_tau

  subroutine m_CS_alloc_op_tau_tl(nfout)
    integer, intent(in) :: nfout
    if(printable) then
       write(nfout,'(" -- m_CS_alloc_op_tau_tl --")')
       write(nfout,'(" !! ngen_tl = ",i5)') ngen_tl
    end if
    if(ngen_tl > 0) then
       allocate(op_tl(3,3,ngen_tl))
       allocate(tau_tl(3,ngen_tl,CRDTYP))
    else
       allocate(op_tl(3,3,1))
       allocate(tau_tl(3,1,CRDTYP))
    end if
  end subroutine m_CS_alloc_op_tau_tl

  subroutine alloc_igen_jgen
    allocate(igen(ngen)); igen = 0
    allocate(jgen(2,3,ngen)); jgen = 0
  end subroutine alloc_igen_jgen

  subroutine alloc_jgen_tl
!!$    allocate(igen_tl(ngen_tl)); igen_tl = 0
    allocate(jgen_tl(2,3,ngen_tl)); jgen_tl = 0
  end subroutine alloc_jgen_tl

  subroutine dealloc_igen_jgen
    deallocate(igen)
    deallocate(jgen)
  end subroutine dealloc_igen_jgen

  subroutine m_CS_wd_CS_data(nfcntn,nfout)
    integer, intent(in) :: nfcntn,nfout
    write(nfcntn) inversion_symmetry
    write(nfcntn) nbztyp
    write(nfcntn) altv,rltv, univol, rvol
  end subroutine m_CS_wd_CS_data

  subroutine m_CS_rd_CS_data(nfcntn,nfout)
    integer, intent(in) :: nfcntn, nfout
    if(printable)  write(nfout,*) ' <<< m_CS_rd_CS_data >>>'
!!$    read(nfcntn) input_coordinate_system
!!$    write(nfout,*) ' input_coordinate_system = ', input_coordinate_system
    read(nfcntn) inversion_symmetry
    read(nfcntn) nbztyp
    read(nfcntn) altv,rltv, univol, rvol
  end subroutine m_CS_rd_CS_data

! --> T. Yamasaki, 18th Aug. 2009
  subroutine m_CS_wd_fix_spin_status(nfcntn)

    integer, intent(in) :: nfcntn

! ================================== added by K. Tagami ====================== 11.0
    if ( noncol ) return
! ============================================================================ 11.0

    if(nspin == 2) then
       if(mype == 0) then
          write(nfcntn,'(a15)') tag_fix_spin_status
          write(nfcntn,'(2i5,d20.8)') sw_fix_total_spin_in, sw_fix_total_spin, total_spin
       end if
    end if
  end subroutine m_CS_wd_fix_spin_status

  subroutine m_CS_rd_fix_spin_status(nfcntn,nfout)
    integer, intent(in) :: nfcntn,nfout
    integer :: i
    logical :: EOF_reach, tag_is_found

! ================================== added by K. Tagami ====================== 11.0
    if ( noncol ) return
! ============================================================================ 11.0

    if(nspin == 2) then
       if(mype == 0) then
          call rewind_to_tag0(nfcntn,len(tag_fix_spin_status),tag_fix_spin_status &
               &, EOF_reach, tag_is_found, str, len_str)
          write(nfout,'(" << m_CS_rd_fix_spin_status>>")')
          if(.not.tag_is_found) then
             write(nfout,'(" sw_fix_total_spin_in, sw_fix_total_spin and total_spin  are not read")')
          else
             read(nfcntn,*) i, sw_fix_total_spin, total_spin
             write(nfout,'(" sw_fix_total_spin_in, sw_fix_total_spin, total_spin = ",2i5,d20.8)') &
                  &         i, sw_fix_total_spin, total_spin
          end if
       end if
    end if
  end subroutine m_CS_rd_fix_spin_status
! <--

! --- subroutine m_CS_read_symmtry_op_etc ---
!  This subroutine is revised version of the subroutine <rdprp>
!                 T. Yamasaki(FUJITSU Lab.) 31 May 2003
  subroutine m_CS_rd_symmetry_op_etc(nf)
    integer, intent(in) :: nf
    integer :: ianti,janti(2,3),i,j,k
    character(len=60) :: cname
    logical :: skip_to_tagbegin

    rewind nf

    if(.not.skip_to_tagbegin(nf,tag_tspace)) then
       if(printable) write(6,'(" ! tag of tspace is not found in the inputfile")')
       stop ' stopped at <<m_CS_rd_symmetry_op_etc>>'
    end if

    read(nf,*) i ! jpr

    read(nf,'(a60)') cname
    read(nf,*) i, il, ngen, inv  ! i<-idim

    if(ipri_spg >= 1 .and. printable) then
       write(6,820) cname,i,il,ngen,inv
       write(6,*) 'ngen=',ngen     
    end if
  820 format(' == ',a60,' ==' / &
     &  ' dimension=',i2,'      il=',i2,'   ngen=',i2,'   inv=',i2)

    call alloc_igen_jgen()
    do i = 1, ngen
       read (nf,*)   igen(i),((jgen(j,k,i),j=1,2),k=1,3)
    end do

    read(nf,*) imag
    if(imag == 1) then
       if(printable) write(6,*) ' antiferromagnetic calculation'
       read (nf,*)   ianti,((janti(j,k),j=1,2),k=1,3)
    endif

!!$    read(nf,*) a,b,c,ca,cb,cc

    if(ipri_spg >= 1 .and. printable) then
       write(6,*) ' << m_CS_rd_symmetry_op_etc >>'
       write(6,860) a,b,c,ca,cb,cc
860    format(' a, b, c =',3f12.6/ &
       &       'ca,cb,cc =',3f12.6)
    end if
  end subroutine m_CS_rd_symmetry_op_etc

  subroutine m_CS_set_abccacbcc()
    a=dsqrt(altv(1,1)**2+altv(2,1)**2+altv(3,1)**2)
    b=dsqrt(altv(1,2)**2+altv(2,2)**2+altv(3,2)**2)
    c=dsqrt(altv(1,3)**2+altv(2,3)**2+altv(3,3)**2)
    ca=(altv(1,2)*altv(1,3)+altv(2,2)*altv(2,3)+altv(3,2)*altv(3,3)) /(b*c)
    cb=(altv(1,3)*altv(1,1)+altv(2,3)*altv(2,1)+altv(3,3)*altv(3,1)) /(c*a)
    cc=(altv(1,1)*altv(1,2)+altv(2,1)*altv(2,2)+altv(3,1)*altv(3,2)) /(a*b)
    if(printable) then 
       write(6,*) ' << m_CS_set_abccacbcc >>  '
       write(6,860) a,b,c,ca,cb,cc
    end if
860 format(' a, b, c =',3f12.6/ 'ca,cb,cc =',3f12.6)
  end subroutine m_CS_set_abccacbcc

  ! --- subroutine m_CS_set_default_symm_op
  !  This subroutine is revised from <setspg_default> by T. Yamasaki(FUJITSU Lab.)
  !  The former part of the <setspg_default> is taken.
  !                                                            31 May 2003
  subroutine m_CS_set_default_symm_op(nfout)
    integer, intent(in) :: nfout
    integer ::   ip

    if(ipri_spg >= 1 .and. printable)  write(nfout,'(" !** nbztyp_spg = ",i6)') nbztyp_spg

!!$    if(ipri_spg >= 1 .and. printable) then
!!$       write(nfout,*) ' '
!!$       write(nfout,860) a,b,c,ca,cb,cc
!!$860    format(' !** a, b, c =',3f12.6/ ' !** ca,cb,cc =',3f12.6)
!!$    end if
    if(nbztyp_spg == SIMPLE_CUBIC) then
       il=1
       ngen=3
       inv=1
    else if(nbztyp_spg == BCC) then
       il=3
       ngen=3
       inv=1
    else if(nbztyp_spg == FCC) then
       il=2
       ngen=3
       inv=1
    else if(nbztyp_spg == DIAMOND) then
       il=2
       ngen=3
       inv=0
    else if(nbztyp_spg == HEXAGONAL) then
       il=0
       ngen=1       !!! K.Mae 040315
       !!! ngen=2   !!! K.Mae 040315
       inv=0
    else if(nbztyp_spg == HCP) then
       il=0
       ngen=3
       inv=1
    else if(nbztyp_spg == TRIGONAL) then
       il=-1
       ngen=1
       inv=0
    else
       il=1
       ngen=1
       inv=0
       if(printable) write(nfout,'(" !** nbztyp_spg = ",i6," <m_CS_set_default_symm_op>")') nbztyp_spg
!!$       stop ' nbztyp_spg (m_CS_set_default_symm_op) is illegal'
    end if
    call alloc_igen_jgen()

    if(nbztyp_spg == SIMPLE_CUBIC) then     ! Oh
       igen(1)=5
       jgen(1,1,1)=0;         jgen(2,1,1)=1
       jgen(1,2,1)=0;         jgen(2,2,1)=1
       jgen(1,3,1)=0;         jgen(2,3,1)=1
       igen(2)=19
       jgen(1,1,2)=0;         jgen(2,1,2)=1
       jgen(1,2,2)=0;         jgen(2,2,2)=1
       jgen(1,3,2)=0;         jgen(2,3,2)=1
       igen(3)=25
       jgen(1,1,3)=0;         jgen(2,1,3)=1
       jgen(1,2,3)=0;         jgen(2,2,3)=1
       jgen(1,3,3)=0;         jgen(2,3,3)=1
    else if(nbztyp_spg == BCC) then
       igen(1)=5
       jgen(1,1,1)=0;         jgen(2,1,1)=1
       jgen(1,2,1)=0;         jgen(2,2,1)=1
       jgen(1,3,1)=0;         jgen(2,3,1)=1
       igen(2)=19
       jgen(1,1,2)=0;         jgen(2,1,2)=1
       jgen(1,2,2)=0;         jgen(2,2,2)=1
       jgen(1,3,2)=0;         jgen(2,3,2)=1
       igen(3)=25
       jgen(1,1,3)=0;         jgen(2,1,3)=1
       jgen(1,2,3)=0;         jgen(2,2,3)=1
       jgen(1,3,3)=0;         jgen(2,3,3)=1
    else if(nbztyp_spg == FCC) then
       igen(1)=5
       jgen(1,1,1)=0;         jgen(2,1,1)=1
       jgen(1,2,1)=0;         jgen(2,2,1)=1
       jgen(1,3,1)=0;         jgen(2,3,1)=1
       igen(2)=19
       jgen(1,1,2)=0;         jgen(2,1,2)=1
       jgen(1,2,2)=0;         jgen(2,2,2)=1
       jgen(1,3,2)=0;         jgen(2,3,2)=1
       igen(3)=25
       jgen(1,1,3)=0;         jgen(2,1,3)=1
       jgen(1,2,3)=0;         jgen(2,2,3)=1
       jgen(1,3,3)=0;         jgen(2,3,3)=1
    else if(nbztyp_spg == DIAMOND) then
       igen(1)=5
       jgen(1,1,1)=0;         jgen(2,1,1)=1
       jgen(1,2,1)=0;         jgen(2,2,1)=1
       jgen(1,3,1)=0;         jgen(2,3,1)=1
!ccccccc 2nd choice ccccccccccccccccccccc
       igen(2)=19
       jgen(1,1,2)=1;         jgen(2,1,2)=4
       jgen(1,2,2)=1;         jgen(2,2,2)=2
       jgen(1,3,2)=3;         jgen(2,3,2)=4
       igen(3)=25
       jgen(1,1,3)=0;         jgen(2,1,3)=1
       jgen(1,2,3)=0;         jgen(2,2,3)=1
       jgen(1,3,3)=0;         jgen(2,3,3)=1
!ccccccc 2nd choice ccccccccccccccccccccc
    else if(nbztyp_spg == HEXAGONAL) then
      !!! K.Mae 040315, only C3
      igen(1)=3
      jgen(1,1,1)=0;         jgen(2,1,1)=1
      jgen(1,2,1)=0;         jgen(2,2,1)=1
      jgen(1,3,1)=0;         jgen(2,3,1)=1
      !!! commented out by K.Mae 040315, These generators only for SiO2
      ! igen(1)=3
      ! jgen(1,1,1)=0;         jgen(2,1,1)=1
      ! jgen(1,2,1)=0;         jgen(2,2,1)=1
      ! jgen(1,3,1)=2;         jgen(2,3,1)=3
      ! igen(2)=10
      ! jgen(1,1,2)=0;         jgen(2,1,2)=1
      ! jgen(1,2,2)=0;         jgen(2,2,2)=1
      ! jgen(1,3,2)=0;         jgen(2,3,2)=1
      !!! end commented out by K.Mae 040315
    else if(nbztyp_spg == HCP) then
! [nbztyp_spg == HCP] is added by T. Yamasaki(FUJITSU LABORATORIES LTD.) 11th Jun. 2003
       igen(1)=2
       jgen(1,1,1)=0;         jgen(2,1,1)=1
       jgen(1,2,1)=0;         jgen(2,2,1)=1
       jgen(1,3,1)=1;         jgen(2,3,1)=2
       igen(2)=7
       jgen(1,1,2)=0;         jgen(2,1,2)=1
       jgen(1,2,2)=0;         jgen(2,2,2)=1
       jgen(1,3,2)=1;         jgen(2,3,2)=2
       igen(3)=13
       jgen(1,1,3)=0;         jgen(2,1,3)=1
       jgen(1,2,3)=0;         jgen(2,2,3)=1
       jgen(1,3,3)=0;         jgen(2,3,3)=1
    else if(nbztyp_spg == TRIGONAL) then
       igen(1)=3
       jgen(1,1,1)=0;         jgen(2,1,1)=1
       jgen(1,2,1)=0;         jgen(2,2,1)=1
       jgen(1,3,1)=0;         jgen(2,3,1)=1
    else
       igen(1)=1
       jgen(1,1,1)=0;         jgen(2,1,1)=1
       jgen(1,2,1)=0;         jgen(2,2,1)=1
       jgen(1,3,1)=0;         jgen(2,3,1)=1
    end if
    if(ipri_spg >= 1 .and. printable) then
       write(nfout,'(" !** il = ",i6, "<<m_CS_set_default_symm_op>>")') il
       do ip = 1, ngen
          write(nfout,'(" !** igen = ",i6,"  jgen = ",6i5)') igen(ip), jgen(1,1,ip), jgen(2,1,ip) &
               & , jgen(1,2,ip),jgen(2,2,ip),jgen(1,3,ip),jgen(2,3,ip)
       end do
    end if
  end subroutine m_CS_set_default_symm_op

  ! ---------- 
  subroutine m_CS_wd_op_and_tau(nfout)
    integer, intent(in) :: nfout
    integer :: no ,i, j, l, k
    real(kind=DP),dimension(3,3) :: op_br
    write(nfout,*) ' --- Symmetry Operations (CARTS, PUCV) --- (in m_CS_wd_op_and_tau)'
    write(nfout,'(" !! nopr+af = ",i6)') nopr+af

    do no = 1, nopr + af
       do i = 1, 3
          do j = 1, 3
             op_br(i,j) = 0.d0
             do l = 1,3
                do k = 1,3
                   op_br(i,j) = op_br(i,j) &
                        &           + altv(l,i)*op(l,k,no)*rltv(k,j)
                enddo
             enddo
             op_br(i,j) = op_br(i,j)/PAI2
          enddo
       enddo
       if( no<= nopr ) then
          if(il<=0 .or. pg_symbol_system == 'hexagonal') then
             write(nfout,*) ' #symmetry op. = ', no, d6h_symbol(ig01(no))
          else
             write(nfout,*) ' #symmetry op. = ', no, oh_symbol(ig01(no))
          end if
       else
          if(il<=0 .or. pg_symbol_system == 'hexagonal') then
             write(nfout,*) ' #symmetry op. = ', no, d6h_symbol(iaf)
          else
             write(nfout,*) ' #symmetry op. = ', no, oh_symbol(iaf)
          end if
       end if
         
       do i = 1, 3
          write(nfout,'(4f8.4,3x,4f8.4)') &
               &           (op   (i,j,no),j=1,3),tau(i,no,CARTS) &
               &          ,(op_br(i,j),j=1,3),tau(i,no,BUCS)
       enddo
    end do
    if(ipri >= 1 .and. symmetry_not_printed) symmetry_not_printed=.false.
  end subroutine m_CS_wd_op_and_tau

  subroutine m_CS_gnrt_symmetry_operations(paramset,nfout)
    logical, intent(in) :: paramset
    integer, intent(in) :: nfout
    integer ::             i, j, iopr, ip
    integer ::             af_t
    integer ::             id_sname = -1
    real(kind=DP),dimension(3,3) :: op_br
#ifdef __TIMER_SUB__
  call timer_sta(1227)
#endif

    call tstatc0_begin('m_CS_gnrt_symmetry_operations ',id_sname)
! ----- iopr, op, tau

! ---> T. Yamasaki(FUJITSU Laboratoreis) 31 May 2003
!!$    if(paramset) then
!!$       if(nbztyp >= 2 .and. &
!!$            & (nbztyp_spg == GENERAL .or. nbztyp_spg == GENERAL_LARGER)) then
!!$          call m_CS_rd_symmetry_op_etc(nfspg)
!!$       else
!!$          call m_CS_set_default_symm_op()  ! <-- nbztyp_spg
!!$       end if
!!$    end if
! <----

    if(printable .and. paramset) then
       write(nfout,'(" ngen = ", i6)') ngen
       do ip = 1, ngen
          write(nfout,'(" igen = ",i6," jgen = ",6i5)') igen(ip) &
               & , jgen(1,1,ip), jgen(2,1,ip), jgen(1,2,ip) &
               & , jgen(2,2,ip), jgen(1,3,ip), jgen(2,3,ip)
       end do
       if(af > 0) then
          write(nfout,'(" iaf  = ",i6," jaf  = ",6i5)') iaf &
                & , jaf(1,1), jaf(2,1), jaf(1,2) &
                & , jaf(2,2), jaf(1,3), jaf(2,3)
       end if
    end if
    call iopr_op_tau(af_t)  ! depends on 'paramset'

    if(ipri >= 3 .and. paramset) write(nfout,'(" !! af_t = ",i10)') af_t
    if(af_t > 1) stop ' ! illegal af_t value'
    call m_CtrlP_set_af(af_t)
    if(ipri >= 2 .and. paramset) write(nfout,'(" !! af_t (after m_CtrlP_set_af) = " ,i6)') af_t

!!$    if(ipri >= 0 .and. printable) then
    if((.not.paramset .and. ipri >= 3 ) .or. (paramset .and. ipri >= 0 .and. printable)) then
       write(nfout,*) ' << rltv, altv >>'
       write(nfout,'(3f8.4,11x,3f8.4)') &
            & ((rltv(i,j),j=1,3),(altv(i,j),j=1,3),i=1,3)
    endif
    if(paramset) then
       nopr = iopr
       goto 1001
    end if

    call tau_in_PUCV()

!!$    if(ipri>=1) call wd_op_and_tau()

1001 continue

!! --------------- supercell (redundant space-group) -------------
!  transfered by T. Yamasaki from a revised subroutine of fd_symmetry by Usami-san
!                                                          March 2014

!!$    call gnrt_operators_for_supsercell()

!! ---------------------------------------------------------------    

    call tstatc0_end(id_sname)
#ifdef __TIMER_SUB__
  call timer_end(1227)
#endif
  contains
    subroutine wd_op_and_tau()
      integer :: no ,i, j, l, k
      write(nfout,*) ' --- Symmetry Operations (CARTS, PUCV) --- (in generator)'
      write(nfout,'(" !! nopr+af = ",i6)') nopr+af

      do no = 1, nopr + af
         do i = 1, 3
            do j = 1, 3
               op_br(i,j) = 0.d0
               do l = 1,3
                  do k = 1,3
                     op_br(i,j) = op_br(i,j) &
                          &           + altv(l,i)*op(l,k,no)*rltv(k,j)
                  enddo
               enddo
               op_br(i,j) = op_br(i,j)/PAI2
            enddo
         enddo
         if( no<= nopr ) then
            if(il<=0 .or. pg_symbol_system == 'hexagonal') then
               write(nfout,*) ' #symmetry op. = ', no, d6h_symbol(ig01(no))
            else
               write(nfout,*) ' #symmetry op. = ', no, oh_symbol(ig01(no))
            end if
         else
            if(il<=0 .or. pg_symbol_system == 'hexagonal') then
               write(nfout,*) ' #symmetry op. = ', no, d6h_symbol(iaf)
            else
               write(nfout,*) ' #symmetry op. = ', no, oh_symbol(iaf)
            end if
         end if
         
         do i = 1, 3
            write(nfout,'(4f8.4,3x,4f8.4)') &
                 &           (op   (i,j,no),j=1,3),tau(i,no,CARTS) &
                 &          ,(op_br(i,j),j=1,3),tau(i,no,BUCS)
         enddo
      end do
    end subroutine wd_op_and_tau

    subroutine iopr_op_tau(af_t)  ! --> iopr,af,op,tau 
      integer, intent(out) :: af_t
      integer ::              ipri_spg_t

      af_t = 0

      if(paramset) then
! ====================================== modified by K. Tagami ============ 12.0A
!         call gnrt_op_paramset(il,ngen,inv,igen,jgen,imag,iaf,jaf,a,b,c,ca,cb,cc &
!              &        ,nfout,iopr,af_t,nbztyp_spg,ig01) !-(b_Crystal_Structure)

         call gnrt_op_paramset( il, ngen, inv, igen, jgen, imag, iaf, jaf, &
              &                 a, b, c, ca, cb, cc, &
              &                 nfout, iopr, af_t, nbztyp_spg, ig01, &
              &                 use_altv_rltv, altv, rltv,&
              &                 gen_name_in_carts )
                                                      !-(b_Crystal_Structure)
! ========================================================================== 12.0A
      else
         ipri_spg_t = ipri_spg
         if(nbztyp < 2) then
            iopr = 1
            op = 0.d0
            tau = 0.d0
            op(1,1,iopr) = 1.d0
            op(2,2,iopr) = 1.d0
            op(3,3,iopr) = 1.d0
         end if
!-----  nbztype =100 & 101   - by Tsuyoshi Miyazaki '94.8.16
!      read operation matrix and k-point from the files
!        1.opgr.data  : operation matrix
!        2.matrix.BP  : transformation matrix from
!                       Bravais lattice to Primitive lattice
!        3.kpoint.dat : irreducible k-point
!      these files can be made by using Dr Hamada-san's code
!     (these files must be located at the working directory)

! ====================================== modified by K. Tagami ============ 12.0A
!         call gnrt_op_n(il,ngen,inv,igen,jgen,imag,iaf,jaf,a,b,c,ca,cb,cc &
!              &        ,nopr+af,altv,nfout,iopr,op,tau, af_t, nbztyp_spg,ipri_spg_t,ig01) !-(b_Crystal_Structure)
!
         call gnrt_op_n( il, ngen, inv, igen, jgen, imag, iaf, jaf, &
              &          a, b, c, ca, cb, cc, &
              &          nopr+af, altv, nfout, iopr, op, tau, af_t, &
              &          nbztyp_spg, ipri_spg_t, ig01, &
              &          use_altv_rltv, rltv, &
              &          gen_name_in_carts ) 
                                          !-(b_Crystal_Structure)
! ============================================================================= 12.0A
      endif

    end subroutine iopr_op_tau

    subroutine tau_in_PUCV
      integer i, no
      do i = 1, 3
         do no = 1, iopr + af
            tau(i,no,BUCS) = (rltv(1,i)*tau(1,no,CARTS) &
                 &     +      rltv(2,i)*tau(2,no,CARTS) &
                 &     +      rltv(3,i)*tau(3,no,CARTS))/PAI2
         enddo
      enddo
    end subroutine tau_in_PUCV
  end subroutine m_CS_gnrt_symmetry_operations

  ! ---------- 
  subroutine m_CS_gnrt_symm_operators_tl(paramset,nfout)
    logical, intent(in) :: paramset
    integer, intent(in) :: nfout
    integer ::             i, j, ip
    integer ::             af_t
    integer ::             id_sname = -1

    if(sw_supercell_symmetry == OFF) return

    call tstatc0_begin('m_CS_gnrt_symm_operators_tl ',id_sname)
! -----  op, tau

!!$    if(printable .and. paramset) then
       write(nfout,'(" ngen_tl = ", i6)') ngen_tl
       do ip = 1, ngen_tl
          write(nfout,'(" jgen_tl = ",6i5)') jgen_tl(1:2,1,ip), jgen_tl(1:2,2,ip), jgen_tl(1:2,3,ip)
       end do
!!$    end if
    if(paramset) goto 1001

    call op_tau_tl()  ! depends on 'paramset'
    call tau_in_CARTS()

    if(ipri>=1) call wd_op_and_tau()

1001 continue

    call tstatc0_end(id_sname)
  contains
    subroutine wd_op_and_tau()
      integer :: no ,i, j, l, k
      real(kind=DP),dimension(3,3) :: op_br

      write(nfout,*) ' --- SC Symmetry Operations (CARTS, PUCV) --- (in m_CS_gnrt_symm_operators_tl)'
      write(nfout,'(" !! ngen_tl = ",i6)') ngen_tl

      do no = 1, ngen_tl
         do i = 1, 3
            do j = 1, 3
               op_br(i,j) = 0.d0
               do l = 1,3
                  do k = 1,3
                     op_br(i,j) = op_br(i,j) &
                          &           + altv(l,i)*op_tl(l,k,no)*rltv(k,j)
                  enddo
               enddo
               op_br(i,j) = op_br(i,j)/PAI2
            enddo
         enddo
         if(il<=0 .or. pg_symbol_system == 'hexagonal') then
            write(nfout,*) ' #symmetry op. = ', no, d6h_symbol(ig01(1))
         else
            write(nfout,*) ' #symmetry op. = ', no, oh_symbol(ig01(1))
         end if
         do i = 1, 3
            write(nfout,'(4f8.4,3x,4f8.4)') &
                 &           (op_tl(i,j,no),j=1,3),tau_tl(i,no,CARTS) &
                 &          ,(op_br(i,j),j=1,3),tau_tl(i,no,BUCS)
         enddo
      end do
    end subroutine wd_op_and_tau

    subroutine op_tau_tl()  ! --> op,tau 
      integer ::              i

      if(ngen_tl < 1) return

      op_tl = 0.d0
      do i = 1, ngen_tl
         op_tl(1,1,i) = 1.d0
         op_tl(2,2,i) = 1.d0
         op_tl(3,3,i) = 1.d0
         tau_tl(1,i,BUCS) = dble(jgen_tl(1,1,i))/dble(jgen_tl(2,1,i))
         tau_tl(2,i,BUCS) = dble(jgen_tl(1,2,i))/dble(jgen_tl(2,2,i))
         tau_tl(3,i,BUCS) = dble(jgen_tl(1,3,i))/dble(jgen_tl(2,3,i))
      end do
    end subroutine op_tau_tl

    subroutine tau_in_CARTS
      integer i, no
      if(ngen_tl < 1) return
      do i = 1, 3
         do no = 1, ngen_tl
            tau_tl(i,no,CARTS) = (altv(i,1)*tau_tl(1,no,BUCS) &
                 &     +          altv(i,2)*tau_tl(2,no,BUCS) &
                 &     +          altv(i,3)*tau_tl(3,no,BUCS))
         enddo
      enddo
    end subroutine tau_in_CARTS
  end subroutine m_CS_gnrt_symm_operators_tl

! ================================== modified by K. Tagami ========== 11.0Ex
  subroutine m_CS_op_in_PUCV(nfout,op_br, n, print_flag, comment )
! =================================================================== 11.0Ex
    integer, intent(in) :: nfout, n
    real(kind=DP), intent(out), dimension(3,3,n) :: op_br

! ================================== added by K. Tagami ========== 11.0Ex
    logical, optional, intent(in) :: print_flag
    character(len=*), optional, intent(in) :: comment
!
    logical :: print_go_flag
! =================================================================== 11.0Ex
    integer :: i,j,l,k,no
    op_br = 0.d0
! ================================== added by K. Tagami ========== 11.0Ex
    print_go_flag = .true.
    if ( present(print_flag) ) then
       print_go_flag = print_flag
    endif
! =================================================================== 11.0Ex

    if ( iprisym >=2 ) symmetry_not_printed = .true.
!!    if ( noncol ) symmetry_not_printed = .true.

! ================================== modified by K. Tagami ========== 11.0Ex
    if(ipri >= 1 .and. print_go_flag .and. symmetry_not_printed) then
       if ( present(comment) ) then
          write(nfout,*) comment
       endif
       write(nfout,*) ' --- Symmetry Operations (CARTS, PUCV) --- (m_CS_op_in_PUCV)'
       write(nfout,'(" !! nopr+af, n = ",2i6)') nopr+af,n
    end if
! ==================================================================== 11.0Ex

    do no = 1, nopr + af
       do i = 1, 3
          do j = 1, 3
             op_br(i,j,no) = 0.d0
             do l = 1,3
                do k = 1,3
                   op_br(i,j,no) = op_br(i,j,no) &
                        &           + altv(l,i)*op(l,k,no)*rltv(k,j)
                enddo
             enddo
             op_br(i,j,no) = op_br(i,j,no)/PAI2
          enddo
       enddo

! ================================== modified by K. Tagami ========== 11.0Ex
!       if(ipri >= 1 .and. printable) then
       if(ipri >= 1 .and. printable .and. print_go_flag .and. symmetry_not_printed) then
! ==================================================================== 11.0Ex
! ================================= Added by K. Tagami =============
          if( no<= nopr ) then
! ==================================================================
             if(il<=0 .or. pg_symbol_system == 'hexagonal') then
                write(nfout,*) ' #symmetry op. = ', no, d6h_symbol(ig01(no))
             else
                write(nfout,*) ' #symmetry op. = ', no, oh_symbol(ig01(no))
             end if
          else
             if(il<=0 .or. pg_symbol_system == 'hexagonal') then
                write(nfout,*) ' #symmetry op. = ', no, d6h_symbol(iaf)
             else
                write(nfout,*) ' #symmetry op. = ', no, oh_symbol(iaf)
             end if
          end if
          do i = 1, 3
             write(nfout,'(4f8.4,3x,4f8.4)') &
                  &           (op   (i,j,no),j=1,3),tau(i,no,CARTS) &
                  &          ,(op_br(i,j,no),j=1,3),tau(i,no,BUCS)
          enddo
       endif
    enddo
    if(ipri >= 1.and.printable.and.print_go_flag.and.symmetry_not_printed) symmetry_not_printed = .false.
  end subroutine m_CS_op_in_PUCV


! ================================== modified by K. Tagami ========== 11.0Ex
  subroutine m_CS_op_in_PUCD(nfout,op_pr, n, print_flag, comment )
! =================================================================== 11.0Ex

    integer, intent(in) :: nfout, n
    real(kind=DP), intent(out), dimension(3,3,n) :: op_pr
      
! ================================== added by K. Tagami ========== 11.0Ex
    logical, optional, intent(in) :: print_flag
    character(len=*), optional, intent(in) :: comment
!
    logical :: print_go_flag
! =================================================================== 11.0Ex

    integer :: i,j,l,k,no

    op_pr = 0.d0

! ================================== added by K. Tagami ========== 11.0Ex
    print_go_flag = .true.
    if ( present(print_flag) ) then
       print_go_flag = print_flag
    endif
! =================================================================== 11.0Ex

! ================================== modified by K. Tagami ========== 11.0Ex
    if(ipri >= 1 .and. print_go_flag .and. symmetry_not_printed) then
       if ( present(comment) ) then
           write(nfout,*) comment
       endif
       write(nfout,*) ' --- Symmetry Operations (CARTS, PUCD) ---'
       write(nfout,'(" !! nopr+af, n = ",2i6)') nopr+af,n
    end if
! ==================================================================== 11.0Ex

    do no = 1, nopr + af
       do i = 1, 3
          do j = 1, 3
             op_pr(i,j,no) = 0.d0
             do l = 1,3
                do k = 1,3
                   op_pr(i,j,no) = op_pr(i,j,no) &
                        &           + rltv(l,i)*op(l,k,no)*altv(k,j)
                enddo
             enddo
             op_pr(i,j,no) = op_pr(i,j,no)/PAI2
          enddo
       enddo

! ================================== modified by K. Tagami ========== 11.0Ex
!       if(ipri >= 1) then
       if(ipri >= 1 .and. print_go_flag .and. symmetry_not_printed) then
! ==================================================================== 11.0Ex
          write(nfout,*) ' #symmetry op. = ', no
          do i = 1, 3
             write(nfout,'(4f8.4,3x,4f8.4)') &
                  &           (op   (i,j,no),j=1,3),tau(i,no,CARTS) &
                  &          ,(op_pr(i,j,no),j=1,3),tau(i,no,BUCS)
          enddo
       endif
    enddo
    if(ipri >= 1.and.print_go_flag.and.symmetry_not_printed) symmetry_not_printed=.false.
  end subroutine m_CS_op_in_PUCD

  subroutine m_CS_gnrt_tmatrices(il)
! This subroutine was coded by BETSUYAKU, K. (Fuji Research Institute Co., Ltd.), July 2003

    integer,       intent(in)    :: il
    real(kind=DP)                :: unimat(3,3) = 0.d0
    real(kind=DP), parameter     :: one=1.d0, half=0.5d0, &
         &                          one3rd = 0.33333333333333333d0, &
         &                          two3rd = 0.66666666666666667d0, &
         &                          epsilon = 1.d-10
    integer                      :: ido, jdo

    b2pmat(1,1) = one ; b2pmat(2,2) = one ; b2pmat(3,3) = one
    p2bmat(1,1) = one ; p2bmat(2,2) = one ; p2bmat(3,3) = one

    if (il == -1) then                  ! Trigonal

       b2pmat(1,1) =  two3rd ; b2pmat(1,2) =  one3rd ; b2pmat(1,3) =  one3rd
       b2pmat(2,1) = -one3rd ; b2pmat(2,2) =  one3rd ; b2pmat(2,3) =  one3rd
       b2pmat(3,1) = -one3rd ; b2pmat(3,2) = -two3rd ; b2pmat(3,3) =  one3rd

       p2bmat(1,1) =  one ; p2bmat(1,2) = -one ; p2bmat(1,3) = 0.d0
       p2bmat(2,1) = 0.d0 ; p2bmat(2,2) =  one ; p2bmat(2,3) = -one
       p2bmat(3,1) =  one ; p2bmat(3,2) =  one ; p2bmat(3,3) =  one

    else if (il == 0) then              ! Primitive (Hexagonal)
    else if (il == 1) then              ! Primitive
    else if (il == 2) then              ! Face-centered

       b2pmat(1,1) =  0.d0  ;   b2pmat(1,2) =  half  ;   b2pmat(1,3) =  half
       b2pmat(2,1) =  half  ;   b2pmat(2,2) =  0.d0  ;   b2pmat(2,3) =  half
       b2pmat(3,1) =  half  ;   b2pmat(3,2) =  half  ;   b2pmat(3,3) =  0.d0

       p2bmat(1,1) = -one ;  p2bmat(1,2) =  one ;  p2bmat(1,3) =  one
       p2bmat(2,1) =  one ;  p2bmat(2,2) = -one ;  p2bmat(2,3) =  one
       p2bmat(3,1) =  one ;  p2bmat(3,2) =  one ;  p2bmat(3,3) = -one

    else if (il == 3) then              ! Body-centered

       b2pmat(1,1) = -half  ;   b2pmat(1,2) =  half  ;   b2pmat(1,3) =  half
       b2pmat(2,1) =  half  ;   b2pmat(2,2) = -half  ;   b2pmat(2,3) =  half
       b2pmat(3,1) =  half  ;   b2pmat(3,2) =  half  ;   b2pmat(3,3) = -half

       p2bmat(1,1) =  0.d0 ; p2bmat(1,2) =  one  ; p2bmat(1,3) =  one
       p2bmat(2,1) =  one  ; p2bmat(2,2) =  0.d0 ; p2bmat(2,3) =  one
       p2bmat(3,1) =  one  ; p2bmat(3,2) =  one  ; p2bmat(3,3) =  0.d0

    else if (il == 4) then              ! Base-centered

       b2pmat(1,1) =  half  ;   b2pmat(1,2) = -half  ;   b2pmat(1,3) =  0.d0
       b2pmat(2,1) =  half  ;   b2pmat(2,2) =  half  ;   b2pmat(2,3) =  0.d0
       b2pmat(3,1) =  0.d0  ;   b2pmat(3,2) =  0.d0  ;   b2pmat(3,3) =  one

       p2bmat(1,1) =  one  ; p2bmat(1,2) =  one  ; p2bmat(1,3) =  0.d0
       p2bmat(2,1) = -one  ; p2bmat(2,2) =  one  ; p2bmat(2,3) =  0.d0
       p2bmat(3,1) =  0.d0 ; p2bmat(3,2) =  0.d0 ; p2bmat(3,3) =  one

    else
       if(printable) write(6,*) 'The value of il is invalid. il =', il
       stop
    end if

    unimat = matmul(b2pmat,p2bmat)
    do ido = 1, 3
       do jdo = 1, 3
          if (ido == jdo) then
             if ((unimat(ido,jdo)-one) > epsilon) stop 'not unit matrix'
          else
             if (unimat(ido,jdo) > epsilon) stop 'not unit matrix'
          end if
       end do
    end do

  end subroutine m_CS_gnrt_tmatrices

  subroutine m_CS_phonon_symmetry(on_or_off)
    use m_Files, only : nfout
    integer, intent(in) :: on_or_off
    integer :: i

    if(on_or_off == ON) then
       nopr = phonon_nopr
       if(printable) then
          do i=1,nopr
             write(nfout,'(i2)') i
             write(nfout,'(3(1x,f10.5),2x,f10.5)') op(1,1:3,i),tau(1,i,CARTS)
             write(nfout,'(3(1x,f10.5),2x,f10.5)') op(2,1:3,i),tau(2,i,CARTS)
             write(nfout,'(3(1x,f10.5),2x,f10.5)') op(3,1:3,i),tau(3,i,CARTS)
          end do
       end if
    else
       phonon_nopr = nopr
       nopr = 1
       ngen = 1 
       igen(ngen)=1
       jgen(1,1:3,ngen) = 0
       jgen(2,1:3,ngen) = 1
    end if

  end subroutine m_CS_phonon_symmetry

  subroutine set_strain_tensor()
    integer :: iret
    integer :: f_getRealValue
    real(kind=DP) :: val

    if(f_getRealValue( "e11", val, '') == 0) strain(1,1) = val
    if(f_getRealValue( "e12", val, '') == 0) strain(1,2) = val
    if(f_getRealValue( "e13", val, '') == 0) strain(1,3) = val
    if(f_getRealValue( "e21", val, '') == 0) strain(2,1) = val
    if(f_getRealValue( "e22", val, '') == 0) strain(2,2) = val
    if(f_getRealValue( "e23", val, '') == 0) strain(2,3) = val
    if(f_getRealValue( "e31", val, '') == 0) strain(3,1) = val
    if(f_getRealValue( "e32", val, '') == 0) strain(3,2) = val
    if(f_getRealValue( "e33", val, '') == 0) strain(3,3) = val

  end subroutine set_strain_tensor

  subroutine set_strained_cell(avec,bvec,cvec)
    real(kind=DP), intent(inout), dimension(3) :: avec,bvec,cvec

    integer :: i,j
    real(kind=DP), dimension(3) :: avec0,bvec0,cvec0

    avec0 = avec; bvec0 = bvec; cvec0 = cvec
    do i=1,3
       do j=1,3
          avec(i) = avec(i) + strain(i,j)*avec0(j)
          bvec(i) = bvec(i) + strain(i,j)*bvec0(j)
          cvec(i) = cvec(i) + strain(i,j)*cvec0(j)
       end do
    end do

  end subroutine set_strained_cell

  subroutine m_CS_supercell(nfout)
    integer, intent(in) :: nfout
    integer :: i,j,k,n,l
    real(kind=DP) :: bltv(3,3)
    
    if(sw_supercell == ON) then
       if(supercell_unit_type == BRAVAIS) then
          do j=1,3
             do i=1,3
                bltv(i,j) = sum(altv(i,1:3)*p2bmat(j,1:3))
             end do
          end do
       else ! PRIMITIVE
          bltv = altv
       end if
       altv_super(1:3,1) = n1_sc*bltv(1:3,1)
       altv_super(1:3,2) = n2_sc*bltv(1:3,2)
       altv_super(1:3,3) = n3_sc*bltv(1:3,3)
       call altv_2_rltv(altv_super,rltv_super,univol_super,rvol_super)  ! in b_CS
       if(printable) then
          write(nfout,'("rltv_super",28x,"altv_super")') 
          do i=1,3
             write(nfout,'(3(1x,f10.5),2x,3(1x,f10.5))') rltv_super(i,1:3), altv_super(i,1:3) 
          end do
       end if

       altv_prim = altv
       rltv_prim = rltv
       univol_prim = univol
       rvol_prim = rvol

       altv = altv_super
       rltv = rltv_super
       univol = univol_super
       rvol = rvol_super

       if(il<=1.or.supercell_unit_type==PRIMITIVE) then
          ! trigonal, hexagonal, primitive
          nlpnt = n1_sc*n2_sc*n3_sc
       else if(il==2) then ! facecentered
          nlpnt = n1_sc*n2_sc*n3_sc*4
       else if(il==3.or.il==4) then ! bodycentered, basecentered
          nlpnt = n1_sc*n2_sc*n3_sc*2
       end if
       allocate(lpnt(nlpnt,3))
       n = 0
       do k=0,n3_sc-1
          do j=0,n2_sc-1
             do i=0,n1_sc-1
                if(il<=1.or.supercell_unit_type==PRIMITIVE) then
                ! trigonal, hexagonal, primitive
                   n = n + 1
                   lpnt(n,1:3) = bltv(1:3,1)*i+bltv(1:3,2)*j+bltv(1:3,3)*k
                else if(il==2) then ! facecentered
                   n = n + 4
                   lpnt(n-3,1:3) = bltv(1:3,1)*i+bltv(1:3,2)*j+bltv(1:3,3)*k
                   lpnt(n-2,1:3) = lpnt(n-3,1:3)+0.5d0*(bltv(1:3,2)+bltv(1:3,3))
                   lpnt(n-1,1:3) = lpnt(n-3,1:3)+0.5d0*(bltv(1:3,1)+bltv(1:3,3))
                   lpnt(n  ,1:3) = lpnt(n-3,1:3)+0.5d0*(bltv(1:3,1)+bltv(1:3,2))
                else if(il==3) then ! bodycentered
                   n = n + 2
                   lpnt(n-1,1:3) = bltv(1:3,1)*i+bltv(1:3,2)*j+bltv(1:3,3)*k
                   lpnt(n  ,1:3) = lpnt(n-1,1:3)+0.5d0*(bltv(1:3,1)+bltv(1:3,2)+bltv(1:3,3))
                else if(il==4) then ! basecentered
                   n = n + 2
                   lpnt(n-1,1:3) = bltv(1:3,1)*i+bltv(1:3,2)*j+bltv(1:3,3)*k
                   lpnt(n  ,1:3) = lpnt(n-1,1:3)+0.5d0*(bltv(1:3,1)+bltv(1:3,2))
                end if
             end do
          end do
       end do

    end if
  end subroutine m_CS_supercell

  subroutine m_CS_supercell_on(nfout,uc_type,n1,n2,n3)
    integer, intent(in) :: nfout,uc_type,n1,n2,n3
    sw_supercell = ON
    supercell_unit_type = uc_type
    n1_sc = n1
    n2_sc = n2
    n3_sc = n3
    if(printable) write(nfout,'("supercell_on: uc_type,n1,n2,n3=",4i4)') uc_type,n1,n2,n3
  end subroutine m_CS_supercell_on

  subroutine m_CS_set_altv_prim
    altv = altv_prim
    rltv = rltv_prim
    univol = univol_prim
    rvol = rvol_prim
  end subroutine m_CS_set_altv_prim

  subroutine m_CS_set_altv_super
    altv = altv_super
    rltv = rltv_super
    univol = univol_super
    rvol = rvol_super
  end subroutine m_CS_set_altv_super

  subroutine m_CS_set_inv_sym_off()
    inversion_symmetry = OFF
  end subroutine m_CS_set_inv_sym_off

  subroutine m_CS_dealloc(neb_mode)
    logical, intent(in), optional :: neb_mode
    logical :: neb
    neb = .false.

! === KT_add === 13.1R
    if ( sw_keep_symmetry_strict == ON ) call m_CS_save_op_tau
! ============== 13.1R

    if(present(neb_mode)) neb = neb_mode
    if(allocated(op)) deallocate(op)
    if(allocated(tau)) deallocate(tau)
    if(.not.neb)then
       if(allocated(igen)) deallocate(igen)
       if(allocated(jgen)) deallocate(jgen)
       if(allocated(lpnt)) deallocate(lpnt)
       if(allocated(jgen_tl)) deallocate(jgen_tl)
    endif
    if(allocated(op_tl)) deallocate(op_tl)
    if(allocated(tau_tl)) deallocate(tau_tl)
  end subroutine m_CS_dealloc

! === KT_add == 13.1R
  subroutine m_CS_dealloc_op_tau
    if(allocated(op)) deallocate(op)
    if(allocated(tau)) deallocate(tau)
  end subroutine m_CS_dealloc_op_tau

  subroutine m_CS_save_op_tau
    if ( .not. allocated( op_previous ) )  allocate( op_previous( 3,3,nopr+af) )
    if ( .not. allocated( tau_previous ) ) allocate( tau_previous(3,nopr+af,CRDTYP) )
    nopr_previous = nopr;    op_previous = op;     tau_previous = tau
  end subroutine m_CS_save_op_tau

  subroutine m_CS_read_op_tau_previous
    integer :: iopr, i, j

    if ( sw_keep_symmetry_strict == OFF) return

    nopr = nopr_previous  
    if ( .not. allocated( op ) )  allocate( op( 3,3,nopr+af) )
    if ( .not. allocated( tau ) ) allocate( tau(3,nopr+af,CRDTYP) )

    op = op_previous;     tau = tau_previous

    do iopr=1, nopr +af
       do i=1, 3
          tau(i,iopr,CARTS) = altv(1,i)*tau(1,iopr,BUCS) &
               &     +      altv(2,i)*tau(2,iopr,BUCS) &
               &     +      altv(3,i)*tau(3,iopr,BUCS)
       enddo
    enddo

#if 0
    Do iopr=1, nopr
       write(800+mype,*) 'iopr = ', iopr
       Do i=1, 3
          write(800+mype,*) tau( i,iopr,CARTS), tau_previous( i,iopr, CARTS )
       End do
    End do
#endif

  end subroutine m_CS_read_op_tau_previous
! ============== 13.1R

! ======================== added by K. Tagami ==================== 12.0YAM
  subroutine check_if_sw_inversion_is_valid( nfout )
    integer, intent(in) :: nfout

    integer :: iopr

    real(kind=DP), parameter :: eps = 1.d-4
    real(kind=DP) :: c1

    logical :: Flag_inverse, sw_inversion_is_valid

    if ( inversion_symmetry == OFF ) return

    Flag_inverse = .false.
    sw_inversion_is_valid = .false.

    Do iopr=1, nopr
       if ( abs(op(1,1,iopr)+1.d0) < eps .and. &
            & abs(op(2,2,iopr)+1.d0) < eps .and. &
            & abs(op(3,3,iopr)+1.d0) < eps .and. &
            & abs(op(1,2,iopr)) < eps .and. &
            & abs(op(2,1,iopr)) < eps .and. &
            & abs(op(2,3,iopr)) < eps .and. &
            & abs(op(3,2,iopr)) < eps .and. &
            & abs(op(3,1,iopr)) < eps .and. &
            & abs(op(1,3,iopr)) < eps ) then

          Flag_inverse = .true.
       end if
!
       if ( Flag_inverse ) then
          c1 = abs( tau(1,iopr,BUCS) ) + abs( tau(2,iopr,BUCS) ) &
               &                       + abs( tau(3,iopr,BUCS) )
          if ( c1 < eps ) then
             sw_inversion_is_valid = .true.
          endif
          exit
       endif

    End do
! -------
    if ( sw_inversion_is_valid ) then
       write(nfout,*) '********************************************************'
       write(nfout,*) '******** Confirmed that sw_inversion is avalibale *****'
       write(nfout,*) '********************************************************'
    else
       if ( Flag_inverse ) then
          write(nfout,*) '********************************************************'
          write(nfout,*) '*   sw_inversion is invalid in this system !! '
          write(nfout,*) '*   Translation vector is non-zero for inversion operation'
          write(nfout,*) '********************************************************'
       else
          write(nfout,*) '********************************************************'
          write(nfout,*) '*   sw_inversion is invalid in this system !! '
          write(nfout,*) '*   Inversion operation does not exist'
          write(nfout,*) '********************************************************'
       endif
       stop
    endif

  end subroutine check_if_sw_inversion_is_valid
! ================================================================ 12.0YAM

  subroutine m_CS_wd_BandSymInput(ipri,nfout,nf)
    integer, intent(in) :: ipri, nfout, nf
    character :: TF_inversion_symmetry ! {'T'|'F'}
    integer :: i, j
    integer :: id_sname = -1
    call tstatc0_begin('m_CS_wd_BandSymInput ',id_sname)
    if(mype == 0) then
       write(nf,'("##CRYSTAL_DATA")')
       write(nf,'("#LATTICE_SYSTEM")')
       if(inversion_symmetry == 0) TF_inversion_symmetry = 'F'
       if(inversion_symmetry == 1) TF_inversion_symmetry = 'T'
       write(nf,'(a,3x,a,3x,"! System{Rhombo|Hexa|Primitive|FCC|BCC|CBaseCentered},InversionSymmetry"/,"#")') &
            & Char_lattice_system(il), TF_inversion_symmetry

       write(nf,'("#GENERATORS")')
       write(nf,'(7(i0,1x))') (igen(i),(jgen(1,j,i),jgen(2,j,i),j=1,3),i=1,ngen);  write(nf,'("#")')

       write(nf,'("#BRAVAIS_LATTICE_PARAMETER"/,3f22.6," ! a,b,c"/,3f22.6," ! alpha,beta,gamma"/"#")') &
            & Bravais_lattice_length, Bravais_lattice_angle

       write(nf,'("#PRIMITIVE_LATTICE_PARAMETER",3(/,3f11.5,4x,3f11.5," ! rltv, altv"),/"#")') &
            &          ((rltv(i,j),j=1,3),(altv(i,j),j=1,3),i=1,3)
       write(nf,'("##"/)')
    end if
    call tstatc0_end(id_sname)
  end subroutine m_CS_wd_BandSymInput

end module m_Crystal_Structure

!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 485 $)
!
!  MODULE: m_ES_ExactExchange
!
!  AUTHOR(S): T. Yamamoto   November/22/2009
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!

module m_ES_ExactExchange
  use m_Electronic_Structure,only: totch,zaj_l,occup_l,neordr,eko_l,vnlph_l,fsr_l,fsi_l
  use m_NonLocal_Potential, only : snl
  use m_PlaneWaveBasisSet,  only : ngabc,igf,kg1,kg,kgp,nbase,nbmx,iba,m_pwBS_kinetic_energies &
       &                         , nbase_gamma,igfp_l,ngpt_l,m_pwBS_sphrp_exx,kgp_exx, igfp_exx, n_rGpv
  use m_Kpoints,            only : kv3,vkxyz,kv3_ek,vkxyz_ek,k_symmetry,qwgt,qwgt_ek,mp_index &
       &                         , m_Kp_sample_mesh, kshift
  use m_FFT,                only : nfft,fft_box_size_WF &
       &                         , m_FFT_alloc_WF_work &
       &                         , m_FFT_dealloc_WF_work &
       &                         , m_FFT_WF, fft_box_size_CD, m_FFT_CD0 &
       &                         , m_FFT_CD0_exx &
       &                         , nfftp_exx_nonpara, fft_box_size_CD_exx
  use m_Ionic_System,       only : zeta1, qex, iatom, ntyp, natm, ityp, pos, iwei, napt
  use m_PseudoPotential,    only : qitg_l, iqitg, nqitg, m_PP_include_vanderbilt_pot &
       &                         , ilmt,iqitg,nloc,ntau,ival,isph,il2p,dl2p,modnrm &
       &                         , nlmta,lmta,lmtt,ltp,mtp,taup,nloc,m_PP_find_maximum_l &
       &                         , m_PP_tell_lmtt_l_m_tau &
       &                         , m_PP_set_index_arrays1,m_PP_set_index_arrays2 &
       &                         , radr,xh,rmax,nmesh,mmesh, qrspspw, nlmtt
 
  use m_Files,              only : nfout
  use m_Timing,             only : tstatc0_begin,tstatc0_end
  use m_Control_Parameters, only : nspin,ipri,kimg,neg,printable,af,ekmode &
       &                         , alpha_exx,omega_exx,sw_screened_exchange  &
       &                         , sw_singular_correction,reduction_factor_exx &
       &                         , way_ksample,m_CtrlP_cachesize,sw_rspace_hyb &
       &                         , sw_precalculate,sw_rsb,potential_update 
  use m_Crystal_Structure,  only : univol,altv,rltv,nopr,tau,op
  ! nopr : # of operations
  ! tau  : nonprimitive translation vector
  ! op   : rotation matrix in real space 
  use m_Const_Parameters,   only : DP, CMPLDP, SKIP, EXECUT, ON, OFF, DIRECT, INVERSE, DELTA, DELTA10 &
       &                         , DELTA07, PAI2, PAI4, PAI, ELECTRON, GAMMA, BUCS &
       &                         , MONKHORST_PACK, MESH
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,nrank_k,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,mpi_e_world,myrank_k,map_k,ista_k,iend_k &
       &                         , ista_kg1_k, np_kg1_k, mp_kg1_k &
!       &                         , m_Parallel_mpi_nval,np_nval, mp_nval,ista_kngp_exx,iend_kngp_exx &
       &                         , ista_kngp_exx,iend_kngp_exx &
#ifdef TRANSPOSE
       &                         , ierr,mp_e,nis_e,nie_e,nel_e
#else
       &                         , ierr,mp_e,nel_e
#endif

! ============================ KT_Test ================================ 12.5Exp
  use m_Control_Parameters,    only : nmax_G_hyb
  use m_PlaneWaveBasisSet,     only : kgp, kg1, kg
! ===================================================================== 12.5Exp

  use m_Realspace, only : nmesh_rs_aug_max,nmesh_rs_aug,meshx_rs_aug,meshy_rs_aug,meshz_rs_aug,meshxyz_rs_aug &
  & , qr_clm_ylm,dqr_clm_ylm,plmt1,plmt2,nlmtpair
  use m_ES_RSB, only : overlap,m_ES_RSB_unitary_transform_wf,m_ES_RSB_unitary_transform_vec,m_ES_RSB_alloc,m_ES_RSB_doit

  implicit none

  integer :: sw_update_wfv = ON
  integer :: nval
  integer :: nval_old
  integer :: nfftwf
  integer :: ntrs ! ntrs = 1, if TRS is used. Otherwise, ntrs=0
  integer, allocatable :: ngpt_exx(:,:,:) ! d(kg,nopr,0:ntrs)
#ifndef MEMORY_SAVE_EXX
  real(kind=DP), allocatable :: qitg_exx(:,:,:) ! d(kgp,nqitg,nqmk)
  real(kind=DP), allocatable :: ylm_exx(:,:,:) ! d(kgp,maxylm,nqmk)
#else
#ifndef MEMORY_SAVE_MORE_EXX
  real(kind=DP), allocatable :: qitg_exx(:,:,:) ! d(kgp,nqitg,nqmk)
#else
  real(kind=DP), allocatable :: qitg_exx(:,:) ! d(kgp,nqitg)
#endif
  real(kind=DP), allocatable :: ylm_exx(:,:) ! d(kgp,maxylm)
#endif
  real(kind=DP), allocatable :: vc(:,:) ! d(kgp,nqmk)
  real(kind=DP), allocatable :: wfv(:,:,:,:) ! d(kg1,nval,kv3,kimg)
  real(kind=DP), allocatable :: wfv_old(:,:,:,:) ! d(kg1,nval_old,kv3,kimg)
  real(kind=DP), allocatable :: fsr_exx(:,:,:) ! d(nval,nlmta,kv3)
  real(kind=DP), allocatable :: fsi_exx(:,:,:) ! d(nval,nlmta,kv3)
  real(kind=DP), allocatable :: fsr_exx_old(:,:,:) ! d(nval,nlmta,kv3)
  real(kind=DP), allocatable :: fsi_exx_old(:,:,:) ! d(nval,nlmta,kv3)
  real(kind=DP), allocatable :: occup_val(:,:) ! d(nval,kv3)
  real(kind=DP), allocatable :: occup_val_old(:,:) ! d(nval_old,kv3)
  real(kind=DP), allocatable :: dfsr_exx(:,:,:,:) ! d(nval,nlmta,kv3,3)
  real(kind=DP), allocatable :: dfsi_exx(:,:,:,:) ! d(nval,nlmta,kv3,3)
  real(kind=DP), allocatable :: dfsr_l(:,:,:,:) ! d(np_e,nlmta,ista_k:iend_k,3)
  real(kind=DP), allocatable :: dfsi_l(:,:,:,:) ! d(np_e,nlmta,ista_k:iend_k,3)

  real(kind=DP), allocatable :: wfvtt(:,:,:,:) ! d(kg1,nval,kv3,kimg)
  real(kind=DP), allocatable :: occup_valtt(:,:) ! d(nval,kv3)

  integer :: ikgamma
  logical, allocatable :: qmk_zero(:,:) ! d(kv3bz,kv3)
  logical, allocatable :: qmk_zero2(:) ! d(kv3bz*kv3)
  real(kind=DP), allocatable :: qmk(:,:) !d(kv3bz*kv3,3)
  integer, allocatable :: iqmk(:,:) !d(kv3bz,kv3))
  integer :: nqmk
  integer :: kv3bz

  real(kind=DP), allocatable :: eexx_kb(:,:)
  !
  ! q(BZ) = S*k(IBZ)
  ! 
  ! Symmetry operations in space group:
  !    Os={S|u}
  !    Or={R|t}
  !
  ! Wavefunction coefficient:
  !    c(q,SG) = c(k,G) exp(i(k+G)*t)
  !            = c(k,G) exp(-i(q+SG)*u)
  !
  !    If time reversal symmetry is present,
  !         c(-q,-G) = c*(q,G)
  !
  integer, allocatable :: ikp(:) ! d(kv3bz)
  integer, allocatable :: iops(:) ! d(kv3bz) No. of S_inv = R :  Or={R|t}
  integer, allocatable :: iopt(:) ! d(kv3bz) No. of S         :  Os={S|u}
  integer, allocatable :: itrs(:) ! d(kv3bz) Time reversal symmetry, 0 or 1
  real(kind=DP), allocatable :: vkbz(:,:) ! d(kv3bz,3) k-points in Full BZ
  real(kind=DP), allocatable :: wbz(:) ! d(kv3bz) weight for k-points in Full BZ

  real(kind=DP), allocatable :: oprec(:,:,:) ! d(3,3,nopr) Reciprocal space rotation matrix
  real(kind=DP), allocatable :: opdir(:,:,:) ! d(3,3,nopr) Direct space rotation matrix

  integer :: nface
  integer, allocatable :: iface_bz(:,:) ! d(3,nface)
  integer :: n_bz_mesh(3)

  real(kind=DP), allocatable :: crotylm(:,:,:) ! d(mmax,nsph,nopr)
  integer, allocatable :: iylm(:,:,:) ! d(mmax,nsph,nopr)
  integer, allocatable :: nylm(:,:) ! d(nsph,nopr)
  integer, allocatable :: isph_lmta(:) ! d(nlmta))
  integer, allocatable :: lmta_rot(:,:,:) ! d(mmax,nlmta,nopr))
  integer, allocatable :: ia_lmta(:) !(nlmta)

  logical, save :: preproc_done=.false.
  integer :: n,ibsize,iwidth,maxm
  integer, parameter :: mcritical = 4*2+1
  integer, allocatable :: il3(:)
  integer, allocatable, dimension(:) :: nqitg_sp,nqitg_sp0    
  integer, allocatable, dimension(:) :: iq2l3 ! d(nqitg)
  integer, allocatable, dimension(:,:) :: nc  ! d(maxm,nqitg)
  integer :: mc ! maxval(nc)
  integer, allocatable, dimension(:,:,:) :: nc2lmt1, nc2lmt2, nc2n ! d(mc,maxm,nqitg)


  real(kind=DP), allocatable, dimension(:,:) :: eko_hyb
  real(kind=DP), allocatable, dimension(:,:,:,:,:) :: fsrqm,fsiqm

  real(kind=DP), allocatable, dimension(:,:,:,:) :: exx_potential
#if defined(MEMORY_SAVE_EXX) && defined(MEMORY_SAVE_MORE_EXX)
  integer :: it, lcmax
  integer, allocatable, dimension(:) :: nmm_il3
  integer, allocatable, dimension(:,:) :: mm_il3
  real(kind=DP), allocatable, dimension(:,:) :: qrsps_mm
  real(kind=DP), allocatable, dimension(:) :: h, radr_kept, wos_kept
#endif
  integer, save :: id_sname_cdfft = -1
  include 'mpif.h'                                      ! MPI

contains

! ====================== KT_Test ==================================== 12.5
  subroutine m_ES_EXX_set_nmax_G_hyb
    if ( nmax_G_hyb == 0 ) then
       nmax_G_hyb = kgp
    else if ( nmax_G_hyb == -1 ) then
       nmax_G_hyb = kg
    else if ( nmax_G_hyb == -2 ) then
       nmax_G_hyb = kg /2
    else if ( nmax_G_hyb == -3 ) then
       nmax_G_hyb = kg1
    endif
    if(sw_rspace_hyb==ON) nmax_G_hyb = kgp_exx
    write(nfout,*) 'nmax_G_hyb is set to ', nmax_G_hyb

  end subroutine m_ES_EXX_set_nmax_G_hyb
! ================================================================== 12.5

  subroutine m_ES_EXX_update(on_or_off)
    implicit none
    integer, intent(in) :: on_or_off

    sw_update_wfv = on_or_off
    if(printable) then
       if(sw_update_wfv==ON) then
          write(nfout,'(" EXX: wfv will be updated.")')
       else
          write(nfout,'(" EXX: wfv will be conserved.")')
       end if
    end if
  end subroutine m_ES_EXX_update

  subroutine m_ES_EXX_kbz
    implicit none
    integer :: ik, jk, iopr, i, j, ikbz, jkbz, jtrs
    integer :: i1, i2, i3
    real(kind=DP) :: rkxyz(3), kxyz(3), df(3), ko(3)
    logical :: ltrue
    integer :: g0(3)
    real(kind=DP) :: x(3), y(3)
    real(kind=DP) :: wtot
    real(kind=DP) :: ss(3,3)
    real(kind=DP) :: dk(3)

    allocate(oprec(3,3,nopr))
    do iopr=1,nopr
       do j=1,3
          x = matmul(op(:,:,iopr),rltv(:,j))
          do i=1,3
             y = altv(:,i)
             oprec(i,j,iopr) = dot_product(y,x)/PAI2
          end do
       end do
    end do

    write(nfout,'("k-points in IBZ")')
    write(nfout,'("ik, k1, k2, k3")')
    do ik=1,kv3,nspin
       write(nfout,'(i5,3(1x,f10.5))') (ik-1)/nspin+1, vkxyz(ik,1:3,BUCS)
    end do

    call m_ES_EXX_fbz_faces ! -> iface_bz

    if(kv3/nspin==1) then
       kv3bz = 1
       n_bz_mesh(1:3) = 1
    else
       if(way_ksample == MONKHORST_PACK) then
          n_bz_mesh(1:3) = mp_index(1:3)
       else
          call m_Kp_sample_mesh(n_bz_mesh)
       end if
       kv3bz = n_bz_mesh(1)*n_bz_mesh(2)*n_bz_mesh(3)
    end if

    allocate(vkbz(kv3bz,3))
    allocate(wbz(kv3bz))
    wbz(1:kv3bz) = product(reduction_factor_exx(1:3))/dble(kv3bz)

    ikbz = 0
    do i1=0,n_bz_mesh(1)-1
       do i2=0,n_bz_mesh(2)-1
          do i3=0,n_bz_mesh(3)-1
             rkxyz(1) = (dble(i1) + kshift(1)) / dble(n_bz_mesh(1))  ! USAMI
             rkxyz(2) = (dble(i2) + kshift(2)) / dble(n_bz_mesh(2))
             rkxyz(3) = (dble(i3) + kshift(3)) / dble(n_bz_mesh(3))
             call m_ES_EXX_move_k_into_fbz(rkxyz,ko)
             do ik=1,kv3
                dk(1:3) = vkxyz(ik,1:3,BUCS)-ko(1:3)
                if( abs(dk(1)-nint(dk(1)))<DELTA07 .and. &
                  & abs(dk(2)-nint(dk(2)))<DELTA07 .and. &
                  & abs(dk(3)-nint(dk(3)))<DELTA07 ) then
                  ko(1:3) = vkxyz(ik,1:3,BUCS)
                  exit
                end if
             end do
             ikbz = ikbz + 1
             vkbz(ikbz,1:3) = ko(1:3)
          end do
       end do
    end do

    write(nfout,'("k-points in BZ")')
    write(nfout,'("ikbz k1 k2 k3 wbz")')
    do ikbz=1,kv3bz
       write(nfout,'(i7,4(1x,f20.5))') ikbz, vkbz(ikbz,1:3), wbz(ikbz)
    end do

    allocate(ikp(kv3bz))
    allocate(iops(kv3bz))
    allocate(iopt(kv3bz)); iopt = 0
    allocate(itrs(kv3bz)); itrs = 0

    ! q(bz) = S*k'(ibz)
    do ikbz=1,kv3bz
       ikp(ikbz) = 0
       LOOP_S: do jtrs=0,1
          do iopr=1,nopr
             rkxyz = (1-2*jtrs) * matmul(oprec(:,:,iopr),vkbz(ikbz,1:3))
             do jk=1,kv3,nspin
                dk(1:3) = vkxyz(jk,1:3,BUCS)-rkxyz(1:3)
                if( abs(dk(1)-nint(dk(1)))<DELTA07 .and. &
                  & abs(dk(2)-nint(dk(2)))<DELTA07 .and. &
                  & abs(dk(3)-nint(dk(3)))<DELTA07 ) then
                   g0(1:3) = nint(dk(1:3))
                   ikp(ikbz) = jk
                   iops(ikbz) = iopr
                   itrs(ikbz) = jtrs
                  exit LOOP_S
                end if
             end do
          end do
       end do LOOP_S
       if(ikp(ikbz) == 0) then
          write(nfout,'("ikbz=",i5)') ikbz
          write(nfout,'(" ikp=",i5)') ikp(ikbz)
          write(nfout,'("rkxyz=",3(1x,f20.5))') rkxyz(1:3)
          stop "Did not find the index of k' in IBZ."
       end if

       do iopr=1,nopr
          ss = matmul(op(:,:,iopr),op(:,:,iops(ikbz)))
          if(abs(ss(1,1)-1.d0)<DELTA07 .and. &
           & abs(ss(2,2)-1.d0)<DELTA07 .and. &
           & abs(ss(3,3)-1.d0)<DELTA07 .and. &
           & abs(ss(1,2))<DELTA07 .and. &
           & abs(ss(1,3))<DELTA07 .and. &
           & abs(ss(2,3))<DELTA07) then
             iopt(ikbz) = iopr
             exit
          end if
       end do

       !   k'(bz) is transferable to k in IBZ by a symmetry operation.
       !   g0 = k(ibz) - R k(bz)
       !    0 = k(ibz) - R k'(bz)
       !    k'(bz) = k(bz) + R^inv g0

       rkxyz = (1-2*itrs(ikbz)) * matmul(oprec(:,:,iopt(ikbz)),g0(1:3))
       vkbz(ikbz,1:3) = vkbz(ikbz,1:3) + rkxyz(1:3)

    end do

    ntrs = maxval(itrs)

    write(nfout,'("k-points in BZ")')
    write(nfout,'("ikbz k1 k2 k3 wbz")')
    do ikbz=1,kv3bz
       write(nfout,'(i7,4(1x,f20.5))') ikbz, vkbz(ikbz,1:3), wbz(ikbz)
    end do

    write(nfout,'(2x,"ikbz",3x,"ikp",2x,"iops",2x,"iopt",2x,"itrs")')
    do ikbz=1,kv3bz
       write(nfout,'(i5,4(1x,i5))') ikbz, ikp(ikbz), iops(ikbz), iopt(ikbz), itrs(ikbz)
    end do
  end subroutine m_ES_EXX_kbz

  subroutine m_ES_EXX_fbz_faces
    implicit none
    integer :: n
    integer :: i,j,k
    real(kind=DP) :: mtr(3,3)
    integer, parameter :: nface_max = 125
    logical :: exists_in_fbz(nface_max)
    integer :: iface(3,nface_max)
    real(kind=DP), parameter :: lambda = 1.d0+1.d-8
    real(kind=DP) :: gg, gg_ref

    do i=1,3
       do j=1,3
          mtr(i,j) = dot_product(rltv(:,i),rltv(:,j))
       end do
    end do

    n=0
    do i=-2,2
       do j=-2,2
          do k=-2,2
             if(i == 0 .and. j == 0 .and. k == 0) cycle
             n=n+1
             iface(1,n)=i
             iface(2,n)=j
             iface(3,n)=k
          end do
       end do
    end do

    exists_in_fbz(1:nface_max) = .true.
    do i=1,n
       if(exists_in_fbz(i)) then
          gg_ref = dot_product(iface(:,i),matmul(mtr,iface(:,i)))
          do j=1,n
             if(i /= j) then
                gg = dot_product(iface(:,i),matmul(mtr,iface(:,j)))
                if(gg*lambda > gg_ref) exists_in_fbz(j) = .false.
             end if
          end do
       end if
    end do

    nface = 0
    do i=1,n
       if(exists_in_fbz(i)) nface = nface + 1
    end do
    allocate(iface_bz(3,nface))
    nface = 0
    do i=1,n
       if(exists_in_fbz(i)) then
          nface = nface + 1
          iface_bz(1:3,nface) = iface(1:3,i)
       end if
    end do

    ! Write FBZ faces
    write(nfout,'("FBZ faces: iface_bz(3,nface)")')
    write(nfout,'("nface=",i5)') nface
    write(nfout,'("i, n1, n2, n3")')
    do i=1,nface
       write(nfout,'(i5,3(1x,i5))') i, iface_bz(1:3,i)
    end do
  end subroutine m_ES_EXX_fbz_faces

  subroutine m_ES_EXX_move_k_into_fbz(ki,ko)
    implicit none
    real(kind=DP), intent(in) :: ki(3)
    real(kind=DP), intent(out) :: ko(3)

    integer :: i, j
    real(kind=DP) :: mtr(3,3)
    real(kind=DP), parameter :: lambda = 1.d0+1.d-8
    real(kind=DP) :: gg, gg_ref

    do i=1,3
       do j=1,3
          mtr(i,j) = dot_product(rltv(:,i),rltv(:,j))
       end do
    end do

    ko(1:3) = ki(1:3)
    do i=1,nface
       gg_ref = dot_product(iface_bz(:,i),matmul(mtr,iface_bz(:,i))) * 0.5d0
       do 
          gg = dot_product(iface_bz(:,i),matmul(mtr,ko))
          if(gg > gg_ref*lambda) then
             ko(1:3) = ko(1:3) - dble(iface_bz(1:3,i))
          else
             exit
          end if
       end do
    end do
  end subroutine m_ES_EXX_move_k_into_fbz

  subroutine m_ES_EXX_init0
    integer :: ii,ie
    if(potential_update>0) then
       if(.not.allocated(exx_potential)) allocate(exx_potential(kg1,np_e,ista_k:iend_k,kimg));exx_potential = 0.d0
    endif
  end subroutine m_ES_EXX_init0

  subroutine m_ES_EXX_init
    implicit none
    integer :: ik, ikbz, ii,ierr,ie
    real(kind=DP) :: dk(3)
    integer,save  :: id_sname = -1
    call tstatc0_begin('m_ES_EXX_init ',id_sname,level=1)

    call m_ES_EXX_kbz ! -> ntrs, etc.

    ikgamma = 1
    do ik=1,kv3,nspin
       if( abs(vkxyz(ik,1,BUCS))<DELTA07 .and. &
         & abs(vkxyz(ik,2,BUCS))<DELTA07 .and. &
         & abs(vkxyz(ik,3,BUCS))<DELTA07 ) then
          ikgamma = ik
          exit
       end if
    end do

    allocate(qmk_zero(kv3bz,kv3)); qmk_zero = .false.
    allocate(qmk(kv3bz*kv3,3))
    allocate(qmk_zero2(kv3bz*kv3))
    allocate(iqmk(kv3bz,kv3))
    nqmk = 0
    do ik=1,kv3
       do ikbz=1,kv3bz
          if(.not.q_on_k_centered_mesh(ikbz,ik)) cycle
          if( abs(vkbz(ikbz,1)-vkxyz(ik,1,BUCS))<DELTA07 .and. &
            & abs(vkbz(ikbz,2)-vkxyz(ik,2,BUCS))<DELTA07 .and. &
            & abs(vkbz(ikbz,3)-vkxyz(ik,3,BUCS))<DELTA07 ) then
             qmk_zero(ikbz,ik) = .true.
          end if
          if(nqmk==0) then
             nqmk = nqmk + 1
             qmk(nqmk,1:3) = vkbz(ikbz,1:3)-vkxyz(ik,1:3,BUCS)    
             iqmk(ikbz,ik) = nqmk
             qmk_zero2(nqmk) = qmk_zero(ikbz,ik)
          else
             dk(1:3) = vkbz(ikbz,1:3)-vkxyz(ik,1:3,BUCS)    
             do ii=1,nqmk
                if( abs(qmk(ii,1)-dk(1))<DELTA07 .and. &
                  & abs(qmk(ii,2)-dk(2))<DELTA07 .and. &
                  & abs(qmk(ii,3)-dk(3))<DELTA07 ) then
                  iqmk(ikbz,ik) = ii
                  go to 100
                end if
             end do
             nqmk = nqmk + 1
             qmk(nqmk,1:3) = dk(1:3)
             iqmk(ikbz,ik) = nqmk
             qmk_zero2(nqmk) = qmk_zero(ikbz,ik)
         100 continue
          end if
       end do
    end do

    nfftwf = product(fft_box_size_WF(1:3,1))

    call tstatc0_end(id_sname)
  end subroutine m_ES_EXX_init
 
  subroutine m_ES_EXX_crotylm
    implicit none
    integer :: l1max, mmax, nsph
    integer :: ia1,it1,il1,im1,tau1,lmt1,lmtt1,isph1
    integer :: ia2,it2,il2,im2,tau2,lmt2,lmtt2,isph2
    integer :: iy,ilmta1,iopr
    integer :: iopr1,iopr2
    integer :: invop(nopr)
    integer :: i,j
    real(kind=DP) :: ss(3,3)
    real(kind=DP) :: x(3), y(3)
    integer,save  :: id_sname = -1
    call tstatc0_begin('m_ES_EXX_crotylm ',id_sname,level=1)

    do iopr1=1,nopr
       do iopr2=1,nopr
          ss = matmul(op(:,:,iopr1),op(:,:,iopr2))
          if(abs(ss(1,1)-1.d0)<DELTA07 .and. &
          & abs(ss(2,2)-1.d0)<DELTA07 .and. &
          & abs(ss(3,3)-1.d0)<DELTA07 .and. &
          & abs(ss(1,2))<DELTA07 .and. &
          & abs(ss(1,3))<DELTA07 .and. &
          & abs(ss(2,3))<DELTA07) then
             invop(iopr1) = iopr2
             exit
          end if
       end do
    end do

    l1max = nloc
    mmax  = 2*l1max-1
    nsph = l1max**2
    if(.not.allocated(crotylm)) allocate(crotylm(mmax,nsph,nopr))
    crotylm = 0.0d0
    if(.not.allocated(iylm))    allocate(iylm(mmax,nsph,nopr))
    if(.not.allocated(nylm))    allocate(nylm(nsph,nopr))
    call get_crotylm(l1max,mmax,nsph,nopr,crotylm,iylm,nylm,op)

    if(.not.allocated(isph_lmta)) allocate(isph_lmta(nlmta))
    if(.not.allocated(lmta_rot))  allocate(lmta_rot(mmax,nlmta,nopr))
    lmta_rot = 0
    if(.not.allocated(ia_lmta))   allocate(ia_lmta(nlmta))
    do ia1=1,natm
       it1=ityp(ia1)
       do lmt1=1,ilmt(it1)

          il1  = ltp( lmt1, it1)
          im1  = mtp( lmt1, it1)
          tau1 = taup(lmt1, it1)
          lmtt1 = lmtt(lmt1,it1)
          isph1 = (il1-1)**2 + im1

          ilmta1 = lmta(lmt1,ia1)
          ia_lmta(ilmta1) = ia1
          isph_lmta(ilmta1) = isph1
          do iopr=1,nopr
             ia2=napt(ia1,invop(iopr))
             it2=ityp(ia2)
             if(it1/=it2) stop 'm_ES_EXX_crotylm: it1 and it2 differ.'
             do lmt2=1,ilmt(it2)
                il2  = ltp( lmt2, it2)
                tau2 = taup(lmt2, it2)
                if(il1==il2.and.tau1==tau2) then
                   im2  = mtp( lmt2, it2)
                   lmtt2 = lmtt(lmt2,it2)
                   isph2 = (il2-1)**2 + im2
                   do iy=1,nylm(isph1,iopr)
                      if(isph2 == iylm(iy,isph1,iopr)) then
                         lmta_rot(iy,ilmta1,iopr) = lmta(lmt2,ia2)
                      end if
                   end do
                end if
             end do
          end do
       end do
    end do

    if(.not.allocated(opdir)) allocate(opdir(3,3,nopr))
    do iopr=1,nopr
       do j=1,3
          x = matmul(op(:,:,iopr),altv(:,j))
          do i=1,3
             y = rltv(:,i)
             opdir(i,j,iopr) = dot_product(y,x)/PAI2
          end do
       end do
    end do

    call tstatc0_end(id_sname)
  end subroutine m_ES_EXX_crotylm

  subroutine m_ES_EXX_dealloc
    implicit none
    deallocate(vc)
    deallocate(wfv)
    deallocate(occup_val)
    deallocate(ngpt_exx)
    if(modnrm == EXECUT) then
#ifndef MEMORY_SAVE_EXX
       if(sw_rspace_hyb==OFF) then
         deallocate(ylm_exx)
         deallocate(qitg_exx)
       endif
#else
#ifndef MEMORY_SAVE_MORE_EXX
       if(sw_rspace_hyb==OFF) deallocate(qitg_exx)
#endif
#endif
       deallocate(fsr_exx)
       deallocate(fsi_exx)
    end if
  end subroutine m_ES_EXX_dealloc
  
  subroutine m_ES_EXX_gather_valence_states(nfout,transform)
    implicit none
    integer, intent(in) :: nfout
    logical, optional, intent(in) :: transform

    integer :: ik,ib,ib1,ibm,irev
    real(kind=DP), allocatable :: wfv_mpi(:,:,:,:) ! d(kg1,nval,kv3,kimg)
    real(kind=DP), allocatable :: occup_val_mpi(:,:) ! d(nval,kv3)
    real(kind=DP), allocatable :: fsr_mpi(:,:,:) ! d(nval,nlmta,kv3)
    real(kind=DP), allocatable :: fsi_mpi(:,:,:) ! d(nval,nlmta,kv3)
    real(kind=DP), allocatable :: efsr_l(:,:) ! d(np_e,nlmta)
    real(kind=DP), allocatable :: efsi_l(:,:) ! d(np_e,nlmta)


    logical :: trans
    integer, allocatable, dimension(:) :: ista
    integer,save  :: id_sname = -1

    if(sw_update_wfv==OFF) return

    allocate(ista(MPI_STATUS_SIZE))

    trans = .true.
    if(present(transform)) trans = transform
    call tstatc0_begin('m_ES_EXX_gather_valence_states ',id_sname,level=1)


    if(sw_rsb==ON.and.trans) then
       do ik=1,kv3,af+1
          if(map_k(ik) /= myrank_k) cycle
          call UnitaryTransform_WF(INVERSE,ik,zaj_l,.true.,.true.)
       enddo
    endif

    ibm = 0
    do ik=1,kv3,af+1
       if(map_k(ik) /= myrank_k) cycle
       do ib=1,neg
          ib1 = neordr(ib,ik)
          if(map_e(ib1) == myrank_e) then
             if(occup_l(map_z(ib1),ik) > DELTA) then
                ibm = max(ib,ibm)
             end if
          end if
       end do
    end do
    if(npes>1) then
       call mpi_allreduce(ibm,irev,1,MPI_INTEGER,MPI_MAX,mpi_comm_group,ierr)
       nval = irev
    else
       nval = ibm
    end if


    if(allocated(wfv)) deallocate(wfv)
    if(allocated(occup_val)) deallocate(occup_val)
    allocate(wfv(kg1,nval,kv3,kimg))
    allocate(occup_val(nval,kv3))
    wfv = 0.d0
    occup_val = 0.d0
    if(modnrm == EXECUT) then
       if(allocated(fsr_exx)) deallocate(fsr_exx)
       if(allocated(fsi_exx)) deallocate(fsi_exx)
       allocate(fsr_exx(nval,nlmta,kv3))
       allocate(fsi_exx(nval,nlmta,kv3))
       allocate(efsr_l(np_e,nlmta));efsr_l=0.d0
       allocate(efsi_l(np_e,nlmta));efsi_l=0.d0
       fsr_exx = 0.d0
       fsi_exx = 0.d0
    end if
    do ik=1,kv3,af+1
       if(map_k(ik) /= myrank_k) cycle
       if(modnrm == EXECUT) call get_expkt_fs(ik,fsr_l,fsi_l,efsr_l,efsi_l)
       do ib=1,nval
          ib1 = neordr(ib,ik)
          if(map_e(ib1) == myrank_e) then
             wfv(1:kg1,ib,ik,1:kimg) = zaj_l(1:kg1,map_z(ib1),ik,1:kimg)
             occup_val(ib,ik) = occup_l(map_z(ib1),ik)
             if(modnrm == EXECUT) then
                fsr_exx(ib,1:nlmta,ik) = efsr_l(map_z(ib1),1:nlmta)
                fsi_exx(ib,1:nlmta,ik) = efsi_l(map_z(ib1),1:nlmta)
             end if
          end if
       end do
    end do    
    if(modnrm == EXECUT) then
       deallocate(efsr_l)
       deallocate(efsi_l)
    end if

    allocate(wfv_mpi(kg1,nval,kv3,kimg))
    allocate(occup_val_mpi(nval,kv3))
    call mpi_allreduce(wfv,wfv_mpi,kg1*nval*kv3*kimg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)
    call mpi_allreduce(occup_val,occup_val_mpi,nval*kv3,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)
    wfv = wfv_mpi
    occup_val = occup_val_mpi
    deallocate(wfv_mpi)
    deallocate(occup_val_mpi)
    if(modnrm == EXECUT) then
       allocate(fsr_mpi(nval,nlmta,kv3))
       allocate(fsi_mpi(nval,nlmta,kv3))
       call mpi_allreduce(fsr_exx,fsr_mpi,nval*nlmta*kv3,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)
       call mpi_allreduce(fsi_exx,fsi_mpi,nval*nlmta*kv3,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)
       fsr_exx = fsr_mpi
       fsi_exx = fsi_mpi
       deallocate(fsr_mpi)
       deallocate(fsi_mpi)
    end if

    if(sw_rspace_hyb==ON .and. modnrm==EXECUT.and.sw_precalculate==ON)then
       if(allocated(fsrqm)) deallocate(fsrqm)
       if(allocated(fsiqm)) deallocate(fsiqm)
       allocate(fsrqm(nmesh_rs_aug_max,nlmta,nval,kv3bz,nspin));fsrqm=0.d0
       allocate(fsiqm(nmesh_rs_aug_max,nlmta,nval,kv3bz,nspin));fsiqm=0.d0
       call build_fsqm()
    endif

    if(sw_rsb==ON.and.trans) then
       do ik=1,kv3,af+1
          if(map_k(ik) /= myrank_k) cycle
          call UnitaryTransform_WF(DIRECT,ik,zaj_l,.true.,.true.)
       enddo
    endif

    deallocate(ista)
    call tstatc0_end(id_sname)
  end subroutine m_ES_EXX_gather_valence_states

  subroutine build_fsqm()
    integer :: jkbz,kk,kop,jop,jtrs,m
    integer :: ia,it,imesh,lmt1,lmt2,nma,ilmta1,ilmta2,ispin,lmtp
    real(kind=DP), allocatable, dimension(:) :: fsr, fsi !d(nlmta)
    real(kind=DP), allocatable, dimension(:) :: cosqmkr,sinqmkr
    real(kind=DP) :: fr,fi,fr0,fi0
    real(kind=DP) :: qm
    allocate(fsr(nlmta));fsr=0.d0
    allocate(fsi(nlmta));fsi=0.d0
    fsrqm = 0.d0
    fsiqm = 0.d0
    do ispin=1,nspin,af+1
       do jkbz=1,kv3bz
          ! q(bz) = S*k(ibz)
          kk = ikp(jkbz) + ispin - 1
          kop = iops(jkbz)
          jop = iopt(jkbz) 
          jtrs = itrs(jkbz)
          do m=1,nval
             call get_Rot_betar_dot_WFs(kk,m,jop,kop,jtrs,fsr,fsi)
             do ia=1,natm
                it = ityp(ia)
                if( m_PP_include_vanderbilt_pot(it) == SKIP) cycle
                nma = nmesh_rs_aug(ia)
                do lmtp=1,nlmtpair(ia)
                   lmt1 = plmt1(lmtp,ia)
                   lmt2 = plmt2(lmtp,ia)
                   ilmta1 = lmta(lmt1,ia)
                   ilmta2 = lmta(lmt2,ia)
                   fr = fsr(ilmta2)
                   fi = fsi(ilmta2)
                   fr0 = fsr(ilmta1)
                   fi0 = fsi(ilmta1)
                   do imesh=1,nma
                      qm = qr_clm_ylm(imesh,ia,lmtp)
                      fsrqm(imesh,ilmta1,m,jkbz,ispin) = fsrqm(imesh,ilmta1,m,jkbz,ispin)+qm*fr
                      fsiqm(imesh,ilmta1,m,jkbz,ispin) = fsiqm(imesh,ilmta1,m,jkbz,ispin)+qm*fi
                      if(lmt1.ne.lmt2)then
                         fsrqm(imesh,ilmta2,m,jkbz,ispin) = fsrqm(imesh,ilmta2,m,jkbz,ispin)+qm*fr0
                         fsiqm(imesh,ilmta2,m,jkbz,ispin) = fsiqm(imesh,ilmta2,m,jkbz,ispin)+qm*fi0
                      endif
                   enddo
                enddo
             enddo
          enddo
       enddo
    enddo
    deallocate(fsr)
    deallocate(fsi)
  end subroutine build_fsqm

  subroutine m_ES_EXX_kernel(nfout)
    implicit none
    integer, intent(in) :: nfout
    
    integer :: ik,ikbz,ig,kgs
    real(kind=DP) :: fac, wi, kg(3), vzero, g2
    real(kind=DP), dimension(6) :: ttr
    integer :: igs,ige
    integer,save  :: id_sname = -1
    call tstatc0_begin('m_ES_EXX_kernel ',id_sname,level=1)

    if(.not.allocated(vc)) allocate(vc(nmax_G_hyb,nqmk))

    vc = 0.d0

    call getttr(rltv,ttr)

    fac = PAI4/univol

    if(sw_singular_correction==ON) then
       call singular_correction(vzero)
    else
       vzero = 0.d0
    end if
    vzero = vzero*dble(kv3bz)/product(reduction_factor_exx(1:3))

    if(sw_screened_exchange==OFF) then
       do ik=1,nqmk
          kgs=1
          if(qmk_zero2(ik)) then
             kgs=2
             vc(1,ik) = vzero
          end if
          igs = kgs;ige=nmax_G_hyb
          do ig=igs,ige
             kg(1:3) = qmk(ik,1:3) + ngabc(ig,1:3)
             g2          = ttr(1)*kg(1)*kg(1) &
             &           + ttr(2)*kg(2)*kg(2) &
             &           + ttr(3)*kg(3)*kg(3) &
             &           + ttr(4)*kg(1)*kg(2) &
             &           + ttr(5)*kg(2)*kg(3) &
             &           + ttr(6)*kg(3)*kg(1)
             vc(ig,ik) = fac / g2
          end do
       end do
    else
       wi = 1.d0/(4.d0*omega_exx*omega_exx)
       do ik=1,nqmk
          kgs=1
          if(qmk_zero2(ik)) then
             kgs=2
             vc(1,ik) = vzero
          end if
          igs = kgs;ige=nmax_G_hyb
          do ig=igs,ige
             kg(1:3) = qmk(ik,1:3) + ngabc(ig,1:3)
             g2          = ttr(1)*kg(1)*kg(1) &
             &           + ttr(2)*kg(2)*kg(2) &
             &           + ttr(3)*kg(3)*kg(3) &
             &           + ttr(4)*kg(1)*kg(2) &
             &           + ttr(5)*kg(2)*kg(3) &
             &           + ttr(6)*kg(3)*kg(1)
             vc(ig,ik) = fac / g2 * (1.d0-exp(-g2*wi))
          end do
       end do
    end if

    vc = -alpha_exx * vc

    call tstatc0_end(id_sname)

    !!stop 'm_ES_EXX_kernel: Singular correction'

  contains

    subroutine singular_correction(chi)
      implicit none 
      real(kind=DP), intent(out) :: chi

      real(kind=DP), parameter :: gam  = 1.d0 ! Bohr^-2
      real(kind=DP) :: chig1, chig2, chig3, gam3
      real(kind=DP) :: chi0, chi1, chi2

      !chig1 = chig(gam1)
      !chig2 = chig(gam2)
      !chi_app = chig1 + (chig1-chig2)/(gam2-gam1) * gam1

      call chig_deriv(gam,chi0,chi1,chi2)
      chi = chi0 - chi1*gam + 0.5d0*chi2*gam**2

      if(sw_screened_exchange==ON) then
         gam3 = 1.d0/(4.d0*omega_exx**2)
         chig3 = chig(gam3)
         chi = chi - chig3
      !   chi_app = chi_app - chig3
      end if

      if(printable) then
         write(nfout,'("EXX: Singular correction: chi(0)=",f10.5)') chi
         write(nfout,'("EXX: chi0(",f10.5,") =",f10.5)') gam, chi0
         write(nfout,'("EXX: chi1(",f10.5,") =",f10.5)') gam, chi1
         write(nfout,'("EXX: chi2(",f10.5,") =",f10.5)') gam, chi2
         if(sw_screened_exchange==ON) &
          & write(nfout,'("EXX: chi0(",f10.5,") =",f10.5)') gam3, chig3 
      end if
    end subroutine singular_correction

    function chig(gam)
      implicit none 
      real(kind=DP) :: chig
      real(kind=DP), intent(in) :: gam

      integer :: ig, ikbz, kgs, igs, ige
      real(kind=DP) :: sumg, sumgk

      sumg = 0.d0
      do ikbz=1,kv3bz
         if(.not.q_on_k_centered_mesh(ikbz,ikgamma)) cycle
         kgs=1
         if(qmk_zero(ikbz,ikgamma)) kgs=2
         sumgk = 0.d0
         do ig=kgs,nmax_G_hyb
            kg(1:3) = vkbz(ikbz,1:3) + ngabc(ig,1:3)
            g2          = ttr(1)*kg(1)*kg(1) &
            &           + ttr(2)*kg(2)*kg(2) &
            &           + ttr(3)*kg(3)*kg(3) &
            &           + ttr(4)*kg(1)*kg(2) &
            &           + ttr(5)*kg(2)*kg(3) &
            &           + ttr(6)*kg(3)*kg(1)
            sumgk = sumgk + exp(-gam*g2) / g2
         end do
         sumg = sumg + wbz(ikbz) * sumgk
      end do
      sumg = fac * sumg

      chig = 1.d0/sqrt(PAI*gam) - sumg
    end function chig

    subroutine chig_deriv(gam,chi0,chi1,chi2)
      implicit none
      real(kind=DP), intent(in) :: gam
      real(kind=DP), intent(out) :: chi0, chi1, chi2

      integer :: ig, ikbz, kgs
      real(kind=DP) :: sumg0, sumgk0
      real(kind=DP) :: sumg1, sumgk1
      real(kind=DP) :: sumg2, sumgk2
      real(kind=DP) :: expg2

      sumg0 = 0.d0
      sumg1 = 0.d0
      sumg2 = 0.d0
      do ikbz=1,kv3bz
         if(.not.q_on_k_centered_mesh(ikbz,ikgamma)) cycle
         kgs=1
         if(qmk_zero(ikbz,ikgamma)) kgs=2
         sumgk0 = 0.d0
         sumgk1 = 0.d0
         sumgk2 = 0.d0
         do ig=kgs,nmax_G_hyb
            kg(1:3) = vkbz(ikbz,1:3) + ngabc(ig,1:3)
            g2          = ttr(1)*kg(1)*kg(1) &
            &           + ttr(2)*kg(2)*kg(2) &
            &           + ttr(3)*kg(3)*kg(3) &
            &           + ttr(4)*kg(1)*kg(2) &
            &           + ttr(5)*kg(2)*kg(3) &
            &           + ttr(6)*kg(3)*kg(1)
            expg2 = exp(-gam*g2)
            sumgk0 = sumgk0 + expg2 / g2
            sumgk1 = sumgk1 + expg2
            sumgk2 = sumgk2 + expg2 * g2
         end do
         sumg0 = sumg0 + wbz(ikbz) * sumgk0
         sumg1 = sumg1 + wbz(ikbz) * sumgk1
         sumg2 = sumg2 + wbz(ikbz) * sumgk2
      end do
      chi0 =  1.d0/sqrt(PAI*gam) - fac*sumg0
      chi1 = -0.5d0/sqrt(PAI*gam**3) + fac*sumg1
      chi2 =  0.75d0/sqrt(PAI*gam**5) - fac*sumg2
    end subroutine chig_deriv

  end subroutine m_ES_EXX_kernel

  subroutine m_ES_EXX_potential(nfout,ispin,ib,ik,nff,fsr,fsi,vxw,iupdate,store_potential,exx,exx_only)
    implicit none
    integer, intent(in) :: nfout
    integer, intent(in) :: ispin,ib,ik
    integer, intent(in) :: nff
    integer, intent(in), optional :: iupdate
    logical, intent(in), optional :: store_potential
    integer :: iup
    real(kind=DP), intent(in)  :: fsr(nlmta),fsi(nlmta)
    real(kind=DP), intent(out) :: vxw(nff,kimg) 
    real(kind=DP), intent(out), optional :: exx
    logical, intent(in), optional :: exx_only

    real(kind=DP), allocatable :: efsr_l(:)
    real(kind=DP), allocatable :: efsi_l(:)
    real(kind=DP) :: nfftwf
    logical :: eo
    real(kind=DP) :: ene
    integer :: ig,iadd
    logical :: store_p
    real(kind=DP), allocatable, dimension(:) :: zajbuf_r,zajbuf_i
    integer :: kgw,kgv
    integer :: id_sname=-1
    call tstatc0_begin('m_ES_EXX_potential ',id_sname,level=1)
    store_p = .true.
    if(present(store_potential)) store_p = store_potential

    eo = .false.
    if(present(exx_only)) eo = exx_only
    vxw = 0.0d0

    iup = 2
    if(present(iupdate)) iup = iupdate
    if(iup.lt.potential_update)then
       vxw(1:iba(ik),1:kimg) = exx_potential(1:iba(ik),ib,ik,1:kimg)
       if(present(exx))then
         exx=0.d0
         if(kimg==1)then
            do ig=1,iba(ik)
               exx = exx + zaj_l(ig,ib,ik,1)*vxw(ig,1)
            enddo
         else
            if(k_symmetry(ik) == GAMMA) then
               do ig=2,iba(ik)
                  exx = exx + zaj_l(ig,ib,ik,1) * vxw(ig,1) &
                      &     + zaj_l(ig,ib,ik,2) * vxw(ig,2)
               end do
               exx = exx * 2.d0 + zaj_l(1,ib,ik,1) * vxw(1,1)
            else
               do ig=1,iba(ik)
                  exx = exx + zaj_l(ig,ib,ik,1)*vxw(ig,1) &
                      &     + zaj_l(ig,ib,ik,2)*vxw(ig,2)
               end do
            endif
         endif
       endif
       return
    endif
    allocate(efsr_l(nlmta));efsr_l=0.d0
    allocate(efsi_l(nlmta));efsi_l=0.d0
    if(modnrm == EXECUT) call get_expkt_fs_b(ik,ib,fsr,fsi,efsr_l,efsi_l)
    allocate(zajbuf_r(kg1));zajbuf_r(:) = zaj_l(:,ib,ik,1)
    allocate(zajbuf_i(kg1));zajbuf_i(:) = zaj_l(:,ib,ik,kimg)
    kgw = kg1;kgv=kg1

    if(present(exx))then
       call apply_Vx_to_WF( ispin, ib, ik, kgw, kgv, zajbuf_r, zajbuf_i, efsr_l, efsi_l, vxw, ene, eo )
    else
       call apply_Vx_to_WF( ispin, ib, ik, kgw, kgv, zajbuf_r, zajbuf_i, efsr_l, efsi_l, vxw )
    endif

    deallocate(efsr_l)
    deallocate(efsi_l)
    deallocate(zajbuf_r)
    deallocate(zajbuf_i)
    if(present(exx)) exx = ene
    if(.not.eo.and.potential_update>0.and.store_p) &
    &  exx_potential(1:iba(ik),ib,ik,1:kimg) = vxw(1:iba(ik),1:kimg)
    call tstatc0_end(id_sname)
  end subroutine m_ES_EXX_potential

  subroutine m_ES_EXX_eigenvalue_for_each_k(ispin,ik,update_eko,iupdate)
    implicit none
    integer, intent(in) :: ispin, ik
    logical, intent(in), optional :: update_eko
    integer, intent(in), optional :: iupdate

    integer :: ib,ig
    integer :: iup
    real(kind=DP), allocatable, dimension(:,:,:,:) :: vxw !d(kg1,kimg)
    real(kind=DP), allocatable, dimension(:,:,:) :: vexx
    real(kind=DP) :: exx
    integer :: ng
    logical :: u_eko
    integer,save  :: id_sname = -1
    call tstatc0_begin('m_ES_EXX_eigenvalue_for_each_k ',id_sname,level=1)
    
    iup = 2
    if(present(iupdate)) iup = iupdate

    if(.not.allocated(eexx_kb)) allocate(eexx_kb(np_e,ista_k:iend_k))

    if(.not.allocated(eko_hyb))then
       allocate(eko_hyb(np_e,ista_k:iend_k));eko_hyb=0.d0
    endif
    eko_hyb(:,ik) = 0.0d0
    u_eko = .true.
    if(.not.present(update_eko))then
       eko_l(:,ik) = 0.d0
    else
       if(update_eko) eko_l(:,ik) = 0.d0
       u_eko = update_eko
    endif
    ng=kg1
    allocate(vxw(ng,np_e,ista_k:iend_k,kimg))
       if(sw_rsb==ON.and.iup.ge.potential_update) call UnitaryTransform_WF(INVERSE,ik,zaj_l,.true.,.true.)
       do ib=1,np_e   ! MPI
          if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
             call m_ES_EXX_potential(nfout,ispin,ib,ik,ng,fsr_l(ib,:,ik),fsi_l(ib,:,ik),&
             & vxw(1:ng,ib,ik,1:kimg),iup,exx=exx,exx_only=.true.,store_potential=.false.)
          else
             call m_ES_EXX_potential(nfout,ispin,ib,ik,ng,fsr_l(ib,:,ik),fsr_l(ib,:,ik),&
             & vxw(1:ng,ib,ik,1:kimg),iup,exx=exx,exx_only=.true.,store_potential=.false.)
          endif
          eexx_kb(ib,ik) = occup_l(ib,ik)*exx
          eko_hyb(ib,ik) = exx
          if(u_eko) then
             eko_l(ib,ik) = eko_l(ib,ik) + exx
          endif
       end do
       if(sw_rsb==ON.and.iup.ge.potential_update) call UnitaryTransform_WF(DIRECT,ik,zaj_l,.true.,.true.)

    deallocate(vxw)

    call tstatc0_end(id_sname)
  end subroutine m_ES_EXX_eigenvalue_for_each_k

  subroutine m_ES_EXX_cp_eigenvalue(ik)
     integer, intent(in) :: ik
     if(.not.allocated(eko_hyb)) return
     eko_l(1:np_e,ik) = eko_hyb(1:np_e,ik)
  end subroutine m_ES_EXX_cp_eigenvalue

  subroutine m_ES_EXX_Diagonal_part(ispin,ik,vxdi)
    implicit none
    integer, intent(in) :: ispin, ik
    real(kind=DP), intent(out), dimension(kg1) :: vxdi

    integer :: ib,ig
    integer :: ii,m,jkbz,kk,jk,jop,jtrs
    real(kind=DP) :: fac, occupation
    real(kind=DP), allocatable, dimension(:) :: rho, pot, vx, vxq !d(nfft)
    real(kind=DP), allocatable, dimension(:) :: rhor, rhoi !d(kg1)

    real(kind=DP), allocatable, dimension(:,:,:,:) :: vxdi_t

    integer,save  :: id_sname = -1


    call tstatc0_begin('m_ES_EXX_Diagonal_part ',id_sname,level=1)


    allocate(rho(nfft))
    allocate(pot(nfft))
    allocate(vx(nfft)); vx = 0.d0
    allocate(vxq(nfft))
    allocate(rhor(nmax_G_hyb)); rhor = 0.d0
    allocate(rhoi(nmax_G_hyb)); rhoi = 0.d0

    ! rho(G) = sum_q sum_m |phi_m(q+G)|^2
    do jkbz=1,kv3bz
       if(.not.q_on_k_centered_mesh(jkbz,ik)) cycle
       ! q(bz) = S*k(ibz)
       kk = ikp(jkbz) + ispin - 1
       jop = iopt(jkbz)
       jtrs = itrs(jkbz)
! === DEBUB by tkato 2013/02/21 ================================================
       rhor = 0.0d0
       rhoi = 0.0d0
! ==============================================================================
       do m=1,nval
          if(occup_val(m,kk) < DELTA) cycle
          occupation = wbz(jkbz)*occup_val(m,kk)/qwgt(kk)/dble(kv3)
          if(kimg==1) then
             do ii=1,iba(kk)
                rhor(ii) = rhor(ii) + occupation * ( wfv(ii,m,kk,1) * wfv(ii,m,kk,1) )
             end do
          else
             do ii=1, min( iba(kk), nmax_G_hyb )
                rhor(ii) = rhor(ii) + occupation * ( wfv(ii,m,kk,1) * wfv(ii,m,kk,1) &
                                                 & + wfv(ii,m,kk,2) * wfv(ii,m,kk,2) )
             end do
          end if
       end do
       call map_Rot_WFG_on_FFT_box(kk,jop,jtrs,rhor,rhoi,rho)
       call m_FFT_WF(ELECTRON,nfout,rho,INVERSE,OFF) ! rho(R)

       do ii=1, min( kg, nmax_G_hyb )
          rhor(ii) = vc(ii,iqmk(jkbz,ik))
          rhoi(ii) = 0.d0
       end do
       call map_RHOG_on_FFT_box(rhor,rhoi,pot)
       call m_FFT_WF(ELECTRON,nfout,pot,INVERSE,OFF) ! pot(R)

       call product_on_FFT_box(pot,rho,vxq) ! vx(R)
       vx = vx + vxq
    end do

    call m_FFT_WF(ELECTRON,nfout,vx,DIRECT,OFF) ! vx(G)
    call map_FFT_box_on_RHOG(rhor,rhoi,vx) 
    fac = 1.d0/dble(nfftwf)
    vxdi = 0.0d0
    do ii=1,iba(ik)
       ig = nbase(ii,ik)
       if ( ig <= nmax_G_hyb ) then
          vxdi(ii) = fac * rhor(ig)
       endif
    end do
 
    deallocate(rho)
    deallocate(pot)
    deallocate(vx)
    deallocate(rhor)
    deallocate(rhoi)

    call tstatc0_end(id_sname)
  end subroutine m_ES_EXX_Diagonal_part


  subroutine m_ES_EXX_add_Diagonal_part(ik,ibo,vxdi,vnldi)
    implicit none
    integer, intent(in) :: ik, ibo
    real(kind=DP), intent(in), dimension(kg1) :: vxdi
    real(kind=DP), intent(out), dimension(kg1) :: vnldi

    integer :: ib

    ib = map_z(ibo)
    vnldi = vnldi + vxdi
  end subroutine m_ES_EXX_add_Diagonal_part

  subroutine m_ES_Vexx_W(ik,iupdate,store_exxp)
    implicit none
    integer, intent(in) :: ik
    integer, intent(in), optional :: iupdate
    logical, intent(in), optional :: store_exxp

    logical :: store_e

    integer :: ib,ig,ispin,iup
    real(kind=DP), allocatable, dimension(:,:,:,:) :: vxw !d(kg1,kimg)
    real(kind=DP), allocatable, dimension(:,:,:) :: vexx
    real(kind=DP) :: exx
    integer :: ng
    integer,save  :: id_sname = -1
    iup = 2
    if(present(iupdate)) iup = iupdate
    store_e = .true.
    if(present(store_exxp)) store_e = store_exxp
    call tstatc0_begin('m_ES_Vexx_W ',id_sname,level=1)

    ispin = mod(ik-1,nspin)+1

    ng = kg1
       allocate(vxw(ng,np_e,ista_k:iend_k,kimg))
       if(sw_rsb==ON) call UnitaryTransform_WF(INVERSE,ik,zaj_l,.true.,.true.)
       do ib=1,np_e   ! MPI
          if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
             call m_ES_EXX_potential(nfout,ispin,ib,ik,ng,fsr_l(ib,:,ik),fsi_l(ib,:,ik),&
             &    vxw(1:ng,ib,ik,1:kimg),iup,store_potential=store_e)
          else
             call m_ES_EXX_potential(nfout,ispin,ib,ik,ng,fsr_l(ib,:,ik),fsr_l(ib,:,ik),&
             &    vxw(1:ng,ib,ik,1:kimg),iup,store_potential=store_e)
          endif
       end do
       if(sw_rsb==ON)then
          call UnitaryTransform_WF(DIRECT,ik,vxw,.false.,.false.)
          call UnitaryTransform_WF(DIRECT,ik,zaj_l,.true.,.true.)
          if(potential_update>0.and.store_e) &
          &  call UnitaryTransform_WF(DIRECT,ik,exx_potential,.false.,.false.)
       endif
       do ib=1,np_e
          call m_ES_Vexx_add_vexx(ik,ib,vxw(1:ng,ib,ik,1:kimg))
       enddo
       deallocate(vxw)
    call tstatc0_end(id_sname)
  end subroutine m_ES_Vexx_W

  subroutine m_ES_Vexx_add_vexx(ik,ib,vxw_exx)
    integer, intent(in) :: ib,ik
    real(kind=DP),dimension(kg1,kimg),intent(in) :: vxw_exx
    integer :: ig,iadd
    logical ma
    if(kimg==1) then
       do ig=1,iba(ik)
          vnlph_l(ig,ib,1) = vnlph_l(ig,ib,1) + vxw_exx(ig,1)
       end do
    else
       do ig=1,iba(ik)
          vnlph_l(ig,ib,1) = vnlph_l(ig,ib,1) + vxw_exx(ig,1)
          vnlph_l(ig,ib,2) = vnlph_l(ig,ib,2) + vxw_exx(ig,2)
       end do
    end if 
  end subroutine m_ES_Vexx_add_vexx

  subroutine apply_Vx_to_WF(ispin,ib,ik,kgw,kgv,wfr,wfi,bdwr,bdwi,vxw,eexx,eonly,force_l,dbdwr,dbdwi)
    implicit none
    integer, intent(in)                       :: ispin, ib,ik,kgw,kgv
    real(kind=DP), intent(in), dimension(kgw) :: wfr, wfi
    real(kind=DP), intent(in), dimension(nlmta) :: bdwr, bdwi
    real(kind=DP), intent(out), optional, dimension(kgv,kimg) :: vxw
    real(kind=DP), intent(out), optional :: eexx
    logical, intent(in), optional :: eonly

    real(kind=DP), intent(in), dimension(nlmta,3), optional :: dbdwr, dbdwi
    real(kind=DP), intent(inout), dimension(natm,3), optional :: force_l
    logical :: force_mode=.false.
    real(kind=DP) :: exx
    integer :: kk,m,ig,ii,jop,kop,jtrs
    integer :: jkbz
    real(kind=DP) :: fac, ph, occupation, dnorm
    real(kind=DP) :: skg(3)
    real(kind=DP), allocatable, dimension(:) :: rho,phi !d(nfft)
    real(kind=DP), allocatable, dimension(:) :: wfn,wfm !d(nfft)
    real(kind=DP), allocatable, dimension(:) :: sumdel !d(nfft)
    real(kind=DP), allocatable, dimension(:) :: rhogr, rhogi !d(kgp)
    real(kind=DP), allocatable, dimension(:) :: wfsr,wfsi !d(kg1)
    real(kind=DP), allocatable, dimension(:) :: cosgt, singt !d(kg1)
    real(kind=DP), allocatable, dimension(:) :: fsr, fsi !d(nlmta)
    real(kind=DP), allocatable, dimension(:,:) :: dfsr, dfsi !d(nlmta,3)
    real(kind=DP), allocatable, dimension(:) :: qvr, qvi !d(nlmta)
    real(kind=DP), allocatable, dimension(:,:) :: dqvr, dqvi !d(nlmta,3)
    real(kind=DP), allocatable, dimension(:,:) :: gqvr, gqvi !d(nlmta,3)
    real(kind=DP), allocatable, dimension(:) :: sumqvr, sumqvi !d(nlmta)
    real(kind=DP), allocatable, dimension(:,:) :: sumdqvr, sumdqvi !d(nlmta)
    real(kind=DP), allocatable, dimension(:) :: rhor,rhoi
    real(kind=DP), allocatable, dimension(:) :: afft
    real(kind=DP) :: ifac
    logical :: eo
    integer,save  :: id_sname = -1,id_sname1=-2,id_sname2=-3,id_sname3=-4
    call tstatc0_begin('apply_Vx_to_WF ',id_sname,1)
    eo=.false.
    if(present(eonly))then
      eo = eonly
    endif
    if(present(eexx))then
      eexx = 0.d0
    endif

    force_mode = present(force_l).and.present(dbdwr).and.present(dbdwi)

    allocate(rho(nfft))
    allocate(phi(nfft))
    allocate(wfn(nfft))
    allocate(wfm(nfft))
    allocate(sumdel(nfft))
    allocate(rhogr(nmax_G_hyb))
    if(sw_rspace_hyb==ON.and.modnrm==EXECUT)then
       allocate(rhor(nfftp_exx_nonpara/2));rhor=0.d0
       allocate(rhoi(nfftp_exx_nonpara/2));rhoi=0.d0
       allocate(afft(nfftp_exx_nonpara));afft=0.d0
    endif
    if(kimg==2) allocate(rhogi(nmax_G_hyb))
    allocate(wfsr(kg1))
    if(kimg==2) allocate(wfsi(kg1))
    allocate(cosgt(kg1))
    if(kimg==2) allocate(singt(kg1))
    if(modnrm == EXECUT) then
       allocate(fsr(nlmta))
       allocate(fsi(nlmta))
       allocate(qvr(nlmta))
       allocate(qvi(nlmta))
       allocate(sumqvr(nlmta))
       allocate(sumqvi(nlmta))
       fac = 1.d0/dble(nfftwf)
       sumqvr = 0.d0
       sumqvi = 0.d0
       if(force_mode)then
          allocate(dfsr(nlmta,3))
          allocate(dfsi(nlmta,3))
          allocate(dqvr(nlmta,3))
          allocate(dqvi(nlmta,3))
          allocate(gqvr(nlmta,3))
          allocate(gqvi(nlmta,3))
          allocate(sumdqvr(nlmta,3))
          allocate(sumdqvi(nlmta,3))
          sumdqvr=0.d0;sumdqvi=0.d0
       endif
    end if

    call map_WFG_on_FFT_box(ik,wfr,wfi,wfn)
    call m_FFT_WF(ELECTRON,nfout,wfn,INVERSE,OFF) ! wfn(R)

    sumdel = 0.d0
    do jkbz=1,kv3bz
       if(.not.q_on_k_centered_mesh(jkbz,ik)) cycle
#ifdef MEMORY_SAVE_EXX
       call m_ES_EXX_ylm_each_k(iqmk(jkbz,ik))
#ifdef MEMORY_SAVE_MORE_EXX
       call qitgft_qmk_each_k(iqmk(jkbz,ik))
#endif
#endif
       ! q(bz) = S*k(ibz)
       kk = ikp(jkbz) + ispin - 1
       kop = iops(jkbz)
       jop = iopt(jkbz) 
       jtrs = itrs(jkbz)
       if(kimg==1) then
          do ig=1,iba(kk)
             ii = nbase(ig,kk)
             skg(1:3) = vkxyz(kk,1:3,BUCS) + ngabc(ii,1:3)
             ph = PAI2 * dot_product(skg,tau(:,kop,BUCS))
             cosgt(ig) = cos(ph)
          end do
       else
          do ig=1,iba(kk)
             ii = nbase(ig,kk)
             skg(1:3) = vkxyz(kk,1:3,BUCS) + ngabc(ii,1:3)
             ph = PAI2 * dot_product(skg,tau(:,kop,BUCS))
             cosgt(ig) = cos(ph)
             singt(ig) = sin(ph)
          end do
       end if
       do m=1,nval
          if(occup_val(m,kk) < DELTA) cycle
          if(sw_rsb==ON)then
             if(.not.overlap(ib,m))cycle
          endif
          occupation = wbz(jkbz) * occup_val(m,kk)/qwgt(kk)/dble(kv3)
          if(kimg==1) then
             dnorm = 0.d0
             do ig=1,iba(kk)
                wfsr(ig) = wfv(ig,m,kk,1) * cosgt(ig)  
                dnorm = dnorm + wfsr(ig)*wfsr(ig)
             end do
             dnorm = 1.d0/sqrt(dnorm)
             wfsr = wfsr * dnorm
             call map_Rot_WFG_on_FFT_box(kk,jop,jtrs,wfsr,wfsr,wfm)
          else
             if(jtrs==0) then
                do ig=1,iba(kk)
                   wfsr(ig) = wfv(ig,m,kk,1) * cosgt(ig) - wfv(ig,m,kk,2) * singt(ig)
                   wfsi(ig) = wfv(ig,m,kk,2) * cosgt(ig) + wfv(ig,m,kk,1) * singt(ig)
                end do
             else
                do ig=1,iba(kk)
                   wfsr(ig) = wfv(ig,m,kk,1) * cosgt(ig) - wfv(ig,m,kk,2) * singt(ig)
                   wfsi(ig) = -wfv(ig,m,kk,2) * cosgt(ig) - wfv(ig,m,kk,1) * singt(ig)
                end do
             end if
             call map_Rot_WFG_on_FFT_box(kk,jop,jtrs,wfsr,wfsi,wfm)
          end if
          call m_FFT_WF(ELECTRON,nfout,wfm,INVERSE,OFF) ! wfm(R)
          call product_on_FFT_box(wfn,wfm,rho) ! rho_soft(R)
          call m_FFT_WF(ELECTRON,nfout,rho,DIRECT,OFF) ! rho_soft(G)

          if(kimg==1) then
             call map_FFT_box_on_RHOG(rhogr,rhogr,rho)
             do ii=1,nmax_G_hyb
                rhogr(ii) = vc(ii,iqmk(jkbz,ik)) * rhogr(ii) ! phi(G) = Vc(G,q) * rho(G)
             end do
             call map_RHOG_on_FFT_box(rhogr,rhogr,phi)
          else
             call map_FFT_box_on_RHOG(rhogr,rhogi,rho)
             !! rho(G) = rho_soft(G) + rho_hard(G)
             if(modnrm == EXECUT) then
                do ii=1, min( kg, nmax_G_hyb )
                   rhogr(ii) = fac * rhogr(ii)
                   rhogi(ii) = fac * rhogi(ii)
                end do
                do ii=kg+1, nmax_G_hyb
                   rhogr(ii) = 0.d0
                   rhogi(ii) = 0.d0
                end do
                if(force_mode)then
                   call get_Rot_betar_dot_WFs(kk,m,jop,kop,jtrs,fsr,fsi,dfsr,dfsi)
                else
                   if(sw_rspace_hyb==OFF .or. (sw_rspace_hyb==ON .and. sw_precalculate==OFF)) &
                  &   call get_Rot_betar_dot_WFs(kk,m,jop,kop,jtrs,fsr,fsi)
                endif
                if(sw_rspace_hyb==ON)then
                   if(sw_precalculate==OFF)then
                      call add_RHOG_hard_part_rs(iqmk(jkbz,ik),rhor,rhoi,bdwr,bdwi,fsr,fsi)
                   else
                      call add_RHOG_hard_part_rs2(iqmk(jkbz,ik),rhor,rhoi,&
                     & fsrqm(:,:,m,jkbz,ispin),fsiqm(:,:,m,jkbz,ispin),bdwr,bdwi)
                   endif
                   call tstatc0_begin('FFT_CD_exx ',id_sname_cdfft,1)
                   call map_RHOG_on_FFT_box_hard(rhor,rhoi,afft)
                   call m_FFT_CD0_exx(nfout,afft,DIRECT)
                   call map_FFT_box_on_RHOG_hard(rhor,rhoi,afft)
                   call tstatc0_end(id_sname_cdfft)
                   do ii=1,nmax_G_hyb
                      rhogr(ii) = rhogr(ii) + rhor(ii)
                      rhogi(ii) = rhogi(ii) + rhoi(ii)
                   end do
                else
                   call add_RHOG_hard_part(iqmk(jkbz,ik),rhogr,rhogi,bdwr,bdwi,fsr,fsi)
                endif
             end if
             if(present(eexx))then
                exx = 0.d0
                call sum_rho_vc_rho(rhogr,rhogi,vc(1,iqmk(jkbz,ik)),exx)
                eexx = eexx + occupation * exx
                if(eo) cycle
             endif
             do ii=1,nmax_G_hyb
                rhogr(ii) = vc(ii,iqmk(jkbz,ik)) * rhogr(ii) ! phi(G) = Vc(G,q) * rho(G)
                rhogi(ii) = vc(ii,iqmk(jkbz,ik)) * rhogi(ii) ! phi(G) = Vc(G,q) * rho(G)
             end do
             !! Dij[Vnm] = Sum_G Qij(G) * Vnm(G)
             !! Hi[Vnm] = Sum_j Dij[Vnm] <beta_j|psi_m>
!
             if (modnrm == EXECUT) then
                if(sw_rspace_hyb==ON)then
                   call tstatc0_begin('FFT_CD_exx ',id_sname_cdfft,1)
                   call map_RHOG_on_FFT_box_hard_inv(rhogr,rhogi,afft)
                   call m_FFT_CD0_exx(nfout,afft,INVERSE)
                   call map_FFT_box_on_RHOG_hard_inv(rhor,rhoi,afft)
                   call tstatc0_end(id_sname_cdfft)
                   if(force_mode)then
                      call integrate_QijVnm_rs(iqmk(jkbz,ik),rhor,rhoi,fsr,fsi,qvr,qvi,dfsr,dfsi,dqvr,dqvi,gqvr,gqvi)
                   else
                   if(sw_precalculate==OFF)then
                      call integrate_QijVnm_rs(iqmk(jkbz,ik),rhor,rhoi,fsr,fsi,qvr,qvi)
                   else
                      call integrate_QijVnm_rs2(iqmk(jkbz,ik),rhor,rhoi, &
                    & fsrqm(:,:,m,jkbz,ispin),fsiqm(:,:,m,jkbz,ispin),qvr,qvi)
                   endif
                   endif
                else
                   if(force_mode)then
                      call integrate_QijVnm(iqmk(jkbz,ik),rhogr,rhogi,fsr,fsi,qvr,qvi,dfsr,dfsi,dqvr,dqvi,gqvr,gqvi)
                   else
                      call integrate_QijVnm(iqmk(jkbz,ik),rhogr,rhogi,fsr,fsi,qvr,qvi)
                   endif
                endif
             endif
! =============================================================== 12.5Exp
             if(.not.force_mode)then
                call map_RHOG_on_FFT_box(rhogr,rhogi,phi)
             endif
          end if

          if(force_mode)then
             sumqvr = sumqvr + occupation * qvr ! sum_m qvr_m
             sumqvi = sumqvi + occupation * qvi ! sum_m qvi_m
             sumdqvr = sumdqvr + occupation * (dqvr+gqvr) ! sum_m (dqvr_m + gqvr_m)
             sumdqvi = sumdqvi + occupation * (dqvi+gqvi) ! sum_m (dqvi_m + gqvi_m)
          else
             call m_FFT_WF(ELECTRON,nfout,phi,INVERSE,OFF) ! phi(R)
             call product_on_FFT_box(phi,wfm,rho) ! delta(R)
             sumdel = sumdel + occupation * rho ! sum delta(R)
             !! Bin = Sum_m fm * Hi[Vnm]
             if(modnrm == EXECUT) then
                sumqvr = sumqvr + occupation * qvr ! sum_m qvr_m
                sumqvi = sumqvi + occupation * qvi ! sum_m qvi_m
             end if
          endif
       end do 
    end do 
    if(force_mode)then
       !! dEXX/dR(n) = Sum_i Re[ <psi_n|dbeta_i/dR> * Bin +  <psi_n|beta_i> * Cin ]
       call sum_EXX_force_terms(force_l,bdwr,bdwi,dbdwr,dbdwi,sumqvr,sumqvi,sumdqvr,sumdqvi)
    else
       call m_FFT_WF(ELECTRON,nfout,sumdel,DIRECT,OFF) ! sum delta(G)
       if(kimg==1) then
          call map_FFT_box_on_WFG(ik,vxw(1,1),vxw(1,1),sumdel)
       else
          call map_FFT_box_on_WFG(ik,vxw(1,1),vxw(1,2),sumdel)
       end if

       if(modnrm == EXECUT)  then
          fac = 1.d0/dble(nfftwf)
       else
          fac = 1.d0/dble(nfftwf)**2
          if(present(eexx)) eexx = eexx*fac
       end if
       vxw = fac*vxw
       if(modnrm == EXECUT) then
          call add_Vx_hard_part(ik,vxw,sumqvr,sumqvi)
       endif
    endif
    deallocate(rho)
    deallocate(phi)
    deallocate(wfn)
    deallocate(wfm)
    deallocate(sumdel)
    deallocate(rhogr)
    if(kimg==2) deallocate(rhogi)
    deallocate(wfsr)
    if(kimg==2) deallocate(wfsi)
    deallocate(cosgt)
    if(kimg==2) deallocate(singt)
    if(modnrm == EXECUT) then
       deallocate(fsr)
       deallocate(fsi)
       deallocate(qvr)
       deallocate(qvi)
       deallocate(sumqvr)
       deallocate(sumqvi)
       if(force_mode)then
          deallocate(dfsr)
          deallocate(dfsi)
          deallocate(dqvr)
          deallocate(dqvi)
          deallocate(gqvr)
          deallocate(gqvi)
          deallocate(sumdqvr)
          deallocate(sumdqvi)
       endif
    end if

    if(sw_rspace_hyb==ON.and.modnrm==EXECUT)then
       deallocate(rhor)
       deallocate(rhoi)
       deallocate(afft)
    endif

    call tstatc0_end(id_sname)
  end subroutine apply_Vx_to_WF


  subroutine m_ES_EXX_energy2(eexx)
    implicit none
    real(kind=DP), intent(out) :: eexx
    real(kind=DP) :: eexx_mpi
    integer :: ispin,ik,ib,ib1,ierr
    eexx = 0.0d0
    do ispin=1,nspin,af+1
       do ik=ispin, kv3+ispin-nspin, nspin
          if(map_k(ik) /= myrank_k) cycle ! MPI
          do ib=1,np_e   ! MPI
             if(occup_l(ib,ik) < DELTA) cycle
             eexx = eexx + eexx_kb(ib,ik)
          enddo
       enddo
    enddo
    eexx = 0.5d0*eexx/dble(kv3/nspin)
    if(nspin==1) eexx = 2.d0 * eexx

    if(npes>1) then
       call mpi_allreduce(eexx,eexx_mpi,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)
       eexx = eexx_mpi
    end if

  end subroutine m_ES_EXX_energy2

  subroutine m_ES_EXX_energy(eexx)
    implicit none
    real(kind=DP), intent(out) :: eexx
    integer :: ispin,ik
    integer :: id_sname=-1
    call tstatc0_begin('m_ES_EXX_energy ',id_sname,level=1)

    do ispin=1,nspin,af+1
       do ik=ispin, kv3+ispin-nspin, nspin
          if(map_k(ik) /= myrank_k) cycle ! MPI
          call m_ES_EXX_eigenvalue_for_each_k(ispin,ik,.false.,iupdate=2)
       enddo
    enddo
    call m_ES_EXX_energy2(eexx)

    call tstatc0_end(id_sname)
  end subroutine m_ES_EXX_energy

  subroutine product_on_FFT_box(wfn,wfm,rho)
    implicit none
    real(kind=DP), intent(in), dimension(nfft) :: wfn,wfm
    real(kind=DP), intent(out), dimension(nfft) :: rho

    integer :: i, ire, iim, ik

    if(kv3/nspin==1 .and. k_symmetry(1) == GAMMA) then
       do i=1,nfft,2
          ire = i
          iim = i+1
          rho(ire) = wfn(ire)*wfm(ire)
          rho(iim) = 0.d0
       end do
    else
       do i=1,nfft,2
          ire = i
          iim = i+1
          rho(ire) = wfn(ire)*wfm(ire) + wfn(iim)*wfm(iim)
          rho(iim) = wfn(ire)*wfm(iim) - wfn(iim)*wfm(ire)
       end do
    end if
  end subroutine product_on_FFT_box


  subroutine sum_rho_vc_rho(rhor,rhoi,vc,exx)
    implicit none
    real(kind=DP), intent(in), dimension(nmax_G_hyb) :: rhor,rhoi
    real(kind=DP), intent(in), dimension(nmax_G_hyb) :: vc
    real(kind=DP), intent(out) :: exx

    integer :: ig

    exx = 0.d0

    if(kimg==1) then
       do ig=1,nmax_G_hyb
          exx = exx + vc(ig) * rhor(ig)*rhor(ig)
       end do
    else
       do ig=1,nmax_G_hyb
          exx = exx + vc(ig) * (rhor(ig)*rhor(ig)+rhoi(ig)*rhoi(ig))
       end do
    end if
  end subroutine sum_rho_vc_rho

  subroutine map_WFG_on_FFT_box(ik,wfr,wfi,bfft)
    implicit none
    integer, intent(in)                         :: ik
    real(kind=DP), intent(in), dimension(kg1)   :: wfr, wfi
    real(kind=DP), intent(out), dimension(nfft) :: bfft

    integer :: i,i1,ri, j, i2, ii

    bfft = 0.d0
    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          i1 = igf(1)
          bfft(i1) = wfr(1)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba(ik)
             i = nbase(ii,ik)
             i1 = igf(i)
             bfft(i1) = wfr(ii)
             j = nbase_gamma(ii,2)
             i2 = igf(j)
             bfft(i2) = wfr(ii)
          end do
       else ! kimg == 2
          i1 = 2*igf(1) - 1
          bfft(i1)   = wfr(1)
          bfft(i1+1) = wfi(1)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba(ik)
             i = nbase(ii,ik)
             i1 = 2*igf(i)-1
             bfft(i1  ) = wfr(ii)
             bfft(i1+1) = wfi(ii)
             j = nbase_gamma(ii,2)
             i2 = 2*igf(j)-1
             bfft(i2  ) = wfr(ii)
             bfft(i2+1) = -wfi(ii)
          end do
       end if
    else
      if(kimg == 1) then 
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
        do i = 1, iba(ik)
           i1 = igf(nbase(i,ik))
           bfft(i1) = wfr(i)
        end do
      else ! kimg == 2
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
        do i = 1, iba(ik)
           i1 = 2*igf(nbase(i,ik)) - 1
           bfft(i1) = wfr(i)
           i2 = 2*igf(nbase(i,ik))
           bfft(i2) = wfi(i)
        end do
      end if
    end if
  end subroutine map_WFG_on_FFT_box

  subroutine map_Rot_WFG_on_FFT_box(ik,nop,jtrs,wfr,wfi,bfft)
    implicit none
    integer, intent(in)                         :: ik,nop,jtrs
    real(kind=DP), intent(in), dimension(kg1)   :: wfr, wfi
    real(kind=DP), intent(out), dimension(nfft) :: bfft

    integer :: i,i1,ri, j, i2, ii, ip

    bfft = 0.d0
    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          i1 = igf(1)
          bfft(i1) = wfr(1)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba(ik)
             i = nbase(ii,ik)
             i1 = igf(ngpt_exx(i,nop,jtrs))
             bfft(i1) = wfr(ii)
             j = nbase_gamma(ii,2)
             i2 = igf(ngpt_exx(j,nop,jtrs))
             bfft(i2) = wfr(ii)
          end do
       else ! kimg == 2
          i1 = 2*igf(1) - 1
          bfft(i1)   = wfr(1)
          bfft(i1+1) = wfi(1)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba(ik)
             i = nbase(ii,ik)
             i1 = 2*igf(ngpt_exx(i,nop,jtrs))-1
             bfft(i1  ) = wfr(ii)
             bfft(i1+1) = wfi(ii)
             j = nbase_gamma(ii,2)
             i2 = 2*igf(ngpt_exx(j,nop,jtrs))-1
             bfft(i2  ) = wfr(ii)
             bfft(i2+1) = -wfi(ii)
          end do
       end if
    else
      if(kimg == 1) then 
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
        do i = 1, iba(ik)
           i1 = igf(ngpt_exx(nbase(i,ik),nop,jtrs))
           bfft(i1) = wfr(i)
        end do
      else ! kimg == 2
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
        do i = 1, iba(ik)
           ip = igf(ngpt_exx(nbase(i,ik),nop,jtrs))
           i1 = 2*ip - 1
           bfft(i1) = wfr(i)
           i2 = 2*ip
           bfft(i2) = wfi(i)
        end do
      end if
    end if
  end subroutine map_Rot_WFG_on_FFT_box

  subroutine map_FFT_box_on_WFG(ik,wfr,wfi,bfft)
    implicit none
    integer, intent(in)                        :: ik
    real(kind=DP), intent(out), dimension(kg1) :: wfr, wfi
    real(kind=DP), intent(in), dimension(nfft) :: bfft

    integer :: i,i1,ri, j, i2, ii

    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          wfr = 0.d0

          i1 = igf(1)
          wfr(1) = bfft(i1)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba(ik)
             i = nbase(ii,ik)
             i1 = igf(i)
             wfr(ii) = bfft(i1)
          end do
       else ! kimg == 2
          wfr = 0.d0
          wfi = 0.d0

          i1 = 2*igf(1) - 1
          wfr(1) = bfft(i1)
          wfi(1) = bfft(i1+1)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba(ik)
             i = nbase(ii,ik)
             i1 = 2*igf(i)-1
             wfr(ii) = bfft(i1  )
             wfi(ii) = bfft(i1+1)
          end do
       end if
    else
       if(kimg == 1) then
          wfr = 0.d0
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do i = 1, iba(ik)
             i1 = igf(nbase(i,ik))
             wfr(i) = bfft(i1)
          end do
       else ! kimg == 2
          wfr = 0.d0
          wfi = 0.d0
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do i = 1, iba(ik)
             i1 = 2*igf(nbase(i,ik)) - 1
             wfr(i) = bfft(i1)
             i2 = 2*igf(nbase(i,ik))
             wfi(i) = bfft(i2)
          end do
       end if
    end if
  end subroutine map_FFT_box_on_WFG

  subroutine map_FFT_box_on_RHOG(rhor,rhoi,afft)
    implicit none
    real(kind=DP), intent(out), dimension(nmax_G_hyb) :: rhor, rhoi
    real(kind=DP), intent(in), dimension(nfft) :: afft

    integer :: i,i1,i2

    if(kimg == 1) then
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
       do i = 1, min( kg, nmax_G_hyb )
          i1 = igf(i)
          rhor(i) = afft(i1)
       end do
    else ! kimg==2
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
       do i = 1, min( kg, nmax_G_hyb )
          i1 = 2*igf(i) - 1
          rhor(i) = afft(i1)
          i2 = 2*igf(i)
          rhoi(i) = afft(i2)
       end do
    end if
  end subroutine map_FFT_box_on_RHOG

  subroutine map_RHOG_on_FFT_box(rhor,rhoi,afft)
    implicit none
    real(kind=DP), intent(in), dimension(nmax_G_hyb) :: rhor, rhoi
    real(kind=DP), intent(out), dimension(nfft) :: afft

    integer :: i,i1,i2

    afft = 0.d0

    if(kimg == 1) then
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
       do i = 1, min( kg, nmax_G_hyb )
          i1 = igf(i)
          afft(i1) = rhor(i)
       end do
    else ! kimg==2
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
       do i = 1, min( kg, nmax_G_hyb )
          i1 = 2*igf(i) - 1
          afft(i1) = rhor(i)
          i2 = 2*igf(i)
          afft(i2) = rhoi(i)
       end do
    end if
  end subroutine map_RHOG_on_FFT_box

  subroutine map_RHOG_on_FFT_box_hard(rhor,rhoi,afft)
    implicit none
    real(kind=DP), intent(in), dimension(nfftp_exx_nonpara/2) :: rhor, rhoi
    real(kind=DP), intent(out), dimension(nfftp_exx_nonpara) :: afft

    integer :: i,i1,i2

!    afft(:) = 0.d0
    do i = 1, nfftp_exx_nonpara/2
!       i1 = (igfp_l(i)-1)*kimg+1
       i1 = (i-1)*kimg+1
       afft(i1)   = rhor(i)
       afft(i1+1) = rhoi(i)
    end do
  end subroutine map_RHOG_on_FFT_box_hard

  subroutine map_RHOG_on_FFT_box_hard_inv(rhor,rhoi,afft)
    implicit none
    real(kind=DP), intent(in), dimension(nfftp_exx_nonpara/2) :: rhor, rhoi
    real(kind=DP), intent(out), dimension(nfftp_exx_nonpara) :: afft
    integer :: i,i1,i2

    afft(:) = 0.d0

    do i = 1, kgp_exx
       i1 = (igfp_exx(i)-1)*kimg+1
       afft(i1) = rhor(i)
       afft(i1+1) = rhoi(i)
    end do
  end subroutine map_RHOG_on_FFT_box_hard_inv

  subroutine map_FFT_box_on_RHOG_hard(rhor,rhoi,afft)
    implicit none
    real(kind=DP), intent(in), dimension(nfftp_exx_nonpara) :: afft
    real(kind=DP), intent(out), dimension(nfftp_exx_nonpara/2) :: rhor, rhoi
    real(kind=DP) :: rinplw
    integer :: i,i1,i2

    rinplw = 1.d0/product(fft_box_size_CD_exx(1:3,1))
    rhor(:)=0.d0
    rhoi(:)=0.d0
    do i = 1, kgp_exx
       i1 = (igfp_exx(i)-1)*kimg+1
       rhor(i) = afft(i1)*rinplw
       rhoi(i) = afft(i1+1)*rinplw
    end do
  end subroutine map_FFT_box_on_RHOG_hard

  subroutine map_FFT_box_on_RHOG_hard_inv(rhor,rhoi,afft)
    implicit none
    real(kind=DP), intent(in), dimension(nfftp_exx_nonpara) :: afft
    real(kind=DP), intent(out), dimension(nfftp_exx_nonpara/2) :: rhor, rhoi
    real(kind=DP) :: rinplw
    integer :: i,i1,i2

    rinplw = 1.d0/product(fft_box_size_CD_exx(1:3,1))
!    rhor(:)=0.d0
!    rhoi(:)=0.d0
    do i = 1, nfftp_exx_nonpara/2
       i1 = (i-1)*kimg+1
       rhor(i) = afft(i1)*rinplw 
       rhoi(i) = afft(i1+1)*rinplw
    end do
  end subroutine map_FFT_box_on_RHOG_hard_inv

  subroutine m_ES_EXX_ngpt()
    implicit none

    integer :: i,j,iopr,ii
    integer :: ia,ib,ic
    integer :: namin,namax,nbmin,nbmax,ncmin,ncmax
    integer, allocatable, dimension(:,:,:) :: g_list
    integer, allocatable, dimension(:) :: ngpt_exx_tmp, ngpt_exx0_tmp
    integer,save  :: id_sname = -1
    call tstatc0_begin('m_ES_EXX_ngpt ',id_sname,level=1)

!!$    allocate(ngpt_exx(kgp,nopr,0:ntrs)); ngpt_exx = 0
    allocate(ngpt_exx(kg,nopr,0:ntrs)); ngpt_exx = 0

    !! Time reversal symmetry

    if(ntrs>0) then

       namax = n_rGpv(1); nbmax = n_rGpv(2); ncmax = n_rGpv(3)
       namin = -namax   ; nbmin = -nbmax   ; ncmin = -ncmax
       allocate(g_list(namin:namax,nbmin:nbmax,ncmin:ncmax)); g_list = 0

       do i = 1, kgp
          ia = ngabc(i,1)
          ib = ngabc(i,2)
          ic = ngabc(i,3)
          g_list(ia,ib,ic) = i
       end do
    end if

    if(npes > 1) then
       allocate(ngpt_exx0_tmp(kgp))
       do iopr=1,nopr
          ngpt_exx0_tmp = 0
          do i = ista_kngp, iend_kngp
             ngpt_exx0_tmp(i) = ngpt_l(i,iopr)
          end do
          call mpi_allreduce(MPI_IN_PLACE,ngpt_exx0_tmp,kgp,mpi_integer,mpi_sum,mpi_comm_group,ierr)
          ngpt_exx(1:kg,iopr,0) = ngpt_exx0_tmp(1:kg)

          if(ntrs>0) then
             allocate(ngpt_exx_tmp(kg))
             ngpt_exx_tmp = 0
             do i=1,kg
                ii = ngpt_exx0_tmp(i)
                ia = -ngabc(ii,1)
                ib = -ngabc(ii,2)
                ic = -ngabc(ii,3)
                ngpt_exx_tmp(i) = g_list(ia,ib,ic)
             end do
             ngpt_exx(1:kg,iopr,1) = ngpt_exx_tmp(1:kg)
          end if
       end do
       deallocate(ngpt_exx0_tmp)
    else
       do iopr=1,nopr
          if(ntrs==0) then
             do i = 1, kg
                ngpt_exx(i,iopr,0) = ngpt_l(i,iopr)
             end do
          else
             do i = 1, kg
                ngpt_exx(i,iopr,0) = ngpt_l(i,iopr)
                ii = ngpt_l(i,iopr)
                ia = -ngabc(ii,1)
                ib = -ngabc(ii,2)
                ic = -ngabc(ii,3)
                ngpt_exx(i,iopr,1) = g_list(ia,ib,ic)
             end do
          end if
       end do
    end if

!!$    allocate(ngpt_exx_tmp(kgp))
!!$    do iopr=1,nopr
!!$       ngpt_exx_tmp = 0
!!$       do i=1,kgp
!!$          ii = ngpt_exx(i,iopr,0)
!!$          if(ista_kngp<=ii .and. ii<=iend_kngp) then
!!$             ia = -ngabc_kngp_l(ii,1)
!!$             ib = -ngabc_kngp_l(ii,2)
!!$             ic = -ngabc_kngp_l(ii,3)
!!$             ngpt_exx_tmp(i) = g_list(ia,ib,ic)
!!$          end if
!!$       end do
!!$       call mpi_allreduce(MPI_IN_PLACE, ngpt_exx_tmp, kgp, mpi_integer, mpi_sum,mpi_ke_world,ierr)
!!$       ngpt_exx(:,iopr,1) = ngpt_exx_tmp(:)
!!$    end do
!!$    deallocate(ngpt_exx_tmp)
!!$    
!!$          ia = -ngabc(ii,1)
!!$          ib = -ngabc(ii,2)
!!$          ic = -ngabc(ii,3)
!!$          ngpt_exx(i,iopr,1) = g_list(ia,ib,ic)
!!$       end do
!!$    end do
    if(ntrs>0) deallocate(g_list)

    j = 0
    do ii = 0, ntrs
       do iopr = 1, nopr
          do i = 1, kg
             if(ngpt_exx(i,iopr,ii) <= 0) j = j + 1
          end do
       end do
    end do
    if(j >= 1) then
       write(nfout,'(" !! check of ngpt_exx")')
       do ii = 0, ntrs
          do iopr = 1, nopr
             do i = 1, kg
                if(ngpt_exx(i,iopr,ii) <= 0) write(nfout,'(" ngpt_exx(",i8,",",i8,",",i8,") = ",i20)') &
                & i,iopr,ii, ngpt_exx(i,iopr,ii)
             end do
          end do
       end do
       write(nfout,'(" !! total number of negative values for ngpt_exx = ",i8)') j
       write(nfout,'(" !! out of check of ngpt_exx")')
    end if

    call tstatc0_end(id_sname)
    !!!stop 'Check: G_list'
  end subroutine m_ES_EXX_ngpt

  subroutine m_ES_EXX_occup(nfout)
    implicit none
    integer, intent(in) :: nfout

    real(kind=DP) :: chgt, chg(nspin), zet
    integer :: ik,ib,is,it
    integer,save  :: id_sname = -1
    call tstatc0_begin('m_ES_EXX_occup ',id_sname,level=1)

    chg(1:nspin) = 0.d0
    do it=1,ntyp
       chgt = ival(it) * iatom(it) + qex(it)
       if(nspin==1) then
          chg(1) = chg(1) + chgt
       else
          zet = zeta1(it)
          chg(1) = chg(1) + chgt * (1.d0+zet)/2.d0
          chg(2) = chg(2) + chgt * (1.d0-zet)/2.d0
       end if
    end do
    if(nspin==1) chg(1) = chg(1)/2.d0

    nval = nint(maxval(chg)+0.1d0)

    occup_l(1:np_e,ista_k:iend_k) = 0.d0
    do ik=1,kv3,af+1
       if(map_k(ik) /= myrank_k) cycle ! MPI
       do ib=ista_e,iend_e,istep_e
          !!if(ib>nval) cycle
          if(neordr(ib,ik)>nval) cycle
          occup_l(map_z(ib),ik) = kv3*qwgt(ik)
       end do
    end do
    call tstatc0_end(id_sname)
  end subroutine m_ES_EXX_occup

  subroutine m_ES_EXX_store_wfv()
    implicit none
    if(.not.allocated(wfv_old)) allocate(wfv_old(kg1,nval,kv3,kimg))
    if(.not.allocated(occup_val_old)) allocate(occup_val_old(nval,kv3))
    if(modnrm == EXECUT) then
       if(.not.allocated(fsr_exx_old)) allocate(fsr_exx_old(nval,nlmta,kv3))
       if(.not.allocated(fsi_exx_old)) allocate(fsi_exx_old(nval,nlmta,kv3))
    end if

    wfv_old  = wfv
    occup_val_old = occup_val
    nval_old = nval
    if(modnrm == EXECUT) then
       fsr_exx_old = fsr_exx
       fsi_exx_old = fsi_exx
    end if
  end subroutine m_ES_EXX_store_wfv

  subroutine m_ES_EXX_restore_wfv()
    implicit none
    if(allocated(wfv)) deallocate(wfv)
    if(allocated(occup_val)) deallocate(occup_val)
    if(modnrm == EXECUT) then
       if(allocated(fsr_exx)) deallocate(fsr_exx)
       if(allocated(fsi_exx)) deallocate(fsi_exx)
    end if
    nval = nval_old
    allocate(wfv(kg1,nval,kv3,kimg))
    allocate(occup_val(nval,kv3))
    if(modnrm == EXECUT) then
       allocate(fsr_exx(nval,nlmta,kv3))
       allocate(fsi_exx(nval,nlmta,kv3))
    end if
    wfv = wfv_old
    occup_val = occup_val_old
    if(modnrm == EXECUT) then
       fsr_exx = fsr_exx_old
       fsi_exx = fsi_exx_old
    end if
    deallocate(wfv_old)
    deallocate(occup_val_old)
    if(modnrm == EXECUT) then
       deallocate(fsr_exx_old)
       deallocate(fsi_exx_old)
    end if
  end subroutine m_ES_EXX_restore_wfv

  function q_on_k_centered_mesh(iq,ik) result(ltf)
    implicit none
    integer, intent(in) :: iq, ik

    logical :: ltf
    real(kind=DP) :: qv(3), kv(3) 
    integer :: dv(3)

    qv(1:3) = vkbz(iq,1:3)
    kv(1:3) = vkxyz(ik,1:3,BUCS)
 
    dv(1:3) = nint( (qv(1:3) - kv(1:3)) * n_bz_mesh(1:3) )

    ltf = .false.
    if(mod(dv(1),reduction_factor_exx(1)) == 0 .and. &
     & mod(dv(2),reduction_factor_exx(2)) == 0 .and. &
     & mod(dv(3),reduction_factor_exx(3)) == 0 ) then
       ltf = .true.
    end if
  end function q_on_k_centered_mesh

!! For debug
  function check_ibz_k(ik) result(ltf)
    implicit none
    integer, intent(in) :: ik

    logical :: ltf
    real(kind=DP) :: vkx, vky, vkz

    open(1000,file="ibz.data")
    read(1000,*) vkx, vky, vkz
    close(1000)

    ltf = .true.
    if(abs(vkxyz(ik,1,BUCS) - vkx) < DELTA07 .and. & 
     & abs(vkxyz(ik,2,BUCS) - vky) < DELTA07 .and. & 
     & abs(vkxyz(ik,3,BUCS) - vkz) < DELTA07 ) then
       ltf = .false.
       write(nfout,'("IBZ k: ",3f20.5)') vkxyz(ik,1:3,BUCS)
    end if
  end function check_ibz_k

  function check_bz_k(ik) result(ltf)
    implicit none
    integer, intent(in) :: ik

    logical :: ltf
    real(kind=DP) :: vkx, vky, vkz

    open(1100,file="bz.data")
    read(1100,*) vkx, vky, vkz
    close(1100)

    ltf = .true.
    if(abs(vkbz(ik,1) - vkx) < DELTA07 .and. &
     & abs(vkbz(ik,2) - vky) < DELTA07 .and. &
     & abs(vkbz(ik,3) - vkz) < DELTA07 ) then
       write(nfout,'(" BZ k: ",3f20.5)') vkbz(ik,1:3)
       ltf = .false.
    end if
  end function check_bz_k

!! For ultrasoft pseudopotentials 
#ifndef MEMORY_SAVE_EXX
  subroutine m_ES_EXX_ylm()
    implicit none

    integer :: i,n,ik,ig
    real(kind=DP), allocatable, dimension(:) :: ylm_t ! d(kngp,n)
    real(kind=DP), allocatable, dimension(:,:) :: gqmk ! d(ista_kngp:iend_kngp,3)
    real(kind=DP), allocatable, dimension(:) :: gqmkr ! d(ista_kngp:iend_kngp)

    real(kind=DP) :: kg(3), ttr(6), g2
    integer,save  :: id_sname = -1
    call tstatc0_begin('m_ES_EXX_ylm ',id_sname,level=1)

    call getttr(rltv,ttr)

    call m_PP_find_maximum_l(n)    ! n-1: maximum l
    n = (n-1) + (n-1) + 1
    n = n*n
    if(.not.allocated(ylm_exx)) allocate(ylm_exx(nmax_G_hyb,n,nqmk))

    allocate(gqmk(ista_kngp:iend_kngp,3))
    allocate(gqmkr(ista_kngp:iend_kngp))
    do ik=1,nqmk
       do ig=ista_kngp,iend_kngp
          kg(1:3) = qmk(ik,1:3) + ngabc(ig,1:3)
          g2          = ttr(1)*kg(1)*kg(1) &
          &           + ttr(2)*kg(2)*kg(2) &
          &           + ttr(3)*kg(3)*kg(3) &
          &           + ttr(4)*kg(1)*kg(2) &
          &           + ttr(5)*kg(2)*kg(3) &
          &           + ttr(6)*kg(3)*kg(1)
          gqmk(ig,1:3) = kg(1:3)
          gqmkr(ig) = sqrt(g2)
       end do
       if(npes > 1) then
          allocate(ylm_t(kgp))
          do i=1,n
             ylm_t = 0.d0
             call m_pwBS_sphrp_exx(i,rltv,ista_kngp,iend_kngp,gqmk,gqmkr,ylm_t(ista_kngp:iend_kngp))
             call mpi_allreduce(ylm_t,ylm_exx(1,i,ik),nmax_G_hyb,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
          end do
          deallocate(ylm_t)
       else
          do i=1,n
             call m_pwBS_sphrp_exx(i,rltv,1,nmax_G_hyb,gqmk,gqmkr,ylm_exx(1,i,ik))
          end do
       end if

    end do
    !!stop 'm_ES_EXX_ylm'
    deallocate(gqmk)
    deallocate(gqmkr)

    call tstatc0_end(id_sname)
  end subroutine m_ES_EXX_ylm
#else
  subroutine m_ES_EXX_ylm_each_k(ik)
     implicit none
     integer, intent(in) :: ik
     real(kind=DP), allocatable, dimension(:,:) :: gqmk ! d(kgp,3)
     real(kind=DP), allocatable, dimension(:) :: gqmkr ! d(kgp)
     integer :: i, n, ig

     real(kind=DP) :: kg(3), ttr(6), g2
     integer,save  :: id_sname = -1
     call tstatc0_begin('m_ES_EXX_ylm ', id_sname, level=1)

     call getttr(rltv,ttr)

     call m_PP_find_maximum_l(n) ! n-1: maximum l
     n = (n-1) + (n-1) + 1
     n = n*n
     if(.not. allocated(ylm_exx)) allocate(ylm_exx(nmax_G_hyb,n))

     allocate(gqmk(kgp,3))
     allocate(gqmkr(kgp))
     do ig = 1, kgp
          kg(1:3) = qmk(ik,1:3) + ngabc(ig,1:3)
          g2          = ttr(1)*kg(1)*kg(1) &
          &           + ttr(2)*kg(2)*kg(2) &
          &           + ttr(3)*kg(3)*kg(3) &
          &           + ttr(4)*kg(1)*kg(2) &
          &           + ttr(5)*kg(2)*kg(3) &
          &           + ttr(6)*kg(3)*kg(1)
          gqmk(ig,1:3) = kg(1:3)
          gqmkr(ig) = sqrt(g2)
     end do
     do i = 1, n
        call m_pwBS_sphrp_exx(i,rltv,1,nmax_G_hyb,gqmk,gqmkr,ylm_exx(1,i))
     end do
     deallocate(gqmk)
     deallocate(gqmkr)

     call tstatc0_end(id_sname)
  end subroutine m_ES_EXX_ylm_each_k
#endif

#ifndef MEMORY_SAVE_MORE_EXX
  subroutine check_qitg()
    implicit none
    integer :: iq, ips , ipe

    ips = 1
    ipe = nmax_G_hyb

    do iq=1,nqitg
       write(nfout,'("iq=",i5,1x,"qitg_l=",f20.5,1x,"qitg_exx=",f20.5,1x)') iq, qitg_l(ips,iq), qitg_exx(ips,iq,1)/univol
    end do

    do iq=1,nqitg
       write(nfout,'("iq=",i5,1x,"diff=",f20.5)') iq, sum(qitg_l(ips:ipe,iq)-qitg_exx(ips:ipe,iq,1)/univol)
    end do

    stop 'check_qitg'
  end subroutine check_qitg

  subroutine check_qitg_qmk()
    implicit none
    integer :: iq, ik, ips, ipe

    ips = 1
    ipe = nmax_G_hyb

    do ik=1,nqmk
    do iq=1,nqitg
       write(nfout,'("iq=",i5,1x,"qitg_exx=",f20.5,1x)') iq, qitg_exx(ips,iq,ik)/univol
    end do
    end do

    do ik=1,nqmk
    do iq=1,nqitg
       write(nfout,'("iq=",i5,1x,"sum=",f20.5)') iq, sum(qitg_exx(ips:ipe,iq,ik)/univol)
    end do
    end do

    stop 'check_qitg_qmk'
  end subroutine check_qitg_qmk
#endif

#ifndef MEMORY_SAVE_EXX
  subroutine check_ylm_exx()
    implicit none
    integer :: i, n, ik, ips, ipe

    call m_PP_find_maximum_l(n)    ! n-1: maximum l
    n = (n-1) + (n-1) + 1
    n = n*n

    ips = 1
    ipe = nmax_G_hyb

    do ik=1,nqmk
    do i=1,n
       write(nfout,'("i=",i5,1x,"ylm_exx=",f20.5,1x)') i, ylm_exx(ips,i,ik)
    end do
    end do

    do ik=1,nqmk
    do i=1,n
       write(nfout,'("i=",i5,1x,"sum=",f20.5)')  i, sum(qitg_exx(ips:ipe,i,ik))
    end do
    end do

    stop 'check_ylm_exx'
  end subroutine check_ylm_exx
#endif

  subroutine hard_part_preproc()
    integer :: it,ncache
    call m_PP_find_maximum_l(n)    ! n-1: maximum l
    n = (n-1) + (n-1) + 1
    allocate(il3(n**2))
    call substitute_il3(n**2,il3) ! -(b_Elec..)

    allocate(nqitg_sp(ntyp)); allocate(nqitg_sp0(ntyp))
    allocate(iq2l3(nqitg))
    allocate(nc(mcritical,nqitg));nc=0
! =================================== Added by K. Tagami =======
    nqitg_sp = 0; nqitg_sp0 = 0; iq2l3 = 0
! ==============================================================
    call m_PP_set_index_arrays1(nfout,ntyp,nqitg,mcritical,n**2,il3 &
    & ,maxm,mc,nqitg_sp,nqitg_sp0,iq2l3,nc,.true.)
    allocate(nc2lmt1(mc,maxm,nqitg))
    allocate(nc2lmt2(mc,maxm,nqitg))
    allocate(nc2n(mc,maxm,nqitg))
! ==================================== Added by K. Tagami ======
    nc2lmt1 = 0;  nc2lmt2 = 0; nc2n = 0
! =============================================================
    call m_PP_set_index_arrays2(nfout,mc,maxm,nqitg,mcritical,n**2,il3,iq2l3 &
    & ,nc2lmt1,nc2lmt2,nc2n,nc,.true.) ! -> nc2lmt1, nc2lmt2, nc2n, nc

    ncache = (m_CtrlP_cachesize()*1024)*3/4
    if(ncache == 0) then
       ibsize =  nmax_G_hyb
    else
       iwidth = 0
       do it = 1, ntyp
          iwidth = max(iwidth,nqitg_sp(it)-nqitg_sp0(it)+1)
       end do
       ibsize=ncache/(8*(iwidth + 2))
    end if
#ifdef HYB_DISABLE_BLOCKING
    ibsize = nmax_G_hyb
#endif
    preproc_done = .true.
  end subroutine hard_part_preproc


  subroutine add_RHOG_hard_part(iqmk,rhogr,rhogi,fnr,fni,fmr,fmi)
    implicit none
    integer, intent(in) :: iqmk
    real(kind=DP), intent(inout) :: rhogr(nmax_G_hyb)
    real(kind=DP), intent(inout) :: rhogi(nmax_G_hyb)
    real(kind=DP), intent(in) :: fnr(nlmta)
    real(kind=DP), intent(in) :: fni(nlmta)
    real(kind=DP), intent(in) :: fmr(nlmta)
    real(kind=DP), intent(in) :: fmi(nlmta)

    integer :: it,ia,i,lmt1,lmt2,np,il1,il2,tau1,tau2,ilmta1,ilmta2
    integer :: l3,ilm3,iil
    real(kind=DP) :: ph, hr, hi, fac, f0
    real(kind=DP), allocatable :: cosgt(:), singt(:)

    real(kind=DP), allocatable, dimension(:) :: ylm_sum,ylm_sum2

    real(kind=DP), allocatable :: qitg_red(:,:),ylm_red(:,:)
    real(kind=DP), allocatable :: rhogr_red(:),rhogi_red(:)
    real(kind=DP) :: yr,yi
    integer :: ibl1,ibl2,iq,inn,ip,m, ips, ipe

    integer,save  :: id_sname = -1

    call tstatc0_begin('add_RHOG_hard_part ',id_sname,1)

    if(.not.preproc_done) call hard_part_preproc()

    allocate(cosgt(ibsize))
    allocate(singt(ibsize))
    allocate(ylm_sum(ibsize));ylm_sum=0.d0
    allocate(ylm_sum2(ibsize));ylm_sum2=0.d0

    allocate(qitg_red(ibsize,nqitg))
    allocate(ylm_red(ibsize,n*n))
    allocate(rhogr_red(ibsize))
    allocate(rhogi_red(ibsize))
! --
    ips = 1
    ipe = nmax_G_hyb

    do ibl1=ips, ipe, ibsize
       rhogr_red=0.d0;  rhogi_red=0.d0

       ibl2=min(ipe,ibl1+ibsize-1)
       do iq=1,nqitg
          do i=1,ibl2-ibl1+1
#if defined(MEMORY_SAVE_EXX) && defined(MEMORY_SAVE_MORE_EXX)
             qitg_red(i,iq) = qitg_exx(i+ibl1-1,iq)
#else
             qitg_red(i,iq) = qitg_exx(i+ibl1-1,iq,iqmk)
#endif
          enddo
       enddo
       do inn=1,n*n
          do i=1,ibl2-ibl1+1
#ifndef MEMORY_SAVE_EXX
             ylm_red(i,inn) = ylm_exx(i+ibl1-1,inn,iqmk)
#else
             ylm_red(i,inn) = ylm_exx(i+ibl1-1,inn)
#endif
          enddo
       enddo

       do ia=1,natm
          it = ityp(ia)
          if( m_PP_include_vanderbilt_pot(it) == SKIP) cycle
          do i=1,ibl2-ibl1+1
             ph = PAI2 * dot_product(pos(ia,1:3),ngabc(i+ibl1-1,1:3)+qmk(iqmk,1:3))
             cosgt(i) = cos(ph);  singt(i) = sin(ph)
          end do
          do iq = nqitg_sp0(it), nqitg_sp(it)
             l3 = iq2l3(iq)
             iil = mod(l3,4)
             ylm_sum  = 0.d0;  ylm_sum2 = 0.d0

             do m = 1, 2*l3+1
                ilm3 = l3*l3+m
                yr=0.d0;  yi=0.d0

                do ip=1,nc(m,iq)
                   lmt1 = nc2lmt1(ip,m,iq);  lmt2 = nc2lmt2(ip,m,iq)
                   ilmta1 = lmta(lmt1,ia);   ilmta2 = lmta(lmt2,ia)
                   np = nc2n(ip,m,iq)
                   hr = fnr(ilmta1)*fmr(ilmta2) + fni(ilmta1)*fmi(ilmta2)
                   hi = fnr(ilmta1)*fmi(ilmta2) - fni(ilmta1)*fmr(ilmta2)
                   f0 = iwei(ia) * dl2p(lmt1,lmt2,np,it)
                   yr = yr + f0*hr;  yi = yi + f0*hi
                   !do i=1,ibl2-ibl1+1
                   !   ylm_sum(i)  = ylm_sum(i)  + f0*ylm_red(i,ilm3)*hr
                   !   ylm_sum2(i) = ylm_sum2(i) + f0*ylm_red(i,ilm3)*hi
                   !enddo
                enddo
                do i=1,ibl2-ibl1+1
                   ylm_sum(i)  = ylm_sum(i)  + yr*ylm_red(i,ilm3)
                   ylm_sum2(i) = ylm_sum2(i) + yi*ylm_red(i,ilm3)
                enddo
             enddo

             if(iil==0) then
                do i=1,ibl2-ibl1+1
                   fac =  qitg_red(i,iq)
                   rhogr_red(i) = rhogr_red(i) + fac * (cosgt(i)*ylm_sum(i) +singt(i)*ylm_sum2(i))
                   rhogi_red(i) = rhogi_red(i) + fac * (cosgt(i)*ylm_sum2(i)-singt(i)*ylm_sum(i))
                end do
             else if(iil==1) then
                do i=1,ibl2-ibl1+1
                   fac =  qitg_red(i,iq)
                   rhogr_red(i) = rhogr_red(i) + fac * (cosgt(i)*ylm_sum2(i)-singt(i)*ylm_sum(i))
                   rhogi_red(i) = rhogi_red(i) - fac * (cosgt(i)*ylm_sum(i) +singt(i)*ylm_sum2(i))
                end do
             else if(iil==2) then
                do i=1,ibl2-ibl1+1
                   fac =  qitg_red(i,iq)
                   rhogr_red(i) = rhogr_red(i) - fac * (cosgt(i)*ylm_sum(i) +singt(i)*ylm_sum2(i))
                   rhogi_red(i) = rhogi_red(i) - fac * (cosgt(i)*ylm_sum2(i)-singt(i)*ylm_sum(i))
                end do
             else if(iil==3) then
                do i=1,ibl2-ibl1+1
                   fac =  qitg_red(i,iq)
                   rhogr_red(i) = rhogr_red(i) - fac * (cosgt(i)*ylm_sum2(i)-singt(i)*ylm_sum(i))
                   rhogi_red(i) = rhogi_red(i) + fac * (cosgt(i)*ylm_sum(i) +singt(i)*ylm_sum2(i))
                end do
             end if
          enddo
       enddo

       do i=ibl1,ibl2
          rhogr(i) = rhogr(i) + rhogr_red(i-ibl1+1)
          rhogi(i) = rhogi(i) + rhogi_red(i-ibl1+1)
       enddo
       
    enddo
    
    deallocate(cosgt); deallocate(singt)
    deallocate(ylm_sum); deallocate(ylm_sum2)
    deallocate(qitg_red); deallocate(ylm_red)
    deallocate(rhogr_red); deallocate(rhogi_red)

    call tstatc0_end(id_sname)
  end subroutine add_RHOG_hard_part

  subroutine add_RHOG_hard_part_rs2(iqmk,rhor,rhoi,qmfnr,qmfni,fmr,fmi)
    integer, intent(in) :: iqmk
    real(kind=DP), intent(out) :: rhor(nfftp_exx_nonpara/2)
    real(kind=DP), intent(out) :: rhoi(nfftp_exx_nonpara/2)
    real(kind=DP), intent(in) :: qmfnr(nmesh_rs_aug_max,nlmta)
    real(kind=DP), intent(in) :: qmfni(nmesh_rs_aug_max,nlmta)
    real(kind=DP), intent(in) :: fmr(nlmta)
    real(kind=DP), intent(in) :: fmi(nlmta)
    real(kind=DP), dimension(:), allocatable :: cosqmkr,sinqmkr
    real(kind=DP), allocatable, dimension(:) :: rtmp,itmp
    real(kind=DP) :: fr,fi,co,si,qmr,qmi,rr,ii
    integer :: ia,it,lmt1,ilmta1,ind,imesh,nma
    integer,save  :: id_sname = -1
    call tstatc0_begin('add_RHOG_hard_part_rs2 ',id_sname,1)
    allocate(cosqmkr(nmesh_rs_aug_max));cosqmkr=0.d0
    allocate(sinqmkr(nmesh_rs_aug_max));sinqmkr=0.d0
    allocate(rtmp(nmesh_rs_aug_max));rtmp=0.d0
    allocate(itmp(nmesh_rs_aug_max));itmp=0.d0
    rhor(:) = 0.d0;rhoi(:) = 0.d0
    do ia=1,natm
       it = ityp(ia)
       if( m_PP_include_vanderbilt_pot(it) == SKIP) cycle
       call qmk_dot_r(iqmk,ia,cosqmkr,sinqmkr)
       nma = nmesh_rs_aug(ia)
       rtmp=0.d0;itmp=0.d0
       do lmt1=1,ilmt(it)
          ilmta1 = lmta(lmt1,ia)
          fr =  fmr(ilmta1)
          fi = -fmi(ilmta1) ! c.c. of fsr
          do imesh=1,nma
             co =  cosqmkr(imesh)
             si = -sinqmkr(imesh) ! c.c. of exp(i(G+q-k))
             qmr = qmfnr(imesh,ilmta1)
             qmi = qmfni(imesh,ilmta1)
             rr = co*qmr-si*qmi
             ii = co*qmi+si*qmr
             rtmp(imesh) = rtmp(imesh) + rr*fr-ii*fi
             itmp(imesh) = itmp(imesh) + ii*fr+rr*fi
          enddo
       enddo
       do imesh=1,nma
          ind = meshxyz_rs_aug(imesh,ia)
          rhor(ind) = rhor(ind) + rtmp(imesh)
          rhoi(ind) = rhoi(ind) + itmp(imesh)
       enddo
    enddo
    deallocate(cosqmkr) 
    deallocate(sinqmkr) 
    deallocate(rtmp)
    deallocate(itmp)
    call tstatc0_end(id_sname)
  end subroutine add_RHOG_hard_part_rs2

  subroutine add_RHOG_hard_part_rs(iqmk,rhor,rhoi,fnr,fni,fmr,fmi)
    implicit none
    integer, intent(in) :: iqmk
    real(kind=DP), intent(out) :: rhor(nfftp_exx_nonpara/2)
    real(kind=DP), intent(out) :: rhoi(nfftp_exx_nonpara/2)
    real(kind=DP), intent(in) :: fnr(nlmta)
    real(kind=DP), intent(in) :: fni(nlmta)
    real(kind=DP), intent(in) :: fmr(nlmta)
    real(kind=DP), intent(in) :: fmi(nlmta)
    integer :: n,it,ia,imesh,lmt1,lmt2,il1,il2,tau1,tau2,ilmta1,ilmta2,lmtp
    integer :: nma
    real(kind=DP), dimension(:), allocatable :: cosqmkr,sinqmkr
    real(kind=DP) :: rr,ii,si,co,qm,rr0,ii0
    integer :: ind
    real(kind=DP), allocatable, dimension(:) :: rtmp,itmp
    real(kind=DP) :: fac
    integer,save  :: id_sname = -1
    call tstatc0_begin('add_RHOG_hard_part_rs ',id_sname,1)
    allocate(cosqmkr(nmesh_rs_aug_max));cosqmkr=0.d0
    allocate(sinqmkr(nmesh_rs_aug_max));sinqmkr=0.d0
    allocate(rtmp(nmesh_rs_aug_max));rtmp=0.d0
    allocate(itmp(nmesh_rs_aug_max));itmp=0.d0
    rhor(:) = 0.d0;rhoi(:) = 0.d0
    do ia=1,natm
       it = ityp(ia)
       if( m_PP_include_vanderbilt_pot(it) == SKIP) cycle
       call qmk_dot_r(iqmk,ia,cosqmkr,sinqmkr)
       nma = nmesh_rs_aug(ia)
       rtmp=0.d0;itmp=0.d0
       do lmtp = 1,nlmtpair(ia)
          lmt1 = plmt1(lmtp,ia)
          lmt2 = plmt2(lmtp,ia)
          ilmta1 = lmta(lmt1,ia)
          ilmta2 = lmta(lmt2,ia)
          rr = fnr(ilmta1)*fmr(ilmta2) + fni(ilmta1)*fmi(ilmta2)
          ii = fnr(ilmta1)*fmi(ilmta2) - fni(ilmta1)*fmr(ilmta2)
          if(lmt1.ne.lmt2)then
            rr = rr+fnr(ilmta2)*fmr(ilmta1) + fni(ilmta2)*fmi(ilmta1)
            ii = ii+fnr(ilmta2)*fmi(ilmta1) - fni(ilmta2)*fmr(ilmta1)
          endif
          do imesh=1,nma
             co = cosqmkr(imesh)
             si = sinqmkr(imesh)
             qm = qr_clm_ylm(imesh,ia,lmtp)
             rtmp(imesh) = rtmp(imesh) + qm*(rr*co+ii*si)
             itmp(imesh) = itmp(imesh) + qm*(ii*co-rr*si)
          enddo
       enddo
       do imesh=1,nma
          ind = meshxyz_rs_aug(imesh,ia)
          rhor(ind) = rhor(ind) + rtmp(imesh)
          rhoi(ind) = rhoi(ind) + itmp(imesh)
       enddo
    enddo
    deallocate(cosqmkr)
    deallocate(sinqmkr)
    deallocate(rtmp)
    deallocate(itmp)
    call tstatc0_end(id_sname)
  end subroutine add_RHOG_hard_part_rs

  subroutine qmk_dot_r(iqmk,ia,zc_ar,zs_ar)
    integer, intent(in) :: iqmk,ia 
    real(kind=DP),dimension(nmesh_rs_aug_max),intent(out) :: zc_ar,zs_ar
    integer :: i
    real(kind=DP) :: inl,inm,inn
    real(kind=DP) :: rx,ry,rz,kdr
    integer :: id_sname = -1
    inl = 1.d0/dble(fft_box_size_CD_exx(1,1))
    inm = 1.d0/dble(fft_box_size_CD_exx(2,1))
    inn = 1.d0/dble(fft_box_size_CD_exx(3,1))
    do i=1,nmesh_rs_aug(ia)
       rx = dble(meshx_rs_aug(i,ia))*inl
       ry = dble(meshy_rs_aug(i,ia))*inm
       rz = dble(meshz_rs_aug(i,ia))*inn
       kdr = (rx*qmk(iqmk,1)+ry*qmk(iqmk,2)+rz*qmk(iqmk,3))*PAI2
       zc_ar(i) = dcos(kdr)
       zs_ar(i) = dsin(kdr)
    enddo
  end subroutine qmk_dot_r


! ================================== KT_Test ========================= 12.5Exp
  subroutine integrate_QijVnm(iqmk,potr,poti,fmr,fmi,qvr,qvi,dfmr,dfmi,dqvr,dqvi,gqvr,gqvi)
    implicit none
    integer, intent(in) :: iqmk
    real(kind=DP), intent(in) :: potr(nmax_G_hyb)
    real(kind=DP), intent(in) :: poti(nmax_G_hyb)
    real(kind=DP), intent(in) :: fmr(nlmta)
    real(kind=DP), intent(in) :: fmi(nlmta)
    real(kind=DP), intent(out) :: qvr(nlmta)
    real(kind=DP), intent(out) :: qvi(nlmta)
    real(kind=DP), optional, intent(in) :: dfmr(nlmta,3)
    real(kind=DP), optional, intent(in) :: dfmi(nlmta,3)
    real(kind=DP), optional, intent(out) :: dqvr(nlmta,3)
    real(kind=DP), optional, intent(out) :: dqvi(nlmta,3)
    real(kind=DP), optional, intent(out) :: gqvr(nlmta,3)
    real(kind=DP), optional, intent(out) :: gqvi(nlmta,3)

    integer :: it,ia,i,lmt1,lmt2,np,il1,il2,tau1,tau2,ilmta1,ilmta2
    integer :: l3,ilm3,iiqitg,iil
    real(kind=DP) :: ph, hr, hi, fac, f0
    real(kind=DP) :: cosgt, singt
    real(kind=DP) :: dr, di
    real(kind=DP), allocatable :: zsr(:), zsi(:)

    real(kind=DP), allocatable :: qitg_red(:,:),ylm_red(:,:)
    integer :: ibl1,ibl2,iq,inn,ip,m, ips, ipe
    logical :: force_mode = .false. 
    real(kind=DP), allocatable :: gvec(:,:)
    real(kind=DP) :: er(3), ei(3)
    integer,save  :: id_sname = -1
    call tstatc0_begin('integrate_QijVnm ',id_sname,1)
    force_mode = present(dfmr).and.present(dfmi).and.present(dqvr).and.present(dqvi).and. &
               & present(gqvr).and.present(gqvi)
    if(.not.preproc_done) call hard_part_preproc()

    qvr(1:nlmta) = 0.d0;  qvi(1:nlmta) = 0.d0
    if(force_mode)then
       dqvr(1:nlmta,1:3) = 0.d0
       dqvi(1:nlmta,1:3) = 0.d0
       gqvr(1:nlmta,1:3) = 0.d0
       gqvi(1:nlmta,1:3) = 0.d0
    endif
    allocate(zsr(ibsize)); allocate(zsi(ibsize))
    allocate(qitg_red(ibsize,nqitg))
    allocate(ylm_red(ibsize,n*n))
    if(force_mode) allocate(gvec(ibsize,3))

    ips = 1
    ipe = nmax_G_hyb

    do ibl1=ips, ipe, ibsize
       ibl2=min(ipe,ibl1+ibsize-1)
       do iq=1,nqitg
          do i=1,ibl2-ibl1+1
#if defined(MEMORY_SAVE_EXX) && defined(MEMORY_SAVE_MORE_EXX)
             qitg_red(i,iq) = qitg_exx(i+ibl1-1,iq)
#else
             qitg_red(i,iq) = qitg_exx(i+ibl1-1,iq,iqmk)
#endif
          enddo
       enddo
       do inn=1,n*n
          do i=1,ibl2-ibl1+1
#ifndef MEMORY_SAVE_EXX
             ylm_red(i,inn) = ylm_exx(i+ibl1-1,inn,iqmk)
#else
             ylm_red(i,inn) = ylm_exx(i+ibl1-1,inn)
#endif
          enddo
       enddo
       
       if(force_mode)then
          do i=1,ibl2-ibl1+1
             gvec(i,1:3) = ngabc(i+ibl1-1,1:3) + qmk(iqmk,1:3)
          end do
       endif
       do ia=1,natm
          it = ityp(ia)
          if( m_PP_include_vanderbilt_pot(it) == SKIP) cycle
          do i=1,ibl2-ibl1+1
             ph = PAI2 * dot_product(pos(ia,1:3),ngabc(i+ibl1-1,1:3)+qmk(iqmk,1:3)) 
             cosgt = cos(ph); singt = sin(ph)
             zsr(i) = cosgt * potr(i+ibl1-1) - singt * poti(i+ibl1-1)
             zsi(i) = cosgt * poti(i+ibl1-1) + singt * potr(i+ibl1-1)
          end do
          do iq=nqitg_sp0(it), nqitg_sp(it)
             l3 = iq2l3(iq)
             iil = mod(l3,4)
             
             do m = 1, 2*l3+1
                ilm3 = l3*l3+m
                
                dr = 0.d0; di = 0.d0
                if(force_mode)then
                   er(1:3) = 0.d0;ei(1:3)=0.d0
                endif
                if(iil==0) then
                   do i=1,ibl2-ibl1+1
                      fac =  qitg_red(i,iq) * ylm_red(i,ilm3)
                      dr = dr + fac * zsr(i)
                      di = di + fac * zsi(i)
                   end do
                   if(force_mode)then
                      do i=1,ibl2-ibl1+1
                         fac =  qitg_red(i,iq) * ylm_red(i,ilm3)
                         er = er + (fac * zsr(i))*gvec(i,1:3)
                         ei = ei + (fac * zsi(i))*gvec(i,1:3)
                      end do
                   endif
                else if(iil==1) then
                   do i=1,ibl2-ibl1+1
                      fac =  qitg_red(i,iq) * ylm_red(i,ilm3)
                      dr = dr - fac * zsi(i)
                      di = di + fac * zsr(i)
                   end do
                   if(force_mode)then
                      do i=1,ibl2-ibl1+1
                         fac =  qitg_red(i,iq) * ylm_red(i,ilm3)
                         er = er - (fac * zsi(i))*gvec(i,1:3)
                         ei = ei + (fac * zsr(i))*gvec(i,1:3)
                      end do
                   endif
                else if(iil==2) then
                   do i=1,ibl2-ibl1+1
                      fac =  qitg_red(i,iq) * ylm_red(i,ilm3)
                      dr = dr - fac * zsr(i)
                      di = di - fac * zsi(i)
                   end do
                   if(force_mode)then
                      do i=1,ibl2-ibl1+1
                         fac =  qitg_red(i,iq) * ylm_red(i,ilm3)
                         er = er - (fac * zsr(i))*gvec(i,1:3)
                         ei = ei - (fac * zsi(i))*gvec(i,1:3)
                      end do
                   endif
                else if(iil==3) then
                   do i=1,ibl2-ibl1+1
                      fac =  qitg_red(i,iq) * ylm_red(i,ilm3)
                      dr = dr + fac * zsi(i)
                      di = di - fac * zsr(i)
                   end do
                   if(force_mode)then
                      do i=1,ibl2-ibl1+1
                         fac =  qitg_red(i,iq) * ylm_red(i,ilm3)
                         er = er + (fac * zsi(i))*gvec(i,1:3)
                         ei = ei - (fac * zsr(i))*gvec(i,1:3)
                      end do
                   endif
                end if
                di = -di
                if(force_mode) ei=-ei
                do ip=1,nc(m,iq)
                   lmt1 = nc2lmt1(ip,m,iq); lmt2 = nc2lmt2(ip,m,iq)
                   ilmta1 = lmta(lmt1,ia);  ilmta2 = lmta(lmt2,ia)
                   np = nc2n(ip,m,iq)
                   f0 = iwei(ia) * dl2p(lmt1,lmt2,np,it)
                   qvr(ilmta1) = qvr(ilmta1) + f0 * (dr * fmr(ilmta2) - di * fmi(ilmta2))
                   qvi(ilmta1) = qvi(ilmta1) + f0 * (di * fmr(ilmta2) + dr * fmi(ilmta2))
                end do
                if(force_mode)then
                   do ip=1,nc(m,iq)
                      lmt1 = nc2lmt1(ip,m,iq); lmt2 = nc2lmt2(ip,m,iq)
                      ilmta1 = lmta(lmt1,ia);  ilmta2 = lmta(lmt2,ia)
                      np = nc2n(ip,m,iq)
                      f0 = iwei(ia) * dl2p(lmt1,lmt2,np,it)
                      dqvr(ilmta1,1:3) = dqvr(ilmta1,1:3) + f0 * (dr * dfmr(ilmta2,1:3) - di * dfmi(ilmta2,1:3))
                      dqvi(ilmta1,1:3) = dqvi(ilmta1,1:3) + f0 * (di * dfmr(ilmta2,1:3) + dr * dfmi(ilmta2,1:3))
                      gqvr(ilmta1,1:3) = gqvr(ilmta1,1:3) + f0 * (ei(1:3) * fmr(ilmta2) + er(1:3) * fmi(ilmta2))
                      gqvi(ilmta1,1:3) = gqvi(ilmta1,1:3) + f0 * (-er(1:3) * fmr(ilmta2) + ei(1:3) * fmi(ilmta2))
                   enddo
                endif
             end do
          end do
       end do
       
    enddo
    
    deallocate(zsr);  deallocate(zsi)
    deallocate(qitg_red); deallocate(ylm_red)
    if(force_mode) deallocate(gvec)
    call tstatc0_end(id_sname)
  end subroutine integrate_QijVnm
! ========================================================================= 125.Exp

  subroutine integrate_QijVnm_rs2(iqmk,potr,poti,fmrq,fmiq,qvr,qvi)
    integer, intent(in) :: iqmk
    real(kind=DP), intent(in) :: potr(nfftp_exx_nonpara/2)
    real(kind=DP), intent(in) :: poti(nfftp_exx_nonpara/2)
    real(kind=DP), intent(in) :: fmrq(nmesh_rs_aug_max,nlmta)
    real(kind=DP), intent(in) :: fmiq(nmesh_rs_aug_max,nlmta)
    real(kind=DP), intent(out) :: qvr(nlmta)
    real(kind=DP), intent(out) :: qvi(nlmta)
    real(kind=DP), dimension(:), allocatable :: cosqmkr,sinqmkr
    real(kind=DP), allocatable, dimension(:) :: rra,iia
    integer :: ia,it,lmt1,ilmta1
    integer :: imesh,nma,ind
    real(kind=DP) :: co,si
    real(kind=DP) :: qr,qi,qmr,qmi,rr,ii
    integer :: id_sname=-1
    call tstatc0_begin('integrate_QijVnm_rs2 ',id_sname,1)
    allocate(cosqmkr(nmesh_rs_aug_max));cosqmkr=0.d0
    allocate(sinqmkr(nmesh_rs_aug_max));sinqmkr=0.d0
    allocate(rra(nmesh_rs_aug_max));rra=0.d0
    allocate(iia(nmesh_rs_aug_max));iia=0.d0
    qvr(:) = 0.d0
    qvi(:) = 0.d0
    do ia=1,natm
       it = ityp(ia)
       if( m_PP_include_vanderbilt_pot(it) == SKIP) cycle
       call qmk_dot_r(iqmk,ia,cosqmkr,sinqmkr)
       nma = nmesh_rs_aug(ia)
       do imesh=1,nma
          ind = meshxyz_rs_aug(imesh,ia)
          co  =  cosqmkr(imesh)
          si  = -sinqmkr(imesh)
          rra(imesh) =  potr(ind)*co+poti(ind)*si
          iia(imesh) = -poti(ind)*co+potr(ind)*si
       enddo
       do lmt1=1,ilmt(it)
          ilmta1 = lmta(lmt1,ia)
          qr=0.d0;qi=0.d0
          do imesh=1,nma
             qmr = fmrq(imesh,ilmta1)
             qmi = fmiq(imesh,ilmta1)
             rr = rra(imesh)
             ii = iia(imesh)
             qr = qr+qmr*rr-qmi*ii
             qi = qi+qmr*ii+qmi*rr
          enddo
          qvr(ilmta1) = qr
          qvi(ilmta1) = qi
       enddo
    enddo
    deallocate(cosqmkr)
    deallocate(sinqmkr)
    deallocate(rra,iia)
    call tstatc0_end(id_sname)
  end subroutine integrate_QijVnm_rs2

  subroutine integrate_QijVnm_rs(iqmk,potr,poti,fmr,fmi,qvr,qvi,dfmr,dfmi,dqvr,dqvi,gqvr,gqvi)
    integer, intent(in) :: iqmk
    real(kind=DP), intent(in) :: potr(nfftp_exx_nonpara/2)
    real(kind=DP), intent(in) :: poti(nfftp_exx_nonpara/2)
    real(kind=DP), intent(in) :: fmr(nlmta)
    real(kind=DP), intent(in) :: fmi(nlmta)
    real(kind=DP), intent(out) :: qvr(nlmta)
    real(kind=DP), intent(out) :: qvi(nlmta)
    real(kind=DP), intent(in),optional  :: dfmr(nlmta,3)
    real(kind=DP), intent(in),optional  :: dfmi(nlmta,3)
    real(kind=DP), intent(out),optional :: dqvr(nlmta,3)
    real(kind=DP), intent(out),optional :: dqvi(nlmta,3)
    real(kind=DP), intent(out),optional :: gqvr(nlmta,3)
    real(kind=DP), intent(out),optional :: gqvi(nlmta,3)
    integer :: n,it,ia,imesh,lmt1,lmt2,il1,il2,tau1,tau2,ilmta1,ilmta2,lmtp
    real(kind=DP), dimension(:), allocatable :: cosqmkr,sinqmkr
    real(kind=DP) :: co,si,rr,ii,rrr,iii,qr,qi,qqr,qqi,qm,rr0,ii0
    real(kind=DP), allocatable, dimension(:) :: rra,iia
    integer :: nma,ind
    real(kind=DP) :: er(3), ei(3),dqm(3),dqqr(3),dqqi(3),der(3),dei(3),drr(3),dii(3),drr0(3),dii0(3)
    real(kind=DP) :: dqqr0(3),dqqi0(3),der0(3),dei0(3)
    logical :: force_mode = .false.
    integer :: id_sname=-1
    call tstatc0_begin('integrate_QijVnm_rs ',id_sname,1)
    force_mode = present(dfmr).and.present(dfmi).and. &
               & present(dqvr).and.present(dqvi).and. &
               & present(gqvr).and.present(gqvi)
    allocate(cosqmkr(nmesh_rs_aug_max));cosqmkr=0.d0
    allocate(sinqmkr(nmesh_rs_aug_max));sinqmkr=0.d0
    allocate(rra(nmesh_rs_aug_max));rra=0.d0
    allocate(iia(nmesh_rs_aug_max));iia=0.d0
    qvr(:) = 0.d0
    qvi(:) = 0.d0
    if(force_mode)then
       dqvr(1:nlmta,1:3) = 0.d0
       dqvi(1:nlmta,1:3) = 0.d0
       gqvr(1:nlmta,1:3) = 0.d0
       gqvi(1:nlmta,1:3) = 0.d0
    endif
    do ia=1,natm
       it = ityp(ia)
       if( m_PP_include_vanderbilt_pot(it) == SKIP) cycle
       call qmk_dot_r(iqmk,ia,cosqmkr,sinqmkr)
       nma = nmesh_rs_aug(ia)
       do imesh=1,nma
          ind = meshxyz_rs_aug(imesh,ia)
          co  =  cosqmkr(imesh)
          si  = -sinqmkr(imesh)
          rra(imesh) =  potr(ind)*co+poti(ind)*si
          iia(imesh) = -poti(ind)*co+potr(ind)*si
       enddo
       do lmtp=1,nlmtpair(ia)
          lmt1 = plmt1(lmtp,ia)
          lmt2 = plmt2(lmtp,ia)
          ilmta1 = lmta(lmt1,ia)
          ilmta2 = lmta(lmt2,ia)
          rr0 =  fmr(ilmta1)
          ii0 =  fmi(ilmta1)
          qqr=0.d0;qqi=0.d0
          qr=0.d0;qi=0.d0
          rr =  fmr(ilmta2)
          ii =  fmi(ilmta2)
          if(force_mode)then
            dqqr=0.d0;dqqi=0.d0
            dqqr0=0.d0;dqqi0=0.d0
            der=0.d0;dei=0.d0
            der0=0.d0;dei0=0.d0
            drr(1:3) =  dfmr(ilmta2,1:3)
            dii(1:3) =  dfmi(ilmta2,1:3)
            er=0.d0;ei=0.d0
          endif
          do imesh=1,nma
             qm = qr_clm_ylm(imesh,ia,lmtp)
             qr = qr+qm*rra(imesh)
             qi = qi+qm*iia(imesh)
          enddo
          if(force_mode)then
             do imesh=1,nma
                dqm(1:3) = dqr_clm_ylm(imesh,ia,lmtp,1:3)
                er(1:3) = er(1:3)+dqm(1:3)*rra(imesh)
                ei(1:3) = ei(1:3)+dqm(1:3)*iia(imesh)
             enddo
          endif
          qqr = qr*rr-qi*ii
          qqi = qr*ii+qi*rr
          qvr(ilmta1) = qvr(ilmta1)+qqr
          qvi(ilmta1) = qvi(ilmta1)+qqi
          if(force_mode)then
             dqqr(1:3)  = qr*drr(1:3)-qi*dii(1:3)
             dqqi(1:3)  = qr*dii(1:3)+qi*drr(1:3)
             der(1:3)   = er(1:3)*rr-ei(1:3)*ii
             dei(1:3)   = er(1:3)*ii+ei(1:3)*rr
             dqvr(ilmta1,1:3) = dqvr(ilmta1,1:3)+dqqr(1:3)
             dqvi(ilmta1,1:3) = dqvi(ilmta1,1:3)+dqqi(1:3)
             gqvr(ilmta1,1:3) = gqvr(ilmta1,1:3)+der(1:3)
             gqvi(ilmta1,1:3) = gqvi(ilmta1,1:3)+dei(1:3)
          endif
          if(lmt1.ne.lmt2)then
             qvr(ilmta2) = qvr(ilmta2)+(qr*rr0-qi*ii0)
             qvi(ilmta2) = qvi(ilmta2)+(qr*ii0+qi*rr0)
          endif
          if(force_mode.and.lmt1.ne.lmt2)then
             drr0(1:3) =  dfmr(ilmta1,1:3)
             dii0(1:3) =  dfmi(ilmta1,1:3)
             dqqr0(1:3) = qr*drr0(1:3)-qi*dii0(1:3)
             dqqi0(1:3) = qr*dii0(1:3)+qi*drr0(1:3)
             der0(1:3)   = er(1:3)*rr0-ei(1:3)*ii0
             dei0(1:3)   = er(1:3)*ii0+ei(1:3)*rr0
             dqvr(ilmta2,1:3) = dqvr(ilmta2,1:3)+dqqr0(1:3)
             dqvi(ilmta2,1:3) = dqvi(ilmta2,1:3)+dqqi0(1:3)
             gqvr(ilmta2,1:3) = gqvr(ilmta2,1:3)+der0(1:3)
             gqvi(ilmta2,1:3) = gqvi(ilmta2,1:3)+dei0(1:3)
          endif
       enddo
    enddo
    deallocate(cosqmkr)
    deallocate(sinqmkr)
    deallocate(rra,iia)
    call tstatc0_end(id_sname)
  end subroutine integrate_QijVnm_rs

  subroutine add_Vx_hard_part(ik,vxw,sumqvr,sumqvi)
  !!subroutine add_Vx_hard_part(ik,vxw1,sumqvr,sumqvi)
    implicit none
    integer, intent(in) :: ik
    real(kind=DP), intent(inout) :: vxw(kg1,kimg)
    !!real(kind=DP), intent(inout) :: vxw1(kg1,kimg)
    real(kind=DP), intent(in) :: sumqvr(nlmta)
    real(kind=DP), intent(in) :: sumqvi(nlmta)

    integer :: it,ia,i,il1,ilmtt1,ilmta1,iil,iksnl
    integer :: lmt1,lmtt1
    real(kind=DP) :: fac, ph
    real(kind=DP), allocatable :: cosgt(:) ! d(kg1)
    real(kind=DP), allocatable :: singt(:) ! d(kg1)
    integer,save  :: id_sname = -1
    call tstatc0_begin('add_Vx_hard_part ',id_sname)

    allocate(cosgt(kg1))
    allocate(singt(kg1))

    iksnl = (ik-1)/nspin + 1

    do ia=1,natm
       it = ityp(ia)
       if( m_PP_include_vanderbilt_pot(it) == SKIP) cycle
       do i=1,iba(ik)
          ph = PAI2 * dot_product(pos(ia,1:3),vkxyz(ik,1:3,BUCS)+ngabc(nbase(i,ik),1:3))
          cosgt(i) = cos(ph)
          singt(i) = sin(ph)
       end do
       do lmt1 = 1, ilmt(it)
          il1  = ltp(lmt1,it)
          lmtt1 = lmtt(lmt1,it)
          ilmta1 = lmta(lmt1,ia)
          iil=mod(il1-1,4)
          if(iil==0) then
             do i=1,iba(ik)
                fac = iwei(ia)*snl(i,lmtt1,iksnl)
                vxw(i,1) = vxw(i,1) + fac * (cosgt(i)*sumqvr(ilmta1)+singt(i)*sumqvi(ilmta1))
                if(kimg==2) vxw(i,2) = vxw(i,2) + fac * (cosgt(i)*sumqvi(ilmta1)-singt(i)*sumqvr(ilmta1))
             end do
          else if(iil==1) then
             do i=1,iba(ik)
                fac = iwei(ia)*snl(i,lmtt1,iksnl)
                vxw(i,1) = vxw(i,1) + fac * (cosgt(i)*sumqvi(ilmta1)-singt(i)*sumqvr(ilmta1))
                if(kimg==2) vxw(i,2) = vxw(i,2) - fac * (cosgt(i)*sumqvr(ilmta1)+singt(i)*sumqvi(ilmta1))
             end do
          else if(iil==2) then
             do i=1,iba(ik)
                fac = -iwei(ia)*snl(i,lmtt1,iksnl)
                vxw(i,1) = vxw(i,1) + fac * (cosgt(i)*sumqvr(ilmta1)+singt(i)*sumqvi(ilmta1))
                if(kimg==2) vxw(i,2) = vxw(i,2) + fac * (cosgt(i)*sumqvi(ilmta1)-singt(i)*sumqvr(ilmta1))
             end do
          else if(iil==3) then
             do i=1,iba(ik)
                fac = -iwei(ia)*snl(i,lmtt1,iksnl)
                vxw(i,1) = vxw(i,1) + fac * (cosgt(i)*sumqvi(ilmta1)-singt(i)*sumqvr(ilmta1))
                if(kimg==2) vxw(i,2) = vxw(i,2) - fac * (cosgt(i)*sumqvr(ilmta1)+singt(i)*sumqvi(ilmta1))
             end do
          end if
       end do
    end do

    deallocate(cosgt)
    deallocate(singt)

    call tstatc0_end(id_sname)
  end subroutine add_Vx_hard_part

  subroutine get_Rot_betar_dot_WFs(ik,ib,jop,kop,jtrs,fsr,fsi,dfsr,dfsi)
    implicit none
    integer, intent(in)                          :: ik,ib,jop,kop,jtrs
    real(kind=DP), intent(out), dimension(nlmta) :: fsr,fsi
    real(kind=DP), intent(out), optional, dimension(nlmta,3) :: dfsr,dfsi

    integer :: ilmta1,ilmta2,isph1,isph2,iy
    integer :: ia,i
    real(kind=DP) :: prim(3)
    real(kind=DP) :: coskt(natm), sinkt(natm)
    real(kind=DP) :: ph, tmpr, tmpi
    logical :: force_mode=.false.
    integer,save  :: id_sname = -1
    call tstatc0_begin('get_Rot_betar_dot_WFs ',id_sname)
    force_mode = present(dfsr).and.present(dfsi)
    if(jop==1) then
       fsr(1:nlmta) = fsr_exx(ib,1:nlmta,ik)
       fsi(1:nlmta) = fsi_exx(ib,1:nlmta,ik)
       if(force_mode)then
          dfsr(1:nlmta,1:3) = dfsr_exx(ib,1:nlmta,ik,1:3)
          dfsi(1:nlmta,1:3) = dfsi_exx(ib,1:nlmta,ik,1:3)
       endif
    else
       fsr = 0.d0
       fsi = 0.d0
       if(force_mode)then
          dfsr = 0.d0
          dfsi = 0.d0
       endif
       do ilmta1=1,nlmta       
          isph1=isph_lmta(ilmta1)
          do iy=1,nylm(isph1,jop)
             isph2 = iylm(iy,isph1,jop)
             ilmta2=lmta_rot(iy,ilmta1,jop)
             fsr(ilmta1) = fsr(ilmta1) + crotylm(iy,isph1,jop) * fsr_exx(ib,ilmta2,ik)
             fsi(ilmta1) = fsi(ilmta1) + crotylm(iy,isph1,jop) * fsi_exx(ib,ilmta2,ik)
             if(force_mode)then
                dfsr(ilmta1,1:3) = dfsr(ilmta1,1:3) + crotylm(iy,isph1,jop) * dfsr_exx(ib,ilmta2,ik,1:3)
                dfsi(ilmta1,1:3) = dfsi(ilmta1,1:3) + crotylm(iy,isph1,jop) * dfsi_exx(ib,ilmta2,ik,1:3)
             endif
          end do
       end do 
    end if

    if(jop>1) then
       do ia=1,natm
          prim(1:3) = matmul(opdir(:,:,kop),pos(ia,1:3)) + tau(1:3,kop,BUCS) - pos(napt(ia,kop),1:3)
          ph = PAI2 * dot_product(vkxyz(ik,1:3,BUCS),prim) 
          coskt(ia) = cos(ph)
          sinkt(ia) = sin(ph)
       end do
       do ilmta1=1,nlmta
          ia = ia_lmta(ilmta1)
          tmpr = fsr(ilmta1)
          tmpi = fsi(ilmta1)
          fsr(ilmta1) = coskt(ia) * tmpr - sinkt(ia) * tmpi
          fsi(ilmta1) = coskt(ia) * tmpi + sinkt(ia) * tmpr 
          if(force_mode)then
             do i=1,3
                tmpr = dfsr(ilmta1,i)
                tmpi = dfsi(ilmta1,i)
                dfsr(ilmta1,i) = coskt(ia) * tmpr - sinkt(ia) * tmpi
                dfsi(ilmta1,i) = coskt(ia) * tmpi + sinkt(ia) * tmpr 
             end do
          endif
       end do
    end if

    if(jtrs==1) fsi = -fsi
    if(force_mode.and.jtrs==1) dfsi = -dfsi
    call tstatc0_end(id_sname)
  end subroutine get_Rot_betar_dot_WFs

  subroutine get_expkt_fs_b(ik,ib,fsr_l,fsi_l,efsr_l,efsi_l)
    implicit none
    integer, intent(in) :: ik,ib
    real(kind=DP), intent(in), dimension(nlmta) :: fsr_l,fsi_l
    real(kind=DP), intent(out), dimension(nlmta) :: efsr_l,efsi_l

    integer :: it, ia, lmt, ilmta
    real(kind=DP) :: ph, coskt, sinkt
    efsr_l(1:nlmta) = 0.d0
    efsi_l(1:nlmta) = 0.d0
    if(k_symmetry(ik)==GAMMA)then
       efsr_l(:) = fsr_l(:)
    else
       do ia=1,natm
          it = ityp(ia)
          if( m_PP_include_vanderbilt_pot(it) == SKIP) cycle
          ph = PAI2 * dot_product(pos(ia,1:3),vkxyz(ik,1:3,BUCS))
          coskt = cos(ph)
          sinkt = sin(ph)
          do lmt = 1, ilmt(it)
             ilmta = lmta(lmt,ia)
             efsr_l(ilmta) = coskt * fsr_l(ilmta) - sinkt * fsi_l(ilmta)
             efsi_l(ilmta) = sinkt * fsr_l(ilmta) + coskt * fsi_l(ilmta)
          end do
       end do
    endif

  end subroutine get_expkt_fs_b

  subroutine get_expkt_fs(ik,fsr_l,fsi_l,efsr_l,efsi_l)
    implicit none
    integer, intent(in) :: ik
    real(kind=DP), intent(in), dimension(np_e,nlmta,ista_k:iend_k) :: fsr_l,fsi_l
    real(kind=DP), intent(out), dimension(np_e,nlmta) :: efsr_l,efsi_l

    integer :: it, ia, lmt, ilmta
    real(kind=DP) :: ph, coskt, sinkt
    integer :: ib
    efsr_l = 0.d0
    efsi_l = 0.d0
    do ib=1,np_e
       call get_expkt_fs_b(ik,ib,fsr_l(ib,1:nlmta,ik),fsi_l(ib,1:nlmta,ik),efsr_l(ib,1:nlmta),efsi_l(ib,1:nlmta))
    enddo

  end subroutine get_expkt_fs

  subroutine m_ES_EXX_Force(force)
    implicit none
    real(kind=DP), intent(out) :: force(natm,3)

    integer :: ik,ib,ig,ispin,ia,iadd
    real(kind=DP), allocatable :: force_l(:,:) ! d(natm,3)
    real(kind=DP), allocatable :: force_mpi(:,:) ! d(natm,3)
    real(kind=DP), allocatable :: efsr_l(:,:) ! d(np_e,nlmta)
    real(kind=DP), allocatable :: efsi_l(:,:) ! d(np_e,nlmta)
    real(kind=DP), allocatable :: defsr_l(:,:,:) ! d(np_e,nlmta,3)
    real(kind=DP), allocatable :: defsi_l(:,:,:) ! d(np_e,nlmta,3)
    real(kind=DP), allocatable, dimension(:) :: zajbuf_r,zajbuf_i
    integer :: kgw,kgv
    integer,save  :: id_sname = -1

    if(modnrm /= EXECUT) then
       force = 0.d0
       return
    end if

    call tstatc0_begin('m_ES_EXX_Force ',id_sname,level=1)

    call m_FFT_alloc_WF_work()

    allocate(force_l(natm,3))
    allocate(efsr_l(np_e,nlmta));efsr_l=0.d0
    allocate(efsi_l(np_e,nlmta));efsi_l=0.d0

    !!write(nfout,'("m_ES_EXX_force")')

    allocate(dfsr_l(np_e,nlmta,ista_k:iend_k,3));dfsr_l=0.d0
    allocate(dfsi_l(np_e,nlmta,ista_k:iend_k,3));dfsi_l=0.d0
    call drv_betar_dot_WFs_exx() !-> dfsr_l, dfsi_l

    allocate(dfsr_exx(nval,nlmta,kv3,3));dfsr_exx=0.d0
    allocate(dfsi_exx(nval,nlmta,kv3,3));dfsi_exx=0.d0
    call gather_drv_bdw_exx() !-> dfsr_exx, dfsi_exx

    force = 0.d0
    do ispin=1,nspin,af+1
       do ik=ispin, kv3+ispin-nspin, nspin
          if(map_k(ik) /= myrank_k) cycle ! MPI
          call get_expkt_fs(ik,fsr_l,fsi_l,efsr_l,efsi_l)
          do ib=1,np_e   ! MPI
             if(occup_l(ib,ik) < DELTA) cycle
             force_l = 0.d0
             allocate(zajbuf_r(kg1));zajbuf_r(:) = zaj_l(:,ib,ik,1)
             allocate(zajbuf_i(kg1));zajbuf_i(:) = zaj_l(:,ib,ik,kimg)
             kgw = kg1;kgv=kg1

             if(kimg==1) then
                call apply_Vx_to_WF(ispin,ib,ik,kgw,kgv,zajbuf_r,zajbuf_r &
                    & ,efsr_l(ib,1:nlmta),efsr_l(ib,1:nlmta) &
                    & ,dbdwr=dfsr_l(ib,1:nlmta,ik,1:3),dbdwi=dfsr_l(ib,1:nlmta,ik,1:3),force_l=force_l)
             else
                call apply_Vx_to_WF(ispin,ib,ik,kgw,kgv,zajbuf_r,zajbuf_i &
                    & ,efsr_l(ib,1:nlmta),efsi_l(ib,1:nlmta) &
                    & ,dbdwr=dfsr_l(ib,1:nlmta,ik,1:3),dbdwi=dfsi_l(ib,1:nlmta,ik,1:3),force_l=force_l)
             end if
             force = force + occup_l(ib,ik) * force_l
             deallocate(zajbuf_r)
             deallocate(zajbuf_i)
          end do
       end do
    end do

    force = -force / dble(kv3/nspin)
    if(nspin==1) force = 2.d0 * force
    
    deallocate(force_l)
    deallocate(efsr_l)
    deallocate(efsi_l)
    deallocate(dfsr_l)
    deallocate(dfsi_l)
    deallocate(dfsr_exx)
    deallocate(dfsi_exx)

    call m_FFT_dealloc_WF_work()

    if(npes>1) then
       allocate(force_mpi(natm,3))
       call mpi_allreduce(force,force_mpi,natm*3,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)
       force = force_mpi
       deallocate(force_mpi)
    end if

    !! Reduced coordinate -> Cartesian coordinate
    do ia=1,natm
       force(ia,1:3) = matmul(transpose(rltv),force(ia,1:3))
    end do

    call tstatc0_end(id_sname)
  end subroutine m_ES_EXX_Force

  subroutine sum_EXX_force_terms(force_l,bdwr,bdwi,dbdwr,dbdwi,sumqvr,sumqvi,sumdqvr,sumdqvi)
    implicit none
    real(kind=DP), intent(inout) :: force_l(natm,3)
    real(kind=DP), intent(in) :: bdwr(nlmta), bdwi(nlmta)
    real(kind=DP), intent(in) :: dbdwr(nlmta,3), dbdwi(nlmta,3)
    real(kind=DP), intent(in) :: sumqvr(nlmta), sumqvi(nlmta)
    real(kind=DP), intent(in) :: sumdqvr(nlmta,3), sumdqvi(nlmta,3)

    integer :: ia,it,lmt1,ip

    do ia=1,natm
       it=ityp(ia)
       if( m_PP_include_vanderbilt_pot(it) == SKIP) cycle
       do lmt1 = 1, ilmt(it)
          ip = lmta(lmt1,ia)
          force_l(ia,1:3) = force_l(ia,1:3) &
                        & + dbdwr(ip,1:3)*sumqvr(ip) + dbdwi(ip,1:3)*sumqvi(ip) &
                        & + bdwr(ip)*sumdqvr(ip,1:3) + bdwi(ip)*sumdqvi(ip,1:3)
       end do
    end do
  end subroutine sum_EXX_force_terms

  subroutine gather_drv_bdw_exx()
    implicit none

    integer :: ik,ib,ib1,ibm,irev
    real(kind=DP), allocatable :: dfsr_mpi(:,:,:,:) ! d(nval,nlmta,kv3,3)
    real(kind=DP), allocatable :: dfsi_mpi(:,:,:,:) ! d(nval,nlmta,kv3,3)

    integer,save  :: id_sname = -1

    call tstatc0_begin('gather_drv_bdw_exx ',id_sname)

    dfsr_exx = 0.d0
    dfsi_exx = 0.d0

    do ik=1,kv3,af+1
       if(map_k(ik) /= myrank_k) cycle
       do ib=1,nval
          ib1 = neordr(ib,ik)
          if(map_e(ib1) == myrank_e) then
             dfsr_exx(ib,1:nlmta,ik,1:3) = dfsr_l(map_z(ib1),1:nlmta,ik,1:3)
             dfsi_exx(ib,1:nlmta,ik,1:3) = dfsi_l(map_z(ib1),1:nlmta,ik,1:3)
          end if
       end do
    end do    

    if(npes>1) then
       allocate(dfsr_mpi(nval,nlmta,kv3,3))
       allocate(dfsi_mpi(nval,nlmta,kv3,3))
       call mpi_allreduce(dfsr_exx,dfsr_mpi,nval*nlmta*kv3*3,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)
       call mpi_allreduce(dfsi_exx,dfsi_mpi,nval*nlmta*kv3*3,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)
       dfsr_exx = dfsr_mpi
       dfsi_exx = dfsi_mpi
       deallocate(dfsr_mpi)
       deallocate(dfsi_mpi)
    end if

    call tstatc0_end(id_sname)
  end subroutine gather_drv_bdw_exx

  subroutine drv_betar_dot_WFs_exx()
    implicit none

    integer :: ik,ib,it,ia,i,il1,ilmtt1,ilmta1,iil,iksnl
    integer :: lmt1,lmtt1
    real(kind=DP) :: fac, ph, fr, fi, fac2
    real(kind=DP), allocatable :: cosgt(:) ! d(kg1)
    real(kind=DP), allocatable :: singt(:) ! d(kg1)
    real(kind=DP), allocatable :: gvec(:,:) ! d(kg1,3)

    integer,save  :: id_sname = -1
    call tstatc0_begin('drv_betar_dot_WFs_exx ',id_sname)

    allocate(cosgt(kg1))
    allocate(singt(kg1))
    allocate(gvec(kg1,3))

    dfsr_l = 0.d0
    dfsi_l = 0.d0

    do ik=1,kv3,af+1
       if(map_k(ik) /= myrank_k) cycle ! MPI
       iksnl = (ik-1)/nspin + 1
       fac2 = 1.d0
       if(k_symmetry(ik)==GAMMA) fac2 = 2.d0
       do ia=1,natm
          it = ityp(ia)
          if( m_PP_include_vanderbilt_pot(it) == SKIP) cycle
          do i=1,iba(ik)
             gvec(i,1:3) = vkxyz(ik,1:3,BUCS)+ngabc(nbase(i,ik),1:3)
             ph = PAI2 * dot_product(pos(ia,1:3),gvec(i,1:3))
             cosgt(i) = cos(ph)
             singt(i) = sin(ph)
          end do
          do lmt1 = 1, ilmt(it)
             il1  = ltp(lmt1,it)
             lmtt1 = lmtt(lmt1,it)
             ilmta1 = lmta(lmt1,ia)
             iil=mod(il1,4) !! i^(L+1)
             if(iil==0) then
                do ib=1,np_e
                   if(occup_l(ib,ik) < DELTA) cycle
                   do i=1,iba(ik)
                      fac = snl(i,lmtt1,iksnl)*fac2
                      fr = fac * ( cosgt(i)*zaj_l(i,ib,ik,1)-singt(i)*zaj_l(i,ib,ik,2) )
                      fi = fac * ( cosgt(i)*zaj_l(i,ib,ik,2)+singt(i)*zaj_l(i,ib,ik,1) )
                      dfsr_l(ib,ilmta1,ik,1:3) = dfsr_l(ib,ilmta1,ik,1:3) + gvec(i,1:3) * fr
                      dfsi_l(ib,ilmta1,ik,1:3) = dfsi_l(ib,ilmta1,ik,1:3) + gvec(i,1:3) * fi
                   end do
                end do
             else if(iil==1) then
                do ib=1,np_e
                   if(occup_l(ib,ik) < DELTA) cycle
                   do i=1,iba(ik)
                      fac = snl(i,lmtt1,iksnl)*fac2
                      fr = -fac * ( cosgt(i)*zaj_l(i,ib,ik,2)+singt(i)*zaj_l(i,ib,ik,1) )
                      fi =  fac * ( cosgt(i)*zaj_l(i,ib,ik,1)-singt(i)*zaj_l(i,ib,ik,2) )
                      dfsr_l(ib,ilmta1,ik,1:3) = dfsr_l(ib,ilmta1,ik,1:3) + gvec(i,1:3) * fr
                      dfsi_l(ib,ilmta1,ik,1:3) = dfsi_l(ib,ilmta1,ik,1:3) + gvec(i,1:3) * fi
                   end do
                end do
             else if(iil==2) then
                do ib=1,np_e
                   if(occup_l(ib,ik) < DELTA) cycle
                   do i=1,iba(ik)
                      fac = snl(i,lmtt1,iksnl)*fac2
                      fr = -fac * ( cosgt(i)*zaj_l(i,ib,ik,1)-singt(i)*zaj_l(i,ib,ik,2) )
                      fi = -fac * ( cosgt(i)*zaj_l(i,ib,ik,2)+singt(i)*zaj_l(i,ib,ik,1) )
                      dfsr_l(ib,ilmta1,ik,1:3) = dfsr_l(ib,ilmta1,ik,1:3) + gvec(i,1:3) * fr
                      dfsi_l(ib,ilmta1,ik,1:3) = dfsi_l(ib,ilmta1,ik,1:3) + gvec(i,1:3) * fi
                   end do
                end do
             else if(iil==3) then
                do ib=1,np_e
                   if(occup_l(ib,ik) < DELTA) cycle
                   do i=1,iba(ik)
                      fac = snl(i,lmtt1,iksnl)*fac2
                      fr =  fac * ( cosgt(i)*zaj_l(i,ib,ik,2)+singt(i)*zaj_l(i,ib,ik,1) )
                      fi = -fac * ( cosgt(i)*zaj_l(i,ib,ik,1)-singt(i)*zaj_l(i,ib,ik,2) )
                      dfsr_l(ib,ilmta1,ik,1:3) = dfsr_l(ib,ilmta1,ik,1:3) + gvec(i,1:3) * fr
                      dfsi_l(ib,ilmta1,ik,1:3) = dfsi_l(ib,ilmta1,ik,1:3) + gvec(i,1:3) * fi
                   end do
                end do
             end if
          end do
       end do
    end do

    deallocate(cosgt)
    deallocate(singt)
    deallocate(gvec)

    call tstatc0_end(id_sname)
  end subroutine drv_betar_dot_WFs_exx
#if defined(MEMORY_SAVE_EXX) && defined(MEMORY_SAVE_MORE_EXX)
  subroutine qitgft_qmk_each_k_setup(it_in,nmm_il3_in,mm_il3_in,qrsps_mm_in,lcmax_in,h_in)
     use m_PseudoPotential, only : wos, nqitg_sp
     implicit none
     integer, intent(in) :: it_in
     integer, intent(in) :: nmm_il3_in(lcmax_in+1)
     integer, intent(in) :: mm_il3_in(nqitg_sp(it_in),lcmax_in+1)
     real(kind=DP), intent(in) :: qrsps_mm_in(mmesh,nqitg_sp(it_in))
     integer, intent(in) :: lcmax_in
     real(kind=DP), intent(in) :: h_in(it_in)

     it = it_in
     lcmax = lcmax_in
     allocate(nmm_il3(lcmax+1)); nmm_il3 = nmm_il3_in
     allocate(mm_il3(nqitg_sp(it),lcmax+1)); mm_il3 = mm_il3_in
     allocate(qrsps_mm(mmesh,nqitg_sp(it))); qrsps_mm = qrsps_mm_in
     allocate(h(it)); h = h_in
     allocate(radr_kept(mmesh)); radr_kept = radr
     allocate(wos_kept(mmesh)); wos_kept = wos

     return
  end subroutine qitgft_qmk_each_k_setup

  subroutine qitgft_qmk_each_k(ik)
     use m_PseudoPotential,    only : nqitg_sp
     implicit none
     integer, intent(in) :: ik

     integer :: mm0, i, il3, mm, mmp, n, idp, iq
     real(kind=DP) :: ttr(6), kg(3)
     real(kind=DP) :: qitg_sh, g2, gabs
     real(kind=DP) :: wkx(mmesh), wky(mmesh)
     real(kind=DP), allocatable :: gqmk_l(:) ! d(kgp)
     real(kind=DP), allocatable :: qitg_exx_l(:,:) ! d(kgp,nqitg_sp(it))
     integer,save  :: id_sname = -1

     if(m_PP_include_vanderbilt_pot(it) == SKIP .or. sw_rspace_hyb == ON) return

     call tstatc0_begin('qitgft_qmk ', id_sname)

     call getttr(rltv,ttr)

     allocate(qitg_exx_l(kgp,nqitg_sp(it)))
     allocate(gqmk_l(kgp))
     mm0 = 0
     do i = 1, it-1
        mm0 = mm0 + nqitg_sp(i)
     end do
     do i = 1, kgp
        kg(1:3) = qmk(ik,1:3) + ngabc(i,1:3)
        g2          = ttr(1)*kg(1)*kg(1) &
        &           + ttr(2)*kg(2)*kg(2) &
        &           + ttr(3)*kg(3)*kg(3) &
        &           + ttr(4)*kg(1)*kg(2) &
        &           + ttr(5)*kg(2)*kg(3) &
        &           + ttr(6)*kg(3)*kg(1)
        gqmk_l(i) = sqrt(g2)
     end do
     do il3 = 1, lcmax+1
        if(nmm_il3(il3) <= 0) cycle
        do i = 1, kgp
           gabs = gqmk_l(i)
           if(gabs < DELTA) then
              idp = nmesh(it)+1
           else
              idp = ceiling(nmesh(it) - dlog(rmax(it)*gabs)/h(it))
           end if
           wkx(1:nmesh(it)) = gabs*radr_kept(1:nmesh(it))
           call dsjnvn(il3-1,nmesh(it),idp,wkx,wky)
           do mm = 1, nmm_il3(il3)
              mmp = mm_il3(mm,il3)
              qitg_sh = 0.d0
              do n = 1, nmesh(it)
                 qitg_sh = qitg_sh + wos_kept(n)*qrsps_mm(n,mmp)*wky(n)
              end do
              qitg_exx_l(i,mmp) = qitg_sh*PAI4
           end do
        end do
     end do
     do iq = 1, nqitg_sp(it)
        do i = 1, kgp
           qitg_exx(i,mm0+iq) = qitg_exx_l(i,iq)
        end do
     end do
     deallocate(qitg_exx_l)
     deallocate(gqmk_l)

     call tstatc0_end(id_sname)
  end subroutine qitgft_qmk_each_k
#endif

end module m_ES_ExactExchange

      SUBROUTINE ZHEGVX( ITYPE, JOBZ, RANGE, UPLO, N, A, LDA, B, LDB,
     $                   VL, VU, IL, IU, ABSTOL, M, W, Z, LDZ, WORK,
     $                   LWORK, RWORK, IWORK, IFAIL, INFO )
*
*  -- LAPACK driver routine (version 3.3.1) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*  -- April 2011                                                      --
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, RANGE, UPLO
      INTEGER            IL, INFO, ITYPE, IU, LDA, LDB, LDZ, LWORK, M, N
      DOUBLE PRECISION   ABSTOL, VL, VU
*     ..
*     .. Array Arguments ..
      INTEGER            IFAIL( * ), IWORK( * )
      DOUBLE PRECISION   RWORK( * ), W( * )
      COMPLEX*16         A( LDA, * ), B( LDB, * ), WORK( * ),
     $                   Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  ZHEGVX computes selected eigenvalues, and optionally, eigenvectors
*  of a complex generalized Hermitian-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A and
*  B are assumed to be Hermitian and B is also positive definite.
*  Eigenvalues and eigenvectors can be selected by specifying either a
*  range of values or a range of indices for the desired eigenvalues.
*
*  Arguments
*  =========
*
*  ITYPE   (input) INTEGER
*          Specifies the problem type to be solved:
*          = 1:  A*x = (lambda)*B*x
*          = 2:  A*B*x = (lambda)*x
*          = 3:  B*A*x = (lambda)*x
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  RANGE   (input) CHARACTER*1
*          = 'A': all eigenvalues will be found.
*          = 'V': all eigenvalues in the half-open interval (VL,VU]
*                 will be found.
*          = 'I': the IL-th through IU-th eigenvalues will be found.
**
*  UPLO    (input) CHARACTER*1
*          = 'U':  Upper triangles of A and B are stored;
*          = 'L':  Lower triangles of A and B are stored.
*
*  N       (input) INTEGER
*          The order of the matrices A and B.  N >= 0.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA, N)
*          On entry, the Hermitian matrix A.  If UPLO = 'U', the
*          leading N-by-N upper triangular part of A contains the
*          upper triangular part of the matrix A.  If UPLO = 'L',
*          the leading N-by-N lower triangular part of A contains
*          the lower triangular part of the matrix A.
*
*          On exit,  the lower triangle (if UPLO='L') or the upper
*          triangle (if UPLO='U') of A, including the diagonal, is
*          destroyed.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  B       (input/output) COMPLEX*16 array, dimension (LDB, N)
*          On entry, the Hermitian matrix B.  If UPLO = 'U', the
*          leading N-by-N upper triangular part of B contains the
*          upper triangular part of the matrix B.  If UPLO = 'L',
*          the leading N-by-N lower triangular part of B contains
*          the lower triangular part of the matrix B.
*
*          On exit, if INFO <= N, the part of B containing the matrix is
*          overwritten by the triangular factor U or L from the Cholesky
*          factorization B = U**H*U or B = L*L**H.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  VL      (input) DOUBLE PRECISION
*  VU      (input) DOUBLE PRECISION
*          If RANGE='V', the lower and upper bounds of the interval to
*          be searched for eigenvalues. VL < VU.
*          Not referenced if RANGE = 'A' or 'I'.
*
*  IL      (input) INTEGER
*  IU      (input) INTEGER
*          If RANGE='I', the indices (in ascending order) of the
*          smallest and largest eigenvalues to be returned.
*          1 <= IL <= IU <= N, if N > 0; IL = 1 and IU = 0 if N = 0.
*          Not referenced if RANGE = 'A' or 'V'.
*
*  ABSTOL  (input) DOUBLE PRECISION
*          The absolute error tolerance for the eigenvalues.
*          An approximate eigenvalue is accepted as converged
*          when it is determined to lie in an interval [a,b]
*          of width less than or equal to
*
*                  ABSTOL + EPS *   max( |a|,|b| ) ,
*
*          where EPS is the machine precision.  If ABSTOL is less than
*          or equal to zero, then  EPS*|T|  will be used in its place,
*          where |T| is the 1-norm of the tridiagonal matrix obtained
*          by reducing A to tridiagonal form.
*
*          Eigenvalues will be computed most accurately when ABSTOL is
*          set to twice the underflow threshold 2*DLAMCH('S'), not zero.
*          If this routine returns with INFO>0, indicating that some
*          eigenvectors did not converge, try setting ABSTOL to
*          2*DLAMCH('S').
*
*  M       (output) INTEGER
*          The total number of eigenvalues found.  0 <= M <= N.
*          If RANGE = 'A', M = N, and if RANGE = 'I', M = IU-IL+1.
*
*  W       (output) DOUBLE PRECISION array, dimension (N)
*          The first M elements contain the selected
*          eigenvalues in ascending order.
*
*  Z       (output) COMPLEX*16 array, dimension (LDZ, max(1,M))
*          If JOBZ = 'N', then Z is not referenced.
*          If JOBZ = 'V', then if INFO = 0, the first M columns of Z
*          contain the orthonormal eigenvectors of the matrix A
*          corresponding to the selected eigenvalues, with the i-th
*          column of Z holding the eigenvector associated with W(i).
*          The eigenvectors are normalized as follows:
*          if ITYPE = 1 or 2, Z**T*B*Z = I;
*          if ITYPE = 3, Z**T*inv(B)*Z = I.
*
*          If an eigenvector fails to converge, then that column of Z
*          contains the latest approximation to the eigenvector, and the
*          index of the eigenvector is returned in IFAIL.
*          Note: the user must ensure that at least max(1,M) columns are
*          supplied in the array Z; if RANGE = 'V', the exact value of M
*          is not known in advance and an upper bound must be used.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1, and if
*          JOBZ = 'V', LDZ >= max(1,N).
*
*  WORK    (workspace/output) COMPLEX*16 array, dimension (MAX(1,LWORK))
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The length of the array WORK.  LWORK >= max(1,2*N).
*          For optimal efficiency, LWORK >= (NB+1)*N,
*          where NB is the blocksize for ZHETRD returned by ILAENV.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (7*N)
*
*  IWORK   (workspace) INTEGER array, dimension (5*N)
*
*  IFAIL   (output) INTEGER array, dimension (N)
*          If JOBZ = 'V', then if INFO = 0, the first M elements of
*          IFAIL are zero.  If INFO > 0, then IFAIL contains the
*          indices of the eigenvectors that failed to converge.
*          If JOBZ = 'N', then IFAIL is not referenced.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  ZPOTRF or ZHEEVX returned an error code:
*             <= N:  if INFO = i, ZHEEVX failed to converge;
*                    i eigenvectors failed to converge.  Their indices
*                    are stored in array IFAIL.
*             > N:   if INFO = N + i, for 1 <= i <= N, then the leading
*                    minor of order i of B is not positive definite.
*                    The factorization of B could not be completed and
*                    no eigenvalues or eigenvectors were computed.
*
*  Further Details
*  ===============
*
*  Based on contributions by
*     Mark Fahey, Department of Mathematics, Univ. of Kentucky, USA
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         CONE
      PARAMETER          ( CONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            ALLEIG, INDEIG, LQUERY, UPPER, VALEIG, WANTZ
      CHARACTER          TRANS
      INTEGER            LWKOPT, NB
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZHEEVX, ZHEGST, ZPOTRF, ZTRMM, ZTRSM
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
      UPPER = LSAME( UPLO, 'U' )
      ALLEIG = LSAME( RANGE, 'A' )
      VALEIG = LSAME( RANGE, 'V' )
      INDEIG = LSAME( RANGE, 'I' )
      LQUERY = ( LWORK.EQ.-1 )
*
      INFO = 0
      IF( ITYPE.LT.1 .OR. ITYPE.GT.3 ) THEN
         INFO = -1
      ELSE IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -2
      ELSE IF( .NOT.( ALLEIG .OR. VALEIG .OR. INDEIG ) ) THEN
         INFO = -3
      ELSE IF( .NOT.( UPPER .OR. LSAME( UPLO, 'L' ) ) ) THEN
         INFO = -4
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -9
      ELSE
         IF( VALEIG ) THEN
            IF( N.GT.0 .AND. VU.LE.VL )
     $         INFO = -11
         ELSE IF( INDEIG ) THEN
            IF( IL.LT.1 .OR. IL.GT.MAX( 1, N ) ) THEN
               INFO = -12
            ELSE IF( IU.LT.MIN( N, IL ) .OR. IU.GT.N ) THEN
               INFO = -13
            END IF
         END IF
      END IF
      IF (INFO.EQ.0) THEN
         IF (LDZ.LT.1 .OR. (WANTZ .AND. LDZ.LT.N)) THEN
            INFO = -18
         END IF
      END IF
*
      IF( INFO.EQ.0 ) THEN
         NB = ILAENV( 1, 'ZHETRD', UPLO, N, -1, -1, -1 )
         LWKOPT = MAX( 1, ( NB + 1 )*N )
         WORK( 1 ) = LWKOPT
*
         IF( LWORK.LT.MAX( 1, 2*N ) .AND. .NOT.LQUERY ) THEN
            INFO = -20
         END IF
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZHEGVX', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      M = 0
      IF( N.EQ.0 ) THEN
         RETURN
      END IF
*
*     Form a Cholesky factorization of B.
*
      CALL ZPOTRF( UPLO, N, B, LDB, INFO )
      IF( INFO.NE.0 ) THEN
         INFO = N + INFO
         RETURN
      END IF
*
*     Transform problem to standard eigenvalue problem and solve.
*
      CALL ZHEGST( ITYPE, UPLO, N, A, LDA, B, LDB, INFO )
      CALL ZHEEVX( JOBZ, RANGE, UPLO, N, A, LDA, VL, VU, IL, IU, ABSTOL,
     $             M, W, Z, LDZ, WORK, LWORK, RWORK, IWORK, IFAIL,
     $             INFO )
*
      IF( WANTZ ) THEN
*
*        Backtransform eigenvectors to the original problem.
*
         IF( INFO.GT.0 )
     $      M = INFO - 1
         IF( ITYPE.EQ.1 .OR. ITYPE.EQ.2 ) THEN
*
*           For A*x=(lambda)*B*x and A*B*x=(lambda)*x;
*           backtransform eigenvectors: x = inv(L)**H *y or inv(U)*y
*
            IF( UPPER ) THEN
               TRANS = 'N'
            ELSE
               TRANS = 'C'
            END IF
*
            CALL ZTRSM( 'Left', UPLO, TRANS, 'Non-unit', N, M, CONE, B,
     $                  LDB, Z, LDZ )
*
         ELSE IF( ITYPE.EQ.3 ) THEN
*
*           For B*A*x=(lambda)*x;
*           backtransform eigenvectors: x = L*y or U**H *y
*
            IF( UPPER ) THEN
               TRANS = 'C'
            ELSE
               TRANS = 'N'
            END IF
*
            CALL ZTRMM( 'Left', UPLO, TRANS, 'Non-unit', N, M, CONE, B,
     $                  LDB, Z, LDZ )
         END IF
      END IF
*
*     Set WORK(1) to optimal complex workspace size.
*
      WORK( 1 ) = LWKOPT
*
      RETURN
*
*     End of ZHEGVX
*
      END

!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 475 $)
!
!  SUBROUINE: cnstr_fcvect_work_alloc, cnstr_fcvect_work_dealloc, 
!             get_CS_and_ionic_system_data, read_ntyp_natm_natm2, read_altv, 
!             read_ncord_ninv, read_atomic_coordinates, 
!             read_iatomn_alfa_amion_etc, read_nbztyp, InputData_Analysis
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine InputData_Analysis()
! $Id: InputData_Analysis.F90 475 2016-02-23 05:22:18Z jkoga $
  use m_Files, only :             nfinp, nfout, nfcntn, file_existance_contfiles, file_existance_3contfiles &
       &                        , m_Files_open_nfcntn &
       &                        , m_Files_check_file_names &
       &                        , m_Files_reopen_nfinp &
       &                        , m_Files_reopen_nfcntn &
       &                        , F_ZAJ_in, F_CNTN_in, F_CNTN_BIN_in &
       &                        , F_CHGT_in, F_ZAJ, F_CNTN, F_CNTN_BIN &
       &                        , F_CHGT, F_CNTN_bak &
       &                        , F_CHGT_bak, F_CNTN_BIN_bak &
       &                        , F_ZAJ_bak &
       &                        , m_Files_check_file_existance &
       &                        , m_Files_check_nfcntn_existance, m_Files_echo_nfinp &
       &                        , m_Files_open_nfdynm_cif_initially
  use m_Crystal_Structure, only : altv,rltv,univol,rvol&
       &                        , inversion_symmetry&
       &                        , nbztyp,nbztyp_spg &
       &                        , m_CS_set_nbztyp_spg, m_CS_set_nbztyp &
       &                        , m_CS_rd_symmetry_op_etc &
       &                        , m_CS_set_default_symm_op &
       &                        , m_CS_set_abccacbcc &
       &                        , m_CS_rd_n, m_CS_rd_fix_spin_status
  use m_Ionic_System, only :      input_coordinate_system &
       &                        , ntyp, natm, natm2, nfcatm, iwei, imdtyp  &
       &                        , ityp,cnst_typ, iatomn,iatom,ivan &
       &                        , pos, cps, alfa, amion,zeta1 &
       &                        , m_IS_alloc_pos_and_v, m_IS_rd_pos_and_v &
       &                        , m_IS_alloc_iatomn_etc &
       &                        , m_IS_alloc_cnstrvectors_etc &
       &                        , m_IS_init_cnstrnt &
       &                        , m_IS_cp_works2fcvect_etc, m_IS_rd_atomic_coordinates &
       &                        , m_IS_rd_n, m_IS_set_iatom &
       &                        , m_IS_rd_nrsv_stdin, m_IS_rd_T_parameters &
       &                        , m_IS_set_ionic_mass &
       &                        , m_IS_rd_diis_history &
       &                        , m_IS_natm_can_change &
       &                        , m_IS_rd_curr_atom_reservoir
  use m_Control_Parameters, only: imdalg, paramset,icond,icond_org,nspin &
       &                        , iconvergence_previous_job, ekmode, printable &
       &                        , sw_phonon, sw_positron &
       &                        , driver &
       &                        , sw_phonon, sw_wannier90 &
       &                        , fixed_charge_k_parallel &
       &                        , m_CtrlP_rd_parameters, m_CtrlP_rd_iconvergence &
       &                        , m_CtrlP_rd_iconv_ek &
       &                        , m_CtrlP_rd_numk_zajsaved &
       &                        , m_CtrlP_check_inputfilestyle &
       &                        , m_CtrlP_rd_control &
       &                        , m_CtrlP_rd_accuracy &
       &                        , m_CtrlP_rd_driver &
#ifndef _EMPIRICAL_
       &                        , m_CtrlP_rd_wfsolver &
       &                        , m_CtrlP_rd_chargemix &
       &                        , m_CtrlP_check_matm &
       &                        , m_CtrlP_rd_edelta_ontheway, m_CtrlP_rd_neg_previous &
#endif
       &                        , m_CtrlP_rd_struc_evol &
       &                        , m_CtrlP_rd_printlevel &
       &                        , m_CtrlP_rd_postproc &
       &                        , m_CtrlP_rd_corecharge_cntnbin &
       &                        , sw_optimize_lattice ,sw_rebuild_pws,ipriinputfile
#ifndef _EMPIRICAL_
  use m_Kpoints,            only: m_Kp_rd_way_ksample_etc, m_Kp_rd_n, m_Kp_rd_kv3
  use m_ES_dos,             only: m_ESdos_rd_pdos_param
#endif
  use m_Const_Parameters, only :DP, PUCV, CARTS, PAI2 &
       &, FIX, RELAX, BONDLENGTH_FIX, BONDLENGTH_FIX_1, BONDLENGTH_FIX_2 &
       &, COG_CNTR, COG_FIX_L, HEAT_BATH &
       &, FIX_IN_A_PLANE, CONTINUATION, FIXED_CHARGE, FIXED_CHARGE_CONTINUATION,DELTA &
       &, GENERAL, GENERAL_LARGER &
       &, OLD, NEW_, GRID, ON, OFF &
       &, GDIIS, BFGS &
       &, INITIAL, PREPARATION_ONLY, DRIVER_CONSTRAINT, DRIVER_NEB, DRIVER_MTD &
       &, COORDINATE_CONTINUATION, ONE_BY_ONE, ALL_AT_ONCE
  use m_IterationNumbers, only : m_Iter_rd_iteration_numbers,m_Iter_rd_iters_and_nk,iteration_unit_cell 
#ifndef _EMPIRICAL_
  use m_Phonon,     only : m_Phonon_rd_param, m_Phonon_set_supercell
  use m_BerryPhase, only : m_BP_rd_parameters
  use m_PseudoPotential,  only : m_PP_rd_window_param

  use m_Parallelization, only : mype_conf, nrank_conf, mype, npes, mpi_comm_group, conf_para

  use m_PAW_ChargeDensity,  only : m_PAWCD_rd_ntheta_nphi
  use m_Wannier90, only : m_Wan90_init
  use m_UnitCell, only : m_UC_rd_cntn_data

!!$  use m_Parallel,   only : m_Parallel_rd_npes_etc
#endif
! === For restart lm+MSD! by tkato 2012/02/15 ==================================
  use m_Control_Parameters, only: m_CtrlP_rd_dtim_previous
! ==============================================================================

! ================================ added by K. Tagami ============== 11.0&13.0XX
  use m_Control_Parameters,    only : noncol, ndim_spinor, m_CtrlP_chkif_metagga
! =================================================================== 11.0&13.0XX

  use m_ES_occup, only : m_ES_rd_occ_ext
  use m_ErrorMessages

! ==== KT_add === 13.1XI
  use m_Excitation,  only : m_XI_read_input
! =============== 13.1XI

! === KT_add === 2014/12/29
#ifdef INIT_CHARGE_ATOM_BY_ATOM
  use m_Ionic_System, only :  m_IS_set_mag_moment0_atoms, m_IS_set_ionic_charge_atoms
#endif
! ============== 2014/12/29

  implicit none

  real(kind=DP), allocatable, dimension(:)       :: work
  integer, parameter                         :: NWK = 13
  integer                                    :: nlines
  integer,       allocatable, dimension(:)   :: ia_cnst_work    ! d(natm)
  real(kind=DP), allocatable, dimension(:,:) :: fcvect_work     ! d(natm,4)
  integer :: ierror

  integer,      parameter   :: len_str = 132
  character(len=len_str)       :: str
  character(len=260)           :: zajbuf,cntnbuf,cntn_binbuf,chgtbuf
  character(len=256) :: to_string

  integer :: iret, f_closeInputFile
  logical :: ex
  logical,save :: first_call = .true.
  logical :: initialization_required

  if(.not.initialization_required()) return

  if(m_CtrlP_check_inputfilestyle(nfinp) == NEW_) then
     if(printable) write(nfout,'(" !*--- input-file style = NEW")')
     call m_Files_reopen_nfinp(1)
     if(first_call)then
     call m_CtrlP_rd_printlevel(nfout)
     if(ipriinputfile>0) call m_Files_echo_nfinp() 
     call m_CtrlP_rd_driver(nfout)
     call m_CtrlP_rd_control(nfout,file_existance_contfiles,file_existance_3contfiles)  ! -> icond, cpumax, nmd2, ifstop, ipriekzaj
     endif
     call m_Files_open_nfdynm_cif_initially()
     if(first_call) call m_CtrlP_rd_accuracy(nfout)
     call m_CS_rd_n(nfout)
     call m_CtrlP_rd_struc_evol(nfout)
     call m_CtrlP_rd_postproc(nfout)
#ifndef _EMPIRICAL_
     call m_Phonon_rd_param(nfout)
     if(sw_wannier90==ON) call m_Wan90_init(nfout)
#endif
!     call m_CS_rd_n(nfout)
     call m_IS_rd_n(nfout)
     call m_IS_set_ionic_mass(nfout)

#ifndef _EMPIRICAL_
     call m_CtrlP_rd_wfsolver(nfout,natm)
     call m_CtrlP_rd_chargemix(nfout)
#endif

! === KT_add ==== 2014/12/29
#ifdef INIT_CHARGE_ATOM_BY_ATOM
     call m_IS_set_ionic_charge_atoms(nfout)
     call m_IS_set_mag_moment0_atoms(nfout)
#endif
! =============== 2014/12/29

#ifndef _EMPIRICAL_
     call m_PP_rd_window_param(nfout)
     call m_ESdos_rd_pdos_param(nfout)
     call m_CtrlP_check_matm(nfout,natm) ! rmm_precal_phase_matm

! === KT_add ===== 13.0XX
     call m_CtrlP_chkif_metagga(nfout)
! ================ 13.0XX

! === KT_add ==== 13.1XI
     call m_XI_read_input
! =============== 13.1XI

     if(ekmode /= GRID) then
        call m_Kp_rd_n(nfout)
        call m_BP_rd_parameters
     end if
#endif

     call m_PAWCD_rd_ntheta_nphi

     call m_ES_rd_occ_ext(nfout)

     ! setup supercell

#ifndef _EMPIRICAL_
     if(sw_phonon == ON) call m_Phonon_set_supercell
#endif

     icond_org=icond
     if(driver == DRIVER_CONSTRAINT .and. conf_para .and. .not.(icond==PREPARATION_ONLY)) then
       icond=INITIAL
     endif

     if(driver == DRIVER_MTD .and.mype_conf>0)then
        zajbuf=F_ZAJ;cntnbuf=F_CNTN;cntn_binbuf=F_CNTN_BIN;chgtbuf=F_CHGT
        F_ZAJ=trim(zajbuf)//'_conf'//trim(adjustl(to_string(mype_conf,2)))
        F_CNTN=trim(cntnbuf)//'_conf'//trim(adjustl(to_string(mype_conf,2)))
        F_CNTN_BIN=trim(cntn_binbuf)//'_conf'//trim(adjustl(to_string(mype_conf,2)))
        F_CHGT=trim(chgtbuf)//'_conf'//trim(adjustl(to_string(mype_conf,2)))

        F_ZAJ_in=trim(zajbuf)//'_conf'//trim(adjustl(to_string(mype_conf,2)))
        F_CNTN_in=trim(cntnbuf)//'_conf'//trim(adjustl(to_string(mype_conf,2)))
        F_CNTN_BIN_in=trim(cntn_binbuf)//'_conf'//trim(adjustl(to_string(mype_conf,2)))
        F_CHGT_in=trim(chgtbuf)//'_conf'//trim(adjustl(to_string(mype_conf,2)))
     endif

!!$     call parse_args()
!     call m_Files_reopen_nfinp(2)
!!$     stop '  !! stop after [call m_Files_reopen_nfinp(2) <<InputData_Analysis>>'
  else
     if(printable) write(nfout,'(" !! --- input-file style = OLD")')
     allocate(work(NWK))
     call m_CtrlP_rd_parameters(nfinp,nfout,nlines)
     call get_CS_and_ionic_system_data(nlines) !-(contained here) CS: Crystal Structure, contained here

#ifndef _EMPIRICAL_
     if(ekmode /= GRID) call m_Kp_rd_way_ksample_etc(nfinp,nlines) ! <-(nfinp-file)
#endif
     call m_CS_set_abccacbcc()
     if(nbztyp >= 2 .and. &
          & (nbztyp_spg == GENERAL .or. nbztyp_spg == GENERAL_LARGER)) then
!!$        call m_Files_open_nfspg()
!!$        call m_CS_rd_symmetry_op_etc(nfspg)
        call m_CS_rd_symmetry_op_etc(nfinp)
     else
        call m_CS_set_default_symm_op(nfout)  ! <-- nbztyp_spg
     end if
!!$     call m_CS_rd_symmetry_operations(nfinp)

     call m_IS_rd_nrsv_stdin(nfinp)   ! ->(nrsv)
     call m_IS_rd_T_parameters(imdalg,nfinp)
     !                                            ->(qmass,tkb,cprv,cpqr,forcp)
     deallocate(work)
  end if

!!$  call m_Files_check_file_existance()
  ex = file_existance_contfiles.and.file_existance_3contfiles

  if(driver==DRIVER_MTD.and.mype_conf>0 .and. .not.ex.and.icond==CONTINUATION)then
     F_CNTN=F_CNTN_bak
     F_CNTN_BIN=F_CNTN_BIN_bak
     F_CHGT=F_CHGT_bak
     F_ZAJ=F_ZAJ_bak
     F_CNTN_in=F_CNTN_bak
     F_CNTN_BIN_in=F_CNTN_BIN_bak
     F_CHGT_in=F_CHGT_bak
     F_ZAJ_in=F_ZAJ_bak
     if(printable) then
        write(nfout,'(a)') 'temporarily renamed continuation files'
        write(nfout,'(a)') '  F_CNTN     : '//trim(F_CNTN)
        write(nfout,'(a)') '  F_CNTN_BIN : '//trim(F_CNTN_BIN)
        write(nfout,'(a)') '  F_CHGT     : '//trim(F_CHGT)
        write(nfout,'(a)') '  F_ZAJ      : '//trim(F_ZAJ)
     endif
  endif

  if(driver .ne. DRIVER_NEB) then
  if(icond == CONTINUATION .or.icond==COORDINATE_CONTINUATION .or. &
       & (icond == FIXED_CHARGE_CONTINUATION .and. fixed_charge_k_parallel == ALL_AT_ONCE)) then
     if(sw_phonon == OFF) then
        if(m_Files_check_nfcntn_existance()) then
           call m_Files_open_nfcntn()
        else
           ierror = FILE_NOT_EXIST
           call phase_error(ierror, nfout, nfcntn, F_CNTN, __LINE__, __FILE__)
        end if
     endif
  endif
#ifndef DISABLE_CONSTRAINTS
  if(driver==DRIVER_CONSTRAINT) call constrained_dynamics_init(nfout)
#endif
  if(icond == CONTINUATION .or.icond==COORDINATE_CONTINUATION .or. &
       & (icond == FIXED_CHARGE_CONTINUATION .and. fixed_charge_k_parallel == ALL_AT_ONCE)) then
   if(sw_phonon == OFF) then
     if(m_Files_check_nfcntn_existance()) then
        call m_Files_open_nfcntn()
     else
        ierror = FILE_NOT_EXIST
        call phase_error(ierror, nfout, nfcntn, F_CNTN, __LINE__, __FILE__)
     end if
     call m_Iter_rd_iteration_numbers(nfcntn,icond)
     call m_IS_rd_pos_and_v(nfcntn)

     call m_IS_rd_curr_atom_reservoir(nfcntn)
     if ((imdalg==GDIIS .or. imdalg==BFGS).and.icond.ne.COORDINATE_CONTINUATION) then
        call m_IS_rd_diis_history(nfcntn)
     endif
#ifndef _EMPIRICAL_
     if(icond==CONTINUATION) call m_CtrlP_rd_neg_previous(nfcntn)
     call m_CtrlP_rd_edelta_ontheway(nfcntn)
#endif
! === For restart lm+MSD! by tkato 2012/02/15 ==================================
   call m_CtrlP_rd_dtim_previous(nfcntn)
! ==============================================================================
     call m_CtrlP_rd_iconvergence(nfcntn)
     call m_CtrlP_rd_corecharge_cntnbin(nfcntn) ! -> status_cntnbin_positron
     call m_CS_rd_fix_spin_status(nfcntn,nfout)  ! <-- T. Yamasaki, 18th Aug. 2009
     if(icond==CONTINUATION.and.sw_optimize_lattice==ON.and.sw_rebuild_pws==ON) &
      & call m_UC_rd_cntn_data(nfcntn)
   end if
  else if(icond == FIXED_CHARGE .and. fixed_charge_k_parallel == ALL_AT_ONCE) then
     !!if( m_Files_check_nfcntn_existance()) then
     !!   call m_Files_open_nfcntn()
     !!   call m_IS_rd_pos_and_v(nfcntn)
     !!endif
  else if(icond == FIXED_CHARGE_CONTINUATION.and.fixed_charge_k_parallel == ONE_BY_ONE) then
     if(m_Files_check_nfcntn_existance()) then
        call m_Files_open_nfcntn()
     else
        ierror = FILE_NOT_EXIST
        call phase_error(ierror, nfout, nfcntn, F_CNTN, __LINE__, __FILE__)
     end if
     call m_CtrlP_rd_iconvergence(nfcntn)

! ================================================ modified by K. Tagami ======= 11.0
!     call m_Iter_rd_iters_and_nk(nfcntn,nspin)
!!$     if(fixed_charge_k_parallel == ALL_AT_ONCE) then
!!$        call m_Iter_rd_iteration_numbers(nfcntn,icond)
!!$     else if(fixed_charge_k_parallel == ONE_BY_ONE) then
     if ( noncol ) then
        call m_Iter_rd_iters_and_nk(nfcntn,ndim_spinor)
     else
        call m_Iter_rd_iters_and_nk(nfcntn,nspin)
     endif
! ============================================================================== 11.0

!!$     call m_Parallel_rd_npes_etc(nfcntn)
     call m_Kp_rd_kv3(nfcntn,nfout)
     if(sw_positron /= OFF) call m_CtrlP_rd_corecharge_cntnbin(nfcntn) ! -> status_cntnbin_positron
     call m_CtrlP_rd_iconv_ek(nfcntn,nfout)  ! -> iconv_ek_tmp
     call m_CtrlP_rd_numk_zajsaved(nfcntn,nfout) ! -> numk_zajsaved
  end if
  end if

  !!$call m_Files_check_file_names  ! for debugging 

  iret = f_closeInputFile()
  first_call = .false. 
contains
  subroutine cnstr_fcvect_work_alloc
    if(printable) write(nfout,'(" ! natm  = ",i6," << cnstr_fcvect_work_alloc >>")') natm
    allocate(ia_cnst_work(natm))
    allocate(fcvect_work(natm,4));fcvect_work = 0.d0
  end subroutine cnstr_fcvect_work_alloc

  subroutine cnstr_fcvect_work_dealloc
    if(allocated(fcvect_work)) deallocate(fcvect_work)
    if(allocated(ia_cnst_work)) deallocate(ia_cnst_work)
  end subroutine cnstr_fcvect_work_dealloc
    
  subroutine get_CS_and_ionic_system_data(nlines)
    integer, intent(in) :: nlines
!        =================
    rewind nfinp
    call read_ntyp_natm_natm2(nfinp)       ! gmax, gmaxp, ntyp, natm, natm2
    call read_altv(nfinp)                  ! altv, rltv, univol, rvol
    call read_ncord_ninv(nfinp)            ! ncord, ninv

    ! --> atomic coordinates, iwei, imdtyp, ityp, fcvect etc.
    call m_IS_alloc_pos_and_v(nfout)       ! pos, cps, cpd_l, cpo_l, iwei, imdtyp, ityp
    call cnstr_fcvect_work_alloc()          !-(InputData_Analysis) (*) ->ia_cnst_work,fcvect_work
    call read_atomic_coordinates(nfinp)      ! -> nfcatm
!!$    call m_IS_rd_atomic_coordinates(nfinp,nfout,work,ia_cnst_work,fcvect_work)      ! -> nfcatm
    call m_IS_alloc_iatomn_etc()           ! iatomn,iatom,ivan,alfa,amion,zeta1
    call m_IS_alloc_cnstrvectors_etc(imdalg) ! (fcvect,ia_cnst,gca)
    call m_IS_cp_works2fcvect_etc(imdalg,nfcatm,ia_cnst_work,fcvect_work)
    !   (fcvect_work,ia_cnst_work) ->(fcvect,ia_cnst)

    call m_IS_set_iatom(nfout)             ! -> iatom
    call read_iatomn_alfa_amion_etc(nfinp) ! iatomn,alfa,amion
    call m_IS_init_cnstrnt(natm,fcvect_work)
    call cnstr_fcvect_work_dealloc         !-(InputData_Analysis) (*)

    call skip_lines(nfinp,nlines+9)  ! nbztyp
    call read_nbztyp(nfinp)
!!$    call skip_lines(nfinp,2)  ! neg
!!$    call read_neg(nfinp)
!        =================
  end subroutine get_CS_and_ionic_system_data

  subroutine read_ntyp_natm_natm2(nfinp)
    integer, intent(in) :: nfinp
    
    real(kind=DP) :: wk1, wk2
    read(nfinp,*) wk1, wk2, ntyp, natm, natm2
    if(printable) write(nfout,100) wk1, wk2, ntyp, natm, natm2
100 format(' ',2f8.4,3i4,'   : gmax, gmaxp, ntyp, natm, natm2')
  end subroutine read_ntyp_natm_natm2

  subroutine read_altv(nfinp)
    integer, intent(in) :: nfinp
    integer      :: i,j
    do i = 1, 3
       read(nfinp,*) altv(1,i), altv(2,i), altv(3,i)
       if(printable) write(nfout,'(2H  ,3f20.10)') altv(1,i), altv(2,i), altv(3,i)
    enddo

    if(printable) write(nfout,'("      <<<RECIPROCAL LATTICE VECTOR>>>")')
    call altv_2_rltv(altv,rltv,univol,rvol)
    if(printable) write(nfout,100) ((rltv(i,j),i=1,3),j=1,3)
100 format((' ',3f18.10))
    if(printable) write(nfout,'("VOLUME OF A UNIT CELL=",2f20.10)') univol,rvol
    
  end subroutine read_altv

  subroutine read_ncord_ninv(nfinp)
    integer, intent(in) :: nfinp

    read(nfinp,*) input_coordinate_system, inversion_symmetry
    if(printable) write(nfout,120) input_coordinate_system, inversion_symmetry
120 format(' ',2i4,'   : ncord, ninv,   : iwei, imdtyp, ityp')
  end subroutine read_ncord_ninv

  subroutine read_atomic_coordinates(nfinp)
    integer, intent(in)  :: nfinp

    integer          :: i, imdt, incunt
    real(kind=DP)    :: v

    if(printable) write(nfout,'(" !! << read_atomic_coordinates >>")')
    nfcatm = 0
    do i = 1, natm
       read(nfinp,*) pos(i,1),pos(i,2),pos(i,3),iwei(i),imdtyp(i),ityp(i) 
       if(printable) write(nfout,210) pos(i,1),pos(i,2),pos(i,3),iwei(i),imdtyp(i),ityp(i)
       imdt = imdtyp(i)
       if((imdt<HEAT_BATH .and. imdt/=FIX .and. imdt/=RELAX .and.imdt/=BONDLENGTH_FIX) &
            & .or.&
            & (imdt == HEAT_BATH+BONDLENGTH_FIX_1 .or. imdt == HEAT_BATH+BONDLENGTH_FIX_2 &
            &  .or. imdt == HEAT_BATH+COG_FIX_L)) then
          nfcatm = nfcatm + 1
          if(printable) write(nfout,*)' nfcatm = ', nfcatm
          ia_cnst_work(nfcatm) = i
          if(nfcatm == 1) then
             if(imdt > HEAT_BATH) then
                cnst_typ = imdt - HEAT_BATH
             else
                cnst_typ = imdt
             end if
          end if
          backspace nfinp
          read(nfinp,'(a132)') str
          call chnnm(str,len_str,10,work,incunt)
          if(incunt == 7) then
             fcvect_work(nfcatm,1) = work(7)
          else if(incunt >= 9) then
             if(input_coordinate_system == PUCV) then
                work(11:13) = matmul(altv,work(7:9))
             else if(input_coordinate_system == CARTS) then
                work(11:13) = work(7:9)
             end if
    !        ---> Normalization of directional vectors fcvect(*,1:3).
             v = dsqrt(dot_product(work(11:13),work(11:13)))
             fcvect_work(nfcatm,1:3) = work(11:13)/v

             if(incunt == 10) fcvect_work(nfcatm,4) = work(10)
             if(printable) write(nfout,9001) nfcatm &
                  &     ,fcvect_work(nfcatm,1),fcvect_work(nfcatm,2) &
                  &     ,fcvect_work(nfcatm,3),fcvect_work(nfcatm,4)
9001         format(' Fcvect(',i4,') = ',3f8.4, d20.8)
          endif
       endif
    enddo
210 format(' ',3f18.10,i3,i6,i3)

    if(input_coordinate_system == PUCV) then
       call change_of_coordinate_system(altv,pos,natm,natm,cps) !-(b_C.S.)
    else if(input_coordinate_system == CARTS) then
       cps = pos
       rltv = transpose(rltv)/PAI2
       call change_of_coordinate_system(rltv,cps,natm,natm,pos) !-(b_C.S.)
       call altv_2_rltv(altv,rltv,univol,rvol) !-(b_Crystal_Structure)
       !                   (altv)->(rltv,univol,rvol)
    end if

    if(printable) then
       write(nfout,*) ' ! nfcatm = ', nfcatm
       write(nfout,*) ' ! cnst_typ = ', cnst_typ
    end if

!!$    call m_IS_init_cnstrnt(natm,fcvect_work)   ! ->sgmc

    if(printable) write(nfout,*) ' ! univol = ', univol
  end subroutine read_atomic_coordinates

  subroutine read_iatomn_alfa_amion_etc(nfinp)
    integer, intent(in) :: nfinp
    integer nsize
    integer i
    do i = 1, ntyp
       read(nfinp,'(a132)') str
       call chnnm(str,len_str,NWK,work,nsize)
       iatomn(i) = work(1)
       alfa(i)   = work(2)
       amion(i)  = work(3)
!!$       iloc_inputf(i)   = nint(work(4))
       ivan(i)   = nint(work(5))
       zeta1(i)  = work(6)
       if(printable) then
          if(nsize >=6 .and. dabs(zeta1(i)) > 1.d-20) then
             write(nfout,511) iatomn(i),alfa(i),amion(i),nint(work(4)),ivan(i),zeta1(i),i
          else
             write(nfout,510) iatomn(i),alfa(i),amion(i),nint(work(4)),ivan(i),i
          endif
       end if
    enddo
510 format(' ',2f8.4,f10.2, 2i2 &
         & ,' :type',i2,'iatomn,alfa,amion,iloc,ivan')
511 format(' ',2f8.4,f10.2, 2i2, f10.2 &
         & ,' :type',i2, 'iatomn,alfa,amion,iloc,ivan,zeta1')
  end subroutine read_iatomn_alfa_amion_etc

  subroutine read_nbztyp(nfinp)
    integer, intent(in) :: nfinp
    read(nfinp,*) nbztyp
    if(printable) write(6,9000) nbztyp
9000 format(' ',i3,'  : nbztyp 0-sf, 1-bk, 2-sc, 3-bcc, 4-fcc, ', &
          &                      '5-dia, 6-hex')
    call m_CS_set_nbztyp_spg() ! -> nbztyp_spg <- nbztyp
!!$    nbztyp1 = nbztyp
    if(nbztyp /= 0 .and. nbztyp /= 1 .and. nbztyp /= GENERAL .and. nbztyp /= GENERAL_LARGER) then
       call m_CS_set_nbztyp(GENERAL) ! nbztyp <- GENERAL
!!$        nbztyp = GENERAL
    end if 
  end subroutine read_nbztyp

#ifndef SX
  subroutine parse_args()
    integer :: i,narg,ieq
    character(len=32) :: arg,argval
    narg = command_argument_count()
    do i=1,narg
       call get_command_argument(i,arg)
       argval = arg 
       ieq = index(arg,'=')
       if (ieq>0) then
          if(.not.(ieq.eq.len_trim(arg)-1)) then
             write(0,*) 'invalid argument : '//trim(arg)
             stop
          endif
          argval = arg(1:ieq-1)
       endif
       select case (argval)
       case('-p','--preparation')
          icond = PREPARATION_ONLY
       end select
    enddo
  end subroutine parse_args
#endif
end subroutine InputData_Analysis

subroutine InputData_Analysis_neb()
! $Id: InputData_Analysis.F90 475 2016-02-23 05:22:18Z jkoga $
  use m_Files, only :             nfout, nfcntn &
       &                        , m_Files_reopen_nfcntn
  use m_Ionic_System, only :      m_IS_rd_pos_and_v
  use m_Control_Parameters, only: icond,nspin &
       &                        , iconvergence_previous_job &
#ifndef _EMPIRICAL_
       &                        , m_CtrlP_rd_edelta_ontheway &
#endif
       &                        , m_CtrlP_rd_iconvergence
  use m_Const_Parameters, only :  CONTINUATION, FIXED_CHARGE_CONTINUATION
  use m_IterationNumbers, only :  m_Iter_rd_iteration_numbers,m_Iter_rd_iters_and_nk

! ============================= added by K. Tagami ==================== 11.0
  use m_Control_Parameters,    only : noncol, ndim_spinor
! ===================================================================== 11.0

  implicit none

  if(icond == CONTINUATION) then
     call m_Files_reopen_nfcntn()
     call m_Iter_rd_iteration_numbers(nfcntn,icond)
!!!!!     call m_IS_rd_pos_and_v(nfcntn)
     call m_CtrlP_rd_iconvergence(nfcntn)
#ifndef _EMPIRICAL_
     call m_CtrlP_rd_edelta_ontheway(nfcntn)
#endif
  else if(icond == FIXED_CHARGE_CONTINUATION) then
     call m_Files_reopen_nfcntn()
     call m_CtrlP_rd_iconvergence(nfcntn)
!!$     call m_Iter_rd_iters_and_nk(iconvergence_previous_job,nfcntn,nspin)

! ========================================= modified by K. Tagami ========= 11.0
!     call m_Iter_rd_iters_and_nk(nfcntn,nspin)

     if ( noncol ) then
       call m_Iter_rd_iters_and_nk(nfcntn,ndim_spinor)
     else
       call m_Iter_rd_iters_and_nk(nfcntn,nspin)
     endif
! ======================================================================== 11.0

  end if
  
end subroutine InputData_Analysis_neb

!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 440 $)
!
!  PROGRAM: TDLRMAIN
!
!  AUTHOR(S): K. Tagami et al   Aug. 1 2011
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is a module for calculating and printing spectra.
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.  
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

module m_LinearResponse_Spectrum

  use m_Const_Parameters,           only : DP, ON, OFF, CMPLDP, DELTA, &
       &                                   BUCS, Hartree, PAI4
  use m_Control_Parameters,         only : nspin, neg
  use m_Timing,                     only : tstatc0_begin, tstatc0_end
!
!  use m_Parallelization,        only : mype, myrank_e, npes, mpi_comm_group, &
!       &                               ierr, map_e, map_z
  use m_Parallelization
  use m_Files,                      only  : nfout, nf_LR_spectra
  use m_Crystal_Structure,   only : univol, rltv
  use m_Electronic_Structure,    only : eko_ek
  use m_LinearResponse_Control,     only  : e, nmax_G_LR, &
       &                                    vqxyz,  &
       &                                    xc_kernel_type, ALDA_R,  &
       &                                    sw_NLF, & 
       &                                    spectrum_type, &
       &                                    OPTICS, PACS, EELS, IXSS, &
       &                                    e_high
  use m_LinearResponse_Density,     only :  RhoTilde, occup_lkt_ek

!  use m_IterationNumbers,     only : nk_in_the_process, nk_converged
!  use m_PlaneWaveBasisSet,    only : kg1

  use m_LinearResponse_Kernel, only : Kernel_Coulomb, Kernel_XC

  
  use m_LinearResponse_NonInt,  only : Mat_Chi0, &
       &                               nband_LR, band_start_LR, band_end_LR

  
  use m_LinearResponse_ALDA, only : MatrixT
  use m_PlaneWaveBasisSet,    only : ngabc
  use m_LinearResponse_BS,   only : MatL0, MatXi

  Implicit None
!  include 'mpif.h'

  Complex(kind=CMPLDP), allocatable :: Chi_Head(:,:)
  Complex(kind=CMPLDP), allocatable :: MatL(:,:)

contains 

!-------------------------------------------------------------
!!
!!!               Alloc /Dealloc Chi_Head
!!
! ------------------------------------------------------------
  subroutine m_LR_alloc_Chi_Head
    if ( mype == 0 ) then
       allocate( Chi_Head( nspin,nspin )  ); Chi_Head = 0.0d0
    endif
  end subroutine m_LR_alloc_Chi_Head

  subroutine m_LR_dealloc_Chi_Head
    if ( mype == 0 ) deallocate( Chi_Head )
  end subroutine m_LR_dealloc_Chi_Head

!-------------------------------------------------------------
!!
!!!               Alloc /Dealloc Matrix L of BS equation
!!
! ------------------------------------------------------------
  subroutine m_LR_Alloc_MatL
    integer :: matsize
    matsize = nband_LR**2
    if ( mype == 0 ) then
       allocate( MatL( matsize, matsize) ); MatL = 0.0D0
    endif
  end subroutine m_LR_Alloc_MatL

  subroutine m_LR_dealloc_MatL
    if ( mype == 0 ) deallocate( MatL )
  end subroutine m_LR_dealloc_MatL
!---------------------------------------------------------
!!
!!!          Solver for Dyson-like Equation
!!
!----------------------------------------------------------
  subroutine Calc_Chi_Head( ene )
    real(kind=DP), intent(in)  :: ene

    Complex(kind=CMPLDP), allocatable :: MatA( :,: ), TmpVector(:,:)
    integer :: matsize, i, j
    integer :: id_sname = -1
! ---------------------------- start --------
    if ( mype /= 0 ) return

    call tstatc0_begin('Calc_Chi_Head ', id_sname)
    call Alloc_Arrays_For_LinEq

    if ( xc_kernel_type == ALDA_R ) then
       call set_XC_contrib_GatOnida
    else
       call set_XC_contrib_default
    endif

    if ( sw_NLF == OFF ) call add_LF_effects
    if ( spectrum_type /= OPTICS ) call add_hartree_contrib_G0

    call Add_Diagonal_Elements
    call Initial_Guess_VecX
    Call Calc_LinearEq( nspin, matsize, MatA, TmpVector )
    Call Extract_ChiHead
    call Dealloc_Arrays_For_LinEq
!
!    call tstatc0_end(id_sname)
    
  contains

    subroutine Extract_ChiHead
      Chi_Head(1:nspin,1:nspin) = TmpVector(1:nspin,1:nspin)
    end subroutine Extract_ChiHead

    subroutine Alloc_Arrays_For_LinEq
      matsize = nspin *nmax_G_LR
      Allocate( MatA( matsize, matsize ) );   MatA = 0.0d0
      Allocate( TmpVector( matsize,nspin ) ); TmpVector = 0.0d0
    end subroutine Alloc_Arrays_For_LinEq

    subroutine Dealloc_Arrays_For_LinEq
      Deallocate( MatA, TmpVector )
    end subroutine Dealloc_Arrays_For_LinEq

    subroutine Set_XC_Contrib_GatOnida
      integer :: i, j, ni, nj, tmp_i, tmp_j
      Do i=1, nmax_G_LR
         Do j=1, nmax_G_LR
            Do ni=1, nspin
               Do nj=1, nspin
                  tmp_i = ( i-1 )*nspin + ni
                  tmp_j = ( j-1 )*nspin + nj
                  MatA( tmp_i, tmp_j ) = -MatrixT( i,j,ni,nj )
               End do
!               write(*,*) 'Y', i,j,ni,nj, MatA( tmp_i, tmp_j )
            End Do
         End Do
      End Do
!      stop
    end subroutine Set_XC_Contrib_GatOnida

    subroutine set_XC_contrib_default
      integer       :: i, j, k, ni, nj, nk
      integer       :: tmp_i, tmp_j, tmp_k
      complex(kind=CMPLDP) :: d1

      Do i=1, nmax_G_LR
         Do j=1, nmax_G_LR
            Do ni=1, nspin
               Do nj=1, nspin
!
                  d1 = 0.0d0
                  Do k=1, nmax_G_LR
                     Do nk=1, nspin

                        if ( ni == nk ) then
                           tmp_i = (i-1)*nspin + ni
                           tmp_j = (j-1)*nspin + nj
                           tmp_k = (k-1)*nspin + nk
                           d1 = d1 + Mat_Chi0( i,k,ni ) *Kernel_XC( k,j,nk,nj )
                        endif
                     End do
                  End do
                  MatA( tmp_i,tmp_j ) = -d1
!                  write(*,*) 'Y', i,j,ni,nj, MatA( tmp_i, tmp_j )
               End do
            End do
         End do
      End do
!      stop
    end subroutine set_XC_contrib_default

    subroutine add_LF_effects
      integer       :: i, j, ni, nj
      integer       :: tmp_i, tmp_j

      Do i=1, nmax_G_LR
         Do j=2, nmax_G_LR
!            if ( i /= j ) cycle

            Do ni=1, nspin
               Do nj=1, nspin
                  tmp_i = (i-1)*nspin + ni
                  tmp_j = (j-1)*nspin + nj

                  MatA( tmp_i,tmp_j ) = MatA( tmp_i, tmp_j ) &
                       &         - Mat_Chi0( i,j,ni ) *Kernel_Coulomb(j)

!                 write(*,*) tmp_i, tmp_j, Chi0_Full(i,j,ni)
!                 write(*,*) tmp_i, tmp_j, Kernel_Coulomb(j)
               End do
            End do
         End do
      End do
!      stop
    end subroutine add_LF_effects

    subroutine add_hartree_contrib_G0
      integer :: i, j, ni, nj, tmp_i, tmp_j
      Do i=1, nmax_G_LR
         Do j=1, 1
!            if ( i /= j ) cycle

            Do ni=1, nspin
               Do nj=1, nspin
                  tmp_i = (i-1)*nspin + ni
                  tmp_j = (j-1)*nspin + nj
                  MatA( tmp_i,tmp_j ) = MatA( tmp_i,tmp_j ) &
                       &              - Mat_Chi0( i,j,ni ) *Kernel_Coulomb(j)
               End do
            End do
         End do
      End do
    end subroutine add_hartree_contrib_G0

    subroutine Add_Diagonal_Elements
      integer  :: i, ni, tmp_i
      Do i=1, nmax_G_LR
         Do ni=1, nspin
            tmp_i = (i-1)*nspin + ni
            MatA( tmp_i,tmp_i ) = MatA( tmp_i,tmp_i )  +1.0d0
!            write(*,*) 'F ',tmp_i, MatA( tmp_i,tmp_i)
         End do
      End do
!      stop
    end subroutine Add_Diagonal_Elements

    subroutine Initial_Guess_VecX
      integer :: i, j, ni, nj, tmp_i, tmp_j

      TmpVector = 0.0d0
      Do j=1, 1
         Do nj=1, nspin
            Do i=1, nmax_G_LR
               Do ni=1, nspin
                  if ( ni==nj ) then
                     tmp_i = (i-1)*nspin + ni
                     tmp_j = (j-1)*nspin + nj
                     TmpVector(tmp_i,nj) = Mat_Chi0( i,j,ni )
                  endif
               End do
            End do
         End do
      End do
    end subroutine Initial_Guess_VecX

  end subroutine Calc_Chi_Head
  
  subroutine Calc_LinearEq( ncolumn, matsize, MatA, VecX )
    integer, intent(in)                 :: ncolumn, matsize
    complex(kind=CMPLDP), intent(inout) :: MatA( matsize, matsize )
    complex(kind=CMPLDP), intent(inout) :: VecX( matsize, ncolumn )
    
    integer                 ::  kt_info
    integer,    allocatable :: iwork(:)
    integer :: id_sname = -1
    !      
    call tstatc0_begin('Calc_Linear_Equation ', id_sname)
    !
    Allocate( iwork( matsize ) )
    Call ZGESV( matsize, ncolumn, MatA, matsize, iwork, VecX, &
         &      matsize, kt_info )
    if ( kt_info /= 0 ) write(nfout,*) 'kt_info = ', kt_info

    Deallocate( iwork )
    call tstatc0_end(id_sname)
      
  end subroutine Calc_LinearEq

!---------------------------------------------------------
!!
!!!          Limit band indices in consideraiton
!!
!----------------------------------------------------------
 subroutine set_nband_LR
    integer ispin, k, ik1, ib1
    Real(kind=DP) :: width, emin, emax, ebi
    Real(kind=DP) :: occ1, e_homo, e_lumo
    integer :: k_max
! ------------
    k_max = 1
    e_homo = -1.0D+3;   e_lumo= 1.0D+3
! --------------------------
    Do ispin=1, nspin
       Do k=1, k_max
          ik1 = nspin*(k-1) + ispin
          Do ib1=1, neg           ! unoccpuied state
             ebi = Eko_ek( ib1,ik1 )
             occ1 = Occup_lkt_ek( ib1, ik1 );
             if ( occ1 > Delta )  then
                e_homo = max( ebi, e_homo )
             else
                e_lumo = min( ebi, e_lumo )
             endif
          End do
       End do
    End do
! ----------------
!    Do ib1=1, neg
!       write(80+mype,*) ib1, eko_ek( ib1,1 ), occup_lkt_ek( ib1,1 )
!    End do
!    stop
    if ( mype == 0 ) then
       write(nfout,*) '! Highest  occupied level ', e_homo
       write(nfout,*) '! Lowest unoccupied level ', e_lumo
    endif
! ------------------------
    width = e_high
    emin = e_lumo - width; emax = e_homo + width
! --------------------------
    Do ispin=1, nspin
       Do k=1, k_max
          ik1 = nspin*(k-1) + ispin
          Do ib1=1, neg           ! unoccpuied state
             ebi = Eko_ek( ib1,ik1 )
             if ( ebi < emin ) then
                band_start_LR = ib1
             else if ( ebi < emax ) then
                band_end_LR = ib1
             endif
          End do
       End do
    End do
! -------------------- temp --------
!    band_start_LR = 6
!    band_end_LR = 7
! ----------------------------------
    nband_LR = band_end_LR - band_start_LR +1
    if ( mype == 0 ) then
       write(nfout,*) '!* band LR : start, end = ', band_start_LR, band_end_LR
    endif
  end subroutine set_nband_LR

!---------------------------------------------------------
!!
!!!          Solver for BS-like Equation
!!
!----------------------------------------------------------
  subroutine Calc_MatL
    Complex(kind=CMPLDP), allocatable :: MatA(:,:), work(:)
    integer, allocatable :: ipiv(:)
    integer matsize, lwork, info
!
    Complex(kind=CMPLDP) :: ztmp
    integer :: ix1, ix2, ib1, ib2
! ---
    matsize = nband_LR**2
    lwork = matsize
! --
    if ( mype /= 0 ) return

    allocate( MatA(matsize,matsize) ); MatA = 0.0D0
    allocate( ipiv(matsize) ); ipiv = 0
    allocate( work(lwork) ); work = 0.0d0
!
    Do ix1=1, matsize
       ib1 = ( ix1-1 ) /nband_LR +1
       ib2 = mod( ix1-1,nband_LR ) + 1
       ztmp = 0.0D0
       Do ix2=1, matsize
          MatA(ix1,ix2) = -MatL0( ib1,ib2,1 ) *MatXi(ix1,ix2) *dcmplx(0.0D0,1.0D0)
       End do
    End do
    Do ix1=1, matsize
       MatA(ix1,ix1) = MatA(ix1,ix1) + 1.0D0
    End do
!
    Call ZGETRF( matsize, matsize, MatA, matsize, ipiv, info )
    if ( info /= 0 ) write(*,*) 'INFO A2 = ', info
    Call ZGETRI( matsize, MatA, matsize, ipiv, work, lwork, info )
    if ( info /= 0 ) write(*,*) 'INFO B2 = ', info
!
    Do ix1=1,matsize
       Do ix2=1,matsize
          ib1 = ( ix2-1 ) /nband_LR +1
          ib2 = mod( ix2-1,nband_LR ) + 1
          MatL(ix1,ix2) = MatA(ix1,ix2) *MatL0(ib1,ib2,1)
       End do
    End do
    deallocate( ipiv, work )
    deallocate( MatA )

  end subroutine Calc_MatL

  subroutine Calc_Chi_Head_Mol( ene )
    real(kind=DP), intent(in) :: ene

    Complex(kind=CMPLDP) :: ztmp1, ztmp2, z0, z1, z2
    integer ix1, ix2, ib1, ib2, ib3, ib4
    integer ispin
! ---------------
    if ( npes > 1 ) call mpi_barrier( mpi_comm_group,ierr )
! --
    ztmp1 = 0.0D0
    ztmp2 = 0.0D0
    z0 = 0.0D0
    Do ix1=1, nband_LR**2
       ib1 = ( ix1-1 ) /nband_LR +1
       ib2 = mod( ix1-1,nband_LR ) + 1

       if ( mype == 0 ) z0 = MatL0( ib1, ib2, 1 )

       ib1 = ib1 + band_start_LR -1;     ib2 = ib2 + band_start_LR -1

       call set_value_z1
       ztmp1 = ztmp1 -conjg(z1) *z1 *z0 *dcmplx(0.0,1.0)

       Do ix2=1, nband_LR**2
!!!!          if ( ix1 /= ix2 ) cycle

          ib3 = ( ix2-1 ) /nband_LR +1
          ib4 = mod( ix2-1,nband_LR ) + 1
          
          ib3 = ib3 + band_start_LR -1;     ib4 = ib4 + band_start_LR -1

          call set_value_z2
          if ( mype == 0 ) then
             ztmp2 = ztmp2 -z1 *conjg(z2) * MatL( ix1,ix2 ) *dcmplx( 0.0D0, 1.0D0 )
          endif
       End do
    End do
!    if ( mype == 0 ) then
!!       write(91,*) ene*Hartree, aimag(ztmp1) /univol, aimag(ztmp2) /univol
!    endif
!--
    if ( mype == 0 ) then
       Mat_Chi0(1,1,1) = ztmp1 / univol
       Chi_Head(1,1) = ztmp2 / univol
    endif

  contains

    subroutine set_value_z1
      integer :: jb2

      if ( map_e(ib2) == myrank_e ) then
         jb2 = map_z(ib2)
         z1 = RhoTilde( 1, ib1, jb2, 1 )
      endif
      if ( npes > 1 ) then
         call mpi_bcast( z1, 2, MPI_DOUBLE_PRECISION, &
              &          map_e(ib2), mpi_comm_group, ierr )
      endif
    end subroutine set_value_z1

    subroutine set_value_z2
      integer :: jb4

      if ( map_e(ib4) == myrank_e ) then
         jb4 = map_z(ib4)
         z2 = RhoTilde( 1, ib3, jb4, 1 )
      endif
      if ( npes > 1 ) then
         call mpi_bcast( z2, 2, MPI_DOUBLE_PRECISION, &
                  &          map_e(ib4), mpi_comm_group, ierr )
      end if
    end subroutine Set_value_z2

  end subroutine Calc_Chi_Head_Mol
  
! ------------------------------------------------------------
!!
!!!         Output for Spectrum Data
!!
! ------------------------------------------------------------
  subroutine Write_Spectrum_Header
    if ( mype /= 0 ) return

    select case(spectrum_type)
    case (OPTICS)
       write(nf_LR_spectra,'("#",16x," Optical spectrum ")')
       write(nf_LR_spectra,'("#",27x," NonInteracting ",14x, "Interacting")')
       write(nf_LR_spectra,'("#",6x,"Energy[eV]", 8x, "Real",8x,"Imaginary",9x,"Real",8x,"Imaginary")')
    case (PACS)
       write(nf_LR_spectra,'("#",16x," Photo Absorption Cross Section")')
       write(nf_LR_spectra,'("#",6x,"Energy[eV]", 2x," NonInteracting ", 2x, "Interacting")')
    case (EELS)
       write(nf_LR_spectra,'("#",16x," EELS")')
       write(nf_LR_spectra,'("#",6x,"Energy[eV]", 2x," NonInteracting ", 2x, "Interacting")')
    case (IXSS)
       write(nf_LR_spectra,'("#",16x," IXSS")')
       write(nf_LR_spectra,'("#",6x,"Energy[eV]", 2x," NonInteracting ", 2x, "Interacting")')
    end select
    
  end subroutine Write_Spectrum_Header

  subroutine Write_Spectrum_Data( ene )
    real(kind=DP), intent(in) :: ene

    real(kind=DP) :: speed_of_light = 2.99792458d8          ! m/sec
    real(kind=DP) :: au_of_velocity = 2.18769126d6         ! m/sec
    
    integer :: ni, nj, i
    real(kind=DP) :: c1
    real(kind=DP) :: au_of_speed_of_light
    complex(kind=CMPLDP)      :: z0, z1, eps0, eps1
!
    real(kind=DP) :: pot_v0, ttr(6), ga, gb, gc, g2
! --------------------------------- start ------------
    if ( mype /= 0 ) return
    Call getttr (rltv,ttr)
! --------------------------------- main -------------
    pot_v0 = Kernel_Coulomb(1)
! ---------------
    Do i=1, 1
       ga = ngabc(i,1) + vqxyz( 1,1,BUCS )
       gb = ngabc(i,2) + vqxyz( 1,2,BUCS )
       gc = ngabc(i,3) + vqxyz( 1,3,BUCS )
       g2 = ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
              &   +   ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga
       c1 = 1.0d0
       pot_v0 = PAI4 / g2 *c1
    End Do
    !
    z0 = 0.0d0;    z1 = 0.0d0
    Do ni=1, nspin
       z0 = z0 + Mat_Chi0(1,1,ni)
    End do
    Do ni=1, nspin
       Do nj=1, nspin
          z1 = z1 + Chi_Head(ni,nj)
       End do
    End do
    eps0 = 1.0d0 - pot_v0 *z0;      eps1 = 1.0d0 - pot_v0 *z1
    
    select case (spectrum_type)
    case (OPTICS)
       write(nf_LR_spectra,'(5F15.6)') ene *Hartree, &
            &                          real(eps0), aimag(eps0), &
            &                          real(eps1), aimag(eps1)
    case (PACS)
       au_of_speed_of_light = speed_of_light/au_of_velocity
       c1 = univol / au_of_speed_of_light
       write(nf_LR_spectra,'(3F15.6)') ene *Hartree, &
            &                          c1 *ene *aimag(eps0), &
            &                          c1 *ene *aimag(eps1)
    case (EELS)
       write(nf_LR_spectra,'(3F15.6)') ene *Hartree, &
            &                          aimag(eps0), &
            &                          aimag(eps1)
    case (IXSS)
       c1 = -2.0d0 *univol
       write(nf_LR_spectra,'(3F15.6)') ene *Hartree, &
            &                          c1 *aimag(z0), &
            &                          c1 *aimag(z1)
    end select
  end subroutine Write_Spectrum_Data

end module m_LinearResponse_Spectrum

!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 440 $)
!
!  MODULE: m_ES_Intgr_VlhxcQlm
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!      Further modification by T. Yamasaki   May/17/2005
!      Further modification by T. Yamasaki   Aug/31/2007
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!

#ifdef VPP
#define _VECTOR_TUNING_
#endif
#ifdef SX
#define _VECTOR_TUNING_
#endif
#ifdef HIUX
#define _VECTOR_TUNING_
#endif

module m_ES_Intgr_VlhxcQlm
! $Id: m_ES_Intgr_VlhxcQlm.F90 440 2015-08-03 07:18:01Z ktagami $
  use m_Electronic_Structure,only : vlhxcQ, vlhxc_l, dhub
  use m_PlaneWaveBasisSet,   only : kgp,ngabc,m_pwBS_sphrp2,ylm_l
  use m_PseudoPotential,     only : ilmt,ltp,taup,isph,il2p,iqitg,qitg_l,dl2p &
       &                           ,modnrm,m_PP_find_maximum_l, nqitg, nlmt &
       &                           ,m_PP_include_vanderbilt_pot, ivanl &
       &                           ,m_PP_set_index_arrays1 &
       &                           ,m_PP_set_index_arrays2
  use m_Ionic_System,        only : ntyp, natm, ityp, pos, ihubbard
  use m_Crystal_Structure,   only : af, rltv, univol
  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,  only : nspin,iprivlhxcq,kimg,nel_Ylm, m_CtrlP_cachesize
  use m_Const_Parameters,    only : DP, PAI2, zi, SKIP
  use m_Parallelization,     only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype,ierr, np_e
!$$#ifdef PARA3D
  use m_PlaneWaveBasisSet,   only : m_pwBS_sphrp2_3D
  use m_PlaneWaveBasisSet,   only : ngabc_kngp_l, ngabc_kngp_B_l
! ==== DEBUG by tkato 2012/04/03 ===============================================
  use m_Parallelization,     only : mpi_k_world, myrank_k
! ==============================================================================
!$$#endif

! ========================== added by K. Tagami ================== 11.0
  use m_Control_Parameters,  only : ndim_magmom
! ================================================================ 11.0

  implicit none

  include 'mpif.h'
!  52. m_ESiVQ_integrate_VlhxcQlm
#ifdef _VECTOR_TUNING_
!      - symmetrize_vlhxcq, - integrate_qitg_x_ylm, - integration_of_VlhxcQlm_core3,
#else
!      - symmetrize_vlhxcq, - integration_of_VlhxcQlm_core2,
#endif
!      - integration_of_VlhxcQlm_core
contains


  subroutine m_ESiVQ_add_dhub_to_vlhxcQ(nfout)
    integer, intent(in) :: nfout
    integer :: is,ia
! ========================================== modified by K. Tagami ======== 11.0
!    do is=1,nspin
    do is=1, ndim_magmom
! ========================================================================= 11.0
       do ia=1,natm
          if(ihubbard(ia) > 0) then
             vlhxcQ(:,:,ia,is) = vlhxcQ(:,:,ia,is)+dhub(:,:,ia,is)
          end if
       end do
    end do
  end subroutine m_ESiVQ_add_dhub_to_vlhxcQ

!$$#ifdef PARA3D
!=======================================================================
!=======================================================================
!=======================================================================
!! #define _NOPARA_KNGP_B_
  subroutine m_ESiVQ_integrate_VlhxcQlm_3D(nfout)
   use m_Parallelization,     only : ista_kngp_B , iend_kngp_B    &
  &                                , ista_atm_B, iend_atm_B, mem_atm_B &
  &                                , mpi_ke_world

    ! ***
    ! (Rev) T. Yamaskai, 31, Aug, 2007
    !     1. 'call set_index_arrays1' that included a bug is replaced
    !       by 'call m_PP_set_index_arrays1', whose bug is fixed.
    !     2. 'call set_index_arrays2' is also replaced by 'call
    !       m_PP_set_index_arrays2' that can be referred from other modules.
    !     3. contained subroutines, set_index_arrays1 and set_index_arrays2 were
    !       deleted.
    ! ***
    integer, intent(in)   :: nfout

    real(kind=DP), allocatable, dimension(:)           :: ylm_t
    real(kind=DP), allocatable, target, dimension(:,:) :: ylm_ext
    real(kind=DP), allocatable, target, dimension(:)   :: zfcos, zfsin

    integer :: ncache, ibsize, ibl1, ibl2
    real(kind=DP), allocatable, dimension(:)           :: veq ! d(ista_kngp:iend_kngp)
    real(kind=DP)                                      :: vq_ia
    real(kind=DP), allocatable, dimension(:,:)         :: qitg_red, ylm_red, vlhxc_red
    integer,       allocatable, dimension(:)           :: il3

    integer :: is,it,lmt1,lmt2,n,ilm3,l3,ia

    integer :: m, maxm, ip, np, iq
    integer, parameter :: mcritical = 4*2+1
    integer, allocatable, dimension(:) :: nqitg_sp, nqitg_sp0 !d(ntyp)
    integer, allocatable, dimension(:) :: iq2l3 ! d(nqitg)
    integer, allocatable, dimension(:,:) :: nc  ! d(maxm,nqitg)
    integer :: mc ! maxval(nc)
    integer, allocatable, dimension(:,:,:) :: nc2lmt1, nc2lmt2, nc2n ! d(mc,maxm,nqitg)

    real(kind=DP), allocatable, dimension(:,:,:,:) :: vlhxcQ_mpi ! d(nlmt,nlmt,natm,nspin)
    integer :: iab
    integer :: id_sname = -1

    integer :: i, ilm
    if(modnrm == SKIP) return

!--- dummy timer --->
#ifdef __TIMER_SUB__
  call timer_sta(1061)
  call timer_end(1061)
  call timer_sta(1062)
  call timer_end(1062)
#endif

#ifdef __TIMER_DO__
  call timer_sta(1085)
  call timer_end(1085)
#endif
!<--- dummy timer ---

    call tstatc0_begin('m_ESiVQ_integrate_VlhxcQlm_3D ',id_sname)

#ifdef __TIMER_SUB__
  call timer_sta(1057)
#endif

    call m_PP_find_maximum_l(n)    ! n-1: maximum l
    n = (n-1) + (n-1) + 1
    allocate(il3(n**2)); call substitute_il3(n**2,il3) ! -(b_Elec..)

    allocate(nqitg_sp(ntyp)); allocate(nqitg_sp0(ntyp))
    allocate(iq2l3(nqitg))
    allocate(nc(mcritical,nqitg));nc=0
    call m_PP_set_index_arrays1(nfout,ntyp,nqitg,mcritical,n**2,il3 &
         & ,maxm,mc,nqitg_sp,nqitg_sp0,iq2l3,nc)
    allocate(nc2lmt1(mc,maxm,nqitg))
    allocate(nc2lmt2(mc,maxm,nqitg))
    allocate(nc2n(mc,maxm,nqitg))
    call m_PP_set_index_arrays2(nfout,mc,maxm,nqitg,mcritical,n**2,il3,iq2l3 &
         & ,nc2lmt1,nc2lmt2,nc2n,nc) ! -> nc2lmt1, nc2lmt2, nc2n, nc

    if(n**2 > nel_Ylm) then
#ifndef _NOPARA_KNGP_B_
       allocate(ylm_ext(ista_kngp_B:iend_kngp_B,nel_Ylm+1:n**2));  ylm_ext = 0.d0
       allocate(ylm_t(ista_kngp_B:iend_kngp_B)); ylm_t = 0.d0
       do ilm3 = nel_Ylm+1, n**2
          call m_pwBS_sphrp2_3D(ilm3,rltv,ista_kngp_B,iend_kngp_B,ylm_t)  !(ilm3,rltv,ngabc,gr_l)->(ylm)
          ylm_ext(:,ilm3) = ylm_t(:)
       end do
#else
       allocate(ylm_ext(ista_kngp:iend_kngp,nel_Ylm+1:n**2));  ylm_ext = 0.d0
       allocate(ylm_t(ista_kngp:iend_kngp)); ylm_t = 0.d0
       do ilm3 = nel_Ylm+1, n**2
          call m_pwBS_sphrp2_3D(ilm3,rltv,ista_kngp,iend_kngp,ylm_t)  !(ilm3,rltv,ngabc,gr_l)->(ylm)
          ylm_ext(:,ilm3) = ylm_t(:)
       end do
#endif
       deallocate(ylm_t)
    end if

    vlhxcQ = 0.d0

#ifndef _NOPARA_KNGP_B_
    do is = 1, nspin, af+1

       ncache = (m_CtrlP_cachesize()*1024)*3/4
       if(ncache == 0) then
          ibsize = iend_kngp_B-ista_kngp_B+1
       else
          ibsize=ncache/(8*(n**2))
       end if
       if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ:    ibsize = ", i8)') ibsize
!f       allocate(zfcos(ibsize)); zfcos = 0.d0
!f       allocate(zfsin(ibsize)); zfsin = 0.d0
!f       allocate(veq(ibsize))
       allocate(qitg_red(ibsize,nqitg))
       allocate(vlhxc_red(ibsize,kimg))
       allocate(ylm_red(ibsize,n**2))
!$omp parallel default(none)                                                    &
!$omp   shared(ityp,natm,ivanl,nqitg_sp0,nqitg_sp,iq2l3,nc,nc2lmt1,             &
!$omp          nc2lmt2,nc2n,vlhxcQ,is,univol,dl2p,pos,ista_kngp_B,iend_kngp_B,  &
!$omp          ngabc_kngp_B_l,qitg_red,vlhxc_red,ylm_red,kimg,ibsize,mype,      &
!$omp          qitg_l,vlhxc_l,ylm_l,ylm_ext,nqitg,nel_Ylm,n)         &
!$omp   private(ibl1,ibl2,ia,it,iq,l3,m,ilm3,vq_ia,ip,lmt1,lmt2,np,zfcos,zfsin,veq,i,ilm)
#ifdef __TIMER_OMP1__
  call timer_sta(1088)
#endif
       allocate(zfcos(ibsize)); zfcos = 0.d0
       allocate(zfsin(ibsize)); zfsin = 0.d0
       allocate(veq(ibsize))
#ifdef __TIMER_OMP1__
  call timer_end(1088)
#endif
#ifdef __TIMER_DO__
  call timer_sta(1076)
#endif
!#ifdef USE_PROF
!  call timer_sta(1076)
!#endif
!-!OCL PREFETCH_INDIRECT
       do ibl1 = ista_kngp_B, iend_kngp_B, ibsize
          ibl2 = ibl1+ibsize-1
          if(ibl2 .gt. iend_kngp_B) ibl2 = iend_kngp_B
!oo       if(iprivlhxcq >= 2) then
!oo          write(nfout,'(" !mESiVQ:    ibl1,ibl2,ibsize = ", 3i8)') ibl1, ibl2, ibsize
!oo       end if
!f          call substitute_qitgred(ibl1,ibl2)  ! qitg_l -> qitg_red
!---
!$omp do
          do iq = 1, nqitg
             do i = 1, ibl2-ibl1+1
                qitg_red(i, iq) = qitg_l(i+ibl1-1,iq)
             end do
          end do
!$omp end do
!---
!f          call substitute_vlhxcred(ibl1,ibl2) ! vlhxc_l -> vlhxc_red
!---
          if(kimg==1) then
!$omp do
             do i = 1, ibl2-ibl1+1
                vlhxc_red(i,1) = vlhxc_l(i+ibl1-1,1,is)
             end do
!$omp end do
          else if(kimg==2) then
!$omp do
             do i = 1, ibl2-ibl1+1
                vlhxc_red(i,1) = vlhxc_l(i+ibl1-1,1,is)
                vlhxc_red(i,2) = vlhxc_l(i+ibl1-1,2,is)
             end do
!$omp end do
          end if
!---
!f          call substitute_ylmred(ibl1,ibl2)   ! ylm_l, ylm_ext -> ylm_red
!$omp do
      do ilm = 1, nel_Ylm
         do i = 1, ibl2-ibl1+1
            ylm_red(i,ilm) = ylm_l(i+ibl1-1,ilm)
         end do
      end do
!$omp end do
      if(n**2 > nel_Ylm) then
         do ilm = nel_ylm+1, n**2
!$omp do
            do i = 1, ibl2-ibl1+1
               ylm_red(i,ilm) = ylm_ext(i+ibl1-1,ilm)
            end do
!$omp end do
         end do
      end if

#ifdef __TIMER_OMP1__
  call timer_sta(1087)
#endif
#ifdef __TIMER_OMP1__
  call timer_sta(1093)
#endif
#ifdef __TIMER_DO__
  call timer_sta(1084)
#endif
!$omp do schedule(runtime)
          do ia = 1, natm
             it = ityp(ia)
             if(sum(ivanl(:,it)) == 0) cycle
!             call calc_phase_div(ia)  !   -> zfcos, zfsin
!f             call calc_phase_div_B_3D(ia)  !   -> zfcos, zfsin
#ifdef __TIMER_OMP3__
  call timer_sta(1089)
#endif
             call calc_phase_div_B_3D(ia,zfcos,zfsin,ibsize,ibl1,ibl2)  !   -> zfcos, zfsin
#ifdef __TIMER_OMP3__
  call timer_end(1089)
#endif
!oo          if(iprivlhxcq >= 2) then
!oo             write(nfout,'(" !mESiVQ:    ia,  iq,  l3,   m,ilm3,  ip,lmt1,lmt2,  np")')
!oo          end if
#ifdef __TIMER_OMP2__
  call timer_sta(1095)
#endif
             do iq = nqitg_sp0(it), nqitg_sp(it)
                l3 = iq2l3(iq)
!f                call dp_Vlhxcq_exp_Q_div(iq) ! vlhxc, exp, qitg_l  -> veq
#ifdef __TIMER_OMP3__
  call timer_sta(1090)
#endif
                call dp_Vlhxcq_exp_Q_div(iq,zfcos,zfsin,veq,ibsize,l3,ibl1,ibl2) ! vlhxc, exp, qitg_l  -> veq
#ifdef __TIMER_OMP3__
  call timer_end(1090)
#endif
#ifdef __TIMER_OMP2__
  call timer_sta(1096)
#endif
                do m = 1, 2*l3+1
                   ilm3 = l3*l3+m
!f                   call veQ_dot_ylm_div(vq_ia) ! veq, ylm -> vq_ia
#ifdef __TIMER_OMP3__
  call timer_sta(1091)
#endif
                   call veQ_dot_ylm_div(vq_ia,veq,ibsize,ilm3,l3,ibl1,ibl2) ! veq, ylm -> vq_ia
#ifdef __TIMER_OMP3__
  call timer_end(1091)
#endif
!f--#ifdef __TIMER_DO__
!f--  call timer_sta(1076)
!f--#endif
#ifdef __TIMER_OMP2__
  call timer_sta(1092)
#endif
                   do ip = 1, nc(m,iq)
                      lmt1 = nc2lmt1(ip,m,iq)
                      lmt2 = nc2lmt2(ip,m,iq)
                      np = nc2n(ip,m,iq)
!oo                   if(iprivlhxcq >= 2) then
!oo                      write(nfout,'(" !mESiVQ: ",9i5)') ia, iq, l3, m, ilm3, ip, lmt1,lmt2,np
!oo                   end if
                      vlhxcQ(lmt1,lmt2,ia,is) = vlhxcQ(lmt1,lmt2,ia,is) &
                     &                          + univol*vq_ia*dl2p(lmt1,lmt2,np,it)
                   end do
#ifdef __TIMER_OMP2__
  call timer_end(1092)
#endif
!f--#ifdef __TIMER_DO__
!f--  call timer_end(1076)
!f--#endif
                end do
#ifdef __TIMER_OMP2__
  call timer_end(1096)
#endif
             end do
#ifdef __TIMER_OMP2__
  call timer_end(1095)
#endif
          end do
!$omp end do
#ifdef __TIMER_DO__
  call timer_end(1084)
#endif
#ifdef __TIMER_OMP1__
  call timer_end(1093)
#endif
#ifdef __TIMER_OMP1__
  call timer_end(1087)
#endif
       end do
!#ifdef USE_PROF
!  call timer_end(1076)
!#endif
#ifdef __TIMER_DO__
  call timer_end(1076)
#endif
#ifdef __TIMER_OMP1__
  call timer_sta(1094)
#endif
       deallocate(veq)
       deallocate(zfsin);deallocate(zfcos)
#ifdef __TIMER_OMP1__
  call timer_end(1094)
#endif
!$omp end parallel
       deallocate(ylm_red)
       deallocate(vlhxc_red)
       deallocate(qitg_red)
!f       deallocate(veq)

!f       deallocate(zfsin);deallocate(zfcos)
    end do

    if(npes > 1) then
       allocate(vlhxcQ_mpi(nlmt,nlmt,natm,nspin)); vlhxcQ_mpi = 0.d0
! ==== DEBUG by tkato 2012/04/03 ===============================================
#if 0
#ifdef __TIMER_COMM__
  call timer_barrier(mpi_comm_group)
  call timer_sta(1077)
#endif
       call mpi_allreduce(vlhxcQ, vlhxcQ_mpi, nlmt*nlmt*natm*nspin,  &
      &                   mpi_double_precision, mpi_sum, mpi_comm_group, ierr)
#else
#ifdef __TIMER_COMM__
  call timer_barrier(mpi_k_world(myrank_k))
  call timer_sta(1077)
#endif
       call mpi_allreduce(vlhxcQ, vlhxcQ_mpi, nlmt*nlmt*natm*nspin,  &
      &                   mpi_double_precision, mpi_sum, mpi_k_world(myrank_k), ierr)
#endif
! ==============================================================================
#ifdef __TIMER_COMM__
  call timer_end(1077)
#endif
       vlhxcQ = vlhxcQ_mpi
       deallocate(vlhxcQ_mpi)
    end if

#else

    do is = 1, nspin, af+1

       ncache = (m_CtrlP_cachesize()*1024)*3/4
       if(ncache == 0) then
          ibsize = iend_kngp-ista_kngp+1
       else
          ibsize=ncache/(8*(n**2))
       end if
       if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ:    ibsize = ", i8)') ibsize
       allocate(zfcos(ibsize)); zfcos = 0.d0
       allocate(zfsin(ibsize)); zfsin = 0.d0
       allocate(veq(ibsize))
       allocate(qitg_red(ibsize,nqitg))
       allocate(vlhxc_red(ibsize,kimg))
       allocate(ylm_red(ibsize,n**2))
       do ibl1 = ista_kngp, iend_kngp, ibsize
          ibl2 = ibl1+ibsize-1
          if(ibl2 .gt. iend_kngp) ibl2 = iend_kngp
!oo       if(iprivlhxcq >= 2) then
!oo          write(nfout,'(" !mESiVQ:    ibl1,ibl2,ibsize = ", 3i8)') ibl1, ibl2, ibsize
!oo       end if
          call substitute_qitgred()  ! qitg_l -> qitg_red
          call substitute_vlhxcred() ! vlhxc_l -> vlhxc_red
          call substitute_ylmred()   ! ylm_l, ylm_ext -> ylm_red 

!!        do ia = ista_atm_B, iend_atm_B
          do iab = ista_atm_B, iend_atm_B
             ia = mem_atm_B(iab)
             it = ityp(ia)
             if(sum(ivanl(:,it)) == 0) cycle
!             call calc_phase_div(ia)  !   -> zfcos, zfsin
             call calc_phase_div_3D(ia)  !   -> zfcos, zfsin
!oo          if(iprivlhxcq >= 2) then
!oo             write(nfout,'(" !mESiVQ:    ia,  iq,  l3,   m,ilm3,  ip,lmt1,lmt2,  np")')
!oo          end if
             do iq = nqitg_sp0(it), nqitg_sp(it)
                l3 = iq2l3(iq)
!f                call dp_Vlhxcq_exp_Q_div(iq) ! vlhxc, exp, qitg_l  -> veq
                call dp_Vlhxcq_exp_Q_div(iq,zfcos,zfsin,veq,ibsize,l3,ibl1,ibl2) ! vlhxc, exp, qitg_l  -> veq
                do m = 1, 2*l3+1
                   ilm3 = l3*l3+m
!f                   call veQ_dot_ylm_div(vq_ia) ! veq, ylm -> vq_ia
                   call veQ_dot_ylm_div(vq_ia,veq,ibsize,ilm3,l3,ibl1,ibl2) ! veq, ylm -> vq_ia
#ifdef __TIMER_DO__
  call timer_sta(1078)
#endif
                   do ip = 1, nc(m,iq)
                      lmt1 = nc2lmt1(ip,m,iq)
                      lmt2 = nc2lmt2(ip,m,iq)
                      np = nc2n(ip,m,iq)
!oo                   if(iprivlhxcq >= 2) then
!oo                      write(nfout,'(" !mESiVQ: ",9i5)') ia, iq, l3, m, ilm3, ip, lmt1,lmt2,np
!oo                   end if
                      vlhxcQ(lmt1,lmt2,ia,is) = vlhxcQ(lmt1,lmt2,ia,is) &
                     &                          + univol*vq_ia*dl2p(lmt1,lmt2,np,it)
                   end do
#ifdef __TIMER_DO__
  call timer_end(1078)
#endif
                end do
             end do
          end do
       end do
       deallocate(ylm_red)
       deallocate(vlhxc_red)
       deallocate(qitg_red)
       deallocate(veq)

       deallocate(zfsin);deallocate(zfcos)
    end do

    if(npes > 1) then
       allocate(vlhxcQ_mpi(nlmt,nlmt,natm,nspin)); vlhxcQ_mpi = 0.d0
! ==== DEBUG by tkato 2012/04/03 ===============================================
#if 0
#ifdef __TIMER_COMM__
  call timer_barrier(mpi_comm_group)
  call timer_sta(1079)
#endif
       call mpi_allreduce(vlhxcQ, vlhxcQ_mpi, nlmt*nlmt*natm*nspin,  &
      &                   mpi_double_precision, mpi_sum, mpi_comm_group, ierr)
#else
#ifdef __TIMER_COMM__
  call timer_barrier(mpi_k_world(myrank_k))
  call timer_sta(1079)
#endif
       call mpi_allreduce(vlhxcQ, vlhxcQ_mpi, nlmt*nlmt*natm*nspin,  &
      &                   mpi_double_precision, mpi_sum, mpi_k_world(myrank_k), ierr)
#endif
! ==============================================================================
#ifdef __TIMER_COMM__
  call timer_end(1079)
#endif
       vlhxcQ = vlhxcQ_mpi
       deallocate(vlhxcQ_mpi)
    end if
#endif

!   if(nrank_g > 1) then
!      allocate(vlhxcQ_mpi(nlmt,nlmt,natm,nspin)); vlhxcQ_mpi = 0.d0
!      call mpi_allreduce(vlhxcQ, vlhxcQ_mpi, nlmt*nlmt*natm*nspin,  &
!     &                   mpi_double_precision, mpi_sum, mpi_ke_world, ierr)
!      call mpi_allgather(vlhxcQ_l_3D, nlmt*nlmt*nspin*np_atm_B, MPI_DOUBLE_PRECISION &
!     &                   vlhxcQ_mpi,  nlmt*nlmt*nspin*mp_atm_B, MPI_DOUBLE_PRECISION &
!     &                   mpi_ke_world, ierr )
!      vlhxcQ = vlhxcQ_mpi
!      deallocate(vlhxcQ_mpi)
!   end if

    call symmetrize_vlhxcq
    if(allocated(ylm_ext)) deallocate(ylm_ext)
    deallocate(il3)

    deallocate(nc2n,nc2lmt2,nc2lmt1,nc,iq2l3,nqitg_sp,nqitg_sp0)

    if(iprivlhxcq >= 2) then
       write(nfout,*) ' <<< m_ESiVQ_integrate_VlhxcQlm >>> vlhxcQ start'
       do is = 1, nspin, af+1
          do it = 1, natm
             write(nfout,*) ' (vlhxcQ) -- #atom = ', it
             do lmt1 = 1, ilmt(ityp(it))
                write(nfout,*) ' --- lmt1 = ', lmt1
                write(nfout,'(99(5d16.8,/))')&
                     & (vlhxcq(lmt1,lmt2,it,is),lmt2=1,ilmt(ityp(it)))
             end do
          end do
       end do
       write(nfout,*) ' <<< m_ESiVQ_integrate_VlhxcQlm >>> vlhxcQ end'
    endif
#ifdef __TIMER_SUB__
  call timer_end(1057)
#endif
    call tstatc0_end(id_sname)
  contains

    subroutine symmetrize_vlhxcq
      integer :: is, ia, it, lmt1, lmt2
#ifdef __TIMER_SUB__
  call timer_sta(1063)
#endif
#ifdef __TIMER_DO__
  call timer_sta(1086)
#endif
      do is = 1, nspin, af+1
         do ia = 1, natm
            it = ityp(ia)
            do lmt1 = 1, ilmt(it)
               do lmt2 = lmt1+1, ilmt(it)
                  vlhxcQ(lmt2,lmt1,ia,is) = vlhxcQ(lmt1,lmt2,ia,is)
               end do
            end do
         end do
      end do
#ifdef __TIMER_DO__
  call timer_end(1086)
#endif
#ifdef __TIMER_SUB__
  call timer_end(1063)
#endif
    end subroutine symmetrize_vlhxcq

!f    subroutine substitute_qitgred()
    subroutine substitute_qitgred(ib1,ib2)
      integer, intent(in) :: ib1, ib2
      integer :: iq, i
      do iq = 1, nqitg
!f         do i = 1, ibl2-ibl1+1
!f            qitg_red(i, iq) = qitg_l(i+ibl1-1,iq)
         do i = 1, ib2-ib1+1
            qitg_red(i, iq) = qitg_l(i+ib1-1,iq)
         end do
      end do
    end subroutine substitute_qitgred

!f    subroutine substitute_vlhxcred
    subroutine substitute_vlhxcred(ib1,ib2)
      integer, intent(in) :: ib1, ib2
      integer :: i
#ifdef __TIMER_SUB__
  call timer_sta(1060)
#endif

#ifdef __TIMER_DO__
  call timer_sta(1083)
#endif
      if(kimg==1) then
!f         do i = 1, ibl2-ibl1+1
!f            vlhxc_red(i,1) = vlhxc_l(i+ibl1-1,1,is)
         do i = 1, ib2-ib1+1
            vlhxc_red(i,1) = vlhxc_l(i+ib1-1,1,is)
         end do
      else if(kimg==2) then
!f         do i = 1, ibl2-ibl1+1
!f            vlhxc_red(i,1) = vlhxc_l(i+ibl1-1,1,is)
!f            vlhxc_red(i,2) = vlhxc_l(i+ibl1-1,2,is)
         do i = 1, ib2-ib1+1
            vlhxc_red(i,1) = vlhxc_l(i+ib1-1,1,is)
            vlhxc_red(i,2) = vlhxc_l(i+ib1-1,2,is)
         end do
      end if
#ifdef __TIMER_DO__
  call timer_end(1083)
#endif
#ifdef __TIMER_SUB__
  call timer_end(1060)
#endif
    end subroutine substitute_vlhxcred

!f    subroutine substitute_ylmred
    subroutine substitute_ylmred(ib1,ib2)
      integer, intent(in) :: ib1, ib2
      integer :: ilm, i
      do ilm = 1, nel_Ylm
!f         do i = 1, ibl2-ibl1+1
!f            ylm_red(i,ilm) = ylm_l(i+ibl1-1,ilm)
         do i = 1, ib2-ib1+1
            ylm_red(i,ilm) = ylm_l(i+ib1-1,ilm)
         end do
      end do
      if(n**2 > nel_Ylm) then
         do ilm = nel_ylm+1, n**2
!f            do i = 1, ibl2-ibl1+1
!f               ylm_red(i,ilm) = ylm_ext(i+ibl1-1,ilm)
            do i = 1, ib2-ib1+1
               ylm_red(i,ilm) = ylm_ext(i+ib1-1,ilm)
            end do
         end do
      end if
    end subroutine substitute_ylmred

    subroutine calc_phase_div(ia)
      integer, intent(in) :: ia
      integer :: i, ig
      real(kind=DP) :: fx, fy, fz, ph
      fx = pos(ia,1)*PAI2
      fy = pos(ia,2)*PAI2
      fz = pos(ia,3)*PAI2
      do i = 1, ibl2-ibl1+1
         ig = i + ibl1 - 1
         ph = ngabc(ig,1)*fx + ngabc(ig,2)*fy + ngabc(ig,3)*fz
         zfcos(i) = dcos(ph)
         zfsin(i) = dsin(ph)
      end do
    end subroutine calc_phase_div

    subroutine calc_phase_div_3D(ia)
      integer, intent(in) :: ia
      integer :: i, ig
      real(kind=DP) :: fx, fy, fz, ph
      fx = pos(ia,1)*PAI2
      fy = pos(ia,2)*PAI2
      fz = pos(ia,3)*PAI2
      do i = 1, ibl2-ibl1+1
         ig = i + ibl1 - 1
         ph = ngabc_kngp_l(ig,1)*fx + ngabc_kngp_l(ig,2)*fy + ngabc_kngp_l(ig,3)*fz
         zfcos(i) = dcos(ph)
         zfsin(i) = dsin(ph)
      end do
    end subroutine calc_phase_div_3D

!f    subroutine calc_phase_div_B_3D(ia)
    subroutine calc_phase_div_B_3D(ia,zfcos0,zfsin0,ib,ib1,ib2)
      integer, intent(in) :: ia, ib, ib1, ib2
      real(kind=DP), intent(out) :: zfcos0(ib), zfsin0(ib)
      integer :: i, ig
      real(kind=DP) :: fx, fy, fz, ph
      fx = pos(ia,1)*PAI2
      fy = pos(ia,2)*PAI2
      fz = pos(ia,3)*PAI2
!f      do i = 1, ibl2-ibl1+1
!f         ig = i + ibl1 - 1
      do i = 1, ib2-ib1+1
         ig = i + ib1 - 1
         ph = ngabc_kngp_B_l(ig,1)*fx + ngabc_kngp_B_l(ig,2)*fy + ngabc_kngp_B_l(ig,3)*fz
         zfcos0(i) = dcos(ph)
         zfsin0(i) = dsin(ph)
      end do
    end subroutine calc_phase_div_B_3D

!f    subroutine dp_Vlhxcq_exp_Q_div(iq)
    subroutine dp_Vlhxcq_exp_Q_div(iq,zfcos0,zfsin0,veq0,ib,l,ib1,ib2)
      integer, intent(in) :: iq, ib, l, ib1, ib2
      real(kind=DP), intent(out) :: veq0(ib)
      real(kind=DP), target, intent(in) :: zfcos0(ib), zfsin0(ib)
      integer       :: i
      real(kind=DP) :: f
      real(kind=DP), pointer, dimension(:) :: zfsc1, zfsc2

!f--#ifdef __TIMER_SUB__
!f--  call timer_sta(1061)
!f--#endif
      
!      if(mod(l3,2) == 0) then
      if(mod(l,2) == 0) then
         zfsc1 => zfcos0
         if(kimg == 2) zfsc2 => zfsin0
         f = -1.d0
!      else if(mod(l3,2) == 1) then
      else if(mod(l,2) == 1) then
         zfsc1 => zfsin0
         if(kimg == 2) zfsc2 => zfcos0
         f = 1.d0
      end if

!f--#ifdef __TIMER_DO__
!f--  call timer_sta(1084)
!f--#endif
      if(kimg == 1) then
!f         do i = 1, ibl2-ibl1+1
         do i = 1, ib2-ib1+1
            veq0(i) = qitg_red(i,iq)*vlhxc_red(i,1)*zfsc1(i)
         end do
      else if(kimg == 2) then
!f         do i = 1, ibl2-ibl1+1
         do i = 1, ib2-ib1+1
            veq0(i)  = qitg_red(i,iq)*(vlhxc_red(i,1)*zfsc1(i)+f*vlhxc_red(i,2)*zfsc2(i))
         end do
      end if
!f--#ifdef __TIMER_DO__
!f--  call timer_end(1084)
!f--#endif
!f--#ifdef __TIMER_SUB__
!f--  call timer_end(1061)
!f--#endif
    end subroutine dp_Vlhxcq_exp_Q_div

    subroutine veQ_dot_ylm_div(vq,veq0,ib,il,l,ib1,ib2)
      real(kind=DP), intent(out) :: vq
      integer, intent(in) :: ib, il, l, ib1, ib2
      real(kind=DP), intent(in) :: veq0(ib)

      integer       :: i
!f--#ifdef __TIMER_SUB__
!f--  call timer_sta(1062)
!f--#endif
      vq = 0.d0
!f--#ifdef __TIMER_DO__
!f--  call timer_sta(1085)
!f--#endif
!      do i = 1, ibl2-ibl1+1
!         vq = vq + veq(i)*ylm_red(i,ilm3)
      do i = 1, ib2-ib1+1
         vq = vq + veq0(i)*ylm_red(i,il)
      end do
!f--#ifdef __TIMER_DO__
!f--  call timer_end(1085)
!f--#endif

!      if(mod(l3,4) == 0) then
      if(mod(l,4) == 0) then
         vq = vq
!      else if(mod(l3,4) == 1) then
      else if(mod(l,4) == 1) then
         vq = -vq
!      else if(mod(l3,4) == 2) then
      else if(mod(l,4) == 2) then
         vq = -vq
!      else if(mod(l3,4) == 3) then
      else if(mod(l,4) == 3) then
         vq = vq
      end if
!f--#ifdef __TIMER_SUB__
!f--  call timer_end(1062)
!f--#endif
    end subroutine veQ_dot_ylm_div

  end subroutine m_ESiVQ_integrate_VlhxcQlm_3D

!$$#endif

end module m_ES_Intgr_VlhxcQlm

!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 440 $)
!
!  MODULE: m_ES_Intgr_VlhxcQlm
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!      Further modification by T. Yamasaki   May/17/2005
!      Further modification by T. Yamasaki   Aug/31/2007
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!

#ifdef VPP
#define _VECTOR_TUNING_
#endif
#ifdef SX
#define _VECTOR_TUNING_
#endif
#ifdef HIUX
#define _VECTOR_TUNING_
#endif

module m_ES_Intgr_VlhxcQlm
! $Id: m_ES_Intgr_VlhxcQlm.F90 440 2015-08-03 07:18:01Z ktagami $
  use m_Electronic_Structure,only : vlhxcQ, vlhxc_l, dhub
  use m_PlaneWaveBasisSet,   only : kgp,ngabc,m_pwBS_sphrp2,ylm_l
  use m_PseudoPotential,     only : ilmt,ltp,taup,isph,il2p,iqitg,qitg_l,dl2p &
       &                           ,modnrm,m_PP_find_maximum_l, nqitg, nlmt &
       &                           ,m_PP_include_vanderbilt_pot, ivanl &
       &                           ,m_PP_set_index_arrays1 &
       &                           ,m_PP_set_index_arrays2
  use m_Ionic_System,        only : ntyp, natm, ityp, pos, ihubbard
  use m_Crystal_Structure,   only : af, rltv, univol
  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,  only : nspin,iprivlhxcq,kimg,nel_Ylm, m_CtrlP_cachesize
  use m_Const_Parameters,    only : DP, PAI2, zi, SKIP
  use m_Parallelization,     only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype,ierr, np_e

! ========================== added by K. Tagami ================== 11.0
  use m_Control_Parameters,  only : ndim_magmom
! ================================================================ 11.0

  implicit none

  include 'mpif.h'
!  52. m_ESiVQ_integrate_VlhxcQlm
#ifdef _VECTOR_TUNING_
!      - symmetrize_vlhxcq, - integrate_qitg_x_ylm, - integration_of_VlhxcQlm_core3,
#else
!      - symmetrize_vlhxcq, - integration_of_VlhxcQlm_core2,
#endif
!      - integration_of_VlhxcQlm_core
contains

!$$#ifndef PARA3D
  subroutine m_ESiVQ_integrate_VlhxcQlm(nfout)
    ! ***
    ! (Rev) T. Yamaskai, 31, Aug, 2007
    !     1. 'call set_index_arrays1' that included a bug is replaced
    !       by 'call m_PP_set_index_arrays1', whose bug is fixed.
    !     2. 'call set_index_arrays2' is also replaced by 'call
    !       m_PP_set_index_arrays2' that can be referred from other modules.
    !     3. contained subroutines, set_index_arrays1 and set_index_arrays2 were
    !       deleted.
    ! ***
    integer, intent(in)   :: nfout

    real(kind=DP), pointer, dimension(:)               :: ylm
    real(kind=DP), allocatable, dimension(:)           :: ylm_t
    real(kind=DP), allocatable, target, dimension(:,:) :: ylm_ext
#ifdef _VECTOR_TUNING_
    real(kind=DP), allocatable, target, dimension(:,:) :: zfcos_x, zfsin_x  ! d(ista_kngp:iend_kngp_adj,n_ialist0)
#ifndef _m_ESIV_no_loop_exchange_
    integer                                            :: ia_s
    real(kind=DP), allocatable, dimension(:,:)         :: veq_x ! d(ista_kngp:iend_kngp_adj,n_ialist0)
    real(kind=DP), allocatable, dimension(:)           :: vq_x ! d(n_ialist0) 
#endif
    integer :: iend_kngp_adj, n_ialist, n_ialist0, ia_start, n_iagroup, n_ia, ia_g, l3_odd, l3_even
    integer, allocatable, dimension(:) :: ia_list
    real(kind=DP), allocatable, dimension(:,:) ::         qitgylm
#else
    real(kind=DP), allocatable, target, dimension(:)   :: zfcos, zfsin
#ifndef _m_ESIV_no_loop_exchange_
    integer :: ncache, ibsize, ibl1, ibl2
    real(kind=DP), allocatable, dimension(:)           :: veq ! d(ista_kngp:iend_kngp)
    real(kind=DP)                                      :: vq_ia
    real(kind=DP), allocatable, dimension(:,:)         :: qitg_red, ylm_red, vlhxc_red
#endif
#endif
    integer,       allocatable, dimension(:)           :: il3

    integer :: is,it,lmt1,lmt2,il1,tau1,il2,tau2,n,ilm3,l3,iiqitg,ia

#ifndef _m_ESIV_no_loop_exchange_
    integer :: m, maxm, ip, np, iq
    integer, parameter :: mcritical = 4*2+1
    integer, allocatable, dimension(:) :: nqitg_sp, nqitg_sp0 !d(ntyp)
    integer, allocatable, dimension(:) :: iq2l3 ! d(nqitg)
    integer, allocatable, dimension(:,:) :: nc  ! d(maxm,nqitg)
    integer :: mc ! maxval(nc)
    integer, allocatable, dimension(:,:,:) :: nc2lmt1, nc2lmt2, nc2n ! d(mc,maxm,nqitg)
#endif

    real(kind=DP), allocatable, dimension(:,:,:,:) :: vlhxcQ_mpi ! d(nlmt,nlmt,natm,nspin)

    integer :: id_sname = -1
    if(modnrm == SKIP) return

    call tstatc0_begin('m_ESiVQ_integrate_VlhxcQlm ',id_sname)

    call m_PP_find_maximum_l(n)    ! n-1: maximum l
    n = (n-1) + (n-1) + 1
    allocate(il3(n**2)); call substitute_il3(n**2,il3) ! -(b_Elec..)

#ifndef _m_ESIV_no_loop_exchange_
    allocate(nqitg_sp(ntyp)); allocate(nqitg_sp0(ntyp))
    allocate(iq2l3(nqitg))
    allocate(nc(mcritical,nqitg));nc=0
    call m_PP_set_index_arrays1(nfout,ntyp,nqitg,mcritical,n**2,il3 &
         & ,maxm,mc,nqitg_sp,nqitg_sp0,iq2l3,nc)
    allocate(nc2lmt1(mc,maxm,nqitg))
    allocate(nc2lmt2(mc,maxm,nqitg))
    allocate(nc2n(mc,maxm,nqitg))
    call m_PP_set_index_arrays2(nfout,mc,maxm,nqitg,mcritical,n**2,il3,iq2l3 &
         & ,nc2lmt1,nc2lmt2,nc2n,nc) ! -> nc2lmt1, nc2lmt2, nc2n, nc
#endif

#ifdef _VECTOR_TUNING_
    n_ialist = 1
#ifdef HIUX
    n_ialist = 16
#endif
#ifdef VPP
    n_ialist = 8
#endif
#ifdef SX
    n_ialist = 8
#endif
    iend_kngp_adj = iend_kngp
#ifdef HIUX
#else
    if(mod(iend_kngp-ista_kngp+1,2) == 0) iend_kngp_adj = iend_kngp_adj+1
#endif
    allocate(ia_list(n_ialist))
#endif

    if(n**2 > nel_Ylm) then
       allocate(ylm_ext(ista_kngp:iend_kngp,nel_Ylm+1:n**2));  ylm_ext = 0.d0
       allocate(ylm_t(ista_kngp:iend_kngp)); ylm_t = 0.d0
       do ilm3 = nel_Ylm+1, n**2
          call m_pwBS_sphrp2(ilm3,rltv,ista_kngp,iend_kngp,ylm_t)  ! (ilm3,rltv,ngabc,gr_l)->(ylm)
          ylm_ext(:,ilm3) = ylm_t(:)
       end do
       deallocate(ylm_t)
    end if

    vlhxcQ = 0.d0

! ====================================== modified by K. Tagami ============== 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! =========================================================================== 11.0

#ifdef _VECTOR_TUNING_
       do it = 1, ntyp
          if(sum(ivanl(:,it)) == 0) cycle
          allocate(qitgylm(ista_kngp:iend_kngp,2))

          n_ia = 0
          do ia = 1, natm
             if(ityp(ia) == it) n_ia = n_ia + 1
          end do
          if(n_ialist <=0) stop 'n_ialist is illegal <<m_ESiVQ_integrate_VlhxcQlm>>'
          n_iagroup = n_ia/n_ialist + 1
          ia_start = 1
          if(iprivlhxcq >= 2) write(nfout,'(" !m_ESiVQ_integrate_VlhxcQlm: n_iagroup = ",i8, " ityp = ",i8)') n_iagroup,it
          do ia_g = 1, n_iagroup
             n_ialist0 = 0
             ia_list = 0
             AtomcountLoop: do ia = ia_start, natm
                if(ityp(ia) == it) then
                   n_ialist0 = n_ialist0 + 1
                   ia_list(n_ialist0) = ia
                end if
                if(n_ialist0 >= n_ialist) exit AtomcountLoop
             end do AtomcountLoop
             ia_start = ia+1
             if(n_ialist0 >= 1) then
                if(iprivlhxcq >= 2) write(nfout,'(" !m_ESiVQ_integrate_VlhxcQlm: ia_list = ",8i8)') (ia_list(ia),ia=1,n_ialist0)
                allocate(zfcos_x(ista_kngp:iend_kngp_adj,n_ialist0))
                allocate(zfsin_x(ista_kngp:iend_kngp_adj,n_ialist0))
                call calc_phase_b(natm,pos,ia_list,n_ialist0,kgp,ngabc,ista_kngp,iend_kngp &
                     &                                                ,ista_kngp,iend_kngp_adj,zfcos_x,zfsin_x)
#ifndef _m_ESIV_no_loop_exchange_
                allocate(veq_x(ista_kngp:iend_kngp_adj,n_ialist0))
                allocate(vq_x(n_ialist0))
                if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ:    ia,  iq,  l3,   m,ilm3,  ip,lmt1,lmt2,  np")')
                do iq = nqitg_sp0(it), nqitg_sp(it)
                   l3 = iq2l3(iq)
                   if(l3 == 0) then
                      ilm3 = 1
                      call integration_of_VlhxcQlm_core4(iq,vq_x) ! iq, vlhxc,exp,qitg_l,ylm -> vq_x
                   else
                      call dp_Vlhxcq_exp_Q_x(iq) ! vlhxc, exp, qitg_l  -> veq_x
                   end if
                   do m = 1, 2*l3+1
                      ilm3 = l3*l3+m
                      if(l3 /= 0) call veQ_dot_ylm_x(vq_x) ! veq_x, ylm -> vq_x
                      do ia_s = 1, n_ialist0 
                         ia = ia_list(ia_s)
                         do ip = 1, nc(m,iq)
                            lmt1 = nc2lmt1(ip,m,iq)
                            lmt2 = nc2lmt2(ip,m,iq)
                            np = nc2n(ip,m,iq)
                            if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ: ",9i5)') ia, iq, l3, m, ilm3, ip, lmt1,lmt2,np
                            vlhxcQ(lmt1,lmt2,ia,is) = vlhxcQ(lmt1,lmt2,ia,is) + univol*vq_x(ia_s)*dl2p(lmt1,lmt2,np,it)
                         end do
                      end do
                   end do
                end do
                deallocate(vq_x,veq_x)
#else
                if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ:    ia,lmt1, il1,tau1,lmt2, il2,tau2,il2p,ilm3,  l3,iiqitg ")')
                
                do lmt1 = 1, ilmt(it)
                   il1  = ltp( lmt1, it);   tau1 = taup(lmt1, it)
                   do lmt2 = lmt1, ilmt(it)
                      il2  = ltp( lmt2, it);   tau2 = taup(lmt2, it)
                      l3_odd = 0; l3_even = 0

! ---------------------------------------------------- 11.0S
#ifdef SKIP_TEST
                      if ( il1 /= il2 ) cycle
                      if ( im1 /= im2 ) cycle
#endif
! ---------------------------------------------------- 11.0S


                      qitgylm = 0.d0
                      do n = 1, il2p(lmt1,lmt2,it)
                         ilm3 = isph(lmt1,lmt2,n,it);   l3 = il3(ilm3)
                         iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
                         if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ: ",11i5)') ia,lmt1,il1,tau1,lmt2,il2,tau2,n,ilm3,l3,iiqitg
                         if(iiqitg == 0) cycle
                         call integrate_qitg_x_ylm() ! -> qitgylm
                      end do
                      if(l3_odd + l3_even >=1) call integration_of_VlhxcQlm_core3()
                      !                             ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                   end do
                end do
#endif
                deallocate(zfsin_x,zfcos_x)
             end if
          end do
          deallocate(qitgylm)
       end do
#else

#ifndef _m_ESIV_no_loop_exchange_
       ncache = (m_CtrlP_cachesize()*1024)*3/4
       if(ncache == 0) then
          ibsize = iend_kngp-ista_kngp+1
       else
          ibsize=ncache/(8*(n**2))
       end if
       if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ:    ibsize = ", i8)') ibsize
       allocate(zfcos(ibsize)); zfcos = 0.d0
       allocate(zfsin(ibsize)); zfsin = 0.d0
       allocate(veq(ibsize))
       allocate(qitg_red(ibsize,nqitg))
       allocate(vlhxc_red(ibsize,kimg))
       allocate(ylm_red(ibsize,n**2))
       do ibl1 = ista_kngp, iend_kngp, ibsize
          ibl2 = ibl1+ibsize-1
          if(ibl2 .gt. iend_kngp) ibl2 = iend_kngp
          if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ:    ibl1,ibl2,ibsize = ", 3i8)') ibl1, ibl2, ibsize

          call substitute_qitgred()  ! qitg_l -> qitg_red
          call substitute_vlhxcred() ! vlhxc_l -> vlhxc_red
          call substitute_ylmred()   ! ylm_l, ylm_ext -> ylm_red 
          do ia = 1, natm
             it = ityp(ia)
             if(sum(ivanl(:,it)) == 0) cycle
             call calc_phase_div(ia)  !   -> zfcos, zfsin
             if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ:    ia,  iq,  l3,   m,ilm3,  ip,lmt1,lmt2,  np")')
             do iq = nqitg_sp0(it), nqitg_sp(it)
                l3 = iq2l3(iq)
                call dp_Vlhxcq_exp_Q_div(iq) ! vlhxc, exp, qitg_l  -> veq
                do m = 1, 2*l3+1
                   ilm3 = l3*l3+m
!!$                   if(ilm3 <= nel_Ylm) then
!!$                      ylm => ylm_l(:,ilm3)
!!$                   else
!!$                      ylm => ylm_ext(:,ilm3)
!!$                   end if
                   call veQ_dot_ylm_div(vq_ia) ! veq, ylm -> vq_ia
                   do ip = 1, nc(m,iq)
                      lmt1 = nc2lmt1(ip,m,iq)
                      lmt2 = nc2lmt2(ip,m,iq)
                      np = nc2n(ip,m,iq)
                      if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ: ",9i5)') ia, iq, l3, m, ilm3, ip, lmt1,lmt2,np
                      vlhxcQ(lmt1,lmt2,ia,is) = vlhxcQ(lmt1,lmt2,ia,is) + univol*vq_ia*dl2p(lmt1,lmt2,np,it)
                   end do
                end do
             end do
          end do
       end do
       deallocate(ylm_red)
       deallocate(vlhxc_red)
       deallocate(qitg_red)
       deallocate(veq)
#else
       allocate(zfcos(ista_kngp:iend_kngp)); zfcos = 0.d0
       allocate(zfsin(ista_kngp:iend_kngp)); zfsin = 0.d0
       do ia = 1, natm
          it = ityp(ia)
          if(sum(ivanl(:,it)) == 0) cycle
          call calc_phase2(natm,pos,ia,kgp,ngabc,ista_kngp,iend_kngp,zfcos,zfsin)
          !                -> zfcos, zfsin
          if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ:    ia,lmt1, il1,tau1,lmt2, il2,tau2,il2p,ilm3,  l3,iiqitg ")')
          do lmt1 = 1, ilmt(it)
             il1  = ltp( lmt1, it);   tau1 = taup(lmt1, it)
             do lmt2 = lmt1, ilmt(it)
                il2  = ltp( lmt2, it);   tau2 = taup(lmt2, it)

#ifdef SKIP_TEST
! ---------------------------------------------------- 11.0S
                if ( il1 /= il2 ) cycle
                if ( im1 /= im2 ) cycle
! ---------------------------------------------------- 11.0S
#endif

                do n = 1, il2p(lmt1,lmt2,it)
                   ilm3 = isph(lmt1,lmt2,n,it);   l3 = il3(ilm3)
                   iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
                   if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ: ",11i5)') ia,lmt1,il1,tau1,lmt2,il2,tau2,n,ilm3,l3,iiqitg
                   if(iiqitg == 0) cycle
                   if(ilm3 <= nel_Ylm) then
                      ylm => ylm_l(:,ilm3)
                   else
                      ylm => ylm_ext(:,ilm3)
                   end if
                   call integration_of_VlhxcQlm_core2 ! -> vlhxcQ(lmt1,lmt2,ia,is)
                   !    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                end do
             end do
          end do
       end do
#endif
#endif

#ifndef _VECTOR_TUNING_
       deallocate(zfsin);deallocate(zfcos)
#endif
    end do
    if(npes > 1) then
! ================================= modified by K. Tagami ================ 11.0
!       allocate(vlhxcQ_mpi(nlmt,nlmt,natm,nspin)); vlhxcQ_mpi = 0.d0
!       call mpi_allreduce(vlhxcQ, vlhxcQ_mpi,nlmt*nlmt*natm*nspin, mpi_double_precision,mpi_sum,mpi_comm_group,ierr)

       allocate( vlhxcQ_mpi(nlmt,nlmt,natm,ndim_magmom) ); vlhxcQ_mpi = 0.d0
       call mpi_allreduce( vlhxcQ, vlhxcQ_mpi, nlmt*nlmt*natm*ndim_magmom, &
        &                  mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
! ======================================================================= 11.0
       vlhxcQ = vlhxcQ_mpi
       deallocate(vlhxcQ_mpi)
    end if
    call symmetrize_vlhxcq
    if(allocated(ylm_ext)) deallocate(ylm_ext)
#ifdef _VECTOR_TUNING_
    deallocate(ia_list); deallocate(il3)
#else
!!$    deallocate(zfsin); deallocate(zfcos); deallocate(il3)
    deallocate(il3)
#endif

#ifndef _m_ESIV_no_loop_exchange_
    deallocate(nc2n,nc2lmt2,nc2lmt1,nc,iq2l3,nqitg_sp,nqitg_sp0)
#endif

    if(iprivlhxcq >= 2) then
       write(nfout,*) ' <<< m_ESiVQ_integrate_VlhxcQlm >>> vlhxcQ start'
! =================================== modified by K. Tagami =============== 11.0
!       do is = 1, nspin, af+1
       do is = 1, ndim_magmom, af+1
! ========================================================================= 11.0

          do it = 1, natm
             write(nfout,*) ' (vlhxcQ) -- #atom = ', it
             do lmt1 = 1, ilmt(ityp(it))
                write(nfout,*) ' --- lmt1 = ', lmt1
                write(nfout,'(99(5d16.8,/))')&
                     & (vlhxcq(lmt1,lmt2,it,is),lmt2=1,ilmt(ityp(it)))
             end do
          end do
       end do
       write(nfout,*) ' <<< m_ESiVQ_integrate_VlhxcQlm >>> vlhxcQ end'
    endif
    call tstatc0_end(id_sname)
  contains

    subroutine symmetrize_vlhxcq
      integer :: is, ia, it, lmt1, lmt2
! =================================== modified by K. Tagami =============== 11.0
!       do is = 1, nspin, af+1
       do is = 1, ndim_magmom, af+1
! ========================================================================= 11.0

         do ia = 1, natm
            it = ityp(ia)
            do lmt1 = 1, ilmt(it)
               do lmt2 = lmt1+1, ilmt(it)
                  vlhxcQ(lmt2,lmt1,ia,is) = vlhxcQ(lmt1,lmt2,ia,is)
               end do
            end do
         end do
      end do
    end subroutine symmetrize_vlhxcq

#ifdef _VECTOR_TUNING_
#ifndef _m_ESIV_no_loop_exchange_
    subroutine integration_of_VlhxcQlm_core4(iq,vq)
      integer, intent(in) :: iq
      real(kind=DP),dimension(n_ialist0), intent(out) :: vq
      integer       :: i,ia_s,ia
      real(kind=DP) ::  f


      vq = 0.d0
      if(ilm3 <= nel_Ylm) then
         if(kimg == 1) then
            if(mod(l3,2) == 0) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
               do ia_s = 1, n_ialist0
                  do i = ista_kngp, iend_kngp  ! mpi
                     vq(ia_s) = vq(ia_s) + qitg_l(i,iq)*ylm_l(i,ilm3)*vlhxc_l(i,1,is)*zfcos_x(i,ia_s)
                  end do
               end do
            else if(mod(l3,2) == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
               do ia_s = 1, n_ialist0
                  do i = ista_kngp, iend_kngp  ! mpi
                     vq(ia_s) = vq(ia_s) + qitg_l(i,iq)*ylm_l(i,ilm3)*vlhxc_l(i,1,is)*zfsin_x(i,ia_s)
                  end do
               end do
            end if
         else if(kimg == 2) then
            if(mod(l3,2) == 0) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
               do ia_s = 1, n_ialist0
                  do i = ista_kngp, iend_kngp  ! mpi
                     vq(ia_s) = vq(ia_s) + qitg_l(i,iq)*ylm_l(i,ilm3) &
                          & *(vlhxc_l(i,1,is)*zfcos_x(i,ia_s)-vlhxc_l(i,2,is)*zfsin_x(i,ia_s))
                  end do
               end do
            else if(mod(l3,2) == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
               do ia_s = 1, n_ialist0
                  do i = ista_kngp, iend_kngp  !for mpi
                     vq(ia_s) = vq(ia_s) + qitg_l(i,iq)*ylm_l(i,ilm3) &
                          & *(vlhxc_l(i,1,is)*zfsin_x(i,ia_s)+vlhxc_l(i,2,is)*zfcos_x(i,ia_s))
                  end do
               end do
            end if
         end if
      else if(ilm3 > nel_Ylm) then
         if(kimg == 1) then
            if(mod(l3,2) == 0) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
               do ia_s = 1, n_ialist0
                  do i = ista_kngp, iend_kngp  ! mpi
                     vq(ia_s) = vq(ia_s) + qitg_l(i,iq)*ylm_ext(i,ilm3)*vlhxc_l(i,1,is)*zfcos_x(i,ia_s)
                  end do
               end do
            else if(mod(l3,2) == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
               do ia_s = 1, n_ialist0
                  do i = ista_kngp, iend_kngp  ! mpi
                     vq(ia_s) = vq(ia_s) + qitg_l(i,iq)*ylm_ext(i,ilm3)*vlhxc_l(i,1,is)*zfsin_x(i,ia_s)
                  end do
               end do
            end if
         else if(kimg == 2) then
            if(mod(l3,2) == 0) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
               do ia_s = 1, n_ialist0
                  do i = ista_kngp, iend_kngp  ! mpi
                     vq(ia_s) = vq(ia_s) + qitg_l(i,iq)*ylm_ext(i,ilm3) &
                          & *(vlhxc_l(i,1,is)*zfcos_x(i,ia_s)-vlhxc_l(i,2,is)*zfsin_x(i,ia_s))
                  end do
               end do
            else if(mod(l3,2) == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
               do ia_s = 1, n_ialist0
                  do i = ista_kngp, iend_kngp  !for mpi
                     vq(ia_s) = vq(ia_s) + qitg_l(i,iq)*ylm_ext(i,ilm3) &
                          & *(vlhxc_l(i,1,is)*zfsin_x(i,ia_s)+vlhxc_l(i,2,is)*zfcos_x(i,ia_s))
                  end do
               end do
            end if
         end if
      end if

      if(mod(l3,2) == 0) then
         vq(:) = real(zi**l3)*vq(:)
      else if(mod(l3,2) == 1) then
         vq(:) = -aimag(zi**l3)*vq(:)
      end if
    end subroutine integration_of_VlhxcQlm_core4

    subroutine dp_Vlhxcq_exp_Q_x(iq)
      integer, intent(in) :: iq
      integer       :: i, ia_s

      if(kimg == 1) then
         if(mod(l3,2) == 0) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
            do ia_s = 1, n_ialist0
               do i = ista_kngp, iend_kngp  ! mpi
                  veq_x(i,ia_s) = qitg_l(i,iq)*vlhxc_l(i,1,is)*zfcos_x(i,ia_s)
               end do
            end do
         else if(mod(l3,2) == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
            do ia_s = 1, n_ialist0
               do i = ista_kngp, iend_kngp  ! mpi
                  veq_x(i,ia_s) = qitg_l(i,iq)*vlhxc_l(i,1,is)*zfsin_x(i,ia_s)
               end do
            end do
         end if
      else if(kimg == 2) then
         if(mod(l3,2) == 0) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
            do ia_s = 1, n_ialist0
               do i = ista_kngp, iend_kngp  ! mpi
                  veq_x(i,ia_s) = qitg_l(i,iq)*(vlhxc_l(i,1,is)*zfcos_x(i,ia_s)-vlhxc_l(i,2,is)*zfsin_x(i,ia_s))
               end do
            end do
         else if(mod(l3,2) == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
            do ia_s = 1, n_ialist0
               do i = ista_kngp, iend_kngp  !for mpi
                  veq_x(i,ia_s) = qitg_l(i,iq)*(vlhxc_l(i,1,is)*zfsin_x(i,ia_s)+vlhxc_l(i,2,is)*zfcos_x(i,ia_s))
               end do
            end do
         end if
      end if
    end subroutine dp_Vlhxcq_exp_Q_x

    subroutine veQ_dot_ylm_x(vq_x)
      real(kind=DP), intent(out) :: vq_x(n_ialist0)

      integer       :: i,iy, ia

      if(ilm3 <= nel_Ylm) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
#ifdef SX
!CDIR PARALLEL DO PRIVATE(ia,i)
#endif
         do ia = 1, n_ialist0
            vq_x(ia) = 0.d0
            do i = ista_kngp, iend_kngp  ! mpi
               vq_x(ia) = vq_x(ia) + veq_x(i,ia)*ylm_l(i,ilm3)
            end do
         end do
      else
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
#ifdef SX
!CDIR PARALLEL DO PRIVATE(ia,i)
#endif
         do ia = 1, n_ialist0
            vq_x(ia) = 0.d0
            do i = ista_kngp, iend_kngp  ! mpi
               vq_x(ia) = vq_x(ia) + veq_x(i,ia)*ylm_ext(i,ilm3)
            end do
         end do
      end if

      if(mod(l3,4) == 0) then
         vq_x = vq_x
      else if(mod(l3,4) == 1) then
         vq_x = -vq_x
      else if(mod(l3,4) == 2) then
         vq_x = -vq_x
      else if(mod(l3,4) == 3) then
         vq_x = vq_x
      end if
    end subroutine veQ_dot_ylm_x
#else
    subroutine integrate_qitg_x_ylm()
      integer :: i
      real(kind=DP) :: f

      if(ilm3 <= nel_Ylm) then
         if(mod(l3,2) == 0) then
            l3_even = l3_even+1
            f = real(zi**l3)*dl2p(lmt1,lmt2,n,it)
            do i = ista_kngp, iend_kngp  ! mpi
               qitgylm(i,1) = qitgylm(i,1) + f*qitg_l(i,iiqitg)*ylm_l(i,ilm3)
            end do
         else if(mod(l3,2) == 1) then
            l3_odd = l3_odd+1
            f = -aimag(zi**l3)*dl2p(lmt1,lmt2,n,it)
            do i = ista_kngp, iend_kngp  !mpi
               qitgylm(i,2) = qitgylm(i,2) + f*qitg_l(i,iiqitg)*ylm_l(i,ilm3)
            end do
         end if
      else
         if(mod(l3,2) == 0) then
            l3_even = l3_even+1
            f = real(zi**l3)*dl2p(lmt1,lmt2,n,it)
            do i = ista_kngp, iend_kngp  ! mpi
               qitgylm(i,1) = qitgylm(i,1) + f*qitg_l(i,iiqitg)*ylm_ext(i,ilm3)
            end do
         else if(mod(l3,2) == 1) then
            l3_odd = l3_odd+1
            f = -aimag(zi**l3)*dl2p(lmt1,lmt2,n,it)
            do i = ista_kngp, iend_kngp  !mpi
               qitgylm(i,2) = qitgylm(i,2) + f*qitg_l(i,iiqitg)*ylm_ext(i,ilm3)
            end do
         end if
      end if
    end subroutine integrate_qitg_x_ylm
      
    subroutine integration_of_VlhxcQlm_core3
      integer       :: i,ia_s,ia
      real(kind=DP),allocatable,dimension(:) :: vq

      allocate(vq(n_ialist0)); vq = 0.d0

      if(kimg == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
         do ia_s = 1, n_ialist0
            do i = ista_kngp, iend_kngp  ! mpi
               vq(ia_s) = vq(ia_s) + vlhxc_l(i,1,is)*(qitgylm(i,1)*zfcos_x(i,ia_s) &
                    &                               + qitgylm(i,2)*zfsin_x(i,ia_s))
            end do
         end do
      else if(kimg == 2) then
         if(l3_even > 0 .and. l3_odd >0) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
            do ia_s = 1, n_ialist0
               do i = ista_kngp, iend_kngp  ! mpi
                  vq(ia_s) = vq(ia_s) &
                       & + qitgylm(i,1)*(vlhxc_l(i,1,is)*zfcos_x(i,ia_s)-vlhxc_l(i,2,is)*zfsin_x(i,ia_s)) &
                       & + qitgylm(i,2)*(vlhxc_l(i,1,is)*zfsin_x(i,ia_s)+vlhxc_l(i,2,is)*zfcos_x(i,ia_s))
               end do
            end do
        else if(l3_even > 0 .and. l3_odd == 0) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
            do ia_s = 1, n_ialist0
               do i = ista_kngp, iend_kngp  ! mpi
                  vq(ia_s) = vq(ia_s) &
                       & + qitgylm(i,1)*(vlhxc_l(i,1,is)*zfcos_x(i,ia_s)-vlhxc_l(i,2,is)*zfsin_x(i,ia_s))
               end do
            end do
         else if(l3_even == 0 .and. l3_odd > 0) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
            do ia_s = 1, n_ialist0
               do i = ista_kngp, iend_kngp  ! mpi
                  vq(ia_s) = vq(ia_s) &
                       & + qitgylm(i,2)*(vlhxc_l(i,1,is)*zfsin_x(i,ia_s)+vlhxc_l(i,2,is)*zfcos_x(i,ia_s))
               end do
            end do
         end if
      end if

      do ia_s = 1, n_ialist0
         ia = ia_list(ia_s)
         vlhxcQ(lmt1,lmt2,ia,is) = vlhxcQ(lmt1,lmt2,ia,is)+univol*vq(ia_s)
      end do
      deallocate(vq)
    end subroutine integration_of_VlhxcQlm_core3
#endif


!!!-->  #else if .not. _VECTOR_TUNING_
#else

    subroutine substitute_qitgred()
      integer :: iq, i
      do iq = 1, nqitg
         do i = 1, ibl2-ibl1+1
            qitg_red(i, iq) = qitg_l(i+ibl1-1,iq)
         end do
      end do
    end subroutine substitute_qitgred

    subroutine substitute_vlhxcred
      integer :: i
      if(kimg==1) then
         do i = 1, ibl2-ibl1+1
            vlhxc_red(i,1) = vlhxc_l(i+ibl1-1,1,is)
         end do
      else if(kimg==2) then
         do i = 1, ibl2-ibl1+1
            vlhxc_red(i,1) = vlhxc_l(i+ibl1-1,1,is)
            vlhxc_red(i,2) = vlhxc_l(i+ibl1-1,2,is)
         end do
      end if
    end subroutine substitute_vlhxcred

    subroutine substitute_ylmred
      integer :: ilm, i
      do ilm = 1, nel_Ylm
         do i = 1, ibl2-ibl1+1
            ylm_red(i,ilm) = ylm_l(i+ibl1-1,ilm)
         end do
      end do
      if(n**2 > nel_Ylm) then
         do ilm = nel_ylm+1, n**2
            do i = 1, ibl2-ibl1+1
               ylm_red(i,ilm) = ylm_ext(i+ibl1-1,ilm)
            end do
         end do
      end if
    end subroutine substitute_ylmred

    subroutine calc_phase_div(ia)
      integer, intent(in) :: ia
      integer :: i, ig
      real(kind=DP) :: fx, fy, fz, ph
      fx = pos(ia,1)*PAI2
      fy = pos(ia,2)*PAI2
      fz = pos(ia,3)*PAI2
      do i = 1, ibl2-ibl1+1
         ig = i + ibl1 - 1
         ph = ngabc(ig,1)*fx + ngabc(ig,2)*fy + ngabc(ig,3)*fz
         zfcos(i) = dcos(ph)
         zfsin(i) = dsin(ph)
      end do
    end subroutine calc_phase_div

#ifndef _m_ESIV_no_loop_exchange_
    subroutine dp_Vlhxcq_exp_Q(iq)
      integer, intent(in) :: iq
      integer       :: i
      real(kind=DP) :: f
      real(kind=DP), pointer, dimension(:) :: zfsc1, zfsc2
      
      if(mod(l3,2) == 0) then
         zfsc1 => zfcos
         if(kimg == 2) zfsc2 => zfsin
         f = -1.d0
      else if(mod(l3,2) == 1) then
         zfsc1 => zfsin
         if(kimg == 2) zfsc2 => zfcos
         f = 1.d0
      end if

      if(kimg == 1) then
         do i = ista_kngp, iend_kngp  ! mpi
            veq(i) = qitg_l(i,iq)*vlhxc_l(i,1,is)*zfsc1(i)
         end do
      else if(kimg == 2) then
         do i = ista_kngp, iend_kngp  ! mpi
            veq(i)  = qitg_l(i,iq)*(vlhxc_l(i,1,is)*zfsc1(i)+f*vlhxc_l(i,2,is)*zfsc2(i))
         end do
      end if
    end subroutine dp_Vlhxcq_exp_Q

    subroutine veQ_dot_ylm(vq)
      real(kind=DP), intent(out) :: vq

      integer       :: i,iy
      vq = 0.d0
      do i = ista_kngp, iend_kngp  ! mpi
         iy = i-ista_kngp+1
         vq = vq + veq(i)*ylm(iy)
      end do

      if(mod(l3,4) == 0) then
         vq = vq
      else if(mod(l3,4) == 1) then
         vq = -vq
      else if(mod(l3,4) == 2) then
         vq = -vq
      else if(mod(l3,4) == 3) then
         vq = vq
      end if
    end subroutine veQ_dot_ylm

    subroutine dp_Vlhxcq_exp_Q_div(iq)
      integer, intent(in) :: iq
      integer       :: i
      real(kind=DP) :: f
      real(kind=DP), pointer, dimension(:) :: zfsc1, zfsc2
      
      if(mod(l3,2) == 0) then
         zfsc1 => zfcos
         if(kimg == 2) zfsc2 => zfsin
         f = -1.d0
      else if(mod(l3,2) == 1) then
         zfsc1 => zfsin
         if(kimg == 2) zfsc2 => zfcos
         f = 1.d0
      end if

      if(kimg == 1) then
         do i = 1, ibl2-ibl1+1
            veq(i) = qitg_red(i,iq)*vlhxc_red(i,1)*zfsc1(i)
         end do
      else if(kimg == 2) then
         do i = 1, ibl2-ibl1+1
            veq(i)  = qitg_red(i,iq)*(vlhxc_red(i,1)*zfsc1(i)+f*vlhxc_red(i,2)*zfsc2(i))
         end do
      end if
    end subroutine dp_Vlhxcq_exp_Q_div

    subroutine veQ_dot_ylm_div(vq)
      real(kind=DP), intent(out) :: vq

      integer       :: i,iy
      vq = 0.d0
      do i = 1, ibl2-ibl1+1
         vq = vq + veq(i)*ylm_red(i,ilm3)
      end do

      if(mod(l3,4) == 0) then
         vq = vq
      else if(mod(l3,4) == 1) then
         vq = -vq
      else if(mod(l3,4) == 2) then
         vq = -vq
      else if(mod(l3,4) == 3) then
         vq = vq
      end if
    end subroutine veQ_dot_ylm_div

#else
    subroutine integration_of_VlhxcQlm_core2
      integer       :: i,iy
      real(kind=DP) :: vq
      real(kind=DP) :: f
      real(kind=DP), pointer, dimension(:) :: zfsc1, zfsc2

      vq = 0.d0
      if(mod(l3,2) == 0) then
         zfsc1 => zfcos
         if(kimg == 2) zfsc2 => zfsin
         f = -1.d0
      else if(mod(l3,2) == 1) then
         zfsc1 => zfsin
         if(kimg == 2) zfsc2 => zfcos
         f = 1.d0
      end if

      if(kimg == 1) then
         do i = ista_kngp, iend_kngp  ! mpi
            iy = i-ista_kngp+1
            vq = vq + qitg_l(i,iiqitg)*ylm(iy)*vlhxc_l(i,1,is)*zfsc1(i)
         end do
      else if(kimg == 2) then
         do i = ista_kngp, iend_kngp  ! mpi
            iy = i-ista_kngp+1
            vq  = vq + qitg_l(i,iiqitg)*ylm(iy)*(vlhxc_l(i,1,is)*zfsc1(i)+f*vlhxc_l(i,2,is)*zfsc2(i))
         end do
      end if
      if(mod(l3,2) == 0) then
         vq = real(zi**l3)*dl2p(lmt1,lmt2,n,it)*vq
      else if(mod(l3,2) == 1) then
         vq = -aimag(zi**l3)*dl2p(lmt1,lmt2,n,it)*vq
      end if

      vlhxcQ(lmt1,lmt2,ia,is) = vlhxcQ(lmt1,lmt2,ia,is)+univol*vq
    end subroutine integration_of_VlhxcQlm_core2
#endif
#endif

!!$    subroutine integration_of_VlhxcQlm_core
!!$      integer       :: ia, i, iy
!!$      real(kind=DP) :: dga, vq, grt, qy, zfc, zfs
!!$
!!$      dga = dl2p(lmt1,lmt2,n,it)
!!$      do ia = 1, natm
!!$         if(ityp(ia) /= it) cycle
!!$         vq = 0.d0
!!$         if(mod(il1+il2,2) == 0) then
!!$            do i = ista_kngp, iend_kngp  !for mpi
!!$               iy = i-ista_kngp+1
!!$               grt = (pos(ia,1)*ngabc(i,1) + pos(ia,2)*ngabc(i,2)&
!!$                    &+pos(ia,3)*ngabc(i,3))*PAI2
!!$               zfc = dcos(grt); if(kimg == 2) zfs = dsin(grt)
!!$               qy  = qitg_l(i,iiqitg)*ylm(iy)
!!$               vq  = vq+ qy*vlhxc_l(i,1,is)*zfc
!!$               if(kimg==2) vq = vq - qy*vlhxc_l(i,kimg,is)*zfs
!!$            end do
!!$            vq = real(zi**l3)*dga*vq
!!$         else if(mod(il1+il2,2) == 1) then
!!$            do i = ista_kngp, iend_kngp  !for mpi
!!$               iy = i-ista_kngp+1
!!$               grt = (pos(ia,1)*ngabc(i,1) + pos(ia,2)*ngabc(i,2)&
!!$                    &+pos(ia,3)*ngabc(i,3))*PAI2
!!$               zfs = dsin(grt); if(kimg==2) zfc = dcos(grt)
!!$               qy  = qitg_l(i,iiqitg)*ylm(iy)
!!$               vq  = vq + qy*vlhxc_l(i,1,is)*zfs
!!$               if(kimg==2) vq = vq + qy*vlhxc_l(i,kimg,is)*zfc
!!$            end do
!!$            vq = -aimag(zi**l3)*dga*vq
!!$         endif
!!$         vlhxcQ(lmt1,lmt2,ia,is) = vlhxcQ(lmt1,lmt2,ia,is)+univol*vq
!!$      end do
!!$    end subroutine integration_of_VlhxcQlm_core
  end subroutine m_ESiVQ_integrate_VlhxcQlm
!$$#endif

  subroutine m_ESiVQ_add_dhub_to_vlhxcQ(nfout)
    integer, intent(in) :: nfout
    integer :: is,ia
! ========================================== modified by K. Tagami ======== 11.0
!    do is=1,nspin
    do is=1, ndim_magmom
! ========================================================================= 11.0
       do ia=1,natm
          if(ihubbard(ia) > 0) then
             vlhxcQ(:,:,ia,is) = vlhxcQ(:,:,ia,is)+dhub(:,:,ia,is)
          end if
       end do
    end do
  end subroutine m_ESiVQ_add_dhub_to_vlhxcQ


end module m_ES_Intgr_VlhxcQlm

!=======================================================================
!
!  PROGRAM  PHASE/0 2015.01 ($Rev: 440 $)
!
!  SUBROUINE: Initialization_set_ekmode_ON, Initialization, aavers
!
!  AUTHORS: T. Yamasaki, K. Betsuyaku,   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Initialization_set_ekmode_ON
! $Id: Initialization.F90 440 2015-08-03 07:18:01Z ktagami $
  use m_Control_Parameters, only : m_CtrlP_set_ekmode_ON
  implicit none

  call m_CtrlP_set_ekmode_ON()
end subroutine Initialization_set_ekmode_ON

subroutine Initialization_set_ekmode_GRID
  use m_Control_Parameters, only : m_CtrlP_set_ekmode_GRID
  implicit none

  call m_CtrlP_set_ekmode_GRID()
end subroutine Initialization_set_ekmode_GRID

logical function initialization_required()
  use m_Const_Parameters, only : OFF,ON,CONTINUATION,FIXED_CHARGE_CONTINUATION
  use m_Control_Parameters, only : sw_optimize_lattice,sw_rebuild_pws,icond &
   & , m_CtrlP_in_initialization
  use m_IterationNumbers, only : iteration_unit_cell
  use m_Ionic_System, only : m_IS_natm_can_change
  implicit none
  if (sw_optimize_lattice==OFF.or.iteration_unit_cell==1) then
    initialization_required = .true.
    return
  endif
  if(m_IS_natm_can_change())then
    initialization_required = .true.
    return
  endif
  if(sw_rebuild_pws==ON) then
     initialization_required = .true.
     return
  endif

  if((icond==CONTINUATION.or.icond==FIXED_CHARGE_CONTINUATION).and.m_CtrlP_in_initialization())then
     initialization_required = .true.
     return
  endif

  initialization_required = .false.
end function initialization_required

subroutine Initialization(init_mpi)
! $Id: Initialization.F90 440 2015-08-03 07:18:01Z ktagami $
  use m_Parallelization, only : m_Parallel_init_comm_world
  use m_Parallelization, only : m_Parallel_get_nproc_from_arg_3D
  use m_Control_Parameters,only:  m_CtrlP_set_sw_scalapack
  use m_Timing,          only : m_Timing_wd_timenow, m_Timing_init_timer
  use m_Files,           only : nfout &
       &                      , m_Files_open_standardout &
       &                      , m_Files_set_default_filenames &
       &                      , m_Files_rd_file_names_data &
       &                      , m_Files_open_files_initially &
       &                      , m_Files_check_file_existance
  use m_Ionic_System,    only : m_IS_initialize_mdmode
  use m_Control_Parameters,only: m_CtrlP_set_printable, printable &
       &                      , m_CtrlP_set_wct_start
  implicit none

  integer, optional, intent(in) :: init_mpi
  logical,save :: first_call=.true.
  logical :: initialization_required

  if(.not.initialization_required()) return

!    -----------
  if(first_call)then
  call m_Parallel_init_comm_world(init_mpi)
  call m_CtrlP_set_printable()             !-> printable
  call m_Timing_init_timer()
  call m_Files_set_default_filenames()
  call m_Files_rd_file_names_data()
  call m_Files_open_standardout()
  if(printable) call print_title()
  if(printable) call m_Timing_wd_timenow("program start")

  call m_Parallel_get_nproc_from_arg_3D(printable)
#ifdef _USE_SCALAPACK_
  call m_CtrlP_set_sw_scalapack(printable)
#endif
  call aavers                      ! -(here)
  endif
  call m_Files_check_file_existance
  call m_Files_open_files_initially
  call m_IS_initialize_mdmode()
  if(first_call) call m_CtrlP_set_wct_start                   !  (ckcput)
!  call m_CtrlP_set_wct_start                   !  (ckcput)
!!$  call m_CtrlP_set_paramset_off
  first_call = .false.
contains
  subroutine print_title()
    integer :: i
    write(nfout,'(1x,79a)') ("*",i=1,79)
!       10        20                  40        50        60        70        80        90       100       110       120       130      140
!2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890
    !                        123456789a      123456789a      123456789a      123456789a      123456789a      1234567      12345678
!!$    write(nfout,'(1x,"*",3x,"PPPPPPP   ",1x,"HH     HH ",1x,"    AA    ",1x,"   SSSSS  ",1x," EEEEEEEE ",1x,"       ",1x,"        ",3x,"*")') ! a
!!$    write(nfout,'(1x,"*",3x,"PPPPPPPP  ",1x,"HH     HH ",1x,"   AAAA   ",1x,"  SSSSSSS ",1x," EEEEEEEE ",1x,"      /",1x,"        ",3x,"*")') ! b
!!$    write(nfout,'(1x,"*",3x,"PP     PP ",1x,"HH     HH ",1x,"   AAAA   ",1x,"  SS   SS ",1x," EE       ",1x,"     //",1x,"  0000  ",3x,"*")') ! c
!!$!   write(nfout,'(1x,"*",3x,"PP     PP ",1x,"HH     HH ",1x,"  AA  AA  ",1x," SS       ",1x," EE       ",1x,"     / ",1x," 000000 ",3x,"*")') ! d
!!$    write(nfout,'(1x,"*",3x,"PP     PP ",1x,"HH     HH ",1x,"  AA  AA  ",1x," SS       ",1x," EE       ",1x,"    // ",1x,"000  000",3x,"*")') ! e
!!$    write(nfout,'(1x,"*",3x,"PP     PP ",1x,"HH     HH ",1x,"  AA  AA  ",1x," SSS      ",1x," EE       ",1x,"    /  ",1x,"00    00",3x,"*")') ! f
!!$    write(nfout,'(1x,"*",3x,"PPPPPPPP  ",1x,"HHHHHHHHH ",1x,"  AA  AA  ",1x,"  SSSSS   ",1x," EEEEEEEE ",1x,"   //  ",1x,"00    00",3x,"*")') ! g
!!$    write(nfout,'(1x,"*",3x,"PPPPPPP   ",1x,"HHHHHHHHH ",1x," AA    AA ",1x,"    SSSS  ",1x," EEEEEEEE ",1x,"   /   ",1x,"00    00",3x,"*")') ! h
!!$    write(nfout,'(1x,"*",3x,"PP        ",1x,"HH     HH ",1x," AA    AA ",1x,"      SSS ",1x," EE       ",1x,"   /   ",1x,"00    00",3x,"*")') ! i
!!$!   write(nfout,'(1x,"*",3x,"PP        ",1x,"HH     HH ",1x," AAAAAAAA ",1x,"       SS ",1x," EE       ",1x,"  //   ",1x,"00    00",3x,"*")') ! j
!!$    write(nfout,'(1x,"*",3x,"PP        ",1x,"HH     HH ",1x," AAAAAAAA ",1x,"       SS ",1x," EE       ",1x,"  /    ",1x,"00    00",3x,"*")') ! k
!!$    write(nfout,'(1x,"*",3x,"PP        ",1x,"HH     HH ",1x,"AAAAAAAAAA",1x," SS   SSS ",1x," EE       ",1x," //    ",1x,"00    00",3x,"*")') ! l
!!$    write(nfout,'(1x,"*",3x,"PP        ",1x,"HH     HH ",1x,"AA      AA",1x," SSSSSSS  ",1x," EEEEEEEE ",1x," /     ",1x," 000000 ",3x,"*")') ! m
!!$    write(nfout,'(1x,"*",3x,"PP        ",1x,"HH     HH ",1x,"AA      AA",1x,"  SSSSS   ",1x," EEEEEEEE ",1x,"//     ",1x,"  0000  ",3x,"*")') ! n
!!$    write(nfout,'(1x,79a)') ("*",i=1,79)
    write(nfout,2011) "PPPPPPP   ","HH     HH ","    AA    ","   SSSSS  "," EEEEEEEE ","       ","        "  ! a
    write(nfout,2011) "PPPPPPPP  ","HH     HH ","   AAAA   ","  SSSSSSS "," EEEEEEEE ","      /","        "  ! b
    write(nfout,2011) "PP     PP ","HH     HH ","   AAAA   ","  SS   SS "," EE       ","     //","  0000  "  ! c
!   write(nfout,2011) "PP     PP ","HH     HH ","  AA  AA  "," SS       "," EE       ","     / "," 000000 "  ! d
    write(nfout,2011) "PP     PP ","HH     HH ","  AA  AA  "," SS       "," EE       ","    // ","000  000"  ! e
    write(nfout,2011) "PP     PP ","HH     HH ","  AA  AA  "," SSS      "," EE       ","    /  ","00    00"  ! f
    write(nfout,2011) "PPPPPPPP  ","HHHHHHHHH ","  AA  AA  ","  SSSSS   "," EEEEEEEE ","   //  ","00    00"  ! g
    write(nfout,2011) "PPPPPPP   ","HHHHHHHHH "," AA    AA ","    SSSS  "," EEEEEEEE ","   /   ","00    00"  ! h
    write(nfout,2011) "PP        ","HH     HH "," AA    AA ","      SSS "," EE       ","   /   ","00    00"  ! i
!   write(nfout,2011) "PP        ","HH     HH "," AAAAAAAA ","       SS "," EE       ","  //   ","00    00"  ! j
    write(nfout,2011) "PP        ","HH     HH "," AAAAAAAA ","       SS "," EE       ","  /    ","00    00"  ! k
    write(nfout,2011) "PP        ","HH     HH ","AAAAAAAAAA"," SS   SSS "," EE       "," //    ","00    00"  ! l
    write(nfout,2011) "PP        ","HH     HH ","AA      AA"," SSSSSSS  "," EEEEEEEE "," /     "," 000000 "  ! m
    write(nfout,2011) "PP        ","HH     HH ","AA      AA","  SSSSS   "," EEEEEEEE ","//     ","  0000  "  ! n
    write(nfout,'(1x,79a)') ("*",i=1,79)
2011 format(1x,'*',3x,a10,1x,a10,1x,a10,1x,a10,1x,a10,1x,a7,1x,a8,3x,'*')
!!$    write(nfout,'(1x,"****",10a,1x,10a,1x,10a,1x,10a,1x,10a,3x,"*")') ("**********",i=1,5)
  end subroutine print_title

  subroutine aavers
    include 'version.h' ! svn_revision
    character(len=72) :: vers, system, codename
    write(vers,'("phase/0 2015.01.01 Revision:",i5," -- 3D_Parallel --")') svn_revision
    codename = 'phaseUnif'
    system = ''

#ifdef VPP
    system = '@(#)system=vpp'
#elif DEC
    system = '@(#)system=dec'
#elif HP
    system = '@(#)system=hp'
#elif SUN
    system = '@(#)system=sun'
#elif ONYX
    system = '@(#)system=onyx'
#elif IRIX64
    system = '@(#)system=irix64'
#elif CRAY
    system = '@(#)system=crayxmp'
#elif HIUX
    system = '@(#)system=hi-ux'
#elif SX
    system = '@(#)system=sx'
#elif SP2
    system = '@(#)system=aix'
#elif Linux
#ifdef PGI
    system = '@(#)system=linux_pgi'
#else
    system = '@(#)system=linux'
#endif
#endif
    if(printable) then
!!$       write(nfout,*) ' ********************************'
!!$       write(nfout,*) ' *  PHASE/0 ver.2013.11         *'
!!$       write(nfout,*) ' *  (phaseUnif_noncol_r340rev+) *'
!!$       write(nfout,*) ' ********************************'
       write(nfout,*) vers
       write(nfout,*) system
       write(nfout,*) codename
       write(nfout,'(" --- << CPP options defined in the makefile >> --")')
#ifdef _NO_MPI_
#ifdef _OPENMP
       write(nfout,'(" Parallization: OpenMP")')
#else
       write(nfout,'(" Parallization: Serial")')
#endif
#else
#ifdef _OPENMP
       write(nfout,'(" Parallization: OpenMP and MPI")')
#else
       write(nfout,'(" Parallization: MPI")')
#endif
#endif
    end if
    if(printable) then
#ifdef TRANSPOSE
       write(nfout,'(" MGS  = TRANSPOSE")')
#elif CYCLIC
       write(nfout,'(" MGS  = CYCLIC")')
#endif
#ifdef _EMPIRICAL_
       write(nfout,'(" _EMPIRICAL_")')
#endif
#ifdef _SIMPLE_SORT_
       write(nfout,'(" SORTING = _SIMPLE_SORT_")')
#elif  _HEAP_SORT_
       write(nfout,'(" SORTING = _HEAP_SORT_")')
#endif
#ifdef DECFFT
       write(nfout,'(" FFT WF  = DECFFT")')
#elif  MKLFFT
       write(nfout,'(" FFT WF  = MKLFFT")')
#elif  FFTW3
       write(nfout,'(" FFT WF  = FFTW3")')
#elif  ACMLFFT
       write(nfout,'(" FFT WF  = ACMLFFT")')
#elif  SCSLFFT
       write(nfout,'(" FFT WF  = SCSLFFT")')
#elif  WF_SRFFT
       write(nfout,'(" FFT WF  = WF_SRFFT")')
#elif  WF_JRCATFFT
       write(nfout,'(" FFT WF  = WF_JRCATFFT")')
#elif  WF_JRCATFFT_WS
       write(nfout,'(" FFT WF  = WF_JRCATFFT_WS")')
#endif
    end if
#ifdef CD_SRFFT
    if(printable) write(nfout,'(" FFT CD  = CD_SRFFT")')
#elif CD_JRCATFFT
    if(printable) write(nfout,'(" FFT CD  = CD_JRCATFFT")')
#ifdef WF_JRCATFFT_WS
    if(printable) write(nfout,'(" Do NOT use WF_JRCATFFT_WS and CD_JRCATFFT at the same time")')
    stop
#endif
#elif  CD_JRCATFFT_WS
    if(printable) write(nfout,'(" FFT CD  = CD_JRCATFFT_WS")')
#ifdef WF_JRCATFFT
    if(printable) write(nfout,'(" Do NOT use WF_JRCATFFT and CD_JRCATFFT_WS at the same time")')
    stop
#endif
#elif  FFTW3
    if(printable) write(nfout,'(" FFT CD  = FFTW3")')
#endif
#ifdef NO_MGS_DGEMM
    if(printable) write(nfout,'(" NO_MGS_DGEMM is defined")')
#else
    if(printable) write(nfout,'(" NO_MGS_DGEMM is not defined")')
#endif
#ifdef NO_NONLOCAL_DGEMM
    if(printable) write(nfout,'(" NO_NONLOCAL_DGEMM is defined")')
#else
    if(printable) write(nfout,'(" NO_NONLOCAL_DGEMM is not defined")')
#endif
#ifdef NO_NONLOCAL_RMM_DGEMM
    if(printable) write(nfout,'(" NO_NONLOCAL_RMM_DGEMM is defined")')
#else
    if(printable) write(nfout,'(" NO_NONLOCAL_RMM_DGEMM is not defined")')
#endif
#ifdef NO_SUBMAT_DGEMM
    if(printable) write(nfout,'(" NO_SUBMAT_DGEMM is defined")')
#else
    if(printable) write(nfout,'(" NO_SUBMAT_DGEMM is not defined")')
#endif
#ifdef NO_FORCE_DGEMM
    if(printable) write(nfout,'(" NO_FORCE_DGEMM is defined")')
#else
    if(printable) write(nfout,'(" NO_FORCE_DGEMM is not defined")')
#endif
#ifdef NO_MATDIAGON_DGEMM
    if(printable) write(nfout,'(" NO_MATDIAGON_DGEMM is defined")')
#else
    if(printable) write(nfout,'(" NO_MATDIAGON_DGEMM is not defined")')
#endif


#ifdef LMM_PREVIOUS
    if(printable) write(nfout,'(" LMM_PREVIOUS is defined")')
#else
    if(printable) write(nfout,'(" LMM_PREVIOUS is not defined")')
#endif
    if(printable) write(nfout,'(" ----------------------------------------------")')
  end subroutine aavers
  
end subroutine Initialization

#!/bin/sh
NP=1
NE=1
NK=1
nvol=20
ivol=990
dvol=15
rm -f nfefn.data
for v in `seq 1 $nvol`;do
vol=$( echo \($v-1\)*$dvol+$ivol | bc -l )
cd vol$vol
mpiexec -n $NP ~/phase0_2015.01/bin/phase ne=$NE nk=$NK < /dev/null
echo -n $vol >> ../nfefn.data; echo -n; tail -1 nfefn.data >> ../nfefn.data
cd ../
done

#imrcolor,lincolorは2通りの指定方法(linecolor,linecolor2)のうち片方を使う
erange=" -erange -9,26"
#erange=" -erange 0,4"
einc="-einc 1.0"
#imrfont="-imrfont Helvetica,11"
#ticsfont="-ticsfont Helvetica,10"
#imrcolor="-imrcolor #545422"
imrcolor2="-imrcolor blue"
#linecolor="-linecolor #545422"
linecolor2="-linecolor red"
imrtype="-imrtype mulliken"
#noncross="-nonecross"
#kgrouptype="-kgrouptype Schoenflies"
withfermi="-with_fermi nfefermi.data"
numimr="-numimr 2"
perl band_symm_new02.pl reduce_down.data ${erange} ${einc} ${imrfont} ${ticsfont} ${imrcolor} ${imrcolor2} ${linecolor} ${linecolor2} ${imrtype} ${noncross} ${kgrouptype} ${withfermi} ${numimr}
#perl ${HOME}/band_symm/perl/band_symm.pl reduce.data ${erange} ${einc} ${imrfont} ${ticsfont} ${imrcolor} ${imrcolor2} ${linecolor} ${linecolor2} ${imrtype} ${noncross} ${kgrouptype} ${withfermi} ${numimr}
